/* Box.c generated by valac 0.14.2, the Vala compiler
 * generated from Box.vala, do not modify */

/* Copyright 2009-2011 Yorba Foundation
 *
 * This software is licensed under the GNU LGPL (version 2.1 or later).
 * See the COPYING file in this distribution. 
 */

#include <glib.h>
#include <glib-object.h>
#include <string.h>
#include <gdk/gdk.h>
#include <gtk/gtk.h>
#include <float.h>
#include <math.h>
#include <stdlib.h>


#define TYPE_BOX_LOCATION (box_location_get_type ())

#define TYPE_BOX_COMPLEMENTS (box_complements_get_type ())

#define TYPE_BOX (box_get_type ())
typedef struct _Box Box;

#define TYPE_DIMENSIONS (dimensions_get_type ())
typedef struct _Dimensions Dimensions;
#define _g_free0(var) (var = (g_free (var), NULL))

typedef enum  {
	BOX_LOCATION_OUTSIDE,
	BOX_LOCATION_INSIDE,
	BOX_LOCATION_TOP_SIDE,
	BOX_LOCATION_LEFT_SIDE,
	BOX_LOCATION_RIGHT_SIDE,
	BOX_LOCATION_BOTTOM_SIDE,
	BOX_LOCATION_TOP_LEFT,
	BOX_LOCATION_BOTTOM_LEFT,
	BOX_LOCATION_TOP_RIGHT,
	BOX_LOCATION_BOTTOM_RIGHT
} BoxLocation;

typedef enum  {
	BOX_COMPLEMENTS_NONE,
	BOX_COMPLEMENTS_VERTICAL,
	BOX_COMPLEMENTS_HORIZONTAL,
	BOX_COMPLEMENTS_BOTH
} BoxComplements;

struct _Box {
	gint left;
	gint top;
	gint right;
	gint bottom;
};

struct _Dimensions {
	gint width;
	gint height;
};



GType box_location_get_type (void) G_GNUC_CONST;
GType box_complements_get_type (void) G_GNUC_CONST;
BoxComplements box_complements_derive (gboolean horizontal_complement, gboolean vertical_complement);
GType box_get_type (void) G_GNUC_CONST;
Box* box_dup (const Box* self);
void box_free (Box* self);
#define BOX_HAND_GRENADES 12
void box_init (Box *self, gint left, gint top, gint right, gint bottom);
void box_from_rectangle (GdkRectangle* rect, Box* result);
void box_from_allocation (GtkAllocation* alloc, Box* result);
void box_from_points (GdkPoint* corner1, GdkPoint* corner2, Box* result);
gint box_get_width (Box *self);
gint box_get_height (Box *self);
gboolean box_is_valid (Box *self);
gboolean box_equals (Box *self, Box* box);
GType dimensions_get_type (void) G_GNUC_CONST;
Dimensions* dimensions_dup (const Dimensions* self);
void dimensions_free (Dimensions* self);
void box_get_scaled (Box *self, Dimensions* scaled, Box* result);
void box_get_dimensions (Box *self, Dimensions* result);
void dimensions_get_scale_ratios (Dimensions *self, Dimensions* scaled, gdouble* width_ratio, gdouble* height_ratio);
void box_get_scaled_similar (Box *self, Dimensions* original, Dimensions* scaled, Box* result);
void box_get_offset (Box *self, gint xofs, gint yofs, Box* result);
void dimensions_init (Dimensions *self, gint width, gint height);
void box_get_points (Box *self, GdkPoint* top_left, GdkPoint* bottom_right);
void box_get_rectangle (Box *self, GdkRectangle* result);
void box_rotate_clockwise (Box *self, Dimensions* space, Box* result);
void box_rotate_counterclockwise (Box *self, Dimensions* space, Box* result);
void box_flip_left_to_right (Box *self, Dimensions* space, Box* result);
void box_flip_top_to_bottom (Box *self, Dimensions* space, Box* result);
gboolean box_intersects (Box *self, Box* compare);
void box_get_reduced (Box *self, gint amount, Box* result);
void box_get_expanded (Box *self, gint amount, Box* result);
gboolean box_contains (Box *self, GdkPoint* point);
BoxComplements box_resized_complements (Box *self, Box* resized, Box* horizontal, gboolean* horizontal_enlarged, Box* vertical, gboolean* vertical_enlarged);
BoxComplements box_shifted_complements (Box *self, Box* shifted, Box* horizontal_this, Box* vertical_this, Box* horizontal_shifted, Box* vertical_shifted);
void box_rubber_band (Box *self, GdkPoint* point, Box* result);
gchar* box_to_string (Box *self);
gchar* dimensions_to_string (Dimensions *self);
static gboolean box_in_zone (gdouble pos, gint zone);
static gboolean box_in_between (gdouble pos, gint top, gint bottom);
static gboolean box_near_in_between (gdouble pos, gint top, gint bottom);
BoxLocation box_approx_location (Box *self, gint x, gint y);


GType box_location_get_type (void) {
	static volatile gsize box_location_type_id__volatile = 0;
	if (g_once_init_enter (&box_location_type_id__volatile)) {
		static const GEnumValue values[] = {{BOX_LOCATION_OUTSIDE, "BOX_LOCATION_OUTSIDE", "outside"}, {BOX_LOCATION_INSIDE, "BOX_LOCATION_INSIDE", "inside"}, {BOX_LOCATION_TOP_SIDE, "BOX_LOCATION_TOP_SIDE", "top-side"}, {BOX_LOCATION_LEFT_SIDE, "BOX_LOCATION_LEFT_SIDE", "left-side"}, {BOX_LOCATION_RIGHT_SIDE, "BOX_LOCATION_RIGHT_SIDE", "right-side"}, {BOX_LOCATION_BOTTOM_SIDE, "BOX_LOCATION_BOTTOM_SIDE", "bottom-side"}, {BOX_LOCATION_TOP_LEFT, "BOX_LOCATION_TOP_LEFT", "top-left"}, {BOX_LOCATION_BOTTOM_LEFT, "BOX_LOCATION_BOTTOM_LEFT", "bottom-left"}, {BOX_LOCATION_TOP_RIGHT, "BOX_LOCATION_TOP_RIGHT", "top-right"}, {BOX_LOCATION_BOTTOM_RIGHT, "BOX_LOCATION_BOTTOM_RIGHT", "bottom-right"}, {0, NULL, NULL}};
		GType box_location_type_id;
		box_location_type_id = g_enum_register_static ("BoxLocation", values);
		g_once_init_leave (&box_location_type_id__volatile, box_location_type_id);
	}
	return box_location_type_id__volatile;
}


BoxComplements box_complements_derive (gboolean horizontal_complement, gboolean vertical_complement) {
	BoxComplements result = 0;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
	gboolean _tmp3_;
#line 27 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp1_ = horizontal_complement;
#line 27 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	if (_tmp1_) {
#line 132 "Box.c"
		gboolean _tmp2_;
#line 27 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		_tmp2_ = vertical_complement;
#line 27 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		_tmp0_ = _tmp2_;
#line 138 "Box.c"
	} else {
#line 27 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		_tmp0_ = FALSE;
#line 142 "Box.c"
	}
#line 27 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp3_ = _tmp0_;
#line 27 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	if (_tmp3_) {
#line 28 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		result = BOX_COMPLEMENTS_BOTH;
#line 28 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		return result;
#line 152 "Box.c"
	} else {
		gboolean _tmp4_;
#line 29 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		_tmp4_ = horizontal_complement;
#line 29 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		if (_tmp4_) {
#line 30 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
			result = BOX_COMPLEMENTS_HORIZONTAL;
#line 30 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
			return result;
#line 163 "Box.c"
		} else {
			gboolean _tmp5_;
#line 31 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
			_tmp5_ = vertical_complement;
#line 31 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
			if (_tmp5_) {
#line 32 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
				result = BOX_COMPLEMENTS_VERTICAL;
#line 32 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
				return result;
#line 174 "Box.c"
			}
		}
	}
#line 34 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	result = BOX_COMPLEMENTS_NONE;
#line 34 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	return result;
#line 182 "Box.c"
}


GType box_complements_get_type (void) {
	static volatile gsize box_complements_type_id__volatile = 0;
	if (g_once_init_enter (&box_complements_type_id__volatile)) {
		static const GEnumValue values[] = {{BOX_COMPLEMENTS_NONE, "BOX_COMPLEMENTS_NONE", "none"}, {BOX_COMPLEMENTS_VERTICAL, "BOX_COMPLEMENTS_VERTICAL", "vertical"}, {BOX_COMPLEMENTS_HORIZONTAL, "BOX_COMPLEMENTS_HORIZONTAL", "horizontal"}, {BOX_COMPLEMENTS_BOTH, "BOX_COMPLEMENTS_BOTH", "both"}, {0, NULL, NULL}};
		GType box_complements_type_id;
		box_complements_type_id = g_enum_register_static ("BoxComplements", values);
		g_once_init_leave (&box_complements_type_id__volatile, box_complements_type_id);
	}
	return box_complements_type_id__volatile;
}


void box_init (Box *self, gint left, gint top, gint right, gint bottom) {
	gint _tmp0_;
	gint _tmp1_;
	gint _tmp2_ = 0;
	gint _tmp3_;
	gint _tmp4_;
	gint _tmp5_ = 0;
	gint _tmp6_;
	gint _tmp7_;
	gint _tmp9_;
	gint _tmp10_;
	gint _tmp12_;
	gint _tmp13_;
	gint _tmp14_;
	gint _tmp15_;
#line 46 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	memset (self, 0, sizeof (Box));
#line 48 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp0_ = left;
#line 48 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp1_ = G_MAXINT;
#line 48 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp2_ = CLAMP (_tmp0_, 0, _tmp1_);
#line 48 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	left = _tmp2_;
#line 49 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp3_ = top;
#line 49 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp4_ = G_MAXINT;
#line 49 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp5_ = CLAMP (_tmp3_, 0, _tmp4_);
#line 49 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	top = _tmp5_;
#line 53 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp6_ = right;
#line 53 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp7_ = left;
#line 53 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	if (_tmp6_ <= _tmp7_) {
#line 237 "Box.c"
		gint _tmp8_;
#line 54 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		_tmp8_ = left;
#line 54 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		right = _tmp8_ + 1;
#line 243 "Box.c"
	}
#line 56 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp9_ = bottom;
#line 56 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp10_ = top;
#line 56 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	if (_tmp9_ <= _tmp10_) {
#line 251 "Box.c"
		gint _tmp11_;
#line 57 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		_tmp11_ = top;
#line 57 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		bottom = _tmp11_ + 1;
#line 257 "Box.c"
	}
#line 59 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp12_ = left;
#line 59 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	(*self).left = _tmp12_;
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp13_ = top;
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	(*self).top = _tmp13_;
#line 61 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp14_ = right;
#line 61 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	(*self).right = _tmp14_;
#line 62 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp15_ = bottom;
#line 62 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	(*self).bottom = _tmp15_;
#line 275 "Box.c"
}


void box_from_rectangle (GdkRectangle* rect, Box* result) {
	GdkRectangle _tmp0_;
	gint _tmp1_;
	GdkRectangle _tmp2_;
	gint _tmp3_;
	GdkRectangle _tmp4_;
	gint _tmp5_;
	GdkRectangle _tmp6_;
	gint _tmp7_;
	GdkRectangle _tmp8_;
	gint _tmp9_;
	GdkRectangle _tmp10_;
	gint _tmp11_;
	Box _tmp12_ = {0};
#line 65 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	g_return_if_fail (rect != NULL);
#line 66 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp0_ = *rect;
#line 66 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp1_ = _tmp0_.x;
#line 66 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp2_ = *rect;
#line 66 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp3_ = _tmp2_.y;
#line 66 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp4_ = *rect;
#line 66 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp5_ = _tmp4_.x;
#line 66 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp6_ = *rect;
#line 66 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp7_ = _tmp6_.width;
#line 66 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp8_ = *rect;
#line 66 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp9_ = _tmp8_.y;
#line 66 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp10_ = *rect;
#line 66 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp11_ = _tmp10_.height;
#line 66 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	box_init (&_tmp12_, _tmp1_, _tmp3_, (_tmp5_ + _tmp7_) - 1, (_tmp9_ + _tmp11_) - 1);
#line 66 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	*result = _tmp12_;
#line 66 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	return;
#line 325 "Box.c"
}


void box_from_allocation (GtkAllocation* alloc, Box* result) {
	GtkAllocation _tmp0_;
	gint _tmp1_;
	GtkAllocation _tmp2_;
	gint _tmp3_;
	GtkAllocation _tmp4_;
	gint _tmp5_;
	GtkAllocation _tmp6_;
	gint _tmp7_;
	GtkAllocation _tmp8_;
	gint _tmp9_;
	GtkAllocation _tmp10_;
	gint _tmp11_;
	Box _tmp12_ = {0};
#line 69 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	g_return_if_fail (alloc != NULL);
#line 70 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp0_ = *alloc;
#line 70 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp1_ = _tmp0_.x;
#line 70 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp2_ = *alloc;
#line 70 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp3_ = _tmp2_.y;
#line 70 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp4_ = *alloc;
#line 70 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp5_ = _tmp4_.x;
#line 70 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp6_ = *alloc;
#line 70 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp7_ = _tmp6_.width;
#line 70 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp8_ = *alloc;
#line 70 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp9_ = _tmp8_.y;
#line 70 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp10_ = *alloc;
#line 70 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp11_ = _tmp10_.height;
#line 70 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	box_init (&_tmp12_, _tmp1_, _tmp3_, (_tmp5_ + _tmp7_) - 1, (_tmp9_ + _tmp11_) - 1);
#line 70 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	*result = _tmp12_;
#line 70 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	return;
#line 375 "Box.c"
}


void box_from_points (GdkPoint* corner1, GdkPoint* corner2, Box* result) {
	GdkPoint _tmp0_;
	gint _tmp1_;
	GdkPoint _tmp2_;
	gint _tmp3_;
	gint _tmp4_ = 0;
	GdkPoint _tmp5_;
	gint _tmp6_;
	GdkPoint _tmp7_;
	gint _tmp8_;
	gint _tmp9_ = 0;
	GdkPoint _tmp10_;
	gint _tmp11_;
	GdkPoint _tmp12_;
	gint _tmp13_;
	gint _tmp14_ = 0;
	GdkPoint _tmp15_;
	gint _tmp16_;
	GdkPoint _tmp17_;
	gint _tmp18_;
	gint _tmp19_ = 0;
	Box _tmp20_ = {0};
#line 75 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	g_return_if_fail (corner1 != NULL);
#line 75 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	g_return_if_fail (corner2 != NULL);
#line 76 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp0_ = *corner1;
#line 76 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp1_ = _tmp0_.x;
#line 76 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp2_ = *corner2;
#line 76 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp3_ = _tmp2_.x;
#line 76 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp4_ = MIN (_tmp1_, _tmp3_);
#line 76 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp5_ = *corner1;
#line 76 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp6_ = _tmp5_.y;
#line 76 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp7_ = *corner2;
#line 76 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp8_ = _tmp7_.y;
#line 76 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp9_ = MIN (_tmp6_, _tmp8_);
#line 76 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp10_ = *corner1;
#line 76 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp11_ = _tmp10_.x;
#line 76 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp12_ = *corner2;
#line 76 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp13_ = _tmp12_.x;
#line 76 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp14_ = MAX (_tmp11_, _tmp13_);
#line 76 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp15_ = *corner1;
#line 76 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp16_ = _tmp15_.y;
#line 76 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp17_ = *corner2;
#line 76 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp18_ = _tmp17_.y;
#line 76 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp19_ = MAX (_tmp16_, _tmp18_);
#line 76 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	box_init (&_tmp20_, _tmp4_, _tmp9_, _tmp14_, _tmp19_);
#line 76 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	*result = _tmp20_;
#line 76 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	return;
#line 451 "Box.c"
}


gint box_get_width (Box *self) {
	gint result = 0;
	gint _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
#line 81 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp0_ = (*self).right;
#line 81 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp1_ = (*self).left;
#line 81 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	g_assert (_tmp0_ >= _tmp1_);
#line 83 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp2_ = (*self).right;
#line 83 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp3_ = (*self).left;
#line 83 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	result = (_tmp2_ - _tmp3_) + 1;
#line 83 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	return result;
#line 475 "Box.c"
}


gint box_get_height (Box *self) {
	gint result = 0;
	gint _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
#line 87 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp0_ = (*self).bottom;
#line 87 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp1_ = (*self).top;
#line 87 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	g_assert (_tmp0_ >= _tmp1_);
#line 89 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp2_ = (*self).bottom;
#line 89 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp3_ = (*self).top;
#line 89 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	result = (_tmp2_ - _tmp3_) + 1;
#line 89 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	return result;
#line 499 "Box.c"
}


gboolean box_is_valid (Box *self) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gint _tmp3_;
	gboolean _tmp5_;
	gboolean _tmp8_;
	gboolean _tmp11_;
#line 93 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp3_ = (*self).left;
#line 93 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	if (_tmp3_ >= 0) {
#line 516 "Box.c"
		gint _tmp4_;
#line 93 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		_tmp4_ = (*self).top;
#line 93 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		_tmp2_ = _tmp4_ >= 0;
#line 522 "Box.c"
	} else {
#line 93 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		_tmp2_ = FALSE;
#line 526 "Box.c"
	}
#line 93 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp5_ = _tmp2_;
#line 93 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	if (_tmp5_) {
#line 532 "Box.c"
		gint _tmp6_;
		gint _tmp7_;
#line 93 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		_tmp6_ = (*self).right;
#line 93 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		_tmp7_ = (*self).left;
#line 93 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		_tmp1_ = _tmp6_ >= _tmp7_;
#line 541 "Box.c"
	} else {
#line 93 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		_tmp1_ = FALSE;
#line 545 "Box.c"
	}
#line 93 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp8_ = _tmp1_;
#line 93 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	if (_tmp8_) {
#line 551 "Box.c"
		gint _tmp9_;
		gint _tmp10_;
#line 93 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		_tmp9_ = (*self).bottom;
#line 93 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		_tmp10_ = (*self).top;
#line 93 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		_tmp0_ = _tmp9_ >= _tmp10_;
#line 560 "Box.c"
	} else {
#line 93 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		_tmp0_ = FALSE;
#line 564 "Box.c"
	}
#line 93 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp11_ = _tmp0_;
#line 93 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	result = _tmp11_;
#line 93 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	return result;
#line 572 "Box.c"
}


gboolean box_equals (Box *self, Box* box) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gint _tmp3_;
	Box _tmp4_;
	gint _tmp5_;
	gboolean _tmp9_;
	gboolean _tmp13_;
	gboolean _tmp17_;
#line 96 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	g_return_val_if_fail (box != NULL, FALSE);
#line 97 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp3_ = (*self).left;
#line 97 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp4_ = *box;
#line 97 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp5_ = _tmp4_.left;
#line 97 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	if (_tmp3_ == _tmp5_) {
#line 597 "Box.c"
		gint _tmp6_;
		Box _tmp7_;
		gint _tmp8_;
#line 97 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		_tmp6_ = (*self).top;
#line 97 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		_tmp7_ = *box;
#line 97 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		_tmp8_ = _tmp7_.top;
#line 97 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		_tmp2_ = _tmp6_ == _tmp8_;
#line 609 "Box.c"
	} else {
#line 97 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		_tmp2_ = FALSE;
#line 613 "Box.c"
	}
#line 97 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp9_ = _tmp2_;
#line 97 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	if (_tmp9_) {
#line 619 "Box.c"
		gint _tmp10_;
		Box _tmp11_;
		gint _tmp12_;
#line 97 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		_tmp10_ = (*self).right;
#line 97 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		_tmp11_ = *box;
#line 97 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		_tmp12_ = _tmp11_.right;
#line 97 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		_tmp1_ = _tmp10_ == _tmp12_;
#line 631 "Box.c"
	} else {
#line 97 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		_tmp1_ = FALSE;
#line 635 "Box.c"
	}
#line 97 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp13_ = _tmp1_;
#line 97 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	if (_tmp13_) {
#line 641 "Box.c"
		gint _tmp14_;
		Box _tmp15_;
		gint _tmp16_;
#line 97 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		_tmp14_ = (*self).bottom;
#line 97 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		_tmp15_ = *box;
#line 97 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		_tmp16_ = _tmp15_.bottom;
#line 97 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		_tmp0_ = _tmp14_ == _tmp16_;
#line 653 "Box.c"
	} else {
#line 97 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		_tmp0_ = FALSE;
#line 657 "Box.c"
	}
#line 97 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp17_ = _tmp0_;
#line 97 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	result = _tmp17_;
#line 97 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	return result;
#line 665 "Box.c"
}


void box_get_scaled (Box *self, Dimensions* scaled, Box* result) {
	gdouble x_scale = 0.0;
	gdouble y_scale = 0.0;
	Dimensions _tmp0_ = {0};
	Dimensions _tmp1_;
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_ = 0.0;
	gint _tmp4_;
	gdouble _tmp5_;
	gdouble _tmp6_ = 0.0;
	gint l;
	gint _tmp7_;
	gdouble _tmp8_;
	gdouble _tmp9_ = 0.0;
	gint t;
	gint _tmp10_;
	Dimensions _tmp11_;
	gint _tmp12_;
	gint r;
	gint _tmp13_;
	Dimensions _tmp14_;
	gint _tmp15_;
	gint b;
	gint _tmp16_;
	gint _tmp17_;
	gint _tmp18_;
	gint _tmp19_;
	Box box = {0};
	gboolean _tmp20_ = FALSE;
	gint _tmp21_ = 0;
	Dimensions _tmp22_;
	gint _tmp23_;
	gboolean _tmp27_;
#line 100 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	g_return_if_fail (scaled != NULL);
#line 102 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	box_get_dimensions (&(*self), &_tmp0_);
#line 102 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp1_ = *scaled;
#line 102 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	dimensions_get_scale_ratios (&_tmp0_, &_tmp1_, &_tmp2_, &_tmp3_);
#line 102 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	x_scale = _tmp2_;
#line 102 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	y_scale = _tmp3_;
#line 104 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp4_ = (*self).left;
#line 104 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp5_ = x_scale;
#line 104 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp6_ = round (((gdouble) _tmp4_) * _tmp5_);
#line 104 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	l = (gint) _tmp6_;
#line 105 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp7_ = (*self).top;
#line 105 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp8_ = y_scale;
#line 105 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp9_ = round (((gdouble) _tmp7_) * _tmp8_);
#line 105 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	t = (gint) _tmp9_;
#line 108 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp10_ = l;
#line 108 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp11_ = *scaled;
#line 108 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp12_ = _tmp11_.width;
#line 108 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	r = (_tmp10_ + _tmp12_) - 1;
#line 109 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp13_ = t;
#line 109 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp14_ = *scaled;
#line 109 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp15_ = _tmp14_.height;
#line 109 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	b = (_tmp13_ + _tmp15_) - 1;
#line 111 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp16_ = l;
#line 111 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp17_ = t;
#line 111 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp18_ = r;
#line 111 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp19_ = b;
#line 111 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	box_init (&box, _tmp16_, _tmp17_, _tmp18_, _tmp19_);
#line 112 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp21_ = box_get_width (&box);
#line 112 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp22_ = *scaled;
#line 112 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp23_ = _tmp22_.width;
#line 112 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	if (_tmp21_ == _tmp23_) {
#line 112 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		_tmp20_ = TRUE;
#line 766 "Box.c"
	} else {
		gint _tmp24_ = 0;
		Dimensions _tmp25_;
		gint _tmp26_;
#line 112 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		_tmp24_ = box_get_height (&box);
#line 112 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		_tmp25_ = *scaled;
#line 112 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		_tmp26_ = _tmp25_.height;
#line 112 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		_tmp20_ = _tmp24_ == _tmp26_;
#line 779 "Box.c"
	}
#line 112 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp27_ = _tmp20_;
#line 112 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	g_assert (_tmp27_);
#line 114 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	*result = box;
#line 114 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	return;
#line 789 "Box.c"
}


void box_get_scaled_similar (Box *self, Dimensions* original, Dimensions* scaled, Box* result) {
	gdouble x_scale = 0.0;
	gdouble y_scale = 0.0;
	Dimensions _tmp0_;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	gint _tmp3_;
	gdouble _tmp4_;
	gdouble _tmp5_ = 0.0;
	gint l;
	gint _tmp6_;
	gdouble _tmp7_;
	gdouble _tmp8_ = 0.0;
	gint t;
	gint _tmp9_;
	gdouble _tmp10_;
	gdouble _tmp11_ = 0.0;
	gint r;
	gint _tmp12_;
	gdouble _tmp13_;
	gdouble _tmp14_ = 0.0;
	gint b;
	gint _tmp15_;
	Dimensions _tmp16_;
	gint _tmp17_;
	gint _tmp20_;
	Dimensions _tmp21_;
	gint _tmp22_;
	gint _tmp25_;
	gint _tmp26_;
	gint _tmp27_;
	gint _tmp28_;
	Box _tmp29_ = {0};
#line 117 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	g_return_if_fail (original != NULL);
#line 117 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	g_return_if_fail (scaled != NULL);
#line 119 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp0_ = *scaled;
#line 119 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	dimensions_get_scale_ratios (original, &_tmp0_, &_tmp1_, &_tmp2_);
#line 119 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	x_scale = _tmp1_;
#line 119 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	y_scale = _tmp2_;
#line 121 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp3_ = (*self).left;
#line 121 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp4_ = x_scale;
#line 121 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp5_ = round (((gdouble) _tmp3_) * _tmp4_);
#line 121 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	l = (gint) _tmp5_;
#line 122 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp6_ = (*self).top;
#line 122 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp7_ = y_scale;
#line 122 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp8_ = round (((gdouble) _tmp6_) * _tmp7_);
#line 122 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	t = (gint) _tmp8_;
#line 123 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp9_ = (*self).right;
#line 123 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp10_ = x_scale;
#line 123 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp11_ = round (((gdouble) _tmp9_) * _tmp10_);
#line 123 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	r = (gint) _tmp11_;
#line 124 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp12_ = (*self).bottom;
#line 124 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp13_ = y_scale;
#line 124 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp14_ = round (((gdouble) _tmp12_) * _tmp13_);
#line 124 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	b = (gint) _tmp14_;
#line 127 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp15_ = r;
#line 127 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp16_ = *scaled;
#line 127 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp17_ = _tmp16_.width;
#line 127 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	if (_tmp15_ >= _tmp17_) {
#line 878 "Box.c"
		Dimensions _tmp18_;
		gint _tmp19_;
#line 128 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		_tmp18_ = *scaled;
#line 128 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		_tmp19_ = _tmp18_.width;
#line 128 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		r = _tmp19_ - 1;
#line 887 "Box.c"
	}
#line 130 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp20_ = b;
#line 130 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp21_ = *scaled;
#line 130 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp22_ = _tmp21_.height;
#line 130 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	if (_tmp20_ >= _tmp22_) {
#line 897 "Box.c"
		Dimensions _tmp23_;
		gint _tmp24_;
#line 131 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		_tmp23_ = *scaled;
#line 131 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		_tmp24_ = _tmp23_.height;
#line 131 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		b = _tmp24_ - 1;
#line 906 "Box.c"
	}
#line 133 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp25_ = l;
#line 133 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp26_ = t;
#line 133 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp27_ = r;
#line 133 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp28_ = b;
#line 133 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	box_init (&_tmp29_, _tmp25_, _tmp26_, _tmp27_, _tmp28_);
#line 133 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	*result = _tmp29_;
#line 133 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	return;
#line 922 "Box.c"
}


void box_get_offset (Box *self, gint xofs, gint yofs, Box* result) {
	gint _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
	Box _tmp8_ = {0};
#line 137 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp0_ = (*self).left;
#line 137 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp1_ = xofs;
#line 137 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp2_ = (*self).top;
#line 137 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp3_ = yofs;
#line 137 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp4_ = (*self).right;
#line 137 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp5_ = xofs;
#line 137 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp6_ = (*self).bottom;
#line 137 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp7_ = yofs;
#line 137 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	box_init (&_tmp8_, _tmp0_ + _tmp1_, _tmp2_ + _tmp3_, _tmp4_ + _tmp5_, _tmp6_ + _tmp7_);
#line 137 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	*result = _tmp8_;
#line 137 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	return;
#line 958 "Box.c"
}


void box_get_dimensions (Box *self, Dimensions* result) {
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	Dimensions _tmp2_ = {0};
#line 141 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp0_ = box_get_width (&(*self));
#line 141 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp1_ = box_get_height (&(*self));
#line 141 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	dimensions_init (&_tmp2_, _tmp0_, _tmp1_);
#line 141 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	*result = _tmp2_;
#line 141 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	return;
#line 976 "Box.c"
}


void box_get_points (Box *self, GdkPoint* top_left, GdkPoint* bottom_right) {
	GdkPoint _vala_top_left = {0};
	GdkPoint _vala_bottom_right = {0};
	gint _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
#line 145 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp0_ = (*self).left;
#line 145 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_vala_top_left.x = _tmp0_;
#line 146 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp1_ = (*self).top;
#line 146 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_vala_top_left.y = _tmp1_;
#line 148 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp2_ = (*self).right;
#line 148 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_vala_bottom_right.x = _tmp2_;
#line 149 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp3_ = (*self).bottom;
#line 149 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_vala_bottom_right.y = _tmp3_;
#line 144 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	if (top_left) {
#line 144 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		*top_left = _vala_top_left;
#line 1007 "Box.c"
	}
#line 144 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	if (bottom_right) {
#line 144 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		*bottom_right = _vala_bottom_right;
#line 1013 "Box.c"
	}
}


void box_get_rectangle (Box *self, GdkRectangle* result) {
	GdkRectangle rect = {0};
	gint _tmp0_;
	gint _tmp1_;
	gint _tmp2_ = 0;
	gint _tmp3_ = 0;
#line 153 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	memset (&rect, 0, sizeof (GdkRectangle));
#line 154 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp0_ = (*self).left;
#line 154 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	rect.x = _tmp0_;
#line 155 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp1_ = (*self).top;
#line 155 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	rect.y = _tmp1_;
#line 156 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp2_ = box_get_width (&(*self));
#line 156 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	rect.width = _tmp2_;
#line 157 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp3_ = box_get_height (&(*self));
#line 157 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	rect.height = _tmp3_;
#line 159 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	*result = rect;
#line 159 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	return;
#line 1046 "Box.c"
}


void box_rotate_clockwise (Box *self, Dimensions* space, Box* result) {
	Dimensions _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint l;
	gint _tmp3_;
	gint t;
	Dimensions _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	gint r;
	gint _tmp7_;
	gint b;
	Box _tmp8_ = {0};
#line 162 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	g_return_if_fail (space != NULL);
#line 163 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp0_ = *space;
#line 163 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp1_ = _tmp0_.width;
#line 163 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp2_ = (*self).bottom;
#line 163 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	l = (_tmp1_ - _tmp2_) - 1;
#line 164 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp3_ = (*self).left;
#line 164 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	t = _tmp3_;
#line 165 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp4_ = *space;
#line 165 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp5_ = _tmp4_.width;
#line 165 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp6_ = (*self).top;
#line 165 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	r = (_tmp5_ - _tmp6_) - 1;
#line 166 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp7_ = (*self).right;
#line 166 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	b = _tmp7_;
#line 168 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	box_init (&_tmp8_, l, t, r, b);
#line 168 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	*result = _tmp8_;
#line 168 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	return;
#line 1096 "Box.c"
}


void box_rotate_counterclockwise (Box *self, Dimensions* space, Box* result) {
	gint _tmp0_;
	gint l;
	Dimensions _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	gint t;
	gint _tmp4_;
	gint r;
	Dimensions _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
	gint b;
	Box _tmp8_ = {0};
#line 171 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	g_return_if_fail (space != NULL);
#line 172 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp0_ = (*self).top;
#line 172 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	l = _tmp0_;
#line 173 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp1_ = *space;
#line 173 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp2_ = _tmp1_.height;
#line 173 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp3_ = (*self).right;
#line 173 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	t = (_tmp2_ - _tmp3_) - 1;
#line 174 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp4_ = (*self).bottom;
#line 174 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	r = _tmp4_;
#line 175 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp5_ = *space;
#line 175 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp6_ = _tmp5_.height;
#line 175 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp7_ = (*self).left;
#line 175 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	b = (_tmp6_ - _tmp7_) - 1;
#line 177 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	box_init (&_tmp8_, l, t, r, b);
#line 177 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	*result = _tmp8_;
#line 177 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	return;
#line 1146 "Box.c"
}


void box_flip_left_to_right (Box *self, Dimensions* space, Box* result) {
	Dimensions _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint l;
	Dimensions _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	gint r;
	gint _tmp6_;
	gint _tmp7_;
	Box _tmp8_ = {0};
#line 180 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	g_return_if_fail (space != NULL);
#line 181 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp0_ = *space;
#line 181 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp1_ = _tmp0_.width;
#line 181 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp2_ = (*self).right;
#line 181 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	l = (_tmp1_ - _tmp2_) - 1;
#line 182 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp3_ = *space;
#line 182 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp4_ = _tmp3_.width;
#line 182 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp5_ = (*self).left;
#line 182 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	r = (_tmp4_ - _tmp5_) - 1;
#line 184 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp6_ = (*self).top;
#line 184 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp7_ = (*self).bottom;
#line 184 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	box_init (&_tmp8_, l, _tmp6_, r, _tmp7_);
#line 184 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	*result = _tmp8_;
#line 184 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	return;
#line 1190 "Box.c"
}


void box_flip_top_to_bottom (Box *self, Dimensions* space, Box* result) {
	Dimensions _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint t;
	Dimensions _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	gint b;
	gint _tmp6_;
	gint _tmp7_;
	Box _tmp8_ = {0};
#line 187 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	g_return_if_fail (space != NULL);
#line 188 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp0_ = *space;
#line 188 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp1_ = _tmp0_.height;
#line 188 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp2_ = (*self).bottom;
#line 188 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	t = (_tmp1_ - _tmp2_) - 1;
#line 189 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp3_ = *space;
#line 189 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp4_ = _tmp3_.height;
#line 189 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp5_ = (*self).top;
#line 189 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	b = (_tmp4_ - _tmp5_) - 1;
#line 191 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp6_ = (*self).left;
#line 191 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp7_ = (*self).right;
#line 191 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	box_init (&_tmp8_, _tmp6_, t, _tmp7_, b);
#line 191 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	*result = _tmp8_;
#line 191 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	return;
#line 1234 "Box.c"
}


gboolean box_intersects (Box *self, Box* compare) {
	gboolean result = FALSE;
	gint _tmp0_;
	Box _tmp1_;
	gint _tmp2_;
	gint _tmp3_ = 0;
	gint left_intersect;
	gint _tmp4_;
	Box _tmp5_;
	gint _tmp6_;
	gint _tmp7_ = 0;
	gint top_intersect;
	gint _tmp8_;
	Box _tmp9_;
	gint _tmp10_;
	gint _tmp11_ = 0;
	gint right_intersect;
	gint _tmp12_;
	Box _tmp13_;
	gint _tmp14_;
	gint _tmp15_ = 0;
	gint bottom_intersect;
	gboolean _tmp16_ = FALSE;
	gint _tmp17_;
	gint _tmp18_;
	gboolean _tmp21_;
#line 194 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	g_return_val_if_fail (compare != NULL, FALSE);
#line 195 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp0_ = (*self).left;
#line 195 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp1_ = *compare;
#line 195 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp2_ = _tmp1_.left;
#line 195 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp3_ = MAX (_tmp0_, _tmp2_);
#line 195 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	left_intersect = _tmp3_;
#line 196 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp4_ = (*self).top;
#line 196 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp5_ = *compare;
#line 196 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp6_ = _tmp5_.top;
#line 196 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp7_ = MAX (_tmp4_, _tmp6_);
#line 196 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	top_intersect = _tmp7_;
#line 197 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp8_ = (*self).right;
#line 197 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp9_ = *compare;
#line 197 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp10_ = _tmp9_.right;
#line 197 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp11_ = MIN (_tmp8_, _tmp10_);
#line 197 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	right_intersect = _tmp11_;
#line 198 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp12_ = (*self).bottom;
#line 198 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp13_ = *compare;
#line 198 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp14_ = _tmp13_.bottom;
#line 198 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp15_ = MIN (_tmp12_, _tmp14_);
#line 198 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	bottom_intersect = _tmp15_;
#line 200 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp17_ = right_intersect;
#line 200 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp18_ = left_intersect;
#line 200 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	if (_tmp17_ >= _tmp18_) {
#line 1312 "Box.c"
		gint _tmp19_;
		gint _tmp20_;
#line 200 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		_tmp19_ = bottom_intersect;
#line 200 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		_tmp20_ = top_intersect;
#line 200 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		_tmp16_ = _tmp19_ >= _tmp20_;
#line 1321 "Box.c"
	} else {
#line 200 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		_tmp16_ = FALSE;
#line 1325 "Box.c"
	}
#line 200 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp21_ = _tmp16_;
#line 200 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	result = _tmp21_;
#line 200 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	return result;
#line 1333 "Box.c"
}


void box_get_reduced (Box *self, gint amount, Box* result) {
	gint _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
	Box _tmp8_ = {0};
#line 204 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp0_ = (*self).left;
#line 204 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp1_ = amount;
#line 204 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp2_ = (*self).top;
#line 204 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp3_ = amount;
#line 204 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp4_ = (*self).right;
#line 204 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp5_ = amount;
#line 204 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp6_ = (*self).bottom;
#line 204 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp7_ = amount;
#line 204 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	box_init (&_tmp8_, _tmp0_ + _tmp1_, _tmp2_ + _tmp3_, _tmp4_ - _tmp5_, _tmp6_ - _tmp7_);
#line 204 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	*result = _tmp8_;
#line 204 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	return;
#line 1369 "Box.c"
}


void box_get_expanded (Box *self, gint amount, Box* result) {
	gint _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
	Box _tmp8_ = {0};
#line 208 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp0_ = (*self).left;
#line 208 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp1_ = amount;
#line 208 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp2_ = (*self).top;
#line 208 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp3_ = amount;
#line 208 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp4_ = (*self).right;
#line 208 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp5_ = amount;
#line 208 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp6_ = (*self).bottom;
#line 208 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp7_ = amount;
#line 208 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	box_init (&_tmp8_, _tmp0_ - _tmp1_, _tmp2_ - _tmp3_, _tmp4_ + _tmp5_, _tmp6_ + _tmp7_);
#line 208 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	*result = _tmp8_;
#line 208 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	return;
#line 1405 "Box.c"
}


gboolean box_contains (Box *self, GdkPoint* point) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	GdkPoint _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	gboolean _tmp9_;
	gboolean _tmp13_;
	gboolean _tmp17_;
#line 211 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	g_return_val_if_fail (point != NULL, FALSE);
#line 212 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp3_ = *point;
#line 212 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp4_ = _tmp3_.x;
#line 212 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp5_ = (*self).left;
#line 212 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	if (_tmp4_ >= _tmp5_) {
#line 1430 "Box.c"
		GdkPoint _tmp6_;
		gint _tmp7_;
		gint _tmp8_;
#line 212 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		_tmp6_ = *point;
#line 212 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		_tmp7_ = _tmp6_.x;
#line 212 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		_tmp8_ = (*self).right;
#line 212 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		_tmp2_ = _tmp7_ <= _tmp8_;
#line 1442 "Box.c"
	} else {
#line 212 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		_tmp2_ = FALSE;
#line 1446 "Box.c"
	}
#line 212 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp9_ = _tmp2_;
#line 212 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	if (_tmp9_) {
#line 1452 "Box.c"
		GdkPoint _tmp10_;
		gint _tmp11_;
		gint _tmp12_;
#line 212 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		_tmp10_ = *point;
#line 212 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		_tmp11_ = _tmp10_.y;
#line 212 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		_tmp12_ = (*self).top;
#line 212 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		_tmp1_ = _tmp11_ >= _tmp12_;
#line 1464 "Box.c"
	} else {
#line 212 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		_tmp1_ = FALSE;
#line 1468 "Box.c"
	}
#line 212 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp13_ = _tmp1_;
#line 212 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	if (_tmp13_) {
#line 1474 "Box.c"
		GdkPoint _tmp14_;
		gint _tmp15_;
		gint _tmp16_;
#line 212 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		_tmp14_ = *point;
#line 212 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		_tmp15_ = _tmp14_.y;
#line 212 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		_tmp16_ = (*self).bottom;
#line 212 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		_tmp0_ = _tmp15_ <= _tmp16_;
#line 1486 "Box.c"
	} else {
#line 212 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		_tmp0_ = FALSE;
#line 1490 "Box.c"
	}
#line 212 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp17_ = _tmp0_;
#line 212 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	result = _tmp17_;
#line 212 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	return result;
#line 1498 "Box.c"
}


BoxComplements box_resized_complements (Box *self, Box* resized, Box* horizontal, gboolean* horizontal_enlarged, Box* vertical, gboolean* vertical_enlarged) {
	Box _vala_horizontal = {0};
	gboolean _vala_horizontal_enlarged = FALSE;
	Box _vala_vertical = {0};
	gboolean _vala_vertical_enlarged = FALSE;
	BoxComplements result = 0;
	gboolean horizontal_complement;
	Box _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gboolean vertical_complement;
	Box _tmp40_;
	gint _tmp41_;
	gint _tmp42_;
	gboolean _tmp80_;
	gboolean _tmp81_;
	BoxComplements _tmp82_ = 0;
#line 218 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	g_return_val_if_fail (resized != NULL, 0);
#line 221 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	horizontal_complement = TRUE;
#line 222 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp0_ = *resized;
#line 222 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp1_ = _tmp0_.top;
#line 222 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp2_ = (*self).top;
#line 222 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	if (_tmp1_ < _tmp2_) {
#line 1531 "Box.c"
		Box _tmp3_;
		gint _tmp4_;
		Box _tmp5_;
		gint _tmp6_;
		Box _tmp7_;
		gint _tmp8_;
		gint _tmp9_;
		Box _tmp10_ = {0};
#line 224 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		_tmp3_ = *resized;
#line 224 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		_tmp4_ = _tmp3_.left;
#line 224 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		_tmp5_ = *resized;
#line 224 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		_tmp6_ = _tmp5_.top;
#line 224 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		_tmp7_ = *resized;
#line 224 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		_tmp8_ = _tmp7_.right;
#line 224 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		_tmp9_ = (*self).top;
#line 224 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		box_init (&_tmp10_, _tmp4_, _tmp6_, _tmp8_, _tmp9_);
#line 224 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		_vala_horizontal = _tmp10_;
#line 225 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		_vala_horizontal_enlarged = TRUE;
#line 1560 "Box.c"
	} else {
		Box _tmp11_;
		gint _tmp12_;
		gint _tmp13_;
#line 226 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		_tmp11_ = *resized;
#line 226 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		_tmp12_ = _tmp11_.top;
#line 226 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		_tmp13_ = (*self).top;
#line 226 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		if (_tmp12_ > _tmp13_) {
#line 1573 "Box.c"
			gint _tmp14_;
			gint _tmp15_;
			gint _tmp16_;
			Box _tmp17_;
			gint _tmp18_;
			Box _tmp19_ = {0};
#line 228 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
			_tmp14_ = (*self).left;
#line 228 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
			_tmp15_ = (*self).top;
#line 228 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
			_tmp16_ = (*self).right;
#line 228 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
			_tmp17_ = *resized;
#line 228 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
			_tmp18_ = _tmp17_.top;
#line 228 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
			box_init (&_tmp19_, _tmp14_, _tmp15_, _tmp16_, _tmp18_);
#line 228 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
			_vala_horizontal = _tmp19_;
#line 229 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
			_vala_horizontal_enlarged = FALSE;
#line 1596 "Box.c"
		} else {
			Box _tmp20_;
			gint _tmp21_;
			gint _tmp22_;
#line 230 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
			_tmp20_ = *resized;
#line 230 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
			_tmp21_ = _tmp20_.bottom;
#line 230 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
			_tmp22_ = (*self).bottom;
#line 230 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
			if (_tmp21_ < _tmp22_) {
#line 1609 "Box.c"
				gint _tmp23_;
				Box _tmp24_;
				gint _tmp25_;
				gint _tmp26_;
				gint _tmp27_;
				Box _tmp28_ = {0};
#line 232 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
				_tmp23_ = (*self).left;
#line 232 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
				_tmp24_ = *resized;
#line 232 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
				_tmp25_ = _tmp24_.bottom;
#line 232 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
				_tmp26_ = (*self).right;
#line 232 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
				_tmp27_ = (*self).bottom;
#line 232 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
				box_init (&_tmp28_, _tmp23_, _tmp25_, _tmp26_, _tmp27_);
#line 232 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
				_vala_horizontal = _tmp28_;
#line 233 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
				_vala_horizontal_enlarged = FALSE;
#line 1632 "Box.c"
			} else {
				Box _tmp29_;
				gint _tmp30_;
				gint _tmp31_;
#line 234 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
				_tmp29_ = *resized;
#line 234 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
				_tmp30_ = _tmp29_.bottom;
#line 234 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
				_tmp31_ = (*self).bottom;
#line 234 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
				if (_tmp30_ > _tmp31_) {
#line 1645 "Box.c"
					Box _tmp32_;
					gint _tmp33_;
					gint _tmp34_;
					Box _tmp35_;
					gint _tmp36_;
					Box _tmp37_;
					gint _tmp38_;
					Box _tmp39_ = {0};
#line 236 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
					_tmp32_ = *resized;
#line 236 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
					_tmp33_ = _tmp32_.left;
#line 236 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
					_tmp34_ = (*self).bottom;
#line 236 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
					_tmp35_ = *resized;
#line 236 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
					_tmp36_ = _tmp35_.right;
#line 236 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
					_tmp37_ = *resized;
#line 236 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
					_tmp38_ = _tmp37_.bottom;
#line 236 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
					box_init (&_tmp39_, _tmp33_, _tmp34_, _tmp36_, _tmp38_);
#line 236 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
					_vala_horizontal = _tmp39_;
#line 237 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
					_vala_horizontal_enlarged = TRUE;
#line 1674 "Box.c"
				} else {
#line 239 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
					horizontal_complement = FALSE;
#line 1678 "Box.c"
				}
			}
		}
	}
#line 242 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	vertical_complement = TRUE;
#line 243 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp40_ = *resized;
#line 243 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp41_ = _tmp40_.left;
#line 243 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp42_ = (*self).left;
#line 243 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	if (_tmp41_ < _tmp42_) {
#line 1693 "Box.c"
		Box _tmp43_;
		gint _tmp44_;
		Box _tmp45_;
		gint _tmp46_;
		gint _tmp47_;
		Box _tmp48_;
		gint _tmp49_;
		Box _tmp50_ = {0};
#line 245 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		_tmp43_ = *resized;
#line 245 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		_tmp44_ = _tmp43_.left;
#line 245 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		_tmp45_ = *resized;
#line 245 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		_tmp46_ = _tmp45_.top;
#line 245 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		_tmp47_ = (*self).left;
#line 245 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		_tmp48_ = *resized;
#line 245 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		_tmp49_ = _tmp48_.bottom;
#line 245 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		box_init (&_tmp50_, _tmp44_, _tmp46_, _tmp47_, _tmp49_);
#line 245 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		_vala_vertical = _tmp50_;
#line 246 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		_vala_vertical_enlarged = TRUE;
#line 1722 "Box.c"
	} else {
		Box _tmp51_;
		gint _tmp52_;
		gint _tmp53_;
#line 247 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		_tmp51_ = *resized;
#line 247 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		_tmp52_ = _tmp51_.left;
#line 247 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		_tmp53_ = (*self).left;
#line 247 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		if (_tmp52_ > _tmp53_) {
#line 1735 "Box.c"
			gint _tmp54_;
			gint _tmp55_;
			Box _tmp56_;
			gint _tmp57_;
			gint _tmp58_;
			Box _tmp59_ = {0};
#line 249 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
			_tmp54_ = (*self).left;
#line 249 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
			_tmp55_ = (*self).top;
#line 249 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
			_tmp56_ = *resized;
#line 249 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
			_tmp57_ = _tmp56_.left;
#line 249 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
			_tmp58_ = (*self).bottom;
#line 249 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
			box_init (&_tmp59_, _tmp54_, _tmp55_, _tmp57_, _tmp58_);
#line 249 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
			_vala_vertical = _tmp59_;
#line 250 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
			_vala_vertical_enlarged = FALSE;
#line 1758 "Box.c"
		} else {
			Box _tmp60_;
			gint _tmp61_;
			gint _tmp62_;
#line 251 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
			_tmp60_ = *resized;
#line 251 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
			_tmp61_ = _tmp60_.right;
#line 251 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
			_tmp62_ = (*self).right;
#line 251 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
			if (_tmp61_ < _tmp62_) {
#line 1771 "Box.c"
				Box _tmp63_;
				gint _tmp64_;
				gint _tmp65_;
				gint _tmp66_;
				gint _tmp67_;
				Box _tmp68_ = {0};
#line 253 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
				_tmp63_ = *resized;
#line 253 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
				_tmp64_ = _tmp63_.right;
#line 253 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
				_tmp65_ = (*self).top;
#line 253 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
				_tmp66_ = (*self).right;
#line 253 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
				_tmp67_ = (*self).bottom;
#line 253 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
				box_init (&_tmp68_, _tmp64_, _tmp65_, _tmp66_, _tmp67_);
#line 253 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
				_vala_vertical = _tmp68_;
#line 254 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
				_vala_vertical_enlarged = FALSE;
#line 1794 "Box.c"
			} else {
				Box _tmp69_;
				gint _tmp70_;
				gint _tmp71_;
#line 255 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
				_tmp69_ = *resized;
#line 255 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
				_tmp70_ = _tmp69_.right;
#line 255 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
				_tmp71_ = (*self).right;
#line 255 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
				if (_tmp70_ > _tmp71_) {
#line 1807 "Box.c"
					gint _tmp72_;
					Box _tmp73_;
					gint _tmp74_;
					Box _tmp75_;
					gint _tmp76_;
					Box _tmp77_;
					gint _tmp78_;
					Box _tmp79_ = {0};
#line 257 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
					_tmp72_ = (*self).right;
#line 257 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
					_tmp73_ = *resized;
#line 257 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
					_tmp74_ = _tmp73_.top;
#line 257 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
					_tmp75_ = *resized;
#line 257 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
					_tmp76_ = _tmp75_.right;
#line 257 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
					_tmp77_ = *resized;
#line 257 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
					_tmp78_ = _tmp77_.bottom;
#line 257 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
					box_init (&_tmp79_, _tmp72_, _tmp74_, _tmp76_, _tmp78_);
#line 257 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
					_vala_vertical = _tmp79_;
#line 258 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
					_vala_vertical_enlarged = TRUE;
#line 1836 "Box.c"
				} else {
#line 260 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
					vertical_complement = FALSE;
#line 1840 "Box.c"
				}
			}
		}
	}
#line 263 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp80_ = horizontal_complement;
#line 263 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp81_ = vertical_complement;
#line 263 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp82_ = box_complements_derive (_tmp80_, _tmp81_);
#line 263 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	result = _tmp82_;
#line 263 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	if (horizontal) {
#line 263 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		*horizontal = _vala_horizontal;
#line 1857 "Box.c"
	}
#line 263 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	if (horizontal_enlarged) {
#line 263 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		*horizontal_enlarged = _vala_horizontal_enlarged;
#line 1863 "Box.c"
	}
#line 263 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	if (vertical) {
#line 263 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		*vertical = _vala_vertical;
#line 1869 "Box.c"
	}
#line 263 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	if (vertical_enlarged) {
#line 263 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		*vertical_enlarged = _vala_vertical_enlarged;
#line 1875 "Box.c"
	}
#line 263 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	return result;
#line 1879 "Box.c"
}


BoxComplements box_shifted_complements (Box *self, Box* shifted, Box* horizontal_this, Box* vertical_this, Box* horizontal_shifted, Box* vertical_shifted) {
	Box _vala_horizontal_this = {0};
	Box _vala_vertical_this = {0};
	Box _vala_horizontal_shifted = {0};
	Box _vala_vertical_shifted = {0};
	BoxComplements result = 0;
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	gint _tmp3_ = 0;
	gboolean horizontal_complement;
	gboolean _tmp4_ = FALSE;
	Box _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
	gboolean _tmp11_;
	gboolean vertical_complement;
	gboolean _tmp48_ = FALSE;
	Box _tmp49_;
	gint _tmp50_;
	gint _tmp51_;
	gboolean _tmp55_;
	gboolean _tmp92_;
	gboolean _tmp93_;
	BoxComplements _tmp94_ = 0;
#line 269 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	g_return_val_if_fail (shifted != NULL, 0);
#line 271 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp0_ = box_get_width (&(*self));
#line 271 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp1_ = box_get_width (shifted);
#line 271 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	g_assert (_tmp0_ == _tmp1_);
#line 272 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp2_ = box_get_height (&(*self));
#line 272 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp3_ = box_get_height (shifted);
#line 272 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	g_assert (_tmp2_ == _tmp3_);
#line 274 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	horizontal_complement = TRUE;
#line 275 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp5_ = *shifted;
#line 275 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp6_ = _tmp5_.top;
#line 275 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp7_ = (*self).top;
#line 275 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	if (_tmp6_ < _tmp7_) {
#line 1932 "Box.c"
		Box _tmp8_;
		gint _tmp9_;
		gint _tmp10_;
#line 275 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		_tmp8_ = *shifted;
#line 275 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		_tmp9_ = _tmp8_.bottom;
#line 275 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		_tmp10_ = (*self).top;
#line 275 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		_tmp4_ = _tmp9_ > _tmp10_;
#line 1944 "Box.c"
	} else {
#line 275 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		_tmp4_ = FALSE;
#line 1948 "Box.c"
	}
#line 275 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp11_ = _tmp4_;
#line 275 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	if (_tmp11_) {
#line 1954 "Box.c"
		gint _tmp12_;
		Box _tmp13_;
		gint _tmp14_;
		gint _tmp15_;
		gint _tmp16_;
		Box _tmp17_ = {0};
		Box _tmp18_;
		gint _tmp19_;
		Box _tmp20_;
		gint _tmp21_;
		Box _tmp22_;
		gint _tmp23_;
		gint _tmp24_;
		Box _tmp25_ = {0};
#line 277 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		_tmp12_ = (*self).left;
#line 277 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		_tmp13_ = *shifted;
#line 277 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		_tmp14_ = _tmp13_.bottom;
#line 277 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		_tmp15_ = (*self).right;
#line 277 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		_tmp16_ = (*self).bottom;
#line 277 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		box_init (&_tmp17_, _tmp12_, _tmp14_, _tmp15_, _tmp16_);
#line 277 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		_vala_horizontal_this = _tmp17_;
#line 278 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		_tmp18_ = *shifted;
#line 278 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		_tmp19_ = _tmp18_.left;
#line 278 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		_tmp20_ = *shifted;
#line 278 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		_tmp21_ = _tmp20_.top;
#line 278 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		_tmp22_ = *shifted;
#line 278 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		_tmp23_ = _tmp22_.right;
#line 278 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		_tmp24_ = (*self).top;
#line 278 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		box_init (&_tmp25_, _tmp19_, _tmp21_, _tmp23_, _tmp24_);
#line 278 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		_vala_horizontal_shifted = _tmp25_;
#line 2001 "Box.c"
	} else {
		gboolean _tmp26_ = FALSE;
		Box _tmp27_;
		gint _tmp28_;
		gint _tmp29_;
		gboolean _tmp33_;
#line 279 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		_tmp27_ = *shifted;
#line 279 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		_tmp28_ = _tmp27_.top;
#line 279 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		_tmp29_ = (*self).top;
#line 279 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		if (_tmp28_ > _tmp29_) {
#line 2016 "Box.c"
			Box _tmp30_;
			gint _tmp31_;
			gint _tmp32_;
#line 279 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
			_tmp30_ = *shifted;
#line 279 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
			_tmp31_ = _tmp30_.top;
#line 279 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
			_tmp32_ = (*self).bottom;
#line 279 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
			_tmp26_ = _tmp31_ < _tmp32_;
#line 2028 "Box.c"
		} else {
#line 279 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
			_tmp26_ = FALSE;
#line 2032 "Box.c"
		}
#line 279 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		_tmp33_ = _tmp26_;
#line 279 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		if (_tmp33_) {
#line 2038 "Box.c"
			gint _tmp34_;
			gint _tmp35_;
			gint _tmp36_;
			Box _tmp37_;
			gint _tmp38_;
			Box _tmp39_ = {0};
			Box _tmp40_;
			gint _tmp41_;
			gint _tmp42_;
			Box _tmp43_;
			gint _tmp44_;
			Box _tmp45_;
			gint _tmp46_;
			Box _tmp47_ = {0};
#line 281 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
			_tmp34_ = (*self).left;
#line 281 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
			_tmp35_ = (*self).top;
#line 281 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
			_tmp36_ = (*self).right;
#line 281 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
			_tmp37_ = *shifted;
#line 281 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
			_tmp38_ = _tmp37_.top;
#line 281 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
			box_init (&_tmp39_, _tmp34_, _tmp35_, _tmp36_, _tmp38_);
#line 281 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
			_vala_horizontal_this = _tmp39_;
#line 282 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
			_tmp40_ = *shifted;
#line 282 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
			_tmp41_ = _tmp40_.left;
#line 282 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
			_tmp42_ = (*self).bottom;
#line 282 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
			_tmp43_ = *shifted;
#line 282 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
			_tmp44_ = _tmp43_.right;
#line 282 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
			_tmp45_ = *shifted;
#line 282 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
			_tmp46_ = _tmp45_.bottom;
#line 282 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
			box_init (&_tmp47_, _tmp41_, _tmp42_, _tmp44_, _tmp46_);
#line 282 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
			_vala_horizontal_shifted = _tmp47_;
#line 2085 "Box.c"
		} else {
#line 285 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
			horizontal_complement = FALSE;
#line 2089 "Box.c"
		}
	}
#line 288 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	vertical_complement = TRUE;
#line 289 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp49_ = *shifted;
#line 289 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp50_ = _tmp49_.left;
#line 289 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp51_ = (*self).left;
#line 289 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	if (_tmp50_ < _tmp51_) {
#line 2102 "Box.c"
		Box _tmp52_;
		gint _tmp53_;
		gint _tmp54_;
#line 289 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		_tmp52_ = *shifted;
#line 289 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		_tmp53_ = _tmp52_.right;
#line 289 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		_tmp54_ = (*self).left;
#line 289 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		_tmp48_ = _tmp53_ > _tmp54_;
#line 2114 "Box.c"
	} else {
#line 289 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		_tmp48_ = FALSE;
#line 2118 "Box.c"
	}
#line 289 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp55_ = _tmp48_;
#line 289 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	if (_tmp55_) {
#line 2124 "Box.c"
		Box _tmp56_;
		gint _tmp57_;
		gint _tmp58_;
		gint _tmp59_;
		gint _tmp60_;
		Box _tmp61_ = {0};
		Box _tmp62_;
		gint _tmp63_;
		Box _tmp64_;
		gint _tmp65_;
		gint _tmp66_;
		Box _tmp67_;
		gint _tmp68_;
		Box _tmp69_ = {0};
#line 291 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		_tmp56_ = *shifted;
#line 291 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		_tmp57_ = _tmp56_.right;
#line 291 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		_tmp58_ = (*self).top;
#line 291 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		_tmp59_ = (*self).right;
#line 291 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		_tmp60_ = (*self).bottom;
#line 291 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		box_init (&_tmp61_, _tmp57_, _tmp58_, _tmp59_, _tmp60_);
#line 291 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		_vala_vertical_this = _tmp61_;
#line 292 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		_tmp62_ = *shifted;
#line 292 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		_tmp63_ = _tmp62_.left;
#line 292 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		_tmp64_ = *shifted;
#line 292 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		_tmp65_ = _tmp64_.top;
#line 292 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		_tmp66_ = (*self).left;
#line 292 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		_tmp67_ = *shifted;
#line 292 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		_tmp68_ = _tmp67_.bottom;
#line 292 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		box_init (&_tmp69_, _tmp63_, _tmp65_, _tmp66_, _tmp68_);
#line 292 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		_vala_vertical_shifted = _tmp69_;
#line 2171 "Box.c"
	} else {
		gboolean _tmp70_ = FALSE;
		Box _tmp71_;
		gint _tmp72_;
		gint _tmp73_;
		gboolean _tmp77_;
#line 293 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		_tmp71_ = *shifted;
#line 293 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		_tmp72_ = _tmp71_.left;
#line 293 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		_tmp73_ = (*self).left;
#line 293 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		if (_tmp72_ > _tmp73_) {
#line 2186 "Box.c"
			Box _tmp74_;
			gint _tmp75_;
			gint _tmp76_;
#line 293 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
			_tmp74_ = *shifted;
#line 293 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
			_tmp75_ = _tmp74_.left;
#line 293 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
			_tmp76_ = (*self).right;
#line 293 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
			_tmp70_ = _tmp75_ < _tmp76_;
#line 2198 "Box.c"
		} else {
#line 293 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
			_tmp70_ = FALSE;
#line 2202 "Box.c"
		}
#line 293 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		_tmp77_ = _tmp70_;
#line 293 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		if (_tmp77_) {
#line 2208 "Box.c"
			gint _tmp78_;
			gint _tmp79_;
			Box _tmp80_;
			gint _tmp81_;
			gint _tmp82_;
			Box _tmp83_ = {0};
			gint _tmp84_;
			Box _tmp85_;
			gint _tmp86_;
			Box _tmp87_;
			gint _tmp88_;
			Box _tmp89_;
			gint _tmp90_;
			Box _tmp91_ = {0};
#line 295 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
			_tmp78_ = (*self).left;
#line 295 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
			_tmp79_ = (*self).top;
#line 295 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
			_tmp80_ = *shifted;
#line 295 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
			_tmp81_ = _tmp80_.left;
#line 295 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
			_tmp82_ = (*self).bottom;
#line 295 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
			box_init (&_tmp83_, _tmp78_, _tmp79_, _tmp81_, _tmp82_);
#line 295 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
			_vala_vertical_this = _tmp83_;
#line 296 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
			_tmp84_ = (*self).right;
#line 296 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
			_tmp85_ = *shifted;
#line 296 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
			_tmp86_ = _tmp85_.top;
#line 296 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
			_tmp87_ = *shifted;
#line 296 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
			_tmp88_ = _tmp87_.right;
#line 296 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
			_tmp89_ = *shifted;
#line 296 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
			_tmp90_ = _tmp89_.bottom;
#line 296 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
			box_init (&_tmp91_, _tmp84_, _tmp86_, _tmp88_, _tmp90_);
#line 296 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
			_vala_vertical_shifted = _tmp91_;
#line 2255 "Box.c"
		} else {
#line 299 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
			vertical_complement = FALSE;
#line 2259 "Box.c"
		}
	}
#line 302 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp92_ = horizontal_complement;
#line 302 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp93_ = vertical_complement;
#line 302 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp94_ = box_complements_derive (_tmp92_, _tmp93_);
#line 302 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	result = _tmp94_;
#line 302 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	if (horizontal_this) {
#line 302 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		*horizontal_this = _vala_horizontal_this;
#line 2274 "Box.c"
	}
#line 302 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	if (vertical_this) {
#line 302 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		*vertical_this = _vala_vertical_this;
#line 2280 "Box.c"
	}
#line 302 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	if (horizontal_shifted) {
#line 302 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		*horizontal_shifted = _vala_horizontal_shifted;
#line 2286 "Box.c"
	}
#line 302 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	if (vertical_shifted) {
#line 302 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		*vertical_shifted = _vala_vertical_shifted;
#line 2292 "Box.c"
	}
#line 302 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	return result;
#line 2296 "Box.c"
}


void box_rubber_band (Box *self, GdkPoint* point, Box* result) {
	GdkPoint _tmp0_;
	gint _tmp1_;
	GdkPoint _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	GdkPoint _tmp5_;
	gint _tmp6_;
	gint _tmp7_ = 0;
	gint t;
	gint _tmp8_;
	GdkPoint _tmp9_;
	gint _tmp10_;
	gint _tmp11_ = 0;
	gint b;
	gint _tmp12_;
	GdkPoint _tmp13_;
	gint _tmp14_;
	gint _tmp15_ = 0;
	gint l;
	gint _tmp16_;
	GdkPoint _tmp17_;
	gint _tmp18_;
	gint _tmp19_ = 0;
	gint r;
	Box _tmp20_ = {0};
#line 305 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	g_return_if_fail (point != NULL);
#line 306 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp0_ = *point;
#line 306 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp1_ = _tmp0_.x;
#line 306 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	g_assert (_tmp1_ >= 0);
#line 307 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp2_ = *point;
#line 307 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp3_ = _tmp2_.y;
#line 307 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	g_assert (_tmp3_ >= 0);
#line 309 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp4_ = (*self).top;
#line 309 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp5_ = *point;
#line 309 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp6_ = _tmp5_.y;
#line 309 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp7_ = MIN (_tmp4_, _tmp6_);
#line 309 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	t = _tmp7_;
#line 310 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp8_ = (*self).bottom;
#line 310 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp9_ = *point;
#line 310 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp10_ = _tmp9_.y;
#line 310 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp11_ = MAX (_tmp8_, _tmp10_);
#line 310 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	b = _tmp11_;
#line 311 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp12_ = (*self).left;
#line 311 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp13_ = *point;
#line 311 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp14_ = _tmp13_.x;
#line 311 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp15_ = MIN (_tmp12_, _tmp14_);
#line 311 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	l = _tmp15_;
#line 312 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp16_ = (*self).right;
#line 312 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp17_ = *point;
#line 312 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp18_ = _tmp17_.x;
#line 312 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp19_ = MAX (_tmp16_, _tmp18_);
#line 312 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	r = _tmp19_;
#line 314 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	box_init (&_tmp20_, l, t, r, b);
#line 314 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	*result = _tmp20_;
#line 314 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	return;
#line 2386 "Box.c"
}


gchar* box_to_string (Box *self) {
	gchar* result = NULL;
	gint _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	Dimensions _tmp4_ = {0};
	gchar* _tmp5_ = NULL;
	gchar* _tmp6_;
	gchar* _tmp7_ = NULL;
	gchar* _tmp8_;
#line 318 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp0_ = (*self).left;
#line 318 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp1_ = (*self).top;
#line 318 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp2_ = (*self).right;
#line 318 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp3_ = (*self).bottom;
#line 318 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	box_get_dimensions (&(*self), &_tmp4_);
#line 318 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp5_ = dimensions_to_string (&_tmp4_);
#line 318 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp6_ = _tmp5_;
#line 318 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp7_ = g_strdup_printf ("%d,%d %d,%d (%s)", _tmp0_, _tmp1_, _tmp2_, _tmp3_, _tmp6_);
#line 318 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp8_ = _tmp7_;
#line 318 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_g_free0 (_tmp6_);
#line 318 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	result = _tmp8_;
#line 318 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	return result;
#line 2425 "Box.c"
}


static gboolean box_in_zone (gdouble pos, gint zone) {
	gboolean result = FALSE;
	gint _tmp0_;
	gint top_zone;
	gint _tmp1_;
	gint bottom_zone;
	gdouble _tmp2_;
	gboolean _tmp3_ = FALSE;
#line 322 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp0_ = zone;
#line 322 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	top_zone = _tmp0_ - BOX_HAND_GRENADES;
#line 323 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp1_ = zone;
#line 323 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	bottom_zone = _tmp1_ + BOX_HAND_GRENADES;
#line 325 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp2_ = pos;
#line 325 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp3_ = box_in_between (_tmp2_, top_zone, bottom_zone);
#line 325 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	result = _tmp3_;
#line 325 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	return result;
#line 2453 "Box.c"
}


static gboolean box_in_between (gdouble pos, gint top, gint bottom) {
	gboolean result = FALSE;
	gdouble _tmp0_;
	gint ipos;
	gboolean _tmp1_ = FALSE;
	gint _tmp2_;
	gint _tmp3_;
	gboolean _tmp6_;
#line 329 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp0_ = pos;
#line 329 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	ipos = (gint) _tmp0_;
#line 331 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp2_ = ipos;
#line 331 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp3_ = top;
#line 331 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	if (_tmp2_ > _tmp3_) {
#line 2475 "Box.c"
		gint _tmp4_;
		gint _tmp5_;
#line 331 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		_tmp4_ = ipos;
#line 331 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		_tmp5_ = bottom;
#line 331 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		_tmp1_ = _tmp4_ < _tmp5_;
#line 2484 "Box.c"
	} else {
#line 331 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		_tmp1_ = FALSE;
#line 2488 "Box.c"
	}
#line 331 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp6_ = _tmp1_;
#line 331 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	result = _tmp6_;
#line 331 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	return result;
#line 2496 "Box.c"
}


static gboolean box_near_in_between (gdouble pos, gint top, gint bottom) {
	gboolean result = FALSE;
	gdouble _tmp0_;
	gint ipos;
	gint _tmp1_;
	gint top_zone;
	gint _tmp2_;
	gint bottom_zone;
	gboolean _tmp3_ = FALSE;
	gint _tmp4_;
	gint _tmp5_;
	gboolean _tmp8_;
#line 335 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp0_ = pos;
#line 335 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	ipos = (gint) _tmp0_;
#line 336 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp1_ = top;
#line 336 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	top_zone = _tmp1_ - BOX_HAND_GRENADES;
#line 337 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp2_ = bottom;
#line 337 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	bottom_zone = _tmp2_ + BOX_HAND_GRENADES;
#line 339 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp4_ = ipos;
#line 339 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp5_ = top_zone;
#line 339 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	if (_tmp4_ > _tmp5_) {
#line 2530 "Box.c"
		gint _tmp6_;
		gint _tmp7_;
#line 339 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		_tmp6_ = ipos;
#line 339 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		_tmp7_ = bottom_zone;
#line 339 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		_tmp3_ = _tmp6_ < _tmp7_;
#line 2539 "Box.c"
	} else {
#line 339 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		_tmp3_ = FALSE;
#line 2543 "Box.c"
	}
#line 339 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp8_ = _tmp3_;
#line 339 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	result = _tmp8_;
#line 339 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	return result;
#line 2551 "Box.c"
}


BoxLocation box_approx_location (Box *self, gint x, gint y) {
	BoxLocation result = 0;
	gint _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gboolean _tmp3_ = FALSE;
	gboolean near_width;
	gint _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	gboolean _tmp7_ = FALSE;
	gboolean near_height;
	gboolean _tmp8_ = FALSE;
	gint _tmp9_;
	gint _tmp10_;
	gboolean _tmp11_ = FALSE;
	gboolean _tmp13_;
#line 343 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp0_ = x;
#line 343 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp1_ = (*self).left;
#line 343 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp2_ = (*self).right;
#line 343 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp3_ = box_near_in_between ((gdouble) _tmp0_, _tmp1_, _tmp2_);
#line 343 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	near_width = _tmp3_;
#line 344 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp4_ = y;
#line 344 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp5_ = (*self).top;
#line 344 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp6_ = (*self).bottom;
#line 344 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp7_ = box_near_in_between ((gdouble) _tmp4_, _tmp5_, _tmp6_);
#line 344 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	near_height = _tmp7_;
#line 346 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp9_ = x;
#line 346 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp10_ = (*self).left;
#line 346 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp11_ = box_in_zone ((gdouble) _tmp9_, _tmp10_);
#line 346 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	if (_tmp11_) {
#line 2600 "Box.c"
		gboolean _tmp12_;
#line 346 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		_tmp12_ = near_height;
#line 346 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		_tmp8_ = _tmp12_;
#line 2606 "Box.c"
	} else {
#line 346 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		_tmp8_ = FALSE;
#line 2610 "Box.c"
	}
#line 346 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	_tmp13_ = _tmp8_;
#line 346 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	if (_tmp13_) {
#line 2616 "Box.c"
		gint _tmp14_;
		gint _tmp15_;
		gboolean _tmp16_ = FALSE;
#line 347 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		_tmp14_ = y;
#line 347 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		_tmp15_ = (*self).top;
#line 347 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		_tmp16_ = box_in_zone ((gdouble) _tmp14_, _tmp15_);
#line 347 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		if (_tmp16_) {
#line 348 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
			result = BOX_LOCATION_TOP_LEFT;
#line 348 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
			return result;
#line 2632 "Box.c"
		} else {
			gint _tmp17_;
			gint _tmp18_;
			gboolean _tmp19_ = FALSE;
#line 349 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
			_tmp17_ = y;
#line 349 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
			_tmp18_ = (*self).bottom;
#line 349 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
			_tmp19_ = box_in_zone ((gdouble) _tmp17_, _tmp18_);
#line 349 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
			if (_tmp19_) {
#line 350 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
				result = BOX_LOCATION_BOTTOM_LEFT;
#line 350 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
				return result;
#line 2649 "Box.c"
			} else {
#line 352 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
				result = BOX_LOCATION_LEFT_SIDE;
#line 352 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
				return result;
#line 2655 "Box.c"
			}
		}
	} else {
		gboolean _tmp20_ = FALSE;
		gint _tmp21_;
		gint _tmp22_;
		gboolean _tmp23_ = FALSE;
		gboolean _tmp25_;
#line 354 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		_tmp21_ = x;
#line 354 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		_tmp22_ = (*self).right;
#line 354 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		_tmp23_ = box_in_zone ((gdouble) _tmp21_, _tmp22_);
#line 354 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		if (_tmp23_) {
#line 2672 "Box.c"
			gboolean _tmp24_;
#line 354 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
			_tmp24_ = near_height;
#line 354 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
			_tmp20_ = _tmp24_;
#line 2678 "Box.c"
		} else {
#line 354 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
			_tmp20_ = FALSE;
#line 2682 "Box.c"
		}
#line 354 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		_tmp25_ = _tmp20_;
#line 354 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
		if (_tmp25_) {
#line 2688 "Box.c"
			gint _tmp26_;
			gint _tmp27_;
			gboolean _tmp28_ = FALSE;
#line 355 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
			_tmp26_ = y;
#line 355 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
			_tmp27_ = (*self).top;
#line 355 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
			_tmp28_ = box_in_zone ((gdouble) _tmp26_, _tmp27_);
#line 355 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
			if (_tmp28_) {
#line 356 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
				result = BOX_LOCATION_TOP_RIGHT;
#line 356 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
				return result;
#line 2704 "Box.c"
			} else {
				gint _tmp29_;
				gint _tmp30_;
				gboolean _tmp31_ = FALSE;
#line 357 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
				_tmp29_ = y;
#line 357 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
				_tmp30_ = (*self).bottom;
#line 357 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
				_tmp31_ = box_in_zone ((gdouble) _tmp29_, _tmp30_);
#line 357 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
				if (_tmp31_) {
#line 358 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
					result = BOX_LOCATION_BOTTOM_RIGHT;
#line 358 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
					return result;
#line 2721 "Box.c"
				} else {
#line 360 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
					result = BOX_LOCATION_RIGHT_SIDE;
#line 360 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
					return result;
#line 2727 "Box.c"
				}
			}
		} else {
			gboolean _tmp32_ = FALSE;
			gint _tmp33_;
			gint _tmp34_;
			gboolean _tmp35_ = FALSE;
			gboolean _tmp37_;
#line 362 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
			_tmp33_ = y;
#line 362 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
			_tmp34_ = (*self).top;
#line 362 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
			_tmp35_ = box_in_zone ((gdouble) _tmp33_, _tmp34_);
#line 362 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
			if (_tmp35_) {
#line 2744 "Box.c"
				gboolean _tmp36_;
#line 362 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
				_tmp36_ = near_width;
#line 362 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
				_tmp32_ = _tmp36_;
#line 2750 "Box.c"
			} else {
#line 362 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
				_tmp32_ = FALSE;
#line 2754 "Box.c"
			}
#line 362 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
			_tmp37_ = _tmp32_;
#line 362 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
			if (_tmp37_) {
#line 364 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
				result = BOX_LOCATION_TOP_SIDE;
#line 364 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
				return result;
#line 2764 "Box.c"
			} else {
				gboolean _tmp38_ = FALSE;
				gint _tmp39_;
				gint _tmp40_;
				gboolean _tmp41_ = FALSE;
				gboolean _tmp43_;
#line 365 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
				_tmp39_ = y;
#line 365 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
				_tmp40_ = (*self).bottom;
#line 365 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
				_tmp41_ = box_in_zone ((gdouble) _tmp39_, _tmp40_);
#line 365 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
				if (_tmp41_) {
#line 2779 "Box.c"
					gboolean _tmp42_;
#line 365 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
					_tmp42_ = near_width;
#line 365 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
					_tmp38_ = _tmp42_;
#line 2785 "Box.c"
				} else {
#line 365 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
					_tmp38_ = FALSE;
#line 2789 "Box.c"
				}
#line 365 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
				_tmp43_ = _tmp38_;
#line 365 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
				if (_tmp43_) {
#line 367 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
					result = BOX_LOCATION_BOTTOM_SIDE;
#line 367 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
					return result;
#line 2799 "Box.c"
				} else {
					gboolean _tmp44_ = FALSE;
					gint _tmp45_;
					gint _tmp46_;
					gint _tmp47_;
					gboolean _tmp48_ = FALSE;
					gboolean _tmp53_;
#line 368 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
					_tmp45_ = x;
#line 368 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
					_tmp46_ = (*self).left;
#line 368 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
					_tmp47_ = (*self).right;
#line 368 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
					_tmp48_ = box_in_between ((gdouble) _tmp45_, _tmp46_, _tmp47_);
#line 368 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
					if (_tmp48_) {
#line 2817 "Box.c"
						gint _tmp49_;
						gint _tmp50_;
						gint _tmp51_;
						gboolean _tmp52_ = FALSE;
#line 368 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
						_tmp49_ = y;
#line 368 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
						_tmp50_ = (*self).top;
#line 368 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
						_tmp51_ = (*self).bottom;
#line 368 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
						_tmp52_ = box_in_between ((gdouble) _tmp49_, _tmp50_, _tmp51_);
#line 368 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
						_tmp44_ = _tmp52_;
#line 2832 "Box.c"
					} else {
#line 368 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
						_tmp44_ = FALSE;
#line 2836 "Box.c"
					}
#line 368 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
					_tmp53_ = _tmp44_;
#line 368 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
					if (_tmp53_) {
#line 369 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
						result = BOX_LOCATION_INSIDE;
#line 369 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
						return result;
#line 2846 "Box.c"
					} else {
#line 371 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
						result = BOX_LOCATION_OUTSIDE;
#line 371 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
						return result;
#line 2852 "Box.c"
					}
				}
			}
		}
	}
}


Box* box_dup (const Box* self) {
	Box* dup;
#line 38 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	dup = g_new0 (Box, 1);
#line 38 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	memcpy (dup, self, sizeof (Box));
#line 38 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	return dup;
#line 2869 "Box.c"
}


void box_free (Box* self) {
#line 38 "/builddir/build/BUILD/shotwell-0.10.1/src/Box.vala"
	g_free (self);
#line 2876 "Box.c"
}


GType box_get_type (void) {
	static volatile gsize box_type_id__volatile = 0;
	if (g_once_init_enter (&box_type_id__volatile)) {
		GType box_type_id;
		box_type_id = g_boxed_type_register_static ("Box", (GBoxedCopyFunc) box_dup, (GBoxedFreeFunc) box_free);
		g_once_init_leave (&box_type_id__volatile, box_type_id);
	}
	return box_type_id__volatile;
}



