/* Db.c generated by valac 0.14.2, the Vala compiler
 * generated from Db.vala, do not modify */

/* Copyright 2011 Yorba Foundation
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution. 
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>

#define _g_free0(var) (var = (g_free (var), NULL))

#define DB_TYPE_VERIFY_RESULT (db_verify_result_get_type ())

#define TYPE_DATABASE_TABLE (database_table_get_type ())
#define DATABASE_TABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATABASE_TABLE, DatabaseTable))
#define DATABASE_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATABASE_TABLE, DatabaseTableClass))
#define IS_DATABASE_TABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATABASE_TABLE))
#define IS_DATABASE_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATABASE_TABLE))
#define DATABASE_TABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATABASE_TABLE, DatabaseTableClass))

typedef struct _DatabaseTable DatabaseTable;
typedef struct _DatabaseTableClass DatabaseTableClass;

#define TYPE_VERSION_TABLE (version_table_get_type ())
#define VERSION_TABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_VERSION_TABLE, VersionTable))
#define VERSION_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_VERSION_TABLE, VersionTableClass))
#define IS_VERSION_TABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_VERSION_TABLE))
#define IS_VERSION_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_VERSION_TABLE))
#define VERSION_TABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_VERSION_TABLE, VersionTableClass))

typedef struct _VersionTable VersionTable;
typedef struct _VersionTableClass VersionTableClass;
#define _database_table_unref0(var) ((var == NULL) ? NULL : (var = (database_table_unref (var), NULL)))

typedef enum  {
	DB_VERIFY_RESULT_OK,
	DB_VERIFY_RESULT_FUTURE_VERSION,
	DB_VERIFY_RESULT_UPGRADE_ERROR,
	DB_VERIFY_RESULT_NO_UPGRADE_AVAILABLE
} DbVerifyResult;


extern gchar* db_filename;
gchar* db_filename = NULL;

#define DB_IN_MEMORY_NAME ":memory:"
void db_preconfigure (GFile* db_file);
void db_init (GError** error);
void database_table_init (const gchar* filename);
void db_terminate (void);
void database_table_terminate (void);
GType db_verify_result_get_type (void) G_GNUC_CONST;
DbVerifyResult db_verify_database (gchar** app_version, gint* schema_version);
gpointer database_table_ref (gpointer instance);
void database_table_unref (gpointer instance);
GParamSpec* param_spec_database_table (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_database_table (GValue* value, gpointer v_object);
void value_take_database_table (GValue* value, gpointer v_object);
gpointer value_get_database_table (const GValue* value);
GType database_table_get_type (void) G_GNUC_CONST;
GType version_table_get_type (void) G_GNUC_CONST;
VersionTable* version_table_get_instance (void);
gint version_table_get_version (VersionTable* self, gchar** app_version);
#define DATABASE_TABLE_SCHEMA_VERSION 12
#define RESOURCES_APP_VERSION _VERSION
void version_table_set_version (VersionTable* self, gint version, const gchar* app_version, const gchar* user_data);
DbVerifyResult db_upgrade_database (gint version);
gboolean database_table_has_column (const gchar* table_name, const gchar* column_name);
gboolean database_table_add_column (const gchar* table_name, const gchar* column_name, const gchar* column_constraints);
gboolean database_table_has_table (const gchar* table_name);
gboolean database_table_ensure_column (const gchar* table_name, const gchar* column_name, const gchar* column_constraints, const gchar* upgrade_msg);
void version_table_update_version (VersionTable* self, gint version, const gchar* app_version);


void db_preconfigure (GFile* db_file) {
	gchar* _tmp0_ = NULL;
	GFile* _tmp1_;
	const gchar* _tmp5_;
	gchar* _tmp6_;
#line 14 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
	g_return_if_fail ((db_file == NULL) || G_IS_FILE (db_file));
#line 15 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
	_tmp1_ = db_file;
#line 15 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
	if (_tmp1_ != NULL) {
#line 93 "Db.c"
		GFile* _tmp2_;
		gchar* _tmp3_ = NULL;
#line 15 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
		_tmp2_ = db_file;
#line 15 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
		_tmp3_ = g_file_get_path (_tmp2_);
#line 15 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
		_g_free0 (_tmp0_);
#line 15 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
		_tmp0_ = _tmp3_;
#line 104 "Db.c"
	} else {
		gchar* _tmp4_;
#line 15 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
		_tmp4_ = g_strdup (DB_IN_MEMORY_NAME);
#line 15 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
		_g_free0 (_tmp0_);
#line 15 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
		_tmp0_ = _tmp4_;
#line 113 "Db.c"
	}
#line 15 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
	_tmp5_ = _tmp0_;
#line 15 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
	_tmp6_ = g_strdup (_tmp5_);
#line 15 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
	_g_free0 (db_filename);
#line 15 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
	db_filename = _tmp6_;
#line 14 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
	_g_free0 (_tmp0_);
#line 125 "Db.c"
}


void db_init (GError** error) {
	const gchar* _tmp0_;
	const gchar* _tmp1_;
#line 19 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
	_tmp0_ = db_filename;
#line 19 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
	g_assert (_tmp0_ != NULL);
#line 21 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
	_tmp1_ = db_filename;
#line 21 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
	database_table_init (_tmp1_);
#line 140 "Db.c"
}


void db_terminate (void) {
#line 25 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
	database_table_terminate ();
#line 147 "Db.c"
}


GType db_verify_result_get_type (void) {
	static volatile gsize db_verify_result_type_id__volatile = 0;
	if (g_once_init_enter (&db_verify_result_type_id__volatile)) {
		static const GEnumValue values[] = {{DB_VERIFY_RESULT_OK, "DB_VERIFY_RESULT_OK", "ok"}, {DB_VERIFY_RESULT_FUTURE_VERSION, "DB_VERIFY_RESULT_FUTURE_VERSION", "future-version"}, {DB_VERIFY_RESULT_UPGRADE_ERROR, "DB_VERIFY_RESULT_UPGRADE_ERROR", "upgrade-error"}, {DB_VERIFY_RESULT_NO_UPGRADE_AVAILABLE, "DB_VERIFY_RESULT_NO_UPGRADE_AVAILABLE", "no-upgrade-available"}, {0, NULL, NULL}};
		GType db_verify_result_type_id;
		db_verify_result_type_id = g_enum_register_static ("DbVerifyResult", values);
		g_once_init_leave (&db_verify_result_type_id__volatile, db_verify_result_type_id);
	}
	return db_verify_result_type_id__volatile;
}


DbVerifyResult db_verify_database (gchar** app_version, gint* schema_version) {
	gchar* _vala_app_version = NULL;
	gint _vala_schema_version = 0;
	DbVerifyResult result = 0;
	VersionTable* _tmp0_ = NULL;
	VersionTable* version_table;
	VersionTable* _tmp1_;
	gchar* _tmp2_ = NULL;
	gint _tmp3_ = 0;
	gint _tmp4_;
	gint _tmp7_;
#line 36 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
	_tmp0_ = version_table_get_instance ();
#line 36 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
	version_table = _tmp0_;
#line 37 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
	_tmp1_ = version_table;
#line 37 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
	_tmp3_ = version_table_get_version (_tmp1_, &_tmp2_);
#line 37 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
	_g_free0 (_vala_app_version);
#line 37 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
	_vala_app_version = _tmp2_;
#line 37 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
	_vala_schema_version = _tmp3_;
#line 39 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
	_tmp4_ = _vala_schema_version;
#line 39 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
	if (_tmp4_ >= 0) {
#line 192 "Db.c"
		gint _tmp5_;
		const gchar* _tmp6_;
#line 40 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
		_tmp5_ = _vala_schema_version;
#line 40 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
		_tmp6_ = _vala_app_version;
#line 40 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
		g_debug ("Db.vala:40: Database schema version %d created by app version %s", _tmp5_, _tmp6_);
#line 201 "Db.c"
	}
#line 42 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
	_tmp7_ = _vala_schema_version;
#line 42 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
	if (_tmp7_ == (-1)) {
#line 207 "Db.c"
		VersionTable* _tmp8_;
		gchar* _tmp9_;
#line 44 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
		g_debug ("Db.vala:44: Creating database schema version %d for app version %s", DATABASE_TABLE_SCHEMA_VERSION, RESOURCES_APP_VERSION);
#line 46 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
		_tmp8_ = version_table;
#line 46 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
		version_table_set_version (_tmp8_, DATABASE_TABLE_SCHEMA_VERSION, RESOURCES_APP_VERSION, NULL);
#line 47 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
		_tmp9_ = g_strdup (RESOURCES_APP_VERSION);
#line 47 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
		_g_free0 (_vala_app_version);
#line 47 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
		_vala_app_version = _tmp9_;
#line 48 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
		_vala_schema_version = DATABASE_TABLE_SCHEMA_VERSION;
#line 224 "Db.c"
	} else {
		gint _tmp10_;
#line 49 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
		_tmp10_ = _vala_schema_version;
#line 49 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
		if (_tmp10_ > DATABASE_TABLE_SCHEMA_VERSION) {
#line 51 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
			result = DB_VERIFY_RESULT_FUTURE_VERSION;
#line 51 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
			_database_table_unref0 (version_table);
#line 51 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
			if (app_version) {
#line 51 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
				*app_version = _vala_app_version;
#line 239 "Db.c"
			} else {
#line 51 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
				_g_free0 (_vala_app_version);
#line 243 "Db.c"
			}
#line 51 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
			if (schema_version) {
#line 51 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
				*schema_version = _vala_schema_version;
#line 249 "Db.c"
			}
#line 51 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
			return result;
#line 253 "Db.c"
		} else {
			gint _tmp11_;
#line 52 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
			_tmp11_ = _vala_schema_version;
#line 52 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
			if (_tmp11_ < DATABASE_TABLE_SCHEMA_VERSION) {
#line 260 "Db.c"
				gint _tmp12_;
				DbVerifyResult _tmp13_ = 0;
				DbVerifyResult _result_;
				DbVerifyResult _tmp14_;
#line 54 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
				_tmp12_ = _vala_schema_version;
#line 54 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
				_tmp13_ = db_upgrade_database (_tmp12_);
#line 54 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
				_result_ = _tmp13_;
#line 55 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
				_tmp14_ = _result_;
#line 55 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
				if (_tmp14_ != DB_VERIFY_RESULT_OK) {
#line 56 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
					result = _result_;
#line 56 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
					_database_table_unref0 (version_table);
#line 56 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
					if (app_version) {
#line 56 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
						*app_version = _vala_app_version;
#line 283 "Db.c"
					} else {
#line 56 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
						_g_free0 (_vala_app_version);
#line 287 "Db.c"
					}
#line 56 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
					if (schema_version) {
#line 56 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
						*schema_version = _vala_schema_version;
#line 293 "Db.c"
					}
#line 56 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
					return result;
#line 297 "Db.c"
				}
			}
		}
	}
#line 59 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
	result = DB_VERIFY_RESULT_OK;
#line 59 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
	_database_table_unref0 (version_table);
#line 59 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
	if (app_version) {
#line 59 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
		*app_version = _vala_app_version;
#line 310 "Db.c"
	} else {
#line 59 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
		_g_free0 (_vala_app_version);
#line 314 "Db.c"
	}
#line 59 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
	if (schema_version) {
#line 59 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
		*schema_version = _vala_schema_version;
#line 320 "Db.c"
	}
#line 59 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
	return result;
#line 324 "Db.c"
}


DbVerifyResult db_upgrade_database (gint version) {
	DbVerifyResult result = 0;
	gint _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp5_ = FALSE;
	gboolean _tmp7_ = FALSE;
	gboolean _tmp9_ = FALSE;
	gboolean _tmp11_ = FALSE;
	gboolean _tmp13_ = FALSE;
	gboolean _tmp15_ = FALSE;
	gboolean _tmp17_ = FALSE;
	gboolean _tmp19_ = FALSE;
	gboolean _tmp20_ = FALSE;
	gboolean _tmp22_;
	gboolean _tmp24_ = FALSE;
	gboolean _tmp26_ = FALSE;
	gint _tmp27_;
	VersionTable* _tmp28_ = NULL;
	VersionTable* _tmp29_;
	gint _tmp30_;
	gint _tmp31_;
#line 63 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
	_tmp0_ = version;
#line 63 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
	g_assert (_tmp0_ < DATABASE_TABLE_SCHEMA_VERSION);
#line 66 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
	_tmp1_ = version;
#line 66 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
	if (_tmp1_ == 1) {
#line 67 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
		result = DB_VERIFY_RESULT_NO_UPGRADE_AVAILABLE;
#line 67 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
		return result;
#line 363 "Db.c"
	}
#line 69 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
	_tmp2_ = version;
#line 69 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
	g_message ("Db.vala:69: Upgrading database from schema version %d to %d", _tmp2_, DATABASE_TABLE_SCHEMA_VERSION);
#line 81 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
	_tmp3_ = database_table_has_column ("PhotoTable", "flags");
#line 81 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
	if (!_tmp3_) {
#line 373 "Db.c"
		gboolean _tmp4_ = FALSE;
#line 82 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
		g_message ("Db.vala:82: upgrade_database: adding flags column to PhotoTable");
#line 83 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
		_tmp4_ = database_table_add_column ("PhotoTable", "flags", "INTEGER DEFAULT 0");
#line 83 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
		if (!_tmp4_) {
#line 84 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
			result = DB_VERIFY_RESULT_UPGRADE_ERROR;
#line 84 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
			return result;
#line 385 "Db.c"
		}
	}
#line 87 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
	version = 3;
#line 98 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
	_tmp5_ = database_table_has_column ("PhotoTable", "file_format");
#line 98 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
	if (!_tmp5_) {
#line 394 "Db.c"
		gboolean _tmp6_ = FALSE;
#line 99 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
		g_message ("Db.vala:99: upgrade_database: adding file_format column to PhotoTable");
#line 100 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
		_tmp6_ = database_table_add_column ("PhotoTable", "file_format", "INTEGER DEFAULT 0");
#line 100 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
		if (!_tmp6_) {
#line 101 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
			result = DB_VERIFY_RESULT_UPGRADE_ERROR;
#line 101 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
			return result;
#line 406 "Db.c"
		}
	}
#line 104 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
	version = 4;
#line 111 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
	_tmp7_ = database_table_has_column ("PhotoTable", "title");
#line 111 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
	if (!_tmp7_) {
#line 415 "Db.c"
		gboolean _tmp8_ = FALSE;
#line 112 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
		g_message ("Db.vala:112: upgrade_database: adding title column to PhotoTable");
#line 113 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
		_tmp8_ = database_table_add_column ("PhotoTable", "title", "TEXT");
#line 113 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
		if (!_tmp8_) {
#line 114 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
			result = DB_VERIFY_RESULT_UPGRADE_ERROR;
#line 114 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
			return result;
#line 427 "Db.c"
		}
	}
#line 117 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
	version = 5;
#line 124 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
	_tmp9_ = database_table_has_column ("PhotoTable", "backlinks");
#line 124 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
	if (!_tmp9_) {
#line 436 "Db.c"
		gboolean _tmp10_ = FALSE;
#line 125 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
		g_message ("Db.vala:125: upgrade_database: adding backlinks column to PhotoTable");
#line 126 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
		_tmp10_ = database_table_add_column ("PhotoTable", "backlinks", "TEXT");
#line 126 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
		if (!_tmp10_) {
#line 127 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
			result = DB_VERIFY_RESULT_UPGRADE_ERROR;
#line 127 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
			return result;
#line 448 "Db.c"
		}
	}
#line 130 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
	version = 6;
#line 144 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
	_tmp11_ = database_table_has_column ("PhotoTable", "time_reimported");
#line 144 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
	if (!_tmp11_) {
#line 457 "Db.c"
		gboolean _tmp12_ = FALSE;
#line 145 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
		g_message ("Db.vala:145: upgrade_database: adding time_reimported column to PhotoT" \
"able");
#line 146 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
		_tmp12_ = database_table_add_column ("PhotoTable", "time_reimported", "INTEGER");
#line 146 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
		if (!_tmp12_) {
#line 147 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
			result = DB_VERIFY_RESULT_UPGRADE_ERROR;
#line 147 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
			return result;
#line 469 "Db.c"
		}
	}
#line 150 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
	_tmp13_ = database_table_has_column ("PhotoTable", "editable_id");
#line 150 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
	if (!_tmp13_) {
#line 476 "Db.c"
		gboolean _tmp14_ = FALSE;
#line 151 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
		g_message ("Db.vala:151: upgrade_database: adding editable_id column to PhotoTable");
#line 152 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
		_tmp14_ = database_table_add_column ("PhotoTable", "editable_id", "INTEGER DEFAULT -1");
#line 152 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
		if (!_tmp14_) {
#line 153 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
			result = DB_VERIFY_RESULT_UPGRADE_ERROR;
#line 153 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
			return result;
#line 488 "Db.c"
		}
	}
#line 156 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
	version = 7;
#line 168 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
	_tmp15_ = database_table_has_column ("PhotoTable", "rating");
#line 168 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
	if (!_tmp15_) {
#line 497 "Db.c"
		gboolean _tmp16_ = FALSE;
#line 169 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
		g_message ("Db.vala:169: upgrade_database: adding rating column to PhotoTable");
#line 170 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
		_tmp16_ = database_table_add_column ("PhotoTable", "rating", "INTEGER DEFAULT 0");
#line 170 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
		if (!_tmp16_) {
#line 171 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
			result = DB_VERIFY_RESULT_UPGRADE_ERROR;
#line 171 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
			return result;
#line 509 "Db.c"
		}
	}
#line 180 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
	_tmp17_ = database_table_has_column ("PhotoTable", "metadata_dirty");
#line 180 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
	if (!_tmp17_) {
#line 516 "Db.c"
		gboolean _tmp18_ = FALSE;
#line 181 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
		g_message ("Db.vala:181: upgrade_database: adding metadata_dirty column to PhotoTa" \
"ble");
#line 182 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
		_tmp18_ = database_table_add_column ("PhotoTable", "metadata_dirty", "INTEGER DEFAULT 1");
#line 182 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
		if (!_tmp18_) {
#line 183 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
			result = DB_VERIFY_RESULT_UPGRADE_ERROR;
#line 183 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
			return result;
#line 528 "Db.c"
		}
	}
#line 186 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
	version = 9;
#line 193 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
	_tmp20_ = database_table_has_table ("VideoTable");
#line 193 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
	if (_tmp20_) {
#line 537 "Db.c"
		gboolean _tmp21_ = FALSE;
#line 193 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
		_tmp21_ = database_table_has_column ("VideoTable", "flags");
#line 193 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
		_tmp19_ = !_tmp21_;
#line 543 "Db.c"
	} else {
#line 193 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
		_tmp19_ = FALSE;
#line 547 "Db.c"
	}
#line 193 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
	_tmp22_ = _tmp19_;
#line 193 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
	if (_tmp22_) {
#line 553 "Db.c"
		gboolean _tmp23_ = FALSE;
#line 194 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
		g_message ("Db.vala:194: upgrade_database: adding flags column to VideoTable");
#line 195 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
		_tmp23_ = database_table_add_column ("VideoTable", "flags", "INTEGER DEFAULT 0");
#line 195 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
		if (!_tmp23_) {
#line 196 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
			result = DB_VERIFY_RESULT_UPGRADE_ERROR;
#line 196 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
			return result;
#line 565 "Db.c"
		}
	}
#line 199 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
	version = 10;
#line 206 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
	_tmp24_ = database_table_has_column ("EventTable", "primary_source_id");
#line 206 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
	if (!_tmp24_) {
#line 574 "Db.c"
		gboolean _tmp25_ = FALSE;
#line 207 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
		g_message ("Db.vala:207: upgrade_database: adding primary_source_id column to Even" \
"tTable");
#line 208 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
		_tmp25_ = database_table_add_column ("EventTable", "primary_source_id", "INTEGER DEFAULT 0");
#line 208 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
		if (!_tmp25_) {
#line 209 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
			result = DB_VERIFY_RESULT_UPGRADE_ERROR;
#line 209 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
			return result;
#line 586 "Db.c"
		}
	}
#line 212 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
	version = 11;
#line 219 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
	_tmp26_ = database_table_ensure_column ("TombstoneTable", "reason", "INTEGER DEFAULT 0", "upgrade_database: adding reason column to TombstoneTable");
#line 219 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
	if (!_tmp26_) {
#line 221 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
		result = DB_VERIFY_RESULT_UPGRADE_ERROR;
#line 221 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
		return result;
#line 599 "Db.c"
	}
#line 224 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
	version = 12;
#line 226 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
	_tmp27_ = version;
#line 226 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
	g_assert (_tmp27_ == DATABASE_TABLE_SCHEMA_VERSION);
#line 227 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
	_tmp28_ = version_table_get_instance ();
#line 227 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
	_tmp29_ = _tmp28_;
#line 227 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
	_tmp30_ = version;
#line 227 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
	version_table_update_version (_tmp29_, _tmp30_, RESOURCES_APP_VERSION);
#line 227 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
	_database_table_unref0 (_tmp29_);
#line 229 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
	_tmp31_ = version;
#line 229 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
	g_message ("Db.vala:229: Database upgrade to schema version %d successful", _tmp31_);
#line 231 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
	result = DB_VERIFY_RESULT_OK;
#line 231 "/builddir/build/BUILD/shotwell-0.10.1/src/db/Db.vala"
	return result;
#line 625 "Db.c"
}



