/* TagTable.c generated by valac 0.14.2, the Vala compiler
 * generated from TagTable.vala, do not modify */

/* Copyright 2011 Yorba Foundation
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution. 
 */

#include <glib.h>
#include <glib-object.h>
#include <string.h>
#include <stdlib.h>
#include <gee.h>
#include <time.h>
#include <sqlite3.h>


#define TYPE_TAG_ID (tag_id_get_type ())
typedef struct _TagID TagID;

#define TYPE_TAG_ROW (tag_row_get_type ())
typedef struct _TagRow TagRow;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define TYPE_DATABASE_TABLE (database_table_get_type ())
#define DATABASE_TABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATABASE_TABLE, DatabaseTable))
#define DATABASE_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATABASE_TABLE, DatabaseTableClass))
#define IS_DATABASE_TABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATABASE_TABLE))
#define IS_DATABASE_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATABASE_TABLE))
#define DATABASE_TABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATABASE_TABLE, DatabaseTableClass))

typedef struct _DatabaseTable DatabaseTable;
typedef struct _DatabaseTableClass DatabaseTableClass;
typedef struct _DatabaseTablePrivate DatabaseTablePrivate;

#define TYPE_TAG_TABLE (tag_table_get_type ())
#define TAG_TABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TAG_TABLE, TagTable))
#define TAG_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TAG_TABLE, TagTableClass))
#define IS_TAG_TABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TAG_TABLE))
#define IS_TAG_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TAG_TABLE))
#define TAG_TABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TAG_TABLE, TagTableClass))

typedef struct _TagTable TagTable;
typedef struct _TagTableClass TagTableClass;
typedef struct _TagTablePrivate TagTablePrivate;
#define _sqlite3_finalize0(var) ((var == NULL) ? NULL : (var = (sqlite3_finalize (var), NULL)))
#define _database_table_unref0(var) ((var == NULL) ? NULL : (var = (database_table_unref (var), NULL)))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))

#define TYPE_PHOTO_ID (photo_id_get_type ())
typedef struct _PhotoID PhotoID;

struct _TagID {
	gint64 id;
};

struct _TagRow {
	TagID tag_id;
	gchar* name;
	GeeSet* source_id_list;
	time_t time_created;
};

struct _DatabaseTable {
	GTypeInstance parent_instance;
	volatile int ref_count;
	DatabaseTablePrivate * priv;
	gchar* table_name;
};

struct _DatabaseTableClass {
	GTypeClass parent_class;
	void (*finalize) (DatabaseTable *self);
};

struct _TagTable {
	DatabaseTable parent_instance;
	TagTablePrivate * priv;
};

struct _TagTableClass {
	DatabaseTableClass parent_class;
};

typedef enum  {
	DATABASE_ERROR_ERROR,
	DATABASE_ERROR_BACKING,
	DATABASE_ERROR_MEMORY,
	DATABASE_ERROR_ABORT,
	DATABASE_ERROR_LIMITS,
	DATABASE_ERROR_TYPESPEC
} DatabaseError;
#define DATABASE_ERROR database_error_quark ()
struct _PhotoID {
	gint64 id;
};


static gpointer tag_table_parent_class = NULL;
static TagTable* tag_table_instance;
static TagTable* tag_table_instance = NULL;
extern sqlite3* database_table_db;

GType tag_id_get_type (void) G_GNUC_CONST;
TagID* tag_id_dup (const TagID* self);
void tag_id_free (TagID* self);
#define TAG_ID_INVALID ((gint64) (-1))
void tag_id_init (TagID *self, gint64 id);
gboolean tag_id_is_invalid (TagID *self);
gboolean tag_id_is_valid (TagID *self);
GType tag_row_get_type (void) G_GNUC_CONST;
TagRow* tag_row_dup (const TagRow* self);
void tag_row_free (TagRow* self);
void tag_row_copy (const TagRow* self, TagRow* dest);
void tag_row_destroy (TagRow* self);
gpointer database_table_ref (gpointer instance);
void database_table_unref (gpointer instance);
GParamSpec* param_spec_database_table (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_database_table (GValue* value, gpointer v_object);
void value_take_database_table (GValue* value, gpointer v_object);
gpointer value_get_database_table (const GValue* value);
GType database_table_get_type (void) G_GNUC_CONST;
GType tag_table_get_type (void) G_GNUC_CONST;
enum  {
	TAG_TABLE_DUMMY_PROPERTY
};
static TagTable* tag_table_new (void);
static TagTable* tag_table_construct (GType object_type);
DatabaseTable* database_table_construct (GType object_type);
void database_table_set_table_name (DatabaseTable* self, const gchar* table_name);
void database_table_fatal (const gchar* op, gint res);
TagTable* tag_table_get_instance (void);
GQuark database_error_quark (void);
void tag_table_add (TagTable* self, const gchar* name, TagRow* result, GError** error);
gulong now_sec (void);
void database_table_throw_error (const gchar* method, gint res, GError** error);
void tag_table_create_from_row (TagTable* self, TagRow* row, TagID* result, GError** error);
static gchar* tag_table_serialize_source_ids (TagTable* self, GeeCollection* source_ids);
void tag_table_remove (TagTable* self, TagID* tag_id, GError** error);
void database_table_delete_by_id (DatabaseTable* self, gint64 id, GError** error);
gchar* tag_table_get_name (TagTable* self, TagID* tag_id, GError** error);
gboolean database_table_select_by_id (DatabaseTable* self, gint64 id, const gchar* columns, sqlite3_stmt** stmt);
TagRow* tag_table_get_row (TagTable* self, TagID* tag_id, GError** error);
static GeeSet* tag_table_unserialize_source_ids (TagTable* self, const gchar* text_list);
GeeList* tag_table_get_all_rows (TagTable* self, GError** error);
void tag_table_rename (TagTable* self, TagID* tag_id, const gchar* new_name, GError** error);
void database_table_update_text_by_id_2 (DatabaseTable* self, gint64 id, const gchar* column, const gchar* text, GError** error);
void tag_table_set_tagged_sources (TagTable* self, TagID* tag_id, GeeCollection* source_ids, GError** error);
gboolean is_string_empty (const gchar* s);
GType photo_id_get_type (void) G_GNUC_CONST;
PhotoID* photo_id_dup (const PhotoID* self);
void photo_id_free (PhotoID* self);
gchar* photo_id_upgrade_photo_id_to_source_id (PhotoID* photo_id);
gint64 parse_int64 (const gchar* str, gint num_base);
void photo_id_init (PhotoID *self, gint64 id);
static void tag_table_finalize (DatabaseTable* obj);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);


void tag_id_init (TagID *self, gint64 id) {
	gint64 _tmp0_;
#line 12 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	memset (self, 0, sizeof (TagID));
#line 13 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	_tmp0_ = id;
#line 13 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	(*self).id = _tmp0_;
#line 173 "TagTable.c"
}


gboolean tag_id_is_invalid (TagID *self) {
	gboolean result = FALSE;
	gint64 _tmp0_;
#line 17 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	_tmp0_ = (*self).id;
#line 17 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	result = _tmp0_ == TAG_ID_INVALID;
#line 17 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	return result;
#line 186 "TagTable.c"
}


gboolean tag_id_is_valid (TagID *self) {
	gboolean result = FALSE;
	gint64 _tmp0_;
#line 21 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	_tmp0_ = (*self).id;
#line 21 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	result = _tmp0_ != TAG_ID_INVALID;
#line 21 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	return result;
#line 199 "TagTable.c"
}


TagID* tag_id_dup (const TagID* self) {
	TagID* dup;
#line 7 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	dup = g_new0 (TagID, 1);
#line 7 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	memcpy (dup, self, sizeof (TagID));
#line 7 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	return dup;
#line 211 "TagTable.c"
}


void tag_id_free (TagID* self) {
#line 7 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	g_free (self);
#line 218 "TagTable.c"
}


GType tag_id_get_type (void) {
	static volatile gsize tag_id_type_id__volatile = 0;
	if (g_once_init_enter (&tag_id_type_id__volatile)) {
		GType tag_id_type_id;
		tag_id_type_id = g_boxed_type_register_static ("TagID", (GBoxedCopyFunc) tag_id_dup, (GBoxedFreeFunc) tag_id_free);
		g_once_init_leave (&tag_id_type_id__volatile, tag_id_type_id);
	}
	return tag_id_type_id__volatile;
}


static gpointer _g_object_ref0 (gpointer self) {
#line 25 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	return self ? g_object_ref (self) : NULL;
#line 236 "TagTable.c"
}


void tag_row_copy (const TagRow* self, TagRow* dest) {
	TagID _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	GeeSet* _tmp3_;
	GeeSet* _tmp4_;
	time_t _tmp5_;
#line 25 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	_tmp0_ = (*self).tag_id;
#line 25 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	(*dest).tag_id = _tmp0_;
#line 25 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	_tmp1_ = (*self).name;
#line 25 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	_tmp2_ = g_strdup (_tmp1_);
#line 25 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	_g_free0 ((*dest).name);
#line 25 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	(*dest).name = _tmp2_;
#line 25 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	_tmp3_ = (*self).source_id_list;
#line 25 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	_tmp4_ = _g_object_ref0 (_tmp3_);
#line 25 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	_g_object_unref0 ((*dest).source_id_list);
#line 25 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	(*dest).source_id_list = _tmp4_;
#line 25 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	_tmp5_ = (*self).time_created;
#line 25 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	(*dest).time_created = _tmp5_;
#line 271 "TagTable.c"
}


void tag_row_destroy (TagRow* self) {
#line 27 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	_g_free0 ((*self).name);
#line 28 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	_g_object_unref0 ((*self).source_id_list);
#line 280 "TagTable.c"
}


TagRow* tag_row_dup (const TagRow* self) {
	TagRow* dup;
#line 25 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	dup = g_new0 (TagRow, 1);
#line 25 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	tag_row_copy (self, dup);
#line 25 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	return dup;
#line 292 "TagTable.c"
}


void tag_row_free (TagRow* self) {
#line 25 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	tag_row_destroy (self);
#line 25 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	g_free (self);
#line 301 "TagTable.c"
}


GType tag_row_get_type (void) {
	static volatile gsize tag_row_type_id__volatile = 0;
	if (g_once_init_enter (&tag_row_type_id__volatile)) {
		GType tag_row_type_id;
		tag_row_type_id = g_boxed_type_register_static ("TagRow", (GBoxedCopyFunc) tag_row_dup, (GBoxedFreeFunc) tag_row_free);
		g_once_init_leave (&tag_row_type_id__volatile, tag_row_type_id);
	}
	return tag_row_type_id__volatile;
}


static TagTable* tag_table_construct (GType object_type) {
	TagTable* self = NULL;
	sqlite3_stmt* stmt = NULL;
	sqlite3* _tmp0_;
	sqlite3_stmt* _tmp1_ = NULL;
	gint _tmp2_ = 0;
	gint res;
	gint _tmp3_;
	sqlite3_stmt* _tmp4_;
	gint _tmp5_ = 0;
	gint _tmp6_;
#line 35 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	self = (TagTable*) database_table_construct (object_type);
#line 36 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	database_table_set_table_name (DATABASE_TABLE (self), "TagTable");
#line 39 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	_tmp0_ = database_table_db;
#line 39 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	_tmp2_ = sqlite3_prepare_v2 (_tmp0_, "CREATE TABLE IF NOT EXISTS " "TagTable " "(" "id INTEGER PRIMARY KEY, " "name TEXT UNIQUE NOT NULL, " "photo_id_list TEXT, " "time_created INTEGER" ")", -1, &_tmp1_, NULL);
#line 39 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	_sqlite3_finalize0 (stmt);
#line 39 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	stmt = _tmp1_;
#line 39 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	res = _tmp2_;
#line 47 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	_tmp3_ = res;
#line 47 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	g_assert (_tmp3_ == SQLITE_OK);
#line 49 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	_tmp4_ = stmt;
#line 49 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	_tmp5_ = sqlite3_step (_tmp4_);
#line 49 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	res = _tmp5_;
#line 50 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	_tmp6_ = res;
#line 50 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	if (_tmp6_ != SQLITE_DONE) {
#line 355 "TagTable.c"
		gint _tmp7_;
#line 51 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
		_tmp7_ = res;
#line 51 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
		database_table_fatal ("create TagTable", _tmp7_);
#line 361 "TagTable.c"
	}
#line 35 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	_sqlite3_finalize0 (stmt);
#line 35 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	return self;
#line 367 "TagTable.c"
}


static TagTable* tag_table_new (void) {
#line 35 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	return tag_table_construct (TYPE_TAG_TABLE);
#line 374 "TagTable.c"
}


static gpointer _database_table_ref0 (gpointer self) {
#line 58 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	return self ? database_table_ref (self) : NULL;
#line 381 "TagTable.c"
}


TagTable* tag_table_get_instance (void) {
	TagTable* result = NULL;
	TagTable* _tmp0_;
	TagTable* _tmp2_;
	TagTable* _tmp3_;
#line 55 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	_tmp0_ = tag_table_instance;
#line 55 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	if (_tmp0_ == NULL) {
#line 394 "TagTable.c"
		TagTable* _tmp1_;
#line 56 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
		_tmp1_ = tag_table_new ();
#line 56 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
		_database_table_unref0 (tag_table_instance);
#line 56 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
		tag_table_instance = _tmp1_;
#line 402 "TagTable.c"
	}
#line 58 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	_tmp2_ = tag_table_instance;
#line 58 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	_tmp3_ = _database_table_ref0 (_tmp2_);
#line 58 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	result = _tmp3_;
#line 58 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	return result;
#line 412 "TagTable.c"
}


void tag_table_add (TagTable* self, const gchar* name, TagRow* result, GError** error) {
	sqlite3_stmt* stmt = NULL;
	sqlite3* _tmp0_;
	sqlite3_stmt* _tmp1_ = NULL;
	gint _tmp2_ = 0;
	gint res;
	gint _tmp3_;
	gulong _tmp4_ = 0UL;
	time_t time_created;
	sqlite3_stmt* _tmp5_;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	GDestroyNotify _tmp8_;
	gint _tmp9_ = 0;
	gint _tmp10_;
	sqlite3_stmt* _tmp11_;
	time_t _tmp12_;
	gint _tmp13_ = 0;
	gint _tmp14_;
	sqlite3_stmt* _tmp15_;
	gint _tmp16_ = 0;
	gint _tmp17_;
	TagRow row = {0};
	sqlite3* _tmp19_;
	gint64 _tmp20_ = 0LL;
	TagID _tmp21_ = {0};
	const gchar* _tmp22_;
	gchar* _tmp23_;
	time_t _tmp24_;
	GError * _inner_error_ = NULL;
#line 61 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	g_return_if_fail (IS_TAG_TABLE (self));
#line 61 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	g_return_if_fail (name != NULL);
#line 63 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	_tmp0_ = database_table_db;
#line 63 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	_tmp2_ = sqlite3_prepare_v2 (_tmp0_, "INSERT INTO TagTable (name, time_created) VALUES (?, ?)", -1, &_tmp1_, NULL);
#line 63 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	_sqlite3_finalize0 (stmt);
#line 63 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	stmt = _tmp1_;
#line 63 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	res = _tmp2_;
#line 65 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	_tmp3_ = res;
#line 65 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	g_assert (_tmp3_ == SQLITE_OK);
#line 67 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	_tmp4_ = now_sec ();
#line 67 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	time_created = (time_t) _tmp4_;
#line 69 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	_tmp5_ = stmt;
#line 69 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	_tmp6_ = name;
#line 69 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	_tmp7_ = g_strdup (_tmp6_);
#line 69 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	_tmp8_ = g_free;
#line 69 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	_tmp9_ = sqlite3_bind_text (_tmp5_, 1, _tmp7_, -1, _tmp8_);
#line 69 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	res = _tmp9_;
#line 70 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	_tmp10_ = res;
#line 70 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	g_assert (_tmp10_ == SQLITE_OK);
#line 71 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	_tmp11_ = stmt;
#line 71 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	_tmp12_ = time_created;
#line 71 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	_tmp13_ = sqlite3_bind_int64 (_tmp11_, 2, (gint64) _tmp12_);
#line 71 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	res = _tmp13_;
#line 72 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	_tmp14_ = res;
#line 72 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	g_assert (_tmp14_ == SQLITE_OK);
#line 74 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	_tmp15_ = stmt;
#line 74 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	_tmp16_ = sqlite3_step (_tmp15_);
#line 74 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	res = _tmp16_;
#line 75 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	_tmp17_ = res;
#line 75 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	if (_tmp17_ != SQLITE_DONE) {
#line 506 "TagTable.c"
		gint _tmp18_;
#line 76 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
		_tmp18_ = res;
#line 76 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
		database_table_throw_error ("TagTable.add", _tmp18_, &_inner_error_);
#line 76 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
		if (_inner_error_ != NULL) {
#line 76 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
			if (_inner_error_->domain == DATABASE_ERROR) {
#line 76 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
				g_propagate_error (error, _inner_error_);
#line 76 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
				_sqlite3_finalize0 (stmt);
#line 76 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
				return;
#line 522 "TagTable.c"
			} else {
#line 76 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
				_sqlite3_finalize0 (stmt);
#line 76 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 76 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
				g_clear_error (&_inner_error_);
#line 76 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
				return;
#line 532 "TagTable.c"
			}
		}
	}
#line 78 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	memset (&row, 0, sizeof (TagRow));
#line 79 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	_tmp19_ = database_table_db;
#line 79 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	_tmp20_ = sqlite3_last_insert_rowid (_tmp19_);
#line 79 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	tag_id_init (&_tmp21_, _tmp20_);
#line 79 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	row.tag_id = _tmp21_;
#line 80 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	_tmp22_ = name;
#line 80 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	_tmp23_ = g_strdup (_tmp22_);
#line 80 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	_g_free0 (row.name);
#line 80 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	row.name = _tmp23_;
#line 81 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	_g_object_unref0 (row.source_id_list);
#line 81 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	row.source_id_list = NULL;
#line 82 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	_tmp24_ = time_created;
#line 82 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	row.time_created = _tmp24_;
#line 84 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	*result = row;
#line 84 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	_sqlite3_finalize0 (stmt);
#line 84 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	return;
#line 568 "TagTable.c"
}


void tag_table_create_from_row (TagTable* self, TagRow* row, TagID* result, GError** error) {
	sqlite3_stmt* stmt = NULL;
	sqlite3* _tmp0_;
	sqlite3_stmt* _tmp1_ = NULL;
	gint _tmp2_ = 0;
	gint res;
	gint _tmp3_;
	sqlite3_stmt* _tmp4_;
	TagRow _tmp5_;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	GDestroyNotify _tmp8_;
	gint _tmp9_ = 0;
	gint _tmp10_;
	sqlite3_stmt* _tmp11_;
	TagRow _tmp12_;
	GeeSet* _tmp13_;
	gchar* _tmp14_ = NULL;
	GDestroyNotify _tmp15_;
	gint _tmp16_ = 0;
	gint _tmp17_;
	sqlite3_stmt* _tmp18_;
	TagRow _tmp19_;
	time_t _tmp20_;
	gint _tmp21_ = 0;
	gint _tmp22_;
	sqlite3_stmt* _tmp23_;
	gint _tmp24_ = 0;
	gint _tmp25_;
	sqlite3* _tmp27_;
	gint64 _tmp28_ = 0LL;
	TagID _tmp29_ = {0};
	GError * _inner_error_ = NULL;
#line 88 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	g_return_if_fail (IS_TAG_TABLE (self));
#line 88 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	g_return_if_fail (row != NULL);
#line 90 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	_tmp0_ = database_table_db;
#line 90 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	_tmp2_ = sqlite3_prepare_v2 (_tmp0_, "INSERT INTO TagTable (name, photo_id_list, time_created) VALUES (?, ?," \
" ?)", -1, &_tmp1_, NULL);
#line 90 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	_sqlite3_finalize0 (stmt);
#line 90 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	stmt = _tmp1_;
#line 90 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	res = _tmp2_;
#line 92 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	_tmp3_ = res;
#line 92 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	g_assert (_tmp3_ == SQLITE_OK);
#line 94 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	_tmp4_ = stmt;
#line 94 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	_tmp5_ = *row;
#line 94 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	_tmp6_ = _tmp5_.name;
#line 94 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	_tmp7_ = g_strdup (_tmp6_);
#line 94 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	_tmp8_ = g_free;
#line 94 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	_tmp9_ = sqlite3_bind_text (_tmp4_, 1, _tmp7_, -1, _tmp8_);
#line 94 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	res = _tmp9_;
#line 95 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	_tmp10_ = res;
#line 95 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	g_assert (_tmp10_ == SQLITE_OK);
#line 96 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	_tmp11_ = stmt;
#line 96 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	_tmp12_ = *row;
#line 96 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	_tmp13_ = _tmp12_.source_id_list;
#line 96 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	_tmp14_ = tag_table_serialize_source_ids (self, GEE_COLLECTION (_tmp13_));
#line 96 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	_tmp15_ = g_free;
#line 96 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	_tmp16_ = sqlite3_bind_text (_tmp11_, 2, _tmp14_, -1, _tmp15_);
#line 96 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	res = _tmp16_;
#line 97 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	_tmp17_ = res;
#line 97 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	g_assert (_tmp17_ == SQLITE_OK);
#line 98 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	_tmp18_ = stmt;
#line 98 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	_tmp19_ = *row;
#line 98 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	_tmp20_ = _tmp19_.time_created;
#line 98 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	_tmp21_ = sqlite3_bind_int64 (_tmp18_, 3, (gint64) _tmp20_);
#line 98 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	res = _tmp21_;
#line 99 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	_tmp22_ = res;
#line 99 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	g_assert (_tmp22_ == SQLITE_OK);
#line 101 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	_tmp23_ = stmt;
#line 101 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	_tmp24_ = sqlite3_step (_tmp23_);
#line 101 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	res = _tmp24_;
#line 102 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	_tmp25_ = res;
#line 102 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	if (_tmp25_ != SQLITE_DONE) {
#line 683 "TagTable.c"
		gint _tmp26_;
#line 103 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
		_tmp26_ = res;
#line 103 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
		database_table_throw_error ("TagTable.create_from_row", _tmp26_, &_inner_error_);
#line 103 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
		if (_inner_error_ != NULL) {
#line 103 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
			if (_inner_error_->domain == DATABASE_ERROR) {
#line 103 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
				g_propagate_error (error, _inner_error_);
#line 103 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
				_sqlite3_finalize0 (stmt);
#line 103 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
				return;
#line 699 "TagTable.c"
			} else {
#line 103 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
				_sqlite3_finalize0 (stmt);
#line 103 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 103 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
				g_clear_error (&_inner_error_);
#line 103 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
				return;
#line 709 "TagTable.c"
			}
		}
	}
#line 105 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	_tmp27_ = database_table_db;
#line 105 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	_tmp28_ = sqlite3_last_insert_rowid (_tmp27_);
#line 105 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	tag_id_init (&_tmp29_, _tmp28_);
#line 105 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	*result = _tmp29_;
#line 105 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	_sqlite3_finalize0 (stmt);
#line 105 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	return;
#line 725 "TagTable.c"
}


void tag_table_remove (TagTable* self, TagID* tag_id, GError** error) {
	TagID _tmp0_;
	gint64 _tmp1_;
	GError * _inner_error_ = NULL;
#line 108 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	g_return_if_fail (IS_TAG_TABLE (self));
#line 108 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	g_return_if_fail (tag_id != NULL);
#line 109 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	_tmp0_ = *tag_id;
#line 109 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	_tmp1_ = _tmp0_.id;
#line 109 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	database_table_delete_by_id (DATABASE_TABLE (self), _tmp1_, &_inner_error_);
#line 109 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	if (_inner_error_ != NULL) {
#line 109 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
		if (_inner_error_->domain == DATABASE_ERROR) {
#line 109 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
			g_propagate_error (error, _inner_error_);
#line 109 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
			return;
#line 751 "TagTable.c"
		} else {
#line 109 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 109 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
			g_clear_error (&_inner_error_);
#line 109 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
			return;
#line 759 "TagTable.c"
		}
	}
}


gchar* tag_table_get_name (TagTable* self, TagID* tag_id, GError** error) {
	gchar* result = NULL;
	sqlite3_stmt* stmt = NULL;
	TagID _tmp0_;
	gint64 _tmp1_;
	sqlite3_stmt* _tmp2_ = NULL;
	gboolean _tmp3_ = FALSE;
	sqlite3_stmt* _tmp4_;
	const gchar* _tmp5_ = NULL;
	gchar* _tmp6_;
#line 112 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	g_return_val_if_fail (IS_TAG_TABLE (self), NULL);
#line 112 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	g_return_val_if_fail (tag_id != NULL, NULL);
#line 114 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	_tmp0_ = *tag_id;
#line 114 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	_tmp1_ = _tmp0_.id;
#line 114 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	_tmp3_ = database_table_select_by_id (DATABASE_TABLE (self), _tmp1_, "name", &_tmp2_);
#line 114 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	_sqlite3_finalize0 (stmt);
#line 114 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	stmt = _tmp2_;
#line 114 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	if (!_tmp3_) {
#line 115 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
		result = NULL;
#line 115 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
		_sqlite3_finalize0 (stmt);
#line 115 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
		return result;
#line 797 "TagTable.c"
	}
#line 117 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	_tmp4_ = stmt;
#line 117 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	_tmp5_ = sqlite3_column_text (_tmp4_, 0);
#line 117 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	_tmp6_ = g_strdup (_tmp5_);
#line 117 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	result = _tmp6_;
#line 117 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	_sqlite3_finalize0 (stmt);
#line 117 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	return result;
#line 811 "TagTable.c"
}


static gpointer _tag_row_dup0 (gpointer self) {
#line 141 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	return self ? tag_row_dup (self) : NULL;
#line 818 "TagTable.c"
}


TagRow* tag_table_get_row (TagTable* self, TagID* tag_id, GError** error) {
	TagRow* result = NULL;
	sqlite3_stmt* stmt = NULL;
	sqlite3* _tmp0_;
	sqlite3_stmt* _tmp1_ = NULL;
	gint _tmp2_ = 0;
	gint res;
	gint _tmp3_;
	sqlite3_stmt* _tmp4_;
	TagID _tmp5_;
	gint64 _tmp6_;
	gint _tmp7_ = 0;
	gint _tmp8_;
	sqlite3_stmt* _tmp9_;
	gint _tmp10_ = 0;
	gint _tmp11_;
	TagRow row = {0};
	TagID _tmp14_;
	sqlite3_stmt* _tmp15_;
	const gchar* _tmp16_ = NULL;
	gchar* _tmp17_;
	sqlite3_stmt* _tmp18_;
	const gchar* _tmp19_ = NULL;
	GeeSet* _tmp20_ = NULL;
	sqlite3_stmt* _tmp21_;
	gint64 _tmp22_ = 0LL;
	TagRow _tmp23_;
	TagRow* _tmp24_;
	TagRow* _tmp25_;
	GError * _inner_error_ = NULL;
#line 120 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	g_return_val_if_fail (IS_TAG_TABLE (self), NULL);
#line 120 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	g_return_val_if_fail (tag_id != NULL, NULL);
#line 122 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	_tmp0_ = database_table_db;
#line 122 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	_tmp2_ = sqlite3_prepare_v2 (_tmp0_, "SELECT name, photo_id_list, time_created FROM TagTable WHERE id=?", -1, &_tmp1_, NULL);
#line 122 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	_sqlite3_finalize0 (stmt);
#line 122 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	stmt = _tmp1_;
#line 122 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	res = _tmp2_;
#line 124 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	_tmp3_ = res;
#line 124 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	g_assert (_tmp3_ == SQLITE_OK);
#line 126 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	_tmp4_ = stmt;
#line 126 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	_tmp5_ = *tag_id;
#line 126 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	_tmp6_ = _tmp5_.id;
#line 126 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	_tmp7_ = sqlite3_bind_int64 (_tmp4_, 1, _tmp6_);
#line 126 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	res = _tmp7_;
#line 127 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	_tmp8_ = res;
#line 127 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	g_assert (_tmp8_ == SQLITE_OK);
#line 129 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	_tmp9_ = stmt;
#line 129 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	_tmp10_ = sqlite3_step (_tmp9_);
#line 129 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	res = _tmp10_;
#line 130 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	_tmp11_ = res;
#line 130 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	if (_tmp11_ == SQLITE_DONE) {
#line 131 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
		result = NULL;
#line 131 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
		_sqlite3_finalize0 (stmt);
#line 131 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
		return result;
#line 900 "TagTable.c"
	} else {
		gint _tmp12_;
#line 132 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
		_tmp12_ = res;
#line 132 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
		if (_tmp12_ != SQLITE_ROW) {
#line 907 "TagTable.c"
			gint _tmp13_;
#line 133 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
			_tmp13_ = res;
#line 133 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
			database_table_throw_error ("TagTable.get_row", _tmp13_, &_inner_error_);
#line 133 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
			if (_inner_error_ != NULL) {
#line 133 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
				if (_inner_error_->domain == DATABASE_ERROR) {
#line 133 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
					g_propagate_error (error, _inner_error_);
#line 133 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
					_sqlite3_finalize0 (stmt);
#line 133 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
					return NULL;
#line 923 "TagTable.c"
				} else {
#line 133 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
					_sqlite3_finalize0 (stmt);
#line 133 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 133 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
					g_clear_error (&_inner_error_);
#line 133 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
					return NULL;
#line 933 "TagTable.c"
				}
			}
		}
	}
#line 135 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	memset (&row, 0, sizeof (TagRow));
#line 136 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	_tmp14_ = *tag_id;
#line 136 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	row.tag_id = _tmp14_;
#line 137 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	_tmp15_ = stmt;
#line 137 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	_tmp16_ = sqlite3_column_text (_tmp15_, 0);
#line 137 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	_tmp17_ = g_strdup (_tmp16_);
#line 137 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	_g_free0 (row.name);
#line 137 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	row.name = _tmp17_;
#line 138 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	_tmp18_ = stmt;
#line 138 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	_tmp19_ = sqlite3_column_text (_tmp18_, 1);
#line 138 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	_tmp20_ = tag_table_unserialize_source_ids (self, _tmp19_);
#line 138 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	_g_object_unref0 (row.source_id_list);
#line 138 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	row.source_id_list = _tmp20_;
#line 139 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	_tmp21_ = stmt;
#line 139 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	_tmp22_ = sqlite3_column_int64 (_tmp21_, 2);
#line 139 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	row.time_created = (time_t) _tmp22_;
#line 141 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	_tmp23_ = row;
#line 141 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	_tmp24_ = _tag_row_dup0 (&_tmp23_);
#line 141 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	_tmp25_ = _tmp24_;
#line 141 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	tag_row_destroy (&_tmp23_);
#line 141 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	result = _tmp25_;
#line 141 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	_sqlite3_finalize0 (stmt);
#line 141 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	return result;
#line 984 "TagTable.c"
}


GeeList* tag_table_get_all_rows (TagTable* self, GError** error) {
	GeeList* result = NULL;
	sqlite3_stmt* stmt = NULL;
	sqlite3* _tmp0_;
	sqlite3_stmt* _tmp1_ = NULL;
	gint _tmp2_ = 0;
	gint res;
	gint _tmp3_;
	GeeArrayList* _tmp4_;
	GeeList* rows;
	GError * _inner_error_ = NULL;
#line 144 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	g_return_val_if_fail (IS_TAG_TABLE (self), NULL);
#line 146 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	_tmp0_ = database_table_db;
#line 146 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	_tmp2_ = sqlite3_prepare_v2 (_tmp0_, "SELECT id, name, photo_id_list, time_created FROM TagTable", -1, &_tmp1_, NULL);
#line 146 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	_sqlite3_finalize0 (stmt);
#line 146 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	stmt = _tmp1_;
#line 146 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	res = _tmp2_;
#line 148 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	_tmp3_ = res;
#line 148 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	g_assert (_tmp3_ == SQLITE_OK);
#line 150 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	_tmp4_ = gee_array_list_new (TYPE_TAG_ROW, (GBoxedCopyFunc) tag_row_dup, tag_row_free, NULL);
#line 150 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	rows = GEE_LIST (_tmp4_);
#line 1019 "TagTable.c"
	{
		gboolean _tmp5_;
#line 152 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
		_tmp5_ = TRUE;
#line 152 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
		while (TRUE) {
#line 1026 "TagTable.c"
			gboolean _tmp6_;
			sqlite3_stmt* _tmp7_;
			gint _tmp8_ = 0;
			gint _tmp9_;
			TagRow row = {0};
			sqlite3_stmt* _tmp12_;
			gint64 _tmp13_ = 0LL;
			TagID _tmp14_ = {0};
			sqlite3_stmt* _tmp15_;
			const gchar* _tmp16_ = NULL;
			gchar* _tmp17_;
			sqlite3_stmt* _tmp18_;
			const gchar* _tmp19_ = NULL;
			GeeSet* _tmp20_ = NULL;
			sqlite3_stmt* _tmp21_;
			gint64 _tmp22_ = 0LL;
			GeeList* _tmp23_;
			TagRow _tmp24_;
#line 152 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
			_tmp6_ = _tmp5_;
#line 152 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
			if (!_tmp6_) {
#line 1049 "TagTable.c"
			}
#line 152 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
			_tmp5_ = FALSE;
#line 153 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
			_tmp7_ = stmt;
#line 153 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
			_tmp8_ = sqlite3_step (_tmp7_);
#line 153 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
			res = _tmp8_;
#line 154 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
			_tmp9_ = res;
#line 154 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
			if (_tmp9_ == SQLITE_DONE) {
#line 155 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
				break;
#line 1065 "TagTable.c"
			} else {
				gint _tmp10_;
#line 156 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
				_tmp10_ = res;
#line 156 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
				if (_tmp10_ != SQLITE_ROW) {
#line 1072 "TagTable.c"
					gint _tmp11_;
#line 157 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
					_tmp11_ = res;
#line 157 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
					database_table_throw_error ("TagTable.get_all_rows", _tmp11_, &_inner_error_);
#line 157 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
					if (_inner_error_ != NULL) {
#line 157 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
						if (_inner_error_->domain == DATABASE_ERROR) {
#line 157 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
							g_propagate_error (error, _inner_error_);
#line 157 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
							_g_object_unref0 (rows);
#line 157 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
							_sqlite3_finalize0 (stmt);
#line 157 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
							return NULL;
#line 1090 "TagTable.c"
						} else {
#line 157 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
							_g_object_unref0 (rows);
#line 157 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
							_sqlite3_finalize0 (stmt);
#line 157 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
							g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 157 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
							g_clear_error (&_inner_error_);
#line 157 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
							return NULL;
#line 1102 "TagTable.c"
						}
					}
				}
			}
#line 160 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
			memset (&row, 0, sizeof (TagRow));
#line 161 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
			_tmp12_ = stmt;
#line 161 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
			_tmp13_ = sqlite3_column_int64 (_tmp12_, 0);
#line 161 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
			tag_id_init (&_tmp14_, _tmp13_);
#line 161 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
			row.tag_id = _tmp14_;
#line 162 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
			_tmp15_ = stmt;
#line 162 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
			_tmp16_ = sqlite3_column_text (_tmp15_, 1);
#line 162 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
			_tmp17_ = g_strdup (_tmp16_);
#line 162 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
			_g_free0 (row.name);
#line 162 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
			row.name = _tmp17_;
#line 163 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
			_tmp18_ = stmt;
#line 163 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
			_tmp19_ = sqlite3_column_text (_tmp18_, 2);
#line 163 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
			_tmp20_ = tag_table_unserialize_source_ids (self, _tmp19_);
#line 163 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
			_g_object_unref0 (row.source_id_list);
#line 163 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
			row.source_id_list = _tmp20_;
#line 164 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
			_tmp21_ = stmt;
#line 164 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
			_tmp22_ = sqlite3_column_int64 (_tmp21_, 3);
#line 164 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
			row.time_created = (time_t) _tmp22_;
#line 166 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
			_tmp23_ = rows;
#line 166 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
			_tmp24_ = row;
#line 166 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
			gee_collection_add (GEE_COLLECTION (_tmp23_), &_tmp24_);
#line 152 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
			tag_row_destroy (&row);
#line 1151 "TagTable.c"
		}
	}
#line 169 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	result = rows;
#line 169 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	_sqlite3_finalize0 (stmt);
#line 169 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	return result;
#line 1160 "TagTable.c"
}


void tag_table_rename (TagTable* self, TagID* tag_id, const gchar* new_name, GError** error) {
	TagID _tmp0_;
	gint64 _tmp1_;
	const gchar* _tmp2_;
	GError * _inner_error_ = NULL;
#line 172 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	g_return_if_fail (IS_TAG_TABLE (self));
#line 172 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	g_return_if_fail (tag_id != NULL);
#line 172 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	g_return_if_fail (new_name != NULL);
#line 173 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	_tmp0_ = *tag_id;
#line 173 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	_tmp1_ = _tmp0_.id;
#line 173 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	_tmp2_ = new_name;
#line 173 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	database_table_update_text_by_id_2 (DATABASE_TABLE (self), _tmp1_, "name", _tmp2_, &_inner_error_);
#line 173 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	if (_inner_error_ != NULL) {
#line 173 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
		if (_inner_error_->domain == DATABASE_ERROR) {
#line 173 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
			g_propagate_error (error, _inner_error_);
#line 173 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
			return;
#line 1191 "TagTable.c"
		} else {
#line 173 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 173 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
			g_clear_error (&_inner_error_);
#line 173 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
			return;
#line 1199 "TagTable.c"
		}
	}
}


void tag_table_set_tagged_sources (TagTable* self, TagID* tag_id, GeeCollection* source_ids, GError** error) {
	sqlite3_stmt* stmt = NULL;
	sqlite3* _tmp0_;
	sqlite3_stmt* _tmp1_ = NULL;
	gint _tmp2_ = 0;
	gint res;
	gint _tmp3_;
	sqlite3_stmt* _tmp4_;
	GeeCollection* _tmp5_;
	gchar* _tmp6_ = NULL;
	GDestroyNotify _tmp7_;
	gint _tmp8_ = 0;
	gint _tmp9_;
	sqlite3_stmt* _tmp10_;
	TagID _tmp11_;
	gint64 _tmp12_;
	gint _tmp13_ = 0;
	gint _tmp14_;
	sqlite3_stmt* _tmp15_;
	gint _tmp16_ = 0;
	gint _tmp17_;
	GError * _inner_error_ = NULL;
#line 176 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	g_return_if_fail (IS_TAG_TABLE (self));
#line 176 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	g_return_if_fail (tag_id != NULL);
#line 176 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	g_return_if_fail (GEE_IS_COLLECTION (source_ids));
#line 178 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	_tmp0_ = database_table_db;
#line 178 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	_tmp2_ = sqlite3_prepare_v2 (_tmp0_, "UPDATE TagTable SET photo_id_list=? WHERE id=?", -1, &_tmp1_, NULL);
#line 178 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	_sqlite3_finalize0 (stmt);
#line 178 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	stmt = _tmp1_;
#line 178 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	res = _tmp2_;
#line 179 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	_tmp3_ = res;
#line 179 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	g_assert (_tmp3_ == SQLITE_OK);
#line 181 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	_tmp4_ = stmt;
#line 181 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	_tmp5_ = source_ids;
#line 181 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	_tmp6_ = tag_table_serialize_source_ids (self, _tmp5_);
#line 181 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	_tmp7_ = g_free;
#line 181 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	_tmp8_ = sqlite3_bind_text (_tmp4_, 1, _tmp6_, -1, _tmp7_);
#line 181 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	res = _tmp8_;
#line 182 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	_tmp9_ = res;
#line 182 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	g_assert (_tmp9_ == SQLITE_OK);
#line 183 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	_tmp10_ = stmt;
#line 183 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	_tmp11_ = *tag_id;
#line 183 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	_tmp12_ = _tmp11_.id;
#line 183 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	_tmp13_ = sqlite3_bind_int64 (_tmp10_, 2, _tmp12_);
#line 183 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	res = _tmp13_;
#line 184 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	_tmp14_ = res;
#line 184 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	g_assert (_tmp14_ == SQLITE_OK);
#line 186 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	_tmp15_ = stmt;
#line 186 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	_tmp16_ = sqlite3_step (_tmp15_);
#line 186 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	res = _tmp16_;
#line 187 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	_tmp17_ = res;
#line 187 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	if (_tmp17_ != SQLITE_DONE) {
#line 1287 "TagTable.c"
		gint _tmp18_;
#line 188 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
		_tmp18_ = res;
#line 188 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
		database_table_throw_error ("TagTable.set_tagged_photos", _tmp18_, &_inner_error_);
#line 188 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
		if (_inner_error_ != NULL) {
#line 188 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
			if (_inner_error_->domain == DATABASE_ERROR) {
#line 188 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
				g_propagate_error (error, _inner_error_);
#line 188 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
				_sqlite3_finalize0 (stmt);
#line 188 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
				return;
#line 1303 "TagTable.c"
			} else {
#line 188 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
				_sqlite3_finalize0 (stmt);
#line 188 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 188 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
				g_clear_error (&_inner_error_);
#line 188 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
				return;
#line 1313 "TagTable.c"
			}
		}
	}
#line 176 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	_sqlite3_finalize0 (stmt);
#line 1319 "TagTable.c"
}


static gchar* tag_table_serialize_source_ids (TagTable* self, GeeCollection* source_ids) {
	gchar* result = NULL;
	GeeCollection* _tmp0_;
	GString* _tmp1_;
	GString* _result_;
	const gchar* _tmp11_ = NULL;
	GString* _tmp12_;
	gssize _tmp13_;
	const gchar* _tmp16_;
	gchar* _tmp17_;
#line 191 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	g_return_val_if_fail (IS_TAG_TABLE (self), NULL);
#line 191 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	g_return_val_if_fail ((source_ids == NULL) || GEE_IS_COLLECTION (source_ids), NULL);
#line 192 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	_tmp0_ = source_ids;
#line 192 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	if (_tmp0_ == NULL) {
#line 193 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
		result = NULL;
#line 193 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
		return result;
#line 1345 "TagTable.c"
	}
#line 195 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	_tmp1_ = g_string_new ("");
#line 195 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	_result_ = _tmp1_;
#line 1351 "TagTable.c"
	{
		GeeCollection* _tmp2_;
		GeeIterator* _tmp3_ = NULL;
		GeeIterator* _source_id_it;
#line 197 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
		_tmp2_ = source_ids;
#line 197 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
		_tmp3_ = gee_iterable_iterator (GEE_ITERABLE (_tmp2_));
#line 197 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
		_source_id_it = _tmp3_;
#line 197 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
		while (TRUE) {
#line 1364 "TagTable.c"
			GeeIterator* _tmp4_;
			gboolean _tmp5_ = FALSE;
			GeeIterator* _tmp6_;
			gpointer _tmp7_ = NULL;
			gchar* source_id;
			GString* _tmp8_;
			const gchar* _tmp9_;
			GString* _tmp10_;
#line 197 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
			_tmp4_ = _source_id_it;
#line 197 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
			_tmp5_ = gee_iterator_next (_tmp4_);
#line 197 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
			if (!_tmp5_) {
#line 197 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
				break;
#line 1381 "TagTable.c"
			}
#line 197 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
			_tmp6_ = _source_id_it;
#line 197 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
			_tmp7_ = gee_iterator_get (_tmp6_);
#line 197 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
			source_id = (gchar*) _tmp7_;
#line 198 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
			_tmp8_ = _result_;
#line 198 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
			_tmp9_ = source_id;
#line 198 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
			g_string_append (_tmp8_, _tmp9_);
#line 199 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
			_tmp10_ = _result_;
#line 199 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
			g_string_append (_tmp10_, ",");
#line 197 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
			_g_free0 (source_id);
#line 1401 "TagTable.c"
		}
#line 197 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
		_g_object_unref0 (_source_id_it);
#line 1405 "TagTable.c"
	}
#line 202 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	_tmp12_ = _result_;
#line 202 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	_tmp13_ = _tmp12_->len;
#line 202 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	if (_tmp13_ != ((gssize) 0)) {
#line 1413 "TagTable.c"
		GString* _tmp14_;
		const gchar* _tmp15_;
#line 202 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
		_tmp14_ = _result_;
#line 202 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
		_tmp15_ = _tmp14_->str;
#line 202 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
		_tmp11_ = _tmp15_;
#line 1422 "TagTable.c"
	} else {
#line 202 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
		_tmp11_ = NULL;
#line 1426 "TagTable.c"
	}
#line 202 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	_tmp16_ = _tmp11_;
#line 202 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	_tmp17_ = g_strdup (_tmp16_);
#line 202 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	result = _tmp17_;
#line 202 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	_g_string_free0 (_result_);
#line 202 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	return result;
#line 1438 "TagTable.c"
}


static gchar string_get (const gchar* self, glong index) {
	gchar result = '\0';
	glong _tmp0_;
	gchar _tmp1_;
#line 1122 "/usr/share/vala-0.14/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, '\0');
#line 1123 "/usr/share/vala-0.14/vapi/glib-2.0.vapi"
	_tmp0_ = index;
#line 1123 "/usr/share/vala-0.14/vapi/glib-2.0.vapi"
	_tmp1_ = ((gchar*) self)[_tmp0_];
#line 1123 "/usr/share/vala-0.14/vapi/glib-2.0.vapi"
	result = _tmp1_;
#line 1123 "/usr/share/vala-0.14/vapi/glib-2.0.vapi"
	return result;
#line 1456 "TagTable.c"
}


static GeeSet* tag_table_unserialize_source_ids (TagTable* self, const gchar* text_list) {
	GeeSet* result = NULL;
	GeeHashSet* _tmp0_;
	GeeSet* _result_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar** _tmp3_;
	gchar** _tmp4_ = NULL;
	gchar** split;
	gint split_length1;
	gint _split_size_;
	gchar** _tmp5_;
	gint _tmp5__length1;
#line 205 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	g_return_val_if_fail (IS_TAG_TABLE (self), NULL);
#line 206 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	_tmp0_ = gee_hash_set_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, NULL, NULL);
#line 206 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	_result_ = GEE_SET (_tmp0_);
#line 208 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	_tmp1_ = text_list;
#line 208 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	if (_tmp1_ == NULL) {
#line 209 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
		result = _result_;
#line 209 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
		return result;
#line 1487 "TagTable.c"
	}
#line 211 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	_tmp2_ = text_list;
#line 211 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	_tmp4_ = _tmp3_ = g_strsplit (_tmp2_, ",", 0);
#line 211 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	split = _tmp4_;
#line 211 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	split_length1 = _vala_array_length (_tmp3_);
#line 211 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	_split_size_ = split_length1;
#line 212 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	_tmp5_ = split;
#line 212 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	_tmp5__length1 = split_length1;
#line 1503 "TagTable.c"
	{
		gchar** token_collection = NULL;
		gint token_collection_length1 = 0;
		gint _token_collection_size_ = 0;
		gint token_it = 0;
#line 212 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
		token_collection = _tmp5_;
#line 212 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
		token_collection_length1 = _tmp5__length1;
#line 212 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
		for (token_it = 0; token_it < _tmp5__length1; token_it = token_it + 1) {
#line 1515 "TagTable.c"
			gchar* _tmp6_;
			gchar* token = NULL;
#line 212 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
			_tmp6_ = g_strdup (token_collection[token_it]);
#line 212 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
			token = _tmp6_;
#line 1522 "TagTable.c"
			{
				const gchar* _tmp7_;
				gboolean _tmp8_ = FALSE;
				const gchar* _tmp9_;
				gchar _tmp10_ = '\0';
				gboolean _tmp11_ = FALSE;
#line 213 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
				_tmp7_ = token;
#line 213 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
				_tmp8_ = is_string_empty (_tmp7_);
#line 213 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
				if (_tmp8_) {
#line 214 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
					_g_free0 (token);
#line 214 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
					continue;
#line 1539 "TagTable.c"
				}
#line 221 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
				_tmp9_ = token;
#line 221 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
				_tmp10_ = string_get (_tmp9_, (glong) 0);
#line 221 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
				_tmp11_ = g_ascii_isdigit (_tmp10_);
#line 221 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
				if (_tmp11_) {
#line 1549 "TagTable.c"
					GeeSet* _tmp12_;
					const gchar* _tmp13_;
					gint64 _tmp14_ = 0LL;
					PhotoID _tmp15_ = {0};
					gchar* _tmp16_ = NULL;
					gchar* _tmp17_;
#line 223 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
					_tmp12_ = _result_;
#line 223 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
					_tmp13_ = token;
#line 223 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
					_tmp14_ = parse_int64 (_tmp13_, 10);
#line 223 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
					photo_id_init (&_tmp15_, _tmp14_);
#line 223 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
					_tmp16_ = photo_id_upgrade_photo_id_to_source_id (&_tmp15_);
#line 223 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
					_tmp17_ = _tmp16_;
#line 223 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
					gee_collection_add (GEE_COLLECTION (_tmp12_), _tmp17_);
#line 223 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
					_g_free0 (_tmp17_);
#line 1572 "TagTable.c"
				} else {
					const gchar* _tmp18_;
					gchar _tmp19_ = '\0';
					gboolean _tmp20_ = FALSE;
#line 224 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
					_tmp18_ = token;
#line 224 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
					_tmp19_ = string_get (_tmp18_, (glong) 0);
#line 224 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
					_tmp20_ = g_ascii_isalpha (_tmp19_);
#line 224 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
					if (_tmp20_) {
#line 1585 "TagTable.c"
						GeeSet* _tmp21_;
						const gchar* _tmp22_;
#line 226 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
						_tmp21_ = _result_;
#line 226 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
						_tmp22_ = token;
#line 226 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
						gee_collection_add (GEE_COLLECTION (_tmp21_), _tmp22_);
#line 1594 "TagTable.c"
					}
				}
#line 212 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
				_g_free0 (token);
#line 1599 "TagTable.c"
			}
		}
	}
#line 230 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	result = _result_;
#line 230 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	split = (_vala_array_free (split, split_length1, (GDestroyNotify) g_free), NULL);
#line 230 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	return result;
#line 1609 "TagTable.c"
}


static void tag_table_class_init (TagTableClass * klass) {
#line 32 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	tag_table_parent_class = g_type_class_peek_parent (klass);
#line 32 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	DATABASE_TABLE_CLASS (klass)->finalize = tag_table_finalize;
#line 1618 "TagTable.c"
}


static void tag_table_instance_init (TagTable * self) {
}


static void tag_table_finalize (DatabaseTable* obj) {
	TagTable * self;
#line 32 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	self = TAG_TABLE (obj);
#line 32 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TagTable.vala"
	DATABASE_TABLE_CLASS (tag_table_parent_class)->finalize (obj);
#line 1632 "TagTable.c"
}


GType tag_table_get_type (void) {
	static volatile gsize tag_table_type_id__volatile = 0;
	if (g_once_init_enter (&tag_table_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (TagTableClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) tag_table_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TagTable), 0, (GInstanceInitFunc) tag_table_instance_init, NULL };
		GType tag_table_type_id;
		tag_table_type_id = g_type_register_static (TYPE_DATABASE_TABLE, "TagTable", &g_define_type_info, 0);
		g_once_init_leave (&tag_table_type_id__volatile, tag_table_type_id);
	}
	return tag_table_type_id__volatile;
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint _vala_array_length (gpointer array) {
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}



