/* TombstoneTable.c generated by valac 0.14.2, the Vala compiler
 * generated from TombstoneTable.vala, do not modify */

/* Copyright 2011 Yorba Foundation
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution. 
 */

#include <glib.h>
#include <glib-object.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>
#include <sqlite3.h>


#define TYPE_TOMBSTONE_ID (tombstone_id_get_type ())
typedef struct _TombstoneID TombstoneID;

#define TYPE_TOMBSTONE_ROW (tombstone_row_get_type ())

#define TOMBSTONE_TYPE_REASON (tombstone_reason_get_type ())
typedef struct _TombstoneRow TombstoneRow;
#define _g_free0(var) (var = (g_free (var), NULL))

#define TYPE_DATABASE_TABLE (database_table_get_type ())
#define DATABASE_TABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATABASE_TABLE, DatabaseTable))
#define DATABASE_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATABASE_TABLE, DatabaseTableClass))
#define IS_DATABASE_TABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATABASE_TABLE))
#define IS_DATABASE_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATABASE_TABLE))
#define DATABASE_TABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATABASE_TABLE, DatabaseTableClass))

typedef struct _DatabaseTable DatabaseTable;
typedef struct _DatabaseTableClass DatabaseTableClass;
typedef struct _DatabaseTablePrivate DatabaseTablePrivate;

#define TYPE_TOMBSTONE_TABLE (tombstone_table_get_type ())
#define TOMBSTONE_TABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TOMBSTONE_TABLE, TombstoneTable))
#define TOMBSTONE_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TOMBSTONE_TABLE, TombstoneTableClass))
#define IS_TOMBSTONE_TABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TOMBSTONE_TABLE))
#define IS_TOMBSTONE_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TOMBSTONE_TABLE))
#define TOMBSTONE_TABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TOMBSTONE_TABLE, TombstoneTableClass))

typedef struct _TombstoneTable TombstoneTable;
typedef struct _TombstoneTableClass TombstoneTableClass;
typedef struct _TombstoneTablePrivate TombstoneTablePrivate;
#define _sqlite3_finalize0(var) ((var == NULL) ? NULL : (var = (sqlite3_finalize (var), NULL)))
#define _database_table_unref0(var) ((var == NULL) ? NULL : (var = (database_table_unref (var), NULL)))

struct _TombstoneID {
	gint64 id;
};

typedef enum  {
	TOMBSTONE_REASON_REMOVED_BY_USER = 0,
	TOMBSTONE_REASON_AUTO_DETECTED_DUPLICATE = 1
} TombstoneReason;

struct _TombstoneRow {
	TombstoneID id;
	gchar* filepath;
	gint64 filesize;
	gchar* md5;
	time_t time_created;
	TombstoneReason reason;
};

struct _DatabaseTable {
	GTypeInstance parent_instance;
	volatile int ref_count;
	DatabaseTablePrivate * priv;
	gchar* table_name;
};

struct _DatabaseTableClass {
	GTypeClass parent_class;
	void (*finalize) (DatabaseTable *self);
};

struct _TombstoneTable {
	DatabaseTable parent_instance;
	TombstoneTablePrivate * priv;
};

struct _TombstoneTableClass {
	DatabaseTableClass parent_class;
};

typedef enum  {
	DATABASE_ERROR_ERROR,
	DATABASE_ERROR_BACKING,
	DATABASE_ERROR_MEMORY,
	DATABASE_ERROR_ABORT,
	DATABASE_ERROR_LIMITS,
	DATABASE_ERROR_TYPESPEC
} DatabaseError;
#define DATABASE_ERROR database_error_quark ()

static gpointer tombstone_table_parent_class = NULL;
static TombstoneTable* tombstone_table_instance;
static TombstoneTable* tombstone_table_instance = NULL;
extern sqlite3* database_table_db;

GType tombstone_id_get_type (void) G_GNUC_CONST;
TombstoneID* tombstone_id_dup (const TombstoneID* self);
void tombstone_id_free (TombstoneID* self);
#define TOMBSTONE_ID_INVALID ((gint64) (-1))
void tombstone_id_init (TombstoneID *self, gint64 id);
gboolean tombstone_id_is_invalid (TombstoneID *self);
gboolean tombstone_id_is_valid (TombstoneID *self);
GType tombstone_row_get_type (void) G_GNUC_CONST;
GType tombstone_reason_get_type (void) G_GNUC_CONST;
TombstoneRow* tombstone_row_dup (const TombstoneRow* self);
void tombstone_row_free (TombstoneRow* self);
void tombstone_row_copy (const TombstoneRow* self, TombstoneRow* dest);
void tombstone_row_destroy (TombstoneRow* self);
gpointer database_table_ref (gpointer instance);
void database_table_unref (gpointer instance);
GParamSpec* param_spec_database_table (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_database_table (GValue* value, gpointer v_object);
void value_take_database_table (GValue* value, gpointer v_object);
gpointer value_get_database_table (const GValue* value);
GType database_table_get_type (void) G_GNUC_CONST;
GType tombstone_table_get_type (void) G_GNUC_CONST;
enum  {
	TOMBSTONE_TABLE_DUMMY_PROPERTY
};
static TombstoneTable* tombstone_table_new (void);
static TombstoneTable* tombstone_table_construct (GType object_type);
DatabaseTable* database_table_construct (GType object_type);
void database_table_set_table_name (DatabaseTable* self, const gchar* table_name);
void database_table_fatal (const gchar* op, gint res);
TombstoneTable* tombstone_table_get_instance (void);
GQuark database_error_quark (void);
void tombstone_table_add (TombstoneTable* self, const gchar* filepath, gint64 filesize, const gchar* md5, TombstoneReason reason, TombstoneRow* result, GError** error);
gulong now_sec (void);
gint tombstone_reason_serialize (TombstoneReason self);
void database_table_throw_error (const gchar* method, gint res, GError** error);
TombstoneRow* tombstone_table_fetch_all (TombstoneTable* self, int* result_length1, GError** error);
gint database_table_get_row_count (DatabaseTable* self);
static void _vala_TombstoneRow_array_free (TombstoneRow* array, gint array_length);
TombstoneReason tombstone_reason_unserialize (gint value);
void tombstone_table_update_file (TombstoneTable* self, TombstoneID* tombstone_id, const gchar* filepath, GError** error);
void database_table_update_text_by_id_2 (DatabaseTable* self, gint64 id, const gchar* column, const gchar* text, GError** error);
void tombstone_table_remove (TombstoneTable* self, TombstoneID* tombstone_id, GError** error);
void database_table_delete_by_id (DatabaseTable* self, gint64 id, GError** error);
static void tombstone_table_finalize (DatabaseTable* obj);


void tombstone_id_init (TombstoneID *self, gint64 id) {
	gint64 _tmp0_;
#line 12 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	memset (self, 0, sizeof (TombstoneID));
#line 13 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	_tmp0_ = id;
#line 13 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	(*self).id = _tmp0_;
#line 160 "TombstoneTable.c"
}


gboolean tombstone_id_is_invalid (TombstoneID *self) {
	gboolean result = FALSE;
	gint64 _tmp0_;
#line 17 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	_tmp0_ = (*self).id;
#line 17 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	result = _tmp0_ == TOMBSTONE_ID_INVALID;
#line 17 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	return result;
#line 173 "TombstoneTable.c"
}


gboolean tombstone_id_is_valid (TombstoneID *self) {
	gboolean result = FALSE;
	gint64 _tmp0_;
#line 21 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	_tmp0_ = (*self).id;
#line 21 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	result = _tmp0_ != TOMBSTONE_ID_INVALID;
#line 21 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	return result;
#line 186 "TombstoneTable.c"
}


TombstoneID* tombstone_id_dup (const TombstoneID* self) {
	TombstoneID* dup;
#line 7 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	dup = g_new0 (TombstoneID, 1);
#line 7 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	memcpy (dup, self, sizeof (TombstoneID));
#line 7 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	return dup;
#line 198 "TombstoneTable.c"
}


void tombstone_id_free (TombstoneID* self) {
#line 7 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	g_free (self);
#line 205 "TombstoneTable.c"
}


GType tombstone_id_get_type (void) {
	static volatile gsize tombstone_id_type_id__volatile = 0;
	if (g_once_init_enter (&tombstone_id_type_id__volatile)) {
		GType tombstone_id_type_id;
		tombstone_id_type_id = g_boxed_type_register_static ("TombstoneID", (GBoxedCopyFunc) tombstone_id_dup, (GBoxedFreeFunc) tombstone_id_free);
		g_once_init_leave (&tombstone_id_type_id__volatile, tombstone_id_type_id);
	}
	return tombstone_id_type_id__volatile;
}


void tombstone_row_copy (const TombstoneRow* self, TombstoneRow* dest) {
	TombstoneID _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gint64 _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	time_t _tmp6_;
	TombstoneReason _tmp7_;
#line 25 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	_tmp0_ = (*self).id;
#line 25 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	(*dest).id = _tmp0_;
#line 25 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	_tmp1_ = (*self).filepath;
#line 25 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	_tmp2_ = g_strdup (_tmp1_);
#line 25 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	_g_free0 ((*dest).filepath);
#line 25 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	(*dest).filepath = _tmp2_;
#line 25 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	_tmp3_ = (*self).filesize;
#line 25 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	(*dest).filesize = _tmp3_;
#line 25 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	_tmp4_ = (*self).md5;
#line 25 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	_tmp5_ = g_strdup (_tmp4_);
#line 25 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	_g_free0 ((*dest).md5);
#line 25 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	(*dest).md5 = _tmp5_;
#line 25 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	_tmp6_ = (*self).time_created;
#line 25 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	(*dest).time_created = _tmp6_;
#line 25 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	_tmp7_ = (*self).reason;
#line 25 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	(*dest).reason = _tmp7_;
#line 261 "TombstoneTable.c"
}


void tombstone_row_destroy (TombstoneRow* self) {
#line 27 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	_g_free0 ((*self).filepath);
#line 29 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	_g_free0 ((*self).md5);
#line 270 "TombstoneTable.c"
}


TombstoneRow* tombstone_row_dup (const TombstoneRow* self) {
	TombstoneRow* dup;
#line 25 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	dup = g_new0 (TombstoneRow, 1);
#line 25 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	tombstone_row_copy (self, dup);
#line 25 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	return dup;
#line 282 "TombstoneTable.c"
}


void tombstone_row_free (TombstoneRow* self) {
#line 25 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	tombstone_row_destroy (self);
#line 25 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	g_free (self);
#line 291 "TombstoneTable.c"
}


GType tombstone_row_get_type (void) {
	static volatile gsize tombstone_row_type_id__volatile = 0;
	if (g_once_init_enter (&tombstone_row_type_id__volatile)) {
		GType tombstone_row_type_id;
		tombstone_row_type_id = g_boxed_type_register_static ("TombstoneRow", (GBoxedCopyFunc) tombstone_row_dup, (GBoxedFreeFunc) tombstone_row_free);
		g_once_init_leave (&tombstone_row_type_id__volatile, tombstone_row_type_id);
	}
	return tombstone_row_type_id__volatile;
}


static TombstoneTable* tombstone_table_construct (GType object_type) {
	TombstoneTable* self = NULL;
	sqlite3_stmt* stmt = NULL;
	sqlite3* _tmp0_;
	sqlite3_stmt* _tmp1_ = NULL;
	gint _tmp2_ = 0;
	gint res;
	gint _tmp3_;
	sqlite3_stmt* _tmp4_;
	gint _tmp5_ = 0;
	gint _tmp6_;
#line 37 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	self = (TombstoneTable*) database_table_construct (object_type);
#line 38 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	database_table_set_table_name (DATABASE_TABLE (self), "TombstoneTable");
#line 41 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	_tmp0_ = database_table_db;
#line 41 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	_tmp2_ = sqlite3_prepare_v2 (_tmp0_, "CREATE TABLE IF NOT EXISTS " "TombstoneTable " "(" "id INTEGER PRIMARY KEY, " "filepath TEXT NOT NULL, " "filesize INTEGER, " "md5 TEXT, " "time_created INTEGER, " "reason INTEGER DEFAULT 0 " ")", -1, &_tmp1_, NULL);
#line 41 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	_sqlite3_finalize0 (stmt);
#line 41 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	stmt = _tmp1_;
#line 41 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	res = _tmp2_;
#line 51 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	_tmp3_ = res;
#line 51 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	g_assert (_tmp3_ == SQLITE_OK);
#line 53 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	_tmp4_ = stmt;
#line 53 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	_tmp5_ = sqlite3_step (_tmp4_);
#line 53 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	res = _tmp5_;
#line 54 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	_tmp6_ = res;
#line 54 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	if (_tmp6_ != SQLITE_DONE) {
#line 345 "TombstoneTable.c"
		gint _tmp7_;
#line 55 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
		_tmp7_ = res;
#line 55 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
		database_table_fatal ("create TombstoneTable", _tmp7_);
#line 351 "TombstoneTable.c"
	}
#line 37 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	_sqlite3_finalize0 (stmt);
#line 37 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	return self;
#line 357 "TombstoneTable.c"
}


static TombstoneTable* tombstone_table_new (void) {
#line 37 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	return tombstone_table_construct (TYPE_TOMBSTONE_TABLE);
#line 364 "TombstoneTable.c"
}


static gpointer _database_table_ref0 (gpointer self) {
#line 62 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	return self ? database_table_ref (self) : NULL;
#line 371 "TombstoneTable.c"
}


TombstoneTable* tombstone_table_get_instance (void) {
	TombstoneTable* result = NULL;
	TombstoneTable* _tmp0_;
	TombstoneTable* _tmp2_;
	TombstoneTable* _tmp3_;
#line 59 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	_tmp0_ = tombstone_table_instance;
#line 59 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	if (_tmp0_ == NULL) {
#line 384 "TombstoneTable.c"
		TombstoneTable* _tmp1_;
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
		_tmp1_ = tombstone_table_new ();
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
		_database_table_unref0 (tombstone_table_instance);
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
		tombstone_table_instance = _tmp1_;
#line 392 "TombstoneTable.c"
	}
#line 62 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	_tmp2_ = tombstone_table_instance;
#line 62 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	_tmp3_ = _database_table_ref0 (_tmp2_);
#line 62 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	result = _tmp3_;
#line 62 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	return result;
#line 402 "TombstoneTable.c"
}


void tombstone_table_add (TombstoneTable* self, const gchar* filepath, gint64 filesize, const gchar* md5, TombstoneReason reason, TombstoneRow* result, GError** error) {
	sqlite3_stmt* stmt = NULL;
	sqlite3* _tmp0_;
	sqlite3_stmt* _tmp1_ = NULL;
	gint _tmp2_ = 0;
	gint res;
	gint _tmp3_;
	gulong _tmp4_ = 0UL;
	time_t time_created;
	sqlite3_stmt* _tmp5_;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	GDestroyNotify _tmp8_;
	gint _tmp9_ = 0;
	gint _tmp10_;
	sqlite3_stmt* _tmp11_;
	gint64 _tmp12_;
	gint _tmp13_ = 0;
	gint _tmp14_;
	sqlite3_stmt* _tmp15_;
	const gchar* _tmp16_;
	gchar* _tmp17_;
	GDestroyNotify _tmp18_;
	gint _tmp19_ = 0;
	gint _tmp20_;
	sqlite3_stmt* _tmp21_;
	time_t _tmp22_;
	gint _tmp23_ = 0;
	gint _tmp24_;
	sqlite3_stmt* _tmp25_;
	TombstoneReason _tmp26_;
	gint _tmp27_ = 0;
	gint _tmp28_ = 0;
	gint _tmp29_;
	sqlite3_stmt* _tmp30_;
	gint _tmp31_ = 0;
	gint _tmp32_;
	TombstoneRow row = {0};
	sqlite3* _tmp34_;
	gint64 _tmp35_ = 0LL;
	TombstoneID _tmp36_ = {0};
	const gchar* _tmp37_;
	gchar* _tmp38_;
	gint64 _tmp39_;
	const gchar* _tmp40_;
	gchar* _tmp41_;
	time_t _tmp42_;
	TombstoneReason _tmp43_;
	GError * _inner_error_ = NULL;
#line 65 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	g_return_if_fail (IS_TOMBSTONE_TABLE (self));
#line 65 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	g_return_if_fail (filepath != NULL);
#line 68 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	_tmp0_ = database_table_db;
#line 68 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	_tmp2_ = sqlite3_prepare_v2 (_tmp0_, "INSERT INTO TombstoneTable " "(filepath, filesize, md5, time_created, reason) " "VALUES (?, ?, ?, ?, ?)", -1, &_tmp1_, NULL);
#line 68 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	_sqlite3_finalize0 (stmt);
#line 68 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	stmt = _tmp1_;
#line 68 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	res = _tmp2_;
#line 72 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	_tmp3_ = res;
#line 72 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	g_assert (_tmp3_ == SQLITE_OK);
#line 74 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	_tmp4_ = now_sec ();
#line 74 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	time_created = (time_t) _tmp4_;
#line 76 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	_tmp5_ = stmt;
#line 76 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	_tmp6_ = filepath;
#line 76 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	_tmp7_ = g_strdup (_tmp6_);
#line 76 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	_tmp8_ = g_free;
#line 76 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	_tmp9_ = sqlite3_bind_text (_tmp5_, 1, _tmp7_, -1, _tmp8_);
#line 76 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	res = _tmp9_;
#line 77 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	_tmp10_ = res;
#line 77 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	g_assert (_tmp10_ == SQLITE_OK);
#line 78 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	_tmp11_ = stmt;
#line 78 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	_tmp12_ = filesize;
#line 78 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	_tmp13_ = sqlite3_bind_int64 (_tmp11_, 2, _tmp12_);
#line 78 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	res = _tmp13_;
#line 79 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	_tmp14_ = res;
#line 79 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	g_assert (_tmp14_ == SQLITE_OK);
#line 80 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	_tmp15_ = stmt;
#line 80 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	_tmp16_ = md5;
#line 80 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	_tmp17_ = g_strdup (_tmp16_);
#line 80 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	_tmp18_ = g_free;
#line 80 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	_tmp19_ = sqlite3_bind_text (_tmp15_, 3, _tmp17_, -1, _tmp18_);
#line 80 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	res = _tmp19_;
#line 81 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	_tmp20_ = res;
#line 81 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	g_assert (_tmp20_ == SQLITE_OK);
#line 82 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	_tmp21_ = stmt;
#line 82 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	_tmp22_ = time_created;
#line 82 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	_tmp23_ = sqlite3_bind_int64 (_tmp21_, 4, (gint64) _tmp22_);
#line 82 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	res = _tmp23_;
#line 83 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	_tmp24_ = res;
#line 83 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	g_assert (_tmp24_ == SQLITE_OK);
#line 84 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	_tmp25_ = stmt;
#line 84 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	_tmp26_ = reason;
#line 84 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	_tmp27_ = tombstone_reason_serialize (_tmp26_);
#line 84 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	_tmp28_ = sqlite3_bind_int (_tmp25_, 5, _tmp27_);
#line 84 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	res = _tmp28_;
#line 85 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	_tmp29_ = res;
#line 85 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	g_assert (_tmp29_ == SQLITE_OK);
#line 87 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	_tmp30_ = stmt;
#line 87 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	_tmp31_ = sqlite3_step (_tmp30_);
#line 87 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	res = _tmp31_;
#line 88 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	_tmp32_ = res;
#line 88 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	if (_tmp32_ != SQLITE_DONE) {
#line 557 "TombstoneTable.c"
		gint _tmp33_;
#line 89 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
		_tmp33_ = res;
#line 89 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
		database_table_throw_error ("TombstoneTable.add", _tmp33_, &_inner_error_);
#line 89 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
		if (_inner_error_ != NULL) {
#line 89 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
			if (_inner_error_->domain == DATABASE_ERROR) {
#line 89 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
				g_propagate_error (error, _inner_error_);
#line 89 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
				_sqlite3_finalize0 (stmt);
#line 89 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
				return;
#line 573 "TombstoneTable.c"
			} else {
#line 89 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
				_sqlite3_finalize0 (stmt);
#line 89 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 89 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
				g_clear_error (&_inner_error_);
#line 89 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
				return;
#line 583 "TombstoneTable.c"
			}
		}
	}
#line 91 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	memset (&row, 0, sizeof (TombstoneRow));
#line 92 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	_tmp34_ = database_table_db;
#line 92 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	_tmp35_ = sqlite3_last_insert_rowid (_tmp34_);
#line 92 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	tombstone_id_init (&_tmp36_, _tmp35_);
#line 92 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	row.id = _tmp36_;
#line 93 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	_tmp37_ = filepath;
#line 93 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	_tmp38_ = g_strdup (_tmp37_);
#line 93 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	_g_free0 (row.filepath);
#line 93 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	row.filepath = _tmp38_;
#line 94 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	_tmp39_ = filesize;
#line 94 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	row.filesize = _tmp39_;
#line 95 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	_tmp40_ = md5;
#line 95 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	_tmp41_ = g_strdup (_tmp40_);
#line 95 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	_g_free0 (row.md5);
#line 95 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	row.md5 = _tmp41_;
#line 96 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	_tmp42_ = time_created;
#line 96 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	row.time_created = _tmp42_;
#line 97 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	_tmp43_ = reason;
#line 97 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	row.reason = _tmp43_;
#line 99 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	*result = row;
#line 99 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	_sqlite3_finalize0 (stmt);
#line 99 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	return;
#line 631 "TombstoneTable.c"
}


static void _vala_TombstoneRow_array_free (TombstoneRow* array, gint array_length) {
#line 120 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	if (array != NULL) {
#line 638 "TombstoneTable.c"
		int i;
#line 120 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
		for (i = 0; i < array_length; i = i + 1) {
#line 120 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
			tombstone_row_destroy (&array[i]);
#line 644 "TombstoneTable.c"
		}
	}
#line 120 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	g_free (array);
#line 649 "TombstoneTable.c"
}


TombstoneRow* tombstone_table_fetch_all (TombstoneTable* self, int* result_length1, GError** error) {
	TombstoneRow* result = NULL;
	gint _tmp0_ = 0;
	gint row_count;
	gint _tmp1_;
	sqlite3_stmt* stmt = NULL;
	sqlite3* _tmp3_;
	sqlite3_stmt* _tmp4_ = NULL;
	gint _tmp5_ = 0;
	gint res;
	gint _tmp6_;
	gint _tmp7_;
	TombstoneRow* _tmp8_ = NULL;
	TombstoneRow* rows;
	gint rows_length1;
	gint _rows_size_;
	gint index;
	gint _tmp37_;
	gint _tmp38_;
	TombstoneRow* _tmp39_;
	gint _tmp39__length1;
	GError * _inner_error_ = NULL;
#line 102 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	g_return_val_if_fail (IS_TOMBSTONE_TABLE (self), NULL);
#line 103 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	_tmp0_ = database_table_get_row_count (DATABASE_TABLE (self));
#line 103 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	row_count = _tmp0_;
#line 104 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	_tmp1_ = row_count;
#line 104 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	if (_tmp1_ == 0) {
#line 685 "TombstoneTable.c"
		TombstoneRow* _tmp2_;
		gint _tmp2__length1;
#line 105 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
		_tmp2_ = NULL;
#line 105 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
		_tmp2__length1 = 0;
#line 105 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
		if (result_length1) {
#line 105 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
			*result_length1 = _tmp2__length1;
#line 696 "TombstoneTable.c"
		}
#line 105 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
		result = _tmp2_;
#line 105 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
		return result;
#line 702 "TombstoneTable.c"
	}
#line 108 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	_tmp3_ = database_table_db;
#line 108 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	_tmp5_ = sqlite3_prepare_v2 (_tmp3_, "SELECT id, filepath, filesize, md5, time_created, reason " "FROM TombstoneTable", -1, &_tmp4_, NULL);
#line 108 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	_sqlite3_finalize0 (stmt);
#line 108 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	stmt = _tmp4_;
#line 108 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	res = _tmp5_;
#line 110 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	_tmp6_ = res;
#line 110 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	g_assert (_tmp6_ == SQLITE_OK);
#line 112 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	_tmp7_ = row_count;
#line 112 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	_tmp8_ = g_new0 (TombstoneRow, _tmp7_);
#line 112 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	rows = _tmp8_;
#line 112 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	rows_length1 = _tmp7_;
#line 112 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	_rows_size_ = rows_length1;
#line 114 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	index = 0;
#line 730 "TombstoneTable.c"
	{
		gboolean _tmp9_;
#line 115 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
		_tmp9_ = TRUE;
#line 115 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
		while (TRUE) {
#line 737 "TombstoneTable.c"
			gboolean _tmp10_;
			sqlite3_stmt* _tmp11_;
			gint _tmp12_ = 0;
			gint _tmp13_;
			TombstoneRow row = {0};
			sqlite3_stmt* _tmp16_;
			gint64 _tmp17_ = 0LL;
			TombstoneID _tmp18_ = {0};
			sqlite3_stmt* _tmp19_;
			const gchar* _tmp20_ = NULL;
			gchar* _tmp21_;
			sqlite3_stmt* _tmp22_;
			gint64 _tmp23_ = 0LL;
			sqlite3_stmt* _tmp24_;
			const gchar* _tmp25_ = NULL;
			gchar* _tmp26_;
			sqlite3_stmt* _tmp27_;
			gint64 _tmp28_ = 0LL;
			sqlite3_stmt* _tmp29_;
			gint _tmp30_ = 0;
			TombstoneReason _tmp31_ = 0;
			TombstoneRow* _tmp32_;
			gint _tmp32__length1;
			gint _tmp33_;
			TombstoneRow _tmp34_;
			TombstoneRow _tmp35_ = {0};
			TombstoneRow _tmp36_;
#line 115 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
			_tmp10_ = _tmp9_;
#line 115 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
			if (!_tmp10_) {
#line 769 "TombstoneTable.c"
			}
#line 115 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
			_tmp9_ = FALSE;
#line 116 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
			_tmp11_ = stmt;
#line 116 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
			_tmp12_ = sqlite3_step (_tmp11_);
#line 116 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
			res = _tmp12_;
#line 117 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
			_tmp13_ = res;
#line 117 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
			if (_tmp13_ == SQLITE_DONE) {
#line 118 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
				break;
#line 785 "TombstoneTable.c"
			} else {
				gint _tmp14_;
#line 119 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
				_tmp14_ = res;
#line 119 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
				if (_tmp14_ != SQLITE_ROW) {
#line 792 "TombstoneTable.c"
					gint _tmp15_;
#line 120 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
					_tmp15_ = res;
#line 120 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
					database_table_throw_error ("TombstoneTable.fetch_all", _tmp15_, &_inner_error_);
#line 120 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
					if (_inner_error_ != NULL) {
#line 120 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
						if (_inner_error_->domain == DATABASE_ERROR) {
#line 120 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
							g_propagate_error (error, _inner_error_);
#line 120 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
							rows = (_vala_TombstoneRow_array_free (rows, rows_length1), NULL);
#line 120 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
							_sqlite3_finalize0 (stmt);
#line 120 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
							return NULL;
#line 810 "TombstoneTable.c"
						} else {
#line 120 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
							rows = (_vala_TombstoneRow_array_free (rows, rows_length1), NULL);
#line 120 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
							_sqlite3_finalize0 (stmt);
#line 120 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
							g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 120 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
							g_clear_error (&_inner_error_);
#line 120 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
							return NULL;
#line 822 "TombstoneTable.c"
						}
					}
				}
			}
#line 122 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
			memset (&row, 0, sizeof (TombstoneRow));
#line 123 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
			_tmp16_ = stmt;
#line 123 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
			_tmp17_ = sqlite3_column_int64 (_tmp16_, 0);
#line 123 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
			tombstone_id_init (&_tmp18_, _tmp17_);
#line 123 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
			row.id = _tmp18_;
#line 124 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
			_tmp19_ = stmt;
#line 124 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
			_tmp20_ = sqlite3_column_text (_tmp19_, 1);
#line 124 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
			_tmp21_ = g_strdup (_tmp20_);
#line 124 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
			_g_free0 (row.filepath);
#line 124 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
			row.filepath = _tmp21_;
#line 125 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
			_tmp22_ = stmt;
#line 125 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
			_tmp23_ = sqlite3_column_int64 (_tmp22_, 2);
#line 125 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
			row.filesize = _tmp23_;
#line 126 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
			_tmp24_ = stmt;
#line 126 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
			_tmp25_ = sqlite3_column_text (_tmp24_, 3);
#line 126 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
			_tmp26_ = g_strdup (_tmp25_);
#line 126 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
			_g_free0 (row.md5);
#line 126 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
			row.md5 = _tmp26_;
#line 127 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
			_tmp27_ = stmt;
#line 127 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
			_tmp28_ = sqlite3_column_int64 (_tmp27_, 4);
#line 127 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
			row.time_created = (time_t) _tmp28_;
#line 128 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
			_tmp29_ = stmt;
#line 128 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
			_tmp30_ = sqlite3_column_int (_tmp29_, 5);
#line 128 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
			_tmp31_ = tombstone_reason_unserialize (_tmp30_);
#line 128 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
			row.reason = _tmp31_;
#line 130 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
			_tmp32_ = rows;
#line 130 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
			_tmp32__length1 = rows_length1;
#line 130 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
			_tmp33_ = index;
#line 130 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
			index = _tmp33_ + 1;
#line 130 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
			_tmp34_ = row;
#line 130 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
			tombstone_row_copy (&_tmp34_, &_tmp35_);
#line 130 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
			tombstone_row_destroy (&_tmp32_[_tmp33_]);
#line 130 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
			_tmp32_[_tmp33_] = _tmp35_;
#line 130 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
			_tmp36_ = _tmp32_[_tmp33_];
#line 115 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
			tombstone_row_destroy (&row);
#line 897 "TombstoneTable.c"
		}
	}
#line 133 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	_tmp37_ = index;
#line 133 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	_tmp38_ = row_count;
#line 133 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	g_assert (_tmp37_ == _tmp38_);
#line 135 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	_tmp39_ = rows;
#line 135 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	_tmp39__length1 = rows_length1;
#line 135 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	if (result_length1) {
#line 135 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
		*result_length1 = _tmp39__length1;
#line 914 "TombstoneTable.c"
	}
#line 135 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	result = _tmp39_;
#line 135 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	_sqlite3_finalize0 (stmt);
#line 135 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	return result;
#line 922 "TombstoneTable.c"
}


void tombstone_table_update_file (TombstoneTable* self, TombstoneID* tombstone_id, const gchar* filepath, GError** error) {
	TombstoneID _tmp0_;
	gint64 _tmp1_;
	const gchar* _tmp2_;
	GError * _inner_error_ = NULL;
#line 138 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	g_return_if_fail (IS_TOMBSTONE_TABLE (self));
#line 138 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	g_return_if_fail (tombstone_id != NULL);
#line 138 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	g_return_if_fail (filepath != NULL);
#line 139 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	_tmp0_ = *tombstone_id;
#line 139 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	_tmp1_ = _tmp0_.id;
#line 139 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	_tmp2_ = filepath;
#line 139 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	database_table_update_text_by_id_2 (DATABASE_TABLE (self), _tmp1_, "filepath", _tmp2_, &_inner_error_);
#line 139 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	if (_inner_error_ != NULL) {
#line 139 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
		if (_inner_error_->domain == DATABASE_ERROR) {
#line 139 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
			g_propagate_error (error, _inner_error_);
#line 139 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
			return;
#line 953 "TombstoneTable.c"
		} else {
#line 139 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 139 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
			g_clear_error (&_inner_error_);
#line 139 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
			return;
#line 961 "TombstoneTable.c"
		}
	}
}


void tombstone_table_remove (TombstoneTable* self, TombstoneID* tombstone_id, GError** error) {
	TombstoneID _tmp0_;
	gint64 _tmp1_;
	GError * _inner_error_ = NULL;
#line 142 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	g_return_if_fail (IS_TOMBSTONE_TABLE (self));
#line 142 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	g_return_if_fail (tombstone_id != NULL);
#line 143 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	_tmp0_ = *tombstone_id;
#line 143 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	_tmp1_ = _tmp0_.id;
#line 143 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	database_table_delete_by_id (DATABASE_TABLE (self), _tmp1_, &_inner_error_);
#line 143 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	if (_inner_error_ != NULL) {
#line 143 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
		if (_inner_error_->domain == DATABASE_ERROR) {
#line 143 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
			g_propagate_error (error, _inner_error_);
#line 143 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
			return;
#line 989 "TombstoneTable.c"
		} else {
#line 143 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 143 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
			g_clear_error (&_inner_error_);
#line 143 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
			return;
#line 997 "TombstoneTable.c"
		}
	}
}


static void tombstone_table_class_init (TombstoneTableClass * klass) {
#line 34 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	tombstone_table_parent_class = g_type_class_peek_parent (klass);
#line 34 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	DATABASE_TABLE_CLASS (klass)->finalize = tombstone_table_finalize;
#line 1008 "TombstoneTable.c"
}


static void tombstone_table_instance_init (TombstoneTable * self) {
}


static void tombstone_table_finalize (DatabaseTable* obj) {
	TombstoneTable * self;
#line 34 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	self = TOMBSTONE_TABLE (obj);
#line 34 "/builddir/build/BUILD/shotwell-0.10.1/src/db/TombstoneTable.vala"
	DATABASE_TABLE_CLASS (tombstone_table_parent_class)->finalize (obj);
#line 1022 "TombstoneTable.c"
}


GType tombstone_table_get_type (void) {
	static volatile gsize tombstone_table_type_id__volatile = 0;
	if (g_once_init_enter (&tombstone_table_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (TombstoneTableClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) tombstone_table_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TombstoneTable), 0, (GInstanceInitFunc) tombstone_table_instance_init, NULL };
		GType tombstone_table_type_id;
		tombstone_table_type_id = g_type_register_static (TYPE_DATABASE_TABLE, "TombstoneTable", &g_define_type_info, 0);
		g_once_init_leave (&tombstone_table_type_id__volatile, tombstone_table_type_id);
	}
	return tombstone_table_type_id__volatile;
}



