/* VideoTable.c generated by valac 0.14.2, the Vala compiler
 * generated from VideoTable.vala, do not modify */

/* Copyright 2011 Yorba Foundation
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution. 
 */

#include <glib.h>
#include <glib-object.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>
#include <float.h>
#include <math.h>
#include <sqlite3.h>
#include <gee.h>
#include <gio/gio.h>


#define TYPE_VIDEO_ID (video_id_get_type ())
typedef struct _VideoID VideoID;

#define TYPE_VIDEO_ROW (video_row_get_type ())

#define TYPE_IMPORT_ID (import_id_get_type ())
typedef struct _ImportID ImportID;

#define TYPE_EVENT_ID (event_id_get_type ())
typedef struct _EventID EventID;

#define TYPE_RATING (rating_get_type ())
typedef struct _VideoRow VideoRow;
#define _g_free0(var) (var = (g_free (var), NULL))

#define TYPE_DATABASE_TABLE (database_table_get_type ())
#define DATABASE_TABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATABASE_TABLE, DatabaseTable))
#define DATABASE_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATABASE_TABLE, DatabaseTableClass))
#define IS_DATABASE_TABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATABASE_TABLE))
#define IS_DATABASE_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATABASE_TABLE))
#define DATABASE_TABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATABASE_TABLE, DatabaseTableClass))

typedef struct _DatabaseTable DatabaseTable;
typedef struct _DatabaseTableClass DatabaseTableClass;
typedef struct _DatabaseTablePrivate DatabaseTablePrivate;

#define TYPE_VIDEO_TABLE (video_table_get_type ())
#define VIDEO_TABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_VIDEO_TABLE, VideoTable))
#define VIDEO_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_VIDEO_TABLE, VideoTableClass))
#define IS_VIDEO_TABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_VIDEO_TABLE))
#define IS_VIDEO_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_VIDEO_TABLE))
#define VIDEO_TABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_VIDEO_TABLE, VideoTableClass))

typedef struct _VideoTable VideoTable;
typedef struct _VideoTableClass VideoTableClass;
typedef struct _VideoTablePrivate VideoTablePrivate;
#define _sqlite3_finalize0(var) ((var == NULL) ? NULL : (var = (sqlite3_finalize (var), NULL)))
#define _database_table_unref0(var) ((var == NULL) ? NULL : (var = (database_table_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _VideoID {
	gint64 id;
};

struct _ImportID {
	gint64 id;
};

struct _EventID {
	gint64 id;
};

typedef enum  {
	RATING_REJECTED = -1,
	RATING_UNRATED = 0,
	RATING_ONE = 1,
	RATING_TWO = 2,
	RATING_THREE = 3,
	RATING_FOUR = 4,
	RATING_FIVE = 5
} Rating;

struct _VideoRow {
	VideoID video_id;
	gchar* filepath;
	gint64 filesize;
	time_t timestamp;
	gint width;
	gint height;
	gdouble clip_duration;
	gboolean is_interpretable;
	time_t exposure_time;
	ImportID import_id;
	EventID event_id;
	gchar* md5;
	time_t time_created;
	Rating rating;
	gchar* title;
	gchar* backlinks;
	time_t time_reimported;
	guint64 flags;
};

struct _DatabaseTable {
	GTypeInstance parent_instance;
	volatile int ref_count;
	DatabaseTablePrivate * priv;
	gchar* table_name;
};

struct _DatabaseTableClass {
	GTypeClass parent_class;
	void (*finalize) (DatabaseTable *self);
};

struct _VideoTable {
	DatabaseTable parent_instance;
	VideoTablePrivate * priv;
};

struct _VideoTableClass {
	DatabaseTableClass parent_class;
};

typedef enum  {
	DATABASE_ERROR_ERROR,
	DATABASE_ERROR_BACKING,
	DATABASE_ERROR_MEMORY,
	DATABASE_ERROR_ABORT,
	DATABASE_ERROR_LIMITS,
	DATABASE_ERROR_TYPESPEC
} DatabaseError;
#define DATABASE_ERROR database_error_quark ()

static gpointer video_table_parent_class = NULL;
static VideoTable* video_table_instance;
static VideoTable* video_table_instance = NULL;
extern sqlite3* database_table_db;

GType video_id_get_type (void) G_GNUC_CONST;
VideoID* video_id_dup (const VideoID* self);
void video_id_free (VideoID* self);
#define VIDEO_ID_INVALID ((gint64) (-1))
void video_id_init (VideoID *self, gint64 id);
gboolean video_id_is_invalid (VideoID *self);
gboolean video_id_is_valid (VideoID *self);
guint video_id_hash (void* a);
guint int64_hash (void* p);
gboolean video_id_equal (void* a, void* b);
gchar* video_id_upgrade_video_id_to_source_id (VideoID* video_id);
#define VIDEO_TYPENAME "video"
GType video_row_get_type (void) G_GNUC_CONST;
GType import_id_get_type (void) G_GNUC_CONST;
ImportID* import_id_dup (const ImportID* self);
void import_id_free (ImportID* self);
GType event_id_get_type (void) G_GNUC_CONST;
EventID* event_id_dup (const EventID* self);
void event_id_free (EventID* self);
GType rating_get_type (void) G_GNUC_CONST;
VideoRow* video_row_dup (const VideoRow* self);
void video_row_free (VideoRow* self);
void video_row_copy (const VideoRow* self, VideoRow* dest);
void video_row_destroy (VideoRow* self);
gpointer database_table_ref (gpointer instance);
void database_table_unref (gpointer instance);
GParamSpec* param_spec_database_table (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_database_table (GValue* value, gpointer v_object);
void value_take_database_table (GValue* value, gpointer v_object);
gpointer value_get_database_table (const GValue* value);
GType database_table_get_type (void) G_GNUC_CONST;
GType video_table_get_type (void) G_GNUC_CONST;
enum  {
	VIDEO_TABLE_DUMMY_PROPERTY
};
static VideoTable* video_table_new (void);
static VideoTable* video_table_construct (GType object_type);
DatabaseTable* database_table_construct (GType object_type);
void database_table_fatal (const gchar* op, gint res);
void database_table_set_table_name (DatabaseTable* self, const gchar* table_name);
VideoTable* video_table_get_instance (void);
GQuark database_error_quark (void);
void video_table_add (VideoTable* self, VideoRow* video_row, VideoID* result, GError** error);
gulong now_sec (void);
#define EVENT_ID_INVALID ((gint64) (-1))
void database_table_throw_error (const gchar* method, gint res, GError** error);
void event_id_init (EventID *self, gint64 id);
gboolean video_table_drop_event (VideoTable* self, EventID* event_id);
VideoRow* video_table_get_row (VideoTable* self, VideoID* video_id);
Rating rating_unserialize (gint value);
GeeArrayList* video_table_get_all (VideoTable* self);
void video_table_set_filepath (VideoTable* self, VideoID* video_id, const gchar* filepath, GError** error);
void database_table_update_text_by_id_2 (DatabaseTable* self, gint64 id, const gchar* column, const gchar* text, GError** error);
void video_table_set_title (VideoTable* self, VideoID* video_id, const gchar* new_title, GError** error);
void video_table_set_exposure_time (VideoTable* self, VideoID* video_id, time_t time, GError** error);
void database_table_update_int64_by_id_2 (DatabaseTable* self, gint64 id, const gchar* column, gint64 value, GError** error);
void video_table_set_rating (VideoTable* self, VideoID* video_id, Rating rating, GError** error);
gint rating_serialize (Rating self);
void video_table_set_flags (VideoTable* self, VideoID* video_id, guint64 flags, GError** error);
void video_table_update_backlinks (VideoTable* self, VideoID* video_id, const gchar* backlinks, GError** error);
void video_table_update_is_interpretable (VideoTable* self, VideoID* video_id, gboolean is_interpretable, GError** error);
void database_table_update_int_by_id_2 (DatabaseTable* self, gint64 id, const gchar* column, gint value, GError** error);
gboolean video_table_set_event (VideoTable* self, VideoID* video_id, EventID* event_id);
gboolean database_table_update_int64_by_id (DatabaseTable* self, gint64 id, const gchar* column, gint64 value);
void video_table_remove_by_file (VideoTable* self, GFile* file, GError** error);
void video_table_remove (VideoTable* self, VideoID* videoID, GError** error);
gboolean video_table_is_video_stored (VideoTable* self, GFile* file);
void video_table_get_id (VideoTable* self, GFile* file, VideoID* result);
GeeArrayList* video_table_get_videos (VideoTable* self, GError** error);
static sqlite3_stmt* video_table_get_duplicate_stmt (VideoTable* self, GFile* file, const gchar* md5);
gboolean video_table_has_duplicate (VideoTable* self, GFile* file, const gchar* md5);
VideoID* video_table_get_duplicate_ids (VideoTable* self, GFile* file, const gchar* md5, int* result_length1);
static void _vala_array_add3 (VideoID** array, int* length, int* size, const VideoID* value);
GeeArrayList* video_table_get_event_source_ids (VideoTable* self, EventID* event_id);
void video_table_set_timestamp (VideoTable* self, VideoID* video_id, time_t timestamp, GError** error);
static void video_table_finalize (DatabaseTable* obj);


void video_id_init (VideoID *self, gint64 id) {
	gint64 _tmp0_;
#line 12 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	memset (self, 0, sizeof (VideoID));
#line 13 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp0_ = id;
#line 13 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	(*self).id = _tmp0_;
#line 228 "VideoTable.c"
}


gboolean video_id_is_invalid (VideoID *self) {
	gboolean result = FALSE;
	gint64 _tmp0_;
#line 17 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp0_ = (*self).id;
#line 17 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	result = _tmp0_ == VIDEO_ID_INVALID;
#line 17 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	return result;
#line 241 "VideoTable.c"
}


gboolean video_id_is_valid (VideoID *self) {
	gboolean result = FALSE;
	gint64 _tmp0_;
#line 21 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp0_ = (*self).id;
#line 21 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	result = _tmp0_ != VIDEO_ID_INVALID;
#line 21 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	return result;
#line 254 "VideoTable.c"
}


guint video_id_hash (void* a) {
	guint result = 0U;
	void* _tmp0_;
	guint _tmp1_ = 0U;
#line 25 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp0_ = a;
#line 25 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp1_ = int64_hash (&(*((VideoID*) _tmp0_)).id);
#line 25 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	result = _tmp1_;
#line 25 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	return result;
#line 270 "VideoTable.c"
}


gboolean video_id_equal (void* a, void* b) {
	gboolean result = FALSE;
	void* _tmp0_;
	gint64 _tmp1_;
	void* _tmp2_;
	gint64 _tmp3_;
#line 29 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp0_ = a;
#line 29 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp1_ = (*((VideoID*) _tmp0_)).id;
#line 29 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp2_ = b;
#line 29 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp3_ = (*((VideoID*) _tmp2_)).id;
#line 29 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	result = _tmp1_ == _tmp3_;
#line 29 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	return result;
#line 292 "VideoTable.c"
}


gchar* video_id_upgrade_video_id_to_source_id (VideoID* video_id) {
	gchar* result = NULL;
	VideoID _tmp0_;
	gint64 _tmp1_;
	gchar* _tmp2_ = NULL;
#line 32 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	g_return_val_if_fail (video_id != NULL, NULL);
#line 33 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp0_ = *video_id;
#line 33 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp1_ = _tmp0_.id;
#line 33 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp2_ = g_strdup_printf ("%s-%016" G_GINT64_MODIFIER "x", VIDEO_TYPENAME, _tmp1_);
#line 33 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	result = _tmp2_;
#line 33 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	return result;
#line 313 "VideoTable.c"
}


VideoID* video_id_dup (const VideoID* self) {
	VideoID* dup;
#line 7 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	dup = g_new0 (VideoID, 1);
#line 7 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	memcpy (dup, self, sizeof (VideoID));
#line 7 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	return dup;
#line 325 "VideoTable.c"
}


void video_id_free (VideoID* self) {
#line 7 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	g_free (self);
#line 332 "VideoTable.c"
}


GType video_id_get_type (void) {
	static volatile gsize video_id_type_id__volatile = 0;
	if (g_once_init_enter (&video_id_type_id__volatile)) {
		GType video_id_type_id;
		video_id_type_id = g_boxed_type_register_static ("VideoID", (GBoxedCopyFunc) video_id_dup, (GBoxedFreeFunc) video_id_free);
		g_once_init_leave (&video_id_type_id__volatile, video_id_type_id);
	}
	return video_id_type_id__volatile;
}


void video_row_copy (const VideoRow* self, VideoRow* dest) {
	VideoID _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gint64 _tmp3_;
	time_t _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	gdouble _tmp7_;
	gboolean _tmp8_;
	time_t _tmp9_;
	ImportID _tmp10_;
	EventID _tmp11_;
	const gchar* _tmp12_;
	gchar* _tmp13_;
	time_t _tmp14_;
	Rating _tmp15_;
	const gchar* _tmp16_;
	gchar* _tmp17_;
	const gchar* _tmp18_;
	gchar* _tmp19_;
	time_t _tmp20_;
	guint64 _tmp21_;
#line 37 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp0_ = (*self).video_id;
#line 37 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	(*dest).video_id = _tmp0_;
#line 37 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp1_ = (*self).filepath;
#line 37 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp2_ = g_strdup (_tmp1_);
#line 37 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_g_free0 ((*dest).filepath);
#line 37 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	(*dest).filepath = _tmp2_;
#line 37 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp3_ = (*self).filesize;
#line 37 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	(*dest).filesize = _tmp3_;
#line 37 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp4_ = (*self).timestamp;
#line 37 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	(*dest).timestamp = _tmp4_;
#line 37 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp5_ = (*self).width;
#line 37 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	(*dest).width = _tmp5_;
#line 37 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp6_ = (*self).height;
#line 37 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	(*dest).height = _tmp6_;
#line 37 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp7_ = (*self).clip_duration;
#line 37 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	(*dest).clip_duration = _tmp7_;
#line 37 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp8_ = (*self).is_interpretable;
#line 37 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	(*dest).is_interpretable = _tmp8_;
#line 37 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp9_ = (*self).exposure_time;
#line 37 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	(*dest).exposure_time = _tmp9_;
#line 37 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp10_ = (*self).import_id;
#line 37 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	(*dest).import_id = _tmp10_;
#line 37 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp11_ = (*self).event_id;
#line 37 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	(*dest).event_id = _tmp11_;
#line 37 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp12_ = (*self).md5;
#line 37 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp13_ = g_strdup (_tmp12_);
#line 37 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_g_free0 ((*dest).md5);
#line 37 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	(*dest).md5 = _tmp13_;
#line 37 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp14_ = (*self).time_created;
#line 37 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	(*dest).time_created = _tmp14_;
#line 37 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp15_ = (*self).rating;
#line 37 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	(*dest).rating = _tmp15_;
#line 37 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp16_ = (*self).title;
#line 37 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp17_ = g_strdup (_tmp16_);
#line 37 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_g_free0 ((*dest).title);
#line 37 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	(*dest).title = _tmp17_;
#line 37 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp18_ = (*self).backlinks;
#line 37 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp19_ = g_strdup (_tmp18_);
#line 37 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_g_free0 ((*dest).backlinks);
#line 37 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	(*dest).backlinks = _tmp19_;
#line 37 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp20_ = (*self).time_reimported;
#line 37 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	(*dest).time_reimported = _tmp20_;
#line 37 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp21_ = (*self).flags;
#line 37 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	(*dest).flags = _tmp21_;
#line 458 "VideoTable.c"
}


void video_row_destroy (VideoRow* self) {
#line 39 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_g_free0 ((*self).filepath);
#line 49 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_g_free0 ((*self).md5);
#line 52 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_g_free0 ((*self).title);
#line 53 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_g_free0 ((*self).backlinks);
#line 471 "VideoTable.c"
}


VideoRow* video_row_dup (const VideoRow* self) {
	VideoRow* dup;
#line 37 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	dup = g_new0 (VideoRow, 1);
#line 37 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	video_row_copy (self, dup);
#line 37 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	return dup;
#line 483 "VideoTable.c"
}


void video_row_free (VideoRow* self) {
#line 37 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	video_row_destroy (self);
#line 37 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	g_free (self);
#line 492 "VideoTable.c"
}


GType video_row_get_type (void) {
	static volatile gsize video_row_type_id__volatile = 0;
	if (g_once_init_enter (&video_row_type_id__volatile)) {
		GType video_row_type_id;
		video_row_type_id = g_boxed_type_register_static ("VideoRow", (GBoxedCopyFunc) video_row_dup, (GBoxedFreeFunc) video_row_free);
		g_once_init_leave (&video_row_type_id__volatile, video_row_type_id);
	}
	return video_row_type_id__volatile;
}


static VideoTable* video_table_construct (GType object_type) {
	VideoTable* self = NULL;
	sqlite3_stmt* stmt = NULL;
	sqlite3* _tmp0_;
	sqlite3_stmt* _tmp1_ = NULL;
	gint _tmp2_ = 0;
	gint res;
	gint _tmp3_;
	sqlite3_stmt* _tmp4_;
	gint _tmp5_ = 0;
	gint _tmp6_;
	sqlite3_stmt* stmt2 = NULL;
	sqlite3* _tmp8_;
	sqlite3_stmt* _tmp9_ = NULL;
	gint _tmp10_ = 0;
	gint res2;
	gint _tmp11_;
	sqlite3_stmt* _tmp12_;
	gint _tmp13_ = 0;
	gint _tmp14_;
#line 61 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	self = (VideoTable*) database_table_construct (object_type);
#line 63 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp0_ = database_table_db;
#line 63 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp2_ = sqlite3_prepare_v2 (_tmp0_, "CREATE TABLE IF NOT EXISTS VideoTable (" "id INTEGER PRIMARY KEY, " "filename TEXT UNIQUE NOT NULL, " "width INTEGER, " "height INTEGER, " "clip_duration REAL, " "is_interpretable INTEGER, " "filesize INTEGER, " "timestamp INTEGER, " "exposure_time INTEGER, " "import_id INTEGER, " "event_id INTEGER, " "md5 TEXT, " "time_created INTEGER, " "rating INTEGER DEFAULT 0, " "title TEXT, " "backlinks TEXT, " "time_reimported INTEGER, " "flags INTEGER DEFAULT 0 " ")", -1, &_tmp1_, NULL);
#line 63 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 63 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	stmt = _tmp1_;
#line 63 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	res = _tmp2_;
#line 83 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp3_ = res;
#line 83 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	g_assert (_tmp3_ == SQLITE_OK);
#line 85 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp4_ = stmt;
#line 85 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp5_ = sqlite3_step (_tmp4_);
#line 85 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	res = _tmp5_;
#line 86 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp6_ = res;
#line 86 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	if (_tmp6_ != SQLITE_DONE) {
#line 553 "VideoTable.c"
		gint _tmp7_;
#line 87 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		_tmp7_ = res;
#line 87 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		database_table_fatal ("VideoTable constructor", _tmp7_);
#line 559 "VideoTable.c"
	}
#line 91 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp8_ = database_table_db;
#line 91 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp10_ = sqlite3_prepare_v2 (_tmp8_, "CREATE INDEX IF NOT EXISTS VideoEventIDIndex ON VideoTable (event_id)", -1, &_tmp9_, NULL);
#line 91 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_sqlite3_finalize0 (stmt2);
#line 91 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	stmt2 = _tmp9_;
#line 91 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	res2 = _tmp10_;
#line 93 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp11_ = res2;
#line 93 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	g_assert (_tmp11_ == SQLITE_OK);
#line 95 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp12_ = stmt2;
#line 95 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp13_ = sqlite3_step (_tmp12_);
#line 95 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	res2 = _tmp13_;
#line 96 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp14_ = res2;
#line 96 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	if (_tmp14_ != SQLITE_DONE) {
#line 585 "VideoTable.c"
		gint _tmp15_;
#line 97 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		_tmp15_ = res2;
#line 97 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		database_table_fatal ("VideoTable constructor", _tmp15_);
#line 591 "VideoTable.c"
	}
#line 99 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	database_table_set_table_name (DATABASE_TABLE (self), "VideoTable");
#line 61 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_sqlite3_finalize0 (stmt2);
#line 61 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 61 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	return self;
#line 601 "VideoTable.c"
}


static VideoTable* video_table_new (void) {
#line 61 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	return video_table_construct (TYPE_VIDEO_TABLE);
#line 608 "VideoTable.c"
}


static gpointer _database_table_ref0 (gpointer self) {
#line 106 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	return self ? database_table_ref (self) : NULL;
#line 615 "VideoTable.c"
}


VideoTable* video_table_get_instance (void) {
	VideoTable* result = NULL;
	VideoTable* _tmp0_;
	VideoTable* _tmp2_;
	VideoTable* _tmp3_;
#line 103 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp0_ = video_table_instance;
#line 103 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	if (_tmp0_ == NULL) {
#line 628 "VideoTable.c"
		VideoTable* _tmp1_;
#line 104 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		_tmp1_ = video_table_new ();
#line 104 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		_database_table_unref0 (video_table_instance);
#line 104 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		video_table_instance = _tmp1_;
#line 636 "VideoTable.c"
	}
#line 106 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp2_ = video_table_instance;
#line 106 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp3_ = _database_table_ref0 (_tmp2_);
#line 106 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	result = _tmp3_;
#line 106 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	return result;
#line 646 "VideoTable.c"
}


void video_table_add (VideoTable* self, VideoRow* video_row, VideoID* result, GError** error) {
	sqlite3_stmt* stmt = NULL;
	sqlite3* _tmp0_;
	sqlite3_stmt* _tmp1_ = NULL;
	gint _tmp2_ = 0;
	gint res;
	gint _tmp3_;
	gulong _tmp4_ = 0UL;
	gulong time_created;
	sqlite3_stmt* _tmp5_;
	VideoRow _tmp6_;
	const gchar* _tmp7_;
	gchar* _tmp8_;
	GDestroyNotify _tmp9_;
	gint _tmp10_ = 0;
	gint _tmp11_;
	sqlite3_stmt* _tmp12_;
	VideoRow _tmp13_;
	gint _tmp14_;
	gint _tmp15_ = 0;
	gint _tmp16_;
	sqlite3_stmt* _tmp17_;
	VideoRow _tmp18_;
	gint _tmp19_;
	gint _tmp20_ = 0;
	gint _tmp21_;
	sqlite3_stmt* _tmp22_;
	VideoRow _tmp23_;
	gdouble _tmp24_;
	gint _tmp25_ = 0;
	gint _tmp26_;
	gint _tmp27_ = 0;
	VideoRow _tmp28_;
	gboolean _tmp29_;
	sqlite3_stmt* _tmp30_;
	gint _tmp31_;
	gint _tmp32_ = 0;
	gint _tmp33_;
	sqlite3_stmt* _tmp34_;
	VideoRow _tmp35_;
	gint64 _tmp36_;
	gint _tmp37_ = 0;
	gint _tmp38_;
	sqlite3_stmt* _tmp39_;
	VideoRow _tmp40_;
	time_t _tmp41_;
	gint _tmp42_ = 0;
	gint _tmp43_;
	sqlite3_stmt* _tmp44_;
	VideoRow _tmp45_;
	time_t _tmp46_;
	gint _tmp47_ = 0;
	gint _tmp48_;
	sqlite3_stmt* _tmp49_;
	VideoRow _tmp50_;
	ImportID _tmp51_;
	gint64 _tmp52_;
	gint _tmp53_ = 0;
	gint _tmp54_;
	sqlite3_stmt* _tmp55_;
	gint _tmp56_ = 0;
	gint _tmp57_;
	sqlite3_stmt* _tmp58_;
	VideoRow _tmp59_;
	const gchar* _tmp60_;
	gchar* _tmp61_;
	GDestroyNotify _tmp62_;
	gint _tmp63_ = 0;
	gint _tmp64_;
	sqlite3_stmt* _tmp65_;
	gulong _tmp66_;
	gint _tmp67_ = 0;
	gint _tmp68_;
	sqlite3_stmt* _tmp69_;
	VideoRow _tmp70_;
	const gchar* _tmp71_;
	gchar* _tmp72_;
	GDestroyNotify _tmp73_;
	gint _tmp74_ = 0;
	gint _tmp75_;
	sqlite3_stmt* _tmp76_;
	gint _tmp77_ = 0;
	gint _tmp78_;
	sqlite3* _tmp81_;
	gint64 _tmp82_ = 0LL;
	VideoID _tmp83_ = {0};
	EventID _tmp84_ = {0};
	gulong _tmp85_;
	VideoRow _tmp86_;
	VideoID _tmp87_;
	GError * _inner_error_ = NULL;
#line 111 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	g_return_if_fail (IS_VIDEO_TABLE (self));
#line 111 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	g_return_if_fail (video_row != NULL);
#line 113 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp0_ = database_table_db;
#line 113 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp2_ = sqlite3_prepare_v2 (_tmp0_, "INSERT INTO VideoTable (filename, width, height, clip_duration, is_int" \
"erpretable, " "filesize, timestamp, exposure_time, import_id, event_id, md5, time_cre" \
"ated, title) " "VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)", -1, &_tmp1_, NULL);
#line 113 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 113 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	stmt = _tmp1_;
#line 113 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	res = _tmp2_;
#line 118 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp3_ = res;
#line 118 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	g_assert (_tmp3_ == SQLITE_OK);
#line 120 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp4_ = now_sec ();
#line 120 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	time_created = _tmp4_;
#line 122 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp5_ = stmt;
#line 122 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp6_ = *video_row;
#line 122 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp7_ = _tmp6_.filepath;
#line 122 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp8_ = g_strdup (_tmp7_);
#line 122 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp9_ = g_free;
#line 122 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp10_ = sqlite3_bind_text (_tmp5_, 1, _tmp8_, -1, _tmp9_);
#line 122 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	res = _tmp10_;
#line 123 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp11_ = res;
#line 123 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	g_assert (_tmp11_ == SQLITE_OK);
#line 124 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp12_ = stmt;
#line 124 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp13_ = *video_row;
#line 124 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp14_ = _tmp13_.width;
#line 124 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp15_ = sqlite3_bind_int (_tmp12_, 2, _tmp14_);
#line 124 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	res = _tmp15_;
#line 125 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp16_ = res;
#line 125 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	g_assert (_tmp16_ == SQLITE_OK);
#line 126 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp17_ = stmt;
#line 126 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp18_ = *video_row;
#line 126 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp19_ = _tmp18_.height;
#line 126 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp20_ = sqlite3_bind_int (_tmp17_, 3, _tmp19_);
#line 126 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	res = _tmp20_;
#line 127 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp21_ = res;
#line 127 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	g_assert (_tmp21_ == SQLITE_OK);
#line 128 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp22_ = stmt;
#line 128 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp23_ = *video_row;
#line 128 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp24_ = _tmp23_.clip_duration;
#line 128 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp25_ = sqlite3_bind_double (_tmp22_, 4, _tmp24_);
#line 128 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	res = _tmp25_;
#line 129 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp26_ = res;
#line 129 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	g_assert (_tmp26_ == SQLITE_OK);
#line 130 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp28_ = *video_row;
#line 130 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp29_ = _tmp28_.is_interpretable;
#line 130 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	if (_tmp29_) {
#line 130 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		_tmp27_ = 1;
#line 831 "VideoTable.c"
	} else {
#line 130 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		_tmp27_ = 0;
#line 835 "VideoTable.c"
	}
#line 130 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp30_ = stmt;
#line 130 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp31_ = _tmp27_;
#line 130 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp32_ = sqlite3_bind_int (_tmp30_, 5, _tmp31_);
#line 130 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	res = _tmp32_;
#line 131 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp33_ = res;
#line 131 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	g_assert (_tmp33_ == SQLITE_OK);
#line 132 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp34_ = stmt;
#line 132 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp35_ = *video_row;
#line 132 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp36_ = _tmp35_.filesize;
#line 132 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp37_ = sqlite3_bind_int64 (_tmp34_, 6, _tmp36_);
#line 132 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	res = _tmp37_;
#line 133 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp38_ = res;
#line 133 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	g_assert (_tmp38_ == SQLITE_OK);
#line 134 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp39_ = stmt;
#line 134 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp40_ = *video_row;
#line 134 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp41_ = _tmp40_.timestamp;
#line 134 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp42_ = sqlite3_bind_int64 (_tmp39_, 7, (gint64) _tmp41_);
#line 134 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	res = _tmp42_;
#line 135 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp43_ = res;
#line 135 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	g_assert (_tmp43_ == SQLITE_OK);
#line 136 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp44_ = stmt;
#line 136 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp45_ = *video_row;
#line 136 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp46_ = _tmp45_.exposure_time;
#line 136 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp47_ = sqlite3_bind_int64 (_tmp44_, 8, (gint64) _tmp46_);
#line 136 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	res = _tmp47_;
#line 137 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp48_ = res;
#line 137 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	g_assert (_tmp48_ == SQLITE_OK);
#line 138 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp49_ = stmt;
#line 138 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp50_ = *video_row;
#line 138 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp51_ = _tmp50_.import_id;
#line 138 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp52_ = _tmp51_.id;
#line 138 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp53_ = sqlite3_bind_int64 (_tmp49_, 9, _tmp52_);
#line 138 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	res = _tmp53_;
#line 139 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp54_ = res;
#line 139 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	g_assert (_tmp54_ == SQLITE_OK);
#line 140 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp55_ = stmt;
#line 140 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp56_ = sqlite3_bind_int64 (_tmp55_, 10, EVENT_ID_INVALID);
#line 140 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	res = _tmp56_;
#line 141 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp57_ = res;
#line 141 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	g_assert (_tmp57_ == SQLITE_OK);
#line 142 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp58_ = stmt;
#line 142 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp59_ = *video_row;
#line 142 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp60_ = _tmp59_.md5;
#line 142 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp61_ = g_strdup (_tmp60_);
#line 142 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp62_ = g_free;
#line 142 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp63_ = sqlite3_bind_text (_tmp58_, 11, _tmp61_, -1, _tmp62_);
#line 142 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	res = _tmp63_;
#line 143 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp64_ = res;
#line 143 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	g_assert (_tmp64_ == SQLITE_OK);
#line 144 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp65_ = stmt;
#line 144 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp66_ = time_created;
#line 144 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp67_ = sqlite3_bind_int64 (_tmp65_, 12, (gint64) _tmp66_);
#line 144 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	res = _tmp67_;
#line 145 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp68_ = res;
#line 145 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	g_assert (_tmp68_ == SQLITE_OK);
#line 146 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp69_ = stmt;
#line 146 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp70_ = *video_row;
#line 146 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp71_ = _tmp70_.title;
#line 146 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp72_ = g_strdup (_tmp71_);
#line 146 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp73_ = g_free;
#line 146 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp74_ = sqlite3_bind_text (_tmp69_, 13, _tmp72_, -1, _tmp73_);
#line 146 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	res = _tmp74_;
#line 147 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp75_ = res;
#line 147 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	g_assert (_tmp75_ == SQLITE_OK);
#line 149 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp76_ = stmt;
#line 149 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp77_ = sqlite3_step (_tmp76_);
#line 149 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	res = _tmp77_;
#line 150 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp78_ = res;
#line 150 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	if (_tmp78_ != SQLITE_DONE) {
#line 975 "VideoTable.c"
		gint _tmp79_;
#line 151 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		_tmp79_ = res;
#line 151 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		if (_tmp79_ != SQLITE_CONSTRAINT) {
#line 981 "VideoTable.c"
			gint _tmp80_;
#line 152 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
			_tmp80_ = res;
#line 152 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
			database_table_throw_error ("VideoTable.add", _tmp80_, &_inner_error_);
#line 152 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
			if (_inner_error_ != NULL) {
#line 152 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
				if (_inner_error_->domain == DATABASE_ERROR) {
#line 152 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
					g_propagate_error (error, _inner_error_);
#line 152 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
					_sqlite3_finalize0 (stmt);
#line 152 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
					return;
#line 997 "VideoTable.c"
				} else {
#line 152 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
					_sqlite3_finalize0 (stmt);
#line 152 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 152 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
					g_clear_error (&_inner_error_);
#line 152 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
					return;
#line 1007 "VideoTable.c"
				}
			}
		}
	}
#line 156 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp81_ = database_table_db;
#line 156 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp82_ = sqlite3_last_insert_rowid (_tmp81_);
#line 156 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	video_id_init (&_tmp83_, _tmp82_);
#line 156 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	(*video_row).video_id = _tmp83_;
#line 157 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	event_id_init (&_tmp84_, EVENT_ID_INVALID);
#line 157 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	(*video_row).event_id = _tmp84_;
#line 158 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp85_ = time_created;
#line 158 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	(*video_row).time_created = (time_t) _tmp85_;
#line 159 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	(*video_row).flags = (guint64) 0;
#line 161 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp86_ = *video_row;
#line 161 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp87_ = _tmp86_.video_id;
#line 161 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	*result = _tmp87_;
#line 161 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 161 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	return;
#line 1040 "VideoTable.c"
}


gboolean video_table_drop_event (VideoTable* self, EventID* event_id) {
	gboolean result = FALSE;
	sqlite3_stmt* stmt = NULL;
	sqlite3* _tmp0_;
	sqlite3_stmt* _tmp1_ = NULL;
	gint _tmp2_ = 0;
	gint res;
	gint _tmp3_;
	sqlite3_stmt* _tmp4_;
	gint _tmp5_ = 0;
	gint _tmp6_;
	sqlite3_stmt* _tmp7_;
	EventID _tmp8_;
	gint64 _tmp9_;
	gint _tmp10_ = 0;
	gint _tmp11_;
	sqlite3_stmt* _tmp12_;
	gint _tmp13_ = 0;
	gint _tmp14_;
#line 164 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	g_return_val_if_fail (IS_VIDEO_TABLE (self), FALSE);
#line 164 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	g_return_val_if_fail (event_id != NULL, FALSE);
#line 166 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp0_ = database_table_db;
#line 166 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp2_ = sqlite3_prepare_v2 (_tmp0_, "UPDATE VideoTable SET event_id = ? WHERE event_id = ?", -1, &_tmp1_, NULL);
#line 166 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 166 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	stmt = _tmp1_;
#line 166 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	res = _tmp2_;
#line 167 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp3_ = res;
#line 167 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	g_assert (_tmp3_ == SQLITE_OK);
#line 169 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp4_ = stmt;
#line 169 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp5_ = sqlite3_bind_int64 (_tmp4_, 1, EVENT_ID_INVALID);
#line 169 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	res = _tmp5_;
#line 170 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp6_ = res;
#line 170 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	g_assert (_tmp6_ == SQLITE_OK);
#line 171 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp7_ = stmt;
#line 171 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp8_ = *event_id;
#line 171 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp9_ = _tmp8_.id;
#line 171 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp10_ = sqlite3_bind_int64 (_tmp7_, 2, _tmp9_);
#line 171 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	res = _tmp10_;
#line 172 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp11_ = res;
#line 172 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	g_assert (_tmp11_ == SQLITE_OK);
#line 174 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp12_ = stmt;
#line 174 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp13_ = sqlite3_step (_tmp12_);
#line 174 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	res = _tmp13_;
#line 175 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp14_ = res;
#line 175 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	if (_tmp14_ != SQLITE_DONE) {
#line 1115 "VideoTable.c"
		gint _tmp15_;
#line 176 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		_tmp15_ = res;
#line 176 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		database_table_fatal ("VideoTable.drop_event", _tmp15_);
#line 178 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		result = FALSE;
#line 178 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		_sqlite3_finalize0 (stmt);
#line 178 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		return result;
#line 1127 "VideoTable.c"
	}
#line 181 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	result = TRUE;
#line 181 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 181 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	return result;
#line 1135 "VideoTable.c"
}


static gpointer _video_row_dup0 (gpointer self) {
#line 219 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	return self ? video_row_dup (self) : NULL;
#line 1142 "VideoTable.c"
}


VideoRow* video_table_get_row (VideoTable* self, VideoID* video_id) {
	VideoRow* result = NULL;
	sqlite3_stmt* stmt = NULL;
	sqlite3* _tmp0_;
	sqlite3_stmt* _tmp1_ = NULL;
	gint _tmp2_ = 0;
	gint res;
	gint _tmp3_;
	sqlite3_stmt* _tmp4_;
	VideoID _tmp5_;
	gint64 _tmp6_;
	gint _tmp7_ = 0;
	gint _tmp8_;
	sqlite3_stmt* _tmp9_;
	gint _tmp10_ = 0;
	VideoRow row = {0};
	VideoID _tmp11_;
	sqlite3_stmt* _tmp12_;
	const gchar* _tmp13_ = NULL;
	gchar* _tmp14_;
	sqlite3_stmt* _tmp15_;
	gint _tmp16_ = 0;
	sqlite3_stmt* _tmp17_;
	gint _tmp18_ = 0;
	sqlite3_stmt* _tmp19_;
	gdouble _tmp20_ = 0.0;
	sqlite3_stmt* _tmp21_;
	gint _tmp22_ = 0;
	sqlite3_stmt* _tmp23_;
	gint64 _tmp24_ = 0LL;
	sqlite3_stmt* _tmp25_;
	gint64 _tmp26_ = 0LL;
	sqlite3_stmt* _tmp27_;
	gint64 _tmp28_ = 0LL;
	sqlite3_stmt* _tmp29_;
	gint64 _tmp30_ = 0LL;
	sqlite3_stmt* _tmp31_;
	gint64 _tmp32_ = 0LL;
	sqlite3_stmt* _tmp33_;
	const gchar* _tmp34_ = NULL;
	gchar* _tmp35_;
	sqlite3_stmt* _tmp36_;
	gint64 _tmp37_ = 0LL;
	sqlite3_stmt* _tmp38_;
	gint _tmp39_ = 0;
	Rating _tmp40_ = 0;
	sqlite3_stmt* _tmp41_;
	const gchar* _tmp42_ = NULL;
	gchar* _tmp43_;
	sqlite3_stmt* _tmp44_;
	const gchar* _tmp45_ = NULL;
	gchar* _tmp46_;
	sqlite3_stmt* _tmp47_;
	gint64 _tmp48_ = 0LL;
	sqlite3_stmt* _tmp49_;
	gint64 _tmp50_ = 0LL;
	VideoRow _tmp51_;
	VideoRow* _tmp52_;
	VideoRow* _tmp53_;
#line 184 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	g_return_val_if_fail (IS_VIDEO_TABLE (self), NULL);
#line 184 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	g_return_val_if_fail (video_id != NULL, NULL);
#line 186 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp0_ = database_table_db;
#line 186 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp2_ = sqlite3_prepare_v2 (_tmp0_, "SELECT filename, width, height, clip_duration, is_interpretable, files" \
"ize, timestamp, " "exposure_time, import_id, event_id, md5, time_created, rating, title, " \
"backlinks, " "time_reimported, flags FROM VideoTable WHERE id=?", -1, &_tmp1_, NULL);
#line 186 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 186 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	stmt = _tmp1_;
#line 186 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	res = _tmp2_;
#line 191 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp3_ = res;
#line 191 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	g_assert (_tmp3_ == SQLITE_OK);
#line 193 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp4_ = stmt;
#line 193 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp5_ = *video_id;
#line 193 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp6_ = _tmp5_.id;
#line 193 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp7_ = sqlite3_bind_int64 (_tmp4_, 1, _tmp6_);
#line 193 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	res = _tmp7_;
#line 194 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp8_ = res;
#line 194 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	g_assert (_tmp8_ == SQLITE_OK);
#line 196 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp9_ = stmt;
#line 196 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp10_ = sqlite3_step (_tmp9_);
#line 196 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	if (_tmp10_ != SQLITE_ROW) {
#line 197 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		result = NULL;
#line 197 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		_sqlite3_finalize0 (stmt);
#line 197 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		return result;
#line 1249 "VideoTable.c"
	}
#line 199 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	memset (&row, 0, sizeof (VideoRow));
#line 200 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp11_ = *video_id;
#line 200 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	row.video_id = _tmp11_;
#line 201 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp12_ = stmt;
#line 201 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp13_ = sqlite3_column_text (_tmp12_, 0);
#line 201 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp14_ = g_strdup (_tmp13_);
#line 201 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_g_free0 (row.filepath);
#line 201 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	row.filepath = _tmp14_;
#line 202 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp15_ = stmt;
#line 202 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp16_ = sqlite3_column_int (_tmp15_, 1);
#line 202 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	row.width = _tmp16_;
#line 203 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp17_ = stmt;
#line 203 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp18_ = sqlite3_column_int (_tmp17_, 2);
#line 203 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	row.height = _tmp18_;
#line 204 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp19_ = stmt;
#line 204 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp20_ = sqlite3_column_double (_tmp19_, 3);
#line 204 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	row.clip_duration = _tmp20_;
#line 205 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp21_ = stmt;
#line 205 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp22_ = sqlite3_column_int (_tmp21_, 4);
#line 205 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	row.is_interpretable = _tmp22_ == 1;
#line 206 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp23_ = stmt;
#line 206 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp24_ = sqlite3_column_int64 (_tmp23_, 5);
#line 206 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	row.filesize = _tmp24_;
#line 207 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp25_ = stmt;
#line 207 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp26_ = sqlite3_column_int64 (_tmp25_, 6);
#line 207 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	row.timestamp = (time_t) _tmp26_;
#line 208 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp27_ = stmt;
#line 208 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp28_ = sqlite3_column_int64 (_tmp27_, 7);
#line 208 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	row.exposure_time = (time_t) _tmp28_;
#line 209 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp29_ = stmt;
#line 209 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp30_ = sqlite3_column_int64 (_tmp29_, 8);
#line 209 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	row.import_id.id = _tmp30_;
#line 210 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp31_ = stmt;
#line 210 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp32_ = sqlite3_column_int64 (_tmp31_, 9);
#line 210 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	row.event_id.id = _tmp32_;
#line 211 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp33_ = stmt;
#line 211 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp34_ = sqlite3_column_text (_tmp33_, 10);
#line 211 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp35_ = g_strdup (_tmp34_);
#line 211 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_g_free0 (row.md5);
#line 211 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	row.md5 = _tmp35_;
#line 212 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp36_ = stmt;
#line 212 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp37_ = sqlite3_column_int64 (_tmp36_, 11);
#line 212 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	row.time_created = (time_t) _tmp37_;
#line 213 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp38_ = stmt;
#line 213 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp39_ = sqlite3_column_int (_tmp38_, 12);
#line 213 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp40_ = rating_unserialize (_tmp39_);
#line 213 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	row.rating = _tmp40_;
#line 214 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp41_ = stmt;
#line 214 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp42_ = sqlite3_column_text (_tmp41_, 13);
#line 214 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp43_ = g_strdup (_tmp42_);
#line 214 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_g_free0 (row.title);
#line 214 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	row.title = _tmp43_;
#line 215 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp44_ = stmt;
#line 215 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp45_ = sqlite3_column_text (_tmp44_, 14);
#line 215 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp46_ = g_strdup (_tmp45_);
#line 215 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_g_free0 (row.backlinks);
#line 215 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	row.backlinks = _tmp46_;
#line 216 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp47_ = stmt;
#line 216 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp48_ = sqlite3_column_int64 (_tmp47_, 15);
#line 216 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	row.time_reimported = (time_t) _tmp48_;
#line 217 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp49_ = stmt;
#line 217 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp50_ = sqlite3_column_int64 (_tmp49_, 16);
#line 217 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	row.flags = (guint64) _tmp50_;
#line 219 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp51_ = row;
#line 219 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp52_ = _video_row_dup0 (&_tmp51_);
#line 219 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp53_ = _tmp52_;
#line 219 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	video_row_destroy (&_tmp51_);
#line 219 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	result = _tmp53_;
#line 219 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 219 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	return result;
#line 1391 "VideoTable.c"
}


GeeArrayList* video_table_get_all (VideoTable* self) {
	GeeArrayList* result = NULL;
	sqlite3_stmt* stmt = NULL;
	sqlite3* _tmp0_;
	sqlite3_stmt* _tmp1_ = NULL;
	gint _tmp2_ = 0;
	gint res;
	gint _tmp3_;
	GeeArrayList* _tmp4_;
	GeeArrayList* all;
#line 222 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	g_return_val_if_fail (IS_VIDEO_TABLE (self), NULL);
#line 224 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp0_ = database_table_db;
#line 224 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp2_ = sqlite3_prepare_v2 (_tmp0_, "SELECT id, filename, width, height, clip_duration, is_interpretable, f" \
"ilesize, " "timestamp, exposure_time, import_id, event_id, md5, time_created, rati" \
"ng, title, " "backlinks, time_reimported, flags FROM VideoTable", -1, &_tmp1_, NULL);
#line 224 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 224 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	stmt = _tmp1_;
#line 224 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	res = _tmp2_;
#line 229 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp3_ = res;
#line 229 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	g_assert (_tmp3_ == SQLITE_OK);
#line 231 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp4_ = gee_array_list_new (TYPE_VIDEO_ROW, (GBoxedCopyFunc) video_row_dup, video_row_free, NULL);
#line 231 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	all = _tmp4_;
#line 233 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	while (TRUE) {
#line 1427 "VideoTable.c"
		sqlite3_stmt* _tmp5_;
		gint _tmp6_ = 0;
		gint _tmp7_;
		VideoRow row = {0};
		sqlite3_stmt* _tmp8_;
		gint64 _tmp9_ = 0LL;
		sqlite3_stmt* _tmp10_;
		const gchar* _tmp11_ = NULL;
		gchar* _tmp12_;
		sqlite3_stmt* _tmp13_;
		gint _tmp14_ = 0;
		sqlite3_stmt* _tmp15_;
		gint _tmp16_ = 0;
		sqlite3_stmt* _tmp17_;
		gdouble _tmp18_ = 0.0;
		sqlite3_stmt* _tmp19_;
		gint _tmp20_ = 0;
		sqlite3_stmt* _tmp21_;
		gint64 _tmp22_ = 0LL;
		sqlite3_stmt* _tmp23_;
		gint64 _tmp24_ = 0LL;
		sqlite3_stmt* _tmp25_;
		gint64 _tmp26_ = 0LL;
		sqlite3_stmt* _tmp27_;
		gint64 _tmp28_ = 0LL;
		sqlite3_stmt* _tmp29_;
		gint64 _tmp30_ = 0LL;
		sqlite3_stmt* _tmp31_;
		const gchar* _tmp32_ = NULL;
		gchar* _tmp33_;
		sqlite3_stmt* _tmp34_;
		gint64 _tmp35_ = 0LL;
		sqlite3_stmt* _tmp36_;
		gint _tmp37_ = 0;
		Rating _tmp38_ = 0;
		sqlite3_stmt* _tmp39_;
		const gchar* _tmp40_ = NULL;
		gchar* _tmp41_;
		sqlite3_stmt* _tmp42_;
		const gchar* _tmp43_ = NULL;
		gchar* _tmp44_;
		sqlite3_stmt* _tmp45_;
		gint64 _tmp46_ = 0LL;
		sqlite3_stmt* _tmp47_;
		gint64 _tmp48_ = 0LL;
		GeeArrayList* _tmp49_;
		VideoRow _tmp50_;
#line 233 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		_tmp5_ = stmt;
#line 233 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		_tmp6_ = sqlite3_step (_tmp5_);
#line 233 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		res = _tmp6_;
#line 233 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		_tmp7_ = res;
#line 233 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		if (!(_tmp7_ == SQLITE_ROW)) {
#line 233 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
			break;
#line 1487 "VideoTable.c"
		}
#line 234 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		memset (&row, 0, sizeof (VideoRow));
#line 235 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		_tmp8_ = stmt;
#line 235 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		_tmp9_ = sqlite3_column_int64 (_tmp8_, 0);
#line 235 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		row.video_id.id = _tmp9_;
#line 236 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		_tmp10_ = stmt;
#line 236 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		_tmp11_ = sqlite3_column_text (_tmp10_, 1);
#line 236 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		_tmp12_ = g_strdup (_tmp11_);
#line 236 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		_g_free0 (row.filepath);
#line 236 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		row.filepath = _tmp12_;
#line 237 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		_tmp13_ = stmt;
#line 237 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		_tmp14_ = sqlite3_column_int (_tmp13_, 2);
#line 237 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		row.width = _tmp14_;
#line 238 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		_tmp15_ = stmt;
#line 238 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		_tmp16_ = sqlite3_column_int (_tmp15_, 3);
#line 238 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		row.height = _tmp16_;
#line 239 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		_tmp17_ = stmt;
#line 239 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		_tmp18_ = sqlite3_column_double (_tmp17_, 4);
#line 239 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		row.clip_duration = _tmp18_;
#line 240 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		_tmp19_ = stmt;
#line 240 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		_tmp20_ = sqlite3_column_int (_tmp19_, 5);
#line 240 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		row.is_interpretable = _tmp20_ == 1;
#line 241 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		_tmp21_ = stmt;
#line 241 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		_tmp22_ = sqlite3_column_int64 (_tmp21_, 6);
#line 241 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		row.filesize = _tmp22_;
#line 242 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		_tmp23_ = stmt;
#line 242 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		_tmp24_ = sqlite3_column_int64 (_tmp23_, 7);
#line 242 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		row.timestamp = (time_t) _tmp24_;
#line 243 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		_tmp25_ = stmt;
#line 243 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		_tmp26_ = sqlite3_column_int64 (_tmp25_, 8);
#line 243 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		row.exposure_time = (time_t) _tmp26_;
#line 244 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		_tmp27_ = stmt;
#line 244 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		_tmp28_ = sqlite3_column_int64 (_tmp27_, 9);
#line 244 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		row.import_id.id = _tmp28_;
#line 245 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		_tmp29_ = stmt;
#line 245 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		_tmp30_ = sqlite3_column_int64 (_tmp29_, 10);
#line 245 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		row.event_id.id = _tmp30_;
#line 246 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		_tmp31_ = stmt;
#line 246 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		_tmp32_ = sqlite3_column_text (_tmp31_, 11);
#line 246 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		_tmp33_ = g_strdup (_tmp32_);
#line 246 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		_g_free0 (row.md5);
#line 246 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		row.md5 = _tmp33_;
#line 247 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		_tmp34_ = stmt;
#line 247 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		_tmp35_ = sqlite3_column_int64 (_tmp34_, 12);
#line 247 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		row.time_created = (time_t) _tmp35_;
#line 248 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		_tmp36_ = stmt;
#line 248 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		_tmp37_ = sqlite3_column_int (_tmp36_, 13);
#line 248 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		_tmp38_ = rating_unserialize (_tmp37_);
#line 248 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		row.rating = _tmp38_;
#line 249 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		_tmp39_ = stmt;
#line 249 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		_tmp40_ = sqlite3_column_text (_tmp39_, 14);
#line 249 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		_tmp41_ = g_strdup (_tmp40_);
#line 249 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		_g_free0 (row.title);
#line 249 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		row.title = _tmp41_;
#line 250 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		_tmp42_ = stmt;
#line 250 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		_tmp43_ = sqlite3_column_text (_tmp42_, 15);
#line 250 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		_tmp44_ = g_strdup (_tmp43_);
#line 250 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		_g_free0 (row.backlinks);
#line 250 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		row.backlinks = _tmp44_;
#line 251 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		_tmp45_ = stmt;
#line 251 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		_tmp46_ = sqlite3_column_int64 (_tmp45_, 16);
#line 251 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		row.time_reimported = (time_t) _tmp46_;
#line 252 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		_tmp47_ = stmt;
#line 252 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		_tmp48_ = sqlite3_column_int64 (_tmp47_, 17);
#line 252 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		row.flags = (guint64) _tmp48_;
#line 254 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		_tmp49_ = all;
#line 254 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		_tmp50_ = row;
#line 254 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (_tmp49_), &_tmp50_);
#line 233 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		video_row_destroy (&row);
#line 1625 "VideoTable.c"
	}
#line 257 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	result = all;
#line 257 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 257 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	return result;
#line 1633 "VideoTable.c"
}


void video_table_set_filepath (VideoTable* self, VideoID* video_id, const gchar* filepath, GError** error) {
	VideoID _tmp0_;
	gint64 _tmp1_;
	const gchar* _tmp2_;
	GError * _inner_error_ = NULL;
#line 260 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	g_return_if_fail (IS_VIDEO_TABLE (self));
#line 260 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	g_return_if_fail (video_id != NULL);
#line 260 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	g_return_if_fail (filepath != NULL);
#line 261 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp0_ = *video_id;
#line 261 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp1_ = _tmp0_.id;
#line 261 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp2_ = filepath;
#line 261 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	database_table_update_text_by_id_2 (DATABASE_TABLE (self), _tmp1_, "filename", _tmp2_, &_inner_error_);
#line 261 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	if (_inner_error_ != NULL) {
#line 261 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		if (_inner_error_->domain == DATABASE_ERROR) {
#line 261 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
			g_propagate_error (error, _inner_error_);
#line 261 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
			return;
#line 1664 "VideoTable.c"
		} else {
#line 261 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 261 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
			g_clear_error (&_inner_error_);
#line 261 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
			return;
#line 1672 "VideoTable.c"
		}
	}
}


void video_table_set_title (VideoTable* self, VideoID* video_id, const gchar* new_title, GError** error) {
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_;
	VideoID _tmp3_;
	gint64 _tmp4_;
	const gchar* _tmp5_;
	GError * _inner_error_ = NULL;
#line 264 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	g_return_if_fail (IS_VIDEO_TABLE (self));
#line 264 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	g_return_if_fail (video_id != NULL);
#line 265 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp1_ = new_title;
#line 265 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	if (_tmp1_ != NULL) {
#line 1693 "VideoTable.c"
		const gchar* _tmp2_;
#line 265 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		_tmp2_ = new_title;
#line 265 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		_tmp0_ = _tmp2_;
#line 1699 "VideoTable.c"
	} else {
#line 265 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		_tmp0_ = "";
#line 1703 "VideoTable.c"
	}
#line 265 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp3_ = *video_id;
#line 265 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp4_ = _tmp3_.id;
#line 265 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp5_ = _tmp0_;
#line 265 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	database_table_update_text_by_id_2 (DATABASE_TABLE (self), _tmp4_, "title", _tmp5_, &_inner_error_);
#line 265 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	if (_inner_error_ != NULL) {
#line 265 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		if (_inner_error_->domain == DATABASE_ERROR) {
#line 265 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
			g_propagate_error (error, _inner_error_);
#line 265 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
			return;
#line 1721 "VideoTable.c"
		} else {
#line 265 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 265 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
			g_clear_error (&_inner_error_);
#line 265 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
			return;
#line 1729 "VideoTable.c"
		}
	}
}


void video_table_set_exposure_time (VideoTable* self, VideoID* video_id, time_t time, GError** error) {
	VideoID _tmp0_;
	gint64 _tmp1_;
	time_t _tmp2_;
	GError * _inner_error_ = NULL;
#line 268 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	g_return_if_fail (IS_VIDEO_TABLE (self));
#line 268 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	g_return_if_fail (video_id != NULL);
#line 269 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp0_ = *video_id;
#line 269 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp1_ = _tmp0_.id;
#line 269 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp2_ = time;
#line 269 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	database_table_update_int64_by_id_2 (DATABASE_TABLE (self), _tmp1_, "exposure_time", (gint64) _tmp2_, &_inner_error_);
#line 269 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	if (_inner_error_ != NULL) {
#line 269 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		if (_inner_error_->domain == DATABASE_ERROR) {
#line 269 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
			g_propagate_error (error, _inner_error_);
#line 269 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
			return;
#line 1760 "VideoTable.c"
		} else {
#line 269 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 269 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
			g_clear_error (&_inner_error_);
#line 269 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
			return;
#line 1768 "VideoTable.c"
		}
	}
}


void video_table_set_rating (VideoTable* self, VideoID* video_id, Rating rating, GError** error) {
	VideoID _tmp0_;
	gint64 _tmp1_;
	Rating _tmp2_;
	gint _tmp3_ = 0;
	GError * _inner_error_ = NULL;
#line 272 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	g_return_if_fail (IS_VIDEO_TABLE (self));
#line 272 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	g_return_if_fail (video_id != NULL);
#line 273 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp0_ = *video_id;
#line 273 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp1_ = _tmp0_.id;
#line 273 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp2_ = rating;
#line 273 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp3_ = rating_serialize (_tmp2_);
#line 273 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	database_table_update_int64_by_id_2 (DATABASE_TABLE (self), _tmp1_, "rating", (gint64) _tmp3_, &_inner_error_);
#line 273 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	if (_inner_error_ != NULL) {
#line 273 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		if (_inner_error_->domain == DATABASE_ERROR) {
#line 273 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
			g_propagate_error (error, _inner_error_);
#line 273 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
			return;
#line 1802 "VideoTable.c"
		} else {
#line 273 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 273 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
			g_clear_error (&_inner_error_);
#line 273 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
			return;
#line 1810 "VideoTable.c"
		}
	}
}


void video_table_set_flags (VideoTable* self, VideoID* video_id, guint64 flags, GError** error) {
	VideoID _tmp0_;
	gint64 _tmp1_;
	guint64 _tmp2_;
	GError * _inner_error_ = NULL;
#line 276 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	g_return_if_fail (IS_VIDEO_TABLE (self));
#line 276 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	g_return_if_fail (video_id != NULL);
#line 277 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp0_ = *video_id;
#line 277 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp1_ = _tmp0_.id;
#line 277 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp2_ = flags;
#line 277 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	database_table_update_int64_by_id_2 (DATABASE_TABLE (self), _tmp1_, "flags", (gint64) _tmp2_, &_inner_error_);
#line 277 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	if (_inner_error_ != NULL) {
#line 277 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		if (_inner_error_->domain == DATABASE_ERROR) {
#line 277 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
			g_propagate_error (error, _inner_error_);
#line 277 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
			return;
#line 1841 "VideoTable.c"
		} else {
#line 277 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 277 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
			g_clear_error (&_inner_error_);
#line 277 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
			return;
#line 1849 "VideoTable.c"
		}
	}
}


void video_table_update_backlinks (VideoTable* self, VideoID* video_id, const gchar* backlinks, GError** error) {
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_;
	VideoID _tmp3_;
	gint64 _tmp4_;
	const gchar* _tmp5_;
	GError * _inner_error_ = NULL;
#line 280 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	g_return_if_fail (IS_VIDEO_TABLE (self));
#line 280 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	g_return_if_fail (video_id != NULL);
#line 281 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp1_ = backlinks;
#line 281 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	if (_tmp1_ != NULL) {
#line 1870 "VideoTable.c"
		const gchar* _tmp2_;
#line 281 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		_tmp2_ = backlinks;
#line 281 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		_tmp0_ = _tmp2_;
#line 1876 "VideoTable.c"
	} else {
#line 281 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		_tmp0_ = "";
#line 1880 "VideoTable.c"
	}
#line 281 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp3_ = *video_id;
#line 281 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp4_ = _tmp3_.id;
#line 281 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp5_ = _tmp0_;
#line 281 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	database_table_update_text_by_id_2 (DATABASE_TABLE (self), _tmp4_, "backlinks", _tmp5_, &_inner_error_);
#line 281 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	if (_inner_error_ != NULL) {
#line 281 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		if (_inner_error_->domain == DATABASE_ERROR) {
#line 281 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
			g_propagate_error (error, _inner_error_);
#line 281 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
			return;
#line 1898 "VideoTable.c"
		} else {
#line 281 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 281 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
			g_clear_error (&_inner_error_);
#line 281 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
			return;
#line 1906 "VideoTable.c"
		}
	}
}


void video_table_update_is_interpretable (VideoTable* self, VideoID* video_id, gboolean is_interpretable, GError** error) {
	gint _tmp0_ = 0;
	gboolean _tmp1_;
	VideoID _tmp2_;
	gint64 _tmp3_;
	gint _tmp4_;
	GError * _inner_error_ = NULL;
#line 284 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	g_return_if_fail (IS_VIDEO_TABLE (self));
#line 284 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	g_return_if_fail (video_id != NULL);
#line 285 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp1_ = is_interpretable;
#line 285 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	if (_tmp1_) {
#line 285 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		_tmp0_ = 1;
#line 1929 "VideoTable.c"
	} else {
#line 285 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		_tmp0_ = 0;
#line 1933 "VideoTable.c"
	}
#line 285 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp2_ = *video_id;
#line 285 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp3_ = _tmp2_.id;
#line 285 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp4_ = _tmp0_;
#line 285 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	database_table_update_int_by_id_2 (DATABASE_TABLE (self), _tmp3_, "is_interpretable", _tmp4_, &_inner_error_);
#line 285 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	if (_inner_error_ != NULL) {
#line 285 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		if (_inner_error_->domain == DATABASE_ERROR) {
#line 285 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
			g_propagate_error (error, _inner_error_);
#line 285 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
			return;
#line 1951 "VideoTable.c"
		} else {
#line 285 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 285 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
			g_clear_error (&_inner_error_);
#line 285 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
			return;
#line 1959 "VideoTable.c"
		}
	}
}


gboolean video_table_set_event (VideoTable* self, VideoID* video_id, EventID* event_id) {
	gboolean result = FALSE;
	VideoID _tmp0_;
	gint64 _tmp1_;
	EventID _tmp2_;
	gint64 _tmp3_;
	gboolean _tmp4_ = FALSE;
#line 288 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	g_return_val_if_fail (IS_VIDEO_TABLE (self), FALSE);
#line 288 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	g_return_val_if_fail (video_id != NULL, FALSE);
#line 288 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	g_return_val_if_fail (event_id != NULL, FALSE);
#line 289 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp0_ = *video_id;
#line 289 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp1_ = _tmp0_.id;
#line 289 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp2_ = *event_id;
#line 289 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp3_ = _tmp2_.id;
#line 289 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp4_ = database_table_update_int64_by_id (DATABASE_TABLE (self), _tmp1_, "event_id", _tmp3_);
#line 289 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	result = _tmp4_;
#line 289 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	return result;
#line 1992 "VideoTable.c"
}


void video_table_remove_by_file (VideoTable* self, GFile* file, GError** error) {
	sqlite3_stmt* stmt = NULL;
	sqlite3* _tmp0_;
	sqlite3_stmt* _tmp1_ = NULL;
	gint _tmp2_ = 0;
	gint res;
	gint _tmp3_;
	sqlite3_stmt* _tmp4_;
	GFile* _tmp5_;
	gchar* _tmp6_ = NULL;
	GDestroyNotify _tmp7_;
	gint _tmp8_ = 0;
	gint _tmp9_;
	sqlite3_stmt* _tmp10_;
	gint _tmp11_ = 0;
	gint _tmp12_;
	GError * _inner_error_ = NULL;
#line 292 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	g_return_if_fail (IS_VIDEO_TABLE (self));
#line 292 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	g_return_if_fail (G_IS_FILE (file));
#line 294 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp0_ = database_table_db;
#line 294 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp2_ = sqlite3_prepare_v2 (_tmp0_, "DELETE FROM VideoTable WHERE filename=?", -1, &_tmp1_, NULL);
#line 294 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 294 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	stmt = _tmp1_;
#line 294 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	res = _tmp2_;
#line 295 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp3_ = res;
#line 295 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	g_assert (_tmp3_ == SQLITE_OK);
#line 297 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp4_ = stmt;
#line 297 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp5_ = file;
#line 297 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp6_ = g_file_get_path (_tmp5_);
#line 297 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp7_ = g_free;
#line 297 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp8_ = sqlite3_bind_text (_tmp4_, 1, _tmp6_, -1, _tmp7_);
#line 297 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	res = _tmp8_;
#line 298 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp9_ = res;
#line 298 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	g_assert (_tmp9_ == SQLITE_OK);
#line 300 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp10_ = stmt;
#line 300 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp11_ = sqlite3_step (_tmp10_);
#line 300 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	res = _tmp11_;
#line 301 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp12_ = res;
#line 301 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	if (_tmp12_ != SQLITE_DONE) {
#line 2057 "VideoTable.c"
		gint _tmp13_;
#line 302 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		_tmp13_ = res;
#line 302 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		database_table_throw_error ("VideoTable.remove_by_file", _tmp13_, &_inner_error_);
#line 302 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		if (_inner_error_ != NULL) {
#line 302 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
			if (_inner_error_->domain == DATABASE_ERROR) {
#line 302 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
				g_propagate_error (error, _inner_error_);
#line 302 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
				_sqlite3_finalize0 (stmt);
#line 302 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
				return;
#line 2073 "VideoTable.c"
			} else {
#line 302 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
				_sqlite3_finalize0 (stmt);
#line 302 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 302 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
				g_clear_error (&_inner_error_);
#line 302 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
				return;
#line 2083 "VideoTable.c"
			}
		}
	}
#line 292 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 2089 "VideoTable.c"
}


void video_table_remove (VideoTable* self, VideoID* videoID, GError** error) {
	sqlite3_stmt* stmt = NULL;
	sqlite3* _tmp0_;
	sqlite3_stmt* _tmp1_ = NULL;
	gint _tmp2_ = 0;
	gint res;
	gint _tmp3_;
	sqlite3_stmt* _tmp4_;
	VideoID _tmp5_;
	gint64 _tmp6_;
	gint _tmp7_ = 0;
	gint _tmp8_;
	sqlite3_stmt* _tmp9_;
	gint _tmp10_ = 0;
	gint _tmp11_;
	GError * _inner_error_ = NULL;
#line 305 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	g_return_if_fail (IS_VIDEO_TABLE (self));
#line 305 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	g_return_if_fail (videoID != NULL);
#line 307 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp0_ = database_table_db;
#line 307 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp2_ = sqlite3_prepare_v2 (_tmp0_, "DELETE FROM VideoTable WHERE id=?", -1, &_tmp1_, NULL);
#line 307 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 307 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	stmt = _tmp1_;
#line 307 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	res = _tmp2_;
#line 308 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp3_ = res;
#line 308 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	g_assert (_tmp3_ == SQLITE_OK);
#line 310 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp4_ = stmt;
#line 310 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp5_ = *videoID;
#line 310 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp6_ = _tmp5_.id;
#line 310 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp7_ = sqlite3_bind_int64 (_tmp4_, 1, _tmp6_);
#line 310 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	res = _tmp7_;
#line 311 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp8_ = res;
#line 311 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	g_assert (_tmp8_ == SQLITE_OK);
#line 313 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp9_ = stmt;
#line 313 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp10_ = sqlite3_step (_tmp9_);
#line 313 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	res = _tmp10_;
#line 314 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp11_ = res;
#line 314 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	if (_tmp11_ != SQLITE_DONE) {
#line 2151 "VideoTable.c"
		gint _tmp12_;
#line 315 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		_tmp12_ = res;
#line 315 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		database_table_throw_error ("VideoTable.remove", _tmp12_, &_inner_error_);
#line 315 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		if (_inner_error_ != NULL) {
#line 315 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
			if (_inner_error_->domain == DATABASE_ERROR) {
#line 315 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
				g_propagate_error (error, _inner_error_);
#line 315 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
				_sqlite3_finalize0 (stmt);
#line 315 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
				return;
#line 2167 "VideoTable.c"
			} else {
#line 315 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
				_sqlite3_finalize0 (stmt);
#line 315 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 315 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
				g_clear_error (&_inner_error_);
#line 315 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
				return;
#line 2177 "VideoTable.c"
			}
		}
	}
#line 305 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 2183 "VideoTable.c"
}


gboolean video_table_is_video_stored (VideoTable* self, GFile* file) {
	gboolean result = FALSE;
	GFile* _tmp0_;
	VideoID _tmp1_ = {0};
	gboolean _tmp2_ = FALSE;
#line 318 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	g_return_val_if_fail (IS_VIDEO_TABLE (self), FALSE);
#line 318 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	g_return_val_if_fail (G_IS_FILE (file), FALSE);
#line 319 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp0_ = file;
#line 319 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	video_table_get_id (self, _tmp0_, &_tmp1_);
#line 319 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp2_ = video_id_is_valid (&_tmp1_);
#line 319 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	result = _tmp2_;
#line 319 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	return result;
#line 2206 "VideoTable.c"
}


void video_table_get_id (VideoTable* self, GFile* file, VideoID* result) {
	sqlite3_stmt* stmt = NULL;
	sqlite3* _tmp0_;
	sqlite3_stmt* _tmp1_ = NULL;
	gint _tmp2_ = 0;
	gint res;
	gint _tmp3_;
	sqlite3_stmt* _tmp4_;
	GFile* _tmp5_;
	gchar* _tmp6_ = NULL;
	GDestroyNotify _tmp7_;
	gint _tmp8_ = 0;
	gint _tmp9_;
	sqlite3_stmt* _tmp10_;
	gint _tmp11_ = 0;
	VideoID _tmp12_ = {0};
	gint _tmp13_;
#line 322 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	g_return_if_fail (IS_VIDEO_TABLE (self));
#line 322 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	g_return_if_fail (G_IS_FILE (file));
#line 324 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp0_ = database_table_db;
#line 324 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp2_ = sqlite3_prepare_v2 (_tmp0_, "SELECT ID FROM VideoTable WHERE filename=?", -1, &_tmp1_, NULL);
#line 324 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 324 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	stmt = _tmp1_;
#line 324 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	res = _tmp2_;
#line 325 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp3_ = res;
#line 325 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	g_assert (_tmp3_ == SQLITE_OK);
#line 327 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp4_ = stmt;
#line 327 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp5_ = file;
#line 327 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp6_ = g_file_get_path (_tmp5_);
#line 327 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp7_ = g_free;
#line 327 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp8_ = sqlite3_bind_text (_tmp4_, 1, _tmp6_, -1, _tmp7_);
#line 327 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	res = _tmp8_;
#line 328 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp9_ = res;
#line 328 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	g_assert (_tmp9_ == SQLITE_OK);
#line 330 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp10_ = stmt;
#line 330 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp11_ = sqlite3_step (_tmp10_);
#line 330 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	res = _tmp11_;
#line 332 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp13_ = res;
#line 332 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	if (_tmp13_ == SQLITE_ROW) {
#line 2271 "VideoTable.c"
		sqlite3_stmt* _tmp14_;
		gint64 _tmp15_ = 0LL;
		VideoID _tmp16_ = {0};
#line 332 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		_tmp14_ = stmt;
#line 332 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		_tmp15_ = sqlite3_column_int64 (_tmp14_, 0);
#line 332 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		video_id_init (&_tmp16_, _tmp15_);
#line 332 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		_tmp12_ = _tmp16_;
#line 2283 "VideoTable.c"
	} else {
		VideoID _tmp17_ = {0};
#line 332 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		video_id_init (&_tmp17_, VIDEO_ID_INVALID);
#line 332 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		_tmp12_ = _tmp17_;
#line 2290 "VideoTable.c"
	}
#line 332 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	*result = _tmp12_;
#line 332 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 332 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	return;
#line 2298 "VideoTable.c"
}


GeeArrayList* video_table_get_videos (VideoTable* self, GError** error) {
	GeeArrayList* result = NULL;
	sqlite3_stmt* stmt = NULL;
	sqlite3* _tmp0_;
	sqlite3_stmt* _tmp1_ = NULL;
	gint _tmp2_ = 0;
	gint res;
	gint _tmp3_;
	GeeArrayList* _tmp4_;
	GeeArrayList* video_ids;
	GError * _inner_error_ = NULL;
#line 335 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	g_return_val_if_fail (IS_VIDEO_TABLE (self), NULL);
#line 337 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp0_ = database_table_db;
#line 337 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp2_ = sqlite3_prepare_v2 (_tmp0_, "SELECT id FROM VideoTable", -1, &_tmp1_, NULL);
#line 337 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 337 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	stmt = _tmp1_;
#line 337 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	res = _tmp2_;
#line 338 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp3_ = res;
#line 338 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	g_assert (_tmp3_ == SQLITE_OK);
#line 340 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp4_ = gee_array_list_new (TYPE_VIDEO_ID, (GBoxedCopyFunc) video_id_dup, video_id_free, NULL);
#line 340 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	video_ids = _tmp4_;
#line 2333 "VideoTable.c"
	{
		gboolean _tmp5_;
#line 341 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		_tmp5_ = TRUE;
#line 341 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		while (TRUE) {
#line 2340 "VideoTable.c"
			gboolean _tmp6_;
			sqlite3_stmt* _tmp7_;
			gint _tmp8_ = 0;
			gint _tmp9_;
			GeeArrayList* _tmp12_;
			sqlite3_stmt* _tmp13_;
			gint64 _tmp14_ = 0LL;
			VideoID _tmp15_ = {0};
#line 341 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
			_tmp6_ = _tmp5_;
#line 341 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
			if (!_tmp6_) {
#line 2353 "VideoTable.c"
			}
#line 341 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
			_tmp5_ = FALSE;
#line 342 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
			_tmp7_ = stmt;
#line 342 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
			_tmp8_ = sqlite3_step (_tmp7_);
#line 342 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
			res = _tmp8_;
#line 343 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
			_tmp9_ = res;
#line 343 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
			if (_tmp9_ == SQLITE_DONE) {
#line 344 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
				break;
#line 2369 "VideoTable.c"
			} else {
				gint _tmp10_;
#line 345 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
				_tmp10_ = res;
#line 345 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
				if (_tmp10_ != SQLITE_ROW) {
#line 2376 "VideoTable.c"
					gint _tmp11_;
#line 346 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
					_tmp11_ = res;
#line 346 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
					database_table_throw_error ("VideoTable.get_videos", _tmp11_, &_inner_error_);
#line 346 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
					if (_inner_error_ != NULL) {
#line 346 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
						if (_inner_error_->domain == DATABASE_ERROR) {
#line 346 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
							g_propagate_error (error, _inner_error_);
#line 346 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
							_g_object_unref0 (video_ids);
#line 346 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
							_sqlite3_finalize0 (stmt);
#line 346 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
							return NULL;
#line 2394 "VideoTable.c"
						} else {
#line 346 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
							_g_object_unref0 (video_ids);
#line 346 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
							_sqlite3_finalize0 (stmt);
#line 346 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
							g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 346 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
							g_clear_error (&_inner_error_);
#line 346 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
							return NULL;
#line 2406 "VideoTable.c"
						}
					}
				}
			}
#line 349 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
			_tmp12_ = video_ids;
#line 349 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
			_tmp13_ = stmt;
#line 349 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
			_tmp14_ = sqlite3_column_int64 (_tmp13_, 0);
#line 349 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
			video_id_init (&_tmp15_, _tmp14_);
#line 349 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
			gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (_tmp12_), &_tmp15_);
#line 2421 "VideoTable.c"
		}
	}
#line 352 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	result = video_ids;
#line 352 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 352 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	return result;
#line 2430 "VideoTable.c"
}


static sqlite3_stmt* video_table_get_duplicate_stmt (VideoTable* self, GFile* file, const gchar* md5) {
	sqlite3_stmt* result = NULL;
	gboolean _tmp0_ = FALSE;
	GFile* _tmp1_;
	gboolean _tmp3_;
	gchar* _tmp4_;
	gchar* sql;
	gboolean first;
	GFile* _tmp5_;
	const gchar* _tmp8_;
	sqlite3_stmt* stmt = NULL;
	sqlite3* _tmp14_;
	const gchar* _tmp15_;
	sqlite3_stmt* _tmp16_ = NULL;
	gint _tmp17_ = 0;
	gint res;
	gint _tmp18_;
	gint col;
	GFile* _tmp19_;
	const gchar* _tmp27_;
#line 355 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	g_return_val_if_fail (IS_VIDEO_TABLE (self), NULL);
#line 355 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	g_return_val_if_fail ((file == NULL) || G_IS_FILE (file), NULL);
#line 356 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp1_ = file;
#line 356 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	if (_tmp1_ != NULL) {
#line 356 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		_tmp0_ = TRUE;
#line 2464 "VideoTable.c"
	} else {
		const gchar* _tmp2_;
#line 356 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		_tmp2_ = md5;
#line 356 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		_tmp0_ = _tmp2_ != NULL;
#line 2471 "VideoTable.c"
	}
#line 356 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp3_ = _tmp0_;
#line 356 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	g_assert (_tmp3_);
#line 358 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp4_ = g_strdup ("SELECT id FROM VideoTable WHERE");
#line 358 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	sql = _tmp4_;
#line 359 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	first = TRUE;
#line 361 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp5_ = file;
#line 361 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	if (_tmp5_ != NULL) {
#line 2487 "VideoTable.c"
		const gchar* _tmp6_;
		gchar* _tmp7_;
#line 362 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		_tmp6_ = sql;
#line 362 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		_tmp7_ = g_strconcat (_tmp6_, " filename=?", NULL);
#line 362 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		_g_free0 (sql);
#line 362 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		sql = _tmp7_;
#line 363 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		first = FALSE;
#line 2500 "VideoTable.c"
	}
#line 366 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp8_ = md5;
#line 366 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	if (_tmp8_ != NULL) {
#line 2506 "VideoTable.c"
		gboolean _tmp9_;
		const gchar* _tmp12_;
		gchar* _tmp13_;
#line 367 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		_tmp9_ = first;
#line 367 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		if (!_tmp9_) {
#line 2514 "VideoTable.c"
			const gchar* _tmp10_;
			gchar* _tmp11_;
#line 368 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
			_tmp10_ = sql;
#line 368 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
			_tmp11_ = g_strconcat (_tmp10_, " OR ", NULL);
#line 368 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
			_g_free0 (sql);
#line 368 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
			sql = _tmp11_;
#line 2525 "VideoTable.c"
		}
#line 370 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		_tmp12_ = sql;
#line 370 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		_tmp13_ = g_strconcat (_tmp12_, " md5=?", NULL);
#line 370 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		_g_free0 (sql);
#line 370 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		sql = _tmp13_;
#line 2535 "VideoTable.c"
	}
#line 374 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp14_ = database_table_db;
#line 374 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp15_ = sql;
#line 374 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp17_ = sqlite3_prepare_v2 (_tmp14_, _tmp15_, -1, &_tmp16_, NULL);
#line 374 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 374 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	stmt = _tmp16_;
#line 374 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	res = _tmp17_;
#line 375 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp18_ = res;
#line 375 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	g_assert (_tmp18_ == SQLITE_OK);
#line 377 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	col = 1;
#line 379 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp19_ = file;
#line 379 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	if (_tmp19_ != NULL) {
#line 2559 "VideoTable.c"
		sqlite3_stmt* _tmp20_;
		gint _tmp21_;
		GFile* _tmp22_;
		gchar* _tmp23_ = NULL;
		GDestroyNotify _tmp24_;
		gint _tmp25_ = 0;
		gint _tmp26_;
#line 380 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		_tmp20_ = stmt;
#line 380 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		_tmp21_ = col;
#line 380 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		col = _tmp21_ + 1;
#line 380 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		_tmp22_ = file;
#line 380 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		_tmp23_ = g_file_get_path (_tmp22_);
#line 380 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		_tmp24_ = g_free;
#line 380 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		_tmp25_ = sqlite3_bind_text (_tmp20_, _tmp21_, _tmp23_, -1, _tmp24_);
#line 380 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		res = _tmp25_;
#line 381 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		_tmp26_ = res;
#line 381 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		g_assert (_tmp26_ == SQLITE_OK);
#line 2587 "VideoTable.c"
	}
#line 384 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp27_ = md5;
#line 384 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	if (_tmp27_ != NULL) {
#line 2593 "VideoTable.c"
		sqlite3_stmt* _tmp28_;
		gint _tmp29_;
		const gchar* _tmp30_;
		gchar* _tmp31_;
		GDestroyNotify _tmp32_;
		gint _tmp33_ = 0;
		gint _tmp34_;
#line 385 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		_tmp28_ = stmt;
#line 385 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		_tmp29_ = col;
#line 385 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		col = _tmp29_ + 1;
#line 385 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		_tmp30_ = md5;
#line 385 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		_tmp31_ = g_strdup (_tmp30_);
#line 385 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		_tmp32_ = g_free;
#line 385 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		_tmp33_ = sqlite3_bind_text (_tmp28_, _tmp29_, _tmp31_, -1, _tmp32_);
#line 385 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		res = _tmp33_;
#line 386 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		_tmp34_ = res;
#line 386 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		g_assert (_tmp34_ == SQLITE_OK);
#line 2621 "VideoTable.c"
	}
#line 389 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	result = stmt;
#line 389 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_g_free0 (sql);
#line 389 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	return result;
#line 2629 "VideoTable.c"
}


gboolean video_table_has_duplicate (VideoTable* self, GFile* file, const gchar* md5) {
	gboolean result = FALSE;
	GFile* _tmp0_;
	const gchar* _tmp1_;
	sqlite3_stmt* _tmp2_ = NULL;
	sqlite3_stmt* stmt;
	sqlite3_stmt* _tmp3_;
	gint _tmp4_ = 0;
	gint res;
	gint _tmp5_;
#line 392 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	g_return_val_if_fail (IS_VIDEO_TABLE (self), FALSE);
#line 392 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	g_return_val_if_fail ((file == NULL) || G_IS_FILE (file), FALSE);
#line 393 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp0_ = file;
#line 393 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp1_ = md5;
#line 393 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp2_ = video_table_get_duplicate_stmt (self, _tmp0_, _tmp1_);
#line 393 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	stmt = _tmp2_;
#line 394 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp3_ = stmt;
#line 394 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp4_ = sqlite3_step (_tmp3_);
#line 394 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	res = _tmp4_;
#line 396 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp5_ = res;
#line 396 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	if (_tmp5_ == SQLITE_DONE) {
#line 398 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		result = FALSE;
#line 398 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		_sqlite3_finalize0 (stmt);
#line 398 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		return result;
#line 2671 "VideoTable.c"
	} else {
		gint _tmp6_;
#line 399 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		_tmp6_ = res;
#line 399 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		if (_tmp6_ == SQLITE_ROW) {
#line 401 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
			result = TRUE;
#line 401 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
			_sqlite3_finalize0 (stmt);
#line 401 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
			return result;
#line 2684 "VideoTable.c"
		} else {
			gint _tmp7_;
#line 403 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
			_tmp7_ = res;
#line 403 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
			database_table_fatal ("VideoTable.has_duplicate", _tmp7_);
#line 2691 "VideoTable.c"
		}
	}
#line 406 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	result = FALSE;
#line 406 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 406 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	return result;
#line 2700 "VideoTable.c"
}


static void _vala_array_add3 (VideoID** array, int* length, int* size, const VideoID* value) {
#line 416 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	if ((*length) == (*size)) {
#line 416 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 416 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		*array = g_renew (VideoID, *array, *size);
#line 2711 "VideoTable.c"
	}
#line 416 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	(*array)[(*length)++] = *value;
#line 2715 "VideoTable.c"
}


VideoID* video_table_get_duplicate_ids (VideoTable* self, GFile* file, const gchar* md5, int* result_length1) {
	VideoID* result = NULL;
	GFile* _tmp0_;
	const gchar* _tmp1_;
	sqlite3_stmt* _tmp2_ = NULL;
	sqlite3_stmt* stmt;
	VideoID* _tmp3_ = NULL;
	VideoID* ids;
	gint ids_length1;
	gint _ids_size_;
	sqlite3_stmt* _tmp4_;
	gint _tmp5_ = 0;
	gint res;
	VideoID* _tmp13_;
	gint _tmp13__length1;
#line 409 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	g_return_val_if_fail (IS_VIDEO_TABLE (self), NULL);
#line 409 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	g_return_val_if_fail ((file == NULL) || G_IS_FILE (file), NULL);
#line 410 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp0_ = file;
#line 410 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp1_ = md5;
#line 410 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp2_ = video_table_get_duplicate_stmt (self, _tmp0_, _tmp1_);
#line 410 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	stmt = _tmp2_;
#line 412 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp3_ = g_new0 (VideoID, 0);
#line 412 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	ids = _tmp3_;
#line 412 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	ids_length1 = 0;
#line 412 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_ids_size_ = ids_length1;
#line 414 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp4_ = stmt;
#line 414 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp5_ = sqlite3_step (_tmp4_);
#line 414 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	res = _tmp5_;
#line 415 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	while (TRUE) {
#line 2762 "VideoTable.c"
		gint _tmp6_;
		VideoID* _tmp7_;
		gint _tmp7__length1;
		sqlite3_stmt* _tmp8_;
		gint64 _tmp9_ = 0LL;
		VideoID _tmp10_ = {0};
		sqlite3_stmt* _tmp11_;
		gint _tmp12_ = 0;
#line 415 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		_tmp6_ = res;
#line 415 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		if (!(_tmp6_ == SQLITE_ROW)) {
#line 415 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
			break;
#line 2777 "VideoTable.c"
		}
#line 416 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		_tmp7_ = ids;
#line 416 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		_tmp7__length1 = ids_length1;
#line 416 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		_tmp8_ = stmt;
#line 416 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		_tmp9_ = sqlite3_column_int64 (_tmp8_, 0);
#line 416 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		video_id_init (&_tmp10_, _tmp9_);
#line 416 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		_vala_array_add3 (&ids, &ids_length1, &_ids_size_, &_tmp10_);
#line 417 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		_tmp11_ = stmt;
#line 417 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		_tmp12_ = sqlite3_step (_tmp11_);
#line 417 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		res = _tmp12_;
#line 2797 "VideoTable.c"
	}
#line 420 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp13_ = ids;
#line 420 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp13__length1 = ids_length1;
#line 420 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	if (result_length1) {
#line 420 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		*result_length1 = _tmp13__length1;
#line 2807 "VideoTable.c"
	}
#line 420 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	result = _tmp13_;
#line 420 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 420 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	return result;
#line 2815 "VideoTable.c"
}


GeeArrayList* video_table_get_event_source_ids (VideoTable* self, EventID* event_id) {
	GeeArrayList* result = NULL;
	sqlite3_stmt* stmt = NULL;
	sqlite3* _tmp0_;
	sqlite3_stmt* _tmp1_ = NULL;
	gint _tmp2_ = 0;
	gint res;
	gint _tmp3_;
	sqlite3_stmt* _tmp4_;
	EventID _tmp5_;
	gint64 _tmp6_;
	gint _tmp7_ = 0;
	gint _tmp8_;
	GeeArrayList* _tmp9_;
	GeeArrayList* _result_;
#line 423 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	g_return_val_if_fail (IS_VIDEO_TABLE (self), NULL);
#line 423 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	g_return_val_if_fail (event_id != NULL, NULL);
#line 425 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp0_ = database_table_db;
#line 425 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp2_ = sqlite3_prepare_v2 (_tmp0_, "SELECT id FROM VideoTable WHERE event_id = ?", -1, &_tmp1_, NULL);
#line 425 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 425 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	stmt = _tmp1_;
#line 425 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	res = _tmp2_;
#line 426 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp3_ = res;
#line 426 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	g_assert (_tmp3_ == SQLITE_OK);
#line 428 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp4_ = stmt;
#line 428 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp5_ = *event_id;
#line 428 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp6_ = _tmp5_.id;
#line 428 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp7_ = sqlite3_bind_int64 (_tmp4_, 1, _tmp6_);
#line 428 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	res = _tmp7_;
#line 429 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp8_ = res;
#line 429 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	g_assert (_tmp8_ == SQLITE_OK);
#line 431 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp9_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, NULL);
#line 431 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_result_ = _tmp9_;
#line 2870 "VideoTable.c"
	{
		gboolean _tmp10_;
#line 432 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		_tmp10_ = TRUE;
#line 432 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		while (TRUE) {
#line 2877 "VideoTable.c"
			gboolean _tmp11_;
			sqlite3_stmt* _tmp12_;
			gint _tmp13_ = 0;
			gint _tmp14_;
			GeeArrayList* _tmp17_;
			sqlite3_stmt* _tmp18_;
			gint64 _tmp19_ = 0LL;
			VideoID _tmp20_ = {0};
			gchar* _tmp21_ = NULL;
			gchar* _tmp22_;
#line 432 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
			_tmp11_ = _tmp10_;
#line 432 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
			if (!_tmp11_) {
#line 2892 "VideoTable.c"
			}
#line 432 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
			_tmp10_ = FALSE;
#line 433 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
			_tmp12_ = stmt;
#line 433 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
			_tmp13_ = sqlite3_step (_tmp12_);
#line 433 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
			res = _tmp13_;
#line 434 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
			_tmp14_ = res;
#line 434 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
			if (_tmp14_ == SQLITE_DONE) {
#line 435 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
				break;
#line 2908 "VideoTable.c"
			} else {
				gint _tmp15_;
#line 436 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
				_tmp15_ = res;
#line 436 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
				if (_tmp15_ != SQLITE_ROW) {
#line 2915 "VideoTable.c"
					gint _tmp16_;
#line 437 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
					_tmp16_ = res;
#line 437 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
					database_table_fatal ("get_event_source_ids", _tmp16_);
#line 439 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
					break;
#line 2923 "VideoTable.c"
				}
			}
#line 442 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
			_tmp17_ = _result_;
#line 442 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
			_tmp18_ = stmt;
#line 442 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
			_tmp19_ = sqlite3_column_int64 (_tmp18_, 0);
#line 442 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
			video_id_init (&_tmp20_, _tmp19_);
#line 442 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
			_tmp21_ = video_id_upgrade_video_id_to_source_id (&_tmp20_);
#line 442 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
			_tmp22_ = _tmp21_;
#line 442 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
			gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (_tmp17_), _tmp22_);
#line 442 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
			_g_free0 (_tmp22_);
#line 2942 "VideoTable.c"
		}
	}
#line 445 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	result = _result_;
#line 445 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_sqlite3_finalize0 (stmt);
#line 445 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	return result;
#line 2951 "VideoTable.c"
}


void video_table_set_timestamp (VideoTable* self, VideoID* video_id, time_t timestamp, GError** error) {
	VideoID _tmp0_;
	gint64 _tmp1_;
	time_t _tmp2_;
	GError * _inner_error_ = NULL;
#line 448 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	g_return_if_fail (IS_VIDEO_TABLE (self));
#line 448 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	g_return_if_fail (video_id != NULL);
#line 449 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp0_ = *video_id;
#line 449 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp1_ = _tmp0_.id;
#line 449 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	_tmp2_ = timestamp;
#line 449 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	database_table_update_int64_by_id_2 (DATABASE_TABLE (self), _tmp1_, "timestamp", (gint64) _tmp2_, &_inner_error_);
#line 449 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	if (_inner_error_ != NULL) {
#line 449 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
		if (_inner_error_->domain == DATABASE_ERROR) {
#line 449 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
			g_propagate_error (error, _inner_error_);
#line 449 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
			return;
#line 2980 "VideoTable.c"
		} else {
#line 449 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 449 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
			g_clear_error (&_inner_error_);
#line 449 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
			return;
#line 2988 "VideoTable.c"
		}
	}
}


static void video_table_class_init (VideoTableClass * klass) {
#line 58 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	video_table_parent_class = g_type_class_peek_parent (klass);
#line 58 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	DATABASE_TABLE_CLASS (klass)->finalize = video_table_finalize;
#line 2999 "VideoTable.c"
}


static void video_table_instance_init (VideoTable * self) {
}


static void video_table_finalize (DatabaseTable* obj) {
	VideoTable * self;
#line 58 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	self = VIDEO_TABLE (obj);
#line 58 "/builddir/build/BUILD/shotwell-0.10.1/src/db/VideoTable.vala"
	DATABASE_TABLE_CLASS (video_table_parent_class)->finalize (obj);
#line 3013 "VideoTable.c"
}


GType video_table_get_type (void) {
	static volatile gsize video_table_type_id__volatile = 0;
	if (g_once_init_enter (&video_table_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (VideoTableClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) video_table_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (VideoTable), 0, (GInstanceInitFunc) video_table_instance_init, NULL };
		GType video_table_type_id;
		video_table_type_id = g_type_register_static (TYPE_DATABASE_TABLE, "VideoTable", &g_define_type_info, 0);
		g_once_init_leave (&video_table_type_id__volatile, video_table_type_id);
	}
	return video_table_type_id__volatile;
}



