/* Dimensions.c generated by valac 0.14.2, the Vala compiler
 * generated from Dimensions.vala, do not modify */

/* Copyright 2009-2011 Yorba Foundation
 *
 * This software is licensed under the GNU LGPL (version 2.1 or later).
 * See the COPYING file in this distribution. 
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include <gdk-pixbuf/gdk-pixdata.h>
#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <float.h>
#include <math.h>


#define TYPE_SCALE_CONSTRAINT (scale_constraint_get_type ())

#define TYPE_DIMENSIONS (dimensions_get_type ())
typedef struct _Dimensions Dimensions;

#define TYPE_SCALING (scaling_get_type ())
typedef struct _Scaling Scaling;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

#define TYPE_ZOOM_STATE (zoom_state_get_type ())
typedef struct _ZoomState ZoomState;

typedef enum  {
	SCALE_CONSTRAINT_ORIGINAL,
	SCALE_CONSTRAINT_DIMENSIONS,
	SCALE_CONSTRAINT_WIDTH,
	SCALE_CONSTRAINT_HEIGHT,
	SCALE_CONSTRAINT_FILL_VIEWPORT
} ScaleConstraint;

struct _Dimensions {
	gint width;
	gint height;
};

struct _Scaling {
	ScaleConstraint constraint;
	gint scale;
	Dimensions viewport;
	gboolean scale_up;
};

struct _ZoomState {
	Dimensions content_dimensions;
	Dimensions viewport_dimensions;
	gdouble zoom_factor;
	gdouble interpolation_factor;
	gdouble min_factor;
	gdouble max_factor;
	GdkPoint viewport_center;
};



GType scale_constraint_get_type (void) G_GNUC_CONST;
gchar* scale_constraint_to_string (ScaleConstraint self);
GType dimensions_get_type (void) G_GNUC_CONST;
Dimensions* dimensions_dup (const Dimensions* self);
void dimensions_free (Dimensions* self);
void dimensions_init (Dimensions *self, gint width, gint height);
void dimensions_for_pixbuf (GdkPixbuf* pixbuf, Dimensions* result);
void dimensions_for_allocation (GtkAllocation* allocation, Dimensions* result);
void dimensions_for_rectangle (GdkRectangle* rect, Dimensions* result);
gboolean dimensions_has_area (Dimensions *self);
void dimensions_floor (Dimensions *self, Dimensions* min, Dimensions* result);
gchar* dimensions_to_string (Dimensions *self);
gboolean dimensions_equals (Dimensions *self, Dimensions* dim);
gboolean dimensions_approx_equals (Dimensions *self, Dimensions* dim, gint fudge);
gboolean dimensions_approx_scaled (Dimensions *self, gint scale, gint fudge);
gint dimensions_major_axis (Dimensions *self);
gint dimensions_minor_axis (Dimensions *self);
void dimensions_with_min (Dimensions *self, gint min_width, gint min_height, Dimensions* result);
void dimensions_get_scaled (Dimensions *self, gint scale, gboolean scale_up, Dimensions* result);
void dimensions_get_scaled_by_width (Dimensions *self, gint scale, Dimensions* result);
void dimensions_get_scaled_by_height (Dimensions *self, gint scale, Dimensions* result);
void dimensions_get_scale_ratios (Dimensions *self, Dimensions* scaled, gdouble* width_ratio, gdouble* height_ratio);
gdouble dimensions_get_aspect_ratio (Dimensions *self);
void dimensions_get_scaled_proportional (Dimensions *self, Dimensions* viewport, Dimensions* result);
void dimensions_get_scaled_to_fill_viewport (Dimensions *self, Dimensions* viewport, Dimensions* result);
void dimensions_get_scaled_rectangle (Dimensions *self, Dimensions* scaled, GdkRectangle* rect, GdkRectangle* result);
void dimensions_get_scaled_similar (Dimensions *self, Dimensions* original, Dimensions* scaled, Dimensions* result);
void dimensions_get_scaled_by_constraint (Dimensions *self, gint scale, ScaleConstraint constraint, Dimensions* result);
GType scaling_get_type (void) G_GNUC_CONST;
Scaling* scaling_dup (const Scaling* self);
void scaling_free (Scaling* self);
#define SCALING_NO_SCALE 0
static void scaling_init (Scaling *self, ScaleConstraint constraint, gint scale, Dimensions* viewport, gboolean scale_up);
void scaling_for_original (Scaling* result);
void scaling_for_screen (GtkWindow* window, gboolean scale_up, Scaling* result);
void scaling_for_viewport (Dimensions* viewport, gboolean scale_up, Scaling* result);
static void scaling_get_screen_dimensions (GtkWindow* window, Dimensions* result);
void scaling_for_best_fit (gint pixels, gboolean scale_up, Scaling* result);
void scaling_for_widget (GtkWidget* widget, gboolean scale_up, Scaling* result);
void scaling_to_fill_viewport (Dimensions* viewport, Scaling* result);
void scaling_to_fill_screen (GtkWindow* window, Scaling* result);
void scaling_for_constraint (ScaleConstraint constraint, gint scale, gboolean scale_up, Scaling* result);
static gint scaling_scale_to_pixels (Scaling *self);
gboolean scaling_is_unscaled (Scaling *self);
gboolean scaling_is_best_fit (Scaling *self, Dimensions* original, gint* pixels);
gboolean scaling_is_best_fit_dimensions (Scaling *self, Dimensions* original, Dimensions* scaled);
gboolean scaling_is_for_viewport (Scaling *self, Dimensions* original, Dimensions* scaled);
gboolean scaling_is_fill_viewport (Scaling *self, Dimensions* original, Dimensions* scaled);
void scaling_get_scaled_dimensions (Scaling *self, Dimensions* original, Dimensions* result);
GdkPixbuf* scaling_perform_on_pixbuf (Scaling *self, GdkPixbuf* pixbuf, GdkInterpType interp, gboolean scale_up);
GdkPixbuf* scale_pixbuf (GdkPixbuf* pixbuf, gint scale, GdkInterpType interp, gboolean scale_up);
GdkPixbuf* resize_pixbuf (GdkPixbuf* pixbuf, Dimensions* resized, GdkInterpType interp);
gchar* scaling_to_string (Scaling *self);
gboolean scaling_equals (Scaling *self, Scaling* scaling);
GType zoom_state_get_type (void) G_GNUC_CONST;
ZoomState* zoom_state_dup (const ZoomState* self);
void zoom_state_free (ZoomState* self);
void zoom_state_init (ZoomState *self, Dimensions* content_dimensions, Dimensions* viewport_dimensions, gdouble slider_val, GdkPoint* viewport_center);
static void zoom_state_compute_zoom_factors (ZoomState *self);
static void zoom_state_center_viewport (ZoomState *self);
static void zoom_state_clamp_viewport_center (ZoomState *self);
void zoom_state_init_rescale (ZoomState *self, ZoomState* existing, gdouble new_slider_val);
void zoom_state_init_rescale_to_isomorphic (ZoomState *self, ZoomState* existing);
void zoom_state_init_pan (ZoomState *self, ZoomState* existing, GdkPoint* new_viewport_center);
gint zoom_state_get_zoomed_width (ZoomState *self);
gint zoom_state_get_zoomed_height (ZoomState *self);
gdouble zoom_state_get_interpolation_factor (ZoomState *self);
void zoom_state_get_viewing_rectangle_wrt_content (ZoomState *self, GdkRectangle* result);
void zoom_state_get_viewing_rectangle_wrt_screen (ZoomState *self, GdkRectangle* result);
void zoom_state_get_viewing_rectangle_projection (ZoomState *self, GdkPixbuf* for_pixbuf, GdkRectangle* result);
gdouble zoom_state_get_zoom_factor (ZoomState *self);
void zoom_state_get_viewport_center (ZoomState *self, GdkPoint* result);
gchar* zoom_state_to_string (ZoomState *self);
gboolean zoom_state_is_min (ZoomState *self);
gboolean zoom_state_is_default (ZoomState *self);
gboolean zoom_state_is_isomorphic (ZoomState *self);
gboolean zoom_state_is_max (ZoomState *self);
gboolean zoom_state_equals (ZoomState *self, ZoomState* other);


gchar* scale_constraint_to_string (ScaleConstraint self) {
	gchar* result = NULL;
#line 15 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	switch (self) {
#line 15 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		case SCALE_CONSTRAINT_ORIGINAL:
#line 154 "Dimensions.c"
		{
			const gchar* _tmp0_ = NULL;
			gchar* _tmp1_;
#line 17 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
			_tmp0_ = _ ("Original size");
#line 17 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
			_tmp1_ = g_strdup (_tmp0_);
#line 17 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
			result = _tmp1_;
#line 17 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
			return result;
#line 166 "Dimensions.c"
		}
#line 15 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		case SCALE_CONSTRAINT_DIMENSIONS:
#line 170 "Dimensions.c"
		{
			const gchar* _tmp2_ = NULL;
			gchar* _tmp3_;
#line 20 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
			_tmp2_ = _ ("Width or height");
#line 20 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
			_tmp3_ = g_strdup (_tmp2_);
#line 20 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
			result = _tmp3_;
#line 20 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
			return result;
#line 182 "Dimensions.c"
		}
#line 15 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		case SCALE_CONSTRAINT_WIDTH:
#line 186 "Dimensions.c"
		{
			const gchar* _tmp4_ = NULL;
			gchar* _tmp5_;
#line 23 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
			_tmp4_ = _ ("Width");
#line 23 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
			_tmp5_ = g_strdup (_tmp4_);
#line 23 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
			result = _tmp5_;
#line 23 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
			return result;
#line 198 "Dimensions.c"
		}
#line 15 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		case SCALE_CONSTRAINT_HEIGHT:
#line 202 "Dimensions.c"
		{
			const gchar* _tmp6_ = NULL;
			gchar* _tmp7_;
#line 26 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
			_tmp6_ = _ ("Height");
#line 26 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
			_tmp7_ = g_strdup (_tmp6_);
#line 26 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
			result = _tmp7_;
#line 26 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
			return result;
#line 214 "Dimensions.c"
		}
#line 15 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		case SCALE_CONSTRAINT_FILL_VIEWPORT:
#line 218 "Dimensions.c"
		{
			gchar* _tmp8_;
#line 30 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
			_tmp8_ = g_strdup ("Fill Viewport");
#line 30 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
			result = _tmp8_;
#line 30 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
			return result;
#line 227 "Dimensions.c"
		}
		default:
#line 15 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		break;
#line 232 "Dimensions.c"
	}
#line 33 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	g_warn_if_reached ();
#line 35 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	result = NULL;
#line 35 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	return result;
#line 240 "Dimensions.c"
}


GType scale_constraint_get_type (void) {
	static volatile gsize scale_constraint_type_id__volatile = 0;
	if (g_once_init_enter (&scale_constraint_type_id__volatile)) {
		static const GEnumValue values[] = {{SCALE_CONSTRAINT_ORIGINAL, "SCALE_CONSTRAINT_ORIGINAL", "original"}, {SCALE_CONSTRAINT_DIMENSIONS, "SCALE_CONSTRAINT_DIMENSIONS", "dimensions"}, {SCALE_CONSTRAINT_WIDTH, "SCALE_CONSTRAINT_WIDTH", "width"}, {SCALE_CONSTRAINT_HEIGHT, "SCALE_CONSTRAINT_HEIGHT", "height"}, {SCALE_CONSTRAINT_FILL_VIEWPORT, "SCALE_CONSTRAINT_FILL_VIEWPORT", "fill-viewport"}, {0, NULL, NULL}};
		GType scale_constraint_type_id;
		scale_constraint_type_id = g_enum_register_static ("ScaleConstraint", values);
		g_once_init_leave (&scale_constraint_type_id__volatile, scale_constraint_type_id);
	}
	return scale_constraint_type_id__volatile;
}


void dimensions_init (Dimensions *self, gint width, gint height) {
	gboolean _tmp0_ = FALSE;
	gint _tmp1_;
	gboolean _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
#line 43 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	memset (self, 0, sizeof (Dimensions));
#line 44 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp1_ = width;
#line 44 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	if (_tmp1_ >= 0) {
#line 268 "Dimensions.c"
		gint _tmp2_;
#line 44 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp2_ = height;
#line 44 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp0_ = _tmp2_ >= 0;
#line 274 "Dimensions.c"
	} else {
#line 44 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp0_ = FALSE;
#line 278 "Dimensions.c"
	}
#line 44 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp3_ = _tmp0_;
#line 44 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	g_assert (_tmp3_);
#line 46 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp4_ = width;
#line 46 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	(*self).width = _tmp4_;
#line 47 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp5_ = height;
#line 47 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	(*self).height = _tmp5_;
#line 292 "Dimensions.c"
}


void dimensions_for_pixbuf (GdkPixbuf* pixbuf, Dimensions* result) {
	GdkPixbuf* _tmp0_;
	gint _tmp1_ = 0;
	GdkPixbuf* _tmp2_;
	gint _tmp3_ = 0;
	Dimensions _tmp4_ = {0};
#line 50 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	g_return_if_fail (GDK_IS_PIXBUF (pixbuf));
#line 51 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp0_ = pixbuf;
#line 51 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp1_ = gdk_pixbuf_get_width (_tmp0_);
#line 51 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp2_ = pixbuf;
#line 51 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp3_ = gdk_pixbuf_get_height (_tmp2_);
#line 51 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	dimensions_init (&_tmp4_, _tmp1_, _tmp3_);
#line 51 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	*result = _tmp4_;
#line 51 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	return;
#line 318 "Dimensions.c"
}


void dimensions_for_allocation (GtkAllocation* allocation, Dimensions* result) {
	GtkAllocation _tmp0_;
	gint _tmp1_;
	GtkAllocation _tmp2_;
	gint _tmp3_;
	Dimensions _tmp4_ = {0};
#line 54 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	g_return_if_fail (allocation != NULL);
#line 55 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp0_ = *allocation;
#line 55 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp1_ = _tmp0_.width;
#line 55 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp2_ = *allocation;
#line 55 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp3_ = _tmp2_.height;
#line 55 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	dimensions_init (&_tmp4_, _tmp1_, _tmp3_);
#line 55 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	*result = _tmp4_;
#line 55 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	return;
#line 344 "Dimensions.c"
}


void dimensions_for_rectangle (GdkRectangle* rect, Dimensions* result) {
	GdkRectangle _tmp0_;
	gint _tmp1_;
	GdkRectangle _tmp2_;
	gint _tmp3_;
	Dimensions _tmp4_ = {0};
#line 58 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	g_return_if_fail (rect != NULL);
#line 59 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp0_ = *rect;
#line 59 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp1_ = _tmp0_.width;
#line 59 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp2_ = *rect;
#line 59 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp3_ = _tmp2_.height;
#line 59 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	dimensions_init (&_tmp4_, _tmp1_, _tmp3_);
#line 59 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	*result = _tmp4_;
#line 59 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	return;
#line 370 "Dimensions.c"
}


gboolean dimensions_has_area (Dimensions *self) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gint _tmp1_;
	gboolean _tmp3_;
#line 63 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp1_ = (*self).width;
#line 63 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	if (_tmp1_ > 0) {
#line 383 "Dimensions.c"
		gint _tmp2_;
#line 63 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp2_ = (*self).height;
#line 63 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp0_ = _tmp2_ > 0;
#line 389 "Dimensions.c"
	} else {
#line 63 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp0_ = FALSE;
#line 393 "Dimensions.c"
	}
#line 63 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp3_ = _tmp0_;
#line 63 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	result = _tmp3_;
#line 63 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	return result;
#line 401 "Dimensions.c"
}


void dimensions_floor (Dimensions *self, Dimensions* min, Dimensions* result) {
	gint _tmp0_ = 0;
	gint _tmp1_;
	Dimensions _tmp2_;
	gint _tmp3_;
	gint _tmp7_ = 0;
	gint _tmp8_;
	Dimensions _tmp9_;
	gint _tmp10_;
	gint _tmp14_;
	gint _tmp15_;
	Dimensions _tmp16_ = {0};
#line 66 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	g_return_if_fail (min != NULL);
#line 67 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp1_ = (*self).width;
#line 67 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp2_ = *min;
#line 67 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp3_ = _tmp2_.width;
#line 67 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	if (_tmp1_ > _tmp3_) {
#line 427 "Dimensions.c"
		gint _tmp4_;
#line 67 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp4_ = (*self).width;
#line 67 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp0_ = _tmp4_;
#line 433 "Dimensions.c"
	} else {
		Dimensions _tmp5_;
		gint _tmp6_;
#line 67 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp5_ = *min;
#line 67 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp6_ = _tmp5_.width;
#line 67 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp0_ = _tmp6_;
#line 443 "Dimensions.c"
	}
#line 68 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp8_ = (*self).height;
#line 68 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp9_ = *min;
#line 68 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp10_ = _tmp9_.height;
#line 68 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	if (_tmp8_ > _tmp10_) {
#line 453 "Dimensions.c"
		gint _tmp11_;
#line 68 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp11_ = (*self).height;
#line 68 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp7_ = _tmp11_;
#line 459 "Dimensions.c"
	} else {
		Dimensions _tmp12_;
		gint _tmp13_;
#line 68 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp12_ = *min;
#line 68 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp13_ = _tmp12_.height;
#line 68 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp7_ = _tmp13_;
#line 469 "Dimensions.c"
	}
#line 67 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp14_ = _tmp0_;
#line 67 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp15_ = _tmp7_;
#line 67 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	dimensions_init (&_tmp16_, _tmp14_, _tmp15_);
#line 67 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	*result = _tmp16_;
#line 67 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	return;
#line 481 "Dimensions.c"
}


gchar* dimensions_to_string (Dimensions *self) {
	gchar* result = NULL;
	gint _tmp0_;
	gint _tmp1_;
	gchar* _tmp2_ = NULL;
#line 72 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp0_ = (*self).width;
#line 72 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp1_ = (*self).height;
#line 72 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp2_ = g_strdup_printf ("%dx%d", _tmp0_, _tmp1_);
#line 72 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	result = _tmp2_;
#line 72 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	return result;
#line 500 "Dimensions.c"
}


gboolean dimensions_equals (Dimensions *self, Dimensions* dim) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gint _tmp1_;
	Dimensions _tmp2_;
	gint _tmp3_;
	gboolean _tmp7_;
#line 75 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	g_return_val_if_fail (dim != NULL, FALSE);
#line 76 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp1_ = (*self).width;
#line 76 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp2_ = *dim;
#line 76 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp3_ = _tmp2_.width;
#line 76 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	if (_tmp1_ == _tmp3_) {
#line 521 "Dimensions.c"
		gint _tmp4_;
		Dimensions _tmp5_;
		gint _tmp6_;
#line 76 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp4_ = (*self).height;
#line 76 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp5_ = *dim;
#line 76 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp6_ = _tmp5_.height;
#line 76 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp0_ = _tmp4_ == _tmp6_;
#line 533 "Dimensions.c"
	} else {
#line 76 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp0_ = FALSE;
#line 537 "Dimensions.c"
	}
#line 76 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp7_ = _tmp0_;
#line 76 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	result = _tmp7_;
#line 76 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	return result;
#line 545 "Dimensions.c"
}


gboolean dimensions_approx_equals (Dimensions *self, Dimensions* dim, gint fudge) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gint _tmp1_;
	Dimensions _tmp2_;
	gint _tmp3_;
	gint _tmp4_ = 0;
	gint _tmp5_;
	gboolean _tmp11_;
#line 80 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	g_return_val_if_fail (dim != NULL, FALSE);
#line 81 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp1_ = (*self).width;
#line 81 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp2_ = *dim;
#line 81 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp3_ = _tmp2_.width;
#line 81 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp4_ = abs (_tmp1_ - _tmp3_);
#line 81 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp5_ = fudge;
#line 81 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	if (_tmp4_ <= _tmp5_) {
#line 572 "Dimensions.c"
		gint _tmp6_;
		Dimensions _tmp7_;
		gint _tmp8_;
		gint _tmp9_ = 0;
		gint _tmp10_;
#line 81 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp6_ = (*self).height;
#line 81 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp7_ = *dim;
#line 81 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp8_ = _tmp7_.height;
#line 81 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp9_ = abs (_tmp6_ - _tmp8_);
#line 81 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp10_ = fudge;
#line 81 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp0_ = _tmp9_ <= _tmp10_;
#line 590 "Dimensions.c"
	} else {
#line 81 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp0_ = FALSE;
#line 594 "Dimensions.c"
	}
#line 81 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp11_ = _tmp0_;
#line 81 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	result = _tmp11_;
#line 81 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	return result;
#line 602 "Dimensions.c"
}


gboolean dimensions_approx_scaled (Dimensions *self, gint scale, gint fudge) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gint _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	gboolean _tmp7_;
#line 85 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp1_ = (*self).width;
#line 85 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp2_ = scale;
#line 85 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp3_ = fudge;
#line 85 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	if (_tmp1_ <= (_tmp2_ + _tmp3_)) {
#line 621 "Dimensions.c"
		gint _tmp4_;
		gint _tmp5_;
		gint _tmp6_;
#line 85 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp4_ = (*self).height;
#line 85 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp5_ = scale;
#line 85 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp6_ = fudge;
#line 85 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp0_ = _tmp4_ <= (_tmp5_ + _tmp6_);
#line 633 "Dimensions.c"
	} else {
#line 85 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp0_ = FALSE;
#line 637 "Dimensions.c"
	}
#line 85 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp7_ = _tmp0_;
#line 85 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	result = _tmp7_;
#line 85 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	return result;
#line 645 "Dimensions.c"
}


gint dimensions_major_axis (Dimensions *self) {
	gint result = 0;
	gint _tmp0_;
	gint _tmp1_;
	gint _tmp2_ = 0;
#line 89 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp0_ = (*self).width;
#line 89 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp1_ = (*self).height;
#line 89 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp2_ = MAX (_tmp0_, _tmp1_);
#line 89 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	result = _tmp2_;
#line 89 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	return result;
#line 664 "Dimensions.c"
}


gint dimensions_minor_axis (Dimensions *self) {
	gint result = 0;
	gint _tmp0_;
	gint _tmp1_;
	gint _tmp2_ = 0;
#line 93 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp0_ = (*self).width;
#line 93 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp1_ = (*self).height;
#line 93 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp2_ = MIN (_tmp0_, _tmp1_);
#line 93 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	result = _tmp2_;
#line 93 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	return result;
#line 683 "Dimensions.c"
}


void dimensions_with_min (Dimensions *self, gint min_width, gint min_height, Dimensions* result) {
	Dimensions min = {0};
	gint _tmp0_ = 0;
	gint _tmp1_;
	gint _tmp2_;
	gint _tmp5_;
	gint _tmp6_ = 0;
	gint _tmp7_;
	gint _tmp8_;
	gint _tmp11_;
#line 97 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	dimensions_init (&min, 0, 0);
#line 98 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp1_ = (*self).width;
#line 98 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp2_ = min_width;
#line 98 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	if (_tmp1_ > _tmp2_) {
#line 705 "Dimensions.c"
		gint _tmp3_;
#line 98 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp3_ = (*self).width;
#line 98 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp0_ = _tmp3_;
#line 711 "Dimensions.c"
	} else {
		gint _tmp4_;
#line 98 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp4_ = min_width;
#line 98 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp0_ = _tmp4_;
#line 718 "Dimensions.c"
	}
#line 98 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp5_ = _tmp0_;
#line 98 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	min.width = _tmp5_;
#line 99 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp7_ = (*self).height;
#line 99 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp8_ = min_height;
#line 99 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	if (_tmp7_ > _tmp8_) {
#line 730 "Dimensions.c"
		gint _tmp9_;
#line 99 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp9_ = (*self).height;
#line 99 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp6_ = _tmp9_;
#line 736 "Dimensions.c"
	} else {
		gint _tmp10_;
#line 99 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp10_ = min_height;
#line 99 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp6_ = _tmp10_;
#line 743 "Dimensions.c"
	}
#line 99 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp11_ = _tmp6_;
#line 99 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	min.height = _tmp11_;
#line 101 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	*result = min;
#line 101 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	return;
#line 753 "Dimensions.c"
}


void dimensions_get_scaled (Dimensions *self, gint scale, gboolean scale_up, Dimensions* result) {
	gint _tmp0_;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gint _tmp3_;
	gint _tmp4_;
	gboolean _tmp7_;
	gboolean _tmp14_;
	gboolean _tmp18_ = FALSE;
	gboolean _tmp19_;
	gboolean _tmp26_;
	gint _tmp30_;
	gint _tmp31_;
	gint _tmp32_;
	gint _tmp33_;
#line 105 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp0_ = scale;
#line 105 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	g_assert (_tmp0_ > 0);
#line 108 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp3_ = (*self).width;
#line 108 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp4_ = scale;
#line 108 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	if (_tmp3_ == _tmp4_) {
#line 782 "Dimensions.c"
		gint _tmp5_;
		gint _tmp6_;
#line 108 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp5_ = (*self).height;
#line 108 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp6_ = scale;
#line 108 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp2_ = _tmp5_ < _tmp6_;
#line 791 "Dimensions.c"
	} else {
#line 108 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp2_ = FALSE;
#line 795 "Dimensions.c"
	}
#line 108 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp7_ = _tmp2_;
#line 108 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	if (_tmp7_) {
#line 108 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp1_ = TRUE;
#line 803 "Dimensions.c"
	} else {
		gboolean _tmp8_ = FALSE;
		gint _tmp9_;
		gint _tmp10_;
		gboolean _tmp13_;
#line 108 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp9_ = (*self).height;
#line 108 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp10_ = scale;
#line 108 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		if (_tmp9_ == _tmp10_) {
#line 815 "Dimensions.c"
			gint _tmp11_;
			gint _tmp12_;
#line 108 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
			_tmp11_ = (*self).width;
#line 108 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
			_tmp12_ = scale;
#line 108 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
			_tmp8_ = _tmp11_ < _tmp12_;
#line 824 "Dimensions.c"
		} else {
#line 108 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
			_tmp8_ = FALSE;
#line 828 "Dimensions.c"
		}
#line 108 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp13_ = _tmp8_;
#line 108 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp1_ = _tmp13_;
#line 834 "Dimensions.c"
	}
#line 108 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp14_ = _tmp1_;
#line 108 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	if (_tmp14_) {
#line 840 "Dimensions.c"
		gint _tmp15_;
		gint _tmp16_;
		Dimensions _tmp17_ = {0};
#line 109 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp15_ = (*self).width;
#line 109 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp16_ = (*self).height;
#line 109 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		dimensions_init (&_tmp17_, _tmp15_, _tmp16_);
#line 109 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		*result = _tmp17_;
#line 109 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		return;
#line 854 "Dimensions.c"
	}
#line 112 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp19_ = scale_up;
#line 112 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	if (!_tmp19_) {
#line 860 "Dimensions.c"
		gboolean _tmp20_ = FALSE;
		gint _tmp21_;
		gint _tmp22_;
		gboolean _tmp25_;
#line 112 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp21_ = (*self).width;
#line 112 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp22_ = scale;
#line 112 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		if (_tmp21_ < _tmp22_) {
#line 871 "Dimensions.c"
			gint _tmp23_;
			gint _tmp24_;
#line 112 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
			_tmp23_ = (*self).height;
#line 112 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
			_tmp24_ = scale;
#line 112 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
			_tmp20_ = _tmp23_ < _tmp24_;
#line 880 "Dimensions.c"
		} else {
#line 112 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
			_tmp20_ = FALSE;
#line 884 "Dimensions.c"
		}
#line 112 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp25_ = _tmp20_;
#line 112 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp18_ = _tmp25_;
#line 890 "Dimensions.c"
	} else {
#line 112 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp18_ = FALSE;
#line 894 "Dimensions.c"
	}
#line 112 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp26_ = _tmp18_;
#line 112 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	if (_tmp26_) {
#line 900 "Dimensions.c"
		gint _tmp27_;
		gint _tmp28_;
		Dimensions _tmp29_ = {0};
#line 113 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp27_ = (*self).width;
#line 113 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp28_ = (*self).height;
#line 113 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		dimensions_init (&_tmp29_, _tmp27_, _tmp28_);
#line 113 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		*result = _tmp29_;
#line 113 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		return;
#line 914 "Dimensions.c"
	}
#line 115 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp30_ = (*self).width;
#line 115 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp31_ = scale;
#line 115 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp32_ = (*self).height;
#line 115 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp33_ = scale;
#line 115 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	if ((_tmp30_ - _tmp31_) > (_tmp32_ - _tmp33_)) {
#line 926 "Dimensions.c"
		gint _tmp34_;
		Dimensions _tmp35_ = {0};
#line 116 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp34_ = scale;
#line 116 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		dimensions_get_scaled_by_width (&(*self), _tmp34_, &_tmp35_);
#line 116 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		*result = _tmp35_;
#line 116 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		return;
#line 937 "Dimensions.c"
	} else {
		gint _tmp36_;
		Dimensions _tmp37_ = {0};
#line 118 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp36_ = scale;
#line 118 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		dimensions_get_scaled_by_height (&(*self), _tmp36_, &_tmp37_);
#line 118 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		*result = _tmp37_;
#line 118 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		return;
#line 949 "Dimensions.c"
	}
}


void dimensions_get_scale_ratios (Dimensions *self, Dimensions* scaled, gdouble* width_ratio, gdouble* height_ratio) {
	gdouble _vala_width_ratio = 0.0;
	gdouble _vala_height_ratio = 0.0;
	Dimensions _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	Dimensions _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
#line 121 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	g_return_if_fail (scaled != NULL);
#line 122 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp0_ = *scaled;
#line 122 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp1_ = _tmp0_.width;
#line 122 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp2_ = (*self).width;
#line 122 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_vala_width_ratio = ((gdouble) _tmp1_) / ((gdouble) _tmp2_);
#line 123 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp3_ = *scaled;
#line 123 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp4_ = _tmp3_.height;
#line 123 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp5_ = (*self).height;
#line 123 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_vala_height_ratio = ((gdouble) _tmp4_) / ((gdouble) _tmp5_);
#line 121 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	if (width_ratio) {
#line 121 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		*width_ratio = _vala_width_ratio;
#line 985 "Dimensions.c"
	}
#line 121 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	if (height_ratio) {
#line 121 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		*height_ratio = _vala_height_ratio;
#line 991 "Dimensions.c"
	}
}


gdouble dimensions_get_aspect_ratio (Dimensions *self) {
	gdouble result = 0.0;
	gint _tmp0_;
	gint _tmp1_;
#line 127 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp0_ = (*self).width;
#line 127 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp1_ = (*self).height;
#line 127 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	result = ((gdouble) _tmp0_) / _tmp1_;
#line 127 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	return result;
#line 1008 "Dimensions.c"
}


void dimensions_get_scaled_proportional (Dimensions *self, Dimensions* viewport, Dimensions* result) {
	gdouble width_ratio = 0.0;
	gdouble height_ratio = 0.0;
	Dimensions _tmp0_;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble scaled_width = 0.0;
	gdouble scaled_height = 0.0;
	gdouble _tmp3_;
	gdouble _tmp4_;
	gdouble _tmp13_;
	gdouble _tmp14_ = 0.0;
	gdouble _tmp15_;
	gdouble _tmp16_ = 0.0;
	Dimensions _tmp17_ = {0};
	Dimensions _tmp18_ = {0};
	Dimensions _tmp19_ = {0};
	Dimensions scaled;
	Dimensions _tmp20_;
	gint _tmp21_;
	Dimensions _tmp22_;
	gint _tmp23_;
	Dimensions _tmp24_;
	gint _tmp25_;
	Dimensions _tmp26_;
	gint _tmp27_;
#line 130 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	g_return_if_fail (viewport != NULL);
#line 132 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp0_ = *viewport;
#line 132 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	dimensions_get_scale_ratios (&(*self), &_tmp0_, &_tmp1_, &_tmp2_);
#line 132 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	width_ratio = _tmp1_;
#line 132 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	height_ratio = _tmp2_;
#line 135 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp3_ = width_ratio;
#line 135 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp4_ = height_ratio;
#line 135 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	if (_tmp3_ < _tmp4_) {
#line 1054 "Dimensions.c"
		Dimensions _tmp5_;
		gint _tmp6_;
		gint _tmp7_;
		gdouble _tmp8_;
#line 136 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp5_ = *viewport;
#line 136 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp6_ = _tmp5_.width;
#line 136 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		scaled_width = (gdouble) _tmp6_;
#line 137 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp7_ = (*self).height;
#line 137 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp8_ = width_ratio;
#line 137 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		scaled_height = ((gdouble) _tmp7_) * _tmp8_;
#line 1071 "Dimensions.c"
	} else {
		gint _tmp9_;
		gdouble _tmp10_;
		Dimensions _tmp11_;
		gint _tmp12_;
#line 139 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp9_ = (*self).width;
#line 139 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp10_ = height_ratio;
#line 139 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		scaled_width = ((gdouble) _tmp9_) * _tmp10_;
#line 140 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp11_ = *viewport;
#line 140 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp12_ = _tmp11_.height;
#line 140 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		scaled_height = (gdouble) _tmp12_;
#line 1089 "Dimensions.c"
	}
#line 143 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp13_ = scaled_width;
#line 143 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp14_ = round (_tmp13_);
#line 143 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp15_ = scaled_height;
#line 143 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp16_ = round (_tmp15_);
#line 143 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	dimensions_init (&_tmp17_, (gint) _tmp14_, (gint) _tmp16_);
#line 143 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	dimensions_init (&_tmp18_, 1, 1);
#line 143 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	dimensions_floor (&_tmp17_, &_tmp18_, &_tmp19_);
#line 143 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	scaled = _tmp19_;
#line 145 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp20_ = scaled;
#line 145 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp21_ = _tmp20_.height;
#line 145 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp22_ = *viewport;
#line 145 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp23_ = _tmp22_.height;
#line 145 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	g_assert (_tmp21_ <= _tmp23_);
#line 146 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp24_ = scaled;
#line 146 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp25_ = _tmp24_.width;
#line 146 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp26_ = *viewport;
#line 146 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp27_ = _tmp26_.width;
#line 146 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	g_assert (_tmp25_ <= _tmp27_);
#line 148 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	*result = scaled;
#line 148 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	return;
#line 1131 "Dimensions.c"
}


void dimensions_get_scaled_to_fill_viewport (Dimensions *self, Dimensions* viewport, Dimensions* result) {
	gdouble width_ratio = 0.0;
	gdouble height_ratio = 0.0;
	Dimensions _tmp0_;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble scaled_width = 0.0;
	gdouble scaled_height = 0.0;
	gboolean _tmp3_ = FALSE;
	gint _tmp4_;
	Dimensions _tmp5_;
	gint _tmp6_;
	gboolean _tmp10_;
	gdouble _tmp34_;
	gdouble _tmp35_ = 0.0;
	gdouble _tmp36_;
	gdouble _tmp37_ = 0.0;
	Dimensions _tmp38_ = {0};
	Dimensions _tmp39_ = {0};
	Dimensions _tmp40_ = {0};
#line 151 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	g_return_if_fail (viewport != NULL);
#line 153 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp0_ = *viewport;
#line 153 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	dimensions_get_scale_ratios (&(*self), &_tmp0_, &_tmp1_, &_tmp2_);
#line 153 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	width_ratio = _tmp1_;
#line 153 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	height_ratio = _tmp2_;
#line 156 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp4_ = (*self).width;
#line 156 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp5_ = *viewport;
#line 156 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp6_ = _tmp5_.width;
#line 156 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	if (_tmp4_ < _tmp6_) {
#line 1173 "Dimensions.c"
		gint _tmp7_;
		Dimensions _tmp8_;
		gint _tmp9_;
#line 156 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp7_ = (*self).height;
#line 156 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp8_ = *viewport;
#line 156 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp9_ = _tmp8_.height;
#line 156 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp3_ = _tmp7_ >= _tmp9_;
#line 1185 "Dimensions.c"
	} else {
#line 156 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp3_ = FALSE;
#line 1189 "Dimensions.c"
	}
#line 156 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp10_ = _tmp3_;
#line 156 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	if (_tmp10_) {
#line 1195 "Dimensions.c"
		Dimensions _tmp11_;
		gint _tmp12_;
		gint _tmp13_;
		gdouble _tmp14_;
#line 158 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp11_ = *viewport;
#line 158 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp12_ = _tmp11_.width;
#line 158 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		scaled_width = (gdouble) _tmp12_;
#line 159 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp13_ = (*self).height;
#line 159 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp14_ = width_ratio;
#line 159 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		scaled_height = ((gdouble) _tmp13_) * _tmp14_;
#line 1212 "Dimensions.c"
	} else {
		gboolean _tmp15_ = FALSE;
		gint _tmp16_;
		Dimensions _tmp17_;
		gint _tmp18_;
		gboolean _tmp22_;
#line 160 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp16_ = (*self).width;
#line 160 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp17_ = *viewport;
#line 160 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp18_ = _tmp17_.width;
#line 160 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		if (_tmp16_ >= _tmp18_) {
#line 1227 "Dimensions.c"
			gint _tmp19_;
			Dimensions _tmp20_;
			gint _tmp21_;
#line 160 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
			_tmp19_ = (*self).height;
#line 160 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
			_tmp20_ = *viewport;
#line 160 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
			_tmp21_ = _tmp20_.height;
#line 160 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
			_tmp15_ = _tmp19_ < _tmp21_;
#line 1239 "Dimensions.c"
		} else {
#line 160 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
			_tmp15_ = FALSE;
#line 1243 "Dimensions.c"
		}
#line 160 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp22_ = _tmp15_;
#line 160 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		if (_tmp22_) {
#line 1249 "Dimensions.c"
			gint _tmp23_;
			gdouble _tmp24_;
			Dimensions _tmp25_;
			gint _tmp26_;
#line 162 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
			_tmp23_ = (*self).width;
#line 162 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
			_tmp24_ = height_ratio;
#line 162 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
			scaled_width = ((gdouble) _tmp23_) * _tmp24_;
#line 163 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
			_tmp25_ = *viewport;
#line 163 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
			_tmp26_ = _tmp25_.height;
#line 163 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
			scaled_height = (gdouble) _tmp26_;
#line 1266 "Dimensions.c"
		} else {
			gdouble _tmp27_;
			gdouble _tmp28_;
			gdouble _tmp29_ = 0.0;
			gdouble ratio;
			gint _tmp30_;
			gdouble _tmp31_;
			gint _tmp32_;
			gdouble _tmp33_;
#line 166 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
			_tmp27_ = width_ratio;
#line 166 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
			_tmp28_ = height_ratio;
#line 166 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
			_tmp29_ = MAX (_tmp27_, _tmp28_);
#line 166 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
			ratio = _tmp29_;
#line 168 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
			_tmp30_ = (*self).width;
#line 168 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
			_tmp31_ = ratio;
#line 168 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
			scaled_width = ((gdouble) _tmp30_) * _tmp31_;
#line 169 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
			_tmp32_ = (*self).height;
#line 169 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
			_tmp33_ = ratio;
#line 169 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
			scaled_height = ((gdouble) _tmp32_) * _tmp33_;
#line 1296 "Dimensions.c"
		}
	}
#line 172 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp34_ = scaled_width;
#line 172 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp35_ = round (_tmp34_);
#line 172 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp36_ = scaled_height;
#line 172 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp37_ = round (_tmp36_);
#line 172 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	dimensions_init (&_tmp38_, (gint) _tmp35_, (gint) _tmp37_);
#line 172 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	dimensions_init (&_tmp39_, 1, 1);
#line 172 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	dimensions_floor (&_tmp38_, &_tmp39_, &_tmp40_);
#line 172 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	*result = _tmp40_;
#line 172 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	return;
#line 1317 "Dimensions.c"
}


void dimensions_get_scaled_rectangle (Dimensions *self, Dimensions* scaled, GdkRectangle* rect, GdkRectangle* result) {
	gdouble x_scale = 0.0;
	gdouble y_scale = 0.0;
	Dimensions _tmp0_;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	GdkRectangle scaled_rect = {0};
	GdkRectangle _tmp3_;
	gint _tmp4_;
	gdouble _tmp5_;
	gdouble _tmp6_ = 0.0;
	GdkRectangle _tmp7_;
	gint _tmp8_;
	gdouble _tmp9_;
	gdouble _tmp10_ = 0.0;
	GdkRectangle _tmp11_;
	gint _tmp12_;
	gdouble _tmp13_;
	gdouble _tmp14_ = 0.0;
	GdkRectangle _tmp15_;
	gint _tmp16_;
	gdouble _tmp17_;
	gdouble _tmp18_ = 0.0;
	GdkRectangle _tmp19_;
	gint _tmp20_;
	GdkRectangle _tmp21_;
	gint _tmp22_;
#line 175 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	g_return_if_fail (scaled != NULL);
#line 175 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	g_return_if_fail (rect != NULL);
#line 177 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp0_ = *scaled;
#line 177 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	dimensions_get_scale_ratios (&(*self), &_tmp0_, &_tmp1_, &_tmp2_);
#line 177 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	x_scale = _tmp1_;
#line 177 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	y_scale = _tmp2_;
#line 179 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	memset (&scaled_rect, 0, sizeof (GdkRectangle));
#line 180 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp3_ = *rect;
#line 180 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp4_ = _tmp3_.x;
#line 180 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp5_ = x_scale;
#line 180 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp6_ = round (((gdouble) _tmp4_) * _tmp5_);
#line 180 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	scaled_rect.x = (gint) _tmp6_;
#line 181 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp7_ = *rect;
#line 181 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp8_ = _tmp7_.y;
#line 181 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp9_ = y_scale;
#line 181 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp10_ = round (((gdouble) _tmp8_) * _tmp9_);
#line 181 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	scaled_rect.y = (gint) _tmp10_;
#line 182 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp11_ = *rect;
#line 182 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp12_ = _tmp11_.width;
#line 182 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp13_ = x_scale;
#line 182 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp14_ = round (((gdouble) _tmp12_) * _tmp13_);
#line 182 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	scaled_rect.width = (gint) _tmp14_;
#line 183 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp15_ = *rect;
#line 183 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp16_ = _tmp15_.height;
#line 183 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp17_ = y_scale;
#line 183 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp18_ = round (((gdouble) _tmp16_) * _tmp17_);
#line 183 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	scaled_rect.height = (gint) _tmp18_;
#line 185 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp19_ = scaled_rect;
#line 185 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp20_ = _tmp19_.width;
#line 185 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	if (_tmp20_ <= 0) {
#line 186 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		scaled_rect.width = 1;
#line 1410 "Dimensions.c"
	}
#line 188 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp21_ = scaled_rect;
#line 188 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp22_ = _tmp21_.height;
#line 188 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	if (_tmp22_ <= 0) {
#line 189 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		scaled_rect.height = 1;
#line 1420 "Dimensions.c"
	}
#line 191 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	*result = scaled_rect;
#line 191 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	return;
#line 1426 "Dimensions.c"
}


void dimensions_get_scaled_similar (Dimensions *self, Dimensions* original, Dimensions* scaled, Dimensions* result) {
	gdouble x_scale = 0.0;
	gdouble y_scale = 0.0;
	Dimensions _tmp0_;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_ = 0.0;
	gdouble scale;
	gint _tmp4_;
	gdouble _tmp5_ = 0.0;
	gint _tmp6_;
	gdouble _tmp7_ = 0.0;
	Dimensions _tmp8_ = {0};
	Dimensions _tmp9_ = {0};
	Dimensions _tmp10_ = {0};
#line 195 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	g_return_if_fail (original != NULL);
#line 195 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	g_return_if_fail (scaled != NULL);
#line 197 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp0_ = *scaled;
#line 197 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	dimensions_get_scale_ratios (original, &_tmp0_, &_tmp1_, &_tmp2_);
#line 197 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	x_scale = _tmp1_;
#line 197 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	y_scale = _tmp2_;
#line 199 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp3_ = MIN (x_scale, y_scale);
#line 199 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	scale = _tmp3_;
#line 201 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp4_ = (*self).width;
#line 201 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp5_ = round (((gdouble) _tmp4_) * scale);
#line 201 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp6_ = (*self).height;
#line 201 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp7_ = round (((gdouble) _tmp6_) * scale);
#line 201 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	dimensions_init (&_tmp8_, (gint) _tmp5_, (gint) _tmp7_);
#line 201 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	dimensions_init (&_tmp9_, 1, 1);
#line 201 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	dimensions_floor (&_tmp8_, &_tmp9_, &_tmp10_);
#line 201 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	*result = _tmp10_;
#line 201 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	return;
#line 1479 "Dimensions.c"
}


void dimensions_get_scaled_by_width (Dimensions *self, gint scale, Dimensions* result) {
	gint _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gdouble ratio;
	gint _tmp3_;
	gint _tmp4_;
	gdouble _tmp5_ = 0.0;
	Dimensions _tmp6_ = {0};
	Dimensions _tmp7_ = {0};
	Dimensions _tmp8_ = {0};
#line 206 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp0_ = scale;
#line 206 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	g_assert (_tmp0_ > 0);
#line 208 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp1_ = scale;
#line 208 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp2_ = (*self).width;
#line 208 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	ratio = ((gdouble) _tmp1_) / ((gdouble) _tmp2_);
#line 210 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp3_ = scale;
#line 210 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp4_ = (*self).height;
#line 210 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp5_ = round (((gdouble) _tmp4_) * ratio);
#line 210 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	dimensions_init (&_tmp6_, _tmp3_, (gint) _tmp5_);
#line 210 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	dimensions_init (&_tmp7_, 1, 1);
#line 210 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	dimensions_floor (&_tmp6_, &_tmp7_, &_tmp8_);
#line 210 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	*result = _tmp8_;
#line 210 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	return;
#line 1520 "Dimensions.c"
}


void dimensions_get_scaled_by_height (Dimensions *self, gint scale, Dimensions* result) {
	gint _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gdouble ratio;
	gint _tmp3_;
	gdouble _tmp4_ = 0.0;
	gint _tmp5_;
	Dimensions _tmp6_ = {0};
	Dimensions _tmp7_ = {0};
	Dimensions _tmp8_ = {0};
#line 214 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp0_ = scale;
#line 214 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	g_assert (_tmp0_ > 0);
#line 216 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp1_ = scale;
#line 216 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp2_ = (*self).height;
#line 216 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	ratio = ((gdouble) _tmp1_) / ((gdouble) _tmp2_);
#line 218 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp3_ = (*self).width;
#line 218 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp4_ = round (((gdouble) _tmp3_) * ratio);
#line 218 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp5_ = scale;
#line 218 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	dimensions_init (&_tmp6_, (gint) _tmp4_, _tmp5_);
#line 218 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	dimensions_init (&_tmp7_, 1, 1);
#line 218 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	dimensions_floor (&_tmp6_, &_tmp7_, &_tmp8_);
#line 218 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	*result = _tmp8_;
#line 218 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	return;
#line 1561 "Dimensions.c"
}


void dimensions_get_scaled_by_constraint (Dimensions *self, gint scale, ScaleConstraint constraint, Dimensions* result) {
	ScaleConstraint _tmp0_;
#line 222 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp0_ = constraint;
#line 222 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	switch (_tmp0_) {
#line 222 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		case SCALE_CONSTRAINT_ORIGINAL:
#line 1573 "Dimensions.c"
		{
			gint _tmp1_;
			gint _tmp2_;
			Dimensions _tmp3_ = {0};
#line 224 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
			_tmp1_ = (*self).width;
#line 224 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
			_tmp2_ = (*self).height;
#line 224 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
			dimensions_init (&_tmp3_, _tmp1_, _tmp2_);
#line 224 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
			*result = _tmp3_;
#line 224 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
			return;
#line 1588 "Dimensions.c"
		}
#line 222 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		case SCALE_CONSTRAINT_DIMENSIONS:
#line 1592 "Dimensions.c"
		{
			Dimensions _tmp4_ = {0};
			gint _tmp5_;
			gint _tmp6_;
#line 227 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
			_tmp5_ = (*self).width;
#line 227 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
			_tmp6_ = (*self).height;
#line 227 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
			if (_tmp5_ >= _tmp6_) {
#line 1603 "Dimensions.c"
				gint _tmp7_;
				Dimensions _tmp8_ = {0};
#line 227 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
				_tmp7_ = scale;
#line 227 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
				dimensions_get_scaled_by_width (&(*self), _tmp7_, &_tmp8_);
#line 227 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
				_tmp4_ = _tmp8_;
#line 1612 "Dimensions.c"
			} else {
				gint _tmp9_;
				Dimensions _tmp10_ = {0};
#line 227 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
				_tmp9_ = scale;
#line 227 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
				dimensions_get_scaled_by_height (&(*self), _tmp9_, &_tmp10_);
#line 227 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
				_tmp4_ = _tmp10_;
#line 1622 "Dimensions.c"
			}
#line 227 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
			*result = _tmp4_;
#line 227 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
			return;
#line 1628 "Dimensions.c"
		}
#line 222 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		case SCALE_CONSTRAINT_WIDTH:
#line 1632 "Dimensions.c"
		{
			gint _tmp11_;
			Dimensions _tmp12_ = {0};
#line 230 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
			_tmp11_ = scale;
#line 230 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
			dimensions_get_scaled_by_width (&(*self), _tmp11_, &_tmp12_);
#line 230 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
			*result = _tmp12_;
#line 230 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
			return;
#line 1644 "Dimensions.c"
		}
#line 222 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		case SCALE_CONSTRAINT_HEIGHT:
#line 1648 "Dimensions.c"
		{
			gint _tmp13_;
			Dimensions _tmp14_ = {0};
#line 233 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
			_tmp13_ = scale;
#line 233 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
			dimensions_get_scaled_by_height (&(*self), _tmp13_, &_tmp14_);
#line 233 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
			*result = _tmp14_;
#line 233 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
			return;
#line 1660 "Dimensions.c"
		}
		default:
		{
			ScaleConstraint _tmp15_;
#line 236 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
			_tmp15_ = constraint;
#line 236 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
			g_error ("Dimensions.vala:236: Bad constraint: %d", (gint) _tmp15_);
#line 1669 "Dimensions.c"
		}
	}
}


Dimensions* dimensions_dup (const Dimensions* self) {
	Dimensions* dup;
#line 39 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	dup = g_new0 (Dimensions, 1);
#line 39 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	memcpy (dup, self, sizeof (Dimensions));
#line 39 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	return dup;
#line 1683 "Dimensions.c"
}


void dimensions_free (Dimensions* self) {
#line 39 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	g_free (self);
#line 1690 "Dimensions.c"
}


GType dimensions_get_type (void) {
	static volatile gsize dimensions_type_id__volatile = 0;
	if (g_once_init_enter (&dimensions_type_id__volatile)) {
		GType dimensions_type_id;
		dimensions_type_id = g_boxed_type_register_static ("Dimensions", (GBoxedCopyFunc) dimensions_dup, (GBoxedFreeFunc) dimensions_free);
		g_once_init_leave (&dimensions_type_id__volatile, dimensions_type_id);
	}
	return dimensions_type_id__volatile;
}


static void scaling_init (Scaling *self, ScaleConstraint constraint, gint scale, Dimensions* viewport, gboolean scale_up) {
	ScaleConstraint _tmp0_;
	gint _tmp1_;
	Dimensions _tmp2_;
	gboolean _tmp3_;
#line 249 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	g_return_if_fail (viewport != NULL);
#line 249 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	memset (self, 0, sizeof (Scaling));
#line 250 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp0_ = constraint;
#line 250 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	(*self).constraint = _tmp0_;
#line 251 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp1_ = scale;
#line 251 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	(*self).scale = _tmp1_;
#line 252 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp2_ = *viewport;
#line 252 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	(*self).viewport = _tmp2_;
#line 253 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp3_ = scale_up;
#line 253 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	(*self).scale_up = _tmp3_;
#line 1730 "Dimensions.c"
}


void scaling_for_original (Scaling* result) {
	Dimensions _tmp0_ = {0};
	Scaling _tmp1_ = {0};
#line 257 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	dimensions_init (&_tmp0_, 0, 0);
#line 257 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	scaling_init (&_tmp1_, SCALE_CONSTRAINT_ORIGINAL, SCALING_NO_SCALE, &_tmp0_, FALSE);
#line 257 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	*result = _tmp1_;
#line 257 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	return;
#line 1745 "Dimensions.c"
}


void scaling_for_screen (GtkWindow* window, gboolean scale_up, Scaling* result) {
	GtkWindow* _tmp0_;
	Dimensions _tmp1_ = {0};
	gboolean _tmp2_;
	Scaling _tmp3_ = {0};
#line 260 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	g_return_if_fail (GTK_IS_WINDOW (window));
#line 261 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp0_ = window;
#line 261 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	scaling_get_screen_dimensions (_tmp0_, &_tmp1_);
#line 261 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp2_ = scale_up;
#line 261 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	scaling_for_viewport (&_tmp1_, _tmp2_, &_tmp3_);
#line 261 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	*result = _tmp3_;
#line 261 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	return;
#line 1768 "Dimensions.c"
}


void scaling_for_best_fit (gint pixels, gboolean scale_up, Scaling* result) {
	gint _tmp0_;
	gint _tmp1_;
	Dimensions _tmp2_ = {0};
	gboolean _tmp3_;
	Scaling _tmp4_ = {0};
#line 265 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp0_ = pixels;
#line 265 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	g_assert (_tmp0_ > 0);
#line 267 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp1_ = pixels;
#line 267 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	dimensions_init (&_tmp2_, 0, 0);
#line 267 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp3_ = scale_up;
#line 267 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	scaling_init (&_tmp4_, SCALE_CONSTRAINT_DIMENSIONS, _tmp1_, &_tmp2_, _tmp3_);
#line 267 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	*result = _tmp4_;
#line 267 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	return;
#line 1794 "Dimensions.c"
}


void scaling_for_viewport (Dimensions* viewport, gboolean scale_up, Scaling* result) {
	gboolean _tmp0_ = FALSE;
	Dimensions _tmp1_;
	gboolean _tmp2_;
	Scaling _tmp3_ = {0};
#line 270 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	g_return_if_fail (viewport != NULL);
#line 271 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp0_ = dimensions_has_area (viewport);
#line 271 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	g_assert (_tmp0_);
#line 273 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp1_ = *viewport;
#line 273 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp2_ = scale_up;
#line 273 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	scaling_init (&_tmp3_, SCALE_CONSTRAINT_DIMENSIONS, SCALING_NO_SCALE, &_tmp1_, _tmp2_);
#line 273 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	*result = _tmp3_;
#line 273 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	return;
#line 1819 "Dimensions.c"
}


void scaling_for_widget (GtkWidget* widget, gboolean scale_up, Scaling* result) {
	GtkWidget* _tmp0_;
	GtkAllocation _tmp1_;
	Dimensions _tmp2_ = {0};
	Dimensions viewport;
	gboolean _tmp3_ = FALSE;
	Dimensions _tmp4_;
	gboolean _tmp5_;
	Scaling _tmp6_ = {0};
#line 276 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	g_return_if_fail (GTK_IS_WIDGET (widget));
#line 277 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp0_ = widget;
#line 277 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp1_ = _tmp0_->allocation;
#line 277 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	dimensions_for_allocation (&_tmp1_, &_tmp2_);
#line 277 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	viewport = _tmp2_;
#line 278 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp3_ = dimensions_has_area (&viewport);
#line 278 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	g_assert (_tmp3_);
#line 280 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp4_ = viewport;
#line 280 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp5_ = scale_up;
#line 280 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	scaling_init (&_tmp6_, SCALE_CONSTRAINT_DIMENSIONS, SCALING_NO_SCALE, &_tmp4_, _tmp5_);
#line 280 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	*result = _tmp6_;
#line 280 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	return;
#line 1856 "Dimensions.c"
}


void scaling_to_fill_viewport (Dimensions* viewport, Scaling* result) {
	gboolean _tmp0_ = FALSE;
	Dimensions _tmp1_;
	Scaling _tmp2_ = {0};
#line 283 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	g_return_if_fail (viewport != NULL);
#line 284 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp0_ = dimensions_has_area (viewport);
#line 284 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	g_assert (_tmp0_);
#line 286 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp1_ = *viewport;
#line 286 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	scaling_init (&_tmp2_, SCALE_CONSTRAINT_FILL_VIEWPORT, SCALING_NO_SCALE, &_tmp1_, TRUE);
#line 286 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	*result = _tmp2_;
#line 286 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	return;
#line 1878 "Dimensions.c"
}


void scaling_to_fill_screen (GtkWindow* window, Scaling* result) {
	GtkWindow* _tmp0_;
	Dimensions _tmp1_ = {0};
	Scaling _tmp2_ = {0};
#line 289 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	g_return_if_fail (GTK_IS_WINDOW (window));
#line 290 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp0_ = window;
#line 290 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	scaling_get_screen_dimensions (_tmp0_, &_tmp1_);
#line 290 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	scaling_to_fill_viewport (&_tmp1_, &_tmp2_);
#line 290 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	*result = _tmp2_;
#line 290 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	return;
#line 1898 "Dimensions.c"
}


void scaling_for_constraint (ScaleConstraint constraint, gint scale, gboolean scale_up, Scaling* result) {
	ScaleConstraint _tmp0_;
	gint _tmp1_;
	Dimensions _tmp2_ = {0};
	gboolean _tmp3_;
	Scaling _tmp4_ = {0};
#line 294 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp0_ = constraint;
#line 294 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp1_ = scale;
#line 294 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	dimensions_init (&_tmp2_, 0, 0);
#line 294 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp3_ = scale_up;
#line 294 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	scaling_init (&_tmp4_, _tmp0_, _tmp1_, &_tmp2_, _tmp3_);
#line 294 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	*result = _tmp4_;
#line 294 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	return;
#line 1922 "Dimensions.c"
}


static gpointer _g_object_ref0 (gpointer self) {
#line 298 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	return self ? g_object_ref (self) : NULL;
#line 1929 "Dimensions.c"
}


static void scaling_get_screen_dimensions (GtkWindow* window, Dimensions* result) {
	GtkWindow* _tmp0_;
	GdkScreen* _tmp1_ = NULL;
	GdkScreen* _tmp2_;
	GdkScreen* screen;
	gint _tmp3_ = 0;
	gint _tmp4_ = 0;
	Dimensions _tmp5_ = {0};
#line 297 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	g_return_if_fail (GTK_IS_WINDOW (window));
#line 298 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp0_ = window;
#line 298 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp1_ = gtk_window_get_screen (_tmp0_);
#line 298 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 298 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	screen = _tmp2_;
#line 300 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp3_ = gdk_screen_get_width (screen);
#line 300 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp4_ = gdk_screen_get_height (screen);
#line 300 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	dimensions_init (&_tmp5_, _tmp3_, _tmp4_);
#line 300 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	*result = _tmp5_;
#line 300 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_g_object_unref0 (screen);
#line 300 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	return;
#line 1963 "Dimensions.c"
}


static gint scaling_scale_to_pixels (Scaling *self) {
	gint result = 0;
	gint _tmp0_ = 0;
	gint _tmp1_;
	gint _tmp3_;
#line 304 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp1_ = (*self).scale;
#line 304 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	if (_tmp1_ >= 0) {
#line 1976 "Dimensions.c"
		gint _tmp2_;
#line 304 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp2_ = (*self).scale;
#line 304 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp0_ = _tmp2_;
#line 1982 "Dimensions.c"
	} else {
#line 304 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp0_ = 0;
#line 1986 "Dimensions.c"
	}
#line 304 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp3_ = _tmp0_;
#line 304 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	result = _tmp3_;
#line 304 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	return result;
#line 1994 "Dimensions.c"
}


gboolean scaling_is_unscaled (Scaling *self) {
	gboolean result = FALSE;
	ScaleConstraint _tmp0_;
#line 308 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp0_ = (*self).constraint;
#line 308 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	result = _tmp0_ == SCALE_CONSTRAINT_ORIGINAL;
#line 308 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	return result;
#line 2007 "Dimensions.c"
}


gboolean scaling_is_best_fit (Scaling *self, Dimensions* original, gint* pixels) {
	gint _vala_pixels = 0;
	gboolean result = FALSE;
	gint _tmp0_;
	ScaleConstraint _tmp1_;
#line 311 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	g_return_val_if_fail (original != NULL, FALSE);
#line 312 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp0_ = (*self).scale;
#line 312 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	if (_tmp0_ == SCALING_NO_SCALE) {
#line 313 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		result = FALSE;
#line 313 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		if (pixels) {
#line 313 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
			*pixels = _vala_pixels;
#line 2028 "Dimensions.c"
		}
#line 313 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		return result;
#line 2032 "Dimensions.c"
	}
#line 315 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp1_ = (*self).constraint;
#line 315 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	switch (_tmp1_) {
#line 315 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		case SCALE_CONSTRAINT_ORIGINAL:
#line 315 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		case SCALE_CONSTRAINT_FILL_VIEWPORT:
#line 2042 "Dimensions.c"
		{
#line 318 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
			result = FALSE;
#line 318 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
			if (pixels) {
#line 318 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
				*pixels = _vala_pixels;
#line 2050 "Dimensions.c"
			}
#line 318 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
			return result;
#line 2054 "Dimensions.c"
		}
		default:
		{
			gint _tmp2_ = 0;
			gint _tmp3_;
#line 321 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
			_tmp2_ = scaling_scale_to_pixels (&(*self));
#line 321 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
			_vala_pixels = _tmp2_;
#line 322 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
			_tmp3_ = _vala_pixels;
#line 322 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
			g_assert (_tmp3_ > 0);
#line 324 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
			result = TRUE;
#line 324 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
			if (pixels) {
#line 324 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
				*pixels = _vala_pixels;
#line 2074 "Dimensions.c"
			}
#line 324 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
			return result;
#line 2078 "Dimensions.c"
		}
	}
#line 311 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	if (pixels) {
#line 311 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		*pixels = _vala_pixels;
#line 2085 "Dimensions.c"
	}
}


gboolean scaling_is_best_fit_dimensions (Scaling *self, Dimensions* original, Dimensions* scaled) {
	Dimensions _vala_scaled = {0};
	gboolean result = FALSE;
	gint _tmp0_;
	ScaleConstraint _tmp1_;
#line 328 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	g_return_val_if_fail (original != NULL, FALSE);
#line 329 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp0_ = (*self).scale;
#line 329 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	if (_tmp0_ == SCALING_NO_SCALE) {
#line 330 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		result = FALSE;
#line 330 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		if (scaled) {
#line 330 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
			*scaled = _vala_scaled;
#line 2107 "Dimensions.c"
		}
#line 330 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		return result;
#line 2111 "Dimensions.c"
	}
#line 332 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp1_ = (*self).constraint;
#line 332 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	switch (_tmp1_) {
#line 332 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		case SCALE_CONSTRAINT_ORIGINAL:
#line 332 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		case SCALE_CONSTRAINT_FILL_VIEWPORT:
#line 2121 "Dimensions.c"
		{
#line 335 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
			result = FALSE;
#line 335 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
			if (scaled) {
#line 335 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
				*scaled = _vala_scaled;
#line 2129 "Dimensions.c"
			}
#line 335 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
			return result;
#line 2133 "Dimensions.c"
		}
		default:
		{
			gint _tmp2_ = 0;
			gint pixels;
			gint _tmp3_;
			gint _tmp4_;
			ScaleConstraint _tmp5_;
			Dimensions _tmp6_ = {0};
#line 338 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
			_tmp2_ = scaling_scale_to_pixels (&(*self));
#line 338 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
			pixels = _tmp2_;
#line 339 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
			_tmp3_ = pixels;
#line 339 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
			g_assert (_tmp3_ > 0);
#line 341 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
			_tmp4_ = pixels;
#line 341 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
			_tmp5_ = (*self).constraint;
#line 341 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
			dimensions_get_scaled_by_constraint (original, _tmp4_, _tmp5_, &_tmp6_);
#line 341 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
			_vala_scaled = _tmp6_;
#line 343 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
			result = TRUE;
#line 343 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
			if (scaled) {
#line 343 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
				*scaled = _vala_scaled;
#line 2165 "Dimensions.c"
			}
#line 343 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
			return result;
#line 2169 "Dimensions.c"
		}
	}
#line 328 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	if (scaled) {
#line 328 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		*scaled = _vala_scaled;
#line 2176 "Dimensions.c"
	}
}


gboolean scaling_is_for_viewport (Scaling *self, Dimensions* original, Dimensions* scaled) {
	Dimensions _vala_scaled = {0};
	gboolean result = FALSE;
	gint _tmp0_;
	ScaleConstraint _tmp1_;
#line 347 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	g_return_val_if_fail (original != NULL, FALSE);
#line 348 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp0_ = (*self).scale;
#line 348 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	if (_tmp0_ != SCALING_NO_SCALE) {
#line 349 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		result = FALSE;
#line 349 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		if (scaled) {
#line 349 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
			*scaled = _vala_scaled;
#line 2198 "Dimensions.c"
		}
#line 349 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		return result;
#line 2202 "Dimensions.c"
	}
#line 351 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp1_ = (*self).constraint;
#line 351 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	switch (_tmp1_) {
#line 351 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		case SCALE_CONSTRAINT_ORIGINAL:
#line 351 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		case SCALE_CONSTRAINT_FILL_VIEWPORT:
#line 2212 "Dimensions.c"
		{
#line 354 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
			result = FALSE;
#line 354 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
			if (scaled) {
#line 354 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
				*scaled = _vala_scaled;
#line 2220 "Dimensions.c"
			}
#line 354 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
			return result;
#line 2224 "Dimensions.c"
		}
		default:
		{
			gboolean _tmp2_ = FALSE;
			gboolean _tmp3_ = FALSE;
			gboolean _tmp4_ = FALSE;
			gboolean _tmp5_;
			gboolean _tmp10_;
			gboolean _tmp15_;
#line 357 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
			_tmp2_ = dimensions_has_area (&(*self).viewport);
#line 357 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
			g_assert (_tmp2_);
#line 359 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
			_tmp5_ = (*self).scale_up;
#line 359 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
			if (!_tmp5_) {
#line 2242 "Dimensions.c"
				Dimensions _tmp6_;
				gint _tmp7_;
				Dimensions _tmp8_;
				gint _tmp9_;
#line 359 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
				_tmp6_ = *original;
#line 359 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
				_tmp7_ = _tmp6_.width;
#line 359 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
				_tmp8_ = (*self).viewport;
#line 359 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
				_tmp9_ = _tmp8_.width;
#line 359 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
				_tmp4_ = _tmp7_ < _tmp9_;
#line 2257 "Dimensions.c"
			} else {
#line 359 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
				_tmp4_ = FALSE;
#line 2261 "Dimensions.c"
			}
#line 359 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
			_tmp10_ = _tmp4_;
#line 359 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
			if (_tmp10_) {
#line 2267 "Dimensions.c"
				Dimensions _tmp11_;
				gint _tmp12_;
				Dimensions _tmp13_;
				gint _tmp14_;
#line 359 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
				_tmp11_ = *original;
#line 359 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
				_tmp12_ = _tmp11_.height;
#line 359 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
				_tmp13_ = (*self).viewport;
#line 359 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
				_tmp14_ = _tmp13_.height;
#line 359 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
				_tmp3_ = _tmp12_ < _tmp14_;
#line 2282 "Dimensions.c"
			} else {
#line 359 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
				_tmp3_ = FALSE;
#line 2286 "Dimensions.c"
			}
#line 359 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
			_tmp15_ = _tmp3_;
#line 359 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
			if (_tmp15_) {
#line 2292 "Dimensions.c"
				Dimensions _tmp16_;
#line 360 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
				_tmp16_ = *original;
#line 360 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
				_vala_scaled = _tmp16_;
#line 2298 "Dimensions.c"
			} else {
				Dimensions _tmp17_;
				Dimensions _tmp18_ = {0};
#line 362 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
				_tmp17_ = (*self).viewport;
#line 362 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
				dimensions_get_scaled_proportional (original, &_tmp17_, &_tmp18_);
#line 362 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
				_vala_scaled = _tmp18_;
#line 2308 "Dimensions.c"
			}
#line 364 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
			result = TRUE;
#line 364 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
			if (scaled) {
#line 364 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
				*scaled = _vala_scaled;
#line 2316 "Dimensions.c"
			}
#line 364 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
			return result;
#line 2320 "Dimensions.c"
		}
	}
#line 347 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	if (scaled) {
#line 347 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		*scaled = _vala_scaled;
#line 2327 "Dimensions.c"
	}
}


gboolean scaling_is_fill_viewport (Scaling *self, Dimensions* original, Dimensions* scaled) {
	Dimensions _vala_scaled = {0};
	gboolean result = FALSE;
	ScaleConstraint _tmp0_;
	gboolean _tmp1_ = FALSE;
	Dimensions _tmp2_;
	Dimensions _tmp3_ = {0};
#line 368 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	g_return_val_if_fail (original != NULL, FALSE);
#line 369 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp0_ = (*self).constraint;
#line 369 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	if (_tmp0_ != SCALE_CONSTRAINT_FILL_VIEWPORT) {
#line 370 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		result = FALSE;
#line 370 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		if (scaled) {
#line 370 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
			*scaled = _vala_scaled;
#line 2351 "Dimensions.c"
		}
#line 370 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		return result;
#line 2355 "Dimensions.c"
	}
#line 372 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp1_ = dimensions_has_area (&(*self).viewport);
#line 372 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	g_assert (_tmp1_);
#line 373 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp2_ = (*self).viewport;
#line 373 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	dimensions_get_scaled_to_fill_viewport (original, &_tmp2_, &_tmp3_);
#line 373 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_vala_scaled = _tmp3_;
#line 375 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	result = TRUE;
#line 375 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	if (scaled) {
#line 375 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		*scaled = _vala_scaled;
#line 2373 "Dimensions.c"
	}
#line 375 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	return result;
#line 2377 "Dimensions.c"
}


void scaling_get_scaled_dimensions (Scaling *self, Dimensions* original, Dimensions* result) {
	gboolean _tmp0_ = FALSE;
	Dimensions scaled = {0};
	Dimensions _tmp2_;
	Dimensions _tmp3_ = {0};
	gboolean _tmp4_ = FALSE;
	Dimensions _tmp5_;
	Dimensions _tmp6_ = {0};
	gboolean _tmp7_ = FALSE;
	Dimensions _tmp8_;
	Dimensions _tmp9_ = {0};
	gboolean _tmp10_ = FALSE;
	gboolean is_viewport;
	gboolean _tmp11_;
#line 378 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	g_return_if_fail (original != NULL);
#line 379 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp0_ = scaling_is_unscaled (&(*self));
#line 379 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	if (_tmp0_) {
#line 2401 "Dimensions.c"
		Dimensions _tmp1_;
#line 380 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp1_ = *original;
#line 380 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		*result = _tmp1_;
#line 380 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		return;
#line 2409 "Dimensions.c"
	}
#line 383 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp2_ = *original;
#line 383 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp4_ = scaling_is_fill_viewport (&(*self), &_tmp2_, &_tmp3_);
#line 383 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	scaled = _tmp3_;
#line 383 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	if (_tmp4_) {
#line 384 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		*result = scaled;
#line 384 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		return;
#line 2423 "Dimensions.c"
	}
#line 386 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp5_ = *original;
#line 386 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp7_ = scaling_is_best_fit_dimensions (&(*self), &_tmp5_, &_tmp6_);
#line 386 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	scaled = _tmp6_;
#line 386 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	if (_tmp7_) {
#line 387 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		*result = scaled;
#line 387 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		return;
#line 2437 "Dimensions.c"
	}
#line 389 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp8_ = *original;
#line 389 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp10_ = scaling_is_for_viewport (&(*self), &_tmp8_, &_tmp9_);
#line 389 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	scaled = _tmp9_;
#line 389 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	is_viewport = _tmp10_;
#line 390 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp11_ = is_viewport;
#line 390 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	g_assert (_tmp11_);
#line 392 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	*result = scaled;
#line 392 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	return;
#line 2455 "Dimensions.c"
}


GdkPixbuf* scaling_perform_on_pixbuf (Scaling *self, GdkPixbuf* pixbuf, GdkInterpType interp, gboolean scale_up) {
	GdkPixbuf* result = NULL;
	gboolean _tmp0_ = FALSE;
	GdkPixbuf* _tmp3_;
	Dimensions _tmp4_ = {0};
	Dimensions pixbuf_dim;
	gint pixels = 0;
	Dimensions _tmp5_;
	gint _tmp6_ = 0;
	gboolean _tmp7_ = FALSE;
	Dimensions scaled = {0};
	Dimensions _tmp13_;
	Dimensions _tmp14_ = {0};
	gboolean _tmp15_ = FALSE;
	Dimensions _tmp20_;
	Dimensions _tmp21_ = {0};
	gboolean _tmp22_ = FALSE;
	gboolean is_viewport;
	gboolean _tmp23_;
	GdkPixbuf* _tmp24_;
	Dimensions _tmp25_;
	GdkInterpType _tmp26_;
	GdkPixbuf* _tmp27_ = NULL;
#line 395 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	g_return_val_if_fail (GDK_IS_PIXBUF (pixbuf), NULL);
#line 396 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp0_ = scaling_is_unscaled (&(*self));
#line 396 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	if (_tmp0_) {
#line 2488 "Dimensions.c"
		GdkPixbuf* _tmp1_;
		GdkPixbuf* _tmp2_;
#line 397 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp1_ = pixbuf;
#line 397 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp2_ = _g_object_ref0 (_tmp1_);
#line 397 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		result = _tmp2_;
#line 397 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		return result;
#line 2499 "Dimensions.c"
	}
#line 399 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp3_ = pixbuf;
#line 399 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	dimensions_for_pixbuf (_tmp3_, &_tmp4_);
#line 399 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	pixbuf_dim = _tmp4_;
#line 402 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp5_ = pixbuf_dim;
#line 402 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp7_ = scaling_is_best_fit (&(*self), &_tmp5_, &_tmp6_);
#line 402 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	pixels = _tmp6_;
#line 402 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	if (_tmp7_) {
#line 2515 "Dimensions.c"
		GdkPixbuf* _tmp8_;
		gint _tmp9_;
		GdkInterpType _tmp10_;
		gboolean _tmp11_;
		GdkPixbuf* _tmp12_ = NULL;
#line 403 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp8_ = pixbuf;
#line 403 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp9_ = pixels;
#line 403 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp10_ = interp;
#line 403 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp11_ = scale_up;
#line 403 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp12_ = scale_pixbuf (_tmp8_, _tmp9_, _tmp10_, _tmp11_);
#line 403 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		result = _tmp12_;
#line 403 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		return result;
#line 2535 "Dimensions.c"
	}
#line 406 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp13_ = pixbuf_dim;
#line 406 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp15_ = scaling_is_fill_viewport (&(*self), &_tmp13_, &_tmp14_);
#line 406 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	scaled = _tmp14_;
#line 406 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	if (_tmp15_) {
#line 2545 "Dimensions.c"
		GdkPixbuf* _tmp16_;
		Dimensions _tmp17_;
		GdkInterpType _tmp18_;
		GdkPixbuf* _tmp19_ = NULL;
#line 407 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp16_ = pixbuf;
#line 407 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp17_ = scaled;
#line 407 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp18_ = interp;
#line 407 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp19_ = resize_pixbuf (_tmp16_, &_tmp17_, _tmp18_);
#line 407 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		result = _tmp19_;
#line 407 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		return result;
#line 2562 "Dimensions.c"
	}
#line 409 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp20_ = pixbuf_dim;
#line 409 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp22_ = scaling_is_for_viewport (&(*self), &_tmp20_, &_tmp21_);
#line 409 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	scaled = _tmp21_;
#line 409 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	is_viewport = _tmp22_;
#line 410 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp23_ = is_viewport;
#line 410 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	g_assert (_tmp23_);
#line 412 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp24_ = pixbuf;
#line 412 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp25_ = scaled;
#line 412 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp26_ = interp;
#line 412 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp27_ = resize_pixbuf (_tmp24_, &_tmp25_, _tmp26_);
#line 412 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	result = _tmp27_;
#line 412 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	return result;
#line 2588 "Dimensions.c"
}


gchar* scaling_to_string (Scaling *self) {
	gchar* result = NULL;
	ScaleConstraint _tmp0_;
#line 416 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp0_ = (*self).constraint;
#line 416 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	if (_tmp0_ == SCALE_CONSTRAINT_ORIGINAL) {
#line 2599 "Dimensions.c"
		gchar* _tmp1_;
#line 417 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp1_ = g_strdup ("scaling: UNSCALED");
#line 417 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		result = _tmp1_;
#line 417 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		return result;
#line 2607 "Dimensions.c"
	} else {
		ScaleConstraint _tmp2_;
#line 418 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp2_ = (*self).constraint;
#line 418 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		if (_tmp2_ == SCALE_CONSTRAINT_FILL_VIEWPORT) {
#line 2614 "Dimensions.c"
			gchar* _tmp3_ = NULL;
			gchar* _tmp4_;
			gchar* _tmp5_ = NULL;
			gchar* _tmp6_;
#line 419 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
			_tmp3_ = dimensions_to_string (&(*self).viewport);
#line 419 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
			_tmp4_ = _tmp3_;
#line 419 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
			_tmp5_ = g_strdup_printf ("scaling: fill viewport %s", _tmp4_);
#line 419 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
			_tmp6_ = _tmp5_;
#line 419 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
			_g_free0 (_tmp4_);
#line 419 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
			result = _tmp6_;
#line 419 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
			return result;
#line 2633 "Dimensions.c"
		} else {
			gint _tmp7_;
#line 420 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
			_tmp7_ = (*self).scale;
#line 420 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
			if (_tmp7_ != SCALING_NO_SCALE) {
#line 2640 "Dimensions.c"
				const gchar* _tmp8_ = NULL;
				gboolean _tmp9_;
				ScaleConstraint _tmp10_;
				gchar* _tmp11_ = NULL;
				gchar* _tmp12_;
				gint _tmp13_ = 0;
				const gchar* _tmp14_;
				gchar* _tmp15_ = NULL;
				gchar* _tmp16_;
#line 422 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
				_tmp9_ = (*self).scale_up;
#line 422 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
				if (_tmp9_) {
#line 422 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
					_tmp8_ = "scaled up";
#line 2656 "Dimensions.c"
				} else {
#line 422 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
					_tmp8_ = "not scaled up";
#line 2660 "Dimensions.c"
				}
#line 421 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
				_tmp10_ = (*self).constraint;
#line 421 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
				_tmp11_ = scale_constraint_to_string (_tmp10_);
#line 421 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
				_tmp12_ = _tmp11_;
#line 421 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
				_tmp13_ = scaling_scale_to_pixels (&(*self));
#line 421 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
				_tmp14_ = _tmp8_;
#line 421 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
				_tmp15_ = g_strdup_printf ("scaling: best-fit (%s %d pixels %s)", _tmp12_, _tmp13_, _tmp14_);
#line 421 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
				_tmp16_ = _tmp15_;
#line 421 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
				_g_free0 (_tmp12_);
#line 421 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
				result = _tmp16_;
#line 421 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
				return result;
#line 2682 "Dimensions.c"
			} else {
				const gchar* _tmp17_ = NULL;
				gboolean _tmp18_;
				gchar* _tmp19_ = NULL;
				gchar* _tmp20_;
				const gchar* _tmp21_;
				gchar* _tmp22_ = NULL;
				gchar* _tmp23_;
#line 425 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
				_tmp18_ = (*self).scale_up;
#line 425 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
				if (_tmp18_) {
#line 425 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
					_tmp17_ = "scaled up";
#line 2697 "Dimensions.c"
				} else {
#line 425 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
					_tmp17_ = "not scaled up";
#line 2701 "Dimensions.c"
				}
#line 424 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
				_tmp19_ = dimensions_to_string (&(*self).viewport);
#line 424 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
				_tmp20_ = _tmp19_;
#line 424 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
				_tmp21_ = _tmp17_;
#line 424 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
				_tmp22_ = g_strdup_printf ("scaling: viewport %s (%s)", _tmp20_, _tmp21_);
#line 424 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
				_tmp23_ = _tmp22_;
#line 424 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
				_g_free0 (_tmp20_);
#line 424 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
				result = _tmp23_;
#line 424 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
				return result;
#line 2719 "Dimensions.c"
			}
		}
	}
}


gboolean scaling_equals (Scaling *self, Scaling* scaling) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	ScaleConstraint _tmp2_;
	Scaling _tmp3_;
	ScaleConstraint _tmp4_;
	gboolean _tmp8_;
	gboolean _tmp12_;
#line 428 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	g_return_val_if_fail (scaling != NULL, FALSE);
#line 429 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp2_ = (*self).constraint;
#line 429 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp3_ = *scaling;
#line 429 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp4_ = _tmp3_.constraint;
#line 429 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	if (_tmp2_ == _tmp4_) {
#line 2745 "Dimensions.c"
		gint _tmp5_;
		Scaling _tmp6_;
		gint _tmp7_;
#line 429 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp5_ = (*self).scale;
#line 429 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp6_ = *scaling;
#line 429 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp7_ = _tmp6_.scale;
#line 429 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp1_ = _tmp5_ == _tmp7_;
#line 2757 "Dimensions.c"
	} else {
#line 429 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp1_ = FALSE;
#line 2761 "Dimensions.c"
	}
#line 429 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp8_ = _tmp1_;
#line 429 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	if (_tmp8_) {
#line 2767 "Dimensions.c"
		Scaling _tmp9_;
		Dimensions _tmp10_;
		gboolean _tmp11_ = FALSE;
#line 430 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp9_ = *scaling;
#line 430 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp10_ = _tmp9_.viewport;
#line 430 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp11_ = dimensions_equals (&(*self).viewport, &_tmp10_);
#line 430 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp0_ = _tmp11_;
#line 2779 "Dimensions.c"
	} else {
#line 429 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp0_ = FALSE;
#line 2783 "Dimensions.c"
	}
#line 429 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp12_ = _tmp0_;
#line 429 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	result = _tmp12_;
#line 429 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	return result;
#line 2791 "Dimensions.c"
}


Scaling* scaling_dup (const Scaling* self) {
	Scaling* dup;
#line 241 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	dup = g_new0 (Scaling, 1);
#line 241 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	memcpy (dup, self, sizeof (Scaling));
#line 241 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	return dup;
#line 2803 "Dimensions.c"
}


void scaling_free (Scaling* self) {
#line 241 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	g_free (self);
#line 2810 "Dimensions.c"
}


GType scaling_get_type (void) {
	static volatile gsize scaling_type_id__volatile = 0;
	if (g_once_init_enter (&scaling_type_id__volatile)) {
		GType scaling_type_id;
		scaling_type_id = g_boxed_type_register_static ("Scaling", (GBoxedCopyFunc) scaling_dup, (GBoxedFreeFunc) scaling_free);
		g_once_init_leave (&scaling_type_id__volatile, scaling_type_id);
	}
	return scaling_type_id__volatile;
}


void zoom_state_init (ZoomState *self, Dimensions* content_dimensions, Dimensions* viewport_dimensions, gdouble slider_val, GdkPoint* viewport_center) {
	Dimensions _tmp0_;
	Dimensions _tmp1_;
	gdouble _tmp2_;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_ = FALSE;
	GdkPoint* _tmp5_;
	gboolean _tmp12_;
	gboolean _tmp14_;
#line 443 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	g_return_if_fail (content_dimensions != NULL);
#line 443 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	g_return_if_fail (viewport_dimensions != NULL);
#line 443 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	memset (self, 0, sizeof (ZoomState));
#line 445 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp0_ = *content_dimensions;
#line 445 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	(*self).content_dimensions = _tmp0_;
#line 446 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp1_ = *viewport_dimensions;
#line 446 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	(*self).viewport_dimensions = _tmp1_;
#line 447 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp2_ = slider_val;
#line 447 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	(*self).interpolation_factor = _tmp2_;
#line 449 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	zoom_state_compute_zoom_factors (&(*self));
#line 451 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp5_ = viewport_center;
#line 451 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	if (_tmp5_ == NULL) {
#line 451 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp4_ = TRUE;
#line 2860 "Dimensions.c"
	} else {
		gboolean _tmp6_ = FALSE;
		GdkPoint* _tmp7_;
		gint _tmp8_;
		gboolean _tmp11_;
#line 451 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp7_ = viewport_center;
#line 451 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp8_ = (*_tmp7_).x;
#line 451 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		if (_tmp8_ == 0) {
#line 2872 "Dimensions.c"
			GdkPoint* _tmp9_;
			gint _tmp10_;
#line 451 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
			_tmp9_ = viewport_center;
#line 451 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
			_tmp10_ = (*_tmp9_).y;
#line 451 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
			_tmp6_ = _tmp10_ == 0;
#line 2881 "Dimensions.c"
		} else {
#line 451 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
			_tmp6_ = FALSE;
#line 2885 "Dimensions.c"
		}
#line 451 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp11_ = _tmp6_;
#line 451 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp4_ = _tmp11_;
#line 2891 "Dimensions.c"
	}
#line 451 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp12_ = _tmp4_;
#line 451 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	if (_tmp12_) {
#line 451 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp3_ = TRUE;
#line 2899 "Dimensions.c"
	} else {
		gdouble _tmp13_;
#line 452 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp13_ = slider_val;
#line 452 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp3_ = _tmp13_ == 0.0;
#line 2906 "Dimensions.c"
	}
#line 451 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp14_ = _tmp3_;
#line 451 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	if (_tmp14_) {
#line 453 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		zoom_state_center_viewport (&(*self));
#line 2914 "Dimensions.c"
	} else {
		GdkPoint* _tmp15_;
#line 455 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp15_ = viewport_center;
#line 455 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		(*self).viewport_center = *_tmp15_;
#line 456 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		zoom_state_clamp_viewport_center (&(*self));
#line 2923 "Dimensions.c"
	}
}


void zoom_state_init_rescale (ZoomState *self, ZoomState* existing, gdouble new_slider_val) {
	ZoomState _tmp0_;
	Dimensions _tmp1_;
	ZoomState _tmp2_;
	Dimensions _tmp3_;
	gdouble _tmp4_;
	gdouble _tmp5_;
#line 460 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	g_return_if_fail (existing != NULL);
#line 460 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	memset (self, 0, sizeof (ZoomState));
#line 461 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp0_ = *existing;
#line 461 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp1_ = _tmp0_.content_dimensions;
#line 461 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	(*self).content_dimensions = _tmp1_;
#line 462 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp2_ = *existing;
#line 462 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp3_ = _tmp2_.viewport_dimensions;
#line 462 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	(*self).viewport_dimensions = _tmp3_;
#line 463 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp4_ = new_slider_val;
#line 463 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	(*self).interpolation_factor = _tmp4_;
#line 465 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	zoom_state_compute_zoom_factors (&(*self));
#line 467 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp5_ = new_slider_val;
#line 467 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	if (_tmp5_ == 0.0) {
#line 468 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		zoom_state_center_viewport (&(*self));
#line 2963 "Dimensions.c"
	} else {
		gdouble _tmp6_;
		ZoomState _tmp7_;
		GdkPoint _tmp8_;
		gint _tmp9_;
		ZoomState _tmp10_;
		gdouble _tmp11_;
		gdouble _tmp12_;
		ZoomState _tmp13_;
		GdkPoint _tmp14_;
		gint _tmp15_;
		ZoomState _tmp16_;
		gdouble _tmp17_;
#line 470 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp6_ = (*self).zoom_factor;
#line 470 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp7_ = *existing;
#line 470 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp8_ = _tmp7_.viewport_center;
#line 470 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp9_ = _tmp8_.x;
#line 470 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp10_ = *existing;
#line 470 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp11_ = _tmp10_.zoom_factor;
#line 470 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		(*self).viewport_center.x = (gint) (_tmp6_ * (_tmp9_ / _tmp11_));
#line 472 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp12_ = (*self).zoom_factor;
#line 472 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp13_ = *existing;
#line 472 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp14_ = _tmp13_.viewport_center;
#line 472 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp15_ = _tmp14_.y;
#line 472 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp16_ = *existing;
#line 472 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp17_ = _tmp16_.zoom_factor;
#line 472 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		(*self).viewport_center.y = (gint) (_tmp12_ * (_tmp15_ / _tmp17_));
#line 474 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		zoom_state_clamp_viewport_center (&(*self));
#line 3007 "Dimensions.c"
	}
}


void zoom_state_init_rescale_to_isomorphic (ZoomState *self, ZoomState* existing) {
	ZoomState _tmp0_;
	Dimensions _tmp1_;
	ZoomState _tmp2_;
	Dimensions _tmp3_;
	ZoomState _tmp4_;
	gdouble _tmp5_;
	gdouble _tmp6_ = 0.0;
	ZoomState _tmp7_;
	gdouble _tmp8_;
	ZoomState _tmp9_;
	gdouble _tmp10_;
	gdouble _tmp11_ = 0.0;
	gdouble _tmp12_;
#line 478 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	g_return_if_fail (existing != NULL);
#line 478 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	memset (self, 0, sizeof (ZoomState));
#line 479 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp0_ = *existing;
#line 479 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp1_ = _tmp0_.content_dimensions;
#line 479 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	(*self).content_dimensions = _tmp1_;
#line 480 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp2_ = *existing;
#line 480 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp3_ = _tmp2_.viewport_dimensions;
#line 480 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	(*self).viewport_dimensions = _tmp3_;
#line 481 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp4_ = *existing;
#line 481 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp5_ = _tmp4_.min_factor;
#line 481 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp6_ = log (1.0 / _tmp5_);
#line 481 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp7_ = *existing;
#line 481 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp8_ = _tmp7_.max_factor;
#line 481 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp9_ = *existing;
#line 481 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp10_ = _tmp9_.min_factor;
#line 481 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp11_ = log (_tmp8_ / _tmp10_);
#line 481 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	(*self).interpolation_factor = _tmp6_ / _tmp11_;
#line 484 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	zoom_state_compute_zoom_factors (&(*self));
#line 486 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp12_ = (*self).interpolation_factor;
#line 486 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	if (_tmp12_ == 0.0) {
#line 487 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		zoom_state_center_viewport (&(*self));
#line 3068 "Dimensions.c"
	} else {
		gdouble _tmp13_;
		ZoomState _tmp14_;
		GdkPoint _tmp15_;
		gint _tmp16_;
		ZoomState _tmp17_;
		gdouble _tmp18_;
		gdouble _tmp19_;
		ZoomState _tmp20_;
		GdkPoint _tmp21_;
		gint _tmp22_;
		ZoomState _tmp23_;
		gdouble _tmp24_;
#line 489 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp13_ = (*self).zoom_factor;
#line 489 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp14_ = *existing;
#line 489 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp15_ = _tmp14_.viewport_center;
#line 489 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp16_ = _tmp15_.x;
#line 489 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp17_ = *existing;
#line 489 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp18_ = _tmp17_.zoom_factor;
#line 489 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		(*self).viewport_center.x = (gint) (_tmp13_ * (_tmp16_ / _tmp18_));
#line 491 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp19_ = (*self).zoom_factor;
#line 491 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp20_ = *existing;
#line 491 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp21_ = _tmp20_.viewport_center;
#line 491 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp22_ = _tmp21_.y;
#line 491 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp23_ = *existing;
#line 491 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp24_ = _tmp23_.zoom_factor;
#line 491 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		(*self).viewport_center.y = (gint) (_tmp19_ * (_tmp22_ / _tmp24_));
#line 493 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		zoom_state_clamp_viewport_center (&(*self));
#line 3112 "Dimensions.c"
	}
}


void zoom_state_init_pan (ZoomState *self, ZoomState* existing, GdkPoint* new_viewport_center) {
	ZoomState _tmp0_;
	Dimensions _tmp1_;
	ZoomState _tmp2_;
	Dimensions _tmp3_;
	ZoomState _tmp4_;
	gdouble _tmp5_;
	GdkPoint _tmp6_;
#line 497 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	g_return_if_fail (existing != NULL);
#line 497 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	g_return_if_fail (new_viewport_center != NULL);
#line 497 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	memset (self, 0, sizeof (ZoomState));
#line 498 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp0_ = *existing;
#line 498 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp1_ = _tmp0_.content_dimensions;
#line 498 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	(*self).content_dimensions = _tmp1_;
#line 499 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp2_ = *existing;
#line 499 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp3_ = _tmp2_.viewport_dimensions;
#line 499 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	(*self).viewport_dimensions = _tmp3_;
#line 500 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp4_ = *existing;
#line 500 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp5_ = _tmp4_.interpolation_factor;
#line 500 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	(*self).interpolation_factor = _tmp5_;
#line 502 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	zoom_state_compute_zoom_factors (&(*self));
#line 504 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp6_ = *new_viewport_center;
#line 504 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	(*self).viewport_center = _tmp6_;
#line 506 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	zoom_state_clamp_viewport_center (&(*self));
#line 3157 "Dimensions.c"
}


static void zoom_state_clamp_viewport_center (ZoomState *self) {
	gint _tmp0_ = 0;
	gint zoomed_width;
	gint _tmp1_ = 0;
	gint zoomed_height;
	GdkPoint _tmp2_;
	gint _tmp3_;
	Dimensions _tmp4_;
	gint _tmp5_;
	Dimensions _tmp6_;
	gint _tmp7_;
	gint _tmp8_ = 0;
	GdkPoint _tmp9_;
	gint _tmp10_;
	Dimensions _tmp11_;
	gint _tmp12_;
	Dimensions _tmp13_;
	gint _tmp14_;
	gint _tmp15_ = 0;
#line 510 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp0_ = zoom_state_get_zoomed_width (&(*self));
#line 510 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	zoomed_width = _tmp0_;
#line 511 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp1_ = zoom_state_get_zoomed_height (&(*self));
#line 511 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	zoomed_height = _tmp1_;
#line 513 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp2_ = (*self).viewport_center;
#line 513 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp3_ = _tmp2_.x;
#line 513 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp4_ = (*self).viewport_dimensions;
#line 513 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp5_ = _tmp4_.width;
#line 513 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp6_ = (*self).viewport_dimensions;
#line 513 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp7_ = _tmp6_.width;
#line 513 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp8_ = CLAMP (_tmp3_, _tmp5_ / 2, (zoomed_width - (_tmp7_ / 2)) - 1);
#line 513 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	(*self).viewport_center.x = _tmp8_;
#line 515 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp9_ = (*self).viewport_center;
#line 515 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp10_ = _tmp9_.y;
#line 515 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp11_ = (*self).viewport_dimensions;
#line 515 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp12_ = _tmp11_.height;
#line 515 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp13_ = (*self).viewport_dimensions;
#line 515 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp14_ = _tmp13_.height;
#line 515 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp15_ = CLAMP (_tmp10_, _tmp12_ / 2, (zoomed_height - (_tmp14_ / 2)) - 1);
#line 515 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	(*self).viewport_center.y = _tmp15_;
#line 3220 "Dimensions.c"
}


static void zoom_state_center_viewport (ZoomState *self) {
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
#line 520 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp0_ = zoom_state_get_zoomed_width (&(*self));
#line 520 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	(*self).viewport_center.x = _tmp0_ / 2;
#line 521 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp1_ = zoom_state_get_zoomed_height (&(*self));
#line 521 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	(*self).viewport_center.y = _tmp1_ / 2;
#line 3235 "Dimensions.c"
}


static void zoom_state_compute_zoom_factors (ZoomState *self) {
	gdouble viewport_to_content_x = 0.0;
	gdouble viewport_to_content_y = 0.0;
	Dimensions _tmp0_;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_;
	gdouble _tmp4_;
	gdouble _tmp5_ = 0.0;
	gdouble _tmp6_;
	gdouble _tmp7_;
	gdouble _tmp8_;
	gdouble _tmp9_;
	gdouble _tmp10_;
	gdouble _tmp11_ = 0.0;
#line 525 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	(*self).max_factor = 2.0;
#line 529 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp0_ = (*self).viewport_dimensions;
#line 529 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	dimensions_get_scale_ratios (&(*self).content_dimensions, &_tmp0_, &_tmp1_, &_tmp2_);
#line 529 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	viewport_to_content_x = _tmp1_;
#line 529 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	viewport_to_content_y = _tmp2_;
#line 531 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp3_ = viewport_to_content_x;
#line 531 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp4_ = viewport_to_content_y;
#line 531 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp5_ = MIN (_tmp3_, _tmp4_);
#line 531 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	(*self).min_factor = _tmp5_;
#line 532 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp6_ = (*self).min_factor;
#line 532 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	if (_tmp6_ > 1.0) {
#line 533 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		(*self).min_factor = 1.0;
#line 3278 "Dimensions.c"
	}
#line 535 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp7_ = (*self).min_factor;
#line 535 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp8_ = (*self).max_factor;
#line 535 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp9_ = (*self).min_factor;
#line 535 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp10_ = (*self).interpolation_factor;
#line 535 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp11_ = pow (_tmp8_ / _tmp9_, _tmp10_);
#line 535 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	(*self).zoom_factor = _tmp7_ * _tmp11_;
#line 3292 "Dimensions.c"
}


gdouble zoom_state_get_interpolation_factor (ZoomState *self) {
	gdouble result = 0.0;
	gdouble _tmp0_;
#line 539 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp0_ = (*self).interpolation_factor;
#line 539 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	result = _tmp0_;
#line 539 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	return result;
#line 3305 "Dimensions.c"
}


void zoom_state_get_viewing_rectangle_wrt_content (ZoomState *self, GdkRectangle* result) {
	gint _tmp0_ = 0;
	gint zoomed_width;
	gint _tmp1_ = 0;
	gint zoomed_height;
	GdkRectangle _tmp2_ = {0};
	GdkRectangle _result_;
	Dimensions _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	GdkRectangle _tmp13_;
	gint _tmp14_;
	Dimensions _tmp15_;
	gint _tmp16_;
	gint _tmp17_;
	GdkRectangle _tmp25_;
	gint _tmp26_;
	GdkRectangle _tmp27_;
	gint _tmp28_;
	Dimensions _tmp29_;
	gint _tmp30_;
	gint right;
	gint _tmp31_;
	gint _tmp32_;
	gint _tmp34_;
	GdkRectangle _tmp35_;
	gint _tmp36_;
	GdkRectangle _tmp37_;
	gint _tmp38_;
	Dimensions _tmp39_;
	gint _tmp40_;
	gint bottom;
	gint _tmp41_;
	gint _tmp42_;
	gint _tmp44_;
	GdkRectangle _tmp45_;
	gint _tmp46_;
	GdkRectangle _tmp47_;
	gint _tmp48_;
	gint _tmp49_;
	gint _tmp50_ = 0;
	GdkRectangle _tmp51_;
	gint _tmp52_;
	gint _tmp53_;
	gint _tmp54_ = 0;
#line 544 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp0_ = zoom_state_get_zoomed_width (&(*self));
#line 544 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	zoomed_width = _tmp0_;
#line 545 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp1_ = zoom_state_get_zoomed_height (&(*self));
#line 545 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	zoomed_height = _tmp1_;
#line 547 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp2_.x = 0;
#line 547 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_result_ = _tmp2_;
#line 549 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp3_ = (*self).viewport_dimensions;
#line 549 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp4_ = _tmp3_.width;
#line 549 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp5_ = zoomed_width;
#line 549 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	if (_tmp4_ < _tmp5_) {
#line 3374 "Dimensions.c"
		GdkPoint _tmp6_;
		gint _tmp7_;
		Dimensions _tmp8_;
		gint _tmp9_;
#line 550 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp6_ = (*self).viewport_center;
#line 550 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp7_ = _tmp6_.x;
#line 550 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp8_ = (*self).viewport_dimensions;
#line 550 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp9_ = _tmp8_.width;
#line 550 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_result_.x = _tmp7_ - (_tmp9_ / 2);
#line 3389 "Dimensions.c"
	} else {
		gint _tmp10_;
		Dimensions _tmp11_;
		gint _tmp12_;
#line 552 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp10_ = zoomed_width;
#line 552 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp11_ = (*self).viewport_dimensions;
#line 552 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp12_ = _tmp11_.width;
#line 552 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_result_.x = (_tmp10_ - _tmp12_) / 2;
#line 3402 "Dimensions.c"
	}
#line 554 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp13_ = _result_;
#line 554 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp14_ = _tmp13_.x;
#line 554 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	if (_tmp14_ < 0) {
#line 555 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_result_.x = 0;
#line 3412 "Dimensions.c"
	}
#line 557 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp15_ = (*self).viewport_dimensions;
#line 557 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp16_ = _tmp15_.height;
#line 557 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp17_ = zoomed_height;
#line 557 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	if (_tmp16_ < _tmp17_) {
#line 3422 "Dimensions.c"
		GdkPoint _tmp18_;
		gint _tmp19_;
		Dimensions _tmp20_;
		gint _tmp21_;
#line 558 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp18_ = (*self).viewport_center;
#line 558 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp19_ = _tmp18_.y;
#line 558 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp20_ = (*self).viewport_dimensions;
#line 558 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp21_ = _tmp20_.height;
#line 558 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_result_.y = _tmp19_ - (_tmp21_ / 2);
#line 3437 "Dimensions.c"
	} else {
		gint _tmp22_;
		Dimensions _tmp23_;
		gint _tmp24_;
#line 560 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp22_ = zoomed_height;
#line 560 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp23_ = (*self).viewport_dimensions;
#line 560 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp24_ = _tmp23_.height;
#line 560 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_result_.y = (_tmp22_ - _tmp24_) / 2;
#line 3450 "Dimensions.c"
	}
#line 562 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp25_ = _result_;
#line 562 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp26_ = _tmp25_.y;
#line 562 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	if (_tmp26_ < 0) {
#line 563 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_result_.y = 0;
#line 3460 "Dimensions.c"
	}
#line 565 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp27_ = _result_;
#line 565 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp28_ = _tmp27_.x;
#line 565 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp29_ = (*self).viewport_dimensions;
#line 565 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp30_ = _tmp29_.width;
#line 565 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	right = _tmp28_ + _tmp30_;
#line 566 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp31_ = right;
#line 566 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp32_ = zoomed_width;
#line 566 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	if (_tmp31_ > _tmp32_) {
#line 3478 "Dimensions.c"
		gint _tmp33_;
#line 567 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp33_ = zoomed_width;
#line 567 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		right = _tmp33_;
#line 3484 "Dimensions.c"
	}
#line 568 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp34_ = right;
#line 568 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp35_ = _result_;
#line 568 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp36_ = _tmp35_.x;
#line 568 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_result_.width = _tmp34_ - _tmp36_;
#line 570 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp37_ = _result_;
#line 570 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp38_ = _tmp37_.y;
#line 570 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp39_ = (*self).viewport_dimensions;
#line 570 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp40_ = _tmp39_.height;
#line 570 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	bottom = _tmp38_ + _tmp40_;
#line 571 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp41_ = bottom;
#line 571 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp42_ = zoomed_height;
#line 571 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	if (_tmp41_ > _tmp42_) {
#line 3510 "Dimensions.c"
		gint _tmp43_;
#line 572 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp43_ = zoomed_height;
#line 572 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		bottom = _tmp43_;
#line 3516 "Dimensions.c"
	}
#line 573 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp44_ = bottom;
#line 573 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp45_ = _result_;
#line 573 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp46_ = _tmp45_.y;
#line 573 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_result_.height = _tmp44_ - _tmp46_;
#line 575 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp47_ = _result_;
#line 575 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp48_ = _tmp47_.width;
#line 575 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp49_ = G_MAXINT;
#line 575 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp50_ = CLAMP (_tmp48_, 1, _tmp49_);
#line 575 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_result_.width = _tmp50_;
#line 576 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp51_ = _result_;
#line 576 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp52_ = _tmp51_.height;
#line 576 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp53_ = G_MAXINT;
#line 576 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp54_ = CLAMP (_tmp52_, 1, _tmp53_);
#line 576 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_result_.height = _tmp54_;
#line 578 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	*result = _result_;
#line 578 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	return;
#line 3550 "Dimensions.c"
}


void zoom_state_get_viewing_rectangle_wrt_screen (ZoomState *self, GdkRectangle* result) {
	GdkRectangle _tmp0_ = {0};
	GdkRectangle wrt_content;
	GdkRectangle _tmp1_ = {0};
	GdkRectangle _result_;
	Dimensions _tmp2_;
	gint _tmp3_;
	GdkRectangle _tmp4_;
	gint _tmp5_;
	GdkRectangle _tmp6_;
	gint _tmp7_;
	Dimensions _tmp8_;
	gint _tmp9_;
	GdkRectangle _tmp10_;
	gint _tmp11_;
	GdkRectangle _tmp12_;
	gint _tmp13_;
	GdkRectangle _tmp14_;
	gint _tmp15_;
	GdkRectangle _tmp16_;
	gint _tmp17_;
#line 584 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	zoom_state_get_viewing_rectangle_wrt_content (&(*self), &_tmp0_);
#line 584 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	wrt_content = _tmp0_;
#line 586 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp1_.x = 0;
#line 586 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_result_ = _tmp1_;
#line 587 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp2_ = (*self).viewport_dimensions;
#line 587 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp3_ = _tmp2_.width;
#line 587 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp4_ = wrt_content;
#line 587 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp5_ = _tmp4_.width;
#line 587 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_result_.x = (_tmp3_ / 2) - (_tmp5_ / 2);
#line 588 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp6_ = _result_;
#line 588 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp7_ = _tmp6_.x;
#line 588 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	if (_tmp7_ < 0) {
#line 589 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_result_.x = 0;
#line 3601 "Dimensions.c"
	}
#line 590 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp8_ = (*self).viewport_dimensions;
#line 590 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp9_ = _tmp8_.height;
#line 590 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp10_ = wrt_content;
#line 590 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp11_ = _tmp10_.height;
#line 590 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_result_.y = (_tmp9_ / 2) - (_tmp11_ / 2);
#line 591 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp12_ = _result_;
#line 591 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp13_ = _tmp12_.y;
#line 591 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	if (_tmp13_ < 0) {
#line 592 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_result_.y = 0;
#line 3621 "Dimensions.c"
	}
#line 593 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp14_ = wrt_content;
#line 593 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp15_ = _tmp14_.width;
#line 593 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_result_.width = _tmp15_;
#line 594 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp16_ = wrt_content;
#line 594 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp17_ = _tmp16_.height;
#line 594 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_result_.height = _tmp17_;
#line 596 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	*result = _result_;
#line 596 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	return;
#line 3639 "Dimensions.c"
}


void zoom_state_get_viewing_rectangle_projection (ZoomState *self, GdkPixbuf* for_pixbuf, GdkRectangle* result) {
	gint _tmp0_ = 0;
	gdouble zoomed_width;
	gint _tmp1_ = 0;
	gdouble zoomed_height;
	GdkPixbuf* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	gdouble horiz_scale;
	GdkPixbuf* _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
	gdouble vert_scale;
	gdouble scale;
	GdkRectangle _tmp8_ = {0};
	GdkRectangle viewing_rectangle;
	GdkRectangle _tmp9_ = {0};
	GdkRectangle _result_;
	GdkRectangle _tmp10_;
	gint _tmp11_;
	GdkRectangle _tmp12_;
	gint _tmp13_;
	GdkPixbuf* _tmp14_;
	gint _tmp15_;
	gint _tmp16_;
	gint _tmp17_ = 0;
	GdkRectangle _tmp18_;
	gint _tmp19_;
	GdkRectangle _tmp20_;
	gint _tmp21_;
	GdkPixbuf* _tmp22_;
	gint _tmp23_;
	gint _tmp24_;
	gint _tmp25_ = 0;
	GdkRectangle _tmp26_;
	gint _tmp27_;
	GdkRectangle _tmp28_;
	gint _tmp29_;
	gint right;
	gint _tmp30_;
	GdkPixbuf* _tmp31_;
	gint _tmp32_;
	gint _tmp33_;
	gint _tmp34_ = 0;
	GdkRectangle _tmp35_;
	gint _tmp36_;
	GdkRectangle _tmp37_;
	gint _tmp38_;
	gint bottom;
	gint _tmp39_;
	GdkPixbuf* _tmp40_;
	gint _tmp41_;
	gint _tmp42_;
	gint _tmp43_ = 0;
	gint _tmp44_;
	GdkRectangle _tmp45_;
	gint _tmp46_;
	gint _tmp47_;
	GdkRectangle _tmp48_;
	gint _tmp49_;
#line 600 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	g_return_if_fail (GDK_IS_PIXBUF (for_pixbuf));
#line 601 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp0_ = zoom_state_get_zoomed_width (&(*self));
#line 601 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	zoomed_width = (gdouble) _tmp0_;
#line 602 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp1_ = zoom_state_get_zoomed_height (&(*self));
#line 602 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	zoomed_height = (gdouble) _tmp1_;
#line 604 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp2_ = for_pixbuf;
#line 604 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp3_ = gdk_pixbuf_get_width (_tmp2_);
#line 604 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp4_ = _tmp3_;
#line 604 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	horiz_scale = _tmp4_ / zoomed_width;
#line 605 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp5_ = for_pixbuf;
#line 605 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp6_ = gdk_pixbuf_get_height (_tmp5_);
#line 605 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp7_ = _tmp6_;
#line 605 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	vert_scale = _tmp7_ / zoomed_height;
#line 606 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	scale = (horiz_scale + vert_scale) / 2.0;
#line 608 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	zoom_state_get_viewing_rectangle_wrt_content (&(*self), &_tmp8_);
#line 608 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	viewing_rectangle = _tmp8_;
#line 610 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp9_.x = 0;
#line 610 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_result_ = _tmp9_;
#line 611 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp10_ = viewing_rectangle;
#line 611 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp11_ = _tmp10_.x;
#line 611 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_result_.x = (gint) (_tmp11_ * scale);
#line 612 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp12_ = _result_;
#line 612 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp13_ = _tmp12_.x;
#line 612 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp14_ = for_pixbuf;
#line 612 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp15_ = gdk_pixbuf_get_width (_tmp14_);
#line 612 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp16_ = _tmp15_;
#line 612 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp17_ = CLAMP (_tmp13_, 0, _tmp16_);
#line 612 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_result_.x = _tmp17_;
#line 613 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp18_ = viewing_rectangle;
#line 613 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp19_ = _tmp18_.y;
#line 613 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_result_.y = (gint) (_tmp19_ * scale);
#line 614 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp20_ = _result_;
#line 614 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp21_ = _tmp20_.y;
#line 614 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp22_ = for_pixbuf;
#line 614 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp23_ = gdk_pixbuf_get_height (_tmp22_);
#line 614 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp24_ = _tmp23_;
#line 614 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp25_ = CLAMP (_tmp21_, 0, _tmp24_);
#line 614 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_result_.y = _tmp25_;
#line 615 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp26_ = viewing_rectangle;
#line 615 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp27_ = _tmp26_.x;
#line 615 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp28_ = viewing_rectangle;
#line 615 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp29_ = _tmp28_.width;
#line 615 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	right = (gint) ((_tmp27_ + _tmp29_) * scale);
#line 616 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp30_ = right;
#line 616 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp31_ = for_pixbuf;
#line 616 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp32_ = gdk_pixbuf_get_width (_tmp31_);
#line 616 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp33_ = _tmp32_;
#line 616 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp34_ = CLAMP (_tmp30_, 0, _tmp33_);
#line 616 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	right = _tmp34_;
#line 617 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp35_ = viewing_rectangle;
#line 617 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp36_ = _tmp35_.y;
#line 617 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp37_ = viewing_rectangle;
#line 617 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp38_ = _tmp37_.height;
#line 617 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	bottom = (gint) ((_tmp36_ + _tmp38_) * scale);
#line 618 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp39_ = bottom;
#line 618 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp40_ = for_pixbuf;
#line 618 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp41_ = gdk_pixbuf_get_height (_tmp40_);
#line 618 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp42_ = _tmp41_;
#line 618 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp43_ = CLAMP (_tmp39_, 0, _tmp42_);
#line 618 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	bottom = _tmp43_;
#line 619 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp44_ = right;
#line 619 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp45_ = _result_;
#line 619 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp46_ = _tmp45_.x;
#line 619 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_result_.width = _tmp44_ - _tmp46_;
#line 620 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp47_ = bottom;
#line 620 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp48_ = _result_;
#line 620 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp49_ = _tmp48_.y;
#line 620 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_result_.height = _tmp47_ - _tmp49_;
#line 622 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	*result = _result_;
#line 622 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	return;
#line 3843 "Dimensions.c"
}


gdouble zoom_state_get_zoom_factor (ZoomState *self) {
	gdouble result = 0.0;
	gdouble _tmp0_;
#line 627 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp0_ = (*self).zoom_factor;
#line 627 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	result = _tmp0_;
#line 627 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	return result;
#line 3856 "Dimensions.c"
}


gint zoom_state_get_zoomed_width (ZoomState *self) {
	gint result = 0;
	Dimensions _tmp0_;
	gint _tmp1_;
	gdouble _tmp2_;
#line 631 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp0_ = (*self).content_dimensions;
#line 631 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp1_ = _tmp0_.width;
#line 631 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp2_ = (*self).zoom_factor;
#line 631 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	result = (gint) (_tmp1_ * _tmp2_);
#line 631 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	return result;
#line 3875 "Dimensions.c"
}


gint zoom_state_get_zoomed_height (ZoomState *self) {
	gint result = 0;
	Dimensions _tmp0_;
	gint _tmp1_;
	gdouble _tmp2_;
#line 635 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp0_ = (*self).content_dimensions;
#line 635 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp1_ = _tmp0_.height;
#line 635 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp2_ = (*self).zoom_factor;
#line 635 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	result = (gint) (_tmp1_ * _tmp2_);
#line 635 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	return result;
#line 3894 "Dimensions.c"
}


void zoom_state_get_viewport_center (ZoomState *self, GdkPoint* result) {
	GdkPoint _tmp0_;
#line 639 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp0_ = (*self).viewport_center;
#line 639 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	*result = _tmp0_;
#line 639 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	return;
#line 3906 "Dimensions.c"
}


gchar* zoom_state_to_string (ZoomState *self) {
	gchar* result = NULL;
	gchar* _tmp0_;
	gchar* named_modes;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp7_ = FALSE;
	gboolean _tmp13_ = FALSE;
	gboolean _tmp19_ = FALSE;
	const gchar* _tmp25_;
	GdkRectangle _tmp27_ = {0};
	GdkRectangle viewing_rect;
	Dimensions _tmp28_;
	gint _tmp29_;
	Dimensions _tmp30_;
	gint _tmp31_;
	Dimensions _tmp32_;
	gint _tmp33_;
	Dimensions _tmp34_;
	gint _tmp35_;
	gdouble _tmp36_;
	gdouble _tmp37_;
	gdouble _tmp38_;
	gint _tmp39_ = 0;
	gint _tmp40_ = 0;
	const gchar* _tmp41_;
	GdkRectangle _tmp42_;
	gint _tmp43_;
	GdkRectangle _tmp44_;
	gint _tmp45_;
	GdkRectangle _tmp46_;
	gint _tmp47_;
	GdkRectangle _tmp48_;
	gint _tmp49_;
	GdkPoint _tmp50_;
	gint _tmp51_;
	GdkPoint _tmp52_;
	gint _tmp53_;
	gchar* _tmp54_ = NULL;
#line 643 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp0_ = g_strdup ("");
#line 643 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	named_modes = _tmp0_;
#line 644 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp1_ = zoom_state_is_min (&(*self));
#line 644 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	if (_tmp1_) {
#line 3956 "Dimensions.c"
		const gchar* _tmp2_ = NULL;
		const gchar* _tmp3_;
		const gchar* _tmp4_;
		const gchar* _tmp5_;
		gchar* _tmp6_;
#line 645 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp3_ = named_modes;
#line 645 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		if (g_strcmp0 (_tmp3_, "") == 0) {
#line 645 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
			_tmp2_ = "MIN";
#line 3968 "Dimensions.c"
		} else {
#line 645 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
			_tmp2_ = ", MIN";
#line 3972 "Dimensions.c"
		}
#line 645 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp4_ = named_modes;
#line 645 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp5_ = _tmp2_;
#line 645 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp6_ = g_strconcat (_tmp4_, _tmp5_, NULL);
#line 645 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_g_free0 (named_modes);
#line 645 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		named_modes = _tmp6_;
#line 3984 "Dimensions.c"
	}
#line 646 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp7_ = zoom_state_is_default (&(*self));
#line 646 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	if (_tmp7_) {
#line 3990 "Dimensions.c"
		const gchar* _tmp8_ = NULL;
		const gchar* _tmp9_;
		const gchar* _tmp10_;
		const gchar* _tmp11_;
		gchar* _tmp12_;
#line 647 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp9_ = named_modes;
#line 647 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		if (g_strcmp0 (_tmp9_, "") == 0) {
#line 647 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
			_tmp8_ = "DEFAULT";
#line 4002 "Dimensions.c"
		} else {
#line 647 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
			_tmp8_ = ", DEFAULT";
#line 4006 "Dimensions.c"
		}
#line 647 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp10_ = named_modes;
#line 647 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp11_ = _tmp8_;
#line 647 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp12_ = g_strconcat (_tmp10_, _tmp11_, NULL);
#line 647 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_g_free0 (named_modes);
#line 647 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		named_modes = _tmp12_;
#line 4018 "Dimensions.c"
	}
#line 648 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp13_ = zoom_state_is_isomorphic (&(*self));
#line 648 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	if (_tmp13_) {
#line 4024 "Dimensions.c"
		const gchar* _tmp14_ = NULL;
		const gchar* _tmp15_;
		const gchar* _tmp16_;
		const gchar* _tmp17_;
		gchar* _tmp18_;
#line 649 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp15_ = named_modes;
#line 649 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		if (g_strcmp0 (_tmp15_, "") == 0) {
#line 649 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
			_tmp14_ = "ISOMORPHIC";
#line 4036 "Dimensions.c"
		} else {
#line 649 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
			_tmp14_ = ", ISOMORPHIC";
#line 4040 "Dimensions.c"
		}
#line 649 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp16_ = named_modes;
#line 649 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp17_ = _tmp14_;
#line 649 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp18_ = g_strconcat (_tmp16_, _tmp17_, NULL);
#line 649 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_g_free0 (named_modes);
#line 649 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		named_modes = _tmp18_;
#line 4052 "Dimensions.c"
	}
#line 650 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp19_ = zoom_state_is_max (&(*self));
#line 650 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	if (_tmp19_) {
#line 4058 "Dimensions.c"
		const gchar* _tmp20_ = NULL;
		const gchar* _tmp21_;
		const gchar* _tmp22_;
		const gchar* _tmp23_;
		gchar* _tmp24_;
#line 651 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp21_ = named_modes;
#line 651 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		if (g_strcmp0 (_tmp21_, "") == 0) {
#line 651 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
			_tmp20_ = "MAX";
#line 4070 "Dimensions.c"
		} else {
#line 651 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
			_tmp20_ = ", MAX";
#line 4074 "Dimensions.c"
		}
#line 651 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp22_ = named_modes;
#line 651 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp23_ = _tmp20_;
#line 651 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp24_ = g_strconcat (_tmp22_, _tmp23_, NULL);
#line 651 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_g_free0 (named_modes);
#line 651 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		named_modes = _tmp24_;
#line 4086 "Dimensions.c"
	}
#line 652 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp25_ = named_modes;
#line 652 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	if (g_strcmp0 (_tmp25_, "") == 0) {
#line 4092 "Dimensions.c"
		gchar* _tmp26_;
#line 653 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_tmp26_ = g_strdup ("(none)");
#line 653 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		_g_free0 (named_modes);
#line 653 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		named_modes = _tmp26_;
#line 4100 "Dimensions.c"
	}
#line 655 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	zoom_state_get_viewing_rectangle_wrt_content (&(*self), &_tmp27_);
#line 655 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	viewing_rect = _tmp27_;
#line 657 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp28_ = (*self).content_dimensions;
#line 657 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp29_ = _tmp28_.width;
#line 657 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp30_ = (*self).content_dimensions;
#line 657 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp31_ = _tmp30_.height;
#line 657 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp32_ = (*self).viewport_dimensions;
#line 657 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp33_ = _tmp32_.width;
#line 657 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp34_ = (*self).viewport_dimensions;
#line 657 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp35_ = _tmp34_.height;
#line 657 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp36_ = (*self).min_factor;
#line 657 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp37_ = (*self).max_factor;
#line 657 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp38_ = (*self).zoom_factor;
#line 657 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp39_ = zoom_state_get_zoomed_width (&(*self));
#line 657 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp40_ = zoom_state_get_zoomed_height (&(*self));
#line 657 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp41_ = named_modes;
#line 657 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp42_ = viewing_rect;
#line 657 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp43_ = _tmp42_.x;
#line 657 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp44_ = viewing_rect;
#line 657 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp45_ = _tmp44_.y;
#line 657 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp46_ = viewing_rect;
#line 657 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp47_ = _tmp46_.width;
#line 657 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp48_ = viewing_rect;
#line 657 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp49_ = _tmp48_.height;
#line 657 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp50_ = (*self).viewport_center;
#line 657 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp51_ = _tmp50_.x;
#line 657 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp52_ = (*self).viewport_center;
#line 657 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp53_ = _tmp52_.y;
#line 657 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp54_ = g_strdup_printf ("ZoomState {\n" \
"    content dimensions = %d x %d;\n" \
"    viewport dimensions = " "%d x %d;\n" \
"    min factor = %f;\n" \
"    max factor = %f;\n" \
"    current factor = %f;" "\n" \
"    zoomed width = %d;\n" \
"    zoomed height = %d;\n" \
"    named modes = %s;" "\n    viewing rectangle = { x: %d, y: %d, width: %d, height: %d };" "\n    viewport center = (%d, %d);\n}\n", _tmp29_, _tmp31_, _tmp33_, _tmp35_, _tmp36_, _tmp37_, _tmp38_, _tmp39_, _tmp40_, _tmp41_, _tmp43_, _tmp45_, _tmp47_, _tmp49_, _tmp51_, _tmp53_);
#line 657 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	result = _tmp54_;
#line 657 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_g_free0 (named_modes);
#line 657 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	return result;
#line 4166 "Dimensions.c"
}


gboolean zoom_state_is_min (ZoomState *self) {
	gboolean result = FALSE;
	gdouble _tmp0_;
	gdouble _tmp1_;
#line 669 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp0_ = (*self).zoom_factor;
#line 669 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp1_ = (*self).min_factor;
#line 669 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	result = _tmp0_ == _tmp1_;
#line 669 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	return result;
#line 4182 "Dimensions.c"
}


gboolean zoom_state_is_default (ZoomState *self) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
#line 673 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp0_ = zoom_state_is_min (&(*self));
#line 673 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	result = _tmp0_;
#line 673 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	return result;
#line 4195 "Dimensions.c"
}


gboolean zoom_state_is_max (ZoomState *self) {
	gboolean result = FALSE;
	gdouble _tmp0_;
	gdouble _tmp1_;
#line 677 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp0_ = (*self).zoom_factor;
#line 677 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp1_ = (*self).max_factor;
#line 677 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	result = _tmp0_ == _tmp1_;
#line 677 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	return result;
#line 4211 "Dimensions.c"
}


gboolean zoom_state_is_isomorphic (ZoomState *self) {
	gboolean result = FALSE;
	gdouble _tmp0_;
#line 681 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp0_ = (*self).zoom_factor;
#line 681 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	result = _tmp0_ == 1.0;
#line 681 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	return result;
#line 4224 "Dimensions.c"
}


gboolean zoom_state_equals (ZoomState *self, ZoomState* other) {
	gboolean result = FALSE;
	ZoomState _tmp0_;
	Dimensions _tmp1_;
	gboolean _tmp2_ = FALSE;
	ZoomState _tmp3_;
	Dimensions _tmp4_;
	gboolean _tmp5_ = FALSE;
	gdouble _tmp6_;
	ZoomState _tmp7_;
	gdouble _tmp8_;
	gdouble _tmp9_;
	ZoomState _tmp10_;
	gdouble _tmp11_;
	gdouble _tmp12_;
	ZoomState _tmp13_;
	gdouble _tmp14_;
	GdkPoint _tmp15_;
	gint _tmp16_;
	ZoomState _tmp17_;
	GdkPoint _tmp18_;
	gint _tmp19_;
	GdkPoint _tmp20_;
	gint _tmp21_;
	ZoomState _tmp22_;
	GdkPoint _tmp23_;
	gint _tmp24_;
#line 684 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	g_return_val_if_fail (other != NULL, FALSE);
#line 685 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp0_ = *other;
#line 685 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp1_ = _tmp0_.content_dimensions;
#line 685 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp2_ = dimensions_equals (&(*self).content_dimensions, &_tmp1_);
#line 685 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	if (!_tmp2_) {
#line 686 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		result = FALSE;
#line 686 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		return result;
#line 4269 "Dimensions.c"
	}
#line 687 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp3_ = *other;
#line 687 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp4_ = _tmp3_.viewport_dimensions;
#line 687 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp5_ = dimensions_equals (&(*self).viewport_dimensions, &_tmp4_);
#line 687 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	if (!_tmp5_) {
#line 688 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		result = FALSE;
#line 688 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		return result;
#line 4283 "Dimensions.c"
	}
#line 689 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp6_ = (*self).zoom_factor;
#line 689 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp7_ = *other;
#line 689 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp8_ = _tmp7_.zoom_factor;
#line 689 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	if (_tmp6_ != _tmp8_) {
#line 690 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		result = FALSE;
#line 690 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		return result;
#line 4297 "Dimensions.c"
	}
#line 691 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp9_ = (*self).min_factor;
#line 691 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp10_ = *other;
#line 691 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp11_ = _tmp10_.min_factor;
#line 691 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	if (_tmp9_ != _tmp11_) {
#line 692 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		result = FALSE;
#line 692 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		return result;
#line 4311 "Dimensions.c"
	}
#line 693 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp12_ = (*self).max_factor;
#line 693 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp13_ = *other;
#line 693 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp14_ = _tmp13_.max_factor;
#line 693 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	if (_tmp12_ != _tmp14_) {
#line 694 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		result = FALSE;
#line 694 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		return result;
#line 4325 "Dimensions.c"
	}
#line 695 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp15_ = (*self).viewport_center;
#line 695 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp16_ = _tmp15_.x;
#line 695 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp17_ = *other;
#line 695 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp18_ = _tmp17_.viewport_center;
#line 695 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp19_ = _tmp18_.x;
#line 695 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	if (_tmp16_ != _tmp19_) {
#line 696 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		result = FALSE;
#line 696 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		return result;
#line 4343 "Dimensions.c"
	}
#line 697 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp20_ = (*self).viewport_center;
#line 697 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp21_ = _tmp20_.y;
#line 697 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp22_ = *other;
#line 697 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp23_ = _tmp22_.viewport_center;
#line 697 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	_tmp24_ = _tmp23_.y;
#line 697 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	if (_tmp21_ != _tmp24_) {
#line 698 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		result = FALSE;
#line 698 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
		return result;
#line 4361 "Dimensions.c"
	}
#line 700 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	result = TRUE;
#line 700 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	return result;
#line 4367 "Dimensions.c"
}


ZoomState* zoom_state_dup (const ZoomState* self) {
	ZoomState* dup;
#line 434 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	dup = g_new0 (ZoomState, 1);
#line 434 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	memcpy (dup, self, sizeof (ZoomState));
#line 434 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	return dup;
#line 4379 "Dimensions.c"
}


void zoom_state_free (ZoomState* self) {
#line 434 "/builddir/build/BUILD/shotwell-0.10.1/src/Dimensions.vala"
	g_free (self);
#line 4386 "Dimensions.c"
}


GType zoom_state_get_type (void) {
	static volatile gsize zoom_state_type_id__volatile = 0;
	if (g_once_init_enter (&zoom_state_type_id__volatile)) {
		GType zoom_state_type_id;
		zoom_state_type_id = g_boxed_type_register_static ("ZoomState", (GBoxedCopyFunc) zoom_state_dup, (GBoxedFreeFunc) zoom_state_free);
		g_once_init_leave (&zoom_state_type_id__volatile, zoom_state_type_id);
	}
	return zoom_state_type_id__volatile;
}



