/* DirectoryMonitor.c generated by valac 0.14.2, the Vala compiler
 * generated from DirectoryMonitor.vala, do not modify */

/* Copyright 2009-2011 Yorba Foundation
 *
 * This software is licensed under the GNU LGPL (version 2.1 or later).
 * See the COPYING file in this distribution. 
 */
/**/
/* DirectoryMonitor will monitor an entire directory for changes to all files and directories*/
/* within it.  It uses FileMonitor to monitor all directories it discovers at initialization*/
/* and reports changes to the files and directories just as FileMonitor reports them.  Subclasses*/
/* can override the notify_* methods to filter or monitor events before the signal is fired,*/
/* or can override the signals themselves to be notified afterwards.*/
/**/
/* start_discovery() must be called to initiate monitoring.  Directories and files will be reported*/
/* as they're discovered.  Directories will be monitored as they're discovered as well.  Discovery*/
/* can only be initiated once.*/
/**/
/* All signals are virtual and have a corresponding notify_* protected virtual function.*/
/* Subclasses can either override the notify or the signal to decide when they want to process*/
/* the event.*/
/**/
/* DirectoryMonitor also adds a level of intelligence to GLib's monitoring API.Because certain*/
/* file/directory events are decomposed by FileMonitor into more atomic events, it's difficult*/
/* to know when these "composed" events have occurred.  (For example, a file move is reported*/
/* as a DELETED event followed by a CREATED event, with no clue that the two are related.)  Later*/
/* versions added the MOVE event, but we can't rely on those being installed.  Also, documentation*/
/* suggests it's only available with certain back-ends.*/
/**/
/* DirectoryMonitor attempts to solve this by deducing when a set of events actually equals*/
/* a composite event.  It requires more memory in order to do this (i.e. it stores all files and*/
/* their information), but the trade-off is easier file/directory monitoring via familiar*/
/* semantics.*/
/**/
/* DirectoryMonitor also will synthesize events when normal monitor events don't produce expected*/
/* results.  For example, if a directory is moved out of DirectoryMonitor's root, it is reported*/
/* as a delete event, but none of its children are reported as deleted.  Similarly, a directory*/
/* rename can be captured as a move, but notifications for all its children are not fired and*/
/* are synthesized by DirectoryMonitor.  DirectoryMonitor will fire delete and move notifications*/
/* for all the directory's children in depth-first order.*/
/**/
/* In general, DirectoryMonitor attempts to preserve ordering of events, so that (for example) a*/
/* file-altered event doesn't fire before a file-created, and so on.*/
/**/
/* Because of these requirements, DirectoryMonitor maintains a FileInfo struct on all directories */
/* and files being monitored.  (It maintains the attributes gather during the discovery phase, i.e. */
/* SUPPLIED_ATTRIBUTES.)  This information can be retrieved via get_info(), get_file_id(), and*/
/* get_etag().  These calls can be made at any time; the information is stored before any signal*/
/* is fired.*/
/**/
/* Note that DirectoryMonitor currently only supports files and directories.  Other file types*/
/* (special, symbolic links, shortcuts, and mount points) are not supported.  It has been seen*/
/* when a temporary file is created for its file type to be reported as "unknown" and when it's*/
/* altered/deleted to be reported as a regular file.  This means it's possible for a file not to*/
/* be reported as discovered or created but to be reported as altered and/or deleted.*/
/**/
/* DirectoryMonitor can be configured to not recurse (in which case it only discovers/monitors*/
/* the root directory) and to not monitor (in which case only discovery occurs).*/
/**/

#include <glib.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <gee.h>
#include <glib/gi18n-lib.h>
#include <gobject/gvaluecollector.h>


#define TYPE_DIRECTORY_MONITOR (directory_monitor_get_type ())
#define DIRECTORY_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DIRECTORY_MONITOR, DirectoryMonitor))
#define DIRECTORY_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DIRECTORY_MONITOR, DirectoryMonitorClass))
#define IS_DIRECTORY_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DIRECTORY_MONITOR))
#define IS_DIRECTORY_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DIRECTORY_MONITOR))
#define DIRECTORY_MONITOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DIRECTORY_MONITOR, DirectoryMonitorClass))

typedef struct _DirectoryMonitor DirectoryMonitor;
typedef struct _DirectoryMonitorClass DirectoryMonitorClass;
typedef struct _DirectoryMonitorPrivate DirectoryMonitorPrivate;

#define DIRECTORY_MONITOR_TYPE_QUERY_INFO_QUEUE_ELEMENT (directory_monitor_query_info_queue_element_get_type ())
#define DIRECTORY_MONITOR_QUERY_INFO_QUEUE_ELEMENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DIRECTORY_MONITOR_TYPE_QUERY_INFO_QUEUE_ELEMENT, DirectoryMonitorQueryInfoQueueElement))
#define DIRECTORY_MONITOR_QUERY_INFO_QUEUE_ELEMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DIRECTORY_MONITOR_TYPE_QUERY_INFO_QUEUE_ELEMENT, DirectoryMonitorQueryInfoQueueElementClass))
#define DIRECTORY_MONITOR_IS_QUERY_INFO_QUEUE_ELEMENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DIRECTORY_MONITOR_TYPE_QUERY_INFO_QUEUE_ELEMENT))
#define DIRECTORY_MONITOR_IS_QUERY_INFO_QUEUE_ELEMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DIRECTORY_MONITOR_TYPE_QUERY_INFO_QUEUE_ELEMENT))
#define DIRECTORY_MONITOR_QUERY_INFO_QUEUE_ELEMENT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DIRECTORY_MONITOR_TYPE_QUERY_INFO_QUEUE_ELEMENT, DirectoryMonitorQueryInfoQueueElementClass))

typedef struct _DirectoryMonitorQueryInfoQueueElement DirectoryMonitorQueryInfoQueueElement;
typedef struct _DirectoryMonitorQueryInfoQueueElementClass DirectoryMonitorQueryInfoQueueElementClass;

#define DIRECTORY_MONITOR_TYPE_FILE_INFO_MAP (directory_monitor_file_info_map_get_type ())
#define DIRECTORY_MONITOR_FILE_INFO_MAP(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DIRECTORY_MONITOR_TYPE_FILE_INFO_MAP, DirectoryMonitorFileInfoMap))
#define DIRECTORY_MONITOR_FILE_INFO_MAP_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DIRECTORY_MONITOR_TYPE_FILE_INFO_MAP, DirectoryMonitorFileInfoMapClass))
#define DIRECTORY_MONITOR_IS_FILE_INFO_MAP(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DIRECTORY_MONITOR_TYPE_FILE_INFO_MAP))
#define DIRECTORY_MONITOR_IS_FILE_INFO_MAP_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DIRECTORY_MONITOR_TYPE_FILE_INFO_MAP))
#define DIRECTORY_MONITOR_FILE_INFO_MAP_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DIRECTORY_MONITOR_TYPE_FILE_INFO_MAP, DirectoryMonitorFileInfoMapClass))

typedef struct _DirectoryMonitorFileInfoMap DirectoryMonitorFileInfoMap;
typedef struct _DirectoryMonitorFileInfoMapClass DirectoryMonitorFileInfoMapClass;

#define DIRECTORY_MONITOR_TYPE_FTYPE (directory_monitor_ftype_get_type ())
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _directory_monitor_file_info_map_unref0(var) ((var == NULL) ? NULL : (var = (directory_monitor_file_info_map_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _DirectoryMonitorAsyncInternalNotifyDirectoryMovedData DirectoryMonitorAsyncInternalNotifyDirectoryMovedData;
typedef struct _DirectoryMonitorAsyncNotifyDirectoryDeletedData DirectoryMonitorAsyncNotifyDirectoryDeletedData;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define __g_list_free__g_object_unref0_0(var) ((var == NULL) ? NULL : (var = (_g_list_free__g_object_unref0_ (var), NULL)))
typedef struct _DirectoryMonitorExploreAsyncData DirectoryMonitorExploreAsyncData;
typedef struct _DirectoryMonitorNotifyDirectoryFilesData DirectoryMonitorNotifyDirectoryFilesData;
typedef struct _DirectoryMonitorQueryInfoQueueElementPrivate DirectoryMonitorQueryInfoQueueElementPrivate;
#define _directory_monitor_query_info_queue_element_unref0(var) ((var == NULL) ? NULL : (var = (directory_monitor_query_info_queue_element_unref (var), NULL)))
typedef struct _DirectoryMonitorParamSpecQueryInfoQueueElement DirectoryMonitorParamSpecQueryInfoQueueElement;
typedef struct _DirectoryMonitorFileInfoMapPrivate DirectoryMonitorFileInfoMapPrivate;
typedef struct _DirectoryMonitorParamSpecFileInfoMap DirectoryMonitorParamSpecFileInfoMap;

struct _DirectoryMonitor {
	GObject parent_instance;
	DirectoryMonitorPrivate * priv;
};

struct _DirectoryMonitorClass {
	GObjectClass parent_class;
	void (*notify_root_deleted) (DirectoryMonitor* self, GFile* root);
	void (*notify_root_moved) (DirectoryMonitor* self, GFile* old_root, GFile* new_root, GFileInfo* new_root_info);
	void (*notify_discovery_started) (DirectoryMonitor* self);
	void (*internal_notify_file_discovered) (DirectoryMonitor* self, GFile* file, GFileInfo* info);
	void (*notify_file_discovered) (DirectoryMonitor* self, GFile* file, GFileInfo* info);
	void (*internal_notify_directory_discovered) (DirectoryMonitor* self, GFile* dir, GFileInfo* info);
	void (*notify_directory_discovered) (DirectoryMonitor* self, GFile* dir, GFileInfo* info);
	void (*notify_discovery_failed) (DirectoryMonitor* self, const gchar* reason);
	void (*notify_discovery_completed) (DirectoryMonitor* self);
	void (*notify_file_created) (DirectoryMonitor* self, GFile* file, GFileInfo* info);
	void (*notify_file_moved) (DirectoryMonitor* self, GFile* old_file, GFile* new_file, GFileInfo* new_file_info);
	void (*notify_file_altered) (DirectoryMonitor* self, GFile* file);
	void (*notify_file_alteration_completed) (DirectoryMonitor* self, GFile* file, GFileInfo* info);
	void (*notify_file_attributes_altered) (DirectoryMonitor* self, GFile* file);
	void (*notify_file_deleted) (DirectoryMonitor* self, GFile* file);
	void (*notify_directory_created) (DirectoryMonitor* self, GFile* dir, GFileInfo* info);
	void (*notify_directory_moved) (DirectoryMonitor* self, GFile* old_dir, GFile* new_dir, GFileInfo* new_dir_info);
	void (*notify_directory_altered) (DirectoryMonitor* self, GFile* dir);
	void (*notify_directory_alteration_completed) (DirectoryMonitor* self, GFile* dir, GFileInfo* info);
	void (*notify_directory_attributes_altered) (DirectoryMonitor* self, GFile* dir);
	void (*notify_directory_deleted) (DirectoryMonitor* self, GFile* dir);
	void (*notify_closed) (DirectoryMonitor* self);
	void (*close) (DirectoryMonitor* self);
	void (*root_moved) (DirectoryMonitor* self, GFile* old_root, GFile* new_root, GFileInfo* new_root_info);
	void (*root_deleted) (DirectoryMonitor* self, GFile* root);
	void (*discovery_started) (DirectoryMonitor* self);
	void (*file_discovered) (DirectoryMonitor* self, GFile* file, GFileInfo* info);
	void (*directory_discovered) (DirectoryMonitor* self, GFile* file, GFileInfo* info);
	void (*discovery_failed) (DirectoryMonitor* self, const gchar* reason);
	void (*discovery_completed) (DirectoryMonitor* self);
	void (*file_created) (DirectoryMonitor* self, GFile* file, GFileInfo* info);
	void (*file_moved) (DirectoryMonitor* self, GFile* old_file, GFile* new_file, GFileInfo* new_file_info);
	void (*file_altered) (DirectoryMonitor* self, GFile* file);
	void (*file_alteration_completed) (DirectoryMonitor* self, GFile* file, GFileInfo* info);
	void (*file_attributes_altered) (DirectoryMonitor* self, GFile* file);
	void (*file_deleted) (DirectoryMonitor* self, GFile* file);
	void (*directory_created) (DirectoryMonitor* self, GFile* dir, GFileInfo* info);
	void (*directory_moved) (DirectoryMonitor* self, GFile* old_dir, GFile* new_dir, GFileInfo* new_dir_info);
	void (*directory_altered) (DirectoryMonitor* self, GFile* dir);
	void (*directory_alteration_completed) (DirectoryMonitor* self, GFile* dir, GFileInfo* info);
	void (*directory_attributes_altered) (DirectoryMonitor* self, GFile* dir);
	void (*directory_deleted) (DirectoryMonitor* self, GFile* dir);
	void (*closed) (DirectoryMonitor* self);
};

struct _DirectoryMonitorPrivate {
	GFile* root;
	gboolean recurse;
	gboolean monitoring;
	GeeHashMap* monitors;
	GeeQueue* query_info_queue;
	DirectoryMonitorFileInfoMap* files;
	DirectoryMonitorFileInfoMap* parent_moved;
	GCancellable* cancellable;
	gint outstanding_exploration_dirs;
	gboolean started;
	gboolean has_discovery_started;
	guint delete_timer_id;
};

typedef enum  {
	DIRECTORY_MONITOR_FTYPE_FILE,
	DIRECTORY_MONITOR_FTYPE_DIRECTORY,
	DIRECTORY_MONITOR_FTYPE_UNSUPPORTED
} DirectoryMonitorFType;

struct _DirectoryMonitorAsyncInternalNotifyDirectoryMovedData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GSimpleAsyncResult* _async_result;
	DirectoryMonitor* self;
	GFile* old_dir;
	GFileInfo* old_dir_info;
	GFile* new_dir;
	GFileInfo* new_dir_info;
	GEqualFunc _tmp0_;
	GeeArrayList* _tmp1_;
	GeeArrayList* file_children;
	GEqualFunc _tmp2_;
	GeeArrayList* _tmp3_;
	GeeArrayList* dir_children;
	DirectoryMonitorFileInfoMap* _tmp4_;
	GFile* _tmp5_;
	GeeArrayList* _tmp6_;
	GeeArrayList* _tmp7_;
	gint _tmp8_;
	gint count;
	gint _tmp9_;
	GeeArrayList* _tmp10_;
	GeeArrayList* _tmp11_;
	GeeArrayList* _dir_child_list;
	GeeArrayList* _tmp12_;
	gint _tmp13_;
	gint _tmp14_;
	gint _dir_child_size;
	gint _dir_child_index;
	gint _tmp15_;
	gint _tmp16_;
	gint _tmp17_;
	GeeArrayList* _tmp18_;
	gint _tmp19_;
	gpointer _tmp20_;
	GFile* dir_child;
	DirectoryMonitorFileInfoMap* _tmp21_;
	GFile* _tmp22_;
	GFileInfo* _tmp23_;
	GFileInfo* dir_info;
	GFileInfo* _tmp24_;
	GFile* _tmp25_;
	gchar* _tmp26_;
	gchar* _tmp27_;
	GFile* _tmp28_;
	GFileInfo* _tmp29_;
	GFile* _tmp30_;
	GFile* _tmp31_;
	gchar* _tmp32_;
	gchar* _tmp33_;
	GFile* _tmp34_;
	GFile* _tmp35_;
	GFileInfo* _tmp36_;
	GeeArrayList* _tmp37_;
	GeeArrayList* _tmp38_;
	GeeArrayList* _file_child_list;
	GeeArrayList* _tmp39_;
	gint _tmp40_;
	gint _tmp41_;
	gint _file_child_size;
	gint _file_child_index;
	gint _tmp42_;
	gint _tmp43_;
	gint _tmp44_;
	GeeArrayList* _tmp45_;
	gint _tmp46_;
	gpointer _tmp47_;
	GFile* file_child;
	DirectoryMonitorFileInfoMap* _tmp48_;
	GFile* _tmp49_;
	GFileInfo* _tmp50_;
	GFileInfo* file_info;
	GFileInfo* _tmp51_;
	GFile* _tmp52_;
	gchar* _tmp53_;
	gchar* _tmp54_;
	GFile* _tmp55_;
	GFile* _tmp56_;
	GFile* _tmp57_;
	gchar* _tmp58_;
	gchar* _tmp59_;
	GFile* _tmp60_;
	GFile* _tmp61_;
	GFileInfo* _tmp62_;
	DirectoryMonitorFileInfoMap* _tmp63_;
	GFile* _tmp64_;
	DirectoryMonitorFileInfoMap* _tmp65_;
	GFile* _tmp66_;
	GFileInfo* _tmp67_;
	gboolean _tmp68_;
	gboolean updated;
	GFile* _tmp69_;
	GFileInfo* _tmp70_;
	GFile* _tmp71_;
	GFileInfo* _tmp72_;
	GFile* _tmp73_;
	GFile* _tmp74_;
	GFileInfo* _tmp75_;
};

struct _DirectoryMonitorAsyncNotifyDirectoryDeletedData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GSimpleAsyncResult* _async_result;
	DirectoryMonitor* self;
	GFile* dir;
	gboolean already_removed;
	GEqualFunc _tmp0_;
	GeeArrayList* _tmp1_;
	GeeArrayList* file_children;
	GEqualFunc _tmp2_;
	GeeArrayList* _tmp3_;
	GeeArrayList* dir_children;
	DirectoryMonitorFileInfoMap* _tmp4_;
	GFile* _tmp5_;
	GeeArrayList* _tmp6_;
	GeeArrayList* _tmp7_;
	gint _tmp8_;
	gint count;
	gint _tmp9_;
	GeeArrayList* _tmp10_;
	GeeArrayList* _tmp11_;
	GeeArrayList* _dir_child_list;
	GeeArrayList* _tmp12_;
	gint _tmp13_;
	gint _tmp14_;
	gint _dir_child_size;
	gint _dir_child_index;
	gint _tmp15_;
	gint _tmp16_;
	gint _tmp17_;
	GeeArrayList* _tmp18_;
	gint _tmp19_;
	gpointer _tmp20_;
	GFile* dir_child;
	GFile* _tmp21_;
	GeeArrayList* _tmp22_;
	GeeArrayList* _tmp23_;
	GeeArrayList* _file_child_list;
	GeeArrayList* _tmp24_;
	gint _tmp25_;
	gint _tmp26_;
	gint _file_child_size;
	gint _file_child_index;
	gint _tmp27_;
	gint _tmp28_;
	gint _tmp29_;
	GeeArrayList* _tmp30_;
	gint _tmp31_;
	gpointer _tmp32_;
	GFile* file_child;
	DirectoryMonitorFileInfoMap* _tmp33_;
	GFile* _tmp34_;
	GFile* _tmp35_;
	gboolean _tmp36_;
	DirectoryMonitorFileInfoMap* _tmp37_;
	GFile* _tmp38_;
	GFile* _tmp39_;
};

struct _DirectoryMonitorExploreAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GSimpleAsyncResult* _async_result;
	DirectoryMonitor* self;
	GFile* dir;
	GFileInfo* dir_info;
	gboolean in_discovery;
	DirectoryMonitorFileInfoMap* _tmp0_;
	GFile* _tmp1_;
	GFileInfo* _tmp2_;
	gboolean _tmp3_;
	GFile* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gboolean _tmp7_;
	GFileInfo* _tmp8_;
	GFileInfo* _tmp9_;
	GFileInfo* local_dir_info;
	GFileInfo* _tmp10_;
	GFile* _tmp11_;
	GCancellable* _tmp12_;
	GFileInfo* _tmp13_;
	GFileInfo* _tmp14_;
	GError* err;
	GFile* _tmp15_;
	gchar* _tmp16_;
	gchar* _tmp17_;
	GError* _tmp18_;
	const gchar* _tmp19_;
	gboolean _tmp20_;
	GFileInfo* _tmp21_;
	gboolean _tmp22_;
	GFile* _tmp23_;
	gchar* _tmp24_;
	gchar* _tmp25_;
	gboolean _tmp26_;
	GFileInfo* _tmp27_;
	gchar* _tmp28_;
	gchar* _tmp29_;
	gboolean _tmp30_;
	GFile* _tmp31_;
	gchar* _tmp32_;
	gchar* _tmp33_;
	gboolean _tmp34_;
	GFileInfo* _tmp35_;
	GFileType _tmp36_;
	const gchar* _tmp37_;
	GFile* _tmp38_;
	gchar* _tmp39_;
	gchar* _tmp40_;
	GFileInfo* _tmp41_;
	GFileType _tmp42_;
	GEnumValue* _tmp43_;
	gchar* _tmp44_;
	gchar* _tmp45_;
	gboolean _tmp46_;
	GeeHashMap* dir_map;
	GeeHashMap* file_map;
	GFile* _tmp47_;
	GCancellable* _tmp48_;
	GFileEnumerator* _tmp49_;
	GFileEnumerator* enumerator;
	gboolean _tmp50_;
	gboolean _tmp51_;
	GFileEnumerator* _tmp52_;
	GCancellable* _tmp53_;
	GList* _tmp54_;
	GList* infos;
	GList* _tmp55_;
	GList* _tmp56_;
	GList* info_collection;
	GList* info_it;
	GFileInfo* _tmp57_;
	GFileInfo* info;
	GFileInfo* _tmp58_;
	gboolean _tmp59_;
	GFile* _tmp60_;
	GFileInfo* _tmp61_;
	const gchar* _tmp62_;
	GFile* _tmp63_;
	GFile* _tmp64_;
	gchar* _tmp65_;
	gchar* _tmp66_;
	GFileInfo* _tmp67_;
	gboolean _tmp68_;
	GFileInfo* _tmp69_;
	GFileType _tmp70_;
	GeeHashMap* _tmp71_;
	GHashFunc _tmp72_;
	GEqualFunc _tmp73_;
	GeeHashMap* _tmp74_;
	GeeHashMap* _tmp75_;
	GFile* _tmp76_;
	GFileInfo* _tmp77_;
	const gchar* _tmp78_;
	GFile* _tmp79_;
	GFile* _tmp80_;
	GFileInfo* _tmp81_;
	GeeHashMap* _tmp82_;
	GHashFunc _tmp83_;
	GEqualFunc _tmp84_;
	GeeHashMap* _tmp85_;
	GeeHashMap* _tmp86_;
	GFile* _tmp87_;
	GFileInfo* _tmp88_;
	const gchar* _tmp89_;
	GFile* _tmp90_;
	GFile* _tmp91_;
	GFileInfo* _tmp92_;
	GError* err2;
	GFile* _tmp93_;
	gchar* _tmp94_;
	gchar* _tmp95_;
	GError* _tmp96_;
	const gchar* _tmp97_;
	gboolean _tmp98_;
	gboolean _tmp99_;
	GFile* _tmp100_;
	GFileInfo* _tmp101_;
	GFile* _tmp102_;
	GFileInfo* _tmp103_;
	GFile* _tmp104_;
	GFileInfo* _tmp105_;
	GeeHashMap* _tmp106_;
	GeeHashMap* _tmp107_;
	gboolean _tmp108_;
	gboolean _tmp109_;
	gboolean _tmp110_;
	GeeHashMap* _tmp111_;
	gboolean _tmp112_;
	GeeHashMap* _tmp113_;
	GeeSet* _tmp114_;
	GeeSet* _tmp115_;
	GeeSet* _tmp116_;
	GeeIterator* _tmp117_;
	GeeIterator* _tmp118_;
	GeeIterator* _subdir_it;
	GeeIterator* _tmp119_;
	gboolean _tmp120_;
	GeeIterator* _tmp121_;
	gpointer _tmp122_;
	GFile* subdir;
	gint _tmp123_;
	gint _tmp124_;
	GFile* _tmp125_;
	GeeHashMap* _tmp126_;
	GFile* _tmp127_;
	gpointer _tmp128_;
	GFileInfo* _tmp129_;
	gboolean _tmp130_;
	GFile* _tmp131_;
	GeeHashMap* _tmp132_;
	GFile* _tmp133_;
	gpointer _tmp134_;
	GFileInfo* _tmp135_;
	gboolean _tmp136_;
	gboolean _tmp137_;
	GError * _inner_error_;
};

struct _DirectoryMonitorNotifyDirectoryFilesData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GSimpleAsyncResult* _async_result;
	DirectoryMonitor* self;
	GeeMap* map;
	gboolean in_discovery;
	GeeMap* _tmp0_;
	GeeMapIterator* _tmp1_;
	GeeMapIterator* iter;
	GeeMapIterator* _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_;
	GeeMapIterator* _tmp5_;
	gpointer _tmp6_;
	GFile* _tmp7_;
	GeeMapIterator* _tmp8_;
	gpointer _tmp9_;
	GFileInfo* _tmp10_;
	GeeMapIterator* _tmp11_;
	gpointer _tmp12_;
	GFile* _tmp13_;
	GeeMapIterator* _tmp14_;
	gpointer _tmp15_;
	GFileInfo* _tmp16_;
};

struct _DirectoryMonitorQueryInfoQueueElement {
	GTypeInstance parent_instance;
	volatile int ref_count;
	DirectoryMonitorQueryInfoQueueElementPrivate * priv;
	DirectoryMonitor* owner;
	GFile* file;
	GFile* other_file;
	GFileMonitorEvent event;
	guint position;
	gulong time_created_msec;
	GFileInfo* info;
	GError* err;
	gboolean completed;
};

struct _DirectoryMonitorQueryInfoQueueElementClass {
	GTypeClass parent_class;
	void (*finalize) (DirectoryMonitorQueryInfoQueueElement *self);
};

struct _DirectoryMonitorParamSpecQueryInfoQueueElement {
	GParamSpec parent_instance;
};

struct _DirectoryMonitorFileInfoMap {
	GTypeInstance parent_instance;
	volatile int ref_count;
	DirectoryMonitorFileInfoMapPrivate * priv;
};

struct _DirectoryMonitorFileInfoMapClass {
	GTypeClass parent_class;
	void (*finalize) (DirectoryMonitorFileInfoMap *self);
};

struct _DirectoryMonitorFileInfoMapPrivate {
	GeeHashMap* map;
	GeeHashMap* id_map;
};

struct _DirectoryMonitorParamSpecFileInfoMap {
	GParamSpec parent_instance;
};


static gpointer directory_monitor_parent_class = NULL;
static gpointer directory_monitor_query_info_queue_element_parent_class = NULL;
static guint directory_monitor_query_info_queue_element_current;
static guint directory_monitor_query_info_queue_element_current = (guint) 0;
static gpointer directory_monitor_file_info_map_parent_class = NULL;

GType directory_monitor_get_type (void) G_GNUC_CONST;
static gpointer directory_monitor_query_info_queue_element_ref (gpointer instance);
static void directory_monitor_query_info_queue_element_unref (gpointer instance);
static GParamSpec* directory_monitor_param_spec_query_info_queue_element (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) G_GNUC_UNUSED;
static void directory_monitor_value_set_query_info_queue_element (GValue* value, gpointer v_object) G_GNUC_UNUSED;
static void directory_monitor_value_take_query_info_queue_element (GValue* value, gpointer v_object) G_GNUC_UNUSED;
static gpointer directory_monitor_value_get_query_info_queue_element (const GValue* value) G_GNUC_UNUSED;
static GType directory_monitor_query_info_queue_element_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
static gpointer directory_monitor_file_info_map_ref (gpointer instance);
static void directory_monitor_file_info_map_unref (gpointer instance);
static GParamSpec* directory_monitor_param_spec_file_info_map (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) G_GNUC_UNUSED;
static void directory_monitor_value_set_file_info_map (GValue* value, gpointer v_object) G_GNUC_UNUSED;
static void directory_monitor_value_take_file_info_map (GValue* value, gpointer v_object) G_GNUC_UNUSED;
static gpointer directory_monitor_value_get_file_info_map (const GValue* value) G_GNUC_UNUSED;
static GType directory_monitor_file_info_map_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
#define DIRECTORY_MONITOR_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_DIRECTORY_MONITOR, DirectoryMonitorPrivate))
enum  {
	DIRECTORY_MONITOR_DUMMY_PROPERTY
};
static GType directory_monitor_ftype_get_type (void) G_GNUC_UNUSED;
static DirectoryMonitorFileInfoMap* directory_monitor_file_info_map_new (void);
static DirectoryMonitorFileInfoMap* directory_monitor_file_info_map_construct (GType object_type);
#define DIRECTORY_MONITOR_DEFAULT_PRIORITY G_PRIORITY_LOW
#define DIRECTORY_MONITOR_DIR_INFO_FLAGS G_FILE_QUERY_INFO_NONE
#define DIRECTORY_MONITOR_FILE_INFO_FLAGS G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS
#define DIRECTORY_MONITOR_UNKNOWN_INFO_FLAGS G_FILE_QUERY_INFO_NONE
#define DIRECTORY_MONITOR_SUPPORT_DIR_SYMLINKS TRUE
#define DIRECTORY_MONITOR_SUPPORT_FILE_SYMLINKS FALSE
#define UTIL_FILE_ATTRIBUTES "standard::*,time::*,id::file,id::filesystem,etag::value"
#define DIRECTORY_MONITOR_SUPPLIED_ATTRIBUTES UTIL_FILE_ATTRIBUTES
#define DIRECTORY_MONITOR_FILE_MONITOR_FLAGS G_FILE_MONITOR_SEND_MOVED
#define DIRECTORY_MONITOR_DELETED_EXPIRATION_MSEC ((guint) 500)
#define DIRECTORY_MONITOR_MAX_EXPLORATION_DIRS 5
DirectoryMonitor* directory_monitor_new (GFile* root, gboolean recurse, gboolean monitoring);
DirectoryMonitor* directory_monitor_construct (GType object_type, GFile* root, gboolean recurse, gboolean monitoring);
void directory_monitor_mdbg (const gchar* msg);
gboolean directory_monitor_is_recursive (DirectoryMonitor* self);
gboolean directory_monitor_is_monitoring (DirectoryMonitor* self);
void directory_monitor_notify_root_deleted (DirectoryMonitor* self, GFile* root);
static void directory_monitor_real_notify_root_deleted (DirectoryMonitor* self, GFile* root);
static void directory_monitor_internal_notify_root_moved (DirectoryMonitor* self, GFile* old_root, GFile* new_root, GFileInfo* new_root_info);
static gboolean directory_monitor_file_info_map_remove (DirectoryMonitorFileInfoMap* self, GFile* file, GFileInfo* info);
static gboolean directory_monitor_file_info_map_update (DirectoryMonitorFileInfoMap* self, GFile* file, GFileInfo* info);
void directory_monitor_notify_root_moved (DirectoryMonitor* self, GFile* old_root, GFile* new_root, GFileInfo* new_root_info);
static void directory_monitor_real_notify_root_moved (DirectoryMonitor* self, GFile* old_root, GFile* new_root, GFileInfo* new_root_info);
void directory_monitor_notify_discovery_started (DirectoryMonitor* self);
static void directory_monitor_real_notify_discovery_started (DirectoryMonitor* self);
void directory_monitor_internal_notify_file_discovered (DirectoryMonitor* self, GFile* file, GFileInfo* info);
static void directory_monitor_real_internal_notify_file_discovered (DirectoryMonitor* self, GFile* file, GFileInfo* info);
void directory_monitor_notify_file_discovered (DirectoryMonitor* self, GFile* file, GFileInfo* info);
static void directory_monitor_real_notify_file_discovered (DirectoryMonitor* self, GFile* file, GFileInfo* info);
void directory_monitor_internal_notify_directory_discovered (DirectoryMonitor* self, GFile* dir, GFileInfo* info);
static void directory_monitor_real_internal_notify_directory_discovered (DirectoryMonitor* self, GFile* dir, GFileInfo* info);
void directory_monitor_notify_directory_discovered (DirectoryMonitor* self, GFile* dir, GFileInfo* info);
static void directory_monitor_real_notify_directory_discovered (DirectoryMonitor* self, GFile* dir, GFileInfo* info);
void directory_monitor_notify_discovery_failed (DirectoryMonitor* self, const gchar* reason);
static void directory_monitor_real_notify_discovery_failed (DirectoryMonitor* self, const gchar* reason);
void directory_monitor_notify_discovery_completed (DirectoryMonitor* self);
static void directory_monitor_real_notify_discovery_completed (DirectoryMonitor* self);
static void directory_monitor_internal_notify_file_created (DirectoryMonitor* self, GFile* file, GFileInfo* info);
static gboolean directory_monitor_is_file_create_move (DirectoryMonitor* self, GFile* file, GFileInfo* info, GFile** old_file, GFileInfo** old_file_info);
static void directory_monitor_internal_notify_file_moved (DirectoryMonitor* self, GFile* old_file, GFile* new_file, GFileInfo* new_file_info);
void directory_monitor_notify_file_created (DirectoryMonitor* self, GFile* file, GFileInfo* info);
static void directory_monitor_real_notify_file_created (DirectoryMonitor* self, GFile* file, GFileInfo* info);
void directory_monitor_notify_file_moved (DirectoryMonitor* self, GFile* old_file, GFile* new_file, GFileInfo* new_file_info);
static void directory_monitor_real_notify_file_moved (DirectoryMonitor* self, GFile* old_file, GFile* new_file, GFileInfo* new_file_info);
void directory_monitor_notify_file_altered (DirectoryMonitor* self, GFile* file);
static void directory_monitor_real_notify_file_altered (DirectoryMonitor* self, GFile* file);
static void directory_monitor_internal_notify_file_alteration_completed (DirectoryMonitor* self, GFile* file, GFileInfo* info);
void directory_monitor_notify_file_alteration_completed (DirectoryMonitor* self, GFile* file, GFileInfo* info);
static void directory_monitor_real_notify_file_alteration_completed (DirectoryMonitor* self, GFile* file, GFileInfo* info);
void directory_monitor_notify_file_attributes_altered (DirectoryMonitor* self, GFile* file);
static void directory_monitor_real_notify_file_attributes_altered (DirectoryMonitor* self, GFile* file);
static void directory_monitor_internal_notify_file_deleted (DirectoryMonitor* self, GFile* file);
void directory_monitor_notify_file_deleted (DirectoryMonitor* self, GFile* file);
static void directory_monitor_real_notify_file_deleted (DirectoryMonitor* self, GFile* file);
static void directory_monitor_internal_notify_directory_created (DirectoryMonitor* self, GFile* dir, GFileInfo* info);
static void directory_monitor_file_info_map_remove_descendents (DirectoryMonitorFileInfoMap* self, GFile* root, DirectoryMonitorFileInfoMap* descendents);
static void directory_monitor_internal_notify_directory_moved (DirectoryMonitor* self, GFile* old_dir, GFileInfo* old_dir_info, GFile* new_dir, GFileInfo* new_dir_info);
void directory_monitor_notify_directory_created (DirectoryMonitor* self, GFile* dir, GFileInfo* info);
static void directory_monitor_real_notify_directory_created (DirectoryMonitor* self, GFile* dir, GFileInfo* info);
static void directory_monitor_async_internal_notify_directory_moved (DirectoryMonitor* self, GFile* old_dir, GFileInfo* old_dir_info, GFile* new_dir, GFileInfo* new_dir_info, GAsyncReadyCallback _callback_, gpointer _user_data_);
static void directory_monitor_async_internal_notify_directory_moved_finish (DirectoryMonitor* self, GAsyncResult* _res_);
static void directory_monitor_async_internal_notify_directory_moved_data_free (gpointer _data);
static gboolean directory_monitor_async_internal_notify_directory_moved_co (DirectoryMonitorAsyncInternalNotifyDirectoryMovedData* _data_);
static gint directory_monitor_file_info_map_get_children (DirectoryMonitorFileInfoMap* self, GFile* root, GeeCollection* files, GeeCollection* dirs);
static GFileInfo* directory_monitor_file_info_map_get_info (DirectoryMonitorFileInfoMap* self, GFile* file);
static void directory_monitor_async_internal_notify_directory_moved_ready (GObject* source_object, GAsyncResult* _res_, gpointer _user_data_);
static gboolean _directory_monitor_async_internal_notify_directory_moved_co_gsource_func (gpointer self);
static gboolean directory_monitor_remove_monitor (DirectoryMonitor* self, GFile* dir, GFileInfo* info);
static gboolean directory_monitor_add_monitor (DirectoryMonitor* self, GFile* dir, GFileInfo* info);
void directory_monitor_notify_directory_moved (DirectoryMonitor* self, GFile* old_dir, GFile* new_dir, GFileInfo* new_dir_info);
static void directory_monitor_real_notify_directory_moved (DirectoryMonitor* self, GFile* old_dir, GFile* new_dir, GFileInfo* new_dir_info);
void directory_monitor_notify_directory_altered (DirectoryMonitor* self, GFile* dir);
static void directory_monitor_real_notify_directory_altered (DirectoryMonitor* self, GFile* dir);
static void directory_monitor_internal_notify_directory_alteration_completed (DirectoryMonitor* self, GFile* dir, GFileInfo* info);
void directory_monitor_notify_directory_alteration_completed (DirectoryMonitor* self, GFile* dir, GFileInfo* info);
static void directory_monitor_real_notify_directory_alteration_completed (DirectoryMonitor* self, GFile* dir, GFileInfo* info);
void directory_monitor_notify_directory_attributes_altered (DirectoryMonitor* self, GFile* dir);
static void directory_monitor_real_notify_directory_attributes_altered (DirectoryMonitor* self, GFile* dir);
static void directory_monitor_internal_notify_directory_deleted (DirectoryMonitor* self, GFile* dir);
static void directory_monitor_async_notify_directory_deleted (DirectoryMonitor* self, GFile* dir, gboolean already_removed, GAsyncReadyCallback _callback_, gpointer _user_data_);
static void directory_monitor_async_notify_directory_deleted_finish (DirectoryMonitor* self, GAsyncResult* _res_);
static void directory_monitor_async_notify_directory_deleted_data_free (gpointer _data);
static gboolean directory_monitor_async_notify_directory_deleted_co (DirectoryMonitorAsyncNotifyDirectoryDeletedData* _data_);
static void directory_monitor_async_notify_directory_deleted_ready (GObject* source_object, GAsyncResult* _res_, gpointer _user_data_);
static gboolean _directory_monitor_async_notify_directory_deleted_co_gsource_func (gpointer self);
void directory_monitor_notify_directory_deleted (DirectoryMonitor* self, GFile* dir);
static void directory_monitor_real_notify_directory_deleted (DirectoryMonitor* self, GFile* dir);
void directory_monitor_notify_closed (DirectoryMonitor* self);
static void directory_monitor_real_notify_closed (DirectoryMonitor* self);
GFile* directory_monitor_get_root (DirectoryMonitor* self);
gboolean directory_monitor_is_in_root (DirectoryMonitor* self, GFile* file);
gboolean directory_monitor_has_started (DirectoryMonitor* self);
void directory_monitor_start_discovery (DirectoryMonitor* self);
static void directory_monitor_explore_async (DirectoryMonitor* self, GFile* dir, GFileInfo* dir_info, gboolean in_discovery, GAsyncReadyCallback _callback_, gpointer _user_data_);
static void directory_monitor_explore_finish (DirectoryMonitor* self, GAsyncResult* _res_);
void directory_monitor_close (DirectoryMonitor* self);
static void directory_monitor_real_close (DirectoryMonitor* self);
static void directory_monitor_cancel_monitor (DirectoryMonitor* self, GFileMonitor* monitor);
static DirectoryMonitorFType directory_monitor_get_ftype (GFileInfo* info);
const gchar* g_file_type_to_string (GFileType self);
static void directory_monitor_explore_async_data_free (gpointer _data);
static gboolean directory_monitor_explore_async_co (DirectoryMonitorExploreAsyncData* _data_);
static gboolean directory_monitor_file_info_map_contains (DirectoryMonitorFileInfoMap* self, GFile* file, GFileInfo* info);
static void directory_monitor_explore_directory_completed (DirectoryMonitor* self, gboolean in_discovery);
static void directory_monitor_explore_async_ready (GObject* source_object, GAsyncResult* _res_, gpointer _user_data_);
gchar* get_file_info_id (GFileInfo* info);
static void _g_object_unref0_ (gpointer var);
static void _g_list_free__g_object_unref0_ (GList* self);
gboolean directory_monitor_is_file_symlink_supported (GFileInfo* info);
static void directory_monitor_notify_directory_files (DirectoryMonitor* self, GeeMap* map, gboolean in_discovery, GAsyncReadyCallback _callback_, gpointer _user_data_);
static void directory_monitor_notify_directory_files_finish (DirectoryMonitor* self, GAsyncResult* _res_);
static void directory_monitor_notify_directory_files_data_free (gpointer _data);
static gboolean directory_monitor_notify_directory_files_co (DirectoryMonitorNotifyDirectoryFilesData* _data_);
static gboolean _directory_monitor_notify_directory_files_co_gsource_func (gpointer self);
static gchar* directory_monitor_file_info_map_get_id (DirectoryMonitorFileInfoMap* self, GFile* file, GFileInfo* info);
static void directory_monitor_on_monitor_notification (DirectoryMonitor* self, GFile* file, GFile* other_file, GFileMonitorEvent event);
static void _directory_monitor_on_monitor_notification_g_file_monitor_changed (GFileMonitor* _sender, GFile* file, GFile* other_file, GFileMonitorEvent event_type, gpointer self);
const gchar* g_file_monitor_event_to_string (GFileMonitorEvent self);
static DirectoryMonitorQueryInfoQueueElement* directory_monitor_query_info_queue_element_new (DirectoryMonitor* owner, GFile* file, GFile* other_file, GFileMonitorEvent event);
static DirectoryMonitorQueryInfoQueueElement* directory_monitor_query_info_queue_element_construct (GType object_type, DirectoryMonitor* owner, GFile* file, GFile* other_file, GFileMonitorEvent event);
static void directory_monitor_query_info_queue_element_on_completed (DirectoryMonitorQueryInfoQueueElement* self, GObject* source, GAsyncResult* aresult);
static void _directory_monitor_query_info_queue_element_on_completed_gasync_ready_callback (GObject* source_object, GAsyncResult* res, gpointer self);
static gboolean directory_monitor_check_for_expired_delete_events (DirectoryMonitor* self);
static gboolean _directory_monitor_check_for_expired_delete_events_gsource_func (gpointer self);
static void directory_monitor_process_query_queue (DirectoryMonitor* self, DirectoryMonitorQueryInfoQueueElement* query_info);
static GFile* directory_monitor_file_info_map_find_match (DirectoryMonitorFileInfoMap* self, GFileInfo* match);
static void directory_monitor_on_monitor_notification_ready (DirectoryMonitor* self, GFile* file, GFile* other_file, GFileInfo* info, GFileMonitorEvent event);
GFileInfo* directory_monitor_get_file_info (DirectoryMonitor* self, GFile* file);
gulong now_ms (void);
GeeCollection* directory_monitor_get_files (DirectoryMonitor* self);
static GeeCollection* directory_monitor_file_info_map_get_all (DirectoryMonitorFileInfoMap* self);
GFileInfo* directory_monitor_query_file_info (DirectoryMonitor* self, GFile* file);
static GFileInfo* directory_monitor_file_info_map_query_info (DirectoryMonitorFileInfoMap* self, GFile* file, GCancellable* cancellable);
static void directory_monitor_real_root_moved (DirectoryMonitor* self, GFile* old_root, GFile* new_root, GFileInfo* new_root_info);
static void g_cclosure_user_marshal_VOID__OBJECT_OBJECT_OBJECT (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);
static void directory_monitor_real_root_deleted (DirectoryMonitor* self, GFile* root);
static void directory_monitor_real_discovery_started (DirectoryMonitor* self);
static void directory_monitor_real_file_discovered (DirectoryMonitor* self, GFile* file, GFileInfo* info);
static void g_cclosure_user_marshal_VOID__OBJECT_OBJECT (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);
static void directory_monitor_real_directory_discovered (DirectoryMonitor* self, GFile* file, GFileInfo* info);
static void directory_monitor_real_discovery_failed (DirectoryMonitor* self, const gchar* reason);
static void directory_monitor_real_discovery_completed (DirectoryMonitor* self);
static void directory_monitor_real_file_created (DirectoryMonitor* self, GFile* file, GFileInfo* info);
static void directory_monitor_real_file_moved (DirectoryMonitor* self, GFile* old_file, GFile* new_file, GFileInfo* new_file_info);
static void directory_monitor_real_file_altered (DirectoryMonitor* self, GFile* file);
static void directory_monitor_real_file_alteration_completed (DirectoryMonitor* self, GFile* file, GFileInfo* info);
static void directory_monitor_real_file_attributes_altered (DirectoryMonitor* self, GFile* file);
static void directory_monitor_real_file_deleted (DirectoryMonitor* self, GFile* file);
static void directory_monitor_real_directory_created (DirectoryMonitor* self, GFile* dir, GFileInfo* info);
static void directory_monitor_real_directory_moved (DirectoryMonitor* self, GFile* old_dir, GFile* new_dir, GFileInfo* new_dir_info);
static void directory_monitor_real_directory_altered (DirectoryMonitor* self, GFile* dir);
static void directory_monitor_real_directory_alteration_completed (DirectoryMonitor* self, GFile* dir, GFileInfo* info);
static void directory_monitor_real_directory_attributes_altered (DirectoryMonitor* self, GFile* dir);
static void directory_monitor_real_directory_deleted (DirectoryMonitor* self, GFile* dir);
static void directory_monitor_real_closed (DirectoryMonitor* self);
enum  {
	DIRECTORY_MONITOR_QUERY_INFO_QUEUE_ELEMENT_DUMMY_PROPERTY
};
static void directory_monitor_query_info_queue_element_finalize (DirectoryMonitorQueryInfoQueueElement* obj);
#define DIRECTORY_MONITOR_FILE_INFO_MAP_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), DIRECTORY_MONITOR_TYPE_FILE_INFO_MAP, DirectoryMonitorFileInfoMapPrivate))
enum  {
	DIRECTORY_MONITOR_FILE_INFO_MAP_DUMMY_PROPERTY
};
static gboolean directory_monitor_file_info_map_normalize_file (DirectoryMonitorFileInfoMap* self, GFile* file, GFileInfo* info, GFile** normalized, gchar** id);
static void directory_monitor_file_info_map_remove_all (DirectoryMonitorFileInfoMap* self, GeeCollection* files);
static void directory_monitor_file_info_map_finalize (DirectoryMonitorFileInfoMap* obj);
static void directory_monitor_finalize (GObject* obj);


static GType directory_monitor_ftype_get_type (void) {
	static volatile gsize directory_monitor_ftype_type_id__volatile = 0;
	if (g_once_init_enter (&directory_monitor_ftype_type_id__volatile)) {
		static const GEnumValue values[] = {{DIRECTORY_MONITOR_FTYPE_FILE, "DIRECTORY_MONITOR_FTYPE_FILE", "file"}, {DIRECTORY_MONITOR_FTYPE_DIRECTORY, "DIRECTORY_MONITOR_FTYPE_DIRECTORY", "directory"}, {DIRECTORY_MONITOR_FTYPE_UNSUPPORTED, "DIRECTORY_MONITOR_FTYPE_UNSUPPORTED", "unsupported"}, {0, NULL, NULL}};
		GType directory_monitor_ftype_type_id;
		directory_monitor_ftype_type_id = g_enum_register_static ("DirectoryMonitorFType", values);
		g_once_init_leave (&directory_monitor_ftype_type_id__volatile, directory_monitor_ftype_type_id);
	}
	return directory_monitor_ftype_type_id__volatile;
}


static gpointer _g_object_ref0 (gpointer self) {
#line 453 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	return self ? g_object_ref (self) : NULL;
#line 803 "DirectoryMonitor.c"
}


DirectoryMonitor* directory_monitor_construct (GType object_type, GFile* root, gboolean recurse, gboolean monitoring) {
	DirectoryMonitor * self = NULL;
	GFile* _tmp0_;
	GFile* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
#line 452 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_val_if_fail (G_IS_FILE (root), NULL);
#line 452 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	self = (DirectoryMonitor*) g_object_new (object_type, NULL);
#line 453 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp0_ = root;
#line 453 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 453 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_g_object_unref0 (self->priv->root);
#line 453 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	self->priv->root = _tmp1_;
#line 454 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp2_ = recurse;
#line 454 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	self->priv->recurse = _tmp2_;
#line 455 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp3_ = monitoring;
#line 455 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	self->priv->monitoring = _tmp3_;
#line 452 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	return self;
#line 835 "DirectoryMonitor.c"
}


DirectoryMonitor* directory_monitor_new (GFile* root, gboolean recurse, gboolean monitoring) {
#line 452 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	return directory_monitor_construct (TYPE_DIRECTORY_MONITOR, root, recurse, monitoring);
#line 842 "DirectoryMonitor.c"
}


void directory_monitor_mdbg (const gchar* msg) {
#line 458 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_if_fail (msg != NULL);
#line 849 "DirectoryMonitor.c"
}


gboolean directory_monitor_is_recursive (DirectoryMonitor* self) {
	gboolean result = FALSE;
	gboolean _tmp0_;
#line 464 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_val_if_fail (IS_DIRECTORY_MONITOR (self), FALSE);
#line 465 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp0_ = self->priv->recurse;
#line 465 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	result = _tmp0_;
#line 465 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	return result;
#line 864 "DirectoryMonitor.c"
}


gboolean directory_monitor_is_monitoring (DirectoryMonitor* self) {
	gboolean result = FALSE;
	gboolean _tmp0_;
#line 468 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_val_if_fail (IS_DIRECTORY_MONITOR (self), FALSE);
#line 469 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp0_ = self->priv->monitoring;
#line 469 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	result = _tmp0_;
#line 469 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	return result;
#line 879 "DirectoryMonitor.c"
}


static void directory_monitor_real_notify_root_deleted (DirectoryMonitor* self, GFile* root) {
	GFile* _tmp0_;
	GFile* _tmp1_;
	gboolean _tmp2_ = FALSE;
	GFile* _tmp3_;
#line 472 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (root));
#line 473 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp0_ = self->priv->root;
#line 473 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp1_ = root;
#line 473 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp2_ = g_file_equal (_tmp0_, _tmp1_);
#line 473 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_assert (_tmp2_);
#line 475 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	directory_monitor_mdbg ("root deleted");
#line 476 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp3_ = root;
#line 476 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_signal_emit_by_name (self, "root-deleted", _tmp3_);
#line 904 "DirectoryMonitor.c"
}


void directory_monitor_notify_root_deleted (DirectoryMonitor* self, GFile* root) {
#line 472 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 472 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	DIRECTORY_MONITOR_GET_CLASS (self)->notify_root_deleted (self, root);
#line 913 "DirectoryMonitor.c"
}


static void directory_monitor_internal_notify_root_moved (DirectoryMonitor* self, GFile* old_root, GFile* new_root, GFileInfo* new_root_info) {
	DirectoryMonitorFileInfoMap* _tmp0_;
	GFile* _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean removed;
	DirectoryMonitorFileInfoMap* _tmp3_;
	GFile* _tmp4_;
	GFileInfo* _tmp5_;
	gboolean _tmp6_ = FALSE;
	gboolean updated;
	GFile* _tmp7_;
	GFile* _tmp8_;
	GFile* _tmp9_;
	GFile* _tmp10_;
	GFileInfo* _tmp11_;
#line 479 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 479 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (old_root));
#line 479 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (new_root));
#line 479 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE_INFO (new_root_info));
#line 480 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp0_ = self->priv->files;
#line 480 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp1_ = old_root;
#line 480 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp2_ = directory_monitor_file_info_map_remove (_tmp0_, _tmp1_, NULL);
#line 480 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	removed = _tmp2_;
#line 481 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_assert (removed);
#line 483 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp3_ = self->priv->files;
#line 483 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp4_ = new_root;
#line 483 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp5_ = new_root_info;
#line 483 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp6_ = directory_monitor_file_info_map_update (_tmp3_, _tmp4_, _tmp5_);
#line 483 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	updated = _tmp6_;
#line 484 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_assert (updated);
#line 486 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp7_ = new_root;
#line 486 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp8_ = _g_object_ref0 (_tmp7_);
#line 486 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_g_object_unref0 (self->priv->root);
#line 486 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	self->priv->root = _tmp8_;
#line 488 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp9_ = old_root;
#line 488 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp10_ = new_root;
#line 488 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp11_ = new_root_info;
#line 488 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	directory_monitor_notify_root_moved (self, _tmp9_, _tmp10_, _tmp11_);
#line 978 "DirectoryMonitor.c"
}


static void directory_monitor_real_notify_root_moved (DirectoryMonitor* self, GFile* old_root, GFile* new_root, GFileInfo* new_root_info) {
	GFile* _tmp0_;
	GFile* _tmp1_;
	gboolean _tmp2_ = FALSE;
	GFile* _tmp3_;
	gchar* _tmp4_ = NULL;
	gchar* _tmp5_;
	GFile* _tmp6_;
	gchar* _tmp7_ = NULL;
	gchar* _tmp8_;
	gchar* _tmp9_ = NULL;
	gchar* _tmp10_;
	GFile* _tmp11_;
	GFile* _tmp12_;
	GFileInfo* _tmp13_;
#line 491 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (old_root));
#line 491 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (new_root));
#line 491 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE_INFO (new_root_info));
#line 492 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp0_ = self->priv->root;
#line 492 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp1_ = old_root;
#line 492 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp2_ = g_file_equal (_tmp0_, _tmp1_);
#line 492 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_assert (_tmp2_);
#line 494 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp3_ = old_root;
#line 494 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp4_ = g_file_get_path (_tmp3_);
#line 494 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp5_ = _tmp4_;
#line 494 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp6_ = new_root;
#line 494 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp7_ = g_file_get_path (_tmp6_);
#line 494 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp8_ = _tmp7_;
#line 494 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp9_ = g_strdup_printf ("root moved: %s -> %s", _tmp5_, _tmp8_);
#line 494 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp10_ = _tmp9_;
#line 494 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	directory_monitor_mdbg (_tmp10_);
#line 494 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_g_free0 (_tmp10_);
#line 494 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_g_free0 (_tmp8_);
#line 494 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_g_free0 (_tmp5_);
#line 495 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp11_ = old_root;
#line 495 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp12_ = new_root;
#line 495 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp13_ = new_root_info;
#line 495 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_signal_emit_by_name (self, "root-moved", _tmp11_, _tmp12_, _tmp13_);
#line 1043 "DirectoryMonitor.c"
}


void directory_monitor_notify_root_moved (DirectoryMonitor* self, GFile* old_root, GFile* new_root, GFileInfo* new_root_info) {
#line 491 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 491 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	DIRECTORY_MONITOR_GET_CLASS (self)->notify_root_moved (self, old_root, new_root, new_root_info);
#line 1052 "DirectoryMonitor.c"
}


static void directory_monitor_real_notify_discovery_started (DirectoryMonitor* self) {
#line 499 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	directory_monitor_mdbg ("discovery started");
#line 500 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_signal_emit_by_name (self, "discovery-started");
#line 1061 "DirectoryMonitor.c"
}


void directory_monitor_notify_discovery_started (DirectoryMonitor* self) {
#line 498 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 498 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	DIRECTORY_MONITOR_GET_CLASS (self)->notify_discovery_started (self);
#line 1070 "DirectoryMonitor.c"
}


static void directory_monitor_real_internal_notify_file_discovered (DirectoryMonitor* self, GFile* file, GFileInfo* info) {
	DirectoryMonitorFileInfoMap* _tmp0_;
	GFile* _tmp1_;
	GFileInfo* _tmp2_;
	gboolean _tmp3_ = FALSE;
	gboolean updated;
	GFile* _tmp4_;
	GFileInfo* _tmp5_;
#line 503 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (file));
#line 503 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE_INFO (info));
#line 504 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp0_ = self->priv->files;
#line 504 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp1_ = file;
#line 504 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp2_ = info;
#line 504 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp3_ = directory_monitor_file_info_map_update (_tmp0_, _tmp1_, _tmp2_);
#line 504 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	updated = _tmp3_;
#line 505 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_assert (updated);
#line 507 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp4_ = file;
#line 507 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp5_ = info;
#line 507 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	directory_monitor_notify_file_discovered (self, _tmp4_, _tmp5_);
#line 1104 "DirectoryMonitor.c"
}


void directory_monitor_internal_notify_file_discovered (DirectoryMonitor* self, GFile* file, GFileInfo* info) {
#line 503 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 503 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	DIRECTORY_MONITOR_GET_CLASS (self)->internal_notify_file_discovered (self, file, info);
#line 1113 "DirectoryMonitor.c"
}


static void directory_monitor_real_notify_file_discovered (DirectoryMonitor* self, GFile* file, GFileInfo* info) {
	GFile* _tmp0_;
	gchar* _tmp1_ = NULL;
	gchar* _tmp2_;
	gchar* _tmp3_ = NULL;
	gchar* _tmp4_;
	GFile* _tmp5_;
	GFileInfo* _tmp6_;
#line 510 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (file));
#line 510 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE_INFO (info));
#line 511 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp0_ = file;
#line 511 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp1_ = g_file_get_path (_tmp0_);
#line 511 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp2_ = _tmp1_;
#line 511 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp3_ = g_strdup_printf ("file discovered: %s", _tmp2_);
#line 511 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp4_ = _tmp3_;
#line 511 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	directory_monitor_mdbg (_tmp4_);
#line 511 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_g_free0 (_tmp4_);
#line 511 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_g_free0 (_tmp2_);
#line 512 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp5_ = file;
#line 512 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp6_ = info;
#line 512 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_signal_emit_by_name (self, "file-discovered", _tmp5_, _tmp6_);
#line 1151 "DirectoryMonitor.c"
}


void directory_monitor_notify_file_discovered (DirectoryMonitor* self, GFile* file, GFileInfo* info) {
#line 510 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 510 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	DIRECTORY_MONITOR_GET_CLASS (self)->notify_file_discovered (self, file, info);
#line 1160 "DirectoryMonitor.c"
}


static void directory_monitor_real_internal_notify_directory_discovered (DirectoryMonitor* self, GFile* dir, GFileInfo* info) {
	DirectoryMonitorFileInfoMap* _tmp0_;
	GFile* _tmp1_;
	GFileInfo* _tmp2_;
	gboolean _tmp3_ = FALSE;
	gboolean updated;
	GFile* _tmp4_;
	GFileInfo* _tmp5_;
#line 515 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (dir));
#line 515 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE_INFO (info));
#line 516 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp0_ = self->priv->files;
#line 516 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp1_ = dir;
#line 516 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp2_ = info;
#line 516 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp3_ = directory_monitor_file_info_map_update (_tmp0_, _tmp1_, _tmp2_);
#line 516 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	updated = _tmp3_;
#line 517 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_assert (updated);
#line 519 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp4_ = dir;
#line 519 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp5_ = info;
#line 519 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	directory_monitor_notify_directory_discovered (self, _tmp4_, _tmp5_);
#line 1194 "DirectoryMonitor.c"
}


void directory_monitor_internal_notify_directory_discovered (DirectoryMonitor* self, GFile* dir, GFileInfo* info) {
#line 515 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 515 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	DIRECTORY_MONITOR_GET_CLASS (self)->internal_notify_directory_discovered (self, dir, info);
#line 1203 "DirectoryMonitor.c"
}


static void directory_monitor_real_notify_directory_discovered (DirectoryMonitor* self, GFile* dir, GFileInfo* info) {
	GFile* _tmp0_;
	gchar* _tmp1_ = NULL;
	gchar* _tmp2_;
	gchar* _tmp3_ = NULL;
	gchar* _tmp4_;
	GFile* _tmp5_;
	GFileInfo* _tmp6_;
#line 522 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (dir));
#line 522 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE_INFO (info));
#line 523 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp0_ = dir;
#line 523 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp1_ = g_file_get_path (_tmp0_);
#line 523 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp2_ = _tmp1_;
#line 523 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp3_ = g_strdup_printf ("directory discovered: %s", _tmp2_);
#line 523 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp4_ = _tmp3_;
#line 523 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	directory_monitor_mdbg (_tmp4_);
#line 523 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_g_free0 (_tmp4_);
#line 523 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_g_free0 (_tmp2_);
#line 524 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp5_ = dir;
#line 524 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp6_ = info;
#line 524 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_signal_emit_by_name (self, "directory-discovered", _tmp5_, _tmp6_);
#line 1241 "DirectoryMonitor.c"
}


void directory_monitor_notify_directory_discovered (DirectoryMonitor* self, GFile* dir, GFileInfo* info) {
#line 522 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 522 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	DIRECTORY_MONITOR_GET_CLASS (self)->notify_directory_discovered (self, dir, info);
#line 1250 "DirectoryMonitor.c"
}


static void directory_monitor_real_notify_discovery_failed (DirectoryMonitor* self, const gchar* reason) {
	const gchar* _tmp0_;
	const gchar* _tmp1_;
#line 527 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_if_fail (reason != NULL);
#line 528 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp0_ = reason;
#line 528 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_warning ("DirectoryMonitor.vala:528: discovery failed: %s", _tmp0_);
#line 529 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp1_ = reason;
#line 529 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_signal_emit_by_name (self, "discovery-failed", _tmp1_);
#line 1267 "DirectoryMonitor.c"
}


void directory_monitor_notify_discovery_failed (DirectoryMonitor* self, const gchar* reason) {
#line 527 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 527 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	DIRECTORY_MONITOR_GET_CLASS (self)->notify_discovery_failed (self, reason);
#line 1276 "DirectoryMonitor.c"
}


static void directory_monitor_real_notify_discovery_completed (DirectoryMonitor* self) {
#line 533 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_signal_emit_by_name (self, "discovery-completed");
#line 1283 "DirectoryMonitor.c"
}


void directory_monitor_notify_discovery_completed (DirectoryMonitor* self) {
#line 532 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 532 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	DIRECTORY_MONITOR_GET_CLASS (self)->notify_discovery_completed (self);
#line 1292 "DirectoryMonitor.c"
}


static void directory_monitor_internal_notify_file_created (DirectoryMonitor* self, GFile* file, GFileInfo* info) {
	GFile* old_file = NULL;
	GFileInfo* old_file_info = NULL;
	GFile* _tmp0_;
	GFileInfo* _tmp1_;
	GFile* _tmp2_ = NULL;
	GFileInfo* _tmp3_ = NULL;
	gboolean _tmp4_ = FALSE;
#line 536 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 536 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (file));
#line 536 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE_INFO (info));
#line 539 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp0_ = file;
#line 539 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp1_ = info;
#line 539 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp4_ = directory_monitor_is_file_create_move (self, _tmp0_, _tmp1_, &_tmp2_, &_tmp3_);
#line 539 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_g_object_unref0 (old_file);
#line 539 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	old_file = _tmp2_;
#line 539 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_g_object_unref0 (old_file_info);
#line 539 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	old_file_info = _tmp3_;
#line 539 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	if (_tmp4_) {
#line 1326 "DirectoryMonitor.c"
		GFile* _tmp5_;
		GFile* _tmp6_;
		GFileInfo* _tmp7_;
#line 540 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_tmp5_ = old_file;
#line 540 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_tmp6_ = file;
#line 540 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_tmp7_ = info;
#line 540 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		directory_monitor_internal_notify_file_moved (self, _tmp5_, _tmp6_, _tmp7_);
#line 1338 "DirectoryMonitor.c"
	} else {
		DirectoryMonitorFileInfoMap* _tmp8_;
		GFile* _tmp9_;
		GFileInfo* _tmp10_;
		gboolean _tmp11_ = FALSE;
		gboolean updated;
		gboolean _tmp12_;
		GFile* _tmp13_;
		GFileInfo* _tmp14_;
#line 542 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_tmp8_ = self->priv->files;
#line 542 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_tmp9_ = file;
#line 542 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_tmp10_ = info;
#line 542 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_tmp11_ = directory_monitor_file_info_map_update (_tmp8_, _tmp9_, _tmp10_);
#line 542 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		updated = _tmp11_;
#line 543 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_tmp12_ = updated;
#line 543 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		g_assert (_tmp12_);
#line 545 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_tmp13_ = file;
#line 545 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_tmp14_ = info;
#line 545 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		directory_monitor_notify_file_created (self, _tmp13_, _tmp14_);
#line 1368 "DirectoryMonitor.c"
	}
#line 536 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_g_object_unref0 (old_file_info);
#line 536 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_g_object_unref0 (old_file);
#line 1374 "DirectoryMonitor.c"
}


static void directory_monitor_real_notify_file_created (DirectoryMonitor* self, GFile* file, GFileInfo* info) {
	GFile* _tmp0_;
	gchar* _tmp1_ = NULL;
	gchar* _tmp2_;
	gchar* _tmp3_ = NULL;
	gchar* _tmp4_;
	GFile* _tmp5_;
	GFileInfo* _tmp6_;
#line 549 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (file));
#line 549 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE_INFO (info));
#line 550 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp0_ = file;
#line 550 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp1_ = g_file_get_path (_tmp0_);
#line 550 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp2_ = _tmp1_;
#line 550 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp3_ = g_strdup_printf ("file created: %s", _tmp2_);
#line 550 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp4_ = _tmp3_;
#line 550 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	directory_monitor_mdbg (_tmp4_);
#line 550 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_g_free0 (_tmp4_);
#line 550 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_g_free0 (_tmp2_);
#line 551 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp5_ = file;
#line 551 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp6_ = info;
#line 551 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_signal_emit_by_name (self, "file-created", _tmp5_, _tmp6_);
#line 1412 "DirectoryMonitor.c"
}


void directory_monitor_notify_file_created (DirectoryMonitor* self, GFile* file, GFileInfo* info) {
#line 549 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 549 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	DIRECTORY_MONITOR_GET_CLASS (self)->notify_file_created (self, file, info);
#line 1421 "DirectoryMonitor.c"
}


static void directory_monitor_internal_notify_file_moved (DirectoryMonitor* self, GFile* old_file, GFile* new_file, GFileInfo* new_file_info) {
	DirectoryMonitorFileInfoMap* _tmp0_;
	GFile* _tmp1_;
	DirectoryMonitorFileInfoMap* _tmp2_;
	GFile* _tmp3_;
	GFileInfo* _tmp4_;
	gboolean _tmp5_ = FALSE;
	gboolean updated;
	GFile* _tmp6_;
	GFile* _tmp7_;
	GFileInfo* _tmp8_;
#line 554 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 554 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (old_file));
#line 554 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (new_file));
#line 554 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE_INFO (new_file_info));
#line 557 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp0_ = self->priv->files;
#line 557 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp1_ = old_file;
#line 557 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	directory_monitor_file_info_map_remove (_tmp0_, _tmp1_, NULL);
#line 559 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp2_ = self->priv->files;
#line 559 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp3_ = new_file;
#line 559 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp4_ = new_file_info;
#line 559 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp5_ = directory_monitor_file_info_map_update (_tmp2_, _tmp3_, _tmp4_);
#line 559 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	updated = _tmp5_;
#line 560 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_assert (updated);
#line 562 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp6_ = old_file;
#line 562 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp7_ = new_file;
#line 562 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp8_ = new_file_info;
#line 562 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	directory_monitor_notify_file_moved (self, _tmp6_, _tmp7_, _tmp8_);
#line 1470 "DirectoryMonitor.c"
}


static void directory_monitor_real_notify_file_moved (DirectoryMonitor* self, GFile* old_file, GFile* new_file, GFileInfo* new_file_info) {
	GFile* _tmp0_;
	gchar* _tmp1_ = NULL;
	gchar* _tmp2_;
	GFile* _tmp3_;
	gchar* _tmp4_ = NULL;
	gchar* _tmp5_;
	gchar* _tmp6_ = NULL;
	gchar* _tmp7_;
	GFile* _tmp8_;
	GFile* _tmp9_;
	GFileInfo* _tmp10_;
#line 565 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (old_file));
#line 565 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (new_file));
#line 565 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE_INFO (new_file_info));
#line 566 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp0_ = old_file;
#line 566 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp1_ = g_file_get_path (_tmp0_);
#line 566 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp2_ = _tmp1_;
#line 566 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp3_ = new_file;
#line 566 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp4_ = g_file_get_path (_tmp3_);
#line 566 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp5_ = _tmp4_;
#line 566 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp6_ = g_strdup_printf ("file moved: %s -> %s", _tmp2_, _tmp5_);
#line 566 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp7_ = _tmp6_;
#line 566 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	directory_monitor_mdbg (_tmp7_);
#line 566 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_g_free0 (_tmp7_);
#line 566 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_g_free0 (_tmp5_);
#line 566 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_g_free0 (_tmp2_);
#line 567 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp8_ = old_file;
#line 567 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp9_ = new_file;
#line 567 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp10_ = new_file_info;
#line 567 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_signal_emit_by_name (self, "file-moved", _tmp8_, _tmp9_, _tmp10_);
#line 1524 "DirectoryMonitor.c"
}


void directory_monitor_notify_file_moved (DirectoryMonitor* self, GFile* old_file, GFile* new_file, GFileInfo* new_file_info) {
#line 565 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 565 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	DIRECTORY_MONITOR_GET_CLASS (self)->notify_file_moved (self, old_file, new_file, new_file_info);
#line 1533 "DirectoryMonitor.c"
}


static void directory_monitor_real_notify_file_altered (DirectoryMonitor* self, GFile* file) {
	GFile* _tmp0_;
	gchar* _tmp1_ = NULL;
	gchar* _tmp2_;
	gchar* _tmp3_ = NULL;
	gchar* _tmp4_;
	GFile* _tmp5_;
#line 570 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (file));
#line 571 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp0_ = file;
#line 571 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp1_ = g_file_get_path (_tmp0_);
#line 571 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp2_ = _tmp1_;
#line 571 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp3_ = g_strdup_printf ("file altered: %s", _tmp2_);
#line 571 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp4_ = _tmp3_;
#line 571 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	directory_monitor_mdbg (_tmp4_);
#line 571 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_g_free0 (_tmp4_);
#line 571 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_g_free0 (_tmp2_);
#line 572 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp5_ = file;
#line 572 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_signal_emit_by_name (self, "file-altered", _tmp5_);
#line 1566 "DirectoryMonitor.c"
}


void directory_monitor_notify_file_altered (DirectoryMonitor* self, GFile* file) {
#line 570 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 570 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	DIRECTORY_MONITOR_GET_CLASS (self)->notify_file_altered (self, file);
#line 1575 "DirectoryMonitor.c"
}


static void directory_monitor_internal_notify_file_alteration_completed (DirectoryMonitor* self, GFile* file, GFileInfo* info) {
	DirectoryMonitorFileInfoMap* _tmp0_;
	GFile* _tmp1_;
	GFileInfo* _tmp2_;
	gboolean _tmp3_ = FALSE;
	gboolean updated;
	GFile* _tmp4_;
	GFileInfo* _tmp5_;
#line 575 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 575 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (file));
#line 575 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE_INFO (info));
#line 576 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp0_ = self->priv->files;
#line 576 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp1_ = file;
#line 576 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp2_ = info;
#line 576 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp3_ = directory_monitor_file_info_map_update (_tmp0_, _tmp1_, _tmp2_);
#line 576 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	updated = _tmp3_;
#line 577 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_assert (updated);
#line 579 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp4_ = file;
#line 579 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp5_ = info;
#line 579 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	directory_monitor_notify_file_alteration_completed (self, _tmp4_, _tmp5_);
#line 1611 "DirectoryMonitor.c"
}


static void directory_monitor_real_notify_file_alteration_completed (DirectoryMonitor* self, GFile* file, GFileInfo* info) {
	GFile* _tmp0_;
	gchar* _tmp1_ = NULL;
	gchar* _tmp2_;
	gchar* _tmp3_ = NULL;
	gchar* _tmp4_;
	GFile* _tmp5_;
	GFileInfo* _tmp6_;
#line 582 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (file));
#line 582 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE_INFO (info));
#line 583 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp0_ = file;
#line 583 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp1_ = g_file_get_path (_tmp0_);
#line 583 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp2_ = _tmp1_;
#line 583 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp3_ = g_strdup_printf ("file alteration completed: %s", _tmp2_);
#line 583 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp4_ = _tmp3_;
#line 583 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	directory_monitor_mdbg (_tmp4_);
#line 583 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_g_free0 (_tmp4_);
#line 583 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_g_free0 (_tmp2_);
#line 584 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp5_ = file;
#line 584 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp6_ = info;
#line 584 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_signal_emit_by_name (self, "file-alteration-completed", _tmp5_, _tmp6_);
#line 1649 "DirectoryMonitor.c"
}


void directory_monitor_notify_file_alteration_completed (DirectoryMonitor* self, GFile* file, GFileInfo* info) {
#line 582 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 582 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	DIRECTORY_MONITOR_GET_CLASS (self)->notify_file_alteration_completed (self, file, info);
#line 1658 "DirectoryMonitor.c"
}


static void directory_monitor_real_notify_file_attributes_altered (DirectoryMonitor* self, GFile* file) {
	GFile* _tmp0_;
	gchar* _tmp1_ = NULL;
	gchar* _tmp2_;
	gchar* _tmp3_ = NULL;
	gchar* _tmp4_;
	GFile* _tmp5_;
#line 587 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (file));
#line 588 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp0_ = file;
#line 588 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp1_ = g_file_get_path (_tmp0_);
#line 588 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp2_ = _tmp1_;
#line 588 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp3_ = g_strdup_printf ("file attributes altered: %s", _tmp2_);
#line 588 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp4_ = _tmp3_;
#line 588 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	directory_monitor_mdbg (_tmp4_);
#line 588 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_g_free0 (_tmp4_);
#line 588 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_g_free0 (_tmp2_);
#line 589 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp5_ = file;
#line 589 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_signal_emit_by_name (self, "file-attributes-altered", _tmp5_);
#line 1691 "DirectoryMonitor.c"
}


void directory_monitor_notify_file_attributes_altered (DirectoryMonitor* self, GFile* file) {
#line 587 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 587 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	DIRECTORY_MONITOR_GET_CLASS (self)->notify_file_attributes_altered (self, file);
#line 1700 "DirectoryMonitor.c"
}


static void directory_monitor_internal_notify_file_deleted (DirectoryMonitor* self, GFile* file) {
	DirectoryMonitorFileInfoMap* _tmp0_;
	GFile* _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean removed;
	GFile* _tmp3_;
#line 592 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 592 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (file));
#line 593 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp0_ = self->priv->files;
#line 593 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp1_ = file;
#line 593 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp2_ = directory_monitor_file_info_map_remove (_tmp0_, _tmp1_, NULL);
#line 593 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	removed = _tmp2_;
#line 594 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_assert (removed);
#line 596 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp3_ = file;
#line 596 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	directory_monitor_notify_file_deleted (self, _tmp3_);
#line 1728 "DirectoryMonitor.c"
}


static void directory_monitor_real_notify_file_deleted (DirectoryMonitor* self, GFile* file) {
	GFile* _tmp0_;
	gchar* _tmp1_ = NULL;
	gchar* _tmp2_;
	gchar* _tmp3_ = NULL;
	gchar* _tmp4_;
	GFile* _tmp5_;
#line 599 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (file));
#line 600 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp0_ = file;
#line 600 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp1_ = g_file_get_path (_tmp0_);
#line 600 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp2_ = _tmp1_;
#line 600 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp3_ = g_strdup_printf ("file deleted: %s", _tmp2_);
#line 600 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp4_ = _tmp3_;
#line 600 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	directory_monitor_mdbg (_tmp4_);
#line 600 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_g_free0 (_tmp4_);
#line 600 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_g_free0 (_tmp2_);
#line 601 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp5_ = file;
#line 601 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_signal_emit_by_name (self, "file-deleted", _tmp5_);
#line 1761 "DirectoryMonitor.c"
}


void directory_monitor_notify_file_deleted (DirectoryMonitor* self, GFile* file) {
#line 599 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 599 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	DIRECTORY_MONITOR_GET_CLASS (self)->notify_file_deleted (self, file);
#line 1770 "DirectoryMonitor.c"
}


static void directory_monitor_internal_notify_directory_created (DirectoryMonitor* self, GFile* dir, GFileInfo* info) {
	GFile* old_dir = NULL;
	GFileInfo* old_dir_info = NULL;
	GFile* _tmp0_;
	GFileInfo* _tmp1_;
	GFile* _tmp2_ = NULL;
	GFileInfo* _tmp3_ = NULL;
	gboolean _tmp4_ = FALSE;
#line 604 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 604 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (dir));
#line 604 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE_INFO (info));
#line 607 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp0_ = dir;
#line 607 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp1_ = info;
#line 607 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp4_ = directory_monitor_is_file_create_move (self, _tmp0_, _tmp1_, &_tmp2_, &_tmp3_);
#line 607 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_g_object_unref0 (old_dir);
#line 607 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	old_dir = _tmp2_;
#line 607 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_g_object_unref0 (old_dir_info);
#line 607 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	old_dir_info = _tmp3_;
#line 607 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	if (_tmp4_) {
#line 1804 "DirectoryMonitor.c"
		DirectoryMonitorFileInfoMap* _tmp5_;
		GFile* _tmp6_;
		DirectoryMonitorFileInfoMap* _tmp7_;
		GFile* _tmp8_;
		GFileInfo* _tmp9_;
		GFile* _tmp10_;
		GFileInfo* _tmp11_;
#line 613 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_tmp5_ = self->priv->files;
#line 613 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_tmp6_ = old_dir;
#line 613 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_tmp7_ = self->priv->parent_moved;
#line 613 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		directory_monitor_file_info_map_remove_descendents (_tmp5_, _tmp6_, _tmp7_);
#line 615 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_tmp8_ = old_dir;
#line 615 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_tmp9_ = old_dir_info;
#line 615 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_tmp10_ = dir;
#line 615 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_tmp11_ = info;
#line 615 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		directory_monitor_internal_notify_directory_moved (self, _tmp8_, _tmp9_, _tmp10_, _tmp11_);
#line 1830 "DirectoryMonitor.c"
	} else {
		DirectoryMonitorFileInfoMap* _tmp12_;
		GFile* _tmp13_;
		GFileInfo* _tmp14_;
		gboolean _tmp15_ = FALSE;
		gboolean updated;
		gboolean _tmp16_;
		GFile* _tmp17_;
		GFileInfo* _tmp18_;
#line 617 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_tmp12_ = self->priv->files;
#line 617 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_tmp13_ = dir;
#line 617 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_tmp14_ = info;
#line 617 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_tmp15_ = directory_monitor_file_info_map_update (_tmp12_, _tmp13_, _tmp14_);
#line 617 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		updated = _tmp15_;
#line 618 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_tmp16_ = updated;
#line 618 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		g_assert (_tmp16_);
#line 620 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_tmp17_ = dir;
#line 620 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_tmp18_ = info;
#line 620 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		directory_monitor_notify_directory_created (self, _tmp17_, _tmp18_);
#line 1860 "DirectoryMonitor.c"
	}
#line 604 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_g_object_unref0 (old_dir_info);
#line 604 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_g_object_unref0 (old_dir);
#line 1866 "DirectoryMonitor.c"
}


static void directory_monitor_real_notify_directory_created (DirectoryMonitor* self, GFile* dir, GFileInfo* info) {
	GFile* _tmp0_;
	gchar* _tmp1_ = NULL;
	gchar* _tmp2_;
	gchar* _tmp3_ = NULL;
	gchar* _tmp4_;
	GFile* _tmp5_;
	GFileInfo* _tmp6_;
#line 624 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (dir));
#line 624 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE_INFO (info));
#line 625 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp0_ = dir;
#line 625 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp1_ = g_file_get_path (_tmp0_);
#line 625 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp2_ = _tmp1_;
#line 625 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp3_ = g_strdup_printf ("directory created: %s", _tmp2_);
#line 625 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp4_ = _tmp3_;
#line 625 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	directory_monitor_mdbg (_tmp4_);
#line 625 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_g_free0 (_tmp4_);
#line 625 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_g_free0 (_tmp2_);
#line 626 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp5_ = dir;
#line 626 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp6_ = info;
#line 626 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_signal_emit_by_name (self, "directory-created", _tmp5_, _tmp6_);
#line 1904 "DirectoryMonitor.c"
}


void directory_monitor_notify_directory_created (DirectoryMonitor* self, GFile* dir, GFileInfo* info) {
#line 624 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 624 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	DIRECTORY_MONITOR_GET_CLASS (self)->notify_directory_created (self, dir, info);
#line 1913 "DirectoryMonitor.c"
}


static void directory_monitor_internal_notify_directory_moved (DirectoryMonitor* self, GFile* old_dir, GFileInfo* old_dir_info, GFile* new_dir, GFileInfo* new_dir_info) {
	GFile* _tmp0_;
	GFileInfo* _tmp1_;
	GFile* _tmp2_;
	GFileInfo* _tmp3_;
#line 629 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 629 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (old_dir));
#line 629 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE_INFO (old_dir_info));
#line 629 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (new_dir));
#line 629 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE_INFO (new_dir_info));
#line 631 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp0_ = old_dir;
#line 631 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp1_ = old_dir_info;
#line 631 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp2_ = new_dir;
#line 631 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp3_ = new_dir_info;
#line 631 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	directory_monitor_async_internal_notify_directory_moved (self, _tmp0_, _tmp1_, _tmp2_, _tmp3_, NULL, NULL);
#line 1942 "DirectoryMonitor.c"
}


static void directory_monitor_async_internal_notify_directory_moved_data_free (gpointer _data) {
	DirectoryMonitorAsyncInternalNotifyDirectoryMovedData* _data_;
	_data_ = _data;
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_g_object_unref0 (_data_->old_dir);
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_g_object_unref0 (_data_->old_dir_info);
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_g_object_unref0 (_data_->new_dir);
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_g_object_unref0 (_data_->new_dir_info);
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_g_object_unref0 (_data_->self);
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_slice_free (DirectoryMonitorAsyncInternalNotifyDirectoryMovedData, _data_);
#line 1961 "DirectoryMonitor.c"
}


static void directory_monitor_async_internal_notify_directory_moved (DirectoryMonitor* self, GFile* old_dir, GFileInfo* old_dir_info, GFile* new_dir, GFileInfo* new_dir_info, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	DirectoryMonitorAsyncInternalNotifyDirectoryMovedData* _data_;
	DirectoryMonitor* _tmp0_;
	GFile* _tmp1_;
	GFile* _tmp2_;
	GFileInfo* _tmp3_;
	GFileInfo* _tmp4_;
	GFile* _tmp5_;
	GFile* _tmp6_;
	GFileInfo* _tmp7_;
	GFileInfo* _tmp8_;
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_data_ = g_slice_new0 (DirectoryMonitorAsyncInternalNotifyDirectoryMovedData);
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_data_->_async_result = g_simple_async_result_new (G_OBJECT (self), _callback_, _user_data_, directory_monitor_async_internal_notify_directory_moved);
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_simple_async_result_set_op_res_gpointer (_data_->_async_result, _data_, directory_monitor_async_internal_notify_directory_moved_data_free);
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_data_->self = _tmp0_;
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp1_ = old_dir;
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_data_->old_dir = _tmp2_;
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp3_ = old_dir_info;
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp4_ = _g_object_ref0 (_tmp3_);
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_data_->old_dir_info = _tmp4_;
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp5_ = new_dir;
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp6_ = _g_object_ref0 (_tmp5_);
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_data_->new_dir = _tmp6_;
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp7_ = new_dir_info;
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp8_ = _g_object_ref0 (_tmp7_);
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_data_->new_dir_info = _tmp8_;
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	directory_monitor_async_internal_notify_directory_moved_co (_data_);
#line 2012 "DirectoryMonitor.c"
}


static void directory_monitor_async_internal_notify_directory_moved_finish (DirectoryMonitor* self, GAsyncResult* _res_) {
	DirectoryMonitorAsyncInternalNotifyDirectoryMovedData* _data_;
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_data_ = g_simple_async_result_get_op_res_gpointer (G_SIMPLE_ASYNC_RESULT (_res_));
#line 2020 "DirectoryMonitor.c"
}


static void directory_monitor_async_internal_notify_directory_moved_ready (GObject* source_object, GAsyncResult* _res_, gpointer _user_data_) {
	DirectoryMonitorAsyncInternalNotifyDirectoryMovedData* _data_;
#line 651 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_data_ = _user_data_;
#line 651 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_data_->_source_object_ = source_object;
#line 651 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_data_->_res_ = _res_;
#line 651 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	directory_monitor_async_internal_notify_directory_moved_co (_data_);
#line 2034 "DirectoryMonitor.c"
}


static gboolean _directory_monitor_async_internal_notify_directory_moved_co_gsource_func (gpointer self) {
	gboolean result;
	result = directory_monitor_async_internal_notify_directory_moved_co (self);
#line 667 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	return result;
#line 2043 "DirectoryMonitor.c"
}


static gboolean directory_monitor_async_internal_notify_directory_moved_co (DirectoryMonitorAsyncInternalNotifyDirectoryMovedData* _data_) {
#line 634 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	switch (_data_->_state_) {
#line 634 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		case 0:
#line 2052 "DirectoryMonitor.c"
		goto _state_0;
#line 634 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		case 1:
#line 2056 "DirectoryMonitor.c"
		goto _state_1;
#line 634 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		case 2:
#line 2060 "DirectoryMonitor.c"
		goto _state_2;
		default:
#line 634 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		g_assert_not_reached ();
#line 2065 "DirectoryMonitor.c"
	}
	_state_0:
#line 636 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_data_->_tmp0_ = g_file_equal;
#line 636 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_data_->_tmp1_ = gee_array_list_new (G_TYPE_FILE, (GBoxedCopyFunc) g_object_ref, g_object_unref, _data_->_tmp0_);
#line 636 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_data_->file_children = _data_->_tmp1_;
#line 637 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_data_->_tmp2_ = g_file_equal;
#line 637 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_data_->_tmp3_ = gee_array_list_new (G_TYPE_FILE, (GBoxedCopyFunc) g_object_ref, g_object_unref, _data_->_tmp2_);
#line 637 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_data_->dir_children = _data_->_tmp3_;
#line 638 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_data_->_tmp4_ = _data_->self->priv->files;
#line 638 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_data_->_tmp5_ = _data_->old_dir;
#line 638 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_data_->_tmp6_ = _data_->file_children;
#line 638 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_data_->_tmp7_ = _data_->dir_children;
#line 638 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_data_->_tmp8_ = 0;
#line 638 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_data_->_tmp8_ = directory_monitor_file_info_map_get_children (_data_->_tmp4_, _data_->_tmp5_, GEE_COLLECTION (_data_->_tmp6_), GEE_COLLECTION (_data_->_tmp7_));
#line 638 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_data_->count = _data_->_tmp8_;
#line 639 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_data_->_tmp9_ = _data_->count;
#line 639 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	if (_data_->_tmp9_ > 0) {
#line 2098 "DirectoryMonitor.c"
		{
#line 643 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_data_->_tmp10_ = _data_->dir_children;
#line 643 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_data_->_tmp11_ = _g_object_ref0 (_data_->_tmp10_);
#line 643 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_data_->_dir_child_list = _data_->_tmp11_;
#line 643 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_data_->_tmp12_ = _data_->_dir_child_list;
#line 643 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_data_->_tmp13_ = gee_abstract_collection_get_size (GEE_COLLECTION (_data_->_tmp12_));
#line 643 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_data_->_tmp14_ = _data_->_tmp13_;
#line 643 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_data_->_dir_child_size = _data_->_tmp14_;
#line 643 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_data_->_dir_child_index = -1;
#line 643 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			while (TRUE) {
#line 643 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_data_->_tmp15_ = _data_->_dir_child_index;
#line 643 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_data_->_dir_child_index = _data_->_tmp15_ + 1;
#line 643 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_data_->_tmp16_ = _data_->_dir_child_index;
#line 643 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_data_->_tmp17_ = _data_->_dir_child_size;
#line 643 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				if (!(_data_->_tmp16_ < _data_->_tmp17_)) {
#line 643 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					break;
#line 2130 "DirectoryMonitor.c"
				}
#line 643 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_data_->_tmp18_ = _data_->_dir_child_list;
#line 643 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_data_->_tmp19_ = _data_->_dir_child_index;
#line 643 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_data_->_tmp20_ = NULL;
#line 643 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_data_->_tmp20_ = gee_abstract_list_get (GEE_ABSTRACT_LIST (_data_->_tmp18_), _data_->_tmp19_);
#line 643 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_data_->dir_child = (GFile*) _data_->_tmp20_;
#line 644 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_data_->_tmp21_ = _data_->self->priv->files;
#line 644 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_data_->_tmp22_ = _data_->dir_child;
#line 644 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_data_->_tmp23_ = NULL;
#line 644 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_data_->_tmp23_ = directory_monitor_file_info_map_get_info (_data_->_tmp21_, _data_->_tmp22_);
#line 644 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_data_->dir_info = _data_->_tmp23_;
#line 645 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_data_->_tmp24_ = _data_->dir_info;
#line 645 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				if (_data_->_tmp24_ == NULL) {
#line 646 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					_data_->_tmp25_ = _data_->dir_child;
#line 646 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					_data_->_tmp26_ = NULL;
#line 646 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					_data_->_tmp26_ = g_file_get_path (_data_->_tmp25_);
#line 646 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					_data_->_tmp27_ = _data_->_tmp26_;
#line 646 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					g_warning ("DirectoryMonitor.vala:646: Unable to retrieve directory-moved info for" \
" %s", _data_->_tmp27_);
#line 646 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					_g_free0 (_data_->_tmp27_);
#line 648 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					_g_object_unref0 (_data_->dir_info);
#line 648 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					_g_object_unref0 (_data_->dir_child);
#line 648 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					continue;
#line 2174 "DirectoryMonitor.c"
				}
#line 651 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_data_->_tmp28_ = _data_->dir_child;
#line 651 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_data_->_tmp29_ = _data_->dir_info;
#line 651 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_data_->_tmp30_ = _data_->new_dir;
#line 651 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_data_->_tmp31_ = _data_->dir_child;
#line 651 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_data_->_tmp32_ = NULL;
#line 651 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_data_->_tmp32_ = g_file_get_basename (_data_->_tmp31_);
#line 651 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_data_->_tmp33_ = _data_->_tmp32_;
#line 651 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_data_->_tmp34_ = NULL;
#line 651 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_data_->_tmp34_ = g_file_get_child (_data_->_tmp30_, _data_->_tmp33_);
#line 651 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_data_->_tmp35_ = _data_->_tmp34_;
#line 651 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_data_->_tmp36_ = _data_->dir_info;
#line 651 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_data_->_state_ = 1;
#line 651 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				directory_monitor_async_internal_notify_directory_moved (_data_->self, _data_->_tmp28_, _data_->_tmp29_, _data_->_tmp35_, _data_->_tmp36_, directory_monitor_async_internal_notify_directory_moved_ready, _data_);
#line 651 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				return FALSE;
#line 2204 "DirectoryMonitor.c"
				_state_1:
#line 651 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				directory_monitor_async_internal_notify_directory_moved_finish (_data_->self, _data_->_res_);
#line 651 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_g_object_unref0 (_data_->_tmp35_);
#line 651 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_g_free0 (_data_->_tmp33_);
#line 643 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_g_object_unref0 (_data_->dir_info);
#line 643 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_g_object_unref0 (_data_->dir_child);
#line 2216 "DirectoryMonitor.c"
			}
#line 643 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_g_object_unref0 (_data_->_dir_child_list);
#line 2220 "DirectoryMonitor.c"
		}
		{
#line 656 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_data_->_tmp37_ = _data_->file_children;
#line 656 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_data_->_tmp38_ = _g_object_ref0 (_data_->_tmp37_);
#line 656 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_data_->_file_child_list = _data_->_tmp38_;
#line 656 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_data_->_tmp39_ = _data_->_file_child_list;
#line 656 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_data_->_tmp40_ = gee_abstract_collection_get_size (GEE_COLLECTION (_data_->_tmp39_));
#line 656 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_data_->_tmp41_ = _data_->_tmp40_;
#line 656 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_data_->_file_child_size = _data_->_tmp41_;
#line 656 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_data_->_file_child_index = -1;
#line 656 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			while (TRUE) {
#line 656 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_data_->_tmp42_ = _data_->_file_child_index;
#line 656 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_data_->_file_child_index = _data_->_tmp42_ + 1;
#line 656 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_data_->_tmp43_ = _data_->_file_child_index;
#line 656 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_data_->_tmp44_ = _data_->_file_child_size;
#line 656 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				if (!(_data_->_tmp43_ < _data_->_tmp44_)) {
#line 656 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					break;
#line 2253 "DirectoryMonitor.c"
				}
#line 656 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_data_->_tmp45_ = _data_->_file_child_list;
#line 656 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_data_->_tmp46_ = _data_->_file_child_index;
#line 656 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_data_->_tmp47_ = NULL;
#line 656 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_data_->_tmp47_ = gee_abstract_list_get (GEE_ABSTRACT_LIST (_data_->_tmp45_), _data_->_tmp46_);
#line 656 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_data_->file_child = (GFile*) _data_->_tmp47_;
#line 657 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_data_->_tmp48_ = _data_->self->priv->files;
#line 657 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_data_->_tmp49_ = _data_->file_child;
#line 657 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_data_->_tmp50_ = NULL;
#line 657 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_data_->_tmp50_ = directory_monitor_file_info_map_get_info (_data_->_tmp48_, _data_->_tmp49_);
#line 657 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_data_->file_info = _data_->_tmp50_;
#line 658 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_data_->_tmp51_ = _data_->file_info;
#line 658 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				if (_data_->_tmp51_ == NULL) {
#line 659 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					_data_->_tmp52_ = _data_->file_child;
#line 659 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					_data_->_tmp53_ = NULL;
#line 659 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					_data_->_tmp53_ = g_file_get_path (_data_->_tmp52_);
#line 659 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					_data_->_tmp54_ = _data_->_tmp53_;
#line 659 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					g_warning ("DirectoryMonitor.vala:659: Unable to retrieve directory-moved info for" \
" %s", _data_->_tmp54_);
#line 659 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					_g_free0 (_data_->_tmp54_);
#line 661 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					_g_object_unref0 (_data_->file_info);
#line 661 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					_g_object_unref0 (_data_->file_child);
#line 661 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					continue;
#line 2297 "DirectoryMonitor.c"
				}
#line 664 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_data_->_tmp55_ = _data_->file_child;
#line 664 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_data_->_tmp56_ = _data_->new_dir;
#line 664 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_data_->_tmp57_ = _data_->file_child;
#line 664 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_data_->_tmp58_ = NULL;
#line 664 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_data_->_tmp58_ = g_file_get_basename (_data_->_tmp57_);
#line 664 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_data_->_tmp59_ = _data_->_tmp58_;
#line 664 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_data_->_tmp60_ = NULL;
#line 664 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_data_->_tmp60_ = g_file_get_child (_data_->_tmp56_, _data_->_tmp59_);
#line 664 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_data_->_tmp61_ = _data_->_tmp60_;
#line 664 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_data_->_tmp62_ = _data_->file_info;
#line 664 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				directory_monitor_internal_notify_file_moved (_data_->self, _data_->_tmp55_, _data_->_tmp61_, _data_->_tmp62_);
#line 664 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_g_object_unref0 (_data_->_tmp61_);
#line 664 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_g_free0 (_data_->_tmp59_);
#line 667 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				g_idle_add_full (DIRECTORY_MONITOR_DEFAULT_PRIORITY, _directory_monitor_async_internal_notify_directory_moved_co_gsource_func, _data_, NULL);
#line 668 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_data_->_state_ = 2;
#line 668 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				return FALSE;
#line 2331 "DirectoryMonitor.c"
				_state_2:
				;
#line 656 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_g_object_unref0 (_data_->file_info);
#line 656 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_g_object_unref0 (_data_->file_child);
#line 2338 "DirectoryMonitor.c"
			}
#line 656 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_g_object_unref0 (_data_->_file_child_list);
#line 2342 "DirectoryMonitor.c"
		}
	}
#line 674 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_data_->_tmp63_ = _data_->self->priv->files;
#line 674 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_data_->_tmp64_ = _data_->old_dir;
#line 674 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	directory_monitor_file_info_map_remove (_data_->_tmp63_, _data_->_tmp64_, NULL);
#line 676 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_data_->_tmp65_ = _data_->self->priv->files;
#line 676 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_data_->_tmp66_ = _data_->new_dir;
#line 676 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_data_->_tmp67_ = _data_->new_dir_info;
#line 676 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_data_->_tmp68_ = FALSE;
#line 676 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_data_->_tmp68_ = directory_monitor_file_info_map_update (_data_->_tmp65_, _data_->_tmp66_, _data_->_tmp67_);
#line 676 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_data_->updated = _data_->_tmp68_;
#line 677 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_assert (_data_->updated);
#line 680 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_data_->_tmp69_ = _data_->old_dir;
#line 680 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_data_->_tmp70_ = _data_->old_dir_info;
#line 680 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	directory_monitor_remove_monitor (_data_->self, _data_->_tmp69_, _data_->_tmp70_);
#line 681 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_data_->_tmp71_ = _data_->new_dir;
#line 681 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_data_->_tmp72_ = _data_->new_dir_info;
#line 681 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	directory_monitor_add_monitor (_data_->self, _data_->_tmp71_, _data_->_tmp72_);
#line 683 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_data_->_tmp73_ = _data_->old_dir;
#line 683 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_data_->_tmp74_ = _data_->new_dir;
#line 683 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_data_->_tmp75_ = _data_->new_dir_info;
#line 683 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	directory_monitor_notify_directory_moved (_data_->self, _data_->_tmp73_, _data_->_tmp74_, _data_->_tmp75_);
#line 634 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_g_object_unref0 (_data_->dir_children);
#line 634 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_g_object_unref0 (_data_->file_children);
#line 634 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	if (_data_->_state_ == 0) {
#line 634 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		g_simple_async_result_complete_in_idle (_data_->_async_result);
#line 2393 "DirectoryMonitor.c"
	} else {
#line 634 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		g_simple_async_result_complete (_data_->_async_result);
#line 2397 "DirectoryMonitor.c"
	}
#line 634 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_object_unref (_data_->_async_result);
#line 634 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	return FALSE;
#line 2403 "DirectoryMonitor.c"
}


static void directory_monitor_real_notify_directory_moved (DirectoryMonitor* self, GFile* old_dir, GFile* new_dir, GFileInfo* new_dir_info) {
	GFile* _tmp0_;
	gchar* _tmp1_ = NULL;
	gchar* _tmp2_;
	GFile* _tmp3_;
	gchar* _tmp4_ = NULL;
	gchar* _tmp5_;
	gchar* _tmp6_ = NULL;
	gchar* _tmp7_;
	GFile* _tmp8_;
	GFile* _tmp9_;
	GFileInfo* _tmp10_;
	GFile* _tmp11_;
	GFile* _tmp12_;
	gboolean _tmp13_ = FALSE;
#line 686 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (old_dir));
#line 686 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (new_dir));
#line 686 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE_INFO (new_dir_info));
#line 687 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp0_ = old_dir;
#line 687 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp1_ = g_file_get_path (_tmp0_);
#line 687 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp2_ = _tmp1_;
#line 687 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp3_ = new_dir;
#line 687 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp4_ = g_file_get_path (_tmp3_);
#line 687 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp5_ = _tmp4_;
#line 687 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp6_ = g_strdup_printf ("directory moved: %s -> %s", _tmp2_, _tmp5_);
#line 687 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp7_ = _tmp6_;
#line 687 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	directory_monitor_mdbg (_tmp7_);
#line 687 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_g_free0 (_tmp7_);
#line 687 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_g_free0 (_tmp5_);
#line 687 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_g_free0 (_tmp2_);
#line 688 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp8_ = old_dir;
#line 688 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp9_ = new_dir;
#line 688 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp10_ = new_dir_info;
#line 688 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_signal_emit_by_name (self, "directory-moved", _tmp8_, _tmp9_, _tmp10_);
#line 690 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp11_ = old_dir;
#line 690 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp12_ = self->priv->root;
#line 690 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp13_ = g_file_equal (_tmp11_, _tmp12_);
#line 690 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	if (_tmp13_) {
#line 2468 "DirectoryMonitor.c"
		GFile* _tmp14_;
		GFile* _tmp15_;
		GFileInfo* _tmp16_;
#line 691 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_tmp14_ = old_dir;
#line 691 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_tmp15_ = new_dir;
#line 691 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_tmp16_ = new_dir_info;
#line 691 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		directory_monitor_internal_notify_root_moved (self, _tmp14_, _tmp15_, _tmp16_);
#line 2480 "DirectoryMonitor.c"
	}
}


void directory_monitor_notify_directory_moved (DirectoryMonitor* self, GFile* old_dir, GFile* new_dir, GFileInfo* new_dir_info) {
#line 686 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 686 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	DIRECTORY_MONITOR_GET_CLASS (self)->notify_directory_moved (self, old_dir, new_dir, new_dir_info);
#line 2490 "DirectoryMonitor.c"
}


static void directory_monitor_real_notify_directory_altered (DirectoryMonitor* self, GFile* dir) {
	GFile* _tmp0_;
	gchar* _tmp1_ = NULL;
	gchar* _tmp2_;
	gchar* _tmp3_ = NULL;
	gchar* _tmp4_;
	GFile* _tmp5_;
#line 694 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (dir));
#line 695 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp0_ = dir;
#line 695 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp1_ = g_file_get_path (_tmp0_);
#line 695 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp2_ = _tmp1_;
#line 695 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp3_ = g_strdup_printf ("directory altered: %s", _tmp2_);
#line 695 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp4_ = _tmp3_;
#line 695 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	directory_monitor_mdbg (_tmp4_);
#line 695 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_g_free0 (_tmp4_);
#line 695 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_g_free0 (_tmp2_);
#line 696 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp5_ = dir;
#line 696 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_signal_emit_by_name (self, "directory-altered", _tmp5_);
#line 2523 "DirectoryMonitor.c"
}


void directory_monitor_notify_directory_altered (DirectoryMonitor* self, GFile* dir) {
#line 694 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 694 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	DIRECTORY_MONITOR_GET_CLASS (self)->notify_directory_altered (self, dir);
#line 2532 "DirectoryMonitor.c"
}


static void directory_monitor_internal_notify_directory_alteration_completed (DirectoryMonitor* self, GFile* dir, GFileInfo* info) {
	DirectoryMonitorFileInfoMap* _tmp0_;
	GFile* _tmp1_;
	GFileInfo* _tmp2_;
	gboolean _tmp3_ = FALSE;
	gboolean updated;
	GFile* _tmp4_;
	GFileInfo* _tmp5_;
#line 699 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 699 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (dir));
#line 699 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE_INFO (info));
#line 700 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp0_ = self->priv->files;
#line 700 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp1_ = dir;
#line 700 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp2_ = info;
#line 700 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp3_ = directory_monitor_file_info_map_update (_tmp0_, _tmp1_, _tmp2_);
#line 700 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	updated = _tmp3_;
#line 701 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_assert (updated);
#line 703 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp4_ = dir;
#line 703 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp5_ = info;
#line 703 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	directory_monitor_notify_directory_alteration_completed (self, _tmp4_, _tmp5_);
#line 2568 "DirectoryMonitor.c"
}


static void directory_monitor_real_notify_directory_alteration_completed (DirectoryMonitor* self, GFile* dir, GFileInfo* info) {
	GFile* _tmp0_;
	gchar* _tmp1_ = NULL;
	gchar* _tmp2_;
	gchar* _tmp3_ = NULL;
	gchar* _tmp4_;
	GFile* _tmp5_;
	GFileInfo* _tmp6_;
#line 706 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (dir));
#line 706 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE_INFO (info));
#line 707 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp0_ = dir;
#line 707 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp1_ = g_file_get_path (_tmp0_);
#line 707 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp2_ = _tmp1_;
#line 707 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp3_ = g_strdup_printf ("directory alteration completed: %s", _tmp2_);
#line 707 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp4_ = _tmp3_;
#line 707 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	directory_monitor_mdbg (_tmp4_);
#line 707 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_g_free0 (_tmp4_);
#line 707 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_g_free0 (_tmp2_);
#line 708 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp5_ = dir;
#line 708 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp6_ = info;
#line 708 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_signal_emit_by_name (self, "directory-alteration-completed", _tmp5_, _tmp6_);
#line 2606 "DirectoryMonitor.c"
}


void directory_monitor_notify_directory_alteration_completed (DirectoryMonitor* self, GFile* dir, GFileInfo* info) {
#line 706 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 706 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	DIRECTORY_MONITOR_GET_CLASS (self)->notify_directory_alteration_completed (self, dir, info);
#line 2615 "DirectoryMonitor.c"
}


static void directory_monitor_real_notify_directory_attributes_altered (DirectoryMonitor* self, GFile* dir) {
	GFile* _tmp0_;
	gchar* _tmp1_ = NULL;
	gchar* _tmp2_;
	gchar* _tmp3_ = NULL;
	gchar* _tmp4_;
	GFile* _tmp5_;
#line 711 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (dir));
#line 712 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp0_ = dir;
#line 712 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp1_ = g_file_get_path (_tmp0_);
#line 712 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp2_ = _tmp1_;
#line 712 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp3_ = g_strdup_printf ("directory attributes altered: %s", _tmp2_);
#line 712 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp4_ = _tmp3_;
#line 712 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	directory_monitor_mdbg (_tmp4_);
#line 712 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_g_free0 (_tmp4_);
#line 712 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_g_free0 (_tmp2_);
#line 713 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp5_ = dir;
#line 713 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_signal_emit_by_name (self, "directory-attributes-altered", _tmp5_);
#line 2648 "DirectoryMonitor.c"
}


void directory_monitor_notify_directory_attributes_altered (DirectoryMonitor* self, GFile* dir) {
#line 711 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 711 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	DIRECTORY_MONITOR_GET_CLASS (self)->notify_directory_attributes_altered (self, dir);
#line 2657 "DirectoryMonitor.c"
}


static void directory_monitor_internal_notify_directory_deleted (DirectoryMonitor* self, GFile* dir) {
	DirectoryMonitorFileInfoMap* _tmp0_;
	GFile* _tmp1_;
	GFileInfo* _tmp2_ = NULL;
	GFileInfo* info;
	GFile* _tmp3_;
	GFile* _tmp4_;
#line 716 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 716 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (dir));
#line 717 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp0_ = self->priv->files;
#line 717 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp1_ = dir;
#line 717 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp2_ = directory_monitor_file_info_map_get_info (_tmp0_, _tmp1_);
#line 717 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	info = _tmp2_;
#line 718 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_assert (info != NULL);
#line 721 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp3_ = dir;
#line 721 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	directory_monitor_remove_monitor (self, _tmp3_, info);
#line 723 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp4_ = dir;
#line 723 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	directory_monitor_async_notify_directory_deleted (self, _tmp4_, FALSE, NULL, NULL);
#line 716 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_g_object_unref0 (info);
#line 2692 "DirectoryMonitor.c"
}


static void directory_monitor_async_notify_directory_deleted_data_free (gpointer _data) {
	DirectoryMonitorAsyncNotifyDirectoryDeletedData* _data_;
	_data_ = _data;
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_g_object_unref0 (_data_->dir);
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_g_object_unref0 (_data_->self);
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_slice_free (DirectoryMonitorAsyncNotifyDirectoryDeletedData, _data_);
#line 2705 "DirectoryMonitor.c"
}


static void directory_monitor_async_notify_directory_deleted (DirectoryMonitor* self, GFile* dir, gboolean already_removed, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	DirectoryMonitorAsyncNotifyDirectoryDeletedData* _data_;
	DirectoryMonitor* _tmp0_;
	GFile* _tmp1_;
	GFile* _tmp2_;
	gboolean _tmp3_;
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_data_ = g_slice_new0 (DirectoryMonitorAsyncNotifyDirectoryDeletedData);
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_data_->_async_result = g_simple_async_result_new (G_OBJECT (self), _callback_, _user_data_, directory_monitor_async_notify_directory_deleted);
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_simple_async_result_set_op_res_gpointer (_data_->_async_result, _data_, directory_monitor_async_notify_directory_deleted_data_free);
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_data_->self = _tmp0_;
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp1_ = dir;
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_data_->dir = _tmp2_;
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp3_ = already_removed;
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_data_->already_removed = _tmp3_;
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	directory_monitor_async_notify_directory_deleted_co (_data_);
#line 2737 "DirectoryMonitor.c"
}


static void directory_monitor_async_notify_directory_deleted_finish (DirectoryMonitor* self, GAsyncResult* _res_) {
	DirectoryMonitorAsyncNotifyDirectoryDeletedData* _data_;
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_data_ = g_simple_async_result_get_op_res_gpointer (G_SIMPLE_ASYNC_RESULT (_res_));
#line 2745 "DirectoryMonitor.c"
}


static void directory_monitor_async_notify_directory_deleted_ready (GObject* source_object, GAsyncResult* _res_, gpointer _user_data_) {
	DirectoryMonitorAsyncNotifyDirectoryDeletedData* _data_;
#line 746 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_data_ = _user_data_;
#line 746 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_data_->_source_object_ = source_object;
#line 746 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_data_->_res_ = _res_;
#line 746 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	directory_monitor_async_notify_directory_deleted_co (_data_);
#line 2759 "DirectoryMonitor.c"
}


static gboolean _directory_monitor_async_notify_directory_deleted_co_gsource_func (gpointer self) {
	gboolean result;
	result = directory_monitor_async_notify_directory_deleted_co (self);
#line 755 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	return result;
#line 2768 "DirectoryMonitor.c"
}


static gboolean directory_monitor_async_notify_directory_deleted_co (DirectoryMonitorAsyncNotifyDirectoryDeletedData* _data_) {
#line 726 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	switch (_data_->_state_) {
#line 726 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		case 0:
#line 2777 "DirectoryMonitor.c"
		goto _state_0;
#line 726 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		case 1:
#line 2781 "DirectoryMonitor.c"
		goto _state_1;
#line 726 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		case 2:
#line 2785 "DirectoryMonitor.c"
		goto _state_2;
		default:
#line 726 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		g_assert_not_reached ();
#line 2790 "DirectoryMonitor.c"
	}
	_state_0:
#line 734 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_data_->_tmp0_ = g_file_equal;
#line 734 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_data_->_tmp1_ = gee_array_list_new (G_TYPE_FILE, (GBoxedCopyFunc) g_object_ref, g_object_unref, _data_->_tmp0_);
#line 734 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_data_->file_children = _data_->_tmp1_;
#line 735 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_data_->_tmp2_ = g_file_equal;
#line 735 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_data_->_tmp3_ = gee_array_list_new (G_TYPE_FILE, (GBoxedCopyFunc) g_object_ref, g_object_unref, _data_->_tmp2_);
#line 735 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_data_->dir_children = _data_->_tmp3_;
#line 736 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_data_->_tmp4_ = _data_->self->priv->files;
#line 736 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_data_->_tmp5_ = _data_->dir;
#line 736 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_data_->_tmp6_ = _data_->file_children;
#line 736 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_data_->_tmp7_ = _data_->dir_children;
#line 736 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_data_->_tmp8_ = 0;
#line 736 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_data_->_tmp8_ = directory_monitor_file_info_map_get_children (_data_->_tmp4_, _data_->_tmp5_, GEE_COLLECTION (_data_->_tmp6_), GEE_COLLECTION (_data_->_tmp7_));
#line 736 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_data_->count = _data_->_tmp8_;
#line 737 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_data_->_tmp9_ = _data_->count;
#line 737 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	if (_data_->_tmp9_ > 0) {
#line 2823 "DirectoryMonitor.c"
		{
#line 745 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_data_->_tmp10_ = _data_->dir_children;
#line 745 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_data_->_tmp11_ = _g_object_ref0 (_data_->_tmp10_);
#line 745 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_data_->_dir_child_list = _data_->_tmp11_;
#line 745 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_data_->_tmp12_ = _data_->_dir_child_list;
#line 745 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_data_->_tmp13_ = gee_abstract_collection_get_size (GEE_COLLECTION (_data_->_tmp12_));
#line 745 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_data_->_tmp14_ = _data_->_tmp13_;
#line 745 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_data_->_dir_child_size = _data_->_tmp14_;
#line 745 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_data_->_dir_child_index = -1;
#line 745 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			while (TRUE) {
#line 745 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_data_->_tmp15_ = _data_->_dir_child_index;
#line 745 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_data_->_dir_child_index = _data_->_tmp15_ + 1;
#line 745 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_data_->_tmp16_ = _data_->_dir_child_index;
#line 745 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_data_->_tmp17_ = _data_->_dir_child_size;
#line 745 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				if (!(_data_->_tmp16_ < _data_->_tmp17_)) {
#line 745 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					break;
#line 2855 "DirectoryMonitor.c"
				}
#line 745 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_data_->_tmp18_ = _data_->_dir_child_list;
#line 745 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_data_->_tmp19_ = _data_->_dir_child_index;
#line 745 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_data_->_tmp20_ = NULL;
#line 745 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_data_->_tmp20_ = gee_abstract_list_get (GEE_ABSTRACT_LIST (_data_->_tmp18_), _data_->_tmp19_);
#line 745 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_data_->dir_child = (GFile*) _data_->_tmp20_;
#line 746 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_data_->_tmp21_ = _data_->dir_child;
#line 746 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_data_->_state_ = 1;
#line 746 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				directory_monitor_async_notify_directory_deleted (_data_->self, _data_->_tmp21_, FALSE, directory_monitor_async_notify_directory_deleted_ready, _data_);
#line 746 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				return FALSE;
#line 2875 "DirectoryMonitor.c"
				_state_1:
#line 746 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				directory_monitor_async_notify_directory_deleted_finish (_data_->self, _data_->_res_);
#line 745 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_g_object_unref0 (_data_->dir_child);
#line 2881 "DirectoryMonitor.c"
			}
#line 745 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_g_object_unref0 (_data_->_dir_child_list);
#line 2885 "DirectoryMonitor.c"
		}
		{
#line 750 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_data_->_tmp22_ = _data_->file_children;
#line 750 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_data_->_tmp23_ = _g_object_ref0 (_data_->_tmp22_);
#line 750 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_data_->_file_child_list = _data_->_tmp23_;
#line 750 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_data_->_tmp24_ = _data_->_file_child_list;
#line 750 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_data_->_tmp25_ = gee_abstract_collection_get_size (GEE_COLLECTION (_data_->_tmp24_));
#line 750 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_data_->_tmp26_ = _data_->_tmp25_;
#line 750 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_data_->_file_child_size = _data_->_tmp26_;
#line 750 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_data_->_file_child_index = -1;
#line 750 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			while (TRUE) {
#line 750 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_data_->_tmp27_ = _data_->_file_child_index;
#line 750 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_data_->_file_child_index = _data_->_tmp27_ + 1;
#line 750 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_data_->_tmp28_ = _data_->_file_child_index;
#line 750 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_data_->_tmp29_ = _data_->_file_child_size;
#line 750 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				if (!(_data_->_tmp28_ < _data_->_tmp29_)) {
#line 750 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					break;
#line 2918 "DirectoryMonitor.c"
				}
#line 750 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_data_->_tmp30_ = _data_->_file_child_list;
#line 750 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_data_->_tmp31_ = _data_->_file_child_index;
#line 750 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_data_->_tmp32_ = NULL;
#line 750 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_data_->_tmp32_ = gee_abstract_list_get (GEE_ABSTRACT_LIST (_data_->_tmp30_), _data_->_tmp31_);
#line 750 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_data_->file_child = (GFile*) _data_->_tmp32_;
#line 751 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_data_->_tmp33_ = _data_->self->priv->files;
#line 751 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_data_->_tmp34_ = _data_->file_child;
#line 751 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				directory_monitor_file_info_map_remove (_data_->_tmp33_, _data_->_tmp34_, NULL);
#line 753 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_data_->_tmp35_ = _data_->file_child;
#line 753 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				directory_monitor_notify_file_deleted (_data_->self, _data_->_tmp35_);
#line 755 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				g_idle_add_full (DIRECTORY_MONITOR_DEFAULT_PRIORITY, _directory_monitor_async_notify_directory_deleted_co_gsource_func, _data_, NULL);
#line 756 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_data_->_state_ = 2;
#line 756 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				return FALSE;
#line 2946 "DirectoryMonitor.c"
				_state_2:
				;
#line 750 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_g_object_unref0 (_data_->file_child);
#line 2951 "DirectoryMonitor.c"
			}
#line 750 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_g_object_unref0 (_data_->_file_child_list);
#line 2955 "DirectoryMonitor.c"
		}
	}
#line 760 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_data_->_tmp36_ = _data_->already_removed;
#line 760 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	if (!_data_->_tmp36_) {
#line 761 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_data_->_tmp37_ = _data_->self->priv->files;
#line 761 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_data_->_tmp38_ = _data_->dir;
#line 761 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		directory_monitor_file_info_map_remove (_data_->_tmp37_, _data_->_tmp38_, NULL);
#line 2968 "DirectoryMonitor.c"
	}
#line 763 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_data_->_tmp39_ = _data_->dir;
#line 763 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	directory_monitor_notify_directory_deleted (_data_->self, _data_->_tmp39_);
#line 726 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_g_object_unref0 (_data_->dir_children);
#line 726 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_g_object_unref0 (_data_->file_children);
#line 726 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	if (_data_->_state_ == 0) {
#line 726 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		g_simple_async_result_complete_in_idle (_data_->_async_result);
#line 2982 "DirectoryMonitor.c"
	} else {
#line 726 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		g_simple_async_result_complete (_data_->_async_result);
#line 2986 "DirectoryMonitor.c"
	}
#line 726 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_object_unref (_data_->_async_result);
#line 726 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	return FALSE;
#line 2992 "DirectoryMonitor.c"
}


static void directory_monitor_real_notify_directory_deleted (DirectoryMonitor* self, GFile* dir) {
	GFile* _tmp0_;
	gchar* _tmp1_ = NULL;
	gchar* _tmp2_;
	gchar* _tmp3_ = NULL;
	gchar* _tmp4_;
	GFile* _tmp5_;
	GFile* _tmp6_;
	GFile* _tmp7_;
	gboolean _tmp8_ = FALSE;
#line 766 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (dir));
#line 767 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp0_ = dir;
#line 767 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp1_ = g_file_get_path (_tmp0_);
#line 767 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp2_ = _tmp1_;
#line 767 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp3_ = g_strdup_printf ("directory deleted: %s", _tmp2_);
#line 767 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp4_ = _tmp3_;
#line 767 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	directory_monitor_mdbg (_tmp4_);
#line 767 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_g_free0 (_tmp4_);
#line 767 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_g_free0 (_tmp2_);
#line 768 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp5_ = dir;
#line 768 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_signal_emit_by_name (self, "directory-deleted", _tmp5_);
#line 770 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp6_ = dir;
#line 770 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp7_ = self->priv->root;
#line 770 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp8_ = g_file_equal (_tmp6_, _tmp7_);
#line 770 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	if (_tmp8_) {
#line 3036 "DirectoryMonitor.c"
		GFile* _tmp9_;
#line 771 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_tmp9_ = dir;
#line 771 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		directory_monitor_notify_root_deleted (self, _tmp9_);
#line 3042 "DirectoryMonitor.c"
	}
}


void directory_monitor_notify_directory_deleted (DirectoryMonitor* self, GFile* dir) {
#line 766 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 766 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	DIRECTORY_MONITOR_GET_CLASS (self)->notify_directory_deleted (self, dir);
#line 3052 "DirectoryMonitor.c"
}


static void directory_monitor_real_notify_closed (DirectoryMonitor* self) {
	GFile* _tmp0_;
	gchar* _tmp1_ = NULL;
	gchar* _tmp2_;
	gchar* _tmp3_ = NULL;
	gchar* _tmp4_;
#line 775 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp0_ = self->priv->root;
#line 775 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp1_ = g_file_get_path (_tmp0_);
#line 775 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp2_ = _tmp1_;
#line 775 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp3_ = g_strdup_printf ("monitoring of %s closed", _tmp2_);
#line 775 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp4_ = _tmp3_;
#line 775 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	directory_monitor_mdbg (_tmp4_);
#line 775 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_g_free0 (_tmp4_);
#line 775 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_g_free0 (_tmp2_);
#line 776 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_signal_emit_by_name (self, "closed");
#line 3080 "DirectoryMonitor.c"
}


void directory_monitor_notify_closed (DirectoryMonitor* self) {
#line 774 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 774 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	DIRECTORY_MONITOR_GET_CLASS (self)->notify_closed (self);
#line 3089 "DirectoryMonitor.c"
}


GFile* directory_monitor_get_root (DirectoryMonitor* self) {
	GFile* result = NULL;
	GFile* _tmp0_;
	GFile* _tmp1_;
#line 779 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_val_if_fail (IS_DIRECTORY_MONITOR (self), NULL);
#line 780 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp0_ = self->priv->root;
#line 780 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 780 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	result = _tmp1_;
#line 780 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	return result;
#line 3107 "DirectoryMonitor.c"
}


gboolean directory_monitor_is_in_root (DirectoryMonitor* self, GFile* file) {
	gboolean result = FALSE;
	GFile* _tmp0_;
	GFile* _tmp1_;
	gboolean _tmp2_ = FALSE;
#line 783 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_val_if_fail (IS_DIRECTORY_MONITOR (self), FALSE);
#line 783 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_val_if_fail (G_IS_FILE (file), FALSE);
#line 784 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp0_ = file;
#line 784 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp1_ = self->priv->root;
#line 784 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp2_ = g_file_has_prefix (_tmp0_, _tmp1_);
#line 784 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	result = _tmp2_;
#line 784 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	return result;
#line 3130 "DirectoryMonitor.c"
}


gboolean directory_monitor_has_started (DirectoryMonitor* self) {
	gboolean result = FALSE;
	gboolean _tmp0_;
#line 787 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_val_if_fail (IS_DIRECTORY_MONITOR (self), FALSE);
#line 788 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp0_ = self->priv->started;
#line 788 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	result = _tmp0_;
#line 788 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	return result;
#line 3145 "DirectoryMonitor.c"
}


void directory_monitor_start_discovery (DirectoryMonitor* self) {
	gboolean _tmp0_;
	GFile* _tmp1_;
#line 791 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 792 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp0_ = self->priv->started;
#line 792 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_assert (!_tmp0_);
#line 794 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	self->priv->has_discovery_started = TRUE;
#line 795 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	self->priv->started = TRUE;
#line 797 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	directory_monitor_notify_discovery_started (self);
#line 800 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	self->priv->outstanding_exploration_dirs = 1;
#line 801 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp1_ = self->priv->root;
#line 801 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	directory_monitor_explore_async (self, _tmp1_, NULL, TRUE, NULL, NULL);
#line 3170 "DirectoryMonitor.c"
}


static void directory_monitor_real_close (DirectoryMonitor* self) {
	GCancellable* _tmp0_;
	GeeHashMap* _tmp12_;
#line 808 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp0_ = self->priv->cancellable;
#line 808 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_cancellable_cancel (_tmp0_);
#line 3181 "DirectoryMonitor.c"
	{
		GeeHashMap* _tmp1_;
		GeeCollection* _tmp2_;
		GeeCollection* _tmp3_;
		GeeCollection* _tmp4_;
		GeeIterator* _tmp5_ = NULL;
		GeeIterator* _tmp6_;
		GeeIterator* _monitor_it;
#line 811 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_tmp1_ = self->priv->monitors;
#line 811 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_tmp2_ = gee_abstract_map_get_values (GEE_MAP (_tmp1_));
#line 811 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_tmp3_ = _tmp2_;
#line 811 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_tmp4_ = _tmp3_;
#line 811 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_tmp5_ = gee_iterable_iterator (GEE_ITERABLE (_tmp4_));
#line 811 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_tmp6_ = _tmp5_;
#line 811 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_g_object_unref0 (_tmp4_);
#line 811 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_monitor_it = _tmp6_;
#line 811 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		while (TRUE) {
#line 3208 "DirectoryMonitor.c"
			GeeIterator* _tmp7_;
			gboolean _tmp8_ = FALSE;
			GeeIterator* _tmp9_;
			gpointer _tmp10_ = NULL;
			GFileMonitor* monitor;
			GFileMonitor* _tmp11_;
#line 811 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_tmp7_ = _monitor_it;
#line 811 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_tmp8_ = gee_iterator_next (_tmp7_);
#line 811 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			if (!_tmp8_) {
#line 811 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				break;
#line 3223 "DirectoryMonitor.c"
			}
#line 811 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_tmp9_ = _monitor_it;
#line 811 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_tmp10_ = gee_iterator_get (_tmp9_);
#line 811 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			monitor = (GFileMonitor*) _tmp10_;
#line 812 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_tmp11_ = monitor;
#line 812 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			directory_monitor_cancel_monitor (self, _tmp11_);
#line 811 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_g_object_unref0 (monitor);
#line 3237 "DirectoryMonitor.c"
		}
#line 811 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_g_object_unref0 (_monitor_it);
#line 3241 "DirectoryMonitor.c"
	}
#line 814 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp12_ = self->priv->monitors;
#line 814 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	gee_abstract_map_clear (GEE_ABSTRACT_MAP (_tmp12_));
#line 816 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	directory_monitor_notify_closed (self);
#line 3249 "DirectoryMonitor.c"
}


void directory_monitor_close (DirectoryMonitor* self) {
#line 806 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 806 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	DIRECTORY_MONITOR_GET_CLASS (self)->close (self);
#line 3258 "DirectoryMonitor.c"
}


static DirectoryMonitorFType directory_monitor_get_ftype (GFileInfo* info) {
	DirectoryMonitorFType result = 0;
	GFileInfo* _tmp0_;
	GFileType _tmp1_ = 0;
	GFileType file_type;
	GFileType _tmp2_;
#line 819 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_val_if_fail (G_IS_FILE_INFO (info), 0);
#line 820 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp0_ = info;
#line 820 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp1_ = g_file_info_get_file_type (_tmp0_);
#line 820 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	file_type = _tmp1_;
#line 821 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp2_ = file_type;
#line 821 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	switch (_tmp2_) {
#line 821 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		case G_FILE_TYPE_REGULAR:
#line 3282 "DirectoryMonitor.c"
		{
#line 823 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			result = DIRECTORY_MONITOR_FTYPE_FILE;
#line 823 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			return result;
#line 3288 "DirectoryMonitor.c"
		}
#line 821 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		case G_FILE_TYPE_DIRECTORY:
#line 3292 "DirectoryMonitor.c"
		{
#line 826 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			result = DIRECTORY_MONITOR_FTYPE_DIRECTORY;
#line 826 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			return result;
#line 3298 "DirectoryMonitor.c"
		}
		default:
		{
			GFileType _tmp3_;
			GEnumValue* _tmp4_;
			gchar* _tmp5_ = NULL;
			gchar* _tmp6_;
#line 829 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_tmp3_ = file_type;
#line 829 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_tmp4_ = g_enum_get_value (g_type_class_ref (G_TYPE_FILE_TYPE), _tmp3_);
#line 829 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_tmp5_ = g_strdup_printf ("query_ftype: Unknown file type %s", (_tmp4_ != NULL) ? _tmp4_->value_name : NULL);
#line 829 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_tmp6_ = _tmp5_;
#line 829 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			directory_monitor_mdbg (_tmp6_);
#line 829 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_g_free0 (_tmp6_);
#line 830 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			result = DIRECTORY_MONITOR_FTYPE_UNSUPPORTED;
#line 830 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			return result;
#line 3322 "DirectoryMonitor.c"
		}
	}
}


static void directory_monitor_explore_async_data_free (gpointer _data) {
	DirectoryMonitorExploreAsyncData* _data_;
	_data_ = _data;
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_g_object_unref0 (_data_->dir);
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_g_object_unref0 (_data_->dir_info);
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_g_object_unref0 (_data_->self);
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_slice_free (DirectoryMonitorExploreAsyncData, _data_);
#line 3339 "DirectoryMonitor.c"
}


static void directory_monitor_explore_async (DirectoryMonitor* self, GFile* dir, GFileInfo* dir_info, gboolean in_discovery, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	DirectoryMonitorExploreAsyncData* _data_;
	DirectoryMonitor* _tmp0_;
	GFile* _tmp1_;
	GFile* _tmp2_;
	GFileInfo* _tmp3_;
	GFileInfo* _tmp4_;
	gboolean _tmp5_;
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_data_ = g_slice_new0 (DirectoryMonitorExploreAsyncData);
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_data_->_async_result = g_simple_async_result_new (G_OBJECT (self), _callback_, _user_data_, directory_monitor_explore_async);
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_simple_async_result_set_op_res_gpointer (_data_->_async_result, _data_, directory_monitor_explore_async_data_free);
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_data_->self = _tmp0_;
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp1_ = dir;
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_data_->dir = _tmp2_;
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp3_ = dir_info;
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp4_ = _g_object_ref0 (_tmp3_);
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_data_->dir_info = _tmp4_;
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp5_ = in_discovery;
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_data_->in_discovery = _tmp5_;
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	directory_monitor_explore_async_co (_data_);
#line 3379 "DirectoryMonitor.c"
}


static void directory_monitor_explore_finish (DirectoryMonitor* self, GAsyncResult* _res_) {
	DirectoryMonitorExploreAsyncData* _data_;
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_data_ = g_simple_async_result_get_op_res_gpointer (G_SIMPLE_ASYNC_RESULT (_res_));
#line 3387 "DirectoryMonitor.c"
}


static void directory_monitor_explore_async_ready (GObject* source_object, GAsyncResult* _res_, gpointer _user_data_) {
	DirectoryMonitorExploreAsyncData* _data_;
#line 847 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_data_ = _user_data_;
#line 847 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_data_->_source_object_ = source_object;
#line 847 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_data_->_res_ = _res_;
#line 847 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	directory_monitor_explore_async_co (_data_);
#line 3401 "DirectoryMonitor.c"
}


static void _g_object_unref0_ (gpointer var) {
#line 901 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 3408 "DirectoryMonitor.c"
}


static void _g_list_free__g_object_unref0_ (GList* self) {
#line 901 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_list_foreach (self, (GFunc) _g_object_unref0_, NULL);
#line 901 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_list_free (self);
#line 3417 "DirectoryMonitor.c"
}


static gboolean directory_monitor_explore_async_co (DirectoryMonitorExploreAsyncData* _data_) {
#line 834 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	switch (_data_->_state_) {
#line 834 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		case 0:
#line 3426 "DirectoryMonitor.c"
		goto _state_0;
#line 834 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		case 1:
#line 3430 "DirectoryMonitor.c"
		goto _state_1;
#line 834 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		case 2:
#line 3434 "DirectoryMonitor.c"
		goto _state_2;
#line 834 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		case 3:
#line 3438 "DirectoryMonitor.c"
		goto _state_3;
#line 834 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		case 4:
#line 3442 "DirectoryMonitor.c"
		goto _state_4;
#line 834 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		case 5:
#line 3446 "DirectoryMonitor.c"
		goto _state_5;
		default:
#line 834 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		g_assert_not_reached ();
#line 3451 "DirectoryMonitor.c"
	}
	_state_0:
#line 835 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_data_->_tmp0_ = _data_->self->priv->files;
#line 835 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_data_->_tmp1_ = _data_->dir;
#line 835 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_data_->_tmp2_ = _data_->dir_info;
#line 835 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_data_->_tmp3_ = FALSE;
#line 835 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_data_->_tmp3_ = directory_monitor_file_info_map_contains (_data_->_tmp0_, _data_->_tmp1_, _data_->_tmp2_);
#line 835 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	if (_data_->_tmp3_) {
#line 836 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_data_->_tmp4_ = _data_->dir;
#line 836 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_data_->_tmp5_ = NULL;
#line 836 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_data_->_tmp5_ = g_file_get_path (_data_->_tmp4_);
#line 836 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_data_->_tmp6_ = _data_->_tmp5_;
#line 836 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		g_warning ("DirectoryMonitor.vala:836: Directory loop detected at %s, not explorin" \
"g", _data_->_tmp6_);
#line 836 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_g_free0 (_data_->_tmp6_);
#line 838 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_data_->_tmp7_ = _data_->in_discovery;
#line 838 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		directory_monitor_explore_directory_completed (_data_->self, _data_->_tmp7_);
#line 840 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		if (_data_->_state_ == 0) {
#line 840 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			g_simple_async_result_complete_in_idle (_data_->_async_result);
#line 3486 "DirectoryMonitor.c"
		} else {
#line 840 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			g_simple_async_result_complete (_data_->_async_result);
#line 3490 "DirectoryMonitor.c"
		}
#line 840 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		g_object_unref (_data_->_async_result);
#line 840 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		return FALSE;
#line 3496 "DirectoryMonitor.c"
	}
#line 844 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_data_->_tmp8_ = _data_->dir_info;
#line 844 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_data_->_tmp9_ = _g_object_ref0 (_data_->_tmp8_);
#line 844 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_data_->local_dir_info = _data_->_tmp9_;
#line 845 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_data_->_tmp10_ = _data_->local_dir_info;
#line 845 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	if (_data_->_tmp10_ == NULL) {
#line 3508 "DirectoryMonitor.c"
		{
#line 847 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_data_->_tmp11_ = _data_->dir;
#line 847 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_data_->_tmp12_ = _data_->self->priv->cancellable;
#line 847 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_data_->_state_ = 1;
#line 847 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			g_file_query_info_async (_data_->_tmp11_, DIRECTORY_MONITOR_SUPPLIED_ATTRIBUTES, DIRECTORY_MONITOR_DIR_INFO_FLAGS, DIRECTORY_MONITOR_DEFAULT_PRIORITY, _data_->_tmp12_, directory_monitor_explore_async_ready, _data_);
#line 847 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			return FALSE;
#line 3520 "DirectoryMonitor.c"
			_state_1:
#line 847 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_data_->_tmp13_ = NULL;
#line 847 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_data_->_tmp13_ = g_file_query_info_finish (_data_->_tmp11_, _data_->_res_, &_data_->_inner_error_);
#line 847 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_data_->_tmp14_ = _data_->_tmp13_;
#line 847 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			if (_data_->_inner_error_ != NULL) {
#line 3530 "DirectoryMonitor.c"
				goto __catch310_g_error;
			}
#line 847 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_g_object_unref0 (_data_->local_dir_info);
#line 847 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_data_->local_dir_info = _data_->_tmp14_;
#line 3537 "DirectoryMonitor.c"
		}
		goto __finally310;
		__catch310_g_error:
		{
#line 846 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_data_->err = _data_->_inner_error_;
#line 846 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_data_->_inner_error_ = NULL;
#line 850 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_data_->_tmp15_ = _data_->dir;
#line 850 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_data_->_tmp16_ = NULL;
#line 850 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_data_->_tmp16_ = g_file_get_path (_data_->_tmp15_);
#line 850 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_data_->_tmp17_ = _data_->_tmp16_;
#line 850 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_data_->_tmp18_ = _data_->err;
#line 850 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_data_->_tmp19_ = _data_->_tmp18_->message;
#line 850 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			g_warning ("DirectoryMonitor.vala:850: Unable to retrieve info on %s: %s", _data_->_tmp17_, _data_->_tmp19_);
#line 850 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_g_free0 (_data_->_tmp17_);
#line 852 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_data_->_tmp20_ = _data_->in_discovery;
#line 852 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			directory_monitor_explore_directory_completed (_data_->self, _data_->_tmp20_);
#line 854 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_g_error_free0 (_data_->err);
#line 854 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_g_object_unref0 (_data_->local_dir_info);
#line 854 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			if (_data_->_state_ == 0) {
#line 854 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				g_simple_async_result_complete_in_idle (_data_->_async_result);
#line 3574 "DirectoryMonitor.c"
			} else {
#line 854 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				g_simple_async_result_complete (_data_->_async_result);
#line 3578 "DirectoryMonitor.c"
			}
#line 854 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			g_object_unref (_data_->_async_result);
#line 854 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			return FALSE;
#line 3584 "DirectoryMonitor.c"
		}
		__finally310:
#line 846 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		if (_data_->_inner_error_ != NULL) {
#line 846 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_g_object_unref0 (_data_->local_dir_info);
#line 846 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error_->message, g_quark_to_string (_data_->_inner_error_->domain), _data_->_inner_error_->code);
#line 846 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			g_clear_error (&_data_->_inner_error_);
#line 846 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			return FALSE;
#line 3597 "DirectoryMonitor.c"
		}
	}
#line 858 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_data_->_tmp21_ = _data_->local_dir_info;
#line 858 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_data_->_tmp22_ = FALSE;
#line 858 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_data_->_tmp22_ = g_file_info_get_is_hidden (_data_->_tmp21_);
#line 858 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	if (_data_->_tmp22_) {
#line 859 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_data_->_tmp23_ = _data_->dir;
#line 859 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_data_->_tmp24_ = NULL;
#line 859 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_data_->_tmp24_ = g_file_get_path (_data_->_tmp23_);
#line 859 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_data_->_tmp25_ = _data_->_tmp24_;
#line 859 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		g_warning ("DirectoryMonitor.vala:859: Ignoring hidden directory %s", _data_->_tmp25_);
#line 859 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_g_free0 (_data_->_tmp25_);
#line 861 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_data_->_tmp26_ = _data_->in_discovery;
#line 861 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		directory_monitor_explore_directory_completed (_data_->self, _data_->_tmp26_);
#line 863 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_g_object_unref0 (_data_->local_dir_info);
#line 863 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		if (_data_->_state_ == 0) {
#line 863 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			g_simple_async_result_complete_in_idle (_data_->_async_result);
#line 3630 "DirectoryMonitor.c"
		} else {
#line 863 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			g_simple_async_result_complete (_data_->_async_result);
#line 3634 "DirectoryMonitor.c"
		}
#line 863 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		g_object_unref (_data_->_async_result);
#line 863 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		return FALSE;
#line 3640 "DirectoryMonitor.c"
	}
#line 869 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_data_->_tmp27_ = _data_->local_dir_info;
#line 869 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_data_->_tmp28_ = NULL;
#line 869 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_data_->_tmp28_ = get_file_info_id (_data_->_tmp27_);
#line 869 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_data_->_tmp29_ = _data_->_tmp28_;
#line 869 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_data_->_tmp30_ = _data_->_tmp29_ == NULL;
#line 869 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_g_free0 (_data_->_tmp29_);
#line 869 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	if (_data_->_tmp30_) {
#line 870 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_data_->_tmp31_ = _data_->dir;
#line 870 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_data_->_tmp32_ = NULL;
#line 870 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_data_->_tmp32_ = g_file_get_path (_data_->_tmp31_);
#line 870 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_data_->_tmp33_ = _data_->_tmp32_;
#line 870 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		g_warning ("DirectoryMonitor.vala:870: Unable to retrieve file ID on %s: skipping", _data_->_tmp33_);
#line 870 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_g_free0 (_data_->_tmp33_);
#line 872 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_data_->_tmp34_ = _data_->in_discovery;
#line 872 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		directory_monitor_explore_directory_completed (_data_->self, _data_->_tmp34_);
#line 874 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_g_object_unref0 (_data_->local_dir_info);
#line 874 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		if (_data_->_state_ == 0) {
#line 874 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			g_simple_async_result_complete_in_idle (_data_->_async_result);
#line 3678 "DirectoryMonitor.c"
		} else {
#line 874 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			g_simple_async_result_complete (_data_->_async_result);
#line 3682 "DirectoryMonitor.c"
		}
#line 874 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		g_object_unref (_data_->_async_result);
#line 874 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		return FALSE;
#line 3688 "DirectoryMonitor.c"
	}
#line 878 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_data_->_tmp35_ = _data_->local_dir_info;
#line 878 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_data_->_tmp36_ = 0;
#line 878 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_data_->_tmp36_ = g_file_info_get_file_type (_data_->_tmp35_);
#line 878 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	if (_data_->_tmp36_ != G_FILE_TYPE_DIRECTORY) {
#line 879 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_data_->_tmp37_ = NULL;
#line 879 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_data_->_tmp37_ = _ ("Unable to monitor %s: Not a directory (%s)");
#line 879 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_data_->_tmp38_ = _data_->dir;
#line 879 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_data_->_tmp39_ = NULL;
#line 879 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_data_->_tmp39_ = g_file_get_path (_data_->_tmp38_);
#line 879 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_data_->_tmp40_ = _data_->_tmp39_;
#line 879 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_data_->_tmp41_ = _data_->local_dir_info;
#line 879 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_data_->_tmp42_ = 0;
#line 879 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_data_->_tmp42_ = g_file_info_get_file_type (_data_->_tmp41_);
#line 880 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_data_->_tmp43_ = g_enum_get_value (g_type_class_ref (G_TYPE_FILE_TYPE), _data_->_tmp42_);
#line 879 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_data_->_tmp44_ = NULL;
#line 879 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_data_->_tmp44_ = g_strdup_printf (_data_->_tmp37_, _data_->_tmp40_, (_data_->_tmp43_ != NULL) ? _data_->_tmp43_->value_name : NULL);
#line 879 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_data_->_tmp45_ = _data_->_tmp44_;
#line 879 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		directory_monitor_notify_discovery_failed (_data_->self, _data_->_tmp45_);
#line 879 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_g_free0 (_data_->_tmp45_);
#line 879 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_g_free0 (_data_->_tmp40_);
#line 882 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_data_->_tmp46_ = _data_->in_discovery;
#line 882 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		directory_monitor_explore_directory_completed (_data_->self, _data_->_tmp46_);
#line 884 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_g_object_unref0 (_data_->local_dir_info);
#line 884 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		if (_data_->_state_ == 0) {
#line 884 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			g_simple_async_result_complete_in_idle (_data_->_async_result);
#line 3740 "DirectoryMonitor.c"
		} else {
#line 884 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			g_simple_async_result_complete (_data_->_async_result);
#line 3744 "DirectoryMonitor.c"
		}
#line 884 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		g_object_unref (_data_->_async_result);
#line 884 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		return FALSE;
#line 3750 "DirectoryMonitor.c"
	}
#line 891 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_data_->dir_map = NULL;
#line 892 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_data_->file_map = NULL;
#line 3756 "DirectoryMonitor.c"
	{
#line 895 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_data_->_tmp47_ = _data_->dir;
#line 895 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_data_->_tmp48_ = _data_->self->priv->cancellable;
#line 895 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_data_->_state_ = 2;
#line 895 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		g_file_enumerate_children_async (_data_->_tmp47_, DIRECTORY_MONITOR_SUPPLIED_ATTRIBUTES, DIRECTORY_MONITOR_UNKNOWN_INFO_FLAGS, DIRECTORY_MONITOR_DEFAULT_PRIORITY, _data_->_tmp48_, directory_monitor_explore_async_ready, _data_);
#line 895 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		return FALSE;
#line 3768 "DirectoryMonitor.c"
		_state_2:
#line 895 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_data_->_tmp49_ = NULL;
#line 895 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_data_->_tmp49_ = g_file_enumerate_children_finish (_data_->_tmp47_, _data_->_res_, &_data_->_inner_error_);
#line 895 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_data_->enumerator = _data_->_tmp49_;
#line 895 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		if (_data_->_inner_error_ != NULL) {
#line 3778 "DirectoryMonitor.c"
			goto __catch311_g_error;
		}
		{
#line 897 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_data_->_tmp50_ = TRUE;
#line 897 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			while (TRUE) {
#line 897 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_data_->_tmp51_ = _data_->_tmp50_;
#line 897 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				if (!_data_->_tmp51_) {
#line 3790 "DirectoryMonitor.c"
				}
#line 897 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_data_->_tmp50_ = FALSE;
#line 898 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_data_->_tmp52_ = _data_->enumerator;
#line 898 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_data_->_tmp53_ = _data_->self->priv->cancellable;
#line 898 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_data_->_state_ = 3;
#line 898 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				g_file_enumerator_next_files_async (_data_->_tmp52_, 10, DIRECTORY_MONITOR_DEFAULT_PRIORITY, _data_->_tmp53_, directory_monitor_explore_async_ready, _data_);
#line 898 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				return FALSE;
#line 3804 "DirectoryMonitor.c"
				_state_3:
#line 898 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_data_->_tmp54_ = NULL;
#line 898 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_data_->_tmp54_ = g_file_enumerator_next_files_finish (_data_->_tmp52_, _data_->_res_, &_data_->_inner_error_);
#line 898 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_data_->infos = _data_->_tmp54_;
#line 898 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				if (_data_->_inner_error_ != NULL) {
#line 898 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					_g_object_unref0 (_data_->enumerator);
#line 3816 "DirectoryMonitor.c"
					goto __catch311_g_error;
				}
#line 900 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_data_->_tmp55_ = _data_->infos;
#line 900 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				if (_data_->_tmp55_ == NULL) {
#line 901 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					__g_list_free__g_object_unref0_0 (_data_->infos);
#line 901 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					break;
#line 3827 "DirectoryMonitor.c"
				}
#line 903 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_data_->_tmp56_ = _data_->infos;
#line 3831 "DirectoryMonitor.c"
				{
#line 903 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					_data_->info_collection = _data_->_tmp56_;
#line 903 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					_data_->info_it = NULL;
#line 903 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					for (_data_->info_it = _data_->info_collection; _data_->info_it != NULL; _data_->info_it = _data_->info_it->next) {
#line 903 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
						_data_->_tmp57_ = _g_object_ref0 ((GFileInfo*) _data_->info_it->data);
#line 903 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
						_data_->info = _data_->_tmp57_;
#line 3843 "DirectoryMonitor.c"
						{
#line 905 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
							_data_->_tmp58_ = _data_->info;
#line 905 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
							_data_->_tmp59_ = FALSE;
#line 905 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
							_data_->_tmp59_ = g_file_info_get_is_hidden (_data_->_tmp58_);
#line 905 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
							if (_data_->_tmp59_) {
#line 906 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
								_data_->_tmp60_ = _data_->dir;
#line 906 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
								_data_->_tmp61_ = _data_->info;
#line 906 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
								_data_->_tmp62_ = NULL;
#line 906 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
								_data_->_tmp62_ = g_file_info_get_name (_data_->_tmp61_);
#line 906 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
								_data_->_tmp63_ = NULL;
#line 906 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
								_data_->_tmp63_ = g_file_get_child (_data_->_tmp60_, _data_->_tmp62_);
#line 906 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
								_data_->_tmp64_ = _data_->_tmp63_;
#line 906 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
								_data_->_tmp65_ = NULL;
#line 906 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
								_data_->_tmp65_ = g_file_get_path (_data_->_tmp64_);
#line 906 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
								_data_->_tmp66_ = _data_->_tmp65_;
#line 906 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
								g_warning ("DirectoryMonitor.vala:906: Skipping hidden file/directory %s", _data_->_tmp66_);
#line 906 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
								_g_free0 (_data_->_tmp66_);
#line 906 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
								_g_object_unref0 (_data_->_tmp64_);
#line 909 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
								_g_object_unref0 (_data_->info);
#line 909 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
								continue;
#line 3883 "DirectoryMonitor.c"
							}
#line 913 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
							_data_->_tmp67_ = _data_->info;
#line 913 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
							_data_->_tmp68_ = FALSE;
#line 913 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
							_data_->_tmp68_ = directory_monitor_is_file_symlink_supported (_data_->_tmp67_);
#line 913 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
							if (!_data_->_tmp68_) {
#line 914 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
								_g_object_unref0 (_data_->info);
#line 914 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
								continue;
#line 3897 "DirectoryMonitor.c"
							}
#line 916 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
							_data_->_tmp69_ = _data_->info;
#line 916 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
							_data_->_tmp70_ = 0;
#line 916 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
							_data_->_tmp70_ = g_file_info_get_file_type (_data_->_tmp69_);
#line 916 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
							switch (_data_->_tmp70_) {
#line 916 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
								case G_FILE_TYPE_REGULAR:
#line 3909 "DirectoryMonitor.c"
								{
#line 918 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
									_data_->_tmp71_ = _data_->file_map;
#line 918 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
									if (_data_->_tmp71_ == NULL) {
#line 919 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
										_data_->_tmp72_ = g_file_hash;
#line 919 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
										_data_->_tmp73_ = g_file_equal;
#line 919 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
										_data_->_tmp74_ = gee_hash_map_new (G_TYPE_FILE, (GBoxedCopyFunc) g_object_ref, g_object_unref, G_TYPE_FILE_INFO, (GBoxedCopyFunc) g_object_ref, g_object_unref, _data_->_tmp72_, _data_->_tmp73_, NULL);
#line 919 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
										_g_object_unref0 (_data_->file_map);
#line 919 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
										_data_->file_map = _data_->_tmp74_;
#line 3925 "DirectoryMonitor.c"
									}
#line 921 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
									_data_->_tmp75_ = _data_->file_map;
#line 921 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
									_data_->_tmp76_ = _data_->dir;
#line 921 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
									_data_->_tmp77_ = _data_->info;
#line 921 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
									_data_->_tmp78_ = NULL;
#line 921 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
									_data_->_tmp78_ = g_file_info_get_name (_data_->_tmp77_);
#line 921 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
									_data_->_tmp79_ = NULL;
#line 921 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
									_data_->_tmp79_ = g_file_get_child (_data_->_tmp76_, _data_->_tmp78_);
#line 921 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
									_data_->_tmp80_ = _data_->_tmp79_;
#line 921 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
									_data_->_tmp81_ = _data_->info;
#line 921 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
									gee_abstract_map_set (GEE_ABSTRACT_MAP (_data_->_tmp75_), _data_->_tmp80_, _data_->_tmp81_);
#line 921 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
									_g_object_unref0 (_data_->_tmp80_);
#line 922 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
									break;
#line 3951 "DirectoryMonitor.c"
								}
#line 916 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
								case G_FILE_TYPE_DIRECTORY:
#line 3955 "DirectoryMonitor.c"
								{
#line 925 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
									_data_->_tmp82_ = _data_->dir_map;
#line 925 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
									if (_data_->_tmp82_ == NULL) {
#line 926 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
										_data_->_tmp83_ = g_file_hash;
#line 926 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
										_data_->_tmp84_ = g_file_equal;
#line 926 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
										_data_->_tmp85_ = gee_hash_map_new (G_TYPE_FILE, (GBoxedCopyFunc) g_object_ref, g_object_unref, G_TYPE_FILE_INFO, (GBoxedCopyFunc) g_object_ref, g_object_unref, _data_->_tmp83_, _data_->_tmp84_, NULL);
#line 926 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
										_g_object_unref0 (_data_->dir_map);
#line 926 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
										_data_->dir_map = _data_->_tmp85_;
#line 3971 "DirectoryMonitor.c"
									}
#line 928 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
									_data_->_tmp86_ = _data_->dir_map;
#line 928 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
									_data_->_tmp87_ = _data_->dir;
#line 928 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
									_data_->_tmp88_ = _data_->info;
#line 928 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
									_data_->_tmp89_ = NULL;
#line 928 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
									_data_->_tmp89_ = g_file_info_get_name (_data_->_tmp88_);
#line 928 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
									_data_->_tmp90_ = NULL;
#line 928 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
									_data_->_tmp90_ = g_file_get_child (_data_->_tmp87_, _data_->_tmp89_);
#line 928 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
									_data_->_tmp91_ = _data_->_tmp90_;
#line 928 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
									_data_->_tmp92_ = _data_->info;
#line 928 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
									gee_abstract_map_set (GEE_ABSTRACT_MAP (_data_->_tmp86_), _data_->_tmp91_, _data_->_tmp92_);
#line 928 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
									_g_object_unref0 (_data_->_tmp91_);
#line 929 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
									break;
#line 3997 "DirectoryMonitor.c"
								}
								default:
								{
#line 933 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
									break;
#line 4003 "DirectoryMonitor.c"
								}
							}
#line 903 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
							_g_object_unref0 (_data_->info);
#line 4008 "DirectoryMonitor.c"
						}
					}
				}
#line 897 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				__g_list_free__g_object_unref0_0 (_data_->infos);
#line 4014 "DirectoryMonitor.c"
			}
		}
#line 894 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_g_object_unref0 (_data_->enumerator);
#line 4019 "DirectoryMonitor.c"
	}
	goto __finally311;
	__catch311_g_error:
	{
#line 894 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_data_->err2 = _data_->_inner_error_;
#line 894 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_data_->_inner_error_ = NULL;
#line 938 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_data_->_tmp93_ = _data_->dir;
#line 938 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_data_->_tmp94_ = NULL;
#line 938 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_data_->_tmp94_ = g_file_get_path (_data_->_tmp93_);
#line 938 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_data_->_tmp95_ = _data_->_tmp94_;
#line 938 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_data_->_tmp96_ = _data_->err2;
#line 938 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_data_->_tmp97_ = _data_->_tmp96_->message;
#line 938 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		g_warning ("DirectoryMonitor.vala:938: Aborted directory traversal of %s: %s", _data_->_tmp95_, _data_->_tmp97_);
#line 938 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_g_free0 (_data_->_tmp95_);
#line 940 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_data_->_tmp98_ = _data_->in_discovery;
#line 940 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		directory_monitor_explore_directory_completed (_data_->self, _data_->_tmp98_);
#line 942 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_g_error_free0 (_data_->err2);
#line 942 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_g_object_unref0 (_data_->file_map);
#line 942 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_g_object_unref0 (_data_->dir_map);
#line 942 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_g_object_unref0 (_data_->local_dir_info);
#line 942 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		if (_data_->_state_ == 0) {
#line 942 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			g_simple_async_result_complete_in_idle (_data_->_async_result);
#line 4060 "DirectoryMonitor.c"
		} else {
#line 942 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			g_simple_async_result_complete (_data_->_async_result);
#line 4064 "DirectoryMonitor.c"
		}
#line 942 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		g_object_unref (_data_->_async_result);
#line 942 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		return FALSE;
#line 4070 "DirectoryMonitor.c"
	}
	__finally311:
#line 894 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	if (_data_->_inner_error_ != NULL) {
#line 894 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_g_object_unref0 (_data_->file_map);
#line 894 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_g_object_unref0 (_data_->dir_map);
#line 894 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_g_object_unref0 (_data_->local_dir_info);
#line 894 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error_->message, g_quark_to_string (_data_->_inner_error_->domain), _data_->_inner_error_->code);
#line 894 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		g_clear_error (&_data_->_inner_error_);
#line 894 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		return FALSE;
#line 4087 "DirectoryMonitor.c"
	}
#line 946 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_data_->_tmp99_ = _data_->in_discovery;
#line 946 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	if (_data_->_tmp99_) {
#line 947 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_data_->_tmp100_ = _data_->dir;
#line 947 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_data_->_tmp101_ = _data_->local_dir_info;
#line 947 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		directory_monitor_internal_notify_directory_discovered (_data_->self, _data_->_tmp100_, _data_->_tmp101_);
#line 4099 "DirectoryMonitor.c"
	} else {
#line 949 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_data_->_tmp102_ = _data_->dir;
#line 949 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_data_->_tmp103_ = _data_->local_dir_info;
#line 949 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		directory_monitor_internal_notify_directory_created (_data_->self, _data_->_tmp102_, _data_->_tmp103_);
#line 4107 "DirectoryMonitor.c"
	}
#line 953 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_data_->_tmp104_ = _data_->dir;
#line 953 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_data_->_tmp105_ = _data_->local_dir_info;
#line 953 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	directory_monitor_add_monitor (_data_->self, _data_->_tmp104_, _data_->_tmp105_);
#line 956 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_data_->_tmp106_ = _data_->file_map;
#line 956 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	if (_data_->_tmp106_ != NULL) {
#line 957 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_data_->_tmp107_ = _data_->file_map;
#line 957 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_data_->_tmp108_ = _data_->in_discovery;
#line 957 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_data_->_state_ = 4;
#line 957 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		directory_monitor_notify_directory_files (_data_->self, GEE_MAP (_data_->_tmp107_), _data_->_tmp108_, directory_monitor_explore_async_ready, _data_);
#line 957 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		return FALSE;
#line 4129 "DirectoryMonitor.c"
		_state_4:
#line 957 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		directory_monitor_notify_directory_files_finish (_data_->self, _data_->_res_);
#line 4133 "DirectoryMonitor.c"
	}
#line 960 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_data_->_tmp110_ = _data_->self->priv->recurse;
#line 960 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	if (_data_->_tmp110_) {
#line 960 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_data_->_tmp111_ = _data_->dir_map;
#line 960 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_data_->_tmp109_ = _data_->_tmp111_ != NULL;
#line 4143 "DirectoryMonitor.c"
	} else {
#line 960 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_data_->_tmp109_ = FALSE;
#line 4147 "DirectoryMonitor.c"
	}
#line 960 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_data_->_tmp112_ = _data_->_tmp109_;
#line 960 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	if (_data_->_tmp112_) {
#line 4153 "DirectoryMonitor.c"
		{
#line 961 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_data_->_tmp113_ = _data_->dir_map;
#line 961 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_data_->_tmp114_ = gee_abstract_map_get_keys (GEE_MAP (_data_->_tmp113_));
#line 961 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_data_->_tmp115_ = _data_->_tmp114_;
#line 961 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_data_->_tmp116_ = _data_->_tmp115_;
#line 961 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_data_->_tmp117_ = NULL;
#line 961 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_data_->_tmp117_ = gee_iterable_iterator (GEE_ITERABLE (_data_->_tmp116_));
#line 961 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_data_->_tmp118_ = _data_->_tmp117_;
#line 961 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_g_object_unref0 (_data_->_tmp116_);
#line 961 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_data_->_subdir_it = _data_->_tmp118_;
#line 961 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			while (TRUE) {
#line 961 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_data_->_tmp119_ = _data_->_subdir_it;
#line 961 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_data_->_tmp120_ = FALSE;
#line 961 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_data_->_tmp120_ = gee_iterator_next (_data_->_tmp119_);
#line 961 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				if (!_data_->_tmp120_) {
#line 961 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					break;
#line 4185 "DirectoryMonitor.c"
				}
#line 961 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_data_->_tmp121_ = _data_->_subdir_it;
#line 961 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_data_->_tmp122_ = NULL;
#line 961 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_data_->_tmp122_ = gee_iterator_get (_data_->_tmp121_);
#line 961 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_data_->subdir = (GFile*) _data_->_tmp122_;
#line 962 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_data_->_tmp123_ = _data_->self->priv->outstanding_exploration_dirs;
#line 962 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_data_->self->priv->outstanding_exploration_dirs = _data_->_tmp123_ + 1;
#line 962 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_data_->_tmp124_ = _data_->self->priv->outstanding_exploration_dirs;
#line 962 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				if (_data_->_tmp124_ > DIRECTORY_MONITOR_MAX_EXPLORATION_DIRS) {
#line 963 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					_data_->_tmp125_ = _data_->subdir;
#line 963 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					_data_->_tmp126_ = _data_->dir_map;
#line 963 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					_data_->_tmp127_ = _data_->subdir;
#line 963 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					_data_->_tmp128_ = NULL;
#line 963 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					_data_->_tmp128_ = gee_abstract_map_get (GEE_ABSTRACT_MAP (_data_->_tmp126_), _data_->_tmp127_);
#line 963 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					_data_->_tmp129_ = (GFileInfo*) _data_->_tmp128_;
#line 963 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					_data_->_tmp130_ = _data_->in_discovery;
#line 963 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					_data_->_state_ = 5;
#line 963 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					directory_monitor_explore_async (_data_->self, _data_->_tmp125_, _data_->_tmp129_, _data_->_tmp130_, directory_monitor_explore_async_ready, _data_);
#line 963 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					return FALSE;
#line 4223 "DirectoryMonitor.c"
					_state_5:
#line 963 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					directory_monitor_explore_finish (_data_->self, _data_->_res_);
#line 963 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					_g_object_unref0 (_data_->_tmp129_);
#line 4229 "DirectoryMonitor.c"
				} else {
#line 965 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					_data_->_tmp131_ = _data_->subdir;
#line 965 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					_data_->_tmp132_ = _data_->dir_map;
#line 965 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					_data_->_tmp133_ = _data_->subdir;
#line 965 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					_data_->_tmp134_ = NULL;
#line 965 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					_data_->_tmp134_ = gee_abstract_map_get (GEE_ABSTRACT_MAP (_data_->_tmp132_), _data_->_tmp133_);
#line 965 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					_data_->_tmp135_ = (GFileInfo*) _data_->_tmp134_;
#line 965 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					_data_->_tmp136_ = _data_->in_discovery;
#line 965 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					directory_monitor_explore_async (_data_->self, _data_->_tmp131_, _data_->_tmp135_, _data_->_tmp136_, NULL, NULL);
#line 965 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					_g_object_unref0 (_data_->_tmp135_);
#line 4249 "DirectoryMonitor.c"
				}
#line 961 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_g_object_unref0 (_data_->subdir);
#line 4253 "DirectoryMonitor.c"
			}
#line 961 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_g_object_unref0 (_data_->_subdir_it);
#line 4257 "DirectoryMonitor.c"
		}
	}
#line 969 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_data_->_tmp137_ = _data_->in_discovery;
#line 969 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	directory_monitor_explore_directory_completed (_data_->self, _data_->_tmp137_);
#line 834 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_g_object_unref0 (_data_->file_map);
#line 834 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_g_object_unref0 (_data_->dir_map);
#line 834 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_g_object_unref0 (_data_->local_dir_info);
#line 834 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	if (_data_->_state_ == 0) {
#line 834 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		g_simple_async_result_complete_in_idle (_data_->_async_result);
#line 4274 "DirectoryMonitor.c"
	} else {
#line 834 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		g_simple_async_result_complete (_data_->_async_result);
#line 4278 "DirectoryMonitor.c"
	}
#line 834 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_object_unref (_data_->_async_result);
#line 834 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	return FALSE;
#line 4284 "DirectoryMonitor.c"
}


static void directory_monitor_notify_directory_files_data_free (gpointer _data) {
	DirectoryMonitorNotifyDirectoryFilesData* _data_;
	_data_ = _data;
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_g_object_unref0 (_data_->map);
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_g_object_unref0 (_data_->self);
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_slice_free (DirectoryMonitorNotifyDirectoryFilesData, _data_);
#line 4297 "DirectoryMonitor.c"
}


static void directory_monitor_notify_directory_files (DirectoryMonitor* self, GeeMap* map, gboolean in_discovery, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	DirectoryMonitorNotifyDirectoryFilesData* _data_;
	DirectoryMonitor* _tmp0_;
	GeeMap* _tmp1_;
	GeeMap* _tmp2_;
	gboolean _tmp3_;
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_data_ = g_slice_new0 (DirectoryMonitorNotifyDirectoryFilesData);
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_data_->_async_result = g_simple_async_result_new (G_OBJECT (self), _callback_, _user_data_, directory_monitor_notify_directory_files);
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_simple_async_result_set_op_res_gpointer (_data_->_async_result, _data_, directory_monitor_notify_directory_files_data_free);
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_data_->self = _tmp0_;
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp1_ = map;
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_data_->map = _tmp2_;
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp3_ = in_discovery;
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_data_->in_discovery = _tmp3_;
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	directory_monitor_notify_directory_files_co (_data_);
#line 4329 "DirectoryMonitor.c"
}


static void directory_monitor_notify_directory_files_finish (DirectoryMonitor* self, GAsyncResult* _res_) {
	DirectoryMonitorNotifyDirectoryFilesData* _data_;
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_data_ = g_simple_async_result_get_op_res_gpointer (G_SIMPLE_ASYNC_RESULT (_res_));
#line 4337 "DirectoryMonitor.c"
}


static gboolean _directory_monitor_notify_directory_files_co_gsource_func (gpointer self) {
	gboolean result;
	result = directory_monitor_notify_directory_files_co (self);
#line 980 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	return result;
#line 4346 "DirectoryMonitor.c"
}


static gboolean directory_monitor_notify_directory_files_co (DirectoryMonitorNotifyDirectoryFilesData* _data_) {
#line 972 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	switch (_data_->_state_) {
#line 972 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		case 0:
#line 4355 "DirectoryMonitor.c"
		goto _state_0;
#line 972 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		case 1:
#line 4359 "DirectoryMonitor.c"
		goto _state_1;
		default:
#line 972 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		g_assert_not_reached ();
#line 4364 "DirectoryMonitor.c"
	}
	_state_0:
#line 973 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_data_->_tmp0_ = _data_->map;
#line 973 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_data_->_tmp1_ = NULL;
#line 973 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_data_->_tmp1_ = gee_map_map_iterator (_data_->_tmp0_);
#line 973 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_data_->iter = _data_->_tmp1_;
#line 974 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	while (TRUE) {
#line 974 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_data_->_tmp2_ = _data_->iter;
#line 974 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_data_->_tmp3_ = FALSE;
#line 974 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_data_->_tmp3_ = gee_map_iterator_next (_data_->_tmp2_);
#line 974 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		if (!_data_->_tmp3_) {
#line 974 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			break;
#line 4387 "DirectoryMonitor.c"
		}
#line 975 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_data_->_tmp4_ = _data_->in_discovery;
#line 975 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		if (_data_->_tmp4_) {
#line 976 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_data_->_tmp5_ = _data_->iter;
#line 976 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_data_->_tmp6_ = NULL;
#line 976 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_data_->_tmp6_ = gee_map_iterator_get_key (_data_->_tmp5_);
#line 976 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_data_->_tmp7_ = (GFile*) _data_->_tmp6_;
#line 976 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_data_->_tmp8_ = _data_->iter;
#line 976 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_data_->_tmp9_ = NULL;
#line 976 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_data_->_tmp9_ = gee_map_iterator_get_value (_data_->_tmp8_);
#line 976 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_data_->_tmp10_ = (GFileInfo*) _data_->_tmp9_;
#line 976 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			directory_monitor_internal_notify_file_discovered (_data_->self, _data_->_tmp7_, _data_->_tmp10_);
#line 976 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_g_object_unref0 (_data_->_tmp10_);
#line 976 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_g_object_unref0 (_data_->_tmp7_);
#line 4415 "DirectoryMonitor.c"
		} else {
#line 978 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_data_->_tmp11_ = _data_->iter;
#line 978 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_data_->_tmp12_ = NULL;
#line 978 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_data_->_tmp12_ = gee_map_iterator_get_key (_data_->_tmp11_);
#line 978 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_data_->_tmp13_ = (GFile*) _data_->_tmp12_;
#line 978 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_data_->_tmp14_ = _data_->iter;
#line 978 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_data_->_tmp15_ = NULL;
#line 978 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_data_->_tmp15_ = gee_map_iterator_get_value (_data_->_tmp14_);
#line 978 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_data_->_tmp16_ = (GFileInfo*) _data_->_tmp15_;
#line 978 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			directory_monitor_internal_notify_file_created (_data_->self, _data_->_tmp13_, _data_->_tmp16_);
#line 978 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_g_object_unref0 (_data_->_tmp16_);
#line 978 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_g_object_unref0 (_data_->_tmp13_);
#line 4439 "DirectoryMonitor.c"
		}
#line 980 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		g_idle_add_full (DIRECTORY_MONITOR_DEFAULT_PRIORITY, _directory_monitor_notify_directory_files_co_gsource_func, _data_, NULL);
#line 981 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_data_->_state_ = 1;
#line 981 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		return FALSE;
#line 4447 "DirectoryMonitor.c"
		_state_1:
		;
	}
#line 972 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_g_object_unref0 (_data_->iter);
#line 972 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	if (_data_->_state_ == 0) {
#line 972 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		g_simple_async_result_complete_in_idle (_data_->_async_result);
#line 4457 "DirectoryMonitor.c"
	} else {
#line 972 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		g_simple_async_result_complete (_data_->_async_result);
#line 4461 "DirectoryMonitor.c"
	}
#line 972 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_object_unref (_data_->_async_result);
#line 972 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	return FALSE;
#line 4467 "DirectoryMonitor.c"
}


static void directory_monitor_explore_directory_completed (DirectoryMonitor* self, gboolean in_discovery) {
	gint _tmp0_;
	gint _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_;
	gboolean _tmp5_;
#line 987 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 988 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp0_ = self->priv->outstanding_exploration_dirs;
#line 988 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_assert (_tmp0_ > 0);
#line 989 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp1_ = self->priv->outstanding_exploration_dirs;
#line 989 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	self->priv->outstanding_exploration_dirs = _tmp1_ - 1;
#line 991 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp3_ = in_discovery;
#line 991 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	if (_tmp3_) {
#line 4491 "DirectoryMonitor.c"
		gint _tmp4_;
#line 991 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_tmp4_ = self->priv->outstanding_exploration_dirs;
#line 991 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_tmp2_ = _tmp4_ == 0;
#line 4497 "DirectoryMonitor.c"
	} else {
#line 991 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_tmp2_ = FALSE;
#line 4501 "DirectoryMonitor.c"
	}
#line 991 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp5_ = _tmp2_;
#line 991 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	if (_tmp5_) {
#line 992 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		directory_monitor_notify_discovery_completed (self);
#line 4509 "DirectoryMonitor.c"
	}
}


static void _directory_monitor_on_monitor_notification_g_file_monitor_changed (GFileMonitor* _sender, GFile* file, GFile* other_file, GFileMonitorEvent event_type, gpointer self) {
#line 1020 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	directory_monitor_on_monitor_notification (self, file, other_file, event_type);
#line 4517 "DirectoryMonitor.c"
}


static gboolean directory_monitor_add_monitor (DirectoryMonitor* self, GFile* dir, GFileInfo* info) {
	gboolean result = FALSE;
	gboolean _tmp0_;
	DirectoryMonitorFileInfoMap* _tmp1_;
	GFile* _tmp2_;
	GFileInfo* _tmp3_;
	gchar* _tmp4_ = NULL;
	gchar* id;
	const gchar* _tmp5_;
	GeeHashMap* _tmp6_;
	const gchar* _tmp7_;
	gboolean _tmp8_ = FALSE;
	GFileMonitor* monitor;
	GeeHashMap* _tmp17_;
	const gchar* _tmp18_;
	GFileMonitor* _tmp19_;
	GFileMonitor* _tmp20_;
	GFile* _tmp21_;
	gchar* _tmp22_ = NULL;
	gchar* _tmp23_;
	gchar* _tmp24_ = NULL;
	gchar* _tmp25_;
	GError * _inner_error_ = NULL;
#line 998 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_val_if_fail (IS_DIRECTORY_MONITOR (self), FALSE);
#line 998 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_val_if_fail (G_IS_FILE (dir), FALSE);
#line 998 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_val_if_fail (G_IS_FILE_INFO (info), FALSE);
#line 999 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp0_ = self->priv->monitoring;
#line 999 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	if (!_tmp0_) {
#line 1000 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		result = FALSE;
#line 1000 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		return result;
#line 4558 "DirectoryMonitor.c"
	}
#line 1002 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp1_ = self->priv->files;
#line 1002 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp2_ = dir;
#line 1002 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp3_ = info;
#line 1002 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp4_ = directory_monitor_file_info_map_get_id (_tmp1_, _tmp2_, _tmp3_);
#line 1002 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	id = _tmp4_;
#line 1003 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp5_ = id;
#line 1003 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	if (_tmp5_ == NULL) {
#line 1004 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		result = FALSE;
#line 1004 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_g_free0 (id);
#line 1004 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		return result;
#line 4580 "DirectoryMonitor.c"
	}
#line 1007 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp6_ = self->priv->monitors;
#line 1007 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp7_ = id;
#line 1007 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp8_ = gee_abstract_map_has_key (GEE_ABSTRACT_MAP (_tmp6_), _tmp7_);
#line 1007 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	if (_tmp8_) {
#line 1008 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		result = FALSE;
#line 1008 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_g_free0 (id);
#line 1008 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		return result;
#line 4596 "DirectoryMonitor.c"
	}
#line 1010 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	monitor = NULL;
#line 4600 "DirectoryMonitor.c"
	{
		GFile* _tmp9_;
		GFileMonitor* _tmp10_ = NULL;
		GFileMonitor* _tmp11_;
#line 1012 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_tmp9_ = dir;
#line 1012 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_tmp10_ = g_file_monitor_directory (_tmp9_, DIRECTORY_MONITOR_FILE_MONITOR_FLAGS, NULL, &_inner_error_);
#line 1012 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_tmp11_ = _tmp10_;
#line 1012 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		if (_inner_error_ != NULL) {
#line 4613 "DirectoryMonitor.c"
			goto __catch312_g_error;
		}
#line 1012 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_g_object_unref0 (monitor);
#line 1012 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		monitor = _tmp11_;
#line 4620 "DirectoryMonitor.c"
	}
	goto __finally312;
	__catch312_g_error:
	{
		GError* err = NULL;
		GFile* _tmp12_;
		gchar* _tmp13_ = NULL;
		gchar* _tmp14_;
		GError* _tmp15_;
		const gchar* _tmp16_;
#line 1011 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		err = _inner_error_;
#line 1011 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_inner_error_ = NULL;
#line 1014 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_tmp12_ = dir;
#line 1014 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_tmp13_ = g_file_get_path (_tmp12_);
#line 1014 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_tmp14_ = _tmp13_;
#line 1014 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_tmp15_ = err;
#line 1014 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_tmp16_ = _tmp15_->message;
#line 1014 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		g_warning ("DirectoryMonitor.vala:1014: Unable to monitor %s: %s", _tmp14_, _tmp16_);
#line 1014 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_g_free0 (_tmp14_);
#line 1016 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		result = FALSE;
#line 1016 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_g_error_free0 (err);
#line 1016 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_g_object_unref0 (monitor);
#line 1016 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_g_free0 (id);
#line 1016 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		return result;
#line 4659 "DirectoryMonitor.c"
	}
	__finally312:
#line 1011 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	if (_inner_error_ != NULL) {
#line 1011 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_g_object_unref0 (monitor);
#line 1011 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_g_free0 (id);
#line 1011 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1011 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		g_clear_error (&_inner_error_);
#line 1011 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		return FALSE;
#line 4674 "DirectoryMonitor.c"
	}
#line 1019 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp17_ = self->priv->monitors;
#line 1019 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp18_ = id;
#line 1019 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp19_ = monitor;
#line 1019 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	gee_abstract_map_set (GEE_ABSTRACT_MAP (_tmp17_), _tmp18_, _tmp19_);
#line 1020 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp20_ = monitor;
#line 1020 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_signal_connect_object (_tmp20_, "changed", (GCallback) _directory_monitor_on_monitor_notification_g_file_monitor_changed, self, 0);
#line 1022 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp21_ = dir;
#line 1022 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp22_ = g_file_get_path (_tmp21_);
#line 1022 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp23_ = _tmp22_;
#line 1022 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp24_ = g_strdup_printf ("Added monitor for %s", _tmp23_);
#line 1022 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp25_ = _tmp24_;
#line 1022 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	directory_monitor_mdbg (_tmp25_);
#line 1022 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_g_free0 (_tmp25_);
#line 1022 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_g_free0 (_tmp23_);
#line 1024 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	result = TRUE;
#line 1024 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_g_object_unref0 (monitor);
#line 1024 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_g_free0 (id);
#line 1024 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	return result;
#line 4712 "DirectoryMonitor.c"
}


static gboolean directory_monitor_remove_monitor (DirectoryMonitor* self, GFile* dir, GFileInfo* info) {
	gboolean result = FALSE;
	gboolean _tmp0_;
	DirectoryMonitorFileInfoMap* _tmp1_;
	GFile* _tmp2_;
	GFileInfo* _tmp3_;
	gchar* _tmp4_ = NULL;
	gchar* id;
	const gchar* _tmp5_;
	GeeHashMap* _tmp6_;
	const gchar* _tmp7_;
	gpointer _tmp8_ = NULL;
	GFileMonitor* monitor;
	GFileMonitor* _tmp9_;
	GeeHashMap* _tmp10_;
	const gchar* _tmp11_;
	gboolean _tmp12_ = FALSE;
	gboolean removed;
	gboolean _tmp13_;
	GFileMonitor* _tmp14_;
	GFile* _tmp15_;
	gchar* _tmp16_ = NULL;
	gchar* _tmp17_;
	gchar* _tmp18_ = NULL;
	gchar* _tmp19_;
#line 1028 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_val_if_fail (IS_DIRECTORY_MONITOR (self), FALSE);
#line 1028 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_val_if_fail (G_IS_FILE (dir), FALSE);
#line 1028 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_val_if_fail (G_IS_FILE_INFO (info), FALSE);
#line 1029 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp0_ = self->priv->monitoring;
#line 1029 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	if (!_tmp0_) {
#line 1030 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		result = FALSE;
#line 1030 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		return result;
#line 4755 "DirectoryMonitor.c"
	}
#line 1032 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp1_ = self->priv->files;
#line 1032 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp2_ = dir;
#line 1032 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp3_ = info;
#line 1032 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp4_ = directory_monitor_file_info_map_get_id (_tmp1_, _tmp2_, _tmp3_);
#line 1032 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	id = _tmp4_;
#line 1033 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp5_ = id;
#line 1033 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	if (_tmp5_ == NULL) {
#line 1034 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		result = FALSE;
#line 1034 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_g_free0 (id);
#line 1034 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		return result;
#line 4777 "DirectoryMonitor.c"
	}
#line 1036 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp6_ = self->priv->monitors;
#line 1036 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp7_ = id;
#line 1036 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp8_ = gee_abstract_map_get (GEE_ABSTRACT_MAP (_tmp6_), _tmp7_);
#line 1036 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	monitor = (GFileMonitor*) _tmp8_;
#line 1037 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp9_ = monitor;
#line 1037 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	if (_tmp9_ == NULL) {
#line 1038 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		result = FALSE;
#line 1038 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_g_object_unref0 (monitor);
#line 1038 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_g_free0 (id);
#line 1038 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		return result;
#line 4799 "DirectoryMonitor.c"
	}
#line 1040 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp10_ = self->priv->monitors;
#line 1040 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp11_ = id;
#line 1040 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp12_ = gee_abstract_map_unset (GEE_ABSTRACT_MAP (_tmp10_), _tmp11_, NULL);
#line 1040 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	removed = _tmp12_;
#line 1041 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp13_ = removed;
#line 1041 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_assert (_tmp13_);
#line 1043 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp14_ = monitor;
#line 1043 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	directory_monitor_cancel_monitor (self, _tmp14_);
#line 1045 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp15_ = dir;
#line 1045 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp16_ = g_file_get_path (_tmp15_);
#line 1045 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp17_ = _tmp16_;
#line 1045 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp18_ = g_strdup_printf ("Removed monitor for %s", _tmp17_);
#line 1045 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp19_ = _tmp18_;
#line 1045 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	directory_monitor_mdbg (_tmp19_);
#line 1045 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_g_free0 (_tmp19_);
#line 1045 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_g_free0 (_tmp17_);
#line 1047 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	result = TRUE;
#line 1047 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_g_object_unref0 (monitor);
#line 1047 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_g_free0 (id);
#line 1047 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	return result;
#line 4841 "DirectoryMonitor.c"
}


static void directory_monitor_cancel_monitor (DirectoryMonitor* self, GFileMonitor* monitor) {
	GFileMonitor* _tmp0_;
	guint _tmp1_ = 0U;
	GFileMonitor* _tmp2_;
#line 1050 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 1050 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE_MONITOR (monitor));
#line 1051 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp0_ = monitor;
#line 1051 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_signal_parse_name ("changed", G_TYPE_FILE_MONITOR, &_tmp1_, NULL, FALSE);
#line 1051 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_signal_handlers_disconnect_matched (_tmp0_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _directory_monitor_on_monitor_notification_g_file_monitor_changed, self);
#line 1052 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp2_ = monitor;
#line 1052 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_file_monitor_cancel (_tmp2_);
#line 4863 "DirectoryMonitor.c"
}


static void _directory_monitor_query_info_queue_element_on_completed_gasync_ready_callback (GObject* source_object, GAsyncResult* res, gpointer self) {
#line 1072 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	directory_monitor_query_info_queue_element_on_completed (self, source_object, res);
#line 1072 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	directory_monitor_query_info_queue_element_unref (self);
#line 4872 "DirectoryMonitor.c"
}


static gboolean _directory_monitor_check_for_expired_delete_events_gsource_func (gpointer self) {
	gboolean result;
	result = directory_monitor_check_for_expired_delete_events (self);
#line 1081 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	return result;
#line 4881 "DirectoryMonitor.c"
}


static void directory_monitor_on_monitor_notification (DirectoryMonitor* self, GFile* file, GFile* other_file, GFileMonitorEvent event) {
	gchar* _tmp0_ = NULL;
	GFile* _tmp1_;
	GFileMonitorEvent _tmp5_;
	GEnumValue* _tmp6_;
	GFile* _tmp7_;
	gchar* _tmp8_ = NULL;
	gchar* _tmp9_;
	const gchar* _tmp10_;
	gchar* _tmp11_ = NULL;
	gchar* _tmp12_;
	GFile* _tmp13_;
	GFile* _tmp14_;
	GFileMonitorEvent _tmp15_;
	DirectoryMonitorQueryInfoQueueElement* _tmp16_;
	DirectoryMonitorQueryInfoQueueElement* query_info;
	GeeQueue* _tmp17_;
	DirectoryMonitorQueryInfoQueueElement* _tmp18_;
	GFileMonitorEvent _tmp19_;
#line 1055 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 1055 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (file));
#line 1055 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_if_fail ((other_file == NULL) || G_IS_FILE (other_file));
#line 1057 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp1_ = other_file;
#line 1057 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	if (_tmp1_ != NULL) {
#line 4914 "DirectoryMonitor.c"
		GFile* _tmp2_;
		gchar* _tmp3_ = NULL;
#line 1057 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_tmp2_ = other_file;
#line 1057 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_tmp3_ = g_file_get_path (_tmp2_);
#line 1057 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_g_free0 (_tmp0_);
#line 1057 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_tmp0_ = _tmp3_;
#line 4925 "DirectoryMonitor.c"
	} else {
		gchar* _tmp4_;
#line 1057 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_tmp4_ = g_strdup ("(none)");
#line 1057 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_g_free0 (_tmp0_);
#line 1057 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_tmp0_ = _tmp4_;
#line 4934 "DirectoryMonitor.c"
	}
#line 1056 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp5_ = event;
#line 1056 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp6_ = g_enum_get_value (g_type_class_ref (G_TYPE_FILE_MONITOR_EVENT), _tmp5_);
#line 1056 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp7_ = file;
#line 1056 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp8_ = g_file_get_path (_tmp7_);
#line 1056 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp9_ = _tmp8_;
#line 1056 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp10_ = _tmp0_;
#line 1056 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp11_ = g_strdup_printf ("NOTIFY %s: file=%s other_file=%s", (_tmp6_ != NULL) ? _tmp6_->value_name : NULL, _tmp9_, _tmp10_);
#line 1056 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp12_ = _tmp11_;
#line 1056 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	directory_monitor_mdbg (_tmp12_);
#line 1056 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_g_free0 (_tmp12_);
#line 1056 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_g_free0 (_tmp9_);
#line 1066 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp13_ = file;
#line 1066 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp14_ = other_file;
#line 1066 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp15_ = event;
#line 1066 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp16_ = directory_monitor_query_info_queue_element_new (self, _tmp13_, _tmp14_, _tmp15_);
#line 1066 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	query_info = _tmp16_;
#line 1067 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp17_ = self->priv->query_info_queue;
#line 1067 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp18_ = query_info;
#line 1067 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	gee_queue_offer (_tmp17_, _tmp18_);
#line 1069 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp19_ = event;
#line 1069 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	switch (_tmp19_) {
#line 1069 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		case G_FILE_MONITOR_EVENT_CREATED:
#line 1069 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		case G_FILE_MONITOR_EVENT_CHANGES_DONE_HINT:
#line 4982 "DirectoryMonitor.c"
		{
			GFile* _tmp20_;
			GCancellable* _tmp21_;
			DirectoryMonitorQueryInfoQueueElement* _tmp22_;
#line 1072 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_tmp20_ = file;
#line 1072 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_tmp21_ = self->priv->cancellable;
#line 1072 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_tmp22_ = query_info;
#line 1072 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			g_file_query_info_async (_tmp20_, DIRECTORY_MONITOR_SUPPLIED_ATTRIBUTES, DIRECTORY_MONITOR_UNKNOWN_INFO_FLAGS, DIRECTORY_MONITOR_DEFAULT_PRIORITY, _tmp21_, _directory_monitor_query_info_queue_element_on_completed_gasync_ready_callback, directory_monitor_query_info_queue_element_ref (_tmp22_));
#line 1074 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			break;
#line 4997 "DirectoryMonitor.c"
		}
#line 1069 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		case G_FILE_MONITOR_EVENT_DELETED:
#line 5001 "DirectoryMonitor.c"
		{
			guint _tmp23_;
#line 1080 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_tmp23_ = self->priv->delete_timer_id;
#line 1080 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			if (_tmp23_ == ((guint) 0)) {
#line 5008 "DirectoryMonitor.c"
				guint _tmp24_ = 0U;
#line 1081 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_tmp24_ = g_timeout_add_full (G_PRIORITY_DEFAULT, DIRECTORY_MONITOR_DELETED_EXPIRATION_MSEC / 2, _directory_monitor_check_for_expired_delete_events_gsource_func, g_object_ref (self), g_object_unref);
#line 1081 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				self->priv->delete_timer_id = _tmp24_;
#line 5014 "DirectoryMonitor.c"
			}
#line 1082 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			break;
#line 5018 "DirectoryMonitor.c"
		}
#line 1069 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		case G_FILE_MONITOR_EVENT_MOVED:
#line 5022 "DirectoryMonitor.c"
		{
			GFile* _tmp25_;
#line 1087 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_tmp25_ = other_file;
#line 1087 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			if (_tmp25_ != NULL) {
#line 5029 "DirectoryMonitor.c"
				GFile* _tmp26_;
				GCancellable* _tmp27_;
				DirectoryMonitorQueryInfoQueueElement* _tmp28_;
#line 1088 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_tmp26_ = other_file;
#line 1088 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_tmp27_ = self->priv->cancellable;
#line 1088 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_tmp28_ = query_info;
#line 1088 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				g_file_query_info_async (_tmp26_, DIRECTORY_MONITOR_SUPPLIED_ATTRIBUTES, DIRECTORY_MONITOR_UNKNOWN_INFO_FLAGS, DIRECTORY_MONITOR_DEFAULT_PRIORITY, _tmp27_, _directory_monitor_query_info_queue_element_on_completed_gasync_ready_callback, directory_monitor_query_info_queue_element_ref (_tmp28_));
#line 5041 "DirectoryMonitor.c"
			} else {
				GeeQueue* _tmp29_;
				DirectoryMonitorQueryInfoQueueElement* _tmp30_;
#line 1091 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				g_warning ("DirectoryMonitor.vala:1091: Unable to process MOVED event: no other_fi" \
"le");
#line 1092 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_tmp29_ = self->priv->query_info_queue;
#line 1092 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_tmp30_ = query_info;
#line 1092 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				gee_collection_remove (GEE_COLLECTION (_tmp29_), _tmp30_);
#line 5053 "DirectoryMonitor.c"
			}
#line 1094 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			break;
#line 5057 "DirectoryMonitor.c"
		}
		default:
		{
			DirectoryMonitorQueryInfoQueueElement* _tmp31_;
			DirectoryMonitorQueryInfoQueueElement* _tmp32_;
#line 1098 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_tmp31_ = query_info;
#line 1098 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_tmp31_->completed = TRUE;
#line 1099 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_tmp32_ = query_info;
#line 1099 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			directory_monitor_process_query_queue (self, _tmp32_);
#line 1100 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			break;
#line 5073 "DirectoryMonitor.c"
		}
	}
#line 1055 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_directory_monitor_query_info_queue_element_unref0 (query_info);
#line 1055 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_g_free0 (_tmp0_);
#line 5080 "DirectoryMonitor.c"
}


static void directory_monitor_process_query_queue (DirectoryMonitor* self, DirectoryMonitorQueryInfoQueueElement* query_info) {
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	DirectoryMonitorQueryInfoQueueElement* _tmp2_;
	gboolean _tmp5_;
	gboolean _tmp8_;
#line 1104 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 1104 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_if_fail ((query_info == NULL) || DIRECTORY_MONITOR_IS_QUERY_INFO_QUEUE_ELEMENT (query_info));
#line 1107 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp2_ = query_info;
#line 1107 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	if (_tmp2_ != NULL) {
#line 5098 "DirectoryMonitor.c"
		DirectoryMonitorQueryInfoQueueElement* _tmp3_;
		GFileInfo* _tmp4_;
#line 1107 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_tmp3_ = query_info;
#line 1107 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_tmp4_ = _tmp3_->info;
#line 1107 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_tmp1_ = _tmp4_ != NULL;
#line 5107 "DirectoryMonitor.c"
	} else {
#line 1107 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_tmp1_ = FALSE;
#line 5111 "DirectoryMonitor.c"
	}
#line 1107 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp5_ = _tmp1_;
#line 1107 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	if (_tmp5_) {
#line 5117 "DirectoryMonitor.c"
		DirectoryMonitorQueryInfoQueueElement* _tmp6_;
		GFileMonitorEvent _tmp7_;
#line 1107 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_tmp6_ = query_info;
#line 1107 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_tmp7_ = _tmp6_->event;
#line 1107 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_tmp0_ = _tmp7_ == G_FILE_MONITOR_EVENT_CREATED;
#line 5126 "DirectoryMonitor.c"
	} else {
#line 1107 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_tmp0_ = FALSE;
#line 5130 "DirectoryMonitor.c"
	}
#line 1107 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp8_ = _tmp0_;
#line 1107 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	if (_tmp8_) {
#line 5136 "DirectoryMonitor.c"
		DirectoryMonitorFileInfoMap* _tmp9_;
		DirectoryMonitorQueryInfoQueueElement* _tmp10_;
		GFileInfo* _tmp11_;
		GFile* _tmp12_ = NULL;
		GFile* match;
		GFile* _tmp13_;
#line 1110 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_tmp9_ = self->priv->files;
#line 1110 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_tmp10_ = query_info;
#line 1110 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_tmp11_ = _tmp10_->info;
#line 1110 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_tmp12_ = directory_monitor_file_info_map_find_match (_tmp9_, _tmp11_);
#line 1110 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		match = _tmp12_;
#line 1111 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_tmp13_ = match;
#line 1111 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		if (_tmp13_ != NULL) {
#line 5157 "DirectoryMonitor.c"
			gboolean matched;
			gboolean _tmp52_;
#line 1112 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			matched = FALSE;
#line 5162 "DirectoryMonitor.c"
			{
				GeeQueue* _tmp14_;
				GeeIterator* _tmp15_ = NULL;
				GeeIterator* _enqueued_it;
#line 1113 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_tmp14_ = self->priv->query_info_queue;
#line 1113 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_tmp15_ = gee_iterable_iterator (GEE_ITERABLE (_tmp14_));
#line 1113 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_enqueued_it = _tmp15_;
#line 1113 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				while (TRUE) {
#line 5175 "DirectoryMonitor.c"
					GeeIterator* _tmp16_;
					gboolean _tmp17_ = FALSE;
					GeeIterator* _tmp18_;
					gpointer _tmp19_ = NULL;
					DirectoryMonitorQueryInfoQueueElement* enqueued;
					gboolean _tmp20_ = FALSE;
					gboolean _tmp21_ = FALSE;
					DirectoryMonitorQueryInfoQueueElement* _tmp22_;
					GFileMonitorEvent _tmp23_;
					gboolean _tmp26_;
					gboolean _tmp31_;
					DirectoryMonitorQueryInfoQueueElement* _tmp32_;
					GFile* _tmp33_;
					gchar* _tmp34_ = NULL;
					gchar* _tmp35_;
					DirectoryMonitorQueryInfoQueueElement* _tmp36_;
					GFile* _tmp37_;
					gchar* _tmp38_ = NULL;
					gchar* _tmp39_;
					gchar* _tmp40_ = NULL;
					gchar* _tmp41_;
					DirectoryMonitorQueryInfoQueueElement* _tmp42_;
					DirectoryMonitorQueryInfoQueueElement* _tmp43_;
					DirectoryMonitorQueryInfoQueueElement* _tmp44_;
					GFile* _tmp45_;
					GFile* _tmp46_;
					DirectoryMonitorQueryInfoQueueElement* _tmp47_;
					DirectoryMonitorQueryInfoQueueElement* _tmp48_;
					GFileInfo* _tmp49_;
					GFileInfo* _tmp50_;
					DirectoryMonitorQueryInfoQueueElement* _tmp51_;
#line 1113 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					_tmp16_ = _enqueued_it;
#line 1113 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					_tmp17_ = gee_iterator_next (_tmp16_);
#line 1113 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					if (!_tmp17_) {
#line 1113 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
						break;
#line 5215 "DirectoryMonitor.c"
					}
#line 1113 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					_tmp18_ = _enqueued_it;
#line 1113 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					_tmp19_ = gee_iterator_get (_tmp18_);
#line 1113 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					enqueued = (DirectoryMonitorQueryInfoQueueElement*) _tmp19_;
#line 1114 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					_tmp22_ = enqueued;
#line 1114 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					_tmp23_ = _tmp22_->event;
#line 1114 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					if (_tmp23_ != G_FILE_MONITOR_EVENT_DELETED) {
#line 1114 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
						_tmp21_ = TRUE;
#line 5231 "DirectoryMonitor.c"
					} else {
						DirectoryMonitorQueryInfoQueueElement* _tmp24_;
						gboolean _tmp25_;
#line 1115 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
						_tmp24_ = enqueued;
#line 1115 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
						_tmp25_ = _tmp24_->completed;
#line 1115 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
						_tmp21_ = _tmp25_;
#line 5241 "DirectoryMonitor.c"
					}
#line 1114 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					_tmp26_ = _tmp21_;
#line 1114 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					if (_tmp26_) {
#line 1114 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
						_tmp20_ = TRUE;
#line 5249 "DirectoryMonitor.c"
					} else {
						GFile* _tmp27_;
						DirectoryMonitorQueryInfoQueueElement* _tmp28_;
						GFile* _tmp29_;
						gboolean _tmp30_ = FALSE;
#line 1116 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
						_tmp27_ = match;
#line 1116 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
						_tmp28_ = enqueued;
#line 1116 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
						_tmp29_ = _tmp28_->file;
#line 1116 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
						_tmp30_ = g_file_equal (_tmp27_, _tmp29_);
#line 1116 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
						_tmp20_ = !_tmp30_;
#line 5265 "DirectoryMonitor.c"
					}
#line 1114 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					_tmp31_ = _tmp20_;
#line 1114 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					if (_tmp31_) {
#line 1117 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
						_directory_monitor_query_info_queue_element_unref0 (enqueued);
#line 1117 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
						continue;
#line 5275 "DirectoryMonitor.c"
					}
#line 1120 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					_tmp32_ = query_info;
#line 1120 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					_tmp33_ = _tmp32_->file;
#line 1120 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					_tmp34_ = g_file_get_path (_tmp33_);
#line 1120 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					_tmp35_ = _tmp34_;
#line 1120 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					_tmp36_ = enqueued;
#line 1120 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					_tmp37_ = _tmp36_->file;
#line 1120 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					_tmp38_ = g_file_get_path (_tmp37_);
#line 1120 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					_tmp39_ = _tmp38_;
#line 1120 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					_tmp40_ = g_strdup_printf ("Matching CREATED %s to DELETED %s for MOVED", _tmp35_, _tmp39_);
#line 1120 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					_tmp41_ = _tmp40_;
#line 1120 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					directory_monitor_mdbg (_tmp41_);
#line 1120 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					_g_free0 (_tmp41_);
#line 1120 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					_g_free0 (_tmp39_);
#line 1120 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					_g_free0 (_tmp35_);
#line 1123 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					_tmp42_ = enqueued;
#line 1123 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					_tmp42_->event = G_FILE_MONITOR_EVENT_MOVED;
#line 1124 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					_tmp43_ = enqueued;
#line 1124 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					_tmp44_ = query_info;
#line 1124 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					_tmp45_ = _tmp44_->file;
#line 1124 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					_tmp46_ = _g_object_ref0 (_tmp45_);
#line 1124 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					_g_object_unref0 (_tmp43_->other_file);
#line 1124 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					_tmp43_->other_file = _tmp46_;
#line 1125 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					_tmp47_ = enqueued;
#line 1125 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					_tmp48_ = query_info;
#line 1125 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					_tmp49_ = _tmp48_->info;
#line 1125 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					_tmp50_ = _g_object_ref0 (_tmp49_);
#line 1125 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					_g_object_unref0 (_tmp47_->info);
#line 1125 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					_tmp47_->info = _tmp50_;
#line 1126 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					_tmp51_ = enqueued;
#line 1126 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					_tmp51_->completed = TRUE;
#line 1128 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					matched = TRUE;
#line 1130 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					_directory_monitor_query_info_queue_element_unref0 (enqueued);
#line 1130 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					break;
#line 5343 "DirectoryMonitor.c"
				}
#line 1113 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_g_object_unref0 (_enqueued_it);
#line 5347 "DirectoryMonitor.c"
			}
#line 1133 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_tmp52_ = matched;
#line 1133 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			if (_tmp52_) {
#line 5353 "DirectoryMonitor.c"
				GeeQueue* _tmp53_;
				DirectoryMonitorQueryInfoQueueElement* _tmp54_;
#line 1134 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_tmp53_ = self->priv->query_info_queue;
#line 1134 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_tmp54_ = query_info;
#line 1134 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				gee_collection_remove (GEE_COLLECTION (_tmp53_), _tmp54_);
#line 5362 "DirectoryMonitor.c"
			}
		}
#line 1107 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_g_object_unref0 (match);
#line 5367 "DirectoryMonitor.c"
	}
	{
		gboolean _tmp55_;
#line 1139 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_tmp55_ = TRUE;
#line 1139 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		while (TRUE) {
#line 5375 "DirectoryMonitor.c"
			gboolean _tmp56_;
			GeeQueue* _tmp57_;
			gpointer _tmp58_ = NULL;
			DirectoryMonitorQueryInfoQueueElement* next;
			gboolean _tmp59_ = FALSE;
			DirectoryMonitorQueryInfoQueueElement* _tmp60_;
			gboolean _tmp63_;
			GeeQueue* _tmp64_;
			gpointer _tmp65_ = NULL;
			DirectoryMonitorQueryInfoQueueElement* n;
			DirectoryMonitorQueryInfoQueueElement* _tmp66_;
			DirectoryMonitorQueryInfoQueueElement* _tmp67_;
			DirectoryMonitorQueryInfoQueueElement* _tmp68_;
			guint _tmp69_;
			DirectoryMonitorQueryInfoQueueElement* _tmp70_;
			GFileMonitorEvent _tmp71_;
			GEnumValue* _tmp72_;
			DirectoryMonitorQueryInfoQueueElement* _tmp73_;
			GFile* _tmp74_;
			gchar* _tmp75_ = NULL;
			gchar* _tmp76_;
			gchar* _tmp77_ = NULL;
			gchar* _tmp78_;
			DirectoryMonitorQueryInfoQueueElement* _tmp79_;
			GError* _tmp80_;
			gboolean _tmp93_ = FALSE;
			DirectoryMonitorQueryInfoQueueElement* _tmp94_;
			GFileInfo* _tmp95_;
			gboolean _tmp100_;
			gboolean _tmp110_ = FALSE;
			DirectoryMonitorQueryInfoQueueElement* _tmp111_;
			GFileInfo* _tmp112_;
			gboolean _tmp116_;
			DirectoryMonitorQueryInfoQueueElement* _tmp126_;
			GFile* _tmp127_;
			DirectoryMonitorQueryInfoQueueElement* _tmp128_;
			GFile* _tmp129_;
			DirectoryMonitorQueryInfoQueueElement* _tmp130_;
			GFileInfo* _tmp131_;
			DirectoryMonitorQueryInfoQueueElement* _tmp132_;
			GFileMonitorEvent _tmp133_;
#line 1139 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_tmp56_ = _tmp55_;
#line 1139 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			if (!_tmp56_) {
#line 5421 "DirectoryMonitor.c"
			}
#line 1139 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_tmp55_ = FALSE;
#line 1141 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_tmp57_ = self->priv->query_info_queue;
#line 1141 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_tmp58_ = gee_queue_peek (_tmp57_);
#line 1141 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			next = (DirectoryMonitorQueryInfoQueueElement*) _tmp58_;
#line 1142 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_tmp60_ = next;
#line 1142 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			if (_tmp60_ == NULL) {
#line 1142 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_tmp59_ = TRUE;
#line 5437 "DirectoryMonitor.c"
			} else {
				DirectoryMonitorQueryInfoQueueElement* _tmp61_;
				gboolean _tmp62_;
#line 1142 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_tmp61_ = next;
#line 1142 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_tmp62_ = _tmp61_->completed;
#line 1142 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_tmp59_ = !_tmp62_;
#line 5447 "DirectoryMonitor.c"
			}
#line 1142 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_tmp63_ = _tmp59_;
#line 1142 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			if (_tmp63_) {
#line 1143 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_directory_monitor_query_info_queue_element_unref0 (next);
#line 1143 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				break;
#line 5457 "DirectoryMonitor.c"
			}
#line 1146 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_tmp64_ = self->priv->query_info_queue;
#line 1146 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_tmp65_ = gee_queue_poll (_tmp64_);
#line 1146 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			n = (DirectoryMonitorQueryInfoQueueElement*) _tmp65_;
#line 1147 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_tmp66_ = next;
#line 1147 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_tmp67_ = n;
#line 1147 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			g_assert (_tmp66_ == _tmp67_);
#line 1149 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_tmp68_ = next;
#line 1149 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_tmp69_ = _tmp68_->position;
#line 1149 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_tmp70_ = next;
#line 1149 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_tmp71_ = _tmp70_->event;
#line 1149 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_tmp72_ = g_enum_get_value (g_type_class_ref (G_TYPE_FILE_MONITOR_EVENT), _tmp71_);
#line 1149 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_tmp73_ = next;
#line 1149 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_tmp74_ = _tmp73_->file;
#line 1149 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_tmp75_ = g_file_get_path (_tmp74_);
#line 1149 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_tmp76_ = _tmp75_;
#line 1149 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_tmp77_ = g_strdup_printf ("Completed info query %u for %s on %s", _tmp69_, (_tmp72_ != NULL) ? _tmp72_->value_name : NULL, _tmp76_);
#line 1149 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_tmp78_ = _tmp77_;
#line 1149 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			directory_monitor_mdbg (_tmp78_);
#line 1149 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_g_free0 (_tmp78_);
#line 1149 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_g_free0 (_tmp76_);
#line 1152 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_tmp79_ = next;
#line 1152 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_tmp80_ = _tmp79_->err;
#line 1152 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			if (_tmp80_ != NULL) {
#line 5505 "DirectoryMonitor.c"
				DirectoryMonitorQueryInfoQueueElement* _tmp81_;
				GFile* _tmp82_;
				gchar* _tmp83_ = NULL;
				gchar* _tmp84_;
				DirectoryMonitorQueryInfoQueueElement* _tmp85_;
				GFileMonitorEvent _tmp86_;
				GEnumValue* _tmp87_;
				DirectoryMonitorQueryInfoQueueElement* _tmp88_;
				GError* _tmp89_;
				const gchar* _tmp90_;
				gchar* _tmp91_ = NULL;
				gchar* _tmp92_;
#line 1153 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_tmp81_ = next;
#line 1153 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_tmp82_ = _tmp81_->file;
#line 1153 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_tmp83_ = g_file_get_path (_tmp82_);
#line 1153 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_tmp84_ = _tmp83_;
#line 1153 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_tmp85_ = next;
#line 1153 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_tmp86_ = _tmp85_->event;
#line 1154 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_tmp87_ = g_enum_get_value (g_type_class_ref (G_TYPE_FILE_MONITOR_EVENT), _tmp86_);
#line 1153 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_tmp88_ = next;
#line 1153 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_tmp89_ = _tmp88_->err;
#line 1153 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_tmp90_ = _tmp89_->message;
#line 1153 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_tmp91_ = g_strdup_printf ("Unable to retrieve file information for %s, dropping %s: %s", _tmp84_, (_tmp87_ != NULL) ? _tmp87_->value_name : NULL, _tmp90_);
#line 1153 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_tmp92_ = _tmp91_;
#line 1153 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				directory_monitor_mdbg (_tmp92_);
#line 1153 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_g_free0 (_tmp92_);
#line 1153 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_g_free0 (_tmp84_);
#line 1156 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_directory_monitor_query_info_queue_element_unref0 (n);
#line 1156 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_directory_monitor_query_info_queue_element_unref0 (next);
#line 1156 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				continue;
#line 5554 "DirectoryMonitor.c"
			}
#line 1160 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_tmp94_ = next;
#line 1160 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_tmp95_ = _tmp94_->info;
#line 1160 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			if (_tmp95_ != NULL) {
#line 5562 "DirectoryMonitor.c"
				DirectoryMonitorQueryInfoQueueElement* _tmp96_;
				GFileInfo* _tmp97_;
				gchar* _tmp98_ = NULL;
				gchar* _tmp99_;
#line 1160 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_tmp96_ = next;
#line 1160 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_tmp97_ = _tmp96_->info;
#line 1160 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_tmp98_ = get_file_info_id (_tmp97_);
#line 1160 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_tmp99_ = _tmp98_;
#line 1160 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_tmp93_ = _tmp99_ == NULL;
#line 1160 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_g_free0 (_tmp99_);
#line 5579 "DirectoryMonitor.c"
			} else {
#line 1160 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_tmp93_ = FALSE;
#line 5583 "DirectoryMonitor.c"
			}
#line 1160 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_tmp100_ = _tmp93_;
#line 1160 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			if (_tmp100_) {
#line 5589 "DirectoryMonitor.c"
				DirectoryMonitorQueryInfoQueueElement* _tmp101_;
				GFile* _tmp102_;
				gchar* _tmp103_ = NULL;
				gchar* _tmp104_;
				DirectoryMonitorQueryInfoQueueElement* _tmp105_;
				GFileMonitorEvent _tmp106_;
				GEnumValue* _tmp107_;
				gchar* _tmp108_ = NULL;
				gchar* _tmp109_;
#line 1161 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_tmp101_ = next;
#line 1161 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_tmp102_ = _tmp101_->file;
#line 1161 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_tmp103_ = g_file_get_path (_tmp102_);
#line 1161 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_tmp104_ = _tmp103_;
#line 1161 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_tmp105_ = next;
#line 1161 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_tmp106_ = _tmp105_->event;
#line 1162 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_tmp107_ = g_enum_get_value (g_type_class_ref (G_TYPE_FILE_MONITOR_EVENT), _tmp106_);
#line 1161 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_tmp108_ = g_strdup_printf ("Unable to retrieve file ID for %s, dropping %s", _tmp104_, (_tmp107_ != NULL) ? _tmp107_->value_name : NULL);
#line 1161 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_tmp109_ = _tmp108_;
#line 1161 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				directory_monitor_mdbg (_tmp109_);
#line 1161 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_g_free0 (_tmp109_);
#line 1161 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_g_free0 (_tmp104_);
#line 1164 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_directory_monitor_query_info_queue_element_unref0 (n);
#line 1164 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_directory_monitor_query_info_queue_element_unref0 (next);
#line 1164 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				continue;
#line 5629 "DirectoryMonitor.c"
			}
#line 1168 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_tmp111_ = next;
#line 1168 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_tmp112_ = _tmp111_->info;
#line 1168 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			if (_tmp112_ != NULL) {
#line 5637 "DirectoryMonitor.c"
				DirectoryMonitorQueryInfoQueueElement* _tmp113_;
				GFileInfo* _tmp114_;
				gboolean _tmp115_ = FALSE;
#line 1168 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_tmp113_ = next;
#line 1168 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_tmp114_ = _tmp113_->info;
#line 1168 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_tmp115_ = directory_monitor_is_file_symlink_supported (_tmp114_);
#line 1168 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_tmp110_ = !_tmp115_;
#line 5649 "DirectoryMonitor.c"
			} else {
#line 1168 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_tmp110_ = FALSE;
#line 5653 "DirectoryMonitor.c"
			}
#line 1168 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_tmp116_ = _tmp110_;
#line 1168 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			if (_tmp116_) {
#line 5659 "DirectoryMonitor.c"
				DirectoryMonitorQueryInfoQueueElement* _tmp117_;
				GFile* _tmp118_;
				gchar* _tmp119_ = NULL;
				gchar* _tmp120_;
				DirectoryMonitorQueryInfoQueueElement* _tmp121_;
				GFileMonitorEvent _tmp122_;
				GEnumValue* _tmp123_;
				gchar* _tmp124_ = NULL;
				gchar* _tmp125_;
#line 1169 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_tmp117_ = next;
#line 1169 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_tmp118_ = _tmp117_->file;
#line 1169 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_tmp119_ = g_file_get_path (_tmp118_);
#line 1169 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_tmp120_ = _tmp119_;
#line 1169 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_tmp121_ = next;
#line 1169 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_tmp122_ = _tmp121_->event;
#line 1170 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_tmp123_ = g_enum_get_value (g_type_class_ref (G_TYPE_FILE_MONITOR_EVENT), _tmp122_);
#line 1169 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_tmp124_ = g_strdup_printf ("No symlink support for %s, dropping %s", _tmp120_, (_tmp123_ != NULL) ? _tmp123_->value_name : NULL);
#line 1169 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_tmp125_ = _tmp124_;
#line 1169 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				directory_monitor_mdbg (_tmp125_);
#line 1169 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_g_free0 (_tmp125_);
#line 1169 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_g_free0 (_tmp120_);
#line 1172 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_directory_monitor_query_info_queue_element_unref0 (n);
#line 1172 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_directory_monitor_query_info_queue_element_unref0 (next);
#line 1172 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				continue;
#line 5699 "DirectoryMonitor.c"
			}
#line 1175 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_tmp126_ = next;
#line 1175 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_tmp127_ = _tmp126_->file;
#line 1175 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_tmp128_ = next;
#line 1175 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_tmp129_ = _tmp128_->other_file;
#line 1175 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_tmp130_ = next;
#line 1175 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_tmp131_ = _tmp130_->info;
#line 1175 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_tmp132_ = next;
#line 1175 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_tmp133_ = _tmp132_->event;
#line 1175 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			directory_monitor_on_monitor_notification_ready (self, _tmp127_, _tmp129_, _tmp131_, _tmp133_);
#line 1139 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_directory_monitor_query_info_queue_element_unref0 (n);
#line 1139 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_directory_monitor_query_info_queue_element_unref0 (next);
#line 5723 "DirectoryMonitor.c"
		}
	}
}


static void directory_monitor_on_monitor_notification_ready (DirectoryMonitor* self, GFile* file, GFile* other_file, GFileInfo* info, GFileMonitorEvent event) {
	gchar* _tmp0_ = NULL;
	GFile* _tmp1_;
	GFileMonitorEvent _tmp5_;
	GEnumValue* _tmp6_;
	GFile* _tmp7_;
	gchar* _tmp8_ = NULL;
	gchar* _tmp9_;
	const gchar* _tmp10_;
	gchar* _tmp11_ = NULL;
	gchar* _tmp12_;
	GFileMonitorEvent _tmp13_;
#line 1179 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_if_fail (IS_DIRECTORY_MONITOR (self));
#line 1179 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (file));
#line 1179 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_if_fail ((other_file == NULL) || G_IS_FILE (other_file));
#line 1179 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_if_fail ((info == NULL) || G_IS_FILE_INFO (info));
#line 1182 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp1_ = other_file;
#line 1182 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	if (_tmp1_ != NULL) {
#line 5753 "DirectoryMonitor.c"
		GFile* _tmp2_;
		gchar* _tmp3_ = NULL;
#line 1182 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_tmp2_ = other_file;
#line 1182 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_tmp3_ = g_file_get_path (_tmp2_);
#line 1182 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_g_free0 (_tmp0_);
#line 1182 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_tmp0_ = _tmp3_;
#line 5764 "DirectoryMonitor.c"
	} else {
		gchar* _tmp4_;
#line 1182 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_tmp4_ = g_strdup ("(null)");
#line 1182 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_g_free0 (_tmp0_);
#line 1182 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_tmp0_ = _tmp4_;
#line 5773 "DirectoryMonitor.c"
	}
#line 1181 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp5_ = event;
#line 1181 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp6_ = g_enum_get_value (g_type_class_ref (G_TYPE_FILE_MONITOR_EVENT), _tmp5_);
#line 1181 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp7_ = file;
#line 1181 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp8_ = g_file_get_path (_tmp7_);
#line 1181 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp9_ = _tmp8_;
#line 1181 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp10_ = _tmp0_;
#line 1181 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp11_ = g_strdup_printf ("READY %s: file=%s other_file=%s", (_tmp6_ != NULL) ? _tmp6_->value_name : NULL, _tmp9_, _tmp10_);
#line 1181 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp12_ = _tmp11_;
#line 1181 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	directory_monitor_mdbg (_tmp12_);
#line 1181 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_g_free0 (_tmp12_);
#line 1181 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_g_free0 (_tmp9_);
#line 1186 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp13_ = event;
#line 1186 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	switch (_tmp13_) {
#line 1186 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		case G_FILE_MONITOR_EVENT_CREATED:
#line 5803 "DirectoryMonitor.c"
		{
			GFileInfo* _tmp14_;
			GFileInfo* _tmp15_;
			DirectoryMonitorFType _tmp16_ = 0;
			DirectoryMonitorFType ftype;
			DirectoryMonitorFType _tmp17_;
#line 1188 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_tmp14_ = info;
#line 1188 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			g_assert (_tmp14_ != NULL);
#line 1190 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_tmp15_ = info;
#line 1190 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_tmp16_ = directory_monitor_get_ftype (_tmp15_);
#line 1190 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			ftype = _tmp16_;
#line 1191 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_tmp17_ = ftype;
#line 1191 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			switch (_tmp17_) {
#line 1191 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				case DIRECTORY_MONITOR_FTYPE_FILE:
#line 5826 "DirectoryMonitor.c"
				{
					GFile* _tmp18_;
					GFileInfo* _tmp19_;
#line 1193 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					_tmp18_ = file;
#line 1193 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					_tmp19_ = info;
#line 1193 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					directory_monitor_internal_notify_file_created (self, _tmp18_, _tmp19_);
#line 1194 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					break;
#line 5838 "DirectoryMonitor.c"
				}
#line 1191 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				case DIRECTORY_MONITOR_FTYPE_DIRECTORY:
#line 5842 "DirectoryMonitor.c"
				{
					gint _tmp20_;
					GFile* _tmp21_;
					GFileInfo* _tmp22_;
#line 1201 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					_tmp20_ = self->priv->outstanding_exploration_dirs;
#line 1201 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					self->priv->outstanding_exploration_dirs = _tmp20_ + 1;
#line 1202 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					_tmp21_ = file;
#line 1202 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					_tmp22_ = info;
#line 1202 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					directory_monitor_explore_async (self, _tmp21_, _tmp22_, FALSE, NULL, NULL);
#line 1203 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					break;
#line 5859 "DirectoryMonitor.c"
				}
				default:
				{
					DirectoryMonitorFType _tmp23_;
#line 1206 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					_tmp23_ = ftype;
#line 1206 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					g_assert (_tmp23_ == DIRECTORY_MONITOR_FTYPE_UNSUPPORTED);
#line 1207 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					break;
#line 5870 "DirectoryMonitor.c"
				}
			}
#line 1209 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			break;
#line 5875 "DirectoryMonitor.c"
		}
#line 1186 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		case G_FILE_MONITOR_EVENT_CHANGED:
#line 5879 "DirectoryMonitor.c"
		{
			GFileInfo* _tmp24_;
			GFile* _tmp25_;
			GFileInfo* _tmp26_ = NULL;
			GFileInfo* local_info;
			GFileInfo* _tmp27_;
			GFileInfo* _tmp33_;
			DirectoryMonitorFType _tmp34_ = 0;
			DirectoryMonitorFType ftype;
			DirectoryMonitorFType _tmp35_;
#line 1213 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_tmp24_ = info;
#line 1213 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			g_assert (_tmp24_ == NULL);
#line 1215 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_tmp25_ = file;
#line 1215 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_tmp26_ = directory_monitor_get_file_info (self, _tmp25_);
#line 1215 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			local_info = _tmp26_;
#line 1216 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_tmp27_ = local_info;
#line 1216 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			if (_tmp27_ == NULL) {
#line 5904 "DirectoryMonitor.c"
				GFile* _tmp28_;
				gchar* _tmp29_ = NULL;
				gchar* _tmp30_;
				gchar* _tmp31_ = NULL;
				gchar* _tmp32_;
#line 1217 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_tmp28_ = file;
#line 1217 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_tmp29_ = g_file_get_path (_tmp28_);
#line 1217 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_tmp30_ = _tmp29_;
#line 1217 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_tmp31_ = g_strdup_printf ("Changed event for unknown file %s", _tmp30_);
#line 1217 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_tmp32_ = _tmp31_;
#line 1217 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				directory_monitor_mdbg (_tmp32_);
#line 1217 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_g_free0 (_tmp32_);
#line 1217 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_g_free0 (_tmp30_);
#line 1219 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_g_object_unref0 (local_info);
#line 1219 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				break;
#line 5930 "DirectoryMonitor.c"
			}
#line 1222 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_tmp33_ = local_info;
#line 1222 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_tmp34_ = directory_monitor_get_ftype (_tmp33_);
#line 1222 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			ftype = _tmp34_;
#line 1223 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_tmp35_ = ftype;
#line 1223 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			switch (_tmp35_) {
#line 1223 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				case DIRECTORY_MONITOR_FTYPE_FILE:
#line 5944 "DirectoryMonitor.c"
				{
					GFile* _tmp36_;
#line 1225 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					_tmp36_ = file;
#line 1225 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					directory_monitor_notify_file_altered (self, _tmp36_);
#line 1226 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					break;
#line 5953 "DirectoryMonitor.c"
				}
#line 1223 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				case DIRECTORY_MONITOR_FTYPE_DIRECTORY:
#line 5957 "DirectoryMonitor.c"
				{
					GFile* _tmp37_;
#line 1229 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					_tmp37_ = file;
#line 1229 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					directory_monitor_notify_directory_altered (self, _tmp37_);
#line 1230 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					break;
#line 5966 "DirectoryMonitor.c"
				}
				default:
				{
					DirectoryMonitorFType _tmp38_;
#line 1233 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					_tmp38_ = ftype;
#line 1233 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					g_assert (_tmp38_ == DIRECTORY_MONITOR_FTYPE_UNSUPPORTED);
#line 1234 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					break;
#line 5977 "DirectoryMonitor.c"
				}
			}
#line 1236 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_g_object_unref0 (local_info);
#line 1236 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			break;
#line 5984 "DirectoryMonitor.c"
		}
#line 1186 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		case G_FILE_MONITOR_EVENT_CHANGES_DONE_HINT:
#line 5988 "DirectoryMonitor.c"
		{
			GFileInfo* _tmp39_;
			GFileInfo* _tmp40_;
			DirectoryMonitorFType _tmp41_ = 0;
			DirectoryMonitorFType ftype;
			DirectoryMonitorFType _tmp42_;
#line 1239 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_tmp39_ = info;
#line 1239 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			g_assert (_tmp39_ != NULL);
#line 1241 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_tmp40_ = info;
#line 1241 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_tmp41_ = directory_monitor_get_ftype (_tmp40_);
#line 1241 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			ftype = _tmp41_;
#line 1242 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_tmp42_ = ftype;
#line 1242 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			switch (_tmp42_) {
#line 1242 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				case DIRECTORY_MONITOR_FTYPE_FILE:
#line 6011 "DirectoryMonitor.c"
				{
					GFile* _tmp43_;
					GFileInfo* _tmp44_;
#line 1244 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					_tmp43_ = file;
#line 1244 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					_tmp44_ = info;
#line 1244 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					directory_monitor_internal_notify_file_alteration_completed (self, _tmp43_, _tmp44_);
#line 1245 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					break;
#line 6023 "DirectoryMonitor.c"
				}
#line 1242 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				case DIRECTORY_MONITOR_FTYPE_DIRECTORY:
#line 6027 "DirectoryMonitor.c"
				{
					GFile* _tmp45_;
					GFileInfo* _tmp46_;
#line 1248 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					_tmp45_ = file;
#line 1248 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					_tmp46_ = info;
#line 1248 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					directory_monitor_internal_notify_directory_alteration_completed (self, _tmp45_, _tmp46_);
#line 1249 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					break;
#line 6039 "DirectoryMonitor.c"
				}
				default:
				{
					DirectoryMonitorFType _tmp47_;
#line 1252 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					_tmp47_ = ftype;
#line 1252 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					g_assert (_tmp47_ == DIRECTORY_MONITOR_FTYPE_UNSUPPORTED);
#line 1253 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					break;
#line 6050 "DirectoryMonitor.c"
				}
			}
#line 1255 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			break;
#line 6055 "DirectoryMonitor.c"
		}
#line 1186 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		case G_FILE_MONITOR_EVENT_MOVED:
#line 6059 "DirectoryMonitor.c"
		{
			GFileInfo* _tmp48_;
			GFile* _tmp49_;
			GFileInfo* _tmp50_;
			DirectoryMonitorFType _tmp51_ = 0;
			DirectoryMonitorFType ftype;
			DirectoryMonitorFType _tmp52_;
#line 1258 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_tmp48_ = info;
#line 1258 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			g_assert (_tmp48_ != NULL);
#line 1259 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_tmp49_ = other_file;
#line 1259 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			g_assert (_tmp49_ != NULL);
#line 1263 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_tmp50_ = info;
#line 1263 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_tmp51_ = directory_monitor_get_ftype (_tmp50_);
#line 1263 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			ftype = _tmp51_;
#line 1264 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_tmp52_ = ftype;
#line 1264 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			switch (_tmp52_) {
#line 1264 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				case DIRECTORY_MONITOR_FTYPE_FILE:
#line 6087 "DirectoryMonitor.c"
				{
					GFile* _tmp53_;
					GFile* _tmp54_;
					GFileInfo* _tmp55_;
#line 1266 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					_tmp53_ = file;
#line 1266 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					_tmp54_ = other_file;
#line 1266 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					_tmp55_ = info;
#line 1266 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					directory_monitor_internal_notify_file_moved (self, _tmp53_, _tmp54_, _tmp55_);
#line 1267 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					break;
#line 6102 "DirectoryMonitor.c"
				}
#line 1264 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				case DIRECTORY_MONITOR_FTYPE_DIRECTORY:
#line 6106 "DirectoryMonitor.c"
				{
					DirectoryMonitorFileInfoMap* _tmp56_;
					GFile* _tmp57_;
					GFileInfo* _tmp58_ = NULL;
					GFileInfo* old_dir_info;
					GFileInfo* _tmp59_;
					GFile* _tmp63_;
					GFileInfo* _tmp64_;
					GFile* _tmp65_;
					GFileInfo* _tmp66_;
#line 1271 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					_tmp56_ = self->priv->files;
#line 1271 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					_tmp57_ = file;
#line 1271 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					_tmp58_ = directory_monitor_file_info_map_get_info (_tmp56_, _tmp57_);
#line 1271 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					old_dir_info = _tmp58_;
#line 1272 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					_tmp59_ = old_dir_info;
#line 1272 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					if (_tmp59_ == NULL) {
#line 6129 "DirectoryMonitor.c"
						GFile* _tmp60_;
						gchar* _tmp61_ = NULL;
						gchar* _tmp62_;
#line 1273 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
						_tmp60_ = file;
#line 1273 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
						_tmp61_ = g_file_get_path (_tmp60_);
#line 1273 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
						_tmp62_ = _tmp61_;
#line 1273 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
						g_warning ("DirectoryMonitor.vala:1273: Directory moved event for unknown file %s", _tmp62_);
#line 1273 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
						_g_free0 (_tmp62_);
#line 1275 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
						_g_object_unref0 (old_dir_info);
#line 1275 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
						break;
#line 6147 "DirectoryMonitor.c"
					}
#line 1278 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					_tmp63_ = file;
#line 1278 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					_tmp64_ = old_dir_info;
#line 1278 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					_tmp65_ = other_file;
#line 1278 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					_tmp66_ = info;
#line 1278 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					directory_monitor_internal_notify_directory_moved (self, _tmp63_, _tmp64_, _tmp65_, _tmp66_);
#line 1279 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					_g_object_unref0 (old_dir_info);
#line 1279 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					break;
#line 6163 "DirectoryMonitor.c"
				}
				default:
				{
					DirectoryMonitorFType _tmp67_;
#line 1282 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					_tmp67_ = ftype;
#line 1282 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					g_assert (_tmp67_ == DIRECTORY_MONITOR_FTYPE_UNSUPPORTED);
#line 1283 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					break;
#line 6174 "DirectoryMonitor.c"
				}
			}
#line 1285 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			break;
#line 6179 "DirectoryMonitor.c"
		}
#line 1186 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		case G_FILE_MONITOR_EVENT_DELETED:
#line 6183 "DirectoryMonitor.c"
		{
			GFileInfo* _tmp68_;
			GFile* _tmp69_;
			GFileInfo* _tmp70_ = NULL;
			GFileInfo* local_info;
			GFileInfo* _tmp71_;
			GFileInfo* _tmp75_;
			DirectoryMonitorFType _tmp76_ = 0;
			DirectoryMonitorFType ftype;
			DirectoryMonitorFType _tmp77_;
#line 1288 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_tmp68_ = info;
#line 1288 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			g_assert (_tmp68_ == NULL);
#line 1290 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_tmp69_ = file;
#line 1290 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_tmp70_ = directory_monitor_get_file_info (self, _tmp69_);
#line 1290 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			local_info = _tmp70_;
#line 1291 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_tmp71_ = local_info;
#line 1291 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			if (_tmp71_ == NULL) {
#line 6208 "DirectoryMonitor.c"
				GFile* _tmp72_;
				gchar* _tmp73_ = NULL;
				gchar* _tmp74_;
#line 1292 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_tmp72_ = file;
#line 1292 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_tmp73_ = g_file_get_path (_tmp72_);
#line 1292 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_tmp74_ = _tmp73_;
#line 1292 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				g_warning ("DirectoryMonitor.vala:1292: Deleted event for unknown file %s", _tmp74_);
#line 1292 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_g_free0 (_tmp74_);
#line 1294 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_g_object_unref0 (local_info);
#line 1294 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				break;
#line 6226 "DirectoryMonitor.c"
			}
#line 1297 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_tmp75_ = local_info;
#line 1297 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_tmp76_ = directory_monitor_get_ftype (_tmp75_);
#line 1297 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			ftype = _tmp76_;
#line 1298 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_tmp77_ = ftype;
#line 1298 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			switch (_tmp77_) {
#line 1298 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				case DIRECTORY_MONITOR_FTYPE_FILE:
#line 6240 "DirectoryMonitor.c"
				{
					GFile* _tmp78_;
#line 1300 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					_tmp78_ = file;
#line 1300 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					directory_monitor_internal_notify_file_deleted (self, _tmp78_);
#line 1301 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					break;
#line 6249 "DirectoryMonitor.c"
				}
#line 1298 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				case DIRECTORY_MONITOR_FTYPE_DIRECTORY:
#line 6253 "DirectoryMonitor.c"
				{
					GFile* _tmp79_;
#line 1304 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					_tmp79_ = file;
#line 1304 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					directory_monitor_internal_notify_directory_deleted (self, _tmp79_);
#line 1305 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					break;
#line 6262 "DirectoryMonitor.c"
				}
				default:
				{
					DirectoryMonitorFType _tmp80_;
#line 1308 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					_tmp80_ = ftype;
#line 1308 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					g_assert (_tmp80_ == DIRECTORY_MONITOR_FTYPE_UNSUPPORTED);
#line 1309 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					break;
#line 6273 "DirectoryMonitor.c"
				}
			}
#line 1311 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_g_object_unref0 (local_info);
#line 1311 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			break;
#line 6280 "DirectoryMonitor.c"
		}
#line 1186 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		case G_FILE_MONITOR_EVENT_ATTRIBUTE_CHANGED:
#line 6284 "DirectoryMonitor.c"
		{
			GFileInfo* _tmp81_;
			GFile* _tmp82_;
			GFileInfo* _tmp83_ = NULL;
			GFileInfo* local_info;
			GFileInfo* _tmp84_;
			GFileInfo* _tmp88_;
			DirectoryMonitorFType _tmp89_ = 0;
			DirectoryMonitorFType ftype;
			DirectoryMonitorFType _tmp90_;
#line 1315 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_tmp81_ = info;
#line 1315 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			g_assert (_tmp81_ == NULL);
#line 1317 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_tmp82_ = file;
#line 1317 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_tmp83_ = directory_monitor_get_file_info (self, _tmp82_);
#line 1317 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			local_info = _tmp83_;
#line 1318 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_tmp84_ = local_info;
#line 1318 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			if (_tmp84_ == NULL) {
#line 6309 "DirectoryMonitor.c"
				GFile* _tmp85_;
				gchar* _tmp86_ = NULL;
				gchar* _tmp87_;
#line 1319 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_tmp85_ = file;
#line 1319 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_tmp86_ = g_file_get_path (_tmp85_);
#line 1319 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_tmp87_ = _tmp86_;
#line 1319 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				g_warning ("DirectoryMonitor.vala:1319: Attribute changed event for unknown file %" \
"s", _tmp87_);
#line 1319 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_g_free0 (_tmp87_);
#line 1321 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_g_object_unref0 (local_info);
#line 1321 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				break;
#line 6327 "DirectoryMonitor.c"
			}
#line 1324 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_tmp88_ = local_info;
#line 1324 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_tmp89_ = directory_monitor_get_ftype (_tmp88_);
#line 1324 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			ftype = _tmp89_;
#line 1325 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_tmp90_ = ftype;
#line 1325 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			switch (_tmp90_) {
#line 1325 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				case DIRECTORY_MONITOR_FTYPE_FILE:
#line 6341 "DirectoryMonitor.c"
				{
					GFile* _tmp91_;
#line 1327 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					_tmp91_ = file;
#line 1327 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					directory_monitor_notify_file_attributes_altered (self, _tmp91_);
#line 1328 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					break;
#line 6350 "DirectoryMonitor.c"
				}
#line 1325 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				case DIRECTORY_MONITOR_FTYPE_DIRECTORY:
#line 6354 "DirectoryMonitor.c"
				{
					GFile* _tmp92_;
#line 1331 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					_tmp92_ = file;
#line 1331 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					directory_monitor_notify_directory_attributes_altered (self, _tmp92_);
#line 1332 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					break;
#line 6363 "DirectoryMonitor.c"
				}
				default:
				{
					DirectoryMonitorFType _tmp93_;
#line 1335 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					_tmp93_ = ftype;
#line 1335 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					g_assert (_tmp93_ == DIRECTORY_MONITOR_FTYPE_UNSUPPORTED);
#line 1336 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					break;
#line 6374 "DirectoryMonitor.c"
				}
			}
#line 1338 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_g_object_unref0 (local_info);
#line 1338 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			break;
#line 6381 "DirectoryMonitor.c"
		}
#line 1186 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		case G_FILE_MONITOR_EVENT_PRE_UNMOUNT:
#line 1186 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		case G_FILE_MONITOR_EVENT_UNMOUNTED:
#line 6387 "DirectoryMonitor.c"
		{
#line 1343 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			break;
#line 6391 "DirectoryMonitor.c"
		}
		default:
		{
			GFileMonitorEvent _tmp94_;
			GEnumValue* _tmp95_;
#line 1346 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_tmp94_ = event;
#line 1346 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_tmp95_ = g_enum_get_value (g_type_class_ref (G_TYPE_FILE_MONITOR_EVENT), _tmp94_);
#line 1346 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			g_warning ("DirectoryMonitor.vala:1346: Unknown directory monitor event %s", (_tmp95_ != NULL) ? _tmp95_->value_name : NULL);
#line 1347 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			break;
#line 6405 "DirectoryMonitor.c"
		}
	}
#line 1179 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_g_free0 (_tmp0_);
#line 6410 "DirectoryMonitor.c"
}


static gboolean directory_monitor_is_file_create_move (DirectoryMonitor* self, GFile* file, GFileInfo* info, GFile** old_file, GFileInfo** old_file_info) {
	GFile* _vala_old_file = NULL;
	GFileInfo* _vala_old_file_info = NULL;
	gboolean result = FALSE;
	DirectoryMonitorFileInfoMap* _tmp0_;
	GFileInfo* _tmp1_;
	GFile* _tmp2_ = NULL;
	GFile* match;
	GFile* _tmp3_;
#line 1353 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_val_if_fail (IS_DIRECTORY_MONITOR (self), FALSE);
#line 1353 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_val_if_fail (G_IS_FILE (file), FALSE);
#line 1353 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_val_if_fail (G_IS_FILE_INFO (info), FALSE);
#line 1356 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp0_ = self->priv->parent_moved;
#line 1356 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp1_ = info;
#line 1356 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp2_ = directory_monitor_file_info_map_find_match (_tmp0_, _tmp1_);
#line 1356 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	match = _tmp2_;
#line 1357 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp3_ = match;
#line 1357 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	if (_tmp3_ != NULL) {
#line 6441 "DirectoryMonitor.c"
		GFile* _tmp4_;
		GFile* _tmp5_;
		DirectoryMonitorFileInfoMap* _tmp6_;
		GFile* _tmp7_;
		GFileInfo* _tmp8_ = NULL;
		DirectoryMonitorFileInfoMap* _tmp9_;
		GFile* _tmp10_;
		GFileInfo* _tmp11_;
#line 1358 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_tmp4_ = match;
#line 1358 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_tmp5_ = _g_object_ref0 (_tmp4_);
#line 1358 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_g_object_unref0 (_vala_old_file);
#line 1358 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_vala_old_file = _tmp5_;
#line 1359 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_tmp6_ = self->priv->parent_moved;
#line 1359 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_tmp7_ = match;
#line 1359 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_tmp8_ = directory_monitor_file_info_map_get_info (_tmp6_, _tmp7_);
#line 1359 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_g_object_unref0 (_vala_old_file_info);
#line 1359 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_vala_old_file_info = _tmp8_;
#line 1361 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_tmp9_ = self->priv->parent_moved;
#line 1361 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_tmp10_ = match;
#line 1361 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_tmp11_ = info;
#line 1361 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		directory_monitor_file_info_map_remove (_tmp9_, _tmp10_, _tmp11_);
#line 1363 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		result = TRUE;
#line 1363 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_g_object_unref0 (match);
#line 1363 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		if (old_file) {
#line 1363 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			*old_file = _vala_old_file;
#line 6484 "DirectoryMonitor.c"
		} else {
#line 1363 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_g_object_unref0 (_vala_old_file);
#line 6488 "DirectoryMonitor.c"
		}
#line 1363 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		if (old_file_info) {
#line 1363 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			*old_file_info = _vala_old_file_info;
#line 6494 "DirectoryMonitor.c"
		} else {
#line 1363 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_g_object_unref0 (_vala_old_file_info);
#line 6498 "DirectoryMonitor.c"
		}
#line 1363 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		return result;
#line 6502 "DirectoryMonitor.c"
	}
#line 1366 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	result = FALSE;
#line 1366 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_g_object_unref0 (match);
#line 1366 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	if (old_file) {
#line 1366 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		*old_file = _vala_old_file;
#line 6512 "DirectoryMonitor.c"
	} else {
#line 1366 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_g_object_unref0 (_vala_old_file);
#line 6516 "DirectoryMonitor.c"
	}
#line 1366 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	if (old_file_info) {
#line 1366 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		*old_file_info = _vala_old_file_info;
#line 6522 "DirectoryMonitor.c"
	} else {
#line 1366 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_g_object_unref0 (_vala_old_file_info);
#line 6526 "DirectoryMonitor.c"
	}
#line 1366 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	return result;
#line 6530 "DirectoryMonitor.c"
}


static gboolean directory_monitor_check_for_expired_delete_events (DirectoryMonitor* self) {
	gboolean result = FALSE;
	gulong _tmp0_ = 0UL;
	gulong expiration;
	gboolean any_deleted;
	gboolean any_expired;
	gboolean _tmp13_;
	gboolean _tmp14_;
#line 1369 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_val_if_fail (IS_DIRECTORY_MONITOR (self), FALSE);
#line 1370 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp0_ = now_ms ();
#line 1370 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	expiration = _tmp0_ - DIRECTORY_MONITOR_DELETED_EXPIRATION_MSEC;
#line 1372 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	any_deleted = FALSE;
#line 1373 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	any_expired = FALSE;
#line 6552 "DirectoryMonitor.c"
	{
		GeeQueue* _tmp1_;
		GeeIterator* _tmp2_ = NULL;
		GeeIterator* _element_it;
#line 1374 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_tmp1_ = self->priv->query_info_queue;
#line 1374 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_tmp2_ = gee_iterable_iterator (GEE_ITERABLE (_tmp1_));
#line 1374 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_element_it = _tmp2_;
#line 1374 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		while (TRUE) {
#line 6565 "DirectoryMonitor.c"
			GeeIterator* _tmp3_;
			gboolean _tmp4_ = FALSE;
			GeeIterator* _tmp5_;
			gpointer _tmp6_ = NULL;
			DirectoryMonitorQueryInfoQueueElement* element;
			DirectoryMonitorQueryInfoQueueElement* _tmp7_;
			GFileMonitorEvent _tmp8_;
			DirectoryMonitorQueryInfoQueueElement* _tmp9_;
			gulong _tmp10_;
			gulong _tmp11_;
			DirectoryMonitorQueryInfoQueueElement* _tmp12_;
#line 1374 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_tmp3_ = _element_it;
#line 1374 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_tmp4_ = gee_iterator_next (_tmp3_);
#line 1374 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			if (!_tmp4_) {
#line 1374 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				break;
#line 6585 "DirectoryMonitor.c"
			}
#line 1374 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_tmp5_ = _element_it;
#line 1374 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_tmp6_ = gee_iterator_get (_tmp5_);
#line 1374 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			element = (DirectoryMonitorQueryInfoQueueElement*) _tmp6_;
#line 1375 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_tmp7_ = element;
#line 1375 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_tmp8_ = _tmp7_->event;
#line 1375 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			if (_tmp8_ != G_FILE_MONITOR_EVENT_DELETED) {
#line 1376 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_directory_monitor_query_info_queue_element_unref0 (element);
#line 1376 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				continue;
#line 6603 "DirectoryMonitor.c"
			}
#line 1378 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			any_deleted = TRUE;
#line 1380 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_tmp9_ = element;
#line 1380 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_tmp10_ = _tmp9_->time_created_msec;
#line 1380 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_tmp11_ = expiration;
#line 1380 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			if (_tmp10_ > _tmp11_) {
#line 1381 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_directory_monitor_query_info_queue_element_unref0 (element);
#line 1381 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				continue;
#line 6619 "DirectoryMonitor.c"
			}
#line 1384 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_tmp12_ = element;
#line 1384 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_tmp12_->completed = TRUE;
#line 1385 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			any_expired = TRUE;
#line 1374 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_directory_monitor_query_info_queue_element_unref0 (element);
#line 6629 "DirectoryMonitor.c"
		}
#line 1374 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_g_object_unref0 (_element_it);
#line 6633 "DirectoryMonitor.c"
	}
#line 1388 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp13_ = any_expired;
#line 1388 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	if (_tmp13_) {
#line 1389 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		directory_monitor_process_query_queue (self, NULL);
#line 6641 "DirectoryMonitor.c"
	}
#line 1391 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp14_ = any_deleted;
#line 1391 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	if (!_tmp14_) {
#line 1392 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		self->priv->delete_timer_id = (guint) 0;
#line 6649 "DirectoryMonitor.c"
	}
#line 1394 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	result = any_deleted;
#line 1394 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	return result;
#line 6655 "DirectoryMonitor.c"
}


GFileInfo* directory_monitor_get_file_info (DirectoryMonitor* self, GFile* file) {
	GFileInfo* result = NULL;
	DirectoryMonitorFileInfoMap* _tmp0_;
	GFile* _tmp1_;
	GFileInfo* _tmp2_ = NULL;
#line 1398 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_val_if_fail (IS_DIRECTORY_MONITOR (self), NULL);
#line 1398 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_val_if_fail (G_IS_FILE (file), NULL);
#line 1399 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp0_ = self->priv->files;
#line 1399 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp1_ = file;
#line 1399 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp2_ = directory_monitor_file_info_map_get_info (_tmp0_, _tmp1_);
#line 1399 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	result = _tmp2_;
#line 1399 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	return result;
#line 6678 "DirectoryMonitor.c"
}


GeeCollection* directory_monitor_get_files (DirectoryMonitor* self) {
	GeeCollection* result = NULL;
	DirectoryMonitorFileInfoMap* _tmp0_;
	GeeCollection* _tmp1_ = NULL;
#line 1404 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_val_if_fail (IS_DIRECTORY_MONITOR (self), NULL);
#line 1405 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp0_ = self->priv->files;
#line 1405 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp1_ = directory_monitor_file_info_map_get_all (_tmp0_);
#line 1405 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	result = _tmp1_;
#line 1405 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	return result;
#line 6696 "DirectoryMonitor.c"
}


GFileInfo* directory_monitor_query_file_info (DirectoryMonitor* self, GFile* file) {
	GFileInfo* result = NULL;
	DirectoryMonitorFileInfoMap* _tmp0_;
	GFile* _tmp1_;
	GCancellable* _tmp2_;
	GFileInfo* _tmp3_ = NULL;
#line 1411 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_val_if_fail (IS_DIRECTORY_MONITOR (self), NULL);
#line 1411 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_val_if_fail (G_IS_FILE (file), NULL);
#line 1412 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp0_ = self->priv->files;
#line 1412 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp1_ = file;
#line 1412 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp2_ = self->priv->cancellable;
#line 1412 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp3_ = directory_monitor_file_info_map_query_info (_tmp0_, _tmp1_, _tmp2_);
#line 1412 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	result = _tmp3_;
#line 1412 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	return result;
#line 6722 "DirectoryMonitor.c"
}


gboolean directory_monitor_is_file_symlink_supported (GFileInfo* info) {
	gboolean result = FALSE;
	GFileInfo* _tmp0_;
	gboolean _tmp1_ = FALSE;
	GFileInfo* _tmp2_;
	DirectoryMonitorFType _tmp3_ = 0;
	DirectoryMonitorFType ftype;
	DirectoryMonitorFType _tmp4_;
#line 1422 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_val_if_fail (G_IS_FILE_INFO (info), FALSE);
#line 1423 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp0_ = info;
#line 1423 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp1_ = g_file_info_get_is_symlink (_tmp0_);
#line 1423 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	if (!_tmp1_) {
#line 1424 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		result = TRUE;
#line 1424 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		return result;
#line 6746 "DirectoryMonitor.c"
	}
#line 1426 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp2_ = info;
#line 1426 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp3_ = directory_monitor_get_ftype (_tmp2_);
#line 1426 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	ftype = _tmp3_;
#line 1427 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp4_ = ftype;
#line 1427 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	switch (_tmp4_) {
#line 1427 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		case DIRECTORY_MONITOR_FTYPE_DIRECTORY:
#line 6760 "DirectoryMonitor.c"
		{
#line 1429 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			result = DIRECTORY_MONITOR_SUPPORT_DIR_SYMLINKS;
#line 1429 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			return result;
#line 6766 "DirectoryMonitor.c"
		}
#line 1427 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		case DIRECTORY_MONITOR_FTYPE_FILE:
#line 6770 "DirectoryMonitor.c"
		{
#line 1432 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			result = DIRECTORY_MONITOR_SUPPORT_FILE_SYMLINKS;
#line 1432 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			return result;
#line 6776 "DirectoryMonitor.c"
		}
		default:
		{
			DirectoryMonitorFType _tmp5_;
#line 1435 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_tmp5_ = ftype;
#line 1435 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			g_assert (_tmp5_ == DIRECTORY_MONITOR_FTYPE_UNSUPPORTED);
#line 1437 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			result = FALSE;
#line 1437 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			return result;
#line 6789 "DirectoryMonitor.c"
		}
	}
}


static void directory_monitor_real_root_moved (DirectoryMonitor* self, GFile* old_root, GFile* new_root, GFileInfo* new_root_info) {
#line 374 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (old_root));
#line 374 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (new_root));
#line 374 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE_INFO (new_root_info));
#line 6802 "DirectoryMonitor.c"
}


static void g_cclosure_user_marshal_VOID__OBJECT_OBJECT_OBJECT (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__OBJECT_OBJECT_OBJECT) (gpointer data1, gpointer arg_1, gpointer arg_2, gpointer arg_3, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_OBJECT_OBJECT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_if_fail (n_param_values == 4);
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		data1 = closure->data;
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		data2 = param_values->data[0].v_pointer;
#line 6821 "DirectoryMonitor.c"
	} else {
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		data1 = param_values->data[0].v_pointer;
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		data2 = closure->data;
#line 6827 "DirectoryMonitor.c"
	}
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	callback = (GMarshalFunc_VOID__OBJECT_OBJECT_OBJECT) (marshal_data ? marshal_data : cc->callback);
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	callback (data1, g_value_get_object (param_values + 1), g_value_get_object (param_values + 2), g_value_get_object (param_values + 3), data2);
#line 6833 "DirectoryMonitor.c"
}


static void directory_monitor_real_root_deleted (DirectoryMonitor* self, GFile* root) {
#line 382 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (root));
#line 6840 "DirectoryMonitor.c"
}


static void directory_monitor_real_discovery_started (DirectoryMonitor* self) {
}


static void directory_monitor_real_file_discovered (DirectoryMonitor* self, GFile* file, GFileInfo* info) {
#line 388 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (file));
#line 388 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE_INFO (info));
#line 6853 "DirectoryMonitor.c"
}


static void g_cclosure_user_marshal_VOID__OBJECT_OBJECT (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__OBJECT_OBJECT) (gpointer data1, gpointer arg_1, gpointer arg_2, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_OBJECT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_if_fail (n_param_values == 3);
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		data1 = closure->data;
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		data2 = param_values->data[0].v_pointer;
#line 6872 "DirectoryMonitor.c"
	} else {
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		data1 = param_values->data[0].v_pointer;
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		data2 = closure->data;
#line 6878 "DirectoryMonitor.c"
	}
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	callback = (GMarshalFunc_VOID__OBJECT_OBJECT) (marshal_data ? marshal_data : cc->callback);
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	callback (data1, g_value_get_object (param_values + 1), g_value_get_object (param_values + 2), data2);
#line 6884 "DirectoryMonitor.c"
}


static void directory_monitor_real_directory_discovered (DirectoryMonitor* self, GFile* file, GFileInfo* info) {
#line 391 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (file));
#line 391 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE_INFO (info));
#line 6893 "DirectoryMonitor.c"
}


static void directory_monitor_real_discovery_failed (DirectoryMonitor* self, const gchar* reason) {
#line 396 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_if_fail (reason != NULL);
#line 6900 "DirectoryMonitor.c"
}


static void directory_monitor_real_discovery_completed (DirectoryMonitor* self) {
#line 400 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	self->priv->has_discovery_started = FALSE;
#line 401 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	directory_monitor_mdbg ("discovery completed");
#line 6909 "DirectoryMonitor.c"
}


static void directory_monitor_real_file_created (DirectoryMonitor* self, GFile* file, GFileInfo* info) {
#line 404 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (file));
#line 404 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE_INFO (info));
#line 6918 "DirectoryMonitor.c"
}


static void directory_monitor_real_file_moved (DirectoryMonitor* self, GFile* old_file, GFile* new_file, GFileInfo* new_file_info) {
#line 407 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (old_file));
#line 407 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (new_file));
#line 407 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE_INFO (new_file_info));
#line 6929 "DirectoryMonitor.c"
}


static void directory_monitor_real_file_altered (DirectoryMonitor* self, GFile* file) {
#line 411 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (file));
#line 6936 "DirectoryMonitor.c"
}


static void directory_monitor_real_file_alteration_completed (DirectoryMonitor* self, GFile* file, GFileInfo* info) {
#line 416 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (file));
#line 416 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE_INFO (info));
#line 6945 "DirectoryMonitor.c"
}


static void directory_monitor_real_file_attributes_altered (DirectoryMonitor* self, GFile* file) {
#line 419 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (file));
#line 6952 "DirectoryMonitor.c"
}


static void directory_monitor_real_file_deleted (DirectoryMonitor* self, GFile* file) {
#line 422 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (file));
#line 6959 "DirectoryMonitor.c"
}


static void directory_monitor_real_directory_created (DirectoryMonitor* self, GFile* dir, GFileInfo* info) {
#line 426 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (dir));
#line 426 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE_INFO (info));
#line 6968 "DirectoryMonitor.c"
}


static void directory_monitor_real_directory_moved (DirectoryMonitor* self, GFile* old_dir, GFile* new_dir, GFileInfo* new_dir_info) {
#line 430 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (old_dir));
#line 430 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (new_dir));
#line 430 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE_INFO (new_dir_info));
#line 6979 "DirectoryMonitor.c"
}


static void directory_monitor_real_directory_altered (DirectoryMonitor* self, GFile* dir) {
#line 434 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (dir));
#line 6986 "DirectoryMonitor.c"
}


static void directory_monitor_real_directory_alteration_completed (DirectoryMonitor* self, GFile* dir, GFileInfo* info) {
#line 439 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (dir));
#line 439 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE_INFO (info));
#line 6995 "DirectoryMonitor.c"
}


static void directory_monitor_real_directory_attributes_altered (DirectoryMonitor* self, GFile* dir) {
#line 442 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (dir));
#line 7002 "DirectoryMonitor.c"
}


static void directory_monitor_real_directory_deleted (DirectoryMonitor* self, GFile* dir) {
#line 446 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (dir));
#line 7009 "DirectoryMonitor.c"
}


static void directory_monitor_real_closed (DirectoryMonitor* self) {
}


static DirectoryMonitorQueryInfoQueueElement* directory_monitor_query_info_queue_element_construct (GType object_type, DirectoryMonitor* owner, GFile* file, GFile* other_file, GFileMonitorEvent event) {
	DirectoryMonitorQueryInfoQueueElement* self = NULL;
	DirectoryMonitor* _tmp0_;
	DirectoryMonitor* _tmp1_;
	GFile* _tmp2_;
	GFile* _tmp3_;
	GFile* _tmp4_;
	GFile* _tmp5_;
	GFileMonitorEvent _tmp6_;
	guint _tmp7_;
	gulong _tmp8_ = 0UL;
#line 96 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_val_if_fail (IS_DIRECTORY_MONITOR (owner), NULL);
#line 96 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_val_if_fail (G_IS_FILE (file), NULL);
#line 96 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_val_if_fail ((other_file == NULL) || G_IS_FILE (other_file), NULL);
#line 96 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	self = (DirectoryMonitorQueryInfoQueueElement*) g_type_create_instance (object_type);
#line 98 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp0_ = owner;
#line 98 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 98 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_g_object_unref0 (self->owner);
#line 98 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	self->owner = _tmp1_;
#line 99 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp2_ = file;
#line 99 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 99 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_g_object_unref0 (self->file);
#line 99 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	self->file = _tmp3_;
#line 100 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp4_ = other_file;
#line 100 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp5_ = _g_object_ref0 (_tmp4_);
#line 100 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_g_object_unref0 (self->other_file);
#line 100 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	self->other_file = _tmp5_;
#line 101 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp6_ = event;
#line 101 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	self->event = _tmp6_;
#line 102 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp7_ = directory_monitor_query_info_queue_element_current;
#line 102 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	directory_monitor_query_info_queue_element_current = _tmp7_ + 1;
#line 102 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	self->position = _tmp7_;
#line 103 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp8_ = now_ms ();
#line 103 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	self->time_created_msec = _tmp8_;
#line 96 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	return self;
#line 7076 "DirectoryMonitor.c"
}


static DirectoryMonitorQueryInfoQueueElement* directory_monitor_query_info_queue_element_new (DirectoryMonitor* owner, GFile* file, GFile* other_file, GFileMonitorEvent event) {
#line 96 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	return directory_monitor_query_info_queue_element_construct (DIRECTORY_MONITOR_TYPE_QUERY_INFO_QUEUE_ELEMENT, owner, file, other_file, event);
#line 7083 "DirectoryMonitor.c"
}


static gpointer _g_error_copy0 (gpointer self) {
#line 113 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	return self ? g_error_copy (self) : NULL;
#line 7090 "DirectoryMonitor.c"
}


static void directory_monitor_query_info_queue_element_on_completed (DirectoryMonitorQueryInfoQueueElement* self, GObject* source, GAsyncResult* aresult) {
	GObject* _tmp0_;
	GFile* _tmp1_;
	GFile* source_file;
	DirectoryMonitor* _tmp7_;
	GError * _inner_error_ = NULL;
#line 106 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_if_fail (DIRECTORY_MONITOR_IS_QUERY_INFO_QUEUE_ELEMENT (self));
#line 106 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_if_fail ((source == NULL) || G_IS_OBJECT (source));
#line 106 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_ASYNC_RESULT (aresult));
#line 107 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp0_ = source;
#line 107 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp1_ = _g_object_ref0 (G_FILE (_tmp0_));
#line 107 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	source_file = _tmp1_;
#line 7112 "DirectoryMonitor.c"
	{
		GAsyncResult* _tmp2_;
		GFileInfo* _tmp3_ = NULL;
		GFileInfo* _tmp4_;
#line 111 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_tmp2_ = aresult;
#line 111 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_tmp3_ = g_file_query_info_finish (source_file, _tmp2_, &_inner_error_);
#line 111 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_tmp4_ = _tmp3_;
#line 111 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		if (_inner_error_ != NULL) {
#line 7125 "DirectoryMonitor.c"
			goto __catch313_g_error;
		}
#line 111 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_g_object_unref0 (self->info);
#line 111 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		self->info = _tmp4_;
#line 7132 "DirectoryMonitor.c"
	}
	goto __finally313;
	__catch313_g_error:
	{
		GError* err = NULL;
		GError* _tmp5_;
		GError* _tmp6_;
#line 110 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		err = _inner_error_;
#line 110 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_inner_error_ = NULL;
#line 113 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_tmp5_ = err;
#line 113 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_tmp6_ = _g_error_copy0 (_tmp5_);
#line 113 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_g_error_free0 (self->err);
#line 113 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		self->err = _tmp6_;
#line 110 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_g_error_free0 (err);
#line 7154 "DirectoryMonitor.c"
	}
	__finally313:
#line 110 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	if (_inner_error_ != NULL) {
#line 110 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_g_object_unref0 (source_file);
#line 110 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 110 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		g_clear_error (&_inner_error_);
#line 110 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		return;
#line 7167 "DirectoryMonitor.c"
	}
#line 117 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	self->completed = TRUE;
#line 120 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp7_ = self->owner;
#line 120 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	directory_monitor_process_query_queue (_tmp7_, self);
#line 106 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_g_object_unref0 (source_file);
#line 7177 "DirectoryMonitor.c"
}


static void directory_monitor_value_query_info_queue_element_init (GValue* value) {
#line 83 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	value->data[0].v_pointer = NULL;
#line 7184 "DirectoryMonitor.c"
}


static void directory_monitor_value_query_info_queue_element_free_value (GValue* value) {
#line 83 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	if (value->data[0].v_pointer) {
#line 83 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		directory_monitor_query_info_queue_element_unref (value->data[0].v_pointer);
#line 7193 "DirectoryMonitor.c"
	}
}


static void directory_monitor_value_query_info_queue_element_copy_value (const GValue* src_value, GValue* dest_value) {
#line 83 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	if (src_value->data[0].v_pointer) {
#line 83 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		dest_value->data[0].v_pointer = directory_monitor_query_info_queue_element_ref (src_value->data[0].v_pointer);
#line 7203 "DirectoryMonitor.c"
	} else {
#line 83 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		dest_value->data[0].v_pointer = NULL;
#line 7207 "DirectoryMonitor.c"
	}
}


static gpointer directory_monitor_value_query_info_queue_element_peek_pointer (const GValue* value) {
#line 83 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	return value->data[0].v_pointer;
#line 7215 "DirectoryMonitor.c"
}


static gchar* directory_monitor_value_query_info_queue_element_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
#line 83 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	if (collect_values[0].v_pointer) {
#line 7222 "DirectoryMonitor.c"
		DirectoryMonitorQueryInfoQueueElement* object;
		object = collect_values[0].v_pointer;
#line 83 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		if (object->parent_instance.g_class == NULL) {
#line 83 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 7229 "DirectoryMonitor.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 83 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 7233 "DirectoryMonitor.c"
		}
#line 83 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		value->data[0].v_pointer = directory_monitor_query_info_queue_element_ref (object);
#line 7237 "DirectoryMonitor.c"
	} else {
#line 83 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		value->data[0].v_pointer = NULL;
#line 7241 "DirectoryMonitor.c"
	}
#line 83 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	return NULL;
#line 7245 "DirectoryMonitor.c"
}


static gchar* directory_monitor_value_query_info_queue_element_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	DirectoryMonitorQueryInfoQueueElement** object_p;
	object_p = collect_values[0].v_pointer;
#line 83 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	if (!object_p) {
#line 83 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 7256 "DirectoryMonitor.c"
	}
#line 83 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	if (!value->data[0].v_pointer) {
#line 83 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		*object_p = NULL;
#line 7262 "DirectoryMonitor.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 83 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		*object_p = value->data[0].v_pointer;
#line 7266 "DirectoryMonitor.c"
	} else {
#line 83 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		*object_p = directory_monitor_query_info_queue_element_ref (value->data[0].v_pointer);
#line 7270 "DirectoryMonitor.c"
	}
#line 83 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	return NULL;
#line 7274 "DirectoryMonitor.c"
}


static GParamSpec* directory_monitor_param_spec_query_info_queue_element (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	DirectoryMonitorParamSpecQueryInfoQueueElement* spec;
#line 83 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_val_if_fail (g_type_is_a (object_type, DIRECTORY_MONITOR_TYPE_QUERY_INFO_QUEUE_ELEMENT), NULL);
#line 83 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 83 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 83 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	return G_PARAM_SPEC (spec);
#line 7288 "DirectoryMonitor.c"
}


static gpointer directory_monitor_value_get_query_info_queue_element (const GValue* value) {
#line 83 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, DIRECTORY_MONITOR_TYPE_QUERY_INFO_QUEUE_ELEMENT), NULL);
#line 83 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	return value->data[0].v_pointer;
#line 7297 "DirectoryMonitor.c"
}


static void directory_monitor_value_set_query_info_queue_element (GValue* value, gpointer v_object) {
	DirectoryMonitorQueryInfoQueueElement* old;
#line 83 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, DIRECTORY_MONITOR_TYPE_QUERY_INFO_QUEUE_ELEMENT));
#line 83 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	old = value->data[0].v_pointer;
#line 83 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	if (v_object) {
#line 83 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, DIRECTORY_MONITOR_TYPE_QUERY_INFO_QUEUE_ELEMENT));
#line 83 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 83 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		value->data[0].v_pointer = v_object;
#line 83 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		directory_monitor_query_info_queue_element_ref (value->data[0].v_pointer);
#line 7317 "DirectoryMonitor.c"
	} else {
#line 83 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		value->data[0].v_pointer = NULL;
#line 7321 "DirectoryMonitor.c"
	}
#line 83 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	if (old) {
#line 83 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		directory_monitor_query_info_queue_element_unref (old);
#line 7327 "DirectoryMonitor.c"
	}
}


static void directory_monitor_value_take_query_info_queue_element (GValue* value, gpointer v_object) {
	DirectoryMonitorQueryInfoQueueElement* old;
#line 83 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, DIRECTORY_MONITOR_TYPE_QUERY_INFO_QUEUE_ELEMENT));
#line 83 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	old = value->data[0].v_pointer;
#line 83 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	if (v_object) {
#line 83 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, DIRECTORY_MONITOR_TYPE_QUERY_INFO_QUEUE_ELEMENT));
#line 83 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 83 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		value->data[0].v_pointer = v_object;
#line 7346 "DirectoryMonitor.c"
	} else {
#line 83 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		value->data[0].v_pointer = NULL;
#line 7350 "DirectoryMonitor.c"
	}
#line 83 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	if (old) {
#line 83 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		directory_monitor_query_info_queue_element_unref (old);
#line 7356 "DirectoryMonitor.c"
	}
}


static void directory_monitor_query_info_queue_element_class_init (DirectoryMonitorQueryInfoQueueElementClass * klass) {
#line 83 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	directory_monitor_query_info_queue_element_parent_class = g_type_class_peek_parent (klass);
#line 83 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	DIRECTORY_MONITOR_QUERY_INFO_QUEUE_ELEMENT_CLASS (klass)->finalize = directory_monitor_query_info_queue_element_finalize;
#line 7366 "DirectoryMonitor.c"
}


static void directory_monitor_query_info_queue_element_instance_init (DirectoryMonitorQueryInfoQueueElement * self) {
#line 92 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	self->info = NULL;
#line 93 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	self->err = NULL;
#line 94 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	self->completed = FALSE;
#line 83 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	self->ref_count = 1;
#line 7379 "DirectoryMonitor.c"
}


static void directory_monitor_query_info_queue_element_finalize (DirectoryMonitorQueryInfoQueueElement* obj) {
	DirectoryMonitorQueryInfoQueueElement * self;
#line 83 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	self = DIRECTORY_MONITOR_QUERY_INFO_QUEUE_ELEMENT (obj);
#line 86 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_g_object_unref0 (self->owner);
#line 87 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_g_object_unref0 (self->file);
#line 88 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_g_object_unref0 (self->other_file);
#line 92 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_g_object_unref0 (self->info);
#line 93 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_g_error_free0 (self->err);
#line 7397 "DirectoryMonitor.c"
}


static GType directory_monitor_query_info_queue_element_get_type (void) {
	static volatile gsize directory_monitor_query_info_queue_element_type_id__volatile = 0;
	if (g_once_init_enter (&directory_monitor_query_info_queue_element_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { directory_monitor_value_query_info_queue_element_init, directory_monitor_value_query_info_queue_element_free_value, directory_monitor_value_query_info_queue_element_copy_value, directory_monitor_value_query_info_queue_element_peek_pointer, "p", directory_monitor_value_query_info_queue_element_collect_value, "p", directory_monitor_value_query_info_queue_element_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (DirectoryMonitorQueryInfoQueueElementClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) directory_monitor_query_info_queue_element_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DirectoryMonitorQueryInfoQueueElement), 0, (GInstanceInitFunc) directory_monitor_query_info_queue_element_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType directory_monitor_query_info_queue_element_type_id;
		directory_monitor_query_info_queue_element_type_id = g_type_register_fundamental (g_type_fundamental_next (), "DirectoryMonitorQueryInfoQueueElement", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&directory_monitor_query_info_queue_element_type_id__volatile, directory_monitor_query_info_queue_element_type_id);
	}
	return directory_monitor_query_info_queue_element_type_id__volatile;
}


static gpointer directory_monitor_query_info_queue_element_ref (gpointer instance) {
	DirectoryMonitorQueryInfoQueueElement* self;
	self = instance;
#line 83 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_atomic_int_inc (&self->ref_count);
#line 83 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	return instance;
#line 7422 "DirectoryMonitor.c"
}


static void directory_monitor_query_info_queue_element_unref (gpointer instance) {
	DirectoryMonitorQueryInfoQueueElement* self;
	self = instance;
#line 83 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 83 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		DIRECTORY_MONITOR_QUERY_INFO_QUEUE_ELEMENT_GET_CLASS (self)->finalize (self);
#line 83 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 7435 "DirectoryMonitor.c"
	}
}


static DirectoryMonitorFileInfoMap* directory_monitor_file_info_map_construct (GType object_type) {
	DirectoryMonitorFileInfoMap* self = NULL;
#line 134 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	self = (DirectoryMonitorFileInfoMap*) g_type_create_instance (object_type);
#line 134 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	return self;
#line 7446 "DirectoryMonitor.c"
}


static DirectoryMonitorFileInfoMap* directory_monitor_file_info_map_new (void) {
#line 134 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	return directory_monitor_file_info_map_construct (DIRECTORY_MONITOR_TYPE_FILE_INFO_MAP);
#line 7453 "DirectoryMonitor.c"
}


static gboolean directory_monitor_file_info_map_normalize_file (DirectoryMonitorFileInfoMap* self, GFile* file, GFileInfo* info, GFile** normalized, gchar** id) {
	GFile* _vala_normalized = NULL;
	gchar* _vala_id = NULL;
	gboolean result = FALSE;
	GFileInfo* _tmp0_;
	GFileInfo* _tmp1_;
	GFileInfo* local_info;
	GFileInfo* _tmp2_;
	GFileInfo* _tmp7_;
	gchar* _tmp8_ = NULL;
	gchar* file_id;
	const gchar* _tmp9_;
	GeeHashMap* _tmp10_;
	const gchar* _tmp11_;
	gpointer _tmp12_ = NULL;
	GFile* known_file;
	const gchar* _tmp13_;
	gchar* _tmp14_;
	GFile* _tmp15_ = NULL;
	GFile* _tmp16_;
	GFile* _tmp19_;
	GFile* _tmp20_;
#line 137 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_val_if_fail (DIRECTORY_MONITOR_IS_FILE_INFO_MAP (self), FALSE);
#line 137 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_val_if_fail (G_IS_FILE (file), FALSE);
#line 137 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_val_if_fail ((info == NULL) || G_IS_FILE_INFO (info), FALSE);
#line 140 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp0_ = info;
#line 140 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 140 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	local_info = _tmp1_;
#line 141 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp2_ = local_info;
#line 141 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	if (_tmp2_ == NULL) {
#line 7495 "DirectoryMonitor.c"
		GeeHashMap* _tmp3_;
		GFile* _tmp4_;
		gpointer _tmp5_ = NULL;
		GFileInfo* _tmp6_;
#line 142 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_tmp3_ = self->priv->map;
#line 142 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_tmp4_ = file;
#line 142 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_tmp5_ = gee_abstract_map_get (GEE_ABSTRACT_MAP (_tmp3_), _tmp4_);
#line 142 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_g_object_unref0 (local_info);
#line 142 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		local_info = (GFileInfo*) _tmp5_;
#line 143 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_tmp6_ = local_info;
#line 143 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		if (_tmp6_ == NULL) {
#line 144 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			result = FALSE;
#line 144 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_g_object_unref0 (local_info);
#line 144 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			if (normalized) {
#line 144 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				*normalized = _vala_normalized;
#line 7522 "DirectoryMonitor.c"
			} else {
#line 144 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_g_object_unref0 (_vala_normalized);
#line 7526 "DirectoryMonitor.c"
			}
#line 144 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			if (id) {
#line 144 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				*id = _vala_id;
#line 7532 "DirectoryMonitor.c"
			} else {
#line 144 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_g_free0 (_vala_id);
#line 7536 "DirectoryMonitor.c"
			}
#line 144 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			return result;
#line 7540 "DirectoryMonitor.c"
		}
	}
#line 147 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp7_ = local_info;
#line 147 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp8_ = get_file_info_id (_tmp7_);
#line 147 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	file_id = _tmp8_;
#line 148 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp9_ = file_id;
#line 148 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	if (_tmp9_ == NULL) {
#line 149 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		result = FALSE;
#line 149 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_g_free0 (file_id);
#line 149 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_g_object_unref0 (local_info);
#line 149 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		if (normalized) {
#line 149 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			*normalized = _vala_normalized;
#line 7563 "DirectoryMonitor.c"
		} else {
#line 149 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_g_object_unref0 (_vala_normalized);
#line 7567 "DirectoryMonitor.c"
		}
#line 149 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		if (id) {
#line 149 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			*id = _vala_id;
#line 7573 "DirectoryMonitor.c"
		} else {
#line 149 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_g_free0 (_vala_id);
#line 7577 "DirectoryMonitor.c"
		}
#line 149 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		return result;
#line 7581 "DirectoryMonitor.c"
	}
#line 151 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp10_ = self->priv->id_map;
#line 151 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp11_ = file_id;
#line 151 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp12_ = gee_abstract_map_get (GEE_ABSTRACT_MAP (_tmp10_), _tmp11_);
#line 151 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	known_file = (GFile*) _tmp12_;
#line 153 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp13_ = file_id;
#line 153 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp14_ = g_strdup ((const gchar*) _tmp13_);
#line 153 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_g_free0 (_vala_id);
#line 153 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_vala_id = _tmp14_;
#line 154 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp16_ = known_file;
#line 154 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	if (_tmp16_ != NULL) {
#line 7603 "DirectoryMonitor.c"
		GFile* _tmp17_;
#line 154 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_tmp17_ = known_file;
#line 154 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_tmp15_ = _tmp17_;
#line 7609 "DirectoryMonitor.c"
	} else {
		GFile* _tmp18_;
#line 154 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_tmp18_ = file;
#line 154 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_tmp15_ = _tmp18_;
#line 7616 "DirectoryMonitor.c"
	}
#line 154 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp19_ = _tmp15_;
#line 154 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp20_ = _g_object_ref0 (_tmp19_);
#line 154 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_g_object_unref0 (_vala_normalized);
#line 154 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_vala_normalized = _tmp20_;
#line 156 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	result = TRUE;
#line 156 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_g_object_unref0 (known_file);
#line 156 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_g_free0 (file_id);
#line 156 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_g_object_unref0 (local_info);
#line 156 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	if (normalized) {
#line 156 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		*normalized = _vala_normalized;
#line 7638 "DirectoryMonitor.c"
	} else {
#line 156 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_g_object_unref0 (_vala_normalized);
#line 7642 "DirectoryMonitor.c"
	}
#line 156 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	if (id) {
#line 156 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		*id = _vala_id;
#line 7648 "DirectoryMonitor.c"
	} else {
#line 156 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_g_free0 (_vala_id);
#line 7652 "DirectoryMonitor.c"
	}
#line 156 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	return result;
#line 7656 "DirectoryMonitor.c"
}


static gboolean directory_monitor_file_info_map_update (DirectoryMonitorFileInfoMap* self, GFile* file, GFileInfo* info) {
	gboolean result = FALSE;
	GeeHashMap* _tmp0_;
	GFile* _tmp1_;
	gboolean _tmp2_ = FALSE;
	GFileInfo* _tmp7_;
	gchar* _tmp8_ = NULL;
	gchar* existing_id;
	gboolean _tmp9_ = FALSE;
	const gchar* _tmp10_;
	gboolean _tmp14_;
	gchar* id = NULL;
	GFile* normalized = NULL;
	GFile* _tmp19_;
	GFileInfo* _tmp20_;
	GFile* _tmp21_ = NULL;
	gchar* _tmp22_ = NULL;
	gboolean _tmp23_ = FALSE;
	GeeHashMap* _tmp24_;
	GFile* _tmp25_;
	GFileInfo* _tmp26_;
	GeeHashMap* _tmp27_;
	const gchar* _tmp28_;
	GFile* _tmp29_;
#line 159 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_val_if_fail (DIRECTORY_MONITOR_IS_FILE_INFO_MAP (self), FALSE);
#line 159 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_val_if_fail (G_IS_FILE (file), FALSE);
#line 159 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_val_if_fail (G_IS_FILE_INFO (info), FALSE);
#line 161 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp0_ = self->priv->map;
#line 161 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp1_ = file;
#line 161 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp2_ = gee_abstract_map_has_key (GEE_ABSTRACT_MAP (_tmp0_), _tmp1_);
#line 161 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	if (_tmp2_) {
#line 7698 "DirectoryMonitor.c"
		GeeHashMap* _tmp3_;
		GFile* _tmp4_;
		gboolean _tmp5_ = FALSE;
		gboolean removed;
		gboolean _tmp6_;
#line 162 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_tmp3_ = self->priv->map;
#line 162 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_tmp4_ = file;
#line 162 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_tmp5_ = gee_abstract_map_unset (GEE_ABSTRACT_MAP (_tmp3_), _tmp4_, NULL);
#line 162 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		removed = _tmp5_;
#line 163 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_tmp6_ = removed;
#line 163 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		g_assert (_tmp6_);
#line 7716 "DirectoryMonitor.c"
	}
#line 167 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp7_ = info;
#line 167 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp8_ = get_file_info_id (_tmp7_);
#line 167 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	existing_id = _tmp8_;
#line 168 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp10_ = existing_id;
#line 168 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	if (_tmp10_ != NULL) {
#line 7728 "DirectoryMonitor.c"
		GeeHashMap* _tmp11_;
		const gchar* _tmp12_;
		gboolean _tmp13_ = FALSE;
#line 168 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_tmp11_ = self->priv->id_map;
#line 168 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_tmp12_ = existing_id;
#line 168 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_tmp13_ = gee_abstract_map_has_key (GEE_ABSTRACT_MAP (_tmp11_), _tmp12_);
#line 168 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_tmp9_ = _tmp13_;
#line 7740 "DirectoryMonitor.c"
	} else {
#line 168 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_tmp9_ = FALSE;
#line 7744 "DirectoryMonitor.c"
	}
#line 168 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp14_ = _tmp9_;
#line 168 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	if (_tmp14_) {
#line 7750 "DirectoryMonitor.c"
		GeeHashMap* _tmp15_;
		const gchar* _tmp16_;
		gboolean _tmp17_ = FALSE;
		gboolean removed;
		gboolean _tmp18_;
#line 169 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_tmp15_ = self->priv->id_map;
#line 169 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_tmp16_ = existing_id;
#line 169 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_tmp17_ = gee_abstract_map_unset (GEE_ABSTRACT_MAP (_tmp15_), _tmp16_, NULL);
#line 169 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		removed = _tmp17_;
#line 170 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_tmp18_ = removed;
#line 170 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		g_assert (_tmp18_);
#line 7768 "DirectoryMonitor.c"
	}
#line 175 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp19_ = file;
#line 175 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp20_ = info;
#line 175 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp23_ = directory_monitor_file_info_map_normalize_file (self, _tmp19_, _tmp20_, &_tmp21_, &_tmp22_);
#line 175 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_g_object_unref0 (normalized);
#line 175 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	normalized = _tmp21_;
#line 175 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_g_free0 (id);
#line 175 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	id = _tmp22_;
#line 175 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	if (!_tmp23_) {
#line 176 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		result = FALSE;
#line 176 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_g_object_unref0 (normalized);
#line 176 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_g_free0 (id);
#line 176 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_g_free0 (existing_id);
#line 176 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		return result;
#line 7796 "DirectoryMonitor.c"
	}
#line 178 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp24_ = self->priv->map;
#line 178 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp25_ = normalized;
#line 178 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp26_ = info;
#line 178 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	gee_abstract_map_set (GEE_ABSTRACT_MAP (_tmp24_), _tmp25_, _tmp26_);
#line 179 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp27_ = self->priv->id_map;
#line 179 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp28_ = id;
#line 179 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp29_ = normalized;
#line 179 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	gee_abstract_map_set (GEE_ABSTRACT_MAP (_tmp27_), _tmp28_, _tmp29_);
#line 181 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	result = TRUE;
#line 181 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_g_object_unref0 (normalized);
#line 181 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_g_free0 (id);
#line 181 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_g_free0 (existing_id);
#line 181 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	return result;
#line 7824 "DirectoryMonitor.c"
}


static gboolean directory_monitor_file_info_map_remove (DirectoryMonitorFileInfoMap* self, GFile* file, GFileInfo* info) {
	gboolean result = FALSE;
	gchar* id = NULL;
	GFile* normalized = NULL;
	GFile* _tmp0_;
	GFileInfo* _tmp1_;
	GFile* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	gboolean _tmp4_ = FALSE;
	GeeHashMap* _tmp5_;
	GFile* _tmp6_;
	GeeHashMap* _tmp7_;
	const gchar* _tmp8_;
#line 184 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_val_if_fail (DIRECTORY_MONITOR_IS_FILE_INFO_MAP (self), FALSE);
#line 184 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_val_if_fail (G_IS_FILE (file), FALSE);
#line 184 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_val_if_fail ((info == NULL) || G_IS_FILE_INFO (info), FALSE);
#line 187 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp0_ = file;
#line 187 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp1_ = info;
#line 187 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp4_ = directory_monitor_file_info_map_normalize_file (self, _tmp0_, _tmp1_, &_tmp2_, &_tmp3_);
#line 187 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_g_object_unref0 (normalized);
#line 187 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	normalized = _tmp2_;
#line 187 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_g_free0 (id);
#line 187 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	id = _tmp3_;
#line 187 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	if (!_tmp4_) {
#line 188 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		result = FALSE;
#line 188 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_g_object_unref0 (normalized);
#line 188 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_g_free0 (id);
#line 188 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		return result;
#line 7871 "DirectoryMonitor.c"
	}
#line 190 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp5_ = self->priv->map;
#line 190 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp6_ = normalized;
#line 190 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	gee_abstract_map_unset (GEE_ABSTRACT_MAP (_tmp5_), _tmp6_, NULL);
#line 191 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp7_ = self->priv->id_map;
#line 191 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp8_ = id;
#line 191 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	gee_abstract_map_unset (GEE_ABSTRACT_MAP (_tmp7_), _tmp8_, NULL);
#line 193 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	result = TRUE;
#line 193 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_g_object_unref0 (normalized);
#line 193 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_g_free0 (id);
#line 193 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	return result;
#line 7893 "DirectoryMonitor.c"
}


static void directory_monitor_file_info_map_remove_all (DirectoryMonitorFileInfoMap* self, GeeCollection* files) {
#line 198 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_if_fail (DIRECTORY_MONITOR_IS_FILE_INFO_MAP (self));
#line 198 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_if_fail (GEE_IS_COLLECTION (files));
#line 7902 "DirectoryMonitor.c"
	{
		GeeCollection* _tmp0_;
		GeeIterator* _tmp1_ = NULL;
		GeeIterator* _file_it;
#line 199 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_tmp0_ = files;
#line 199 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_tmp1_ = gee_iterable_iterator (GEE_ITERABLE (_tmp0_));
#line 199 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_file_it = _tmp1_;
#line 199 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		while (TRUE) {
#line 7915 "DirectoryMonitor.c"
			GeeIterator* _tmp2_;
			gboolean _tmp3_ = FALSE;
			GeeIterator* _tmp4_;
			gpointer _tmp5_ = NULL;
			GFile* file;
			GFile* _tmp6_;
#line 199 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_tmp2_ = _file_it;
#line 199 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_tmp3_ = gee_iterator_next (_tmp2_);
#line 199 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			if (!_tmp3_) {
#line 199 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				break;
#line 7930 "DirectoryMonitor.c"
			}
#line 199 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_tmp4_ = _file_it;
#line 199 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_tmp5_ = gee_iterator_get (_tmp4_);
#line 199 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			file = (GFile*) _tmp5_;
#line 200 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_tmp6_ = file;
#line 200 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			directory_monitor_file_info_map_remove (self, _tmp6_, NULL);
#line 199 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_g_object_unref0 (file);
#line 7944 "DirectoryMonitor.c"
		}
#line 199 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_g_object_unref0 (_file_it);
#line 7948 "DirectoryMonitor.c"
	}
}


static gboolean directory_monitor_file_info_map_contains (DirectoryMonitorFileInfoMap* self, GFile* file, GFileInfo* info) {
	gboolean result = FALSE;
	gchar* id = NULL;
	GFile* normalized = NULL;
	GFile* _tmp0_;
	GFileInfo* _tmp1_;
	GFile* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	gboolean _tmp4_ = FALSE;
	GeeHashMap* _tmp5_;
	const gchar* _tmp6_;
	gboolean _tmp7_ = FALSE;
#line 203 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_val_if_fail (DIRECTORY_MONITOR_IS_FILE_INFO_MAP (self), FALSE);
#line 203 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_val_if_fail (G_IS_FILE (file), FALSE);
#line 203 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_val_if_fail ((info == NULL) || G_IS_FILE_INFO (info), FALSE);
#line 206 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp0_ = file;
#line 206 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp1_ = info;
#line 206 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp4_ = directory_monitor_file_info_map_normalize_file (self, _tmp0_, _tmp1_, &_tmp2_, &_tmp3_);
#line 206 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_g_object_unref0 (normalized);
#line 206 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	normalized = _tmp2_;
#line 206 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_g_free0 (id);
#line 206 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	id = _tmp3_;
#line 206 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	if (!_tmp4_) {
#line 207 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		result = FALSE;
#line 207 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_g_object_unref0 (normalized);
#line 207 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_g_free0 (id);
#line 207 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		return result;
#line 7995 "DirectoryMonitor.c"
	}
#line 209 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp5_ = self->priv->id_map;
#line 209 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp6_ = id;
#line 209 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp7_ = gee_abstract_map_has_key (GEE_ABSTRACT_MAP (_tmp5_), _tmp6_);
#line 209 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	result = _tmp7_;
#line 209 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_g_object_unref0 (normalized);
#line 209 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_g_free0 (id);
#line 209 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	return result;
#line 8011 "DirectoryMonitor.c"
}


static gchar* directory_monitor_file_info_map_get_id (DirectoryMonitorFileInfoMap* self, GFile* file, GFileInfo* info) {
	gchar* result = NULL;
	GFileInfo* _tmp0_;
	gchar* id = NULL;
	GFile* normalized = NULL;
	GFile* _tmp3_;
	GFile* _tmp4_ = NULL;
	gchar* _tmp5_ = NULL;
	gboolean _tmp6_ = FALSE;
#line 212 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_val_if_fail (DIRECTORY_MONITOR_IS_FILE_INFO_MAP (self), NULL);
#line 212 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_val_if_fail (G_IS_FILE (file), NULL);
#line 212 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_val_if_fail ((info == NULL) || G_IS_FILE_INFO (info), NULL);
#line 214 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp0_ = info;
#line 214 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	if (_tmp0_ != NULL) {
#line 8034 "DirectoryMonitor.c"
		GFileInfo* _tmp1_;
		gchar* _tmp2_ = NULL;
#line 215 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_tmp1_ = info;
#line 215 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_tmp2_ = get_file_info_id (_tmp1_);
#line 215 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		result = _tmp2_;
#line 215 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		return result;
#line 8045 "DirectoryMonitor.c"
	}
#line 219 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp3_ = file;
#line 219 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp6_ = directory_monitor_file_info_map_normalize_file (self, _tmp3_, NULL, &_tmp4_, &_tmp5_);
#line 219 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_g_object_unref0 (normalized);
#line 219 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	normalized = _tmp4_;
#line 219 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_g_free0 (id);
#line 219 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	id = _tmp5_;
#line 219 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	if (!_tmp6_) {
#line 220 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		result = NULL;
#line 220 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_g_object_unref0 (normalized);
#line 220 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_g_free0 (id);
#line 220 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		return result;
#line 8069 "DirectoryMonitor.c"
	}
#line 222 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	result = id;
#line 222 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_g_object_unref0 (normalized);
#line 222 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	return result;
#line 8077 "DirectoryMonitor.c"
}


static GeeCollection* directory_monitor_file_info_map_get_all (DirectoryMonitorFileInfoMap* self) {
	GeeCollection* result = NULL;
	GeeHashMap* _tmp0_;
	GeeSet* _tmp1_;
	GeeSet* _tmp2_;
#line 225 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_val_if_fail (DIRECTORY_MONITOR_IS_FILE_INFO_MAP (self), NULL);
#line 226 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp0_ = self->priv->map;
#line 226 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp1_ = gee_abstract_map_get_keys (GEE_MAP (_tmp0_));
#line 226 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp2_ = _tmp1_;
#line 226 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	result = GEE_COLLECTION (_tmp2_);
#line 226 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	return result;
#line 8098 "DirectoryMonitor.c"
}


static GFileInfo* directory_monitor_file_info_map_get_info (DirectoryMonitorFileInfoMap* self, GFile* file) {
	GFileInfo* result = NULL;
	GeeHashMap* _tmp0_;
	GFile* _tmp1_;
	gpointer _tmp2_ = NULL;
	GFileInfo* info;
	GFileInfo* _tmp3_;
	gchar* id = NULL;
	GFile* normalized = NULL;
	GFile* _tmp4_;
	GFile* _tmp5_ = NULL;
	gchar* _tmp6_ = NULL;
	gboolean _tmp7_ = FALSE;
	GeeHashMap* _tmp8_;
	GFile* _tmp9_;
	gpointer _tmp10_ = NULL;
#line 229 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_val_if_fail (DIRECTORY_MONITOR_IS_FILE_INFO_MAP (self), NULL);
#line 229 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_val_if_fail (G_IS_FILE (file), NULL);
#line 231 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp0_ = self->priv->map;
#line 231 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp1_ = file;
#line 231 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp2_ = gee_abstract_map_get (GEE_ABSTRACT_MAP (_tmp0_), _tmp1_);
#line 231 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	info = (GFileInfo*) _tmp2_;
#line 232 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp3_ = info;
#line 232 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	if (_tmp3_ != NULL) {
#line 233 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		result = info;
#line 233 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		return result;
#line 8138 "DirectoryMonitor.c"
	}
#line 237 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp4_ = file;
#line 237 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp7_ = directory_monitor_file_info_map_normalize_file (self, _tmp4_, NULL, &_tmp5_, &_tmp6_);
#line 237 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_g_object_unref0 (normalized);
#line 237 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	normalized = _tmp5_;
#line 237 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_g_free0 (id);
#line 237 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	id = _tmp6_;
#line 237 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	if (!_tmp7_) {
#line 238 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		result = NULL;
#line 238 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_g_object_unref0 (normalized);
#line 238 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_g_free0 (id);
#line 238 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_g_object_unref0 (info);
#line 238 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		return result;
#line 8164 "DirectoryMonitor.c"
	}
#line 240 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp8_ = self->priv->map;
#line 240 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp9_ = normalized;
#line 240 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp10_ = gee_abstract_map_get (GEE_ABSTRACT_MAP (_tmp8_), _tmp9_);
#line 240 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	result = (GFileInfo*) _tmp10_;
#line 240 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_g_object_unref0 (normalized);
#line 240 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_g_free0 (id);
#line 240 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_g_object_unref0 (info);
#line 240 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	return result;
#line 8182 "DirectoryMonitor.c"
}


static GFileInfo* directory_monitor_file_info_map_query_info (DirectoryMonitorFileInfoMap* self, GFile* file, GCancellable* cancellable) {
	GFileInfo* result = NULL;
	GFile* _tmp0_;
	GFileInfo* _tmp1_ = NULL;
	GFileInfo* info;
	GFileInfo* _tmp2_;
	GFileInfo* _tmp12_;
	gboolean _tmp13_ = FALSE;
	GFileInfo* _tmp14_;
	const gchar* _tmp15_ = NULL;
	gchar* _tmp16_;
	gchar* id;
	const gchar* _tmp17_;
	GeeHashMap* _tmp18_;
	const gchar* _tmp19_;
	gpointer _tmp20_ = NULL;
	GFile* normalized;
	GFile* _tmp21_;
	GeeHashMap* _tmp22_;
	GFile* _tmp23_;
	gpointer _tmp24_ = NULL;
	GError * _inner_error_ = NULL;
#line 243 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_val_if_fail (DIRECTORY_MONITOR_IS_FILE_INFO_MAP (self), NULL);
#line 243 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_val_if_fail (G_IS_FILE (file), NULL);
#line 243 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_val_if_fail ((cancellable == NULL) || G_IS_CANCELLABLE (cancellable), NULL);
#line 244 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp0_ = file;
#line 244 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp1_ = directory_monitor_file_info_map_get_info (self, _tmp0_);
#line 244 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	info = _tmp1_;
#line 245 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp2_ = info;
#line 245 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	if (_tmp2_ != NULL) {
#line 246 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		result = info;
#line 246 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		return result;
#line 8228 "DirectoryMonitor.c"
	}
	{
		GFile* _tmp3_;
		GCancellable* _tmp4_;
		GFileInfo* _tmp5_ = NULL;
		GFileInfo* _tmp6_;
#line 251 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_tmp3_ = file;
#line 251 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_tmp4_ = cancellable;
#line 251 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_tmp5_ = g_file_query_info (_tmp3_, G_FILE_ATTRIBUTE_ID_FILE, DIRECTORY_MONITOR_UNKNOWN_INFO_FLAGS, _tmp4_, &_inner_error_);
#line 251 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_tmp6_ = _tmp5_;
#line 251 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		if (_inner_error_ != NULL) {
#line 8245 "DirectoryMonitor.c"
			goto __catch314_g_error;
		}
#line 251 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_g_object_unref0 (info);
#line 251 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		info = _tmp6_;
#line 8252 "DirectoryMonitor.c"
	}
	goto __finally314;
	__catch314_g_error:
	{
		GError* err = NULL;
		GFile* _tmp7_;
		gchar* _tmp8_ = NULL;
		gchar* _tmp9_;
		GError* _tmp10_;
		const gchar* _tmp11_;
#line 250 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		err = _inner_error_;
#line 250 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_inner_error_ = NULL;
#line 253 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_tmp7_ = file;
#line 253 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_tmp8_ = g_file_get_path (_tmp7_);
#line 253 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_tmp9_ = _tmp8_;
#line 253 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_tmp10_ = err;
#line 253 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_tmp11_ = _tmp10_->message;
#line 253 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		g_warning ("DirectoryMonitor.vala:253: Unable to query file ID of %s: %s", _tmp9_, _tmp11_);
#line 253 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_g_free0 (_tmp9_);
#line 255 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		result = NULL;
#line 255 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_g_error_free0 (err);
#line 255 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_g_object_unref0 (info);
#line 255 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		return result;
#line 8289 "DirectoryMonitor.c"
	}
	__finally314:
#line 250 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	if (_inner_error_ != NULL) {
#line 250 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_g_object_unref0 (info);
#line 250 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 250 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		g_clear_error (&_inner_error_);
#line 250 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		return NULL;
#line 8302 "DirectoryMonitor.c"
	}
#line 258 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp12_ = info;
#line 258 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp13_ = directory_monitor_is_file_symlink_supported (_tmp12_);
#line 258 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	if (!_tmp13_) {
#line 259 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		result = NULL;
#line 259 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_g_object_unref0 (info);
#line 259 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		return result;
#line 8316 "DirectoryMonitor.c"
	}
#line 261 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp14_ = info;
#line 261 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp15_ = g_file_info_get_attribute_string (_tmp14_, G_FILE_ATTRIBUTE_ID_FILE);
#line 261 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp16_ = g_strdup (_tmp15_);
#line 261 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	id = _tmp16_;
#line 262 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp17_ = id;
#line 262 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	if (_tmp17_ == NULL) {
#line 263 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		result = NULL;
#line 263 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_g_free0 (id);
#line 263 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_g_object_unref0 (info);
#line 263 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		return result;
#line 8338 "DirectoryMonitor.c"
	}
#line 265 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp18_ = self->priv->id_map;
#line 265 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp19_ = id;
#line 265 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp20_ = gee_abstract_map_get (GEE_ABSTRACT_MAP (_tmp18_), _tmp19_);
#line 265 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	normalized = (GFile*) _tmp20_;
#line 266 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp21_ = normalized;
#line 266 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	if (_tmp21_ == NULL) {
#line 267 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		result = NULL;
#line 267 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_g_object_unref0 (normalized);
#line 267 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_g_free0 (id);
#line 267 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_g_object_unref0 (info);
#line 267 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		return result;
#line 8362 "DirectoryMonitor.c"
	}
#line 269 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp22_ = self->priv->map;
#line 269 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp23_ = file;
#line 269 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp24_ = gee_abstract_map_get (GEE_ABSTRACT_MAP (_tmp22_), _tmp23_);
#line 269 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	result = (GFileInfo*) _tmp24_;
#line 269 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_g_object_unref0 (normalized);
#line 269 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_g_free0 (id);
#line 269 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_g_object_unref0 (info);
#line 269 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	return result;
#line 8380 "DirectoryMonitor.c"
}


static GFile* directory_monitor_file_info_map_find_match (DirectoryMonitorFileInfoMap* self, GFileInfo* match) {
	GFile* result = NULL;
	GFileInfo* _tmp0_;
	gchar* _tmp1_ = NULL;
	gchar* match_id;
	const gchar* _tmp2_;
	GFileInfo* _tmp3_;
	gint64 _tmp4_ = 0LL;
	gint64 match_size;
	GTimeVal match_time = {0};
	GFileInfo* _tmp5_;
	GTimeVal _tmp6_ = {0};
#line 272 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_val_if_fail (DIRECTORY_MONITOR_IS_FILE_INFO_MAP (self), NULL);
#line 272 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_val_if_fail (G_IS_FILE_INFO (match), NULL);
#line 273 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp0_ = match;
#line 273 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp1_ = get_file_info_id (_tmp0_);
#line 273 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	match_id = _tmp1_;
#line 274 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp2_ = match_id;
#line 274 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	if (_tmp2_ == NULL) {
#line 275 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		result = NULL;
#line 275 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_g_free0 (match_id);
#line 275 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		return result;
#line 8416 "DirectoryMonitor.c"
	}
#line 278 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp3_ = match;
#line 278 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp4_ = g_file_info_get_size (_tmp3_);
#line 278 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	match_size = _tmp4_;
#line 280 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp5_ = match;
#line 280 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_file_info_get_modification_time (_tmp5_, &_tmp6_);
#line 280 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	match_time = _tmp6_;
#line 8430 "DirectoryMonitor.c"
	{
		GeeHashMap* _tmp7_;
		GeeSet* _tmp8_;
		GeeSet* _tmp9_;
		GeeSet* _tmp10_;
		GeeIterator* _tmp11_ = NULL;
		GeeIterator* _tmp12_;
		GeeIterator* _file_it;
#line 282 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_tmp7_ = self->priv->map;
#line 282 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_tmp8_ = gee_abstract_map_get_keys (GEE_MAP (_tmp7_));
#line 282 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_tmp9_ = _tmp8_;
#line 282 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_tmp10_ = _tmp9_;
#line 282 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_tmp11_ = gee_iterable_iterator (GEE_ITERABLE (_tmp10_));
#line 282 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_tmp12_ = _tmp11_;
#line 282 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_g_object_unref0 (_tmp10_);
#line 282 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_file_it = _tmp12_;
#line 282 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		while (TRUE) {
#line 8457 "DirectoryMonitor.c"
			GeeIterator* _tmp13_;
			gboolean _tmp14_ = FALSE;
			GeeIterator* _tmp15_;
			gpointer _tmp16_ = NULL;
			GFile* file;
			GeeHashMap* _tmp17_;
			GFile* _tmp18_;
			gpointer _tmp19_ = NULL;
			GFileInfo* info;
			GFileInfo* _tmp20_;
			gchar* _tmp21_ = NULL;
			gchar* _tmp22_;
			const gchar* _tmp23_;
			gboolean _tmp24_;
			gint64 _tmp25_;
			GFileInfo* _tmp26_;
			gint64 _tmp27_ = 0LL;
			GTimeVal time = {0};
			GFileInfo* _tmp28_;
			GTimeVal _tmp29_ = {0};
			GTimeVal _tmp30_;
			glong _tmp31_;
			GTimeVal _tmp32_;
			glong _tmp33_;
#line 282 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_tmp13_ = _file_it;
#line 282 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_tmp14_ = gee_iterator_next (_tmp13_);
#line 282 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			if (!_tmp14_) {
#line 282 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				break;
#line 8490 "DirectoryMonitor.c"
			}
#line 282 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_tmp15_ = _file_it;
#line 282 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_tmp16_ = gee_iterator_get (_tmp15_);
#line 282 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			file = (GFile*) _tmp16_;
#line 283 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_tmp17_ = self->priv->map;
#line 283 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_tmp18_ = file;
#line 283 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_tmp19_ = gee_abstract_map_get (GEE_ABSTRACT_MAP (_tmp17_), _tmp18_);
#line 283 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			info = (GFileInfo*) _tmp19_;
#line 286 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_tmp20_ = info;
#line 286 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_tmp21_ = get_file_info_id (_tmp20_);
#line 286 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_tmp22_ = _tmp21_;
#line 286 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_tmp23_ = match_id;
#line 286 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_tmp24_ = g_strcmp0 (_tmp22_, _tmp23_) == 0;
#line 286 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_g_free0 (_tmp22_);
#line 286 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			if (_tmp24_) {
#line 287 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				result = file;
#line 287 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_g_object_unref0 (info);
#line 287 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_g_object_unref0 (_file_it);
#line 287 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_g_free0 (match_id);
#line 287 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				return result;
#line 8530 "DirectoryMonitor.c"
			}
#line 290 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_tmp25_ = match_size;
#line 290 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_tmp26_ = info;
#line 290 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_tmp27_ = g_file_info_get_size (_tmp26_);
#line 290 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			if (_tmp25_ != _tmp27_) {
#line 291 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_g_object_unref0 (info);
#line 291 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_g_object_unref0 (file);
#line 291 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				continue;
#line 8546 "DirectoryMonitor.c"
			}
#line 294 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_tmp28_ = info;
#line 294 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			g_file_info_get_modification_time (_tmp28_, &_tmp29_);
#line 294 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			time = _tmp29_;
#line 296 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_tmp30_ = time;
#line 296 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_tmp31_ = _tmp30_.tv_sec;
#line 296 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_tmp32_ = match_time;
#line 296 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_tmp33_ = _tmp32_.tv_sec;
#line 296 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			if (_tmp31_ != _tmp33_) {
#line 297 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_g_object_unref0 (info);
#line 297 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_g_object_unref0 (file);
#line 297 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				continue;
#line 8570 "DirectoryMonitor.c"
			}
#line 299 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			result = file;
#line 299 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_g_object_unref0 (info);
#line 299 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_g_object_unref0 (_file_it);
#line 299 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_g_free0 (match_id);
#line 299 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			return result;
#line 8582 "DirectoryMonitor.c"
		}
#line 282 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_g_object_unref0 (_file_it);
#line 8586 "DirectoryMonitor.c"
	}
#line 302 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	result = NULL;
#line 302 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_g_free0 (match_id);
#line 302 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	return result;
#line 8594 "DirectoryMonitor.c"
}


static void directory_monitor_file_info_map_remove_descendents (DirectoryMonitorFileInfoMap* self, GFile* root, DirectoryMonitorFileInfoMap* descendents) {
	GeeArrayList* pruned;
	GeeArrayList* _tmp28_;
#line 305 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_if_fail (DIRECTORY_MONITOR_IS_FILE_INFO_MAP (self));
#line 305 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_if_fail (G_IS_FILE (root));
#line 305 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_if_fail (DIRECTORY_MONITOR_IS_FILE_INFO_MAP (descendents));
#line 306 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	pruned = NULL;
#line 8609 "DirectoryMonitor.c"
	{
		GeeHashMap* _tmp0_;
		GeeSet* _tmp1_;
		GeeSet* _tmp2_;
		GeeSet* _tmp3_;
		GeeIterator* _tmp4_ = NULL;
		GeeIterator* _tmp5_;
		GeeIterator* _file_it;
#line 307 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_tmp0_ = self->priv->map;
#line 307 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_tmp1_ = gee_abstract_map_get_keys (GEE_MAP (_tmp0_));
#line 307 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_tmp2_ = _tmp1_;
#line 307 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_tmp3_ = _tmp2_;
#line 307 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_tmp4_ = gee_iterable_iterator (GEE_ITERABLE (_tmp3_));
#line 307 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_tmp5_ = _tmp4_;
#line 307 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_g_object_unref0 (_tmp3_);
#line 307 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_file_it = _tmp5_;
#line 307 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		while (TRUE) {
#line 8636 "DirectoryMonitor.c"
			GeeIterator* _tmp6_;
			gboolean _tmp7_ = FALSE;
			GeeIterator* _tmp8_;
			gpointer _tmp9_ = NULL;
			GFile* file;
			GFile* _tmp10_;
			GFile* _tmp11_ = NULL;
			GFile* parent;
#line 307 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_tmp6_ = _file_it;
#line 307 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_tmp7_ = gee_iterator_next (_tmp6_);
#line 307 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			if (!_tmp7_) {
#line 307 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				break;
#line 8653 "DirectoryMonitor.c"
			}
#line 307 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_tmp8_ = _file_it;
#line 307 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_tmp9_ = gee_iterator_get (_tmp8_);
#line 307 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			file = (GFile*) _tmp9_;
#line 308 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_tmp10_ = file;
#line 308 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_tmp11_ = g_file_get_parent (_tmp10_);
#line 308 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			parent = _tmp11_;
#line 309 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			while (TRUE) {
#line 8669 "DirectoryMonitor.c"
				GFile* _tmp12_;
				GFile* _tmp13_;
				GFile* _tmp14_;
				gboolean _tmp15_ = FALSE;
				GFile* _tmp26_;
				GFile* _tmp27_ = NULL;
#line 309 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_tmp12_ = parent;
#line 309 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				if (!(_tmp12_ != NULL)) {
#line 309 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					break;
#line 8682 "DirectoryMonitor.c"
				}
#line 310 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_tmp13_ = parent;
#line 310 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_tmp14_ = root;
#line 310 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_tmp15_ = g_file_equal (_tmp13_, _tmp14_);
#line 310 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				if (_tmp15_) {
#line 8692 "DirectoryMonitor.c"
					GeeArrayList* _tmp16_;
					GeeArrayList* _tmp18_;
					GFile* _tmp19_;
					DirectoryMonitorFileInfoMap* _tmp20_;
					GFile* _tmp21_;
					GeeHashMap* _tmp22_;
					GFile* _tmp23_;
					gpointer _tmp24_ = NULL;
					GFileInfo* _tmp25_;
#line 311 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					_tmp16_ = pruned;
#line 311 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					if (_tmp16_ == NULL) {
#line 8706 "DirectoryMonitor.c"
						GeeArrayList* _tmp17_;
#line 312 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
						_tmp17_ = gee_array_list_new (G_TYPE_FILE, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
#line 312 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
						_g_object_unref0 (pruned);
#line 312 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
						pruned = _tmp17_;
#line 8714 "DirectoryMonitor.c"
					}
#line 314 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					_tmp18_ = pruned;
#line 314 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					_tmp19_ = file;
#line 314 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (_tmp18_), _tmp19_);
#line 315 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					_tmp20_ = descendents;
#line 315 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					_tmp21_ = file;
#line 315 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					_tmp22_ = self->priv->map;
#line 315 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					_tmp23_ = file;
#line 315 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					_tmp24_ = gee_abstract_map_get (GEE_ABSTRACT_MAP (_tmp22_), _tmp23_);
#line 315 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					_tmp25_ = (GFileInfo*) _tmp24_;
#line 315 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					directory_monitor_file_info_map_update (_tmp20_, _tmp21_, _tmp25_);
#line 315 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					_g_object_unref0 (_tmp25_);
#line 317 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					break;
#line 8740 "DirectoryMonitor.c"
				}
#line 320 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_tmp26_ = parent;
#line 320 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_tmp27_ = g_file_get_parent (_tmp26_);
#line 320 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_g_object_unref0 (parent);
#line 320 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				parent = _tmp27_;
#line 8750 "DirectoryMonitor.c"
			}
#line 307 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_g_object_unref0 (parent);
#line 307 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_g_object_unref0 (file);
#line 8756 "DirectoryMonitor.c"
		}
#line 307 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_g_object_unref0 (_file_it);
#line 8760 "DirectoryMonitor.c"
	}
#line 324 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp28_ = pruned;
#line 324 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	if (_tmp28_ != NULL) {
#line 8766 "DirectoryMonitor.c"
		GeeArrayList* _tmp29_;
#line 325 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_tmp29_ = pruned;
#line 325 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		directory_monitor_file_info_map_remove_all (self, GEE_COLLECTION (_tmp29_));
#line 8772 "DirectoryMonitor.c"
	}
#line 305 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_g_object_unref0 (pruned);
#line 8776 "DirectoryMonitor.c"
}


static gint directory_monitor_file_info_map_get_children (DirectoryMonitorFileInfoMap* self, GFile* root, GeeCollection* files, GeeCollection* dirs) {
	gint result = 0;
	gint count;
#line 330 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_val_if_fail (DIRECTORY_MONITOR_IS_FILE_INFO_MAP (self), 0);
#line 330 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_val_if_fail (G_IS_FILE (root), 0);
#line 330 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_val_if_fail (GEE_IS_COLLECTION (files), 0);
#line 330 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_val_if_fail (GEE_IS_COLLECTION (dirs), 0);
#line 331 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	count = 0;
#line 8793 "DirectoryMonitor.c"
	{
		GeeHashMap* _tmp0_;
		GeeSet* _tmp1_;
		GeeSet* _tmp2_;
		GeeSet* _tmp3_;
		GeeIterator* _tmp4_ = NULL;
		GeeIterator* _tmp5_;
		GeeIterator* _file_it;
#line 332 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_tmp0_ = self->priv->map;
#line 332 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_tmp1_ = gee_abstract_map_get_keys (GEE_MAP (_tmp0_));
#line 332 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_tmp2_ = _tmp1_;
#line 332 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_tmp3_ = _tmp2_;
#line 332 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_tmp4_ = gee_iterable_iterator (GEE_ITERABLE (_tmp3_));
#line 332 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_tmp5_ = _tmp4_;
#line 332 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_g_object_unref0 (_tmp3_);
#line 332 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_file_it = _tmp5_;
#line 332 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		while (TRUE) {
#line 8820 "DirectoryMonitor.c"
			GeeIterator* _tmp6_;
			gboolean _tmp7_ = FALSE;
			GeeIterator* _tmp8_;
			gpointer _tmp9_ = NULL;
			GFile* file;
			GFile* _tmp10_;
			GFile* _tmp11_ = NULL;
			GFile* parent;
			gboolean _tmp12_ = FALSE;
			GFile* _tmp13_;
			gboolean _tmp17_;
			GeeHashMap* _tmp18_;
			GFile* _tmp19_;
			gpointer _tmp20_ = NULL;
			GFileInfo* _tmp21_;
			DirectoryMonitorFType _tmp22_ = 0;
			DirectoryMonitorFType _tmp23_;
			DirectoryMonitorFType ftype;
			DirectoryMonitorFType _tmp24_;
#line 332 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_tmp6_ = _file_it;
#line 332 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_tmp7_ = gee_iterator_next (_tmp6_);
#line 332 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			if (!_tmp7_) {
#line 332 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				break;
#line 8848 "DirectoryMonitor.c"
			}
#line 332 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_tmp8_ = _file_it;
#line 332 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_tmp9_ = gee_iterator_get (_tmp8_);
#line 332 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			file = (GFile*) _tmp9_;
#line 333 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_tmp10_ = file;
#line 333 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_tmp11_ = g_file_get_parent (_tmp10_);
#line 333 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			parent = _tmp11_;
#line 334 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_tmp13_ = parent;
#line 334 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			if (_tmp13_ == NULL) {
#line 334 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_tmp12_ = TRUE;
#line 8868 "DirectoryMonitor.c"
			} else {
				GFile* _tmp14_;
				GFile* _tmp15_;
				gboolean _tmp16_ = FALSE;
#line 334 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_tmp14_ = parent;
#line 334 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_tmp15_ = root;
#line 334 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_tmp16_ = g_file_equal (_tmp14_, _tmp15_);
#line 334 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_tmp12_ = !_tmp16_;
#line 8881 "DirectoryMonitor.c"
			}
#line 334 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_tmp17_ = _tmp12_;
#line 334 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			if (_tmp17_) {
#line 335 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_g_object_unref0 (parent);
#line 335 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				_g_object_unref0 (file);
#line 335 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				continue;
#line 8893 "DirectoryMonitor.c"
			}
#line 337 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_tmp18_ = self->priv->map;
#line 337 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_tmp19_ = file;
#line 337 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_tmp20_ = gee_abstract_map_get (GEE_ABSTRACT_MAP (_tmp18_), _tmp19_);
#line 337 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_tmp21_ = (GFileInfo*) _tmp20_;
#line 337 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_tmp22_ = directory_monitor_get_ftype (_tmp21_);
#line 337 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_tmp23_ = _tmp22_;
#line 337 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_g_object_unref0 (_tmp21_);
#line 337 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			ftype = _tmp23_;
#line 338 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_tmp24_ = ftype;
#line 338 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			switch (_tmp24_) {
#line 338 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				case DIRECTORY_MONITOR_FTYPE_FILE:
#line 8917 "DirectoryMonitor.c"
				{
					GeeCollection* _tmp25_;
					GFile* _tmp26_;
					gint _tmp27_;
#line 340 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					_tmp25_ = files;
#line 340 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					_tmp26_ = file;
#line 340 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					gee_collection_add (_tmp25_, _tmp26_);
#line 341 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					_tmp27_ = count;
#line 341 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					count = _tmp27_ + 1;
#line 342 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					break;
#line 8934 "DirectoryMonitor.c"
				}
#line 338 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
				case DIRECTORY_MONITOR_FTYPE_DIRECTORY:
#line 8938 "DirectoryMonitor.c"
				{
					GeeCollection* _tmp28_;
					GFile* _tmp29_;
					gint _tmp30_;
#line 345 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					_tmp28_ = dirs;
#line 345 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					_tmp29_ = file;
#line 345 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					gee_collection_add (_tmp28_, _tmp29_);
#line 346 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					_tmp30_ = count;
#line 346 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					count = _tmp30_ + 1;
#line 347 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					break;
#line 8955 "DirectoryMonitor.c"
				}
				default:
				{
					DirectoryMonitorFType _tmp31_;
#line 350 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					_tmp31_ = ftype;
#line 350 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					g_assert (_tmp31_ == DIRECTORY_MONITOR_FTYPE_UNSUPPORTED);
#line 351 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
					break;
#line 8966 "DirectoryMonitor.c"
				}
			}
#line 332 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_g_object_unref0 (parent);
#line 332 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			_g_object_unref0 (file);
#line 8973 "DirectoryMonitor.c"
		}
#line 332 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		_g_object_unref0 (_file_it);
#line 8977 "DirectoryMonitor.c"
	}
#line 355 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	result = count;
#line 355 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	return result;
#line 8983 "DirectoryMonitor.c"
}


static void directory_monitor_value_file_info_map_init (GValue* value) {
#line 128 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	value->data[0].v_pointer = NULL;
#line 8990 "DirectoryMonitor.c"
}


static void directory_monitor_value_file_info_map_free_value (GValue* value) {
#line 128 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	if (value->data[0].v_pointer) {
#line 128 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		directory_monitor_file_info_map_unref (value->data[0].v_pointer);
#line 8999 "DirectoryMonitor.c"
	}
}


static void directory_monitor_value_file_info_map_copy_value (const GValue* src_value, GValue* dest_value) {
#line 128 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	if (src_value->data[0].v_pointer) {
#line 128 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		dest_value->data[0].v_pointer = directory_monitor_file_info_map_ref (src_value->data[0].v_pointer);
#line 9009 "DirectoryMonitor.c"
	} else {
#line 128 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		dest_value->data[0].v_pointer = NULL;
#line 9013 "DirectoryMonitor.c"
	}
}


static gpointer directory_monitor_value_file_info_map_peek_pointer (const GValue* value) {
#line 128 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	return value->data[0].v_pointer;
#line 9021 "DirectoryMonitor.c"
}


static gchar* directory_monitor_value_file_info_map_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
#line 128 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	if (collect_values[0].v_pointer) {
#line 9028 "DirectoryMonitor.c"
		DirectoryMonitorFileInfoMap* object;
		object = collect_values[0].v_pointer;
#line 128 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		if (object->parent_instance.g_class == NULL) {
#line 128 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 9035 "DirectoryMonitor.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 128 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 9039 "DirectoryMonitor.c"
		}
#line 128 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		value->data[0].v_pointer = directory_monitor_file_info_map_ref (object);
#line 9043 "DirectoryMonitor.c"
	} else {
#line 128 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		value->data[0].v_pointer = NULL;
#line 9047 "DirectoryMonitor.c"
	}
#line 128 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	return NULL;
#line 9051 "DirectoryMonitor.c"
}


static gchar* directory_monitor_value_file_info_map_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	DirectoryMonitorFileInfoMap** object_p;
	object_p = collect_values[0].v_pointer;
#line 128 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	if (!object_p) {
#line 128 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 9062 "DirectoryMonitor.c"
	}
#line 128 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	if (!value->data[0].v_pointer) {
#line 128 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		*object_p = NULL;
#line 9068 "DirectoryMonitor.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 128 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		*object_p = value->data[0].v_pointer;
#line 9072 "DirectoryMonitor.c"
	} else {
#line 128 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		*object_p = directory_monitor_file_info_map_ref (value->data[0].v_pointer);
#line 9076 "DirectoryMonitor.c"
	}
#line 128 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	return NULL;
#line 9080 "DirectoryMonitor.c"
}


static GParamSpec* directory_monitor_param_spec_file_info_map (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	DirectoryMonitorParamSpecFileInfoMap* spec;
#line 128 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_val_if_fail (g_type_is_a (object_type, DIRECTORY_MONITOR_TYPE_FILE_INFO_MAP), NULL);
#line 128 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 128 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 128 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	return G_PARAM_SPEC (spec);
#line 9094 "DirectoryMonitor.c"
}


static gpointer directory_monitor_value_get_file_info_map (const GValue* value) {
#line 128 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, DIRECTORY_MONITOR_TYPE_FILE_INFO_MAP), NULL);
#line 128 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	return value->data[0].v_pointer;
#line 9103 "DirectoryMonitor.c"
}


static void directory_monitor_value_set_file_info_map (GValue* value, gpointer v_object) {
	DirectoryMonitorFileInfoMap* old;
#line 128 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, DIRECTORY_MONITOR_TYPE_FILE_INFO_MAP));
#line 128 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	old = value->data[0].v_pointer;
#line 128 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	if (v_object) {
#line 128 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, DIRECTORY_MONITOR_TYPE_FILE_INFO_MAP));
#line 128 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 128 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		value->data[0].v_pointer = v_object;
#line 128 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		directory_monitor_file_info_map_ref (value->data[0].v_pointer);
#line 9123 "DirectoryMonitor.c"
	} else {
#line 128 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		value->data[0].v_pointer = NULL;
#line 9127 "DirectoryMonitor.c"
	}
#line 128 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	if (old) {
#line 128 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		directory_monitor_file_info_map_unref (old);
#line 9133 "DirectoryMonitor.c"
	}
}


static void directory_monitor_value_take_file_info_map (GValue* value, gpointer v_object) {
	DirectoryMonitorFileInfoMap* old;
#line 128 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, DIRECTORY_MONITOR_TYPE_FILE_INFO_MAP));
#line 128 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	old = value->data[0].v_pointer;
#line 128 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	if (v_object) {
#line 128 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, DIRECTORY_MONITOR_TYPE_FILE_INFO_MAP));
#line 128 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 128 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		value->data[0].v_pointer = v_object;
#line 9152 "DirectoryMonitor.c"
	} else {
#line 128 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		value->data[0].v_pointer = NULL;
#line 9156 "DirectoryMonitor.c"
	}
#line 128 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	if (old) {
#line 128 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		directory_monitor_file_info_map_unref (old);
#line 9162 "DirectoryMonitor.c"
	}
}


static void directory_monitor_file_info_map_class_init (DirectoryMonitorFileInfoMapClass * klass) {
#line 128 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	directory_monitor_file_info_map_parent_class = g_type_class_peek_parent (klass);
#line 128 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	DIRECTORY_MONITOR_FILE_INFO_MAP_CLASS (klass)->finalize = directory_monitor_file_info_map_finalize;
#line 128 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_type_class_add_private (klass, sizeof (DirectoryMonitorFileInfoMapPrivate));
#line 9174 "DirectoryMonitor.c"
}


static void directory_monitor_file_info_map_instance_init (DirectoryMonitorFileInfoMap * self) {
	GHashFunc _tmp0_;
	GEqualFunc _tmp1_;
	GeeHashMap* _tmp2_;
	GHashFunc _tmp3_;
	GEqualFunc _tmp4_;
	GEqualFunc _tmp5_;
	GeeHashMap* _tmp6_;
#line 128 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	self->priv = DIRECTORY_MONITOR_FILE_INFO_MAP_GET_PRIVATE (self);
#line 129 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp0_ = g_file_hash;
#line 129 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp1_ = g_file_equal;
#line 129 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp2_ = gee_hash_map_new (G_TYPE_FILE, (GBoxedCopyFunc) g_object_ref, g_object_unref, G_TYPE_FILE_INFO, (GBoxedCopyFunc) g_object_ref, g_object_unref, _tmp0_, _tmp1_, NULL);
#line 129 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	self->priv->map = _tmp2_;
#line 131 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp3_ = g_str_hash;
#line 131 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp4_ = g_str_equal;
#line 131 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp5_ = g_file_equal;
#line 131 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp6_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, G_TYPE_FILE, (GBoxedCopyFunc) g_object_ref, g_object_unref, _tmp3_, _tmp4_, _tmp5_);
#line 131 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	self->priv->id_map = _tmp6_;
#line 128 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	self->ref_count = 1;
#line 9208 "DirectoryMonitor.c"
}


static void directory_monitor_file_info_map_finalize (DirectoryMonitorFileInfoMap* obj) {
	DirectoryMonitorFileInfoMap * self;
#line 128 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	self = DIRECTORY_MONITOR_FILE_INFO_MAP (obj);
#line 129 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_g_object_unref0 (self->priv->map);
#line 131 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_g_object_unref0 (self->priv->id_map);
#line 9220 "DirectoryMonitor.c"
}


static GType directory_monitor_file_info_map_get_type (void) {
	static volatile gsize directory_monitor_file_info_map_type_id__volatile = 0;
	if (g_once_init_enter (&directory_monitor_file_info_map_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { directory_monitor_value_file_info_map_init, directory_monitor_value_file_info_map_free_value, directory_monitor_value_file_info_map_copy_value, directory_monitor_value_file_info_map_peek_pointer, "p", directory_monitor_value_file_info_map_collect_value, "p", directory_monitor_value_file_info_map_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (DirectoryMonitorFileInfoMapClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) directory_monitor_file_info_map_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DirectoryMonitorFileInfoMap), 0, (GInstanceInitFunc) directory_monitor_file_info_map_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType directory_monitor_file_info_map_type_id;
		directory_monitor_file_info_map_type_id = g_type_register_fundamental (g_type_fundamental_next (), "DirectoryMonitorFileInfoMap", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&directory_monitor_file_info_map_type_id__volatile, directory_monitor_file_info_map_type_id);
	}
	return directory_monitor_file_info_map_type_id__volatile;
}


static gpointer directory_monitor_file_info_map_ref (gpointer instance) {
	DirectoryMonitorFileInfoMap* self;
	self = instance;
#line 128 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_atomic_int_inc (&self->ref_count);
#line 128 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	return instance;
#line 9245 "DirectoryMonitor.c"
}


static void directory_monitor_file_info_map_unref (gpointer instance) {
	DirectoryMonitorFileInfoMap* self;
	self = instance;
#line 128 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 128 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		DIRECTORY_MONITOR_FILE_INFO_MAP_GET_CLASS (self)->finalize (self);
#line 128 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 9258 "DirectoryMonitor.c"
	}
}


static void directory_monitor_class_init (DirectoryMonitorClass * klass) {
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	directory_monitor_parent_class = g_type_class_peek_parent (klass);
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_type_class_add_private (klass, sizeof (DirectoryMonitorPrivate));
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	DIRECTORY_MONITOR_CLASS (klass)->notify_root_deleted = directory_monitor_real_notify_root_deleted;
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	DIRECTORY_MONITOR_CLASS (klass)->notify_root_moved = directory_monitor_real_notify_root_moved;
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	DIRECTORY_MONITOR_CLASS (klass)->notify_discovery_started = directory_monitor_real_notify_discovery_started;
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	DIRECTORY_MONITOR_CLASS (klass)->internal_notify_file_discovered = directory_monitor_real_internal_notify_file_discovered;
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	DIRECTORY_MONITOR_CLASS (klass)->notify_file_discovered = directory_monitor_real_notify_file_discovered;
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	DIRECTORY_MONITOR_CLASS (klass)->internal_notify_directory_discovered = directory_monitor_real_internal_notify_directory_discovered;
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	DIRECTORY_MONITOR_CLASS (klass)->notify_directory_discovered = directory_monitor_real_notify_directory_discovered;
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	DIRECTORY_MONITOR_CLASS (klass)->notify_discovery_failed = directory_monitor_real_notify_discovery_failed;
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	DIRECTORY_MONITOR_CLASS (klass)->notify_discovery_completed = directory_monitor_real_notify_discovery_completed;
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	DIRECTORY_MONITOR_CLASS (klass)->notify_file_created = directory_monitor_real_notify_file_created;
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	DIRECTORY_MONITOR_CLASS (klass)->notify_file_moved = directory_monitor_real_notify_file_moved;
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	DIRECTORY_MONITOR_CLASS (klass)->notify_file_altered = directory_monitor_real_notify_file_altered;
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	DIRECTORY_MONITOR_CLASS (klass)->notify_file_alteration_completed = directory_monitor_real_notify_file_alteration_completed;
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	DIRECTORY_MONITOR_CLASS (klass)->notify_file_attributes_altered = directory_monitor_real_notify_file_attributes_altered;
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	DIRECTORY_MONITOR_CLASS (klass)->notify_file_deleted = directory_monitor_real_notify_file_deleted;
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	DIRECTORY_MONITOR_CLASS (klass)->notify_directory_created = directory_monitor_real_notify_directory_created;
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	DIRECTORY_MONITOR_CLASS (klass)->notify_directory_moved = directory_monitor_real_notify_directory_moved;
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	DIRECTORY_MONITOR_CLASS (klass)->notify_directory_altered = directory_monitor_real_notify_directory_altered;
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	DIRECTORY_MONITOR_CLASS (klass)->notify_directory_alteration_completed = directory_monitor_real_notify_directory_alteration_completed;
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	DIRECTORY_MONITOR_CLASS (klass)->notify_directory_attributes_altered = directory_monitor_real_notify_directory_attributes_altered;
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	DIRECTORY_MONITOR_CLASS (klass)->notify_directory_deleted = directory_monitor_real_notify_directory_deleted;
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	DIRECTORY_MONITOR_CLASS (klass)->notify_closed = directory_monitor_real_notify_closed;
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	DIRECTORY_MONITOR_CLASS (klass)->close = directory_monitor_real_close;
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	DIRECTORY_MONITOR_CLASS (klass)->root_moved = directory_monitor_real_root_moved;
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	DIRECTORY_MONITOR_CLASS (klass)->root_deleted = directory_monitor_real_root_deleted;
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	DIRECTORY_MONITOR_CLASS (klass)->discovery_started = directory_monitor_real_discovery_started;
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	DIRECTORY_MONITOR_CLASS (klass)->file_discovered = directory_monitor_real_file_discovered;
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	DIRECTORY_MONITOR_CLASS (klass)->directory_discovered = directory_monitor_real_directory_discovered;
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	DIRECTORY_MONITOR_CLASS (klass)->discovery_failed = directory_monitor_real_discovery_failed;
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	DIRECTORY_MONITOR_CLASS (klass)->discovery_completed = directory_monitor_real_discovery_completed;
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	DIRECTORY_MONITOR_CLASS (klass)->file_created = directory_monitor_real_file_created;
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	DIRECTORY_MONITOR_CLASS (klass)->file_moved = directory_monitor_real_file_moved;
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	DIRECTORY_MONITOR_CLASS (klass)->file_altered = directory_monitor_real_file_altered;
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	DIRECTORY_MONITOR_CLASS (klass)->file_alteration_completed = directory_monitor_real_file_alteration_completed;
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	DIRECTORY_MONITOR_CLASS (klass)->file_attributes_altered = directory_monitor_real_file_attributes_altered;
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	DIRECTORY_MONITOR_CLASS (klass)->file_deleted = directory_monitor_real_file_deleted;
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	DIRECTORY_MONITOR_CLASS (klass)->directory_created = directory_monitor_real_directory_created;
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	DIRECTORY_MONITOR_CLASS (klass)->directory_moved = directory_monitor_real_directory_moved;
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	DIRECTORY_MONITOR_CLASS (klass)->directory_altered = directory_monitor_real_directory_altered;
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	DIRECTORY_MONITOR_CLASS (klass)->directory_alteration_completed = directory_monitor_real_directory_alteration_completed;
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	DIRECTORY_MONITOR_CLASS (klass)->directory_attributes_altered = directory_monitor_real_directory_attributes_altered;
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	DIRECTORY_MONITOR_CLASS (klass)->directory_deleted = directory_monitor_real_directory_deleted;
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	DIRECTORY_MONITOR_CLASS (klass)->closed = directory_monitor_real_closed;
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	G_OBJECT_CLASS (klass)->finalize = directory_monitor_finalize;
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_signal_new ("root_moved", TYPE_DIRECTORY_MONITOR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DirectoryMonitorClass, root_moved), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT_OBJECT, G_TYPE_NONE, 3, G_TYPE_FILE, G_TYPE_FILE, G_TYPE_FILE_INFO);
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_signal_new ("root_deleted", TYPE_DIRECTORY_MONITOR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DirectoryMonitorClass, root_deleted), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, G_TYPE_FILE);
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_signal_new ("discovery_started", TYPE_DIRECTORY_MONITOR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DirectoryMonitorClass, discovery_started), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_signal_new ("file_discovered", TYPE_DIRECTORY_MONITOR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DirectoryMonitorClass, file_discovered), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT, G_TYPE_NONE, 2, G_TYPE_FILE, G_TYPE_FILE_INFO);
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_signal_new ("directory_discovered", TYPE_DIRECTORY_MONITOR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DirectoryMonitorClass, directory_discovered), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT, G_TYPE_NONE, 2, G_TYPE_FILE, G_TYPE_FILE_INFO);
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_signal_new ("discovery_failed", TYPE_DIRECTORY_MONITOR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DirectoryMonitorClass, discovery_failed), NULL, NULL, g_cclosure_marshal_VOID__STRING, G_TYPE_NONE, 1, G_TYPE_STRING);
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_signal_new ("discovery_completed", TYPE_DIRECTORY_MONITOR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DirectoryMonitorClass, discovery_completed), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_signal_new ("file_created", TYPE_DIRECTORY_MONITOR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DirectoryMonitorClass, file_created), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT, G_TYPE_NONE, 2, G_TYPE_FILE, G_TYPE_FILE_INFO);
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_signal_new ("file_moved", TYPE_DIRECTORY_MONITOR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DirectoryMonitorClass, file_moved), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT_OBJECT, G_TYPE_NONE, 3, G_TYPE_FILE, G_TYPE_FILE, G_TYPE_FILE_INFO);
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_signal_new ("file_altered", TYPE_DIRECTORY_MONITOR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DirectoryMonitorClass, file_altered), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, G_TYPE_FILE);
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_signal_new ("file_alteration_completed", TYPE_DIRECTORY_MONITOR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DirectoryMonitorClass, file_alteration_completed), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT, G_TYPE_NONE, 2, G_TYPE_FILE, G_TYPE_FILE_INFO);
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_signal_new ("file_attributes_altered", TYPE_DIRECTORY_MONITOR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DirectoryMonitorClass, file_attributes_altered), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, G_TYPE_FILE);
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_signal_new ("file_deleted", TYPE_DIRECTORY_MONITOR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DirectoryMonitorClass, file_deleted), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, G_TYPE_FILE);
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_signal_new ("directory_created", TYPE_DIRECTORY_MONITOR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DirectoryMonitorClass, directory_created), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT, G_TYPE_NONE, 2, G_TYPE_FILE, G_TYPE_FILE_INFO);
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_signal_new ("directory_moved", TYPE_DIRECTORY_MONITOR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DirectoryMonitorClass, directory_moved), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT_OBJECT, G_TYPE_NONE, 3, G_TYPE_FILE, G_TYPE_FILE, G_TYPE_FILE_INFO);
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_signal_new ("directory_altered", TYPE_DIRECTORY_MONITOR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DirectoryMonitorClass, directory_altered), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, G_TYPE_FILE);
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_signal_new ("directory_alteration_completed", TYPE_DIRECTORY_MONITOR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DirectoryMonitorClass, directory_alteration_completed), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT, G_TYPE_NONE, 2, G_TYPE_FILE, G_TYPE_FILE_INFO);
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_signal_new ("directory_attributes_altered", TYPE_DIRECTORY_MONITOR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DirectoryMonitorClass, directory_attributes_altered), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, G_TYPE_FILE);
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_signal_new ("directory_deleted", TYPE_DIRECTORY_MONITOR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DirectoryMonitorClass, directory_deleted), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, G_TYPE_FILE);
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	g_signal_new ("closed", TYPE_DIRECTORY_MONITOR, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DirectoryMonitorClass, closed), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 9396 "DirectoryMonitor.c"
}


static void directory_monitor_instance_init (DirectoryMonitor * self) {
	GeeHashMap* _tmp0_;
	GeeLinkedList* _tmp1_;
	DirectoryMonitorFileInfoMap* _tmp2_;
	DirectoryMonitorFileInfoMap* _tmp3_;
	GCancellable* _tmp4_;
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	self->priv = DIRECTORY_MONITOR_GET_PRIVATE (self);
#line 362 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp0_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, G_TYPE_FILE_MONITOR, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL, NULL);
#line 362 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	self->priv->monitors = _tmp0_;
#line 363 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp1_ = gee_linked_list_new (DIRECTORY_MONITOR_TYPE_QUERY_INFO_QUEUE_ELEMENT, (GBoxedCopyFunc) directory_monitor_query_info_queue_element_ref, directory_monitor_query_info_queue_element_unref, NULL);
#line 363 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	self->priv->query_info_queue = GEE_QUEUE (_tmp1_);
#line 365 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp2_ = directory_monitor_file_info_map_new ();
#line 365 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	self->priv->files = _tmp2_;
#line 366 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp3_ = directory_monitor_file_info_map_new ();
#line 366 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	self->priv->parent_moved = _tmp3_;
#line 367 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_tmp4_ = g_cancellable_new ();
#line 367 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	self->priv->cancellable = _tmp4_;
#line 368 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	self->priv->outstanding_exploration_dirs = 0;
#line 369 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	self->priv->started = FALSE;
#line 370 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	self->priv->has_discovery_started = FALSE;
#line 371 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	self->priv->delete_timer_id = (guint) 0;
#line 9436 "DirectoryMonitor.c"
}


static void directory_monitor_finalize (GObject* obj) {
	DirectoryMonitor * self;
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	self = DIRECTORY_MONITOR (obj);
#line 359 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_g_object_unref0 (self->priv->root);
#line 362 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_g_object_unref0 (self->priv->monitors);
#line 363 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_g_object_unref0 (self->priv->query_info_queue);
#line 365 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_directory_monitor_file_info_map_unref0 (self->priv->files);
#line 366 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_directory_monitor_file_info_map_unref0 (self->priv->parent_moved);
#line 367 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	_g_object_unref0 (self->priv->cancellable);
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/DirectoryMonitor.vala"
	G_OBJECT_CLASS (directory_monitor_parent_class)->finalize (obj);
#line 9458 "DirectoryMonitor.c"
}


GType directory_monitor_get_type (void) {
	static volatile gsize directory_monitor_type_id__volatile = 0;
	if (g_once_init_enter (&directory_monitor_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (DirectoryMonitorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) directory_monitor_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DirectoryMonitor), 0, (GInstanceInitFunc) directory_monitor_instance_init, NULL };
		GType directory_monitor_type_id;
		directory_monitor_type_id = g_type_register_static (G_TYPE_OBJECT, "DirectoryMonitor", &g_define_type_info, 0);
		g_once_init_leave (&directory_monitor_type_id__volatile, directory_monitor_type_id);
	}
	return directory_monitor_type_id__volatile;
}



