/* MetadataWriter.c generated by valac 0.14.2, the Vala compiler
 * generated from MetadataWriter.vala, do not modify */

/* Copyright 2010-2011 Yorba Foundation
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution. 
 */
/* MetadataWriter tracks LibraryPhotos for alterations to their metadata and commits those changes*/
/* in a timely manner to their backing files.  Because only the MetadataWriter knows when the*/
/* metadata has been properly committed, it is also responsible for updating the metadata-dirty*/
/* flag in Photo.  Thus, MetadataWriter should *always* be running, even if the user has turned off*/
/* the feature, so if they turn it on MetadataWriter can properly go out and update the backing*/
/* files.*/

#include <glib.h>
#include <glib-object.h>
#include <gee.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <time.h>


#define TYPE_METADATA_WRITER (metadata_writer_get_type ())
#define METADATA_WRITER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_METADATA_WRITER, MetadataWriter))
#define METADATA_WRITER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_METADATA_WRITER, MetadataWriterClass))
#define IS_METADATA_WRITER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_METADATA_WRITER))
#define IS_METADATA_WRITER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_METADATA_WRITER))
#define METADATA_WRITER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_METADATA_WRITER, MetadataWriterClass))

typedef struct _MetadataWriter MetadataWriter;
typedef struct _MetadataWriterClass MetadataWriterClass;
typedef struct _MetadataWriterPrivate MetadataWriterPrivate;

#define TYPE_WORKERS (workers_get_type ())
#define WORKERS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_WORKERS, Workers))
#define WORKERS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_WORKERS, WorkersClass))
#define IS_WORKERS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_WORKERS))
#define IS_WORKERS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_WORKERS))
#define WORKERS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_WORKERS, WorkersClass))

typedef struct _Workers Workers;
typedef struct _WorkersClass WorkersClass;

#define TYPE_TIMED_QUEUE (timed_queue_get_type ())
#define TIMED_QUEUE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TIMED_QUEUE, TimedQueue))
#define TIMED_QUEUE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TIMED_QUEUE, TimedQueueClass))
#define IS_TIMED_QUEUE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TIMED_QUEUE))
#define IS_TIMED_QUEUE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TIMED_QUEUE))
#define TIMED_QUEUE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TIMED_QUEUE, TimedQueueClass))

typedef struct _TimedQueue TimedQueue;
typedef struct _TimedQueueClass TimedQueueClass;

#define TYPE_HASH_TIMED_QUEUE (hash_timed_queue_get_type ())
#define HASH_TIMED_QUEUE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_HASH_TIMED_QUEUE, HashTimedQueue))
#define HASH_TIMED_QUEUE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_HASH_TIMED_QUEUE, HashTimedQueueClass))
#define IS_HASH_TIMED_QUEUE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_HASH_TIMED_QUEUE))
#define IS_HASH_TIMED_QUEUE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_HASH_TIMED_QUEUE))
#define HASH_TIMED_QUEUE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_HASH_TIMED_QUEUE, HashTimedQueueClass))

typedef struct _HashTimedQueue HashTimedQueue;
typedef struct _HashTimedQueueClass HashTimedQueueClass;

#define TYPE_DATA_OBJECT (data_object_get_type ())
#define DATA_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_OBJECT, DataObject))
#define DATA_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_OBJECT, DataObjectClass))
#define IS_DATA_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_OBJECT))
#define IS_DATA_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_OBJECT))
#define DATA_OBJECT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_OBJECT, DataObjectClass))

typedef struct _DataObject DataObject;
typedef struct _DataObjectClass DataObjectClass;

#define TYPE_DATA_SOURCE (data_source_get_type ())
#define DATA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_SOURCE, DataSource))
#define DATA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_SOURCE, DataSourceClass))
#define IS_DATA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_SOURCE))
#define IS_DATA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_SOURCE))
#define DATA_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_SOURCE, DataSourceClass))

typedef struct _DataSource DataSource;
typedef struct _DataSourceClass DataSourceClass;

#define TYPE_THUMBNAIL_SOURCE (thumbnail_source_get_type ())
#define THUMBNAIL_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_THUMBNAIL_SOURCE, ThumbnailSource))
#define THUMBNAIL_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_THUMBNAIL_SOURCE, ThumbnailSourceClass))
#define IS_THUMBNAIL_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_THUMBNAIL_SOURCE))
#define IS_THUMBNAIL_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_THUMBNAIL_SOURCE))
#define THUMBNAIL_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_THUMBNAIL_SOURCE, ThumbnailSourceClass))

typedef struct _ThumbnailSource ThumbnailSource;
typedef struct _ThumbnailSourceClass ThumbnailSourceClass;

#define TYPE_MEDIA_SOURCE (media_source_get_type ())
#define MEDIA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_SOURCE, MediaSource))
#define MEDIA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_SOURCE, MediaSourceClass))
#define IS_MEDIA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_SOURCE))
#define IS_MEDIA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_SOURCE))
#define MEDIA_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_SOURCE, MediaSourceClass))

typedef struct _MediaSource MediaSource;
typedef struct _MediaSourceClass MediaSourceClass;

#define TYPE_PHOTO_SOURCE (photo_source_get_type ())
#define PHOTO_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_SOURCE, PhotoSource))
#define PHOTO_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_SOURCE, PhotoSourceClass))
#define IS_PHOTO_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_SOURCE))
#define IS_PHOTO_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_SOURCE))
#define PHOTO_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_SOURCE, PhotoSourceClass))

typedef struct _PhotoSource PhotoSource;
typedef struct _PhotoSourceClass PhotoSourceClass;

#define TYPE_PHOTO (photo_get_type ())
#define PHOTO(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO, Photo))
#define PHOTO_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO, PhotoClass))
#define IS_PHOTO(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO))
#define IS_PHOTO_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO))
#define PHOTO_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO, PhotoClass))

typedef struct _Photo Photo;
typedef struct _PhotoClass PhotoClass;

#define TYPE_LIBRARY_PHOTO (library_photo_get_type ())
#define LIBRARY_PHOTO(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_LIBRARY_PHOTO, LibraryPhoto))
#define LIBRARY_PHOTO_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_LIBRARY_PHOTO, LibraryPhotoClass))
#define IS_LIBRARY_PHOTO(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_LIBRARY_PHOTO))
#define IS_LIBRARY_PHOTO_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_LIBRARY_PHOTO))
#define LIBRARY_PHOTO_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_LIBRARY_PHOTO, LibraryPhotoClass))

typedef struct _LibraryPhoto LibraryPhoto;
typedef struct _LibraryPhotoClass LibraryPhotoClass;

#define TYPE_BACKGROUND_JOB (background_job_get_type ())
#define BACKGROUND_JOB(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BACKGROUND_JOB, BackgroundJob))
#define BACKGROUND_JOB_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BACKGROUND_JOB, BackgroundJobClass))
#define IS_BACKGROUND_JOB(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BACKGROUND_JOB))
#define IS_BACKGROUND_JOB_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BACKGROUND_JOB))
#define BACKGROUND_JOB_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BACKGROUND_JOB, BackgroundJobClass))

typedef struct _BackgroundJob BackgroundJob;
typedef struct _BackgroundJobClass BackgroundJobClass;

#define METADATA_WRITER_TYPE_COMMIT_JOB (metadata_writer_commit_job_get_type ())
#define METADATA_WRITER_COMMIT_JOB(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), METADATA_WRITER_TYPE_COMMIT_JOB, MetadataWriterCommitJob))
#define METADATA_WRITER_COMMIT_JOB_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), METADATA_WRITER_TYPE_COMMIT_JOB, MetadataWriterCommitJobClass))
#define METADATA_WRITER_IS_COMMIT_JOB(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), METADATA_WRITER_TYPE_COMMIT_JOB))
#define METADATA_WRITER_IS_COMMIT_JOB_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), METADATA_WRITER_TYPE_COMMIT_JOB))
#define METADATA_WRITER_COMMIT_JOB_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), METADATA_WRITER_TYPE_COMMIT_JOB, MetadataWriterCommitJobClass))

typedef struct _MetadataWriterCommitJob MetadataWriterCommitJob;
typedef struct _MetadataWriterCommitJobClass MetadataWriterCommitJobClass;

#define TYPE_CONFIG (config_get_type ())
#define CONFIG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CONFIG, Config))
#define CONFIG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CONFIG, ConfigClass))
#define IS_CONFIG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CONFIG))
#define IS_CONFIG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CONFIG))
#define CONFIG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CONFIG, ConfigClass))

typedef struct _Config Config;
typedef struct _ConfigClass ConfigClass;
#define _config_unref0(var) ((var == NULL) ? NULL : (var = (config_unref (var), NULL)))

#define TYPE_DATA_COLLECTION (data_collection_get_type ())
#define DATA_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_COLLECTION, DataCollection))
#define DATA_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_COLLECTION, DataCollectionClass))
#define IS_DATA_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_COLLECTION))
#define IS_DATA_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_COLLECTION))
#define DATA_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_COLLECTION, DataCollectionClass))

typedef struct _DataCollection DataCollection;
typedef struct _DataCollectionClass DataCollectionClass;

#define TYPE_SOURCE_COLLECTION (source_collection_get_type ())
#define SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SOURCE_COLLECTION, SourceCollection))
#define SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SOURCE_COLLECTION, SourceCollectionClass))
#define IS_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SOURCE_COLLECTION))
#define IS_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SOURCE_COLLECTION))
#define SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SOURCE_COLLECTION, SourceCollectionClass))

typedef struct _SourceCollection SourceCollection;
typedef struct _SourceCollectionClass SourceCollectionClass;

#define TYPE_DATABASE_SOURCE_COLLECTION (database_source_collection_get_type ())
#define DATABASE_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATABASE_SOURCE_COLLECTION, DatabaseSourceCollection))
#define DATABASE_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATABASE_SOURCE_COLLECTION, DatabaseSourceCollectionClass))
#define IS_DATABASE_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATABASE_SOURCE_COLLECTION))
#define IS_DATABASE_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATABASE_SOURCE_COLLECTION))
#define DATABASE_SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATABASE_SOURCE_COLLECTION, DatabaseSourceCollectionClass))

typedef struct _DatabaseSourceCollection DatabaseSourceCollection;
typedef struct _DatabaseSourceCollectionClass DatabaseSourceCollectionClass;

#define TYPE_MEDIA_SOURCE_COLLECTION (media_source_collection_get_type ())
#define MEDIA_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection))
#define MEDIA_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollectionClass))
#define IS_MEDIA_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_SOURCE_COLLECTION))
#define IS_MEDIA_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_SOURCE_COLLECTION))
#define MEDIA_SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollectionClass))

typedef struct _MediaSourceCollection MediaSourceCollection;
typedef struct _MediaSourceCollectionClass MediaSourceCollectionClass;

#define TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION (library_photo_source_collection_get_type ())
#define LIBRARY_PHOTO_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, LibraryPhotoSourceCollection))
#define LIBRARY_PHOTO_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, LibraryPhotoSourceCollectionClass))
#define IS_LIBRARY_PHOTO_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION))
#define IS_LIBRARY_PHOTO_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION))
#define LIBRARY_PHOTO_SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, LibraryPhotoSourceCollectionClass))

typedef struct _LibraryPhotoSourceCollection LibraryPhotoSourceCollection;
typedef struct _LibraryPhotoSourceCollectionClass LibraryPhotoSourceCollectionClass;

#define TYPE_ALTERATION (alteration_get_type ())
#define ALTERATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ALTERATION, Alteration))
#define ALTERATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ALTERATION, AlterationClass))
#define IS_ALTERATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ALTERATION))
#define IS_ALTERATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ALTERATION))
#define ALTERATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ALTERATION, AlterationClass))

typedef struct _Alteration Alteration;
typedef struct _AlterationClass AlterationClass;

#define TYPE_CONTAINER_SOURCE_COLLECTION (container_source_collection_get_type ())
#define CONTAINER_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CONTAINER_SOURCE_COLLECTION, ContainerSourceCollection))
#define CONTAINER_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CONTAINER_SOURCE_COLLECTION, ContainerSourceCollectionClass))
#define IS_CONTAINER_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CONTAINER_SOURCE_COLLECTION))
#define IS_CONTAINER_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CONTAINER_SOURCE_COLLECTION))
#define CONTAINER_SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CONTAINER_SOURCE_COLLECTION, ContainerSourceCollectionClass))

typedef struct _ContainerSourceCollection ContainerSourceCollection;
typedef struct _ContainerSourceCollectionClass ContainerSourceCollectionClass;

#define TYPE_TAG_SOURCE_COLLECTION (tag_source_collection_get_type ())
#define TAG_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TAG_SOURCE_COLLECTION, TagSourceCollection))
#define TAG_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TAG_SOURCE_COLLECTION, TagSourceCollectionClass))
#define IS_TAG_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TAG_SOURCE_COLLECTION))
#define IS_TAG_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TAG_SOURCE_COLLECTION))
#define TAG_SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TAG_SOURCE_COLLECTION, TagSourceCollectionClass))

typedef struct _TagSourceCollection TagSourceCollection;
typedef struct _TagSourceCollectionClass TagSourceCollectionClass;

#define TYPE_CONTAINER_SOURCE (container_source_get_type ())
#define CONTAINER_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CONTAINER_SOURCE, ContainerSource))
#define IS_CONTAINER_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CONTAINER_SOURCE))
#define CONTAINER_SOURCE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_CONTAINER_SOURCE, ContainerSourceIface))

typedef struct _ContainerSource ContainerSource;
typedef struct _ContainerSourceIface ContainerSourceIface;

#define TYPE_SOURCE_BACKLINK (source_backlink_get_type ())
#define SOURCE_BACKLINK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SOURCE_BACKLINK, SourceBacklink))
#define SOURCE_BACKLINK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SOURCE_BACKLINK, SourceBacklinkClass))
#define IS_SOURCE_BACKLINK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SOURCE_BACKLINK))
#define IS_SOURCE_BACKLINK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SOURCE_BACKLINK))
#define SOURCE_BACKLINK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SOURCE_BACKLINK, SourceBacklinkClass))

typedef struct _SourceBacklink SourceBacklink;
typedef struct _SourceBacklinkClass SourceBacklinkClass;

#define TYPE_APPLICATION (application_get_type ())
#define APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_APPLICATION, Application))
#define APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_APPLICATION, ApplicationClass))
#define IS_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_APPLICATION))
#define IS_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_APPLICATION))
#define APPLICATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_APPLICATION, ApplicationClass))

typedef struct _Application Application;
typedef struct _ApplicationClass ApplicationClass;
#define _application_unref0(var) ((var == NULL) ? NULL : (var = (application_unref (var), NULL)))

#define TYPE_LIBRARY_MONITOR_POOL (library_monitor_pool_get_type ())
#define LIBRARY_MONITOR_POOL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_LIBRARY_MONITOR_POOL, LibraryMonitorPool))
#define LIBRARY_MONITOR_POOL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_LIBRARY_MONITOR_POOL, LibraryMonitorPoolClass))
#define IS_LIBRARY_MONITOR_POOL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_LIBRARY_MONITOR_POOL))
#define IS_LIBRARY_MONITOR_POOL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_LIBRARY_MONITOR_POOL))
#define LIBRARY_MONITOR_POOL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_LIBRARY_MONITOR_POOL, LibraryMonitorPoolClass))

typedef struct _LibraryMonitorPool LibraryMonitorPool;
typedef struct _LibraryMonitorPoolClass LibraryMonitorPoolClass;

#define TYPE_DIRECTORY_MONITOR (directory_monitor_get_type ())
#define DIRECTORY_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DIRECTORY_MONITOR, DirectoryMonitor))
#define DIRECTORY_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DIRECTORY_MONITOR, DirectoryMonitorClass))
#define IS_DIRECTORY_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DIRECTORY_MONITOR))
#define IS_DIRECTORY_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DIRECTORY_MONITOR))
#define DIRECTORY_MONITOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DIRECTORY_MONITOR, DirectoryMonitorClass))

typedef struct _DirectoryMonitor DirectoryMonitor;
typedef struct _DirectoryMonitorClass DirectoryMonitorClass;

#define TYPE_LIBRARY_MONITOR (library_monitor_get_type ())
#define LIBRARY_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_LIBRARY_MONITOR, LibraryMonitor))
#define LIBRARY_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_LIBRARY_MONITOR, LibraryMonitorClass))
#define IS_LIBRARY_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_LIBRARY_MONITOR))
#define IS_LIBRARY_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_LIBRARY_MONITOR))
#define LIBRARY_MONITOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_LIBRARY_MONITOR, LibraryMonitorClass))

typedef struct _LibraryMonitor LibraryMonitor;
typedef struct _LibraryMonitorClass LibraryMonitorClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _library_monitor_pool_unref0(var) ((var == NULL) ? NULL : (var = (library_monitor_pool_unref (var), NULL)))
#define _workers_unref0(var) ((var == NULL) ? NULL : (var = (workers_unref (var), NULL)))
#define _timed_queue_unref0(var) ((var == NULL) ? NULL : (var = (timed_queue_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _alteration_unref0(var) ((var == NULL) ? NULL : (var = (alteration_unref (var), NULL)))

#define TYPE_TAG (tag_get_type ())
#define TAG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TAG, Tag))
#define TAG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TAG, TagClass))
#define IS_TAG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TAG))
#define IS_TAG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TAG))
#define TAG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TAG, TagClass))

typedef struct _Tag Tag;
typedef struct _TagClass TagClass;

#define TYPE_TRANSACTION_CONTROLLER (transaction_controller_get_type ())
#define TRANSACTION_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TRANSACTION_CONTROLLER, TransactionController))
#define TRANSACTION_CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TRANSACTION_CONTROLLER, TransactionControllerClass))
#define IS_TRANSACTION_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TRANSACTION_CONTROLLER))
#define IS_TRANSACTION_CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TRANSACTION_CONTROLLER))
#define TRANSACTION_CONTROLLER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TRANSACTION_CONTROLLER, TransactionControllerClass))

typedef struct _TransactionController TransactionController;
typedef struct _TransactionControllerClass TransactionControllerClass;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _background_job_unref0(var) ((var == NULL) ? NULL : (var = (background_job_unref (var), NULL)))
typedef struct _BackgroundJobPrivate BackgroundJobPrivate;

#define BACKGROUND_JOB_TYPE_JOB_PRIORITY (background_job_job_priority_get_type ())
typedef struct _MetadataWriterCommitJobPrivate MetadataWriterCommitJobPrivate;

#define PHOTO_TYPE_REIMPORT_MASTER_STATE (photo_reimport_master_state_get_type ())
#define PHOTO_REIMPORT_MASTER_STATE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PHOTO_TYPE_REIMPORT_MASTER_STATE, PhotoReimportMasterState))
#define PHOTO_REIMPORT_MASTER_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PHOTO_TYPE_REIMPORT_MASTER_STATE, PhotoReimportMasterStateClass))
#define PHOTO_IS_REIMPORT_MASTER_STATE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PHOTO_TYPE_REIMPORT_MASTER_STATE))
#define PHOTO_IS_REIMPORT_MASTER_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PHOTO_TYPE_REIMPORT_MASTER_STATE))
#define PHOTO_REIMPORT_MASTER_STATE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PHOTO_TYPE_REIMPORT_MASTER_STATE, PhotoReimportMasterStateClass))

typedef struct _PhotoReimportMasterState PhotoReimportMasterState;
typedef struct _PhotoReimportMasterStateClass PhotoReimportMasterStateClass;

#define PHOTO_TYPE_REIMPORT_EDITABLE_STATE (photo_reimport_editable_state_get_type ())
#define PHOTO_REIMPORT_EDITABLE_STATE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PHOTO_TYPE_REIMPORT_EDITABLE_STATE, PhotoReimportEditableState))
#define PHOTO_REIMPORT_EDITABLE_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PHOTO_TYPE_REIMPORT_EDITABLE_STATE, PhotoReimportEditableStateClass))
#define PHOTO_IS_REIMPORT_EDITABLE_STATE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PHOTO_TYPE_REIMPORT_EDITABLE_STATE))
#define PHOTO_IS_REIMPORT_EDITABLE_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PHOTO_TYPE_REIMPORT_EDITABLE_STATE))
#define PHOTO_REIMPORT_EDITABLE_STATE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PHOTO_TYPE_REIMPORT_EDITABLE_STATE, PhotoReimportEditableStateClass))

typedef struct _PhotoReimportEditableState PhotoReimportEditableState;
typedef struct _PhotoReimportEditableStateClass PhotoReimportEditableStateClass;
#define _photo_reimport_master_state_unref0(var) ((var == NULL) ? NULL : (var = (photo_reimport_master_state_unref (var), NULL)))
#define _photo_reimport_editable_state_unref0(var) ((var == NULL) ? NULL : (var = (photo_reimport_editable_state_unref (var), NULL)))

#define TYPE_PHOTO_FILE_FORMAT (photo_file_format_get_type ())

#define TYPE_MEDIA_METADATA (media_metadata_get_type ())
#define MEDIA_METADATA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_METADATA, MediaMetadata))
#define MEDIA_METADATA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_METADATA, MediaMetadataClass))
#define IS_MEDIA_METADATA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_METADATA))
#define IS_MEDIA_METADATA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_METADATA))
#define MEDIA_METADATA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_METADATA, MediaMetadataClass))

typedef struct _MediaMetadata MediaMetadata;
typedef struct _MediaMetadataClass MediaMetadataClass;

#define TYPE_PHOTO_METADATA (photo_metadata_get_type ())
#define PHOTO_METADATA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_METADATA, PhotoMetadata))
#define PHOTO_METADATA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_METADATA, PhotoMetadataClass))
#define IS_PHOTO_METADATA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_METADATA))
#define IS_PHOTO_METADATA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_METADATA))
#define PHOTO_METADATA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_METADATA, PhotoMetadataClass))

typedef struct _PhotoMetadata PhotoMetadata;
typedef struct _PhotoMetadataClass PhotoMetadataClass;
#define _media_metadata_unref0(var) ((var == NULL) ? NULL : (var = (media_metadata_unref (var), NULL)))

#define PHOTO_METADATA_TYPE_SET_OPTION (photo_metadata_set_option_get_type ())

#define TYPE_RATING (rating_get_type ())

#define TYPE_METADATA_DATE_TIME (metadata_date_time_get_type ())
#define METADATA_DATE_TIME(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_METADATA_DATE_TIME, MetadataDateTime))
#define METADATA_DATE_TIME_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_METADATA_DATE_TIME, MetadataDateTimeClass))
#define IS_METADATA_DATE_TIME(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_METADATA_DATE_TIME))
#define IS_METADATA_DATE_TIME_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_METADATA_DATE_TIME))
#define METADATA_DATE_TIME_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_METADATA_DATE_TIME, MetadataDateTimeClass))

typedef struct _MetadataDateTime MetadataDateTime;
typedef struct _MetadataDateTimeClass MetadataDateTimeClass;
#define _metadata_date_time_unref0(var) ((var == NULL) ? NULL : (var = (metadata_date_time_unref (var), NULL)))

#define TYPE_ORIENTATION (orientation_get_type ())

struct _MetadataWriter {
	GObject parent_instance;
	MetadataWriterPrivate * priv;
};

struct _MetadataWriterClass {
	GObjectClass parent_class;
};

struct _MetadataWriterPrivate {
	Workers* workers;
	gboolean enabled;
	HashTimedQueue* dirty;
	GeeHashMap* pending;
	GeeHashSet* interested_photo_details;
	LibraryPhoto* ignore_photo_alteration;
	guint outstanding_total;
	guint outstanding_completed;
	gboolean closed;
	gint pause_count;
	GeeHashSet* importing_photos;
};

struct _ContainerSourceIface {
	GTypeInterface parent_iface;
	gboolean (*has_links) (ContainerSource* self);
	SourceBacklink* (*get_backlink) (ContainerSource* self);
	void (*break_link) (ContainerSource* self, DataSource* source);
	void (*break_link_many) (ContainerSource* self, GeeCollection* sources);
	void (*establish_link) (ContainerSource* self, DataSource* source);
	void (*establish_link_many) (ContainerSource* self, GeeCollection* sources);
};

typedef void (*DequeuedCallback) (gconstpointer item, void* user_data);
typedef enum  {
	DATABASE_ERROR_ERROR,
	DATABASE_ERROR_BACKING,
	DATABASE_ERROR_MEMORY,
	DATABASE_ERROR_ABORT,
	DATABASE_ERROR_LIMITS,
	DATABASE_ERROR_TYPESPEC
} DatabaseError;
#define DATABASE_ERROR database_error_quark ()
typedef enum  {
	BACKGROUND_JOB_JOB_PRIORITY_HIGHEST = 100,
	BACKGROUND_JOB_JOB_PRIORITY_HIGH = 75,
	BACKGROUND_JOB_JOB_PRIORITY_NORMAL = 50,
	BACKGROUND_JOB_JOB_PRIORITY_LOW = 25,
	BACKGROUND_JOB_JOB_PRIORITY_LOWEST = 0
} BackgroundJobJobPriority;

struct _BackgroundJob {
	GTypeInstance parent_instance;
	volatile int ref_count;
	BackgroundJobPrivate * priv;
};

struct _BackgroundJobClass {
	GTypeClass parent_class;
	void (*finalize) (BackgroundJob *self);
	void (*execute) (BackgroundJob* self);
	BackgroundJobJobPriority (*get_priority) (BackgroundJob* self);
};

struct _MetadataWriterCommitJob {
	BackgroundJob parent_instance;
	MetadataWriterCommitJobPrivate * priv;
	LibraryPhoto* photo;
	GeeSet* current_keywords;
	PhotoReimportMasterState* reimport_master_state;
	PhotoReimportEditableState* reimport_editable_state;
	GError* err;
};

struct _MetadataWriterCommitJobClass {
	BackgroundJobClass parent_class;
};

typedef void (*CompletionCallback) (BackgroundJob* job, void* user_data);
typedef void (*CancellationCallback) (BackgroundJob* job, void* user_data);
typedef enum  {
	PHOTO_FILE_FORMAT_JFIF,
	PHOTO_FILE_FORMAT_RAW,
	PHOTO_FILE_FORMAT_PNG,
	PHOTO_FILE_FORMAT_TIFF,
	PHOTO_FILE_FORMAT_UNKNOWN
} PhotoFileFormat;

typedef enum  {
	PHOTO_METADATA_SET_OPTION_ALL_DOMAINS,
	PHOTO_METADATA_SET_OPTION_ONLY_IF_DOMAIN_PRESENT,
	PHOTO_METADATA_SET_OPTION_AT_LEAST_DEFAULT_DOMAIN
} PhotoMetadataSetOption;

typedef enum  {
	RATING_REJECTED = -1,
	RATING_UNRATED = 0,
	RATING_ONE = 1,
	RATING_TWO = 2,
	RATING_THREE = 3,
	RATING_FOUR = 4,
	RATING_FIVE = 5
} Rating;

typedef enum  {
	ORIENTATION_MIN = 1,
	ORIENTATION_TOP_LEFT = 1,
	ORIENTATION_TOP_RIGHT = 2,
	ORIENTATION_BOTTOM_RIGHT = 3,
	ORIENTATION_BOTTOM_LEFT = 4,
	ORIENTATION_LEFT_TOP = 5,
	ORIENTATION_RIGHT_TOP = 6,
	ORIENTATION_RIGHT_BOTTOM = 7,
	ORIENTATION_LEFT_BOTTOM = 8,
	ORIENTATION_MAX = 8
} Orientation;


static gpointer metadata_writer_parent_class = NULL;
extern LibraryPhotoSourceCollection* library_photo_global;
extern TagSourceCollection* tag_global;
static MetadataWriter* metadata_writer_instance;
static MetadataWriter* metadata_writer_instance = NULL;
static gpointer metadata_writer_commit_job_parent_class = NULL;

GType metadata_writer_get_type (void) G_GNUC_CONST;
gpointer workers_ref (gpointer instance);
void workers_unref (gpointer instance);
GParamSpec* param_spec_workers (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_workers (GValue* value, gpointer v_object);
void value_take_workers (GValue* value, gpointer v_object);
gpointer value_get_workers (const GValue* value);
GType workers_get_type (void) G_GNUC_CONST;
gpointer timed_queue_ref (gpointer instance);
void timed_queue_unref (gpointer instance);
GParamSpec* param_spec_timed_queue (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_timed_queue (GValue* value, gpointer v_object);
void value_take_timed_queue (GValue* value, gpointer v_object);
gpointer value_get_timed_queue (const GValue* value);
GType timed_queue_get_type (void) G_GNUC_CONST;
GType hash_timed_queue_get_type (void) G_GNUC_CONST;
GType data_object_get_type (void) G_GNUC_CONST;
GType data_source_get_type (void) G_GNUC_CONST;
GType thumbnail_source_get_type (void) G_GNUC_CONST;
GType media_source_get_type (void) G_GNUC_CONST;
GType photo_source_get_type (void) G_GNUC_CONST;
GType photo_get_type (void) G_GNUC_CONST;
GType library_photo_get_type (void) G_GNUC_CONST;
gpointer background_job_ref (gpointer instance);
void background_job_unref (gpointer instance);
GParamSpec* param_spec_background_job (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_background_job (GValue* value, gpointer v_object);
void value_take_background_job (GValue* value, gpointer v_object);
gpointer value_get_background_job (const GValue* value);
GType background_job_get_type (void) G_GNUC_CONST;
static GType metadata_writer_commit_job_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
#define METADATA_WRITER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_METADATA_WRITER, MetadataWriterPrivate))
enum  {
	METADATA_WRITER_DUMMY_PROPERTY
};
gpointer config_ref (gpointer instance);
void config_unref (gpointer instance);
GParamSpec* param_spec_config (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_config (GValue* value, gpointer v_object);
void value_take_config (GValue* value, gpointer v_object);
gpointer value_get_config (const GValue* value);
GType config_get_type (void) G_GNUC_CONST;
Config* config_get_instance (void);
static void metadata_writer_on_config_bool_changed (MetadataWriter* self, const gchar* path, gboolean value);
static void _metadata_writer_on_config_bool_changed_config_bool_changed (Config* _sender, const gchar* path, gboolean value, gpointer self);
gpointer data_collection_ref (gpointer instance);
void data_collection_unref (gpointer instance);
GParamSpec* param_spec_data_collection (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_data_collection (GValue* value, gpointer v_object);
void value_take_data_collection (GValue* value, gpointer v_object);
gpointer value_get_data_collection (const GValue* value);
GType data_collection_get_type (void) G_GNUC_CONST;
GType source_collection_get_type (void) G_GNUC_CONST;
GType database_source_collection_get_type (void) G_GNUC_CONST;
GType media_source_collection_get_type (void) G_GNUC_CONST;
GType library_photo_source_collection_get_type (void) G_GNUC_CONST;
static void metadata_writer_on_importing_photos (MetadataWriter* self, GeeCollection* media_sources);
static void _metadata_writer_on_importing_photos_media_source_collection_media_import_starting (MediaSourceCollection* _sender, GeeCollection* media, gpointer self);
static void metadata_writer_on_photos_imported (MetadataWriter* self, GeeCollection* media_sources);
static void _metadata_writer_on_photos_imported_media_source_collection_media_import_completed (MediaSourceCollection* _sender, GeeCollection* media, gpointer self);
static void metadata_writer_on_photos_added_removed (MetadataWriter* self, GeeIterable* added, GeeIterable* removed);
static void _metadata_writer_on_photos_added_removed_data_collection_contents_altered (DataCollection* _sender, GeeIterable* added, GeeIterable* removed, gpointer self);
gpointer alteration_ref (gpointer instance);
void alteration_unref (gpointer instance);
GParamSpec* param_spec_alteration (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_alteration (GValue* value, gpointer v_object);
void value_take_alteration (GValue* value, gpointer v_object);
gpointer value_get_alteration (const GValue* value);
GType alteration_get_type (void) G_GNUC_CONST;
static void metadata_writer_on_photos_altered (MetadataWriter* self, GeeMap* items);
static void _metadata_writer_on_photos_altered_data_collection_items_altered (DataCollection* _sender, GeeMap* items, gpointer self);
static void metadata_writer_on_collection_frozen (MetadataWriter* self);
static void _metadata_writer_on_collection_frozen_data_collection_frozen (DataCollection* _sender, gpointer self);
static void metadata_writer_on_collection_thawed (MetadataWriter* self);
static void _metadata_writer_on_collection_thawed_data_collection_thawed (DataCollection* _sender, gpointer self);
static void metadata_writer_on_photos_destroyed (MetadataWriter* self, GeeCollection* destroyed);
static void _metadata_writer_on_photos_destroyed_source_collection_items_destroyed (SourceCollection* _sender, GeeCollection* destroyed, gpointer self);
GType container_source_collection_get_type (void) G_GNUC_CONST;
GType tag_source_collection_get_type (void) G_GNUC_CONST;
static void metadata_writer_on_tags_altered (MetadataWriter* self, GeeMap* map);
static void _metadata_writer_on_tags_altered_data_collection_items_altered (DataCollection* _sender, GeeMap* items, gpointer self);
gpointer source_backlink_ref (gpointer instance);
void source_backlink_unref (gpointer instance);
GParamSpec* param_spec_source_backlink (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_source_backlink (GValue* value, gpointer v_object);
void value_take_source_backlink (GValue* value, gpointer v_object);
gpointer value_get_source_backlink (const GValue* value);
GType source_backlink_get_type (void) G_GNUC_CONST;
GType container_source_get_type (void) G_GNUC_CONST;
static void metadata_writer_on_tag_contents_altered (MetadataWriter* self, ContainerSource* container, GeeCollection* added, gboolean relinking, GeeCollection* removed, gboolean unlinking);
static void _metadata_writer_on_tag_contents_altered_container_source_collection_container_contents_altered (ContainerSourceCollection* _sender, ContainerSource* container, GeeCollection* added, gboolean relinked, GeeCollection* removed, gboolean unlinked, gpointer self);
static void metadata_writer_on_tag_backlink_removed (MetadataWriter* self, ContainerSource* container, GeeCollection* sources);
static void _metadata_writer_on_tag_backlink_removed_container_source_collection_backlink_to_container_removed (ContainerSourceCollection* _sender, ContainerSource* container, GeeCollection* sources, gpointer self);
gpointer application_ref (gpointer instance);
void application_unref (gpointer instance);
GParamSpec* param_spec_application (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_application (GValue* value, gpointer v_object);
void value_take_application (GValue* value, gpointer v_object);
gpointer value_get_application (const GValue* value);
GType application_get_type (void) G_GNUC_CONST;
Application* application_get_instance (void);
static void metadata_writer_on_application_exiting (MetadataWriter* self);
static void _metadata_writer_on_application_exiting_application_exiting (Application* _sender, gboolean panicked, gpointer self);
gpointer library_monitor_pool_ref (gpointer instance);
void library_monitor_pool_unref (gpointer instance);
GParamSpec* param_spec_library_monitor_pool (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_library_monitor_pool (GValue* value, gpointer v_object);
void value_take_library_monitor_pool (GValue* value, gpointer v_object);
gpointer value_get_library_monitor_pool (const GValue* value);
GType library_monitor_pool_get_type (void) G_GNUC_CONST;
LibraryMonitorPool* library_monitor_pool_get_instance (void);
GType directory_monitor_get_type (void) G_GNUC_CONST;
GType library_monitor_get_type (void) G_GNUC_CONST;
LibraryMonitor* library_monitor_pool_get_monitor (LibraryMonitorPool* self);
static void metadata_writer_on_discovery_completed (MetadataWriter* self);
static void _metadata_writer_on_discovery_completed_directory_monitor_discovery_completed (DirectoryMonitor* _sender, gpointer self);
Workers* workers_new (gint max_threads, gboolean exclusive);
Workers* workers_construct (GType object_type, gint max_threads, gboolean exclusive);
#define METADATA_WRITER_COMMIT_DELAY_MSEC ((guint) 3000)
#define METADATA_WRITER_COMMIT_SPACING_MSEC ((guint) 50)
static MetadataWriter* metadata_writer_new (void);
static MetadataWriter* metadata_writer_construct (GType object_type);
static void metadata_writer_on_photo_dequeued (MetadataWriter* self, LibraryPhoto* photo);
static void _metadata_writer_on_photo_dequeued_dequeued_callback (gconstpointer item, gpointer self);
HashTimedQueue* hash_timed_queue_new (GType g_type, GBoxedCopyFunc g_dup_func, GDestroyNotify g_destroy_func, guint hold_msec, DequeuedCallback callback, void* callback_target, GHashFunc hash_func, GEqualFunc equal_func, gint priority);
HashTimedQueue* hash_timed_queue_construct (GType object_type, GType g_type, GBoxedCopyFunc g_dup_func, GDestroyNotify g_destroy_func, guint hold_msec, DequeuedCallback callback, void* callback_target, GHashFunc hash_func, GEqualFunc equal_func, gint priority);
void timed_queue_set_dequeue_spacing_msec (TimedQueue* self, guint msec);
void metadata_writer_pause (MetadataWriter* self);
gboolean config_get_commit_metadata_to_masters (Config* self);
void metadata_writer_force_rescan (MetadataWriter* self);
void metadata_writer_init (void);
void metadata_writer_terminate (void);
void metadata_writer_close (MetadataWriter* self);
MetadataWriter* metadata_writer_get_instance (void);
static void metadata_writer_schedule_if_dirty (MetadataWriter* self, GeeIterable* media_sources, const gchar* reason);
GeeCollection* data_collection_get_all (DataCollection* self);
void timed_queue_pause (TimedQueue* self);
void metadata_writer_unpause (MetadataWriter* self);
void timed_queue_unpause (TimedQueue* self);
static void metadata_writer_cancel_all (MetadataWriter* self, gboolean wait);
#define CONFIG_PATH_SHOTWELL "/apps/shotwell"
#define CONFIG_PATH_SHOTWELL_PREFS CONFIG_PATH_SHOTWELL "/preferences"
#define CONFIG_BOOL_COMMIT_METADATA_TO_MASTERS CONFIG_PATH_SHOTWELL_PREFS "/files/commit_metadata"
static gboolean metadata_writer_cancel_job (MetadataWriter* self, LibraryPhoto* photo);
gboolean alteration_has_detail (Alteration* self, const gchar* subject, const gchar* detail);
GeeCollection* alteration_get_details (Alteration* self, const gchar* subject);
static void metadata_writer_photos_are_dirty (MetadataWriter* self, GeeCollection* photos, const gchar* reason, gboolean already_marked);
GType tag_get_type (void) G_GNUC_CONST;
GeeCollection* tag_get_sources (Tag* self);
gchar* data_object_to_string (DataObject* self);
static void metadata_writer_count_enqueued_work (MetadataWriter* self, gint count, gboolean report);
static void metadata_writer_count_cancelled_work (MetadataWriter* self, gint count, gboolean report);
static void metadata_writer_count_completed_work (MetadataWriter* self, gint count, gboolean report);
gboolean photo_is_master_metadata_dirty (Photo* self);
gpointer transaction_controller_ref (gpointer instance);
void transaction_controller_unref (gpointer instance);
GParamSpec* param_spec_transaction_controller (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_transaction_controller (GValue* value, gpointer v_object);
void value_take_transaction_controller (GValue* value, gpointer v_object);
gpointer value_get_transaction_controller (const GValue* value);
GType transaction_controller_get_type (void) G_GNUC_CONST;
TransactionController* media_source_collection_get_transaction_controller (MediaSourceCollection* self);
void transaction_controller_begin (TransactionController* self);
GQuark database_error_quark (void);
void photo_set_master_metadata_dirty (Photo* self, gboolean dirty, GError** error);
void transaction_controller_commit (TransactionController* self);
void app_window_database_error (GError* err);
gboolean timed_queue_enqueue (TimedQueue* self, gconstpointer item);
void timed_queue_clear (TimedQueue* self);
void background_job_cancel (BackgroundJob* self);
void workers_wait_for_empty_queue (Workers* self);
gboolean timed_queue_contains (TimedQueue* self, gconstpointer item);
gboolean timed_queue_remove_first (TimedQueue* self, gconstpointer item);
GeeList* tag_source_collection_fetch_for_source (TagSourceCollection* self, MediaSource* source);
gchar* data_object_get_name (DataObject* self);
static MetadataWriterCommitJob* metadata_writer_commit_job_new (MetadataWriter* owner, LibraryPhoto* photo, GeeSet* keywords);
static MetadataWriterCommitJob* metadata_writer_commit_job_construct (GType object_type, MetadataWriter* owner, LibraryPhoto* photo, GeeSet* keywords);
void workers_enqueue (Workers* self, BackgroundJob* job);
static void metadata_writer_on_update_completed (MetadataWriter* self, BackgroundJob* j);
GType background_job_job_priority_get_type (void) G_GNUC_CONST;
gpointer photo_reimport_master_state_ref (gpointer instance);
void photo_reimport_master_state_unref (gpointer instance);
GParamSpec* photo_param_spec_reimport_master_state (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void photo_value_set_reimport_master_state (GValue* value, gpointer v_object);
void photo_value_take_reimport_master_state (GValue* value, gpointer v_object);
gpointer photo_value_get_reimport_master_state (const GValue* value);
GType photo_reimport_master_state_get_type (void) G_GNUC_CONST;
gpointer photo_reimport_editable_state_ref (gpointer instance);
void photo_reimport_editable_state_unref (gpointer instance);
GParamSpec* photo_param_spec_reimport_editable_state (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void photo_value_set_reimport_editable_state (GValue* value, gpointer v_object);
void photo_value_take_reimport_editable_state (GValue* value, gpointer v_object);
gpointer photo_value_get_reimport_editable_state (const GValue* value);
GType photo_reimport_editable_state_get_type (void) G_GNUC_CONST;
void photo_finish_update_master_metadata (Photo* self, PhotoReimportMasterState* state, GError** error);
void photo_finish_update_editable_metadata (Photo* self, PhotoReimportEditableState* state, GError** error);
static void metadata_writer_on_update_cancelled (MetadataWriter* self, BackgroundJob* j);
static void g_cclosure_user_marshal_VOID__UINT_UINT (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);
enum  {
	METADATA_WRITER_COMMIT_JOB_DUMMY_PROPERTY
};
static void _metadata_writer_on_update_completed_completion_callback (BackgroundJob* job, gpointer self);
static void _metadata_writer_on_update_cancelled_cancellation_callback (BackgroundJob* job, gpointer self);
BackgroundJob* background_job_construct (GType object_type, GObject* owner, CompletionCallback callback, void* callback_target, GCancellable* cancellable, CancellationCallback cancellation, void* cancellation_target);
static void metadata_writer_commit_job_real_execute (BackgroundJob* base);
static void metadata_writer_commit_job_commit_master (MetadataWriterCommitJob* self, GError** error);
static void metadata_writer_commit_job_commit_editable (MetadataWriterCommitJob* self, GError** error);
GType photo_file_format_get_type (void) G_GNUC_CONST;
PhotoFileFormat photo_get_master_file_format (Photo* self);
gboolean photo_file_format_can_write_metadata (PhotoFileFormat self);
gpointer media_metadata_ref (gpointer instance);
void media_metadata_unref (gpointer instance);
GParamSpec* param_spec_media_metadata (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_media_metadata (GValue* value, gpointer v_object);
void value_take_media_metadata (GValue* value, gpointer v_object);
gpointer value_get_media_metadata (const GValue* value);
GType media_metadata_get_type (void) G_GNUC_CONST;
GType photo_metadata_get_type (void) G_GNUC_CONST;
PhotoMetadata* photo_get_master_metadata (Photo* self, GError** error);
static gboolean metadata_writer_commit_job_update_metadata (MetadataWriterCommitJob* self, PhotoMetadata* metadata);
void library_monitor_blacklist_file (GFile* file, const gchar* reason);
GFile* media_source_get_master_file (MediaSource* self);
gboolean photo_persist_master_metadata (Photo* self, PhotoMetadata* metadata, PhotoReimportMasterState** state, GError** error);
void library_monitor_unblacklist_file (GFile* file);
gboolean photo_has_editable (Photo* self);
PhotoFileFormat* photo_get_editable_file_format (Photo* self);
PhotoMetadata* photo_get_editable_metadata (Photo* self, GError** error);
GFile* photo_get_editable_file (Photo* self);
gboolean photo_persist_editable_metadata (Photo* self, PhotoMetadata* metadata, PhotoReimportEditableState** state, GError** error);
gchar* media_source_get_title (MediaSource* self);
gchar* media_metadata_get_title (MediaMetadata* self);
GType photo_metadata_set_option_get_type (void) G_GNUC_CONST;
void photo_metadata_set_title (PhotoMetadata* self, const gchar* title, PhotoMetadataSetOption option);
GType rating_get_type (void) G_GNUC_CONST;
Rating media_source_get_rating (MediaSource* self);
Rating photo_metadata_get_rating (PhotoMetadata* self);
void photo_metadata_set_rating (PhotoMetadata* self, Rating rating);
time_t media_source_get_exposure_time (MediaSource* self);
gpointer metadata_date_time_ref (gpointer instance);
void metadata_date_time_unref (gpointer instance);
GParamSpec* param_spec_metadata_date_time (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_metadata_date_time (GValue* value, gpointer v_object);
void value_take_metadata_date_time (GValue* value, gpointer v_object);
gpointer value_get_metadata_date_time (const GValue* value);
GType metadata_date_time_get_type (void) G_GNUC_CONST;
MetadataDateTime* photo_metadata_get_exposure_date_time (PhotoMetadata* self);
time_t metadata_date_time_get_timestamp (MetadataDateTime* self);
MetadataDateTime* metadata_date_time_new (time_t timestamp);
MetadataDateTime* metadata_date_time_construct (GType object_type, time_t timestamp);
void photo_metadata_set_exposure_date_time (PhotoMetadata* self, MetadataDateTime* date_time, PhotoMetadataSetOption option);
gboolean equal_sets (GeeSet* a, GeeSet* b);
GeeSet* photo_metadata_get_keywords (PhotoMetadata* self, GCompareFunc compare_func);
void photo_metadata_set_keywords (PhotoMetadata* self, GeeCollection* keywords, PhotoMetadataSetOption option);
GType orientation_get_type (void) G_GNUC_CONST;
Orientation photo_get_orientation (Photo* self);
Orientation photo_metadata_get_orientation (PhotoMetadata* self);
void photo_metadata_set_orientation (PhotoMetadata* self, Orientation orientation);
void photo_metadata_set_software (PhotoMetadata* self, const gchar* software, const gchar* version);
#define RESOURCES_APP_TITLE "Shotwell"
#define RESOURCES_APP_VERSION _VERSION
static void metadata_writer_commit_job_finalize (BackgroundJob* obj);
static void metadata_writer_finalize (GObject* obj);

static const gchar* METADATA_WRITER_INTERESTED_PHOTO_METADATA_DETAILS[3] = {"name", "rating", "exposure-time"};

static void _metadata_writer_on_config_bool_changed_config_bool_changed (Config* _sender, const gchar* path, gboolean value, gpointer self) {
#line 182 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	metadata_writer_on_config_bool_changed (self, path, value);
#line 794 "MetadataWriter.c"
}


static void _metadata_writer_on_importing_photos_media_source_collection_media_import_starting (MediaSourceCollection* _sender, GeeCollection* media, gpointer self) {
#line 184 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	metadata_writer_on_importing_photos (self, media);
#line 801 "MetadataWriter.c"
}


static void _metadata_writer_on_photos_imported_media_source_collection_media_import_completed (MediaSourceCollection* _sender, GeeCollection* media, gpointer self) {
#line 185 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	metadata_writer_on_photos_imported (self, media);
#line 808 "MetadataWriter.c"
}


static void _metadata_writer_on_photos_added_removed_data_collection_contents_altered (DataCollection* _sender, GeeIterable* added, GeeIterable* removed, gpointer self) {
#line 186 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	metadata_writer_on_photos_added_removed (self, added, removed);
#line 815 "MetadataWriter.c"
}


static void _metadata_writer_on_photos_altered_data_collection_items_altered (DataCollection* _sender, GeeMap* items, gpointer self) {
#line 187 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	metadata_writer_on_photos_altered (self, items);
#line 822 "MetadataWriter.c"
}


static void _metadata_writer_on_collection_frozen_data_collection_frozen (DataCollection* _sender, gpointer self) {
#line 188 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	metadata_writer_on_collection_frozen (self);
#line 829 "MetadataWriter.c"
}


static void _metadata_writer_on_collection_thawed_data_collection_thawed (DataCollection* _sender, gpointer self) {
#line 189 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	metadata_writer_on_collection_thawed (self);
#line 836 "MetadataWriter.c"
}


static void _metadata_writer_on_photos_destroyed_source_collection_items_destroyed (SourceCollection* _sender, GeeCollection* destroyed, gpointer self) {
#line 190 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	metadata_writer_on_photos_destroyed (self, destroyed);
#line 843 "MetadataWriter.c"
}


static void _metadata_writer_on_tags_altered_data_collection_items_altered (DataCollection* _sender, GeeMap* items, gpointer self) {
#line 192 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	metadata_writer_on_tags_altered (self, items);
#line 850 "MetadataWriter.c"
}


static void _metadata_writer_on_tag_contents_altered_container_source_collection_container_contents_altered (ContainerSourceCollection* _sender, ContainerSource* container, GeeCollection* added, gboolean relinked, GeeCollection* removed, gboolean unlinked, gpointer self) {
#line 193 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	metadata_writer_on_tag_contents_altered (self, container, added, relinked, removed, unlinked);
#line 857 "MetadataWriter.c"
}


static void _metadata_writer_on_tag_backlink_removed_container_source_collection_backlink_to_container_removed (ContainerSourceCollection* _sender, ContainerSource* container, GeeCollection* sources, gpointer self) {
#line 194 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	metadata_writer_on_tag_backlink_removed (self, container, sources);
#line 864 "MetadataWriter.c"
}


static void _metadata_writer_on_application_exiting_application_exiting (Application* _sender, gboolean panicked, gpointer self) {
#line 198 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	metadata_writer_on_application_exiting (self);
#line 871 "MetadataWriter.c"
}


static void _metadata_writer_on_discovery_completed_directory_monitor_discovery_completed (DirectoryMonitor* _sender, gpointer self) {
#line 200 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	metadata_writer_on_discovery_completed (self);
#line 878 "MetadataWriter.c"
}


static void _metadata_writer_on_photo_dequeued_dequeued_callback (gconstpointer item, gpointer self) {
#line 143 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	metadata_writer_on_photo_dequeued (self, item);
#line 885 "MetadataWriter.c"
}


static MetadataWriter* metadata_writer_construct (GType object_type) {
	MetadataWriter * self = NULL;
	HashTimedQueue* _tmp0_;
	HashTimedQueue* _tmp1_;
	Config* _tmp5_ = NULL;
	Config* _tmp6_;
	gboolean _tmp7_ = FALSE;
	Config* _tmp8_ = NULL;
	Config* _tmp9_;
	LibraryPhotoSourceCollection* _tmp10_;
	LibraryPhotoSourceCollection* _tmp11_;
	LibraryPhotoSourceCollection* _tmp12_;
	LibraryPhotoSourceCollection* _tmp13_;
	LibraryPhotoSourceCollection* _tmp14_;
	LibraryPhotoSourceCollection* _tmp15_;
	LibraryPhotoSourceCollection* _tmp16_;
	TagSourceCollection* _tmp17_;
	TagSourceCollection* _tmp18_;
	TagSourceCollection* _tmp19_;
	TagSourceCollection* _tmp20_;
	TagSourceCollection* _tmp21_;
	Application* _tmp22_ = NULL;
	Application* _tmp23_;
	LibraryMonitorPool* _tmp24_ = NULL;
	LibraryMonitorPool* _tmp25_;
	LibraryMonitor* _tmp26_ = NULL;
	LibraryMonitor* _tmp27_;
#line 142 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	self = (MetadataWriter*) g_object_new (object_type, NULL);
#line 143 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp0_ = hash_timed_queue_new (TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, g_object_unref, METADATA_WRITER_COMMIT_DELAY_MSEC, _metadata_writer_on_photo_dequeued_dequeued_callback, self, NULL, NULL, G_PRIORITY_DEFAULT);
#line 143 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_timed_queue_unref0 (self->priv->dirty);
#line 143 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	self->priv->dirty = _tmp0_;
#line 144 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp1_ = self->priv->dirty;
#line 144 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	timed_queue_set_dequeue_spacing_msec (TIMED_QUEUE (_tmp1_), METADATA_WRITER_COMMIT_SPACING_MSEC);
#line 149 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	metadata_writer_pause (self);
#line 930 "MetadataWriter.c"
	{
		const gchar** detail_collection = NULL;
		gint detail_collection_length1 = 0;
		gint _detail_collection_size_ = 0;
		gint detail_it = 0;
#line 152 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		detail_collection = METADATA_WRITER_INTERESTED_PHOTO_METADATA_DETAILS;
#line 152 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		detail_collection_length1 = G_N_ELEMENTS (METADATA_WRITER_INTERESTED_PHOTO_METADATA_DETAILS);
#line 152 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		for (detail_it = 0; detail_it < G_N_ELEMENTS (METADATA_WRITER_INTERESTED_PHOTO_METADATA_DETAILS); detail_it = detail_it + 1) {
#line 942 "MetadataWriter.c"
			gchar* _tmp2_;
			gchar* detail = NULL;
#line 152 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			_tmp2_ = g_strdup (detail_collection[detail_it]);
#line 152 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			detail = _tmp2_;
#line 949 "MetadataWriter.c"
			{
				GeeHashSet* _tmp3_;
				const gchar* _tmp4_;
#line 153 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
				_tmp3_ = self->priv->interested_photo_details;
#line 153 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
				_tmp4_ = detail;
#line 153 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
				gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (_tmp3_), _tmp4_);
#line 152 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
				_g_free0 (detail);
#line 961 "MetadataWriter.c"
			}
		}
	}
#line 156 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp5_ = config_get_instance ();
#line 156 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp6_ = _tmp5_;
#line 156 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp7_ = config_get_commit_metadata_to_masters (_tmp6_);
#line 156 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	self->priv->enabled = _tmp7_;
#line 156 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_config_unref0 (_tmp6_);
#line 157 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp8_ = config_get_instance ();
#line 157 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp9_ = _tmp8_;
#line 157 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	g_signal_connect_object (_tmp9_, "bool-changed", (GCallback) _metadata_writer_on_config_bool_changed_config_bool_changed, self, 0);
#line 157 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_config_unref0 (_tmp9_);
#line 160 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	metadata_writer_force_rescan (self);
#line 162 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp10_ = library_photo_global;
#line 162 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	g_signal_connect_object (MEDIA_SOURCE_COLLECTION (_tmp10_), "media-import-starting", (GCallback) _metadata_writer_on_importing_photos_media_source_collection_media_import_starting, self, 0);
#line 163 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp11_ = library_photo_global;
#line 163 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	g_signal_connect_object (MEDIA_SOURCE_COLLECTION (_tmp11_), "media-import-completed", (GCallback) _metadata_writer_on_photos_imported_media_source_collection_media_import_completed, self, 0);
#line 164 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp12_ = library_photo_global;
#line 164 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	g_signal_connect_object (DATA_COLLECTION (_tmp12_), "contents-altered", (GCallback) _metadata_writer_on_photos_added_removed_data_collection_contents_altered, self, 0);
#line 165 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp13_ = library_photo_global;
#line 165 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	g_signal_connect_object (DATA_COLLECTION (_tmp13_), "items-altered", (GCallback) _metadata_writer_on_photos_altered_data_collection_items_altered, self, 0);
#line 166 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp14_ = library_photo_global;
#line 166 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	g_signal_connect_object (DATA_COLLECTION (_tmp14_), "frozen", (GCallback) _metadata_writer_on_collection_frozen_data_collection_frozen, self, 0);
#line 167 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp15_ = library_photo_global;
#line 167 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	g_signal_connect_object (DATA_COLLECTION (_tmp15_), "thawed", (GCallback) _metadata_writer_on_collection_thawed_data_collection_thawed, self, 0);
#line 168 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp16_ = library_photo_global;
#line 168 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	g_signal_connect_object (SOURCE_COLLECTION (_tmp16_), "items-destroyed", (GCallback) _metadata_writer_on_photos_destroyed_source_collection_items_destroyed, self, 0);
#line 170 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp17_ = tag_global;
#line 170 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	g_signal_connect_object (DATA_COLLECTION (_tmp17_), "items-altered", (GCallback) _metadata_writer_on_tags_altered_data_collection_items_altered, self, 0);
#line 171 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp18_ = tag_global;
#line 171 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	g_signal_connect_object (CONTAINER_SOURCE_COLLECTION (_tmp18_), "container-contents-altered", (GCallback) _metadata_writer_on_tag_contents_altered_container_source_collection_container_contents_altered, self, 0);
#line 172 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp19_ = tag_global;
#line 172 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	g_signal_connect_object (CONTAINER_SOURCE_COLLECTION (_tmp19_), "backlink-to-container-removed", (GCallback) _metadata_writer_on_tag_backlink_removed_container_source_collection_backlink_to_container_removed, self, 0);
#line 173 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp20_ = tag_global;
#line 173 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	g_signal_connect_object (DATA_COLLECTION (_tmp20_), "frozen", (GCallback) _metadata_writer_on_collection_frozen_data_collection_frozen, self, 0);
#line 174 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp21_ = tag_global;
#line 174 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	g_signal_connect_object (DATA_COLLECTION (_tmp21_), "thawed", (GCallback) _metadata_writer_on_collection_thawed_data_collection_thawed, self, 0);
#line 176 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp22_ = application_get_instance ();
#line 176 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp23_ = _tmp22_;
#line 176 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	g_signal_connect_object (_tmp23_, "exiting", (GCallback) _metadata_writer_on_application_exiting_application_exiting, self, 0);
#line 176 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_application_unref0 (_tmp23_);
#line 178 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp24_ = library_monitor_pool_get_instance ();
#line 178 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp25_ = _tmp24_;
#line 178 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp26_ = library_monitor_pool_get_monitor (_tmp25_);
#line 178 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp27_ = _tmp26_;
#line 178 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	g_signal_connect_object (DIRECTORY_MONITOR (_tmp27_), "discovery-completed", (GCallback) _metadata_writer_on_discovery_completed_directory_monitor_discovery_completed, self, 0);
#line 178 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_g_object_unref0 (_tmp27_);
#line 178 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_library_monitor_pool_unref0 (_tmp25_);
#line 142 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	return self;
#line 1057 "MetadataWriter.c"
}


static MetadataWriter* metadata_writer_new (void) {
#line 142 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	return metadata_writer_construct (TYPE_METADATA_WRITER);
#line 1064 "MetadataWriter.c"
}


void metadata_writer_init (void) {
	MetadataWriter* _tmp0_;
#line 204 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp0_ = metadata_writer_new ();
#line 204 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_g_object_unref0 (metadata_writer_instance);
#line 204 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	metadata_writer_instance = _tmp0_;
#line 1076 "MetadataWriter.c"
}


void metadata_writer_terminate (void) {
	MetadataWriter* _tmp0_;
#line 208 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp0_ = metadata_writer_instance;
#line 208 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	if (_tmp0_ != NULL) {
#line 1086 "MetadataWriter.c"
		MetadataWriter* _tmp1_;
#line 209 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_tmp1_ = metadata_writer_instance;
#line 209 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		metadata_writer_close (_tmp1_);
#line 1092 "MetadataWriter.c"
	}
#line 211 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_g_object_unref0 (metadata_writer_instance);
#line 211 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	metadata_writer_instance = NULL;
#line 1098 "MetadataWriter.c"
}


static gpointer _g_object_ref0 (gpointer self) {
#line 215 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	return self ? g_object_ref (self) : NULL;
#line 1105 "MetadataWriter.c"
}


MetadataWriter* metadata_writer_get_instance (void) {
	MetadataWriter* result = NULL;
	MetadataWriter* _tmp0_;
	MetadataWriter* _tmp1_;
#line 215 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp0_ = metadata_writer_instance;
#line 215 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 215 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	result = _tmp1_;
#line 215 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	return result;
#line 1121 "MetadataWriter.c"
}


void metadata_writer_force_rescan (MetadataWriter* self) {
	LibraryPhotoSourceCollection* _tmp0_;
	GeeCollection* _tmp1_ = NULL;
	GeeCollection* _tmp2_;
#line 219 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	g_return_if_fail (IS_METADATA_WRITER (self));
#line 220 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp0_ = library_photo_global;
#line 220 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp1_ = data_collection_get_all (DATA_COLLECTION (_tmp0_));
#line 220 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp2_ = GEE_COLLECTION (_tmp1_);
#line 220 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	metadata_writer_schedule_if_dirty (self, GEE_ITERABLE (_tmp2_), "force rescan");
#line 220 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_g_object_unref0 (_tmp2_);
#line 1141 "MetadataWriter.c"
}


void metadata_writer_pause (MetadataWriter* self) {
	gint _tmp0_;
	HashTimedQueue* _tmp1_;
#line 223 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	g_return_if_fail (IS_METADATA_WRITER (self));
#line 224 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp0_ = self->priv->pause_count;
#line 224 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	self->priv->pause_count = _tmp0_ + 1;
#line 224 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	if (_tmp0_ != 0) {
#line 225 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		return;
#line 1158 "MetadataWriter.c"
	}
#line 227 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp1_ = self->priv->dirty;
#line 227 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	timed_queue_pause (TIMED_QUEUE (_tmp1_));
#line 229 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	g_signal_emit_by_name (self, "progress", (guint) 0, (guint) 0);
#line 1166 "MetadataWriter.c"
}


void metadata_writer_unpause (MetadataWriter* self) {
	gboolean _tmp0_ = FALSE;
	gint _tmp1_;
	gboolean _tmp4_;
	HashTimedQueue* _tmp5_;
#line 232 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	g_return_if_fail (IS_METADATA_WRITER (self));
#line 233 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp1_ = self->priv->pause_count;
#line 233 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	if (_tmp1_ == 0) {
#line 233 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_tmp0_ = TRUE;
#line 1183 "MetadataWriter.c"
	} else {
		gint _tmp2_;
		gint _tmp3_;
#line 233 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_tmp2_ = self->priv->pause_count;
#line 233 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		self->priv->pause_count = _tmp2_ - 1;
#line 233 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_tmp3_ = self->priv->pause_count;
#line 233 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_tmp0_ = _tmp3_ != 0;
#line 1195 "MetadataWriter.c"
	}
#line 233 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp4_ = _tmp0_;
#line 233 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	if (_tmp4_) {
#line 234 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		return;
#line 1203 "MetadataWriter.c"
	}
#line 236 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp5_ = self->priv->dirty;
#line 236 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	timed_queue_unpause (TIMED_QUEUE (_tmp5_));
#line 1209 "MetadataWriter.c"
}


void metadata_writer_close (MetadataWriter* self) {
	gboolean _tmp0_;
#line 239 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	g_return_if_fail (IS_METADATA_WRITER (self));
#line 240 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp0_ = self->priv->closed;
#line 240 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	if (_tmp0_) {
#line 241 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		return;
#line 1223 "MetadataWriter.c"
	}
#line 243 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	metadata_writer_cancel_all (self, TRUE);
#line 245 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	self->priv->closed = TRUE;
#line 1229 "MetadataWriter.c"
}


static void metadata_writer_on_config_bool_changed (MetadataWriter* self, const gchar* path, gboolean value) {
	const gchar* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_;
#line 248 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	g_return_if_fail (IS_METADATA_WRITER (self));
#line 248 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	g_return_if_fail (path != NULL);
#line 249 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp0_ = path;
#line 249 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	if (g_strcmp0 (_tmp0_, CONFIG_BOOL_COMMIT_METADATA_TO_MASTERS) != 0) {
#line 250 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		return;
#line 1249 "MetadataWriter.c"
	}
#line 252 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp1_ = self->priv->enabled;
#line 252 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp2_ = value;
#line 252 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	if (_tmp1_ == _tmp2_) {
#line 253 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		return;
#line 1259 "MetadataWriter.c"
	}
#line 255 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp3_ = value;
#line 255 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	self->priv->enabled = _tmp3_;
#line 256 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp4_ = self->priv->enabled;
#line 256 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	if (_tmp4_) {
#line 257 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		metadata_writer_force_rescan (self);
#line 1271 "MetadataWriter.c"
	} else {
#line 259 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		metadata_writer_cancel_all (self, FALSE);
#line 1275 "MetadataWriter.c"
	}
}


static void metadata_writer_on_application_exiting (MetadataWriter* self) {
#line 262 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	g_return_if_fail (IS_METADATA_WRITER (self));
#line 263 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	metadata_writer_close (self);
#line 1285 "MetadataWriter.c"
}


static void metadata_writer_on_discovery_completed (MetadataWriter* self) {
#line 266 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	g_return_if_fail (IS_METADATA_WRITER (self));
#line 267 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	metadata_writer_unpause (self);
#line 1294 "MetadataWriter.c"
}


static void metadata_writer_on_collection_frozen (MetadataWriter* self) {
#line 270 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	g_return_if_fail (IS_METADATA_WRITER (self));
#line 271 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	metadata_writer_pause (self);
#line 1303 "MetadataWriter.c"
}


static void metadata_writer_on_collection_thawed (MetadataWriter* self) {
#line 274 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	g_return_if_fail (IS_METADATA_WRITER (self));
#line 275 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	metadata_writer_unpause (self);
#line 1312 "MetadataWriter.c"
}


static void metadata_writer_on_importing_photos (MetadataWriter* self, GeeCollection* media_sources) {
	GeeHashSet* _tmp0_;
	GeeCollection* _tmp1_;
#line 278 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	g_return_if_fail (IS_METADATA_WRITER (self));
#line 278 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	g_return_if_fail (GEE_IS_COLLECTION (media_sources));
#line 279 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp0_ = self->priv->importing_photos;
#line 279 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp1_ = media_sources;
#line 279 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	gee_abstract_collection_add_all (GEE_ABSTRACT_COLLECTION (_tmp0_), GEE_COLLECTION (_tmp1_));
#line 1329 "MetadataWriter.c"
}


static void metadata_writer_on_photos_imported (MetadataWriter* self, GeeCollection* media_sources) {
	GeeHashSet* _tmp0_;
	GeeCollection* _tmp1_;
#line 282 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	g_return_if_fail (IS_METADATA_WRITER (self));
#line 282 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	g_return_if_fail (GEE_IS_COLLECTION (media_sources));
#line 283 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp0_ = self->priv->importing_photos;
#line 283 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp1_ = media_sources;
#line 283 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	gee_abstract_collection_remove_all (GEE_ABSTRACT_COLLECTION (_tmp0_), GEE_COLLECTION (_tmp1_));
#line 1346 "MetadataWriter.c"
}


static void metadata_writer_on_photos_added_removed (MetadataWriter* self, GeeIterable* added, GeeIterable* removed) {
	gboolean _tmp0_ = FALSE;
	GeeIterable* _tmp1_;
	gboolean _tmp3_;
	GeeIterable* _tmp5_;
#line 286 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	g_return_if_fail (IS_METADATA_WRITER (self));
#line 286 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	g_return_if_fail ((added == NULL) || GEE_IS_ITERABLE (added));
#line 286 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	g_return_if_fail ((removed == NULL) || GEE_IS_ITERABLE (removed));
#line 289 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp1_ = added;
#line 289 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	if (_tmp1_ != NULL) {
#line 1365 "MetadataWriter.c"
		gboolean _tmp2_;
#line 289 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_tmp2_ = self->priv->enabled;
#line 289 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_tmp0_ = _tmp2_;
#line 1371 "MetadataWriter.c"
	} else {
#line 289 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_tmp0_ = FALSE;
#line 1375 "MetadataWriter.c"
	}
#line 289 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp3_ = _tmp0_;
#line 289 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	if (_tmp3_) {
#line 1381 "MetadataWriter.c"
		GeeIterable* _tmp4_;
#line 290 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_tmp4_ = added;
#line 290 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		metadata_writer_schedule_if_dirty (self, GEE_ITERABLE (_tmp4_), "added to LibraryPhoto.global");
#line 1387 "MetadataWriter.c"
	}
#line 293 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp5_ = removed;
#line 293 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	if (_tmp5_ != NULL) {
#line 1393 "MetadataWriter.c"
		gboolean cancelled;
		gboolean _tmp17_;
#line 294 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		cancelled = FALSE;
#line 1398 "MetadataWriter.c"
		{
			GeeIterable* _tmp6_;
			GeeIterator* _tmp7_ = NULL;
			GeeIterator* _object_it;
#line 295 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			_tmp6_ = removed;
#line 295 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			_tmp7_ = gee_iterable_iterator (_tmp6_);
#line 295 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			_object_it = _tmp7_;
#line 295 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			while (TRUE) {
#line 1411 "MetadataWriter.c"
				GeeIterator* _tmp8_;
				gboolean _tmp9_ = FALSE;
				GeeIterator* _tmp10_;
				gpointer _tmp11_ = NULL;
				DataObject* object;
				gboolean _tmp12_ = FALSE;
				DataObject* _tmp13_;
				gboolean _tmp14_ = FALSE;
				gboolean _tmp16_;
#line 295 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
				_tmp8_ = _object_it;
#line 295 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
				_tmp9_ = gee_iterator_next (_tmp8_);
#line 295 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
				if (!_tmp9_) {
#line 295 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
					break;
#line 1429 "MetadataWriter.c"
				}
#line 295 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
				_tmp10_ = _object_it;
#line 295 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
				_tmp11_ = gee_iterator_get (_tmp10_);
#line 295 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
				object = (DataObject*) _tmp11_;
#line 296 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
				_tmp13_ = object;
#line 296 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
				_tmp14_ = metadata_writer_cancel_job (self, LIBRARY_PHOTO (_tmp13_));
#line 296 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
				if (_tmp14_) {
#line 296 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
					_tmp12_ = TRUE;
#line 1445 "MetadataWriter.c"
				} else {
					gboolean _tmp15_;
#line 296 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
					_tmp15_ = cancelled;
#line 296 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
					_tmp12_ = _tmp15_;
#line 1452 "MetadataWriter.c"
				}
#line 296 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
				_tmp16_ = _tmp12_;
#line 296 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
				cancelled = _tmp16_;
#line 295 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
				_g_object_unref0 (object);
#line 1460 "MetadataWriter.c"
			}
#line 295 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			_g_object_unref0 (_object_it);
#line 1464 "MetadataWriter.c"
		}
#line 298 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_tmp17_ = cancelled;
#line 298 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		if (_tmp17_) {
#line 1470 "MetadataWriter.c"
			guint _tmp18_;
			guint _tmp19_;
#line 299 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			_tmp18_ = self->priv->outstanding_completed;
#line 299 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			_tmp19_ = self->priv->outstanding_total;
#line 299 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			g_signal_emit_by_name (self, "progress", _tmp18_, _tmp19_);
#line 1479 "MetadataWriter.c"
		}
	}
}


static void metadata_writer_on_photos_altered (MetadataWriter* self, GeeMap* items) {
	GeeHashSet* photos;
	GeeHashSet* _tmp39_;
#line 303 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	g_return_if_fail (IS_METADATA_WRITER (self));
#line 303 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	g_return_if_fail (GEE_IS_MAP (items));
#line 304 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	photos = NULL;
#line 1494 "MetadataWriter.c"
	{
		GeeMap* _tmp0_;
		GeeSet* _tmp1_;
		GeeSet* _tmp2_;
		GeeSet* _tmp3_;
		GeeIterator* _tmp4_ = NULL;
		GeeIterator* _tmp5_;
		GeeIterator* _object_it;
#line 305 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_tmp0_ = items;
#line 305 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_tmp1_ = gee_map_get_keys (_tmp0_);
#line 305 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_tmp2_ = _tmp1_;
#line 305 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_tmp3_ = _tmp2_;
#line 305 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_tmp4_ = gee_iterable_iterator (GEE_ITERABLE (_tmp3_));
#line 305 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_tmp5_ = _tmp4_;
#line 305 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_g_object_unref0 (_tmp3_);
#line 305 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_object_it = _tmp5_;
#line 305 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		while (TRUE) {
#line 1521 "MetadataWriter.c"
			GeeIterator* _tmp6_;
			gboolean _tmp7_ = FALSE;
			GeeIterator* _tmp8_;
			gpointer _tmp9_ = NULL;
			DataObject* object;
			DataObject* _tmp10_;
			LibraryPhoto* _tmp11_;
			LibraryPhoto* photo;
			LibraryPhoto* _tmp12_;
			LibraryPhoto* _tmp13_;
			GeeMap* _tmp14_;
			DataObject* _tmp15_;
			gpointer _tmp16_ = NULL;
			Alteration* alteration;
			Alteration* _tmp17_;
			gboolean _tmp18_ = FALSE;
			Alteration* _tmp23_;
			GeeCollection* _tmp24_ = NULL;
			GeeCollection* details;
			GeeCollection* _tmp25_;
#line 305 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			_tmp6_ = _object_it;
#line 305 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			_tmp7_ = gee_iterator_next (_tmp6_);
#line 305 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			if (!_tmp7_) {
#line 305 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
				break;
#line 1550 "MetadataWriter.c"
			}
#line 305 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			_tmp8_ = _object_it;
#line 305 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			_tmp9_ = gee_iterator_get (_tmp8_);
#line 305 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			object = (DataObject*) _tmp9_;
#line 306 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			_tmp10_ = object;
#line 306 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			_tmp11_ = _g_object_ref0 (LIBRARY_PHOTO (_tmp10_));
#line 306 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			photo = _tmp11_;
#line 310 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			_tmp12_ = photo;
#line 310 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			_tmp13_ = self->priv->ignore_photo_alteration;
#line 310 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			if (_tmp12_ == _tmp13_) {
#line 311 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
				_g_object_unref0 (photo);
#line 311 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
				_g_object_unref0 (object);
#line 311 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
				continue;
#line 1576 "MetadataWriter.c"
			}
#line 313 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			_tmp14_ = items;
#line 313 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			_tmp15_ = object;
#line 313 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			_tmp16_ = gee_map_get (_tmp14_, _tmp15_);
#line 313 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			alteration = (Alteration*) _tmp16_;
#line 316 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			_tmp17_ = alteration;
#line 316 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			_tmp18_ = alteration_has_detail (_tmp17_, "image", "orientation");
#line 316 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			if (_tmp18_) {
#line 1592 "MetadataWriter.c"
				GeeHashSet* _tmp19_;
				GeeHashSet* _tmp21_;
				LibraryPhoto* _tmp22_;
#line 317 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
				_tmp19_ = photos;
#line 317 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
				if (_tmp19_ == NULL) {
#line 1600 "MetadataWriter.c"
					GeeHashSet* _tmp20_;
#line 318 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
					_tmp20_ = gee_hash_set_new (TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL);
#line 318 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
					_g_object_unref0 (photos);
#line 318 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
					photos = _tmp20_;
#line 1608 "MetadataWriter.c"
				}
#line 320 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
				_tmp21_ = photos;
#line 320 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
				_tmp22_ = photo;
#line 320 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
				gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (_tmp21_), _tmp22_);
#line 322 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
				_alteration_unref0 (alteration);
#line 322 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
				_g_object_unref0 (photo);
#line 322 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
				_g_object_unref0 (object);
#line 322 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
				continue;
#line 1624 "MetadataWriter.c"
			}
#line 326 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			_tmp23_ = alteration;
#line 326 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			_tmp24_ = alteration_get_details (_tmp23_, "metadata");
#line 326 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			details = _tmp24_;
#line 327 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			_tmp25_ = details;
#line 327 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			if (_tmp25_ == NULL) {
#line 328 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
				_g_object_unref0 (details);
#line 328 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
				_alteration_unref0 (alteration);
#line 328 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
				_g_object_unref0 (photo);
#line 328 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
				_g_object_unref0 (object);
#line 328 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
				continue;
#line 1646 "MetadataWriter.c"
			}
			{
				GeeCollection* _tmp26_;
				GeeIterator* _tmp27_ = NULL;
				GeeIterator* _detail_it;
#line 331 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
				_tmp26_ = details;
#line 331 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
				_tmp27_ = gee_iterable_iterator (GEE_ITERABLE (_tmp26_));
#line 331 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
				_detail_it = _tmp27_;
#line 331 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
				while (TRUE) {
#line 1660 "MetadataWriter.c"
					GeeIterator* _tmp28_;
					gboolean _tmp29_ = FALSE;
					GeeIterator* _tmp30_;
					gpointer _tmp31_ = NULL;
					gchar* detail;
					GeeHashSet* _tmp32_;
					const gchar* _tmp33_;
					gboolean _tmp34_ = FALSE;
#line 331 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
					_tmp28_ = _detail_it;
#line 331 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
					_tmp29_ = gee_iterator_next (_tmp28_);
#line 331 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
					if (!_tmp29_) {
#line 331 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
						break;
#line 1677 "MetadataWriter.c"
					}
#line 331 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
					_tmp30_ = _detail_it;
#line 331 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
					_tmp31_ = gee_iterator_get (_tmp30_);
#line 331 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
					detail = (gchar*) _tmp31_;
#line 332 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
					_tmp32_ = self->priv->interested_photo_details;
#line 332 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
					_tmp33_ = detail;
#line 332 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
					_tmp34_ = gee_abstract_collection_contains (GEE_ABSTRACT_COLLECTION (_tmp32_), _tmp33_);
#line 332 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
					if (_tmp34_) {
#line 1693 "MetadataWriter.c"
						GeeHashSet* _tmp35_;
						GeeHashSet* _tmp37_;
						LibraryPhoto* _tmp38_;
#line 333 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
						_tmp35_ = photos;
#line 333 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
						if (_tmp35_ == NULL) {
#line 1701 "MetadataWriter.c"
							GeeHashSet* _tmp36_;
#line 334 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
							_tmp36_ = gee_hash_set_new (TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL);
#line 334 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
							_g_object_unref0 (photos);
#line 334 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
							photos = _tmp36_;
#line 1709 "MetadataWriter.c"
						}
#line 336 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
						_tmp37_ = photos;
#line 336 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
						_tmp38_ = photo;
#line 336 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
						gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (_tmp37_), _tmp38_);
#line 338 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
						_g_free0 (detail);
#line 338 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
						break;
#line 1721 "MetadataWriter.c"
					}
#line 331 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
					_g_free0 (detail);
#line 1725 "MetadataWriter.c"
				}
#line 331 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
				_g_object_unref0 (_detail_it);
#line 1729 "MetadataWriter.c"
			}
#line 305 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			_g_object_unref0 (details);
#line 305 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			_alteration_unref0 (alteration);
#line 305 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			_g_object_unref0 (photo);
#line 305 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			_g_object_unref0 (object);
#line 1739 "MetadataWriter.c"
		}
#line 305 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_g_object_unref0 (_object_it);
#line 1743 "MetadataWriter.c"
	}
#line 343 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp39_ = photos;
#line 343 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	if (_tmp39_ != NULL) {
#line 1749 "MetadataWriter.c"
		GeeHashSet* _tmp40_;
#line 344 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_tmp40_ = photos;
#line 344 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		metadata_writer_photos_are_dirty (self, GEE_COLLECTION (_tmp40_), "alteration", FALSE);
#line 1755 "MetadataWriter.c"
	}
#line 303 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_g_object_unref0 (photos);
#line 1759 "MetadataWriter.c"
}


static void metadata_writer_on_photos_destroyed (MetadataWriter* self, GeeCollection* destroyed) {
#line 347 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	g_return_if_fail (IS_METADATA_WRITER (self));
#line 347 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	g_return_if_fail (GEE_IS_COLLECTION (destroyed));
#line 1768 "MetadataWriter.c"
	{
		GeeCollection* _tmp0_;
		GeeIterator* _tmp1_ = NULL;
		GeeIterator* _source_it;
#line 348 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_tmp0_ = destroyed;
#line 348 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_tmp1_ = gee_iterable_iterator (GEE_ITERABLE (_tmp0_));
#line 348 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_source_it = _tmp1_;
#line 348 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		while (TRUE) {
#line 1781 "MetadataWriter.c"
			GeeIterator* _tmp2_;
			gboolean _tmp3_ = FALSE;
			GeeIterator* _tmp4_;
			gpointer _tmp5_ = NULL;
			DataSource* source;
			DataSource* _tmp6_;
			LibraryPhoto* _tmp7_;
			LibraryPhoto* photo;
			LibraryPhoto* _tmp8_;
			GeeHashSet* _tmp9_;
			LibraryPhoto* _tmp10_;
#line 348 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			_tmp2_ = _source_it;
#line 348 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			_tmp3_ = gee_iterator_next (_tmp2_);
#line 348 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			if (!_tmp3_) {
#line 348 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
				break;
#line 1801 "MetadataWriter.c"
			}
#line 348 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			_tmp4_ = _source_it;
#line 348 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			_tmp5_ = gee_iterator_get (_tmp4_);
#line 348 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			source = (DataSource*) _tmp5_;
#line 349 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			_tmp6_ = source;
#line 349 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			_tmp7_ = _g_object_ref0 (LIBRARY_PHOTO (_tmp6_));
#line 349 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			photo = _tmp7_;
#line 350 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			_tmp8_ = photo;
#line 350 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			metadata_writer_cancel_job (self, _tmp8_);
#line 351 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			_tmp9_ = self->priv->importing_photos;
#line 351 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			_tmp10_ = photo;
#line 351 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			gee_abstract_collection_remove (GEE_ABSTRACT_COLLECTION (_tmp9_), _tmp10_);
#line 348 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			_g_object_unref0 (photo);
#line 348 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			_g_object_unref0 (source);
#line 1829 "MetadataWriter.c"
		}
#line 348 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_g_object_unref0 (_source_it);
#line 1833 "MetadataWriter.c"
	}
}


static void metadata_writer_on_tags_altered (MetadataWriter* self, GeeMap* map) {
	GeeHashSet* photos;
	GeeHashSet* _tmp32_;
#line 355 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	g_return_if_fail (IS_METADATA_WRITER (self));
#line 355 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	g_return_if_fail (GEE_IS_MAP (map));
#line 356 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	photos = NULL;
#line 1847 "MetadataWriter.c"
	{
		GeeMap* _tmp0_;
		GeeSet* _tmp1_;
		GeeSet* _tmp2_;
		GeeSet* _tmp3_;
		GeeIterator* _tmp4_ = NULL;
		GeeIterator* _tmp5_;
		GeeIterator* _object_it;
#line 357 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_tmp0_ = map;
#line 357 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_tmp1_ = gee_map_get_keys (_tmp0_);
#line 357 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_tmp2_ = _tmp1_;
#line 357 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_tmp3_ = _tmp2_;
#line 357 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_tmp4_ = gee_iterable_iterator (GEE_ITERABLE (_tmp3_));
#line 357 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_tmp5_ = _tmp4_;
#line 357 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_g_object_unref0 (_tmp3_);
#line 357 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_object_it = _tmp5_;
#line 357 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		while (TRUE) {
#line 1874 "MetadataWriter.c"
			GeeIterator* _tmp6_;
			gboolean _tmp7_ = FALSE;
			GeeIterator* _tmp8_;
			gpointer _tmp9_ = NULL;
			DataObject* object;
			GeeMap* _tmp10_;
			DataObject* _tmp11_;
			gpointer _tmp12_ = NULL;
			Alteration* _tmp13_;
			gboolean _tmp14_ = FALSE;
			gboolean _tmp15_;
			GeeHashSet* _tmp16_;
#line 357 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			_tmp6_ = _object_it;
#line 357 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			_tmp7_ = gee_iterator_next (_tmp6_);
#line 357 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			if (!_tmp7_) {
#line 357 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
				break;
#line 1895 "MetadataWriter.c"
			}
#line 357 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			_tmp8_ = _object_it;
#line 357 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			_tmp9_ = gee_iterator_get (_tmp8_);
#line 357 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			object = (DataObject*) _tmp9_;
#line 358 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			_tmp10_ = map;
#line 358 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			_tmp11_ = object;
#line 358 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			_tmp12_ = gee_map_get (_tmp10_, _tmp11_);
#line 358 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			_tmp13_ = (Alteration*) _tmp12_;
#line 358 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			_tmp14_ = alteration_has_detail (_tmp13_, "metadata", "name");
#line 358 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			_tmp15_ = !_tmp14_;
#line 358 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			_alteration_unref0 (_tmp13_);
#line 358 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			if (_tmp15_) {
#line 359 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
				_g_object_unref0 (object);
#line 359 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
				continue;
#line 1923 "MetadataWriter.c"
			}
#line 361 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			_tmp16_ = photos;
#line 361 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			if (_tmp16_ == NULL) {
#line 1929 "MetadataWriter.c"
				GeeHashSet* _tmp17_;
#line 362 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
				_tmp17_ = gee_hash_set_new (TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL);
#line 362 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
				_g_object_unref0 (photos);
#line 362 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
				photos = _tmp17_;
#line 1937 "MetadataWriter.c"
			}
			{
				DataObject* _tmp18_;
				GeeCollection* _tmp19_ = NULL;
				GeeCollection* _tmp20_;
				GeeIterator* _tmp21_ = NULL;
				GeeIterator* _tmp22_;
				GeeIterator* _media_it;
#line 364 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
				_tmp18_ = object;
#line 364 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
				_tmp19_ = tag_get_sources (TAG (_tmp18_));
#line 364 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
				_tmp20_ = _tmp19_;
#line 364 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
				_tmp21_ = gee_iterable_iterator (GEE_ITERABLE (_tmp20_));
#line 364 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
				_tmp22_ = _tmp21_;
#line 364 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
				_g_object_unref0 (_tmp20_);
#line 364 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
				_media_it = _tmp22_;
#line 364 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
				while (TRUE) {
#line 1962 "MetadataWriter.c"
					GeeIterator* _tmp23_;
					gboolean _tmp24_ = FALSE;
					GeeIterator* _tmp25_;
					gpointer _tmp26_ = NULL;
					MediaSource* media;
					MediaSource* _tmp27_;
					LibraryPhoto* _tmp28_;
					LibraryPhoto* photo;
					LibraryPhoto* _tmp29_;
#line 364 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
					_tmp23_ = _media_it;
#line 364 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
					_tmp24_ = gee_iterator_next (_tmp23_);
#line 364 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
					if (!_tmp24_) {
#line 364 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
						break;
#line 1980 "MetadataWriter.c"
					}
#line 364 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
					_tmp25_ = _media_it;
#line 364 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
					_tmp26_ = gee_iterator_get (_tmp25_);
#line 364 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
					media = (MediaSource*) _tmp26_;
#line 365 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
					_tmp27_ = media;
#line 365 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
					_tmp28_ = _g_object_ref0 (IS_LIBRARY_PHOTO (_tmp27_) ? ((LibraryPhoto*) _tmp27_) : NULL);
#line 365 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
					photo = _tmp28_;
#line 366 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
					_tmp29_ = photo;
#line 366 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
					if (_tmp29_ != NULL) {
#line 1998 "MetadataWriter.c"
						GeeHashSet* _tmp30_;
						LibraryPhoto* _tmp31_;
#line 367 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
						_tmp30_ = photos;
#line 367 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
						_tmp31_ = photo;
#line 367 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
						gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (_tmp30_), _tmp31_);
#line 2007 "MetadataWriter.c"
					}
#line 364 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
					_g_object_unref0 (photo);
#line 364 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
					_g_object_unref0 (media);
#line 2013 "MetadataWriter.c"
				}
#line 364 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
				_g_object_unref0 (_media_it);
#line 2017 "MetadataWriter.c"
			}
#line 357 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			_g_object_unref0 (object);
#line 2021 "MetadataWriter.c"
		}
#line 357 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_g_object_unref0 (_object_it);
#line 2025 "MetadataWriter.c"
	}
#line 371 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp32_ = photos;
#line 371 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	if (_tmp32_ != NULL) {
#line 2031 "MetadataWriter.c"
		GeeHashSet* _tmp33_;
#line 372 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_tmp33_ = photos;
#line 372 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		metadata_writer_photos_are_dirty (self, GEE_COLLECTION (_tmp33_), "tag renamed", FALSE);
#line 2037 "MetadataWriter.c"
	}
#line 355 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_g_object_unref0 (photos);
#line 2041 "MetadataWriter.c"
}


static void metadata_writer_on_tag_contents_altered (MetadataWriter* self, ContainerSource* container, GeeCollection* added, gboolean relinking, GeeCollection* removed, gboolean unlinking) {
	ContainerSource* _tmp0_;
	Tag* _tmp1_;
	Tag* tag;
	gboolean _tmp2_ = FALSE;
	GeeCollection* _tmp3_;
	gboolean _tmp5_;
	gboolean _tmp29_ = FALSE;
	GeeCollection* _tmp30_;
	gboolean _tmp32_;
#line 375 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	g_return_if_fail (IS_METADATA_WRITER (self));
#line 375 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	g_return_if_fail (IS_CONTAINER_SOURCE (container));
#line 375 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	g_return_if_fail ((added == NULL) || GEE_IS_COLLECTION (added));
#line 375 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	g_return_if_fail ((removed == NULL) || GEE_IS_COLLECTION (removed));
#line 377 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp0_ = container;
#line 377 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp1_ = _g_object_ref0 (TAG (_tmp0_));
#line 377 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	tag = _tmp1_;
#line 379 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp3_ = added;
#line 379 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	if (_tmp3_ != NULL) {
#line 2073 "MetadataWriter.c"
		gboolean _tmp4_;
#line 379 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_tmp4_ = relinking;
#line 379 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_tmp2_ = !_tmp4_;
#line 2079 "MetadataWriter.c"
	} else {
#line 379 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_tmp2_ = FALSE;
#line 2083 "MetadataWriter.c"
	}
#line 379 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp5_ = _tmp2_;
#line 379 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	if (_tmp5_) {
#line 2089 "MetadataWriter.c"
		GeeArrayList* _tmp6_;
		GeeArrayList* added_photos;
		GeeArrayList* _tmp23_;
		Tag* _tmp24_;
		gchar* _tmp25_ = NULL;
		gchar* _tmp26_;
		gchar* _tmp27_ = NULL;
		gchar* _tmp28_;
#line 380 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_tmp6_ = gee_array_list_new (TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
#line 380 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		added_photos = _tmp6_;
#line 2102 "MetadataWriter.c"
		{
			GeeCollection* _tmp7_;
			GeeIterator* _tmp8_ = NULL;
			GeeIterator* _source_it;
#line 381 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			_tmp7_ = added;
#line 381 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			_tmp8_ = gee_iterable_iterator (GEE_ITERABLE (_tmp7_));
#line 381 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			_source_it = _tmp8_;
#line 381 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			while (TRUE) {
#line 2115 "MetadataWriter.c"
				GeeIterator* _tmp9_;
				gboolean _tmp10_ = FALSE;
				GeeIterator* _tmp11_;
				gpointer _tmp12_ = NULL;
				DataSource* source;
				DataSource* _tmp13_;
				LibraryPhoto* _tmp14_;
				LibraryPhoto* photo;
				gboolean _tmp15_ = FALSE;
				LibraryPhoto* _tmp16_;
				gboolean _tmp20_;
#line 381 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
				_tmp9_ = _source_it;
#line 381 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
				_tmp10_ = gee_iterator_next (_tmp9_);
#line 381 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
				if (!_tmp10_) {
#line 381 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
					break;
#line 2135 "MetadataWriter.c"
				}
#line 381 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
				_tmp11_ = _source_it;
#line 381 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
				_tmp12_ = gee_iterator_get (_tmp11_);
#line 381 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
				source = (DataSource*) _tmp12_;
#line 382 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
				_tmp13_ = source;
#line 382 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
				_tmp14_ = _g_object_ref0 (IS_LIBRARY_PHOTO (_tmp13_) ? ((LibraryPhoto*) _tmp13_) : NULL);
#line 382 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
				photo = _tmp14_;
#line 383 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
				_tmp16_ = photo;
#line 383 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
				if (_tmp16_ != NULL) {
#line 2153 "MetadataWriter.c"
					GeeHashSet* _tmp17_;
					LibraryPhoto* _tmp18_;
					gboolean _tmp19_ = FALSE;
#line 383 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
					_tmp17_ = self->priv->importing_photos;
#line 383 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
					_tmp18_ = photo;
#line 383 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
					_tmp19_ = gee_abstract_collection_contains (GEE_ABSTRACT_COLLECTION (_tmp17_), _tmp18_);
#line 383 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
					_tmp15_ = !_tmp19_;
#line 2165 "MetadataWriter.c"
				} else {
#line 383 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
					_tmp15_ = FALSE;
#line 2169 "MetadataWriter.c"
				}
#line 383 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
				_tmp20_ = _tmp15_;
#line 383 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
				if (_tmp20_) {
#line 2175 "MetadataWriter.c"
					GeeArrayList* _tmp21_;
					LibraryPhoto* _tmp22_;
#line 384 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
					_tmp21_ = added_photos;
#line 384 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
					_tmp22_ = photo;
#line 384 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
					gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (_tmp21_), _tmp22_);
#line 2184 "MetadataWriter.c"
				}
#line 381 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
				_g_object_unref0 (photo);
#line 381 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
				_g_object_unref0 (source);
#line 2190 "MetadataWriter.c"
			}
#line 381 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			_g_object_unref0 (_source_it);
#line 2194 "MetadataWriter.c"
		}
#line 387 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_tmp23_ = added_photos;
#line 387 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_tmp24_ = tag;
#line 387 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_tmp25_ = data_object_to_string (DATA_OBJECT (_tmp24_));
#line 387 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_tmp26_ = _tmp25_;
#line 387 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_tmp27_ = g_strdup_printf ("added to %s", _tmp26_);
#line 387 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_tmp28_ = _tmp27_;
#line 387 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		metadata_writer_photos_are_dirty (self, GEE_COLLECTION (_tmp23_), _tmp28_, FALSE);
#line 387 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_g_free0 (_tmp28_);
#line 387 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_g_free0 (_tmp26_);
#line 379 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_g_object_unref0 (added_photos);
#line 2216 "MetadataWriter.c"
	}
#line 390 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp30_ = removed;
#line 390 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	if (_tmp30_ != NULL) {
#line 2222 "MetadataWriter.c"
		gboolean _tmp31_;
#line 390 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_tmp31_ = unlinking;
#line 390 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_tmp29_ = !_tmp31_;
#line 2228 "MetadataWriter.c"
	} else {
#line 390 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_tmp29_ = FALSE;
#line 2232 "MetadataWriter.c"
	}
#line 390 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp32_ = _tmp29_;
#line 390 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	if (_tmp32_) {
#line 2238 "MetadataWriter.c"
		GeeArrayList* _tmp33_;
		GeeArrayList* removed_photos;
		GeeArrayList* _tmp45_;
		Tag* _tmp46_;
		gchar* _tmp47_ = NULL;
		gchar* _tmp48_;
		gchar* _tmp49_ = NULL;
		gchar* _tmp50_;
#line 391 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_tmp33_ = gee_array_list_new (TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
#line 391 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		removed_photos = _tmp33_;
#line 2251 "MetadataWriter.c"
		{
			GeeCollection* _tmp34_;
			GeeIterator* _tmp35_ = NULL;
			GeeIterator* _source_it;
#line 392 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			_tmp34_ = removed;
#line 392 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			_tmp35_ = gee_iterable_iterator (GEE_ITERABLE (_tmp34_));
#line 392 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			_source_it = _tmp35_;
#line 392 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			while (TRUE) {
#line 2264 "MetadataWriter.c"
				GeeIterator* _tmp36_;
				gboolean _tmp37_ = FALSE;
				GeeIterator* _tmp38_;
				gpointer _tmp39_ = NULL;
				DataSource* source;
				DataSource* _tmp40_;
				LibraryPhoto* _tmp41_;
				LibraryPhoto* photo;
				LibraryPhoto* _tmp42_;
#line 392 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
				_tmp36_ = _source_it;
#line 392 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
				_tmp37_ = gee_iterator_next (_tmp36_);
#line 392 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
				if (!_tmp37_) {
#line 392 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
					break;
#line 2282 "MetadataWriter.c"
				}
#line 392 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
				_tmp38_ = _source_it;
#line 392 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
				_tmp39_ = gee_iterator_get (_tmp38_);
#line 392 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
				source = (DataSource*) _tmp39_;
#line 393 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
				_tmp40_ = source;
#line 393 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
				_tmp41_ = _g_object_ref0 (IS_LIBRARY_PHOTO (_tmp40_) ? ((LibraryPhoto*) _tmp40_) : NULL);
#line 393 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
				photo = _tmp41_;
#line 394 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
				_tmp42_ = photo;
#line 394 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
				if (_tmp42_ != NULL) {
#line 2300 "MetadataWriter.c"
					GeeArrayList* _tmp43_;
					LibraryPhoto* _tmp44_;
#line 395 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
					_tmp43_ = removed_photos;
#line 395 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
					_tmp44_ = photo;
#line 395 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
					gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (_tmp43_), _tmp44_);
#line 2309 "MetadataWriter.c"
				}
#line 392 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
				_g_object_unref0 (photo);
#line 392 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
				_g_object_unref0 (source);
#line 2315 "MetadataWriter.c"
			}
#line 392 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			_g_object_unref0 (_source_it);
#line 2319 "MetadataWriter.c"
		}
#line 398 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_tmp45_ = removed_photos;
#line 398 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_tmp46_ = tag;
#line 398 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_tmp47_ = data_object_to_string (DATA_OBJECT (_tmp46_));
#line 398 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_tmp48_ = _tmp47_;
#line 398 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_tmp49_ = g_strdup_printf ("removed from %s", _tmp48_);
#line 398 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_tmp50_ = _tmp49_;
#line 398 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		metadata_writer_photos_are_dirty (self, GEE_COLLECTION (_tmp45_), _tmp50_, FALSE);
#line 398 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_g_free0 (_tmp50_);
#line 398 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_g_free0 (_tmp48_);
#line 390 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_g_object_unref0 (removed_photos);
#line 2341 "MetadataWriter.c"
	}
#line 375 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_g_object_unref0 (tag);
#line 2345 "MetadataWriter.c"
}


static void metadata_writer_on_tag_backlink_removed (MetadataWriter* self, ContainerSource* container, GeeCollection* sources) {
	GeeArrayList* _tmp0_;
	GeeArrayList* photos;
	GeeArrayList* _tmp12_;
	ContainerSource* _tmp13_;
	gchar* _tmp14_ = NULL;
	gchar* _tmp15_;
	gchar* _tmp16_ = NULL;
	gchar* _tmp17_;
#line 402 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	g_return_if_fail (IS_METADATA_WRITER (self));
#line 402 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	g_return_if_fail (IS_CONTAINER_SOURCE (container));
#line 402 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	g_return_if_fail (GEE_IS_COLLECTION (sources));
#line 403 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp0_ = gee_array_list_new (TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
#line 403 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	photos = _tmp0_;
#line 2368 "MetadataWriter.c"
	{
		GeeCollection* _tmp1_;
		GeeIterator* _tmp2_ = NULL;
		GeeIterator* _source_it;
#line 404 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_tmp1_ = sources;
#line 404 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_tmp2_ = gee_iterable_iterator (GEE_ITERABLE (_tmp1_));
#line 404 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_source_it = _tmp2_;
#line 404 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		while (TRUE) {
#line 2381 "MetadataWriter.c"
			GeeIterator* _tmp3_;
			gboolean _tmp4_ = FALSE;
			GeeIterator* _tmp5_;
			gpointer _tmp6_ = NULL;
			DataSource* source;
			DataSource* _tmp7_;
			LibraryPhoto* _tmp8_;
			LibraryPhoto* photo;
			LibraryPhoto* _tmp9_;
#line 404 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			_tmp3_ = _source_it;
#line 404 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			_tmp4_ = gee_iterator_next (_tmp3_);
#line 404 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			if (!_tmp4_) {
#line 404 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
				break;
#line 2399 "MetadataWriter.c"
			}
#line 404 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			_tmp5_ = _source_it;
#line 404 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			_tmp6_ = gee_iterator_get (_tmp5_);
#line 404 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			source = (DataSource*) _tmp6_;
#line 405 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			_tmp7_ = source;
#line 405 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			_tmp8_ = _g_object_ref0 (IS_LIBRARY_PHOTO (_tmp7_) ? ((LibraryPhoto*) _tmp7_) : NULL);
#line 405 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			photo = _tmp8_;
#line 406 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			_tmp9_ = photo;
#line 406 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			if (_tmp9_ != NULL) {
#line 2417 "MetadataWriter.c"
				GeeArrayList* _tmp10_;
				LibraryPhoto* _tmp11_;
#line 407 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
				_tmp10_ = photos;
#line 407 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
				_tmp11_ = photo;
#line 407 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
				gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (_tmp10_), _tmp11_);
#line 2426 "MetadataWriter.c"
			}
#line 404 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			_g_object_unref0 (photo);
#line 404 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			_g_object_unref0 (source);
#line 2432 "MetadataWriter.c"
		}
#line 404 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_g_object_unref0 (_source_it);
#line 2436 "MetadataWriter.c"
	}
#line 410 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp12_ = photos;
#line 410 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp13_ = container;
#line 410 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp14_ = data_object_to_string (DATA_OBJECT (_tmp13_));
#line 410 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp15_ = _tmp14_;
#line 410 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp16_ = g_strdup_printf ("backlink removed from %s", _tmp15_);
#line 410 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp17_ = _tmp16_;
#line 410 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	metadata_writer_photos_are_dirty (self, GEE_COLLECTION (_tmp12_), _tmp17_, FALSE);
#line 410 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_g_free0 (_tmp17_);
#line 410 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_g_free0 (_tmp15_);
#line 402 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_g_object_unref0 (photos);
#line 2458 "MetadataWriter.c"
}


static void metadata_writer_count_enqueued_work (MetadataWriter* self, gint count, gboolean report) {
	guint _tmp0_;
	gint _tmp1_;
	gboolean _tmp2_;
#line 413 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	g_return_if_fail (IS_METADATA_WRITER (self));
#line 414 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp0_ = self->priv->outstanding_total;
#line 414 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp1_ = count;
#line 414 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	self->priv->outstanding_total = _tmp0_ + _tmp1_;
#line 420 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp2_ = report;
#line 420 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	if (_tmp2_) {
#line 2478 "MetadataWriter.c"
		guint _tmp3_;
		guint _tmp4_;
#line 421 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_tmp3_ = self->priv->outstanding_completed;
#line 421 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_tmp4_ = self->priv->outstanding_total;
#line 421 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		g_signal_emit_by_name (self, "progress", _tmp3_, _tmp4_);
#line 2487 "MetadataWriter.c"
	}
}


static void metadata_writer_count_cancelled_work (MetadataWriter* self, gint count, gboolean report) {
	guint _tmp0_ = 0U;
	guint _tmp1_;
	gint _tmp2_;
	guint _tmp5_;
	guint _tmp6_;
	guint _tmp7_;
	gboolean _tmp8_;
#line 424 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	g_return_if_fail (IS_METADATA_WRITER (self));
#line 425 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp1_ = self->priv->outstanding_total;
#line 425 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp2_ = count;
#line 425 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	if (_tmp1_ >= ((guint) _tmp2_)) {
#line 2508 "MetadataWriter.c"
		guint _tmp3_;
		gint _tmp4_;
#line 425 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_tmp3_ = self->priv->outstanding_total;
#line 425 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_tmp4_ = count;
#line 425 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_tmp0_ = _tmp3_ - _tmp4_;
#line 2517 "MetadataWriter.c"
	} else {
#line 425 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_tmp0_ = (guint) 0;
#line 2521 "MetadataWriter.c"
	}
#line 425 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp5_ = _tmp0_;
#line 425 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	self->priv->outstanding_total = _tmp5_;
#line 426 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp6_ = self->priv->outstanding_completed;
#line 426 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp7_ = self->priv->outstanding_total;
#line 426 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	if (_tmp6_ >= _tmp7_) {
#line 427 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		self->priv->outstanding_completed = (guint) 0;
#line 428 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		self->priv->outstanding_total = (guint) 0;
#line 2537 "MetadataWriter.c"
	}
#line 435 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp8_ = report;
#line 435 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	if (_tmp8_) {
#line 2543 "MetadataWriter.c"
		guint _tmp9_;
		guint _tmp10_;
#line 436 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_tmp9_ = self->priv->outstanding_completed;
#line 436 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_tmp10_ = self->priv->outstanding_total;
#line 436 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		g_signal_emit_by_name (self, "progress", _tmp9_, _tmp10_);
#line 2552 "MetadataWriter.c"
	}
}


static void metadata_writer_count_completed_work (MetadataWriter* self, gint count, gboolean report) {
	guint _tmp0_;
	gint _tmp1_;
	guint _tmp2_;
	guint _tmp3_;
	gboolean _tmp4_;
#line 439 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	g_return_if_fail (IS_METADATA_WRITER (self));
#line 440 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp0_ = self->priv->outstanding_completed;
#line 440 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp1_ = count;
#line 440 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	self->priv->outstanding_completed = _tmp0_ + _tmp1_;
#line 441 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp2_ = self->priv->outstanding_completed;
#line 441 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp3_ = self->priv->outstanding_total;
#line 441 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	if (_tmp2_ >= _tmp3_) {
#line 442 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		self->priv->outstanding_completed = (guint) 0;
#line 443 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		self->priv->outstanding_total = (guint) 0;
#line 2581 "MetadataWriter.c"
	}
#line 450 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp4_ = report;
#line 450 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	if (_tmp4_) {
#line 2587 "MetadataWriter.c"
		guint _tmp5_;
		guint _tmp6_;
#line 451 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_tmp5_ = self->priv->outstanding_completed;
#line 451 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_tmp6_ = self->priv->outstanding_total;
#line 451 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		g_signal_emit_by_name (self, "progress", _tmp5_, _tmp6_);
#line 2596 "MetadataWriter.c"
	}
}


static void metadata_writer_schedule_if_dirty (MetadataWriter* self, GeeIterable* media_sources, const gchar* reason) {
	GeeArrayList* photos;
	GeeArrayList* _tmp18_;
#line 454 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	g_return_if_fail (IS_METADATA_WRITER (self));
#line 454 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	g_return_if_fail (GEE_IS_ITERABLE (media_sources));
#line 454 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	g_return_if_fail (reason != NULL);
#line 455 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	photos = NULL;
#line 2612 "MetadataWriter.c"
	{
		GeeIterable* _tmp0_;
		GeeIterator* _tmp1_ = NULL;
		GeeIterator* _media_it;
#line 456 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_tmp0_ = media_sources;
#line 456 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_tmp1_ = gee_iterable_iterator (_tmp0_);
#line 456 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_media_it = _tmp1_;
#line 456 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		while (TRUE) {
#line 2625 "MetadataWriter.c"
			GeeIterator* _tmp2_;
			gboolean _tmp3_ = FALSE;
			GeeIterator* _tmp4_;
			gpointer _tmp5_ = NULL;
			MediaSource* media;
			MediaSource* _tmp6_;
			LibraryPhoto* _tmp7_;
			LibraryPhoto* photo;
			LibraryPhoto* _tmp8_;
			GeeHashSet* _tmp9_;
			LibraryPhoto* _tmp10_;
			gboolean _tmp11_ = FALSE;
			LibraryPhoto* _tmp12_;
			gboolean _tmp13_ = FALSE;
#line 456 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			_tmp2_ = _media_it;
#line 456 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			_tmp3_ = gee_iterator_next (_tmp2_);
#line 456 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			if (!_tmp3_) {
#line 456 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
				break;
#line 2648 "MetadataWriter.c"
			}
#line 456 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			_tmp4_ = _media_it;
#line 456 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			_tmp5_ = gee_iterator_get (_tmp4_);
#line 456 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			media = (MediaSource*) _tmp5_;
#line 457 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			_tmp6_ = media;
#line 457 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			_tmp7_ = _g_object_ref0 (IS_LIBRARY_PHOTO (_tmp6_) ? ((LibraryPhoto*) _tmp6_) : NULL);
#line 457 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			photo = _tmp7_;
#line 458 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			_tmp8_ = photo;
#line 458 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			if (_tmp8_ == NULL) {
#line 459 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
				_g_object_unref0 (photo);
#line 459 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
				_g_object_unref0 (media);
#line 459 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
				continue;
#line 2672 "MetadataWriter.c"
			}
#line 462 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			_tmp9_ = self->priv->importing_photos;
#line 462 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			_tmp10_ = photo;
#line 462 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			_tmp11_ = gee_abstract_collection_contains (GEE_ABSTRACT_COLLECTION (_tmp9_), _tmp10_);
#line 462 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			if (_tmp11_) {
#line 463 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
				_g_object_unref0 (photo);
#line 463 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
				_g_object_unref0 (media);
#line 463 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
				continue;
#line 2688 "MetadataWriter.c"
			}
#line 465 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			_tmp12_ = photo;
#line 465 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			_tmp13_ = photo_is_master_metadata_dirty (PHOTO (_tmp12_));
#line 465 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			if (_tmp13_) {
#line 2696 "MetadataWriter.c"
				GeeArrayList* _tmp14_;
				GeeArrayList* _tmp16_;
				LibraryPhoto* _tmp17_;
#line 466 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
				_tmp14_ = photos;
#line 466 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
				if (_tmp14_ == NULL) {
#line 2704 "MetadataWriter.c"
					GeeArrayList* _tmp15_;
#line 467 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
					_tmp15_ = gee_array_list_new (TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
#line 467 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
					_g_object_unref0 (photos);
#line 467 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
					photos = _tmp15_;
#line 2712 "MetadataWriter.c"
				}
#line 469 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
				_tmp16_ = photos;
#line 469 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
				_tmp17_ = photo;
#line 469 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
				gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (_tmp16_), _tmp17_);
#line 2720 "MetadataWriter.c"
			}
#line 456 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			_g_object_unref0 (photo);
#line 456 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			_g_object_unref0 (media);
#line 2726 "MetadataWriter.c"
		}
#line 456 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_g_object_unref0 (_media_it);
#line 2730 "MetadataWriter.c"
	}
#line 473 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp18_ = photos;
#line 473 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	if (_tmp18_ != NULL) {
#line 2736 "MetadataWriter.c"
		GeeArrayList* _tmp19_;
		const gchar* _tmp20_;
#line 474 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_tmp19_ = photos;
#line 474 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_tmp20_ = reason;
#line 474 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		metadata_writer_photos_are_dirty (self, GEE_COLLECTION (_tmp19_), _tmp20_, TRUE);
#line 2745 "MetadataWriter.c"
	}
#line 454 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_g_object_unref0 (photos);
#line 2749 "MetadataWriter.c"
}


static void metadata_writer_photos_are_dirty (MetadataWriter* self, GeeCollection* photos, const gchar* reason, gboolean already_marked) {
	GeeCollection* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gboolean _tmp10_;
	gboolean _tmp28_ = FALSE;
	gboolean _tmp29_;
	gboolean _tmp31_;
	GeeCollection* _tmp42_;
	gint _tmp43_;
	gint _tmp44_;
	GError * _inner_error_ = NULL;
#line 478 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	g_return_if_fail (IS_METADATA_WRITER (self));
#line 478 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	g_return_if_fail (GEE_IS_COLLECTION (photos));
#line 478 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	g_return_if_fail (reason != NULL);
#line 479 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp0_ = photos;
#line 479 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp1_ = gee_collection_get_size (_tmp0_);
#line 479 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp2_ = _tmp1_;
#line 479 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	if (_tmp2_ == 0) {
#line 480 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		return;
#line 2781 "MetadataWriter.c"
	}
	{
		GeeCollection* _tmp3_;
		GeeIterator* _tmp4_ = NULL;
		GeeIterator* _photo_it;
#line 483 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_tmp3_ = photos;
#line 483 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_tmp4_ = gee_iterable_iterator (GEE_ITERABLE (_tmp3_));
#line 483 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_photo_it = _tmp4_;
#line 483 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		while (TRUE) {
#line 2795 "MetadataWriter.c"
			GeeIterator* _tmp5_;
			gboolean _tmp6_ = FALSE;
			GeeIterator* _tmp7_;
			gpointer _tmp8_ = NULL;
			LibraryPhoto* photo;
			LibraryPhoto* _tmp9_;
#line 483 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			_tmp5_ = _photo_it;
#line 483 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			_tmp6_ = gee_iterator_next (_tmp5_);
#line 483 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			if (!_tmp6_) {
#line 483 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
				break;
#line 2810 "MetadataWriter.c"
			}
#line 483 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			_tmp7_ = _photo_it;
#line 483 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			_tmp8_ = gee_iterator_get (_tmp7_);
#line 483 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			photo = (LibraryPhoto*) _tmp8_;
#line 484 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			_tmp9_ = photo;
#line 484 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			metadata_writer_cancel_job (self, _tmp9_);
#line 483 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			_g_object_unref0 (photo);
#line 2824 "MetadataWriter.c"
		}
#line 483 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_g_object_unref0 (_photo_it);
#line 2828 "MetadataWriter.c"
	}
#line 487 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp10_ = already_marked;
#line 487 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	if (!_tmp10_) {
#line 2834 "MetadataWriter.c"
		{
			LibraryPhotoSourceCollection* _tmp11_;
			TransactionController* _tmp12_;
			TransactionController* _tmp13_;
			LibraryPhotoSourceCollection* _tmp21_;
			TransactionController* _tmp22_;
			TransactionController* _tmp23_;
#line 489 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			_tmp11_ = library_photo_global;
#line 489 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			_tmp12_ = media_source_collection_get_transaction_controller (MEDIA_SOURCE_COLLECTION (_tmp11_));
#line 489 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			_tmp13_ = _tmp12_;
#line 489 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			transaction_controller_begin (_tmp13_);
#line 2850 "MetadataWriter.c"
			{
				GeeCollection* _tmp14_;
				GeeIterator* _tmp15_ = NULL;
				GeeIterator* _photo_it;
#line 491 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
				_tmp14_ = photos;
#line 491 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
				_tmp15_ = gee_iterable_iterator (GEE_ITERABLE (_tmp14_));
#line 491 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
				_photo_it = _tmp15_;
#line 491 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
				while (TRUE) {
#line 2863 "MetadataWriter.c"
					GeeIterator* _tmp16_;
					gboolean _tmp17_ = FALSE;
					GeeIterator* _tmp18_;
					gpointer _tmp19_ = NULL;
					LibraryPhoto* photo;
					LibraryPhoto* _tmp20_;
#line 491 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
					_tmp16_ = _photo_it;
#line 491 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
					_tmp17_ = gee_iterator_next (_tmp16_);
#line 491 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
					if (!_tmp17_) {
#line 491 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
						break;
#line 2878 "MetadataWriter.c"
					}
#line 491 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
					_tmp18_ = _photo_it;
#line 491 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
					_tmp19_ = gee_iterator_get (_tmp18_);
#line 491 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
					photo = (LibraryPhoto*) _tmp19_;
#line 492 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
					_tmp20_ = photo;
#line 492 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
					photo_set_master_metadata_dirty (PHOTO (_tmp20_), TRUE, &_inner_error_);
#line 492 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
					if (_inner_error_ != NULL) {
#line 492 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
						_g_object_unref0 (photo);
#line 492 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
						_g_object_unref0 (_photo_it);
#line 2896 "MetadataWriter.c"
						goto __catch379_g_error;
					}
#line 491 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
					_g_object_unref0 (photo);
#line 2901 "MetadataWriter.c"
				}
#line 491 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
				_g_object_unref0 (_photo_it);
#line 2905 "MetadataWriter.c"
			}
#line 494 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			_tmp21_ = library_photo_global;
#line 494 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			_tmp22_ = media_source_collection_get_transaction_controller (MEDIA_SOURCE_COLLECTION (_tmp21_));
#line 494 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			_tmp23_ = _tmp22_;
#line 494 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			transaction_controller_commit (_tmp23_);
#line 2915 "MetadataWriter.c"
		}
		goto __finally379;
		__catch379_g_error:
		{
			GError* err = NULL;
			GError* _tmp24_;
#line 488 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			err = _inner_error_;
#line 488 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			_inner_error_ = NULL;
#line 496 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			_tmp24_ = err;
#line 496 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			if (_tmp24_->domain == DATABASE_ERROR) {
#line 2930 "MetadataWriter.c"
				GError* _tmp25_;
#line 497 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
				_tmp25_ = err;
#line 497 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
				app_window_database_error ((GError*) _tmp25_);
#line 2936 "MetadataWriter.c"
			} else {
				GError* _tmp26_;
				const gchar* _tmp27_;
#line 499 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
				_tmp26_ = err;
#line 499 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
				_tmp27_ = _tmp26_->message;
#line 499 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
				g_error ("MetadataWriter.vala:499: Unable to mark metadata as dirty: %s", _tmp27_);
#line 2946 "MetadataWriter.c"
			}
#line 488 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			_g_error_free0 (err);
#line 2950 "MetadataWriter.c"
		}
		__finally379:
#line 488 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		if (_inner_error_ != NULL) {
#line 488 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 488 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			g_clear_error (&_inner_error_);
#line 488 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			return;
#line 2961 "MetadataWriter.c"
		}
	}
#line 505 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp29_ = self->priv->closed;
#line 505 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	if (_tmp29_) {
#line 505 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_tmp28_ = TRUE;
#line 2970 "MetadataWriter.c"
	} else {
		gboolean _tmp30_;
#line 505 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_tmp30_ = self->priv->enabled;
#line 505 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_tmp28_ = !_tmp30_;
#line 2977 "MetadataWriter.c"
	}
#line 505 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp31_ = _tmp28_;
#line 505 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	if (_tmp31_) {
#line 506 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		return;
#line 2985 "MetadataWriter.c"
	}
	{
		GeeCollection* _tmp32_;
		GeeIterator* _tmp33_ = NULL;
		GeeIterator* _photo_it;
#line 512 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_tmp32_ = photos;
#line 512 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_tmp33_ = gee_iterable_iterator (GEE_ITERABLE (_tmp32_));
#line 512 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_photo_it = _tmp33_;
#line 512 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		while (TRUE) {
#line 2999 "MetadataWriter.c"
			GeeIterator* _tmp34_;
			gboolean _tmp35_ = FALSE;
			GeeIterator* _tmp36_;
			gpointer _tmp37_ = NULL;
			LibraryPhoto* photo;
			HashTimedQueue* _tmp38_;
			LibraryPhoto* _tmp39_;
			gboolean _tmp40_ = FALSE;
			gboolean enqueued;
			gboolean _tmp41_;
#line 512 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			_tmp34_ = _photo_it;
#line 512 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			_tmp35_ = gee_iterator_next (_tmp34_);
#line 512 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			if (!_tmp35_) {
#line 512 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
				break;
#line 3018 "MetadataWriter.c"
			}
#line 512 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			_tmp36_ = _photo_it;
#line 512 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			_tmp37_ = gee_iterator_get (_tmp36_);
#line 512 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			photo = (LibraryPhoto*) _tmp37_;
#line 513 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			_tmp38_ = self->priv->dirty;
#line 513 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			_tmp39_ = photo;
#line 513 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			_tmp40_ = timed_queue_enqueue (TIMED_QUEUE (_tmp38_), _tmp39_);
#line 513 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			enqueued = _tmp40_;
#line 514 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			_tmp41_ = enqueued;
#line 514 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			g_assert (_tmp41_);
#line 512 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			_g_object_unref0 (photo);
#line 3040 "MetadataWriter.c"
		}
#line 512 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_g_object_unref0 (_photo_it);
#line 3044 "MetadataWriter.c"
	}
#line 517 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp42_ = photos;
#line 517 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp43_ = gee_collection_get_size (_tmp42_);
#line 517 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp44_ = _tmp43_;
#line 517 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	metadata_writer_count_enqueued_work (self, _tmp44_, TRUE);
#line 3054 "MetadataWriter.c"
}


static void metadata_writer_cancel_all (MetadataWriter* self, gboolean wait) {
	HashTimedQueue* _tmp0_;
	gboolean _tmp12_;
	gint _tmp14_;
#line 520 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	g_return_if_fail (IS_METADATA_WRITER (self));
#line 521 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp0_ = self->priv->dirty;
#line 521 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	timed_queue_clear (TIMED_QUEUE (_tmp0_));
#line 3068 "MetadataWriter.c"
	{
		GeeHashMap* _tmp1_;
		GeeCollection* _tmp2_;
		GeeCollection* _tmp3_;
		GeeCollection* _tmp4_;
		GeeIterator* _tmp5_ = NULL;
		GeeIterator* _tmp6_;
		GeeIterator* _job_it;
#line 523 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_tmp1_ = self->priv->pending;
#line 523 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_tmp2_ = gee_abstract_map_get_values (GEE_MAP (_tmp1_));
#line 523 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_tmp3_ = _tmp2_;
#line 523 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_tmp4_ = _tmp3_;
#line 523 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_tmp5_ = gee_iterable_iterator (GEE_ITERABLE (_tmp4_));
#line 523 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_tmp6_ = _tmp5_;
#line 523 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_g_object_unref0 (_tmp4_);
#line 523 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_job_it = _tmp6_;
#line 523 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		while (TRUE) {
#line 3095 "MetadataWriter.c"
			GeeIterator* _tmp7_;
			gboolean _tmp8_ = FALSE;
			GeeIterator* _tmp9_;
			gpointer _tmp10_ = NULL;
			MetadataWriterCommitJob* job;
			MetadataWriterCommitJob* _tmp11_;
#line 523 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			_tmp7_ = _job_it;
#line 523 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			_tmp8_ = gee_iterator_next (_tmp7_);
#line 523 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			if (!_tmp8_) {
#line 523 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
				break;
#line 3110 "MetadataWriter.c"
			}
#line 523 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			_tmp9_ = _job_it;
#line 523 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			_tmp10_ = gee_iterator_get (_tmp9_);
#line 523 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			job = (MetadataWriterCommitJob*) _tmp10_;
#line 524 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			_tmp11_ = job;
#line 524 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			background_job_cancel (BACKGROUND_JOB (_tmp11_));
#line 523 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			_background_job_unref0 (job);
#line 3124 "MetadataWriter.c"
		}
#line 523 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_g_object_unref0 (_job_it);
#line 3128 "MetadataWriter.c"
	}
#line 526 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp12_ = wait;
#line 526 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	if (_tmp12_) {
#line 3134 "MetadataWriter.c"
		Workers* _tmp13_;
#line 527 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_tmp13_ = self->priv->workers;
#line 527 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		workers_wait_for_empty_queue (_tmp13_);
#line 3140 "MetadataWriter.c"
	}
#line 529 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp14_ = G_MAXINT;
#line 529 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	metadata_writer_count_cancelled_work (self, _tmp14_, TRUE);
#line 3146 "MetadataWriter.c"
}


static gboolean metadata_writer_cancel_job (MetadataWriter* self, LibraryPhoto* photo) {
	gboolean result = FALSE;
	gboolean cancelled;
	GeeHashMap* _tmp0_;
	LibraryPhoto* _tmp1_;
	gboolean _tmp2_ = FALSE;
	HashTimedQueue* _tmp7_;
	LibraryPhoto* _tmp8_;
	gboolean _tmp9_ = FALSE;
#line 532 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	g_return_val_if_fail (IS_METADATA_WRITER (self), FALSE);
#line 532 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	g_return_val_if_fail (IS_LIBRARY_PHOTO (photo), FALSE);
#line 533 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	cancelled = FALSE;
#line 535 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp0_ = self->priv->pending;
#line 535 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp1_ = photo;
#line 535 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp2_ = gee_abstract_map_has_key (GEE_ABSTRACT_MAP (_tmp0_), _tmp1_);
#line 535 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	if (_tmp2_) {
#line 3173 "MetadataWriter.c"
		GeeHashMap* _tmp3_;
		LibraryPhoto* _tmp4_;
		gpointer _tmp5_ = NULL;
		MetadataWriterCommitJob* _tmp6_;
#line 536 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_tmp3_ = self->priv->pending;
#line 536 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_tmp4_ = photo;
#line 536 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_tmp5_ = gee_abstract_map_get (GEE_ABSTRACT_MAP (_tmp3_), _tmp4_);
#line 536 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_tmp6_ = (MetadataWriterCommitJob*) _tmp5_;
#line 536 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		background_job_cancel (BACKGROUND_JOB (_tmp6_));
#line 536 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_background_job_unref0 (_tmp6_);
#line 537 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		cancelled = TRUE;
#line 3192 "MetadataWriter.c"
	}
#line 540 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp7_ = self->priv->dirty;
#line 540 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp8_ = photo;
#line 540 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp9_ = timed_queue_contains (TIMED_QUEUE (_tmp7_), _tmp8_);
#line 540 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	if (_tmp9_) {
#line 3202 "MetadataWriter.c"
		HashTimedQueue* _tmp10_;
		LibraryPhoto* _tmp11_;
		gboolean _tmp12_ = FALSE;
		gboolean removed;
		gboolean _tmp13_;
		HashTimedQueue* _tmp14_;
		LibraryPhoto* _tmp15_;
		gboolean _tmp16_ = FALSE;
#line 541 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_tmp10_ = self->priv->dirty;
#line 541 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_tmp11_ = photo;
#line 541 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_tmp12_ = timed_queue_remove_first (TIMED_QUEUE (_tmp10_), _tmp11_);
#line 541 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		removed = _tmp12_;
#line 542 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_tmp13_ = removed;
#line 542 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		g_assert (_tmp13_);
#line 544 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_tmp14_ = self->priv->dirty;
#line 544 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_tmp15_ = photo;
#line 544 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_tmp16_ = timed_queue_contains (TIMED_QUEUE (_tmp14_), _tmp15_);
#line 544 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		g_assert (!_tmp16_);
#line 546 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		metadata_writer_count_cancelled_work (self, 1, FALSE);
#line 547 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		cancelled = TRUE;
#line 3235 "MetadataWriter.c"
	}
#line 550 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	result = cancelled;
#line 550 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	return result;
#line 3241 "MetadataWriter.c"
}


static void metadata_writer_on_photo_dequeued (MetadataWriter* self, LibraryPhoto* photo) {
	GeeHashMap* _tmp0_;
	LibraryPhoto* _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_;
	GeeSet* keywords;
	TagSourceCollection* _tmp4_;
	LibraryPhoto* _tmp5_;
	GeeList* _tmp6_ = NULL;
	GeeCollection* tags;
	GeeCollection* _tmp7_;
	LibraryPhoto* _tmp19_;
	GeeSet* _tmp20_;
	MetadataWriterCommitJob* _tmp21_;
	MetadataWriterCommitJob* job;
	GeeHashMap* _tmp22_;
	LibraryPhoto* _tmp23_;
	MetadataWriterCommitJob* _tmp24_;
	Workers* _tmp25_;
	MetadataWriterCommitJob* _tmp26_;
#line 553 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	g_return_if_fail (IS_METADATA_WRITER (self));
#line 553 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO (photo));
#line 554 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp0_ = self->priv->pending;
#line 554 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp1_ = photo;
#line 554 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp2_ = gee_abstract_map_has_key (GEE_ABSTRACT_MAP (_tmp0_), _tmp1_);
#line 554 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	g_assert (!_tmp2_);
#line 556 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp3_ = self->priv->enabled;
#line 556 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	if (!_tmp3_) {
#line 557 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		metadata_writer_count_cancelled_work (self, 1, TRUE);
#line 559 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		return;
#line 3285 "MetadataWriter.c"
	}
#line 562 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	keywords = NULL;
#line 563 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp4_ = tag_global;
#line 563 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp5_ = photo;
#line 563 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp6_ = tag_source_collection_fetch_for_source (_tmp4_, MEDIA_SOURCE (_tmp5_));
#line 563 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	tags = GEE_COLLECTION (_tmp6_);
#line 564 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp7_ = tags;
#line 564 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	if (_tmp7_ != NULL) {
#line 3301 "MetadataWriter.c"
		GeeHashSet* _tmp8_;
#line 565 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_tmp8_ = gee_hash_set_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, NULL, NULL);
#line 565 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_g_object_unref0 (keywords);
#line 565 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		keywords = GEE_SET (_tmp8_);
#line 3309 "MetadataWriter.c"
		{
			GeeCollection* _tmp9_;
			GeeIterator* _tmp10_ = NULL;
			GeeIterator* _tag_it;
#line 566 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			_tmp9_ = tags;
#line 566 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			_tmp10_ = gee_iterable_iterator (GEE_ITERABLE (_tmp9_));
#line 566 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			_tag_it = _tmp10_;
#line 566 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			while (TRUE) {
#line 3322 "MetadataWriter.c"
				GeeIterator* _tmp11_;
				gboolean _tmp12_ = FALSE;
				GeeIterator* _tmp13_;
				gpointer _tmp14_ = NULL;
				Tag* tag;
				GeeSet* _tmp15_;
				Tag* _tmp16_;
				gchar* _tmp17_ = NULL;
				gchar* _tmp18_;
#line 566 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
				_tmp11_ = _tag_it;
#line 566 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
				_tmp12_ = gee_iterator_next (_tmp11_);
#line 566 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
				if (!_tmp12_) {
#line 566 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
					break;
#line 3340 "MetadataWriter.c"
				}
#line 566 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
				_tmp13_ = _tag_it;
#line 566 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
				_tmp14_ = gee_iterator_get (_tmp13_);
#line 566 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
				tag = (Tag*) _tmp14_;
#line 567 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
				_tmp15_ = keywords;
#line 567 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
				_tmp16_ = tag;
#line 567 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
				_tmp17_ = data_object_get_name (DATA_OBJECT (_tmp16_));
#line 567 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
				_tmp18_ = _tmp17_;
#line 567 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
				gee_collection_add (GEE_COLLECTION (_tmp15_), _tmp18_);
#line 567 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
				_g_free0 (_tmp18_);
#line 566 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
				_g_object_unref0 (tag);
#line 3362 "MetadataWriter.c"
			}
#line 566 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			_g_object_unref0 (_tag_it);
#line 3366 "MetadataWriter.c"
		}
	}
#line 570 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp19_ = photo;
#line 570 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp20_ = keywords;
#line 570 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp21_ = metadata_writer_commit_job_new (self, _tmp19_, _tmp20_);
#line 570 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	job = _tmp21_;
#line 571 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp22_ = self->priv->pending;
#line 571 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp23_ = photo;
#line 571 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp24_ = job;
#line 571 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	gee_abstract_map_set (GEE_ABSTRACT_MAP (_tmp22_), _tmp23_, _tmp24_);
#line 577 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp25_ = self->priv->workers;
#line 577 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp26_ = job;
#line 577 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	workers_enqueue (_tmp25_, BACKGROUND_JOB (_tmp26_));
#line 553 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_background_job_unref0 (job);
#line 553 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_g_object_unref0 (tags);
#line 553 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_g_object_unref0 (keywords);
#line 3397 "MetadataWriter.c"
}


static gpointer _background_job_ref0 (gpointer self) {
#line 581 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	return self ? background_job_ref (self) : NULL;
#line 3404 "MetadataWriter.c"
}


static void metadata_writer_on_update_completed (MetadataWriter* self, BackgroundJob* j) {
	BackgroundJob* _tmp0_;
	MetadataWriterCommitJob* _tmp1_;
	MetadataWriterCommitJob* job;
	MetadataWriterCommitJob* _tmp2_;
	GError* _tmp3_;
	GeeHashMap* _tmp15_;
	MetadataWriterCommitJob* _tmp16_;
	LibraryPhoto* _tmp17_;
	gboolean _tmp18_ = FALSE;
	gboolean removed;
	gboolean _tmp19_;
	LibraryPhotoSourceCollection* _tmp20_;
	TransactionController* _tmp21_;
	TransactionController* _tmp22_;
	gboolean _tmp23_ = FALSE;
	MetadataWriterCommitJob* _tmp24_;
	PhotoReimportMasterState* _tmp25_;
	gboolean _tmp28_;
	LibraryPhotoSourceCollection* _tmp58_;
	TransactionController* _tmp59_;
	TransactionController* _tmp60_;
	GError * _inner_error_ = NULL;
#line 580 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	g_return_if_fail (IS_METADATA_WRITER (self));
#line 580 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	g_return_if_fail (IS_BACKGROUND_JOB (j));
#line 581 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp0_ = j;
#line 581 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp1_ = _background_job_ref0 (METADATA_WRITER_COMMIT_JOB (_tmp0_));
#line 581 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	job = _tmp1_;
#line 583 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp2_ = job;
#line 583 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp3_ = _tmp2_->err;
#line 583 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	if (_tmp3_ != NULL) {
#line 3447 "MetadataWriter.c"
		MetadataWriterCommitJob* _tmp4_;
		LibraryPhoto* _tmp5_;
		gchar* _tmp6_ = NULL;
		gchar* _tmp7_;
		MetadataWriterCommitJob* _tmp8_;
		GError* _tmp9_;
		const gchar* _tmp10_;
#line 584 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_tmp4_ = job;
#line 584 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_tmp5_ = _tmp4_->photo;
#line 584 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_tmp6_ = data_object_to_string (DATA_OBJECT (_tmp5_));
#line 584 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_tmp7_ = _tmp6_;
#line 584 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_tmp8_ = job;
#line 584 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_tmp9_ = _tmp8_->err;
#line 584 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_tmp10_ = _tmp9_->message;
#line 584 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		g_warning ("MetadataWriter.vala:584: Unable to update metadata for %s: %s", _tmp7_, _tmp10_);
#line 584 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_g_free0 (_tmp7_);
#line 3473 "MetadataWriter.c"
	} else {
		MetadataWriterCommitJob* _tmp11_;
		LibraryPhoto* _tmp12_;
		gchar* _tmp13_ = NULL;
		gchar* _tmp14_;
#line 586 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_tmp11_ = job;
#line 586 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_tmp12_ = _tmp11_->photo;
#line 586 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_tmp13_ = data_object_to_string (DATA_OBJECT (_tmp12_));
#line 586 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_tmp14_ = _tmp13_;
#line 586 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		g_message ("MetadataWriter.vala:586: Completed writing metadata for %s", _tmp14_);
#line 586 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_g_free0 (_tmp14_);
#line 3491 "MetadataWriter.c"
	}
#line 588 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp15_ = self->priv->pending;
#line 588 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp16_ = job;
#line 588 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp17_ = _tmp16_->photo;
#line 588 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp18_ = gee_abstract_map_unset (GEE_ABSTRACT_MAP (_tmp15_), _tmp17_, NULL);
#line 588 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	removed = _tmp18_;
#line 589 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp19_ = removed;
#line 589 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	g_assert (_tmp19_);
#line 593 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp20_ = library_photo_global;
#line 593 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp21_ = media_source_collection_get_transaction_controller (MEDIA_SOURCE_COLLECTION (_tmp20_));
#line 593 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp22_ = _tmp21_;
#line 593 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	transaction_controller_begin (_tmp22_);
#line 595 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp24_ = job;
#line 595 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp25_ = _tmp24_->reimport_master_state;
#line 595 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	if (_tmp25_ != NULL) {
#line 595 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_tmp23_ = TRUE;
#line 3523 "MetadataWriter.c"
	} else {
		MetadataWriterCommitJob* _tmp26_;
		PhotoReimportEditableState* _tmp27_;
#line 595 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_tmp26_ = job;
#line 595 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_tmp27_ = _tmp26_->reimport_editable_state;
#line 595 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_tmp23_ = _tmp27_ != NULL;
#line 3533 "MetadataWriter.c"
	}
#line 595 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp28_ = _tmp23_;
#line 595 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	if (_tmp28_) {
#line 3539 "MetadataWriter.c"
		LibraryPhoto* _tmp29_;
		MetadataWriterCommitJob* _tmp30_;
		LibraryPhoto* _tmp31_;
		LibraryPhoto* _tmp32_;
#line 598 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_tmp29_ = self->priv->ignore_photo_alteration;
#line 598 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		g_assert (_tmp29_ == NULL);
#line 599 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_tmp30_ = job;
#line 599 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_tmp31_ = _tmp30_->photo;
#line 599 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_tmp32_ = _g_object_ref0 (_tmp31_);
#line 599 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_g_object_unref0 (self->priv->ignore_photo_alteration);
#line 599 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		self->priv->ignore_photo_alteration = _tmp32_;
#line 3558 "MetadataWriter.c"
		{
			MetadataWriterCommitJob* _tmp33_;
			PhotoReimportMasterState* _tmp34_;
			MetadataWriterCommitJob* _tmp42_;
			PhotoReimportEditableState* _tmp43_;
#line 601 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			_tmp33_ = job;
#line 601 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			_tmp34_ = _tmp33_->reimport_master_state;
#line 601 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			if (_tmp34_ != NULL) {
#line 3570 "MetadataWriter.c"
				MetadataWriterCommitJob* _tmp35_;
				LibraryPhoto* _tmp36_;
				MetadataWriterCommitJob* _tmp37_;
				PhotoReimportMasterState* _tmp38_;
#line 602 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
				_tmp35_ = job;
#line 602 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
				_tmp36_ = _tmp35_->photo;
#line 602 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
				_tmp37_ = job;
#line 602 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
				_tmp38_ = _tmp37_->reimport_master_state;
#line 602 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
				photo_finish_update_master_metadata (PHOTO (_tmp36_), _tmp38_, &_inner_error_);
#line 602 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
				if (_inner_error_ != NULL) {
#line 602 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
					if (_inner_error_->domain == DATABASE_ERROR) {
#line 3589 "MetadataWriter.c"
						goto __catch380_database_error;
					}
					{
						LibraryPhoto* _tmp39_;
						MetadataWriterCommitJob* _tmp40_;
						LibraryPhoto* _tmp41_;
#line 610 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
						_tmp39_ = self->priv->ignore_photo_alteration;
#line 610 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
						_tmp40_ = job;
#line 610 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
						_tmp41_ = _tmp40_->photo;
#line 610 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
						g_assert (_tmp39_ == _tmp41_);
#line 611 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
						_g_object_unref0 (self->priv->ignore_photo_alteration);
#line 611 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
						self->priv->ignore_photo_alteration = NULL;
#line 3608 "MetadataWriter.c"
					}
#line 602 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
					_background_job_unref0 (job);
#line 602 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
					g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 602 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
					g_clear_error (&_inner_error_);
#line 602 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
					return;
#line 3618 "MetadataWriter.c"
				}
			}
#line 604 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			_tmp42_ = job;
#line 604 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			_tmp43_ = _tmp42_->reimport_editable_state;
#line 604 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			if (_tmp43_ != NULL) {
#line 3627 "MetadataWriter.c"
				MetadataWriterCommitJob* _tmp44_;
				LibraryPhoto* _tmp45_;
				MetadataWriterCommitJob* _tmp46_;
				PhotoReimportEditableState* _tmp47_;
#line 605 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
				_tmp44_ = job;
#line 605 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
				_tmp45_ = _tmp44_->photo;
#line 605 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
				_tmp46_ = job;
#line 605 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
				_tmp47_ = _tmp46_->reimport_editable_state;
#line 605 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
				photo_finish_update_editable_metadata (PHOTO (_tmp45_), _tmp47_, &_inner_error_);
#line 605 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
				if (_inner_error_ != NULL) {
#line 605 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
					if (_inner_error_->domain == DATABASE_ERROR) {
#line 3646 "MetadataWriter.c"
						goto __catch380_database_error;
					}
					{
						LibraryPhoto* _tmp48_;
						MetadataWriterCommitJob* _tmp49_;
						LibraryPhoto* _tmp50_;
#line 610 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
						_tmp48_ = self->priv->ignore_photo_alteration;
#line 610 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
						_tmp49_ = job;
#line 610 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
						_tmp50_ = _tmp49_->photo;
#line 610 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
						g_assert (_tmp48_ == _tmp50_);
#line 611 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
						_g_object_unref0 (self->priv->ignore_photo_alteration);
#line 611 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
						self->priv->ignore_photo_alteration = NULL;
#line 3665 "MetadataWriter.c"
					}
#line 605 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
					_background_job_unref0 (job);
#line 605 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
					g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 605 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
					g_clear_error (&_inner_error_);
#line 605 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
					return;
#line 3675 "MetadataWriter.c"
				}
			}
		}
		goto __finally380;
		__catch380_database_error:
		{
			GError* err = NULL;
			GError* _tmp51_;
#line 600 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			err = _inner_error_;
#line 600 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			_inner_error_ = NULL;
#line 607 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			_tmp51_ = err;
#line 607 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			app_window_database_error (_tmp51_);
#line 600 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			_g_error_free0 (err);
#line 3694 "MetadataWriter.c"
		}
		__finally380:
		{
			LibraryPhoto* _tmp52_;
			MetadataWriterCommitJob* _tmp53_;
			LibraryPhoto* _tmp54_;
#line 610 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			_tmp52_ = self->priv->ignore_photo_alteration;
#line 610 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			_tmp53_ = job;
#line 610 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			_tmp54_ = _tmp53_->photo;
#line 610 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			g_assert (_tmp52_ == _tmp54_);
#line 611 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			_g_object_unref0 (self->priv->ignore_photo_alteration);
#line 611 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			self->priv->ignore_photo_alteration = NULL;
#line 3713 "MetadataWriter.c"
		}
#line 600 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		if (_inner_error_ != NULL) {
#line 600 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			_background_job_unref0 (job);
#line 600 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 600 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			g_clear_error (&_inner_error_);
#line 600 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			return;
#line 3725 "MetadataWriter.c"
		}
	} else {
	}
	{
		MetadataWriterCommitJob* _tmp55_;
		LibraryPhoto* _tmp56_;
#line 621 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_tmp55_ = job;
#line 621 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_tmp56_ = _tmp55_->photo;
#line 621 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		photo_set_master_metadata_dirty (PHOTO (_tmp56_), FALSE, &_inner_error_);
#line 621 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		if (_inner_error_ != NULL) {
#line 621 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			if (_inner_error_->domain == DATABASE_ERROR) {
#line 3742 "MetadataWriter.c"
				goto __catch381_database_error;
			}
#line 621 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			_background_job_unref0 (job);
#line 621 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 621 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			g_clear_error (&_inner_error_);
#line 621 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			return;
#line 3753 "MetadataWriter.c"
		}
	}
	goto __finally381;
	__catch381_database_error:
	{
		GError* err = NULL;
		GError* _tmp57_;
#line 620 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		err = _inner_error_;
#line 620 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_inner_error_ = NULL;
#line 623 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_tmp57_ = err;
#line 623 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		app_window_database_error (_tmp57_);
#line 620 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_g_error_free0 (err);
#line 3771 "MetadataWriter.c"
	}
	__finally381:
#line 620 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	if (_inner_error_ != NULL) {
#line 620 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_background_job_unref0 (job);
#line 620 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 620 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		g_clear_error (&_inner_error_);
#line 620 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		return;
#line 3784 "MetadataWriter.c"
	}
#line 626 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp58_ = library_photo_global;
#line 626 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp59_ = media_source_collection_get_transaction_controller (MEDIA_SOURCE_COLLECTION (_tmp58_));
#line 626 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp60_ = _tmp59_;
#line 626 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	transaction_controller_commit (_tmp60_);
#line 628 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	metadata_writer_count_completed_work (self, 1, TRUE);
#line 580 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_background_job_unref0 (job);
#line 3798 "MetadataWriter.c"
}


static void metadata_writer_on_update_cancelled (MetadataWriter* self, BackgroundJob* j) {
	GeeHashMap* _tmp0_;
	BackgroundJob* _tmp1_;
	LibraryPhoto* _tmp2_;
	gboolean _tmp3_ = FALSE;
	gboolean removed;
#line 631 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	g_return_if_fail (IS_METADATA_WRITER (self));
#line 631 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	g_return_if_fail (IS_BACKGROUND_JOB (j));
#line 632 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp0_ = self->priv->pending;
#line 632 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp1_ = j;
#line 632 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp2_ = METADATA_WRITER_COMMIT_JOB (_tmp1_)->photo;
#line 632 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp3_ = gee_abstract_map_unset (GEE_ABSTRACT_MAP (_tmp0_), _tmp2_, NULL);
#line 632 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	removed = _tmp3_;
#line 633 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	g_assert (removed);
#line 635 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	metadata_writer_count_cancelled_work (self, 1, TRUE);
#line 3826 "MetadataWriter.c"
}


static void g_cclosure_user_marshal_VOID__UINT_UINT (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__UINT_UINT) (gpointer data1, guint arg_1, guint arg_2, gpointer data2);
	register GMarshalFunc_VOID__UINT_UINT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 14 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	g_return_if_fail (n_param_values == 3);
#line 14 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 14 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		data1 = closure->data;
#line 14 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		data2 = param_values->data[0].v_pointer;
#line 3845 "MetadataWriter.c"
	} else {
#line 14 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		data1 = param_values->data[0].v_pointer;
#line 14 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		data2 = closure->data;
#line 3851 "MetadataWriter.c"
	}
#line 14 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	callback = (GMarshalFunc_VOID__UINT_UINT) (marshal_data ? marshal_data : cc->callback);
#line 14 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	callback (data1, g_value_get_uint (param_values + 1), g_value_get_uint (param_values + 2), data2);
#line 3857 "MetadataWriter.c"
}


static void _metadata_writer_on_update_completed_completion_callback (BackgroundJob* job, gpointer self) {
#line 28 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	metadata_writer_on_update_completed (self, job);
#line 3864 "MetadataWriter.c"
}


static void _metadata_writer_on_update_cancelled_cancellation_callback (BackgroundJob* job, gpointer self) {
#line 28 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	metadata_writer_on_update_cancelled (self, job);
#line 3871 "MetadataWriter.c"
}


static MetadataWriterCommitJob* metadata_writer_commit_job_construct (GType object_type, MetadataWriter* owner, LibraryPhoto* photo, GeeSet* keywords) {
	MetadataWriterCommitJob* self = NULL;
	MetadataWriter* _tmp0_;
	MetadataWriter* _tmp1_;
	GCancellable* _tmp2_;
	GCancellable* _tmp3_;
	MetadataWriter* _tmp4_;
	LibraryPhoto* _tmp5_;
	LibraryPhoto* _tmp6_;
	GeeSet* _tmp7_;
	GeeSet* _tmp8_;
#line 27 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	g_return_val_if_fail (IS_METADATA_WRITER (owner), NULL);
#line 27 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	g_return_val_if_fail (IS_LIBRARY_PHOTO (photo), NULL);
#line 27 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	g_return_val_if_fail ((keywords == NULL) || GEE_IS_SET (keywords), NULL);
#line 28 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp0_ = owner;
#line 28 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp1_ = owner;
#line 28 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp2_ = g_cancellable_new ();
#line 28 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp3_ = _tmp2_;
#line 28 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp4_ = owner;
#line 28 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	self = (MetadataWriterCommitJob*) background_job_construct (object_type, G_OBJECT (_tmp0_), _metadata_writer_on_update_completed_completion_callback, _tmp1_, _tmp3_, _metadata_writer_on_update_cancelled_cancellation_callback, _tmp4_);
#line 28 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_g_object_unref0 (_tmp3_);
#line 30 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp5_ = photo;
#line 30 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp6_ = _g_object_ref0 (_tmp5_);
#line 30 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_g_object_unref0 (self->photo);
#line 30 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	self->photo = _tmp6_;
#line 31 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp7_ = keywords;
#line 31 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp8_ = _g_object_ref0 (_tmp7_);
#line 31 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_g_object_unref0 (self->current_keywords);
#line 31 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	self->current_keywords = _tmp8_;
#line 27 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	return self;
#line 3924 "MetadataWriter.c"
}


static MetadataWriterCommitJob* metadata_writer_commit_job_new (MetadataWriter* owner, LibraryPhoto* photo, GeeSet* keywords) {
#line 27 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	return metadata_writer_commit_job_construct (METADATA_WRITER_TYPE_COMMIT_JOB, owner, photo, keywords);
#line 3931 "MetadataWriter.c"
}


static gpointer _g_error_copy0 (gpointer self) {
#line 39 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	return self ? g_error_copy (self) : NULL;
#line 3938 "MetadataWriter.c"
}


static void metadata_writer_commit_job_real_execute (BackgroundJob* base) {
	MetadataWriterCommitJob * self;
	GError * _inner_error_ = NULL;
#line 34 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	self = METADATA_WRITER_COMMIT_JOB (base);
#line 3947 "MetadataWriter.c"
	{
#line 36 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		metadata_writer_commit_job_commit_master (self, &_inner_error_);
#line 36 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		if (_inner_error_ != NULL) {
#line 3953 "MetadataWriter.c"
			goto __catch382_g_error;
		}
#line 37 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		metadata_writer_commit_job_commit_editable (self, &_inner_error_);
#line 37 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		if (_inner_error_ != NULL) {
#line 3960 "MetadataWriter.c"
			goto __catch382_g_error;
		}
	}
	goto __finally382;
	__catch382_g_error:
	{
		GError* err = NULL;
		GError* _tmp0_;
		GError* _tmp1_;
#line 35 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		err = _inner_error_;
#line 35 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_inner_error_ = NULL;
#line 39 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_tmp0_ = err;
#line 39 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_tmp1_ = _g_error_copy0 (_tmp0_);
#line 39 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_g_error_free0 (self->err);
#line 39 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		self->err = _tmp1_;
#line 35 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_g_error_free0 (err);
#line 3984 "MetadataWriter.c"
	}
	__finally382:
#line 35 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	if (_inner_error_ != NULL) {
#line 35 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 35 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		g_clear_error (&_inner_error_);
#line 35 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		return;
#line 3995 "MetadataWriter.c"
	}
}


static void metadata_writer_commit_job_commit_master (MetadataWriterCommitJob* self, GError** error) {
	LibraryPhoto* _tmp0_;
	PhotoFileFormat _tmp1_ = 0;
	gboolean _tmp2_ = FALSE;
	LibraryPhoto* _tmp3_;
	PhotoMetadata* _tmp4_ = NULL;
	PhotoMetadata* metadata;
	PhotoMetadata* _tmp5_;
	gboolean _tmp6_ = FALSE;
	GError * _inner_error_ = NULL;
#line 43 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	g_return_if_fail (METADATA_WRITER_IS_COMMIT_JOB (self));
#line 44 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp0_ = self->photo;
#line 44 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp1_ = photo_get_master_file_format (PHOTO (_tmp0_));
#line 44 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp2_ = photo_file_format_can_write_metadata (_tmp1_);
#line 44 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	if (!_tmp2_) {
#line 45 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		return;
#line 4022 "MetadataWriter.c"
	}
#line 47 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp3_ = self->photo;
#line 47 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp4_ = photo_get_master_metadata (PHOTO (_tmp3_), &_inner_error_);
#line 47 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	metadata = _tmp4_;
#line 47 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	if (_inner_error_ != NULL) {
#line 47 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		g_propagate_error (error, _inner_error_);
#line 47 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		return;
#line 4036 "MetadataWriter.c"
	}
#line 48 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp5_ = metadata;
#line 48 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp6_ = metadata_writer_commit_job_update_metadata (self, _tmp5_);
#line 48 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	if (_tmp6_) {
#line 4044 "MetadataWriter.c"
		LibraryPhoto* _tmp7_;
		GFile* _tmp8_ = NULL;
		GFile* _tmp9_;
#line 49 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_tmp7_ = self->photo;
#line 49 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_tmp8_ = media_source_get_master_file (MEDIA_SOURCE (_tmp7_));
#line 49 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_tmp9_ = _tmp8_;
#line 49 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		library_monitor_blacklist_file (_tmp9_, "MetadataWriter.commit_master");
#line 49 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_g_object_unref0 (_tmp9_);
#line 4058 "MetadataWriter.c"
		{
			LibraryPhoto* _tmp10_;
			PhotoMetadata* _tmp11_;
			PhotoReimportMasterState* _tmp12_ = NULL;
#line 51 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			_tmp10_ = self->photo;
#line 51 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			_tmp11_ = metadata;
#line 51 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			photo_persist_master_metadata (PHOTO (_tmp10_), _tmp11_, &_tmp12_, &_inner_error_);
#line 51 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			_photo_reimport_master_state_unref0 (self->reimport_master_state);
#line 51 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			self->reimport_master_state = _tmp12_;
#line 51 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			if (_inner_error_ != NULL) {
#line 4075 "MetadataWriter.c"
				goto __finally383;
			}
		}
		__finally383:
		{
			LibraryPhoto* _tmp13_;
			GFile* _tmp14_ = NULL;
			GFile* _tmp15_;
#line 53 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			_tmp13_ = self->photo;
#line 53 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			_tmp14_ = media_source_get_master_file (MEDIA_SOURCE (_tmp13_));
#line 53 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			_tmp15_ = _tmp14_;
#line 53 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			library_monitor_unblacklist_file (_tmp15_);
#line 53 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			_g_object_unref0 (_tmp15_);
#line 4094 "MetadataWriter.c"
		}
#line 50 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		if (_inner_error_ != NULL) {
#line 50 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			g_propagate_error (error, _inner_error_);
#line 50 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			_media_metadata_unref0 (metadata);
#line 50 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			return;
#line 4104 "MetadataWriter.c"
		}
	}
#line 43 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_media_metadata_unref0 (metadata);
#line 4109 "MetadataWriter.c"
}


static void metadata_writer_commit_job_commit_editable (MetadataWriterCommitJob* self, GError** error) {
	gboolean _tmp0_ = FALSE;
	LibraryPhoto* _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp7_;
	LibraryPhoto* _tmp8_;
	PhotoMetadata* _tmp9_ = NULL;
	PhotoMetadata* metadata;
	PhotoMetadata* _tmp10_;
	PhotoMetadata* _tmp11_;
	gboolean _tmp12_ = FALSE;
	GError * _inner_error_ = NULL;
#line 58 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	g_return_if_fail (METADATA_WRITER_IS_COMMIT_JOB (self));
#line 59 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp1_ = self->photo;
#line 59 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp2_ = photo_has_editable (PHOTO (_tmp1_));
#line 59 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	if (!_tmp2_) {
#line 59 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_tmp0_ = TRUE;
#line 4135 "MetadataWriter.c"
	} else {
		LibraryPhoto* _tmp3_;
		PhotoFileFormat* _tmp4_ = NULL;
		PhotoFileFormat* _tmp5_;
		gboolean _tmp6_ = FALSE;
#line 59 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_tmp3_ = self->photo;
#line 59 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_tmp4_ = photo_get_editable_file_format (PHOTO (_tmp3_));
#line 59 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_tmp5_ = _tmp4_;
#line 59 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_tmp6_ = photo_file_format_can_write_metadata (*_tmp5_);
#line 59 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_tmp0_ = !_tmp6_;
#line 59 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_g_free0 (_tmp5_);
#line 4153 "MetadataWriter.c"
	}
#line 59 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp7_ = _tmp0_;
#line 59 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	if (_tmp7_) {
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		return;
#line 4161 "MetadataWriter.c"
	}
#line 62 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp8_ = self->photo;
#line 62 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp9_ = photo_get_editable_metadata (PHOTO (_tmp8_), &_inner_error_);
#line 62 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	metadata = _tmp9_;
#line 62 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	if (_inner_error_ != NULL) {
#line 62 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		g_propagate_error (error, _inner_error_);
#line 62 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		return;
#line 4175 "MetadataWriter.c"
	}
#line 63 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp10_ = metadata;
#line 63 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	g_assert (_tmp10_ != NULL);
#line 65 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp11_ = metadata;
#line 65 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp12_ = metadata_writer_commit_job_update_metadata (self, _tmp11_);
#line 65 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	if (_tmp12_) {
#line 4187 "MetadataWriter.c"
		LibraryPhoto* _tmp13_;
		GFile* _tmp14_ = NULL;
		GFile* _tmp15_;
#line 66 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_tmp13_ = self->photo;
#line 66 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_tmp14_ = photo_get_editable_file (PHOTO (_tmp13_));
#line 66 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_tmp15_ = _tmp14_;
#line 66 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		library_monitor_blacklist_file (_tmp15_, "MetadataWriter.commit_editable");
#line 66 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_g_object_unref0 (_tmp15_);
#line 4201 "MetadataWriter.c"
		{
			LibraryPhoto* _tmp16_;
			PhotoMetadata* _tmp17_;
			PhotoReimportEditableState* _tmp18_ = NULL;
#line 68 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			_tmp16_ = self->photo;
#line 68 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			_tmp17_ = metadata;
#line 68 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			photo_persist_editable_metadata (PHOTO (_tmp16_), _tmp17_, &_tmp18_, &_inner_error_);
#line 68 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			_photo_reimport_editable_state_unref0 (self->reimport_editable_state);
#line 68 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			self->reimport_editable_state = _tmp18_;
#line 68 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			if (_inner_error_ != NULL) {
#line 4218 "MetadataWriter.c"
				goto __finally384;
			}
		}
		__finally384:
		{
			LibraryPhoto* _tmp19_;
			GFile* _tmp20_ = NULL;
			GFile* _tmp21_;
#line 70 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			_tmp19_ = self->photo;
#line 70 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			_tmp20_ = photo_get_editable_file (PHOTO (_tmp19_));
#line 70 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			_tmp21_ = _tmp20_;
#line 70 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			library_monitor_unblacklist_file (_tmp21_);
#line 70 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			_g_object_unref0 (_tmp21_);
#line 4237 "MetadataWriter.c"
		}
#line 67 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		if (_inner_error_ != NULL) {
#line 67 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			g_propagate_error (error, _inner_error_);
#line 67 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			_media_metadata_unref0 (metadata);
#line 67 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			return;
#line 4247 "MetadataWriter.c"
		}
	}
#line 58 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_media_metadata_unref0 (metadata);
#line 4252 "MetadataWriter.c"
}


static gboolean metadata_writer_commit_job_update_metadata (MetadataWriterCommitJob* self, PhotoMetadata* metadata) {
	gboolean result = FALSE;
	gboolean changed;
	LibraryPhoto* _tmp0_;
	gchar* _tmp1_ = NULL;
	gchar* current_title;
	const gchar* _tmp2_;
	PhotoMetadata* _tmp3_;
	gchar* _tmp4_ = NULL;
	gchar* _tmp5_;
	gboolean _tmp6_;
	LibraryPhoto* _tmp9_;
	Rating _tmp10_ = 0;
	Rating current_rating;
	Rating _tmp11_;
	PhotoMetadata* _tmp12_;
	Rating _tmp13_ = 0;
	LibraryPhoto* _tmp16_;
	time_t _tmp17_ = 0;
	time_t current_exposure_time;
	time_t metadata_exposure_time;
	PhotoMetadata* _tmp18_;
	MetadataDateTime* _tmp19_ = NULL;
	MetadataDateTime* metadata_exposure_date_time;
	MetadataDateTime* _tmp20_;
	time_t _tmp23_;
	time_t _tmp24_;
	GeeSet* _tmp31_;
	PhotoMetadata* _tmp32_;
	GeeSet* _tmp33_ = NULL;
	GeeSet* _tmp34_;
	gboolean _tmp35_ = FALSE;
	gboolean _tmp36_;
	LibraryPhoto* _tmp39_;
	Orientation _tmp40_ = 0;
	Orientation current_orientation;
	Orientation _tmp41_;
	PhotoMetadata* _tmp42_;
	Orientation _tmp43_ = 0;
	gboolean _tmp46_;
#line 75 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	g_return_val_if_fail (METADATA_WRITER_IS_COMMIT_JOB (self), FALSE);
#line 75 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (metadata), FALSE);
#line 76 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	changed = FALSE;
#line 79 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp0_ = self->photo;
#line 79 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp1_ = media_source_get_title (MEDIA_SOURCE (_tmp0_));
#line 79 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	current_title = _tmp1_;
#line 80 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp2_ = current_title;
#line 80 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp3_ = metadata;
#line 80 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp4_ = media_metadata_get_title (MEDIA_METADATA (_tmp3_));
#line 80 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp5_ = _tmp4_;
#line 80 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp6_ = g_strcmp0 (_tmp2_, _tmp5_) != 0;
#line 80 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_g_free0 (_tmp5_);
#line 80 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	if (_tmp6_) {
#line 4322 "MetadataWriter.c"
		PhotoMetadata* _tmp7_;
		const gchar* _tmp8_;
#line 81 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_tmp7_ = metadata;
#line 81 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_tmp8_ = current_title;
#line 81 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		photo_metadata_set_title (_tmp7_, _tmp8_, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 82 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		changed = TRUE;
#line 4333 "MetadataWriter.c"
	}
#line 86 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp9_ = self->photo;
#line 86 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp10_ = media_source_get_rating (MEDIA_SOURCE (_tmp9_));
#line 86 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	current_rating = _tmp10_;
#line 87 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp11_ = current_rating;
#line 87 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp12_ = metadata;
#line 87 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp13_ = photo_metadata_get_rating (_tmp12_);
#line 87 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	if (_tmp11_ != _tmp13_) {
#line 4349 "MetadataWriter.c"
		PhotoMetadata* _tmp14_;
		Rating _tmp15_;
#line 88 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_tmp14_ = metadata;
#line 88 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_tmp15_ = current_rating;
#line 88 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		photo_metadata_set_rating (_tmp14_, _tmp15_);
#line 89 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		changed = TRUE;
#line 4360 "MetadataWriter.c"
	}
#line 93 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp16_ = self->photo;
#line 93 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp17_ = media_source_get_exposure_time (MEDIA_SOURCE (_tmp16_));
#line 93 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	current_exposure_time = _tmp17_;
#line 94 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	metadata_exposure_time = (time_t) 0;
#line 95 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp18_ = metadata;
#line 95 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp19_ = photo_metadata_get_exposure_date_time (_tmp18_);
#line 95 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	metadata_exposure_date_time = _tmp19_;
#line 96 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp20_ = metadata_exposure_date_time;
#line 96 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	if (_tmp20_ != NULL) {
#line 4380 "MetadataWriter.c"
		MetadataDateTime* _tmp21_;
		time_t _tmp22_ = 0;
#line 97 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_tmp21_ = metadata_exposure_date_time;
#line 97 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_tmp22_ = metadata_date_time_get_timestamp (_tmp21_);
#line 97 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		metadata_exposure_time = _tmp22_;
#line 4389 "MetadataWriter.c"
	}
#line 98 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp23_ = current_exposure_time;
#line 98 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp24_ = metadata_exposure_time;
#line 98 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	if (_tmp23_ != _tmp24_) {
#line 4397 "MetadataWriter.c"
		MetadataDateTime* _tmp25_ = NULL;
		time_t _tmp26_;
		PhotoMetadata* _tmp29_;
		MetadataDateTime* _tmp30_;
#line 99 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_tmp26_ = current_exposure_time;
#line 99 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		if (_tmp26_ != ((time_t) 0)) {
#line 4406 "MetadataWriter.c"
			time_t _tmp27_;
			MetadataDateTime* _tmp28_;
#line 100 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			_tmp27_ = current_exposure_time;
#line 100 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			_tmp28_ = metadata_date_time_new (_tmp27_);
#line 100 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			_metadata_date_time_unref0 (_tmp25_);
#line 100 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			_tmp25_ = _tmp28_;
#line 4417 "MetadataWriter.c"
		} else {
#line 101 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			_metadata_date_time_unref0 (_tmp25_);
#line 101 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
			_tmp25_ = NULL;
#line 4423 "MetadataWriter.c"
		}
#line 99 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_tmp29_ = metadata;
#line 99 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_tmp30_ = _tmp25_;
#line 99 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		photo_metadata_set_exposure_date_time (_tmp29_, _tmp30_, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 102 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		changed = TRUE;
#line 98 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_metadata_date_time_unref0 (_tmp25_);
#line 4435 "MetadataWriter.c"
	}
#line 106 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp31_ = self->current_keywords;
#line 106 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp32_ = metadata;
#line 106 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp33_ = photo_metadata_get_keywords (_tmp32_, NULL);
#line 106 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp34_ = _tmp33_;
#line 106 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp35_ = equal_sets (_tmp31_, _tmp34_);
#line 106 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp36_ = !_tmp35_;
#line 106 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_g_object_unref0 (_tmp34_);
#line 106 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	if (_tmp36_) {
#line 4453 "MetadataWriter.c"
		PhotoMetadata* _tmp37_;
		GeeSet* _tmp38_;
#line 107 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_tmp37_ = metadata;
#line 107 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_tmp38_ = self->current_keywords;
#line 107 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		photo_metadata_set_keywords (_tmp37_, GEE_COLLECTION (_tmp38_), PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 108 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		changed = TRUE;
#line 4464 "MetadataWriter.c"
	}
#line 112 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp39_ = self->photo;
#line 112 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp40_ = photo_get_orientation (PHOTO (_tmp39_));
#line 112 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	current_orientation = _tmp40_;
#line 113 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp41_ = current_orientation;
#line 113 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp42_ = metadata;
#line 113 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp43_ = photo_metadata_get_orientation (_tmp42_);
#line 113 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	if (_tmp41_ != _tmp43_) {
#line 4480 "MetadataWriter.c"
		PhotoMetadata* _tmp44_;
		Orientation _tmp45_;
#line 114 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_tmp44_ = metadata;
#line 114 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_tmp45_ = current_orientation;
#line 114 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		photo_metadata_set_orientation (_tmp44_, _tmp45_);
#line 115 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		changed = TRUE;
#line 4491 "MetadataWriter.c"
	}
#line 119 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp46_ = changed;
#line 119 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	if (_tmp46_) {
#line 4497 "MetadataWriter.c"
		PhotoMetadata* _tmp47_;
#line 120 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		_tmp47_ = metadata;
#line 120 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
		photo_metadata_set_software (_tmp47_, RESOURCES_APP_TITLE, RESOURCES_APP_VERSION);
#line 4503 "MetadataWriter.c"
	}
#line 122 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	result = changed;
#line 122 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_metadata_date_time_unref0 (metadata_exposure_date_time);
#line 122 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_g_free0 (current_title);
#line 122 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	return result;
#line 4513 "MetadataWriter.c"
}


static void metadata_writer_commit_job_class_init (MetadataWriterCommitJobClass * klass) {
#line 20 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	metadata_writer_commit_job_parent_class = g_type_class_peek_parent (klass);
#line 20 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	BACKGROUND_JOB_CLASS (klass)->finalize = metadata_writer_commit_job_finalize;
#line 20 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	BACKGROUND_JOB_CLASS (klass)->execute = metadata_writer_commit_job_real_execute;
#line 4524 "MetadataWriter.c"
}


static void metadata_writer_commit_job_instance_init (MetadataWriterCommitJob * self) {
#line 23 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	self->reimport_master_state = NULL;
#line 24 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	self->reimport_editable_state = NULL;
#line 25 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	self->err = NULL;
#line 4535 "MetadataWriter.c"
}


static void metadata_writer_commit_job_finalize (BackgroundJob* obj) {
	MetadataWriterCommitJob * self;
#line 20 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	self = METADATA_WRITER_COMMIT_JOB (obj);
#line 21 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_g_object_unref0 (self->photo);
#line 22 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_g_object_unref0 (self->current_keywords);
#line 23 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_photo_reimport_master_state_unref0 (self->reimport_master_state);
#line 24 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_photo_reimport_editable_state_unref0 (self->reimport_editable_state);
#line 25 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_g_error_free0 (self->err);
#line 20 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	BACKGROUND_JOB_CLASS (metadata_writer_commit_job_parent_class)->finalize (obj);
#line 4555 "MetadataWriter.c"
}


static GType metadata_writer_commit_job_get_type (void) {
	static volatile gsize metadata_writer_commit_job_type_id__volatile = 0;
	if (g_once_init_enter (&metadata_writer_commit_job_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (MetadataWriterCommitJobClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) metadata_writer_commit_job_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MetadataWriterCommitJob), 0, (GInstanceInitFunc) metadata_writer_commit_job_instance_init, NULL };
		GType metadata_writer_commit_job_type_id;
		metadata_writer_commit_job_type_id = g_type_register_static (TYPE_BACKGROUND_JOB, "MetadataWriterCommitJob", &g_define_type_info, 0);
		g_once_init_leave (&metadata_writer_commit_job_type_id__volatile, metadata_writer_commit_job_type_id);
	}
	return metadata_writer_commit_job_type_id__volatile;
}


static void metadata_writer_class_init (MetadataWriterClass * klass) {
#line 14 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	metadata_writer_parent_class = g_type_class_peek_parent (klass);
#line 14 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	g_type_class_add_private (klass, sizeof (MetadataWriterPrivate));
#line 14 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	G_OBJECT_CLASS (klass)->finalize = metadata_writer_finalize;
#line 14 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	g_signal_new ("progress", TYPE_METADATA_WRITER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__UINT_UINT, G_TYPE_NONE, 2, G_TYPE_UINT, G_TYPE_UINT);
#line 4580 "MetadataWriter.c"
}


static void metadata_writer_instance_init (MetadataWriter * self) {
	Workers* _tmp0_;
	GeeHashMap* _tmp1_;
	GeeHashSet* _tmp2_;
	GeeHashSet* _tmp3_;
#line 14 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	self->priv = METADATA_WRITER_GET_PRIVATE (self);
#line 128 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp0_ = workers_new (1, FALSE);
#line 128 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	self->priv->workers = _tmp0_;
#line 129 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	self->priv->enabled = FALSE;
#line 131 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp1_ = gee_hash_map_new (TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, g_object_unref, METADATA_WRITER_TYPE_COMMIT_JOB, (GBoxedCopyFunc) background_job_ref, background_job_unref, NULL, NULL, NULL);
#line 131 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	self->priv->pending = _tmp1_;
#line 132 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp2_ = gee_hash_set_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, NULL, NULL);
#line 132 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	self->priv->interested_photo_details = _tmp2_;
#line 133 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	self->priv->ignore_photo_alteration = NULL;
#line 134 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	self->priv->outstanding_total = (guint) 0;
#line 135 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	self->priv->outstanding_completed = (guint) 0;
#line 136 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	self->priv->closed = FALSE;
#line 137 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	self->priv->pause_count = 0;
#line 138 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp3_ = gee_hash_set_new (TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL);
#line 138 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	self->priv->importing_photos = _tmp3_;
#line 4619 "MetadataWriter.c"
}


static void metadata_writer_finalize (GObject* obj) {
	MetadataWriter * self;
	Config* _tmp0_ = NULL;
	Config* _tmp1_;
	guint _tmp2_ = 0U;
	LibraryPhotoSourceCollection* _tmp3_;
	guint _tmp4_ = 0U;
	LibraryPhotoSourceCollection* _tmp5_;
	guint _tmp6_ = 0U;
	LibraryPhotoSourceCollection* _tmp7_;
	guint _tmp8_ = 0U;
	LibraryPhotoSourceCollection* _tmp9_;
	guint _tmp10_ = 0U;
	LibraryPhotoSourceCollection* _tmp11_;
	guint _tmp12_ = 0U;
	LibraryPhotoSourceCollection* _tmp13_;
	guint _tmp14_ = 0U;
	LibraryPhotoSourceCollection* _tmp15_;
	guint _tmp16_ = 0U;
	TagSourceCollection* _tmp17_;
	guint _tmp18_ = 0U;
	TagSourceCollection* _tmp19_;
	guint _tmp20_ = 0U;
	TagSourceCollection* _tmp21_;
	guint _tmp22_ = 0U;
	TagSourceCollection* _tmp23_;
	guint _tmp24_ = 0U;
	TagSourceCollection* _tmp25_;
	guint _tmp26_ = 0U;
	Application* _tmp27_ = NULL;
	Application* _tmp28_;
	guint _tmp29_ = 0U;
	LibraryMonitorPool* _tmp30_ = NULL;
	LibraryMonitorPool* _tmp31_;
	LibraryMonitor* _tmp32_ = NULL;
	LibraryMonitor* _tmp33_;
	guint _tmp34_ = 0U;
#line 14 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	self = METADATA_WRITER (obj);
#line 182 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp0_ = config_get_instance ();
#line 182 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp1_ = _tmp0_;
#line 182 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	g_signal_parse_name ("bool-changed", TYPE_CONFIG, &_tmp2_, NULL, FALSE);
#line 182 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	g_signal_handlers_disconnect_matched (_tmp1_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp2_, 0, NULL, (GCallback) _metadata_writer_on_config_bool_changed_config_bool_changed, self);
#line 182 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_config_unref0 (_tmp1_);
#line 184 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp3_ = library_photo_global;
#line 184 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	g_signal_parse_name ("media-import-starting", TYPE_MEDIA_SOURCE_COLLECTION, &_tmp4_, NULL, FALSE);
#line 184 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	g_signal_handlers_disconnect_matched (MEDIA_SOURCE_COLLECTION (_tmp3_), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp4_, 0, NULL, (GCallback) _metadata_writer_on_importing_photos_media_source_collection_media_import_starting, self);
#line 185 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp5_ = library_photo_global;
#line 185 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	g_signal_parse_name ("media-import-completed", TYPE_MEDIA_SOURCE_COLLECTION, &_tmp6_, NULL, FALSE);
#line 185 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	g_signal_handlers_disconnect_matched (MEDIA_SOURCE_COLLECTION (_tmp5_), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp6_, 0, NULL, (GCallback) _metadata_writer_on_photos_imported_media_source_collection_media_import_completed, self);
#line 186 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp7_ = library_photo_global;
#line 186 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	g_signal_parse_name ("contents-altered", TYPE_DATA_COLLECTION, &_tmp8_, NULL, FALSE);
#line 186 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	g_signal_handlers_disconnect_matched (DATA_COLLECTION (_tmp7_), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp8_, 0, NULL, (GCallback) _metadata_writer_on_photos_added_removed_data_collection_contents_altered, self);
#line 187 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp9_ = library_photo_global;
#line 187 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	g_signal_parse_name ("items-altered", TYPE_DATA_COLLECTION, &_tmp10_, NULL, FALSE);
#line 187 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	g_signal_handlers_disconnect_matched (DATA_COLLECTION (_tmp9_), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp10_, 0, NULL, (GCallback) _metadata_writer_on_photos_altered_data_collection_items_altered, self);
#line 188 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp11_ = library_photo_global;
#line 188 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	g_signal_parse_name ("frozen", TYPE_DATA_COLLECTION, &_tmp12_, NULL, FALSE);
#line 188 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	g_signal_handlers_disconnect_matched (DATA_COLLECTION (_tmp11_), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp12_, 0, NULL, (GCallback) _metadata_writer_on_collection_frozen_data_collection_frozen, self);
#line 189 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp13_ = library_photo_global;
#line 189 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	g_signal_parse_name ("thawed", TYPE_DATA_COLLECTION, &_tmp14_, NULL, FALSE);
#line 189 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	g_signal_handlers_disconnect_matched (DATA_COLLECTION (_tmp13_), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp14_, 0, NULL, (GCallback) _metadata_writer_on_collection_thawed_data_collection_thawed, self);
#line 190 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp15_ = library_photo_global;
#line 190 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	g_signal_parse_name ("items-destroyed", TYPE_SOURCE_COLLECTION, &_tmp16_, NULL, FALSE);
#line 190 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	g_signal_handlers_disconnect_matched (SOURCE_COLLECTION (_tmp15_), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp16_, 0, NULL, (GCallback) _metadata_writer_on_photos_destroyed_source_collection_items_destroyed, self);
#line 192 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp17_ = tag_global;
#line 192 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	g_signal_parse_name ("items-altered", TYPE_DATA_COLLECTION, &_tmp18_, NULL, FALSE);
#line 192 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	g_signal_handlers_disconnect_matched (DATA_COLLECTION (_tmp17_), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp18_, 0, NULL, (GCallback) _metadata_writer_on_tags_altered_data_collection_items_altered, self);
#line 193 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp19_ = tag_global;
#line 193 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	g_signal_parse_name ("container-contents-altered", TYPE_CONTAINER_SOURCE_COLLECTION, &_tmp20_, NULL, FALSE);
#line 193 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	g_signal_handlers_disconnect_matched (CONTAINER_SOURCE_COLLECTION (_tmp19_), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp20_, 0, NULL, (GCallback) _metadata_writer_on_tag_contents_altered_container_source_collection_container_contents_altered, self);
#line 194 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp21_ = tag_global;
#line 194 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	g_signal_parse_name ("backlink-to-container-removed", TYPE_CONTAINER_SOURCE_COLLECTION, &_tmp22_, NULL, FALSE);
#line 194 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	g_signal_handlers_disconnect_matched (CONTAINER_SOURCE_COLLECTION (_tmp21_), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp22_, 0, NULL, (GCallback) _metadata_writer_on_tag_backlink_removed_container_source_collection_backlink_to_container_removed, self);
#line 195 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp23_ = tag_global;
#line 195 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	g_signal_parse_name ("frozen", TYPE_DATA_COLLECTION, &_tmp24_, NULL, FALSE);
#line 195 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	g_signal_handlers_disconnect_matched (DATA_COLLECTION (_tmp23_), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp24_, 0, NULL, (GCallback) _metadata_writer_on_collection_frozen_data_collection_frozen, self);
#line 196 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp25_ = tag_global;
#line 196 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	g_signal_parse_name ("thawed", TYPE_DATA_COLLECTION, &_tmp26_, NULL, FALSE);
#line 196 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	g_signal_handlers_disconnect_matched (DATA_COLLECTION (_tmp25_), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp26_, 0, NULL, (GCallback) _metadata_writer_on_collection_thawed_data_collection_thawed, self);
#line 198 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp27_ = application_get_instance ();
#line 198 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp28_ = _tmp27_;
#line 198 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	g_signal_parse_name ("exiting", TYPE_APPLICATION, &_tmp29_, NULL, FALSE);
#line 198 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	g_signal_handlers_disconnect_matched (_tmp28_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp29_, 0, NULL, (GCallback) _metadata_writer_on_application_exiting_application_exiting, self);
#line 198 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_application_unref0 (_tmp28_);
#line 200 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp30_ = library_monitor_pool_get_instance ();
#line 200 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp31_ = _tmp30_;
#line 200 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp32_ = library_monitor_pool_get_monitor (_tmp31_);
#line 200 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_tmp33_ = _tmp32_;
#line 200 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	g_signal_parse_name ("discovery-completed", TYPE_DIRECTORY_MONITOR, &_tmp34_, NULL, FALSE);
#line 200 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	g_signal_handlers_disconnect_matched (DIRECTORY_MONITOR (_tmp33_), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp34_, 0, NULL, (GCallback) _metadata_writer_on_discovery_completed_directory_monitor_discovery_completed, self);
#line 200 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_g_object_unref0 (_tmp33_);
#line 200 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_library_monitor_pool_unref0 (_tmp31_);
#line 128 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_workers_unref0 (self->priv->workers);
#line 130 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_timed_queue_unref0 (self->priv->dirty);
#line 131 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_g_object_unref0 (self->priv->pending);
#line 132 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_g_object_unref0 (self->priv->interested_photo_details);
#line 133 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_g_object_unref0 (self->priv->ignore_photo_alteration);
#line 138 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	_g_object_unref0 (self->priv->importing_photos);
#line 14 "/builddir/build/BUILD/shotwell-0.10.1/src/MetadataWriter.vala"
	G_OBJECT_CLASS (metadata_writer_parent_class)->finalize (obj);
#line 4784 "MetadataWriter.c"
}


GType metadata_writer_get_type (void) {
	static volatile gsize metadata_writer_type_id__volatile = 0;
	if (g_once_init_enter (&metadata_writer_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (MetadataWriterClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) metadata_writer_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MetadataWriter), 0, (GInstanceInitFunc) metadata_writer_instance_init, NULL };
		GType metadata_writer_type_id;
		metadata_writer_type_id = g_type_register_static (G_TYPE_OBJECT, "MetadataWriter", &g_define_type_info, 0);
		g_once_init_leave (&metadata_writer_type_id__volatile, metadata_writer_type_id);
	}
	return metadata_writer_type_id__volatile;
}



