/* Photo.c generated by valac 0.14.2, the Vala compiler
 * generated from Photo.vala, do not modify */

/* Copyright 2009-2011 Yorba Foundation
 *
 * This software is licensed under the GNU LGPL (version 2.1 or later).
 * See the COPYING file in this distribution. 
 */
/* Specifies how pixel data is fetched from the backing file on disk.  MASTER is the original*/
/* backing photo of any supported photo file format; SOURCE is either the master or the editable*/
/* file, that is, the appropriate reference file for user display; BASELINE is an appropriate*/
/* file with the proviso that it may be a suitable substitute for the master and/or the editable*/
/* (i.e. a mimic).*/
/**/
/* In general, callers want to use the BASELINE unless requirements are specific.*/

#include <glib.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <gee.h>
#include <gdk-pixbuf/gdk-pixdata.h>
#include <gdk/gdk.h>
#include <glib/gi18n-lib.h>
#include <float.h>
#include <math.h>
#include <gobject/gvaluecollector.h>


#define TYPE_BACKING_FETCH_MODE (backing_fetch_mode_get_type ())

#define TYPE_PHOTO_IMPORT_PARAMS (photo_import_params_get_type ())
#define PHOTO_IMPORT_PARAMS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_IMPORT_PARAMS, PhotoImportParams))
#define PHOTO_IMPORT_PARAMS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_IMPORT_PARAMS, PhotoImportParamsClass))
#define IS_PHOTO_IMPORT_PARAMS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_IMPORT_PARAMS))
#define IS_PHOTO_IMPORT_PARAMS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_IMPORT_PARAMS))
#define PHOTO_IMPORT_PARAMS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_IMPORT_PARAMS, PhotoImportParamsClass))

typedef struct _PhotoImportParams PhotoImportParams;
typedef struct _PhotoImportParamsClass PhotoImportParamsClass;
typedef struct _PhotoImportParamsPrivate PhotoImportParamsPrivate;

#define TYPE_IMPORT_ID (import_id_get_type ())
typedef struct _ImportID ImportID;

#define PHOTO_FILE_SNIFFER_TYPE_OPTIONS (photo_file_sniffer_options_get_type ())

#define TYPE_THUMBNAILS (thumbnails_get_type ())
#define THUMBNAILS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_THUMBNAILS, Thumbnails))
#define THUMBNAILS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_THUMBNAILS, ThumbnailsClass))
#define IS_THUMBNAILS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_THUMBNAILS))
#define IS_THUMBNAILS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_THUMBNAILS))
#define THUMBNAILS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_THUMBNAILS, ThumbnailsClass))

typedef struct _Thumbnails Thumbnails;
typedef struct _ThumbnailsClass ThumbnailsClass;

#define TYPE_PHOTO_ROW (photo_row_get_type ())

#define TYPE_PHOTO_ID (photo_id_get_type ())
typedef struct _PhotoID PhotoID;

#define TYPE_BACKING_PHOTO_STATE (backing_photo_state_get_type ())

#define TYPE_PHOTO_FILE_FORMAT (photo_file_format_get_type ())

#define TYPE_DIMENSIONS (dimensions_get_type ())
typedef struct _Dimensions Dimensions;

#define TYPE_ORIENTATION (orientation_get_type ())
typedef struct _BackingPhotoState BackingPhotoState;

#define TYPE_EVENT_ID (event_id_get_type ())
typedef struct _EventID EventID;

#define TYPE_KEY_VALUE_MAP (key_value_map_get_type ())
#define KEY_VALUE_MAP(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_KEY_VALUE_MAP, KeyValueMap))
#define KEY_VALUE_MAP_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_KEY_VALUE_MAP, KeyValueMapClass))
#define IS_KEY_VALUE_MAP(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_KEY_VALUE_MAP))
#define IS_KEY_VALUE_MAP_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_KEY_VALUE_MAP))
#define KEY_VALUE_MAP_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_KEY_VALUE_MAP, KeyValueMapClass))

typedef struct _KeyValueMap KeyValueMap;
typedef struct _KeyValueMapClass KeyValueMapClass;

#define TYPE_RATING (rating_get_type ())

#define TYPE_BACKING_PHOTO_ID (backing_photo_id_get_type ())
typedef struct _BackingPhotoID BackingPhotoID;
typedef struct _PhotoRow PhotoRow;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _thumbnails_unref0(var) ((var == NULL) ? NULL : (var = (thumbnails_unref (var), NULL)))
typedef struct _ParamSpecPhotoImportParams ParamSpecPhotoImportParams;

#define TYPE_PHOTO_TRANSFORMATION_STATE (photo_transformation_state_get_type ())
#define PHOTO_TRANSFORMATION_STATE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_TRANSFORMATION_STATE, PhotoTransformationState))
#define PHOTO_TRANSFORMATION_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_TRANSFORMATION_STATE, PhotoTransformationStateClass))
#define IS_PHOTO_TRANSFORMATION_STATE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_TRANSFORMATION_STATE))
#define IS_PHOTO_TRANSFORMATION_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_TRANSFORMATION_STATE))
#define PHOTO_TRANSFORMATION_STATE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_TRANSFORMATION_STATE, PhotoTransformationStateClass))

typedef struct _PhotoTransformationState PhotoTransformationState;
typedef struct _PhotoTransformationStateClass PhotoTransformationStateClass;
typedef struct _PhotoTransformationStatePrivate PhotoTransformationStatePrivate;

#define TYPE_DATA_OBJECT (data_object_get_type ())
#define DATA_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_OBJECT, DataObject))
#define DATA_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_OBJECT, DataObjectClass))
#define IS_DATA_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_OBJECT))
#define IS_DATA_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_OBJECT))
#define DATA_OBJECT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_OBJECT, DataObjectClass))

typedef struct _DataObject DataObject;
typedef struct _DataObjectClass DataObjectClass;
typedef struct _DataObjectPrivate DataObjectPrivate;

#define TYPE_ALTERATION (alteration_get_type ())
#define ALTERATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ALTERATION, Alteration))
#define ALTERATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ALTERATION, AlterationClass))
#define IS_ALTERATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ALTERATION))
#define IS_ALTERATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ALTERATION))
#define ALTERATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ALTERATION, AlterationClass))

typedef struct _Alteration Alteration;
typedef struct _AlterationClass AlterationClass;

#define TYPE_DATA_COLLECTION (data_collection_get_type ())
#define DATA_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_COLLECTION, DataCollection))
#define DATA_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_COLLECTION, DataCollectionClass))
#define IS_DATA_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_COLLECTION))
#define IS_DATA_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_COLLECTION))
#define DATA_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_COLLECTION, DataCollectionClass))

typedef struct _DataCollection DataCollection;
typedef struct _DataCollectionClass DataCollectionClass;

#define TYPE_DATA_SOURCE (data_source_get_type ())
#define DATA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_SOURCE, DataSource))
#define DATA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_SOURCE, DataSourceClass))
#define IS_DATA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_SOURCE))
#define IS_DATA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_SOURCE))
#define DATA_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_SOURCE, DataSourceClass))

typedef struct _DataSource DataSource;
typedef struct _DataSourceClass DataSourceClass;
typedef struct _DataSourcePrivate DataSourcePrivate;

#define TYPE_SOURCE_HOLDING_TANK (source_holding_tank_get_type ())
#define SOURCE_HOLDING_TANK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SOURCE_HOLDING_TANK, SourceHoldingTank))
#define SOURCE_HOLDING_TANK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SOURCE_HOLDING_TANK, SourceHoldingTankClass))
#define IS_SOURCE_HOLDING_TANK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SOURCE_HOLDING_TANK))
#define IS_SOURCE_HOLDING_TANK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SOURCE_HOLDING_TANK))
#define SOURCE_HOLDING_TANK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SOURCE_HOLDING_TANK, SourceHoldingTankClass))

typedef struct _SourceHoldingTank SourceHoldingTank;
typedef struct _SourceHoldingTankClass SourceHoldingTankClass;

#define TYPE_SOURCE_COLLECTION (source_collection_get_type ())
#define SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SOURCE_COLLECTION, SourceCollection))
#define SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SOURCE_COLLECTION, SourceCollectionClass))
#define IS_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SOURCE_COLLECTION))
#define IS_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SOURCE_COLLECTION))
#define SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SOURCE_COLLECTION, SourceCollectionClass))

typedef struct _SourceCollection SourceCollection;
typedef struct _SourceCollectionClass SourceCollectionClass;

#define TYPE_SOURCE_SNAPSHOT (source_snapshot_get_type ())
#define SOURCE_SNAPSHOT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SOURCE_SNAPSHOT, SourceSnapshot))
#define SOURCE_SNAPSHOT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SOURCE_SNAPSHOT, SourceSnapshotClass))
#define IS_SOURCE_SNAPSHOT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SOURCE_SNAPSHOT))
#define IS_SOURCE_SNAPSHOT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SOURCE_SNAPSHOT))
#define SOURCE_SNAPSHOT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SOURCE_SNAPSHOT, SourceSnapshotClass))

typedef struct _SourceSnapshot SourceSnapshot;
typedef struct _SourceSnapshotClass SourceSnapshotClass;

#define TYPE_THUMBNAIL_SOURCE (thumbnail_source_get_type ())
#define THUMBNAIL_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_THUMBNAIL_SOURCE, ThumbnailSource))
#define THUMBNAIL_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_THUMBNAIL_SOURCE, ThumbnailSourceClass))
#define IS_THUMBNAIL_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_THUMBNAIL_SOURCE))
#define IS_THUMBNAIL_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_THUMBNAIL_SOURCE))
#define THUMBNAIL_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_THUMBNAIL_SOURCE, ThumbnailSourceClass))

typedef struct _ThumbnailSource ThumbnailSource;
typedef struct _ThumbnailSourceClass ThumbnailSourceClass;
typedef struct _ThumbnailSourcePrivate ThumbnailSourcePrivate;

#define TYPE_INDEXABLE (indexable_get_type ())
#define INDEXABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_INDEXABLE, Indexable))
#define IS_INDEXABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_INDEXABLE))
#define INDEXABLE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_INDEXABLE, IndexableIface))

typedef struct _Indexable Indexable;
typedef struct _IndexableIface IndexableIface;

#define TYPE_MEDIA_SOURCE (media_source_get_type ())
#define MEDIA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_SOURCE, MediaSource))
#define MEDIA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_SOURCE, MediaSourceClass))
#define IS_MEDIA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_SOURCE))
#define IS_MEDIA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_SOURCE))
#define MEDIA_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_SOURCE, MediaSourceClass))

typedef struct _MediaSource MediaSource;
typedef struct _MediaSourceClass MediaSourceClass;
typedef struct _MediaSourcePrivate MediaSourcePrivate;

#define TYPE_BACKING_FILE_STATE (backing_file_state_get_type ())
#define BACKING_FILE_STATE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BACKING_FILE_STATE, BackingFileState))
#define BACKING_FILE_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BACKING_FILE_STATE, BackingFileStateClass))
#define IS_BACKING_FILE_STATE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BACKING_FILE_STATE))
#define IS_BACKING_FILE_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BACKING_FILE_STATE))
#define BACKING_FILE_STATE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BACKING_FILE_STATE, BackingFileStateClass))

typedef struct _BackingFileState BackingFileState;
typedef struct _BackingFileStateClass BackingFileStateClass;

#define TYPE_SCALING (scaling_get_type ())

#define TYPE_SCALE_CONSTRAINT (scale_constraint_get_type ())
typedef struct _Scaling Scaling;

#define TYPE_PHOTO_SOURCE (photo_source_get_type ())
#define PHOTO_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_SOURCE, PhotoSource))
#define PHOTO_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_SOURCE, PhotoSourceClass))
#define IS_PHOTO_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_SOURCE))
#define IS_PHOTO_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_SOURCE))
#define PHOTO_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_SOURCE, PhotoSourceClass))

typedef struct _PhotoSource PhotoSource;
typedef struct _PhotoSourceClass PhotoSourceClass;
typedef struct _PhotoSourcePrivate PhotoSourcePrivate;

#define TYPE_MEDIA_METADATA (media_metadata_get_type ())
#define MEDIA_METADATA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_METADATA, MediaMetadata))
#define MEDIA_METADATA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_METADATA, MediaMetadataClass))
#define IS_MEDIA_METADATA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_METADATA))
#define IS_MEDIA_METADATA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_METADATA))
#define MEDIA_METADATA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_METADATA, MediaMetadataClass))

typedef struct _MediaMetadata MediaMetadata;
typedef struct _MediaMetadataClass MediaMetadataClass;

#define TYPE_PHOTO_METADATA (photo_metadata_get_type ())
#define PHOTO_METADATA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_METADATA, PhotoMetadata))
#define PHOTO_METADATA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_METADATA, PhotoMetadataClass))
#define IS_PHOTO_METADATA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_METADATA))
#define IS_PHOTO_METADATA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_METADATA))
#define PHOTO_METADATA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_METADATA, PhotoMetadataClass))

typedef struct _PhotoMetadata PhotoMetadata;
typedef struct _PhotoMetadataClass PhotoMetadataClass;

#define TYPE_DATEABLE (dateable_get_type ())
#define DATEABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATEABLE, Dateable))
#define IS_DATEABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATEABLE))
#define DATEABLE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_DATEABLE, DateableIface))

typedef struct _Dateable Dateable;
typedef struct _DateableIface DateableIface;

#define TYPE_PHOTO (photo_get_type ())
#define PHOTO(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO, Photo))
#define PHOTO_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO, PhotoClass))
#define IS_PHOTO(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO))
#define IS_PHOTO_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO))
#define PHOTO_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO, PhotoClass))

typedef struct _Photo Photo;
typedef struct _PhotoClass PhotoClass;
typedef struct _PhotoPrivate PhotoPrivate;

#define TYPE_ROTATION (rotation_get_type ())

#define PHOTO_TYPE_BACKING_READERS (photo_backing_readers_get_type ())

#define TYPE_PHOTO_FILE_ADAPTER (photo_file_adapter_get_type ())
#define PHOTO_FILE_ADAPTER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter))
#define PHOTO_FILE_ADAPTER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapterClass))
#define IS_PHOTO_FILE_ADAPTER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_FILE_ADAPTER))
#define IS_PHOTO_FILE_ADAPTER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_FILE_ADAPTER))
#define PHOTO_FILE_ADAPTER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapterClass))

typedef struct _PhotoFileAdapter PhotoFileAdapter;
typedef struct _PhotoFileAdapterClass PhotoFileAdapterClass;

#define TYPE_PHOTO_FILE_READER (photo_file_reader_get_type ())
#define PHOTO_FILE_READER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_FILE_READER, PhotoFileReader))
#define PHOTO_FILE_READER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_FILE_READER, PhotoFileReaderClass))
#define IS_PHOTO_FILE_READER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_FILE_READER))
#define IS_PHOTO_FILE_READER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_FILE_READER))
#define PHOTO_FILE_READER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_FILE_READER, PhotoFileReaderClass))

typedef struct _PhotoFileReader PhotoFileReader;
typedef struct _PhotoFileReaderClass PhotoFileReaderClass;
typedef struct _PhotoBackingReaders PhotoBackingReaders;

#define TYPE_PIXEL_TRANSFORMER (pixel_transformer_get_type ())
#define PIXEL_TRANSFORMER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PIXEL_TRANSFORMER, PixelTransformer))
#define PIXEL_TRANSFORMER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PIXEL_TRANSFORMER, PixelTransformerClass))
#define IS_PIXEL_TRANSFORMER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PIXEL_TRANSFORMER))
#define IS_PIXEL_TRANSFORMER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PIXEL_TRANSFORMER))
#define PIXEL_TRANSFORMER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PIXEL_TRANSFORMER, PixelTransformerClass))

typedef struct _PixelTransformer PixelTransformer;
typedef struct _PixelTransformerClass PixelTransformerClass;

#define TYPE_PIXEL_TRANSFORMATION_BUNDLE (pixel_transformation_bundle_get_type ())
#define PIXEL_TRANSFORMATION_BUNDLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PIXEL_TRANSFORMATION_BUNDLE, PixelTransformationBundle))
#define PIXEL_TRANSFORMATION_BUNDLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PIXEL_TRANSFORMATION_BUNDLE, PixelTransformationBundleClass))
#define IS_PIXEL_TRANSFORMATION_BUNDLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PIXEL_TRANSFORMATION_BUNDLE))
#define IS_PIXEL_TRANSFORMATION_BUNDLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PIXEL_TRANSFORMATION_BUNDLE))
#define PIXEL_TRANSFORMATION_BUNDLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PIXEL_TRANSFORMATION_BUNDLE, PixelTransformationBundleClass))

typedef struct _PixelTransformationBundle PixelTransformationBundle;
typedef struct _PixelTransformationBundleClass PixelTransformationBundleClass;

#define TYPE_ONE_SHOT_SCHEDULER (one_shot_scheduler_get_type ())
#define ONE_SHOT_SCHEDULER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ONE_SHOT_SCHEDULER, OneShotScheduler))
#define ONE_SHOT_SCHEDULER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ONE_SHOT_SCHEDULER, OneShotSchedulerClass))
#define IS_ONE_SHOT_SCHEDULER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ONE_SHOT_SCHEDULER))
#define IS_ONE_SHOT_SCHEDULER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ONE_SHOT_SCHEDULER))
#define ONE_SHOT_SCHEDULER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ONE_SHOT_SCHEDULER, OneShotSchedulerClass))

typedef struct _OneShotScheduler OneShotScheduler;
typedef struct _OneShotSchedulerClass OneShotSchedulerClass;

#define PHOTO_TYPE_EXCEPTION (photo_exception_get_type ())
#define _pixel_transformer_unref0(var) ((var == NULL) ? NULL : (var = (pixel_transformer_unref (var), NULL)))
#define _pixel_transformation_bundle_unref0(var) ((var == NULL) ? NULL : (var = (pixel_transformation_bundle_unref (var), NULL)))
#define _one_shot_scheduler_unref0(var) ((var == NULL) ? NULL : (var = (one_shot_scheduler_unref (var), NULL)))
#define _photo_file_adapter_unref0(var) ((var == NULL) ? NULL : (var = (photo_file_adapter_unref (var), NULL)))

#define TYPE_BACKING_PHOTO_ROW (backing_photo_row_get_type ())
typedef struct _BackingPhotoRow BackingPhotoRow;

#define TYPE_DATABASE_TABLE (database_table_get_type ())
#define DATABASE_TABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATABASE_TABLE, DatabaseTable))
#define DATABASE_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATABASE_TABLE, DatabaseTableClass))
#define IS_DATABASE_TABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATABASE_TABLE))
#define IS_DATABASE_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATABASE_TABLE))
#define DATABASE_TABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATABASE_TABLE, DatabaseTableClass))

typedef struct _DatabaseTable DatabaseTable;
typedef struct _DatabaseTableClass DatabaseTableClass;

#define TYPE_BACKING_PHOTO_TABLE (backing_photo_table_get_type ())
#define BACKING_PHOTO_TABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BACKING_PHOTO_TABLE, BackingPhotoTable))
#define BACKING_PHOTO_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BACKING_PHOTO_TABLE, BackingPhotoTableClass))
#define IS_BACKING_PHOTO_TABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BACKING_PHOTO_TABLE))
#define IS_BACKING_PHOTO_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BACKING_PHOTO_TABLE))
#define BACKING_PHOTO_TABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BACKING_PHOTO_TABLE, BackingPhotoTableClass))

typedef struct _BackingPhotoTable BackingPhotoTable;
typedef struct _BackingPhotoTableClass BackingPhotoTableClass;
#define _database_table_unref0(var) ((var == NULL) ? NULL : (var = (database_table_unref (var), NULL)))
#define _backing_photo_row_free0(var) ((var == NULL) ? NULL : (var = (backing_photo_row_free (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

#define TYPE_PHOTO_TABLE (photo_table_get_type ())
#define PHOTO_TABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_TABLE, PhotoTable))
#define PHOTO_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_TABLE, PhotoTableClass))
#define IS_PHOTO_TABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_TABLE))
#define IS_PHOTO_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_TABLE))
#define PHOTO_TABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_TABLE, PhotoTableClass))

typedef struct _PhotoTable PhotoTable;
typedef struct _PhotoTableClass PhotoTableClass;

#define TYPE_PHOTO_FILE_FORMAT_FLAGS (photo_file_format_flags_get_type ())

#define TYPE_PHOTO_FILE_FORMAT_PROPERTIES (photo_file_format_properties_get_type ())
#define PHOTO_FILE_FORMAT_PROPERTIES(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_FILE_FORMAT_PROPERTIES, PhotoFileFormatProperties))
#define PHOTO_FILE_FORMAT_PROPERTIES_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_FILE_FORMAT_PROPERTIES, PhotoFileFormatPropertiesClass))
#define IS_PHOTO_FILE_FORMAT_PROPERTIES(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_FILE_FORMAT_PROPERTIES))
#define IS_PHOTO_FILE_FORMAT_PROPERTIES_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_FILE_FORMAT_PROPERTIES))
#define PHOTO_FILE_FORMAT_PROPERTIES_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_FILE_FORMAT_PROPERTIES, PhotoFileFormatPropertiesClass))

typedef struct _PhotoFileFormatProperties PhotoFileFormatProperties;
typedef struct _PhotoFileFormatPropertiesClass PhotoFileFormatPropertiesClass;
#define _photo_file_format_properties_unref0(var) ((var == NULL) ? NULL : (var = (photo_file_format_properties_unref (var), NULL)))

#define TYPE_EXPORT_FORMAT_PARAMETERS (export_format_parameters_get_type ())

#define TYPE_EXPORT_FORMAT_MODE (export_format_mode_get_type ())

#define JPEG_TYPE_QUALITY (jpeg_quality_get_type ())
typedef struct _ExportFormatParameters ExportFormatParameters;

#define TYPE_IMPORT_RESULT (import_result_get_type ())

#define TYPE_PHOTO_FILE_INTERROGATOR (photo_file_interrogator_get_type ())
#define PHOTO_FILE_INTERROGATOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_FILE_INTERROGATOR, PhotoFileInterrogator))
#define PHOTO_FILE_INTERROGATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_FILE_INTERROGATOR, PhotoFileInterrogatorClass))
#define IS_PHOTO_FILE_INTERROGATOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_FILE_INTERROGATOR))
#define IS_PHOTO_FILE_INTERROGATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_FILE_INTERROGATOR))
#define PHOTO_FILE_INTERROGATOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_FILE_INTERROGATOR, PhotoFileInterrogatorClass))

typedef struct _PhotoFileInterrogator PhotoFileInterrogator;
typedef struct _PhotoFileInterrogatorClass PhotoFileInterrogatorClass;
#define _photo_file_interrogator_unref0(var) ((var == NULL) ? NULL : (var = (photo_file_interrogator_unref (var), NULL)))

#define TYPE_DETECTED_PHOTO_INFORMATION (detected_photo_information_get_type ())
#define DETECTED_PHOTO_INFORMATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DETECTED_PHOTO_INFORMATION, DetectedPhotoInformation))
#define DETECTED_PHOTO_INFORMATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DETECTED_PHOTO_INFORMATION, DetectedPhotoInformationClass))
#define IS_DETECTED_PHOTO_INFORMATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DETECTED_PHOTO_INFORMATION))
#define IS_DETECTED_PHOTO_INFORMATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DETECTED_PHOTO_INFORMATION))
#define DETECTED_PHOTO_INFORMATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DETECTED_PHOTO_INFORMATION, DetectedPhotoInformationClass))

typedef struct _DetectedPhotoInformation DetectedPhotoInformation;
typedef struct _DetectedPhotoInformationClass DetectedPhotoInformationClass;
#define _detected_photo_information_unref0(var) ((var == NULL) ? NULL : (var = (detected_photo_information_unref (var), NULL)))
typedef struct _DetectedPhotoInformationPrivate DetectedPhotoInformationPrivate;

#define TYPE_METADATA_DATE_TIME (metadata_date_time_get_type ())
#define METADATA_DATE_TIME(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_METADATA_DATE_TIME, MetadataDateTime))
#define METADATA_DATE_TIME_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_METADATA_DATE_TIME, MetadataDateTimeClass))
#define IS_METADATA_DATE_TIME(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_METADATA_DATE_TIME))
#define IS_METADATA_DATE_TIME_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_METADATA_DATE_TIME))
#define METADATA_DATE_TIME_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_METADATA_DATE_TIME, MetadataDateTimeClass))

typedef struct _MetadataDateTime MetadataDateTime;
typedef struct _MetadataDateTimeClass MetadataDateTimeClass;
#define _metadata_date_time_unref0(var) ((var == NULL) ? NULL : (var = (metadata_date_time_unref (var), NULL)))

#define PHOTO_TYPE_REIMPORT_MASTER_STATE (photo_reimport_master_state_get_type ())
#define PHOTO_REIMPORT_MASTER_STATE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PHOTO_TYPE_REIMPORT_MASTER_STATE, PhotoReimportMasterState))
#define PHOTO_REIMPORT_MASTER_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PHOTO_TYPE_REIMPORT_MASTER_STATE, PhotoReimportMasterStateClass))
#define PHOTO_IS_REIMPORT_MASTER_STATE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PHOTO_TYPE_REIMPORT_MASTER_STATE))
#define PHOTO_IS_REIMPORT_MASTER_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PHOTO_TYPE_REIMPORT_MASTER_STATE))
#define PHOTO_REIMPORT_MASTER_STATE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PHOTO_TYPE_REIMPORT_MASTER_STATE, PhotoReimportMasterStateClass))

typedef struct _PhotoReimportMasterState PhotoReimportMasterState;
typedef struct _PhotoReimportMasterStateClass PhotoReimportMasterStateClass;
#define _photo_reimport_master_state_unref0(var) ((var == NULL) ? NULL : (var = (photo_reimport_master_state_unref (var), NULL)))
#define _media_metadata_unref0(var) ((var == NULL) ? NULL : (var = (media_metadata_unref (var), NULL)))

#define PHOTO_TYPE_REIMPORT_MASTER_STATE_IMPL (photo_reimport_master_state_impl_get_type ())
#define PHOTO_REIMPORT_MASTER_STATE_IMPL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PHOTO_TYPE_REIMPORT_MASTER_STATE_IMPL, PhotoReimportMasterStateImpl))
#define PHOTO_REIMPORT_MASTER_STATE_IMPL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PHOTO_TYPE_REIMPORT_MASTER_STATE_IMPL, PhotoReimportMasterStateImplClass))
#define PHOTO_IS_REIMPORT_MASTER_STATE_IMPL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PHOTO_TYPE_REIMPORT_MASTER_STATE_IMPL))
#define PHOTO_IS_REIMPORT_MASTER_STATE_IMPL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PHOTO_TYPE_REIMPORT_MASTER_STATE_IMPL))
#define PHOTO_REIMPORT_MASTER_STATE_IMPL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PHOTO_TYPE_REIMPORT_MASTER_STATE_IMPL, PhotoReimportMasterStateImplClass))

typedef struct _PhotoReimportMasterStateImpl PhotoReimportMasterStateImpl;
typedef struct _PhotoReimportMasterStateImplClass PhotoReimportMasterStateImplClass;
typedef struct _PhotoReimportMasterStatePrivate PhotoReimportMasterStatePrivate;
typedef struct _PhotoReimportMasterStateImplPrivate PhotoReimportMasterStateImplPrivate;
#define _alteration_unref0(var) ((var == NULL) ? NULL : (var = (alteration_unref (var), NULL)))

#define PHOTO_TYPE_REIMPORT_EDITABLE_STATE (photo_reimport_editable_state_get_type ())
#define PHOTO_REIMPORT_EDITABLE_STATE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PHOTO_TYPE_REIMPORT_EDITABLE_STATE, PhotoReimportEditableState))
#define PHOTO_REIMPORT_EDITABLE_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PHOTO_TYPE_REIMPORT_EDITABLE_STATE, PhotoReimportEditableStateClass))
#define PHOTO_IS_REIMPORT_EDITABLE_STATE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PHOTO_TYPE_REIMPORT_EDITABLE_STATE))
#define PHOTO_IS_REIMPORT_EDITABLE_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PHOTO_TYPE_REIMPORT_EDITABLE_STATE))
#define PHOTO_REIMPORT_EDITABLE_STATE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PHOTO_TYPE_REIMPORT_EDITABLE_STATE, PhotoReimportEditableStateClass))

typedef struct _PhotoReimportEditableState PhotoReimportEditableState;
typedef struct _PhotoReimportEditableStateClass PhotoReimportEditableStateClass;
#define _photo_reimport_editable_state_unref0(var) ((var == NULL) ? NULL : (var = (photo_reimport_editable_state_unref (var), NULL)))

#define PHOTO_TYPE_REIMPORT_EDITABLE_STATE_IMPL (photo_reimport_editable_state_impl_get_type ())
#define PHOTO_REIMPORT_EDITABLE_STATE_IMPL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PHOTO_TYPE_REIMPORT_EDITABLE_STATE_IMPL, PhotoReimportEditableStateImpl))
#define PHOTO_REIMPORT_EDITABLE_STATE_IMPL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PHOTO_TYPE_REIMPORT_EDITABLE_STATE_IMPL, PhotoReimportEditableStateImplClass))
#define PHOTO_IS_REIMPORT_EDITABLE_STATE_IMPL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PHOTO_TYPE_REIMPORT_EDITABLE_STATE_IMPL))
#define PHOTO_IS_REIMPORT_EDITABLE_STATE_IMPL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PHOTO_TYPE_REIMPORT_EDITABLE_STATE_IMPL))
#define PHOTO_REIMPORT_EDITABLE_STATE_IMPL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PHOTO_TYPE_REIMPORT_EDITABLE_STATE_IMPL, PhotoReimportEditableStateImplClass))

typedef struct _PhotoReimportEditableStateImpl PhotoReimportEditableStateImpl;
typedef struct _PhotoReimportEditableStateImplClass PhotoReimportEditableStateImplClass;
typedef struct _PhotoReimportEditableStatePrivate PhotoReimportEditableStatePrivate;
typedef struct _PhotoReimportEditableStateImplPrivate PhotoReimportEditableStateImplPrivate;

#define TYPE_LIBRARY_PHOTO (library_photo_get_type ())
#define LIBRARY_PHOTO(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_LIBRARY_PHOTO, LibraryPhoto))
#define LIBRARY_PHOTO_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_LIBRARY_PHOTO, LibraryPhotoClass))
#define IS_LIBRARY_PHOTO(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_LIBRARY_PHOTO))
#define IS_LIBRARY_PHOTO_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_LIBRARY_PHOTO))
#define LIBRARY_PHOTO_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_LIBRARY_PHOTO, LibraryPhotoClass))

typedef struct _LibraryPhoto LibraryPhoto;
typedef struct _LibraryPhotoClass LibraryPhotoClass;

#define PHOTO_METADATA_TYPE_SET_OPTION (photo_metadata_set_option_get_type ())

#define TYPE_PHOTO_FILE_METADATA_WRITER (photo_file_metadata_writer_get_type ())
#define PHOTO_FILE_METADATA_WRITER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_FILE_METADATA_WRITER, PhotoFileMetadataWriter))
#define PHOTO_FILE_METADATA_WRITER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_FILE_METADATA_WRITER, PhotoFileMetadataWriterClass))
#define IS_PHOTO_FILE_METADATA_WRITER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_FILE_METADATA_WRITER))
#define IS_PHOTO_FILE_METADATA_WRITER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_FILE_METADATA_WRITER))
#define PHOTO_FILE_METADATA_WRITER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_FILE_METADATA_WRITER, PhotoFileMetadataWriterClass))

typedef struct _PhotoFileMetadataWriter PhotoFileMetadataWriter;
typedef struct _PhotoFileMetadataWriterClass PhotoFileMetadataWriterClass;

#define TYPE_BOX (box_get_type ())
typedef struct _Box Box;
#define _key_value_map_unref0(var) ((var == NULL) ? NULL : (var = (key_value_map_unref (var), NULL)))

#define TYPE_PIXEL_TRANSFORMATION_TYPE (pixel_transformation_type_get_type ())

#define TYPE_PIXEL_TRANSFORMATION (pixel_transformation_get_type ())
#define PIXEL_TRANSFORMATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PIXEL_TRANSFORMATION, PixelTransformation))
#define PIXEL_TRANSFORMATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PIXEL_TRANSFORMATION, PixelTransformationClass))
#define IS_PIXEL_TRANSFORMATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PIXEL_TRANSFORMATION))
#define IS_PIXEL_TRANSFORMATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PIXEL_TRANSFORMATION))
#define PIXEL_TRANSFORMATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PIXEL_TRANSFORMATION, PixelTransformationClass))

typedef struct _PixelTransformation PixelTransformation;
typedef struct _PixelTransformationClass PixelTransformationClass;
#define _pixel_transformation_unref0(var) ((var == NULL) ? NULL : (var = (pixel_transformation_unref (var), NULL)))

#define PHOTO_TYPE_PHOTO_TRANSFORMATION_STATE_IMPL (photo_photo_transformation_state_impl_get_type ())
#define PHOTO_PHOTO_TRANSFORMATION_STATE_IMPL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PHOTO_TYPE_PHOTO_TRANSFORMATION_STATE_IMPL, PhotoPhotoTransformationStateImpl))
#define PHOTO_PHOTO_TRANSFORMATION_STATE_IMPL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PHOTO_TYPE_PHOTO_TRANSFORMATION_STATE_IMPL, PhotoPhotoTransformationStateImplClass))
#define PHOTO_IS_PHOTO_TRANSFORMATION_STATE_IMPL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PHOTO_TYPE_PHOTO_TRANSFORMATION_STATE_IMPL))
#define PHOTO_IS_PHOTO_TRANSFORMATION_STATE_IMPL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PHOTO_TYPE_PHOTO_TRANSFORMATION_STATE_IMPL))
#define PHOTO_PHOTO_TRANSFORMATION_STATE_IMPL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PHOTO_TYPE_PHOTO_TRANSFORMATION_STATE_IMPL, PhotoPhotoTransformationStateImplClass))

typedef struct _PhotoPhotoTransformationStateImpl PhotoPhotoTransformationStateImpl;
typedef struct _PhotoPhotoTransformationStateImplClass PhotoPhotoTransformationStateImplClass;

#define TYPE_REDEYE_INSTANCE (redeye_instance_get_type ())
typedef struct _RedeyeInstance RedeyeInstance;

#define TYPE_PHOTO_FILE_WRITER (photo_file_writer_get_type ())
#define PHOTO_FILE_WRITER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_FILE_WRITER, PhotoFileWriter))
#define PHOTO_FILE_WRITER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_FILE_WRITER, PhotoFileWriterClass))
#define IS_PHOTO_FILE_WRITER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_FILE_WRITER))
#define IS_PHOTO_FILE_WRITER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_FILE_WRITER))
#define PHOTO_FILE_WRITER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_FILE_WRITER, PhotoFileWriterClass))

typedef struct _PhotoFileWriter PhotoFileWriter;
typedef struct _PhotoFileWriterClass PhotoFileWriterClass;

#define TYPE_CONFIG (config_get_type ())
#define CONFIG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CONFIG, Config))
#define CONFIG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CONFIG, ConfigClass))
#define IS_CONFIG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CONFIG))
#define IS_CONFIG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CONFIG))
#define CONFIG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CONFIG, ConfigClass))

typedef struct _Config Config;
typedef struct _ConfigClass ConfigClass;
#define _config_unref0(var) ((var == NULL) ? NULL : (var = (config_unref (var), NULL)))
#define __g_list_free__g_object_unref0_0(var) ((var == NULL) ? NULL : (var = (_g_list_free__g_object_unref0_ (var), NULL)))
typedef struct _PhotoPhotoTransformationStateImplPrivate PhotoPhotoTransformationStateImplPrivate;
typedef struct _PhotoParamSpecReimportMasterState PhotoParamSpecReimportMasterState;
typedef struct _PhotoParamSpecReimportEditableState PhotoParamSpecReimportEditableState;
typedef struct _DataCollectionPrivate DataCollectionPrivate;

#define TYPE_MARKER (marker_get_type ())
#define MARKER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MARKER, Marker))
#define IS_MARKER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MARKER))
#define MARKER_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_MARKER, MarkerIface))

typedef struct _Marker Marker;
typedef struct _MarkerIface MarkerIface;
typedef struct _SourceCollectionPrivate SourceCollectionPrivate;

#define TYPE_SOURCE_BACKLINK (source_backlink_get_type ())
#define SOURCE_BACKLINK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SOURCE_BACKLINK, SourceBacklink))
#define SOURCE_BACKLINK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SOURCE_BACKLINK, SourceBacklinkClass))
#define IS_SOURCE_BACKLINK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SOURCE_BACKLINK))
#define IS_SOURCE_BACKLINK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SOURCE_BACKLINK))
#define SOURCE_BACKLINK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SOURCE_BACKLINK, SourceBacklinkClass))

typedef struct _SourceBacklink SourceBacklink;
typedef struct _SourceBacklinkClass SourceBacklinkClass;

#define TYPE_DATABASE_SOURCE_COLLECTION (database_source_collection_get_type ())
#define DATABASE_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATABASE_SOURCE_COLLECTION, DatabaseSourceCollection))
#define DATABASE_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATABASE_SOURCE_COLLECTION, DatabaseSourceCollectionClass))
#define IS_DATABASE_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATABASE_SOURCE_COLLECTION))
#define IS_DATABASE_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATABASE_SOURCE_COLLECTION))
#define DATABASE_SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATABASE_SOURCE_COLLECTION, DatabaseSourceCollectionClass))

typedef struct _DatabaseSourceCollection DatabaseSourceCollection;
typedef struct _DatabaseSourceCollectionClass DatabaseSourceCollectionClass;
typedef struct _DatabaseSourceCollectionPrivate DatabaseSourceCollectionPrivate;

#define TYPE_MEDIA_SOURCE_COLLECTION (media_source_collection_get_type ())
#define MEDIA_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection))
#define MEDIA_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollectionClass))
#define IS_MEDIA_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_SOURCE_COLLECTION))
#define IS_MEDIA_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_SOURCE_COLLECTION))
#define MEDIA_SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollectionClass))

typedef struct _MediaSourceCollection MediaSourceCollection;
typedef struct _MediaSourceCollectionClass MediaSourceCollectionClass;
typedef struct _MediaSourceCollectionPrivate MediaSourceCollectionPrivate;

#define TYPE_DATABASE_SOURCE_HOLDING_TANK (database_source_holding_tank_get_type ())
#define DATABASE_SOURCE_HOLDING_TANK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATABASE_SOURCE_HOLDING_TANK, DatabaseSourceHoldingTank))
#define DATABASE_SOURCE_HOLDING_TANK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATABASE_SOURCE_HOLDING_TANK, DatabaseSourceHoldingTankClass))
#define IS_DATABASE_SOURCE_HOLDING_TANK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATABASE_SOURCE_HOLDING_TANK))
#define IS_DATABASE_SOURCE_HOLDING_TANK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATABASE_SOURCE_HOLDING_TANK))
#define DATABASE_SOURCE_HOLDING_TANK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATABASE_SOURCE_HOLDING_TANK, DatabaseSourceHoldingTankClass))

typedef struct _DatabaseSourceHoldingTank DatabaseSourceHoldingTank;
typedef struct _DatabaseSourceHoldingTankClass DatabaseSourceHoldingTankClass;

#define TYPE_MEDIA_SOURCE_HOLDING_TANK (media_source_holding_tank_get_type ())
#define MEDIA_SOURCE_HOLDING_TANK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_SOURCE_HOLDING_TANK, MediaSourceHoldingTank))
#define MEDIA_SOURCE_HOLDING_TANK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_SOURCE_HOLDING_TANK, MediaSourceHoldingTankClass))
#define IS_MEDIA_SOURCE_HOLDING_TANK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_SOURCE_HOLDING_TANK))
#define IS_MEDIA_SOURCE_HOLDING_TANK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_SOURCE_HOLDING_TANK))
#define MEDIA_SOURCE_HOLDING_TANK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_SOURCE_HOLDING_TANK, MediaSourceHoldingTankClass))

typedef struct _MediaSourceHoldingTank MediaSourceHoldingTank;
typedef struct _MediaSourceHoldingTankClass MediaSourceHoldingTankClass;

#define TYPE_WORKERS (workers_get_type ())
#define WORKERS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_WORKERS, Workers))
#define WORKERS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_WORKERS, WorkersClass))
#define IS_WORKERS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_WORKERS))
#define IS_WORKERS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_WORKERS))
#define WORKERS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_WORKERS, WorkersClass))

typedef struct _Workers Workers;
typedef struct _WorkersClass WorkersClass;

#define TYPE_MEDIA_MONITOR (media_monitor_get_type ())
#define MEDIA_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_MONITOR, MediaMonitor))
#define MEDIA_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_MONITOR, MediaMonitorClass))
#define IS_MEDIA_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_MONITOR))
#define IS_MEDIA_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_MONITOR))
#define MEDIA_MONITOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_MONITOR, MediaMonitorClass))

typedef struct _MediaMonitor MediaMonitor;
typedef struct _MediaMonitorClass MediaMonitorClass;

#define TYPE_TRANSACTION_CONTROLLER (transaction_controller_get_type ())
#define TRANSACTION_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TRANSACTION_CONTROLLER, TransactionController))
#define TRANSACTION_CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TRANSACTION_CONTROLLER, TransactionControllerClass))
#define IS_TRANSACTION_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TRANSACTION_CONTROLLER))
#define IS_TRANSACTION_CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TRANSACTION_CONTROLLER))
#define TRANSACTION_CONTROLLER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TRANSACTION_CONTROLLER, TransactionControllerClass))

typedef struct _TransactionController TransactionController;
typedef struct _TransactionControllerClass TransactionControllerClass;

#define TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION (library_photo_source_collection_get_type ())
#define LIBRARY_PHOTO_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, LibraryPhotoSourceCollection))
#define LIBRARY_PHOTO_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, LibraryPhotoSourceCollectionClass))
#define IS_LIBRARY_PHOTO_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION))
#define IS_LIBRARY_PHOTO_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION))
#define LIBRARY_PHOTO_SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, LibraryPhotoSourceCollectionClass))

typedef struct _LibraryPhotoSourceCollection LibraryPhotoSourceCollection;
typedef struct _LibraryPhotoSourceCollectionClass LibraryPhotoSourceCollectionClass;
typedef struct _LibraryPhotoSourceCollectionPrivate LibraryPhotoSourceCollectionPrivate;

#define LIBRARY_PHOTO_SOURCE_COLLECTION_TYPE_STATE (library_photo_source_collection_state_get_type ())
#define _transaction_controller_unref0(var) ((var == NULL) ? NULL : (var = (transaction_controller_unref (var), NULL)))
#define _source_holding_tank_unref0(var) ((var == NULL) ? NULL : (var = (source_holding_tank_unref (var), NULL)))

#define TYPE_PHOTO_MONITOR (photo_monitor_get_type ())
#define PHOTO_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_MONITOR, PhotoMonitor))
#define PHOTO_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_MONITOR, PhotoMonitorClass))
#define IS_PHOTO_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_MONITOR))
#define IS_PHOTO_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_MONITOR))
#define PHOTO_MONITOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_MONITOR, PhotoMonitorClass))

typedef struct _PhotoMonitor PhotoMonitor;
typedef struct _PhotoMonitorClass PhotoMonitorClass;
#define _backing_photo_state_free0(var) ((var == NULL) ? NULL : (var = (backing_photo_state_free (var), NULL)))

#define TYPE_TAG (tag_get_type ())
#define TAG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TAG, Tag))
#define TAG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TAG, TagClass))
#define IS_TAG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TAG))
#define IS_TAG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TAG))
#define TAG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TAG, TagClass))

typedef struct _Tag Tag;
typedef struct _TagClass TagClass;

#define TYPE_MEDIA_SOURCE_TRANSACTION_CONTROLLER (media_source_transaction_controller_get_type ())
#define MEDIA_SOURCE_TRANSACTION_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_SOURCE_TRANSACTION_CONTROLLER, MediaSourceTransactionController))
#define MEDIA_SOURCE_TRANSACTION_CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_SOURCE_TRANSACTION_CONTROLLER, MediaSourceTransactionControllerClass))
#define IS_MEDIA_SOURCE_TRANSACTION_CONTROLLER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_SOURCE_TRANSACTION_CONTROLLER))
#define IS_MEDIA_SOURCE_TRANSACTION_CONTROLLER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_SOURCE_TRANSACTION_CONTROLLER))
#define MEDIA_SOURCE_TRANSACTION_CONTROLLER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_SOURCE_TRANSACTION_CONTROLLER, MediaSourceTransactionControllerClass))

typedef struct _MediaSourceTransactionController MediaSourceTransactionController;
typedef struct _MediaSourceTransactionControllerClass MediaSourceTransactionControllerClass;

#define TYPE_FLAGGABLE (flaggable_get_type ())
#define FLAGGABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_FLAGGABLE, Flaggable))
#define IS_FLAGGABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_FLAGGABLE))
#define FLAGGABLE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_FLAGGABLE, FlaggableIface))

typedef struct _Flaggable Flaggable;
typedef struct _FlaggableIface FlaggableIface;

#define TYPE_MONITORABLE (monitorable_get_type ())
#define MONITORABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MONITORABLE, Monitorable))
#define IS_MONITORABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MONITORABLE))
#define MONITORABLE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_MONITORABLE, MonitorableIface))

typedef struct _Monitorable Monitorable;
typedef struct _MonitorableIface MonitorableIface;
typedef struct _LibraryPhotoPrivate LibraryPhotoPrivate;

#define TYPE_MIMIC_MANAGER (mimic_manager_get_type ())
#define MIMIC_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MIMIC_MANAGER, MimicManager))
#define MIMIC_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MIMIC_MANAGER, MimicManagerClass))
#define IS_MIMIC_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MIMIC_MANAGER))
#define IS_MIMIC_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MIMIC_MANAGER))
#define MIMIC_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MIMIC_MANAGER, MimicManagerClass))

typedef struct _MimicManager MimicManager;
typedef struct _MimicManagerClass MimicManagerClass;
#define _data_collection_unref0(var) ((var == NULL) ? NULL : (var = (data_collection_unref (var), NULL)))
#define _photo_row_free0(var) ((var == NULL) ? NULL : (var = (photo_row_free (var), NULL)))

#define THUMBNAIL_CACHE_TYPE_SIZE (thumbnail_cache_size_get_type ())

#define TYPE_EVENT_SOURCE (event_source_get_type ())
#define EVENT_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_EVENT_SOURCE, EventSource))
#define EVENT_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_EVENT_SOURCE, EventSourceClass))
#define IS_EVENT_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_EVENT_SOURCE))
#define IS_EVENT_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_EVENT_SOURCE))
#define EVENT_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_EVENT_SOURCE, EventSourceClass))

typedef struct _EventSource EventSource;
typedef struct _EventSourceClass EventSourceClass;

#define TYPE_EVENT (event_get_type ())
#define EVENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_EVENT, Event))
#define EVENT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_EVENT, EventClass))
#define IS_EVENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_EVENT))
#define IS_EVENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_EVENT))
#define EVENT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_EVENT, EventClass))

typedef struct _Event Event;
typedef struct _EventClass EventClass;

#define TYPE_CONTAINER_SOURCE_COLLECTION (container_source_collection_get_type ())
#define CONTAINER_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CONTAINER_SOURCE_COLLECTION, ContainerSourceCollection))
#define CONTAINER_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CONTAINER_SOURCE_COLLECTION, ContainerSourceCollectionClass))
#define IS_CONTAINER_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CONTAINER_SOURCE_COLLECTION))
#define IS_CONTAINER_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CONTAINER_SOURCE_COLLECTION))
#define CONTAINER_SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CONTAINER_SOURCE_COLLECTION, ContainerSourceCollectionClass))

typedef struct _ContainerSourceCollection ContainerSourceCollection;
typedef struct _ContainerSourceCollectionClass ContainerSourceCollectionClass;

#define TYPE_TAG_SOURCE_COLLECTION (tag_source_collection_get_type ())
#define TAG_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TAG_SOURCE_COLLECTION, TagSourceCollection))
#define TAG_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TAG_SOURCE_COLLECTION, TagSourceCollectionClass))
#define IS_TAG_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TAG_SOURCE_COLLECTION))
#define IS_TAG_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TAG_SOURCE_COLLECTION))
#define TAG_SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TAG_SOURCE_COLLECTION, TagSourceCollectionClass))

typedef struct _TagSourceCollection TagSourceCollection;
typedef struct _TagSourceCollectionClass TagSourceCollectionClass;

typedef enum  {
	BACKING_FETCH_MODE_SOURCE,
	BACKING_FETCH_MODE_BASELINE,
	BACKING_FETCH_MODE_MASTER
} BackingFetchMode;

struct _ImportID {
	gint64 id;
};

typedef enum  {
	PHOTO_FILE_SNIFFER_OPTIONS_GET_ALL = 0x00000000,
	PHOTO_FILE_SNIFFER_OPTIONS_NO_MD5 = 0x00000001
} PhotoFileSnifferOptions;

struct _PhotoID {
	gint64 id;
};

typedef enum  {
	PHOTO_FILE_FORMAT_JFIF,
	PHOTO_FILE_FORMAT_RAW,
	PHOTO_FILE_FORMAT_PNG,
	PHOTO_FILE_FORMAT_TIFF,
	PHOTO_FILE_FORMAT_UNKNOWN
} PhotoFileFormat;

struct _Dimensions {
	gint width;
	gint height;
};

typedef enum  {
	ORIENTATION_MIN = 1,
	ORIENTATION_TOP_LEFT = 1,
	ORIENTATION_TOP_RIGHT = 2,
	ORIENTATION_BOTTOM_RIGHT = 3,
	ORIENTATION_BOTTOM_LEFT = 4,
	ORIENTATION_LEFT_TOP = 5,
	ORIENTATION_RIGHT_TOP = 6,
	ORIENTATION_RIGHT_BOTTOM = 7,
	ORIENTATION_LEFT_BOTTOM = 8,
	ORIENTATION_MAX = 8
} Orientation;

struct _BackingPhotoState {
	gchar* filepath;
	gint64 filesize;
	time_t timestamp;
	PhotoFileFormat file_format;
	Dimensions dim;
	Orientation original_orientation;
};

struct _EventID {
	gint64 id;
};

typedef enum  {
	RATING_REJECTED = -1,
	RATING_UNRATED = 0,
	RATING_ONE = 1,
	RATING_TWO = 2,
	RATING_THREE = 3,
	RATING_FOUR = 4,
	RATING_FIVE = 5
} Rating;

struct _BackingPhotoID {
	gint64 id;
};

struct _PhotoRow {
	PhotoID photo_id;
	BackingPhotoState master;
	time_t exposure_time;
	ImportID import_id;
	EventID event_id;
	Orientation orientation;
	GeeHashMap* transformations;
	gchar* md5;
	gchar* thumbnail_md5;
	gchar* exif_md5;
	time_t time_created;
	guint64 flags;
	Rating rating;
	gchar* title;
	gchar* backlinks;
	time_t time_reimported;
	BackingPhotoID editable_id;
	gboolean metadata_dirty;
};

struct _PhotoImportParams {
	GTypeInstance parent_instance;
	volatile int ref_count;
	PhotoImportParamsPrivate * priv;
	GFile* file;
	ImportID import_id;
	PhotoFileSnifferOptions sniffer_options;
	gchar* exif_md5;
	gchar* thumbnail_md5;
	gchar* full_md5;
	Thumbnails* thumbnails;
	PhotoRow row;
	GeeCollection* keywords;
};

struct _PhotoImportParamsClass {
	GTypeClass parent_class;
	void (*finalize) (PhotoImportParams *self);
};

struct _ParamSpecPhotoImportParams {
	GParamSpec parent_instance;
};

struct _PhotoTransformationState {
	GObject parent_instance;
	PhotoTransformationStatePrivate * priv;
};

struct _PhotoTransformationStateClass {
	GObjectClass parent_class;
	void (*broken) (PhotoTransformationState* self);
};

struct _PhotoTransformationStatePrivate {
	gboolean is_broke;
};

struct _DataObject {
	GObject parent_instance;
	DataObjectPrivate * priv;
};

struct _DataObjectClass {
	GObjectClass parent_class;
	void (*notify_altered) (DataObject* self, Alteration* alteration);
	void (*notify_membership_changed) (DataObject* self, DataCollection* collection);
	void (*notify_collection_property_set) (DataObject* self, const gchar* name, GValue* old, GValue* val);
	void (*notify_collection_property_cleared) (DataObject* self, const gchar* name);
	gchar* (*get_name) (DataObject* self);
	gchar* (*to_string) (DataObject* self);
};

struct _DataSource {
	DataObject parent_instance;
	DataSourcePrivate * priv;
};

struct _DataSourceClass {
	DataObjectClass parent_class;
	void (*notify_held_in_tank) (DataSource* self, SourceHoldingTank* holding_tank);
	void (*notify_unlinking) (DataSource* self, SourceCollection* collection);
	void (*notify_unlinked) (DataSource* self);
	void (*notify_relinking) (DataSource* self, SourceCollection* collection);
	void (*notify_relinked) (DataSource* self);
	gchar* (*get_typename) (DataSource* self);
	gint64 (*get_instance_id) (DataSource* self);
	gchar* (*get_source_id) (DataSource* self);
	void (*commit_backlinks) (DataSource* self, SourceCollection* sources, const gchar* dehydrated);
	SourceSnapshot* (*save_snapshot) (DataSource* self);
	gboolean (*internal_delete_backing) (DataSource* self, GError** error);
	gboolean (*equals) (DataSource* self, DataSource* source);
	void (*destroy) (DataSource* self);
	void (*unlinked) (DataSource* self, SourceCollection* sources);
	void (*relinked) (DataSource* self, SourceCollection* sources);
	void (*destroyed) (DataSource* self);
};

struct _ThumbnailSource {
	DataSource parent_instance;
	ThumbnailSourcePrivate * priv;
};

struct _ThumbnailSourceClass {
	DataSourceClass parent_class;
	void (*notify_thumbnail_altered) (ThumbnailSource* self);
	GdkPixbuf* (*get_thumbnail) (ThumbnailSource* self, gint scale, GError** error);
	GdkPixbuf* (*create_thumbnail) (ThumbnailSource* self, gint scale, GError** error);
	gchar* (*get_representative_id) (ThumbnailSource* self);
	PhotoFileFormat (*get_preferred_thumbnail_format) (ThumbnailSource* self);
	void (*thumbnail_altered) (ThumbnailSource* self);
};

struct _IndexableIface {
	GTypeInterface parent_iface;
	const gchar* (*get_indexable_keywords) (Indexable* self);
};

typedef enum  {
	SCALE_CONSTRAINT_ORIGINAL,
	SCALE_CONSTRAINT_DIMENSIONS,
	SCALE_CONSTRAINT_WIDTH,
	SCALE_CONSTRAINT_HEIGHT,
	SCALE_CONSTRAINT_FILL_VIEWPORT
} ScaleConstraint;

struct _Scaling {
	ScaleConstraint constraint;
	gint scale;
	Dimensions viewport;
	gboolean scale_up;
};

struct _MediaSource {
	ThumbnailSource parent_instance;
	MediaSourcePrivate * priv;
};

struct _MediaSourceClass {
	ThumbnailSourceClass parent_class;
	void (*notify_master_replaced) (MediaSource* self, GFile* old_file, GFile* new_file);
	gboolean (*set_event_id) (MediaSource* self, EventID* id);
	gchar* (*get_basename) (MediaSource* self);
	GFile* (*get_file) (MediaSource* self);
	GFile* (*get_master_file) (MediaSource* self);
	guint64 (*get_master_filesize) (MediaSource* self);
	guint64 (*get_filesize) (MediaSource* self);
	time_t (*get_timestamp) (MediaSource* self);
	BackingFileState** (*get_backing_files_state) (MediaSource* self, int* result_length1);
	gchar* (*get_title) (MediaSource* self);
	void (*set_title) (MediaSource* self, const gchar* title);
	Rating (*get_rating) (MediaSource* self);
	void (*set_rating) (MediaSource* self, Rating rating);
	void (*increase_rating) (MediaSource* self);
	void (*decrease_rating) (MediaSource* self);
	void (*get_dimensions) (MediaSource* self, Dimensions* result);
	GdkPixbuf* (*get_preview_pixbuf) (MediaSource* self, Scaling* scaling, GError** error);
	gboolean (*is_trashed) (MediaSource* self);
	void (*trash) (MediaSource* self);
	void (*untrash) (MediaSource* self);
	gboolean (*is_offline) (MediaSource* self);
	void (*mark_offline) (MediaSource* self);
	void (*mark_online) (MediaSource* self);
	gchar* (*get_master_md5) (MediaSource* self);
	void (*get_event_id) (MediaSource* self, EventID* result);
	time_t (*get_exposure_time) (MediaSource* self);
	void (*get_import_id) (MediaSource* self, ImportID* result);
	void (*master_replaced) (MediaSource* self, GFile* old_file, GFile* new_file);
};

struct _PhotoSource {
	MediaSource parent_instance;
	PhotoSourcePrivate * priv;
};

struct _PhotoSourceClass {
	MediaSourceClass parent_class;
	PhotoMetadata* (*get_metadata) (PhotoSource* self);
	GdkPixbuf* (*get_pixbuf) (PhotoSource* self, Scaling* scaling, GError** error);
};

struct _DateableIface {
	GTypeInterface parent_iface;
	void (*set_exposure_time) (Dateable* self, time_t target_time);
	time_t (*get_exposure_time) (Dateable* self);
};

typedef enum  {
	ROTATION_CLOCKWISE,
	ROTATION_COUNTERCLOCKWISE,
	ROTATION_MIRROR,
	ROTATION_UPSIDE_DOWN
} Rotation;

struct _Photo {
	PhotoSource parent_instance;
	PhotoPrivate * priv;
};

struct _PhotoClass {
	PhotoSourceClass parent_class;
	void (*notify_editable_replaced) (Photo* self, GFile* old_file, GFile* new_file);
	void (*notify_baseline_replaced) (Photo* self);
	void (*notify_master_reimported) (Photo* self, PhotoMetadata* metadata);
	void (*notify_editable_reimported) (Photo* self, PhotoMetadata* metadata);
	void (*notify_source_reimported) (Photo* self, PhotoMetadata* metadata);
	void (*notify_baseline_reimported) (Photo* self, PhotoMetadata* metadata);
	void (*apply_user_metadata_for_reimport) (Photo* self, PhotoMetadata* metadata);
	void (*rotate) (Photo* self, Rotation rotation);
	gboolean (*has_user_generated_metadata) (Photo* self);
	void (*set_user_metadata_for_export) (Photo* self, PhotoMetadata* metadata);
	void (*editable_replaced) (Photo* self, GFile* old_file, GFile* new_file);
	void (*baseline_replaced) (Photo* self);
	void (*master_reimported) (Photo* self, PhotoMetadata* metadata);
	void (*editable_reimported) (Photo* self, PhotoMetadata* metadata);
	void (*baseline_reimported) (Photo* self, PhotoMetadata* metadata);
	void (*source_reimported) (Photo* self, PhotoMetadata* metadata);
};

struct _PhotoBackingReaders {
	PhotoFileReader* master;
	PhotoFileReader* mimic;
	PhotoFileReader* editable;
};

struct _PhotoPrivate {
	PhotoRow row;
	GStaticRecMutex __lock_row;
	BackingPhotoState editable;
	PhotoBackingReaders readers;
	GStaticRecMutex __lock_readers;
	PixelTransformer* transformer;
	PixelTransformationBundle* adjustments;
	gchar* file_title;
	GFileMonitor* editable_monitor;
	OneShotScheduler* reimport_editable_scheduler;
	OneShotScheduler* update_editable_attributes_scheduler;
	OneShotScheduler* remove_editable_scheduler;
	BackingPhotoState* backing_photo_state;
};

typedef enum  {
	PHOTO_EXCEPTION_NONE = 0,
	PHOTO_EXCEPTION_ORIENTATION = 1 << 0,
	PHOTO_EXCEPTION_CROP = 1 << 1,
	PHOTO_EXCEPTION_REDEYE = 1 << 2,
	PHOTO_EXCEPTION_ADJUST = 1 << 3,
	PHOTO_EXCEPTION_ALL = 0xFFFFFFFFLL
} PhotoException;

struct _BackingPhotoRow {
	BackingPhotoID id;
	time_t time_created;
	BackingPhotoState state;
};

typedef enum  {
	DATABASE_ERROR_ERROR,
	DATABASE_ERROR_BACKING,
	DATABASE_ERROR_MEMORY,
	DATABASE_ERROR_ABORT,
	DATABASE_ERROR_LIMITS,
	DATABASE_ERROR_TYPESPEC
} DatabaseError;
#define DATABASE_ERROR database_error_quark ()
typedef enum  {
	PHOTO_FILE_FORMAT_FLAGS_NONE = 0x00000000,
	PHOTO_FILE_FORMAT_FLAGS_MIMIC_RECOMMENDED = 0x00000001
} PhotoFileFormatFlags;

typedef enum  {
	EXPORT_FORMAT_MODE_UNMODIFIED,
	EXPORT_FORMAT_MODE_CURRENT,
	EXPORT_FORMAT_MODE_SPECIFIED,
	EXPORT_FORMAT_MODE_LAST
} ExportFormatMode;

typedef enum  {
	JPEG_QUALITY_LOW = 50,
	JPEG_QUALITY_MEDIUM = 75,
	JPEG_QUALITY_HIGH = 90,
	JPEG_QUALITY_MAXIMUM = 100
} JpegQuality;

struct _ExportFormatParameters {
	ExportFormatMode mode;
	PhotoFileFormat specified_format;
	JpegQuality quality;
};

typedef enum  {
	IMPORT_RESULT_SUCCESS,
	IMPORT_RESULT_FILE_ERROR,
	IMPORT_RESULT_DECODE_ERROR,
	IMPORT_RESULT_DATABASE_ERROR,
	IMPORT_RESULT_USER_ABORT,
	IMPORT_RESULT_NOT_A_FILE,
	IMPORT_RESULT_PHOTO_EXISTS,
	IMPORT_RESULT_UNSUPPORTED_FORMAT,
	IMPORT_RESULT_NOT_AN_IMAGE,
	IMPORT_RESULT_DISK_FAILURE,
	IMPORT_RESULT_DISK_FULL,
	IMPORT_RESULT_CAMERA_ERROR,
	IMPORT_RESULT_FILE_WRITE_ERROR
} ImportResult;

struct _DetectedPhotoInformation {
	GTypeInstance parent_instance;
	volatile int ref_count;
	DetectedPhotoInformationPrivate * priv;
	PhotoFileFormat file_format;
	PhotoMetadata* metadata;
	gchar* md5;
	gchar* exif_md5;
	gchar* thumbnail_md5;
	gchar* format_name;
	Dimensions image_dim;
	GdkColorspace colorspace;
	gint channels;
	gint bits_per_channel;
};

struct _DetectedPhotoInformationClass {
	GTypeClass parent_class;
	void (*finalize) (DetectedPhotoInformation *self);
};

struct _PhotoReimportMasterState {
	GTypeInstance parent_instance;
	volatile int ref_count;
	PhotoReimportMasterStatePrivate * priv;
};

struct _PhotoReimportMasterStateClass {
	GTypeClass parent_class;
	void (*finalize) (PhotoReimportMasterState *self);
};

struct _PhotoReimportMasterStateImpl {
	PhotoReimportMasterState parent_instance;
	PhotoReimportMasterStateImplPrivate * priv;
	PhotoRow row;
	PhotoMetadata* metadata;
	gchar** alterations;
	gint alterations_length1;
	gint _alterations_size_;
	gboolean metadata_only;
};

struct _PhotoReimportMasterStateImplClass {
	PhotoReimportMasterStateClass parent_class;
};

struct _PhotoReimportEditableState {
	GTypeInstance parent_instance;
	volatile int ref_count;
	PhotoReimportEditableStatePrivate * priv;
};

struct _PhotoReimportEditableStateClass {
	GTypeClass parent_class;
	void (*finalize) (PhotoReimportEditableState *self);
};

struct _PhotoReimportEditableStateImpl {
	PhotoReimportEditableState parent_instance;
	PhotoReimportEditableStateImplPrivate * priv;
	BackingPhotoState backing_state;
	PhotoMetadata* metadata;
	gboolean metadata_only;
};

struct _PhotoReimportEditableStateImplClass {
	PhotoReimportEditableStateClass parent_class;
};

typedef enum  {
	PHOTO_METADATA_SET_OPTION_ALL_DOMAINS,
	PHOTO_METADATA_SET_OPTION_ONLY_IF_DOMAIN_PRESENT,
	PHOTO_METADATA_SET_OPTION_AT_LEAST_DEFAULT_DOMAIN
} PhotoMetadataSetOption;

typedef enum  {
	PHOTO_FORMAT_ERROR_READ_ONLY
} PhotoFormatError;
#define PHOTO_FORMAT_ERROR photo_format_error_quark ()
struct _Box {
	gint left;
	gint top;
	gint right;
	gint bottom;
};

typedef enum  {
	PIXEL_TRANSFORMATION_TYPE_TONE_EXPANSION,
	PIXEL_TRANSFORMATION_TYPE_SHADOWS,
	PIXEL_TRANSFORMATION_TYPE_TEMPERATURE,
	PIXEL_TRANSFORMATION_TYPE_TINT,
	PIXEL_TRANSFORMATION_TYPE_SATURATION,
	PIXEL_TRANSFORMATION_TYPE_EXPOSURE
} PixelTransformationType;

struct _RedeyeInstance {
	GdkPoint center;
	gint radius;
};

typedef void (*OneShotCallback) (void* user_data);
struct _PhotoPhotoTransformationStateImpl {
	PhotoTransformationState parent_instance;
	PhotoPhotoTransformationStateImplPrivate * priv;
};

struct _PhotoPhotoTransformationStateImplClass {
	PhotoTransformationStateClass parent_class;
};

struct _PhotoPhotoTransformationStateImplPrivate {
	Photo* photo;
	Orientation orientation;
	GeeHashMap* transformations;
	PixelTransformer* transformer;
	PixelTransformationBundle* adjustments;
};

struct _PhotoParamSpecReimportMasterState {
	GParamSpec parent_instance;
};

struct _PhotoParamSpecReimportEditableState {
	GParamSpec parent_instance;
};

typedef gint64 (*Comparator) (void* a, void* b, void* user_data);
typedef gboolean (*ComparatorPredicate) (DataObject* object, Alteration* alteration, void* user_data);
typedef gboolean (*ProgressMonitor) (guint64 current, guint64 total, void* user_data);
struct _MarkerIface {
	GTypeInterface parent_iface;
	void (*mark) (Marker* self, DataObject* object);
	void (*unmark) (Marker* self, DataObject* object);
	gboolean (*toggle) (Marker* self, DataObject* object);
	void (*mark_many) (Marker* self, GeeCollection* list);
	void (*unmark_many) (Marker* self, GeeCollection* list);
	void (*mark_all) (Marker* self);
	gint (*get_count) (Marker* self);
	GeeCollection* (*get_all) (Marker* self);
};

struct _DataCollection {
	GTypeInstance parent_instance;
	volatile int ref_count;
	DataCollectionPrivate * priv;
};

struct _DataCollectionClass {
	GTypeClass parent_class;
	void (*finalize) (DataCollection *self);
	gchar* (*to_string) (DataCollection* self);
	void (*notify_items_added) (DataCollection* self, GeeIterable* added);
	void (*notify_items_removed) (DataCollection* self, GeeIterable* removed);
	void (*notify_contents_altered) (DataCollection* self, GeeIterable* added, GeeIterable* removed);
	void (*notify_items_altered) (DataCollection* self, GeeMap* items);
	void (*notify_ordering_changed) (DataCollection* self);
	void (*notify_property_set) (DataCollection* self, const gchar* name, GValue* old, GValue* val);
	void (*notify_property_cleared) (DataCollection* self, const gchar* name);
	gboolean (*valid_type) (DataCollection* self, DataObject* object);
	void (*set_comparator) (DataCollection* self, Comparator comparator, void* comparator_target, ComparatorPredicate predicate, void* predicate_target);
	void (*reset_comparator) (DataCollection* self);
	GeeCollection* (*get_all) (DataCollection* self);
	gint (*get_count) (DataCollection* self);
	DataObject* (*get_at) (DataCollection* self, gint index);
	gint (*index_of) (DataCollection* self, DataObject* object);
	gboolean (*contains) (DataCollection* self, DataObject* object);
	gboolean (*add) (DataCollection* self, DataObject* object);
	GeeCollection* (*add_many) (DataCollection* self, GeeCollection* objects, ProgressMonitor monitor, void* monitor_target);
	void (*remove_marked) (DataCollection* self, Marker* m);
	void (*clear) (DataCollection* self);
	void (*close) (DataCollection* self);
	void (*notify_frozen) (DataCollection* self);
	void (*notify_thawed) (DataCollection* self);
	void (*items_added) (DataCollection* self, GeeIterable* added);
	void (*items_removed) (DataCollection* self, GeeIterable* removed);
	void (*contents_altered) (DataCollection* self, GeeIterable* added, GeeIterable* removed);
	void (*items_altered) (DataCollection* self, GeeMap* items);
	void (*ordering_changed) (DataCollection* self);
	void (*property_set) (DataCollection* self, const gchar* name, GValue* old, GValue* val);
	void (*property_cleared) (DataCollection* self, const gchar* name);
	void (*frozen) (DataCollection* self);
	void (*thawed) (DataCollection* self);
};

struct _SourceCollection {
	DataCollection parent_instance;
	SourceCollectionPrivate * priv;
};

struct _SourceCollectionClass {
	DataCollectionClass parent_class;
	gboolean (*holds_type_of_source) (SourceCollection* self, DataSource* source);
	void (*notify_items_unlinking) (SourceCollection* self, GeeCollection* unlinking);
	void (*notify_items_relinked) (SourceCollection* self, GeeCollection* relinked);
	void (*notify_item_destroyed) (SourceCollection* self, DataSource* source);
	void (*notify_items_destroyed) (SourceCollection* self, GeeCollection* destroyed);
	void (*notify_unlinked_destroyed) (SourceCollection* self, DataSource* unlinked);
	void (*notify_backlink_removed) (SourceCollection* self, SourceBacklink* backlink, GeeCollection* sources);
	gboolean (*has_backlink) (SourceCollection* self, SourceBacklink* backlink);
	void (*remove_backlink) (SourceCollection* self, SourceBacklink* backlink);
	void (*items_unlinking) (SourceCollection* self, GeeCollection* unlinking);
	void (*items_relinked) (SourceCollection* self, GeeCollection* relinked);
	void (*item_destroyed) (SourceCollection* self, DataSource* source);
	void (*items_destroyed) (SourceCollection* self, GeeCollection* destroyed);
	void (*unlinked_destroyed) (SourceCollection* self, DataSource* source);
	void (*backlink_removed) (SourceCollection* self, SourceBacklink* backlink, GeeCollection* sources);
};

struct _DatabaseSourceCollection {
	SourceCollection parent_instance;
	DatabaseSourceCollectionPrivate * priv;
};

struct _DatabaseSourceCollectionClass {
	SourceCollectionClass parent_class;
};

struct _MediaSourceCollection {
	DatabaseSourceCollection parent_instance;
	MediaSourceCollectionPrivate * priv;
};

struct _MediaSourceCollectionClass {
	DatabaseSourceCollectionClass parent_class;
	MediaSourceHoldingTank* (*create_trashcan) (MediaSourceCollection* self);
	MediaSourceHoldingTank* (*create_offline_bin) (MediaSourceCollection* self);
	MediaMonitor* (*create_media_monitor) (MediaSourceCollection* self, Workers* workers, GCancellable* cancellable);
	gchar* (*get_typename) (MediaSourceCollection* self);
	gboolean (*is_file_recognized) (MediaSourceCollection* self, GFile* file);
	MediaSource* (*fetch_by_numeric_id) (MediaSourceCollection* self, gint64 numeric_id);
	void (*notify_import_roll_altered) (MediaSourceCollection* self);
	void (*notify_flagged_contents_altered) (MediaSourceCollection* self);
	void (*notify_media_import_starting) (MediaSourceCollection* self, GeeCollection* media);
	void (*notify_media_import_completed) (MediaSourceCollection* self, GeeCollection* media);
	MediaSource* (*fetch_by_source_id) (MediaSourceCollection* self, const gchar* source_id);
	GeeCollection* (*get_event_source_ids) (MediaSourceCollection* self, EventID* event_id);
	void (*import_many) (MediaSourceCollection* self, GeeCollection* media);
	void (*postprocess_imported_media) (MediaSourceCollection* self, GeeCollection* media);
	void (*media_import_starting) (MediaSourceCollection* self, GeeCollection* media);
	void (*media_import_completed) (MediaSourceCollection* self, GeeCollection* media);
	void (*master_file_replaced) (MediaSourceCollection* self, MediaSource* media, GFile* old_file, GFile* new_file);
	void (*trashcan_contents_altered) (MediaSourceCollection* self, GeeCollection* added, GeeCollection* removed);
	void (*import_roll_altered) (MediaSourceCollection* self);
	void (*offline_contents_altered) (MediaSourceCollection* self, GeeCollection* added, GeeCollection* removed);
	void (*flagged_contents_altered) (MediaSourceCollection* self);
	TransactionController* (*get_transaction_controller) (MediaSourceCollection* self);
};

struct _LibraryPhotoSourceCollection {
	MediaSourceCollection parent_instance;
	LibraryPhotoSourceCollectionPrivate * priv;
};

struct _LibraryPhotoSourceCollectionClass {
	MediaSourceCollectionClass parent_class;
	void (*notify_master_reimported) (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
	void (*notify_editable_reimported) (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
	void (*notify_source_reimported) (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
	void (*notify_baseline_reimported) (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
	void (*master_reimported) (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
	void (*editable_reimported) (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
	void (*baseline_reimported) (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
	void (*source_reimported) (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
};

struct _LibraryPhotoSourceCollectionPrivate {
	TransactionController* _transaction_controller;
	GeeHashMap* by_editable_file;
	GeeMultiMap* filesize_to_photo;
	GeeHashMap* photo_to_master_filesize;
	GeeHashMap* photo_to_editable_filesize;
};

typedef enum  {
	LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_ONLINE,
	LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_OFFLINE,
	LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_TRASH,
	LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_EDITABLE
} LibraryPhotoSourceCollectionState;

typedef gint64 (*GetSourceDatabaseKey) (DataSource* source, void* user_data);
typedef gboolean (*SourceHoldingTankCheckToKeep) (DataSource* source, Alteration* alteration, void* user_data);
struct _FlaggableIface {
	GTypeInterface parent_iface;
	gboolean (*is_flagged) (Flaggable* self);
	void (*mark_flagged) (Flaggable* self);
	void (*mark_unflagged) (Flaggable* self);
};

struct _MonitorableIface {
	GTypeInterface parent_iface;
	gboolean (*is_offline) (Monitorable* self);
	void (*mark_online) (Monitorable* self);
	void (*mark_offline) (Monitorable* self);
	void (*set_master_file) (Monitorable* self, GFile* file);
	void (*set_master_timestamp) (Monitorable* self, GFileInfo* info);
};

struct _LibraryPhoto {
	Photo parent_instance;
	LibraryPhotoPrivate * priv;
};

struct _LibraryPhotoClass {
	PhotoClass parent_class;
};

struct _LibraryPhotoPrivate {
	gboolean block_thumbnail_generation;
	OneShotScheduler* thumbnail_scheduler;
	GeeCollection* import_keywords;
};

typedef enum  {
	THUMBNAIL_CACHE_SIZE_LARGEST = 360,
	THUMBNAIL_CACHE_SIZE_BIG = 360,
	THUMBNAIL_CACHE_SIZE_MEDIUM = 128,
	THUMBNAIL_CACHE_SIZE_SMALLEST = 128
} ThumbnailCacheSize;


static gpointer photo_import_params_parent_class = NULL;
static gpointer photo_transformation_state_parent_class = NULL;
static gpointer photo_parent_class = NULL;
extern gboolean commandline_options_no_mimicked_images;
static gpointer photo_photo_transformation_state_impl_parent_class = NULL;
static gpointer photo_reimport_master_state_parent_class = NULL;
static gpointer photo_reimport_master_state_impl_parent_class = NULL;
static gpointer photo_reimport_editable_state_parent_class = NULL;
static gpointer photo_reimport_editable_state_impl_parent_class = NULL;
static DateableIface* photo_dateable_parent_iface = NULL;
static gpointer library_photo_source_collection_parent_class = NULL;
static gpointer library_photo_parent_class = NULL;
extern LibraryPhotoSourceCollection* library_photo_global;
LibraryPhotoSourceCollection* library_photo_global = NULL;
extern MimicManager* library_photo_mimic_manager;
MimicManager* library_photo_mimic_manager = NULL;
extern TagSourceCollection* tag_global;
static FlaggableIface* library_photo_flaggable_parent_iface = NULL;
static MonitorableIface* library_photo_monitorable_parent_iface = NULL;

GType backing_fetch_mode_get_type (void) G_GNUC_CONST;
gpointer photo_import_params_ref (gpointer instance);
void photo_import_params_unref (gpointer instance);
GParamSpec* param_spec_photo_import_params (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_photo_import_params (GValue* value, gpointer v_object);
void value_take_photo_import_params (GValue* value, gpointer v_object);
gpointer value_get_photo_import_params (const GValue* value);
GType photo_import_params_get_type (void) G_GNUC_CONST;
GType import_id_get_type (void) G_GNUC_CONST;
ImportID* import_id_dup (const ImportID* self);
void import_id_free (ImportID* self);
GType photo_file_sniffer_options_get_type (void) G_GNUC_CONST;
gpointer thumbnails_ref (gpointer instance);
void thumbnails_unref (gpointer instance);
GParamSpec* param_spec_thumbnails (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_thumbnails (GValue* value, gpointer v_object);
void value_take_thumbnails (GValue* value, gpointer v_object);
gpointer value_get_thumbnails (const GValue* value);
GType thumbnails_get_type (void) G_GNUC_CONST;
GType photo_row_get_type (void) G_GNUC_CONST;
GType photo_id_get_type (void) G_GNUC_CONST;
PhotoID* photo_id_dup (const PhotoID* self);
void photo_id_free (PhotoID* self);
GType backing_photo_state_get_type (void) G_GNUC_CONST;
GType photo_file_format_get_type (void) G_GNUC_CONST;
GType dimensions_get_type (void) G_GNUC_CONST;
Dimensions* dimensions_dup (const Dimensions* self);
void dimensions_free (Dimensions* self);
GType orientation_get_type (void) G_GNUC_CONST;
BackingPhotoState* backing_photo_state_dup (const BackingPhotoState* self);
void backing_photo_state_free (BackingPhotoState* self);
void backing_photo_state_copy (const BackingPhotoState* self, BackingPhotoState* dest);
void backing_photo_state_destroy (BackingPhotoState* self);
GType event_id_get_type (void) G_GNUC_CONST;
EventID* event_id_dup (const EventID* self);
void event_id_free (EventID* self);
gpointer key_value_map_ref (gpointer instance);
void key_value_map_unref (gpointer instance);
GParamSpec* param_spec_key_value_map (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_key_value_map (GValue* value, gpointer v_object);
void value_take_key_value_map (GValue* value, gpointer v_object);
gpointer value_get_key_value_map (const GValue* value);
GType key_value_map_get_type (void) G_GNUC_CONST;
GType rating_get_type (void) G_GNUC_CONST;
GType backing_photo_id_get_type (void) G_GNUC_CONST;
BackingPhotoID* backing_photo_id_dup (const BackingPhotoID* self);
void backing_photo_id_free (BackingPhotoID* self);
PhotoRow* photo_row_dup (const PhotoRow* self);
void photo_row_free (PhotoRow* self);
void photo_row_copy (const PhotoRow* self, PhotoRow* dest);
void photo_row_destroy (PhotoRow* self);
enum  {
	PHOTO_IMPORT_PARAMS_DUMMY_PROPERTY
};
void photo_row_init (PhotoRow *self);
PhotoImportParams* photo_import_params_new (GFile* file, ImportID* import_id, PhotoFileSnifferOptions sniffer_options, const gchar* exif_md5, const gchar* thumbnail_md5, const gchar* full_md5, Thumbnails* thumbnails);
PhotoImportParams* photo_import_params_construct (GType object_type, GFile* file, ImportID* import_id, PhotoFileSnifferOptions sniffer_options, const gchar* exif_md5, const gchar* thumbnail_md5, const gchar* full_md5, Thumbnails* thumbnails);
PhotoImportParams* photo_import_params_new_create_placeholder (GFile* file, ImportID* import_id);
PhotoImportParams* photo_import_params_construct_create_placeholder (GType object_type, GFile* file, ImportID* import_id);
static void photo_import_params_finalize (PhotoImportParams* obj);
GType photo_transformation_state_get_type (void) G_GNUC_CONST;
#define PHOTO_TRANSFORMATION_STATE_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_PHOTO_TRANSFORMATION_STATE, PhotoTransformationStatePrivate))
enum  {
	PHOTO_TRANSFORMATION_STATE_DUMMY_PROPERTY
};
PhotoTransformationState* photo_transformation_state_construct (GType object_type);
gboolean photo_transformation_state_is_broken (PhotoTransformationState* self);
static void photo_transformation_state_real_broken (PhotoTransformationState* self);
static void photo_transformation_state_finalize (GObject* obj);
gboolean rating_can_increase (Rating self);
gboolean rating_can_decrease (Rating self);
gboolean rating_is_valid (Rating self);
Rating rating_increase (Rating self);
Rating rating_decrease (Rating self);
gint rating_serialize (Rating self);
Rating rating_unserialize (gint value);
GType data_object_get_type (void) G_GNUC_CONST;
gpointer alteration_ref (gpointer instance);
void alteration_unref (gpointer instance);
GParamSpec* param_spec_alteration (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_alteration (GValue* value, gpointer v_object);
void value_take_alteration (GValue* value, gpointer v_object);
gpointer value_get_alteration (const GValue* value);
GType alteration_get_type (void) G_GNUC_CONST;
gpointer data_collection_ref (gpointer instance);
void data_collection_unref (gpointer instance);
GParamSpec* param_spec_data_collection (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_data_collection (GValue* value, gpointer v_object);
void value_take_data_collection (GValue* value, gpointer v_object);
gpointer value_get_data_collection (const GValue* value);
GType data_collection_get_type (void) G_GNUC_CONST;
GType data_source_get_type (void) G_GNUC_CONST;
gpointer source_holding_tank_ref (gpointer instance);
void source_holding_tank_unref (gpointer instance);
GParamSpec* param_spec_source_holding_tank (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_source_holding_tank (GValue* value, gpointer v_object);
void value_take_source_holding_tank (GValue* value, gpointer v_object);
gpointer value_get_source_holding_tank (const GValue* value);
GType source_holding_tank_get_type (void) G_GNUC_CONST;
GType source_collection_get_type (void) G_GNUC_CONST;
gpointer source_snapshot_ref (gpointer instance);
void source_snapshot_unref (gpointer instance);
GParamSpec* param_spec_source_snapshot (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_source_snapshot (GValue* value, gpointer v_object);
void value_take_source_snapshot (GValue* value, gpointer v_object);
gpointer value_get_source_snapshot (const GValue* value);
GType source_snapshot_get_type (void) G_GNUC_CONST;
GType thumbnail_source_get_type (void) G_GNUC_CONST;
GType indexable_get_type (void) G_GNUC_CONST;
GType media_source_get_type (void) G_GNUC_CONST;
gpointer backing_file_state_ref (gpointer instance);
void backing_file_state_unref (gpointer instance);
GParamSpec* param_spec_backing_file_state (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_backing_file_state (GValue* value, gpointer v_object);
void value_take_backing_file_state (GValue* value, gpointer v_object);
gpointer value_get_backing_file_state (const GValue* value);
GType backing_file_state_get_type (void) G_GNUC_CONST;
GType scaling_get_type (void) G_GNUC_CONST;
GType scale_constraint_get_type (void) G_GNUC_CONST;
Scaling* scaling_dup (const Scaling* self);
void scaling_free (Scaling* self);
GType photo_source_get_type (void) G_GNUC_CONST;
gpointer media_metadata_ref (gpointer instance);
void media_metadata_unref (gpointer instance);
GParamSpec* param_spec_media_metadata (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_media_metadata (GValue* value, gpointer v_object);
void value_take_media_metadata (GValue* value, gpointer v_object);
gpointer value_get_media_metadata (const GValue* value);
GType media_metadata_get_type (void) G_GNUC_CONST;
GType photo_metadata_get_type (void) G_GNUC_CONST;
GType dateable_get_type (void) G_GNUC_CONST;
GType photo_get_type (void) G_GNUC_CONST;
GType rotation_get_type (void) G_GNUC_CONST;
static GType photo_backing_readers_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
gpointer photo_file_adapter_ref (gpointer instance);
void photo_file_adapter_unref (gpointer instance);
GParamSpec* param_spec_photo_file_adapter (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_photo_file_adapter (GValue* value, gpointer v_object);
void value_take_photo_file_adapter (GValue* value, gpointer v_object);
gpointer value_get_photo_file_adapter (const GValue* value);
GType photo_file_adapter_get_type (void) G_GNUC_CONST;
GType photo_file_reader_get_type (void) G_GNUC_CONST;
static PhotoBackingReaders* photo_backing_readers_dup (const PhotoBackingReaders* self);
static void photo_backing_readers_free (PhotoBackingReaders* self);
static void photo_backing_readers_copy (const PhotoBackingReaders* self, PhotoBackingReaders* dest);
static void photo_backing_readers_destroy (PhotoBackingReaders* self);
gpointer pixel_transformer_ref (gpointer instance);
void pixel_transformer_unref (gpointer instance);
GParamSpec* param_spec_pixel_transformer (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_pixel_transformer (GValue* value, gpointer v_object);
void value_take_pixel_transformer (GValue* value, gpointer v_object);
gpointer value_get_pixel_transformer (const GValue* value);
GType pixel_transformer_get_type (void) G_GNUC_CONST;
gpointer pixel_transformation_bundle_ref (gpointer instance);
void pixel_transformation_bundle_unref (gpointer instance);
GParamSpec* param_spec_pixel_transformation_bundle (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_pixel_transformation_bundle (GValue* value, gpointer v_object);
void value_take_pixel_transformation_bundle (GValue* value, gpointer v_object);
gpointer value_get_pixel_transformation_bundle (const GValue* value);
GType pixel_transformation_bundle_get_type (void) G_GNUC_CONST;
gpointer one_shot_scheduler_ref (gpointer instance);
void one_shot_scheduler_unref (gpointer instance);
GParamSpec* param_spec_one_shot_scheduler (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_one_shot_scheduler (GValue* value, gpointer v_object);
void value_take_one_shot_scheduler (GValue* value, gpointer v_object);
gpointer value_get_one_shot_scheduler (const GValue* value);
GType one_shot_scheduler_get_type (void) G_GNUC_CONST;
#define PHOTO_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_PHOTO, PhotoPrivate))
enum  {
	PHOTO_DUMMY_PROPERTY
};
GType photo_exception_get_type (void) G_GNUC_CONST;
gboolean photo_exception_prohibits (PhotoException self, PhotoException exception);
gboolean photo_exception_allows (PhotoException self, PhotoException exception);
#define PHOTO_TYPENAME "thumb"
#define PHOTO_SCALING_FUDGE 64
Photo* photo_construct (GType object_type, PhotoRow* row);
#define DATA_OBJECT_INVALID_OBJECT_ID ((gint64) (-1))
PhotoSource* photo_source_construct (GType object_type, gint64 object_id);
gchar* media_source_prep_title (const gchar* title);
PhotoFileReader* photo_file_format_create_reader (PhotoFileFormat self, const gchar* filepath);
gchar* string_sliced_at_last_char (const gchar* haystack, gunichar ch, gint start_index);
gchar* string_sliced_at (const gchar* str, gint index);
gboolean is_string_empty (const gchar* s);
#define BACKING_PHOTO_ID_INVALID ((gint64) (-1))
GType backing_photo_row_get_type (void) G_GNUC_CONST;
BackingPhotoRow* backing_photo_row_dup (const BackingPhotoRow* self);
void backing_photo_row_free (BackingPhotoRow* self);
void backing_photo_row_copy (const BackingPhotoRow* self, BackingPhotoRow* dest);
void backing_photo_row_destroy (BackingPhotoRow* self);
gpointer database_table_ref (gpointer instance);
void database_table_unref (gpointer instance);
GParamSpec* param_spec_database_table (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_database_table (GValue* value, gpointer v_object);
void value_take_database_table (GValue* value, gpointer v_object);
gpointer value_get_database_table (const GValue* value);
GType database_table_get_type (void) G_GNUC_CONST;
GType backing_photo_table_get_type (void) G_GNUC_CONST;
BackingPhotoTable* backing_photo_table_get_instance (void);
GQuark database_error_quark (void);
BackingPhotoRow* backing_photo_table_fetch (BackingPhotoTable* self, BackingPhotoID* id, GError** error);
gchar* data_object_to_string (DataObject* self);
void backing_photo_table_remove (BackingPhotoTable* self, BackingPhotoID* backing_id, GError** error);
GType photo_table_get_type (void) G_GNUC_CONST;
PhotoTable* photo_table_get_instance (void);
void photo_table_detach_editable (PhotoTable* self, PhotoRow* row, GError** error);
static void photo_internal_remove_all_transformations (Photo* self, gboolean notify);
void photo_notify_editable_replaced (Photo* self, GFile* old_file, GFile* new_file);
static void photo_real_notify_editable_replaced (Photo* self, GFile* old_file, GFile* new_file);
void photo_notify_baseline_replaced (Photo* self);
static void photo_real_notify_baseline_replaced (Photo* self);
void photo_notify_master_reimported (Photo* self, PhotoMetadata* metadata);
static void photo_real_notify_master_reimported (Photo* self, PhotoMetadata* metadata);
void photo_notify_editable_reimported (Photo* self, PhotoMetadata* metadata);
static void photo_real_notify_editable_reimported (Photo* self, PhotoMetadata* metadata);
void photo_notify_source_reimported (Photo* self, PhotoMetadata* metadata);
static void photo_real_notify_source_reimported (Photo* self, PhotoMetadata* metadata);
void photo_notify_baseline_reimported (Photo* self, PhotoMetadata* metadata);
static void photo_real_notify_baseline_reimported (Photo* self, PhotoMetadata* metadata);
static gboolean photo_real_internal_delete_backing (DataSource* base, GError** error);
GFile* photo_file_adapter_get_file (PhotoFileAdapter* self);
static void photo_detach_editable (Photo* self, gboolean delete_editable, gboolean remove_transformations);
gboolean data_source_internal_delete_backing (DataSource* self, GError** error);
gboolean photo_would_use_mimic (Photo* self);
GType photo_file_format_flags_get_type (void) G_GNUC_CONST;
PhotoFileFormat photo_file_adapter_get_file_format (PhotoFileAdapter* self);
gpointer photo_file_format_properties_ref (gpointer instance);
void photo_file_format_properties_unref (gpointer instance);
GParamSpec* param_spec_photo_file_format_properties (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_photo_file_format_properties (GValue* value, gpointer v_object);
void value_take_photo_file_format_properties (GValue* value, gpointer v_object);
gpointer value_get_photo_file_format_properties (const GValue* value);
GType photo_file_format_properties_get_type (void) G_GNUC_CONST;
PhotoFileFormatProperties* photo_file_format_get_properties (PhotoFileFormat self);
PhotoFileFormatFlags photo_file_format_properties_get_flags (PhotoFileFormatProperties* self);
static BackingFileState** photo_real_get_backing_files_state (MediaSource* base, int* result_length1);
BackingFileState* backing_file_state_new_from_photo_state (BackingPhotoState* photo_state, const gchar* md5);
BackingFileState* backing_file_state_construct_from_photo_state (GType object_type, BackingPhotoState* photo_state, const gchar* md5);
static void _vala_array_add203 (BackingFileState*** array, int* length, int* size, BackingFileState* value);
gboolean photo_has_editable (Photo* self);
static void _vala_array_add204 (BackingFileState*** array, int* length, int* size, BackingFileState* value);
static PhotoFileReader* photo_get_backing_reader (Photo* self, BackingFetchMode mode);
static PhotoFileReader* photo_get_master_reader (Photo* self);
static PhotoFileReader* photo_get_baseline_reader (Photo* self);
static PhotoFileReader* photo_get_source_reader (Photo* self);
const gchar* backing_fetch_mode_to_string (BackingFetchMode self);
void photo_set_mimic_reader (Photo* self, PhotoFileReader* mimic);
PhotoFileReader* photo_get_editable_reader (Photo* self);
gboolean photo_is_mimicked (Photo* self);
gboolean photo_does_master_exist (Photo* self);
gboolean photo_file_adapter_file_exists (PhotoFileAdapter* self);
gboolean photo_does_editable_exist (Photo* self);
gboolean photo_is_master_baseline (Photo* self);
gboolean photo_is_master_source (Photo* self);
gboolean photo_is_editable_baseline (Photo* self);
gboolean photo_is_editable_source (Photo* self);
void photo_get_master_photo_state (Photo* self, BackingPhotoState* result);
BackingPhotoState* photo_get_editable_photo_state (Photo* self);
gboolean backing_photo_id_is_valid (BackingPhotoID *self);
PhotoFileFormat* photo_get_editable_file_format (Photo* self);
static PhotoFileFormat* _photo_file_format_dup (PhotoFileFormat* self);
GType export_format_parameters_get_type (void) G_GNUC_CONST;
GType export_format_mode_get_type (void) G_GNUC_CONST;
GType jpeg_quality_get_type (void) G_GNUC_CONST;
ExportFormatParameters* export_format_parameters_dup (const ExportFormatParameters* self);
void export_format_parameters_free (ExportFormatParameters* self);
PhotoFileFormat photo_get_export_format_for_parameters (Photo* self, ExportFormatParameters* params);
PhotoFileFormat photo_file_format_get_system_default_format (void);
PhotoFileFormat photo_get_master_file_format (Photo* self);
PhotoFileFormat photo_get_best_export_file_format (Photo* self);
gchar* photo_get_export_basename_for_parameters (Photo* self, ExportFormatParameters* params);
GFile* media_source_get_master_file (MediaSource* self);
gchar* photo_get_export_basename (Photo* self, PhotoFileFormat* file_format);
GType import_result_get_type (void) G_GNUC_CONST;
ImportResult photo_prepare_for_import (PhotoImportParams* params);
#define UTIL_FILE_ATTRIBUTES "standard::*,time::*,id::file,id::filesystem,etag::value"
#define DIRECTORY_MONITOR_SUPPLIED_ATTRIBUTES UTIL_FILE_ATTRIBUTES
gboolean photo_is_file_image (GFile* file);
gboolean photo_file_format_is_file_supported (GFile* file);
PhotoFileInterrogator* photo_file_interrogator_new (GFile* file, PhotoFileSnifferOptions options);
PhotoFileInterrogator* photo_file_interrogator_construct (GType object_type, GFile* file, PhotoFileSnifferOptions options);
gpointer photo_file_interrogator_ref (gpointer instance);
void photo_file_interrogator_unref (gpointer instance);
GParamSpec* param_spec_photo_file_interrogator (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_photo_file_interrogator (GValue* value, gpointer v_object);
void value_take_photo_file_interrogator (GValue* value, gpointer v_object);
gpointer value_get_photo_file_interrogator (const GValue* value);
GType photo_file_interrogator_get_type (void) G_GNUC_CONST;
void photo_file_interrogator_interrogate (PhotoFileInterrogator* self, GError** error);
gpointer detected_photo_information_ref (gpointer instance);
void detected_photo_information_unref (gpointer instance);
GParamSpec* param_spec_detected_photo_information (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_detected_photo_information (GValue* value, gpointer v_object);
void value_take_detected_photo_information (GValue* value, gpointer v_object);
gpointer value_get_detected_photo_information (const GValue* value);
GType detected_photo_information_get_type (void) G_GNUC_CONST;
DetectedPhotoInformation* photo_file_interrogator_get_detected_photo_information (PhotoFileInterrogator* self);
gpointer metadata_date_time_ref (gpointer instance);
void metadata_date_time_unref (gpointer instance);
GParamSpec* param_spec_metadata_date_time (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_metadata_date_time (GValue* value, gpointer v_object);
void value_take_metadata_date_time (GValue* value, gpointer v_object);
gpointer value_get_metadata_date_time (const GValue* value);
GType metadata_date_time_get_type (void) G_GNUC_CONST;
MetadataDateTime* photo_metadata_get_exposure_date_time (PhotoMetadata* self);
time_t metadata_date_time_get_timestamp (MetadataDateTime* self);
Orientation photo_metadata_get_orientation (PhotoMetadata* self);
gchar* media_metadata_get_title (MediaMetadata* self);
GeeSet* photo_metadata_get_keywords (PhotoMetadata* self, GCompareFunc compare_func);
Rating photo_metadata_get_rating (PhotoMetadata* self);
#define PHOTO_ID_INVALID ((gint64) (-1))
void photo_id_init (PhotoID *self, gint64 id);
#define EVENT_ID_INVALID ((gint64) (-1))
void event_id_init (EventID *self, gint64 id);
void thumbnail_cache_generate_for_photo (Thumbnails* thumbnails, PhotoFileReader* reader, Orientation orientation, Dimensions* original_dim, GError** error);
ImportResult import_result_convert_error (GError* err, ImportResult default_result);
void photo_create_pre_import (PhotoImportParams* params);
void dimensions_init (Dimensions *self, gint width, gint height);
gboolean photo_query_backing_photo_state (Photo* self, GFile* file, PhotoFileSnifferOptions options, BackingPhotoState* state, DetectedPhotoInformation** detected, GError** error);
gpointer photo_reimport_master_state_ref (gpointer instance);
void photo_reimport_master_state_unref (gpointer instance);
GParamSpec* photo_param_spec_reimport_master_state (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void photo_value_set_reimport_master_state (GValue* value, gpointer v_object);
void photo_value_take_reimport_master_state (GValue* value, gpointer v_object);
gpointer photo_value_get_reimport_master_state (const GValue* value);
GType photo_reimport_master_state_get_type (void) G_GNUC_CONST;
gboolean photo_prepare_for_reimport_master (Photo* self, PhotoReimportMasterState** reimport_state, GError** error);
static void _vala_array_add205 (gchar*** array, int* length, int* size, gchar* value);
static void _vala_array_add206 (gchar*** array, int* length, int* size, gchar* value);
static void _vala_array_add207 (gchar*** array, int* length, int* size, gchar* value);
static void _vala_array_add208 (gchar*** array, int* length, int* size, gchar* value);
static void _vala_array_add209 (gchar*** array, int* length, int* size, gchar* value);
static PhotoReimportMasterStateImpl* photo_reimport_master_state_impl_new (PhotoRow* row, PhotoMetadata* metadata, gchar** alterations, int alterations_length1);
static PhotoReimportMasterStateImpl* photo_reimport_master_state_impl_construct (GType object_type, PhotoRow* row, PhotoMetadata* metadata, gchar** alterations, int alterations_length1);
static GType photo_reimport_master_state_impl_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
void photo_apply_user_metadata_for_reimport (Photo* self, PhotoMetadata* metadata);
static void photo_real_apply_user_metadata_for_reimport (Photo* self, PhotoMetadata* metadata);
void photo_finish_reimport_master (Photo* self, PhotoReimportMasterState* state, GError** error);
void photo_table_reimport (PhotoTable* self, PhotoRow* row, GError** error);
static void _vala_array_add210 (gchar*** array, int* length, int* size, gchar* value);
static void _vala_array_add211 (gchar*** array, int* length, int* size, gchar* value);
void data_object_notify_altered (DataObject* self, Alteration* alteration);
Alteration* alteration_new_from_array (gchar** array, int array_length1);
Alteration* alteration_construct_from_array (GType object_type, gchar** array, int array_length1);
gpointer photo_reimport_editable_state_ref (gpointer instance);
void photo_reimport_editable_state_unref (gpointer instance);
GParamSpec* photo_param_spec_reimport_editable_state (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void photo_value_set_reimport_editable_state (GValue* value, gpointer v_object);
void photo_value_take_reimport_editable_state (GValue* value, gpointer v_object);
gpointer photo_value_get_reimport_editable_state (const GValue* value);
GType photo_reimport_editable_state_get_type (void) G_GNUC_CONST;
gboolean photo_prepare_for_reimport_editable (Photo* self, PhotoReimportEditableState** state, GError** error);
GFile* photo_get_editable_file (Photo* self);
static PhotoReimportEditableStateImpl* photo_reimport_editable_state_impl_new (BackingPhotoState* backing_state, PhotoMetadata* metadata);
static PhotoReimportEditableStateImpl* photo_reimport_editable_state_impl_construct (GType object_type, BackingPhotoState* backing_state, PhotoMetadata* metadata);
static GType photo_reimport_editable_state_impl_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
void photo_finish_reimport_editable (Photo* self, PhotoReimportEditableState* state, GError** error);
void photo_get_editable_id (Photo* self, BackingPhotoID* result);
gboolean backing_photo_id_is_invalid (BackingPhotoID *self);
void backing_photo_table_update (BackingPhotoTable* self, BackingPhotoID* id, BackingPhotoState* state, GError** error);
gboolean photo_set_orientation (Photo* self, Orientation orientation);
void media_source_set_title (MediaSource* self, const gchar* title);
void media_source_set_rating (MediaSource* self, Rating rating);
Alteration* alteration_new_from_list (const gchar* list);
Alteration* alteration_construct_from_list (GType object_type, const gchar* list);
static gchar* photo_real_get_typename (DataSource* base);
static gint64 photo_real_get_instance_id (DataSource* base);
void photo_get_photo_id (Photo* self, PhotoID* result);
static gchar* photo_real_get_source_id (DataSource* base);
gchar* data_source_get_typename (DataSource* self);
gint64 data_source_get_instance_id (DataSource* self);
void photo_set_master_timestamp (Photo* self, GFileInfo* info);
void photo_table_update_timestamp (PhotoTable* self, PhotoID* photo_id, time_t timestamp, GError** error);
void app_window_database_error (GError* err);
Alteration* alteration_new (const gchar* subject, const gchar* detail);
Alteration* alteration_construct (GType object_type, const gchar* subject, const gchar* detail);
void photo_update_editable_modification_time (Photo* self, GFileInfo* info, GError** error);
void backing_photo_table_update_timestamp (BackingPhotoTable* self, BackingPhotoID* id, time_t timestamp, GError** error);
void photo_update_many_editable_timestamps (GeeMap* map, GError** error);
void database_table_begin_transaction (void);
void database_table_commit_transaction (GError** error);
static PhotoFileFormat photo_real_get_preferred_thumbnail_format (ThumbnailSource* base);
PhotoFileFormat photo_get_file_format (Photo* self);
gboolean photo_file_format_can_write_image (PhotoFileFormat self);
static GdkPixbuf* photo_real_create_thumbnail (ThumbnailSource* base, gint scale, GError** error);
GdkPixbuf* photo_source_get_pixbuf (PhotoSource* self, Scaling* scaling, GError** error);
void scaling_for_best_fit (gint pixels, gboolean scale_up, Scaling* result);
static gboolean photo_is_extension_found (const gchar* basename, gchar** extensions, int extensions_length1);
void disassemble_filename (const gchar* basename, gchar** name, gchar** ext);
gboolean photo_is_duplicate (GFile* file, const gchar* thumbnail_md5, const gchar* full_md5, PhotoFileFormat file_format);
gboolean photo_table_has_duplicate (PhotoTable* self, GFile* file, const gchar* thumbnail_md5, const gchar* md5, PhotoFileFormat file_format);
PhotoID* photo_get_duplicate_ids (GFile* file, const gchar* thumbnail_md5, const gchar* full_md5, PhotoFileFormat file_format, int* result_length1);
PhotoID* photo_table_get_duplicate_ids (PhotoTable* self, GFile* file, const gchar* thumbnail_md5, const gchar* md5, PhotoFileFormat file_format, int* result_length1);
gint64 photo_get_photo_key (DataSource* source);
GType library_photo_get_type (void) G_GNUC_CONST;
static GFile* photo_real_get_file (MediaSource* base);
void photo_set_master_file (Photo* self, GFile* file);
void photo_table_set_filepath (PhotoTable* self, PhotoID* photo_id, const gchar* filepath, GError** error);
void media_source_notify_master_replaced (MediaSource* self, GFile* old_file, GFile* new_file);
static void _vala_array_add212 (gchar*** array, int* length, int* size, gchar* value);
static void _vala_array_add213 (gchar*** array, int* length, int* size, gchar* value);
static void _vala_array_add214 (gchar*** array, int* length, int* size, gchar* value);
static void _vala_array_add215 (gchar*** array, int* length, int* size, gchar* value);
void photo_set_editable_file (Photo* self, GFile* file);
void backing_photo_table_set_filepath (BackingPhotoTable* self, BackingPhotoID* id, const gchar* filepath, GError** error);
static void _vala_array_add216 (gchar*** array, int* length, int* size, gchar* value);
static void _vala_array_add217 (gchar*** array, int* length, int* size, gchar* value);
static void _vala_array_add218 (gchar*** array, int* length, int* size, gchar* value);
void photo_set_many_editable_file (GeeMap* map, GError** error);
GFile* photo_get_actual_file (Photo* self);
static GFile* photo_real_get_master_file (MediaSource* base);
GFile* photo_get_source_file (Photo* self);
gboolean photo_file_format_can_write (PhotoFileFormat self);
static time_t photo_real_get_timestamp (MediaSource* base);
static inline void photo_real_get_event_id (MediaSource* base, EventID* result);
gint64 photo_get_raw_event_id (Photo* self);
static void photo_real_get_import_id (MediaSource* base, ImportID* result);
static gchar* photo_real_get_master_md5 (MediaSource* base);
guint64 photo_get_flags (Photo* self);
static void photo_notify_flags_altered (Photo* self, Alteration* additional_alteration);
Alteration* alteration_compress (Alteration* self, Alteration* other);
guint64 photo_replace_flags (Photo* self, guint64 flags, Alteration* additional_alteration);
gboolean photo_table_replace_flags (PhotoTable* self, PhotoID* photo_id, guint64 flags);
gboolean photo_is_flag_set (Photo* self, guint64 mask);
gboolean media_source_internal_is_flag_set (guint64 flags, guint64 selector);
guint64 photo_add_flags (Photo* self, guint64 mask, Alteration* additional_alteration);
guint64 media_source_internal_add_flags (guint64 flags, guint64 selector);
guint64 photo_remove_flags (Photo* self, guint64 mask, Alteration* additional_alteration);
guint64 media_source_internal_remove_flags (guint64 flags, guint64 selector);
guint64 photo_add_remove_flags (Photo* self, guint64 add, guint64 remove, Alteration* additional_alteration);
void photo_add_remove_many_flags (GeeCollection* add, guint64 add_mask, Alteration* additional_add_alteration, GeeCollection* remove, guint64 remove_mask, Alteration* additional_remove_alteration, GError** error);
guint64 photo_toggle_flags (Photo* self, guint64 mask, Alteration* additional_alteration);
gboolean photo_is_master_metadata_dirty (Photo* self);
void photo_set_master_metadata_dirty (Photo* self, gboolean dirty, GError** error);
void photo_table_set_metadata_dirty (PhotoTable* self, PhotoID* photo_id, gboolean dirty, GError** error);
static Rating photo_real_get_rating (MediaSource* base);
static void photo_real_set_rating (MediaSource* base, Rating rating);
gboolean photo_table_set_rating (PhotoTable* self, PhotoID* photo_id, Rating rating);
static void photo_real_increase_rating (MediaSource* base);
static void photo_real_decrease_rating (MediaSource* base);
static void photo_real_commit_backlinks (DataSource* base, SourceCollection* sources, const gchar* backlinks);
void photo_table_update_backlinks (PhotoTable* self, PhotoID* photo_id, const gchar* backlinks, GError** error);
static gboolean photo_real_set_event_id (MediaSource* base, EventID* event_id);
gboolean photo_table_set_event (PhotoTable* self, PhotoID* photo_id, EventID* event_id);
static gchar* photo_real_to_string (DataObject* base);
gchar* photo_file_adapter_get_filepath (PhotoFileAdapter* self);
static gboolean photo_real_equals (DataSource* base, DataSource* source);
gboolean data_source_equals (DataSource* self, DataSource* source);
static void photo_file_exif_updated (Photo* self);
GFile* media_source_get_file (MediaSource* self);
gboolean photo_table_master_exif_updated (PhotoTable* self, PhotoID* photoID, gint64 filesize, glong timestamp, const gchar* md5, const gchar* exif_md5, const gchar* thumbnail_md5, PhotoRow* row);
static guint64 photo_real_get_filesize (MediaSource* base);
static guint64 photo_real_get_master_filesize (MediaSource* base);
guint64 photo_get_editable_filesize (Photo* self);
static time_t photo_real_get_exposure_time (Dateable* base);
static gchar* photo_real_get_basename (MediaSource* base);
static gchar* photo_real_get_title (MediaSource* base);
static void photo_real_set_title (MediaSource* base, const gchar* title);
gboolean photo_table_set_title (PhotoTable* self, PhotoID* photo_id, const gchar* new_title);
void photo_set_import_id (Photo* self, ImportID* import_id);
void photo_table_set_import_id (PhotoTable* self, PhotoID* photo_id, ImportID* import_id, GError** error);
void photo_set_title_persistent (Photo* self, const gchar* title, GError** error);
gboolean photo_file_format_can_write_metadata (PhotoFileFormat self);
PhotoMetadata* photo_file_reader_read_metadata (PhotoFileReader* self, GError** error);
GType photo_metadata_set_option_get_type (void) G_GNUC_CONST;
void photo_metadata_set_title (PhotoMetadata* self, const gchar* title, PhotoMetadataSetOption option);
GType photo_file_metadata_writer_get_type (void) G_GNUC_CONST;
GQuark photo_format_error_quark (void);
PhotoFileMetadataWriter* photo_file_reader_create_metadata_writer (PhotoFileReader* self, GError** error);
void library_monitor_blacklist_file (GFile* file, const gchar* reason);
void photo_file_metadata_writer_write_metadata (PhotoFileMetadataWriter* self, PhotoMetadata* metadata, GError** error);
void library_monitor_unblacklist_file (GFile* file);
static void photo_real_set_exposure_time (Dateable* base, time_t time);
gboolean photo_table_set_exposure_time (PhotoTable* self, PhotoID* photo_id, time_t time);
void photo_set_exposure_time_persistent (Photo* self, time_t time, GError** error);
void dateable_set_exposure_time (Dateable* self, time_t target_time);
void photo_metadata_set_exposure_date_time (PhotoMetadata* self, MetadataDateTime* date_time, PhotoMetadataSetOption option);
MetadataDateTime* metadata_date_time_new (time_t timestamp);
MetadataDateTime* metadata_date_time_construct (GType object_type, time_t timestamp);
static void photo_real_get_dimensions (MediaSource* base, Dimensions* result);
GType box_get_type (void) G_GNUC_CONST;
Box* box_dup (const Box* self);
void box_free (Box* self);
gboolean photo_get_crop (Photo* self, Box* crop);
void box_get_dimensions (Box *self, Dimensions* result);
void photo_get_original_dimensions (Photo* self, Dimensions* result);
static void photo_locked_create_adjustments_from_data (Photo* self);
PixelTransformationBundle* pixel_transformation_bundle_new (void);
PixelTransformationBundle* pixel_transformation_bundle_construct (GType object_type);
static KeyValueMap* photo_get_transformation (Photo* self, const gchar* name);
void pixel_transformation_bundle_set_to_identity (PixelTransformationBundle* self);
void pixel_transformation_bundle_load (PixelTransformationBundle* self, KeyValueMap* store);
PixelTransformer* pixel_transformation_bundle_generate_transformer (PixelTransformationBundle* self);
PixelTransformationBundle* photo_get_color_adjustments (Photo* self);
PixelTransformationBundle* pixel_transformation_bundle_copy (PixelTransformationBundle* self);
PixelTransformer* photo_get_pixel_transformer (Photo* self);
PixelTransformer* pixel_transformer_copy (PixelTransformer* self);
gboolean photo_has_color_adjustments (Photo* self);
static gboolean photo_has_transformation (Photo* self, const gchar* name);
GType pixel_transformation_type_get_type (void) G_GNUC_CONST;
gpointer pixel_transformation_ref (gpointer instance);
void pixel_transformation_unref (gpointer instance);
GParamSpec* param_spec_pixel_transformation (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_pixel_transformation (GValue* value, gpointer v_object);
void value_take_pixel_transformation (GValue* value, gpointer v_object);
gpointer value_get_pixel_transformation (const GValue* value);
GType pixel_transformation_get_type (void) G_GNUC_CONST;
PixelTransformation* photo_get_color_adjustment (Photo* self, PixelTransformationType type);
PixelTransformation* pixel_transformation_bundle_get_transformation (PixelTransformationBundle* self, PixelTransformationType type);
void photo_set_color_adjustments (Photo* self, PixelTransformationBundle* new_adjustments);
gboolean pixel_transformation_bundle_is_identity (PixelTransformationBundle* self);
static gboolean photo_remove_transformation (Photo* self, const gchar* name);
KeyValueMap* pixel_transformation_bundle_save (PixelTransformationBundle* self, const gchar* group);
GeeIterable* pixel_transformation_bundle_get_transformations (PixelTransformationBundle* self);
void pixel_transformer_replace_transformation (PixelTransformer* self, PixelTransformation* old_trans, PixelTransformation* new_trans);
PixelTransformationType pixel_transformation_get_transformation_type (PixelTransformation* self);
static gboolean photo_set_transformation (Photo* self, KeyValueMap* trans);
static PhotoMetadata* photo_real_get_metadata (PhotoSource* base);
PhotoMetadata* photo_get_master_metadata (Photo* self, GError** error);
PhotoMetadata* photo_get_editable_metadata (Photo* self, GError** error);
gboolean photo_persist_master_metadata (Photo* self, PhotoMetadata* metadata, PhotoReimportMasterState** state, GError** error);
void photo_finish_update_master_metadata (Photo* self, PhotoReimportMasterState* state, GError** error);
gboolean photo_persist_editable_metadata (Photo* self, PhotoMetadata* metadata, PhotoReimportEditableState** state, GError** error);
void photo_finish_update_editable_metadata (Photo* self, PhotoReimportEditableState* state, GError** error);
void photo_get_raw_dimensions (Photo* self, Dimensions* result);
gboolean photo_has_transformations (Photo* self);
gboolean photo_only_metadata_changed (Photo* self);
PhotoMetadata* photo_source_get_metadata (PhotoSource* self);
gboolean photo_has_alterations (Photo* self);
gchar* media_source_get_title (MediaSource* self);
PhotoTransformationState* photo_save_transformation_state (Photo* self);
static PhotoPhotoTransformationStateImpl* photo_photo_transformation_state_impl_new (Photo* photo, Orientation orientation, GeeHashMap* transformations, PixelTransformer* transformer, PixelTransformationBundle* adjustments);
static PhotoPhotoTransformationStateImpl* photo_photo_transformation_state_impl_construct (GType object_type, Photo* photo, Orientation orientation, GeeHashMap* transformations, PixelTransformer* transformer, PixelTransformationBundle* adjustments);
static GType photo_photo_transformation_state_impl_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
gboolean photo_load_transformation_state (Photo* self, PhotoTransformationState* state);
static Orientation photo_photo_transformation_state_impl_get_orientation (PhotoPhotoTransformationStateImpl* self);
static GeeHashMap* photo_photo_transformation_state_impl_get_transformations (PhotoPhotoTransformationStateImpl* self);
static PixelTransformer* photo_photo_transformation_state_impl_get_transformer (PhotoPhotoTransformationStateImpl* self);
static PixelTransformationBundle* photo_photo_transformation_state_impl_get_color_adjustments (PhotoPhotoTransformationStateImpl* self);
gboolean photo_table_set_transformation_state (PhotoTable* self, PhotoID* photo_id, Orientation orientation, GeeHashMap* transformations);
void photo_remove_all_transformations (Photo* self);
gboolean photo_table_remove_all_transformations (PhotoTable* self, PhotoID* photo_id);
gboolean photo_table_set_orientation (PhotoTable* self, PhotoID* photo_id, Orientation orientation);
Orientation photo_get_original_orientation (Photo* self);
Orientation photo_get_orientation (Photo* self);
void photo_rotate (Photo* self, Rotation rotation);
static void photo_real_rotate (Photo* self, Rotation rotation);
Orientation orientation_perform (Orientation self, Rotation rotation);
KeyValueMap* key_value_map_copy (KeyValueMap* self);
gchar* key_value_map_get_group (KeyValueMap* self);
gboolean photo_table_set_transformation (PhotoTable* self, PhotoID* photo_id, KeyValueMap* map);
gboolean photo_table_remove_transformation (PhotoTable* self, PhotoID* photo_id, const gchar* object);
gboolean photo_has_crop (Photo* self);
static gboolean photo_get_raw_crop (Photo* self, Box* crop);
gint key_value_map_get_int (KeyValueMap* self, const gchar* key, gint def);
void box_init (Box *self, gint left, gint top, gint right, gint bottom);
static void photo_set_raw_crop (Photo* self, Box* crop);
KeyValueMap* key_value_map_new (const gchar* group);
KeyValueMap* key_value_map_construct (GType object_type, const gchar* group);
void key_value_map_set_int (KeyValueMap* self, const gchar* key, gint value);
GType redeye_instance_get_type (void) G_GNUC_CONST;
RedeyeInstance* redeye_instance_dup (const RedeyeInstance* self);
void redeye_instance_free (RedeyeInstance* self);
static RedeyeInstance* photo_get_raw_redeye_instances (Photo* self, int* result_length1);
void key_value_map_get_point (KeyValueMap* self, const gchar* key, GdkPoint* def, GdkPoint* result);
gboolean photo_has_redeye_transformations (Photo* self);
static void photo_add_raw_redeye_instance (Photo* self, RedeyeInstance* redeye);
void key_value_map_set_point (KeyValueMap* self, const gchar* key, GdkPoint* point);
static gboolean photo_calculate_pixbuf_dimensions (Photo* self, Scaling* scaling, PhotoException exceptions, Dimensions* scaled_image, Dimensions* scaled_to_viewport);
static gboolean photo_locked_calculate_pixbuf_dimensions (Photo* self, Scaling* scaling, PhotoException exceptions, Dimensions* scaled_image, Dimensions* scaled_to_viewport);
gboolean scaling_is_unscaled (Scaling *self);
void orientation_rotate_box (Orientation self, Dimensions* space, Box* box, Box* result);
void orientation_rotate_dimensions (Orientation self, Dimensions* dim, Dimensions* result);
void box_get_scaled (Box *self, Dimensions* scaled, Box* result);
void scaling_get_scaled_dimensions (Scaling *self, Dimensions* original, Dimensions* result);
gint box_get_width (Box *self);
gint box_get_height (Box *self);
void dimensions_get_scaled_similar (Dimensions *self, Dimensions* original, Dimensions* scaled, Dimensions* result);
void orientation_derotate_dimensions (Orientation self, Dimensions* dim, Dimensions* result);
gboolean dimensions_has_area (Dimensions *self);
static GdkPixbuf* photo_load_raw_pixbuf (Photo* self, Scaling* scaling, PhotoException exceptions, BackingFetchMode fetch_mode, GError** error);
GdkPixbuf* photo_file_reader_unscaled_read (PhotoFileReader* self, GError** error);
GdkPixbuf* photo_file_reader_scaled_read (PhotoFileReader* self, Dimensions* full, Dimensions* scaled, GError** error);
gboolean dimensions_approx_equals (Dimensions *self, Dimensions* dim, gint fudge);
void dimensions_for_pixbuf (GdkPixbuf* pixbuf, Dimensions* result);
GdkPixbuf* photo_get_master_pixbuf (Photo* self, Scaling* scaling, gboolean rotate, GError** error);
GdkPixbuf* orientation_rotate_pixbuf (Orientation self, GdkPixbuf* pixbuf);
static GdkPixbuf* photo_real_get_pixbuf (PhotoSource* base, Scaling* scaling, GError** error);
GdkPixbuf* photo_get_pixbuf_with_options (Photo* self, Scaling* scaling, PhotoException exceptions, BackingFetchMode fetch_mode, GError** error);
void coord_scaled_in_space (gint x, gint y, Dimensions* original, Dimensions* scaled, GdkPoint* result);
gint radius_scaled_in_space (gint radius, Dimensions* original, Dimensions* scaled);
static GdkPixbuf* photo_do_redeye (Photo* self, GdkPixbuf* pixbuf, RedeyeInstance* inst);
void box_get_scaled_similar (Box *self, Dimensions* original, Dimensions* scaled, Box* result);
void pixel_transformer_transform_pixbuf (PixelTransformer* self, GdkPixbuf* pixbuf, GCancellable* cancellable);
gboolean photo_has_user_generated_metadata (Photo* self);
static gboolean photo_real_has_user_generated_metadata (Photo* self);
void photo_set_user_metadata_for_export (Photo* self, PhotoMetadata* metadata);
static void photo_real_set_user_metadata_for_export (Photo* self, PhotoMetadata* metadata);
GFile* photo_file_format_properties_convert_file_extension (PhotoFileFormatProperties* self, GFile* file);
static gboolean photo_export_fullsized_backing (Photo* self, GFile* file, GError** error);
PhotoFileMetadataWriter* photo_file_format_create_metadata_writer (PhotoFileFormat self, const gchar* filepath, GError** error);
PhotoMetadata* photo_file_format_create_metadata (PhotoFileFormat self);
time_t media_source_get_exposure_time (MediaSource* self);
void photo_metadata_set_pixel_dimensions (PhotoMetadata* self, Dimensions* dim, PhotoMetadataSetOption option);
void media_source_get_dimensions (MediaSource* self, Dimensions* result);
void photo_metadata_set_orientation (PhotoMetadata* self, Orientation orientation);
void photo_metadata_set_software (PhotoMetadata* self, const gchar* software, const gchar* version);
#define RESOURCES_APP_TITLE "Shotwell"
#define RESOURCES_APP_VERSION _VERSION
void photo_metadata_remove_exif_thumbnail (PhotoMetadata* self);
gboolean photo_is_export_required (Photo* self, Scaling* scaling, PhotoFileFormat export_format);
void photo_export (Photo* self, GFile* dest_file, Scaling* scaling, JpegQuality quality, PhotoFileFormat export_format, gboolean direct_copy_unmodified, GError** error);
GType photo_file_writer_get_type (void) G_GNUC_CONST;
PhotoFileWriter* photo_file_format_create_writer (PhotoFileFormat self, const gchar* filepath, GError** error);
const gchar* photo_file_format_to_string (PhotoFileFormat self);
void photo_file_writer_write (PhotoFileWriter* self, GdkPixbuf* pixbuf, JpegQuality quality, GError** error);
void photo_metadata_remove_tag (PhotoMetadata* self, const gchar* tag);
static GFile* photo_generate_new_editable_file (Photo* self, PhotoFileFormat* file_format, GError** error);
gboolean photo_file_format_properties_is_recognized_extension (PhotoFileFormatProperties* self, const gchar* ext);
gchar* photo_file_format_properties_get_default_extension (PhotoFileFormatProperties* self);
GFile* generate_unique_file (GFile* dir, const gchar* basename, gboolean* collision, GError** error);
static gboolean photo_launch_editor (GFile* file, PhotoFileFormat file_format, GError** error);
gpointer config_ref (gpointer instance);
void config_unref (gpointer instance);
GParamSpec* param_spec_config (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_config (GValue* value, gpointer v_object);
void value_take_config (GValue* value, gpointer v_object);
gpointer value_get_config (const GValue* value);
GType config_get_type (void) G_GNUC_CONST;
Config* config_get_instance (void);
gchar* config_get_external_raw_app (Config* self);
gchar* config_get_external_photo_app (Config* self);
static void _g_object_unref0_ (gpointer var);
static void _g_list_free__g_object_unref0_ (GList* self);
void photo_open_master_with_external_editor (Photo* self, GError** error);
void photo_open_with_external_editor (Photo* self, GError** error);
static void photo_halt_monitoring_editable (Photo* self);
void scaling_for_original (Scaling* result);
static void photo_attach_editable (Photo* self, PhotoFileFormat file_format, GFile* file, GError** error);
static void photo_start_monitoring_editable (Photo* self, GFile* file, GError** error);
void photo_revert_to_master (Photo* self);
static void photo_on_editable_file_changed (Photo* self, GFile* file, GFile* other_file, GFileMonitorEvent event);
static void _photo_on_editable_file_changed_g_file_monitor_changed (GFileMonitor* _sender, GFile* file, GFile* other_file, GFileMonitorEvent event_type, gpointer self);
static void photo_update_editable (Photo* self, gboolean only_attributes, PhotoFileReader* new_reader, GError** error);
static void photo_update_editable_attributes (Photo* self, GError** error);
void photo_reimport_editable (Photo* self, GError** error);
void backing_photo_table_update_attributes (BackingPhotoTable* self, BackingPhotoID* id, time_t timestamp, gint64 filesize, GError** error);
void backing_photo_table_add (BackingPhotoTable* self, BackingPhotoState* state, BackingPhotoRow* result, GError** error);
void photo_table_attach_editable (PhotoTable* self, PhotoRow* row, BackingPhotoID* editable_id, GError** error);
static void _vala_array_add219 (gchar*** array, int* length, int* size, gchar* value);
static void _vala_array_add220 (gchar*** array, int* length, int* size, gchar* value);
static void _vala_array_add221 (gchar*** array, int* length, int* size, gchar* value);
static void _vala_array_add222 (gchar*** array, int* length, int* size, gchar* value);
static void _vala_array_add223 (gchar*** array, int* length, int* size, gchar* value);
static void _vala_array_add224 (gchar*** array, int* length, int* size, gchar* value);
void backing_photo_id_init (BackingPhotoID *self, gint64 id);
const gchar* g_file_monitor_event_to_string (GFileMonitorEvent self);
static void photo_on_reimport_editable (Photo* self);
static void _photo_on_reimport_editable_one_shot_callback (gpointer self);
OneShotScheduler* one_shot_scheduler_new (const gchar* name, OneShotCallback callback, void* callback_target);
OneShotScheduler* one_shot_scheduler_construct (GType object_type, const gchar* name, OneShotCallback callback, void* callback_target);
void one_shot_scheduler_after_timeout (OneShotScheduler* self, guint msec, gboolean reschedule);
static void photo_on_update_editable_attributes (Photo* self);
static void _photo_on_update_editable_attributes_one_shot_callback (gpointer self);
static void photo_on_remove_editable (Photo* self);
static void _photo_on_remove_editable_one_shot_callback (gpointer self);
void photo_get_master_dimensions (Photo* self, Dimensions* result);
void photo_set_crop (Photo* self, Box* crop);
void orientation_derotate_box (Orientation self, Dimensions* space, Box* box, Box* result);
void photo_add_redeye_instance (Photo* self, RedeyeInstance* inst_unscaled);
void redeye_instance_to_bounds_rect (RedeyeInstance* inst, GdkRectangle* result);
void photo_unscaled_to_raw_rect (Photo* self, GdkRectangle* unscaled_rect, GdkRectangle* result);
void redeye_instance_from_bounds_rect (GdkRectangle* rect, RedeyeInstance* result);
static GdkPixbuf* photo_red_reduce_pixel (Photo* self, GdkPixbuf* pixbuf, gint x, gint y);
void photo_unscaled_to_raw_point (Photo* self, GdkPoint* unscaled_point, GdkPoint* result);
void orientation_derotate_point (Orientation self, Dimensions* space, GdkPoint* point, GdkPoint* result);
PixelTransformationBundle* photo_get_enhance_transformations (Photo* self);
PixelTransformationBundle* auto_enhance_create_auto_enhance_adjustments (GdkPixbuf* pixbuf);
gboolean photo_enhance (Photo* self);
static void photo_real_editable_replaced (Photo* self, GFile* old_file, GFile* new_file);
static void g_cclosure_user_marshal_VOID__OBJECT_OBJECT (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);
static void photo_real_baseline_replaced (Photo* self);
static void photo_real_master_reimported (Photo* self, PhotoMetadata* metadata);
static void g_cclosure_user_marshal_VOID__MEDIA_METADATA (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);
static void photo_real_editable_reimported (Photo* self, PhotoMetadata* metadata);
static void photo_real_baseline_reimported (Photo* self, PhotoMetadata* metadata);
static void photo_real_source_reimported (Photo* self, PhotoMetadata* metadata);
#define PHOTO_PHOTO_TRANSFORMATION_STATE_IMPL_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), PHOTO_TYPE_PHOTO_TRANSFORMATION_STATE_IMPL, PhotoPhotoTransformationStateImplPrivate))
enum  {
	PHOTO_PHOTO_TRANSFORMATION_STATE_IMPL_DUMMY_PROPERTY
};
static void photo_photo_transformation_state_impl_on_photo_baseline_replaced (PhotoPhotoTransformationStateImpl* self);
static void _photo_photo_transformation_state_impl_on_photo_baseline_replaced_photo_baseline_replaced (Photo* _sender, gpointer self);
static GeeHashMap* photo_photo_transformation_state_impl_copy_transformations (GeeHashMap* original);
static void photo_photo_transformation_state_impl_finalize (GObject* obj);
enum  {
	PHOTO_REIMPORT_MASTER_STATE_DUMMY_PROPERTY
};
PhotoReimportMasterState* photo_reimport_master_state_construct (GType object_type);
static void photo_reimport_master_state_finalize (PhotoReimportMasterState* obj);
enum  {
	PHOTO_REIMPORT_MASTER_STATE_IMPL_DUMMY_PROPERTY
};
static gchar** _vala_array_dup29 (gchar** self, int length);
static void photo_reimport_master_state_impl_finalize (PhotoReimportMasterState* obj);
enum  {
	PHOTO_REIMPORT_EDITABLE_STATE_DUMMY_PROPERTY
};
PhotoReimportEditableState* photo_reimport_editable_state_construct (GType object_type);
static void photo_reimport_editable_state_finalize (PhotoReimportEditableState* obj);
enum  {
	PHOTO_REIMPORT_EDITABLE_STATE_IMPL_DUMMY_PROPERTY
};
static void photo_reimport_editable_state_impl_finalize (PhotoReimportEditableState* obj);
static void photo_finalize (GObject* obj);
GType marker_get_type (void) G_GNUC_CONST;
gpointer source_backlink_ref (gpointer instance);
void source_backlink_unref (gpointer instance);
GParamSpec* param_spec_source_backlink (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_source_backlink (GValue* value, gpointer v_object);
void value_take_source_backlink (GValue* value, gpointer v_object);
gpointer value_get_source_backlink (const GValue* value);
GType source_backlink_get_type (void) G_GNUC_CONST;
GType database_source_collection_get_type (void) G_GNUC_CONST;
GType media_source_collection_get_type (void) G_GNUC_CONST;
GType database_source_holding_tank_get_type (void) G_GNUC_CONST;
GType media_source_holding_tank_get_type (void) G_GNUC_CONST;
gpointer workers_ref (gpointer instance);
void workers_unref (gpointer instance);
GParamSpec* param_spec_workers (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_workers (GValue* value, gpointer v_object);
void value_take_workers (GValue* value, gpointer v_object);
gpointer value_get_workers (const GValue* value);
GType workers_get_type (void) G_GNUC_CONST;
GType media_monitor_get_type (void) G_GNUC_CONST;
gpointer transaction_controller_ref (gpointer instance);
void transaction_controller_unref (gpointer instance);
GParamSpec* param_spec_transaction_controller (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_transaction_controller (GValue* value, gpointer v_object);
void value_take_transaction_controller (GValue* value, gpointer v_object);
gpointer value_get_transaction_controller (const GValue* value);
GType transaction_controller_get_type (void) G_GNUC_CONST;
GType library_photo_source_collection_get_type (void) G_GNUC_CONST;
#define LIBRARY_PHOTO_SOURCE_COLLECTION_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, LibraryPhotoSourceCollectionPrivate))
enum  {
	LIBRARY_PHOTO_SOURCE_COLLECTION_DUMMY_PROPERTY
};
GType library_photo_source_collection_state_get_type (void) G_GNUC_CONST;
gint int64_compare (void* a, void* b);
static gint _int64_compare_gcompare_func (gconstpointer a, gconstpointer b);
static gint64* _int64_dup (gint64* self);
gboolean int64_equal (void* a, void* b);
static gboolean _int64_equal_gequal_func (gconstpointer a, gconstpointer b);
LibraryPhotoSourceCollection* library_photo_source_collection_new (void);
LibraryPhotoSourceCollection* library_photo_source_collection_construct (GType object_type);
static gint64 _photo_get_photo_key_get_source_database_key (DataSource* source, gpointer self);
MediaSourceCollection* media_source_collection_construct (GType object_type, const gchar* name, GetSourceDatabaseKey source_key_func, void* source_key_func_target);
MediaSourceHoldingTank* media_source_collection_get_trashcan (MediaSourceCollection* self);
static void library_photo_source_collection_on_trashcan_contents_altered (LibraryPhotoSourceCollection* self, GeeCollection* added, GeeCollection* removed);
static void _library_photo_source_collection_on_trashcan_contents_altered_source_holding_tank_contents_altered (SourceHoldingTank* _sender, GeeCollection* added, GeeCollection* removed, gpointer self);
MediaSourceHoldingTank* media_source_collection_get_offline_bin (MediaSourceCollection* self);
static void library_photo_source_collection_on_offline_contents_altered (LibraryPhotoSourceCollection* self, GeeCollection* added, GeeCollection* removed);
static void _library_photo_source_collection_on_offline_contents_altered_source_holding_tank_contents_altered (SourceHoldingTank* _sender, GeeCollection* added, GeeCollection* removed, gpointer self);
static MediaSourceHoldingTank* library_photo_source_collection_real_create_trashcan (MediaSourceCollection* base);
static gboolean library_photo_source_collection_check_if_trashed_photo (LibraryPhotoSourceCollection* self, DataSource* source, Alteration* alteration);
static gboolean _library_photo_source_collection_check_if_trashed_photo_source_holding_tank_check_to_keep (DataSource* source, Alteration* alteration, gpointer self);
MediaSourceHoldingTank* media_source_holding_tank_new (MediaSourceCollection* sources, SourceHoldingTankCheckToKeep check_to_keep, void* check_to_keep_target, GetSourceDatabaseKey get_key, void* get_key_target);
MediaSourceHoldingTank* media_source_holding_tank_construct (GType object_type, MediaSourceCollection* sources, SourceHoldingTankCheckToKeep check_to_keep, void* check_to_keep_target, GetSourceDatabaseKey get_key, void* get_key_target);
static MediaSourceHoldingTank* library_photo_source_collection_real_create_offline_bin (MediaSourceCollection* base);
static gboolean library_photo_source_collection_check_if_offline_photo (LibraryPhotoSourceCollection* self, DataSource* source, Alteration* alteration);
static gboolean _library_photo_source_collection_check_if_offline_photo_source_holding_tank_check_to_keep (DataSource* source, Alteration* alteration, gpointer self);
static MediaMonitor* library_photo_source_collection_real_create_media_monitor (MediaSourceCollection* base, Workers* workers, GCancellable* cancellable);
PhotoMonitor* photo_monitor_new (Workers* workers, GCancellable* cancellable);
PhotoMonitor* photo_monitor_construct (GType object_type, Workers* workers, GCancellable* cancellable);
GType photo_monitor_get_type (void) G_GNUC_CONST;
static gboolean library_photo_source_collection_real_holds_type_of_source (SourceCollection* base, DataSource* source);
static gchar* library_photo_source_collection_real_get_typename (MediaSourceCollection* base);
static gboolean library_photo_source_collection_real_is_file_recognized (MediaSourceCollection* base, GFile* file);
static void library_photo_source_collection_real_notify_contents_altered (DataCollection* base, GeeIterable* added, GeeIterable* removed);
static void library_photo_source_collection_on_editable_replaced (LibraryPhotoSourceCollection* self, Photo* photo, GFile* old_file, GFile* new_file);
static void _library_photo_source_collection_on_editable_replaced_photo_editable_replaced (Photo* _sender, GFile* old_file, GFile* new_file, gpointer self);
void data_collection_notify_contents_altered (DataCollection* self, GeeIterable* added, GeeIterable* removed);
static void library_photo_source_collection_real_items_altered (DataCollection* base, GeeMap* items);
gboolean alteration_has_detail (Alteration* self, const gchar* subject, const gchar* detail);
static void library_photo_source_collection_real_postprocess_imported_media (MediaSourceCollection* base, GeeCollection* media_sources);
GType tag_get_type (void) G_GNUC_CONST;
GeeCollection* library_photo_get_import_keywords (LibraryPhoto* self);
gchar* tag_prep_tag_name (const gchar* name);
Tag* tag_for_name (const gchar* name);
void library_photo_clear_import_keywords (LibraryPhoto* self);
void tag_attach_many (Tag* self, GeeCollection* sources);
void media_source_collection_postprocess_imported_media (MediaSourceCollection* self, GeeCollection* media);
void library_photo_source_collection_notify_master_reimported (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
static void library_photo_source_collection_real_notify_master_reimported (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
void library_photo_source_collection_notify_editable_reimported (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
static void library_photo_source_collection_real_notify_editable_reimported (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
void library_photo_source_collection_notify_source_reimported (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
static void library_photo_source_collection_real_notify_source_reimported (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
void library_photo_source_collection_notify_baseline_reimported (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
static void library_photo_source_collection_real_notify_baseline_reimported (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
static MediaSource* library_photo_source_collection_real_fetch_by_numeric_id (MediaSourceCollection* base, gint64 numeric_id);
LibraryPhoto* library_photo_source_collection_fetch (LibraryPhotoSourceCollection* self, PhotoID* photo_id);
gboolean media_source_is_trashed (MediaSource* self);
gboolean media_source_is_offline (MediaSource* self);
static MediaSource* library_photo_source_collection_real_fetch_by_source_id (MediaSourceCollection* base, const gchar* source_id);
MediaSource* media_source_collection_fetch_by_numeric_id (MediaSourceCollection* self, gint64 numeric_id);
gint64 parse_int64 (const gchar* str, gint num_base);
static GeeCollection* library_photo_source_collection_real_get_event_source_ids (MediaSourceCollection* base, EventID* event_id);
GeeArrayList* photo_table_get_event_source_ids (PhotoTable* self, EventID* event_id);
DataSource* database_source_collection_fetch_by_key (DatabaseSourceCollection* self, gint64 key);
LibraryPhoto* library_photo_source_collection_fetch_by_editable_file (LibraryPhotoSourceCollection* self, GFile* file);
static void library_photo_source_collection_compare_backing (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, GFileInfo* info, GeeCollection* matches_master, GeeCollection* matches_editable);
gboolean backing_photo_state_matches_file_info (BackingPhotoState *self, GFileInfo* info);
void library_photo_source_collection_fetch_by_matching_backing (LibraryPhotoSourceCollection* self, GFileInfo* info, GeeCollection* matches_master, GeeCollection* matches_editable);
GeeCollection* media_source_collection_get_offline_bin_contents (MediaSourceCollection* self);
gboolean library_photo_source_collection_has_basename_filesize_duplicate (LibraryPhotoSourceCollection* self, const gchar* basename, gint64 filesize);
gint utf8_ci_compare (void* a, void* b);
LibraryPhoto* library_photo_source_collection_get_trashed_by_file (LibraryPhotoSourceCollection* self, GFile* file);
MediaSource* media_source_holding_tank_fetch_by_master_file (MediaSourceHoldingTank* self, GFile* file);
LibraryPhoto* library_photo_source_collection_get_trashed_by_md5 (LibraryPhotoSourceCollection* self, const gchar* md5);
MediaSource* media_source_holding_tank_fetch_by_md5 (MediaSourceHoldingTank* self, const gchar* md5);
LibraryPhoto* library_photo_source_collection_get_offline_by_file (LibraryPhotoSourceCollection* self, GFile* file);
LibraryPhoto* library_photo_source_collection_get_offline_by_md5 (LibraryPhotoSourceCollection* self, const gchar* md5);
gint library_photo_source_collection_get_offline_count (LibraryPhotoSourceCollection* self);
gint source_holding_tank_get_count (SourceHoldingTank* self);
LibraryPhoto* library_photo_source_collection_get_state_by_file (LibraryPhotoSourceCollection* self, GFile* file, LibraryPhotoSourceCollectionState* state);
MediaSource* media_source_collection_fetch_by_master_file (MediaSourceCollection* self, GFile* file);
static gboolean library_photo_source_collection_real_has_backlink (SourceCollection* base, SourceBacklink* backlink);
gboolean source_collection_has_backlink (SourceCollection* self, SourceBacklink* backlink);
gboolean source_holding_tank_has_backlink (SourceHoldingTank* self, SourceBacklink* backlink);
static void library_photo_source_collection_real_remove_backlink (SourceCollection* base, SourceBacklink* backlink);
void source_holding_tank_remove_backlink (SourceHoldingTank* self, SourceBacklink* backlink);
void source_collection_remove_backlink (SourceCollection* self, SourceBacklink* backlink);
MediaSourceTransactionController* media_source_transaction_controller_new (MediaSourceCollection* sources);
MediaSourceTransactionController* media_source_transaction_controller_construct (GType object_type, MediaSourceCollection* sources);
GType media_source_transaction_controller_get_type (void) G_GNUC_CONST;
static void library_photo_source_collection_real_master_reimported (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
static void g_cclosure_user_marshal_VOID__OBJECT_MEDIA_METADATA (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);
static void library_photo_source_collection_real_editable_reimported (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
static void library_photo_source_collection_real_baseline_reimported (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
static void library_photo_source_collection_real_source_reimported (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata);
static void library_photo_source_collection_finalize (DataCollection* obj);
GType flaggable_get_type (void) G_GNUC_CONST;
GType monitorable_get_type (void) G_GNUC_CONST;
#define LIBRARY_PHOTO_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_LIBRARY_PHOTO, LibraryPhotoPrivate))
enum  {
	LIBRARY_PHOTO_DUMMY_PROPERTY
};
GType mimic_manager_get_type (void) G_GNUC_CONST;
#define LIBRARY_PHOTO_FLAG_HIDDEN ((guint64) 0x0000000000000001)
#define LIBRARY_PHOTO_FLAG_FAVORITE ((guint64) 0x0000000000000002)
#define LIBRARY_PHOTO_FLAG_TRASH ((guint64) 0x0000000000000004)
#define LIBRARY_PHOTO_FLAG_OFFLINE ((guint64) 0x0000000000000008)
#define LIBRARY_PHOTO_FLAG_FLAGGED ((guint64) 0x0000000000000010)
static LibraryPhoto* library_photo_new (PhotoRow* row, GeeCollection* import_keywords);
static LibraryPhoto* library_photo_construct (GType object_type, PhotoRow* row, GeeCollection* import_keywords);
static void library_photo_generate_thumbnails (LibraryPhoto* self);
static void _library_photo_generate_thumbnails_one_shot_callback (gpointer self);
void data_source_rehydrate_backlinks (DataSource* self, SourceCollection* unlinked_from, const gchar* dehydrated);
static void library_photo_upgrade_rating_flags (LibraryPhoto* self, guint64 flags);
void library_photo_init (ProgressMonitor monitor, void* monitor_target);
GFile* app_dirs_get_data_subdir (const gchar* name, const gchar* subname);
MimicManager* mimic_manager_new (SourceCollection* sources, GFile* impersonators_dir);
MimicManager* mimic_manager_construct (GType object_type, SourceCollection* sources, GFile* impersonators_dir);
GeeArrayList* photo_table_get_all (PhotoTable* self);
GeeCollection* data_collection_add_many (DataCollection* self, GeeCollection* objects, ProgressMonitor monitor, void* monitor_target);
void media_source_collection_add_many_to_trash (MediaSourceCollection* self, GeeCollection* sources);
void media_source_collection_add_many_to_offline (MediaSourceCollection* self, GeeCollection* sources);
void library_photo_terminate (void);
ImportResult library_photo_import_create (PhotoImportParams* params, LibraryPhoto** photo);
void photo_table_add (PhotoTable* self, PhotoRow* photo_row, PhotoID* result);
gboolean photo_id_is_invalid (PhotoID *self);
void library_photo_import_failed (LibraryPhoto* photo);
void photo_table_remove (PhotoTable* self, PhotoID* photo_id, GError** error);
static void library_photo_real_notify_master_reimported (Photo* base, PhotoMetadata* metadata);
static void library_photo_real_notify_editable_reimported (Photo* base, PhotoMetadata* metadata);
static void library_photo_real_notify_source_reimported (Photo* base, PhotoMetadata* metadata);
static void library_photo_real_notify_baseline_reimported (Photo* base, PhotoMetadata* metadata);
void thumbnail_cache_import_from_source (ThumbnailSource* source, gboolean force, GError** error);
void thumbnail_source_notify_thumbnail_altered (ThumbnailSource* self);
static void library_photo_real_notify_altered (DataObject* base, Alteration* alteration);
gboolean alteration_has_subject (Alteration* self, const gchar* subject);
void one_shot_scheduler_at_priority_idle (OneShotScheduler* self, gint priority);
static GdkPixbuf* library_photo_real_get_preview_pixbuf (MediaSource* base, Scaling* scaling, GError** error);
GdkPixbuf* thumbnail_source_get_thumbnail (ThumbnailSource* self, gint scale, GError** error);
GType thumbnail_cache_size_get_type (void) G_GNUC_CONST;
GdkPixbuf* scaling_perform_on_pixbuf (Scaling *self, GdkPixbuf* pixbuf, GdkInterpType interp, gboolean scale_up);
static void library_photo_real_rotate (Photo* base, Rotation rotation);
void thumbnail_cache_rotate (ThumbnailSource* source, Rotation rotation, GError** error);
static GdkPixbuf* library_photo_real_get_thumbnail (ThumbnailSource* base, gint scale, GError** error);
GdkPixbuf* thumbnail_cache_fetch (ThumbnailSource* source, gint scale, GError** error);
LibraryPhoto* library_photo_duplicate (LibraryPhoto* self, GError** error);
GFile* library_files_duplicate (GFile* src, GFileProgressCallback progress_callback, void* progress_callback_target, gboolean blacklist, GError** error);
static void library_photo_on_duplicate_progress (LibraryPhoto* self, gint64 current, gint64 total);
static void _library_photo_on_duplicate_progress_gfile_progress_callback (gint64 current_num_bytes, gint64 total_num_bytes, gpointer self);
void photo_table_duplicate (PhotoTable* self, PhotoID* photo_id, const gchar* new_filename, BackingPhotoID* editable_id, PhotoID* result);
PhotoRow* photo_table_get_row (PhotoTable* self, PhotoID* photo_id);
void thumbnail_cache_duplicate (ThumbnailSource* src_source, ThumbnailSource* dest_source);
gboolean data_collection_add (DataCollection* self, DataObject* object);
GType event_source_get_type (void) G_GNUC_CONST;
GType event_get_type (void) G_GNUC_CONST;
Event* media_source_get_event (MediaSource* self);
void event_attach (Event* self, MediaSource* source);
GType container_source_collection_get_type (void) G_GNUC_CONST;
GType tag_source_collection_get_type (void) G_GNUC_CONST;
GeeList* tag_source_collection_fetch_for_source (TagSourceCollection* self, MediaSource* source);
void tag_attach (Tag* self, MediaSource* source);
gboolean spin_event_loop (gint max);
static gboolean library_photo_real_is_trashed (MediaSource* base);
static void library_photo_real_trash (MediaSource* base);
static void library_photo_real_untrash (MediaSource* base);
static gboolean library_photo_real_is_offline (Monitorable* base);
static void library_photo_real_mark_offline (Monitorable* base);
static void library_photo_real_mark_online (Monitorable* base);
static gboolean library_photo_real_is_flagged (Flaggable* base);
static void library_photo_real_mark_flagged (Flaggable* base);
static void library_photo_real_mark_unflagged (Flaggable* base);
static gboolean library_photo_real_internal_delete_backing (DataSource* base, GError** error);
gboolean media_source_delete_original_file (MediaSource* self);
static void library_photo_real_destroy (DataSource* base);
void thumbnail_cache_remove (ThumbnailSource* source);
void data_source_destroy (DataSource* self);
gboolean library_photo_has_nontrash_duplicate (GFile* file, const gchar* thumbnail_md5, const gchar* full_md5, PhotoFileFormat file_format);
static gboolean library_photo_real_has_user_generated_metadata (Photo* base);
Rating media_source_get_rating (MediaSource* self);
gchar* data_object_get_name (DataObject* self);
static void library_photo_real_set_user_metadata_for_export (Photo* base, PhotoMetadata* metadata);
void photo_metadata_set_keywords (PhotoMetadata* self, GeeCollection* keywords, PhotoMetadataSetOption option);
void photo_metadata_set_rating (PhotoMetadata* self, Rating rating);
static void library_photo_real_apply_user_metadata_for_reimport (Photo* base, PhotoMetadata* metadata);
static void library_photo_finalize (GObject* obj);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);

static const gchar* PHOTO_IMAGE_EXTENSIONS[69] = {"jpg", "jpeg", "jpe", "tiff", "tif", "png", "gif", "bmp", "ppm", "pgm", "pbm", "pnm", "thm", "tga", "ilbm", "pcx", "ecw", "img", "sid", "cd5", "fits", "pgf", "cgm", "svg", "odg", "eps", "pdf", "swf", "wmf", "emf", "xps", "pns", "jps", "mpo", "3fr", "arw", "srf", "sr2", "bay", "crw", "cr2", "cap", "iiq", "eip", "dcs", "dcr", "drf", "k25", "kdc", "dng", "erf", "fff", "mef", "mos", "mrw", "nef", "nrw", "orf", "ptx", "pef", "pxn", "r3d", "raf", "raw", "rw2", "rwl", "rwz", "x3f", "srw"};

GType backing_fetch_mode_get_type (void) {
	static volatile gsize backing_fetch_mode_type_id__volatile = 0;
	if (g_once_init_enter (&backing_fetch_mode_type_id__volatile)) {
		static const GEnumValue values[] = {{BACKING_FETCH_MODE_SOURCE, "BACKING_FETCH_MODE_SOURCE", "source"}, {BACKING_FETCH_MODE_BASELINE, "BACKING_FETCH_MODE_BASELINE", "baseline"}, {BACKING_FETCH_MODE_MASTER, "BACKING_FETCH_MODE_MASTER", "master"}, {0, NULL, NULL}};
		GType backing_fetch_mode_type_id;
		backing_fetch_mode_type_id = g_enum_register_static ("BackingFetchMode", values);
		g_once_init_leave (&backing_fetch_mode_type_id__volatile, backing_fetch_mode_type_id);
	}
	return backing_fetch_mode_type_id__volatile;
}


static gpointer _g_object_ref0 (gpointer self) {
#line 38 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return self ? g_object_ref (self) : NULL;
#line 2436 "Photo.c"
}


static gpointer _thumbnails_ref0 (gpointer self) {
#line 44 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return self ? thumbnails_ref (self) : NULL;
#line 2443 "Photo.c"
}


PhotoImportParams* photo_import_params_construct (GType object_type, GFile* file, ImportID* import_id, PhotoFileSnifferOptions sniffer_options, const gchar* exif_md5, const gchar* thumbnail_md5, const gchar* full_md5, Thumbnails* thumbnails) {
	PhotoImportParams* self = NULL;
	GFile* _tmp0_;
	GFile* _tmp1_;
	ImportID _tmp2_;
	PhotoFileSnifferOptions _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	const gchar* _tmp8_;
	gchar* _tmp9_;
	Thumbnails* _tmp10_;
	Thumbnails* _tmp11_;
#line 36 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail (G_IS_FILE (file), NULL);
#line 36 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail (import_id != NULL, NULL);
#line 36 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail ((thumbnails == NULL) || IS_THUMBNAILS (thumbnails), NULL);
#line 36 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	self = (PhotoImportParams*) g_type_create_instance (object_type);
#line 38 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp0_ = file;
#line 38 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 38 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_g_object_unref0 (self->file);
#line 38 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	self->file = _tmp1_;
#line 39 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp2_ = *import_id;
#line 39 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	self->import_id = _tmp2_;
#line 40 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp3_ = sniffer_options;
#line 40 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	self->sniffer_options = _tmp3_;
#line 41 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp4_ = exif_md5;
#line 41 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp5_ = g_strdup (_tmp4_);
#line 41 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_g_free0 (self->exif_md5);
#line 41 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	self->exif_md5 = _tmp5_;
#line 42 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp6_ = thumbnail_md5;
#line 42 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp7_ = g_strdup (_tmp6_);
#line 42 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_g_free0 (self->thumbnail_md5);
#line 42 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	self->thumbnail_md5 = _tmp7_;
#line 43 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp8_ = full_md5;
#line 43 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp9_ = g_strdup (_tmp8_);
#line 43 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_g_free0 (self->full_md5);
#line 43 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	self->full_md5 = _tmp9_;
#line 44 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp10_ = thumbnails;
#line 44 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp11_ = _thumbnails_ref0 (_tmp10_);
#line 44 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_thumbnails_unref0 (self->thumbnails);
#line 44 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	self->thumbnails = _tmp11_;
#line 36 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return self;
#line 2519 "Photo.c"
}


PhotoImportParams* photo_import_params_new (GFile* file, ImportID* import_id, PhotoFileSnifferOptions sniffer_options, const gchar* exif_md5, const gchar* thumbnail_md5, const gchar* full_md5, Thumbnails* thumbnails) {
#line 36 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return photo_import_params_construct (TYPE_PHOTO_IMPORT_PARAMS, file, import_id, sniffer_options, exif_md5, thumbnail_md5, full_md5, thumbnails);
#line 2526 "Photo.c"
}


PhotoImportParams* photo_import_params_construct_create_placeholder (GType object_type, GFile* file, ImportID* import_id) {
	PhotoImportParams* self = NULL;
	GFile* _tmp0_;
	GFile* _tmp1_;
	ImportID _tmp2_;
#line 48 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail (G_IS_FILE (file), NULL);
#line 48 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail (import_id != NULL, NULL);
#line 48 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	self = (PhotoImportParams*) g_type_create_instance (object_type);
#line 49 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp0_ = file;
#line 49 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 49 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_g_object_unref0 (self->file);
#line 49 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	self->file = _tmp1_;
#line 50 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp2_ = *import_id;
#line 50 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	self->import_id = _tmp2_;
#line 51 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	self->sniffer_options = PHOTO_FILE_SNIFFER_OPTIONS_NO_MD5;
#line 52 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_g_free0 (self->exif_md5);
#line 52 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	self->exif_md5 = NULL;
#line 53 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_g_free0 (self->thumbnail_md5);
#line 53 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	self->thumbnail_md5 = NULL;
#line 54 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_g_free0 (self->full_md5);
#line 54 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	self->full_md5 = NULL;
#line 55 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_thumbnails_unref0 (self->thumbnails);
#line 55 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	self->thumbnails = NULL;
#line 48 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return self;
#line 2573 "Photo.c"
}


PhotoImportParams* photo_import_params_new_create_placeholder (GFile* file, ImportID* import_id) {
#line 48 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return photo_import_params_construct_create_placeholder (TYPE_PHOTO_IMPORT_PARAMS, file, import_id);
#line 2580 "Photo.c"
}


static void value_photo_import_params_init (GValue* value) {
#line 20 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	value->data[0].v_pointer = NULL;
#line 2587 "Photo.c"
}


static void value_photo_import_params_free_value (GValue* value) {
#line 20 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (value->data[0].v_pointer) {
#line 20 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		photo_import_params_unref (value->data[0].v_pointer);
#line 2596 "Photo.c"
	}
}


static void value_photo_import_params_copy_value (const GValue* src_value, GValue* dest_value) {
#line 20 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (src_value->data[0].v_pointer) {
#line 20 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		dest_value->data[0].v_pointer = photo_import_params_ref (src_value->data[0].v_pointer);
#line 2606 "Photo.c"
	} else {
#line 20 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		dest_value->data[0].v_pointer = NULL;
#line 2610 "Photo.c"
	}
}


static gpointer value_photo_import_params_peek_pointer (const GValue* value) {
#line 20 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return value->data[0].v_pointer;
#line 2618 "Photo.c"
}


static gchar* value_photo_import_params_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
#line 20 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (collect_values[0].v_pointer) {
#line 2625 "Photo.c"
		PhotoImportParams* object;
		object = collect_values[0].v_pointer;
#line 20 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		if (object->parent_instance.g_class == NULL) {
#line 20 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 2632 "Photo.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 20 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 2636 "Photo.c"
		}
#line 20 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		value->data[0].v_pointer = photo_import_params_ref (object);
#line 2640 "Photo.c"
	} else {
#line 20 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 2644 "Photo.c"
	}
#line 20 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return NULL;
#line 2648 "Photo.c"
}


static gchar* value_photo_import_params_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	PhotoImportParams** object_p;
	object_p = collect_values[0].v_pointer;
#line 20 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (!object_p) {
#line 20 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 2659 "Photo.c"
	}
#line 20 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (!value->data[0].v_pointer) {
#line 20 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		*object_p = NULL;
#line 2665 "Photo.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 20 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		*object_p = value->data[0].v_pointer;
#line 2669 "Photo.c"
	} else {
#line 20 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		*object_p = photo_import_params_ref (value->data[0].v_pointer);
#line 2673 "Photo.c"
	}
#line 20 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return NULL;
#line 2677 "Photo.c"
}


GParamSpec* param_spec_photo_import_params (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	ParamSpecPhotoImportParams* spec;
#line 20 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_PHOTO_IMPORT_PARAMS), NULL);
#line 20 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 20 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 20 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return G_PARAM_SPEC (spec);
#line 2691 "Photo.c"
}


gpointer value_get_photo_import_params (const GValue* value) {
#line 20 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_PHOTO_IMPORT_PARAMS), NULL);
#line 20 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return value->data[0].v_pointer;
#line 2700 "Photo.c"
}


void value_set_photo_import_params (GValue* value, gpointer v_object) {
	PhotoImportParams* old;
#line 20 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_PHOTO_IMPORT_PARAMS));
#line 20 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	old = value->data[0].v_pointer;
#line 20 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (v_object) {
#line 20 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_PHOTO_IMPORT_PARAMS));
#line 20 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 20 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		value->data[0].v_pointer = v_object;
#line 20 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		photo_import_params_ref (value->data[0].v_pointer);
#line 2720 "Photo.c"
	} else {
#line 20 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 2724 "Photo.c"
	}
#line 20 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (old) {
#line 20 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		photo_import_params_unref (old);
#line 2730 "Photo.c"
	}
}


void value_take_photo_import_params (GValue* value, gpointer v_object) {
	PhotoImportParams* old;
#line 20 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_PHOTO_IMPORT_PARAMS));
#line 20 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	old = value->data[0].v_pointer;
#line 20 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (v_object) {
#line 20 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_PHOTO_IMPORT_PARAMS));
#line 20 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 20 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		value->data[0].v_pointer = v_object;
#line 2749 "Photo.c"
	} else {
#line 20 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 2753 "Photo.c"
	}
#line 20 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (old) {
#line 20 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		photo_import_params_unref (old);
#line 2759 "Photo.c"
	}
}


static void photo_import_params_class_init (PhotoImportParamsClass * klass) {
#line 20 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	photo_import_params_parent_class = g_type_class_peek_parent (klass);
#line 20 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	PHOTO_IMPORT_PARAMS_CLASS (klass)->finalize = photo_import_params_finalize;
#line 2769 "Photo.c"
}


static void photo_import_params_instance_init (PhotoImportParams * self) {
	PhotoRow _tmp0_ = {0};
#line 33 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	photo_row_init (&_tmp0_);
#line 33 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	self->row = _tmp0_;
#line 34 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	self->keywords = NULL;
#line 20 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	self->ref_count = 1;
#line 2783 "Photo.c"
}


static void photo_import_params_finalize (PhotoImportParams* obj) {
	PhotoImportParams * self;
#line 20 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	self = PHOTO_IMPORT_PARAMS (obj);
#line 22 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_g_object_unref0 (self->file);
#line 25 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_g_free0 (self->exif_md5);
#line 26 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_g_free0 (self->thumbnail_md5);
#line 27 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_g_free0 (self->full_md5);
#line 30 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_thumbnails_unref0 (self->thumbnails);
#line 33 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	photo_row_destroy (&self->row);
#line 34 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_g_object_unref0 (self->keywords);
#line 2805 "Photo.c"
}


GType photo_import_params_get_type (void) {
	static volatile gsize photo_import_params_type_id__volatile = 0;
	if (g_once_init_enter (&photo_import_params_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_photo_import_params_init, value_photo_import_params_free_value, value_photo_import_params_copy_value, value_photo_import_params_peek_pointer, "p", value_photo_import_params_collect_value, "p", value_photo_import_params_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (PhotoImportParamsClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_import_params_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoImportParams), 0, (GInstanceInitFunc) photo_import_params_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType photo_import_params_type_id;
		photo_import_params_type_id = g_type_register_fundamental (g_type_fundamental_next (), "PhotoImportParams", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&photo_import_params_type_id__volatile, photo_import_params_type_id);
	}
	return photo_import_params_type_id__volatile;
}


gpointer photo_import_params_ref (gpointer instance) {
	PhotoImportParams* self;
	self = instance;
#line 20 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_atomic_int_inc (&self->ref_count);
#line 20 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return instance;
#line 2830 "Photo.c"
}


void photo_import_params_unref (gpointer instance) {
	PhotoImportParams* self;
	self = instance;
#line 20 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 20 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		PHOTO_IMPORT_PARAMS_GET_CLASS (self)->finalize (self);
#line 20 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 2843 "Photo.c"
	}
}


PhotoTransformationState* photo_transformation_state_construct (GType object_type) {
	PhotoTransformationState * self = NULL;
#line 68 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	self = (PhotoTransformationState*) g_object_new (object_type, NULL);
#line 68 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return self;
#line 2854 "Photo.c"
}


gboolean photo_transformation_state_is_broken (PhotoTransformationState* self) {
	gboolean result = FALSE;
	gboolean _tmp0_;
#line 71 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO_TRANSFORMATION_STATE (self), FALSE);
#line 72 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp0_ = self->priv->is_broke;
#line 72 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	result = _tmp0_;
#line 72 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return result;
#line 2869 "Photo.c"
}


static void photo_transformation_state_real_broken (PhotoTransformationState* self) {
#line 65 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	self->priv->is_broke = TRUE;
#line 2876 "Photo.c"
}


static void photo_transformation_state_class_init (PhotoTransformationStateClass * klass) {
#line 59 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	photo_transformation_state_parent_class = g_type_class_peek_parent (klass);
#line 59 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_type_class_add_private (klass, sizeof (PhotoTransformationStatePrivate));
#line 59 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	PHOTO_TRANSFORMATION_STATE_CLASS (klass)->broken = photo_transformation_state_real_broken;
#line 59 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	G_OBJECT_CLASS (klass)->finalize = photo_transformation_state_finalize;
#line 59 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_signal_new ("broken", TYPE_PHOTO_TRANSFORMATION_STATE, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (PhotoTransformationStateClass, broken), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 2891 "Photo.c"
}


static void photo_transformation_state_instance_init (PhotoTransformationState * self) {
#line 59 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	self->priv = PHOTO_TRANSFORMATION_STATE_GET_PRIVATE (self);
#line 60 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	self->priv->is_broke = FALSE;
#line 2900 "Photo.c"
}


static void photo_transformation_state_finalize (GObject* obj) {
	PhotoTransformationState * self;
#line 59 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	self = PHOTO_TRANSFORMATION_STATE (obj);
#line 59 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	G_OBJECT_CLASS (photo_transformation_state_parent_class)->finalize (obj);
#line 2910 "Photo.c"
}


GType photo_transformation_state_get_type (void) {
	static volatile gsize photo_transformation_state_type_id__volatile = 0;
	if (g_once_init_enter (&photo_transformation_state_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PhotoTransformationStateClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_transformation_state_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoTransformationState), 0, (GInstanceInitFunc) photo_transformation_state_instance_init, NULL };
		GType photo_transformation_state_type_id;
		photo_transformation_state_type_id = g_type_register_static (G_TYPE_OBJECT, "PhotoTransformationState", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&photo_transformation_state_type_id__volatile, photo_transformation_state_type_id);
	}
	return photo_transformation_state_type_id__volatile;
}


gboolean rating_can_increase (Rating self) {
	gboolean result = FALSE;
#line 86 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	result = self < RATING_FIVE;
#line 86 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return result;
#line 2932 "Photo.c"
}


gboolean rating_can_decrease (Rating self) {
	gboolean result = FALSE;
#line 90 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	result = self > RATING_REJECTED;
#line 90 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return result;
#line 2942 "Photo.c"
}


gboolean rating_is_valid (Rating self) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
#line 94 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (self >= RATING_REJECTED) {
#line 94 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp0_ = self <= RATING_FIVE;
#line 2954 "Photo.c"
	} else {
#line 94 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp0_ = FALSE;
#line 2958 "Photo.c"
	}
#line 94 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 94 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	result = _tmp1_;
#line 94 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return result;
#line 2966 "Photo.c"
}


Rating rating_increase (Rating self) {
	Rating result = 0;
	Rating _tmp0_ = 0;
	gboolean _tmp1_ = FALSE;
	Rating _tmp2_;
#line 98 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp1_ = rating_can_increase (self);
#line 98 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp1_) {
#line 98 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp0_ = self + 1;
#line 2981 "Photo.c"
	} else {
#line 98 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp0_ = self;
#line 2985 "Photo.c"
	}
#line 98 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp2_ = _tmp0_;
#line 98 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	result = _tmp2_;
#line 98 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return result;
#line 2993 "Photo.c"
}


Rating rating_decrease (Rating self) {
	Rating result = 0;
	Rating _tmp0_ = 0;
	gboolean _tmp1_ = FALSE;
	Rating _tmp2_;
#line 102 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp1_ = rating_can_decrease (self);
#line 102 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp1_) {
#line 102 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp0_ = self - 1;
#line 3008 "Photo.c"
	} else {
#line 102 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp0_ = self;
#line 3012 "Photo.c"
	}
#line 102 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp2_ = _tmp0_;
#line 102 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	result = _tmp2_;
#line 102 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return result;
#line 3020 "Photo.c"
}


gint rating_serialize (Rating self) {
	gint result = 0;
#line 106 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	switch (self) {
#line 106 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		case RATING_REJECTED:
#line 3030 "Photo.c"
		{
#line 108 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			result = -1;
#line 108 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			return result;
#line 3036 "Photo.c"
		}
#line 106 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		case RATING_UNRATED:
#line 3040 "Photo.c"
		{
#line 110 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			result = 0;
#line 110 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			return result;
#line 3046 "Photo.c"
		}
#line 106 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		case RATING_ONE:
#line 3050 "Photo.c"
		{
#line 112 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			result = 1;
#line 112 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			return result;
#line 3056 "Photo.c"
		}
#line 106 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		case RATING_TWO:
#line 3060 "Photo.c"
		{
#line 114 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			result = 2;
#line 114 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			return result;
#line 3066 "Photo.c"
		}
#line 106 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		case RATING_THREE:
#line 3070 "Photo.c"
		{
#line 116 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			result = 3;
#line 116 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			return result;
#line 3076 "Photo.c"
		}
#line 106 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		case RATING_FOUR:
#line 3080 "Photo.c"
		{
#line 118 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			result = 4;
#line 118 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			return result;
#line 3086 "Photo.c"
		}
#line 106 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		case RATING_FIVE:
#line 3090 "Photo.c"
		{
#line 120 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			result = 5;
#line 120 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			return result;
#line 3096 "Photo.c"
		}
		default:
		{
#line 122 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			result = 0;
#line 122 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			return result;
#line 3104 "Photo.c"
		}
	}
}


Rating rating_unserialize (gint value) {
	Rating result = 0;
	gint _tmp0_;
	gint _tmp2_;
#line 127 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp0_ = value;
#line 127 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp0_ > ((gint) RATING_FIVE)) {
#line 128 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		result = RATING_FIVE;
#line 128 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return result;
#line 3122 "Photo.c"
	} else {
		gint _tmp1_;
#line 129 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp1_ = value;
#line 129 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		if (_tmp1_ < ((gint) RATING_REJECTED)) {
#line 130 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			result = RATING_REJECTED;
#line 130 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			return result;
#line 3133 "Photo.c"
		}
	}
#line 132 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp2_ = value;
#line 132 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	switch (_tmp2_) {
#line 132 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		case -1:
#line 3142 "Photo.c"
		{
#line 134 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			result = RATING_REJECTED;
#line 134 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			return result;
#line 3148 "Photo.c"
		}
#line 132 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		case 0:
#line 3152 "Photo.c"
		{
#line 136 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			result = RATING_UNRATED;
#line 136 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			return result;
#line 3158 "Photo.c"
		}
#line 132 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		case 1:
#line 3162 "Photo.c"
		{
#line 138 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			result = RATING_ONE;
#line 138 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			return result;
#line 3168 "Photo.c"
		}
#line 132 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		case 2:
#line 3172 "Photo.c"
		{
#line 140 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			result = RATING_TWO;
#line 140 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			return result;
#line 3178 "Photo.c"
		}
#line 132 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		case 3:
#line 3182 "Photo.c"
		{
#line 142 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			result = RATING_THREE;
#line 142 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			return result;
#line 3188 "Photo.c"
		}
#line 132 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		case 4:
#line 3192 "Photo.c"
		{
#line 144 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			result = RATING_FOUR;
#line 144 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			return result;
#line 3198 "Photo.c"
		}
#line 132 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		case 5:
#line 3202 "Photo.c"
		{
#line 146 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			result = RATING_FIVE;
#line 146 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			return result;
#line 3208 "Photo.c"
		}
		default:
		{
#line 148 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			result = RATING_UNRATED;
#line 148 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			return result;
#line 3216 "Photo.c"
		}
	}
}


GType rating_get_type (void) {
	static volatile gsize rating_type_id__volatile = 0;
	if (g_once_init_enter (&rating_type_id__volatile)) {
		static const GEnumValue values[] = {{RATING_REJECTED, "RATING_REJECTED", "rejected"}, {RATING_UNRATED, "RATING_UNRATED", "unrated"}, {RATING_ONE, "RATING_ONE", "one"}, {RATING_TWO, "RATING_TWO", "two"}, {RATING_THREE, "RATING_THREE", "three"}, {RATING_FOUR, "RATING_FOUR", "four"}, {RATING_FIVE, "RATING_FIVE", "five"}, {0, NULL, NULL}};
		GType rating_type_id;
		rating_type_id = g_enum_register_static ("Rating", values);
		g_once_init_leave (&rating_type_id__volatile, rating_type_id);
	}
	return rating_type_id__volatile;
}


gboolean photo_exception_prohibits (PhotoException self, PhotoException exception) {
	gboolean result = FALSE;
	PhotoException _tmp0_;
#line 205 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp0_ = exception;
#line 205 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	result = (self & _tmp0_) != 0;
#line 205 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return result;
#line 3243 "Photo.c"
}


gboolean photo_exception_allows (PhotoException self, PhotoException exception) {
	gboolean result = FALSE;
	PhotoException _tmp0_;
#line 209 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp0_ = exception;
#line 209 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	result = (self & _tmp0_) == 0;
#line 209 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return result;
#line 3256 "Photo.c"
}


GType photo_exception_get_type (void) {
	static volatile gsize photo_exception_type_id__volatile = 0;
	if (g_once_init_enter (&photo_exception_type_id__volatile)) {
		static const GEnumValue values[] = {{PHOTO_EXCEPTION_NONE, "PHOTO_EXCEPTION_NONE", "none"}, {PHOTO_EXCEPTION_ORIENTATION, "PHOTO_EXCEPTION_ORIENTATION", "orientation"}, {PHOTO_EXCEPTION_CROP, "PHOTO_EXCEPTION_CROP", "crop"}, {PHOTO_EXCEPTION_REDEYE, "PHOTO_EXCEPTION_REDEYE", "redeye"}, {PHOTO_EXCEPTION_ADJUST, "PHOTO_EXCEPTION_ADJUST", "adjust"}, {PHOTO_EXCEPTION_ALL, "PHOTO_EXCEPTION_ALL", "all"}, {0, NULL, NULL}};
		GType photo_exception_type_id;
		photo_exception_type_id = g_enum_register_static ("PhotoException", values);
		g_once_init_leave (&photo_exception_type_id__volatile, photo_exception_type_id);
	}
	return photo_exception_type_id__volatile;
}


Photo* photo_construct (GType object_type, PhotoRow* row) {
	Photo * self = NULL;
	PhotoRow _tmp0_;
	PhotoRow _tmp1_ = {0};
	PhotoRow _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_ = NULL;
	PhotoRow _tmp5_;
	BackingPhotoState _tmp6_;
	PhotoFileFormat _tmp7_;
	PhotoRow _tmp8_;
	BackingPhotoState _tmp9_;
	const gchar* _tmp10_;
	PhotoFileReader* _tmp11_ = NULL;
	PhotoRow _tmp12_;
	BackingPhotoState _tmp13_;
	const gchar* _tmp14_;
	gchar* _tmp15_ = NULL;
	gchar* basename;
	const gchar* _tmp16_;
	const gchar* _tmp19_;
	gboolean _tmp20_ = FALSE;
	PhotoRow _tmp25_;
	BackingPhotoID _tmp26_;
	gint64 _tmp27_;
	BackingPhotoState* _tmp54_ = NULL;
	PhotoBackingReaders _tmp55_;
	PhotoFileReader* _tmp56_;
	BackingPhotoState* _tmp57_;
	GError * _inner_error_ = NULL;
#line 334 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail (row != NULL, NULL);
#line 334 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	self = (Photo*) photo_source_construct (object_type, DATA_OBJECT_INVALID_OBJECT_ID);
#line 335 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp0_ = *row;
#line 335 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	photo_row_copy (&_tmp0_, &_tmp1_);
#line 335 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	photo_row_destroy (&self->priv->row);
#line 335 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	self->priv->row = _tmp1_;
#line 338 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp2_ = self->priv->row;
#line 338 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp3_ = _tmp2_.title;
#line 338 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp4_ = media_source_prep_title (_tmp3_);
#line 338 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_g_free0 (self->priv->row.title);
#line 338 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	self->priv->row.title = _tmp4_;
#line 342 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp5_ = *row;
#line 342 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp6_ = _tmp5_.master;
#line 342 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp7_ = _tmp6_.file_format;
#line 342 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp8_ = *row;
#line 342 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp9_ = _tmp8_.master;
#line 342 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp10_ = _tmp9_.filepath;
#line 342 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp11_ = photo_file_format_create_reader (_tmp7_, _tmp10_);
#line 342 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_photo_file_adapter_unref0 (self->priv->readers.master);
#line 342 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	self->priv->readers.master = _tmp11_;
#line 345 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp12_ = *row;
#line 345 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp13_ = _tmp12_.master;
#line 345 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp14_ = _tmp13_.filepath;
#line 345 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp15_ = string_sliced_at_last_char (_tmp14_, (gunichar) G_DIR_SEPARATOR, 0);
#line 345 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	basename = _tmp15_;
#line 346 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp16_ = basename;
#line 346 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp16_ != NULL) {
#line 3356 "Photo.c"
		const gchar* _tmp17_;
		gchar* _tmp18_ = NULL;
#line 347 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp17_ = basename;
#line 347 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp18_ = string_sliced_at (_tmp17_, 1);
#line 347 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_free0 (self->priv->file_title);
#line 347 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		self->priv->file_title = _tmp18_;
#line 3367 "Photo.c"
	}
#line 349 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp19_ = self->priv->file_title;
#line 349 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp20_ = is_string_empty (_tmp19_);
#line 349 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp20_) {
#line 3375 "Photo.c"
		PhotoRow _tmp21_;
		BackingPhotoState _tmp22_;
		const gchar* _tmp23_;
		gchar* _tmp24_;
#line 350 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp21_ = *row;
#line 350 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp22_ = _tmp21_.master;
#line 350 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp23_ = _tmp22_.filepath;
#line 350 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp24_ = g_strdup (_tmp23_);
#line 350 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_free0 (self->priv->file_title);
#line 350 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		self->priv->file_title = _tmp24_;
#line 3392 "Photo.c"
	}
#line 352 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp25_ = *row;
#line 352 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp26_ = _tmp25_.editable_id;
#line 352 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp27_ = _tmp26_.id;
#line 352 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp27_ != BACKING_PHOTO_ID_INVALID) {
#line 3402 "Photo.c"
		BackingPhotoRow* editable_row;
		BackingPhotoRow* _tmp39_;
#line 353 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		editable_row = NULL;
#line 3407 "Photo.c"
		{
			BackingPhotoTable* _tmp28_ = NULL;
			BackingPhotoTable* _tmp29_;
			PhotoRow _tmp30_;
			BackingPhotoID _tmp31_;
			BackingPhotoRow* _tmp32_ = NULL;
			BackingPhotoRow* _tmp33_;
			BackingPhotoRow* _tmp34_;
#line 355 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp28_ = backing_photo_table_get_instance ();
#line 355 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp29_ = _tmp28_;
#line 355 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp30_ = *row;
#line 355 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp31_ = _tmp30_.editable_id;
#line 355 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp32_ = backing_photo_table_fetch (_tmp29_, &_tmp31_, &_inner_error_);
#line 355 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp33_ = _tmp32_;
#line 355 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_database_table_unref0 (_tmp29_);
#line 355 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp34_ = _tmp33_;
#line 355 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			if (_inner_error_ != NULL) {
#line 355 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				if (_inner_error_->domain == DATABASE_ERROR) {
#line 3436 "Photo.c"
					goto __catch109_database_error;
				}
#line 355 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_backing_photo_row_free0 (editable_row);
#line 355 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_g_free0 (basename);
#line 355 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 355 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				g_clear_error (&_inner_error_);
#line 355 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				return NULL;
#line 3449 "Photo.c"
			}
#line 355 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_backing_photo_row_free0 (editable_row);
#line 355 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			editable_row = _tmp34_;
#line 3455 "Photo.c"
		}
		goto __finally109;
		__catch109_database_error:
		{
			GError* err = NULL;
			gchar* _tmp35_ = NULL;
			gchar* _tmp36_;
			GError* _tmp37_;
			const gchar* _tmp38_;
#line 354 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			err = _inner_error_;
#line 354 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_inner_error_ = NULL;
#line 357 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp35_ = data_object_to_string (DATA_OBJECT (self));
#line 357 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp36_ = _tmp35_;
#line 357 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp37_ = err;
#line 357 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp38_ = _tmp37_->message;
#line 357 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_warning ("Photo.vala:357: Unable to fetch editable state for %s: %s", _tmp36_, _tmp38_);
#line 357 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_g_free0 (_tmp36_);
#line 354 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_g_error_free0 (err);
#line 3483 "Photo.c"
		}
		__finally109:
#line 354 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 354 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_backing_photo_row_free0 (editable_row);
#line 354 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_g_free0 (basename);
#line 354 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 354 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 354 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			return NULL;
#line 3498 "Photo.c"
		}
#line 360 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp39_ = editable_row;
#line 360 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		if (_tmp39_ != NULL) {
#line 3504 "Photo.c"
			BackingPhotoRow* _tmp40_;
			BackingPhotoState _tmp41_;
			BackingPhotoState _tmp42_ = {0};
			BackingPhotoState _tmp43_;
			PhotoFileFormat _tmp44_;
			BackingPhotoState _tmp45_;
			const gchar* _tmp46_;
			PhotoFileReader* _tmp47_ = NULL;
#line 361 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp40_ = editable_row;
#line 361 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp41_ = (*_tmp40_).state;
#line 361 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			backing_photo_state_copy (&_tmp41_, &_tmp42_);
#line 361 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			backing_photo_state_destroy (&self->priv->editable);
#line 361 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			self->priv->editable = _tmp42_;
#line 362 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp43_ = self->priv->editable;
#line 362 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp44_ = _tmp43_.file_format;
#line 362 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp45_ = self->priv->editable;
#line 362 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp46_ = _tmp45_.filepath;
#line 362 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp47_ = photo_file_format_create_reader (_tmp44_, _tmp46_);
#line 362 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_photo_file_adapter_unref0 (self->priv->readers.editable);
#line 362 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			self->priv->readers.editable = _tmp47_;
#line 3537 "Photo.c"
		} else {
			{
				BackingPhotoTable* _tmp48_ = NULL;
				BackingPhotoTable* _tmp49_;
				PhotoRow _tmp50_;
				BackingPhotoID _tmp51_;
#line 365 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp48_ = backing_photo_table_get_instance ();
#line 365 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp49_ = _tmp48_;
#line 365 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp50_ = *row;
#line 365 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp51_ = _tmp50_.editable_id;
#line 365 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				backing_photo_table_remove (_tmp49_, &_tmp51_, &_inner_error_);
#line 365 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_database_table_unref0 (_tmp49_);
#line 365 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				if (_inner_error_ != NULL) {
#line 365 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					if (_inner_error_->domain == DATABASE_ERROR) {
#line 3560 "Photo.c"
						goto __catch110_database_error;
					}
#line 365 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_backing_photo_row_free0 (editable_row);
#line 365 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_g_free0 (basename);
#line 365 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 365 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					g_clear_error (&_inner_error_);
#line 365 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					return NULL;
#line 3573 "Photo.c"
				}
			}
			goto __finally110;
			__catch110_database_error:
			{
				GError* err = NULL;
#line 364 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				err = _inner_error_;
#line 364 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_inner_error_ = NULL;
#line 364 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_g_error_free0 (err);
#line 3586 "Photo.c"
			}
			__finally110:
#line 364 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			if (_inner_error_ != NULL) {
#line 364 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_backing_photo_row_free0 (editable_row);
#line 364 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_g_free0 (basename);
#line 364 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 364 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				g_clear_error (&_inner_error_);
#line 364 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				return NULL;
#line 3601 "Photo.c"
			}
			{
				PhotoTable* _tmp52_ = NULL;
				PhotoTable* _tmp53_;
#line 371 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp52_ = photo_table_get_instance ();
#line 371 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp53_ = _tmp52_;
#line 371 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				photo_table_detach_editable (_tmp53_, &self->priv->row, &_inner_error_);
#line 371 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_database_table_unref0 (_tmp53_);
#line 371 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				if (_inner_error_ != NULL) {
#line 371 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					if (_inner_error_->domain == DATABASE_ERROR) {
#line 3618 "Photo.c"
						goto __catch111_database_error;
					}
#line 371 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_backing_photo_row_free0 (editable_row);
#line 371 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_g_free0 (basename);
#line 371 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 371 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					g_clear_error (&_inner_error_);
#line 371 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					return NULL;
#line 3631 "Photo.c"
				}
			}
			goto __finally111;
			__catch111_database_error:
			{
				GError* err = NULL;
#line 370 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				err = _inner_error_;
#line 370 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_inner_error_ = NULL;
#line 370 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_g_error_free0 (err);
#line 3644 "Photo.c"
			}
			__finally111:
#line 370 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			if (_inner_error_ != NULL) {
#line 370 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_backing_photo_row_free0 (editable_row);
#line 370 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_g_free0 (basename);
#line 370 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 370 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				g_clear_error (&_inner_error_);
#line 370 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				return NULL;
#line 3659 "Photo.c"
			}
#line 378 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			photo_internal_remove_all_transformations (self, FALSE);
#line 3663 "Photo.c"
		}
#line 352 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_backing_photo_row_free0 (editable_row);
#line 3667 "Photo.c"
	}
#line 383 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp55_ = self->priv->readers;
#line 383 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp56_ = _tmp55_.editable;
#line 383 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp56_ == NULL) {
#line 383 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp54_ = &self->priv->row.master;
#line 3677 "Photo.c"
	} else {
#line 383 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp54_ = &self->priv->editable;
#line 3681 "Photo.c"
	}
#line 383 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp57_ = _tmp54_;
#line 383 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	self->priv->backing_photo_state = _tmp57_;
#line 334 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_g_free0 (basename);
#line 334 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return self;
#line 3691 "Photo.c"
}


static void photo_real_notify_editable_replaced (Photo* self, GFile* old_file, GFile* new_file) {
	GFile* _tmp0_;
	GFile* _tmp1_;
#line 386 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail ((old_file == NULL) || G_IS_FILE (old_file));
#line 386 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail ((new_file == NULL) || G_IS_FILE (new_file));
#line 387 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp0_ = old_file;
#line 387 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp1_ = new_file;
#line 387 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_signal_emit_by_name (self, "editable-replaced", _tmp0_, _tmp1_);
#line 3708 "Photo.c"
}


void photo_notify_editable_replaced (Photo* self, GFile* old_file, GFile* new_file) {
#line 386 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 386 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	PHOTO_GET_CLASS (self)->notify_editable_replaced (self, old_file, new_file);
#line 3717 "Photo.c"
}


static void photo_real_notify_baseline_replaced (Photo* self) {
#line 391 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_signal_emit_by_name (self, "baseline-replaced");
#line 3724 "Photo.c"
}


void photo_notify_baseline_replaced (Photo* self) {
#line 390 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 390 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	PHOTO_GET_CLASS (self)->notify_baseline_replaced (self);
#line 3733 "Photo.c"
}


static void photo_real_notify_master_reimported (Photo* self, PhotoMetadata* metadata) {
	PhotoMetadata* _tmp0_;
#line 394 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
#line 395 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp0_ = metadata;
#line 395 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_signal_emit_by_name (self, "master-reimported", _tmp0_);
#line 3745 "Photo.c"
}


void photo_notify_master_reimported (Photo* self, PhotoMetadata* metadata) {
#line 394 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 394 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	PHOTO_GET_CLASS (self)->notify_master_reimported (self, metadata);
#line 3754 "Photo.c"
}


static void photo_real_notify_editable_reimported (Photo* self, PhotoMetadata* metadata) {
	PhotoMetadata* _tmp0_;
#line 398 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
#line 399 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp0_ = metadata;
#line 399 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_signal_emit_by_name (self, "editable-reimported", _tmp0_);
#line 3766 "Photo.c"
}


void photo_notify_editable_reimported (Photo* self, PhotoMetadata* metadata) {
#line 398 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 398 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	PHOTO_GET_CLASS (self)->notify_editable_reimported (self, metadata);
#line 3775 "Photo.c"
}


static void photo_real_notify_source_reimported (Photo* self, PhotoMetadata* metadata) {
	PhotoMetadata* _tmp0_;
#line 402 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
#line 403 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp0_ = metadata;
#line 403 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_signal_emit_by_name (self, "source-reimported", _tmp0_);
#line 3787 "Photo.c"
}


void photo_notify_source_reimported (Photo* self, PhotoMetadata* metadata) {
#line 402 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 402 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	PHOTO_GET_CLASS (self)->notify_source_reimported (self, metadata);
#line 3796 "Photo.c"
}


static void photo_real_notify_baseline_reimported (Photo* self, PhotoMetadata* metadata) {
	PhotoMetadata* _tmp0_;
#line 406 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
#line 407 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp0_ = metadata;
#line 407 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_signal_emit_by_name (self, "baseline-reimported", _tmp0_);
#line 3808 "Photo.c"
}


void photo_notify_baseline_reimported (Photo* self, PhotoMetadata* metadata) {
#line 406 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 406 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	PHOTO_GET_CLASS (self)->notify_baseline_reimported (self, metadata);
#line 3817 "Photo.c"
}


static gboolean photo_real_internal_delete_backing (DataSource* base, GError** error) {
	Photo * self;
	gboolean result = FALSE;
	gboolean ret;
	GFile* file;
	GFile* _tmp7_;
	gboolean _tmp18_ = FALSE;
	gboolean _tmp19_ = FALSE;
	gboolean _tmp20_;
	gboolean _tmp22_;
	GError * _inner_error_ = NULL;
#line 410 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	self = PHOTO (base);
#line 411 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	ret = TRUE;
#line 412 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	file = NULL;
#line 3838 "Photo.c"
	{
		PhotoBackingReaders _tmp0_;
#line 413 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 413 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_readers);
#line 3845 "Photo.c"
		{
			PhotoBackingReaders _tmp1_;
			PhotoFileReader* _tmp2_;
#line 414 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 414 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp2_ = _tmp1_.editable;
#line 414 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			if (_tmp2_ != NULL) {
#line 3855 "Photo.c"
				PhotoBackingReaders _tmp3_;
				PhotoFileReader* _tmp4_;
				GFile* _tmp5_ = NULL;
#line 415 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp3_ = self->priv->readers;
#line 415 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp4_ = _tmp3_.editable;
#line 415 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp5_ = photo_file_adapter_get_file (PHOTO_FILE_ADAPTER (_tmp4_));
#line 415 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_g_object_unref0 (file);
#line 415 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				file = _tmp5_;
#line 3869 "Photo.c"
			}
		}
		__finally112:
		{
			PhotoBackingReaders _tmp6_;
#line 413 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp6_ = self->priv->readers;
#line 413 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_readers);
#line 3879 "Photo.c"
		}
#line 413 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 413 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 413 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_g_object_unref0 (file);
#line 413 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			return FALSE;
#line 3889 "Photo.c"
		}
	}
#line 418 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	photo_detach_editable (self, TRUE, FALSE);
#line 420 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp7_ = file;
#line 420 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp7_ != NULL) {
#line 3898 "Photo.c"
		{
			GFile* _tmp8_;
			gboolean _tmp9_ = FALSE;
			gboolean _tmp10_;
#line 422 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp8_ = file;
#line 422 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp9_ = g_file_trash (_tmp8_, NULL, &_inner_error_);
#line 422 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp10_ = _tmp9_;
#line 422 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			if (_inner_error_ != NULL) {
#line 3911 "Photo.c"
				goto __catch113_g_error;
			}
#line 422 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			ret = _tmp10_;
#line 3916 "Photo.c"
		}
		goto __finally113;
		__catch113_g_error:
		{
			GError* err = NULL;
			GFile* _tmp11_;
			gchar* _tmp12_ = NULL;
			gchar* _tmp13_;
			gchar* _tmp14_ = NULL;
			gchar* _tmp15_;
			GError* _tmp16_;
			const gchar* _tmp17_;
#line 421 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			err = _inner_error_;
#line 421 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_inner_error_ = NULL;
#line 424 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			ret = FALSE;
#line 425 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp11_ = file;
#line 425 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp12_ = g_file_get_path (_tmp11_);
#line 425 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp13_ = _tmp12_;
#line 425 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp14_ = data_object_to_string (DATA_OBJECT (self));
#line 425 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp15_ = _tmp14_;
#line 425 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp16_ = err;
#line 425 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp17_ = _tmp16_->message;
#line 425 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_message ("Photo.vala:425: Unable to move editable %s for %s to trash: %s", _tmp13_, _tmp15_, _tmp17_);
#line 425 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_g_free0 (_tmp15_);
#line 425 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_g_free0 (_tmp13_);
#line 421 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_g_error_free0 (err);
#line 3957 "Photo.c"
		}
		__finally113:
#line 421 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 421 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 421 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_g_object_unref0 (file);
#line 421 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			return FALSE;
#line 3968 "Photo.c"
		}
	}
#line 431 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp19_ = DATA_SOURCE_CLASS (photo_parent_class)->internal_delete_backing (DATA_SOURCE (PHOTO_SOURCE (self)), &_inner_error_);
#line 431 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp20_ = _tmp19_;
#line 431 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 431 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 431 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_object_unref0 (file);
#line 431 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return FALSE;
#line 3983 "Photo.c"
	}
#line 431 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp20_) {
#line 3987 "Photo.c"
		gboolean _tmp21_;
#line 431 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp21_ = ret;
#line 431 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp18_ = _tmp21_;
#line 3993 "Photo.c"
	} else {
#line 431 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp18_ = FALSE;
#line 3997 "Photo.c"
	}
#line 431 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp22_ = _tmp18_;
#line 431 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	result = _tmp22_;
#line 431 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_g_object_unref0 (file);
#line 431 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return result;
#line 4007 "Photo.c"
}


gboolean photo_would_use_mimic (Photo* self) {
	gboolean result = FALSE;
	PhotoFileFormatFlags flags = 0;
	GError * _inner_error_ = NULL;
#line 435 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 4017 "Photo.c"
	{
		PhotoBackingReaders _tmp0_;
#line 437 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 437 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_readers);
#line 4024 "Photo.c"
		{
			PhotoBackingReaders _tmp1_;
			PhotoFileReader* _tmp2_;
			PhotoFileFormat _tmp3_ = 0;
			PhotoFileFormatProperties* _tmp4_ = NULL;
			PhotoFileFormatProperties* _tmp5_;
			PhotoFileFormatFlags _tmp6_ = 0;
#line 438 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 438 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp2_ = _tmp1_.master;
#line 438 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp3_ = photo_file_adapter_get_file_format (PHOTO_FILE_ADAPTER (_tmp2_));
#line 438 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp4_ = photo_file_format_get_properties (_tmp3_);
#line 438 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp5_ = _tmp4_;
#line 438 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp6_ = photo_file_format_properties_get_flags (_tmp5_);
#line 438 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			flags = _tmp6_;
#line 438 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_photo_file_format_properties_unref0 (_tmp5_);
#line 4048 "Photo.c"
		}
		__finally114:
		{
			PhotoBackingReaders _tmp7_;
#line 437 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp7_ = self->priv->readers;
#line 437 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_readers);
#line 4057 "Photo.c"
		}
#line 437 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 437 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 437 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 437 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			return FALSE;
#line 4067 "Photo.c"
		}
	}
#line 441 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	result = (flags & PHOTO_FILE_FORMAT_FLAGS_MIMIC_RECOMMENDED) != 0;
#line 441 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return result;
#line 4074 "Photo.c"
}


static void _vala_array_add203 (BackingFileState*** array, int* length, int* size, BackingFileState* value) {
#line 447 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if ((*length) == (*size)) {
#line 447 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 447 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		*array = g_renew (BackingFileState*, *array, (*size) + 1);
#line 4085 "Photo.c"
	}
#line 447 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	(*array)[(*length)++] = value;
#line 447 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	(*array)[*length] = NULL;
#line 4091 "Photo.c"
}


static void _vala_array_add204 (BackingFileState*** array, int* length, int* size, BackingFileState* value) {
#line 449 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if ((*length) == (*size)) {
#line 449 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 449 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		*array = g_renew (BackingFileState*, *array, (*size) + 1);
#line 4102 "Photo.c"
	}
#line 449 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	(*array)[(*length)++] = value;
#line 449 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	(*array)[*length] = NULL;
#line 4108 "Photo.c"
}


static BackingFileState** photo_real_get_backing_files_state (MediaSource* base, int* result_length1) {
	Photo * self;
	BackingFileState** result = NULL;
	BackingFileState** _tmp0_ = NULL;
	BackingFileState** backing;
	gint backing_length1;
	gint _backing_size_;
	BackingFileState** _tmp13_;
	gint _tmp13__length1;
	GError * _inner_error_ = NULL;
#line 444 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	self = PHOTO (base);
#line 445 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp0_ = g_new0 (BackingFileState*, 0 + 1);
#line 445 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	backing = _tmp0_;
#line 445 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	backing_length1 = 0;
#line 445 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_backing_size_ = backing_length1;
#line 4132 "Photo.c"
	{
		PhotoRow _tmp1_;
#line 446 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp1_ = self->priv->row;
#line 446 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 4139 "Photo.c"
		{
			BackingFileState** _tmp2_;
			gint _tmp2__length1;
			PhotoRow _tmp3_;
			BackingPhotoState _tmp4_;
			PhotoRow _tmp5_;
			const gchar* _tmp6_;
			BackingFileState* _tmp7_;
			gboolean _tmp8_ = FALSE;
#line 447 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp2_ = backing;
#line 447 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp2__length1 = backing_length1;
#line 447 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp3_ = self->priv->row;
#line 447 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp4_ = _tmp3_.master;
#line 447 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp5_ = self->priv->row;
#line 447 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp6_ = _tmp5_.md5;
#line 447 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp7_ = backing_file_state_new_from_photo_state (&_tmp4_, _tmp6_);
#line 447 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_vala_array_add203 (&backing, &backing_length1, &_backing_size_, _tmp7_);
#line 448 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp8_ = photo_has_editable (self);
#line 448 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			if (_tmp8_) {
#line 4169 "Photo.c"
				BackingFileState** _tmp9_;
				gint _tmp9__length1;
				BackingPhotoState _tmp10_;
				BackingFileState* _tmp11_;
#line 449 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp9_ = backing;
#line 449 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp9__length1 = backing_length1;
#line 449 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp10_ = self->priv->editable;
#line 449 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp11_ = backing_file_state_new_from_photo_state (&_tmp10_, NULL);
#line 449 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_vala_array_add204 (&backing, &backing_length1, &_backing_size_, _tmp11_);
#line 4184 "Photo.c"
			}
		}
		__finally115:
		{
			PhotoRow _tmp12_;
#line 446 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp12_ = self->priv->row;
#line 446 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 4194 "Photo.c"
		}
#line 446 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 446 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			backing = (_vala_array_free (backing, backing_length1, (GDestroyNotify) backing_file_state_unref), NULL);
#line 446 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 446 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 446 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			return NULL;
#line 4206 "Photo.c"
		}
	}
#line 452 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp13_ = backing;
#line 452 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp13__length1 = backing_length1;
#line 452 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (result_length1) {
#line 452 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		*result_length1 = _tmp13__length1;
#line 4217 "Photo.c"
	}
#line 452 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	result = _tmp13_;
#line 452 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return result;
#line 4223 "Photo.c"
}


static PhotoFileReader* photo_get_backing_reader (Photo* self, BackingFetchMode mode) {
	PhotoFileReader* result = NULL;
	BackingFetchMode _tmp0_;
#line 455 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 456 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp0_ = mode;
#line 456 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	switch (_tmp0_) {
#line 456 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		case BACKING_FETCH_MODE_MASTER:
#line 4238 "Photo.c"
		{
			PhotoFileReader* _tmp1_ = NULL;
#line 458 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp1_ = photo_get_master_reader (self);
#line 458 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			result = _tmp1_;
#line 458 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			return result;
#line 4247 "Photo.c"
		}
#line 456 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		case BACKING_FETCH_MODE_BASELINE:
#line 4251 "Photo.c"
		{
			PhotoFileReader* _tmp2_ = NULL;
#line 461 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp2_ = photo_get_baseline_reader (self);
#line 461 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			result = _tmp2_;
#line 461 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			return result;
#line 4260 "Photo.c"
		}
#line 456 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		case BACKING_FETCH_MODE_SOURCE:
#line 4264 "Photo.c"
		{
			PhotoFileReader* _tmp3_ = NULL;
#line 464 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp3_ = photo_get_source_reader (self);
#line 464 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			result = _tmp3_;
#line 464 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			return result;
#line 4273 "Photo.c"
		}
		default:
		{
			BackingFetchMode _tmp4_;
			GEnumValue* _tmp5_;
#line 467 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp4_ = mode;
#line 467 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp5_ = g_enum_get_value (g_type_class_ref (TYPE_BACKING_FETCH_MODE), _tmp4_);
#line 467 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_error ("Photo.vala:467: Unknown backing fetch mode %s", (_tmp5_ != NULL) ? _tmp5_->value_name : NULL);
#line 4285 "Photo.c"
		}
	}
}


static gpointer _photo_file_adapter_ref0 (gpointer self) {
#line 473 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return self ? photo_file_adapter_ref (self) : NULL;
#line 4294 "Photo.c"
}


static PhotoFileReader* photo_get_master_reader (Photo* self) {
	PhotoFileReader* result = NULL;
	GError * _inner_error_ = NULL;
#line 471 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 4303 "Photo.c"
	{
		PhotoBackingReaders _tmp0_;
#line 472 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 472 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_readers);
#line 4310 "Photo.c"
		{
			PhotoBackingReaders _tmp1_;
			PhotoFileReader* _tmp2_;
			PhotoFileReader* _tmp3_;
#line 473 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 473 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp2_ = _tmp1_.master;
#line 473 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp3_ = _photo_file_adapter_ref0 (_tmp2_);
#line 473 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			result = _tmp3_;
#line 4323 "Photo.c"
			{
				PhotoBackingReaders _tmp4_;
#line 472 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp4_ = self->priv->readers;
#line 472 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock_readers);
#line 4330 "Photo.c"
			}
#line 473 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			return result;
#line 4334 "Photo.c"
		}
		__finally116:
		{
			PhotoBackingReaders _tmp5_;
#line 472 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp5_ = self->priv->readers;
#line 472 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_readers);
#line 4343 "Photo.c"
		}
#line 472 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 472 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 472 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return NULL;
#line 4351 "Photo.c"
	}
}


void photo_set_mimic_reader (Photo* self, PhotoFileReader* mimic) {
	gboolean _tmp0_;
	GError * _inner_error_ = NULL;
#line 478 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 478 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO_FILE_READER (mimic));
#line 479 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp0_ = commandline_options_no_mimicked_images;
#line 479 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp0_) {
#line 480 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return;
#line 4369 "Photo.c"
	}
	{
		PhotoBackingReaders _tmp1_;
#line 484 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp1_ = self->priv->readers;
#line 484 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_readers);
#line 4377 "Photo.c"
		{
			PhotoFileReader* _tmp2_;
			PhotoFileReader* _tmp3_;
#line 485 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp2_ = mimic;
#line 485 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp3_ = _photo_file_adapter_ref0 (_tmp2_);
#line 485 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_photo_file_adapter_unref0 (self->priv->readers.mimic);
#line 485 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			self->priv->readers.mimic = _tmp3_;
#line 4389 "Photo.c"
		}
		__finally117:
		{
			PhotoBackingReaders _tmp4_;
#line 484 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp4_ = self->priv->readers;
#line 484 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_readers);
#line 4398 "Photo.c"
		}
#line 484 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 484 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 484 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 484 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			return;
#line 4408 "Photo.c"
		}
	}
}


PhotoFileReader* photo_get_editable_reader (Photo* self) {
	PhotoFileReader* result = NULL;
	GError * _inner_error_ = NULL;
#line 489 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 4419 "Photo.c"
	{
		PhotoBackingReaders _tmp0_;
#line 490 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 490 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_readers);
#line 4426 "Photo.c"
		{
			PhotoBackingReaders _tmp1_;
			PhotoFileReader* _tmp2_;
			PhotoFileReader* _tmp3_;
#line 491 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 491 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp2_ = _tmp1_.editable;
#line 491 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp3_ = _photo_file_adapter_ref0 (_tmp2_);
#line 491 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			result = _tmp3_;
#line 4439 "Photo.c"
			{
				PhotoBackingReaders _tmp4_;
#line 490 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp4_ = self->priv->readers;
#line 490 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock_readers);
#line 4446 "Photo.c"
			}
#line 491 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			return result;
#line 4450 "Photo.c"
		}
		__finally118:
		{
			PhotoBackingReaders _tmp5_;
#line 490 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp5_ = self->priv->readers;
#line 490 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_readers);
#line 4459 "Photo.c"
		}
#line 490 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 490 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 490 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return NULL;
#line 4467 "Photo.c"
	}
}


static PhotoFileReader* photo_get_baseline_reader (Photo* self) {
	PhotoFileReader* result = NULL;
	GError * _inner_error_ = NULL;
#line 496 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 4477 "Photo.c"
	{
		PhotoBackingReaders _tmp0_;
#line 497 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 497 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_readers);
#line 4484 "Photo.c"
		{
			PhotoBackingReaders _tmp1_;
			PhotoFileReader* _tmp2_;
			PhotoBackingReaders _tmp7_;
			PhotoFileReader* _tmp8_;
			PhotoBackingReaders _tmp13_;
			PhotoFileReader* _tmp14_;
			PhotoFileReader* _tmp15_;
#line 498 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 498 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp2_ = _tmp1_.editable;
#line 498 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			if (_tmp2_ != NULL) {
#line 4499 "Photo.c"
				PhotoBackingReaders _tmp3_;
				PhotoFileReader* _tmp4_;
				PhotoFileReader* _tmp5_;
#line 499 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp3_ = self->priv->readers;
#line 499 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp4_ = _tmp3_.editable;
#line 499 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp5_ = _photo_file_adapter_ref0 (_tmp4_);
#line 499 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				result = _tmp5_;
#line 4511 "Photo.c"
				{
					PhotoBackingReaders _tmp6_;
#line 497 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_tmp6_ = self->priv->readers;
#line 497 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					g_static_rec_mutex_unlock (&self->priv->__lock_readers);
#line 4518 "Photo.c"
				}
#line 499 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				return result;
#line 4522 "Photo.c"
			}
#line 501 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp7_ = self->priv->readers;
#line 501 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp8_ = _tmp7_.mimic;
#line 501 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			if (_tmp8_ != NULL) {
#line 4530 "Photo.c"
				PhotoBackingReaders _tmp9_;
				PhotoFileReader* _tmp10_;
				PhotoFileReader* _tmp11_;
#line 502 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp9_ = self->priv->readers;
#line 502 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp10_ = _tmp9_.mimic;
#line 502 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp11_ = _photo_file_adapter_ref0 (_tmp10_);
#line 502 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				result = _tmp11_;
#line 4542 "Photo.c"
				{
					PhotoBackingReaders _tmp12_;
#line 497 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_tmp12_ = self->priv->readers;
#line 497 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					g_static_rec_mutex_unlock (&self->priv->__lock_readers);
#line 4549 "Photo.c"
				}
#line 502 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				return result;
#line 4553 "Photo.c"
			}
#line 504 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp13_ = self->priv->readers;
#line 504 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp14_ = _tmp13_.master;
#line 504 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp15_ = _photo_file_adapter_ref0 (_tmp14_);
#line 504 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			result = _tmp15_;
#line 4563 "Photo.c"
			{
				PhotoBackingReaders _tmp16_;
#line 497 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp16_ = self->priv->readers;
#line 497 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock_readers);
#line 4570 "Photo.c"
			}
#line 504 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			return result;
#line 4574 "Photo.c"
		}
		__finally119:
		{
			PhotoBackingReaders _tmp17_;
#line 497 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp17_ = self->priv->readers;
#line 497 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_readers);
#line 4583 "Photo.c"
		}
#line 497 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 497 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 497 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return NULL;
#line 4591 "Photo.c"
	}
}


static PhotoFileReader* photo_get_source_reader (Photo* self) {
	PhotoFileReader* result = NULL;
	GError * _inner_error_ = NULL;
#line 510 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 4601 "Photo.c"
	{
		PhotoBackingReaders _tmp0_;
#line 511 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 511 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_readers);
#line 4608 "Photo.c"
		{
			PhotoBackingReaders _tmp1_;
			PhotoFileReader* _tmp2_;
			PhotoFileReader* _tmp3_;
			PhotoFileReader* _tmp4_;
			PhotoFileReader* _tmp5_;
#line 512 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 512 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp2_ = _tmp1_.editable;
#line 512 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp3_ = _photo_file_adapter_ref0 (_tmp2_);
#line 512 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp4_ = _tmp3_;
#line 512 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp5_ = _tmp4_;
#line 512 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			if (_tmp5_ == NULL) {
#line 4627 "Photo.c"
				PhotoBackingReaders _tmp6_;
				PhotoFileReader* _tmp7_;
				PhotoFileReader* _tmp8_;
#line 512 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp6_ = self->priv->readers;
#line 512 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp7_ = _tmp6_.master;
#line 512 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp8_ = _photo_file_adapter_ref0 (_tmp7_);
#line 512 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_photo_file_adapter_unref0 (_tmp4_);
#line 512 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp4_ = _tmp8_;
#line 4641 "Photo.c"
			}
#line 512 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			result = _tmp4_;
#line 4645 "Photo.c"
			{
				PhotoBackingReaders _tmp9_;
#line 511 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp9_ = self->priv->readers;
#line 511 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock_readers);
#line 4652 "Photo.c"
			}
#line 512 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			return result;
#line 4656 "Photo.c"
		}
		__finally120:
		{
			PhotoBackingReaders _tmp10_;
#line 511 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp10_ = self->priv->readers;
#line 511 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_readers);
#line 4665 "Photo.c"
		}
#line 511 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 511 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 511 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return NULL;
#line 4673 "Photo.c"
	}
}


gboolean photo_is_mimicked (Photo* self) {
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
#line 516 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 4683 "Photo.c"
	{
		PhotoBackingReaders _tmp0_;
#line 517 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 517 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_readers);
#line 4690 "Photo.c"
		{
			PhotoBackingReaders _tmp1_;
			PhotoFileReader* _tmp2_;
#line 518 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 518 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp2_ = _tmp1_.mimic;
#line 518 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			result = _tmp2_ != NULL;
#line 4700 "Photo.c"
			{
				PhotoBackingReaders _tmp3_;
#line 517 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp3_ = self->priv->readers;
#line 517 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock_readers);
#line 4707 "Photo.c"
			}
#line 518 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			return result;
#line 4711 "Photo.c"
		}
		__finally121:
		{
			PhotoBackingReaders _tmp4_;
#line 517 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp4_ = self->priv->readers;
#line 517 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_readers);
#line 4720 "Photo.c"
		}
#line 517 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 517 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 517 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return FALSE;
#line 4728 "Photo.c"
	}
}


gboolean photo_has_editable (Photo* self) {
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
#line 522 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 4738 "Photo.c"
	{
		PhotoBackingReaders _tmp0_;
#line 523 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 523 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_readers);
#line 4745 "Photo.c"
		{
			PhotoBackingReaders _tmp1_;
			PhotoFileReader* _tmp2_;
#line 524 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 524 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp2_ = _tmp1_.editable;
#line 524 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			result = _tmp2_ != NULL;
#line 4755 "Photo.c"
			{
				PhotoBackingReaders _tmp3_;
#line 523 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp3_ = self->priv->readers;
#line 523 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock_readers);
#line 4762 "Photo.c"
			}
#line 524 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			return result;
#line 4766 "Photo.c"
		}
		__finally122:
		{
			PhotoBackingReaders _tmp4_;
#line 523 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp4_ = self->priv->readers;
#line 523 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_readers);
#line 4775 "Photo.c"
		}
#line 523 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 523 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 523 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return FALSE;
#line 4783 "Photo.c"
	}
}


gboolean photo_does_master_exist (Photo* self) {
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
#line 528 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 4793 "Photo.c"
	{
		PhotoBackingReaders _tmp0_;
#line 529 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 529 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_readers);
#line 4800 "Photo.c"
		{
			PhotoBackingReaders _tmp1_;
			PhotoFileReader* _tmp2_;
			gboolean _tmp3_ = FALSE;
#line 530 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 530 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp2_ = _tmp1_.master;
#line 530 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp3_ = photo_file_adapter_file_exists (PHOTO_FILE_ADAPTER (_tmp2_));
#line 530 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			result = _tmp3_;
#line 4813 "Photo.c"
			{
				PhotoBackingReaders _tmp4_;
#line 529 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp4_ = self->priv->readers;
#line 529 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock_readers);
#line 4820 "Photo.c"
			}
#line 530 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			return result;
#line 4824 "Photo.c"
		}
		__finally123:
		{
			PhotoBackingReaders _tmp5_;
#line 529 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp5_ = self->priv->readers;
#line 529 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_readers);
#line 4833 "Photo.c"
		}
#line 529 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 529 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 529 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return FALSE;
#line 4841 "Photo.c"
	}
}


gboolean photo_does_editable_exist (Photo* self) {
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
#line 535 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 4851 "Photo.c"
	{
		PhotoBackingReaders _tmp0_;
#line 536 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 536 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_readers);
#line 4858 "Photo.c"
		{
			gboolean _tmp1_ = FALSE;
			PhotoBackingReaders _tmp2_;
			PhotoFileReader* _tmp3_;
#line 537 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp2_ = self->priv->readers;
#line 537 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp3_ = _tmp2_.editable;
#line 537 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			if (_tmp3_ != NULL) {
#line 4869 "Photo.c"
				PhotoBackingReaders _tmp4_;
				PhotoFileReader* _tmp5_;
				gboolean _tmp6_ = FALSE;
#line 537 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp4_ = self->priv->readers;
#line 537 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp5_ = _tmp4_.editable;
#line 537 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp6_ = photo_file_adapter_file_exists (PHOTO_FILE_ADAPTER (_tmp5_));
#line 537 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp1_ = _tmp6_;
#line 4881 "Photo.c"
			} else {
#line 537 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp1_ = FALSE;
#line 4885 "Photo.c"
			}
#line 537 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			result = _tmp1_;
#line 4889 "Photo.c"
			{
				PhotoBackingReaders _tmp7_;
#line 536 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp7_ = self->priv->readers;
#line 536 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock_readers);
#line 4896 "Photo.c"
			}
#line 537 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			return result;
#line 4900 "Photo.c"
		}
		__finally124:
		{
			PhotoBackingReaders _tmp8_;
#line 536 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp8_ = self->priv->readers;
#line 536 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_readers);
#line 4909 "Photo.c"
		}
#line 536 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 536 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 536 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return FALSE;
#line 4917 "Photo.c"
	}
}


gboolean photo_is_master_baseline (Photo* self) {
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
#line 541 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 4927 "Photo.c"
	{
		PhotoBackingReaders _tmp0_;
#line 542 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 542 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_readers);
#line 4934 "Photo.c"
		{
			gboolean _tmp1_ = FALSE;
			PhotoBackingReaders _tmp2_;
			PhotoFileReader* _tmp3_;
			gboolean _tmp6_;
#line 543 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp2_ = self->priv->readers;
#line 543 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp3_ = _tmp2_.mimic;
#line 543 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			if (_tmp3_ == NULL) {
#line 4946 "Photo.c"
				PhotoBackingReaders _tmp4_;
				PhotoFileReader* _tmp5_;
#line 543 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp4_ = self->priv->readers;
#line 543 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp5_ = _tmp4_.editable;
#line 543 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp1_ = _tmp5_ == NULL;
#line 4955 "Photo.c"
			} else {
#line 543 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp1_ = FALSE;
#line 4959 "Photo.c"
			}
#line 543 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp6_ = _tmp1_;
#line 543 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			result = _tmp6_;
#line 4965 "Photo.c"
			{
				PhotoBackingReaders _tmp7_;
#line 542 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp7_ = self->priv->readers;
#line 542 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock_readers);
#line 4972 "Photo.c"
			}
#line 543 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			return result;
#line 4976 "Photo.c"
		}
		__finally125:
		{
			PhotoBackingReaders _tmp8_;
#line 542 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp8_ = self->priv->readers;
#line 542 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_readers);
#line 4985 "Photo.c"
		}
#line 542 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 542 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 542 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return FALSE;
#line 4993 "Photo.c"
	}
}


gboolean photo_is_master_source (Photo* self) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
#line 547 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 548 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp0_ = photo_has_editable (self);
#line 548 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	result = !_tmp0_;
#line 548 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return result;
#line 5009 "Photo.c"
}


gboolean photo_is_editable_baseline (Photo* self) {
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
#line 551 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 5018 "Photo.c"
	{
		PhotoBackingReaders _tmp0_;
#line 552 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 552 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_readers);
#line 5025 "Photo.c"
		{
			gboolean _tmp1_ = FALSE;
			PhotoBackingReaders _tmp2_;
			PhotoFileReader* _tmp3_;
			gboolean _tmp6_;
#line 553 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp2_ = self->priv->readers;
#line 553 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp3_ = _tmp2_.mimic;
#line 553 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			if (_tmp3_ == NULL) {
#line 5037 "Photo.c"
				PhotoBackingReaders _tmp4_;
				PhotoFileReader* _tmp5_;
#line 553 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp4_ = self->priv->readers;
#line 553 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp5_ = _tmp4_.editable;
#line 553 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp1_ = _tmp5_ != NULL;
#line 5046 "Photo.c"
			} else {
#line 553 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp1_ = FALSE;
#line 5050 "Photo.c"
			}
#line 553 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp6_ = _tmp1_;
#line 553 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			result = _tmp6_;
#line 5056 "Photo.c"
			{
				PhotoBackingReaders _tmp7_;
#line 552 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp7_ = self->priv->readers;
#line 552 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock_readers);
#line 5063 "Photo.c"
			}
#line 553 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			return result;
#line 5067 "Photo.c"
		}
		__finally126:
		{
			PhotoBackingReaders _tmp8_;
#line 552 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp8_ = self->priv->readers;
#line 552 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_readers);
#line 5076 "Photo.c"
		}
#line 552 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 552 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 552 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return FALSE;
#line 5084 "Photo.c"
	}
}


gboolean photo_is_editable_source (Photo* self) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
#line 557 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 558 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp0_ = photo_has_editable (self);
#line 558 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	result = _tmp0_;
#line 558 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return result;
#line 5100 "Photo.c"
}


void photo_get_master_photo_state (Photo* self, BackingPhotoState* result) {
	GError * _inner_error_ = NULL;
#line 561 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 5108 "Photo.c"
	{
		PhotoRow _tmp0_;
#line 562 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp0_ = self->priv->row;
#line 562 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 5115 "Photo.c"
		{
			PhotoRow _tmp1_;
			BackingPhotoState _tmp2_;
			BackingPhotoState _tmp3_ = {0};
#line 563 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp1_ = self->priv->row;
#line 563 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp2_ = _tmp1_.master;
#line 563 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			backing_photo_state_copy (&_tmp2_, &_tmp3_);
#line 563 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			*result = _tmp3_;
#line 5128 "Photo.c"
			{
				PhotoRow _tmp4_;
#line 562 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp4_ = self->priv->row;
#line 562 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 5135 "Photo.c"
			}
#line 563 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			return;
#line 5139 "Photo.c"
		}
		__finally127:
		{
			PhotoRow _tmp5_;
#line 562 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp5_ = self->priv->row;
#line 562 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 5148 "Photo.c"
		}
#line 562 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 562 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 562 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return;
#line 5156 "Photo.c"
	}
}


static gpointer _backing_photo_state_dup0 (gpointer self) {
#line 571 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return self ? backing_photo_state_dup (self) : NULL;
#line 5164 "Photo.c"
}


BackingPhotoState* photo_get_editable_photo_state (Photo* self) {
	BackingPhotoState* result = NULL;
	GError * _inner_error_ = NULL;
#line 567 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 5173 "Photo.c"
	{
		PhotoRow _tmp0_;
#line 568 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp0_ = self->priv->row;
#line 568 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 5180 "Photo.c"
		{
			gboolean _tmp1_ = FALSE;
#line 570 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp1_ = backing_photo_id_is_valid (&self->priv->row.editable_id);
#line 570 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			if (_tmp1_) {
#line 5187 "Photo.c"
				BackingPhotoState _tmp2_;
				BackingPhotoState _tmp3_;
				BackingPhotoState* _tmp4_;
#line 571 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp2_ = self->priv->editable;
#line 571 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp3_ = _tmp2_;
#line 571 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp4_ = _backing_photo_state_dup0 (&_tmp3_);
#line 571 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				result = _tmp4_;
#line 5199 "Photo.c"
				{
					PhotoRow _tmp5_;
#line 568 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_tmp5_ = self->priv->row;
#line 568 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 5206 "Photo.c"
				}
#line 571 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				return result;
#line 5210 "Photo.c"
			} else {
#line 573 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				result = NULL;
#line 5214 "Photo.c"
				{
					PhotoRow _tmp6_;
#line 568 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_tmp6_ = self->priv->row;
#line 568 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 5221 "Photo.c"
				}
#line 573 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				return result;
#line 5225 "Photo.c"
			}
		}
		__finally128:
		{
			PhotoRow _tmp7_;
#line 568 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp7_ = self->priv->row;
#line 568 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 5235 "Photo.c"
		}
#line 568 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 568 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 568 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return NULL;
#line 5243 "Photo.c"
	}
}


static PhotoFileFormat* _photo_file_format_dup (PhotoFileFormat* self) {
	PhotoFileFormat* dup;
#line 583 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	dup = g_new0 (PhotoFileFormat, 1);
#line 583 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	memcpy (dup, self, sizeof (PhotoFileFormat));
#line 583 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return dup;
#line 5256 "Photo.c"
}


static gpointer __photo_file_format_dup0 (gpointer self) {
#line 583 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return self ? _photo_file_format_dup (self) : NULL;
#line 5263 "Photo.c"
}


PhotoFileFormat* photo_get_editable_file_format (Photo* self) {
	PhotoFileFormat* result = NULL;
	PhotoFileReader* _tmp0_ = NULL;
	PhotoFileReader* reader;
	PhotoFileReader* _tmp1_;
	PhotoFileReader* _tmp2_;
	PhotoFileFormat _tmp3_ = 0;
	PhotoFileFormat* _tmp4_;
#line 577 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 578 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp0_ = photo_get_editable_reader (self);
#line 578 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	reader = _tmp0_;
#line 579 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp1_ = reader;
#line 579 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp1_ == NULL) {
#line 580 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		result = NULL;
#line 580 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_photo_file_adapter_unref0 (reader);
#line 580 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return result;
#line 5291 "Photo.c"
	}
#line 583 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp2_ = reader;
#line 583 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp3_ = photo_file_adapter_get_file_format (PHOTO_FILE_ADAPTER (_tmp2_));
#line 583 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp4_ = __photo_file_format_dup0 (&_tmp3_);
#line 583 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	result = _tmp4_;
#line 583 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_photo_file_adapter_unref0 (reader);
#line 583 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return result;
#line 5305 "Photo.c"
}


PhotoFileFormat photo_get_export_format_for_parameters (Photo* self, ExportFormatParameters* params) {
	PhotoFileFormat result = 0;
	PhotoFileFormat _tmp0_ = 0;
	PhotoFileFormat _result_;
	ExportFormatParameters _tmp1_;
	ExportFormatMode _tmp2_;
#line 586 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), 0);
#line 586 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail (params != NULL, 0);
#line 587 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp0_ = photo_file_format_get_system_default_format ();
#line 587 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_result_ = _tmp0_;
#line 589 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp1_ = *params;
#line 589 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp2_ = _tmp1_.mode;
#line 589 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	switch (_tmp2_) {
#line 589 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		case EXPORT_FORMAT_MODE_UNMODIFIED:
#line 5331 "Photo.c"
		{
			PhotoFileFormat _tmp3_ = 0;
#line 591 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp3_ = photo_get_master_file_format (self);
#line 591 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_result_ = _tmp3_;
#line 592 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			break;
#line 5340 "Photo.c"
		}
#line 589 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		case EXPORT_FORMAT_MODE_CURRENT:
#line 5344 "Photo.c"
		{
			PhotoFileFormat _tmp4_ = 0;
#line 595 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp4_ = photo_get_best_export_file_format (self);
#line 595 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_result_ = _tmp4_;
#line 596 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			break;
#line 5353 "Photo.c"
		}
#line 589 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		case EXPORT_FORMAT_MODE_SPECIFIED:
#line 5357 "Photo.c"
		{
			ExportFormatParameters _tmp5_;
			PhotoFileFormat _tmp6_;
#line 599 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp5_ = *params;
#line 599 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp6_ = _tmp5_.specified_format;
#line 599 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_result_ = _tmp6_;
#line 600 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			break;
#line 5369 "Photo.c"
		}
		default:
		{
#line 603 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_error ("Photo.vala:603: get_export_format_for_parameters: unsupported export f" \
"ormat mode");
#line 5375 "Photo.c"
		}
	}
#line 606 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	result = _result_;
#line 606 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return result;
#line 5382 "Photo.c"
}


gchar* photo_get_export_basename_for_parameters (Photo* self, ExportFormatParameters* params) {
	gchar* result = NULL;
	gchar* _result_;
	ExportFormatParameters _tmp0_;
	ExportFormatMode _tmp1_;
	const gchar* _tmp8_;
#line 609 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 609 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail (params != NULL, NULL);
#line 610 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_result_ = NULL;
#line 612 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp0_ = *params;
#line 612 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp1_ = _tmp0_.mode;
#line 612 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	switch (_tmp1_) {
#line 612 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		case EXPORT_FORMAT_MODE_UNMODIFIED:
#line 5406 "Photo.c"
		{
			GFile* _tmp2_ = NULL;
			GFile* _tmp3_;
			gchar* _tmp4_ = NULL;
#line 614 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp2_ = media_source_get_master_file (MEDIA_SOURCE (self));
#line 614 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp3_ = _tmp2_;
#line 614 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp4_ = g_file_get_basename (_tmp3_);
#line 614 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_g_free0 (_result_);
#line 614 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_result_ = _tmp4_;
#line 614 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_g_object_unref0 (_tmp3_);
#line 615 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			break;
#line 5425 "Photo.c"
		}
#line 612 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		case EXPORT_FORMAT_MODE_CURRENT:
#line 612 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		case EXPORT_FORMAT_MODE_SPECIFIED:
#line 5431 "Photo.c"
		{
			ExportFormatParameters _tmp5_;
			PhotoFileFormat _tmp6_ = 0;
			gchar* _tmp7_ = NULL;
#line 619 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp5_ = *params;
#line 619 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp6_ = photo_get_export_format_for_parameters (self, &_tmp5_);
#line 619 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp7_ = photo_get_export_basename (self, &_tmp6_);
#line 619 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			result = _tmp7_;
#line 619 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_g_free0 (_result_);
#line 619 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			return result;
#line 5448 "Photo.c"
		}
		default:
		{
#line 622 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_error ("Photo.vala:622: get_export_basename_for_parameters: unsupported export" \
" format mode");
#line 5454 "Photo.c"
		}
	}
#line 625 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp8_ = _result_;
#line 625 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_assert (_tmp8_ != NULL);
#line 626 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	result = _result_;
#line 626 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return result;
#line 5465 "Photo.c"
}


ImportResult photo_prepare_for_import (PhotoImportParams* params) {
	ImportResult result = 0;
	PhotoImportParams* _tmp0_;
	GFile* _tmp1_;
	GFile* _tmp2_;
	GFile* file;
	GFileInfo* info;
	GFileInfo* _tmp6_;
	GFileType _tmp7_ = 0;
	GFile* _tmp8_;
	gboolean _tmp9_ = FALSE;
	GFile* _tmp13_;
	gboolean _tmp14_ = FALSE;
	GTimeVal timestamp = {0};
	GFileInfo* _tmp18_;
	GTimeVal _tmp19_ = {0};
	gboolean _tmp20_ = FALSE;
	gboolean _tmp21_ = FALSE;
	PhotoImportParams* _tmp22_;
	const gchar* _tmp23_;
	gboolean _tmp26_;
	gboolean _tmp29_;
	GFile* _tmp33_;
	PhotoImportParams* _tmp34_;
	PhotoFileSnifferOptions _tmp35_;
	PhotoFileInterrogator* _tmp36_;
	PhotoFileInterrogator* interrogator;
	PhotoFileInterrogator* _tmp43_;
	DetectedPhotoInformation* _tmp44_ = NULL;
	DetectedPhotoInformation* detected;
	DetectedPhotoInformation* _tmp45_;
	PhotoImportParams* _tmp46_;
	PhotoFileSnifferOptions _tmp47_;
	Orientation orientation;
	time_t exposure_time;
	gchar* _tmp60_;
	gchar* title;
	Rating rating;
	DetectedPhotoInformation* _tmp61_;
	PhotoMetadata* _tmp62_;
	gboolean _tmp82_ = FALSE;
	gboolean _tmp83_ = FALSE;
	DetectedPhotoInformation* _tmp84_;
	GdkColorspace _tmp85_;
	gboolean _tmp88_;
	gboolean _tmp91_;
	PhotoImportParams* _tmp95_;
	PhotoID _tmp96_ = {0};
	PhotoImportParams* _tmp97_;
	GFile* _tmp98_;
	gchar* _tmp99_ = NULL;
	PhotoImportParams* _tmp100_;
	DetectedPhotoInformation* _tmp101_;
	Dimensions _tmp102_;
	PhotoImportParams* _tmp103_;
	GFileInfo* _tmp104_;
	gint64 _tmp105_ = 0LL;
	PhotoImportParams* _tmp106_;
	GTimeVal _tmp107_;
	glong _tmp108_;
	PhotoImportParams* _tmp109_;
	time_t _tmp110_;
	PhotoImportParams* _tmp111_;
	Orientation _tmp112_;
	PhotoImportParams* _tmp113_;
	Orientation _tmp114_;
	PhotoImportParams* _tmp115_;
	PhotoImportParams* _tmp116_;
	ImportID _tmp117_;
	PhotoImportParams* _tmp118_;
	EventID _tmp119_ = {0};
	PhotoImportParams* _tmp120_;
	PhotoImportParams* _tmp121_;
	DetectedPhotoInformation* _tmp122_;
	const gchar* _tmp123_;
	gchar* _tmp124_;
	PhotoImportParams* _tmp125_;
	DetectedPhotoInformation* _tmp126_;
	const gchar* _tmp127_;
	gchar* _tmp128_;
	PhotoImportParams* _tmp129_;
	DetectedPhotoInformation* _tmp130_;
	const gchar* _tmp131_;
	gchar* _tmp132_;
	PhotoImportParams* _tmp133_;
	PhotoImportParams* _tmp134_;
	PhotoImportParams* _tmp135_;
	DetectedPhotoInformation* _tmp136_;
	PhotoFileFormat _tmp137_;
	PhotoImportParams* _tmp138_;
	const gchar* _tmp139_;
	gchar* _tmp140_;
	PhotoImportParams* _tmp141_;
	Rating _tmp142_;
	PhotoImportParams* _tmp143_;
	Thumbnails* _tmp144_;
	GError * _inner_error_ = NULL;
#line 641 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO_IMPORT_PARAMS (params), 0);
#line 645 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp0_ = params;
#line 645 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp1_ = _tmp0_->file;
#line 645 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 645 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	file = _tmp2_;
#line 647 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	info = NULL;
#line 5578 "Photo.c"
	{
		GFile* _tmp3_;
		GFileInfo* _tmp4_ = NULL;
		GFileInfo* _tmp5_;
#line 649 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp3_ = file;
#line 649 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp4_ = g_file_query_info (_tmp3_, DIRECTORY_MONITOR_SUPPLIED_ATTRIBUTES, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, NULL, &_inner_error_);
#line 649 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp5_ = _tmp4_;
#line 649 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 5591 "Photo.c"
			goto __catch129_g_error;
		}
#line 649 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_object_unref0 (info);
#line 649 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		info = _tmp5_;
#line 5598 "Photo.c"
	}
	goto __finally129;
	__catch129_g_error:
	{
		GError* err = NULL;
#line 648 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		err = _inner_error_;
#line 648 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_inner_error_ = NULL;
#line 652 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		result = IMPORT_RESULT_FILE_ERROR;
#line 652 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_error_free0 (err);
#line 652 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_object_unref0 (info);
#line 652 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_object_unref0 (file);
#line 652 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return result;
#line 5618 "Photo.c"
	}
	__finally129:
#line 648 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 648 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_object_unref0 (info);
#line 648 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_object_unref0 (file);
#line 648 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 648 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 648 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return 0;
#line 5633 "Photo.c"
	}
#line 655 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp6_ = info;
#line 655 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp7_ = g_file_info_get_file_type (_tmp6_);
#line 655 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp7_ != G_FILE_TYPE_REGULAR) {
#line 656 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		result = IMPORT_RESULT_NOT_A_FILE;
#line 656 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_object_unref0 (info);
#line 656 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_object_unref0 (file);
#line 656 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return result;
#line 5649 "Photo.c"
	}
#line 658 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp8_ = file;
#line 658 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp9_ = photo_is_file_image (_tmp8_);
#line 658 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (!_tmp9_) {
#line 5657 "Photo.c"
		GFile* _tmp10_;
		gchar* _tmp11_ = NULL;
		gchar* _tmp12_;
#line 659 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp10_ = file;
#line 659 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp11_ = g_file_get_path (_tmp10_);
#line 659 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp12_ = _tmp11_;
#line 659 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_message ("Photo.vala:659: Not importing %s: Not an image file", _tmp12_);
#line 659 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_free0 (_tmp12_);
#line 661 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		result = IMPORT_RESULT_NOT_AN_IMAGE;
#line 661 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_object_unref0 (info);
#line 661 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_object_unref0 (file);
#line 661 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return result;
#line 5679 "Photo.c"
	}
#line 664 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp13_ = file;
#line 664 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp14_ = photo_file_format_is_file_supported (_tmp13_);
#line 664 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (!_tmp14_) {
#line 5687 "Photo.c"
		GFile* _tmp15_;
		gchar* _tmp16_ = NULL;
		gchar* _tmp17_;
#line 665 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp15_ = file;
#line 665 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp16_ = g_file_get_path (_tmp15_);
#line 665 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp17_ = _tmp16_;
#line 665 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_message ("Photo.vala:665: Not importing %s: Unsupported extension", _tmp17_);
#line 665 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_free0 (_tmp17_);
#line 667 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		result = IMPORT_RESULT_UNSUPPORTED_FORMAT;
#line 667 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_object_unref0 (info);
#line 667 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_object_unref0 (file);
#line 667 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return result;
#line 5709 "Photo.c"
	}
#line 671 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp18_ = info;
#line 671 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_file_info_get_modification_time (_tmp18_, &_tmp19_);
#line 671 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	timestamp = _tmp19_;
#line 674 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp22_ = params;
#line 674 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp23_ = _tmp22_->exif_md5;
#line 674 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp23_ != NULL) {
#line 5723 "Photo.c"
		PhotoImportParams* _tmp24_;
		const gchar* _tmp25_;
#line 674 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp24_ = params;
#line 674 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp25_ = _tmp24_->thumbnail_md5;
#line 674 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp21_ = _tmp25_ != NULL;
#line 5732 "Photo.c"
	} else {
#line 674 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp21_ = FALSE;
#line 5736 "Photo.c"
	}
#line 674 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp26_ = _tmp21_;
#line 674 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp26_) {
#line 5742 "Photo.c"
		PhotoImportParams* _tmp27_;
		const gchar* _tmp28_;
#line 674 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp27_ = params;
#line 674 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp28_ = _tmp27_->full_md5;
#line 674 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp20_ = _tmp28_ != NULL;
#line 5751 "Photo.c"
	} else {
#line 674 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp20_ = FALSE;
#line 5755 "Photo.c"
	}
#line 674 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp29_ = _tmp20_;
#line 674 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp29_) {
#line 5761 "Photo.c"
		PhotoImportParams* _tmp30_;
		PhotoImportParams* _tmp31_;
		PhotoFileSnifferOptions _tmp32_;
#line 675 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp30_ = params;
#line 675 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp31_ = params;
#line 675 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp32_ = _tmp31_->sniffer_options;
#line 675 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp31_->sniffer_options = _tmp32_ | PHOTO_FILE_SNIFFER_OPTIONS_NO_MD5;
#line 5773 "Photo.c"
	}
#line 678 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp33_ = file;
#line 678 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp34_ = params;
#line 678 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp35_ = _tmp34_->sniffer_options;
#line 678 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp36_ = photo_file_interrogator_new (_tmp33_, _tmp35_);
#line 678 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	interrogator = _tmp36_;
#line 5785 "Photo.c"
	{
		PhotoFileInterrogator* _tmp37_;
#line 680 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp37_ = interrogator;
#line 680 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		photo_file_interrogator_interrogate (_tmp37_, &_inner_error_);
#line 680 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 5794 "Photo.c"
			goto __catch130_g_error;
		}
	}
	goto __finally130;
	__catch130_g_error:
	{
		GError* err = NULL;
		GFile* _tmp38_;
		gchar* _tmp39_ = NULL;
		gchar* _tmp40_;
		GError* _tmp41_;
		const gchar* _tmp42_;
#line 679 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		err = _inner_error_;
#line 679 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_inner_error_ = NULL;
#line 682 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp38_ = file;
#line 682 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp39_ = g_file_get_path (_tmp38_);
#line 682 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp40_ = _tmp39_;
#line 682 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp41_ = err;
#line 682 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp42_ = _tmp41_->message;
#line 682 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_warning ("Photo.vala:682: Unable to interrogate photo file %s: %s", _tmp40_, _tmp42_);
#line 682 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_free0 (_tmp40_);
#line 684 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		result = IMPORT_RESULT_DECODE_ERROR;
#line 684 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_error_free0 (err);
#line 684 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_photo_file_interrogator_unref0 (interrogator);
#line 684 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_object_unref0 (info);
#line 684 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_object_unref0 (file);
#line 684 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return result;
#line 5837 "Photo.c"
	}
	__finally130:
#line 679 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 679 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_photo_file_interrogator_unref0 (interrogator);
#line 679 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_object_unref0 (info);
#line 679 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_object_unref0 (file);
#line 679 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 679 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 679 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return 0;
#line 5854 "Photo.c"
	}
#line 688 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp43_ = interrogator;
#line 688 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp44_ = photo_file_interrogator_get_detected_photo_information (_tmp43_);
#line 688 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	detected = _tmp44_;
#line 689 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp45_ = detected;
#line 689 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp45_ == NULL) {
#line 690 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		result = IMPORT_RESULT_UNSUPPORTED_FORMAT;
#line 690 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 690 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_photo_file_interrogator_unref0 (interrogator);
#line 690 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_object_unref0 (info);
#line 690 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_object_unref0 (file);
#line 690 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return result;
#line 5878 "Photo.c"
	}
#line 693 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp46_ = params;
#line 693 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp47_ = _tmp46_->sniffer_options;
#line 693 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if ((_tmp47_ & PHOTO_FILE_SNIFFER_OPTIONS_NO_MD5) != 0) {
#line 5886 "Photo.c"
		DetectedPhotoInformation* _tmp48_;
		PhotoImportParams* _tmp49_;
		const gchar* _tmp50_;
		gchar* _tmp51_;
		DetectedPhotoInformation* _tmp52_;
		PhotoImportParams* _tmp53_;
		const gchar* _tmp54_;
		gchar* _tmp55_;
		DetectedPhotoInformation* _tmp56_;
		PhotoImportParams* _tmp57_;
		const gchar* _tmp58_;
		gchar* _tmp59_;
#line 694 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp48_ = detected;
#line 694 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp49_ = params;
#line 694 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp50_ = _tmp49_->exif_md5;
#line 694 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp51_ = g_strdup (_tmp50_);
#line 694 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_free0 (_tmp48_->exif_md5);
#line 694 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp48_->exif_md5 = _tmp51_;
#line 695 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp52_ = detected;
#line 695 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp53_ = params;
#line 695 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp54_ = _tmp53_->thumbnail_md5;
#line 695 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp55_ = g_strdup (_tmp54_);
#line 695 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_free0 (_tmp52_->thumbnail_md5);
#line 695 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp52_->thumbnail_md5 = _tmp55_;
#line 696 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp56_ = detected;
#line 696 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp57_ = params;
#line 696 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp58_ = _tmp57_->full_md5;
#line 696 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp59_ = g_strdup (_tmp58_);
#line 696 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_free0 (_tmp56_->md5);
#line 696 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp56_->md5 = _tmp59_;
#line 5935 "Photo.c"
	}
#line 699 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	orientation = ORIENTATION_TOP_LEFT;
#line 700 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	exposure_time = (time_t) 0;
#line 701 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp60_ = g_strdup ("");
#line 701 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	title = _tmp60_;
#line 702 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	rating = RATING_UNRATED;
#line 709 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp61_ = detected;
#line 709 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp62_ = _tmp61_->metadata;
#line 709 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp62_ != NULL) {
#line 5953 "Photo.c"
		DetectedPhotoInformation* _tmp63_;
		PhotoMetadata* _tmp64_;
		MetadataDateTime* _tmp65_ = NULL;
		MetadataDateTime* date_time;
		MetadataDateTime* _tmp66_;
		DetectedPhotoInformation* _tmp69_;
		PhotoMetadata* _tmp70_;
		Orientation _tmp71_ = 0;
		DetectedPhotoInformation* _tmp72_;
		PhotoMetadata* _tmp73_;
		gchar* _tmp74_ = NULL;
		PhotoImportParams* _tmp75_;
		DetectedPhotoInformation* _tmp76_;
		PhotoMetadata* _tmp77_;
		GeeSet* _tmp78_ = NULL;
		DetectedPhotoInformation* _tmp79_;
		PhotoMetadata* _tmp80_;
		Rating _tmp81_ = 0;
#line 710 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp63_ = detected;
#line 710 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp64_ = _tmp63_->metadata;
#line 710 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp65_ = photo_metadata_get_exposure_date_time (_tmp64_);
#line 710 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		date_time = _tmp65_;
#line 711 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp66_ = date_time;
#line 711 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		if (_tmp66_ != NULL) {
#line 5984 "Photo.c"
			MetadataDateTime* _tmp67_;
			time_t _tmp68_ = 0;
#line 712 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp67_ = date_time;
#line 712 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp68_ = metadata_date_time_get_timestamp (_tmp67_);
#line 712 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			exposure_time = _tmp68_;
#line 5993 "Photo.c"
		}
#line 714 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp69_ = detected;
#line 714 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp70_ = _tmp69_->metadata;
#line 714 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp71_ = photo_metadata_get_orientation (_tmp70_);
#line 714 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		orientation = _tmp71_;
#line 715 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp72_ = detected;
#line 715 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp73_ = _tmp72_->metadata;
#line 715 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp74_ = media_metadata_get_title (MEDIA_METADATA (_tmp73_));
#line 715 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_free0 (title);
#line 715 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		title = _tmp74_;
#line 716 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp75_ = params;
#line 716 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp76_ = detected;
#line 716 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp77_ = _tmp76_->metadata;
#line 716 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp78_ = photo_metadata_get_keywords (_tmp77_, NULL);
#line 716 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_object_unref0 (_tmp75_->keywords);
#line 716 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp75_->keywords = GEE_COLLECTION (_tmp78_);
#line 717 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp79_ = detected;
#line 717 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp80_ = _tmp79_->metadata;
#line 717 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp81_ = photo_metadata_get_rating (_tmp80_);
#line 717 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		rating = _tmp81_;
#line 709 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_metadata_date_time_unref0 (date_time);
#line 6035 "Photo.c"
	}
#line 721 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp84_ = detected;
#line 721 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp85_ = _tmp84_->colorspace;
#line 721 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp85_ != GDK_COLORSPACE_RGB) {
#line 721 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp83_ = TRUE;
#line 6045 "Photo.c"
	} else {
		DetectedPhotoInformation* _tmp86_;
		gint _tmp87_;
#line 722 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp86_ = detected;
#line 722 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp87_ = _tmp86_->channels;
#line 722 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp83_ = _tmp87_ < 3;
#line 6055 "Photo.c"
	}
#line 721 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp88_ = _tmp83_;
#line 721 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp88_) {
#line 721 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp82_ = TRUE;
#line 6063 "Photo.c"
	} else {
		DetectedPhotoInformation* _tmp89_;
		gint _tmp90_;
#line 723 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp89_ = detected;
#line 723 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp90_ = _tmp89_->bits_per_channel;
#line 723 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp82_ = _tmp90_ != 8;
#line 6073 "Photo.c"
	}
#line 721 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp91_ = _tmp82_;
#line 721 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp91_) {
#line 6079 "Photo.c"
		GFile* _tmp92_;
		gchar* _tmp93_ = NULL;
		gchar* _tmp94_;
#line 724 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp92_ = file;
#line 724 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp93_ = g_file_get_path (_tmp92_);
#line 724 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp94_ = _tmp93_;
#line 724 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_message ("Photo.vala:724: Not importing %s: Unsupported color format", _tmp94_);
#line 724 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_free0 (_tmp94_);
#line 726 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		result = IMPORT_RESULT_UNSUPPORTED_FORMAT;
#line 726 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_free0 (title);
#line 726 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 726 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_photo_file_interrogator_unref0 (interrogator);
#line 726 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_object_unref0 (info);
#line 726 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_object_unref0 (file);
#line 726 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return result;
#line 6107 "Photo.c"
	}
#line 732 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp95_ = params;
#line 732 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	photo_id_init (&_tmp96_, PHOTO_ID_INVALID);
#line 732 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp95_->row.photo_id = _tmp96_;
#line 733 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp97_ = params;
#line 733 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp98_ = file;
#line 733 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp99_ = g_file_get_path (_tmp98_);
#line 733 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_g_free0 (_tmp97_->row.master.filepath);
#line 733 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp97_->row.master.filepath = _tmp99_;
#line 734 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp100_ = params;
#line 734 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp101_ = detected;
#line 734 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp102_ = _tmp101_->image_dim;
#line 734 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp100_->row.master.dim = _tmp102_;
#line 735 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp103_ = params;
#line 735 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp104_ = info;
#line 735 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp105_ = g_file_info_get_size (_tmp104_);
#line 735 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp103_->row.master.filesize = _tmp105_;
#line 736 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp106_ = params;
#line 736 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp107_ = timestamp;
#line 736 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp108_ = _tmp107_.tv_sec;
#line 736 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp106_->row.master.timestamp = (time_t) _tmp108_;
#line 737 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp109_ = params;
#line 737 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp110_ = exposure_time;
#line 737 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp109_->row.exposure_time = _tmp110_;
#line 738 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp111_ = params;
#line 738 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp112_ = orientation;
#line 738 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp111_->row.orientation = _tmp112_;
#line 739 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp113_ = params;
#line 739 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp114_ = orientation;
#line 739 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp113_->row.master.original_orientation = _tmp114_;
#line 740 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp115_ = params;
#line 740 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp116_ = params;
#line 740 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp117_ = _tmp116_->import_id;
#line 740 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp115_->row.import_id = _tmp117_;
#line 741 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp118_ = params;
#line 741 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	event_id_init (&_tmp119_, EVENT_ID_INVALID);
#line 741 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp118_->row.event_id = _tmp119_;
#line 742 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp120_ = params;
#line 742 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_g_object_unref0 (_tmp120_->row.transformations);
#line 742 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp120_->row.transformations = NULL;
#line 743 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp121_ = params;
#line 743 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp122_ = detected;
#line 743 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp123_ = _tmp122_->md5;
#line 743 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp124_ = g_strdup (_tmp123_);
#line 743 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_g_free0 (_tmp121_->row.md5);
#line 743 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp121_->row.md5 = _tmp124_;
#line 744 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp125_ = params;
#line 744 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp126_ = detected;
#line 744 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp127_ = _tmp126_->thumbnail_md5;
#line 744 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp128_ = g_strdup (_tmp127_);
#line 744 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_g_free0 (_tmp125_->row.thumbnail_md5);
#line 744 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp125_->row.thumbnail_md5 = _tmp128_;
#line 745 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp129_ = params;
#line 745 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp130_ = detected;
#line 745 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp131_ = _tmp130_->exif_md5;
#line 745 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp132_ = g_strdup (_tmp131_);
#line 745 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_g_free0 (_tmp129_->row.exif_md5);
#line 745 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp129_->row.exif_md5 = _tmp132_;
#line 746 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp133_ = params;
#line 746 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp133_->row.time_created = (time_t) 0;
#line 747 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp134_ = params;
#line 747 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp134_->row.flags = (guint64) 0;
#line 748 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp135_ = params;
#line 748 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp136_ = detected;
#line 748 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp137_ = _tmp136_->file_format;
#line 748 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp135_->row.master.file_format = _tmp137_;
#line 749 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp138_ = params;
#line 749 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp139_ = title;
#line 749 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp140_ = g_strdup (_tmp139_);
#line 749 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_g_free0 (_tmp138_->row.title);
#line 749 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp138_->row.title = _tmp140_;
#line 750 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp141_ = params;
#line 750 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp142_ = rating;
#line 750 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp141_->row.rating = _tmp142_;
#line 752 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp143_ = params;
#line 752 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp144_ = _tmp143_->thumbnails;
#line 752 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp144_ != NULL) {
#line 6261 "Photo.c"
		PhotoImportParams* _tmp145_;
		PhotoRow _tmp146_;
		BackingPhotoState _tmp147_;
		PhotoFileFormat _tmp148_;
		PhotoImportParams* _tmp149_;
		PhotoRow _tmp150_;
		BackingPhotoState _tmp151_;
		const gchar* _tmp152_;
		PhotoFileReader* _tmp153_ = NULL;
		PhotoFileReader* reader;
#line 753 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp145_ = params;
#line 753 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp146_ = _tmp145_->row;
#line 753 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp147_ = _tmp146_.master;
#line 753 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp148_ = _tmp147_.file_format;
#line 753 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp149_ = params;
#line 753 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp150_ = _tmp149_->row;
#line 753 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp151_ = _tmp150_.master;
#line 753 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp152_ = _tmp151_.filepath;
#line 753 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp153_ = photo_file_format_create_reader (_tmp148_, _tmp152_);
#line 753 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		reader = _tmp153_;
#line 6292 "Photo.c"
		{
			PhotoImportParams* _tmp154_;
			Thumbnails* _tmp155_;
			PhotoFileReader* _tmp156_;
			PhotoImportParams* _tmp157_;
			PhotoRow _tmp158_;
			Orientation _tmp159_;
			PhotoImportParams* _tmp160_;
			PhotoRow _tmp161_;
			BackingPhotoState _tmp162_;
			Dimensions _tmp163_;
#line 756 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp154_ = params;
#line 756 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp155_ = _tmp154_->thumbnails;
#line 756 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp156_ = reader;
#line 756 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp157_ = params;
#line 756 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp158_ = _tmp157_->row;
#line 756 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp159_ = _tmp158_.orientation;
#line 756 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp160_ = params;
#line 756 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp161_ = _tmp160_->row;
#line 756 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp162_ = _tmp161_.master;
#line 756 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp163_ = _tmp162_.dim;
#line 756 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			thumbnail_cache_generate_for_photo (_tmp155_, _tmp156_, _tmp159_, &_tmp163_, &_inner_error_);
#line 756 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			if (_inner_error_ != NULL) {
#line 6328 "Photo.c"
				goto __catch131_g_error;
			}
		}
		goto __finally131;
		__catch131_g_error:
		{
			GError* err = NULL;
			GError* _tmp164_;
			ImportResult _tmp165_ = 0;
#line 755 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			err = _inner_error_;
#line 755 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_inner_error_ = NULL;
#line 759 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp164_ = err;
#line 759 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp165_ = import_result_convert_error (_tmp164_, IMPORT_RESULT_FILE_ERROR);
#line 759 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			result = _tmp165_;
#line 759 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_g_error_free0 (err);
#line 759 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_photo_file_adapter_unref0 (reader);
#line 759 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_g_free0 (title);
#line 759 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_detected_photo_information_unref0 (detected);
#line 759 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_photo_file_interrogator_unref0 (interrogator);
#line 759 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_g_object_unref0 (info);
#line 759 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_g_object_unref0 (file);
#line 759 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			return result;
#line 6364 "Photo.c"
		}
		__finally131:
#line 755 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 755 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_photo_file_adapter_unref0 (reader);
#line 755 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_g_free0 (title);
#line 755 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_detected_photo_information_unref0 (detected);
#line 755 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_photo_file_interrogator_unref0 (interrogator);
#line 755 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_g_object_unref0 (info);
#line 755 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_g_object_unref0 (file);
#line 755 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 755 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 755 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			return 0;
#line 6387 "Photo.c"
		}
#line 752 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_photo_file_adapter_unref0 (reader);
#line 6391 "Photo.c"
	}
#line 766 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	result = IMPORT_RESULT_SUCCESS;
#line 766 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_g_free0 (title);
#line 766 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_detected_photo_information_unref0 (detected);
#line 766 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_photo_file_interrogator_unref0 (interrogator);
#line 766 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_g_object_unref0 (info);
#line 766 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_g_object_unref0 (file);
#line 766 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return result;
#line 6407 "Photo.c"
}


void photo_create_pre_import (PhotoImportParams* params) {
	PhotoImportParams* _tmp0_;
	GFile* _tmp1_;
	GFile* _tmp2_;
	GFile* file;
	PhotoImportParams* _tmp3_;
	PhotoID _tmp4_ = {0};
	PhotoImportParams* _tmp5_;
	gchar* _tmp6_ = NULL;
	PhotoImportParams* _tmp7_;
	Dimensions _tmp8_ = {0};
	PhotoImportParams* _tmp9_;
	PhotoImportParams* _tmp10_;
	PhotoImportParams* _tmp11_;
	PhotoImportParams* _tmp12_;
	PhotoImportParams* _tmp13_;
	PhotoImportParams* _tmp14_;
	PhotoImportParams* _tmp15_;
	ImportID _tmp16_;
	PhotoImportParams* _tmp17_;
	EventID _tmp18_ = {0};
	PhotoImportParams* _tmp19_;
	PhotoImportParams* _tmp20_;
	PhotoImportParams* _tmp21_;
	PhotoImportParams* _tmp22_;
	PhotoImportParams* _tmp23_;
	PhotoImportParams* _tmp24_;
	PhotoImportParams* _tmp25_;
	PhotoImportParams* _tmp26_;
	PhotoImportParams* _tmp27_;
#line 769 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO_IMPORT_PARAMS (params));
#line 770 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp0_ = params;
#line 770 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp1_ = _tmp0_->file;
#line 770 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 770 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	file = _tmp2_;
#line 771 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp3_ = params;
#line 771 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	photo_id_init (&_tmp4_, PHOTO_ID_INVALID);
#line 771 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp3_->row.photo_id = _tmp4_;
#line 772 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp5_ = params;
#line 772 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp6_ = g_file_get_path (file);
#line 772 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_g_free0 (_tmp5_->row.master.filepath);
#line 772 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp5_->row.master.filepath = _tmp6_;
#line 773 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp7_ = params;
#line 773 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	dimensions_init (&_tmp8_, 0, 0);
#line 773 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp7_->row.master.dim = _tmp8_;
#line 774 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp9_ = params;
#line 774 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp9_->row.master.filesize = (gint64) 0;
#line 775 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp10_ = params;
#line 775 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp10_->row.master.timestamp = (time_t) 0;
#line 776 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp11_ = params;
#line 776 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp11_->row.exposure_time = (time_t) 0;
#line 777 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp12_ = params;
#line 777 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp12_->row.orientation = ORIENTATION_TOP_LEFT;
#line 778 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp13_ = params;
#line 778 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp13_->row.master.original_orientation = ORIENTATION_TOP_LEFT;
#line 779 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp14_ = params;
#line 779 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp15_ = params;
#line 779 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp16_ = _tmp15_->import_id;
#line 779 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp14_->row.import_id = _tmp16_;
#line 780 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp17_ = params;
#line 780 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	event_id_init (&_tmp18_, EVENT_ID_INVALID);
#line 780 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp17_->row.event_id = _tmp18_;
#line 781 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp19_ = params;
#line 781 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_g_object_unref0 (_tmp19_->row.transformations);
#line 781 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp19_->row.transformations = NULL;
#line 782 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp20_ = params;
#line 782 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_g_free0 (_tmp20_->row.md5);
#line 782 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp20_->row.md5 = NULL;
#line 783 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp21_ = params;
#line 783 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_g_free0 (_tmp21_->row.thumbnail_md5);
#line 783 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp21_->row.thumbnail_md5 = NULL;
#line 784 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp22_ = params;
#line 784 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_g_free0 (_tmp22_->row.exif_md5);
#line 784 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp22_->row.exif_md5 = NULL;
#line 785 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp23_ = params;
#line 785 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp23_->row.time_created = (time_t) 0;
#line 786 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp24_ = params;
#line 786 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp24_->row.flags = (guint64) 0;
#line 787 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp25_ = params;
#line 787 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp25_->row.master.file_format = PHOTO_FILE_FORMAT_JFIF;
#line 788 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp26_ = params;
#line 788 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_g_free0 (_tmp26_->row.title);
#line 788 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp26_->row.title = NULL;
#line 789 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp27_ = params;
#line 789 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp27_->row.rating = RATING_UNRATED;
#line 769 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_g_object_unref0 (file);
#line 6553 "Photo.c"
}


gboolean photo_query_backing_photo_state (Photo* self, GFile* file, PhotoFileSnifferOptions options, BackingPhotoState* state, DetectedPhotoInformation** detected, GError** error) {
	BackingPhotoState _vala_state = {0};
	DetectedPhotoInformation* _vala_detected = NULL;
	gboolean result = FALSE;
	GFileInfo* info;
	GFile* _tmp8_;
	PhotoFileSnifferOptions _tmp9_;
	PhotoFileInterrogator* _tmp10_;
	PhotoFileInterrogator* interrogator;
	PhotoFileInterrogator* _tmp11_;
	PhotoFileInterrogator* _tmp12_;
	DetectedPhotoInformation* _tmp13_ = NULL;
	DetectedPhotoInformation* _tmp14_;
	GTimeVal modification_time = {0};
	GFileInfo* _tmp17_;
	GTimeVal _tmp18_ = {0};
	GFile* _tmp19_;
	gchar* _tmp20_ = NULL;
	GTimeVal _tmp21_;
	glong _tmp22_;
	GFileInfo* _tmp23_;
	gint64 _tmp24_ = 0LL;
	DetectedPhotoInformation* _tmp25_;
	PhotoFileFormat _tmp26_;
	DetectedPhotoInformation* _tmp27_;
	Dimensions _tmp28_;
	Orientation _tmp29_ = 0;
	DetectedPhotoInformation* _tmp30_;
	PhotoMetadata* _tmp31_;
	Orientation _tmp35_;
	GError * _inner_error_ = NULL;
#line 792 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 792 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail (G_IS_FILE (file), FALSE);
#line 795 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	info = NULL;
#line 6594 "Photo.c"
	{
		GFile* _tmp0_;
		GFileInfo* _tmp1_ = NULL;
		GFileInfo* _tmp2_;
#line 797 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp0_ = file;
#line 797 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp1_ = g_file_query_info (_tmp0_, DIRECTORY_MONITOR_SUPPLIED_ATTRIBUTES, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, NULL, &_inner_error_);
#line 797 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp2_ = _tmp1_;
#line 797 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 6607 "Photo.c"
			goto __catch132_g_error;
		}
#line 797 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_object_unref0 (info);
#line 797 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		info = _tmp2_;
#line 6614 "Photo.c"
	}
	goto __finally132;
	__catch132_g_error:
	{
		GError* err = NULL;
		GFile* _tmp3_;
		gchar* _tmp4_ = NULL;
		gchar* _tmp5_;
		GError* _tmp6_;
		const gchar* _tmp7_;
#line 796 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		err = _inner_error_;
#line 796 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_inner_error_ = NULL;
#line 800 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp3_ = file;
#line 800 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp4_ = g_file_get_path (_tmp3_);
#line 800 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp5_ = _tmp4_;
#line 800 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp6_ = err;
#line 800 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp7_ = _tmp6_->message;
#line 800 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_critical ("Photo.vala:800: Unable to read file information for %s: %s", _tmp5_, _tmp7_);
#line 800 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_free0 (_tmp5_);
#line 802 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		result = FALSE;
#line 802 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_error_free0 (err);
#line 802 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_object_unref0 (info);
#line 802 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		if (state) {
#line 802 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			*state = _vala_state;
#line 6653 "Photo.c"
		} else {
#line 802 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			backing_photo_state_destroy (&_vala_state);
#line 6657 "Photo.c"
		}
#line 802 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		if (detected) {
#line 802 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			*detected = _vala_detected;
#line 6663 "Photo.c"
		} else {
#line 802 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_detected_photo_information_unref0 (_vala_detected);
#line 6667 "Photo.c"
		}
#line 802 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return result;
#line 6671 "Photo.c"
	}
	__finally132:
#line 796 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 796 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 796 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_object_unref0 (info);
#line 796 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return FALSE;
#line 6682 "Photo.c"
	}
#line 806 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp8_ = file;
#line 806 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp9_ = options;
#line 806 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp10_ = photo_file_interrogator_new (_tmp8_, _tmp9_);
#line 806 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	interrogator = _tmp10_;
#line 807 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp11_ = interrogator;
#line 807 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	photo_file_interrogator_interrogate (_tmp11_, &_inner_error_);
#line 807 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 807 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 807 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_photo_file_interrogator_unref0 (interrogator);
#line 807 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_object_unref0 (info);
#line 807 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return FALSE;
#line 6706 "Photo.c"
	}
#line 808 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp12_ = interrogator;
#line 808 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp13_ = photo_file_interrogator_get_detected_photo_information (_tmp12_);
#line 808 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_detected_photo_information_unref0 (_vala_detected);
#line 808 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_vala_detected = _tmp13_;
#line 809 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp14_ = _vala_detected;
#line 809 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp14_ == NULL) {
#line 6720 "Photo.c"
		gchar* _tmp15_ = NULL;
		gchar* _tmp16_;
#line 810 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp15_ = data_object_to_string (DATA_OBJECT (self));
#line 810 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp16_ = _tmp15_;
#line 810 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_critical ("Photo.vala:810: Photo update: %s no longer a recognized image", _tmp16_);
#line 810 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_free0 (_tmp16_);
#line 812 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		result = FALSE;
#line 812 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_photo_file_interrogator_unref0 (interrogator);
#line 812 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_object_unref0 (info);
#line 812 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		if (state) {
#line 812 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			*state = _vala_state;
#line 6741 "Photo.c"
		} else {
#line 812 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			backing_photo_state_destroy (&_vala_state);
#line 6745 "Photo.c"
		}
#line 812 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		if (detected) {
#line 812 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			*detected = _vala_detected;
#line 6751 "Photo.c"
		} else {
#line 812 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_detected_photo_information_unref0 (_vala_detected);
#line 6755 "Photo.c"
		}
#line 812 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return result;
#line 6759 "Photo.c"
	}
#line 815 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_get_current_time (&modification_time);
#line 816 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp17_ = info;
#line 816 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_file_info_get_modification_time (_tmp17_, &_tmp18_);
#line 816 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	modification_time = _tmp18_;
#line 818 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp19_ = file;
#line 818 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp20_ = g_file_get_path (_tmp19_);
#line 818 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_g_free0 (_vala_state.filepath);
#line 818 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_vala_state.filepath = _tmp20_;
#line 819 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp21_ = modification_time;
#line 819 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp22_ = _tmp21_.tv_sec;
#line 819 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_vala_state.timestamp = (time_t) _tmp22_;
#line 820 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp23_ = info;
#line 820 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp24_ = g_file_info_get_size (_tmp23_);
#line 820 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_vala_state.filesize = _tmp24_;
#line 821 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp25_ = _vala_detected;
#line 821 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp26_ = _tmp25_->file_format;
#line 821 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_vala_state.file_format = _tmp26_;
#line 822 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp27_ = _vala_detected;
#line 822 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp28_ = _tmp27_->image_dim;
#line 822 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_vala_state.dim = _tmp28_;
#line 823 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp30_ = _vala_detected;
#line 823 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp31_ = _tmp30_->metadata;
#line 823 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp31_ != NULL) {
#line 6807 "Photo.c"
		DetectedPhotoInformation* _tmp32_;
		PhotoMetadata* _tmp33_;
		Orientation _tmp34_ = 0;
#line 824 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp32_ = _vala_detected;
#line 824 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp33_ = _tmp32_->metadata;
#line 824 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp34_ = photo_metadata_get_orientation (_tmp33_);
#line 824 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp29_ = _tmp34_;
#line 6819 "Photo.c"
	} else {
#line 824 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp29_ = ORIENTATION_TOP_LEFT;
#line 6823 "Photo.c"
	}
#line 823 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp35_ = _tmp29_;
#line 823 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_vala_state.original_orientation = _tmp35_;
#line 826 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	result = TRUE;
#line 826 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_photo_file_interrogator_unref0 (interrogator);
#line 826 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_g_object_unref0 (info);
#line 826 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (state) {
#line 826 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		*state = _vala_state;
#line 6839 "Photo.c"
	} else {
#line 826 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		backing_photo_state_destroy (&_vala_state);
#line 6843 "Photo.c"
	}
#line 826 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (detected) {
#line 826 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		*detected = _vala_detected;
#line 6849 "Photo.c"
	} else {
#line 826 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_detected_photo_information_unref0 (_vala_detected);
#line 6853 "Photo.c"
	}
#line 826 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return result;
#line 6857 "Photo.c"
}


static void _vala_array_add205 (gchar*** array, int* length, int* size, gchar* value) {
#line 891 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if ((*length) == (*size)) {
#line 891 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 891 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 6868 "Photo.c"
	}
#line 891 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	(*array)[(*length)++] = value;
#line 891 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	(*array)[*length] = NULL;
#line 6874 "Photo.c"
}


static void _vala_array_add206 (gchar*** array, int* length, int* size, gchar* value) {
#line 894 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if ((*length) == (*size)) {
#line 894 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 894 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 6885 "Photo.c"
	}
#line 894 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	(*array)[(*length)++] = value;
#line 894 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	(*array)[*length] = NULL;
#line 6891 "Photo.c"
}


static void _vala_array_add207 (gchar*** array, int* length, int* size, gchar* value) {
#line 901 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if ((*length) == (*size)) {
#line 901 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 901 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 6902 "Photo.c"
	}
#line 901 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	(*array)[(*length)++] = value;
#line 901 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	(*array)[*length] = NULL;
#line 6908 "Photo.c"
}


static void _vala_array_add208 (gchar*** array, int* length, int* size, gchar* value) {
#line 904 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if ((*length) == (*size)) {
#line 904 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 904 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 6919 "Photo.c"
	}
#line 904 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	(*array)[(*length)++] = value;
#line 904 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	(*array)[*length] = NULL;
#line 6925 "Photo.c"
}


static void _vala_array_add209 (gchar*** array, int* length, int* size, gchar* value) {
#line 907 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if ((*length) == (*size)) {
#line 907 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 907 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 6936 "Photo.c"
	}
#line 907 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	(*array)[(*length)++] = value;
#line 907 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	(*array)[*length] = NULL;
#line 6942 "Photo.c"
}


static gpointer _media_metadata_ref0 (gpointer self) {
#line 917 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return self ? media_metadata_ref (self) : NULL;
#line 6949 "Photo.c"
}


gboolean photo_prepare_for_reimport_master (Photo* self, PhotoReimportMasterState** reimport_state, GError** error) {
	PhotoReimportMasterState* _vala_reimport_state = NULL;
	gboolean result = FALSE;
	PhotoFileReader* _tmp0_ = NULL;
	PhotoFileReader* _tmp1_;
	GFile* _tmp2_ = NULL;
	GFile* _tmp3_;
	GFile* file;
	BackingPhotoState state = {0};
	DetectedPhotoInformation* detected = NULL;
	GFile* _tmp4_;
	BackingPhotoState _tmp5_ = {0};
	DetectedPhotoInformation* _tmp6_ = NULL;
	gboolean _tmp7_ = FALSE;
	gboolean _tmp8_;
	gboolean _tmp12_ = FALSE;
	gboolean _tmp13_ = FALSE;
	DetectedPhotoInformation* _tmp14_;
	GdkColorspace _tmp15_;
	gboolean _tmp18_;
	gboolean _tmp21_;
	PhotoRow updated_row = {0};
	gchar** _tmp29_ = NULL;
	gchar** list;
	gint list_length1;
	gint _list_size_;
	PhotoRow _tmp30_;
	const gchar* _tmp31_;
	DetectedPhotoInformation* _tmp32_;
	const gchar* _tmp33_;
	PhotoRow _tmp36_;
	BackingPhotoState _tmp37_;
	Orientation _tmp38_;
	BackingPhotoState _tmp39_;
	Orientation _tmp40_;
	DetectedPhotoInformation* _tmp45_;
	PhotoMetadata* _tmp46_;
	BackingPhotoState _tmp75_;
	BackingPhotoState _tmp76_ = {0};
	DetectedPhotoInformation* _tmp77_;
	const gchar* _tmp78_;
	gchar* _tmp79_;
	DetectedPhotoInformation* _tmp80_;
	const gchar* _tmp81_;
	gchar* _tmp82_;
	DetectedPhotoInformation* _tmp83_;
	const gchar* _tmp84_;
	gchar* _tmp85_;
	PhotoMetadata* metadata;
	DetectedPhotoInformation* _tmp86_;
	PhotoMetadata* _tmp87_;
	PhotoRow _tmp103_;
	PhotoMetadata* _tmp104_;
	gchar** _tmp105_;
	gint _tmp105__length1;
	PhotoReimportMasterStateImpl* _tmp106_;
	GError * _inner_error_ = NULL;
#line 861 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 862 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp0_ = photo_get_master_reader (self);
#line 862 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 862 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp2_ = photo_file_adapter_get_file (PHOTO_FILE_ADAPTER (_tmp1_));
#line 862 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp3_ = _tmp2_;
#line 862 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_photo_file_adapter_unref0 (_tmp1_);
#line 862 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	file = _tmp3_;
#line 864 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	memset (&state, 0, sizeof (BackingPhotoState));
#line 866 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp4_ = file;
#line 866 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp7_ = photo_query_backing_photo_state (self, _tmp4_, PHOTO_FILE_SNIFFER_OPTIONS_GET_ALL, &_tmp5_, &_tmp6_, &_inner_error_);
#line 866 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	backing_photo_state_destroy (&state);
#line 866 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	state = _tmp5_;
#line 866 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_detected_photo_information_unref0 (detected);
#line 866 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	detected = _tmp6_;
#line 866 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp8_ = _tmp7_;
#line 866 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 866 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 866 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 866 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		backing_photo_state_destroy (&state);
#line 866 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_object_unref0 (file);
#line 866 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return FALSE;
#line 7052 "Photo.c"
	}
#line 866 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (!_tmp8_) {
#line 7056 "Photo.c"
		GFile* _tmp9_;
		gchar* _tmp10_ = NULL;
		gchar* _tmp11_;
#line 867 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp9_ = file;
#line 867 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp10_ = g_file_get_path (_tmp9_);
#line 867 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp11_ = _tmp10_;
#line 867 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_warning ("Photo.vala:867: Unable to retrieve photo state from %s for reimport", _tmp11_);
#line 867 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_free0 (_tmp11_);
#line 869 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		result = FALSE;
#line 869 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 869 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		backing_photo_state_destroy (&state);
#line 869 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_object_unref0 (file);
#line 869 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		if (reimport_state) {
#line 869 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			*reimport_state = _vala_reimport_state;
#line 7082 "Photo.c"
		} else {
#line 869 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_photo_reimport_master_state_unref0 (_vala_reimport_state);
#line 7086 "Photo.c"
		}
#line 869 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return result;
#line 7090 "Photo.c"
	}
#line 873 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp14_ = detected;
#line 873 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp15_ = _tmp14_->colorspace;
#line 873 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp15_ != GDK_COLORSPACE_RGB) {
#line 873 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp13_ = TRUE;
#line 7100 "Photo.c"
	} else {
		DetectedPhotoInformation* _tmp16_;
		gint _tmp17_;
#line 874 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp16_ = detected;
#line 874 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp17_ = _tmp16_->channels;
#line 874 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp13_ = _tmp17_ < 3;
#line 7110 "Photo.c"
	}
#line 873 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp18_ = _tmp13_;
#line 873 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp18_) {
#line 873 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp12_ = TRUE;
#line 7118 "Photo.c"
	} else {
		DetectedPhotoInformation* _tmp19_;
		gint _tmp20_;
#line 875 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp19_ = detected;
#line 875 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp20_ = _tmp19_->bits_per_channel;
#line 875 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp12_ = _tmp20_ != 8;
#line 7128 "Photo.c"
	}
#line 873 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp21_ = _tmp12_;
#line 873 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp21_) {
#line 7134 "Photo.c"
		GFile* _tmp22_;
		gchar* _tmp23_ = NULL;
		gchar* _tmp24_;
#line 876 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp22_ = file;
#line 876 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp23_ = g_file_get_path (_tmp22_);
#line 876 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp24_ = _tmp23_;
#line 876 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_warning ("Photo.vala:876: Not re-importing %s: Unsupported color format", _tmp24_);
#line 876 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_free0 (_tmp24_);
#line 878 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		result = FALSE;
#line 878 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 878 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		backing_photo_state_destroy (&state);
#line 878 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_object_unref0 (file);
#line 878 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		if (reimport_state) {
#line 878 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			*reimport_state = _vala_reimport_state;
#line 7160 "Photo.c"
		} else {
#line 878 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_photo_reimport_master_state_unref0 (_vala_reimport_state);
#line 7164 "Photo.c"
		}
#line 878 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return result;
#line 7168 "Photo.c"
	}
#line 882 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	photo_row_init (&updated_row);
#line 7172 "Photo.c"
	{
		PhotoRow _tmp25_;
#line 883 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp25_ = self->priv->row;
#line 883 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 7179 "Photo.c"
		{
			PhotoRow _tmp26_;
			PhotoRow _tmp27_ = {0};
#line 884 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp26_ = self->priv->row;
#line 884 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			photo_row_copy (&_tmp26_, &_tmp27_);
#line 884 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			photo_row_destroy (&updated_row);
#line 884 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			updated_row = _tmp27_;
#line 7191 "Photo.c"
		}
		__finally133:
		{
			PhotoRow _tmp28_;
#line 883 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp28_ = self->priv->row;
#line 883 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 7200 "Photo.c"
		}
#line 883 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 883 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 883 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			photo_row_destroy (&updated_row);
#line 883 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_detected_photo_information_unref0 (detected);
#line 883 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			backing_photo_state_destroy (&state);
#line 883 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_g_object_unref0 (file);
#line 883 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			return FALSE;
#line 7216 "Photo.c"
		}
	}
#line 888 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp29_ = g_new0 (gchar*, 0 + 1);
#line 888 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	list = _tmp29_;
#line 888 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	list_length1 = 0;
#line 888 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_list_size_ = list_length1;
#line 890 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp30_ = updated_row;
#line 890 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp31_ = _tmp30_.md5;
#line 890 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp32_ = detected;
#line 890 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp33_ = _tmp32_->md5;
#line 890 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (g_strcmp0 (_tmp31_, _tmp33_) != 0) {
#line 7237 "Photo.c"
		gchar** _tmp34_;
		gint _tmp34__length1;
		gchar* _tmp35_;
#line 891 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp34_ = list;
#line 891 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp34__length1 = list_length1;
#line 891 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp35_ = g_strdup ("metadata:md5");
#line 891 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_vala_array_add205 (&list, &list_length1, &_list_size_, _tmp35_);
#line 7249 "Photo.c"
	}
#line 893 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp36_ = updated_row;
#line 893 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp37_ = _tmp36_.master;
#line 893 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp38_ = _tmp37_.original_orientation;
#line 893 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp39_ = state;
#line 893 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp40_ = _tmp39_.original_orientation;
#line 893 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp38_ != _tmp40_) {
#line 7263 "Photo.c"
		gchar** _tmp41_;
		gint _tmp41__length1;
		gchar* _tmp42_;
		BackingPhotoState _tmp43_;
		Orientation _tmp44_;
#line 894 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp41_ = list;
#line 894 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp41__length1 = list_length1;
#line 894 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp42_ = g_strdup ("image:orientation");
#line 894 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_vala_array_add206 (&list, &list_length1, &_list_size_, _tmp42_);
#line 895 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp43_ = state;
#line 895 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp44_ = _tmp43_.original_orientation;
#line 895 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		updated_row.orientation = _tmp44_;
#line 7283 "Photo.c"
	}
#line 898 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp45_ = detected;
#line 898 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp46_ = _tmp45_->metadata;
#line 898 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp46_ != NULL) {
#line 7291 "Photo.c"
		DetectedPhotoInformation* _tmp47_;
		PhotoMetadata* _tmp48_;
		MetadataDateTime* _tmp49_ = NULL;
		MetadataDateTime* date_time;
		gboolean _tmp50_ = FALSE;
		MetadataDateTime* _tmp51_;
		gboolean _tmp56_;
		PhotoRow _tmp59_;
		const gchar* _tmp60_;
		DetectedPhotoInformation* _tmp61_;
		PhotoMetadata* _tmp62_;
		gchar* _tmp63_ = NULL;
		gchar* _tmp64_;
		gboolean _tmp65_;
		PhotoRow _tmp68_;
		Rating _tmp69_;
		DetectedPhotoInformation* _tmp70_;
		PhotoMetadata* _tmp71_;
		Rating _tmp72_ = 0;
#line 899 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp47_ = detected;
#line 899 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp48_ = _tmp47_->metadata;
#line 899 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp49_ = photo_metadata_get_exposure_date_time (_tmp48_);
#line 899 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		date_time = _tmp49_;
#line 900 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp51_ = date_time;
#line 900 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		if (_tmp51_ != NULL) {
#line 7323 "Photo.c"
			PhotoRow _tmp52_;
			time_t _tmp53_;
			MetadataDateTime* _tmp54_;
			time_t _tmp55_ = 0;
#line 900 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp52_ = updated_row;
#line 900 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp53_ = _tmp52_.exposure_time;
#line 900 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp54_ = date_time;
#line 900 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp55_ = metadata_date_time_get_timestamp (_tmp54_);
#line 900 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp50_ = _tmp53_ != _tmp55_;
#line 7338 "Photo.c"
		} else {
#line 900 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp50_ = FALSE;
#line 7342 "Photo.c"
		}
#line 900 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp56_ = _tmp50_;
#line 900 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		if (_tmp56_) {
#line 7348 "Photo.c"
			gchar** _tmp57_;
			gint _tmp57__length1;
			gchar* _tmp58_;
#line 901 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp57_ = list;
#line 901 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp57__length1 = list_length1;
#line 901 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp58_ = g_strdup ("metadata:exposure-time");
#line 901 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_vala_array_add207 (&list, &list_length1, &_list_size_, _tmp58_);
#line 7360 "Photo.c"
		}
#line 903 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp59_ = updated_row;
#line 903 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp60_ = _tmp59_.title;
#line 903 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp61_ = detected;
#line 903 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp62_ = _tmp61_->metadata;
#line 903 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp63_ = media_metadata_get_title (MEDIA_METADATA (_tmp62_));
#line 903 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp64_ = _tmp63_;
#line 903 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp65_ = g_strcmp0 (_tmp60_, _tmp64_) != 0;
#line 903 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_free0 (_tmp64_);
#line 903 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		if (_tmp65_) {
#line 7380 "Photo.c"
			gchar** _tmp66_;
			gint _tmp66__length1;
			gchar* _tmp67_;
#line 904 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp66_ = list;
#line 904 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp66__length1 = list_length1;
#line 904 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp67_ = g_strdup ("metadata:name");
#line 904 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_vala_array_add208 (&list, &list_length1, &_list_size_, _tmp67_);
#line 7392 "Photo.c"
		}
#line 906 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp68_ = updated_row;
#line 906 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp69_ = _tmp68_.rating;
#line 906 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp70_ = detected;
#line 906 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp71_ = _tmp70_->metadata;
#line 906 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp72_ = photo_metadata_get_rating (_tmp71_);
#line 906 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		if (_tmp69_ != _tmp72_) {
#line 7406 "Photo.c"
			gchar** _tmp73_;
			gint _tmp73__length1;
			gchar* _tmp74_;
#line 907 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp73_ = list;
#line 907 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp73__length1 = list_length1;
#line 907 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp74_ = g_strdup ("metadata:rating");
#line 907 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_vala_array_add209 (&list, &list_length1, &_list_size_, _tmp74_);
#line 7418 "Photo.c"
		}
#line 898 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_metadata_date_time_unref0 (date_time);
#line 7422 "Photo.c"
	}
#line 910 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp75_ = state;
#line 910 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	backing_photo_state_copy (&_tmp75_, &_tmp76_);
#line 910 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	backing_photo_state_destroy (&updated_row.master);
#line 910 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	updated_row.master = _tmp76_;
#line 911 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp77_ = detected;
#line 911 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp78_ = _tmp77_->md5;
#line 911 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp79_ = g_strdup (_tmp78_);
#line 911 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_g_free0 (updated_row.md5);
#line 911 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	updated_row.md5 = _tmp79_;
#line 912 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp80_ = detected;
#line 912 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp81_ = _tmp80_->exif_md5;
#line 912 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp82_ = g_strdup (_tmp81_);
#line 912 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_g_free0 (updated_row.exif_md5);
#line 912 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	updated_row.exif_md5 = _tmp82_;
#line 913 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp83_ = detected;
#line 913 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp84_ = _tmp83_->thumbnail_md5;
#line 913 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp85_ = g_strdup (_tmp84_);
#line 913 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_g_free0 (updated_row.thumbnail_md5);
#line 913 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	updated_row.thumbnail_md5 = _tmp85_;
#line 915 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	metadata = NULL;
#line 916 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp86_ = detected;
#line 916 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp87_ = _tmp86_->metadata;
#line 916 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp87_ != NULL) {
#line 7470 "Photo.c"
		DetectedPhotoInformation* _tmp88_;
		PhotoMetadata* _tmp89_;
		PhotoMetadata* _tmp90_;
		DetectedPhotoInformation* _tmp91_;
		PhotoMetadata* _tmp92_;
		MetadataDateTime* _tmp93_ = NULL;
		MetadataDateTime* date_time;
		MetadataDateTime* _tmp94_;
		DetectedPhotoInformation* _tmp97_;
		PhotoMetadata* _tmp98_;
		gchar* _tmp99_ = NULL;
		DetectedPhotoInformation* _tmp100_;
		PhotoMetadata* _tmp101_;
		Rating _tmp102_ = 0;
#line 917 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp88_ = detected;
#line 917 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp89_ = _tmp88_->metadata;
#line 917 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp90_ = _media_metadata_ref0 (_tmp89_);
#line 917 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 917 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		metadata = _tmp90_;
#line 919 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp91_ = detected;
#line 919 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp92_ = _tmp91_->metadata;
#line 919 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp93_ = photo_metadata_get_exposure_date_time (_tmp92_);
#line 919 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		date_time = _tmp93_;
#line 920 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp94_ = date_time;
#line 920 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		if (_tmp94_ != NULL) {
#line 7507 "Photo.c"
			MetadataDateTime* _tmp95_;
			time_t _tmp96_ = 0;
#line 921 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp95_ = date_time;
#line 921 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp96_ = metadata_date_time_get_timestamp (_tmp95_);
#line 921 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			updated_row.exposure_time = _tmp96_;
#line 7516 "Photo.c"
		}
#line 923 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp97_ = detected;
#line 923 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp98_ = _tmp97_->metadata;
#line 923 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp99_ = media_metadata_get_title (MEDIA_METADATA (_tmp98_));
#line 923 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_free0 (updated_row.title);
#line 923 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		updated_row.title = _tmp99_;
#line 924 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp100_ = detected;
#line 924 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp101_ = _tmp100_->metadata;
#line 924 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp102_ = photo_metadata_get_rating (_tmp101_);
#line 924 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		updated_row.rating = _tmp102_;
#line 916 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_metadata_date_time_unref0 (date_time);
#line 7538 "Photo.c"
	}
#line 927 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp103_ = updated_row;
#line 927 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp104_ = metadata;
#line 927 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp105_ = list;
#line 927 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp105__length1 = list_length1;
#line 927 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp106_ = photo_reimport_master_state_impl_new (&_tmp103_, _tmp104_, _tmp105_, _tmp105__length1);
#line 927 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_photo_reimport_master_state_unref0 (_vala_reimport_state);
#line 927 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_vala_reimport_state = PHOTO_REIMPORT_MASTER_STATE (_tmp106_);
#line 929 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	result = TRUE;
#line 929 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_media_metadata_unref0 (metadata);
#line 929 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	list = (_vala_array_free (list, list_length1, (GDestroyNotify) g_free), NULL);
#line 929 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	photo_row_destroy (&updated_row);
#line 929 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_detected_photo_information_unref0 (detected);
#line 929 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	backing_photo_state_destroy (&state);
#line 929 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_g_object_unref0 (file);
#line 929 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (reimport_state) {
#line 929 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		*reimport_state = _vala_reimport_state;
#line 7572 "Photo.c"
	} else {
#line 929 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_photo_reimport_master_state_unref0 (_vala_reimport_state);
#line 7576 "Photo.c"
	}
#line 929 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return result;
#line 7580 "Photo.c"
}


static void photo_real_apply_user_metadata_for_reimport (Photo* self, PhotoMetadata* metadata) {
#line 932 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_critical ("Type `%s' does not implement abstract method `photo_apply_user_metadata_for_reimport'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 932 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return;
#line 7589 "Photo.c"
}


void photo_apply_user_metadata_for_reimport (Photo* self, PhotoMetadata* metadata) {
#line 932 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 932 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	PHOTO_GET_CLASS (self)->apply_user_metadata_for_reimport (self, metadata);
#line 7598 "Photo.c"
}


static gpointer _photo_reimport_master_state_ref0 (gpointer self) {
#line 936 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return self ? photo_reimport_master_state_ref (self) : NULL;
#line 7605 "Photo.c"
}


static void _vala_array_add210 (gchar*** array, int* length, int* size, gchar* value) {
#line 950 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if ((*length) == (*size)) {
#line 950 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 950 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 7616 "Photo.c"
	}
#line 950 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	(*array)[(*length)++] = value;
#line 950 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	(*array)[*length] = NULL;
#line 7622 "Photo.c"
}


static void _vala_array_add211 (gchar*** array, int* length, int* size, gchar* value) {
#line 952 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if ((*length) == (*size)) {
#line 952 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 952 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 7633 "Photo.c"
	}
#line 952 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	(*array)[(*length)++] = value;
#line 952 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	(*array)[*length] = NULL;
#line 7639 "Photo.c"
}


void photo_finish_reimport_master (Photo* self, PhotoReimportMasterState* state, GError** error) {
	PhotoReimportMasterState* _tmp0_;
	PhotoReimportMasterStateImpl* _tmp1_;
	PhotoReimportMasterStateImpl* reimport_state;
	PhotoTable* _tmp2_ = NULL;
	PhotoTable* _tmp3_;
	PhotoMetadata* _tmp9_;
	gboolean _tmp11_;
	gchar** _tmp17_;
	gint _tmp17__length1;
	PhotoMetadata* _tmp21_;
	gboolean _tmp22_ = FALSE;
	gboolean _tmp24_ = FALSE;
	GError * _inner_error_ = NULL;
#line 935 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 935 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail (PHOTO_IS_REIMPORT_MASTER_STATE (state));
#line 936 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp0_ = state;
#line 936 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp1_ = _photo_reimport_master_state_ref0 (PHOTO_REIMPORT_MASTER_STATE_IMPL (_tmp0_));
#line 936 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	reimport_state = _tmp1_;
#line 938 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp2_ = photo_table_get_instance ();
#line 938 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp3_ = _tmp2_;
#line 938 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	photo_table_reimport (_tmp3_, &reimport_state->row, &_inner_error_);
#line 938 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_database_table_unref0 (_tmp3_);
#line 938 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 938 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		if (_inner_error_->domain == DATABASE_ERROR) {
#line 938 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 938 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_photo_reimport_master_state_unref0 (reimport_state);
#line 938 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			return;
#line 7685 "Photo.c"
		} else {
#line 938 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_photo_reimport_master_state_unref0 (reimport_state);
#line 938 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 938 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 938 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			return;
#line 7695 "Photo.c"
		}
	}
	{
		PhotoRow _tmp4_;
#line 940 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp4_ = self->priv->row;
#line 940 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 7704 "Photo.c"
		{
			PhotoRow _tmp5_;
			PhotoRow _tmp6_ = {0};
			gboolean _tmp7_;
#line 941 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp5_ = reimport_state->row;
#line 941 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			photo_row_copy (&_tmp5_, &_tmp6_);
#line 941 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			photo_row_destroy (&self->priv->row);
#line 941 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			self->priv->row = _tmp6_;
#line 942 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp7_ = reimport_state->metadata_only;
#line 942 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			if (!_tmp7_) {
#line 943 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				photo_internal_remove_all_transformations (self, FALSE);
#line 7723 "Photo.c"
			}
		}
		__finally134:
		{
			PhotoRow _tmp8_;
#line 940 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp8_ = self->priv->row;
#line 940 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 7733 "Photo.c"
		}
#line 940 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 940 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			if (_inner_error_->domain == DATABASE_ERROR) {
#line 940 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				g_propagate_error (error, _inner_error_);
#line 940 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_photo_reimport_master_state_unref0 (reimport_state);
#line 940 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				return;
#line 7745 "Photo.c"
			} else {
#line 940 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_photo_reimport_master_state_unref0 (reimport_state);
#line 940 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 940 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				g_clear_error (&_inner_error_);
#line 940 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				return;
#line 7755 "Photo.c"
			}
		}
	}
#line 946 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp9_ = reimport_state->metadata;
#line 946 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp9_ != NULL) {
#line 7763 "Photo.c"
		PhotoMetadata* _tmp10_;
#line 947 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp10_ = reimport_state->metadata;
#line 947 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		photo_apply_user_metadata_for_reimport (self, _tmp10_);
#line 7769 "Photo.c"
	}
#line 949 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp11_ = reimport_state->metadata_only;
#line 949 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (!_tmp11_) {
#line 7775 "Photo.c"
		gchar** _tmp12_;
		gint _tmp12__length1;
		gchar* _tmp13_;
		gboolean _tmp14_ = FALSE;
#line 950 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp12_ = reimport_state->alterations;
#line 950 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp12__length1 = reimport_state->alterations_length1;
#line 950 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp13_ = g_strdup ("image:master");
#line 950 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_vala_array_add210 (&reimport_state->alterations, &reimport_state->alterations_length1, &reimport_state->_alterations_size_, _tmp13_);
#line 951 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp14_ = photo_is_master_baseline (self);
#line 951 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		if (_tmp14_) {
#line 7792 "Photo.c"
			gchar** _tmp15_;
			gint _tmp15__length1;
			gchar* _tmp16_;
#line 952 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp15_ = reimport_state->alterations;
#line 952 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp15__length1 = reimport_state->alterations_length1;
#line 952 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp16_ = g_strdup ("image:baseline");
#line 952 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_vala_array_add211 (&reimport_state->alterations, &reimport_state->alterations_length1, &reimport_state->_alterations_size_, _tmp16_);
#line 7804 "Photo.c"
		}
	}
#line 955 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp17_ = reimport_state->alterations;
#line 955 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp17__length1 = reimport_state->alterations_length1;
#line 955 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp17__length1 > 0) {
#line 7813 "Photo.c"
		gchar** _tmp18_;
		gint _tmp18__length1;
		Alteration* _tmp19_;
		Alteration* _tmp20_;
#line 956 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp18_ = reimport_state->alterations;
#line 956 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp18__length1 = reimport_state->alterations_length1;
#line 956 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp19_ = alteration_new_from_array (_tmp18_, _tmp18__length1);
#line 956 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp20_ = _tmp19_;
#line 956 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		data_object_notify_altered (DATA_OBJECT (self), _tmp20_);
#line 956 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_alteration_unref0 (_tmp20_);
#line 7830 "Photo.c"
	}
#line 958 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp21_ = reimport_state->metadata;
#line 958 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	photo_notify_master_reimported (self, _tmp21_);
#line 960 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp22_ = photo_is_master_baseline (self);
#line 960 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp22_) {
#line 7840 "Photo.c"
		PhotoMetadata* _tmp23_;
#line 961 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp23_ = reimport_state->metadata;
#line 961 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		photo_notify_baseline_reimported (self, _tmp23_);
#line 7846 "Photo.c"
	}
#line 963 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp24_ = photo_is_master_source (self);
#line 963 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp24_) {
#line 7852 "Photo.c"
		PhotoMetadata* _tmp25_;
#line 964 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp25_ = reimport_state->metadata;
#line 964 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		photo_notify_source_reimported (self, _tmp25_);
#line 7858 "Photo.c"
	}
#line 935 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_photo_reimport_master_state_unref0 (reimport_state);
#line 7862 "Photo.c"
}


gboolean photo_prepare_for_reimport_editable (Photo* self, PhotoReimportEditableState** state, GError** error) {
	PhotoReimportEditableState* _vala_state = NULL;
	gboolean result = FALSE;
	GFile* _tmp0_ = NULL;
	GFile* file;
	GFile* _tmp1_;
	DetectedPhotoInformation* detected = NULL;
	BackingPhotoState backing_state = {0};
	GFile* _tmp2_;
	BackingPhotoState _tmp3_ = {0};
	DetectedPhotoInformation* _tmp4_ = NULL;
	gboolean _tmp5_ = FALSE;
	gboolean _tmp6_;
	gboolean _tmp7_ = FALSE;
	gboolean _tmp8_ = FALSE;
	DetectedPhotoInformation* _tmp9_;
	GdkColorspace _tmp10_;
	gboolean _tmp13_;
	gboolean _tmp16_;
	BackingPhotoState _tmp20_;
	DetectedPhotoInformation* _tmp21_;
	PhotoMetadata* _tmp22_;
	PhotoReimportEditableStateImpl* _tmp23_;
	GError * _inner_error_ = NULL;
#line 968 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 969 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp0_ = photo_get_editable_file (self);
#line 969 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	file = _tmp0_;
#line 970 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp1_ = file;
#line 970 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp1_ == NULL) {
#line 971 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		result = FALSE;
#line 971 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_object_unref0 (file);
#line 971 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		if (state) {
#line 971 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			*state = _vala_state;
#line 7908 "Photo.c"
		} else {
#line 971 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_photo_reimport_editable_state_unref0 (_vala_state);
#line 7912 "Photo.c"
		}
#line 971 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return result;
#line 7916 "Photo.c"
	}
#line 974 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	memset (&backing_state, 0, sizeof (BackingPhotoState));
#line 975 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp2_ = file;
#line 975 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp5_ = photo_query_backing_photo_state (self, _tmp2_, PHOTO_FILE_SNIFFER_OPTIONS_NO_MD5, &_tmp3_, &_tmp4_, &_inner_error_);
#line 975 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	backing_photo_state_destroy (&backing_state);
#line 975 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	backing_state = _tmp3_;
#line 975 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_detected_photo_information_unref0 (detected);
#line 975 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	detected = _tmp4_;
#line 975 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp6_ = _tmp5_;
#line 975 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 975 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 975 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		backing_photo_state_destroy (&backing_state);
#line 975 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 975 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_object_unref0 (file);
#line 975 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return FALSE;
#line 7946 "Photo.c"
	}
#line 975 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (!_tmp6_) {
#line 977 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		result = FALSE;
#line 977 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		backing_photo_state_destroy (&backing_state);
#line 977 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 977 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_object_unref0 (file);
#line 977 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		if (state) {
#line 977 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			*state = _vala_state;
#line 7962 "Photo.c"
		} else {
#line 977 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_photo_reimport_editable_state_unref0 (_vala_state);
#line 7966 "Photo.c"
		}
#line 977 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return result;
#line 7970 "Photo.c"
	}
#line 981 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp9_ = detected;
#line 981 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp10_ = _tmp9_->colorspace;
#line 981 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp10_ != GDK_COLORSPACE_RGB) {
#line 981 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp8_ = TRUE;
#line 7980 "Photo.c"
	} else {
		DetectedPhotoInformation* _tmp11_;
		gint _tmp12_;
#line 982 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp11_ = detected;
#line 982 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp12_ = _tmp11_->channels;
#line 982 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp8_ = _tmp12_ < 3;
#line 7990 "Photo.c"
	}
#line 981 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp13_ = _tmp8_;
#line 981 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp13_) {
#line 981 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp7_ = TRUE;
#line 7998 "Photo.c"
	} else {
		DetectedPhotoInformation* _tmp14_;
		gint _tmp15_;
#line 983 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp14_ = detected;
#line 983 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp15_ = _tmp14_->bits_per_channel;
#line 983 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp7_ = _tmp15_ != 8;
#line 8008 "Photo.c"
	}
#line 981 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp16_ = _tmp7_;
#line 981 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp16_) {
#line 8014 "Photo.c"
		GFile* _tmp17_;
		gchar* _tmp18_ = NULL;
		gchar* _tmp19_;
#line 984 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp17_ = file;
#line 984 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp18_ = g_file_get_path (_tmp17_);
#line 984 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp19_ = _tmp18_;
#line 984 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_warning ("Photo.vala:984: Not re-importing %s: Unsupported color format", _tmp19_);
#line 984 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_free0 (_tmp19_);
#line 986 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		result = FALSE;
#line 986 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		backing_photo_state_destroy (&backing_state);
#line 986 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 986 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_object_unref0 (file);
#line 986 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		if (state) {
#line 986 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			*state = _vala_state;
#line 8040 "Photo.c"
		} else {
#line 986 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_photo_reimport_editable_state_unref0 (_vala_state);
#line 8044 "Photo.c"
		}
#line 986 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return result;
#line 8048 "Photo.c"
	}
#line 989 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp20_ = backing_state;
#line 989 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp21_ = detected;
#line 989 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp22_ = _tmp21_->metadata;
#line 989 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp23_ = photo_reimport_editable_state_impl_new (&_tmp20_, _tmp22_);
#line 989 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_photo_reimport_editable_state_unref0 (_vala_state);
#line 989 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_vala_state = PHOTO_REIMPORT_EDITABLE_STATE (_tmp23_);
#line 991 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	result = TRUE;
#line 991 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	backing_photo_state_destroy (&backing_state);
#line 991 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_detected_photo_information_unref0 (detected);
#line 991 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_g_object_unref0 (file);
#line 991 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (state) {
#line 991 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		*state = _vala_state;
#line 8074 "Photo.c"
	} else {
#line 991 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_photo_reimport_editable_state_unref0 (_vala_state);
#line 8078 "Photo.c"
	}
#line 991 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return result;
#line 8082 "Photo.c"
}


static gpointer _photo_reimport_editable_state_ref0 (gpointer self) {
#line 1000 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return self ? photo_reimport_editable_state_ref (self) : NULL;
#line 8089 "Photo.c"
}


void photo_finish_reimport_editable (Photo* self, PhotoReimportEditableState* state, GError** error) {
	BackingPhotoID _tmp0_ = {0};
	BackingPhotoID editable_id;
	gboolean _tmp1_ = FALSE;
	PhotoReimportEditableState* _tmp2_;
	PhotoReimportEditableStateImpl* _tmp3_;
	PhotoReimportEditableStateImpl* reimport_state;
	PhotoReimportEditableStateImpl* _tmp4_;
	gboolean _tmp5_;
	PhotoReimportEditableStateImpl* _tmp22_;
	PhotoMetadata* _tmp23_;
	gchar* _tmp33_;
	gchar* list;
	PhotoReimportEditableStateImpl* _tmp34_;
	gboolean _tmp35_;
	const gchar* _tmp38_;
	Alteration* _tmp39_;
	Alteration* _tmp40_;
	PhotoReimportEditableStateImpl* _tmp41_;
	PhotoMetadata* _tmp42_;
	gboolean _tmp43_ = FALSE;
	gboolean _tmp46_ = FALSE;
	GError * _inner_error_ = NULL;
#line 995 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 995 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail (PHOTO_IS_REIMPORT_EDITABLE_STATE (state));
#line 996 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	photo_get_editable_id (self, &_tmp0_);
#line 996 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	editable_id = _tmp0_;
#line 997 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp1_ = backing_photo_id_is_invalid (&editable_id);
#line 997 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp1_) {
#line 998 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return;
#line 8130 "Photo.c"
	}
#line 1000 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp2_ = state;
#line 1000 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp3_ = _photo_reimport_editable_state_ref0 (PHOTO_REIMPORT_EDITABLE_STATE_IMPL (_tmp2_));
#line 1000 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	reimport_state = _tmp3_;
#line 1002 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp4_ = reimport_state;
#line 1002 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp5_ = _tmp4_->metadata_only;
#line 1002 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (!_tmp5_) {
#line 8144 "Photo.c"
		BackingPhotoTable* _tmp6_ = NULL;
		BackingPhotoTable* _tmp7_;
		BackingPhotoID _tmp8_;
		PhotoReimportEditableStateImpl* _tmp9_;
		BackingPhotoState _tmp10_;
#line 1003 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp6_ = backing_photo_table_get_instance ();
#line 1003 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp7_ = _tmp6_;
#line 1003 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp8_ = editable_id;
#line 1003 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp9_ = reimport_state;
#line 1003 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp10_ = _tmp9_->backing_state;
#line 1003 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		backing_photo_table_update (_tmp7_, &_tmp8_, &_tmp10_, &_inner_error_);
#line 1003 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_database_table_unref0 (_tmp7_);
#line 1003 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 1003 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			if (_inner_error_->domain == DATABASE_ERROR) {
#line 1003 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				g_propagate_error (error, _inner_error_);
#line 1003 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_photo_reimport_editable_state_unref0 (reimport_state);
#line 1003 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				return;
#line 8174 "Photo.c"
			} else {
#line 1003 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_photo_reimport_editable_state_unref0 (reimport_state);
#line 1003 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1003 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				g_clear_error (&_inner_error_);
#line 1003 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				return;
#line 8184 "Photo.c"
			}
		}
		{
			PhotoRow _tmp11_;
#line 1005 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp11_ = self->priv->row;
#line 1005 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 8193 "Photo.c"
			{
				PhotoReimportEditableStateImpl* _tmp12_;
				BackingPhotoState _tmp13_;
				BackingPhotoState _tmp14_ = {0};
				PhotoReimportEditableStateImpl* _tmp15_;
				BackingPhotoState _tmp16_;
				Orientation _tmp17_;
#line 1006 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp12_ = reimport_state;
#line 1006 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp13_ = _tmp12_->backing_state;
#line 1006 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				backing_photo_state_copy (&_tmp13_, &_tmp14_);
#line 1006 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				backing_photo_state_destroy (&self->priv->editable);
#line 1006 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				self->priv->editable = _tmp14_;
#line 1007 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp15_ = reimport_state;
#line 1007 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp16_ = _tmp15_->backing_state;
#line 1007 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp17_ = _tmp16_.original_orientation;
#line 1007 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				photo_set_orientation (self, _tmp17_);
#line 1008 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				photo_internal_remove_all_transformations (self, FALSE);
#line 8221 "Photo.c"
			}
			__finally135:
			{
				PhotoRow _tmp18_;
#line 1005 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp18_ = self->priv->row;
#line 1005 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 8230 "Photo.c"
			}
#line 1005 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			if (_inner_error_ != NULL) {
#line 1005 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				if (_inner_error_->domain == DATABASE_ERROR) {
#line 1005 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					g_propagate_error (error, _inner_error_);
#line 1005 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_photo_reimport_editable_state_unref0 (reimport_state);
#line 1005 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					return;
#line 8242 "Photo.c"
				} else {
#line 1005 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_photo_reimport_editable_state_unref0 (reimport_state);
#line 1005 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1005 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					g_clear_error (&_inner_error_);
#line 1005 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					return;
#line 8252 "Photo.c"
				}
			}
		}
	} else {
		PhotoReimportEditableStateImpl* _tmp19_;
		BackingPhotoState _tmp20_;
		Orientation _tmp21_;
#line 1011 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp19_ = reimport_state;
#line 1011 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp20_ = _tmp19_->backing_state;
#line 1011 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp21_ = _tmp20_.original_orientation;
#line 1011 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		photo_set_orientation (self, _tmp21_);
#line 8268 "Photo.c"
	}
#line 1014 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp22_ = reimport_state;
#line 1014 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp23_ = _tmp22_->metadata;
#line 1014 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp23_ != NULL) {
#line 8276 "Photo.c"
		PhotoReimportEditableStateImpl* _tmp24_;
		PhotoMetadata* _tmp25_;
		gchar* _tmp26_ = NULL;
		gchar* _tmp27_;
		PhotoReimportEditableStateImpl* _tmp28_;
		PhotoMetadata* _tmp29_;
		Rating _tmp30_ = 0;
		PhotoReimportEditableStateImpl* _tmp31_;
		PhotoMetadata* _tmp32_;
#line 1015 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp24_ = reimport_state;
#line 1015 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp25_ = _tmp24_->metadata;
#line 1015 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp26_ = media_metadata_get_title (MEDIA_METADATA (_tmp25_));
#line 1015 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp27_ = _tmp26_;
#line 1015 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		media_source_set_title (MEDIA_SOURCE (self), _tmp27_);
#line 1015 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_free0 (_tmp27_);
#line 1016 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp28_ = reimport_state;
#line 1016 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp29_ = _tmp28_->metadata;
#line 1016 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp30_ = photo_metadata_get_rating (_tmp29_);
#line 1016 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		media_source_set_rating (MEDIA_SOURCE (self), _tmp30_);
#line 1017 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp31_ = reimport_state;
#line 1017 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp32_ = _tmp31_->metadata;
#line 1017 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		photo_apply_user_metadata_for_reimport (self, _tmp32_);
#line 8312 "Photo.c"
	}
#line 1020 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp33_ = g_strdup ("metadata:name,image:orientation,metadata:rating,metadata:exposure-time");
#line 1020 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	list = _tmp33_;
#line 1021 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp34_ = reimport_state;
#line 1021 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp35_ = _tmp34_->metadata_only;
#line 1021 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (!_tmp35_) {
#line 8324 "Photo.c"
		const gchar* _tmp36_;
		gchar* _tmp37_;
#line 1022 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp36_ = list;
#line 1022 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp37_ = g_strconcat (_tmp36_, "image:editable,image:baseline", NULL);
#line 1022 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_free0 (list);
#line 1022 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		list = _tmp37_;
#line 8335 "Photo.c"
	}
#line 1024 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp38_ = list;
#line 1024 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp39_ = alteration_new_from_list (_tmp38_);
#line 1024 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp40_ = _tmp39_;
#line 1024 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	data_object_notify_altered (DATA_OBJECT (self), _tmp40_);
#line 1024 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_alteration_unref0 (_tmp40_);
#line 1026 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp41_ = reimport_state;
#line 1026 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp42_ = _tmp41_->metadata;
#line 1026 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	photo_notify_editable_reimported (self, _tmp42_);
#line 1028 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp43_ = photo_is_editable_baseline (self);
#line 1028 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp43_) {
#line 8357 "Photo.c"
		PhotoReimportEditableStateImpl* _tmp44_;
		PhotoMetadata* _tmp45_;
#line 1029 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp44_ = reimport_state;
#line 1029 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp45_ = _tmp44_->metadata;
#line 1029 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		photo_notify_baseline_reimported (self, _tmp45_);
#line 8366 "Photo.c"
	}
#line 1031 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp46_ = photo_is_editable_source (self);
#line 1031 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp46_) {
#line 8372 "Photo.c"
		PhotoReimportEditableStateImpl* _tmp47_;
		PhotoMetadata* _tmp48_;
#line 1032 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp47_ = reimport_state;
#line 1032 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp48_ = _tmp47_->metadata;
#line 1032 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		photo_notify_source_reimported (self, _tmp48_);
#line 8381 "Photo.c"
	}
#line 995 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_g_free0 (list);
#line 995 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_photo_reimport_editable_state_unref0 (reimport_state);
#line 8387 "Photo.c"
}


static gchar* photo_real_get_typename (DataSource* base) {
	Photo * self;
	gchar* result = NULL;
	gchar* _tmp0_;
#line 1035 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	self = PHOTO (base);
#line 1036 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp0_ = g_strdup (PHOTO_TYPENAME);
#line 1036 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	result = _tmp0_;
#line 1036 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return result;
#line 8403 "Photo.c"
}


static gint64 photo_real_get_instance_id (DataSource* base) {
	Photo * self;
	gint64 result = 0LL;
	PhotoID _tmp0_ = {0};
	gint64 _tmp1_;
#line 1039 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	self = PHOTO (base);
#line 1040 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	photo_get_photo_id (self, &_tmp0_);
#line 1040 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp1_ = _tmp0_.id;
#line 1040 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	result = _tmp1_;
#line 1040 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return result;
#line 8422 "Photo.c"
}


static gchar* photo_real_get_source_id (DataSource* base) {
	Photo * self;
	gchar* result = NULL;
	gchar* _tmp0_ = NULL;
	gchar* _tmp1_;
	gint64 _tmp2_ = 0LL;
	gchar* _tmp3_ = NULL;
	gchar* _tmp4_;
#line 1043 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	self = PHOTO (base);
#line 1047 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp0_ = data_source_get_typename (DATA_SOURCE (self));
#line 1047 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 1047 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp2_ = data_source_get_instance_id (DATA_SOURCE (self));
#line 1047 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp3_ = g_strdup_printf ("%s%016" G_GINT64_MODIFIER "x", _tmp1_, _tmp2_);
#line 1047 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp4_ = _tmp3_;
#line 1047 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_g_free0 (_tmp1_);
#line 1047 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	result = _tmp4_;
#line 1047 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return result;
#line 8452 "Photo.c"
}


void photo_set_master_timestamp (Photo* self, GFileInfo* info) {
	GTimeVal modification = {0};
	GFileInfo* _tmp0_;
	GTimeVal _tmp1_ = {0};
	gboolean _tmp19_ = FALSE;
	GError * _inner_error_ = NULL;
#line 1051 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 1051 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail (G_IS_FILE_INFO (info));
#line 1053 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp0_ = info;
#line 1053 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_file_info_get_modification_time (_tmp0_, &_tmp1_);
#line 1053 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	modification = _tmp1_;
#line 8472 "Photo.c"
	{
		{
			PhotoRow _tmp2_;
#line 1056 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp2_ = self->priv->row;
#line 1056 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 8480 "Photo.c"
			{
				PhotoRow _tmp3_;
				BackingPhotoState _tmp4_;
				time_t _tmp5_;
				GTimeVal _tmp6_;
				glong _tmp7_;
				PhotoTable* _tmp9_ = NULL;
				PhotoTable* _tmp10_;
				PhotoRow _tmp11_;
				PhotoID _tmp12_;
				GTimeVal _tmp13_;
				glong _tmp14_;
				GTimeVal _tmp15_;
				glong _tmp16_;
#line 1057 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp3_ = self->priv->row;
#line 1057 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp4_ = _tmp3_.master;
#line 1057 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp5_ = _tmp4_.timestamp;
#line 1057 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp6_ = modification;
#line 1057 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp7_ = _tmp6_.tv_sec;
#line 1057 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				if (_tmp5_ == ((time_t) _tmp7_)) {
#line 8507 "Photo.c"
					{
						PhotoRow _tmp8_;
#line 1056 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						_tmp8_ = self->priv->row;
#line 1056 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 8514 "Photo.c"
					}
#line 1058 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					return;
#line 8518 "Photo.c"
				}
#line 1060 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp9_ = photo_table_get_instance ();
#line 1060 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp10_ = _tmp9_;
#line 1060 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp11_ = self->priv->row;
#line 1060 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp12_ = _tmp11_.photo_id;
#line 1060 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp13_ = modification;
#line 1060 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp14_ = _tmp13_.tv_sec;
#line 1060 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				photo_table_update_timestamp (_tmp10_, &_tmp12_, (time_t) _tmp14_, &_inner_error_);
#line 1060 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_database_table_unref0 (_tmp10_);
#line 1060 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				if (_inner_error_ != NULL) {
#line 8538 "Photo.c"
					goto __finally137;
				}
#line 1061 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp15_ = modification;
#line 1061 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp16_ = _tmp15_.tv_sec;
#line 1061 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				self->priv->row.master.timestamp = (time_t) _tmp16_;
#line 8547 "Photo.c"
			}
			__finally137:
			{
				PhotoRow _tmp17_;
#line 1056 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp17_ = self->priv->row;
#line 1056 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 8556 "Photo.c"
			}
#line 1056 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			if (_inner_error_ != NULL) {
#line 1056 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				if (_inner_error_->domain == DATABASE_ERROR) {
#line 8562 "Photo.c"
					goto __catch136_database_error;
				}
#line 1056 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1056 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				g_clear_error (&_inner_error_);
#line 1056 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				return;
#line 8571 "Photo.c"
			}
		}
	}
	goto __finally136;
	__catch136_database_error:
	{
		GError* err = NULL;
		GError* _tmp18_;
#line 1055 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		err = _inner_error_;
#line 1055 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_inner_error_ = NULL;
#line 1064 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp18_ = err;
#line 1064 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		app_window_database_error (_tmp18_);
#line 1066 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_error_free0 (err);
#line 1066 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return;
#line 8592 "Photo.c"
	}
	__finally136:
#line 1055 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 1055 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1055 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 1055 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return;
#line 8603 "Photo.c"
	}
#line 1069 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp19_ = photo_is_master_baseline (self);
#line 1069 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp19_) {
#line 8609 "Photo.c"
		Alteration* _tmp20_;
		Alteration* _tmp21_;
#line 1070 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp20_ = alteration_new_from_list ("metadata:master-timestamp,metadata:baseline-timestamp");
#line 1070 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp21_ = _tmp20_;
#line 1070 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		data_object_notify_altered (DATA_OBJECT (self), _tmp21_);
#line 1070 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_alteration_unref0 (_tmp21_);
#line 8620 "Photo.c"
	} else {
		Alteration* _tmp22_;
		Alteration* _tmp23_;
#line 1072 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp22_ = alteration_new ("metadata", "master-timestamp");
#line 1072 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp23_ = _tmp22_;
#line 1072 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		data_object_notify_altered (DATA_OBJECT (self), _tmp23_);
#line 1072 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_alteration_unref0 (_tmp23_);
#line 8632 "Photo.c"
	}
}


void photo_update_editable_modification_time (Photo* self, GFileInfo* info, GError** error) {
	GTimeVal modification = {0};
	GFileInfo* _tmp0_;
	GTimeVal _tmp1_ = {0};
	gboolean altered;
	gboolean _tmp19_;
	GError * _inner_error_ = NULL;
#line 1076 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 1076 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail (G_IS_FILE_INFO (info));
#line 1078 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp0_ = info;
#line 1078 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_file_info_get_modification_time (_tmp0_, &_tmp1_);
#line 1078 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	modification = _tmp1_;
#line 1080 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	altered = FALSE;
#line 8656 "Photo.c"
	{
		PhotoRow _tmp2_;
#line 1081 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp2_ = self->priv->row;
#line 1081 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 8663 "Photo.c"
		{
			gboolean _tmp3_ = FALSE;
			gboolean _tmp4_ = FALSE;
			gboolean _tmp9_;
#line 1082 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp4_ = backing_photo_id_is_valid (&self->priv->row.editable_id);
#line 1082 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			if (_tmp4_) {
#line 8672 "Photo.c"
				BackingPhotoState _tmp5_;
				time_t _tmp6_;
				GTimeVal _tmp7_;
				glong _tmp8_;
#line 1082 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp5_ = self->priv->editable;
#line 1082 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp6_ = _tmp5_.timestamp;
#line 1082 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp7_ = modification;
#line 1082 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp8_ = _tmp7_.tv_sec;
#line 1082 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp3_ = _tmp6_ != ((time_t) _tmp8_);
#line 8687 "Photo.c"
			} else {
#line 1082 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp3_ = FALSE;
#line 8691 "Photo.c"
			}
#line 1082 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp9_ = _tmp3_;
#line 1082 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			if (_tmp9_) {
#line 8697 "Photo.c"
				BackingPhotoTable* _tmp10_ = NULL;
				BackingPhotoTable* _tmp11_;
				PhotoRow _tmp12_;
				BackingPhotoID _tmp13_;
				GTimeVal _tmp14_;
				glong _tmp15_;
				GTimeVal _tmp16_;
				glong _tmp17_;
#line 1083 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp10_ = backing_photo_table_get_instance ();
#line 1083 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp11_ = _tmp10_;
#line 1083 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp12_ = self->priv->row;
#line 1083 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp13_ = _tmp12_.editable_id;
#line 1083 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp14_ = modification;
#line 1083 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp15_ = _tmp14_.tv_sec;
#line 1083 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				backing_photo_table_update_timestamp (_tmp11_, &_tmp13_, (time_t) _tmp15_, &_inner_error_);
#line 1083 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_database_table_unref0 (_tmp11_);
#line 1083 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				if (_inner_error_ != NULL) {
#line 8724 "Photo.c"
					goto __finally138;
				}
#line 1085 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp16_ = modification;
#line 1085 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp17_ = _tmp16_.tv_sec;
#line 1085 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				self->priv->editable.timestamp = (time_t) _tmp17_;
#line 1086 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				altered = TRUE;
#line 8735 "Photo.c"
			}
		}
		__finally138:
		{
			PhotoRow _tmp18_;
#line 1081 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp18_ = self->priv->row;
#line 1081 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 8745 "Photo.c"
		}
#line 1081 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 1081 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			if (_inner_error_->domain == DATABASE_ERROR) {
#line 1081 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				g_propagate_error (error, _inner_error_);
#line 1081 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				return;
#line 8755 "Photo.c"
			} else {
#line 1081 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1081 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				g_clear_error (&_inner_error_);
#line 1081 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				return;
#line 8763 "Photo.c"
			}
		}
	}
#line 1090 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp19_ = altered;
#line 1090 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp19_) {
#line 8771 "Photo.c"
		Alteration* _tmp20_;
		Alteration* _tmp21_;
#line 1091 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp20_ = alteration_new_from_list ("metadata:editable-timestamp,metadata:baseline-timestamp");
#line 1091 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp21_ = _tmp20_;
#line 1091 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		data_object_notify_altered (DATA_OBJECT (self), _tmp21_);
#line 1091 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_alteration_unref0 (_tmp21_);
#line 8782 "Photo.c"
	}
}


void photo_update_many_editable_timestamps (GeeMap* map, GError** error) {
	GError * _inner_error_ = NULL;
#line 1095 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail (GEE_IS_MAP (map));
#line 1097 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	database_table_begin_transaction ();
#line 8793 "Photo.c"
	{
		GeeMap* _tmp0_;
		GeeSet* _tmp1_;
		GeeSet* _tmp2_;
		GeeSet* _tmp3_;
		GeeIterator* _tmp4_ = NULL;
		GeeIterator* _tmp5_;
		GeeIterator* _photo_it;
#line 1098 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp0_ = map;
#line 1098 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp1_ = gee_map_get_keys (_tmp0_);
#line 1098 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp2_ = _tmp1_;
#line 1098 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp3_ = _tmp2_;
#line 1098 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp4_ = gee_iterable_iterator (GEE_ITERABLE (_tmp3_));
#line 1098 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp5_ = _tmp4_;
#line 1098 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_object_unref0 (_tmp3_);
#line 1098 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_photo_it = _tmp5_;
#line 1098 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		while (TRUE) {
#line 8820 "Photo.c"
			GeeIterator* _tmp6_;
			gboolean _tmp7_ = FALSE;
			GeeIterator* _tmp8_;
			gpointer _tmp9_ = NULL;
			Photo* photo;
			Photo* _tmp10_;
			GeeMap* _tmp11_;
			Photo* _tmp12_;
			gpointer _tmp13_ = NULL;
			GFileInfo* _tmp14_;
#line 1098 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp6_ = _photo_it;
#line 1098 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp7_ = gee_iterator_next (_tmp6_);
#line 1098 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			if (!_tmp7_) {
#line 1098 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				break;
#line 8839 "Photo.c"
			}
#line 1098 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp8_ = _photo_it;
#line 1098 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp9_ = gee_iterator_get (_tmp8_);
#line 1098 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			photo = (Photo*) _tmp9_;
#line 1099 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp10_ = photo;
#line 1099 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp11_ = map;
#line 1099 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp12_ = photo;
#line 1099 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp13_ = gee_map_get (_tmp11_, _tmp12_);
#line 1099 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp14_ = (GFileInfo*) _tmp13_;
#line 1099 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			photo_update_editable_modification_time (_tmp10_, _tmp14_, &_inner_error_);
#line 1099 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_g_object_unref0 (_tmp14_);
#line 1099 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			if (_inner_error_ != NULL) {
#line 1099 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				if (_inner_error_->domain == DATABASE_ERROR) {
#line 1099 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					g_propagate_error (error, _inner_error_);
#line 1099 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_g_object_unref0 (photo);
#line 1099 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_g_object_unref0 (_photo_it);
#line 1099 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					return;
#line 8873 "Photo.c"
				} else {
#line 1099 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_g_object_unref0 (photo);
#line 1099 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_g_object_unref0 (_photo_it);
#line 1099 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1099 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					g_clear_error (&_inner_error_);
#line 1099 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					return;
#line 8885 "Photo.c"
				}
			}
#line 1098 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_g_object_unref0 (photo);
#line 8890 "Photo.c"
		}
#line 1098 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_object_unref0 (_photo_it);
#line 8894 "Photo.c"
	}
#line 1100 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	database_table_commit_transaction (&_inner_error_);
#line 1100 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 1100 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		if (_inner_error_->domain == DATABASE_ERROR) {
#line 1100 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 1100 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			return;
#line 8906 "Photo.c"
		} else {
#line 1100 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1100 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 1100 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			return;
#line 8914 "Photo.c"
		}
	}
}


static PhotoFileFormat photo_real_get_preferred_thumbnail_format (ThumbnailSource* base) {
	Photo * self;
	PhotoFileFormat result = 0;
	PhotoFileFormat _tmp0_ = 0;
	PhotoFileFormat _tmp1_ = 0;
	gboolean _tmp2_ = FALSE;
#line 1103 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	self = PHOTO (base);
#line 1104 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp1_ = photo_get_file_format (self);
#line 1104 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp2_ = photo_file_format_can_write_image (_tmp1_);
#line 1104 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp2_) {
#line 8934 "Photo.c"
		PhotoFileFormat _tmp3_ = 0;
#line 1104 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp3_ = photo_get_file_format (self);
#line 1104 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp0_ = _tmp3_;
#line 8940 "Photo.c"
	} else {
		PhotoFileFormat _tmp4_ = 0;
#line 1105 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp4_ = photo_file_format_get_system_default_format ();
#line 1105 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp0_ = _tmp4_;
#line 8947 "Photo.c"
	}
#line 1104 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	result = _tmp0_;
#line 1104 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return result;
#line 8953 "Photo.c"
}


static GdkPixbuf* photo_real_create_thumbnail (ThumbnailSource* base, gint scale, GError** error) {
	Photo * self;
	GdkPixbuf* result = NULL;
	gint _tmp0_;
	Scaling _tmp1_ = {0};
	GdkPixbuf* _tmp2_ = NULL;
	GdkPixbuf* _tmp3_;
	GError * _inner_error_ = NULL;
#line 1108 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	self = PHOTO (base);
#line 1109 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp0_ = scale;
#line 1109 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	scaling_for_best_fit (_tmp0_, TRUE, &_tmp1_);
#line 1109 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp2_ = photo_source_get_pixbuf (PHOTO_SOURCE (self), &_tmp1_, &_inner_error_);
#line 1109 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp3_ = _tmp2_;
#line 1109 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 1109 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 1109 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return NULL;
#line 8981 "Photo.c"
	}
#line 1109 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	result = _tmp3_;
#line 1109 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return result;
#line 8987 "Photo.c"
}


gboolean photo_is_file_image (GFile* file) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	GFile* _tmp1_;
	gboolean _tmp2_ = FALSE;
#line 1112 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail (G_IS_FILE (file), FALSE);
#line 1116 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp1_ = file;
#line 1116 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp2_ = photo_file_format_is_file_supported (_tmp1_);
#line 1116 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp2_) {
#line 1117 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp0_ = TRUE;
#line 9006 "Photo.c"
	} else {
		GFile* _tmp3_;
		gchar* _tmp4_ = NULL;
		gchar* _tmp5_;
		gboolean _tmp6_ = FALSE;
#line 1117 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp3_ = file;
#line 1117 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp4_ = g_file_get_basename (_tmp3_);
#line 1117 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp5_ = _tmp4_;
#line 1117 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp6_ = photo_is_extension_found (_tmp5_, PHOTO_IMAGE_EXTENSIONS, G_N_ELEMENTS (PHOTO_IMAGE_EXTENSIONS));
#line 1117 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp0_ = _tmp6_;
#line 1117 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_free0 (_tmp5_);
#line 9024 "Photo.c"
	}
#line 1116 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	result = _tmp0_;
#line 1116 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return result;
#line 9030 "Photo.c"
}


static gboolean photo_is_extension_found (const gchar* basename, gchar** extensions, int extensions_length1) {
	gboolean result = FALSE;
	gchar* name = NULL;
	gchar* ext = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_ = NULL;
	gchar** _tmp6_;
	gint _tmp6__length1;
#line 1120 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail (basename != NULL, FALSE);
#line 1122 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp0_ = basename;
#line 1122 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	disassemble_filename (_tmp0_, &_tmp1_, &_tmp2_);
#line 1122 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_g_free0 (name);
#line 1122 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	name = _tmp1_;
#line 1122 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_g_free0 (ext);
#line 1122 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	ext = _tmp2_;
#line 1123 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp3_ = ext;
#line 1123 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp3_ == NULL) {
#line 1124 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		result = FALSE;
#line 1124 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_free0 (ext);
#line 1124 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_free0 (name);
#line 1124 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return result;
#line 9072 "Photo.c"
	}
#line 1127 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp4_ = ext;
#line 1127 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp5_ = g_utf8_strdown (_tmp4_, (gssize) (-1));
#line 1127 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_g_free0 (ext);
#line 1127 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	ext = _tmp5_;
#line 1130 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp6_ = extensions;
#line 1130 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp6__length1 = extensions_length1;
#line 9086 "Photo.c"
	{
		gchar** extension_collection = NULL;
		gint extension_collection_length1 = 0;
		gint _extension_collection_size_ = 0;
		gint extension_it = 0;
#line 1130 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		extension_collection = _tmp6_;
#line 1130 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		extension_collection_length1 = _tmp6__length1;
#line 1130 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		for (extension_it = 0; extension_it < _tmp6__length1; extension_it = extension_it + 1) {
#line 9098 "Photo.c"
			gchar* _tmp7_;
			gchar* extension = NULL;
#line 1130 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp7_ = g_strdup (extension_collection[extension_it]);
#line 1130 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			extension = _tmp7_;
#line 9105 "Photo.c"
			{
				const gchar* _tmp8_;
				const gchar* _tmp9_;
#line 1131 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp8_ = ext;
#line 1131 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp9_ = extension;
#line 1131 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				if (g_strcmp0 (_tmp8_, _tmp9_) == 0) {
#line 1132 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					result = TRUE;
#line 1132 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_g_free0 (extension);
#line 1132 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_g_free0 (ext);
#line 1132 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_g_free0 (name);
#line 1132 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					return result;
#line 9125 "Photo.c"
				}
#line 1130 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_g_free0 (extension);
#line 9129 "Photo.c"
			}
		}
	}
#line 1135 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	result = FALSE;
#line 1135 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_g_free0 (ext);
#line 1135 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_g_free0 (name);
#line 1135 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return result;
#line 9141 "Photo.c"
}


gboolean photo_is_duplicate (GFile* file, const gchar* thumbnail_md5, const gchar* full_md5, PhotoFileFormat file_format) {
	gboolean result = FALSE;
	PhotoTable* _tmp0_ = NULL;
	PhotoTable* _tmp1_;
	GFile* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	PhotoFileFormat _tmp5_;
	gboolean _tmp6_ = FALSE;
	gboolean _tmp7_;
#line 1141 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail ((file == NULL) || G_IS_FILE (file), FALSE);
#line 1144 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp0_ = photo_table_get_instance ();
#line 1144 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 1144 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp2_ = file;
#line 1144 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp3_ = thumbnail_md5;
#line 1144 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp4_ = full_md5;
#line 1144 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp5_ = file_format;
#line 1144 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp6_ = photo_table_has_duplicate (_tmp1_, _tmp2_, _tmp3_, _tmp4_, _tmp5_);
#line 1144 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp7_ = _tmp6_;
#line 1144 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_database_table_unref0 (_tmp1_);
#line 1144 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	result = _tmp7_;
#line 1144 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return result;
#line 9179 "Photo.c"
}


PhotoID* photo_get_duplicate_ids (GFile* file, const gchar* thumbnail_md5, const gchar* full_md5, PhotoFileFormat file_format, int* result_length1) {
	PhotoID* result = NULL;
	PhotoTable* _tmp0_ = NULL;
	PhotoTable* _tmp1_;
	GFile* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	PhotoFileFormat _tmp5_;
	gint _tmp6_ = 0;
	PhotoID* _tmp7_ = NULL;
	PhotoID* _tmp8_;
	gint _tmp8__length1;
	PhotoID* _tmp9_;
	gint _tmp9__length1;
#line 1150 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail ((file == NULL) || G_IS_FILE (file), NULL);
#line 1153 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp0_ = photo_table_get_instance ();
#line 1153 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 1153 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp2_ = file;
#line 1153 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp3_ = thumbnail_md5;
#line 1153 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp4_ = full_md5;
#line 1153 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp5_ = file_format;
#line 1153 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp7_ = photo_table_get_duplicate_ids (_tmp1_, _tmp2_, _tmp3_, _tmp4_, _tmp5_, &_tmp6_);
#line 1153 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp8_ = _tmp7_;
#line 1153 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp8__length1 = _tmp6_;
#line 1153 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_database_table_unref0 (_tmp1_);
#line 1153 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp9_ = _tmp8_;
#line 1153 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp9__length1 = _tmp8__length1;
#line 1153 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (result_length1) {
#line 1153 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		*result_length1 = _tmp9__length1;
#line 9227 "Photo.c"
	}
#line 1153 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	result = _tmp9_;
#line 1153 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return result;
#line 9233 "Photo.c"
}


gint64 photo_get_photo_key (DataSource* source) {
	gint64 result = 0LL;
	DataSource* _tmp0_;
	PhotoID _tmp1_ = {0};
	gint64 _tmp2_;
#line 1160 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail (IS_DATA_SOURCE (source), 0LL);
#line 1161 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp0_ = source;
#line 1161 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	photo_get_photo_id (PHOTO (LIBRARY_PHOTO (_tmp0_)), &_tmp1_);
#line 1161 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp2_ = _tmp1_.id;
#line 1161 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	result = _tmp2_;
#line 1161 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return result;
#line 9254 "Photo.c"
}


static GFile* photo_real_get_file (MediaSource* base) {
	Photo * self;
	GFile* result = NULL;
	PhotoFileReader* _tmp0_ = NULL;
	PhotoFileReader* _tmp1_;
	GFile* _tmp2_ = NULL;
	GFile* _tmp3_;
#line 1179 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	self = PHOTO (base);
#line 1180 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp0_ = photo_get_source_reader (self);
#line 1180 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 1180 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp2_ = photo_file_adapter_get_file (PHOTO_FILE_ADAPTER (_tmp1_));
#line 1180 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp3_ = _tmp2_;
#line 1180 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_photo_file_adapter_unref0 (_tmp1_);
#line 1180 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	result = _tmp3_;
#line 1180 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return result;
#line 9281 "Photo.c"
}


static void _vala_array_add212 (gchar*** array, int* length, int* size, gchar* value) {
#line 1223 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if ((*length) == (*size)) {
#line 1223 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1223 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 9292 "Photo.c"
	}
#line 1223 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1223 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	(*array)[*length] = NULL;
#line 9298 "Photo.c"
}


static void _vala_array_add213 (gchar*** array, int* length, int* size, gchar* value) {
#line 1228 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if ((*length) == (*size)) {
#line 1228 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1228 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 9309 "Photo.c"
	}
#line 1228 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1228 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	(*array)[*length] = NULL;
#line 9315 "Photo.c"
}


static void _vala_array_add214 (gchar*** array, int* length, int* size, gchar* value) {
#line 1231 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if ((*length) == (*size)) {
#line 1231 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1231 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 9326 "Photo.c"
	}
#line 1231 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1231 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	(*array)[*length] = NULL;
#line 9332 "Photo.c"
}


static void _vala_array_add215 (gchar*** array, int* length, int* size, gchar* value) {
#line 1234 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if ((*length) == (*size)) {
#line 1234 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1234 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 9343 "Photo.c"
	}
#line 1234 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1234 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	(*array)[*length] = NULL;
#line 9349 "Photo.c"
}


void photo_set_master_file (Photo* self, GFile* file) {
	GFile* _tmp0_;
	gchar* _tmp1_ = NULL;
	gchar* filepath;
	gboolean altered;
	gboolean is_baseline;
	gboolean is_source;
	gboolean name_changed;
	GFile* old_file;
	gboolean _tmp39_;
	GError * _inner_error_ = NULL;
#line 1185 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 1185 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail (G_IS_FILE (file));
#line 1186 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp0_ = file;
#line 1186 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp1_ = g_file_get_path (_tmp0_);
#line 1186 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	filepath = _tmp1_;
#line 1188 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	altered = FALSE;
#line 1189 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	is_baseline = FALSE;
#line 1190 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	is_source = FALSE;
#line 1191 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	name_changed = FALSE;
#line 1192 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	old_file = NULL;
#line 9384 "Photo.c"
	{
		{
			PhotoRow _tmp2_;
#line 1194 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp2_ = self->priv->row;
#line 1194 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 9392 "Photo.c"
			{
				{
					PhotoBackingReaders _tmp3_;
#line 1195 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_tmp3_ = self->priv->readers;
#line 1195 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					g_static_rec_mutex_lock (&self->priv->__lock_readers);
#line 9400 "Photo.c"
					{
						PhotoBackingReaders _tmp4_;
						PhotoFileReader* _tmp5_;
						GFile* _tmp6_ = NULL;
						GFile* _tmp7_;
						GFile* _tmp8_;
						gboolean _tmp9_ = FALSE;
#line 1196 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						_tmp4_ = self->priv->readers;
#line 1196 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						_tmp5_ = _tmp4_.master;
#line 1196 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						_tmp6_ = photo_file_adapter_get_file (PHOTO_FILE_ADAPTER (_tmp5_));
#line 1196 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						_g_object_unref0 (old_file);
#line 1196 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						old_file = _tmp6_;
#line 1197 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						_tmp7_ = file;
#line 1197 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						_tmp8_ = old_file;
#line 1197 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						_tmp9_ = g_file_equal (_tmp7_, _tmp8_);
#line 1197 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						if (!_tmp9_) {
#line 9426 "Photo.c"
							PhotoTable* _tmp10_ = NULL;
							PhotoTable* _tmp11_;
							PhotoID _tmp12_ = {0};
							const gchar* _tmp13_;
							const gchar* _tmp14_;
							gchar* _tmp15_;
							GFile* _tmp16_;
							gchar* _tmp17_ = NULL;
							PhotoRow _tmp18_;
							BackingPhotoState _tmp19_;
							PhotoFileFormat _tmp20_;
							const gchar* _tmp21_;
							PhotoFileReader* _tmp22_ = NULL;
							gboolean _tmp23_ = FALSE;
							gboolean _tmp24_ = FALSE;
							gboolean _tmp25_ = FALSE;
							PhotoRow _tmp26_;
							const gchar* _tmp27_;
							gboolean _tmp28_ = FALSE;
							gboolean _tmp35_;
#line 1198 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
							_tmp10_ = photo_table_get_instance ();
#line 1198 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
							_tmp11_ = _tmp10_;
#line 1198 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
							photo_get_photo_id (self, &_tmp12_);
#line 1198 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
							_tmp13_ = filepath;
#line 1198 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
							photo_table_set_filepath (_tmp11_, &_tmp12_, _tmp13_, &_inner_error_);
#line 1198 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
							_database_table_unref0 (_tmp11_);
#line 1198 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
							if (_inner_error_ != NULL) {
#line 9461 "Photo.c"
								goto __finally141;
							}
#line 1200 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
							_tmp14_ = filepath;
#line 1200 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
							_tmp15_ = g_strdup (_tmp14_);
#line 1200 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
							_g_free0 (self->priv->row.master.filepath);
#line 1200 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
							self->priv->row.master.filepath = _tmp15_;
#line 1201 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
							_tmp16_ = file;
#line 1201 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
							_tmp17_ = g_file_get_basename (_tmp16_);
#line 1201 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
							_g_free0 (self->priv->file_title);
#line 1201 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
							self->priv->file_title = _tmp17_;
#line 1202 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
							_tmp18_ = self->priv->row;
#line 1202 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
							_tmp19_ = _tmp18_.master;
#line 1202 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
							_tmp20_ = _tmp19_.file_format;
#line 1202 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
							_tmp21_ = filepath;
#line 1202 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
							_tmp22_ = photo_file_format_create_reader (_tmp20_, _tmp21_);
#line 1202 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
							_photo_file_adapter_unref0 (self->priv->readers.master);
#line 1202 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
							self->priv->readers.master = _tmp22_;
#line 1204 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
							altered = TRUE;
#line 1205 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
							_tmp23_ = photo_is_master_baseline (self);
#line 1205 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
							is_baseline = _tmp23_;
#line 1206 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
							_tmp24_ = photo_is_master_source (self);
#line 1206 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
							is_source = _tmp24_;
#line 1207 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
							_tmp26_ = self->priv->row;
#line 1207 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
							_tmp27_ = _tmp26_.title;
#line 1207 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
							_tmp28_ = is_string_empty (_tmp27_);
#line 1207 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
							if (_tmp28_) {
#line 9512 "Photo.c"
								GFile* _tmp29_;
								gchar* _tmp30_ = NULL;
								gchar* _tmp31_;
								GFile* _tmp32_;
								gchar* _tmp33_ = NULL;
								gchar* _tmp34_;
#line 1208 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
								_tmp29_ = old_file;
#line 1208 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
								_tmp30_ = g_file_get_basename (_tmp29_);
#line 1208 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
								_tmp31_ = _tmp30_;
#line 1208 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
								_tmp32_ = file;
#line 1208 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
								_tmp33_ = g_file_get_basename (_tmp32_);
#line 1208 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
								_tmp34_ = _tmp33_;
#line 1208 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
								_tmp25_ = g_strcmp0 (_tmp31_, _tmp34_) != 0;
#line 1208 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
								_g_free0 (_tmp34_);
#line 1208 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
								_g_free0 (_tmp31_);
#line 9537 "Photo.c"
							} else {
#line 1207 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
								_tmp25_ = FALSE;
#line 9541 "Photo.c"
							}
#line 1207 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
							_tmp35_ = _tmp25_;
#line 1207 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
							name_changed = _tmp35_;
#line 9547 "Photo.c"
						}
					}
					__finally141:
					{
						PhotoBackingReaders _tmp36_;
#line 1195 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						_tmp36_ = self->priv->readers;
#line 1195 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						g_static_rec_mutex_unlock (&self->priv->__lock_readers);
#line 9557 "Photo.c"
					}
#line 1195 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					if (_inner_error_ != NULL) {
#line 9561 "Photo.c"
						goto __finally140;
					}
				}
			}
			__finally140:
			{
				PhotoRow _tmp37_;
#line 1194 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp37_ = self->priv->row;
#line 1194 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 9573 "Photo.c"
			}
#line 1194 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			if (_inner_error_ != NULL) {
#line 1194 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				if (_inner_error_->domain == DATABASE_ERROR) {
#line 9579 "Photo.c"
					goto __catch139_database_error;
				}
#line 1194 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_g_object_unref0 (old_file);
#line 1194 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_g_free0 (filepath);
#line 1194 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1194 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				g_clear_error (&_inner_error_);
#line 1194 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				return;
#line 9592 "Photo.c"
			}
		}
	}
	goto __finally139;
	__catch139_database_error:
	{
		GError* err = NULL;
		GError* _tmp38_;
#line 1193 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		err = _inner_error_;
#line 1193 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_inner_error_ = NULL;
#line 1213 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp38_ = err;
#line 1213 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		app_window_database_error (_tmp38_);
#line 1193 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_error_free0 (err);
#line 9611 "Photo.c"
	}
	__finally139:
#line 1193 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 1193 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_object_unref0 (old_file);
#line 1193 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_free0 (filepath);
#line 1193 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1193 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 1193 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return;
#line 9626 "Photo.c"
	}
#line 1216 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp39_ = altered;
#line 1216 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp39_) {
#line 9632 "Photo.c"
		GFile* _tmp40_;
		GFile* _tmp41_;
		gboolean _tmp42_;
		gchar** _tmp43_ = NULL;
		gchar** alteration_list;
		gint alteration_list_length1;
		gint _alteration_list_size_;
		gchar** _tmp44_;
		gint _tmp44__length1;
		gchar* _tmp45_;
		gboolean _tmp46_;
		gboolean _tmp49_;
		gboolean _tmp52_;
		gchar** _tmp55_;
		gint _tmp55__length1;
		Alteration* _tmp56_;
		Alteration* _tmp57_;
#line 1217 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp40_ = old_file;
#line 1217 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp41_ = file;
#line 1217 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		media_source_notify_master_replaced (MEDIA_SOURCE (self), _tmp40_, _tmp41_);
#line 1219 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp42_ = is_baseline;
#line 1219 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		if (_tmp42_) {
#line 1220 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			photo_notify_baseline_replaced (self);
#line 9662 "Photo.c"
		}
#line 1222 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp43_ = g_new0 (gchar*, 0 + 1);
#line 1222 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		alteration_list = _tmp43_;
#line 1222 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		alteration_list_length1 = 0;
#line 1222 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_alteration_list_size_ = alteration_list_length1;
#line 1223 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp44_ = alteration_list;
#line 1223 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp44__length1 = alteration_list_length1;
#line 1223 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp45_ = g_strdup ("backing:master");
#line 1223 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_vala_array_add212 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp45_);
#line 1227 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp46_ = name_changed;
#line 1227 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		if (_tmp46_) {
#line 9684 "Photo.c"
			gchar** _tmp47_;
			gint _tmp47__length1;
			gchar* _tmp48_;
#line 1228 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp47_ = alteration_list;
#line 1228 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp47__length1 = alteration_list_length1;
#line 1228 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp48_ = g_strdup ("metadata:name");
#line 1228 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_vala_array_add213 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp48_);
#line 9696 "Photo.c"
		}
#line 1230 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp49_ = is_source;
#line 1230 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		if (_tmp49_) {
#line 9702 "Photo.c"
			gchar** _tmp50_;
			gint _tmp50__length1;
			gchar* _tmp51_;
#line 1231 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp50_ = alteration_list;
#line 1231 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp50__length1 = alteration_list_length1;
#line 1231 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp51_ = g_strdup ("backing:source");
#line 1231 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_vala_array_add214 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp51_);
#line 9714 "Photo.c"
		}
#line 1233 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp52_ = is_baseline;
#line 1233 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		if (_tmp52_) {
#line 9720 "Photo.c"
			gchar** _tmp53_;
			gint _tmp53__length1;
			gchar* _tmp54_;
#line 1234 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp53_ = alteration_list;
#line 1234 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp53__length1 = alteration_list_length1;
#line 1234 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp54_ = g_strdup ("backing:baseline");
#line 1234 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_vala_array_add215 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp54_);
#line 9732 "Photo.c"
		}
#line 1236 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp55_ = alteration_list;
#line 1236 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp55__length1 = alteration_list_length1;
#line 1236 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp56_ = alteration_new_from_array (_tmp55_, _tmp55__length1);
#line 1236 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp57_ = _tmp56_;
#line 1236 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		data_object_notify_altered (DATA_OBJECT (self), _tmp57_);
#line 1236 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_alteration_unref0 (_tmp57_);
#line 1216 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		alteration_list = (_vala_array_free (alteration_list, alteration_list_length1, (GDestroyNotify) g_free), NULL);
#line 9748 "Photo.c"
	}
#line 1185 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_g_object_unref0 (old_file);
#line 1185 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_g_free0 (filepath);
#line 9754 "Photo.c"
}


static void _vala_array_add216 (gchar*** array, int* length, int* size, gchar* value) {
#line 1276 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if ((*length) == (*size)) {
#line 1276 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1276 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 9765 "Photo.c"
	}
#line 1276 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1276 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	(*array)[*length] = NULL;
#line 9771 "Photo.c"
}


static void _vala_array_add217 (gchar*** array, int* length, int* size, gchar* value) {
#line 1279 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if ((*length) == (*size)) {
#line 1279 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1279 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 9782 "Photo.c"
	}
#line 1279 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1279 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	(*array)[*length] = NULL;
#line 9788 "Photo.c"
}


static void _vala_array_add218 (gchar*** array, int* length, int* size, gchar* value) {
#line 1282 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if ((*length) == (*size)) {
#line 1282 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1282 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 9799 "Photo.c"
	}
#line 1282 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	(*array)[(*length)++] = value;
#line 1282 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	(*array)[*length] = NULL;
#line 9805 "Photo.c"
}


void photo_set_editable_file (Photo* self, GFile* file) {
	GFile* _tmp0_;
	gchar* _tmp1_ = NULL;
	gchar* filepath;
	gboolean altered;
	gboolean is_baseline;
	gboolean is_source;
	GFile* old_file;
	gboolean _tmp34_;
	GError * _inner_error_ = NULL;
#line 1242 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 1242 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail (G_IS_FILE (file));
#line 1243 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp0_ = file;
#line 1243 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp1_ = g_file_get_path (_tmp0_);
#line 1243 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	filepath = _tmp1_;
#line 1245 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	altered = FALSE;
#line 1246 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	is_baseline = FALSE;
#line 1247 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	is_source = FALSE;
#line 1248 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	old_file = NULL;
#line 9837 "Photo.c"
	{
		{
			PhotoRow _tmp2_;
#line 1250 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp2_ = self->priv->row;
#line 1250 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 9845 "Photo.c"
			{
				{
					PhotoBackingReaders _tmp3_;
#line 1251 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_tmp3_ = self->priv->readers;
#line 1251 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					g_static_rec_mutex_lock (&self->priv->__lock_readers);
#line 9853 "Photo.c"
					{
						GFile* _tmp4_ = NULL;
						PhotoBackingReaders _tmp5_;
						PhotoFileReader* _tmp6_;
						GFile* _tmp10_;
						GFile* _tmp11_;
						gboolean _tmp12_ = FALSE;
						GFile* _tmp13_;
						gboolean _tmp17_;
#line 1252 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						_tmp5_ = self->priv->readers;
#line 1252 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						_tmp6_ = _tmp5_.editable;
#line 1252 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						if (_tmp6_ != NULL) {
#line 9869 "Photo.c"
							PhotoBackingReaders _tmp7_;
							PhotoFileReader* _tmp8_;
							GFile* _tmp9_ = NULL;
#line 1252 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
							_tmp7_ = self->priv->readers;
#line 1252 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
							_tmp8_ = _tmp7_.editable;
#line 1252 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
							_tmp9_ = photo_file_adapter_get_file (PHOTO_FILE_ADAPTER (_tmp8_));
#line 1252 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
							_g_object_unref0 (_tmp4_);
#line 1252 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
							_tmp4_ = _tmp9_;
#line 9883 "Photo.c"
						} else {
#line 1252 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
							_g_object_unref0 (_tmp4_);
#line 1252 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
							_tmp4_ = NULL;
#line 9889 "Photo.c"
						}
#line 1252 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						_tmp10_ = _tmp4_;
#line 1252 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						_tmp11_ = _g_object_ref0 (_tmp10_);
#line 1252 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						_g_object_unref0 (old_file);
#line 1252 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						old_file = _tmp11_;
#line 1253 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						_tmp13_ = old_file;
#line 1253 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						if (_tmp13_ != NULL) {
#line 9903 "Photo.c"
							GFile* _tmp14_;
							GFile* _tmp15_;
							gboolean _tmp16_ = FALSE;
#line 1253 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
							_tmp14_ = old_file;
#line 1253 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
							_tmp15_ = file;
#line 1253 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
							_tmp16_ = g_file_equal (_tmp14_, _tmp15_);
#line 1253 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
							_tmp12_ = !_tmp16_;
#line 9915 "Photo.c"
						} else {
#line 1253 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
							_tmp12_ = FALSE;
#line 9919 "Photo.c"
						}
#line 1253 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						_tmp17_ = _tmp12_;
#line 1253 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						if (_tmp17_) {
#line 9925 "Photo.c"
							BackingPhotoTable* _tmp18_ = NULL;
							BackingPhotoTable* _tmp19_;
							PhotoRow _tmp20_;
							BackingPhotoID _tmp21_;
							const gchar* _tmp22_;
							const gchar* _tmp23_;
							gchar* _tmp24_;
							BackingPhotoState _tmp25_;
							PhotoFileFormat _tmp26_;
							const gchar* _tmp27_;
							PhotoFileReader* _tmp28_ = NULL;
							gboolean _tmp29_ = FALSE;
							gboolean _tmp30_ = FALSE;
#line 1254 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
							_tmp18_ = backing_photo_table_get_instance ();
#line 1254 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
							_tmp19_ = _tmp18_;
#line 1254 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
							_tmp20_ = self->priv->row;
#line 1254 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
							_tmp21_ = _tmp20_.editable_id;
#line 1254 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
							_tmp22_ = filepath;
#line 1254 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
							backing_photo_table_set_filepath (_tmp19_, &_tmp21_, _tmp22_, &_inner_error_);
#line 1254 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
							_database_table_unref0 (_tmp19_);
#line 1254 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
							if (_inner_error_ != NULL) {
#line 1254 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
								_g_object_unref0 (_tmp4_);
#line 9957 "Photo.c"
								goto __finally144;
							}
#line 1256 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
							_tmp23_ = filepath;
#line 1256 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
							_tmp24_ = g_strdup (_tmp23_);
#line 1256 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
							_g_free0 (self->priv->editable.filepath);
#line 1256 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
							self->priv->editable.filepath = _tmp24_;
#line 1257 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
							_tmp25_ = self->priv->editable;
#line 1257 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
							_tmp26_ = _tmp25_.file_format;
#line 1257 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
							_tmp27_ = filepath;
#line 1257 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
							_tmp28_ = photo_file_format_create_reader (_tmp26_, _tmp27_);
#line 1257 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
							_photo_file_adapter_unref0 (self->priv->readers.editable);
#line 1257 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
							self->priv->readers.editable = _tmp28_;
#line 1259 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
							altered = TRUE;
#line 1260 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
							_tmp29_ = photo_is_editable_baseline (self);
#line 1260 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
							is_baseline = _tmp29_;
#line 1261 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
							_tmp30_ = photo_is_editable_source (self);
#line 1261 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
							is_source = _tmp30_;
#line 9990 "Photo.c"
						}
#line 1251 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						_g_object_unref0 (_tmp4_);
#line 9994 "Photo.c"
					}
					__finally144:
					{
						PhotoBackingReaders _tmp31_;
#line 1251 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						_tmp31_ = self->priv->readers;
#line 1251 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						g_static_rec_mutex_unlock (&self->priv->__lock_readers);
#line 10003 "Photo.c"
					}
#line 1251 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					if (_inner_error_ != NULL) {
#line 10007 "Photo.c"
						goto __finally143;
					}
				}
			}
			__finally143:
			{
				PhotoRow _tmp32_;
#line 1250 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp32_ = self->priv->row;
#line 1250 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 10019 "Photo.c"
			}
#line 1250 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			if (_inner_error_ != NULL) {
#line 1250 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				if (_inner_error_->domain == DATABASE_ERROR) {
#line 10025 "Photo.c"
					goto __catch142_database_error;
				}
#line 1250 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_g_object_unref0 (old_file);
#line 1250 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_g_free0 (filepath);
#line 1250 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1250 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				g_clear_error (&_inner_error_);
#line 1250 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				return;
#line 10038 "Photo.c"
			}
		}
	}
	goto __finally142;
	__catch142_database_error:
	{
		GError* err = NULL;
		GError* _tmp33_;
#line 1249 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		err = _inner_error_;
#line 1249 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_inner_error_ = NULL;
#line 1266 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp33_ = err;
#line 1266 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		app_window_database_error (_tmp33_);
#line 1249 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_error_free0 (err);
#line 10057 "Photo.c"
	}
	__finally142:
#line 1249 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 1249 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_object_unref0 (old_file);
#line 1249 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_free0 (filepath);
#line 1249 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1249 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 1249 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return;
#line 10072 "Photo.c"
	}
#line 1269 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp34_ = altered;
#line 1269 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp34_) {
#line 10078 "Photo.c"
		GFile* _tmp35_;
		GFile* _tmp36_;
		gboolean _tmp37_;
		gchar** _tmp38_ = NULL;
		gchar** alteration_list;
		gint alteration_list_length1;
		gint _alteration_list_size_;
		gchar** _tmp39_;
		gint _tmp39__length1;
		gchar* _tmp40_;
		gboolean _tmp41_;
		gboolean _tmp44_;
		gchar** _tmp47_;
		gint _tmp47__length1;
		Alteration* _tmp48_;
		Alteration* _tmp49_;
#line 1270 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp35_ = old_file;
#line 1270 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp36_ = file;
#line 1270 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		photo_notify_editable_replaced (self, _tmp35_, _tmp36_);
#line 1272 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp37_ = is_baseline;
#line 1272 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		if (_tmp37_) {
#line 1273 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			photo_notify_baseline_replaced (self);
#line 10107 "Photo.c"
		}
#line 1275 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp38_ = g_new0 (gchar*, 0 + 1);
#line 1275 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		alteration_list = _tmp38_;
#line 1275 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		alteration_list_length1 = 0;
#line 1275 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_alteration_list_size_ = alteration_list_length1;
#line 1276 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp39_ = alteration_list;
#line 1276 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp39__length1 = alteration_list_length1;
#line 1276 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp40_ = g_strdup ("backing:editable");
#line 1276 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_vala_array_add216 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp40_);
#line 1278 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp41_ = is_baseline;
#line 1278 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		if (_tmp41_) {
#line 10129 "Photo.c"
			gchar** _tmp42_;
			gint _tmp42__length1;
			gchar* _tmp43_;
#line 1279 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp42_ = alteration_list;
#line 1279 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp42__length1 = alteration_list_length1;
#line 1279 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp43_ = g_strdup ("backing:baseline");
#line 1279 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_vala_array_add217 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp43_);
#line 10141 "Photo.c"
		}
#line 1281 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp44_ = is_source;
#line 1281 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		if (_tmp44_) {
#line 10147 "Photo.c"
			gchar** _tmp45_;
			gint _tmp45__length1;
			gchar* _tmp46_;
#line 1282 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp45_ = alteration_list;
#line 1282 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp45__length1 = alteration_list_length1;
#line 1282 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp46_ = g_strdup ("backing:source");
#line 1282 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_vala_array_add218 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp46_);
#line 10159 "Photo.c"
		}
#line 1284 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp47_ = alteration_list;
#line 1284 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp47__length1 = alteration_list_length1;
#line 1284 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp48_ = alteration_new_from_array (_tmp47_, _tmp47__length1);
#line 1284 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp49_ = _tmp48_;
#line 1284 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		data_object_notify_altered (DATA_OBJECT (self), _tmp49_);
#line 1284 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_alteration_unref0 (_tmp49_);
#line 1269 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		alteration_list = (_vala_array_free (alteration_list, alteration_list_length1, (GDestroyNotify) g_free), NULL);
#line 10175 "Photo.c"
	}
#line 1242 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_g_object_unref0 (old_file);
#line 1242 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_g_free0 (filepath);
#line 10181 "Photo.c"
}


void photo_set_many_editable_file (GeeMap* map, GError** error) {
	PhotoTable* _tmp0_ = NULL;
	PhotoTable* _tmp1_;
	GeeMap* _tmp2_;
	GeeMapIterator* _tmp3_ = NULL;
	GeeMapIterator* map_iter;
	PhotoTable* _tmp12_ = NULL;
	PhotoTable* _tmp13_;
	GError * _inner_error_ = NULL;
#line 1289 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail (GEE_IS_MAP (map));
#line 1290 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp0_ = photo_table_get_instance ();
#line 1290 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 1290 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	database_table_begin_transaction ();
#line 1290 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_database_table_unref0 (_tmp1_);
#line 1292 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp2_ = map;
#line 1292 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp3_ = gee_map_map_iterator (_tmp2_);
#line 1292 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	map_iter = _tmp3_;
#line 1293 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	while (TRUE) {
#line 10212 "Photo.c"
		GeeMapIterator* _tmp4_;
		gboolean _tmp5_ = FALSE;
		GeeMapIterator* _tmp6_;
		gpointer _tmp7_ = NULL;
		Photo* _tmp8_;
		GeeMapIterator* _tmp9_;
		gpointer _tmp10_ = NULL;
		GFile* _tmp11_;
#line 1293 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp4_ = map_iter;
#line 1293 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp5_ = gee_map_iterator_next (_tmp4_);
#line 1293 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		if (!_tmp5_) {
#line 1293 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			break;
#line 10229 "Photo.c"
		}
#line 1294 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp6_ = map_iter;
#line 1294 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp7_ = gee_map_iterator_get_key (_tmp6_);
#line 1294 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp8_ = (Photo*) _tmp7_;
#line 1294 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp9_ = map_iter;
#line 1294 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp10_ = gee_map_iterator_get_value (_tmp9_);
#line 1294 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp11_ = (GFile*) _tmp10_;
#line 1294 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		photo_set_editable_file (_tmp8_, _tmp11_);
#line 1294 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_object_unref0 (_tmp11_);
#line 1294 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_object_unref0 (_tmp8_);
#line 10249 "Photo.c"
	}
#line 1296 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp12_ = photo_table_get_instance ();
#line 1296 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp13_ = _tmp12_;
#line 1296 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	database_table_commit_transaction (&_inner_error_);
#line 1296 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_database_table_unref0 (_tmp13_);
#line 1296 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 1296 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		if (_inner_error_->domain == DATABASE_ERROR) {
#line 1296 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 1296 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_g_object_unref0 (map_iter);
#line 1296 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			return;
#line 10269 "Photo.c"
		} else {
#line 1296 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_g_object_unref0 (map_iter);
#line 1296 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1296 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 1296 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			return;
#line 10279 "Photo.c"
		}
	}
#line 1289 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_g_object_unref0 (map_iter);
#line 10284 "Photo.c"
}


GFile* photo_get_actual_file (Photo* self) {
	GFile* result = NULL;
	PhotoFileReader* _tmp0_ = NULL;
	PhotoFileReader* _tmp1_;
	GFile* _tmp2_ = NULL;
	GFile* _tmp3_;
#line 1301 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 1302 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp0_ = photo_get_baseline_reader (self);
#line 1302 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 1302 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp2_ = photo_file_adapter_get_file (PHOTO_FILE_ADAPTER (_tmp1_));
#line 1302 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp3_ = _tmp2_;
#line 1302 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_photo_file_adapter_unref0 (_tmp1_);
#line 1302 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	result = _tmp3_;
#line 1302 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return result;
#line 10310 "Photo.c"
}


static GFile* photo_real_get_master_file (MediaSource* base) {
	Photo * self;
	GFile* result = NULL;
	PhotoFileReader* _tmp0_ = NULL;
	PhotoFileReader* _tmp1_;
	GFile* _tmp2_ = NULL;
	GFile* _tmp3_;
#line 1305 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	self = PHOTO (base);
#line 1306 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp0_ = photo_get_master_reader (self);
#line 1306 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 1306 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp2_ = photo_file_adapter_get_file (PHOTO_FILE_ADAPTER (_tmp1_));
#line 1306 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp3_ = _tmp2_;
#line 1306 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_photo_file_adapter_unref0 (_tmp1_);
#line 1306 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	result = _tmp3_;
#line 1306 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return result;
#line 10337 "Photo.c"
}


GFile* photo_get_editable_file (Photo* self) {
	GFile* result = NULL;
	PhotoFileReader* _tmp0_ = NULL;
	PhotoFileReader* reader;
	GFile* _tmp1_ = NULL;
	PhotoFileReader* _tmp2_;
#line 1309 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 1310 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp0_ = photo_get_editable_reader (self);
#line 1310 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	reader = _tmp0_;
#line 1312 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp2_ = reader;
#line 1312 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp2_ != NULL) {
#line 10357 "Photo.c"
		PhotoFileReader* _tmp3_;
		GFile* _tmp4_ = NULL;
#line 1312 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp3_ = reader;
#line 1312 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp4_ = photo_file_adapter_get_file (PHOTO_FILE_ADAPTER (_tmp3_));
#line 1312 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_object_unref0 (_tmp1_);
#line 1312 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp1_ = _tmp4_;
#line 10368 "Photo.c"
	} else {
#line 1312 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_object_unref0 (_tmp1_);
#line 1312 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp1_ = NULL;
#line 10374 "Photo.c"
	}
#line 1312 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	result = _tmp1_;
#line 1312 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_photo_file_adapter_unref0 (reader);
#line 1312 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return result;
#line 10382 "Photo.c"
}


GFile* photo_get_source_file (Photo* self) {
	GFile* result = NULL;
	PhotoFileReader* _tmp0_ = NULL;
	PhotoFileReader* _tmp1_;
	GFile* _tmp2_ = NULL;
	GFile* _tmp3_;
#line 1315 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 1316 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp0_ = photo_get_source_reader (self);
#line 1316 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 1316 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp2_ = photo_file_adapter_get_file (PHOTO_FILE_ADAPTER (_tmp1_));
#line 1316 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp3_ = _tmp2_;
#line 1316 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_photo_file_adapter_unref0 (_tmp1_);
#line 1316 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	result = _tmp3_;
#line 1316 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return result;
#line 10408 "Photo.c"
}


PhotoFileFormat photo_get_file_format (Photo* self) {
	PhotoFileFormat result = 0;
	GError * _inner_error_ = NULL;
#line 1319 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), 0);
#line 10417 "Photo.c"
	{
		PhotoRow _tmp0_;
#line 1320 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp0_ = self->priv->row;
#line 1320 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 10424 "Photo.c"
		{
			BackingPhotoState* _tmp1_;
			PhotoFileFormat _tmp2_;
#line 1321 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp1_ = self->priv->backing_photo_state;
#line 1321 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp2_ = (*_tmp1_).file_format;
#line 1321 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			result = _tmp2_;
#line 10434 "Photo.c"
			{
				PhotoRow _tmp3_;
#line 1320 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp3_ = self->priv->row;
#line 1320 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 10441 "Photo.c"
			}
#line 1321 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			return result;
#line 10445 "Photo.c"
		}
		__finally145:
		{
			PhotoRow _tmp4_;
#line 1320 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp4_ = self->priv->row;
#line 1320 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 10454 "Photo.c"
		}
#line 1320 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1320 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 1320 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return 0;
#line 10462 "Photo.c"
	}
}


PhotoFileFormat photo_get_best_export_file_format (Photo* self) {
	PhotoFileFormat result = 0;
	PhotoFileFormat _tmp0_ = 0;
	PhotoFileFormat file_format;
	PhotoFileFormat _tmp1_;
	gboolean _tmp2_ = FALSE;
#line 1325 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), 0);
#line 1326 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp0_ = photo_get_file_format (self);
#line 1326 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	file_format = _tmp0_;
#line 1327 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp1_ = file_format;
#line 1327 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp2_ = photo_file_format_can_write (_tmp1_);
#line 1327 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (!_tmp2_) {
#line 10485 "Photo.c"
		PhotoFileFormat _tmp3_ = 0;
#line 1328 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp3_ = photo_file_format_get_system_default_format ();
#line 1328 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		file_format = _tmp3_;
#line 10491 "Photo.c"
	}
#line 1330 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	result = file_format;
#line 1330 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return result;
#line 10497 "Photo.c"
}


PhotoFileFormat photo_get_master_file_format (Photo* self) {
	PhotoFileFormat result = 0;
	GError * _inner_error_ = NULL;
#line 1333 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), 0);
#line 10506 "Photo.c"
	{
		PhotoRow _tmp0_;
#line 1334 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp0_ = self->priv->row;
#line 1334 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 10513 "Photo.c"
		{
			PhotoBackingReaders _tmp1_;
			PhotoFileReader* _tmp2_;
			PhotoFileFormat _tmp3_ = 0;
#line 1335 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 1335 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp2_ = _tmp1_.master;
#line 1335 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp3_ = photo_file_adapter_get_file_format (PHOTO_FILE_ADAPTER (_tmp2_));
#line 1335 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			result = _tmp3_;
#line 10526 "Photo.c"
			{
				PhotoRow _tmp4_;
#line 1334 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp4_ = self->priv->row;
#line 1334 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 10533 "Photo.c"
			}
#line 1335 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			return result;
#line 10537 "Photo.c"
		}
		__finally146:
		{
			PhotoRow _tmp5_;
#line 1334 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp5_ = self->priv->row;
#line 1334 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 10546 "Photo.c"
		}
#line 1334 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1334 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 1334 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return 0;
#line 10554 "Photo.c"
	}
}


static time_t photo_real_get_timestamp (MediaSource* base) {
	Photo * self;
	time_t result = 0;
	GError * _inner_error_ = NULL;
#line 1339 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	self = PHOTO (base);
#line 10565 "Photo.c"
	{
		PhotoRow _tmp0_;
#line 1340 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp0_ = self->priv->row;
#line 1340 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 10572 "Photo.c"
		{
			BackingPhotoState* _tmp1_;
			time_t _tmp2_;
#line 1341 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp1_ = self->priv->backing_photo_state;
#line 1341 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp2_ = (*_tmp1_).timestamp;
#line 1341 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			result = _tmp2_;
#line 10582 "Photo.c"
			{
				PhotoRow _tmp3_;
#line 1340 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp3_ = self->priv->row;
#line 1340 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 10589 "Photo.c"
			}
#line 1341 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			return result;
#line 10593 "Photo.c"
		}
		__finally147:
		{
			PhotoRow _tmp4_;
#line 1340 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp4_ = self->priv->row;
#line 1340 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 10602 "Photo.c"
		}
#line 1340 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1340 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 1340 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return 0;
#line 10610 "Photo.c"
	}
}


void photo_get_photo_id (Photo* self, PhotoID* result) {
	GError * _inner_error_ = NULL;
#line 1345 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 10619 "Photo.c"
	{
		PhotoRow _tmp0_;
#line 1346 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp0_ = self->priv->row;
#line 1346 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 10626 "Photo.c"
		{
			PhotoRow _tmp1_;
			PhotoID _tmp2_;
#line 1347 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp1_ = self->priv->row;
#line 1347 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp2_ = _tmp1_.photo_id;
#line 1347 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			*result = _tmp2_;
#line 10636 "Photo.c"
			{
				PhotoRow _tmp3_;
#line 1346 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp3_ = self->priv->row;
#line 1346 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 10643 "Photo.c"
			}
#line 1347 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			return;
#line 10647 "Photo.c"
		}
		__finally148:
		{
			PhotoRow _tmp4_;
#line 1346 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp4_ = self->priv->row;
#line 1346 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 10656 "Photo.c"
		}
#line 1346 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1346 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 1346 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return;
#line 10664 "Photo.c"
	}
}


static inline void photo_real_get_event_id (MediaSource* base, EventID* result) {
	Photo * self;
	PhotoRow _tmp0_;
	EventID _tmp1_;
#line 1352 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	self = PHOTO (base);
#line 1353 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp0_ = self->priv->row;
#line 1353 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp1_ = _tmp0_.event_id;
#line 1353 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	*result = _tmp1_;
#line 1353 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return;
#line 10683 "Photo.c"
}


inline gint64 photo_get_raw_event_id (Photo* self) {
	gint64 result = 0LL;
	PhotoRow _tmp0_;
	EventID _tmp1_;
	gint64 _tmp2_;
#line 1357 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), 0LL);
#line 1358 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp0_ = self->priv->row;
#line 1358 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp1_ = _tmp0_.event_id;
#line 1358 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp2_ = _tmp1_.id;
#line 1358 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	result = _tmp2_;
#line 1358 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return result;
#line 10704 "Photo.c"
}


static void photo_real_get_import_id (MediaSource* base, ImportID* result) {
	Photo * self;
	GError * _inner_error_ = NULL;
#line 1361 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	self = PHOTO (base);
#line 10713 "Photo.c"
	{
		PhotoRow _tmp0_;
#line 1362 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp0_ = self->priv->row;
#line 1362 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 10720 "Photo.c"
		{
			PhotoRow _tmp1_;
			ImportID _tmp2_;
#line 1363 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp1_ = self->priv->row;
#line 1363 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp2_ = _tmp1_.import_id;
#line 1363 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			*result = _tmp2_;
#line 10730 "Photo.c"
			{
				PhotoRow _tmp3_;
#line 1362 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp3_ = self->priv->row;
#line 1362 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 10737 "Photo.c"
			}
#line 1363 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			return;
#line 10741 "Photo.c"
		}
		__finally149:
		{
			PhotoRow _tmp4_;
#line 1362 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp4_ = self->priv->row;
#line 1362 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 10750 "Photo.c"
		}
#line 1362 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1362 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 1362 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return;
#line 10758 "Photo.c"
	}
}


void photo_get_editable_id (Photo* self, BackingPhotoID* result) {
	GError * _inner_error_ = NULL;
#line 1367 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 10767 "Photo.c"
	{
		PhotoRow _tmp0_;
#line 1368 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp0_ = self->priv->row;
#line 1368 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 10774 "Photo.c"
		{
			PhotoRow _tmp1_;
			BackingPhotoID _tmp2_;
#line 1369 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp1_ = self->priv->row;
#line 1369 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp2_ = _tmp1_.editable_id;
#line 1369 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			*result = _tmp2_;
#line 10784 "Photo.c"
			{
				PhotoRow _tmp3_;
#line 1368 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp3_ = self->priv->row;
#line 1368 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 10791 "Photo.c"
			}
#line 1369 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			return;
#line 10795 "Photo.c"
		}
		__finally150:
		{
			PhotoRow _tmp4_;
#line 1368 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp4_ = self->priv->row;
#line 1368 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 10804 "Photo.c"
		}
#line 1368 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1368 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 1368 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return;
#line 10812 "Photo.c"
	}
}


static gchar* photo_real_get_master_md5 (MediaSource* base) {
	Photo * self;
	gchar* result = NULL;
	GError * _inner_error_ = NULL;
#line 1373 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	self = PHOTO (base);
#line 10823 "Photo.c"
	{
		PhotoRow _tmp0_;
#line 1374 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp0_ = self->priv->row;
#line 1374 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 10830 "Photo.c"
		{
			PhotoRow _tmp1_;
			const gchar* _tmp2_;
			gchar* _tmp3_;
#line 1375 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp1_ = self->priv->row;
#line 1375 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp2_ = _tmp1_.md5;
#line 1375 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp3_ = g_strdup (_tmp2_);
#line 1375 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			result = _tmp3_;
#line 10843 "Photo.c"
			{
				PhotoRow _tmp4_;
#line 1374 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp4_ = self->priv->row;
#line 1374 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 10850 "Photo.c"
			}
#line 1375 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			return result;
#line 10854 "Photo.c"
		}
		__finally151:
		{
			PhotoRow _tmp5_;
#line 1374 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp5_ = self->priv->row;
#line 1374 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 10863 "Photo.c"
		}
#line 1374 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1374 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 1374 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return NULL;
#line 10871 "Photo.c"
	}
}


guint64 photo_get_flags (Photo* self) {
	guint64 result = 0ULL;
	GError * _inner_error_ = NULL;
#line 1381 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), 0ULL);
#line 10881 "Photo.c"
	{
		PhotoRow _tmp0_;
#line 1382 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp0_ = self->priv->row;
#line 1382 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 10888 "Photo.c"
		{
			PhotoRow _tmp1_;
			guint64 _tmp2_;
#line 1383 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp1_ = self->priv->row;
#line 1383 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp2_ = _tmp1_.flags;
#line 1383 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			result = _tmp2_;
#line 10898 "Photo.c"
			{
				PhotoRow _tmp3_;
#line 1382 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp3_ = self->priv->row;
#line 1382 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 10905 "Photo.c"
			}
#line 1383 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			return result;
#line 10909 "Photo.c"
		}
		__finally152:
		{
			PhotoRow _tmp4_;
#line 1382 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp4_ = self->priv->row;
#line 1382 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 10918 "Photo.c"
		}
#line 1382 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1382 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 1382 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return 0ULL;
#line 10926 "Photo.c"
	}
}


static void photo_notify_flags_altered (Photo* self, Alteration* additional_alteration) {
	Alteration* _tmp0_;
	Alteration* alteration;
	Alteration* _tmp1_;
	Alteration* _tmp5_;
#line 1387 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 1387 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail ((additional_alteration == NULL) || IS_ALTERATION (additional_alteration));
#line 1388 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp0_ = alteration_new ("metadata", "flags");
#line 1388 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	alteration = _tmp0_;
#line 1389 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp1_ = additional_alteration;
#line 1389 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp1_ != NULL) {
#line 10948 "Photo.c"
		Alteration* _tmp2_;
		Alteration* _tmp3_;
		Alteration* _tmp4_ = NULL;
#line 1390 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp2_ = alteration;
#line 1390 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp3_ = additional_alteration;
#line 1390 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp4_ = alteration_compress (_tmp2_, _tmp3_);
#line 1390 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_alteration_unref0 (alteration);
#line 1390 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		alteration = _tmp4_;
#line 10962 "Photo.c"
	}
#line 1392 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp5_ = alteration;
#line 1392 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	data_object_notify_altered (DATA_OBJECT (self), _tmp5_);
#line 1387 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_alteration_unref0 (alteration);
#line 10970 "Photo.c"
}


guint64 photo_replace_flags (Photo* self, guint64 flags, Alteration* additional_alteration) {
	guint64 result = 0ULL;
	gboolean committed = FALSE;
	gboolean _tmp9_;
	guint64 _tmp11_;
	GError * _inner_error_ = NULL;
#line 1395 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), 0ULL);
#line 1395 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail ((additional_alteration == NULL) || IS_ALTERATION (additional_alteration), 0ULL);
#line 10984 "Photo.c"
	{
		PhotoRow _tmp0_;
#line 1397 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp0_ = self->priv->row;
#line 1397 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 10991 "Photo.c"
		{
			PhotoTable* _tmp1_ = NULL;
			PhotoTable* _tmp2_;
			PhotoID _tmp3_ = {0};
			guint64 _tmp4_;
			gboolean _tmp5_ = FALSE;
			gboolean _tmp6_;
#line 1398 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp1_ = photo_table_get_instance ();
#line 1398 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp2_ = _tmp1_;
#line 1398 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			photo_get_photo_id (self, &_tmp3_);
#line 1398 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp4_ = flags;
#line 1398 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp5_ = photo_table_replace_flags (_tmp2_, &_tmp3_, _tmp4_);
#line 1398 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			committed = _tmp5_;
#line 1398 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_database_table_unref0 (_tmp2_);
#line 1399 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp6_ = committed;
#line 1399 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			if (_tmp6_) {
#line 11017 "Photo.c"
				guint64 _tmp7_;
#line 1400 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp7_ = flags;
#line 1400 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				self->priv->row.flags = _tmp7_;
#line 11023 "Photo.c"
			}
		}
		__finally153:
		{
			PhotoRow _tmp8_;
#line 1397 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp8_ = self->priv->row;
#line 1397 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 11033 "Photo.c"
		}
#line 1397 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 1397 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1397 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 1397 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			return 0ULL;
#line 11043 "Photo.c"
		}
	}
#line 1403 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp9_ = committed;
#line 1403 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp9_) {
#line 11050 "Photo.c"
		Alteration* _tmp10_;
#line 1404 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp10_ = additional_alteration;
#line 1404 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		photo_notify_flags_altered (self, _tmp10_);
#line 11056 "Photo.c"
	}
#line 1406 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp11_ = flags;
#line 1406 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	result = _tmp11_;
#line 1406 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return result;
#line 11064 "Photo.c"
}


gboolean photo_is_flag_set (Photo* self, guint64 mask) {
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
#line 1409 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 11073 "Photo.c"
	{
		PhotoRow _tmp0_;
#line 1410 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp0_ = self->priv->row;
#line 1410 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 11080 "Photo.c"
		{
			PhotoRow _tmp1_;
			guint64 _tmp2_;
			guint64 _tmp3_;
			gboolean _tmp4_ = FALSE;
#line 1411 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp1_ = self->priv->row;
#line 1411 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp2_ = _tmp1_.flags;
#line 1411 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp3_ = mask;
#line 1411 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp4_ = media_source_internal_is_flag_set (_tmp2_, _tmp3_);
#line 1411 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			result = _tmp4_;
#line 11096 "Photo.c"
			{
				PhotoRow _tmp5_;
#line 1410 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp5_ = self->priv->row;
#line 1410 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 11103 "Photo.c"
			}
#line 1411 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			return result;
#line 11107 "Photo.c"
		}
		__finally154:
		{
			PhotoRow _tmp6_;
#line 1410 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp6_ = self->priv->row;
#line 1410 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 11116 "Photo.c"
		}
#line 1410 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1410 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 1410 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return FALSE;
#line 11124 "Photo.c"
	}
}


guint64 photo_add_flags (Photo* self, guint64 mask, Alteration* additional_alteration) {
	guint64 result = 0ULL;
	guint64 flags;
	gboolean committed;
	gboolean _tmp16_;
	GError * _inner_error_ = NULL;
#line 1415 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), 0ULL);
#line 1415 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail ((additional_alteration == NULL) || IS_ALTERATION (additional_alteration), 0ULL);
#line 1416 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	flags = (guint64) 0;
#line 1418 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	committed = FALSE;
#line 11143 "Photo.c"
	{
		PhotoRow _tmp0_;
#line 1419 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp0_ = self->priv->row;
#line 1419 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 11150 "Photo.c"
		{
			PhotoRow _tmp1_;
			guint64 _tmp2_;
			guint64 _tmp3_;
			guint64 _tmp4_ = 0ULL;
			PhotoRow _tmp5_;
			guint64 _tmp6_;
			guint64 _tmp7_;
#line 1420 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp1_ = self->priv->row;
#line 1420 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp2_ = _tmp1_.flags;
#line 1420 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp3_ = mask;
#line 1420 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp4_ = media_source_internal_add_flags (_tmp2_, _tmp3_);
#line 1420 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			flags = _tmp4_;
#line 1421 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp5_ = self->priv->row;
#line 1421 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp6_ = _tmp5_.flags;
#line 1421 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp7_ = flags;
#line 1421 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			if (_tmp6_ != _tmp7_) {
#line 11177 "Photo.c"
				PhotoTable* _tmp8_ = NULL;
				PhotoTable* _tmp9_;
				PhotoID _tmp10_ = {0};
				guint64 _tmp11_;
				gboolean _tmp12_ = FALSE;
				gboolean _tmp13_;
#line 1422 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp8_ = photo_table_get_instance ();
#line 1422 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp9_ = _tmp8_;
#line 1422 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				photo_get_photo_id (self, &_tmp10_);
#line 1422 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp11_ = flags;
#line 1422 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp12_ = photo_table_replace_flags (_tmp9_, &_tmp10_, _tmp11_);
#line 1422 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				committed = _tmp12_;
#line 1422 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_database_table_unref0 (_tmp9_);
#line 1423 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp13_ = committed;
#line 1423 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				if (_tmp13_) {
#line 11202 "Photo.c"
					guint64 _tmp14_;
#line 1424 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_tmp14_ = flags;
#line 1424 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					self->priv->row.flags = _tmp14_;
#line 11208 "Photo.c"
				}
			}
		}
		__finally155:
		{
			PhotoRow _tmp15_;
#line 1419 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp15_ = self->priv->row;
#line 1419 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 11219 "Photo.c"
		}
#line 1419 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 1419 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1419 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 1419 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			return 0ULL;
#line 11229 "Photo.c"
		}
	}
#line 1428 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp16_ = committed;
#line 1428 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp16_) {
#line 11236 "Photo.c"
		Alteration* _tmp17_;
#line 1429 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp17_ = additional_alteration;
#line 1429 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		photo_notify_flags_altered (self, _tmp17_);
#line 11242 "Photo.c"
	}
#line 1431 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	result = flags;
#line 1431 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return result;
#line 11248 "Photo.c"
}


guint64 photo_remove_flags (Photo* self, guint64 mask, Alteration* additional_alteration) {
	guint64 result = 0ULL;
	guint64 flags;
	gboolean committed;
	gboolean _tmp16_;
	GError * _inner_error_ = NULL;
#line 1434 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), 0ULL);
#line 1434 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail ((additional_alteration == NULL) || IS_ALTERATION (additional_alteration), 0ULL);
#line 1435 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	flags = (guint64) 0;
#line 1437 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	committed = FALSE;
#line 11266 "Photo.c"
	{
		PhotoRow _tmp0_;
#line 1438 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp0_ = self->priv->row;
#line 1438 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 11273 "Photo.c"
		{
			PhotoRow _tmp1_;
			guint64 _tmp2_;
			guint64 _tmp3_;
			guint64 _tmp4_ = 0ULL;
			PhotoRow _tmp5_;
			guint64 _tmp6_;
			guint64 _tmp7_;
#line 1439 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp1_ = self->priv->row;
#line 1439 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp2_ = _tmp1_.flags;
#line 1439 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp3_ = mask;
#line 1439 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp4_ = media_source_internal_remove_flags (_tmp2_, _tmp3_);
#line 1439 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			flags = _tmp4_;
#line 1440 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp5_ = self->priv->row;
#line 1440 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp6_ = _tmp5_.flags;
#line 1440 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp7_ = flags;
#line 1440 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			if (_tmp6_ != _tmp7_) {
#line 11300 "Photo.c"
				PhotoTable* _tmp8_ = NULL;
				PhotoTable* _tmp9_;
				PhotoID _tmp10_ = {0};
				guint64 _tmp11_;
				gboolean _tmp12_ = FALSE;
				gboolean _tmp13_;
#line 1441 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp8_ = photo_table_get_instance ();
#line 1441 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp9_ = _tmp8_;
#line 1441 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				photo_get_photo_id (self, &_tmp10_);
#line 1441 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp11_ = flags;
#line 1441 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp12_ = photo_table_replace_flags (_tmp9_, &_tmp10_, _tmp11_);
#line 1441 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				committed = _tmp12_;
#line 1441 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_database_table_unref0 (_tmp9_);
#line 1442 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp13_ = committed;
#line 1442 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				if (_tmp13_) {
#line 11325 "Photo.c"
					guint64 _tmp14_;
#line 1443 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_tmp14_ = flags;
#line 1443 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					self->priv->row.flags = _tmp14_;
#line 11331 "Photo.c"
				}
			}
		}
		__finally156:
		{
			PhotoRow _tmp15_;
#line 1438 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp15_ = self->priv->row;
#line 1438 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 11342 "Photo.c"
		}
#line 1438 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 1438 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1438 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 1438 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			return 0ULL;
#line 11352 "Photo.c"
		}
	}
#line 1447 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp16_ = committed;
#line 1447 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp16_) {
#line 11359 "Photo.c"
		Alteration* _tmp17_;
#line 1448 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp17_ = additional_alteration;
#line 1448 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		photo_notify_flags_altered (self, _tmp17_);
#line 11365 "Photo.c"
	}
#line 1450 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	result = flags;
#line 1450 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return result;
#line 11371 "Photo.c"
}


guint64 photo_add_remove_flags (Photo* self, guint64 add, guint64 remove, Alteration* additional_alteration) {
	guint64 result = 0ULL;
	guint64 flags;
	gboolean committed;
	gboolean _tmp16_;
	GError * _inner_error_ = NULL;
#line 1453 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), 0ULL);
#line 1453 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail ((additional_alteration == NULL) || IS_ALTERATION (additional_alteration), 0ULL);
#line 1454 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	flags = (guint64) 0;
#line 1456 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	committed = FALSE;
#line 11389 "Photo.c"
	{
		PhotoRow _tmp0_;
#line 1457 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp0_ = self->priv->row;
#line 1457 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 11396 "Photo.c"
		{
			PhotoRow _tmp1_;
			guint64 _tmp2_;
			guint64 _tmp3_;
			guint64 _tmp4_;
			PhotoRow _tmp5_;
			guint64 _tmp6_;
			guint64 _tmp7_;
#line 1458 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp1_ = self->priv->row;
#line 1458 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp2_ = _tmp1_.flags;
#line 1458 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp3_ = add;
#line 1458 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp4_ = remove;
#line 1458 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			flags = (_tmp2_ | _tmp3_) & (~_tmp4_);
#line 1459 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp5_ = self->priv->row;
#line 1459 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp6_ = _tmp5_.flags;
#line 1459 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp7_ = flags;
#line 1459 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			if (_tmp6_ != _tmp7_) {
#line 11423 "Photo.c"
				PhotoTable* _tmp8_ = NULL;
				PhotoTable* _tmp9_;
				PhotoID _tmp10_ = {0};
				guint64 _tmp11_;
				gboolean _tmp12_ = FALSE;
				gboolean _tmp13_;
#line 1460 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp8_ = photo_table_get_instance ();
#line 1460 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp9_ = _tmp8_;
#line 1460 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				photo_get_photo_id (self, &_tmp10_);
#line 1460 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp11_ = flags;
#line 1460 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp12_ = photo_table_replace_flags (_tmp9_, &_tmp10_, _tmp11_);
#line 1460 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				committed = _tmp12_;
#line 1460 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_database_table_unref0 (_tmp9_);
#line 1461 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp13_ = committed;
#line 1461 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				if (_tmp13_) {
#line 11448 "Photo.c"
					guint64 _tmp14_;
#line 1462 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_tmp14_ = flags;
#line 1462 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					self->priv->row.flags = _tmp14_;
#line 11454 "Photo.c"
				}
			}
		}
		__finally157:
		{
			PhotoRow _tmp15_;
#line 1457 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp15_ = self->priv->row;
#line 1457 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 11465 "Photo.c"
		}
#line 1457 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 1457 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1457 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 1457 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			return 0ULL;
#line 11475 "Photo.c"
		}
	}
#line 1466 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp16_ = committed;
#line 1466 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp16_) {
#line 11482 "Photo.c"
		Alteration* _tmp17_;
#line 1467 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp17_ = additional_alteration;
#line 1467 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		photo_notify_flags_altered (self, _tmp17_);
#line 11488 "Photo.c"
	}
#line 1469 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	result = flags;
#line 1469 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return result;
#line 11494 "Photo.c"
}


void photo_add_remove_many_flags (GeeCollection* add, guint64 add_mask, Alteration* additional_add_alteration, GeeCollection* remove, guint64 remove_mask, Alteration* additional_remove_alteration, GError** error) {
	GeeCollection* _tmp0_;
	GeeCollection* _tmp10_;
	GError * _inner_error_ = NULL;
#line 1472 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail ((add == NULL) || GEE_IS_COLLECTION (add));
#line 1472 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail ((additional_add_alteration == NULL) || IS_ALTERATION (additional_add_alteration));
#line 1472 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail ((remove == NULL) || GEE_IS_COLLECTION (remove));
#line 1472 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail ((additional_remove_alteration == NULL) || IS_ALTERATION (additional_remove_alteration));
#line 1475 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	database_table_begin_transaction ();
#line 1477 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp0_ = add;
#line 1477 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp0_ != NULL) {
#line 11516 "Photo.c"
		{
			GeeCollection* _tmp1_;
			GeeIterator* _tmp2_ = NULL;
			GeeIterator* _photo_it;
#line 1478 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp1_ = add;
#line 1478 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp2_ = gee_iterable_iterator (GEE_ITERABLE (_tmp1_));
#line 1478 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_photo_it = _tmp2_;
#line 1478 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			while (TRUE) {
#line 11529 "Photo.c"
				GeeIterator* _tmp3_;
				gboolean _tmp4_ = FALSE;
				GeeIterator* _tmp5_;
				gpointer _tmp6_ = NULL;
				Photo* photo;
				Photo* _tmp7_;
				guint64 _tmp8_;
				Alteration* _tmp9_;
#line 1478 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp3_ = _photo_it;
#line 1478 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp4_ = gee_iterator_next (_tmp3_);
#line 1478 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				if (!_tmp4_) {
#line 1478 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					break;
#line 11546 "Photo.c"
				}
#line 1478 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp5_ = _photo_it;
#line 1478 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp6_ = gee_iterator_get (_tmp5_);
#line 1478 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				photo = (Photo*) _tmp6_;
#line 1479 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp7_ = photo;
#line 1479 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp8_ = add_mask;
#line 1479 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp9_ = additional_add_alteration;
#line 1479 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				photo_add_flags (_tmp7_, _tmp8_, _tmp9_);
#line 1478 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_g_object_unref0 (photo);
#line 11564 "Photo.c"
			}
#line 1478 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_g_object_unref0 (_photo_it);
#line 11568 "Photo.c"
		}
	}
#line 1482 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp10_ = remove;
#line 1482 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp10_ != NULL) {
#line 11575 "Photo.c"
		{
			GeeCollection* _tmp11_;
			GeeIterator* _tmp12_ = NULL;
			GeeIterator* _photo_it;
#line 1483 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp11_ = remove;
#line 1483 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp12_ = gee_iterable_iterator (GEE_ITERABLE (_tmp11_));
#line 1483 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_photo_it = _tmp12_;
#line 1483 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			while (TRUE) {
#line 11588 "Photo.c"
				GeeIterator* _tmp13_;
				gboolean _tmp14_ = FALSE;
				GeeIterator* _tmp15_;
				gpointer _tmp16_ = NULL;
				Photo* photo;
				Photo* _tmp17_;
				guint64 _tmp18_;
				Alteration* _tmp19_;
#line 1483 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp13_ = _photo_it;
#line 1483 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp14_ = gee_iterator_next (_tmp13_);
#line 1483 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				if (!_tmp14_) {
#line 1483 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					break;
#line 11605 "Photo.c"
				}
#line 1483 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp15_ = _photo_it;
#line 1483 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp16_ = gee_iterator_get (_tmp15_);
#line 1483 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				photo = (Photo*) _tmp16_;
#line 1484 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp17_ = photo;
#line 1484 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp18_ = remove_mask;
#line 1484 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp19_ = additional_remove_alteration;
#line 1484 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				photo_remove_flags (_tmp17_, _tmp18_, _tmp19_);
#line 1483 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_g_object_unref0 (photo);
#line 11623 "Photo.c"
			}
#line 1483 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_g_object_unref0 (_photo_it);
#line 11627 "Photo.c"
		}
	}
#line 1487 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	database_table_commit_transaction (&_inner_error_);
#line 1487 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 1487 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		if (_inner_error_->domain == DATABASE_ERROR) {
#line 1487 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 1487 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			return;
#line 11640 "Photo.c"
		} else {
#line 1487 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1487 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 1487 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			return;
#line 11648 "Photo.c"
		}
	}
}


guint64 photo_toggle_flags (Photo* self, guint64 mask, Alteration* additional_alteration) {
	guint64 result = 0ULL;
	guint64 flags;
	gboolean committed;
	gboolean _tmp15_;
	GError * _inner_error_ = NULL;
#line 1490 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), 0ULL);
#line 1490 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail ((additional_alteration == NULL) || IS_ALTERATION (additional_alteration), 0ULL);
#line 1491 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	flags = (guint64) 0;
#line 1493 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	committed = FALSE;
#line 11668 "Photo.c"
	{
		PhotoRow _tmp0_;
#line 1494 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp0_ = self->priv->row;
#line 1494 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 11675 "Photo.c"
		{
			PhotoRow _tmp1_;
			guint64 _tmp2_;
			guint64 _tmp3_;
			PhotoRow _tmp4_;
			guint64 _tmp5_;
			guint64 _tmp6_;
#line 1495 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp1_ = self->priv->row;
#line 1495 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp2_ = _tmp1_.flags;
#line 1495 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp3_ = mask;
#line 1495 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			flags = _tmp2_ ^ _tmp3_;
#line 1496 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp4_ = self->priv->row;
#line 1496 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp5_ = _tmp4_.flags;
#line 1496 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp6_ = flags;
#line 1496 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			if (_tmp5_ != _tmp6_) {
#line 11699 "Photo.c"
				PhotoTable* _tmp7_ = NULL;
				PhotoTable* _tmp8_;
				PhotoID _tmp9_ = {0};
				guint64 _tmp10_;
				gboolean _tmp11_ = FALSE;
				gboolean _tmp12_;
#line 1497 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp7_ = photo_table_get_instance ();
#line 1497 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp8_ = _tmp7_;
#line 1497 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				photo_get_photo_id (self, &_tmp9_);
#line 1497 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp10_ = flags;
#line 1497 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp11_ = photo_table_replace_flags (_tmp8_, &_tmp9_, _tmp10_);
#line 1497 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				committed = _tmp11_;
#line 1497 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_database_table_unref0 (_tmp8_);
#line 1498 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp12_ = committed;
#line 1498 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				if (_tmp12_) {
#line 11724 "Photo.c"
					guint64 _tmp13_;
#line 1499 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_tmp13_ = flags;
#line 1499 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					self->priv->row.flags = _tmp13_;
#line 11730 "Photo.c"
				}
			}
		}
		__finally158:
		{
			PhotoRow _tmp14_;
#line 1494 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp14_ = self->priv->row;
#line 1494 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 11741 "Photo.c"
		}
#line 1494 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 1494 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1494 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 1494 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			return 0ULL;
#line 11751 "Photo.c"
		}
	}
#line 1503 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp15_ = committed;
#line 1503 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp15_) {
#line 11758 "Photo.c"
		Alteration* _tmp16_;
#line 1504 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp16_ = additional_alteration;
#line 1504 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		photo_notify_flags_altered (self, _tmp16_);
#line 11764 "Photo.c"
	}
#line 1506 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	result = flags;
#line 1506 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return result;
#line 11770 "Photo.c"
}


gboolean photo_is_master_metadata_dirty (Photo* self) {
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
#line 1509 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 11779 "Photo.c"
	{
		PhotoRow _tmp0_;
#line 1510 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp0_ = self->priv->row;
#line 1510 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 11786 "Photo.c"
		{
			PhotoRow _tmp1_;
			gboolean _tmp2_;
#line 1511 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp1_ = self->priv->row;
#line 1511 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp2_ = _tmp1_.metadata_dirty;
#line 1511 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			result = _tmp2_;
#line 11796 "Photo.c"
			{
				PhotoRow _tmp3_;
#line 1510 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp3_ = self->priv->row;
#line 1510 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 11803 "Photo.c"
			}
#line 1511 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			return result;
#line 11807 "Photo.c"
		}
		__finally159:
		{
			PhotoRow _tmp4_;
#line 1510 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp4_ = self->priv->row;
#line 1510 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 11816 "Photo.c"
		}
#line 1510 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1510 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 1510 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return FALSE;
#line 11824 "Photo.c"
	}
}


void photo_set_master_metadata_dirty (Photo* self, gboolean dirty, GError** error) {
	gboolean committed;
	gboolean _tmp10_;
	GError * _inner_error_ = NULL;
#line 1515 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 1516 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	committed = FALSE;
#line 11837 "Photo.c"
	{
		PhotoRow _tmp0_;
#line 1517 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp0_ = self->priv->row;
#line 1517 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 11844 "Photo.c"
		{
			PhotoRow _tmp1_;
			gboolean _tmp2_;
			gboolean _tmp3_;
#line 1518 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp1_ = self->priv->row;
#line 1518 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp2_ = _tmp1_.metadata_dirty;
#line 1518 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp3_ = dirty;
#line 1518 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			if (_tmp2_ != _tmp3_) {
#line 11857 "Photo.c"
				PhotoTable* _tmp4_ = NULL;
				PhotoTable* _tmp5_;
				PhotoID _tmp6_ = {0};
				gboolean _tmp7_;
				gboolean _tmp8_;
#line 1519 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp4_ = photo_table_get_instance ();
#line 1519 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp5_ = _tmp4_;
#line 1519 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				photo_get_photo_id (self, &_tmp6_);
#line 1519 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp7_ = dirty;
#line 1519 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				photo_table_set_metadata_dirty (_tmp5_, &_tmp6_, _tmp7_, &_inner_error_);
#line 1519 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_database_table_unref0 (_tmp5_);
#line 1519 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				if (_inner_error_ != NULL) {
#line 11877 "Photo.c"
					goto __finally160;
				}
#line 1520 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp8_ = dirty;
#line 1520 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				self->priv->row.metadata_dirty = _tmp8_;
#line 1521 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				committed = TRUE;
#line 11886 "Photo.c"
			}
		}
		__finally160:
		{
			PhotoRow _tmp9_;
#line 1517 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp9_ = self->priv->row;
#line 1517 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 11896 "Photo.c"
		}
#line 1517 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 1517 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			if (_inner_error_->domain == DATABASE_ERROR) {
#line 1517 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				g_propagate_error (error, _inner_error_);
#line 1517 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				return;
#line 11906 "Photo.c"
			} else {
#line 1517 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1517 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				g_clear_error (&_inner_error_);
#line 1517 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				return;
#line 11914 "Photo.c"
			}
		}
	}
#line 1525 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp10_ = committed;
#line 1525 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp10_) {
#line 11922 "Photo.c"
		Alteration* _tmp11_;
		Alteration* _tmp12_;
#line 1526 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp11_ = alteration_new ("metadata", "master-dirty");
#line 1526 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp12_ = _tmp11_;
#line 1526 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		data_object_notify_altered (DATA_OBJECT (self), _tmp12_);
#line 1526 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_alteration_unref0 (_tmp12_);
#line 11933 "Photo.c"
	}
}


static Rating photo_real_get_rating (MediaSource* base) {
	Photo * self;
	Rating result = 0;
	GError * _inner_error_ = NULL;
#line 1529 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	self = PHOTO (base);
#line 11944 "Photo.c"
	{
		PhotoRow _tmp0_;
#line 1530 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp0_ = self->priv->row;
#line 1530 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 11951 "Photo.c"
		{
			PhotoRow _tmp1_;
			Rating _tmp2_;
#line 1531 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp1_ = self->priv->row;
#line 1531 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp2_ = _tmp1_.rating;
#line 1531 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			result = _tmp2_;
#line 11961 "Photo.c"
			{
				PhotoRow _tmp3_;
#line 1530 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp3_ = self->priv->row;
#line 1530 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 11968 "Photo.c"
			}
#line 1531 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			return result;
#line 11972 "Photo.c"
		}
		__finally161:
		{
			PhotoRow _tmp4_;
#line 1530 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp4_ = self->priv->row;
#line 1530 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 11981 "Photo.c"
		}
#line 1530 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1530 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 1530 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return 0;
#line 11989 "Photo.c"
	}
}


static void photo_real_set_rating (MediaSource* base, Rating rating) {
	Photo * self;
	gboolean committed;
	gboolean _tmp16_;
	GError * _inner_error_ = NULL;
#line 1535 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	self = PHOTO (base);
#line 1536 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	committed = FALSE;
#line 12003 "Photo.c"
	{
		PhotoRow _tmp0_;
#line 1538 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp0_ = self->priv->row;
#line 1538 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 12010 "Photo.c"
		{
			gboolean _tmp1_ = FALSE;
			Rating _tmp2_;
			PhotoRow _tmp3_;
			Rating _tmp4_;
			gboolean _tmp7_;
#line 1539 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp2_ = rating;
#line 1539 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp3_ = self->priv->row;
#line 1539 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp4_ = _tmp3_.rating;
#line 1539 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			if (_tmp2_ != _tmp4_) {
#line 12025 "Photo.c"
				Rating _tmp5_;
				gboolean _tmp6_ = FALSE;
#line 1539 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp5_ = rating;
#line 1539 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp6_ = rating_is_valid (_tmp5_);
#line 1539 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp1_ = _tmp6_;
#line 12034 "Photo.c"
			} else {
#line 1539 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp1_ = FALSE;
#line 12038 "Photo.c"
			}
#line 1539 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp7_ = _tmp1_;
#line 1539 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			if (_tmp7_) {
#line 12044 "Photo.c"
				PhotoTable* _tmp8_ = NULL;
				PhotoTable* _tmp9_;
				PhotoID _tmp10_ = {0};
				Rating _tmp11_;
				gboolean _tmp12_ = FALSE;
				gboolean _tmp13_;
#line 1540 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp8_ = photo_table_get_instance ();
#line 1540 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp9_ = _tmp8_;
#line 1540 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				photo_get_photo_id (self, &_tmp10_);
#line 1540 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp11_ = rating;
#line 1540 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp12_ = photo_table_set_rating (_tmp9_, &_tmp10_, _tmp11_);
#line 1540 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				committed = _tmp12_;
#line 1540 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_database_table_unref0 (_tmp9_);
#line 1541 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp13_ = committed;
#line 1541 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				if (_tmp13_) {
#line 12069 "Photo.c"
					Rating _tmp14_;
#line 1542 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_tmp14_ = rating;
#line 1542 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					self->priv->row.rating = _tmp14_;
#line 12075 "Photo.c"
				}
			}
		}
		__finally162:
		{
			PhotoRow _tmp15_;
#line 1538 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp15_ = self->priv->row;
#line 1538 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 12086 "Photo.c"
		}
#line 1538 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 1538 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1538 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 1538 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			return;
#line 12096 "Photo.c"
		}
	}
#line 1546 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp16_ = committed;
#line 1546 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp16_) {
#line 12103 "Photo.c"
		Alteration* _tmp17_;
		Alteration* _tmp18_;
#line 1547 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp17_ = alteration_new ("metadata", "rating");
#line 1547 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp18_ = _tmp17_;
#line 1547 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		data_object_notify_altered (DATA_OBJECT (self), _tmp18_);
#line 1547 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_alteration_unref0 (_tmp18_);
#line 12114 "Photo.c"
	}
}


static void photo_real_increase_rating (MediaSource* base) {
	Photo * self;
	GError * _inner_error_ = NULL;
#line 1550 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	self = PHOTO (base);
#line 12124 "Photo.c"
	{
		PhotoRow _tmp0_;
#line 1551 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp0_ = self->priv->row;
#line 1551 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 12131 "Photo.c"
		{
			PhotoRow _tmp1_;
			Rating _tmp2_;
			Rating _tmp3_ = 0;
#line 1552 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp1_ = self->priv->row;
#line 1552 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp2_ = _tmp1_.rating;
#line 1552 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp3_ = rating_increase (_tmp2_);
#line 1552 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			media_source_set_rating (MEDIA_SOURCE (self), _tmp3_);
#line 12144 "Photo.c"
		}
		__finally163:
		{
			PhotoRow _tmp4_;
#line 1551 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp4_ = self->priv->row;
#line 1551 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 12153 "Photo.c"
		}
#line 1551 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 1551 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1551 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 1551 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			return;
#line 12163 "Photo.c"
		}
	}
}


static void photo_real_decrease_rating (MediaSource* base) {
	Photo * self;
	GError * _inner_error_ = NULL;
#line 1556 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	self = PHOTO (base);
#line 12174 "Photo.c"
	{
		PhotoRow _tmp0_;
#line 1557 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp0_ = self->priv->row;
#line 1557 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 12181 "Photo.c"
		{
			PhotoRow _tmp1_;
			Rating _tmp2_;
			Rating _tmp3_ = 0;
#line 1558 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp1_ = self->priv->row;
#line 1558 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp2_ = _tmp1_.rating;
#line 1558 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp3_ = rating_decrease (_tmp2_);
#line 1558 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			media_source_set_rating (MEDIA_SOURCE (self), _tmp3_);
#line 12194 "Photo.c"
		}
		__finally164:
		{
			PhotoRow _tmp4_;
#line 1557 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp4_ = self->priv->row;
#line 1557 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 12203 "Photo.c"
		}
#line 1557 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 1557 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1557 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 1557 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			return;
#line 12213 "Photo.c"
		}
	}
}


static void photo_real_commit_backlinks (DataSource* base, SourceCollection* sources, const gchar* backlinks) {
	Photo * self;
	GError * _inner_error_ = NULL;
#line 1562 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	self = PHOTO (base);
#line 1562 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail ((sources == NULL) || IS_SOURCE_COLLECTION (sources));
#line 12226 "Photo.c"
	{
		PhotoTable* _tmp0_ = NULL;
		PhotoTable* _tmp1_;
		PhotoID _tmp2_ = {0};
		const gchar* _tmp3_;
#line 1567 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp0_ = photo_table_get_instance ();
#line 1567 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp1_ = _tmp0_;
#line 1567 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		photo_get_photo_id (self, &_tmp2_);
#line 1567 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp3_ = backlinks;
#line 1567 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		photo_table_update_backlinks (_tmp1_, &_tmp2_, _tmp3_, &_inner_error_);
#line 1567 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_database_table_unref0 (_tmp1_);
#line 1567 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 1567 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			if (_inner_error_->domain == DATABASE_ERROR) {
#line 12248 "Photo.c"
				goto __catch165_database_error;
			}
#line 1567 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1567 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 1567 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			return;
#line 12257 "Photo.c"
		}
		{
			PhotoRow _tmp4_;
#line 1568 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp4_ = self->priv->row;
#line 1568 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 12265 "Photo.c"
			{
				const gchar* _tmp5_;
				gchar* _tmp6_;
#line 1569 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp5_ = backlinks;
#line 1569 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp6_ = g_strdup (_tmp5_);
#line 1569 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_g_free0 (self->priv->row.backlinks);
#line 1569 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				self->priv->row.backlinks = _tmp6_;
#line 12277 "Photo.c"
			}
			__finally166:
			{
				PhotoRow _tmp7_;
#line 1568 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp7_ = self->priv->row;
#line 1568 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 12286 "Photo.c"
			}
#line 1568 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			if (_inner_error_ != NULL) {
#line 1568 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				if (_inner_error_->domain == DATABASE_ERROR) {
#line 12292 "Photo.c"
					goto __catch165_database_error;
				}
#line 1568 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1568 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				g_clear_error (&_inner_error_);
#line 1568 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				return;
#line 12301 "Photo.c"
			}
		}
	}
	goto __finally165;
	__catch165_database_error:
	{
		GError* err = NULL;
		gchar* _tmp8_ = NULL;
		gchar* _tmp9_;
		GError* _tmp10_;
		const gchar* _tmp11_;
#line 1566 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		err = _inner_error_;
#line 1566 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_inner_error_ = NULL;
#line 1572 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp8_ = data_object_to_string (DATA_OBJECT (self));
#line 1572 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp9_ = _tmp8_;
#line 1572 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp10_ = err;
#line 1572 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp11_ = _tmp10_->message;
#line 1572 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_warning ("Photo.vala:1572: Unable to update link state for %s: %s", _tmp9_, _tmp11_);
#line 1572 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_free0 (_tmp9_);
#line 1566 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_error_free0 (err);
#line 12331 "Photo.c"
	}
	__finally165:
#line 1566 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 1566 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1566 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 1566 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return;
#line 12342 "Photo.c"
	}
}


static gboolean photo_real_set_event_id (MediaSource* base, EventID* event_id) {
	Photo * self;
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
#line 1580 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	self = PHOTO (base);
#line 1580 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail (event_id != NULL, FALSE);
#line 12355 "Photo.c"
	{
		PhotoRow _tmp0_;
#line 1581 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp0_ = self->priv->row;
#line 1581 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 12362 "Photo.c"
		{
			PhotoTable* _tmp1_ = NULL;
			PhotoTable* _tmp2_;
			PhotoRow _tmp3_;
			PhotoID _tmp4_;
			EventID _tmp5_;
			gboolean _tmp6_ = FALSE;
			gboolean _tmp7_;
			gboolean committed;
			gboolean _tmp8_;
#line 1582 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp1_ = photo_table_get_instance ();
#line 1582 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp2_ = _tmp1_;
#line 1582 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp3_ = self->priv->row;
#line 1582 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp4_ = _tmp3_.photo_id;
#line 1582 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp5_ = *event_id;
#line 1582 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp6_ = photo_table_set_event (_tmp2_, &_tmp4_, &_tmp5_);
#line 1582 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp7_ = _tmp6_;
#line 1582 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_database_table_unref0 (_tmp2_);
#line 1582 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			committed = _tmp7_;
#line 1584 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp8_ = committed;
#line 1584 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			if (_tmp8_) {
#line 12395 "Photo.c"
				EventID _tmp9_;
#line 1585 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp9_ = *event_id;
#line 1585 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				self->priv->row.event_id = _tmp9_;
#line 12401 "Photo.c"
			}
#line 1587 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			result = committed;
#line 12405 "Photo.c"
			{
				PhotoRow _tmp10_;
#line 1581 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp10_ = self->priv->row;
#line 1581 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 12412 "Photo.c"
			}
#line 1587 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			return result;
#line 12416 "Photo.c"
		}
		__finally167:
		{
			PhotoRow _tmp11_;
#line 1581 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp11_ = self->priv->row;
#line 1581 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 12425 "Photo.c"
		}
#line 1581 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1581 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 1581 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return FALSE;
#line 12433 "Photo.c"
	}
}


static gchar* photo_real_to_string (DataObject* base) {
	Photo * self;
	gchar* result = NULL;
	gchar* _tmp0_ = NULL;
	gboolean _tmp1_ = FALSE;
	PhotoID _tmp10_ = {0};
	gint64 _tmp11_;
	gchar* _tmp12_ = NULL;
	gchar* _tmp13_;
	PhotoFileReader* _tmp14_ = NULL;
	PhotoFileReader* _tmp15_;
	gchar* _tmp16_ = NULL;
	gchar* _tmp17_;
	const gchar* _tmp18_;
	gchar* _tmp19_ = NULL;
	gchar* _tmp20_;
#line 1591 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	self = PHOTO (base);
#line 1593 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp1_ = photo_is_master_baseline (self);
#line 1593 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (!_tmp1_) {
#line 12460 "Photo.c"
		GFile* _tmp2_ = NULL;
		GFile* _tmp3_;
		gchar* _tmp4_ = NULL;
		gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
#line 1593 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp2_ = photo_get_actual_file (self);
#line 1593 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp3_ = _tmp2_;
#line 1593 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp4_ = g_file_get_path (_tmp3_);
#line 1593 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp5_ = _tmp4_;
#line 1593 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp6_ = g_strconcat (" (", _tmp5_, NULL);
#line 1593 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp7_ = _tmp6_;
#line 1593 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp8_ = g_strconcat (_tmp7_, ")", NULL);
#line 1593 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_free0 (_tmp0_);
#line 1593 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp0_ = _tmp8_;
#line 1593 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_free0 (_tmp7_);
#line 1593 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_free0 (_tmp5_);
#line 1593 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_object_unref0 (_tmp3_);
#line 12492 "Photo.c"
	} else {
		gchar* _tmp9_;
#line 1593 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp9_ = g_strdup ("");
#line 1593 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_free0 (_tmp0_);
#line 1593 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp0_ = _tmp9_;
#line 12501 "Photo.c"
	}
#line 1592 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	photo_get_photo_id (self, &_tmp10_);
#line 1592 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp11_ = _tmp10_.id;
#line 1592 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp12_ = g_strdup_printf ("%" G_GINT64_FORMAT, _tmp11_);
#line 1592 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp13_ = _tmp12_;
#line 1592 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp14_ = photo_get_master_reader (self);
#line 1592 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp15_ = _tmp14_;
#line 1592 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp16_ = photo_file_adapter_get_filepath (PHOTO_FILE_ADAPTER (_tmp15_));
#line 1592 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp17_ = _tmp16_;
#line 1592 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp18_ = _tmp0_;
#line 1592 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp19_ = g_strdup_printf ("[%s] %s%s", _tmp13_, _tmp17_, _tmp18_);
#line 1592 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp20_ = _tmp19_;
#line 1592 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_g_free0 (_tmp17_);
#line 1592 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_photo_file_adapter_unref0 (_tmp15_);
#line 1592 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_g_free0 (_tmp13_);
#line 1592 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	result = _tmp20_;
#line 1592 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_g_free0 (_tmp0_);
#line 1592 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return result;
#line 12537 "Photo.c"
}


static gboolean photo_real_equals (DataSource* base, DataSource* source) {
	Photo * self;
	gboolean result = FALSE;
	DataSource* _tmp0_;
	Photo* _tmp1_;
	Photo* photo;
	Photo* _tmp2_;
	DataSource* _tmp15_;
	gboolean _tmp16_ = FALSE;
#line 1596 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	self = PHOTO (base);
#line 1596 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail ((source == NULL) || IS_DATA_SOURCE (source), FALSE);
#line 1598 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp0_ = source;
#line 1598 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp1_ = _g_object_ref0 (IS_PHOTO (_tmp0_) ? ((Photo*) _tmp0_) : NULL);
#line 1598 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	photo = _tmp1_;
#line 1599 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp2_ = photo;
#line 1599 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp2_ != NULL) {
#line 12564 "Photo.c"
		PhotoID _tmp3_ = {0};
		PhotoID photo_id;
		Photo* _tmp4_;
		PhotoID _tmp5_ = {0};
		PhotoID other_photo_id;
		gboolean _tmp6_ = FALSE;
		Photo* _tmp7_;
		gboolean _tmp10_;
#line 1600 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		photo_get_photo_id (self, &_tmp3_);
#line 1600 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		photo_id = _tmp3_;
#line 1601 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp4_ = photo;
#line 1601 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		photo_get_photo_id (_tmp4_, &_tmp5_);
#line 1601 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		other_photo_id = _tmp5_;
#line 1603 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp7_ = photo;
#line 1603 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		if (self != _tmp7_) {
#line 12587 "Photo.c"
			PhotoID _tmp8_;
			gint64 _tmp9_;
#line 1603 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp8_ = photo_id;
#line 1603 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp9_ = _tmp8_.id;
#line 1603 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp6_ = _tmp9_ != PHOTO_ID_INVALID;
#line 12596 "Photo.c"
		} else {
#line 1603 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp6_ = FALSE;
#line 12600 "Photo.c"
		}
#line 1603 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp10_ = _tmp6_;
#line 1603 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		if (_tmp10_) {
#line 12606 "Photo.c"
			PhotoID _tmp11_;
			gint64 _tmp12_;
			PhotoID _tmp13_;
			gint64 _tmp14_;
#line 1604 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp11_ = photo_id;
#line 1604 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp12_ = _tmp11_.id;
#line 1604 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp13_ = other_photo_id;
#line 1604 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp14_ = _tmp13_.id;
#line 1604 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_assert (_tmp12_ != _tmp14_);
#line 12621 "Photo.c"
		}
	}
#line 1608 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp15_ = source;
#line 1608 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp16_ = DATA_SOURCE_CLASS (photo_parent_class)->equals (DATA_SOURCE (PHOTO_SOURCE (self)), _tmp15_);
#line 1608 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	result = _tmp16_;
#line 1608 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_g_object_unref0 (photo);
#line 1608 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return result;
#line 12634 "Photo.c"
}


static void photo_file_exif_updated (Photo* self) {
	GFile* _tmp0_ = NULL;
	GFile* file;
	GFileInfo* info;
	GTimeVal timestamp = {0};
	GFileInfo* _tmp6_;
	GTimeVal _tmp7_ = {0};
	PhotoFileInterrogator* _tmp8_;
	PhotoFileInterrogator* interrogator;
	DetectedPhotoInformation* _tmp13_ = NULL;
	DetectedPhotoInformation* detected;
	DetectedPhotoInformation* _tmp14_;
	gboolean success = FALSE;
	gboolean _tmp33_;
	GError * _inner_error_ = NULL;
#line 1612 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 1613 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp0_ = media_source_get_file (MEDIA_SOURCE (self));
#line 1613 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	file = _tmp0_;
#line 1615 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	info = NULL;
#line 12661 "Photo.c"
	{
		GFileInfo* _tmp1_ = NULL;
		GFileInfo* _tmp2_;
#line 1617 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp1_ = g_file_query_info (file, DIRECTORY_MONITOR_SUPPLIED_ATTRIBUTES, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, NULL, &_inner_error_);
#line 1617 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp2_ = _tmp1_;
#line 1617 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 12671 "Photo.c"
			goto __catch168_g_error;
		}
#line 1617 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_object_unref0 (info);
#line 1617 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		info = _tmp2_;
#line 12678 "Photo.c"
	}
	goto __finally168;
	__catch168_g_error:
	{
		GError* err = NULL;
		gchar* _tmp3_ = NULL;
		gchar* _tmp4_;
		const gchar* _tmp5_;
#line 1616 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		err = _inner_error_;
#line 1616 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_inner_error_ = NULL;
#line 1620 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp3_ = data_object_to_string (DATA_OBJECT (self));
#line 1620 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp4_ = _tmp3_;
#line 1620 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp5_ = err->message;
#line 1620 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_error ("Photo.vala:1620: Unable to read file information for %s: %s", _tmp4_, _tmp5_);
#line 1620 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_free0 (_tmp4_);
#line 1616 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_error_free0 (err);
#line 12703 "Photo.c"
	}
	__finally168:
#line 1616 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 1616 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_object_unref0 (info);
#line 1616 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_object_unref0 (file);
#line 1616 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1616 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 1616 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return;
#line 12718 "Photo.c"
	}
#line 1623 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_get_current_time (&timestamp);
#line 1624 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp6_ = info;
#line 1624 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_file_info_get_modification_time (_tmp6_, &_tmp7_);
#line 1624 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	timestamp = _tmp7_;
#line 1627 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp8_ = photo_file_interrogator_new (file, PHOTO_FILE_SNIFFER_OPTIONS_GET_ALL);
#line 1627 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	interrogator = _tmp8_;
#line 12732 "Photo.c"
	{
#line 1629 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		photo_file_interrogator_interrogate (interrogator, &_inner_error_);
#line 1629 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 12738 "Photo.c"
			goto __catch169_g_error;
		}
	}
	goto __finally169;
	__catch169_g_error:
	{
		GError* err = NULL;
		gchar* _tmp9_ = NULL;
		gchar* _tmp10_;
		GError* _tmp11_;
		const gchar* _tmp12_;
#line 1628 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		err = _inner_error_;
#line 1628 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_inner_error_ = NULL;
#line 1631 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp9_ = g_file_get_path (file);
#line 1631 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp10_ = _tmp9_;
#line 1631 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp11_ = err;
#line 1631 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp12_ = _tmp11_->message;
#line 1631 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_warning ("Photo.vala:1631: Unable to interrogate photo file %s: %s", _tmp10_, _tmp12_);
#line 1631 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_free0 (_tmp10_);
#line 1628 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_error_free0 (err);
#line 12768 "Photo.c"
	}
	__finally169:
#line 1628 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 1628 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_photo_file_interrogator_unref0 (interrogator);
#line 1628 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_object_unref0 (info);
#line 1628 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_object_unref0 (file);
#line 1628 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1628 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 1628 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return;
#line 12785 "Photo.c"
	}
#line 1634 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp13_ = photo_file_interrogator_get_detected_photo_information (interrogator);
#line 1634 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	detected = _tmp13_;
#line 1635 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp14_ = detected;
#line 1635 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp14_ == NULL) {
#line 12795 "Photo.c"
		gchar* _tmp15_ = NULL;
		gchar* _tmp16_;
#line 1636 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp15_ = data_object_to_string (DATA_OBJECT (self));
#line 1636 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp16_ = _tmp15_;
#line 1636 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_critical ("Photo.vala:1636: file_exif_updated: %s no longer an image", _tmp16_);
#line 1636 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_free0 (_tmp16_);
#line 1638 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 1638 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_photo_file_interrogator_unref0 (interrogator);
#line 1638 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_object_unref0 (info);
#line 1638 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_object_unref0 (file);
#line 1638 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return;
#line 12816 "Photo.c"
	}
	{
		PhotoRow _tmp17_;
#line 1642 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp17_ = self->priv->row;
#line 1642 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 12824 "Photo.c"
		{
			PhotoTable* _tmp18_ = NULL;
			PhotoTable* _tmp19_;
			PhotoID _tmp20_ = {0};
			GFileInfo* _tmp21_;
			gint64 _tmp22_ = 0LL;
			GTimeVal _tmp23_;
			glong _tmp24_;
			DetectedPhotoInformation* _tmp25_;
			const gchar* _tmp26_;
			DetectedPhotoInformation* _tmp27_;
			const gchar* _tmp28_;
			DetectedPhotoInformation* _tmp29_;
			const gchar* _tmp30_;
			gboolean _tmp31_ = FALSE;
#line 1643 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp18_ = photo_table_get_instance ();
#line 1643 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp19_ = _tmp18_;
#line 1643 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			photo_get_photo_id (self, &_tmp20_);
#line 1643 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp21_ = info;
#line 1643 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp22_ = g_file_info_get_size (_tmp21_);
#line 1643 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp23_ = timestamp;
#line 1643 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp24_ = _tmp23_.tv_sec;
#line 1643 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp25_ = detected;
#line 1643 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp26_ = _tmp25_->md5;
#line 1643 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp27_ = detected;
#line 1643 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp28_ = _tmp27_->exif_md5;
#line 1643 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp29_ = detected;
#line 1643 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp30_ = _tmp29_->thumbnail_md5;
#line 1643 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp31_ = photo_table_master_exif_updated (_tmp19_, &_tmp20_, _tmp22_, _tmp24_, _tmp26_, _tmp28_, _tmp30_, &self->priv->row);
#line 1643 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			success = _tmp31_;
#line 1643 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_database_table_unref0 (_tmp19_);
#line 12872 "Photo.c"
		}
		__finally170:
		{
			PhotoRow _tmp32_;
#line 1642 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp32_ = self->priv->row;
#line 1642 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 12881 "Photo.c"
		}
#line 1642 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 1642 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_detected_photo_information_unref0 (detected);
#line 1642 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_photo_file_interrogator_unref0 (interrogator);
#line 1642 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_g_object_unref0 (info);
#line 1642 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_g_object_unref0 (file);
#line 1642 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1642 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 1642 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			return;
#line 12899 "Photo.c"
		}
	}
#line 1647 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp33_ = success;
#line 1647 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp33_) {
#line 12906 "Photo.c"
		Alteration* _tmp34_;
		Alteration* _tmp35_;
#line 1648 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp34_ = alteration_new_from_list ("metadata:exif,metadata:md5");
#line 1648 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp35_ = _tmp34_;
#line 1648 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		data_object_notify_altered (DATA_OBJECT (self), _tmp35_);
#line 1648 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_alteration_unref0 (_tmp35_);
#line 12917 "Photo.c"
	}
#line 1612 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_detected_photo_information_unref0 (detected);
#line 1612 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_photo_file_interrogator_unref0 (interrogator);
#line 1612 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_g_object_unref0 (info);
#line 1612 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_g_object_unref0 (file);
#line 12927 "Photo.c"
}


static guint64 photo_real_get_filesize (MediaSource* base) {
	Photo * self;
	guint64 result = 0ULL;
	GError * _inner_error_ = NULL;
#line 1653 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	self = PHOTO (base);
#line 12937 "Photo.c"
	{
		PhotoRow _tmp0_;
#line 1654 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp0_ = self->priv->row;
#line 1654 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 12944 "Photo.c"
		{
			BackingPhotoState* _tmp1_;
			gint64 _tmp2_;
#line 1655 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp1_ = self->priv->backing_photo_state;
#line 1655 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp2_ = (*_tmp1_).filesize;
#line 1655 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			result = (guint64) _tmp2_;
#line 12954 "Photo.c"
			{
				PhotoRow _tmp3_;
#line 1654 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp3_ = self->priv->row;
#line 1654 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 12961 "Photo.c"
			}
#line 1655 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			return result;
#line 12965 "Photo.c"
		}
		__finally171:
		{
			PhotoRow _tmp4_;
#line 1654 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp4_ = self->priv->row;
#line 1654 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 12974 "Photo.c"
		}
#line 1654 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1654 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 1654 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return 0ULL;
#line 12982 "Photo.c"
	}
}


static guint64 photo_real_get_master_filesize (MediaSource* base) {
	Photo * self;
	guint64 result = 0ULL;
	GError * _inner_error_ = NULL;
#line 1659 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	self = PHOTO (base);
#line 12993 "Photo.c"
	{
		PhotoRow _tmp0_;
#line 1660 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp0_ = self->priv->row;
#line 1660 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 13000 "Photo.c"
		{
			PhotoRow _tmp1_;
			BackingPhotoState _tmp2_;
			gint64 _tmp3_;
#line 1661 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp1_ = self->priv->row;
#line 1661 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp2_ = _tmp1_.master;
#line 1661 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp3_ = _tmp2_.filesize;
#line 1661 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			result = (guint64) _tmp3_;
#line 13013 "Photo.c"
			{
				PhotoRow _tmp4_;
#line 1660 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp4_ = self->priv->row;
#line 1660 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 13020 "Photo.c"
			}
#line 1661 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			return result;
#line 13024 "Photo.c"
		}
		__finally172:
		{
			PhotoRow _tmp5_;
#line 1660 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp5_ = self->priv->row;
#line 1660 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 13033 "Photo.c"
		}
#line 1660 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1660 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 1660 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return 0ULL;
#line 13041 "Photo.c"
	}
}


guint64 photo_get_editable_filesize (Photo* self) {
	guint64 result = 0ULL;
	GError * _inner_error_ = NULL;
#line 1665 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), 0ULL);
#line 13051 "Photo.c"
	{
		PhotoRow _tmp0_;
#line 1666 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp0_ = self->priv->row;
#line 1666 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 13058 "Photo.c"
		{
			BackingPhotoState _tmp1_;
			gint64 _tmp2_;
#line 1667 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp1_ = self->priv->editable;
#line 1667 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp2_ = _tmp1_.filesize;
#line 1667 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			result = (guint64) _tmp2_;
#line 13068 "Photo.c"
			{
				PhotoRow _tmp3_;
#line 1666 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp3_ = self->priv->row;
#line 1666 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 13075 "Photo.c"
			}
#line 1667 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			return result;
#line 13079 "Photo.c"
		}
		__finally173:
		{
			PhotoRow _tmp4_;
#line 1666 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp4_ = self->priv->row;
#line 1666 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 13088 "Photo.c"
		}
#line 1666 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1666 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 1666 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return 0ULL;
#line 13096 "Photo.c"
	}
}


static time_t photo_real_get_exposure_time (Dateable* base) {
	Photo * self;
	time_t result = 0;
	GError * _inner_error_ = NULL;
#line 1671 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	self = PHOTO (base);
#line 13107 "Photo.c"
	{
		PhotoRow _tmp0_;
#line 1672 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp0_ = self->priv->row;
#line 1672 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 13114 "Photo.c"
		{
			PhotoRow _tmp1_;
			time_t _tmp2_;
#line 1673 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp1_ = self->priv->row;
#line 1673 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp2_ = _tmp1_.exposure_time;
#line 1673 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			result = _tmp2_;
#line 13124 "Photo.c"
			{
				PhotoRow _tmp3_;
#line 1672 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp3_ = self->priv->row;
#line 1672 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 13131 "Photo.c"
			}
#line 1673 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			return result;
#line 13135 "Photo.c"
		}
		__finally174:
		{
			PhotoRow _tmp4_;
#line 1672 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp4_ = self->priv->row;
#line 1672 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 13144 "Photo.c"
		}
#line 1672 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1672 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 1672 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return 0;
#line 13152 "Photo.c"
	}
}


static gchar* photo_real_get_basename (MediaSource* base) {
	Photo * self;
	gchar* result = NULL;
	GError * _inner_error_ = NULL;
#line 1677 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	self = PHOTO (base);
#line 13163 "Photo.c"
	{
		PhotoRow _tmp0_;
#line 1678 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp0_ = self->priv->row;
#line 1678 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 13170 "Photo.c"
		{
			const gchar* _tmp1_;
			gchar* _tmp2_;
#line 1679 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp1_ = self->priv->file_title;
#line 1679 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp2_ = g_strdup (_tmp1_);
#line 1679 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			result = _tmp2_;
#line 13180 "Photo.c"
			{
				PhotoRow _tmp3_;
#line 1678 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp3_ = self->priv->row;
#line 1678 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 13187 "Photo.c"
			}
#line 1679 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			return result;
#line 13191 "Photo.c"
		}
		__finally175:
		{
			PhotoRow _tmp4_;
#line 1678 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp4_ = self->priv->row;
#line 1678 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 13200 "Photo.c"
		}
#line 1678 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1678 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 1678 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return NULL;
#line 13208 "Photo.c"
	}
}


static gchar* photo_real_get_title (MediaSource* base) {
	Photo * self;
	gchar* result = NULL;
	GError * _inner_error_ = NULL;
#line 1683 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	self = PHOTO (base);
#line 13219 "Photo.c"
	{
		PhotoRow _tmp0_;
#line 1684 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp0_ = self->priv->row;
#line 1684 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 13226 "Photo.c"
		{
			PhotoRow _tmp1_;
			const gchar* _tmp2_;
			gchar* _tmp3_;
#line 1685 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp1_ = self->priv->row;
#line 1685 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp2_ = _tmp1_.title;
#line 1685 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp3_ = g_strdup (_tmp2_);
#line 1685 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			result = _tmp3_;
#line 13239 "Photo.c"
			{
				PhotoRow _tmp4_;
#line 1684 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp4_ = self->priv->row;
#line 1684 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 13246 "Photo.c"
			}
#line 1685 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			return result;
#line 13250 "Photo.c"
		}
		__finally176:
		{
			PhotoRow _tmp5_;
#line 1684 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp5_ = self->priv->row;
#line 1684 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 13259 "Photo.c"
		}
#line 1684 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1684 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 1684 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return NULL;
#line 13267 "Photo.c"
	}
}


static void photo_real_set_title (MediaSource* base, const gchar* title) {
	Photo * self;
	const gchar* _tmp0_;
	gchar* _tmp1_ = NULL;
	gchar* new_title;
	gboolean committed;
	gboolean _tmp17_;
	GError * _inner_error_ = NULL;
#line 1689 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	self = PHOTO (base);
#line 1690 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp0_ = title;
#line 1690 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp1_ = media_source_prep_title (_tmp0_);
#line 1690 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	new_title = _tmp1_;
#line 1692 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	committed = FALSE;
#line 13290 "Photo.c"
	{
		PhotoRow _tmp2_;
#line 1693 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp2_ = self->priv->row;
#line 1693 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 13297 "Photo.c"
		{
			const gchar* _tmp3_;
			PhotoRow _tmp4_;
			const gchar* _tmp5_;
			PhotoTable* _tmp7_ = NULL;
			PhotoTable* _tmp8_;
			PhotoRow _tmp9_;
			PhotoID _tmp10_;
			const gchar* _tmp11_;
			gboolean _tmp12_ = FALSE;
			gboolean _tmp13_;
#line 1694 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp3_ = new_title;
#line 1694 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp4_ = self->priv->row;
#line 1694 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp5_ = _tmp4_.title;
#line 1694 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			if (g_strcmp0 (_tmp3_, _tmp5_) == 0) {
#line 13317 "Photo.c"
				{
					PhotoRow _tmp6_;
#line 1693 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_tmp6_ = self->priv->row;
#line 1693 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 13324 "Photo.c"
				}
#line 1695 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_g_free0 (new_title);
#line 1695 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				return;
#line 13330 "Photo.c"
			}
#line 1697 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp7_ = photo_table_get_instance ();
#line 1697 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp8_ = _tmp7_;
#line 1697 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp9_ = self->priv->row;
#line 1697 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp10_ = _tmp9_.photo_id;
#line 1697 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp11_ = new_title;
#line 1697 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp12_ = photo_table_set_title (_tmp8_, &_tmp10_, _tmp11_);
#line 1697 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			committed = _tmp12_;
#line 1697 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_database_table_unref0 (_tmp8_);
#line 1698 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp13_ = committed;
#line 1698 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			if (_tmp13_) {
#line 13352 "Photo.c"
				const gchar* _tmp14_;
				gchar* _tmp15_;
#line 1699 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp14_ = new_title;
#line 1699 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp15_ = g_strdup (_tmp14_);
#line 1699 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_g_free0 (self->priv->row.title);
#line 1699 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				self->priv->row.title = _tmp15_;
#line 13363 "Photo.c"
			}
		}
		__finally177:
		{
			PhotoRow _tmp16_;
#line 1693 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp16_ = self->priv->row;
#line 1693 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 13373 "Photo.c"
		}
#line 1693 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 1693 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_g_free0 (new_title);
#line 1693 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1693 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 1693 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			return;
#line 13385 "Photo.c"
		}
	}
#line 1702 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp17_ = committed;
#line 1702 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp17_) {
#line 13392 "Photo.c"
		Alteration* _tmp18_;
		Alteration* _tmp19_;
#line 1703 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp18_ = alteration_new ("metadata", "name");
#line 1703 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp19_ = _tmp18_;
#line 1703 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		data_object_notify_altered (DATA_OBJECT (self), _tmp19_);
#line 1703 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_alteration_unref0 (_tmp19_);
#line 13403 "Photo.c"
	}
#line 1689 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_g_free0 (new_title);
#line 13407 "Photo.c"
}


static gpointer _g_error_copy0 (gpointer self) {
#line 1713 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return self ? g_error_copy (self) : NULL;
#line 13414 "Photo.c"
}


void photo_set_import_id (Photo* self, ImportID* import_id) {
	GError* dberr;
	GError* _tmp12_;
	GError * _inner_error_ = NULL;
#line 1706 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 1706 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail (import_id != NULL);
#line 1707 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	dberr = NULL;
#line 13428 "Photo.c"
	{
		PhotoRow _tmp0_;
#line 1708 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp0_ = self->priv->row;
#line 1708 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 13435 "Photo.c"
		{
			{
				PhotoTable* _tmp1_ = NULL;
				PhotoTable* _tmp2_;
				PhotoRow _tmp3_;
				PhotoID _tmp4_;
				ImportID _tmp5_;
				ImportID _tmp7_;
#line 1710 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp1_ = photo_table_get_instance ();
#line 1710 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp2_ = _tmp1_;
#line 1710 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp3_ = self->priv->row;
#line 1710 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp4_ = _tmp3_.photo_id;
#line 1710 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp5_ = *import_id;
#line 1710 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				photo_table_set_import_id (_tmp2_, &_tmp4_, &_tmp5_, &_inner_error_);
#line 1710 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_database_table_unref0 (_tmp2_);
#line 1710 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				if (_inner_error_ != NULL) {
#line 1710 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					if (_inner_error_->domain == DATABASE_ERROR) {
#line 13462 "Photo.c"
						goto __catch179_database_error;
					}
					{
						PhotoRow _tmp6_;
#line 1708 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						_tmp6_ = self->priv->row;
#line 1708 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 13471 "Photo.c"
					}
#line 1710 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_g_error_free0 (dberr);
#line 1710 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1710 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					g_clear_error (&_inner_error_);
#line 1710 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					return;
#line 13481 "Photo.c"
				}
#line 1711 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp7_ = *import_id;
#line 1711 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				self->priv->row.import_id = _tmp7_;
#line 13487 "Photo.c"
			}
			goto __finally179;
			__catch179_database_error:
			{
				GError* err = NULL;
				GError* _tmp8_;
				GError* _tmp9_;
#line 1709 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				err = _inner_error_;
#line 1709 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_inner_error_ = NULL;
#line 1713 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp8_ = err;
#line 1713 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp9_ = _g_error_copy0 (_tmp8_);
#line 1713 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_g_error_free0 (dberr);
#line 1713 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				dberr = _tmp9_;
#line 1709 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_g_error_free0 (err);
#line 13509 "Photo.c"
			}
			__finally179:
#line 1709 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			if (_inner_error_ != NULL) {
#line 13514 "Photo.c"
				{
					PhotoRow _tmp10_;
#line 1708 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_tmp10_ = self->priv->row;
#line 1708 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 13521 "Photo.c"
				}
#line 1709 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_g_error_free0 (dberr);
#line 1709 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1709 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				g_clear_error (&_inner_error_);
#line 1709 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				return;
#line 13531 "Photo.c"
			}
		}
		__finally178:
		{
			PhotoRow _tmp11_;
#line 1708 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp11_ = self->priv->row;
#line 1708 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 13541 "Photo.c"
		}
#line 1708 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 1708 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_g_error_free0 (dberr);
#line 1708 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1708 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 1708 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			return;
#line 13553 "Photo.c"
		}
	}
#line 1717 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp12_ = dberr;
#line 1717 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp12_ == NULL) {
#line 13560 "Photo.c"
		Alteration* _tmp13_;
		Alteration* _tmp14_;
#line 1718 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp13_ = alteration_new ("metadata", "import-id");
#line 1718 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp14_ = _tmp13_;
#line 1718 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		data_object_notify_altered (DATA_OBJECT (self), _tmp14_);
#line 1718 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_alteration_unref0 (_tmp14_);
#line 13571 "Photo.c"
	} else {
		gchar* _tmp15_ = NULL;
		gchar* _tmp16_;
		GError* _tmp17_;
		const gchar* _tmp18_;
#line 1720 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp15_ = data_object_to_string (DATA_OBJECT (self));
#line 1720 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp16_ = _tmp15_;
#line 1720 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp17_ = dberr;
#line 1720 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp18_ = _tmp17_->message;
#line 1720 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_warning ("Photo.vala:1720: Unable to write import ID for %s: %s", _tmp16_, _tmp18_);
#line 1720 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_free0 (_tmp16_);
#line 13589 "Photo.c"
	}
#line 1706 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_g_error_free0 (dberr);
#line 13593 "Photo.c"
}


void photo_set_title_persistent (Photo* self, const gchar* title, GError** error) {
	PhotoFileReader* _tmp0_ = NULL;
	PhotoFileReader* source;
	PhotoFileReader* _tmp1_;
	PhotoFileFormat _tmp2_ = 0;
	gboolean _tmp3_ = FALSE;
	PhotoFileReader* _tmp8_;
	PhotoMetadata* _tmp9_ = NULL;
	PhotoMetadata* metadata;
	PhotoMetadata* _tmp10_;
	const gchar* _tmp11_;
	PhotoFileReader* _tmp12_;
	PhotoFileMetadataWriter* _tmp13_ = NULL;
	PhotoFileMetadataWriter* writer;
	PhotoFileReader* _tmp14_;
	GFile* _tmp15_ = NULL;
	GFile* _tmp16_;
	const gchar* _tmp22_;
	GError * _inner_error_ = NULL;
#line 1723 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 1724 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp0_ = photo_get_source_reader (self);
#line 1724 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	source = _tmp0_;
#line 1727 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp1_ = source;
#line 1727 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp2_ = photo_file_adapter_get_file_format (PHOTO_FILE_ADAPTER (_tmp1_));
#line 1727 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp3_ = photo_file_format_can_write_metadata (_tmp2_);
#line 1727 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (!_tmp3_) {
#line 13630 "Photo.c"
		PhotoFileReader* _tmp4_;
		gchar* _tmp5_ = NULL;
		gchar* _tmp6_;
		const gchar* _tmp7_;
#line 1728 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp4_ = source;
#line 1728 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp5_ = photo_file_adapter_get_filepath (PHOTO_FILE_ADAPTER (_tmp4_));
#line 1728 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp6_ = _tmp5_;
#line 1728 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_warning ("Photo.vala:1728: No photo file writer available for %s", _tmp6_);
#line 1728 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_free0 (_tmp6_);
#line 1730 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp7_ = title;
#line 1730 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		media_source_set_title (MEDIA_SOURCE (self), _tmp7_);
#line 1732 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_photo_file_adapter_unref0 (source);
#line 1732 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return;
#line 13653 "Photo.c"
	}
#line 1735 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp8_ = source;
#line 1735 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp9_ = photo_file_reader_read_metadata (_tmp8_, &_inner_error_);
#line 1735 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	metadata = _tmp9_;
#line 1735 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 1735 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 1735 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_photo_file_adapter_unref0 (source);
#line 1735 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return;
#line 13669 "Photo.c"
	}
#line 1736 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp10_ = metadata;
#line 1736 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp11_ = title;
#line 1736 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	photo_metadata_set_title (_tmp10_, _tmp11_, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 1738 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp12_ = source;
#line 1738 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp13_ = photo_file_reader_create_metadata_writer (_tmp12_, &_inner_error_);
#line 1738 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	writer = _tmp13_;
#line 1738 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 1738 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 1738 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 1738 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_photo_file_adapter_unref0 (source);
#line 1738 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return;
#line 13693 "Photo.c"
	}
#line 1739 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp14_ = source;
#line 1739 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp15_ = photo_file_adapter_get_file (PHOTO_FILE_ADAPTER (_tmp14_));
#line 1739 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp16_ = _tmp15_;
#line 1739 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	library_monitor_blacklist_file (_tmp16_, "Photo.set_persistent_title");
#line 1739 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_g_object_unref0 (_tmp16_);
#line 13705 "Photo.c"
	{
		PhotoFileMetadataWriter* _tmp17_;
		PhotoMetadata* _tmp18_;
#line 1741 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp17_ = writer;
#line 1741 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp18_ = metadata;
#line 1741 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		photo_file_metadata_writer_write_metadata (_tmp17_, _tmp18_, &_inner_error_);
#line 1741 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 13717 "Photo.c"
			goto __finally180;
		}
	}
	__finally180:
	{
		PhotoFileReader* _tmp19_;
		GFile* _tmp20_ = NULL;
		GFile* _tmp21_;
#line 1743 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp19_ = source;
#line 1743 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp20_ = photo_file_adapter_get_file (PHOTO_FILE_ADAPTER (_tmp19_));
#line 1743 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp21_ = _tmp20_;
#line 1743 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		library_monitor_unblacklist_file (_tmp21_);
#line 1743 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_object_unref0 (_tmp21_);
#line 13736 "Photo.c"
	}
#line 1740 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 1740 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 1740 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_photo_file_adapter_unref0 (writer);
#line 1740 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 1740 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_photo_file_adapter_unref0 (source);
#line 1740 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return;
#line 13750 "Photo.c"
	}
#line 1746 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp22_ = title;
#line 1746 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	media_source_set_title (MEDIA_SOURCE (self), _tmp22_);
#line 1748 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	photo_file_exif_updated (self);
#line 1723 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_photo_file_adapter_unref0 (writer);
#line 1723 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_media_metadata_unref0 (metadata);
#line 1723 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_photo_file_adapter_unref0 (source);
#line 13764 "Photo.c"
}


static void photo_real_set_exposure_time (Dateable* base, time_t time) {
	Photo * self;
	gboolean committed = FALSE;
	gboolean _tmp10_;
	GError * _inner_error_ = NULL;
#line 1751 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	self = PHOTO (base);
#line 13775 "Photo.c"
	{
		PhotoRow _tmp0_;
#line 1753 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp0_ = self->priv->row;
#line 1753 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 13782 "Photo.c"
		{
			PhotoTable* _tmp1_ = NULL;
			PhotoTable* _tmp2_;
			PhotoRow _tmp3_;
			PhotoID _tmp4_;
			time_t _tmp5_;
			gboolean _tmp6_ = FALSE;
			gboolean _tmp7_;
#line 1754 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp1_ = photo_table_get_instance ();
#line 1754 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp2_ = _tmp1_;
#line 1754 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp3_ = self->priv->row;
#line 1754 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp4_ = _tmp3_.photo_id;
#line 1754 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp5_ = time;
#line 1754 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp6_ = photo_table_set_exposure_time (_tmp2_, &_tmp4_, _tmp5_);
#line 1754 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			committed = _tmp6_;
#line 1754 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_database_table_unref0 (_tmp2_);
#line 1755 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp7_ = committed;
#line 1755 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			if (_tmp7_) {
#line 13811 "Photo.c"
				time_t _tmp8_;
#line 1756 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp8_ = time;
#line 1756 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				self->priv->row.exposure_time = _tmp8_;
#line 13817 "Photo.c"
			}
		}
		__finally181:
		{
			PhotoRow _tmp9_;
#line 1753 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp9_ = self->priv->row;
#line 1753 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 13827 "Photo.c"
		}
#line 1753 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 1753 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1753 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 1753 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			return;
#line 13837 "Photo.c"
		}
	}
#line 1759 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp10_ = committed;
#line 1759 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp10_) {
#line 13844 "Photo.c"
		Alteration* _tmp11_;
		Alteration* _tmp12_;
#line 1760 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp11_ = alteration_new ("metadata", "exposure-time");
#line 1760 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp12_ = _tmp11_;
#line 1760 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		data_object_notify_altered (DATA_OBJECT (self), _tmp12_);
#line 1760 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_alteration_unref0 (_tmp12_);
#line 13855 "Photo.c"
	}
}


void photo_set_exposure_time_persistent (Photo* self, time_t time, GError** error) {
	PhotoFileReader* _tmp0_ = NULL;
	PhotoFileReader* source;
	PhotoFileReader* _tmp1_;
	PhotoFileFormat _tmp2_ = 0;
	gboolean _tmp3_ = FALSE;
	PhotoFileReader* _tmp8_;
	PhotoMetadata* _tmp9_ = NULL;
	PhotoMetadata* metadata;
	PhotoMetadata* _tmp10_;
	time_t _tmp11_;
	MetadataDateTime* _tmp12_;
	MetadataDateTime* _tmp13_;
	PhotoFileReader* _tmp14_;
	PhotoFileMetadataWriter* _tmp15_ = NULL;
	PhotoFileMetadataWriter* writer;
	PhotoFileReader* _tmp16_;
	GFile* _tmp17_ = NULL;
	GFile* _tmp18_;
	time_t _tmp24_;
	GError * _inner_error_ = NULL;
#line 1763 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 1764 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp0_ = photo_get_source_reader (self);
#line 1764 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	source = _tmp0_;
#line 1767 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp1_ = source;
#line 1767 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp2_ = photo_file_adapter_get_file_format (PHOTO_FILE_ADAPTER (_tmp1_));
#line 1767 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp3_ = photo_file_format_can_write_metadata (_tmp2_);
#line 1767 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (!_tmp3_) {
#line 13895 "Photo.c"
		PhotoFileReader* _tmp4_;
		gchar* _tmp5_ = NULL;
		gchar* _tmp6_;
		time_t _tmp7_;
#line 1768 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp4_ = source;
#line 1768 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp5_ = photo_file_adapter_get_filepath (PHOTO_FILE_ADAPTER (_tmp4_));
#line 1768 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp6_ = _tmp5_;
#line 1768 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_warning ("Photo.vala:1768: No photo file writer available for %s", _tmp6_);
#line 1768 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_free0 (_tmp6_);
#line 1770 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp7_ = time;
#line 1770 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		dateable_set_exposure_time (DATEABLE (self), _tmp7_);
#line 1772 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_photo_file_adapter_unref0 (source);
#line 1772 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return;
#line 13918 "Photo.c"
	}
#line 1775 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp8_ = source;
#line 1775 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp9_ = photo_file_reader_read_metadata (_tmp8_, &_inner_error_);
#line 1775 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	metadata = _tmp9_;
#line 1775 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 1775 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 1775 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_photo_file_adapter_unref0 (source);
#line 1775 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return;
#line 13934 "Photo.c"
	}
#line 1776 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp10_ = metadata;
#line 1776 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp11_ = time;
#line 1776 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp12_ = metadata_date_time_new (_tmp11_);
#line 1776 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp13_ = _tmp12_;
#line 1776 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	photo_metadata_set_exposure_date_time (_tmp10_, _tmp13_, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 1776 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_metadata_date_time_unref0 (_tmp13_);
#line 1778 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp14_ = source;
#line 1778 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp15_ = photo_file_reader_create_metadata_writer (_tmp14_, &_inner_error_);
#line 1778 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	writer = _tmp15_;
#line 1778 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 1778 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 1778 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 1778 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_photo_file_adapter_unref0 (source);
#line 1778 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return;
#line 13964 "Photo.c"
	}
#line 1779 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp16_ = source;
#line 1779 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp17_ = photo_file_adapter_get_file (PHOTO_FILE_ADAPTER (_tmp16_));
#line 1779 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp18_ = _tmp17_;
#line 1779 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	library_monitor_blacklist_file (_tmp18_, "Photo.set_exposure_time_persistent");
#line 1779 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_g_object_unref0 (_tmp18_);
#line 13976 "Photo.c"
	{
		PhotoFileMetadataWriter* _tmp19_;
		PhotoMetadata* _tmp20_;
#line 1781 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp19_ = writer;
#line 1781 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp20_ = metadata;
#line 1781 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		photo_file_metadata_writer_write_metadata (_tmp19_, _tmp20_, &_inner_error_);
#line 1781 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 13988 "Photo.c"
			goto __finally182;
		}
	}
	__finally182:
	{
		PhotoFileReader* _tmp21_;
		GFile* _tmp22_ = NULL;
		GFile* _tmp23_;
#line 1783 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp21_ = source;
#line 1783 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp22_ = photo_file_adapter_get_file (PHOTO_FILE_ADAPTER (_tmp21_));
#line 1783 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp23_ = _tmp22_;
#line 1783 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		library_monitor_unblacklist_file (_tmp23_);
#line 1783 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_object_unref0 (_tmp23_);
#line 14007 "Photo.c"
	}
#line 1780 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 1780 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 1780 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_photo_file_adapter_unref0 (writer);
#line 1780 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 1780 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_photo_file_adapter_unref0 (source);
#line 1780 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return;
#line 14021 "Photo.c"
	}
#line 1786 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp24_ = time;
#line 1786 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	dateable_set_exposure_time (DATEABLE (self), _tmp24_);
#line 1788 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	photo_file_exif_updated (self);
#line 1763 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_photo_file_adapter_unref0 (writer);
#line 1763 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_media_metadata_unref0 (metadata);
#line 1763 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_photo_file_adapter_unref0 (source);
#line 14035 "Photo.c"
}


static void photo_real_get_dimensions (MediaSource* base, Dimensions* result) {
	Photo * self;
	Box crop = {0};
	Box _tmp0_ = {0};
	gboolean _tmp1_ = FALSE;
	Dimensions _tmp3_ = {0};
#line 1792 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	self = PHOTO (base);
#line 1794 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp1_ = photo_get_crop (self, &_tmp0_);
#line 1794 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	crop = _tmp0_;
#line 1794 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp1_) {
#line 14053 "Photo.c"
		Dimensions _tmp2_ = {0};
#line 1795 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		box_get_dimensions (&crop, &_tmp2_);
#line 1795 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		*result = _tmp2_;
#line 1795 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return;
#line 14061 "Photo.c"
	}
#line 1797 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	photo_get_original_dimensions (self, &_tmp3_);
#line 1797 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	*result = _tmp3_;
#line 1797 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return;
#line 14069 "Photo.c"
}


static void photo_locked_create_adjustments_from_data (Photo* self) {
	PixelTransformationBundle* _tmp0_;
	KeyValueMap* _tmp1_ = NULL;
	KeyValueMap* map;
	KeyValueMap* _tmp2_;
	PixelTransformationBundle* _tmp6_;
	PixelTransformer* _tmp7_ = NULL;
#line 1801 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 1802 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp0_ = pixel_transformation_bundle_new ();
#line 1802 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_pixel_transformation_bundle_unref0 (self->priv->adjustments);
#line 1802 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	self->priv->adjustments = _tmp0_;
#line 1804 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp1_ = photo_get_transformation (self, "adjustments");
#line 1804 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	map = _tmp1_;
#line 1805 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp2_ = map;
#line 1805 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp2_ == NULL) {
#line 14096 "Photo.c"
		PixelTransformationBundle* _tmp3_;
#line 1806 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp3_ = self->priv->adjustments;
#line 1806 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		pixel_transformation_bundle_set_to_identity (_tmp3_);
#line 14102 "Photo.c"
	} else {
		PixelTransformationBundle* _tmp4_;
		KeyValueMap* _tmp5_;
#line 1808 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp4_ = self->priv->adjustments;
#line 1808 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp5_ = map;
#line 1808 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		pixel_transformation_bundle_load (_tmp4_, _tmp5_);
#line 14112 "Photo.c"
	}
#line 1810 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp6_ = self->priv->adjustments;
#line 1810 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp7_ = pixel_transformation_bundle_generate_transformer (_tmp6_);
#line 1810 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_pixel_transformer_unref0 (self->priv->transformer);
#line 1810 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	self->priv->transformer = _tmp7_;
#line 1801 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_key_value_map_unref0 (map);
#line 14124 "Photo.c"
}


PixelTransformationBundle* photo_get_color_adjustments (Photo* self) {
	PixelTransformationBundle* result = NULL;
	GError * _inner_error_ = NULL;
#line 1814 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 14133 "Photo.c"
	{
		PhotoRow _tmp0_;
#line 1815 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp0_ = self->priv->row;
#line 1815 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 14140 "Photo.c"
		{
			PixelTransformationBundle* _tmp1_;
			PixelTransformationBundle* _tmp2_;
			PixelTransformationBundle* _tmp3_ = NULL;
#line 1816 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp1_ = self->priv->adjustments;
#line 1816 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			if (_tmp1_ == NULL) {
#line 1817 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				photo_locked_create_adjustments_from_data (self);
#line 14151 "Photo.c"
			}
#line 1819 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp2_ = self->priv->adjustments;
#line 1819 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp3_ = pixel_transformation_bundle_copy (_tmp2_);
#line 1819 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			result = _tmp3_;
#line 14159 "Photo.c"
			{
				PhotoRow _tmp4_;
#line 1815 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp4_ = self->priv->row;
#line 1815 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 14166 "Photo.c"
			}
#line 1819 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			return result;
#line 14170 "Photo.c"
		}
		__finally183:
		{
			PhotoRow _tmp5_;
#line 1815 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp5_ = self->priv->row;
#line 1815 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 14179 "Photo.c"
		}
#line 1815 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1815 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 1815 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return NULL;
#line 14187 "Photo.c"
	}
}


PixelTransformer* photo_get_pixel_transformer (Photo* self) {
	PixelTransformer* result = NULL;
	GError * _inner_error_ = NULL;
#line 1823 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 14197 "Photo.c"
	{
		PhotoRow _tmp0_;
#line 1824 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp0_ = self->priv->row;
#line 1824 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 14204 "Photo.c"
		{
			PixelTransformer* _tmp1_;
			PixelTransformer* _tmp2_;
			PixelTransformer* _tmp3_ = NULL;
#line 1825 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp1_ = self->priv->transformer;
#line 1825 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			if (_tmp1_ == NULL) {
#line 1826 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				photo_locked_create_adjustments_from_data (self);
#line 14215 "Photo.c"
			}
#line 1828 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp2_ = self->priv->transformer;
#line 1828 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp3_ = pixel_transformer_copy (_tmp2_);
#line 1828 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			result = _tmp3_;
#line 14223 "Photo.c"
			{
				PhotoRow _tmp4_;
#line 1824 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp4_ = self->priv->row;
#line 1824 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 14230 "Photo.c"
			}
#line 1828 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			return result;
#line 14234 "Photo.c"
		}
		__finally184:
		{
			PhotoRow _tmp5_;
#line 1824 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp5_ = self->priv->row;
#line 1824 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 14243 "Photo.c"
		}
#line 1824 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1824 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 1824 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return NULL;
#line 14251 "Photo.c"
	}
}


gboolean photo_has_color_adjustments (Photo* self) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
#line 1832 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 1833 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp0_ = photo_has_transformation (self, "adjustments");
#line 1833 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	result = _tmp0_;
#line 1833 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return result;
#line 14267 "Photo.c"
}


PixelTransformation* photo_get_color_adjustment (Photo* self, PixelTransformationType type) {
	PixelTransformation* result = NULL;
	PixelTransformationBundle* _tmp0_ = NULL;
	PixelTransformationBundle* _tmp1_;
	PixelTransformationType _tmp2_;
	PixelTransformation* _tmp3_ = NULL;
	PixelTransformation* _tmp4_;
#line 1836 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 1837 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp0_ = photo_get_color_adjustments (self);
#line 1837 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 1837 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp2_ = type;
#line 1837 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp3_ = pixel_transformation_bundle_get_transformation (_tmp1_, _tmp2_);
#line 1837 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp4_ = _tmp3_;
#line 1837 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_pixel_transformation_bundle_unref0 (_tmp1_);
#line 1837 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	result = _tmp4_;
#line 1837 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return result;
#line 14296 "Photo.c"
}


void photo_set_color_adjustments (Photo* self, PixelTransformationBundle* new_adjustments) {
	PixelTransformationBundle* _tmp0_;
	gboolean _tmp1_ = FALSE;
	PixelTransformationBundle* _tmp8_;
	KeyValueMap* _tmp9_ = NULL;
	KeyValueMap* map;
	gboolean committed = FALSE;
	gboolean _tmp40_;
	GError * _inner_error_ = NULL;
#line 1840 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 1840 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail (IS_PIXEL_TRANSFORMATION_BUNDLE (new_adjustments));
#line 1843 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp0_ = new_adjustments;
#line 1843 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp1_ = pixel_transformation_bundle_is_identity (_tmp0_);
#line 1843 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp1_) {
#line 14319 "Photo.c"
		gboolean _result_ = FALSE;
		gboolean _tmp5_;
		{
			PhotoRow _tmp2_;
#line 1845 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp2_ = self->priv->row;
#line 1845 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 14328 "Photo.c"
			{
				gboolean _tmp3_ = FALSE;
#line 1846 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp3_ = photo_remove_transformation (self, "adjustments");
#line 1846 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_result_ = _tmp3_;
#line 1847 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_pixel_transformation_bundle_unref0 (self->priv->adjustments);
#line 1847 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				self->priv->adjustments = NULL;
#line 1848 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_pixel_transformer_unref0 (self->priv->transformer);
#line 1848 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				self->priv->transformer = NULL;
#line 14343 "Photo.c"
			}
			__finally185:
			{
				PhotoRow _tmp4_;
#line 1845 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp4_ = self->priv->row;
#line 1845 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 14352 "Photo.c"
			}
#line 1845 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			if (_inner_error_ != NULL) {
#line 1845 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1845 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				g_clear_error (&_inner_error_);
#line 1845 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				return;
#line 14362 "Photo.c"
			}
		}
#line 1851 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp5_ = _result_;
#line 1851 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		if (_tmp5_) {
#line 14369 "Photo.c"
			Alteration* _tmp6_;
			Alteration* _tmp7_;
#line 1852 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp6_ = alteration_new ("image", "color-adjustments");
#line 1852 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp7_ = _tmp6_;
#line 1852 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			data_object_notify_altered (DATA_OBJECT (self), _tmp7_);
#line 1852 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_alteration_unref0 (_tmp7_);
#line 14380 "Photo.c"
		}
#line 1854 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return;
#line 14384 "Photo.c"
	}
#line 1858 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp8_ = new_adjustments;
#line 1858 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp9_ = pixel_transformation_bundle_save (_tmp8_, "adjustments");
#line 1858 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	map = _tmp9_;
#line 14392 "Photo.c"
	{
		PhotoRow _tmp10_;
#line 1861 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp10_ = self->priv->row;
#line 1861 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 14399 "Photo.c"
		{
			gboolean _tmp11_ = FALSE;
			PixelTransformer* _tmp12_;
			gboolean _tmp14_;
			KeyValueMap* _tmp37_;
			gboolean _tmp38_ = FALSE;
#line 1862 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp12_ = self->priv->transformer;
#line 1862 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			if (_tmp12_ == NULL) {
#line 1862 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp11_ = TRUE;
#line 14412 "Photo.c"
			} else {
				PixelTransformationBundle* _tmp13_;
#line 1862 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp13_ = self->priv->adjustments;
#line 1862 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp11_ = _tmp13_ == NULL;
#line 14419 "Photo.c"
			}
#line 1862 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp14_ = _tmp11_;
#line 1862 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			if (_tmp14_) {
#line 14425 "Photo.c"
				PixelTransformationBundle* _tmp15_;
				PixelTransformationBundle* _tmp16_ = NULL;
				PixelTransformationBundle* _tmp17_;
				PixelTransformer* _tmp18_ = NULL;
#line 1864 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp15_ = new_adjustments;
#line 1864 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp16_ = pixel_transformation_bundle_copy (_tmp15_);
#line 1864 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_pixel_transformation_bundle_unref0 (self->priv->adjustments);
#line 1864 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				self->priv->adjustments = _tmp16_;
#line 1865 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp17_ = new_adjustments;
#line 1865 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp18_ = pixel_transformation_bundle_generate_transformer (_tmp17_);
#line 1865 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_pixel_transformer_unref0 (self->priv->transformer);
#line 1865 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				self->priv->transformer = _tmp18_;
#line 14446 "Photo.c"
			} else {
				PixelTransformationBundle* _tmp35_;
				PixelTransformationBundle* _tmp36_ = NULL;
				{
					PixelTransformationBundle* _tmp19_;
					GeeIterable* _tmp20_ = NULL;
					GeeIterable* _tmp21_;
					GeeIterator* _tmp22_ = NULL;
					GeeIterator* _tmp23_;
					GeeIterator* _transformation_it;
#line 1868 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_tmp19_ = new_adjustments;
#line 1868 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_tmp20_ = pixel_transformation_bundle_get_transformations (_tmp19_);
#line 1868 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_tmp21_ = _tmp20_;
#line 1868 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_tmp22_ = gee_iterable_iterator (_tmp21_);
#line 1868 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_tmp23_ = _tmp22_;
#line 1868 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_g_object_unref0 (_tmp21_);
#line 1868 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_transformation_it = _tmp23_;
#line 1868 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					while (TRUE) {
#line 14473 "Photo.c"
						GeeIterator* _tmp24_;
						gboolean _tmp25_ = FALSE;
						GeeIterator* _tmp26_;
						gpointer _tmp27_ = NULL;
						PixelTransformation* transformation;
						PixelTransformer* _tmp28_;
						PixelTransformationBundle* _tmp29_;
						PixelTransformation* _tmp30_;
						PixelTransformationType _tmp31_ = 0;
						PixelTransformation* _tmp32_ = NULL;
						PixelTransformation* _tmp33_;
						PixelTransformation* _tmp34_;
#line 1868 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						_tmp24_ = _transformation_it;
#line 1868 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						_tmp25_ = gee_iterator_next (_tmp24_);
#line 1868 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						if (!_tmp25_) {
#line 1868 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
							break;
#line 14494 "Photo.c"
						}
#line 1868 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						_tmp26_ = _transformation_it;
#line 1868 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						_tmp27_ = gee_iterator_get (_tmp26_);
#line 1868 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						transformation = (PixelTransformation*) _tmp27_;
#line 1869 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						_tmp28_ = self->priv->transformer;
#line 1869 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						_tmp29_ = self->priv->adjustments;
#line 1869 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						_tmp30_ = transformation;
#line 1869 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						_tmp31_ = pixel_transformation_get_transformation_type (_tmp30_);
#line 1869 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						_tmp32_ = pixel_transformation_bundle_get_transformation (_tmp29_, _tmp31_);
#line 1869 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						_tmp33_ = _tmp32_;
#line 1869 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						_tmp34_ = transformation;
#line 1869 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						pixel_transformer_replace_transformation (_tmp28_, _tmp33_, _tmp34_);
#line 1869 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						_pixel_transformation_unref0 (_tmp33_);
#line 1868 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						_pixel_transformation_unref0 (transformation);
#line 14522 "Photo.c"
					}
#line 1868 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_g_object_unref0 (_transformation_it);
#line 14526 "Photo.c"
				}
#line 1874 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp35_ = new_adjustments;
#line 1874 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp36_ = pixel_transformation_bundle_copy (_tmp35_);
#line 1874 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_pixel_transformation_bundle_unref0 (self->priv->adjustments);
#line 1874 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				self->priv->adjustments = _tmp36_;
#line 14536 "Photo.c"
			}
#line 1877 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp37_ = map;
#line 1877 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp38_ = photo_set_transformation (self, _tmp37_);
#line 1877 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			committed = _tmp38_;
#line 14544 "Photo.c"
		}
		__finally186:
		{
			PhotoRow _tmp39_;
#line 1861 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp39_ = self->priv->row;
#line 1861 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 14553 "Photo.c"
		}
#line 1861 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 1861 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_key_value_map_unref0 (map);
#line 1861 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1861 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 1861 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			return;
#line 14565 "Photo.c"
		}
	}
#line 1880 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp40_ = committed;
#line 1880 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp40_) {
#line 14572 "Photo.c"
		Alteration* _tmp41_;
		Alteration* _tmp42_;
#line 1881 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp41_ = alteration_new ("image", "color-adjustments");
#line 1881 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp42_ = _tmp41_;
#line 1881 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		data_object_notify_altered (DATA_OBJECT (self), _tmp42_);
#line 1881 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_alteration_unref0 (_tmp42_);
#line 14583 "Photo.c"
	}
#line 1840 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_key_value_map_unref0 (map);
#line 14587 "Photo.c"
}


static PhotoMetadata* photo_real_get_metadata (PhotoSource* base) {
	Photo * self;
	PhotoMetadata* result = NULL;
	GError * _inner_error_ = NULL;
#line 1885 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	self = PHOTO (base);
#line 14597 "Photo.c"
	{
		PhotoFileReader* _tmp0_ = NULL;
		PhotoFileReader* _tmp1_;
		PhotoMetadata* _tmp2_ = NULL;
		PhotoMetadata* _tmp3_;
		PhotoMetadata* _tmp4_;
#line 1887 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp0_ = photo_get_source_reader (self);
#line 1887 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp1_ = _tmp0_;
#line 1887 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp2_ = photo_file_reader_read_metadata (_tmp1_, &_inner_error_);
#line 1887 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp3_ = _tmp2_;
#line 1887 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_photo_file_adapter_unref0 (_tmp1_);
#line 1887 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp4_ = _tmp3_;
#line 1887 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 14618 "Photo.c"
			goto __catch187_g_error;
		}
#line 1887 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		result = _tmp4_;
#line 1887 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return result;
#line 14625 "Photo.c"
	}
	goto __finally187;
	__catch187_g_error:
	{
		GError* err = NULL;
		GError* _tmp5_;
		const gchar* _tmp6_;
#line 1886 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		err = _inner_error_;
#line 1886 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_inner_error_ = NULL;
#line 1889 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp5_ = err;
#line 1889 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp6_ = _tmp5_->message;
#line 1889 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_warning ("Photo.vala:1889: Unable to load metadata: %s", _tmp6_);
#line 1891 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		result = NULL;
#line 1891 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_error_free0 (err);
#line 1891 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return result;
#line 14649 "Photo.c"
	}
	__finally187:
#line 1886 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1886 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_clear_error (&_inner_error_);
#line 1886 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return NULL;
#line 14658 "Photo.c"
}


PhotoMetadata* photo_get_master_metadata (Photo* self, GError** error) {
	PhotoMetadata* result = NULL;
	PhotoFileReader* _tmp0_ = NULL;
	PhotoFileReader* _tmp1_;
	PhotoMetadata* _tmp2_ = NULL;
	PhotoMetadata* _tmp3_;
	PhotoMetadata* _tmp4_;
	GError * _inner_error_ = NULL;
#line 1895 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 1896 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp0_ = photo_get_master_reader (self);
#line 1896 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 1896 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp2_ = photo_file_reader_read_metadata (_tmp1_, &_inner_error_);
#line 1896 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp3_ = _tmp2_;
#line 1896 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_photo_file_adapter_unref0 (_tmp1_);
#line 1896 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp4_ = _tmp3_;
#line 1896 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 1896 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 1896 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return NULL;
#line 14690 "Photo.c"
	}
#line 1896 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	result = _tmp4_;
#line 1896 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return result;
#line 14696 "Photo.c"
}


PhotoMetadata* photo_get_editable_metadata (Photo* self, GError** error) {
	PhotoMetadata* result = NULL;
	PhotoFileReader* _tmp0_ = NULL;
	PhotoFileReader* reader;
	PhotoMetadata* _tmp1_ = NULL;
	PhotoFileReader* _tmp2_;
	GError * _inner_error_ = NULL;
#line 1899 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 1900 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp0_ = photo_get_editable_reader (self);
#line 1900 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	reader = _tmp0_;
#line 1902 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp2_ = reader;
#line 1902 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp2_ != NULL) {
#line 14717 "Photo.c"
		PhotoFileReader* _tmp3_;
		PhotoMetadata* _tmp4_ = NULL;
#line 1902 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp3_ = reader;
#line 1902 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp4_ = photo_file_reader_read_metadata (_tmp3_, &_inner_error_);
#line 1902 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_media_metadata_unref0 (_tmp1_);
#line 1902 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp1_ = _tmp4_;
#line 1902 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 1902 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 1902 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_media_metadata_unref0 (_tmp1_);
#line 1902 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_photo_file_adapter_unref0 (reader);
#line 1902 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			return NULL;
#line 14738 "Photo.c"
		}
	} else {
#line 1902 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_media_metadata_unref0 (_tmp1_);
#line 1902 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp1_ = NULL;
#line 14745 "Photo.c"
	}
#line 1902 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	result = _tmp1_;
#line 1902 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_photo_file_adapter_unref0 (reader);
#line 1902 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return result;
#line 14753 "Photo.c"
}


gboolean photo_persist_master_metadata (Photo* self, PhotoMetadata* metadata, PhotoReimportMasterState** state, GError** error) {
	PhotoReimportMasterState* _vala_state = NULL;
	gboolean result = FALSE;
	PhotoFileReader* _tmp0_ = NULL;
	PhotoFileReader* master_reader;
	PhotoFileReader* _tmp1_;
	PhotoFileFormat _tmp2_ = 0;
	gboolean _tmp3_ = FALSE;
	PhotoFileReader* _tmp4_;
	PhotoFileMetadataWriter* _tmp5_ = NULL;
	PhotoFileMetadataWriter* _tmp6_;
	PhotoFileMetadataWriter* _tmp7_;
	PhotoMetadata* _tmp8_;
	PhotoReimportMasterState* _tmp9_ = NULL;
	gboolean _tmp10_ = FALSE;
	gboolean _tmp11_;
	PhotoReimportMasterState* _tmp12_;
	GError * _inner_error_ = NULL;
#line 1908 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 1908 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (metadata), FALSE);
#line 1910 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp0_ = photo_get_master_reader (self);
#line 1910 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	master_reader = _tmp0_;
#line 1912 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp1_ = master_reader;
#line 1912 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp2_ = photo_file_adapter_get_file_format (PHOTO_FILE_ADAPTER (_tmp1_));
#line 1912 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp3_ = photo_file_format_can_write_metadata (_tmp2_);
#line 1912 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (!_tmp3_) {
#line 1913 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		result = FALSE;
#line 1913 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_photo_file_adapter_unref0 (master_reader);
#line 1913 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		if (state) {
#line 1913 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			*state = _vala_state;
#line 14799 "Photo.c"
		} else {
#line 1913 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_photo_reimport_master_state_unref0 (_vala_state);
#line 14803 "Photo.c"
		}
#line 1913 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return result;
#line 14807 "Photo.c"
	}
#line 1915 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp4_ = master_reader;
#line 1915 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp5_ = photo_file_reader_create_metadata_writer (_tmp4_, &_inner_error_);
#line 1915 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp6_ = _tmp5_;
#line 1915 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 1915 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 1915 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_photo_file_adapter_unref0 (master_reader);
#line 1915 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return FALSE;
#line 14823 "Photo.c"
	}
#line 1915 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp7_ = _tmp6_;
#line 1915 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp8_ = metadata;
#line 1915 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	photo_file_metadata_writer_write_metadata (_tmp7_, _tmp8_, &_inner_error_);
#line 1915 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_photo_file_adapter_unref0 (_tmp7_);
#line 1915 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 1915 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 1915 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_photo_file_adapter_unref0 (master_reader);
#line 1915 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return FALSE;
#line 14841 "Photo.c"
	}
#line 1917 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp10_ = photo_prepare_for_reimport_master (self, &_tmp9_, &_inner_error_);
#line 1917 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_photo_reimport_master_state_unref0 (_vala_state);
#line 1917 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_vala_state = _tmp9_;
#line 1917 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp11_ = _tmp10_;
#line 1917 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 1917 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 1917 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_photo_file_adapter_unref0 (master_reader);
#line 1917 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return FALSE;
#line 14859 "Photo.c"
	}
#line 1917 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (!_tmp11_) {
#line 1918 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		result = FALSE;
#line 1918 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_photo_file_adapter_unref0 (master_reader);
#line 1918 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		if (state) {
#line 1918 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			*state = _vala_state;
#line 14871 "Photo.c"
		} else {
#line 1918 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_photo_reimport_master_state_unref0 (_vala_state);
#line 14875 "Photo.c"
		}
#line 1918 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return result;
#line 14879 "Photo.c"
	}
#line 1920 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp12_ = _vala_state;
#line 1920 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	PHOTO_REIMPORT_MASTER_STATE_IMPL (_tmp12_)->metadata_only = TRUE;
#line 1922 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	result = TRUE;
#line 1922 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_photo_file_adapter_unref0 (master_reader);
#line 1922 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (state) {
#line 1922 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		*state = _vala_state;
#line 14893 "Photo.c"
	} else {
#line 1922 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_photo_reimport_master_state_unref0 (_vala_state);
#line 14897 "Photo.c"
	}
#line 1922 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return result;
#line 14901 "Photo.c"
}


void photo_finish_update_master_metadata (Photo* self, PhotoReimportMasterState* state, GError** error) {
	PhotoReimportMasterState* _tmp0_;
	GError * _inner_error_ = NULL;
#line 1925 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 1925 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail (PHOTO_IS_REIMPORT_MASTER_STATE (state));
#line 1926 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp0_ = state;
#line 1926 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	photo_finish_reimport_master (self, _tmp0_, &_inner_error_);
#line 1926 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 1926 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		if (_inner_error_->domain == DATABASE_ERROR) {
#line 1926 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 1926 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			return;
#line 14924 "Photo.c"
		} else {
#line 1926 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1926 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 1926 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			return;
#line 14932 "Photo.c"
		}
	}
}


gboolean photo_persist_editable_metadata (Photo* self, PhotoMetadata* metadata, PhotoReimportEditableState** state, GError** error) {
	PhotoReimportEditableState* _vala_state = NULL;
	gboolean result = FALSE;
	PhotoFileReader* _tmp0_ = NULL;
	PhotoFileReader* editable_reader;
	PhotoFileReader* _tmp1_;
	PhotoFileReader* _tmp2_;
	PhotoFileFormat _tmp3_ = 0;
	gboolean _tmp4_ = FALSE;
	PhotoFileReader* _tmp5_;
	PhotoFileMetadataWriter* _tmp6_ = NULL;
	PhotoFileMetadataWriter* _tmp7_;
	PhotoFileMetadataWriter* _tmp8_;
	PhotoMetadata* _tmp9_;
	PhotoReimportEditableState* _tmp10_ = NULL;
	gboolean _tmp11_ = FALSE;
	gboolean _tmp12_;
	PhotoReimportEditableState* _tmp13_;
	GError * _inner_error_ = NULL;
#line 1929 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 1929 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (metadata), FALSE);
#line 1931 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp0_ = photo_get_editable_reader (self);
#line 1931 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	editable_reader = _tmp0_;
#line 1932 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp1_ = editable_reader;
#line 1932 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp1_ == NULL) {
#line 1933 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		result = FALSE;
#line 1933 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_photo_file_adapter_unref0 (editable_reader);
#line 1933 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		if (state) {
#line 1933 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			*state = _vala_state;
#line 14977 "Photo.c"
		} else {
#line 1933 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_photo_reimport_editable_state_unref0 (_vala_state);
#line 14981 "Photo.c"
		}
#line 1933 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return result;
#line 14985 "Photo.c"
	}
#line 1935 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp2_ = editable_reader;
#line 1935 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp3_ = photo_file_adapter_get_file_format (PHOTO_FILE_ADAPTER (_tmp2_));
#line 1935 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp4_ = photo_file_format_can_write_metadata (_tmp3_);
#line 1935 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (!_tmp4_) {
#line 1936 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		result = FALSE;
#line 1936 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_photo_file_adapter_unref0 (editable_reader);
#line 1936 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		if (state) {
#line 1936 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			*state = _vala_state;
#line 15003 "Photo.c"
		} else {
#line 1936 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_photo_reimport_editable_state_unref0 (_vala_state);
#line 15007 "Photo.c"
		}
#line 1936 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return result;
#line 15011 "Photo.c"
	}
#line 1938 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp5_ = editable_reader;
#line 1938 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp6_ = photo_file_reader_create_metadata_writer (_tmp5_, &_inner_error_);
#line 1938 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp7_ = _tmp6_;
#line 1938 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 1938 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 1938 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_photo_file_adapter_unref0 (editable_reader);
#line 1938 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return FALSE;
#line 15027 "Photo.c"
	}
#line 1938 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp8_ = _tmp7_;
#line 1938 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp9_ = metadata;
#line 1938 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	photo_file_metadata_writer_write_metadata (_tmp8_, _tmp9_, &_inner_error_);
#line 1938 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_photo_file_adapter_unref0 (_tmp8_);
#line 1938 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 1938 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 1938 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_photo_file_adapter_unref0 (editable_reader);
#line 1938 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return FALSE;
#line 15045 "Photo.c"
	}
#line 1940 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp11_ = photo_prepare_for_reimport_editable (self, &_tmp10_, &_inner_error_);
#line 1940 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_photo_reimport_editable_state_unref0 (_vala_state);
#line 1940 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_vala_state = _tmp10_;
#line 1940 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp12_ = _tmp11_;
#line 1940 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 1940 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 1940 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_photo_file_adapter_unref0 (editable_reader);
#line 1940 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return FALSE;
#line 15063 "Photo.c"
	}
#line 1940 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (!_tmp12_) {
#line 1941 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		result = FALSE;
#line 1941 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_photo_file_adapter_unref0 (editable_reader);
#line 1941 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		if (state) {
#line 1941 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			*state = _vala_state;
#line 15075 "Photo.c"
		} else {
#line 1941 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_photo_reimport_editable_state_unref0 (_vala_state);
#line 15079 "Photo.c"
		}
#line 1941 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return result;
#line 15083 "Photo.c"
	}
#line 1943 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp13_ = _vala_state;
#line 1943 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	PHOTO_REIMPORT_EDITABLE_STATE_IMPL (_tmp13_)->metadata_only = TRUE;
#line 1945 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	result = TRUE;
#line 1945 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_photo_file_adapter_unref0 (editable_reader);
#line 1945 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (state) {
#line 1945 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		*state = _vala_state;
#line 15097 "Photo.c"
	} else {
#line 1945 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_photo_reimport_editable_state_unref0 (_vala_state);
#line 15101 "Photo.c"
	}
#line 1945 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return result;
#line 15105 "Photo.c"
}


void photo_finish_update_editable_metadata (Photo* self, PhotoReimportEditableState* state, GError** error) {
	PhotoReimportEditableState* _tmp0_;
	GError * _inner_error_ = NULL;
#line 1948 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 1948 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail (PHOTO_IS_REIMPORT_EDITABLE_STATE (state));
#line 1949 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp0_ = state;
#line 1949 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	photo_finish_reimport_editable (self, _tmp0_, &_inner_error_);
#line 1949 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 1949 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		if (_inner_error_->domain == DATABASE_ERROR) {
#line 1949 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 1949 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			return;
#line 15128 "Photo.c"
		} else {
#line 1949 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1949 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 1949 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			return;
#line 15136 "Photo.c"
		}
	}
}


void photo_get_raw_dimensions (Photo* self, Dimensions* result) {
	GError * _inner_error_ = NULL;
#line 1954 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 15146 "Photo.c"
	{
		PhotoRow _tmp0_;
#line 1955 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp0_ = self->priv->row;
#line 1955 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 15153 "Photo.c"
		{
			BackingPhotoState* _tmp1_;
			Dimensions _tmp2_;
#line 1956 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp1_ = self->priv->backing_photo_state;
#line 1956 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp2_ = (*_tmp1_).dim;
#line 1956 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			*result = _tmp2_;
#line 15163 "Photo.c"
			{
				PhotoRow _tmp3_;
#line 1955 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp3_ = self->priv->row;
#line 1955 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 15170 "Photo.c"
			}
#line 1956 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			return;
#line 15174 "Photo.c"
		}
		__finally188:
		{
			PhotoRow _tmp4_;
#line 1955 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp4_ = self->priv->row;
#line 1955 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 15183 "Photo.c"
		}
#line 1955 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1955 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 1955 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return;
#line 15191 "Photo.c"
	}
}


gboolean photo_has_transformations (Photo* self) {
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
#line 1960 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 15201 "Photo.c"
	{
		PhotoRow _tmp0_;
#line 1961 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp0_ = self->priv->row;
#line 1961 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 15208 "Photo.c"
		{
			gboolean _tmp1_ = FALSE;
			PhotoRow _tmp2_;
			Orientation _tmp3_;
			BackingPhotoState* _tmp4_;
			Orientation _tmp5_;
			gboolean _tmp8_;
#line 1962 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp2_ = self->priv->row;
#line 1962 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp3_ = _tmp2_.orientation;
#line 1962 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp4_ = self->priv->backing_photo_state;
#line 1962 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp5_ = (*_tmp4_).original_orientation;
#line 1962 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			if (_tmp3_ != _tmp5_) {
#line 1963 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp1_ = TRUE;
#line 15228 "Photo.c"
			} else {
				PhotoRow _tmp6_;
				GeeHashMap* _tmp7_;
#line 1964 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp6_ = self->priv->row;
#line 1964 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp7_ = _tmp6_.transformations;
#line 1964 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp1_ = _tmp7_ != NULL;
#line 15238 "Photo.c"
			}
#line 1962 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp8_ = _tmp1_;
#line 1962 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			result = _tmp8_;
#line 15244 "Photo.c"
			{
				PhotoRow _tmp9_;
#line 1961 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp9_ = self->priv->row;
#line 1961 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 15251 "Photo.c"
			}
#line 1962 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			return result;
#line 15255 "Photo.c"
		}
		__finally189:
		{
			PhotoRow _tmp10_;
#line 1961 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp10_ = self->priv->row;
#line 1961 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 15264 "Photo.c"
		}
#line 1961 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1961 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 1961 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return FALSE;
#line 15272 "Photo.c"
	}
}


gboolean photo_only_metadata_changed (Photo* self) {
	gboolean result = FALSE;
	MetadataDateTime* date_time;
	PhotoMetadata* _tmp0_ = NULL;
	PhotoMetadata* metadata;
	PhotoMetadata* _tmp1_;
	GError * _inner_error_ = NULL;
#line 1968 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 1969 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	date_time = NULL;
#line 1971 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp0_ = photo_source_get_metadata (PHOTO_SOURCE (self));
#line 1971 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	metadata = _tmp0_;
#line 1972 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp1_ = metadata;
#line 1972 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp1_ != NULL) {
#line 15296 "Photo.c"
		PhotoMetadata* _tmp2_;
		MetadataDateTime* _tmp3_ = NULL;
#line 1973 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp2_ = metadata;
#line 1973 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp3_ = photo_metadata_get_exposure_date_time (_tmp2_);
#line 1973 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_metadata_date_time_unref0 (date_time);
#line 1973 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		date_time = _tmp3_;
#line 15307 "Photo.c"
	}
	{
		PhotoRow _tmp4_;
#line 1975 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp4_ = self->priv->row;
#line 1975 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 15315 "Photo.c"
		{
			gboolean _tmp5_ = FALSE;
			PhotoRow _tmp6_;
			GeeHashMap* _tmp7_;
			gboolean _tmp21_;
#line 1976 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp6_ = self->priv->row;
#line 1976 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp7_ = _tmp6_.transformations;
#line 1976 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			if (_tmp7_ == NULL) {
#line 15327 "Photo.c"
				gboolean _tmp8_ = FALSE;
				PhotoRow _tmp9_;
				Orientation _tmp10_;
				BackingPhotoState* _tmp11_;
				Orientation _tmp12_;
				gboolean _tmp20_;
#line 1977 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp9_ = self->priv->row;
#line 1977 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp10_ = _tmp9_.orientation;
#line 1977 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp11_ = self->priv->backing_photo_state;
#line 1977 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp12_ = (*_tmp11_).original_orientation;
#line 1977 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				if (_tmp10_ != _tmp12_) {
#line 1977 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_tmp8_ = TRUE;
#line 15346 "Photo.c"
				} else {
					gboolean _tmp13_ = FALSE;
					MetadataDateTime* _tmp14_;
					gboolean _tmp19_;
#line 1978 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_tmp14_ = date_time;
#line 1978 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					if (_tmp14_ != NULL) {
#line 15355 "Photo.c"
						PhotoRow _tmp15_;
						time_t _tmp16_;
						MetadataDateTime* _tmp17_;
						time_t _tmp18_ = 0;
#line 1978 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						_tmp15_ = self->priv->row;
#line 1978 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						_tmp16_ = _tmp15_.exposure_time;
#line 1978 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						_tmp17_ = date_time;
#line 1978 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						_tmp18_ = metadata_date_time_get_timestamp (_tmp17_);
#line 1978 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						_tmp13_ = _tmp16_ != _tmp18_;
#line 15370 "Photo.c"
					} else {
#line 1978 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						_tmp13_ = FALSE;
#line 15374 "Photo.c"
					}
#line 1978 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_tmp19_ = _tmp13_;
#line 1978 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_tmp8_ = _tmp19_;
#line 15380 "Photo.c"
				}
#line 1977 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp20_ = _tmp8_;
#line 1977 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp5_ = _tmp20_;
#line 15386 "Photo.c"
			} else {
#line 1976 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp5_ = FALSE;
#line 15390 "Photo.c"
			}
#line 1976 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp21_ = _tmp5_;
#line 1976 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			result = _tmp21_;
#line 15396 "Photo.c"
			{
				PhotoRow _tmp22_;
#line 1975 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp22_ = self->priv->row;
#line 1975 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 15403 "Photo.c"
			}
#line 1976 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_media_metadata_unref0 (metadata);
#line 1976 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_metadata_date_time_unref0 (date_time);
#line 1976 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			return result;
#line 15411 "Photo.c"
		}
		__finally190:
		{
			PhotoRow _tmp23_;
#line 1975 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp23_ = self->priv->row;
#line 1975 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 15420 "Photo.c"
		}
#line 1975 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 1975 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_metadata_date_time_unref0 (date_time);
#line 1975 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1975 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 1975 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return FALSE;
#line 15432 "Photo.c"
	}
#line 1968 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_media_metadata_unref0 (metadata);
#line 1968 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_metadata_date_time_unref0 (date_time);
#line 15438 "Photo.c"
}


gboolean photo_has_alterations (Photo* self) {
	gboolean result = FALSE;
	MetadataDateTime* date_time;
	gchar* title;
	PhotoMetadata* _tmp0_ = NULL;
	PhotoMetadata* metadata;
	PhotoMetadata* _tmp1_;
	GError * _inner_error_ = NULL;
#line 1982 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 1983 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	date_time = NULL;
#line 1984 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	title = NULL;
#line 1986 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp0_ = photo_source_get_metadata (PHOTO_SOURCE (self));
#line 1986 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	metadata = _tmp0_;
#line 1987 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp1_ = metadata;
#line 1987 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp1_ != NULL) {
#line 15464 "Photo.c"
		PhotoMetadata* _tmp2_;
		MetadataDateTime* _tmp3_ = NULL;
		PhotoMetadata* _tmp4_;
		gchar* _tmp5_ = NULL;
#line 1988 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp2_ = metadata;
#line 1988 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp3_ = photo_metadata_get_exposure_date_time (_tmp2_);
#line 1988 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_metadata_date_time_unref0 (date_time);
#line 1988 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		date_time = _tmp3_;
#line 1989 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp4_ = metadata;
#line 1989 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp5_ = media_metadata_get_title (MEDIA_METADATA (_tmp4_));
#line 1989 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_free0 (title);
#line 1989 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		title = _tmp5_;
#line 15485 "Photo.c"
	}
	{
		PhotoRow _tmp6_;
#line 1992 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp6_ = self->priv->row;
#line 1992 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 15493 "Photo.c"
		{
			gboolean _tmp7_ = FALSE;
			gboolean _tmp8_ = FALSE;
			gboolean _tmp9_ = FALSE;
			PhotoRow _tmp10_;
			GeeHashMap* _tmp11_;
			gboolean _tmp16_;
			gboolean _tmp24_;
			gboolean _tmp28_;
#line 1993 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp10_ = self->priv->row;
#line 1993 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp11_ = _tmp10_.transformations;
#line 1993 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			if (_tmp11_ != NULL) {
#line 1993 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp9_ = TRUE;
#line 15511 "Photo.c"
			} else {
				PhotoRow _tmp12_;
				Orientation _tmp13_;
				BackingPhotoState* _tmp14_;
				Orientation _tmp15_;
#line 1994 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp12_ = self->priv->row;
#line 1994 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp13_ = _tmp12_.orientation;
#line 1994 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp14_ = self->priv->backing_photo_state;
#line 1994 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp15_ = (*_tmp14_).original_orientation;
#line 1994 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp9_ = _tmp13_ != _tmp15_;
#line 15527 "Photo.c"
			}
#line 1993 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp16_ = _tmp9_;
#line 1993 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			if (_tmp16_) {
#line 1993 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp8_ = TRUE;
#line 15535 "Photo.c"
			} else {
				gboolean _tmp17_ = FALSE;
				MetadataDateTime* _tmp18_;
				gboolean _tmp23_;
#line 1995 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp18_ = date_time;
#line 1995 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				if (_tmp18_ != NULL) {
#line 15544 "Photo.c"
					PhotoRow _tmp19_;
					time_t _tmp20_;
					MetadataDateTime* _tmp21_;
					time_t _tmp22_ = 0;
#line 1995 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_tmp19_ = self->priv->row;
#line 1995 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_tmp20_ = _tmp19_.exposure_time;
#line 1995 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_tmp21_ = date_time;
#line 1995 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_tmp22_ = metadata_date_time_get_timestamp (_tmp21_);
#line 1995 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_tmp17_ = _tmp20_ != _tmp22_;
#line 15559 "Photo.c"
				} else {
#line 1995 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_tmp17_ = FALSE;
#line 15563 "Photo.c"
				}
#line 1995 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp23_ = _tmp17_;
#line 1995 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp8_ = _tmp23_;
#line 15569 "Photo.c"
			}
#line 1993 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp24_ = _tmp8_;
#line 1993 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			if (_tmp24_) {
#line 1993 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp7_ = TRUE;
#line 15577 "Photo.c"
			} else {
				gchar* _tmp25_ = NULL;
				gchar* _tmp26_;
				const gchar* _tmp27_;
#line 1996 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp25_ = media_source_get_title (MEDIA_SOURCE (self));
#line 1996 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp26_ = _tmp25_;
#line 1996 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp27_ = title;
#line 1996 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp7_ = g_strcmp0 (_tmp26_, _tmp27_) != 0;
#line 1996 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_g_free0 (_tmp26_);
#line 15592 "Photo.c"
			}
#line 1993 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp28_ = _tmp7_;
#line 1993 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			result = _tmp28_;
#line 15598 "Photo.c"
			{
				PhotoRow _tmp29_;
#line 1992 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp29_ = self->priv->row;
#line 1992 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 15605 "Photo.c"
			}
#line 1993 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_media_metadata_unref0 (metadata);
#line 1993 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_g_free0 (title);
#line 1993 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_metadata_date_time_unref0 (date_time);
#line 1993 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			return result;
#line 15615 "Photo.c"
		}
		__finally191:
		{
			PhotoRow _tmp30_;
#line 1992 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp30_ = self->priv->row;
#line 1992 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 15624 "Photo.c"
		}
#line 1992 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 1992 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_free0 (title);
#line 1992 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_metadata_date_time_unref0 (date_time);
#line 1992 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1992 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 1992 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return FALSE;
#line 15638 "Photo.c"
	}
#line 1982 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_media_metadata_unref0 (metadata);
#line 1982 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_g_free0 (title);
#line 1982 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_metadata_date_time_unref0 (date_time);
#line 15646 "Photo.c"
}


PhotoTransformationState* photo_save_transformation_state (Photo* self) {
	PhotoTransformationState* result = NULL;
	GError * _inner_error_ = NULL;
#line 2000 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 15655 "Photo.c"
	{
		PhotoRow _tmp0_;
#line 2001 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp0_ = self->priv->row;
#line 2001 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 15662 "Photo.c"
		{
			PixelTransformer* _tmp1_ = NULL;
			PixelTransformer* _tmp2_;
			PixelTransformationBundle* _tmp5_ = NULL;
			PixelTransformationBundle* _tmp6_;
			PhotoRow _tmp9_;
			Orientation _tmp10_;
			PhotoRow _tmp11_;
			GeeHashMap* _tmp12_;
			PixelTransformer* _tmp13_;
			PixelTransformationBundle* _tmp14_;
			PhotoPhotoTransformationStateImpl* _tmp15_;
#line 2004 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp2_ = self->priv->transformer;
#line 2004 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			if (_tmp2_ != NULL) {
#line 15679 "Photo.c"
				PixelTransformer* _tmp3_;
				PixelTransformer* _tmp4_ = NULL;
#line 2004 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp3_ = self->priv->transformer;
#line 2004 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp4_ = pixel_transformer_copy (_tmp3_);
#line 2004 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_pixel_transformer_unref0 (_tmp1_);
#line 2004 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp1_ = _tmp4_;
#line 15690 "Photo.c"
			} else {
#line 2004 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_pixel_transformer_unref0 (_tmp1_);
#line 2004 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp1_ = NULL;
#line 15696 "Photo.c"
			}
#line 2005 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp6_ = self->priv->adjustments;
#line 2005 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			if (_tmp6_ != NULL) {
#line 15702 "Photo.c"
				PixelTransformationBundle* _tmp7_;
				PixelTransformationBundle* _tmp8_ = NULL;
#line 2005 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp7_ = self->priv->adjustments;
#line 2005 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp8_ = pixel_transformation_bundle_copy (_tmp7_);
#line 2005 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_pixel_transformation_bundle_unref0 (_tmp5_);
#line 2005 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp5_ = _tmp8_;
#line 15713 "Photo.c"
			} else {
#line 2005 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_pixel_transformation_bundle_unref0 (_tmp5_);
#line 2005 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp5_ = NULL;
#line 15719 "Photo.c"
			}
#line 2002 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp9_ = self->priv->row;
#line 2002 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp10_ = _tmp9_.orientation;
#line 2002 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp11_ = self->priv->row;
#line 2002 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp12_ = _tmp11_.transformations;
#line 2002 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp13_ = _tmp1_;
#line 2002 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp14_ = _tmp5_;
#line 2002 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp15_ = photo_photo_transformation_state_impl_new (self, _tmp10_, _tmp12_, _tmp13_, _tmp14_);
#line 2002 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			result = PHOTO_TRANSFORMATION_STATE (_tmp15_);
#line 2002 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_pixel_transformation_bundle_unref0 (_tmp5_);
#line 2002 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_pixel_transformer_unref0 (_tmp1_);
#line 15741 "Photo.c"
			{
				PhotoRow _tmp16_;
#line 2001 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp16_ = self->priv->row;
#line 2001 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 15748 "Photo.c"
			}
#line 2002 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			return result;
#line 15752 "Photo.c"
		}
		__finally192:
		{
			PhotoRow _tmp17_;
#line 2001 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp17_ = self->priv->row;
#line 2001 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 15761 "Photo.c"
		}
#line 2001 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2001 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 2001 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return NULL;
#line 15769 "Photo.c"
	}
}


static gpointer _pixel_transformer_ref0 (gpointer self) {
#line 2026 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return self ? pixel_transformer_ref (self) : NULL;
#line 15777 "Photo.c"
}


static gpointer _pixel_transformation_bundle_ref0 (gpointer self) {
#line 2027 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return self ? pixel_transformation_bundle_ref (self) : NULL;
#line 15784 "Photo.c"
}


gboolean photo_load_transformation_state (Photo* self, PhotoTransformationState* state) {
	gboolean result = FALSE;
	PhotoTransformationState* _tmp0_;
	PhotoPhotoTransformationStateImpl* _tmp1_;
	PhotoPhotoTransformationStateImpl* state_impl;
	PhotoPhotoTransformationStateImpl* _tmp2_;
	PhotoPhotoTransformationStateImpl* _tmp3_;
	Orientation _tmp4_ = 0;
	Orientation saved_orientation;
	PhotoPhotoTransformationStateImpl* _tmp5_;
	GeeHashMap* _tmp6_ = NULL;
	GeeHashMap* saved_transformations;
	PhotoPhotoTransformationStateImpl* _tmp7_;
	PixelTransformer* _tmp8_ = NULL;
	PixelTransformer* saved_transformer;
	PhotoPhotoTransformationStateImpl* _tmp9_;
	PixelTransformationBundle* _tmp10_ = NULL;
	PixelTransformationBundle* saved_adjustments;
	gboolean committed = FALSE;
	gboolean _tmp28_;
	GError * _inner_error_ = NULL;
#line 2009 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 2009 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO_TRANSFORMATION_STATE (state), FALSE);
#line 2010 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp0_ = state;
#line 2010 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp1_ = _g_object_ref0 (PHOTO_IS_PHOTO_TRANSFORMATION_STATE_IMPL (_tmp0_) ? ((PhotoPhotoTransformationStateImpl*) _tmp0_) : NULL);
#line 2010 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	state_impl = _tmp1_;
#line 2011 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp2_ = state_impl;
#line 2011 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp2_ == NULL) {
#line 2012 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		result = FALSE;
#line 2012 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_object_unref0 (state_impl);
#line 2012 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return result;
#line 15829 "Photo.c"
	}
#line 2014 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp3_ = state_impl;
#line 2014 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp4_ = photo_photo_transformation_state_impl_get_orientation (_tmp3_);
#line 2014 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	saved_orientation = _tmp4_;
#line 2015 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp5_ = state_impl;
#line 2015 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp6_ = photo_photo_transformation_state_impl_get_transformations (_tmp5_);
#line 2015 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	saved_transformations = _tmp6_;
#line 2016 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp7_ = state_impl;
#line 2016 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp8_ = photo_photo_transformation_state_impl_get_transformer (_tmp7_);
#line 2016 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	saved_transformer = _tmp8_;
#line 2017 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp9_ = state_impl;
#line 2017 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp10_ = photo_photo_transformation_state_impl_get_color_adjustments (_tmp9_);
#line 2017 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	saved_adjustments = _tmp10_;
#line 15855 "Photo.c"
	{
		PhotoRow _tmp11_;
#line 2020 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp11_ = self->priv->row;
#line 2020 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 15862 "Photo.c"
		{
			PhotoTable* _tmp12_ = NULL;
			PhotoTable* _tmp13_;
			PhotoRow _tmp14_;
			PhotoID _tmp15_;
			Orientation _tmp16_;
			GeeHashMap* _tmp17_;
			gboolean _tmp18_ = FALSE;
			gboolean _tmp19_;
#line 2021 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp12_ = photo_table_get_instance ();
#line 2021 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp13_ = _tmp12_;
#line 2021 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp14_ = self->priv->row;
#line 2021 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp15_ = _tmp14_.photo_id;
#line 2021 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp16_ = saved_orientation;
#line 2021 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp17_ = saved_transformations;
#line 2021 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp18_ = photo_table_set_transformation_state (_tmp13_, &_tmp15_, _tmp16_, _tmp17_);
#line 2021 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			committed = _tmp18_;
#line 2021 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_database_table_unref0 (_tmp13_);
#line 2023 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp19_ = committed;
#line 2023 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			if (_tmp19_) {
#line 15894 "Photo.c"
				Orientation _tmp20_;
				GeeHashMap* _tmp21_;
				GeeHashMap* _tmp22_;
				PixelTransformer* _tmp23_;
				PixelTransformer* _tmp24_;
				PixelTransformationBundle* _tmp25_;
				PixelTransformationBundle* _tmp26_;
#line 2024 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp20_ = saved_orientation;
#line 2024 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				self->priv->row.orientation = _tmp20_;
#line 2025 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp21_ = saved_transformations;
#line 2025 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp22_ = _g_object_ref0 (_tmp21_);
#line 2025 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_g_object_unref0 (self->priv->row.transformations);
#line 2025 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				self->priv->row.transformations = _tmp22_;
#line 2026 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp23_ = saved_transformer;
#line 2026 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp24_ = _pixel_transformer_ref0 (_tmp23_);
#line 2026 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_pixel_transformer_unref0 (self->priv->transformer);
#line 2026 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				self->priv->transformer = _tmp24_;
#line 2027 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp25_ = saved_adjustments;
#line 2027 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp26_ = _pixel_transformation_bundle_ref0 (_tmp25_);
#line 2027 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_pixel_transformation_bundle_unref0 (self->priv->adjustments);
#line 2027 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				self->priv->adjustments = _tmp26_;
#line 15930 "Photo.c"
			}
		}
		__finally193:
		{
			PhotoRow _tmp27_;
#line 2020 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp27_ = self->priv->row;
#line 2020 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 15940 "Photo.c"
		}
#line 2020 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 2020 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_pixel_transformation_bundle_unref0 (saved_adjustments);
#line 2020 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_pixel_transformer_unref0 (saved_transformer);
#line 2020 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_g_object_unref0 (saved_transformations);
#line 2020 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_g_object_unref0 (state_impl);
#line 2020 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2020 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 2020 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			return FALSE;
#line 15958 "Photo.c"
		}
	}
#line 2031 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp28_ = committed;
#line 2031 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp28_) {
#line 15965 "Photo.c"
		Alteration* _tmp29_;
		Alteration* _tmp30_;
#line 2032 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp29_ = alteration_new ("image", "transformation-state");
#line 2032 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp30_ = _tmp29_;
#line 2032 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		data_object_notify_altered (DATA_OBJECT (self), _tmp30_);
#line 2032 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_alteration_unref0 (_tmp30_);
#line 15976 "Photo.c"
	}
#line 2034 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	result = committed;
#line 2034 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_pixel_transformation_bundle_unref0 (saved_adjustments);
#line 2034 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_pixel_transformer_unref0 (saved_transformer);
#line 2034 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_g_object_unref0 (saved_transformations);
#line 2034 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_g_object_unref0 (state_impl);
#line 2034 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return result;
#line 15990 "Photo.c"
}


void photo_remove_all_transformations (Photo* self) {
#line 2037 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 2038 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	photo_internal_remove_all_transformations (self, TRUE);
#line 15999 "Photo.c"
}


static void photo_internal_remove_all_transformations (Photo* self, gboolean notify) {
	gboolean is_altered;
	gboolean _tmp19_ = FALSE;
	gboolean _tmp20_;
	gboolean _tmp22_;
	GError * _inner_error_ = NULL;
#line 2041 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 2042 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	is_altered = FALSE;
#line 16013 "Photo.c"
	{
		PhotoRow _tmp0_;
#line 2043 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp0_ = self->priv->row;
#line 2043 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 16020 "Photo.c"
		{
			PhotoTable* _tmp1_ = NULL;
			PhotoTable* _tmp2_;
			PhotoRow _tmp3_;
			PhotoID _tmp4_;
			gboolean _tmp5_ = FALSE;
			PhotoRow _tmp6_;
			Orientation _tmp7_;
			BackingPhotoState* _tmp8_;
			Orientation _tmp9_;
#line 2044 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp1_ = photo_table_get_instance ();
#line 2044 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp2_ = _tmp1_;
#line 2044 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp3_ = self->priv->row;
#line 2044 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp4_ = _tmp3_.photo_id;
#line 2044 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp5_ = photo_table_remove_all_transformations (_tmp2_, &_tmp4_);
#line 2044 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			is_altered = _tmp5_;
#line 2044 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_database_table_unref0 (_tmp2_);
#line 2045 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_g_object_unref0 (self->priv->row.transformations);
#line 2045 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			self->priv->row.transformations = NULL;
#line 2047 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_pixel_transformer_unref0 (self->priv->transformer);
#line 2047 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			self->priv->transformer = NULL;
#line 2048 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_pixel_transformation_bundle_unref0 (self->priv->adjustments);
#line 2048 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			self->priv->adjustments = NULL;
#line 2050 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp6_ = self->priv->row;
#line 2050 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp7_ = _tmp6_.orientation;
#line 2050 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp8_ = self->priv->backing_photo_state;
#line 2050 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp9_ = (*_tmp8_).original_orientation;
#line 2050 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			if (_tmp7_ != _tmp9_) {
#line 16067 "Photo.c"
				PhotoTable* _tmp10_ = NULL;
				PhotoTable* _tmp11_;
				PhotoRow _tmp12_;
				PhotoID _tmp13_;
				BackingPhotoState* _tmp14_;
				Orientation _tmp15_;
				BackingPhotoState* _tmp16_;
				Orientation _tmp17_;
#line 2051 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp10_ = photo_table_get_instance ();
#line 2051 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp11_ = _tmp10_;
#line 2051 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp12_ = self->priv->row;
#line 2051 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp13_ = _tmp12_.photo_id;
#line 2051 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp14_ = self->priv->backing_photo_state;
#line 2051 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp15_ = (*_tmp14_).original_orientation;
#line 2051 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				photo_table_set_orientation (_tmp11_, &_tmp13_, _tmp15_);
#line 2051 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_database_table_unref0 (_tmp11_);
#line 2053 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp16_ = self->priv->backing_photo_state;
#line 2053 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp17_ = (*_tmp16_).original_orientation;
#line 2053 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				self->priv->row.orientation = _tmp17_;
#line 2054 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				is_altered = TRUE;
#line 16100 "Photo.c"
			}
		}
		__finally194:
		{
			PhotoRow _tmp18_;
#line 2043 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp18_ = self->priv->row;
#line 2043 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 16110 "Photo.c"
		}
#line 2043 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 2043 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2043 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 2043 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			return;
#line 16120 "Photo.c"
		}
	}
#line 2058 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp20_ = is_altered;
#line 2058 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp20_) {
#line 16127 "Photo.c"
		gboolean _tmp21_;
#line 2058 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp21_ = notify;
#line 2058 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp19_ = _tmp21_;
#line 16133 "Photo.c"
	} else {
#line 2058 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp19_ = FALSE;
#line 16137 "Photo.c"
	}
#line 2058 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp22_ = _tmp19_;
#line 2058 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp22_) {
#line 16143 "Photo.c"
		Alteration* _tmp23_;
		Alteration* _tmp24_;
#line 2059 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp23_ = alteration_new ("image", "revert");
#line 2059 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp24_ = _tmp23_;
#line 2059 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		data_object_notify_altered (DATA_OBJECT (self), _tmp24_);
#line 2059 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_alteration_unref0 (_tmp24_);
#line 16154 "Photo.c"
	}
}


Orientation photo_get_original_orientation (Photo* self) {
	Orientation result = 0;
	GError * _inner_error_ = NULL;
#line 2062 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), 0);
#line 16164 "Photo.c"
	{
		PhotoRow _tmp0_;
#line 2063 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp0_ = self->priv->row;
#line 2063 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 16171 "Photo.c"
		{
			BackingPhotoState* _tmp1_;
			Orientation _tmp2_;
#line 2064 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp1_ = self->priv->backing_photo_state;
#line 2064 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp2_ = (*_tmp1_).original_orientation;
#line 2064 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			result = _tmp2_;
#line 16181 "Photo.c"
			{
				PhotoRow _tmp3_;
#line 2063 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp3_ = self->priv->row;
#line 2063 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 16188 "Photo.c"
			}
#line 2064 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			return result;
#line 16192 "Photo.c"
		}
		__finally195:
		{
			PhotoRow _tmp4_;
#line 2063 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp4_ = self->priv->row;
#line 2063 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 16201 "Photo.c"
		}
#line 2063 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2063 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 2063 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return 0;
#line 16209 "Photo.c"
	}
}


Orientation photo_get_orientation (Photo* self) {
	Orientation result = 0;
	GError * _inner_error_ = NULL;
#line 2068 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), 0);
#line 16219 "Photo.c"
	{
		PhotoRow _tmp0_;
#line 2069 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp0_ = self->priv->row;
#line 2069 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 16226 "Photo.c"
		{
			PhotoRow _tmp1_;
			Orientation _tmp2_;
#line 2070 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp1_ = self->priv->row;
#line 2070 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp2_ = _tmp1_.orientation;
#line 2070 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			result = _tmp2_;
#line 16236 "Photo.c"
			{
				PhotoRow _tmp3_;
#line 2069 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp3_ = self->priv->row;
#line 2069 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 16243 "Photo.c"
			}
#line 2070 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			return result;
#line 16247 "Photo.c"
		}
		__finally196:
		{
			PhotoRow _tmp4_;
#line 2069 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp4_ = self->priv->row;
#line 2069 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 16256 "Photo.c"
		}
#line 2069 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2069 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 2069 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return 0;
#line 16264 "Photo.c"
	}
}


gboolean photo_set_orientation (Photo* self, Orientation orientation) {
	gboolean result = FALSE;
	gboolean committed;
	gboolean _tmp13_;
	GError * _inner_error_ = NULL;
#line 2074 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 2075 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	committed = FALSE;
#line 16278 "Photo.c"
	{
		PhotoRow _tmp0_;
#line 2076 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp0_ = self->priv->row;
#line 2076 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 16285 "Photo.c"
		{
			PhotoRow _tmp1_;
			Orientation _tmp2_;
			Orientation _tmp3_;
#line 2077 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp1_ = self->priv->row;
#line 2077 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp2_ = _tmp1_.orientation;
#line 2077 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp3_ = orientation;
#line 2077 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			if (_tmp2_ != _tmp3_) {
#line 16298 "Photo.c"
				PhotoTable* _tmp4_ = NULL;
				PhotoTable* _tmp5_;
				PhotoRow _tmp6_;
				PhotoID _tmp7_;
				Orientation _tmp8_;
				gboolean _tmp9_ = FALSE;
				gboolean _tmp10_;
#line 2078 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp4_ = photo_table_get_instance ();
#line 2078 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp5_ = _tmp4_;
#line 2078 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp6_ = self->priv->row;
#line 2078 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp7_ = _tmp6_.photo_id;
#line 2078 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp8_ = orientation;
#line 2078 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp9_ = photo_table_set_orientation (_tmp5_, &_tmp7_, _tmp8_);
#line 2078 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				committed = _tmp9_;
#line 2078 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_database_table_unref0 (_tmp5_);
#line 2079 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp10_ = committed;
#line 2079 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				if (_tmp10_) {
#line 16326 "Photo.c"
					Orientation _tmp11_;
#line 2080 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_tmp11_ = orientation;
#line 2080 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					self->priv->row.orientation = _tmp11_;
#line 16332 "Photo.c"
				}
			}
		}
		__finally197:
		{
			PhotoRow _tmp12_;
#line 2076 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp12_ = self->priv->row;
#line 2076 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 16343 "Photo.c"
		}
#line 2076 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 2076 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2076 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 2076 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			return FALSE;
#line 16353 "Photo.c"
		}
	}
#line 2084 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp13_ = committed;
#line 2084 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp13_) {
#line 16360 "Photo.c"
		Alteration* _tmp14_;
		Alteration* _tmp15_;
#line 2085 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp14_ = alteration_new ("image", "orientation");
#line 2085 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp15_ = _tmp14_;
#line 2085 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		data_object_notify_altered (DATA_OBJECT (self), _tmp15_);
#line 2085 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_alteration_unref0 (_tmp15_);
#line 16371 "Photo.c"
	}
#line 2087 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	result = committed;
#line 2087 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return result;
#line 16377 "Photo.c"
}


static void photo_real_rotate (Photo* self, Rotation rotation) {
	GError * _inner_error_ = NULL;
	{
		PhotoRow _tmp0_;
#line 2091 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp0_ = self->priv->row;
#line 2091 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 16389 "Photo.c"
		{
			Orientation _tmp1_ = 0;
			Rotation _tmp2_;
			Orientation _tmp3_ = 0;
#line 2092 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp1_ = photo_get_orientation (self);
#line 2092 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp2_ = rotation;
#line 2092 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp3_ = orientation_perform (_tmp1_, _tmp2_);
#line 2092 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			photo_set_orientation (self, _tmp3_);
#line 16402 "Photo.c"
		}
		__finally198:
		{
			PhotoRow _tmp4_;
#line 2091 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp4_ = self->priv->row;
#line 2091 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 16411 "Photo.c"
		}
#line 2091 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 2091 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2091 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 2091 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			return;
#line 16421 "Photo.c"
		}
	}
}


void photo_rotate (Photo* self, Rotation rotation) {
#line 2090 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 2090 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	PHOTO_GET_CLASS (self)->rotate (self, rotation);
#line 16432 "Photo.c"
}


static gboolean photo_has_transformation (Photo* self, const gchar* name) {
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
#line 2096 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 2096 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail (name != NULL, FALSE);
#line 16443 "Photo.c"
	{
		PhotoRow _tmp0_;
#line 2097 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp0_ = self->priv->row;
#line 2097 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 16450 "Photo.c"
		{
			gboolean _tmp1_ = FALSE;
			PhotoRow _tmp2_;
			GeeHashMap* _tmp3_;
#line 2098 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp2_ = self->priv->row;
#line 2098 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp3_ = _tmp2_.transformations;
#line 2098 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			if (_tmp3_ != NULL) {
#line 16461 "Photo.c"
				PhotoRow _tmp4_;
				GeeHashMap* _tmp5_;
				const gchar* _tmp6_;
				gboolean _tmp7_ = FALSE;
#line 2098 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp4_ = self->priv->row;
#line 2098 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp5_ = _tmp4_.transformations;
#line 2098 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp6_ = name;
#line 2098 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp7_ = gee_abstract_map_has_key (GEE_ABSTRACT_MAP (_tmp5_), _tmp6_);
#line 2098 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp1_ = _tmp7_;
#line 16476 "Photo.c"
			} else {
#line 2098 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp1_ = FALSE;
#line 16480 "Photo.c"
			}
#line 2098 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			result = _tmp1_;
#line 16484 "Photo.c"
			{
				PhotoRow _tmp8_;
#line 2097 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp8_ = self->priv->row;
#line 2097 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 16491 "Photo.c"
			}
#line 2098 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			return result;
#line 16495 "Photo.c"
		}
		__finally199:
		{
			PhotoRow _tmp9_;
#line 2097 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp9_ = self->priv->row;
#line 2097 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 16504 "Photo.c"
		}
#line 2097 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2097 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 2097 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return FALSE;
#line 16512 "Photo.c"
	}
}


static KeyValueMap* photo_get_transformation (Photo* self, const gchar* name) {
	KeyValueMap* result = NULL;
	KeyValueMap* map;
	GError * _inner_error_ = NULL;
#line 2105 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 2105 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 2106 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	map = NULL;
#line 16527 "Photo.c"
	{
		PhotoRow _tmp0_;
#line 2107 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp0_ = self->priv->row;
#line 2107 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 16534 "Photo.c"
		{
			PhotoRow _tmp1_;
			GeeHashMap* _tmp2_;
#line 2108 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp1_ = self->priv->row;
#line 2108 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp2_ = _tmp1_.transformations;
#line 2108 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			if (_tmp2_ != NULL) {
#line 16544 "Photo.c"
				PhotoRow _tmp3_;
				GeeHashMap* _tmp4_;
				const gchar* _tmp5_;
				gpointer _tmp6_ = NULL;
				KeyValueMap* _tmp7_;
#line 2109 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp3_ = self->priv->row;
#line 2109 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp4_ = _tmp3_.transformations;
#line 2109 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp5_ = name;
#line 2109 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp6_ = gee_abstract_map_get (GEE_ABSTRACT_MAP (_tmp4_), _tmp5_);
#line 2109 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_key_value_map_unref0 (map);
#line 2109 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				map = (KeyValueMap*) _tmp6_;
#line 2110 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp7_ = map;
#line 2110 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				if (_tmp7_ != NULL) {
#line 16566 "Photo.c"
					KeyValueMap* _tmp8_;
					KeyValueMap* _tmp9_ = NULL;
#line 2111 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_tmp8_ = map;
#line 2111 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_tmp9_ = key_value_map_copy (_tmp8_);
#line 2111 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_key_value_map_unref0 (map);
#line 2111 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					map = _tmp9_;
#line 16577 "Photo.c"
				}
			}
		}
		__finally200:
		{
			PhotoRow _tmp10_;
#line 2107 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp10_ = self->priv->row;
#line 2107 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 16588 "Photo.c"
		}
#line 2107 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 2107 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_key_value_map_unref0 (map);
#line 2107 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2107 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 2107 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			return NULL;
#line 16600 "Photo.c"
		}
	}
#line 2115 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	result = map;
#line 2115 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return result;
#line 16607 "Photo.c"
}


static gboolean photo_set_transformation (Photo* self, KeyValueMap* trans) {
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
#line 2118 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 2118 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail (IS_KEY_VALUE_MAP (trans), FALSE);
#line 16618 "Photo.c"
	{
		PhotoRow _tmp0_;
#line 2119 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp0_ = self->priv->row;
#line 2119 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 16625 "Photo.c"
		{
			PhotoRow _tmp1_;
			GeeHashMap* _tmp2_;
			PhotoRow _tmp7_;
			GeeHashMap* _tmp8_;
			KeyValueMap* _tmp9_;
			gchar* _tmp10_ = NULL;
			gchar* _tmp11_;
			KeyValueMap* _tmp12_;
			PhotoTable* _tmp13_ = NULL;
			PhotoTable* _tmp14_;
			PhotoRow _tmp15_;
			PhotoID _tmp16_;
			KeyValueMap* _tmp17_;
			gboolean _tmp18_ = FALSE;
			gboolean _tmp19_;
#line 2120 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp1_ = self->priv->row;
#line 2120 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp2_ = _tmp1_.transformations;
#line 2120 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			if (_tmp2_ == NULL) {
#line 16648 "Photo.c"
				GHashFunc _tmp3_;
				GEqualFunc _tmp4_;
				GEqualFunc _tmp5_;
				GeeHashMap* _tmp6_;
#line 2121 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp3_ = g_str_hash;
#line 2121 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp4_ = g_str_equal;
#line 2121 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp5_ = g_direct_equal;
#line 2121 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp6_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, TYPE_KEY_VALUE_MAP, (GBoxedCopyFunc) key_value_map_ref, key_value_map_unref, _tmp3_, _tmp4_, _tmp5_);
#line 2121 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_g_object_unref0 (self->priv->row.transformations);
#line 2121 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				self->priv->row.transformations = _tmp6_;
#line 16665 "Photo.c"
			}
#line 2123 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp7_ = self->priv->row;
#line 2123 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp8_ = _tmp7_.transformations;
#line 2123 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp9_ = trans;
#line 2123 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp10_ = key_value_map_get_group (_tmp9_);
#line 2123 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp11_ = _tmp10_;
#line 2123 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp12_ = trans;
#line 2123 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			gee_abstract_map_set (GEE_ABSTRACT_MAP (_tmp8_), _tmp11_, _tmp12_);
#line 2123 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_g_free0 (_tmp11_);
#line 2125 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp13_ = photo_table_get_instance ();
#line 2125 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp14_ = _tmp13_;
#line 2125 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp15_ = self->priv->row;
#line 2125 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp16_ = _tmp15_.photo_id;
#line 2125 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp17_ = trans;
#line 2125 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp18_ = photo_table_set_transformation (_tmp14_, &_tmp16_, _tmp17_);
#line 2125 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp19_ = _tmp18_;
#line 2125 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_database_table_unref0 (_tmp14_);
#line 2125 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			result = _tmp19_;
#line 16701 "Photo.c"
			{
				PhotoRow _tmp20_;
#line 2119 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp20_ = self->priv->row;
#line 2119 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 16708 "Photo.c"
			}
#line 2125 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			return result;
#line 16712 "Photo.c"
		}
		__finally201:
		{
			PhotoRow _tmp21_;
#line 2119 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp21_ = self->priv->row;
#line 2119 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 16721 "Photo.c"
		}
#line 2119 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2119 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 2119 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return FALSE;
#line 16729 "Photo.c"
	}
}


static gboolean photo_remove_transformation (Photo* self, const gchar* name) {
	gboolean result = FALSE;
	gboolean altered_cache = FALSE;
	gboolean altered_persistent = FALSE;
	gboolean _tmp18_ = FALSE;
	gboolean _tmp19_;
	gboolean _tmp20_;
	GError * _inner_error_ = NULL;
#line 2129 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 2129 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail (name != NULL, FALSE);
#line 16746 "Photo.c"
	{
		PhotoRow _tmp0_;
#line 2131 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp0_ = self->priv->row;
#line 2131 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 16753 "Photo.c"
		{
			PhotoRow _tmp1_;
			GeeHashMap* _tmp2_;
			PhotoTable* _tmp11_ = NULL;
			PhotoTable* _tmp12_;
			PhotoRow _tmp13_;
			PhotoID _tmp14_;
			const gchar* _tmp15_;
			gboolean _tmp16_ = FALSE;
#line 2132 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp1_ = self->priv->row;
#line 2132 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp2_ = _tmp1_.transformations;
#line 2132 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			if (_tmp2_ != NULL) {
#line 16769 "Photo.c"
				PhotoRow _tmp3_;
				GeeHashMap* _tmp4_;
				const gchar* _tmp5_;
				gboolean _tmp6_ = FALSE;
				PhotoRow _tmp7_;
				GeeHashMap* _tmp8_;
				gint _tmp9_;
				gint _tmp10_;
#line 2133 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp3_ = self->priv->row;
#line 2133 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp4_ = _tmp3_.transformations;
#line 2133 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp5_ = name;
#line 2133 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp6_ = gee_abstract_map_unset (GEE_ABSTRACT_MAP (_tmp4_), _tmp5_, NULL);
#line 2133 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				altered_cache = _tmp6_;
#line 2134 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp7_ = self->priv->row;
#line 2134 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp8_ = _tmp7_.transformations;
#line 2134 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp9_ = gee_abstract_map_get_size (GEE_MAP (_tmp8_));
#line 2134 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp10_ = _tmp9_;
#line 2134 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				if (_tmp10_ == 0) {
#line 2135 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_g_object_unref0 (self->priv->row.transformations);
#line 2135 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					self->priv->row.transformations = NULL;
#line 16802 "Photo.c"
				}
			} else {
#line 2137 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				altered_cache = FALSE;
#line 16807 "Photo.c"
			}
#line 2140 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp11_ = photo_table_get_instance ();
#line 2140 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp12_ = _tmp11_;
#line 2140 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp13_ = self->priv->row;
#line 2140 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp14_ = _tmp13_.photo_id;
#line 2140 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp15_ = name;
#line 2140 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp16_ = photo_table_remove_transformation (_tmp12_, &_tmp14_, _tmp15_);
#line 2140 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			altered_persistent = _tmp16_;
#line 2140 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_database_table_unref0 (_tmp12_);
#line 16825 "Photo.c"
		}
		__finally202:
		{
			PhotoRow _tmp17_;
#line 2131 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp17_ = self->priv->row;
#line 2131 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 16834 "Photo.c"
		}
#line 2131 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 2131 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2131 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 2131 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			return FALSE;
#line 16844 "Photo.c"
		}
	}
#line 2144 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp19_ = altered_cache;
#line 2144 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp19_) {
#line 2144 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp18_ = TRUE;
#line 16853 "Photo.c"
	} else {
#line 2144 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp18_ = altered_persistent;
#line 16857 "Photo.c"
	}
#line 2144 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp20_ = _tmp18_;
#line 2144 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	result = _tmp20_;
#line 2144 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return result;
#line 16865 "Photo.c"
}


gboolean photo_has_crop (Photo* self) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
#line 2147 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 2148 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp0_ = photo_has_transformation (self, "crop");
#line 2148 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	result = _tmp0_;
#line 2148 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return result;
#line 16880 "Photo.c"
}


static gboolean photo_get_raw_crop (Photo* self, Box* crop) {
	Box _vala_crop = {0};
	gboolean result = FALSE;
	KeyValueMap* _tmp0_ = NULL;
	KeyValueMap* map;
	KeyValueMap* _tmp1_;
	KeyValueMap* _tmp2_;
	gint _tmp3_ = 0;
	gint left;
	KeyValueMap* _tmp4_;
	gint _tmp5_ = 0;
	gint top;
	KeyValueMap* _tmp6_;
	gint _tmp7_ = 0;
	gint right;
	KeyValueMap* _tmp8_;
	gint _tmp9_ = 0;
	gint bottom;
	gboolean _tmp10_ = FALSE;
	gboolean _tmp11_ = FALSE;
	gboolean _tmp12_ = FALSE;
	gint _tmp13_;
	gboolean _tmp15_;
	gboolean _tmp17_;
	gboolean _tmp19_;
	gint _tmp20_;
	gint _tmp21_;
	gint _tmp22_;
	gint _tmp23_;
	Box _tmp24_ = {0};
#line 2152 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 2153 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp0_ = photo_get_transformation (self, "crop");
#line 2153 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	map = _tmp0_;
#line 2154 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp1_ = map;
#line 2154 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp1_ == NULL) {
#line 2155 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		result = FALSE;
#line 2155 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_key_value_map_unref0 (map);
#line 2155 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		if (crop) {
#line 2155 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			*crop = _vala_crop;
#line 16932 "Photo.c"
		}
#line 2155 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return result;
#line 16936 "Photo.c"
	}
#line 2157 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp2_ = map;
#line 2157 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp3_ = key_value_map_get_int (_tmp2_, "left", -1);
#line 2157 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	left = _tmp3_;
#line 2158 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp4_ = map;
#line 2158 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp5_ = key_value_map_get_int (_tmp4_, "top", -1);
#line 2158 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	top = _tmp5_;
#line 2159 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp6_ = map;
#line 2159 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp7_ = key_value_map_get_int (_tmp6_, "right", -1);
#line 2159 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	right = _tmp7_;
#line 2160 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp8_ = map;
#line 2160 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp9_ = key_value_map_get_int (_tmp8_, "bottom", -1);
#line 2160 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	bottom = _tmp9_;
#line 2162 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp13_ = left;
#line 2162 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp13_ == (-1)) {
#line 2162 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp12_ = TRUE;
#line 16968 "Photo.c"
	} else {
		gint _tmp14_;
#line 2162 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp14_ = top;
#line 2162 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp12_ = _tmp14_ == (-1);
#line 16975 "Photo.c"
	}
#line 2162 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp15_ = _tmp12_;
#line 2162 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp15_) {
#line 2162 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp11_ = TRUE;
#line 16983 "Photo.c"
	} else {
		gint _tmp16_;
#line 2162 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp16_ = right;
#line 2162 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp11_ = _tmp16_ == (-1);
#line 16990 "Photo.c"
	}
#line 2162 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp17_ = _tmp11_;
#line 2162 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp17_) {
#line 2162 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp10_ = TRUE;
#line 16998 "Photo.c"
	} else {
		gint _tmp18_;
#line 2162 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp18_ = bottom;
#line 2162 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp10_ = _tmp18_ == (-1);
#line 17005 "Photo.c"
	}
#line 2162 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp19_ = _tmp10_;
#line 2162 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp19_) {
#line 2163 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		result = FALSE;
#line 2163 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_key_value_map_unref0 (map);
#line 2163 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		if (crop) {
#line 2163 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			*crop = _vala_crop;
#line 17019 "Photo.c"
		}
#line 2163 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return result;
#line 17023 "Photo.c"
	}
#line 2165 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp20_ = left;
#line 2165 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp21_ = top;
#line 2165 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp22_ = right;
#line 2165 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp23_ = bottom;
#line 2165 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	box_init (&_tmp24_, _tmp20_, _tmp21_, _tmp22_, _tmp23_);
#line 2165 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_vala_crop = _tmp24_;
#line 2167 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	result = TRUE;
#line 2167 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_key_value_map_unref0 (map);
#line 2167 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (crop) {
#line 2167 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		*crop = _vala_crop;
#line 17045 "Photo.c"
	}
#line 2167 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return result;
#line 17049 "Photo.c"
}


static void photo_set_raw_crop (Photo* self, Box* crop) {
	KeyValueMap* _tmp0_;
	KeyValueMap* map;
	KeyValueMap* _tmp1_;
	Box _tmp2_;
	gint _tmp3_;
	KeyValueMap* _tmp4_;
	Box _tmp5_;
	gint _tmp6_;
	KeyValueMap* _tmp7_;
	Box _tmp8_;
	gint _tmp9_;
	KeyValueMap* _tmp10_;
	Box _tmp11_;
	gint _tmp12_;
	KeyValueMap* _tmp13_;
	gboolean _tmp14_ = FALSE;
#line 2171 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 2171 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail (crop != NULL);
#line 2172 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp0_ = key_value_map_new ("crop");
#line 2172 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	map = _tmp0_;
#line 2173 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp1_ = map;
#line 2173 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp2_ = *crop;
#line 2173 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp3_ = _tmp2_.left;
#line 2173 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	key_value_map_set_int (_tmp1_, "left", _tmp3_);
#line 2174 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp4_ = map;
#line 2174 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp5_ = *crop;
#line 2174 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp6_ = _tmp5_.top;
#line 2174 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	key_value_map_set_int (_tmp4_, "top", _tmp6_);
#line 2175 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp7_ = map;
#line 2175 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp8_ = *crop;
#line 2175 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp9_ = _tmp8_.right;
#line 2175 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	key_value_map_set_int (_tmp7_, "right", _tmp9_);
#line 2176 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp10_ = map;
#line 2176 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp11_ = *crop;
#line 2176 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp12_ = _tmp11_.bottom;
#line 2176 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	key_value_map_set_int (_tmp10_, "bottom", _tmp12_);
#line 2178 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp13_ = map;
#line 2178 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp14_ = photo_set_transformation (self, _tmp13_);
#line 2178 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp14_) {
#line 17116 "Photo.c"
		Alteration* _tmp15_;
		Alteration* _tmp16_;
#line 2179 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp15_ = alteration_new ("image", "crop");
#line 2179 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp16_ = _tmp15_;
#line 2179 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		data_object_notify_altered (DATA_OBJECT (self), _tmp16_);
#line 2179 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_alteration_unref0 (_tmp16_);
#line 17127 "Photo.c"
	}
#line 2171 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_key_value_map_unref0 (map);
#line 17131 "Photo.c"
}


static RedeyeInstance* photo_get_raw_redeye_instances (Photo* self, int* result_length1) {
	RedeyeInstance* result = NULL;
	KeyValueMap* _tmp0_ = NULL;
	KeyValueMap* map;
	KeyValueMap* _tmp1_;
	KeyValueMap* _tmp4_;
	gint _tmp5_ = 0;
	gint num_points;
	gint _tmp6_;
	gint _tmp7_;
	RedeyeInstance* _tmp8_ = NULL;
	RedeyeInstance* res;
	gint res_length1;
	gint _res_size_;
	GdkPoint _tmp9_ = {0};
	GdkPoint default_point;
	RedeyeInstance* _tmp48_;
	gint _tmp48__length1;
#line 2183 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 2184 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp0_ = photo_get_transformation (self, "redeye");
#line 2184 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	map = _tmp0_;
#line 2185 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp1_ = map;
#line 2185 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp1_ == NULL) {
#line 17163 "Photo.c"
		RedeyeInstance* _tmp2_ = NULL;
		RedeyeInstance* _tmp3_;
		gint _tmp3__length1;
#line 2186 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp2_ = g_new0 (RedeyeInstance, 0);
#line 2186 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp3_ = _tmp2_;
#line 2186 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp3__length1 = 0;
#line 2186 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		if (result_length1) {
#line 2186 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			*result_length1 = _tmp3__length1;
#line 17177 "Photo.c"
		}
#line 2186 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		result = _tmp3_;
#line 2186 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_key_value_map_unref0 (map);
#line 2186 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return result;
#line 17185 "Photo.c"
	}
#line 2188 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp4_ = map;
#line 2188 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp5_ = key_value_map_get_int (_tmp4_, "num_points", -1);
#line 2188 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	num_points = _tmp5_;
#line 2189 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp6_ = num_points;
#line 2189 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_assert (_tmp6_ > 0);
#line 2191 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp7_ = num_points;
#line 2191 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp8_ = g_new0 (RedeyeInstance, _tmp7_);
#line 2191 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	res = _tmp8_;
#line 2191 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	res_length1 = _tmp7_;
#line 2191 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_res_size_ = res_length1;
#line 2193 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp9_.x = 0;
#line 2193 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	default_point = _tmp9_;
#line 2194 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	default_point.x = -1;
#line 2195 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	default_point.y = -1;
#line 17215 "Photo.c"
	{
		gint i;
#line 2197 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		i = 0;
#line 17220 "Photo.c"
		{
			gboolean _tmp10_;
#line 2197 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp10_ = TRUE;
#line 2197 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			while (TRUE) {
#line 17227 "Photo.c"
				gboolean _tmp11_;
				gint _tmp13_;
				gint _tmp14_;
				gint _tmp15_;
				gchar* _tmp16_ = NULL;
				gchar* center_key;
				gint _tmp17_;
				gchar* _tmp18_ = NULL;
				gchar* radius_key;
				RedeyeInstance* _tmp19_;
				gint _tmp19__length1;
				gint _tmp20_;
				KeyValueMap* _tmp21_;
				const gchar* _tmp22_;
				GdkPoint _tmp23_;
				GdkPoint _tmp24_ = {0};
				RedeyeInstance* _tmp25_;
				gint _tmp25__length1;
				gint _tmp26_;
				RedeyeInstance _tmp27_;
				GdkPoint _tmp28_;
				gint _tmp29_;
				GdkPoint _tmp30_;
				gint _tmp31_;
				RedeyeInstance* _tmp32_;
				gint _tmp32__length1;
				gint _tmp33_;
				RedeyeInstance _tmp34_;
				GdkPoint _tmp35_;
				gint _tmp36_;
				GdkPoint _tmp37_;
				gint _tmp38_;
				RedeyeInstance* _tmp39_;
				gint _tmp39__length1;
				gint _tmp40_;
				KeyValueMap* _tmp41_;
				const gchar* _tmp42_;
				gint _tmp43_ = 0;
				RedeyeInstance* _tmp44_;
				gint _tmp44__length1;
				gint _tmp45_;
				RedeyeInstance _tmp46_;
				gint _tmp47_;
#line 2197 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp11_ = _tmp10_;
#line 2197 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				if (!_tmp11_) {
#line 17275 "Photo.c"
					gint _tmp12_;
#line 2197 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_tmp12_ = i;
#line 2197 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					i = _tmp12_ + 1;
#line 17281 "Photo.c"
				}
#line 2197 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp10_ = FALSE;
#line 2197 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp13_ = i;
#line 2197 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp14_ = num_points;
#line 2197 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				if (!(_tmp13_ < _tmp14_)) {
#line 2197 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					break;
#line 17293 "Photo.c"
				}
#line 2198 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp15_ = i;
#line 2198 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp16_ = g_strdup_printf ("center%d", _tmp15_);
#line 2198 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				center_key = _tmp16_;
#line 2199 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp17_ = i;
#line 2199 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp18_ = g_strdup_printf ("radius%d", _tmp17_);
#line 2199 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				radius_key = _tmp18_;
#line 2201 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp19_ = res;
#line 2201 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp19__length1 = res_length1;
#line 2201 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp20_ = i;
#line 2201 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp21_ = map;
#line 2201 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp22_ = center_key;
#line 2201 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp23_ = default_point;
#line 2201 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				key_value_map_get_point (_tmp21_, _tmp22_, &_tmp23_, &_tmp24_);
#line 2201 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp19_[_tmp20_].center = _tmp24_;
#line 2202 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp25_ = res;
#line 2202 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp25__length1 = res_length1;
#line 2202 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp26_ = i;
#line 2202 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp27_ = _tmp25_[_tmp26_];
#line 2202 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp28_ = _tmp27_.center;
#line 2202 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp29_ = _tmp28_.x;
#line 2202 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp30_ = default_point;
#line 2202 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp31_ = _tmp30_.x;
#line 2202 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				g_assert (_tmp29_ != _tmp31_);
#line 2203 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp32_ = res;
#line 2203 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp32__length1 = res_length1;
#line 2203 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp33_ = i;
#line 2203 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp34_ = _tmp32_[_tmp33_];
#line 2203 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp35_ = _tmp34_.center;
#line 2203 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp36_ = _tmp35_.y;
#line 2203 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp37_ = default_point;
#line 2203 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp38_ = _tmp37_.y;
#line 2203 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				g_assert (_tmp36_ != _tmp38_);
#line 2205 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp39_ = res;
#line 2205 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp39__length1 = res_length1;
#line 2205 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp40_ = i;
#line 2205 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp41_ = map;
#line 2205 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp42_ = radius_key;
#line 2205 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp43_ = key_value_map_get_int (_tmp41_, _tmp42_, -1);
#line 2205 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp39_[_tmp40_].radius = _tmp43_;
#line 2206 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp44_ = res;
#line 2206 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp44__length1 = res_length1;
#line 2206 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp45_ = i;
#line 2206 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp46_ = _tmp44_[_tmp45_];
#line 2206 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp47_ = _tmp46_.radius;
#line 2206 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				g_assert (_tmp47_ != (-1));
#line 2197 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_g_free0 (radius_key);
#line 2197 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_g_free0 (center_key);
#line 17389 "Photo.c"
			}
		}
	}
#line 2209 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp48_ = res;
#line 2209 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp48__length1 = res_length1;
#line 2209 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (result_length1) {
#line 2209 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		*result_length1 = _tmp48__length1;
#line 17401 "Photo.c"
	}
#line 2209 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	result = _tmp48_;
#line 2209 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_key_value_map_unref0 (map);
#line 2209 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return result;
#line 17409 "Photo.c"
}


gboolean photo_has_redeye_transformations (Photo* self) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
#line 2212 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 2213 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp0_ = photo_has_transformation (self, "redeye");
#line 2213 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	result = _tmp0_;
#line 2213 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return result;
#line 17424 "Photo.c"
}


static void photo_add_raw_redeye_instance (Photo* self, RedeyeInstance* redeye) {
	KeyValueMap* _tmp0_ = NULL;
	KeyValueMap* map;
	KeyValueMap* _tmp1_;
	KeyValueMap* _tmp4_;
	gint _tmp5_ = 0;
	gint num_points;
	gint _tmp6_;
	gint _tmp7_;
	gint _tmp8_;
	gchar* _tmp9_ = NULL;
	gchar* radius_key;
	gint _tmp10_;
	gchar* _tmp11_ = NULL;
	gchar* center_key;
	KeyValueMap* _tmp12_;
	const gchar* _tmp13_;
	RedeyeInstance _tmp14_;
	gint _tmp15_;
	KeyValueMap* _tmp16_;
	const gchar* _tmp17_;
	RedeyeInstance _tmp18_;
	GdkPoint _tmp19_;
	KeyValueMap* _tmp20_;
	gint _tmp21_;
	KeyValueMap* _tmp22_;
	gboolean _tmp23_ = FALSE;
#line 2217 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 2217 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail (redeye != NULL);
#line 2218 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp0_ = photo_get_transformation (self, "redeye");
#line 2218 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	map = _tmp0_;
#line 2219 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp1_ = map;
#line 2219 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp1_ == NULL) {
#line 17467 "Photo.c"
		KeyValueMap* _tmp2_;
		KeyValueMap* _tmp3_;
#line 2220 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp2_ = key_value_map_new ("redeye");
#line 2220 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_key_value_map_unref0 (map);
#line 2220 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		map = _tmp2_;
#line 2221 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp3_ = map;
#line 2221 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		key_value_map_set_int (_tmp3_, "num_points", 0);
#line 17480 "Photo.c"
	}
#line 2224 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp4_ = map;
#line 2224 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp5_ = key_value_map_get_int (_tmp4_, "num_points", -1);
#line 2224 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	num_points = _tmp5_;
#line 2225 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp6_ = num_points;
#line 2225 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_assert (_tmp6_ >= 0);
#line 2227 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp7_ = num_points;
#line 2227 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	num_points = _tmp7_ + 1;
#line 2229 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp8_ = num_points;
#line 2229 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp9_ = g_strdup_printf ("radius%d", _tmp8_ - 1);
#line 2229 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	radius_key = _tmp9_;
#line 2230 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp10_ = num_points;
#line 2230 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp11_ = g_strdup_printf ("center%d", _tmp10_ - 1);
#line 2230 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	center_key = _tmp11_;
#line 2232 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp12_ = map;
#line 2232 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp13_ = radius_key;
#line 2232 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp14_ = *redeye;
#line 2232 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp15_ = _tmp14_.radius;
#line 2232 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	key_value_map_set_int (_tmp12_, _tmp13_, _tmp15_);
#line 2233 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp16_ = map;
#line 2233 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp17_ = center_key;
#line 2233 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp18_ = *redeye;
#line 2233 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp19_ = _tmp18_.center;
#line 2233 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	key_value_map_set_point (_tmp16_, _tmp17_, &_tmp19_);
#line 2235 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp20_ = map;
#line 2235 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp21_ = num_points;
#line 2235 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	key_value_map_set_int (_tmp20_, "num_points", _tmp21_);
#line 2237 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp22_ = map;
#line 2237 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp23_ = photo_set_transformation (self, _tmp22_);
#line 2237 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp23_) {
#line 17540 "Photo.c"
		Alteration* _tmp24_;
		Alteration* _tmp25_;
#line 2238 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp24_ = alteration_new ("image", "redeye");
#line 2238 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp25_ = _tmp24_;
#line 2238 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		data_object_notify_altered (DATA_OBJECT (self), _tmp25_);
#line 2238 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_alteration_unref0 (_tmp25_);
#line 17551 "Photo.c"
	}
#line 2217 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_g_free0 (center_key);
#line 2217 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_g_free0 (radius_key);
#line 2217 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_key_value_map_unref0 (map);
#line 17559 "Photo.c"
}


static gboolean photo_calculate_pixbuf_dimensions (Photo* self, Scaling* scaling, PhotoException exceptions, Dimensions* scaled_image, Dimensions* scaled_to_viewport) {
	Dimensions _vala_scaled_image = {0};
	Dimensions _vala_scaled_to_viewport = {0};
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
#line 2252 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 2252 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail (scaling != NULL, FALSE);
#line 17572 "Photo.c"
	{
		PhotoRow _tmp0_;
#line 2254 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp0_ = self->priv->row;
#line 2254 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 17579 "Photo.c"
		{
			Scaling _tmp1_;
			PhotoException _tmp2_;
			Dimensions _tmp3_ = {0};
			Dimensions _tmp4_ = {0};
			gboolean _tmp5_ = FALSE;
#line 2256 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp1_ = *scaling;
#line 2256 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp2_ = exceptions;
#line 2256 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp5_ = photo_locked_calculate_pixbuf_dimensions (self, &_tmp1_, _tmp2_, &_tmp3_, &_tmp4_);
#line 2256 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_vala_scaled_image = _tmp3_;
#line 2256 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_vala_scaled_to_viewport = _tmp4_;
#line 2256 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			result = _tmp5_;
#line 17598 "Photo.c"
			{
				PhotoRow _tmp6_;
#line 2254 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp6_ = self->priv->row;
#line 2254 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 17605 "Photo.c"
			}
#line 2256 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			if (scaled_image) {
#line 2256 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				*scaled_image = _vala_scaled_image;
#line 17611 "Photo.c"
			}
#line 2256 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			if (scaled_to_viewport) {
#line 2256 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				*scaled_to_viewport = _vala_scaled_to_viewport;
#line 17617 "Photo.c"
			}
#line 2256 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			return result;
#line 17621 "Photo.c"
		}
		__finally203:
		{
			PhotoRow _tmp7_;
#line 2254 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp7_ = self->priv->row;
#line 2254 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 17630 "Photo.c"
		}
#line 2254 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2254 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 2254 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return FALSE;
#line 17638 "Photo.c"
	}
#line 2252 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (scaled_image) {
#line 2252 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		*scaled_image = _vala_scaled_image;
#line 17644 "Photo.c"
	}
#line 2252 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (scaled_to_viewport) {
#line 2252 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		*scaled_to_viewport = _vala_scaled_to_viewport;
#line 17650 "Photo.c"
	}
}


static gboolean photo_locked_calculate_pixbuf_dimensions (Photo* self, Scaling* scaling, PhotoException exceptions, Dimensions* scaled_image, Dimensions* scaled_to_viewport) {
	Dimensions _vala_scaled_image = {0};
	Dimensions _vala_scaled_to_viewport = {0};
	gboolean result = FALSE;
	Dimensions _tmp0_ = {0};
	Dimensions raw;
	gboolean _tmp1_ = FALSE;
	Orientation _tmp4_ = 0;
	Orientation orientation;
	Dimensions _tmp5_ = {0};
	Dimensions _tmp6_ = {0};
	PhotoException _tmp7_;
	gboolean _tmp8_ = FALSE;
	gboolean _tmp41_ = FALSE;
	gboolean _tmp56_ = FALSE;
	Dimensions _tmp57_;
	gint _tmp58_;
	Dimensions _tmp59_;
	gint _tmp60_;
	gboolean _tmp65_;
	gboolean _tmp67_ = FALSE;
	gboolean _tmp68_ = FALSE;
#line 2262 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 2262 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail (scaling != NULL, FALSE);
#line 2264 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	photo_get_raw_dimensions (self, &_tmp0_);
#line 2264 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	raw = _tmp0_;
#line 2266 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp1_ = scaling_is_unscaled (scaling);
#line 2266 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp1_) {
#line 17689 "Photo.c"
		Dimensions _tmp2_;
		Dimensions _tmp3_;
#line 2267 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp2_ = raw;
#line 2267 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_vala_scaled_image = _tmp2_;
#line 2268 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp3_ = raw;
#line 2268 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_vala_scaled_to_viewport = _tmp3_;
#line 2270 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		result = FALSE;
#line 2270 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		if (scaled_image) {
#line 2270 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			*scaled_image = _vala_scaled_image;
#line 17706 "Photo.c"
		}
#line 2270 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		if (scaled_to_viewport) {
#line 2270 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			*scaled_to_viewport = _vala_scaled_to_viewport;
#line 17712 "Photo.c"
		}
#line 2270 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return result;
#line 17716 "Photo.c"
	}
#line 2273 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp4_ = photo_get_orientation (self);
#line 2273 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	orientation = _tmp4_;
#line 2278 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	dimensions_init (&_tmp5_, 0, 0);
#line 2278 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_vala_scaled_image = _tmp5_;
#line 2279 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	dimensions_init (&_tmp6_, 0, 0);
#line 2279 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_vala_scaled_to_viewport = _tmp6_;
#line 2281 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp7_ = exceptions;
#line 2281 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp8_ = photo_exception_allows (_tmp7_, PHOTO_EXCEPTION_CROP);
#line 2281 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp8_) {
#line 17736 "Photo.c"
		Box crop = {0};
		Box _tmp9_ = {0};
		gboolean _tmp10_ = FALSE;
#line 2283 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp10_ = photo_get_raw_crop (self, &_tmp9_);
#line 2283 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		crop = _tmp9_;
#line 2283 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		if (_tmp10_) {
#line 17746 "Photo.c"
			Dimensions _tmp11_;
			Dimensions rotated_raw;
			PhotoException _tmp12_;
			gboolean _tmp13_ = FALSE;
			Dimensions _tmp21_ = {0};
			Dimensions _tmp22_ = {0};
			Box _tmp23_ = {0};
			Box scaled_crop;
			Dimensions _tmp24_ = {0};
			gboolean _tmp25_ = FALSE;
			gint _tmp26_ = 0;
			gint _tmp27_ = 0;
			gboolean _tmp30_;
			Dimensions _tmp33_ = {0};
			Dimensions _tmp34_ = {0};
			Dimensions _tmp35_ = {0};
			PhotoException _tmp36_;
			gboolean _tmp37_ = FALSE;
#line 2286 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp11_ = raw;
#line 2286 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			rotated_raw = _tmp11_;
#line 2287 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp12_ = exceptions;
#line 2287 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp13_ = photo_exception_allows (_tmp12_, PHOTO_EXCEPTION_ORIENTATION);
#line 2287 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			if (_tmp13_) {
#line 17775 "Photo.c"
				Orientation _tmp14_;
				Dimensions _tmp15_;
				Box _tmp16_;
				Box _tmp17_ = {0};
				Orientation _tmp18_;
				Dimensions _tmp19_;
				Dimensions _tmp20_ = {0};
#line 2288 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp14_ = orientation;
#line 2288 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp15_ = raw;
#line 2288 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp16_ = crop;
#line 2288 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				orientation_rotate_box (_tmp14_, &_tmp15_, &_tmp16_, &_tmp17_);
#line 2288 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				crop = _tmp17_;
#line 2289 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp18_ = orientation;
#line 2289 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp19_ = raw;
#line 2289 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				orientation_rotate_dimensions (_tmp18_, &_tmp19_, &_tmp20_);
#line 2289 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				rotated_raw = _tmp20_;
#line 17801 "Photo.c"
			}
#line 2293 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			box_get_dimensions (&crop, &_tmp21_);
#line 2293 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			scaling_get_scaled_dimensions (scaling, &_tmp21_, &_tmp22_);
#line 2293 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			box_get_scaled (&crop, &_tmp22_, &_tmp23_);
#line 2293 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			scaled_crop = _tmp23_;
#line 2296 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			box_get_dimensions (&scaled_crop, &_tmp24_);
#line 2296 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_vala_scaled_to_viewport = _tmp24_;
#line 2299 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp26_ = box_get_width (&crop);
#line 2299 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp27_ = box_get_width (&scaled_crop);
#line 2299 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			if (_tmp26_ <= _tmp27_) {
#line 17821 "Photo.c"
				gint _tmp28_ = 0;
				gint _tmp29_ = 0;
#line 2300 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp28_ = box_get_height (&crop);
#line 2300 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp29_ = box_get_height (&scaled_crop);
#line 2300 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp25_ = _tmp28_ <= _tmp29_;
#line 17830 "Photo.c"
			} else {
#line 2299 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp25_ = FALSE;
#line 17834 "Photo.c"
			}
#line 2299 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp30_ = _tmp25_;
#line 2299 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			if (_tmp30_) {
#line 17840 "Photo.c"
				Dimensions _tmp31_;
				Dimensions _tmp32_ = {0};
#line 2301 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp31_ = raw;
#line 2301 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_vala_scaled_image = _tmp31_;
#line 2302 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				box_get_dimensions (&crop, &_tmp32_);
#line 2302 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_vala_scaled_to_viewport = _tmp32_;
#line 2304 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				result = FALSE;
#line 2304 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				if (scaled_image) {
#line 2304 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					*scaled_image = _vala_scaled_image;
#line 17857 "Photo.c"
				}
#line 2304 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				if (scaled_to_viewport) {
#line 2304 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					*scaled_to_viewport = _vala_scaled_to_viewport;
#line 17863 "Photo.c"
				}
#line 2304 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				return result;
#line 17867 "Photo.c"
			}
#line 2309 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			box_get_dimensions (&crop, &_tmp33_);
#line 2309 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			box_get_dimensions (&scaled_crop, &_tmp34_);
#line 2309 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			dimensions_get_scaled_similar (&rotated_raw, &_tmp33_, &_tmp34_, &_tmp35_);
#line 2309 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_vala_scaled_image = _tmp35_;
#line 2313 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp36_ = exceptions;
#line 2313 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp37_ = photo_exception_allows (_tmp36_, PHOTO_EXCEPTION_ORIENTATION);
#line 2313 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			if (_tmp37_) {
#line 17883 "Photo.c"
				Orientation _tmp38_;
				Dimensions _tmp39_;
				Dimensions _tmp40_ = {0};
#line 2314 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp38_ = orientation;
#line 2314 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp39_ = _vala_scaled_image;
#line 2314 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				orientation_derotate_dimensions (_tmp38_, &_tmp39_, &_tmp40_);
#line 2314 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_vala_scaled_image = _tmp40_;
#line 17895 "Photo.c"
			}
		}
	}
#line 2319 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp41_ = dimensions_has_area (&_vala_scaled_image);
#line 2319 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (!_tmp41_) {
#line 17903 "Photo.c"
		Dimensions _tmp42_;
		Dimensions rotated_raw;
		PhotoException _tmp43_;
		gboolean _tmp44_ = FALSE;
		Dimensions _tmp48_;
		Dimensions _tmp49_ = {0};
		Dimensions _tmp50_;
		PhotoException _tmp51_;
		gboolean _tmp52_ = FALSE;
#line 2321 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp42_ = raw;
#line 2321 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		rotated_raw = _tmp42_;
#line 2322 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp43_ = exceptions;
#line 2322 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp44_ = photo_exception_allows (_tmp43_, PHOTO_EXCEPTION_ORIENTATION);
#line 2322 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		if (_tmp44_) {
#line 17923 "Photo.c"
			Orientation _tmp45_;
			Dimensions _tmp46_;
			Dimensions _tmp47_ = {0};
#line 2323 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp45_ = orientation;
#line 2323 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp46_ = raw;
#line 2323 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			orientation_rotate_dimensions (_tmp45_, &_tmp46_, &_tmp47_);
#line 2323 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			rotated_raw = _tmp47_;
#line 17935 "Photo.c"
		}
#line 2325 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp48_ = rotated_raw;
#line 2325 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		scaling_get_scaled_dimensions (scaling, &_tmp48_, &_tmp49_);
#line 2325 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_vala_scaled_image = _tmp49_;
#line 2326 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp50_ = _vala_scaled_image;
#line 2326 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_vala_scaled_to_viewport = _tmp50_;
#line 2329 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp51_ = exceptions;
#line 2329 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp52_ = photo_exception_allows (_tmp51_, PHOTO_EXCEPTION_ORIENTATION);
#line 2329 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		if (_tmp52_) {
#line 17953 "Photo.c"
			Orientation _tmp53_;
			Dimensions _tmp54_;
			Dimensions _tmp55_ = {0};
#line 2330 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp53_ = orientation;
#line 2330 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp54_ = _vala_scaled_image;
#line 2330 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			orientation_derotate_dimensions (_tmp53_, &_tmp54_, &_tmp55_);
#line 2330 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_vala_scaled_image = _tmp55_;
#line 17965 "Photo.c"
		}
	}
#line 2334 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp57_ = _vala_scaled_image;
#line 2334 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp58_ = _tmp57_.width;
#line 2334 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp59_ = raw;
#line 2334 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp60_ = _tmp59_.width;
#line 2334 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp58_ >= _tmp60_) {
#line 17978 "Photo.c"
		Dimensions _tmp61_;
		gint _tmp62_;
		Dimensions _tmp63_;
		gint _tmp64_;
#line 2334 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp61_ = _vala_scaled_image;
#line 2334 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp62_ = _tmp61_.height;
#line 2334 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp63_ = raw;
#line 2334 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp64_ = _tmp63_.height;
#line 2334 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp56_ = _tmp62_ >= _tmp64_;
#line 17993 "Photo.c"
	} else {
#line 2334 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp56_ = FALSE;
#line 17997 "Photo.c"
	}
#line 2334 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp65_ = _tmp56_;
#line 2334 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp65_) {
#line 18003 "Photo.c"
		Dimensions _tmp66_;
#line 2335 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp66_ = raw;
#line 2335 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_vala_scaled_image = _tmp66_;
#line 2337 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		result = FALSE;
#line 2337 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		if (scaled_image) {
#line 2337 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			*scaled_image = _vala_scaled_image;
#line 18015 "Photo.c"
		}
#line 2337 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		if (scaled_to_viewport) {
#line 2337 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			*scaled_to_viewport = _vala_scaled_to_viewport;
#line 18021 "Photo.c"
		}
#line 2337 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return result;
#line 18025 "Photo.c"
	}
#line 2340 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp67_ = dimensions_has_area (&_vala_scaled_image);
#line 2340 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_assert (_tmp67_);
#line 2341 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp68_ = dimensions_has_area (&_vala_scaled_to_viewport);
#line 2341 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_assert (_tmp68_);
#line 2343 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	result = TRUE;
#line 2343 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (scaled_image) {
#line 2343 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		*scaled_image = _vala_scaled_image;
#line 18041 "Photo.c"
	}
#line 2343 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (scaled_to_viewport) {
#line 2343 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		*scaled_to_viewport = _vala_scaled_to_viewport;
#line 18047 "Photo.c"
	}
#line 2343 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return result;
#line 18051 "Photo.c"
}


static GdkPixbuf* photo_load_raw_pixbuf (Photo* self, Scaling* scaling, PhotoException exceptions, BackingFetchMode fetch_mode, GError** error) {
	GdkPixbuf* result = NULL;
	BackingFetchMode _tmp0_;
	PhotoFileReader* _tmp1_ = NULL;
	PhotoFileReader* loader;
	gboolean _tmp2_ = FALSE;
	Dimensions scaled_image = {0};
	Dimensions scaled_to_viewport = {0};
	Scaling _tmp6_;
	PhotoException _tmp7_;
	Dimensions _tmp8_ = {0};
	Dimensions _tmp9_ = {0};
	gboolean _tmp10_ = FALSE;
	gboolean is_scaled;
	gboolean _tmp11_;
	PhotoFileReader* _tmp15_;
	Dimensions _tmp16_ = {0};
	Dimensions _tmp17_;
	GdkPixbuf* _tmp18_ = NULL;
	GdkPixbuf* pixbuf;
	GdkPixbuf* _tmp19_;
	Dimensions _tmp20_ = {0};
	gboolean _tmp21_ = FALSE;
	GError * _inner_error_ = NULL;
#line 2349 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 2349 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail (scaling != NULL, NULL);
#line 2352 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp0_ = fetch_mode;
#line 2352 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp1_ = photo_get_backing_reader (self, _tmp0_);
#line 2352 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	loader = _tmp1_;
#line 2355 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp2_ = scaling_is_unscaled (scaling);
#line 2355 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp2_) {
#line 18093 "Photo.c"
		PhotoFileReader* _tmp3_;
		GdkPixbuf* _tmp4_ = NULL;
		GdkPixbuf* _tmp5_;
#line 2360 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp3_ = loader;
#line 2360 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp4_ = photo_file_reader_unscaled_read (_tmp3_, &_inner_error_);
#line 2360 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp5_ = _tmp4_;
#line 2360 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 2360 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 2360 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_photo_file_adapter_unref0 (loader);
#line 2360 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			return NULL;
#line 18111 "Photo.c"
		}
#line 2360 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		result = _tmp5_;
#line 2360 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_photo_file_adapter_unref0 (loader);
#line 2360 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return result;
#line 18119 "Photo.c"
	}
#line 2365 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp6_ = *scaling;
#line 2365 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp7_ = exceptions;
#line 2365 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp10_ = photo_calculate_pixbuf_dimensions (self, &_tmp6_, _tmp7_, &_tmp8_, &_tmp9_);
#line 2365 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	scaled_image = _tmp8_;
#line 2365 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	scaled_to_viewport = _tmp9_;
#line 2365 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	is_scaled = _tmp10_;
#line 2367 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp11_ = is_scaled;
#line 2367 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (!_tmp11_) {
#line 18137 "Photo.c"
		PhotoFileReader* _tmp12_;
		GdkPixbuf* _tmp13_ = NULL;
		GdkPixbuf* _tmp14_;
#line 2372 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp12_ = loader;
#line 2372 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp13_ = photo_file_reader_unscaled_read (_tmp12_, &_inner_error_);
#line 2372 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp14_ = _tmp13_;
#line 2372 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 2372 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 2372 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_photo_file_adapter_unref0 (loader);
#line 2372 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			return NULL;
#line 18155 "Photo.c"
		}
#line 2372 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		result = _tmp14_;
#line 2372 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_photo_file_adapter_unref0 (loader);
#line 2372 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return result;
#line 18163 "Photo.c"
	}
#line 2375 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp15_ = loader;
#line 2375 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	photo_get_raw_dimensions (self, &_tmp16_);
#line 2375 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp17_ = scaled_image;
#line 2375 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp18_ = photo_file_reader_scaled_read (_tmp15_, &_tmp16_, &_tmp17_, &_inner_error_);
#line 2375 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	pixbuf = _tmp18_;
#line 2375 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 2375 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 2375 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_photo_file_adapter_unref0 (loader);
#line 2375 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return NULL;
#line 18183 "Photo.c"
	}
#line 2383 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp19_ = pixbuf;
#line 2383 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	dimensions_for_pixbuf (_tmp19_, &_tmp20_);
#line 2383 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp21_ = dimensions_approx_equals (&scaled_image, &_tmp20_, PHOTO_SCALING_FUDGE);
#line 2383 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_assert (_tmp21_);
#line 2385 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	result = pixbuf;
#line 2385 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_photo_file_adapter_unref0 (loader);
#line 2385 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return result;
#line 18199 "Photo.c"
}


GdkPixbuf* photo_get_master_pixbuf (Photo* self, Scaling* scaling, gboolean rotate, GError** error) {
	GdkPixbuf* result = NULL;
	Dimensions scaled_image = {0};
	Dimensions scaled_to_viewport = {0};
	Orientation original_orientation = 0;
	Scaling _tmp6_;
	GdkPixbuf* _tmp7_ = NULL;
	GdkPixbuf* pixbuf;
	gboolean _tmp8_;
	GError * _inner_error_ = NULL;
#line 2390 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 2390 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail (scaling != NULL, NULL);
#line 18217 "Photo.c"
	{
		PhotoRow _tmp0_;
#line 2402 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp0_ = self->priv->row;
#line 2402 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 18224 "Photo.c"
		{
			Scaling _tmp1_;
			Dimensions _tmp2_ = {0};
			Dimensions _tmp3_ = {0};
			Orientation _tmp4_ = 0;
#line 2403 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp1_ = *scaling;
#line 2403 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			photo_calculate_pixbuf_dimensions (self, &_tmp1_, PHOTO_EXCEPTION_NONE, &_tmp2_, &_tmp3_);
#line 2403 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			scaled_image = _tmp2_;
#line 2403 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			scaled_to_viewport = _tmp3_;
#line 2405 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp4_ = photo_get_original_orientation (self);
#line 2405 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			original_orientation = _tmp4_;
#line 18242 "Photo.c"
		}
		__finally204:
		{
			PhotoRow _tmp5_;
#line 2402 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp5_ = self->priv->row;
#line 2402 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 18251 "Photo.c"
		}
#line 2402 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 2402 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 2402 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			return NULL;
#line 18259 "Photo.c"
		}
	}
#line 2409 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp6_ = *scaling;
#line 2409 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp7_ = photo_load_raw_pixbuf (self, &_tmp6_, PHOTO_EXCEPTION_NONE, BACKING_FETCH_MODE_MASTER, &_inner_error_);
#line 2409 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	pixbuf = _tmp7_;
#line 2409 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 2409 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 2409 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return NULL;
#line 18274 "Photo.c"
	}
#line 2415 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp8_ = rotate;
#line 2415 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp8_) {
#line 18280 "Photo.c"
		GdkPixbuf* _tmp9_;
		GdkPixbuf* _tmp10_ = NULL;
#line 2416 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp9_ = pixbuf;
#line 2416 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp10_ = orientation_rotate_pixbuf (original_orientation, _tmp9_);
#line 2416 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_object_unref0 (pixbuf);
#line 2416 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		pixbuf = _tmp10_;
#line 18291 "Photo.c"
	}
#line 2424 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	result = pixbuf;
#line 2424 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return result;
#line 18297 "Photo.c"
}


static GdkPixbuf* photo_real_get_pixbuf (PhotoSource* base, Scaling* scaling, GError** error) {
	Photo * self;
	GdkPixbuf* result = NULL;
	Scaling _tmp0_;
	GdkPixbuf* _tmp1_ = NULL;
	GdkPixbuf* _tmp2_;
	GError * _inner_error_ = NULL;
#line 2427 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	self = PHOTO (base);
#line 2427 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail (scaling != NULL, NULL);
#line 2428 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp0_ = *scaling;
#line 2428 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp1_ = photo_get_pixbuf_with_options (self, &_tmp0_, PHOTO_EXCEPTION_NONE, BACKING_FETCH_MODE_BASELINE, &_inner_error_);
#line 2428 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp2_ = _tmp1_;
#line 2428 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 2428 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 2428 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return NULL;
#line 18324 "Photo.c"
	}
#line 2428 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	result = _tmp2_;
#line 2428 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return result;
#line 18330 "Photo.c"
}


GdkPixbuf* photo_get_pixbuf_with_options (Photo* self, Scaling* scaling, PhotoException exceptions, BackingFetchMode fetch_mode, GError** error) {
	GdkPixbuf* result = NULL;
	gboolean is_scaled = FALSE;
	gboolean is_cropped = FALSE;
	Dimensions scaled_image = {0};
	Dimensions scaled_to_viewport = {0};
	Dimensions original = {0};
	Dimensions scaled = {0};
	RedeyeInstance* redeye_instances;
	gint redeye_instances_length1;
	gint _redeye_instances_size_;
	Box crop = {0};
	PixelTransformer* transformer;
	Orientation orientation = 0;
	Scaling _tmp16_;
	PhotoException _tmp17_;
	BackingFetchMode _tmp18_;
	GdkPixbuf* _tmp19_ = NULL;
	GdkPixbuf* pixbuf;
	gboolean _tmp20_;
	PhotoException _tmp23_;
	gboolean _tmp24_ = FALSE;
	PhotoException _tmp46_;
	gboolean _tmp47_ = FALSE;
	PhotoException _tmp61_;
	gboolean _tmp62_ = FALSE;
	PhotoException _tmp66_;
	gboolean _tmp67_ = FALSE;
	gboolean _tmp70_;
	GError * _inner_error_ = NULL;
#line 2437 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 2437 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail (scaling != NULL, NULL);
#line 2449 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	dimensions_init (&original, 0, 0);
#line 2450 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	dimensions_init (&scaled, 0, 0);
#line 2451 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	redeye_instances = NULL;
#line 2451 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	redeye_instances_length1 = 0;
#line 2451 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_redeye_instances_size_ = redeye_instances_length1;
#line 2453 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	transformer = NULL;
#line 18380 "Photo.c"
	{
		PhotoRow _tmp0_;
#line 2456 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp0_ = self->priv->row;
#line 2456 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 18387 "Photo.c"
		{
			Scaling _tmp1_;
			PhotoException _tmp2_;
			Dimensions _tmp3_ = {0};
			Dimensions _tmp4_ = {0};
			gboolean _tmp5_ = FALSE;
			gboolean _tmp6_;
			gint _tmp8_ = 0;
			RedeyeInstance* _tmp9_ = NULL;
			Box _tmp10_ = {0};
			gboolean _tmp11_ = FALSE;
			gboolean _tmp12_ = FALSE;
			Orientation _tmp14_ = 0;
#line 2459 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp1_ = *scaling;
#line 2459 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp2_ = exceptions;
#line 2459 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp5_ = photo_calculate_pixbuf_dimensions (self, &_tmp1_, _tmp2_, &_tmp3_, &_tmp4_);
#line 2459 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			scaled_image = _tmp3_;
#line 2459 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			scaled_to_viewport = _tmp4_;
#line 2459 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			is_scaled = _tmp5_;
#line 2462 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp6_ = is_scaled;
#line 2462 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			if (_tmp6_) {
#line 18417 "Photo.c"
				Dimensions _tmp7_ = {0};
#line 2463 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				photo_get_raw_dimensions (self, &_tmp7_);
#line 2463 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				original = _tmp7_;
#line 18423 "Photo.c"
			}
#line 2465 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp9_ = photo_get_raw_redeye_instances (self, &_tmp8_);
#line 2465 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			redeye_instances = (g_free (redeye_instances), NULL);
#line 2465 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			redeye_instances = _tmp9_;
#line 2465 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			redeye_instances_length1 = _tmp8_;
#line 2465 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_redeye_instances_size_ = redeye_instances_length1;
#line 2467 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp11_ = photo_get_raw_crop (self, &_tmp10_);
#line 2467 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			crop = _tmp10_;
#line 2467 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			is_cropped = _tmp11_;
#line 2469 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp12_ = photo_has_color_adjustments (self);
#line 2469 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			if (_tmp12_) {
#line 18445 "Photo.c"
				PixelTransformer* _tmp13_ = NULL;
#line 2470 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp13_ = photo_get_pixel_transformer (self);
#line 2470 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_pixel_transformer_unref0 (transformer);
#line 2470 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				transformer = _tmp13_;
#line 18453 "Photo.c"
			}
#line 2472 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp14_ = photo_get_orientation (self);
#line 2472 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			orientation = _tmp14_;
#line 18459 "Photo.c"
		}
		__finally205:
		{
			PhotoRow _tmp15_;
#line 2456 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp15_ = self->priv->row;
#line 2456 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 18468 "Photo.c"
		}
#line 2456 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 2456 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 2456 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_pixel_transformer_unref0 (transformer);
#line 2456 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			redeye_instances = (g_free (redeye_instances), NULL);
#line 2456 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			return NULL;
#line 18480 "Photo.c"
		}
	}
#line 2479 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp16_ = *scaling;
#line 2479 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp17_ = exceptions;
#line 2479 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp18_ = fetch_mode;
#line 2479 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp19_ = photo_load_raw_pixbuf (self, &_tmp16_, _tmp17_, _tmp18_, &_inner_error_);
#line 2479 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	pixbuf = _tmp19_;
#line 2479 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 2479 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 2479 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_pixel_transformer_unref0 (transformer);
#line 2479 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		redeye_instances = (g_free (redeye_instances), NULL);
#line 2479 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return NULL;
#line 18503 "Photo.c"
	}
#line 2481 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp20_ = is_scaled;
#line 2481 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp20_) {
#line 18509 "Photo.c"
		GdkPixbuf* _tmp21_;
		Dimensions _tmp22_ = {0};
#line 2482 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp21_ = pixbuf;
#line 2482 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		dimensions_for_pixbuf (_tmp21_, &_tmp22_);
#line 2482 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		scaled = _tmp22_;
#line 18518 "Photo.c"
	}
#line 2489 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp23_ = exceptions;
#line 2489 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp24_ = photo_exception_allows (_tmp23_, PHOTO_EXCEPTION_REDEYE);
#line 2489 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp24_) {
#line 18526 "Photo.c"
		RedeyeInstance* _tmp25_;
		gint _tmp25__length1;
#line 2493 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp25_ = redeye_instances;
#line 2493 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp25__length1 = redeye_instances_length1;
#line 18533 "Photo.c"
		{
			RedeyeInstance* instance_collection = NULL;
			gint instance_collection_length1 = 0;
			gint _instance_collection_size_ = 0;
			gint instance_it = 0;
#line 2493 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			instance_collection = _tmp25_;
#line 2493 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			instance_collection_length1 = _tmp25__length1;
#line 2493 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			for (instance_it = 0; instance_it < _tmp25__length1; instance_it = instance_it + 1) {
#line 18545 "Photo.c"
				RedeyeInstance instance = {0};
#line 2493 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				instance = instance_collection[instance_it];
#line 18549 "Photo.c"
				{
					gboolean _tmp26_;
					GdkPixbuf* _tmp43_;
					RedeyeInstance _tmp44_;
					GdkPixbuf* _tmp45_ = NULL;
#line 2495 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_tmp26_ = is_scaled;
#line 2495 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					if (_tmp26_) {
#line 18559 "Photo.c"
						RedeyeInstance _tmp27_;
						GdkPoint _tmp28_;
						gint _tmp29_;
						RedeyeInstance _tmp30_;
						GdkPoint _tmp31_;
						gint _tmp32_;
						Dimensions _tmp33_;
						Dimensions _tmp34_;
						GdkPoint _tmp35_ = {0};
						RedeyeInstance _tmp36_;
						gint _tmp37_;
						Dimensions _tmp38_;
						Dimensions _tmp39_;
						gint _tmp40_ = 0;
						RedeyeInstance _tmp41_;
						gint _tmp42_;
#line 2496 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						_tmp27_ = instance;
#line 2496 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						_tmp28_ = _tmp27_.center;
#line 2496 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						_tmp29_ = _tmp28_.x;
#line 2496 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						_tmp30_ = instance;
#line 2496 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						_tmp31_ = _tmp30_.center;
#line 2496 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						_tmp32_ = _tmp31_.y;
#line 2496 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						_tmp33_ = original;
#line 2496 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						_tmp34_ = scaled;
#line 2496 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						coord_scaled_in_space (_tmp29_, _tmp32_, &_tmp33_, &_tmp34_, &_tmp35_);
#line 2496 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						instance.center = _tmp35_;
#line 2498 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						_tmp36_ = instance;
#line 2498 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						_tmp37_ = _tmp36_.radius;
#line 2498 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						_tmp38_ = original;
#line 2498 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						_tmp39_ = scaled;
#line 2498 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						_tmp40_ = radius_scaled_in_space (_tmp37_, &_tmp38_, &_tmp39_);
#line 2498 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						instance.radius = _tmp40_;
#line 2499 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						_tmp41_ = instance;
#line 2499 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						_tmp42_ = _tmp41_.radius;
#line 2499 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						g_assert (_tmp42_ != (-1));
#line 18614 "Photo.c"
					}
#line 2502 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_tmp43_ = pixbuf;
#line 2502 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_tmp44_ = instance;
#line 2502 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_tmp45_ = photo_do_redeye (self, _tmp43_, &_tmp44_);
#line 2502 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_g_object_unref0 (pixbuf);
#line 2502 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					pixbuf = _tmp45_;
#line 18626 "Photo.c"
				}
			}
		}
	}
#line 2510 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp46_ = exceptions;
#line 2510 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp47_ = photo_exception_allows (_tmp46_, PHOTO_EXCEPTION_CROP);
#line 2510 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp47_) {
#line 18637 "Photo.c"
		gboolean _tmp48_;
#line 2514 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp48_ = is_cropped;
#line 2514 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		if (_tmp48_) {
#line 18643 "Photo.c"
			gboolean _tmp49_;
			GdkPixbuf* _tmp53_;
			Box _tmp54_;
			gint _tmp55_;
			Box _tmp56_;
			gint _tmp57_;
			gint _tmp58_ = 0;
			gint _tmp59_ = 0;
			GdkPixbuf* _tmp60_;
#line 2518 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp49_ = is_scaled;
#line 2518 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			if (_tmp49_) {
#line 18657 "Photo.c"
				Dimensions _tmp50_;
				Dimensions _tmp51_;
				Box _tmp52_ = {0};
#line 2519 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp50_ = original;
#line 2519 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp51_ = scaled;
#line 2519 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				box_get_scaled_similar (&crop, &_tmp50_, &_tmp51_, &_tmp52_);
#line 2519 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				crop = _tmp52_;
#line 18669 "Photo.c"
			}
#line 2521 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp53_ = pixbuf;
#line 2521 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp54_ = crop;
#line 2521 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp55_ = _tmp54_.left;
#line 2521 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp56_ = crop;
#line 2521 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp57_ = _tmp56_.top;
#line 2521 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp58_ = box_get_width (&crop);
#line 2521 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp59_ = box_get_height (&crop);
#line 2521 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp60_ = gdk_pixbuf_new_subpixbuf (_tmp53_, _tmp55_, _tmp57_, _tmp58_, _tmp59_);
#line 2521 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_g_object_unref0 (pixbuf);
#line 2521 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			pixbuf = _tmp60_;
#line 18691 "Photo.c"
		}
	}
#line 2531 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp61_ = exceptions;
#line 2531 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp62_ = photo_exception_allows (_tmp61_, PHOTO_EXCEPTION_ADJUST);
#line 2531 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp62_) {
#line 18700 "Photo.c"
		PixelTransformer* _tmp63_;
#line 2535 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp63_ = transformer;
#line 2535 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		if (_tmp63_ != NULL) {
#line 18706 "Photo.c"
			PixelTransformer* _tmp64_;
			GdkPixbuf* _tmp65_;
#line 2536 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp64_ = transformer;
#line 2536 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp65_ = pixbuf;
#line 2536 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			pixel_transformer_transform_pixbuf (_tmp64_, _tmp65_, NULL);
#line 18715 "Photo.c"
		}
	}
#line 2543 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp66_ = exceptions;
#line 2543 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp67_ = photo_exception_allows (_tmp66_, PHOTO_EXCEPTION_ORIENTATION);
#line 2543 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp67_) {
#line 18724 "Photo.c"
		GdkPixbuf* _tmp68_;
		GdkPixbuf* _tmp69_ = NULL;
#line 2547 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp68_ = pixbuf;
#line 2547 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp69_ = orientation_rotate_pixbuf (orientation, _tmp68_);
#line 2547 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_object_unref0 (pixbuf);
#line 2547 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		pixbuf = _tmp69_;
#line 18735 "Photo.c"
	}
#line 2556 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp70_ = is_scaled;
#line 2556 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp70_) {
#line 18741 "Photo.c"
		GdkPixbuf* _tmp71_;
		Dimensions _tmp72_ = {0};
		gboolean _tmp73_ = FALSE;
#line 2557 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp71_ = pixbuf;
#line 2557 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		dimensions_for_pixbuf (_tmp71_, &_tmp72_);
#line 2557 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp73_ = dimensions_approx_equals (&scaled_to_viewport, &_tmp72_, PHOTO_SCALING_FUDGE);
#line 2557 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_assert (_tmp73_);
#line 18753 "Photo.c"
	}
#line 2565 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	result = pixbuf;
#line 2565 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_pixel_transformer_unref0 (transformer);
#line 2565 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	redeye_instances = (g_free (redeye_instances), NULL);
#line 2565 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return result;
#line 18763 "Photo.c"
}


static gboolean photo_real_has_user_generated_metadata (Photo* self) {
#line 2572 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_critical ("Type `%s' does not implement abstract method `photo_has_user_generated_metadata'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 2572 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return FALSE;
#line 18772 "Photo.c"
}


gboolean photo_has_user_generated_metadata (Photo* self) {
#line 2572 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 2572 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return PHOTO_GET_CLASS (self)->has_user_generated_metadata (self);
#line 18781 "Photo.c"
}


static void photo_real_set_user_metadata_for_export (Photo* self, PhotoMetadata* metadata) {
#line 2576 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_critical ("Type `%s' does not implement abstract method `photo_set_user_metadata_for_export'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 2576 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return;
#line 18790 "Photo.c"
}


void photo_set_user_metadata_for_export (Photo* self, PhotoMetadata* metadata) {
#line 2576 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 2576 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	PHOTO_GET_CLASS (self)->set_user_metadata_for_export (self, metadata);
#line 18799 "Photo.c"
}


gchar* photo_get_export_basename (Photo* self, PhotoFileFormat* file_format) {
	gchar* result = NULL;
	PhotoFileFormat* _tmp0_;
#line 2583 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 2584 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp0_ = file_format;
#line 2584 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp0_ != NULL) {
#line 18812 "Photo.c"
		PhotoFileFormat* _tmp1_;
		PhotoFileFormatProperties* _tmp2_ = NULL;
		PhotoFileFormatProperties* _tmp3_;
		GFile* _tmp4_ = NULL;
		GFile* _tmp5_;
		GFile* _tmp6_ = NULL;
		GFile* _tmp7_;
		gchar* _tmp8_ = NULL;
		gchar* _tmp9_;
#line 2585 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp1_ = file_format;
#line 2585 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp2_ = photo_file_format_get_properties (*_tmp1_);
#line 2585 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp3_ = _tmp2_;
#line 2585 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp4_ = media_source_get_master_file (MEDIA_SOURCE (self));
#line 2585 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp5_ = _tmp4_;
#line 2585 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp6_ = photo_file_format_properties_convert_file_extension (_tmp3_, _tmp5_);
#line 2585 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp7_ = _tmp6_;
#line 2585 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp8_ = g_file_get_basename (_tmp7_);
#line 2585 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp9_ = _tmp8_;
#line 2585 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_object_unref0 (_tmp7_);
#line 2585 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_object_unref0 (_tmp5_);
#line 2585 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_photo_file_format_properties_unref0 (_tmp3_);
#line 2585 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		result = _tmp9_;
#line 2585 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return result;
#line 18850 "Photo.c"
	} else {
		PhotoFileFormat _tmp10_ = 0;
		gboolean _tmp11_ = FALSE;
#line 2587 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp10_ = photo_get_file_format (self);
#line 2587 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp11_ = photo_file_format_can_write (_tmp10_);
#line 2587 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		if (_tmp11_) {
#line 18860 "Photo.c"
			PhotoFileFormat _tmp12_ = 0;
			PhotoFileFormatProperties* _tmp13_ = NULL;
			PhotoFileFormatProperties* _tmp14_;
			GFile* _tmp15_ = NULL;
			GFile* _tmp16_;
			GFile* _tmp17_ = NULL;
			GFile* _tmp18_;
			gchar* _tmp19_ = NULL;
			gchar* _tmp20_;
#line 2588 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp12_ = photo_get_file_format (self);
#line 2588 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp13_ = photo_file_format_get_properties (_tmp12_);
#line 2588 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp14_ = _tmp13_;
#line 2588 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp15_ = media_source_get_master_file (MEDIA_SOURCE (self));
#line 2588 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp16_ = _tmp15_;
#line 2588 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp17_ = photo_file_format_properties_convert_file_extension (_tmp14_, _tmp16_);
#line 2588 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp18_ = _tmp17_;
#line 2588 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp19_ = g_file_get_basename (_tmp18_);
#line 2588 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp20_ = _tmp19_;
#line 2588 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_g_object_unref0 (_tmp18_);
#line 2588 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_g_object_unref0 (_tmp16_);
#line 2588 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_photo_file_format_properties_unref0 (_tmp14_);
#line 2588 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			result = _tmp20_;
#line 2588 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			return result;
#line 18898 "Photo.c"
		} else {
			PhotoFileFormat _tmp21_ = 0;
			PhotoFileFormatProperties* _tmp22_ = NULL;
			PhotoFileFormatProperties* _tmp23_;
			GFile* _tmp24_ = NULL;
			GFile* _tmp25_;
			GFile* _tmp26_ = NULL;
			GFile* _tmp27_;
			gchar* _tmp28_ = NULL;
			gchar* _tmp29_;
#line 2591 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp21_ = photo_file_format_get_system_default_format ();
#line 2591 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp22_ = photo_file_format_get_properties (_tmp21_);
#line 2591 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp23_ = _tmp22_;
#line 2591 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp24_ = media_source_get_master_file (MEDIA_SOURCE (self));
#line 2591 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp25_ = _tmp24_;
#line 2591 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp26_ = photo_file_format_properties_convert_file_extension (_tmp23_, _tmp25_);
#line 2591 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp27_ = _tmp26_;
#line 2591 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp28_ = g_file_get_basename (_tmp27_);
#line 2591 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp29_ = _tmp28_;
#line 2591 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_g_object_unref0 (_tmp27_);
#line 2591 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_g_object_unref0 (_tmp25_);
#line 2591 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_photo_file_format_properties_unref0 (_tmp23_);
#line 2591 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			result = _tmp29_;
#line 2591 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			return result;
#line 18937 "Photo.c"
		}
	}
}


static gboolean photo_export_fullsized_backing (Photo* self, GFile* file, GError** error) {
	gboolean result = FALSE;
	PhotoFileReader* export_reader;
	gboolean is_master;
	PhotoFileReader* _tmp31_;
	PhotoFileReader* _tmp32_;
	PhotoFileFormat _tmp33_ = 0;
	PhotoFileFormatProperties* _tmp34_ = NULL;
	PhotoFileFormatProperties* format_properties;
	PhotoFileFormatProperties* _tmp35_;
	GFile* _tmp36_;
	GFile* _tmp37_ = NULL;
	GFile* dest_file;
	PhotoFileReader* _tmp38_;
	PhotoFileFormat _tmp39_ = 0;
	GFile* _tmp40_;
	gchar* _tmp41_ = NULL;
	gchar* _tmp42_;
	PhotoFileMetadataWriter* _tmp43_ = NULL;
	PhotoFileMetadataWriter* _tmp44_;
	PhotoFileMetadataWriter* writer;
	gchar* _tmp45_ = NULL;
	gchar* _tmp46_;
	PhotoFileMetadataWriter* _tmp47_;
	gchar* _tmp48_ = NULL;
	gchar* _tmp49_;
	PhotoFileReader* _tmp50_;
	GFile* _tmp51_ = NULL;
	GFile* _tmp52_;
	GFile* _tmp53_;
	gboolean _tmp54_ = FALSE;
	gboolean _tmp55_ = FALSE;
	gboolean _tmp56_ = FALSE;
	gboolean _tmp57_ = FALSE;
	gboolean _tmp59_;
	gboolean _tmp61_;
	gboolean _tmp64_;
	PhotoFileReader* _tmp65_;
	PhotoMetadata* _tmp66_ = NULL;
	PhotoMetadata* metadata;
	PhotoMetadata* _tmp67_;
	PhotoFileMetadataWriter* _tmp71_;
	gchar* _tmp72_ = NULL;
	gchar* _tmp73_;
	time_t _tmp74_ = 0;
	PhotoMetadata* _tmp80_;
	gchar* _tmp81_ = NULL;
	gchar* _tmp82_;
	PhotoMetadata* _tmp83_;
	Dimensions _tmp84_ = {0};
	PhotoMetadata* _tmp85_;
	Orientation _tmp86_ = 0;
	PhotoMetadata* _tmp87_;
	Orientation _tmp88_ = 0;
	Orientation _tmp89_ = 0;
	PhotoMetadata* _tmp91_;
	PhotoFileMetadataWriter* _tmp92_;
	PhotoMetadata* _tmp93_;
	GError * _inner_error_ = NULL;
#line 2597 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 2597 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail (G_IS_FILE (file), FALSE);
#line 2600 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	export_reader = NULL;
#line 2601 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	is_master = TRUE;
#line 19010 "Photo.c"
	{
		PhotoBackingReaders _tmp0_;
#line 2602 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 2602 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_readers);
#line 19017 "Photo.c"
		{
			gboolean _tmp1_ = FALSE;
			PhotoBackingReaders _tmp2_;
			PhotoFileReader* _tmp3_;
			gboolean _tmp8_;
#line 2603 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp2_ = self->priv->readers;
#line 2603 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp3_ = _tmp2_.editable;
#line 2603 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			if (_tmp3_ != NULL) {
#line 19029 "Photo.c"
				PhotoBackingReaders _tmp4_;
				PhotoFileReader* _tmp5_;
				PhotoFileFormat _tmp6_ = 0;
				gboolean _tmp7_ = FALSE;
#line 2603 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp4_ = self->priv->readers;
#line 2603 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp5_ = _tmp4_.editable;
#line 2603 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp6_ = photo_file_adapter_get_file_format (PHOTO_FILE_ADAPTER (_tmp5_));
#line 2603 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp7_ = photo_file_format_can_write_metadata (_tmp6_);
#line 2603 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp1_ = _tmp7_;
#line 19044 "Photo.c"
			} else {
#line 2603 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp1_ = FALSE;
#line 19048 "Photo.c"
			}
#line 2603 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp8_ = _tmp1_;
#line 2603 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			if (_tmp8_) {
#line 19054 "Photo.c"
				PhotoBackingReaders _tmp9_;
				PhotoFileReader* _tmp10_;
				PhotoFileReader* _tmp11_;
#line 2604 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp9_ = self->priv->readers;
#line 2604 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp10_ = _tmp9_.editable;
#line 2604 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp11_ = _photo_file_adapter_ref0 (_tmp10_);
#line 2604 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_photo_file_adapter_unref0 (export_reader);
#line 2604 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				export_reader = _tmp11_;
#line 2605 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				is_master = FALSE;
#line 19070 "Photo.c"
			} else {
				PhotoBackingReaders _tmp12_;
				PhotoFileReader* _tmp13_;
				PhotoFileFormat _tmp14_ = 0;
				gboolean _tmp15_ = FALSE;
#line 2606 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp12_ = self->priv->readers;
#line 2606 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp13_ = _tmp12_.master;
#line 2606 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp14_ = photo_file_adapter_get_file_format (PHOTO_FILE_ADAPTER (_tmp13_));
#line 2606 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp15_ = photo_file_format_can_write_metadata (_tmp14_);
#line 2606 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				if (_tmp15_) {
#line 19086 "Photo.c"
					PhotoBackingReaders _tmp16_;
					PhotoFileReader* _tmp17_;
					PhotoFileReader* _tmp18_;
#line 2607 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_tmp16_ = self->priv->readers;
#line 2607 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_tmp17_ = _tmp16_.master;
#line 2607 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_tmp18_ = _photo_file_adapter_ref0 (_tmp17_);
#line 2607 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_photo_file_adapter_unref0 (export_reader);
#line 2607 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					export_reader = _tmp18_;
#line 19100 "Photo.c"
				} else {
					gboolean _tmp19_ = FALSE;
					PhotoBackingReaders _tmp20_;
					PhotoFileReader* _tmp21_;
					gboolean _tmp26_;
#line 2608 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_tmp20_ = self->priv->readers;
#line 2608 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_tmp21_ = _tmp20_.mimic;
#line 2608 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					if (_tmp21_ != NULL) {
#line 19112 "Photo.c"
						PhotoBackingReaders _tmp22_;
						PhotoFileReader* _tmp23_;
						PhotoFileFormat _tmp24_ = 0;
						gboolean _tmp25_ = FALSE;
#line 2608 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						_tmp22_ = self->priv->readers;
#line 2608 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						_tmp23_ = _tmp22_.mimic;
#line 2608 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						_tmp24_ = photo_file_adapter_get_file_format (PHOTO_FILE_ADAPTER (_tmp23_));
#line 2608 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						_tmp25_ = photo_file_format_can_write_metadata (_tmp24_);
#line 2608 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						_tmp19_ = _tmp25_;
#line 19127 "Photo.c"
					} else {
#line 2608 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						_tmp19_ = FALSE;
#line 19131 "Photo.c"
					}
#line 2608 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_tmp26_ = _tmp19_;
#line 2608 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					if (_tmp26_) {
#line 19137 "Photo.c"
						PhotoBackingReaders _tmp27_;
						PhotoFileReader* _tmp28_;
						PhotoFileReader* _tmp29_;
#line 2609 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						_tmp27_ = self->priv->readers;
#line 2609 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						_tmp28_ = _tmp27_.mimic;
#line 2609 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						_tmp29_ = _photo_file_adapter_ref0 (_tmp28_);
#line 2609 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						_photo_file_adapter_unref0 (export_reader);
#line 2609 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						export_reader = _tmp29_;
#line 2610 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						is_master = FALSE;
#line 19153 "Photo.c"
					}
				}
			}
		}
		__finally206:
		{
			PhotoBackingReaders _tmp30_;
#line 2602 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp30_ = self->priv->readers;
#line 2602 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_readers);
#line 19165 "Photo.c"
		}
#line 2602 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 2602 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 2602 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_photo_file_adapter_unref0 (export_reader);
#line 2602 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			return FALSE;
#line 19175 "Photo.c"
		}
	}
#line 2614 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp31_ = export_reader;
#line 2614 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp31_ == NULL) {
#line 2615 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		result = FALSE;
#line 2615 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_photo_file_adapter_unref0 (export_reader);
#line 2615 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return result;
#line 19188 "Photo.c"
	}
#line 2617 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp32_ = export_reader;
#line 2617 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp33_ = photo_file_adapter_get_file_format (PHOTO_FILE_ADAPTER (_tmp32_));
#line 2617 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp34_ = photo_file_format_get_properties (_tmp33_);
#line 2617 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	format_properties = _tmp34_;
#line 2620 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp35_ = format_properties;
#line 2620 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp36_ = file;
#line 2620 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp37_ = photo_file_format_properties_convert_file_extension (_tmp35_, _tmp36_);
#line 2620 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	dest_file = _tmp37_;
#line 2623 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp38_ = export_reader;
#line 2623 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp39_ = photo_file_adapter_get_file_format (PHOTO_FILE_ADAPTER (_tmp38_));
#line 2623 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp40_ = dest_file;
#line 2623 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp41_ = g_file_get_path (_tmp40_);
#line 2623 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp42_ = _tmp41_;
#line 2623 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp43_ = photo_file_format_create_metadata_writer (_tmp39_, _tmp42_, &_inner_error_);
#line 2623 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp44_ = _tmp43_;
#line 2623 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_g_free0 (_tmp42_);
#line 2623 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	writer = _tmp44_;
#line 2623 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 2623 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 2623 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_object_unref0 (dest_file);
#line 2623 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_photo_file_format_properties_unref0 (format_properties);
#line 2623 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_photo_file_adapter_unref0 (export_reader);
#line 2623 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return FALSE;
#line 19236 "Photo.c"
	}
#line 2626 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp45_ = data_object_to_string (DATA_OBJECT (self));
#line 2626 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp46_ = _tmp45_;
#line 2626 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp47_ = writer;
#line 2626 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp48_ = photo_file_adapter_get_filepath (PHOTO_FILE_ADAPTER (_tmp47_));
#line 2626 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp49_ = _tmp48_;
#line 2626 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_debug ("Photo.vala:2626: Exporting full-sized copy of %s to %s", _tmp46_, _tmp49_);
#line 2626 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_g_free0 (_tmp49_);
#line 2626 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_g_free0 (_tmp46_);
#line 2628 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp50_ = export_reader;
#line 2628 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp51_ = photo_file_adapter_get_file (PHOTO_FILE_ADAPTER (_tmp50_));
#line 2628 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp52_ = _tmp51_;
#line 2628 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp53_ = dest_file;
#line 2628 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_file_copy (_tmp52_, _tmp53_, G_FILE_COPY_OVERWRITE | G_FILE_COPY_TARGET_DEFAULT_PERMS, NULL, NULL, NULL, &_inner_error_);
#line 2628 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_g_object_unref0 (_tmp52_);
#line 2628 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 2628 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 2628 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_photo_file_adapter_unref0 (writer);
#line 2628 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_object_unref0 (dest_file);
#line 2628 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_photo_file_format_properties_unref0 (format_properties);
#line 2628 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_photo_file_adapter_unref0 (export_reader);
#line 2628 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return FALSE;
#line 19280 "Photo.c"
	}
#line 2633 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp57_ = photo_has_alterations (self);
#line 2633 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (!_tmp57_) {
#line 19286 "Photo.c"
		gboolean _tmp58_;
#line 2633 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp58_ = is_master;
#line 2633 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp56_ = _tmp58_;
#line 19292 "Photo.c"
	} else {
#line 2633 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp56_ = FALSE;
#line 19296 "Photo.c"
	}
#line 2633 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp59_ = _tmp56_;
#line 2633 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp59_) {
#line 19302 "Photo.c"
		gboolean _tmp60_ = FALSE;
#line 2633 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp60_ = photo_has_user_generated_metadata (self);
#line 2633 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp55_ = !_tmp60_;
#line 19308 "Photo.c"
	} else {
#line 2633 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp55_ = FALSE;
#line 19312 "Photo.c"
	}
#line 2633 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp61_ = _tmp55_;
#line 2633 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp61_) {
#line 19318 "Photo.c"
		gchar* _tmp62_ = NULL;
		gchar* _tmp63_;
#line 2633 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp62_ = media_source_get_title (MEDIA_SOURCE (self));
#line 2633 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp63_ = _tmp62_;
#line 2633 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp54_ = _tmp63_ == NULL;
#line 2633 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_free0 (_tmp63_);
#line 19329 "Photo.c"
	} else {
#line 2633 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp54_ = FALSE;
#line 19333 "Photo.c"
	}
#line 2633 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp64_ = _tmp54_;
#line 2633 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp64_) {
#line 2634 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		result = TRUE;
#line 2634 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_photo_file_adapter_unref0 (writer);
#line 2634 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_object_unref0 (dest_file);
#line 2634 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_photo_file_format_properties_unref0 (format_properties);
#line 2634 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_photo_file_adapter_unref0 (export_reader);
#line 2634 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return result;
#line 19351 "Photo.c"
	}
#line 2637 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp65_ = export_reader;
#line 2637 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp66_ = photo_file_reader_read_metadata (_tmp65_, &_inner_error_);
#line 2637 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	metadata = _tmp66_;
#line 2637 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 2637 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 2637 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_photo_file_adapter_unref0 (writer);
#line 2637 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_object_unref0 (dest_file);
#line 2637 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_photo_file_format_properties_unref0 (format_properties);
#line 2637 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_photo_file_adapter_unref0 (export_reader);
#line 2637 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return FALSE;
#line 19373 "Photo.c"
	}
#line 2638 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp67_ = metadata;
#line 2638 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp67_ == NULL) {
#line 19379 "Photo.c"
		PhotoFileReader* _tmp68_;
		PhotoFileFormat _tmp69_ = 0;
		PhotoMetadata* _tmp70_ = NULL;
#line 2639 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp68_ = export_reader;
#line 2639 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp69_ = photo_file_adapter_get_file_format (PHOTO_FILE_ADAPTER (_tmp68_));
#line 2639 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp70_ = photo_file_format_create_metadata (_tmp69_);
#line 2639 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 2639 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		metadata = _tmp70_;
#line 19393 "Photo.c"
	}
#line 2641 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp71_ = writer;
#line 2641 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp72_ = photo_file_adapter_get_filepath (PHOTO_FILE_ADAPTER (_tmp71_));
#line 2641 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp73_ = _tmp72_;
#line 2641 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_debug ("Photo.vala:2641: Updating metadata of %s", _tmp73_);
#line 2641 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_g_free0 (_tmp73_);
#line 2643 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp74_ = media_source_get_exposure_time (MEDIA_SOURCE (self));
#line 2643 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp74_ != ((time_t) 0)) {
#line 19409 "Photo.c"
		PhotoMetadata* _tmp75_;
		time_t _tmp76_ = 0;
		MetadataDateTime* _tmp77_;
		MetadataDateTime* _tmp78_;
#line 2644 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp75_ = metadata;
#line 2644 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp76_ = media_source_get_exposure_time (MEDIA_SOURCE (self));
#line 2644 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp77_ = metadata_date_time_new (_tmp76_);
#line 2644 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp78_ = _tmp77_;
#line 2644 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		photo_metadata_set_exposure_date_time (_tmp75_, _tmp78_, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 2644 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_metadata_date_time_unref0 (_tmp78_);
#line 19426 "Photo.c"
	} else {
		PhotoMetadata* _tmp79_;
#line 2646 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp79_ = metadata;
#line 2646 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		photo_metadata_set_exposure_date_time (_tmp79_, NULL, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 19433 "Photo.c"
	}
#line 2648 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp80_ = metadata;
#line 2648 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp81_ = media_source_get_title (MEDIA_SOURCE (self));
#line 2648 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp82_ = _tmp81_;
#line 2648 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	photo_metadata_set_title (_tmp80_, _tmp82_, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 2648 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_g_free0 (_tmp82_);
#line 2649 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp83_ = metadata;
#line 2649 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	media_source_get_dimensions (MEDIA_SOURCE (self), &_tmp84_);
#line 2649 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	photo_metadata_set_pixel_dimensions (_tmp83_, &_tmp84_, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 2650 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp85_ = metadata;
#line 2650 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp86_ = photo_get_orientation (self);
#line 2650 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	photo_metadata_set_orientation (_tmp85_, _tmp86_);
#line 2651 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp87_ = metadata;
#line 2651 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	photo_metadata_set_software (_tmp87_, RESOURCES_APP_TITLE, RESOURCES_APP_VERSION);
#line 2653 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp88_ = photo_get_orientation (self);
#line 2653 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp89_ = photo_get_original_orientation (self);
#line 2653 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp88_ != _tmp89_) {
#line 19467 "Photo.c"
		PhotoMetadata* _tmp90_;
#line 2654 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp90_ = metadata;
#line 2654 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		photo_metadata_remove_exif_thumbnail (_tmp90_);
#line 19473 "Photo.c"
	}
#line 2656 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp91_ = metadata;
#line 2656 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	photo_set_user_metadata_for_export (self, _tmp91_);
#line 2658 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp92_ = writer;
#line 2658 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp93_ = metadata;
#line 2658 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	photo_file_metadata_writer_write_metadata (_tmp92_, _tmp93_, &_inner_error_);
#line 2658 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 2658 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 2658 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 2658 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_photo_file_adapter_unref0 (writer);
#line 2658 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_object_unref0 (dest_file);
#line 2658 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_photo_file_format_properties_unref0 (format_properties);
#line 2658 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_photo_file_adapter_unref0 (export_reader);
#line 2658 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return FALSE;
#line 19501 "Photo.c"
	}
#line 2660 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	result = TRUE;
#line 2660 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_media_metadata_unref0 (metadata);
#line 2660 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_photo_file_adapter_unref0 (writer);
#line 2660 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_g_object_unref0 (dest_file);
#line 2660 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_photo_file_format_properties_unref0 (format_properties);
#line 2660 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_photo_file_adapter_unref0 (export_reader);
#line 2660 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return result;
#line 19517 "Photo.c"
}


gboolean photo_is_export_required (Photo* self, Scaling* scaling, PhotoFileFormat export_format) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp5_;
	gboolean _tmp7_;
	gboolean _tmp10_;
#line 2666 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 2666 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail (scaling != NULL, FALSE);
#line 2667 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp3_ = scaling_is_unscaled (scaling);
#line 2667 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (!_tmp3_) {
#line 2667 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp2_ = TRUE;
#line 19540 "Photo.c"
	} else {
		gboolean _tmp4_ = FALSE;
#line 2667 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp4_ = photo_has_alterations (self);
#line 2667 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp2_ = _tmp4_;
#line 19547 "Photo.c"
	}
#line 2667 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp5_ = _tmp2_;
#line 2667 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp5_) {
#line 2667 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp1_ = TRUE;
#line 19555 "Photo.c"
	} else {
		gboolean _tmp6_ = FALSE;
#line 2667 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp6_ = photo_has_user_generated_metadata (self);
#line 2667 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp1_ = _tmp6_;
#line 19562 "Photo.c"
	}
#line 2667 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp7_ = _tmp1_;
#line 2667 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp7_) {
#line 2667 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp0_ = TRUE;
#line 19570 "Photo.c"
	} else {
		PhotoFileFormat _tmp8_;
		PhotoFileFormat _tmp9_ = 0;
#line 2668 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp8_ = export_format;
#line 2668 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp9_ = photo_get_file_format (self);
#line 2668 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp0_ = _tmp8_ != _tmp9_;
#line 19580 "Photo.c"
	}
#line 2667 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp10_ = _tmp0_;
#line 2667 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	result = _tmp10_;
#line 2667 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return result;
#line 19588 "Photo.c"
}


void photo_export (Photo* self, GFile* dest_file, Scaling* scaling, JpegQuality quality, PhotoFileFormat export_format, gboolean direct_copy_unmodified, GError** error) {
	gboolean _tmp0_;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp5_ = FALSE;
	gboolean _tmp6_ = FALSE;
	gboolean _tmp7_ = FALSE;
	gboolean _tmp12_;
	gboolean _tmp15_;
	gboolean _tmp17_;
	PhotoFileFormat _tmp21_;
	gboolean _tmp22_ = FALSE;
	PhotoFileFormat _tmp24_;
	GFile* _tmp25_;
	gchar* _tmp26_ = NULL;
	gchar* _tmp27_;
	PhotoFileWriter* _tmp28_ = NULL;
	PhotoFileWriter* _tmp29_;
	PhotoFileWriter* writer;
	gchar* _tmp30_ = NULL;
	gchar* _tmp31_;
	PhotoFileWriter* _tmp32_;
	gchar* _tmp33_ = NULL;
	gchar* _tmp34_;
	PhotoFileFormat _tmp35_;
	GEnumValue* _tmp36_;
	Scaling _tmp37_;
	GdkPixbuf* _tmp38_ = NULL;
	GdkPixbuf* pixbuf;
	PhotoFileWriter* _tmp39_;
	GdkPixbuf* _tmp40_;
	JpegQuality _tmp41_;
	PhotoFileWriter* _tmp42_;
	gchar* _tmp43_ = NULL;
	gchar* _tmp44_;
	PhotoMetadata* _tmp45_ = NULL;
	PhotoMetadata* metadata;
	PhotoMetadata* _tmp46_;
	PhotoMetadata* _tmp49_;
	gchar* _tmp50_ = NULL;
	gchar* _tmp51_;
	PhotoMetadata* _tmp52_;
	GdkPixbuf* _tmp53_;
	Dimensions _tmp54_ = {0};
	PhotoMetadata* _tmp55_;
	PhotoMetadata* _tmp56_;
	time_t _tmp57_ = 0;
	PhotoMetadata* _tmp63_;
	PhotoMetadata* _tmp64_;
	PhotoMetadata* _tmp65_;
	gboolean _tmp66_ = FALSE;
	PhotoFileFormat _tmp68_;
	GFile* _tmp69_;
	gchar* _tmp70_ = NULL;
	gchar* _tmp71_;
	PhotoFileMetadataWriter* _tmp72_ = NULL;
	PhotoFileMetadataWriter* _tmp73_;
	PhotoFileMetadataWriter* _tmp74_;
	PhotoFileMetadataWriter* _tmp75_;
	PhotoMetadata* _tmp76_;
	GError * _inner_error_ = NULL;
#line 2674 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 2674 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail (G_IS_FILE (dest_file));
#line 2674 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail (scaling != NULL);
#line 2676 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp0_ = direct_copy_unmodified;
#line 2676 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp0_) {
#line 19662 "Photo.c"
		GFile* _tmp1_ = NULL;
		GFile* _tmp2_;
		GFile* _tmp3_;
#line 2677 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp1_ = media_source_get_master_file (MEDIA_SOURCE (self));
#line 2677 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp2_ = _tmp1_;
#line 2677 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp3_ = dest_file;
#line 2677 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_file_copy (_tmp2_, _tmp3_, G_FILE_COPY_OVERWRITE | G_FILE_COPY_TARGET_DEFAULT_PERMS, NULL, NULL, NULL, &_inner_error_);
#line 2677 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_object_unref0 (_tmp2_);
#line 2677 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 2677 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 2677 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			return;
#line 19682 "Photo.c"
		}
#line 2679 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return;
#line 19686 "Photo.c"
	}
#line 2686 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp7_ = scaling_is_unscaled (scaling);
#line 2686 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp7_) {
#line 19692 "Photo.c"
		gboolean _tmp8_ = FALSE;
		gboolean _tmp9_ = FALSE;
		gboolean _tmp11_;
#line 2686 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp9_ = photo_has_alterations (self);
#line 2686 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		if (!_tmp9_) {
#line 2686 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp8_ = TRUE;
#line 19702 "Photo.c"
		} else {
			gboolean _tmp10_ = FALSE;
#line 2686 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp10_ = photo_only_metadata_changed (self);
#line 2686 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp8_ = _tmp10_;
#line 19709 "Photo.c"
		}
#line 2686 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp11_ = _tmp8_;
#line 2686 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp6_ = _tmp11_;
#line 19715 "Photo.c"
	} else {
#line 2686 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp6_ = FALSE;
#line 19719 "Photo.c"
	}
#line 2686 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp12_ = _tmp6_;
#line 2686 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp12_) {
#line 19725 "Photo.c"
		PhotoFileFormat _tmp13_;
		PhotoFileFormat _tmp14_ = 0;
#line 2687 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp13_ = export_format;
#line 2687 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp14_ = photo_get_file_format (self);
#line 2687 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp5_ = _tmp13_ == _tmp14_;
#line 19734 "Photo.c"
	} else {
#line 2686 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp5_ = FALSE;
#line 19738 "Photo.c"
	}
#line 2686 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp15_ = _tmp5_;
#line 2686 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp15_) {
#line 19744 "Photo.c"
		PhotoFileFormat _tmp16_ = 0;
#line 2687 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp16_ = photo_get_file_format (self);
#line 2687 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp4_ = _tmp16_ == PHOTO_FILE_FORMAT_JFIF;
#line 19750 "Photo.c"
	} else {
#line 2686 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp4_ = FALSE;
#line 19754 "Photo.c"
	}
#line 2686 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp17_ = _tmp4_;
#line 2686 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp17_) {
#line 19760 "Photo.c"
		GFile* _tmp18_;
		gboolean _tmp19_ = FALSE;
		gboolean _tmp20_;
#line 2688 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp18_ = dest_file;
#line 2688 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp19_ = photo_export_fullsized_backing (self, _tmp18_, &_inner_error_);
#line 2688 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp20_ = _tmp19_;
#line 2688 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 2688 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 2688 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			return;
#line 19776 "Photo.c"
		}
#line 2688 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		if (_tmp20_) {
#line 2689 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			return;
#line 19782 "Photo.c"
		}
	}
#line 2692 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp21_ = export_format;
#line 2692 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp22_ = photo_file_format_can_write (_tmp21_);
#line 2692 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (!_tmp22_) {
#line 19791 "Photo.c"
		PhotoFileFormat _tmp23_ = 0;
#line 2693 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp23_ = photo_file_format_get_system_default_format ();
#line 2693 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		export_format = _tmp23_;
#line 19797 "Photo.c"
	}
#line 2695 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp24_ = export_format;
#line 2695 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp25_ = dest_file;
#line 2695 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp26_ = g_file_get_path (_tmp25_);
#line 2695 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp27_ = _tmp26_;
#line 2695 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp28_ = photo_file_format_create_writer (_tmp24_, _tmp27_, &_inner_error_);
#line 2695 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp29_ = _tmp28_;
#line 2695 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_g_free0 (_tmp27_);
#line 2695 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	writer = _tmp29_;
#line 2695 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 2695 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 2695 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return;
#line 19821 "Photo.c"
	}
#line 2697 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp30_ = data_object_to_string (DATA_OBJECT (self));
#line 2697 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp31_ = _tmp30_;
#line 2697 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp32_ = writer;
#line 2697 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp33_ = photo_file_adapter_get_filepath (PHOTO_FILE_ADAPTER (_tmp32_));
#line 2697 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp34_ = _tmp33_;
#line 2697 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp35_ = export_format;
#line 2698 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp36_ = g_enum_get_value (g_type_class_ref (TYPE_PHOTO_FILE_FORMAT), _tmp35_);
#line 2697 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_debug ("Photo.vala:2697: Saving transformed version of %s to %s in file format" \
" %s", _tmp31_, _tmp34_, (_tmp36_ != NULL) ? _tmp36_->value_name : NULL);
#line 2697 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_g_free0 (_tmp34_);
#line 2697 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_g_free0 (_tmp31_);
#line 2700 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp37_ = *scaling;
#line 2700 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp38_ = photo_get_pixbuf_with_options (self, &_tmp37_, PHOTO_EXCEPTION_NONE, BACKING_FETCH_MODE_SOURCE, &_inner_error_);
#line 2700 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	pixbuf = _tmp38_;
#line 2700 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 2700 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 2700 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_photo_file_adapter_unref0 (writer);
#line 2700 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return;
#line 19857 "Photo.c"
	}
#line 2703 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp39_ = writer;
#line 2703 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp40_ = pixbuf;
#line 2703 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp41_ = quality;
#line 2703 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	photo_file_writer_write (_tmp39_, _tmp40_, _tmp41_, &_inner_error_);
#line 2703 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 2703 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 2703 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_object_unref0 (pixbuf);
#line 2703 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_photo_file_adapter_unref0 (writer);
#line 2703 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return;
#line 19877 "Photo.c"
	}
#line 2705 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp42_ = writer;
#line 2705 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp43_ = photo_file_adapter_get_filepath (PHOTO_FILE_ADAPTER (_tmp42_));
#line 2705 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp44_ = _tmp43_;
#line 2705 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_debug ("Photo.vala:2705: Setting EXIF for %s", _tmp44_);
#line 2705 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_g_free0 (_tmp44_);
#line 2708 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp45_ = photo_source_get_metadata (PHOTO_SOURCE (self));
#line 2708 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	metadata = _tmp45_;
#line 2709 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp46_ = metadata;
#line 2709 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp46_ == NULL) {
#line 19897 "Photo.c"
		PhotoFileFormat _tmp47_;
		PhotoMetadata* _tmp48_ = NULL;
#line 2710 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp47_ = export_format;
#line 2710 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp48_ = photo_file_format_create_metadata (_tmp47_);
#line 2710 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 2710 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		metadata = _tmp48_;
#line 19908 "Photo.c"
	}
#line 2712 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp49_ = metadata;
#line 2712 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp50_ = media_source_get_title (MEDIA_SOURCE (self));
#line 2712 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp51_ = _tmp50_;
#line 2712 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	photo_metadata_set_title (_tmp49_, _tmp51_, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 2712 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_g_free0 (_tmp51_);
#line 2713 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp52_ = metadata;
#line 2713 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp53_ = pixbuf;
#line 2713 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	dimensions_for_pixbuf (_tmp53_, &_tmp54_);
#line 2713 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	photo_metadata_set_pixel_dimensions (_tmp52_, &_tmp54_, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 2714 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp55_ = metadata;
#line 2714 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	photo_metadata_set_orientation (_tmp55_, ORIENTATION_TOP_LEFT);
#line 2715 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp56_ = metadata;
#line 2715 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	photo_metadata_set_software (_tmp56_, RESOURCES_APP_TITLE, RESOURCES_APP_VERSION);
#line 2717 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp57_ = media_source_get_exposure_time (MEDIA_SOURCE (self));
#line 2717 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp57_ != ((time_t) 0)) {
#line 19940 "Photo.c"
		PhotoMetadata* _tmp58_;
		time_t _tmp59_ = 0;
		MetadataDateTime* _tmp60_;
		MetadataDateTime* _tmp61_;
#line 2718 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp58_ = metadata;
#line 2718 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp59_ = media_source_get_exposure_time (MEDIA_SOURCE (self));
#line 2718 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp60_ = metadata_date_time_new (_tmp59_);
#line 2718 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp61_ = _tmp60_;
#line 2718 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		photo_metadata_set_exposure_date_time (_tmp58_, _tmp61_, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 2718 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_metadata_date_time_unref0 (_tmp61_);
#line 19957 "Photo.c"
	} else {
		PhotoMetadata* _tmp62_;
#line 2720 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp62_ = metadata;
#line 2720 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		photo_metadata_set_exposure_date_time (_tmp62_, NULL, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 19964 "Photo.c"
	}
#line 2721 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp63_ = metadata;
#line 2721 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	photo_metadata_remove_tag (_tmp63_, "Exif.Iop.RelatedImageWidth");
#line 2722 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp64_ = metadata;
#line 2722 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	photo_metadata_remove_tag (_tmp64_, "Exif.Iop.RelatedImageHeight");
#line 2723 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp65_ = metadata;
#line 2723 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	photo_metadata_remove_exif_thumbnail (_tmp65_);
#line 2725 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp66_ = photo_has_user_generated_metadata (self);
#line 2725 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp66_) {
#line 19982 "Photo.c"
		PhotoMetadata* _tmp67_;
#line 2726 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp67_ = metadata;
#line 2726 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		photo_set_user_metadata_for_export (self, _tmp67_);
#line 19988 "Photo.c"
	}
#line 2728 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp68_ = export_format;
#line 2728 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp69_ = dest_file;
#line 2728 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp70_ = g_file_get_path (_tmp69_);
#line 2728 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp71_ = _tmp70_;
#line 2728 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp72_ = photo_file_format_create_metadata_writer (_tmp68_, _tmp71_, &_inner_error_);
#line 2728 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp73_ = _tmp72_;
#line 2728 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_g_free0 (_tmp71_);
#line 2728 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp74_ = _tmp73_;
#line 2728 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 2728 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 2728 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 2728 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_object_unref0 (pixbuf);
#line 2728 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_photo_file_adapter_unref0 (writer);
#line 2728 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return;
#line 20018 "Photo.c"
	}
#line 2728 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp75_ = _tmp74_;
#line 2728 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp76_ = metadata;
#line 2728 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	photo_file_metadata_writer_write_metadata (_tmp75_, _tmp76_, &_inner_error_);
#line 2728 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_photo_file_adapter_unref0 (_tmp75_);
#line 2728 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 2728 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 2728 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 2728 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_object_unref0 (pixbuf);
#line 2728 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_photo_file_adapter_unref0 (writer);
#line 2728 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return;
#line 20040 "Photo.c"
	}
#line 2674 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_media_metadata_unref0 (metadata);
#line 2674 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_g_object_unref0 (pixbuf);
#line 2674 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_photo_file_adapter_unref0 (writer);
#line 20048 "Photo.c"
}


static GFile* photo_generate_new_editable_file (Photo* self, PhotoFileFormat* file_format, GError** error) {
	PhotoFileFormat _vala_file_format = 0;
	GFile* result = NULL;
	GFile* backing = NULL;
	PhotoFileFormat _tmp4_;
	gboolean _tmp5_ = FALSE;
	gchar* name = NULL;
	gchar* ext = NULL;
	gchar* _tmp7_ = NULL;
	gchar* _tmp8_;
	gchar* _tmp9_ = NULL;
	gchar* _tmp10_ = NULL;
	gboolean _tmp11_ = FALSE;
	const gchar* _tmp12_;
	gboolean _tmp18_;
	const gchar* _tmp23_;
	const gchar* _tmp24_ = NULL;
	const gchar* _tmp25_;
	gchar* _tmp26_ = NULL;
	gchar* editable_basename;
	gboolean collision = FALSE;
	GFile* _tmp27_ = NULL;
	GFile* _tmp28_;
	gboolean _tmp29_ = FALSE;
	GFile* _tmp30_ = NULL;
	GFile* _tmp31_;
	GFile* _tmp32_;
	GError * _inner_error_ = NULL;
#line 2731 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 20082 "Photo.c"
	{
		PhotoRow _tmp0_;
#line 2733 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp0_ = self->priv->row;
#line 2733 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 20089 "Photo.c"
		{
			PhotoFileFormat _tmp1_ = 0;
			GFile* _tmp2_ = NULL;
#line 2734 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp1_ = photo_get_file_format (self);
#line 2734 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_vala_file_format = _tmp1_;
#line 2735 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp2_ = media_source_get_file (MEDIA_SOURCE (self));
#line 2735 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_g_object_unref0 (backing);
#line 2735 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			backing = _tmp2_;
#line 20103 "Photo.c"
		}
		__finally207:
		{
			PhotoRow _tmp3_;
#line 2733 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp3_ = self->priv->row;
#line 2733 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 20112 "Photo.c"
		}
#line 2733 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 2733 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 2733 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_g_object_unref0 (backing);
#line 2733 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			return NULL;
#line 20122 "Photo.c"
		}
	}
#line 2738 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp4_ = _vala_file_format;
#line 2738 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp5_ = photo_file_format_can_write (_tmp4_);
#line 2738 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (!_tmp5_) {
#line 20131 "Photo.c"
		PhotoFileFormat _tmp6_ = 0;
#line 2739 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp6_ = photo_file_format_get_system_default_format ();
#line 2739 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_vala_file_format = _tmp6_;
#line 20137 "Photo.c"
	}
#line 2742 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp7_ = g_file_get_basename (backing);
#line 2742 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp8_ = _tmp7_;
#line 2742 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	disassemble_filename (_tmp8_, &_tmp9_, &_tmp10_);
#line 2742 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_g_free0 (name);
#line 2742 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	name = _tmp9_;
#line 2742 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_g_free0 (ext);
#line 2742 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	ext = _tmp10_;
#line 2742 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_g_free0 (_tmp8_);
#line 2744 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp12_ = ext;
#line 2744 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp12_ == NULL) {
#line 2744 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp11_ = TRUE;
#line 20161 "Photo.c"
	} else {
		PhotoFileFormat _tmp13_;
		PhotoFileFormatProperties* _tmp14_ = NULL;
		PhotoFileFormatProperties* _tmp15_;
		const gchar* _tmp16_;
		gboolean _tmp17_ = FALSE;
#line 2744 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp13_ = _vala_file_format;
#line 2744 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp14_ = photo_file_format_get_properties (_tmp13_);
#line 2744 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp15_ = _tmp14_;
#line 2744 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp16_ = ext;
#line 2744 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp17_ = photo_file_format_properties_is_recognized_extension (_tmp15_, _tmp16_);
#line 2744 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp11_ = !_tmp17_;
#line 2744 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_photo_file_format_properties_unref0 (_tmp15_);
#line 20182 "Photo.c"
	}
#line 2744 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp18_ = _tmp11_;
#line 2744 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp18_) {
#line 20188 "Photo.c"
		PhotoFileFormat _tmp19_;
		PhotoFileFormatProperties* _tmp20_ = NULL;
		PhotoFileFormatProperties* _tmp21_;
		gchar* _tmp22_ = NULL;
#line 2745 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp19_ = _vala_file_format;
#line 2745 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp20_ = photo_file_format_get_properties (_tmp19_);
#line 2745 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp21_ = _tmp20_;
#line 2745 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp22_ = photo_file_format_properties_get_default_extension (_tmp21_);
#line 2745 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_free0 (ext);
#line 2745 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		ext = _tmp22_;
#line 2745 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_photo_file_format_properties_unref0 (_tmp21_);
#line 20207 "Photo.c"
	}
#line 2747 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp23_ = name;
#line 2747 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp24_ = _ ("modified");
#line 2747 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp25_ = ext;
#line 2747 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp26_ = g_strdup_printf ("%s_%s.%s", _tmp23_, _tmp24_, _tmp25_);
#line 2747 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	editable_basename = _tmp26_;
#line 2750 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp27_ = g_file_get_parent (backing);
#line 2750 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp28_ = _tmp27_;
#line 2750 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp30_ = generate_unique_file (_tmp28_, editable_basename, &_tmp29_, &_inner_error_);
#line 2750 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	collision = _tmp29_;
#line 2750 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp31_ = _tmp30_;
#line 2750 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_g_object_unref0 (_tmp28_);
#line 2750 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp32_ = _tmp31_;
#line 2750 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 2750 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 2750 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_free0 (editable_basename);
#line 2750 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_free0 (ext);
#line 2750 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_free0 (name);
#line 2750 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_object_unref0 (backing);
#line 2750 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return NULL;
#line 20247 "Photo.c"
	}
#line 2750 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	result = _tmp32_;
#line 2750 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_g_free0 (editable_basename);
#line 2750 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_g_free0 (ext);
#line 2750 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_g_free0 (name);
#line 2750 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_g_object_unref0 (backing);
#line 2750 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (file_format) {
#line 2750 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		*file_format = _vala_file_format;
#line 20263 "Photo.c"
	}
#line 2750 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return result;
#line 20267 "Photo.c"
}


static void _g_object_unref0_ (gpointer var) {
#line 2772 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 20274 "Photo.c"
}


static void _g_list_free__g_object_unref0_ (GList* self) {
#line 2772 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_list_foreach (self, (GFunc) _g_object_unref0_, NULL);
#line 2772 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_list_free (self);
#line 20283 "Photo.c"
}


static gboolean photo_launch_editor (GFile* file, PhotoFileFormat file_format, GError** error) {
	gboolean result = FALSE;
	gchar* _tmp0_ = NULL;
	PhotoFileFormat _tmp1_;
	const gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* commandline;
	const gchar* _tmp10_;
	gboolean _tmp11_ = FALSE;
	GAppInfo* app = NULL;
	GList* files;
	GFile* _tmp16_;
	GFile* _tmp17_;
	GAppInfo* _tmp18_;
	gchar** _tmp23_ = NULL;
	gchar** argv;
	gint argv_length1;
	gint _argv_size_;
	gchar** _tmp24_;
	gint _tmp24__length1;
	const gchar* _tmp25_;
	gchar* _tmp26_;
	gchar* _tmp27_;
	gchar** _tmp28_;
	gint _tmp28__length1;
	GFile* _tmp29_;
	gchar* _tmp30_ = NULL;
	gchar* _tmp31_;
	GPid child_pid = 0;
	gchar** _tmp32_;
	gint _tmp32__length1;
	GPid _tmp33_ = 0;
	gboolean _tmp34_ = FALSE;
	gboolean _tmp35_;
	GError * _inner_error_ = NULL;
#line 2753 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail (G_IS_FILE (file), FALSE);
#line 2754 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp1_ = file_format;
#line 2754 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp1_ == PHOTO_FILE_FORMAT_RAW) {
#line 20328 "Photo.c"
		Config* _tmp2_ = NULL;
		Config* _tmp3_;
		gchar* _tmp4_ = NULL;
#line 2754 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp2_ = config_get_instance ();
#line 2754 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp3_ = _tmp2_;
#line 2754 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp4_ = config_get_external_raw_app (_tmp3_);
#line 2754 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_free0 (_tmp0_);
#line 2754 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp0_ = _tmp4_;
#line 2754 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_config_unref0 (_tmp3_);
#line 20344 "Photo.c"
	} else {
		Config* _tmp5_ = NULL;
		Config* _tmp6_;
		gchar* _tmp7_ = NULL;
#line 2755 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp5_ = config_get_instance ();
#line 2755 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp6_ = _tmp5_;
#line 2755 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp7_ = config_get_external_photo_app (_tmp6_);
#line 2755 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_free0 (_tmp0_);
#line 2755 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp0_ = _tmp7_;
#line 2755 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_config_unref0 (_tmp6_);
#line 20361 "Photo.c"
	}
#line 2754 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp8_ = _tmp0_;
#line 2754 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp9_ = g_strdup (_tmp8_);
#line 2754 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	commandline = _tmp9_;
#line 2757 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp10_ = commandline;
#line 2757 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp11_ = is_string_empty (_tmp10_);
#line 2757 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp11_) {
#line 2758 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		result = FALSE;
#line 2758 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_free0 (commandline);
#line 2758 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_free0 (_tmp0_);
#line 2758 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return result;
#line 20383 "Photo.c"
	}
	{
		const gchar* _tmp12_;
		GAppInfo* _tmp13_ = NULL;
		GAppInfo* _tmp14_;
		GAppInfo* _tmp15_;
#line 2762 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp12_ = commandline;
#line 2762 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp13_ = g_app_info_create_from_commandline (_tmp12_, "", G_APP_INFO_CREATE_NONE, &_inner_error_);
#line 2762 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp14_ = _tmp13_;
#line 2762 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 20398 "Photo.c"
			goto __catch208_g_error;
		}
#line 2762 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp15_ = _g_object_ref0 (_tmp14_);
#line 2762 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_object_unref0 (app);
#line 2762 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		app = _tmp15_;
#line 20407 "Photo.c"
	}
	goto __finally208;
	__catch208_g_error:
	{
		GError* er = NULL;
#line 2761 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		er = _inner_error_;
#line 2761 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_inner_error_ = NULL;
#line 2765 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_object_unref0 (app);
#line 2765 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		app = NULL;
#line 2761 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_error_free0 (er);
#line 20423 "Photo.c"
	}
	__finally208:
#line 2761 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 2761 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 2761 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_object_unref0 (app);
#line 2761 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_free0 (commandline);
#line 2761 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_free0 (_tmp0_);
#line 2761 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return FALSE;
#line 20438 "Photo.c"
	}
#line 2768 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	files = NULL;
#line 2769 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp16_ = file;
#line 2769 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp17_ = _g_object_ref0 (_tmp16_);
#line 2769 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	files = g_list_insert (files, _tmp17_, -1);
#line 2771 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp18_ = app;
#line 2771 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp18_ != NULL) {
#line 20452 "Photo.c"
		GAppInfo* _tmp19_;
		GList* _tmp20_;
		gboolean _tmp21_ = FALSE;
		gboolean _tmp22_;
#line 2772 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp19_ = app;
#line 2772 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp20_ = files;
#line 2772 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp21_ = g_app_info_launch (_tmp19_, _tmp20_, NULL, &_inner_error_);
#line 2772 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp22_ = _tmp21_;
#line 2772 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 2772 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 2772 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			__g_list_free__g_object_unref0_0 (files);
#line 2772 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_g_object_unref0 (app);
#line 2772 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_g_free0 (commandline);
#line 2772 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_g_free0 (_tmp0_);
#line 2772 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			return FALSE;
#line 20479 "Photo.c"
		}
#line 2772 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		result = _tmp22_;
#line 2772 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		__g_list_free__g_object_unref0_0 (files);
#line 2772 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_object_unref0 (app);
#line 2772 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_free0 (commandline);
#line 2772 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_free0 (_tmp0_);
#line 2772 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return result;
#line 20493 "Photo.c"
	}
#line 2774 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp23_ = g_new0 (gchar*, 2 + 1);
#line 2774 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	argv = _tmp23_;
#line 2774 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	argv_length1 = 2;
#line 2774 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_argv_size_ = argv_length1;
#line 2775 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp24_ = argv;
#line 2775 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp24__length1 = argv_length1;
#line 2775 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp25_ = commandline;
#line 2775 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp26_ = g_strdup (_tmp25_);
#line 2775 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_g_free0 (_tmp24_[0]);
#line 2775 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp24_[0] = _tmp26_;
#line 2775 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp27_ = _tmp24_[0];
#line 2776 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp28_ = argv;
#line 2776 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp28__length1 = argv_length1;
#line 2776 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp29_ = file;
#line 2776 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp30_ = g_file_get_path (_tmp29_);
#line 2776 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_g_free0 (_tmp28_[1]);
#line 2776 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp28_[1] = _tmp30_;
#line 2776 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp31_ = _tmp28_[1];
#line 2780 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp32_ = argv;
#line 2780 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp32__length1 = argv_length1;
#line 2780 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp34_ = g_spawn_async ("/", _tmp32_, NULL, G_SPAWN_SEARCH_PATH, NULL, NULL, &_tmp33_, &_inner_error_);
#line 2780 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	child_pid = _tmp33_;
#line 2780 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp35_ = _tmp34_;
#line 2780 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 2780 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 2780 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		argv = (_vala_array_free (argv, argv_length1, (GDestroyNotify) g_free), NULL);
#line 2780 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		__g_list_free__g_object_unref0_0 (files);
#line 2780 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_object_unref0 (app);
#line 2780 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_free0 (commandline);
#line 2780 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_free0 (_tmp0_);
#line 2780 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return FALSE;
#line 20557 "Photo.c"
	}
#line 2780 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	result = _tmp35_;
#line 2780 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	argv = (_vala_array_free (argv, argv_length1, (GDestroyNotify) g_free), NULL);
#line 2780 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	__g_list_free__g_object_unref0_0 (files);
#line 2780 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_g_object_unref0 (app);
#line 2780 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_g_free0 (commandline);
#line 2780 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_g_free0 (_tmp0_);
#line 2780 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return result;
#line 20573 "Photo.c"
}


void photo_open_master_with_external_editor (Photo* self, GError** error) {
	GFile* _tmp0_ = NULL;
	GFile* _tmp1_;
	PhotoFileFormat _tmp2_ = 0;
	GError * _inner_error_ = NULL;
#line 2792 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 2793 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp0_ = media_source_get_master_file (MEDIA_SOURCE (self));
#line 2793 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 2793 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp2_ = photo_get_master_file_format (self);
#line 2793 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	photo_launch_editor (_tmp1_, _tmp2_, &_inner_error_);
#line 2793 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_g_object_unref0 (_tmp1_);
#line 2793 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 2793 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 2793 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return;
#line 20600 "Photo.c"
	}
}


void photo_open_with_external_editor (Photo* self, GError** error) {
	GFile* current_editable_file;
	GFile* create_editable_file;
	PhotoFileFormat editable_file_format = 0;
	gboolean _tmp14_ = FALSE;
	gboolean _tmp15_ = FALSE;
	GFile* _tmp16_;
	gboolean _tmp18_;
	gboolean _tmp24_;
	gboolean _tmp27_ = FALSE;
	GFile* _tmp28_;
	gboolean _tmp31_;
	GFile* _tmp47_;
	GFileMonitor* _tmp48_;
	GFile* _tmp50_;
	PhotoFileFormat _tmp51_ = 0;
	GError * _inner_error_ = NULL;
#line 2796 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 2797 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	current_editable_file = NULL;
#line 2798 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	create_editable_file = NULL;
#line 20628 "Photo.c"
	{
		PhotoBackingReaders _tmp0_;
#line 2800 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 2800 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_readers);
#line 20635 "Photo.c"
		{
			PhotoBackingReaders _tmp1_;
			PhotoFileReader* _tmp2_;
			GFile* _tmp6_;
#line 2801 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 2801 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp2_ = _tmp1_.editable;
#line 2801 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			if (_tmp2_ != NULL) {
#line 20646 "Photo.c"
				PhotoBackingReaders _tmp3_;
				PhotoFileReader* _tmp4_;
				GFile* _tmp5_ = NULL;
#line 2802 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp3_ = self->priv->readers;
#line 2802 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp4_ = _tmp3_.editable;
#line 2802 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp5_ = photo_file_adapter_get_file (PHOTO_FILE_ADAPTER (_tmp4_));
#line 2802 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_g_object_unref0 (current_editable_file);
#line 2802 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				current_editable_file = _tmp5_;
#line 20660 "Photo.c"
			}
#line 2804 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp6_ = current_editable_file;
#line 2804 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			if (_tmp6_ == NULL) {
#line 20666 "Photo.c"
				PhotoFileFormat _tmp7_ = 0;
				GFile* _tmp8_ = NULL;
				GFile* _tmp9_;
#line 2805 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp8_ = photo_generate_new_editable_file (self, &_tmp7_, &_inner_error_);
#line 2805 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				editable_file_format = _tmp7_;
#line 2805 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp9_ = _tmp8_;
#line 2805 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				if (_inner_error_ != NULL) {
#line 20678 "Photo.c"
					goto __finally209;
				}
#line 2805 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_g_object_unref0 (create_editable_file);
#line 2805 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				create_editable_file = _tmp9_;
#line 20685 "Photo.c"
			} else {
				PhotoBackingReaders _tmp10_;
				PhotoFileReader* _tmp11_;
				PhotoFileFormat _tmp12_ = 0;
#line 2807 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp10_ = self->priv->readers;
#line 2807 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp11_ = _tmp10_.editable;
#line 2807 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp12_ = photo_file_adapter_get_file_format (PHOTO_FILE_ADAPTER (_tmp11_));
#line 2807 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				editable_file_format = _tmp12_;
#line 20698 "Photo.c"
			}
		}
		__finally209:
		{
			PhotoBackingReaders _tmp13_;
#line 2800 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp13_ = self->priv->readers;
#line 2800 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_readers);
#line 20708 "Photo.c"
		}
#line 2800 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 2800 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 2800 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_g_object_unref0 (create_editable_file);
#line 2800 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_g_object_unref0 (current_editable_file);
#line 2800 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			return;
#line 20720 "Photo.c"
		}
	}
#line 2812 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp16_ = create_editable_file;
#line 2812 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp16_ == NULL) {
#line 20727 "Photo.c"
		GFile* _tmp17_;
#line 2812 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp17_ = current_editable_file;
#line 2812 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp15_ = _tmp17_ != NULL;
#line 20733 "Photo.c"
	} else {
#line 2812 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp15_ = FALSE;
#line 20737 "Photo.c"
	}
#line 2812 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp18_ = _tmp15_;
#line 2812 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp18_) {
#line 20743 "Photo.c"
		gboolean _tmp19_ = FALSE;
		GFile* _tmp20_;
		gboolean _tmp21_ = FALSE;
		gboolean _tmp23_;
#line 2813 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp20_ = current_editable_file;
#line 2813 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp21_ = g_file_query_exists (_tmp20_, NULL);
#line 2813 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		if (!_tmp21_) {
#line 2813 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp19_ = TRUE;
#line 20756 "Photo.c"
		} else {
			gboolean _tmp22_ = FALSE;
#line 2813 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp22_ = photo_has_transformations (self);
#line 2813 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp19_ = _tmp22_;
#line 20763 "Photo.c"
		}
#line 2813 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp23_ = _tmp19_;
#line 2813 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp14_ = _tmp23_;
#line 20769 "Photo.c"
	} else {
#line 2812 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp14_ = FALSE;
#line 20773 "Photo.c"
	}
#line 2812 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp24_ = _tmp14_;
#line 2812 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp24_) {
#line 20779 "Photo.c"
		GFile* _tmp25_;
		GFile* _tmp26_;
#line 2814 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp25_ = current_editable_file;
#line 2814 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp26_ = _g_object_ref0 (_tmp25_);
#line 2814 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_object_unref0 (create_editable_file);
#line 2814 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		create_editable_file = _tmp26_;
#line 20790 "Photo.c"
	}
#line 2817 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp28_ = create_editable_file;
#line 2817 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp28_ != NULL) {
#line 20796 "Photo.c"
		PhotoFileFormat _tmp29_;
		gboolean _tmp30_ = FALSE;
#line 2817 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp29_ = editable_file_format;
#line 2817 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp30_ = photo_file_format_can_write (_tmp29_);
#line 2817 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp27_ = _tmp30_;
#line 20805 "Photo.c"
	} else {
#line 2817 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp27_ = FALSE;
#line 20809 "Photo.c"
	}
#line 2817 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp31_ = _tmp27_;
#line 2817 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp31_) {
#line 20815 "Photo.c"
		PhotoFileFormat _tmp43_;
		GFile* _tmp44_;
		GFile* _tmp45_;
		GFile* _tmp46_;
#line 2818 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		photo_halt_monitoring_editable (self);
#line 20822 "Photo.c"
		{
			GFile* _tmp32_;
			Scaling _tmp33_ = {0};
			PhotoFileFormat _tmp34_;
#line 2821 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp32_ = create_editable_file;
#line 2821 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			scaling_for_original (&_tmp33_);
#line 2821 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp34_ = editable_file_format;
#line 2821 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			photo_export (self, _tmp32_, &_tmp33_, JPEG_QUALITY_MAXIMUM, _tmp34_, FALSE, &_inner_error_);
#line 2821 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			if (_inner_error_ != NULL) {
#line 20837 "Photo.c"
				goto __catch210_g_error;
			}
		}
		goto __finally210;
		__catch210_g_error:
		{
			GError* err = NULL;
			GError* _tmp41_;
			GError* _tmp42_;
#line 2820 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			err = _inner_error_;
#line 2820 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_inner_error_ = NULL;
#line 20851 "Photo.c"
			{
				GFile* _tmp35_;
#line 2826 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp35_ = create_editable_file;
#line 2826 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				g_file_delete (_tmp35_, NULL, &_inner_error_);
#line 2826 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				if (_inner_error_ != NULL) {
#line 20860 "Photo.c"
					goto __catch211_g_error;
				}
			}
			goto __finally211;
			__catch211_g_error:
			{
				GError* delete_err = NULL;
				GFile* _tmp36_;
				gchar* _tmp37_ = NULL;
				gchar* _tmp38_;
				GError* _tmp39_;
				const gchar* _tmp40_;
#line 2825 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				delete_err = _inner_error_;
#line 2825 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_inner_error_ = NULL;
#line 2829 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp36_ = create_editable_file;
#line 2829 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp37_ = g_file_get_path (_tmp36_);
#line 2829 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp38_ = _tmp37_;
#line 2829 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp39_ = delete_err;
#line 2829 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp40_ = _tmp39_->message;
#line 2829 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				g_warning ("Photo.vala:2829: Unable to delete editable file %s after export error:" \
" %s", _tmp38_, _tmp40_);
#line 2829 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_g_free0 (_tmp38_);
#line 2825 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_g_error_free0 (delete_err);
#line 20893 "Photo.c"
			}
			__finally211:
#line 2825 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			if (_inner_error_ != NULL) {
#line 2825 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_g_error_free0 (err);
#line 2825 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_g_error_free0 (err);
#line 2825 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_g_object_unref0 (create_editable_file);
#line 2825 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_g_object_unref0 (current_editable_file);
#line 2825 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 2825 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				g_clear_error (&_inner_error_);
#line 2825 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				return;
#line 20912 "Photo.c"
			}
#line 2833 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp41_ = err;
#line 2833 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp42_ = _g_error_copy0 (_tmp41_);
#line 2833 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_inner_error_ = _tmp42_;
#line 2833 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_g_error_free0 (err);
#line 20922 "Photo.c"
			goto __finally210;
		}
		__finally210:
#line 2820 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 2820 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 2820 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_g_object_unref0 (create_editable_file);
#line 2820 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_g_object_unref0 (current_editable_file);
#line 2820 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			return;
#line 20936 "Photo.c"
		}
#line 2837 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp43_ = editable_file_format;
#line 2837 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp44_ = create_editable_file;
#line 2837 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		photo_attach_editable (self, _tmp43_, _tmp44_, &_inner_error_);
#line 2837 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 2837 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 2837 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_g_object_unref0 (create_editable_file);
#line 2837 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_g_object_unref0 (current_editable_file);
#line 2837 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			return;
#line 20954 "Photo.c"
		}
#line 2839 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp45_ = create_editable_file;
#line 2839 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp46_ = _g_object_ref0 (_tmp45_);
#line 2839 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_object_unref0 (current_editable_file);
#line 2839 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		current_editable_file = _tmp46_;
#line 20964 "Photo.c"
	}
#line 2842 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp47_ = current_editable_file;
#line 2842 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_assert (_tmp47_ != NULL);
#line 2845 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp48_ = self->priv->editable_monitor;
#line 2845 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp48_ == NULL) {
#line 20974 "Photo.c"
		GFile* _tmp49_;
#line 2846 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp49_ = current_editable_file;
#line 2846 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		photo_start_monitoring_editable (self, _tmp49_, &_inner_error_);
#line 2846 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 2846 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 2846 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_g_object_unref0 (create_editable_file);
#line 2846 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_g_object_unref0 (current_editable_file);
#line 2846 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			return;
#line 20990 "Photo.c"
		}
	}
#line 2848 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp50_ = current_editable_file;
#line 2848 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp51_ = photo_get_file_format (self);
#line 2848 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	photo_launch_editor (_tmp50_, _tmp51_, &_inner_error_);
#line 2848 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 2848 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 2848 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_object_unref0 (create_editable_file);
#line 2848 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_object_unref0 (current_editable_file);
#line 2848 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return;
#line 21009 "Photo.c"
	}
#line 2796 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_g_object_unref0 (create_editable_file);
#line 2796 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_g_object_unref0 (current_editable_file);
#line 21015 "Photo.c"
}


void photo_revert_to_master (Photo* self) {
#line 2851 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 2852 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	photo_detach_editable (self, TRUE, TRUE);
#line 21024 "Photo.c"
}


static void _photo_on_editable_file_changed_g_file_monitor_changed (GFileMonitor* _sender, GFile* file, GFile* other_file, GFileMonitorEvent event_type, gpointer self) {
#line 2862 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	photo_on_editable_file_changed (self, file, other_file, event_type);
#line 21031 "Photo.c"
}


static void photo_start_monitoring_editable (Photo* self, GFile* file, GError** error) {
	GFile* _tmp0_;
	GFile* _tmp1_;
	GFileMonitor* _tmp2_ = NULL;
	GFileMonitor* _tmp3_;
	GFileMonitor* _tmp4_;
	GFileMonitor* _tmp5_;
	GError * _inner_error_ = NULL;
#line 2855 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 2855 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail (G_IS_FILE (file));
#line 2856 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	photo_halt_monitoring_editable (self);
#line 2859 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp0_ = file;
#line 2859 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	library_monitor_blacklist_file (_tmp0_, "Photo.start_monitoring_editable");
#line 2861 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp1_ = file;
#line 2861 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp2_ = g_file_monitor (_tmp1_, G_FILE_MONITOR_NONE, NULL, &_inner_error_);
#line 2861 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp3_ = _tmp2_;
#line 2861 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 2861 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 2861 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return;
#line 21065 "Photo.c"
	}
#line 2861 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp4_ = _g_object_ref0 (_tmp3_);
#line 2861 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_g_object_unref0 (self->priv->editable_monitor);
#line 2861 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	self->priv->editable_monitor = _tmp4_;
#line 2862 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp5_ = self->priv->editable_monitor;
#line 2862 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_signal_connect_object (_tmp5_, "changed", (GCallback) _photo_on_editable_file_changed_g_file_monitor_changed, self, 0);
#line 21077 "Photo.c"
}


static void photo_halt_monitoring_editable (Photo* self) {
	GFileMonitor* _tmp0_;
	GFile* _tmp1_ = NULL;
	GFile* file;
	GFile* _tmp2_;
	GFileMonitor* _tmp4_;
	guint _tmp5_ = 0U;
	GFileMonitor* _tmp6_;
#line 2865 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 2866 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp0_ = self->priv->editable_monitor;
#line 2866 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp0_ == NULL) {
#line 2867 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return;
#line 21097 "Photo.c"
	}
#line 2870 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp1_ = photo_get_editable_file (self);
#line 2870 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	file = _tmp1_;
#line 2871 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp2_ = file;
#line 2871 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp2_ != NULL) {
#line 21107 "Photo.c"
		GFile* _tmp3_;
#line 2872 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp3_ = file;
#line 2872 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		library_monitor_unblacklist_file (_tmp3_);
#line 21113 "Photo.c"
	}
#line 2874 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp4_ = self->priv->editable_monitor;
#line 2874 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_signal_parse_name ("changed", G_TYPE_FILE_MONITOR, &_tmp5_, NULL, FALSE);
#line 2874 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_signal_handlers_disconnect_matched (_tmp4_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp5_, 0, NULL, (GCallback) _photo_on_editable_file_changed_g_file_monitor_changed, self);
#line 2875 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp6_ = self->priv->editable_monitor;
#line 2875 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_file_monitor_cancel (_tmp6_);
#line 2876 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_g_object_unref0 (self->priv->editable_monitor);
#line 2876 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	self->priv->editable_monitor = NULL;
#line 2865 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_g_object_unref0 (file);
#line 21131 "Photo.c"
}


static void photo_attach_editable (Photo* self, PhotoFileFormat file_format, GFile* file, GError** error) {
	PhotoFileFormat _tmp0_;
	GFile* _tmp1_;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_;
	PhotoFileReader* _tmp4_ = NULL;
	PhotoFileReader* _tmp5_;
	GError * _inner_error_ = NULL;
#line 2879 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 2879 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail (G_IS_FILE (file));
#line 2884 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	photo_internal_remove_all_transformations (self, FALSE);
#line 2885 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp0_ = file_format;
#line 2885 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp1_ = file;
#line 2885 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp2_ = g_file_get_path (_tmp1_);
#line 2885 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp3_ = _tmp2_;
#line 2885 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp4_ = photo_file_format_create_reader (_tmp0_, _tmp3_);
#line 2885 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp5_ = _tmp4_;
#line 2885 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	photo_update_editable (self, FALSE, _tmp5_, &_inner_error_);
#line 2885 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_photo_file_adapter_unref0 (_tmp5_);
#line 2885 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_g_free0 (_tmp3_);
#line 2885 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 2885 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 2885 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return;
#line 21173 "Photo.c"
	}
}


static void photo_update_editable_attributes (Photo* self, GError** error) {
	GError * _inner_error_ = NULL;
#line 2888 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 2889 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	photo_update_editable (self, TRUE, NULL, &_inner_error_);
#line 2889 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 2889 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 2889 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return;
#line 21190 "Photo.c"
	}
}


void photo_reimport_editable (Photo* self, GError** error) {
	GError * _inner_error_ = NULL;
#line 2892 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 2894 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	photo_internal_remove_all_transformations (self, FALSE);
#line 2895 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	photo_update_editable (self, FALSE, NULL, &_inner_error_);
#line 2895 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 2895 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 2895 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return;
#line 21209 "Photo.c"
	}
}


static void _vala_array_add219 (gchar*** array, int* length, int* size, gchar* value) {
#line 2989 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if ((*length) == (*size)) {
#line 2989 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 2989 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 21221 "Photo.c"
	}
#line 2989 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	(*array)[(*length)++] = value;
#line 2989 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	(*array)[*length] = NULL;
#line 21227 "Photo.c"
}


static void _vala_array_add220 (gchar*** array, int* length, int* size, gchar* value) {
#line 2990 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if ((*length) == (*size)) {
#line 2990 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 2990 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 21238 "Photo.c"
	}
#line 2990 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	(*array)[(*length)++] = value;
#line 2990 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	(*array)[*length] = NULL;
#line 21244 "Photo.c"
}


static void _vala_array_add221 (gchar*** array, int* length, int* size, gchar* value) {
#line 2993 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if ((*length) == (*size)) {
#line 2993 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 2993 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 21255 "Photo.c"
	}
#line 2993 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	(*array)[(*length)++] = value;
#line 2993 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	(*array)[*length] = NULL;
#line 21261 "Photo.c"
}


static void _vala_array_add222 (gchar*** array, int* length, int* size, gchar* value) {
#line 2997 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if ((*length) == (*size)) {
#line 2997 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 2997 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 21272 "Photo.c"
	}
#line 2997 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	(*array)[(*length)++] = value;
#line 2997 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	(*array)[*length] = NULL;
#line 21278 "Photo.c"
}


static void _vala_array_add223 (gchar*** array, int* length, int* size, gchar* value) {
#line 2998 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if ((*length) == (*size)) {
#line 2998 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 2998 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 21289 "Photo.c"
	}
#line 2998 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	(*array)[(*length)++] = value;
#line 2998 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	(*array)[*length] = NULL;
#line 21295 "Photo.c"
}


static void _vala_array_add224 (gchar*** array, int* length, int* size, gchar* value) {
#line 3001 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if ((*length) == (*size)) {
#line 3001 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 3001 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 21306 "Photo.c"
	}
#line 3001 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	(*array)[(*length)++] = value;
#line 3001 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	(*array)[*length] = NULL;
#line 21312 "Photo.c"
}


static void photo_update_editable (Photo* self, gboolean only_attributes, PhotoFileReader* new_reader, GError** error) {
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_;
	gboolean _tmp4_;
	gboolean _tmp6_;
	PhotoFileReader* _tmp7_ = NULL;
	PhotoFileReader* old_reader;
	PhotoFileReader* _tmp8_;
	PhotoFileReader* _tmp9_;
	PhotoFileReader* _tmp10_;
	PhotoFileReader* _tmp11_;
	PhotoFileReader* _tmp14_;
	PhotoFileReader* _tmp15_;
	PhotoFileReader* reader;
	PhotoFileReader* _tmp16_;
	BackingPhotoID _tmp17_ = {0};
	BackingPhotoID editable_id;
	PhotoFileReader* _tmp18_;
	GFile* _tmp19_ = NULL;
	GFile* file;
	gboolean timestamp_changed;
	gboolean filesize_changed;
	gboolean _tmp20_;
	PhotoFileReader* _tmp103_;
	gboolean _tmp108_ = FALSE;
	gboolean _tmp109_;
	gboolean _tmp112_;
	gchar** _tmp123_ = NULL;
	gchar** alteration_list;
	gint alteration_list_length1;
	gint _alteration_list_size_;
	gboolean _tmp124_;
	gboolean _tmp132_ = FALSE;
	gboolean _tmp133_;
	gboolean _tmp135_;
	gchar** _tmp143_;
	gint _tmp143__length1;
	GError * _inner_error_ = NULL;
#line 2900 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 2900 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail ((new_reader == NULL) || IS_PHOTO_FILE_READER (new_reader));
#line 2902 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp2_ = only_attributes;
#line 2902 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp2_) {
#line 21363 "Photo.c"
		PhotoFileReader* _tmp3_;
#line 2902 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp3_ = new_reader;
#line 2902 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp1_ = _tmp3_ == NULL;
#line 21369 "Photo.c"
	} else {
#line 2902 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp1_ = FALSE;
#line 21373 "Photo.c"
	}
#line 2902 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp4_ = _tmp1_;
#line 2902 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp4_) {
#line 2902 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp0_ = TRUE;
#line 21381 "Photo.c"
	} else {
		gboolean _tmp5_;
#line 2902 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp5_ = only_attributes;
#line 2902 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp0_ = !_tmp5_;
#line 21388 "Photo.c"
	}
#line 2902 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp6_ = _tmp0_;
#line 2902 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_assert (_tmp6_);
#line 2904 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp7_ = photo_get_editable_reader (self);
#line 2904 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	old_reader = _tmp7_;
#line 2906 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp8_ = new_reader;
#line 2906 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp9_ = _photo_file_adapter_ref0 (_tmp8_);
#line 2906 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp10_ = _tmp9_;
#line 2906 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp11_ = _tmp10_;
#line 2906 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp11_ == NULL) {
#line 21408 "Photo.c"
		PhotoFileReader* _tmp12_;
		PhotoFileReader* _tmp13_;
#line 2906 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp12_ = old_reader;
#line 2906 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp13_ = _photo_file_adapter_ref0 (_tmp12_);
#line 2906 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_photo_file_adapter_unref0 (_tmp10_);
#line 2906 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp10_ = _tmp13_;
#line 21419 "Photo.c"
	}
#line 2906 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp14_ = _tmp10_;
#line 2906 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp15_ = _photo_file_adapter_ref0 (_tmp14_);
#line 2906 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	reader = _tmp15_;
#line 2907 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp16_ = reader;
#line 2907 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp16_ == NULL) {
#line 2908 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		photo_detach_editable (self, FALSE, TRUE);
#line 2910 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_photo_file_adapter_unref0 (reader);
#line 2910 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_photo_file_adapter_unref0 (_tmp10_);
#line 2910 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_photo_file_adapter_unref0 (old_reader);
#line 2910 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return;
#line 21441 "Photo.c"
	}
#line 2913 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	photo_get_editable_id (self, &_tmp17_);
#line 2913 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	editable_id = _tmp17_;
#line 2914 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp18_ = reader;
#line 2914 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp19_ = photo_file_adapter_get_file (PHOTO_FILE_ADAPTER (_tmp18_));
#line 2914 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	file = _tmp19_;
#line 2916 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	timestamp_changed = FALSE;
#line 2917 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	filesize_changed = FALSE;
#line 2918 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp20_ = only_attributes;
#line 2918 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp20_) {
#line 21461 "Photo.c"
		gboolean _tmp21_ = FALSE;
		GFileInfo* info = NULL;
		GTimeVal timestamp = {0};
		GFileInfo* _tmp29_;
		GTimeVal _tmp30_ = {0};
		BackingPhotoTable* _tmp31_ = NULL;
		BackingPhotoTable* _tmp32_;
		BackingPhotoID _tmp33_;
		GTimeVal _tmp34_;
		glong _tmp35_;
		GFileInfo* _tmp36_;
		gint64 _tmp37_ = 0LL;
#line 2919 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp21_ = backing_photo_id_is_valid (&editable_id);
#line 2919 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_assert (_tmp21_);
#line 21478 "Photo.c"
		{
			GFile* _tmp22_;
			GFileInfo* _tmp23_ = NULL;
			GFileInfo* _tmp24_;
#line 2923 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp22_ = file;
#line 2923 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp23_ = g_file_query_filesystem_info (_tmp22_, DIRECTORY_MONITOR_SUPPLIED_ATTRIBUTES, NULL, &_inner_error_);
#line 2923 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp24_ = _tmp23_;
#line 2923 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			if (_inner_error_ != NULL) {
#line 21491 "Photo.c"
				goto __catch212_g_error;
			}
#line 2923 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_g_object_unref0 (info);
#line 2923 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			info = _tmp24_;
#line 21498 "Photo.c"
		}
		goto __finally212;
		__catch212_g_error:
		{
			GError* err = NULL;
			gchar* _tmp25_ = NULL;
			gchar* _tmp26_;
			GError* _tmp27_;
			const gchar* _tmp28_;
#line 2922 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			err = _inner_error_;
#line 2922 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_inner_error_ = NULL;
#line 2925 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp25_ = data_object_to_string (DATA_OBJECT (self));
#line 2925 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp26_ = _tmp25_;
#line 2925 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp27_ = err;
#line 2925 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp28_ = _tmp27_->message;
#line 2925 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_warning ("Photo.vala:2925: Unable to read editable filesystem info for %s: %s", _tmp26_, _tmp28_);
#line 2925 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_g_free0 (_tmp26_);
#line 2926 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			photo_detach_editable (self, FALSE, TRUE);
#line 2928 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_g_error_free0 (err);
#line 2928 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_g_object_unref0 (info);
#line 2928 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_g_object_unref0 (file);
#line 2928 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_photo_file_adapter_unref0 (reader);
#line 2928 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_photo_file_adapter_unref0 (_tmp10_);
#line 2928 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_photo_file_adapter_unref0 (old_reader);
#line 2928 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			return;
#line 21540 "Photo.c"
		}
		__finally212:
#line 2922 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 2922 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 2922 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_g_object_unref0 (info);
#line 2922 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_g_object_unref0 (file);
#line 2922 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_photo_file_adapter_unref0 (reader);
#line 2922 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_photo_file_adapter_unref0 (_tmp10_);
#line 2922 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_photo_file_adapter_unref0 (old_reader);
#line 2922 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			return;
#line 21559 "Photo.c"
		}
#line 2932 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp29_ = info;
#line 2932 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_file_info_get_modification_time (_tmp29_, &_tmp30_);
#line 2932 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		timestamp = _tmp30_;
#line 2934 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp31_ = backing_photo_table_get_instance ();
#line 2934 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp32_ = _tmp31_;
#line 2934 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp33_ = editable_id;
#line 2934 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp34_ = timestamp;
#line 2934 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp35_ = _tmp34_.tv_sec;
#line 2934 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp36_ = info;
#line 2934 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp37_ = g_file_info_get_size (_tmp36_);
#line 2934 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		backing_photo_table_update_attributes (_tmp32_, &_tmp33_, (time_t) _tmp35_, _tmp37_, &_inner_error_);
#line 2934 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_database_table_unref0 (_tmp32_);
#line 2934 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 2934 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 2934 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_g_object_unref0 (info);
#line 2934 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_g_object_unref0 (file);
#line 2934 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_photo_file_adapter_unref0 (reader);
#line 2934 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_photo_file_adapter_unref0 (_tmp10_);
#line 2934 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_photo_file_adapter_unref0 (old_reader);
#line 2934 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			return;
#line 21601 "Photo.c"
		}
		{
			PhotoRow _tmp38_;
#line 2936 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp38_ = self->priv->row;
#line 2936 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 21609 "Photo.c"
			{
				BackingPhotoState _tmp39_;
				time_t _tmp40_;
				GTimeVal _tmp41_;
				glong _tmp42_;
				BackingPhotoState _tmp43_;
				gint64 _tmp44_;
				GFileInfo* _tmp45_;
				gint64 _tmp46_ = 0LL;
				GTimeVal _tmp47_;
				glong _tmp48_;
				GFileInfo* _tmp49_;
				gint64 _tmp50_ = 0LL;
#line 2937 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp39_ = self->priv->editable;
#line 2937 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp40_ = _tmp39_.timestamp;
#line 2937 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp41_ = timestamp;
#line 2937 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp42_ = _tmp41_.tv_sec;
#line 2937 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				timestamp_changed = _tmp40_ != ((time_t) _tmp42_);
#line 2938 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp43_ = self->priv->editable;
#line 2938 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp44_ = _tmp43_.filesize;
#line 2938 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp45_ = info;
#line 2938 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp46_ = g_file_info_get_size (_tmp45_);
#line 2938 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				filesize_changed = _tmp44_ != _tmp46_;
#line 2940 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp47_ = timestamp;
#line 2940 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp48_ = _tmp47_.tv_sec;
#line 2940 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				self->priv->editable.timestamp = (time_t) _tmp48_;
#line 2941 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp49_ = info;
#line 2941 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp50_ = g_file_info_get_size (_tmp49_);
#line 2941 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				self->priv->editable.filesize = _tmp50_;
#line 21655 "Photo.c"
			}
			__finally213:
			{
				PhotoRow _tmp51_;
#line 2936 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp51_ = self->priv->row;
#line 2936 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 21664 "Photo.c"
			}
#line 2936 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			if (_inner_error_ != NULL) {
#line 2936 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				g_propagate_error (error, _inner_error_);
#line 2936 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_g_object_unref0 (info);
#line 2936 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_g_object_unref0 (file);
#line 2936 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_photo_file_adapter_unref0 (reader);
#line 2936 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_photo_file_adapter_unref0 (_tmp10_);
#line 2936 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_photo_file_adapter_unref0 (old_reader);
#line 2936 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				return;
#line 21682 "Photo.c"
			}
		}
#line 2918 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_object_unref0 (info);
#line 21687 "Photo.c"
	} else {
		BackingPhotoState state = {0};
		DetectedPhotoInformation* detected = NULL;
		GFile* _tmp52_;
		BackingPhotoState _tmp53_ = {0};
		DetectedPhotoInformation* _tmp54_ = NULL;
		gboolean _tmp55_ = FALSE;
		gboolean _tmp56_;
#line 2944 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		memset (&state, 0, sizeof (BackingPhotoState));
#line 2946 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp52_ = file;
#line 2946 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp55_ = photo_query_backing_photo_state (self, _tmp52_, PHOTO_FILE_SNIFFER_OPTIONS_NO_MD5, &_tmp53_, &_tmp54_, &_inner_error_);
#line 2946 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		backing_photo_state_destroy (&state);
#line 2946 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		state = _tmp53_;
#line 2946 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 2946 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		detected = _tmp54_;
#line 2946 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp56_ = _tmp55_;
#line 2946 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 2946 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 2946 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_detected_photo_information_unref0 (detected);
#line 2946 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			backing_photo_state_destroy (&state);
#line 2946 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_g_object_unref0 (file);
#line 2946 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_photo_file_adapter_unref0 (reader);
#line 2946 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_photo_file_adapter_unref0 (_tmp10_);
#line 2946 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_photo_file_adapter_unref0 (old_reader);
#line 2946 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			return;
#line 21730 "Photo.c"
		}
#line 2946 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		if (_tmp56_) {
#line 21734 "Photo.c"
			gboolean _tmp57_ = FALSE;
#line 2949 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp57_ = backing_photo_id_is_valid (&editable_id);
#line 2949 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			if (_tmp57_) {
#line 21740 "Photo.c"
				BackingPhotoTable* _tmp58_ = NULL;
				BackingPhotoTable* _tmp59_;
				BackingPhotoID _tmp60_;
				BackingPhotoState _tmp61_;
#line 2950 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp58_ = backing_photo_table_get_instance ();
#line 2950 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp59_ = _tmp58_;
#line 2950 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp60_ = editable_id;
#line 2950 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp61_ = state;
#line 2950 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				backing_photo_table_update (_tmp59_, &_tmp60_, &_tmp61_, &_inner_error_);
#line 2950 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_database_table_unref0 (_tmp59_);
#line 2950 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				if (_inner_error_ != NULL) {
#line 2950 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					g_propagate_error (error, _inner_error_);
#line 2950 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_detected_photo_information_unref0 (detected);
#line 2950 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					backing_photo_state_destroy (&state);
#line 2950 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_g_object_unref0 (file);
#line 2950 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_photo_file_adapter_unref0 (reader);
#line 2950 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_photo_file_adapter_unref0 (_tmp10_);
#line 2950 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_photo_file_adapter_unref0 (old_reader);
#line 2950 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					return;
#line 21775 "Photo.c"
				}
				{
					PhotoRow _tmp62_;
#line 2951 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_tmp62_ = self->priv->row;
#line 2951 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 21783 "Photo.c"
					{
						BackingPhotoState _tmp63_;
						time_t _tmp64_;
						BackingPhotoState _tmp65_;
						time_t _tmp66_;
						BackingPhotoState _tmp67_;
						gint64 _tmp68_;
						BackingPhotoState _tmp69_;
						gint64 _tmp70_;
						BackingPhotoState _tmp71_;
						BackingPhotoState _tmp72_ = {0};
						BackingPhotoState* _tmp73_;
						BackingPhotoState* _tmp74_;
						Orientation _tmp75_;
#line 2952 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						_tmp63_ = self->priv->editable;
#line 2952 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						_tmp64_ = _tmp63_.timestamp;
#line 2952 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						_tmp65_ = state;
#line 2952 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						_tmp66_ = _tmp65_.timestamp;
#line 2952 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						timestamp_changed = _tmp64_ != _tmp66_;
#line 2953 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						_tmp67_ = self->priv->editable;
#line 2953 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						_tmp68_ = _tmp67_.filesize;
#line 2953 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						_tmp69_ = state;
#line 2953 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						_tmp70_ = _tmp69_.filesize;
#line 2953 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						filesize_changed = _tmp68_ != _tmp70_;
#line 2955 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						_tmp71_ = state;
#line 2955 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						backing_photo_state_copy (&_tmp71_, &_tmp72_);
#line 2955 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						backing_photo_state_destroy (&self->priv->editable);
#line 2955 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						self->priv->editable = _tmp72_;
#line 2956 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						_tmp73_ = self->priv->backing_photo_state;
#line 2956 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						g_assert (_tmp73_ == (&self->priv->editable));
#line 2957 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						_tmp74_ = self->priv->backing_photo_state;
#line 2957 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						_tmp75_ = (*_tmp74_).original_orientation;
#line 2957 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						photo_set_orientation (self, _tmp75_);
#line 21836 "Photo.c"
					}
					__finally214:
					{
						PhotoRow _tmp76_;
#line 2951 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						_tmp76_ = self->priv->row;
#line 2951 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 21845 "Photo.c"
					}
#line 2951 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					if (_inner_error_ != NULL) {
#line 2951 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						g_propagate_error (error, _inner_error_);
#line 2951 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						_detected_photo_information_unref0 (detected);
#line 2951 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						backing_photo_state_destroy (&state);
#line 2951 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						_g_object_unref0 (file);
#line 2951 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						_photo_file_adapter_unref0 (reader);
#line 2951 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						_photo_file_adapter_unref0 (_tmp10_);
#line 2951 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						_photo_file_adapter_unref0 (old_reader);
#line 2951 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						return;
#line 21865 "Photo.c"
					}
				}
			} else {
				BackingPhotoTable* _tmp77_ = NULL;
				BackingPhotoTable* _tmp78_;
				BackingPhotoState _tmp79_;
				BackingPhotoRow _tmp80_ = {0};
				BackingPhotoRow _tmp81_;
				BackingPhotoRow editable_row;
#line 2960 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp77_ = backing_photo_table_get_instance ();
#line 2960 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp78_ = _tmp77_;
#line 2960 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp79_ = state;
#line 2960 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				backing_photo_table_add (_tmp78_, &_tmp79_, &_tmp80_, &_inner_error_);
#line 2960 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp81_ = _tmp80_;
#line 2960 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_database_table_unref0 (_tmp78_);
#line 2960 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				editable_row = _tmp81_;
#line 2960 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				if (_inner_error_ != NULL) {
#line 2960 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					g_propagate_error (error, _inner_error_);
#line 2960 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_detected_photo_information_unref0 (detected);
#line 2960 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					backing_photo_state_destroy (&state);
#line 2960 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_g_object_unref0 (file);
#line 2960 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_photo_file_adapter_unref0 (reader);
#line 2960 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_photo_file_adapter_unref0 (_tmp10_);
#line 2960 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_photo_file_adapter_unref0 (old_reader);
#line 2960 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					return;
#line 21907 "Photo.c"
				}
				{
					PhotoRow _tmp82_;
#line 2961 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_tmp82_ = self->priv->row;
#line 2961 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 21915 "Photo.c"
					{
						BackingPhotoRow _tmp83_;
						BackingPhotoState _tmp84_;
						time_t _tmp85_;
						BackingPhotoState _tmp86_;
						time_t _tmp87_;
						BackingPhotoRow _tmp88_;
						BackingPhotoState _tmp89_;
						gint64 _tmp90_;
						BackingPhotoState _tmp91_;
						gint64 _tmp92_;
						PhotoTable* _tmp93_ = NULL;
						PhotoTable* _tmp94_;
						BackingPhotoRow _tmp95_;
						BackingPhotoID _tmp96_;
						BackingPhotoRow _tmp97_;
						BackingPhotoState _tmp98_;
						BackingPhotoState _tmp99_ = {0};
						BackingPhotoState* _tmp100_;
						Orientation _tmp101_;
#line 2962 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						_tmp83_ = editable_row;
#line 2962 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						_tmp84_ = _tmp83_.state;
#line 2962 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						_tmp85_ = _tmp84_.timestamp;
#line 2962 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						_tmp86_ = state;
#line 2962 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						_tmp87_ = _tmp86_.timestamp;
#line 2962 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						timestamp_changed = _tmp85_ != _tmp87_;
#line 2963 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						_tmp88_ = editable_row;
#line 2963 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						_tmp89_ = _tmp88_.state;
#line 2963 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						_tmp90_ = _tmp89_.filesize;
#line 2963 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						_tmp91_ = state;
#line 2963 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						_tmp92_ = _tmp91_.filesize;
#line 2963 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						filesize_changed = _tmp90_ != _tmp92_;
#line 2965 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						_tmp93_ = photo_table_get_instance ();
#line 2965 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						_tmp94_ = _tmp93_;
#line 2965 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						_tmp95_ = editable_row;
#line 2965 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						_tmp96_ = _tmp95_.id;
#line 2965 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						photo_table_attach_editable (_tmp94_, &self->priv->row, &_tmp96_, &_inner_error_);
#line 2965 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						_database_table_unref0 (_tmp94_);
#line 2965 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						if (_inner_error_ != NULL) {
#line 21974 "Photo.c"
							goto __finally215;
						}
#line 2966 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						_tmp97_ = editable_row;
#line 2966 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						_tmp98_ = _tmp97_.state;
#line 2966 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						backing_photo_state_copy (&_tmp98_, &_tmp99_);
#line 2966 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						backing_photo_state_destroy (&self->priv->editable);
#line 2966 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						self->priv->editable = _tmp99_;
#line 2967 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						self->priv->backing_photo_state = &self->priv->editable;
#line 2968 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						_tmp100_ = self->priv->backing_photo_state;
#line 2968 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						_tmp101_ = (*_tmp100_).original_orientation;
#line 2968 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						photo_set_orientation (self, _tmp101_);
#line 21995 "Photo.c"
					}
					__finally215:
					{
						PhotoRow _tmp102_;
#line 2961 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						_tmp102_ = self->priv->row;
#line 2961 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 22004 "Photo.c"
					}
#line 2961 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					if (_inner_error_ != NULL) {
#line 2961 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						g_propagate_error (error, _inner_error_);
#line 2961 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						backing_photo_row_destroy (&editable_row);
#line 2961 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						_detected_photo_information_unref0 (detected);
#line 2961 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						backing_photo_state_destroy (&state);
#line 2961 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						_g_object_unref0 (file);
#line 2961 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						_photo_file_adapter_unref0 (reader);
#line 2961 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						_photo_file_adapter_unref0 (_tmp10_);
#line 2961 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						_photo_file_adapter_unref0 (old_reader);
#line 2961 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						return;
#line 22026 "Photo.c"
					}
				}
#line 2949 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				backing_photo_row_destroy (&editable_row);
#line 22031 "Photo.c"
			}
		}
#line 2918 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 2918 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		backing_photo_state_destroy (&state);
#line 22038 "Photo.c"
	}
#line 2975 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp103_ = new_reader;
#line 2975 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp103_ != NULL) {
#line 22044 "Photo.c"
		{
			PhotoBackingReaders _tmp104_;
#line 2976 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp104_ = self->priv->readers;
#line 2976 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_static_rec_mutex_lock (&self->priv->__lock_readers);
#line 22051 "Photo.c"
			{
				PhotoFileReader* _tmp105_;
				PhotoFileReader* _tmp106_;
#line 2977 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp105_ = new_reader;
#line 2977 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp106_ = _photo_file_adapter_ref0 (_tmp105_);
#line 2977 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_photo_file_adapter_unref0 (self->priv->readers.editable);
#line 2977 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				self->priv->readers.editable = _tmp106_;
#line 22063 "Photo.c"
			}
			__finally216:
			{
				PhotoBackingReaders _tmp107_;
#line 2976 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp107_ = self->priv->readers;
#line 2976 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				g_static_rec_mutex_unlock (&self->priv->__lock_readers);
#line 22072 "Photo.c"
			}
#line 2976 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			if (_inner_error_ != NULL) {
#line 2976 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				g_propagate_error (error, _inner_error_);
#line 2976 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_g_object_unref0 (file);
#line 2976 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_photo_file_adapter_unref0 (reader);
#line 2976 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_photo_file_adapter_unref0 (_tmp10_);
#line 2976 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_photo_file_adapter_unref0 (old_reader);
#line 2976 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				return;
#line 22088 "Photo.c"
			}
		}
	}
#line 2981 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp109_ = only_attributes;
#line 2981 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (!_tmp109_) {
#line 22096 "Photo.c"
		PhotoFileReader* _tmp110_;
		PhotoFileReader* _tmp111_;
#line 2981 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp110_ = reader;
#line 2981 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp111_ = old_reader;
#line 2981 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp108_ = _tmp110_ != _tmp111_;
#line 22105 "Photo.c"
	} else {
#line 2981 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp108_ = FALSE;
#line 22109 "Photo.c"
	}
#line 2981 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp112_ = _tmp108_;
#line 2981 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp112_) {
#line 22115 "Photo.c"
		GFile* _tmp113_ = NULL;
		PhotoFileReader* _tmp114_;
		GFile* _tmp117_ = NULL;
		PhotoFileReader* _tmp118_;
		GFile* _tmp121_;
		GFile* _tmp122_;
#line 2982 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		photo_notify_baseline_replaced (self);
#line 2983 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp114_ = old_reader;
#line 2983 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		if (_tmp114_ != NULL) {
#line 22128 "Photo.c"
			PhotoFileReader* _tmp115_;
			GFile* _tmp116_ = NULL;
#line 2983 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp115_ = old_reader;
#line 2983 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp116_ = photo_file_adapter_get_file (PHOTO_FILE_ADAPTER (_tmp115_));
#line 2983 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_g_object_unref0 (_tmp113_);
#line 2983 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp113_ = _tmp116_;
#line 22139 "Photo.c"
		} else {
#line 2983 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_g_object_unref0 (_tmp113_);
#line 2983 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp113_ = NULL;
#line 22145 "Photo.c"
		}
#line 2984 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp118_ = new_reader;
#line 2984 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		if (_tmp118_ != NULL) {
#line 22151 "Photo.c"
			PhotoFileReader* _tmp119_;
			GFile* _tmp120_ = NULL;
#line 2984 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp119_ = new_reader;
#line 2984 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp120_ = photo_file_adapter_get_file (PHOTO_FILE_ADAPTER (_tmp119_));
#line 2984 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_g_object_unref0 (_tmp117_);
#line 2984 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp117_ = _tmp120_;
#line 22162 "Photo.c"
		} else {
#line 2984 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_g_object_unref0 (_tmp117_);
#line 2984 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp117_ = NULL;
#line 22168 "Photo.c"
		}
#line 2983 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp121_ = _tmp113_;
#line 2983 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp122_ = _tmp117_;
#line 2983 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		photo_notify_editable_replaced (self, _tmp121_, _tmp122_);
#line 2981 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_object_unref0 (_tmp117_);
#line 2981 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_object_unref0 (_tmp113_);
#line 22180 "Photo.c"
	}
#line 2987 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp123_ = g_new0 (gchar*, 0 + 1);
#line 2987 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	alteration_list = _tmp123_;
#line 2987 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	alteration_list_length1 = 0;
#line 2987 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_alteration_list_size_ = alteration_list_length1;
#line 2988 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp124_ = timestamp_changed;
#line 2988 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp124_) {
#line 22194 "Photo.c"
		gchar** _tmp125_;
		gint _tmp125__length1;
		gchar* _tmp126_;
		gchar** _tmp127_;
		gint _tmp127__length1;
		gchar* _tmp128_;
		gboolean _tmp129_ = FALSE;
#line 2989 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp125_ = alteration_list;
#line 2989 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp125__length1 = alteration_list_length1;
#line 2989 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp126_ = g_strdup ("metadata:editable-timestamp");
#line 2989 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_vala_array_add219 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp126_);
#line 2990 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp127_ = alteration_list;
#line 2990 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp127__length1 = alteration_list_length1;
#line 2990 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp128_ = g_strdup ("metadata:baseline-timestamp");
#line 2990 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_vala_array_add220 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp128_);
#line 2992 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp129_ = photo_is_editable_source (self);
#line 2992 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		if (_tmp129_) {
#line 22222 "Photo.c"
			gchar** _tmp130_;
			gint _tmp130__length1;
			gchar* _tmp131_;
#line 2993 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp130_ = alteration_list;
#line 2993 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp130__length1 = alteration_list_length1;
#line 2993 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp131_ = g_strdup ("metadata:source-timestamp");
#line 2993 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_vala_array_add221 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp131_);
#line 22234 "Photo.c"
		}
	}
#line 2996 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp133_ = filesize_changed;
#line 2996 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp133_) {
#line 2996 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp132_ = TRUE;
#line 22243 "Photo.c"
	} else {
		PhotoFileReader* _tmp134_;
#line 2996 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp134_ = new_reader;
#line 2996 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp132_ = _tmp134_ != NULL;
#line 22250 "Photo.c"
	}
#line 2996 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp135_ = _tmp132_;
#line 2996 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp135_) {
#line 22256 "Photo.c"
		gchar** _tmp136_;
		gint _tmp136__length1;
		gchar* _tmp137_;
		gchar** _tmp138_;
		gint _tmp138__length1;
		gchar* _tmp139_;
		gboolean _tmp140_ = FALSE;
#line 2997 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp136_ = alteration_list;
#line 2997 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp136__length1 = alteration_list_length1;
#line 2997 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp137_ = g_strdup ("image:editable");
#line 2997 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_vala_array_add222 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp137_);
#line 2998 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp138_ = alteration_list;
#line 2998 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp138__length1 = alteration_list_length1;
#line 2998 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp139_ = g_strdup ("image:baseline");
#line 2998 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_vala_array_add223 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp139_);
#line 3000 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp140_ = photo_is_editable_source (self);
#line 3000 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		if (_tmp140_) {
#line 22284 "Photo.c"
			gchar** _tmp141_;
			gint _tmp141__length1;
			gchar* _tmp142_;
#line 3001 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp141_ = alteration_list;
#line 3001 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp141__length1 = alteration_list_length1;
#line 3001 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp142_ = g_strdup ("image:source");
#line 3001 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_vala_array_add224 (&alteration_list, &alteration_list_length1, &_alteration_list_size_, _tmp142_);
#line 22296 "Photo.c"
		}
	}
#line 3004 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp143_ = alteration_list;
#line 3004 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp143__length1 = alteration_list_length1;
#line 3004 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp143__length1 > 0) {
#line 22305 "Photo.c"
		gchar** _tmp144_;
		gint _tmp144__length1;
		Alteration* _tmp145_;
		Alteration* _tmp146_;
#line 3005 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp144_ = alteration_list;
#line 3005 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp144__length1 = alteration_list_length1;
#line 3005 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp145_ = alteration_new_from_array (_tmp144_, _tmp144__length1);
#line 3005 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp146_ = _tmp145_;
#line 3005 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		data_object_notify_altered (DATA_OBJECT (self), _tmp146_);
#line 3005 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_alteration_unref0 (_tmp146_);
#line 22322 "Photo.c"
	}
#line 2900 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	alteration_list = (_vala_array_free (alteration_list, alteration_list_length1, (GDestroyNotify) g_free), NULL);
#line 2900 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_g_object_unref0 (file);
#line 2900 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_photo_file_adapter_unref0 (reader);
#line 2900 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_photo_file_adapter_unref0 (_tmp10_);
#line 2900 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_photo_file_adapter_unref0 (old_reader);
#line 22334 "Photo.c"
}


static void photo_detach_editable (Photo* self, gboolean delete_editable, gboolean remove_transformations) {
	gboolean has_editable;
	GFile* editable_file;
	gboolean _tmp7_;
	gboolean _tmp23_;
	gboolean _tmp24_;
	gboolean _tmp26_ = FALSE;
	gboolean _tmp27_;
	gboolean _tmp29_;
	gboolean _tmp38_ = FALSE;
	gboolean _tmp39_;
	gboolean _tmp41_;
	GError * _inner_error_ = NULL;
#line 3008 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 3009 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	photo_halt_monitoring_editable (self);
#line 3011 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	has_editable = FALSE;
#line 3012 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	editable_file = NULL;
#line 22359 "Photo.c"
	{
		PhotoBackingReaders _tmp0_;
#line 3013 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 3013 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_readers);
#line 22366 "Photo.c"
		{
			PhotoBackingReaders _tmp1_;
			PhotoFileReader* _tmp2_;
#line 3014 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp1_ = self->priv->readers;
#line 3014 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp2_ = _tmp1_.editable;
#line 3014 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			if (_tmp2_ != NULL) {
#line 22376 "Photo.c"
				PhotoBackingReaders _tmp3_;
				PhotoFileReader* _tmp4_;
				GFile* _tmp5_ = NULL;
#line 3015 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp3_ = self->priv->readers;
#line 3015 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp4_ = _tmp3_.editable;
#line 3015 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp5_ = photo_file_adapter_get_file (PHOTO_FILE_ADAPTER (_tmp4_));
#line 3015 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_g_object_unref0 (editable_file);
#line 3015 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				editable_file = _tmp5_;
#line 3016 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_photo_file_adapter_unref0 (self->priv->readers.editable);
#line 3016 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				self->priv->readers.editable = NULL;
#line 3017 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				has_editable = TRUE;
#line 22396 "Photo.c"
			}
		}
		__finally217:
		{
			PhotoBackingReaders _tmp6_;
#line 3013 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp6_ = self->priv->readers;
#line 3013 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_readers);
#line 22406 "Photo.c"
		}
#line 3013 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 3013 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_g_object_unref0 (editable_file);
#line 3013 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 3013 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 3013 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			return;
#line 22418 "Photo.c"
		}
	}
#line 3021 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp7_ = has_editable;
#line 3021 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp7_) {
#line 22425 "Photo.c"
		BackingPhotoID editable_id = {0};
#line 3022 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		backing_photo_id_init (&editable_id, BACKING_PHOTO_ID_INVALID);
#line 22429 "Photo.c"
		{
			{
				PhotoRow _tmp8_;
#line 3024 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp8_ = self->priv->row;
#line 3024 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 22437 "Photo.c"
				{
					PhotoRow _tmp9_;
					BackingPhotoID _tmp10_;
					gboolean _tmp11_ = FALSE;
#line 3025 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_tmp9_ = self->priv->row;
#line 3025 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_tmp10_ = _tmp9_.editable_id;
#line 3025 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					editable_id = _tmp10_;
#line 3026 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_tmp11_ = backing_photo_id_is_valid (&editable_id);
#line 3026 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					if (_tmp11_) {
#line 22452 "Photo.c"
						PhotoTable* _tmp12_ = NULL;
						PhotoTable* _tmp13_;
#line 3027 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						_tmp12_ = photo_table_get_instance ();
#line 3027 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						_tmp13_ = _tmp12_;
#line 3027 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						photo_table_detach_editable (_tmp13_, &self->priv->row, &_inner_error_);
#line 3027 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						_database_table_unref0 (_tmp13_);
#line 3027 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						if (_inner_error_ != NULL) {
#line 22465 "Photo.c"
							goto __finally219;
						}
					}
#line 3028 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					self->priv->backing_photo_state = &self->priv->row.master;
#line 22471 "Photo.c"
				}
				__finally219:
				{
					PhotoRow _tmp14_;
#line 3024 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_tmp14_ = self->priv->row;
#line 3024 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 22480 "Photo.c"
				}
#line 3024 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				if (_inner_error_ != NULL) {
#line 3024 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					if (_inner_error_->domain == DATABASE_ERROR) {
#line 22486 "Photo.c"
						goto __catch218_database_error;
					}
#line 3024 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_g_object_unref0 (editable_file);
#line 3024 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 3024 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					g_clear_error (&_inner_error_);
#line 3024 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					return;
#line 22497 "Photo.c"
				}
			}
		}
		goto __finally218;
		__catch218_database_error:
		{
			GError* err = NULL;
			GError* _tmp15_;
			const gchar* _tmp16_;
#line 3023 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			err = _inner_error_;
#line 3023 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_inner_error_ = NULL;
#line 3031 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp15_ = err;
#line 3031 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp16_ = _tmp15_->message;
#line 3031 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_warning ("Photo.vala:3031: Unable to remove editable from PhotoTable: %s", _tmp16_);
#line 3023 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_g_error_free0 (err);
#line 22519 "Photo.c"
		}
		__finally218:
#line 3023 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 3023 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_g_object_unref0 (editable_file);
#line 3023 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 3023 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 3023 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			return;
#line 22532 "Photo.c"
		}
		{
			gboolean _tmp17_ = FALSE;
#line 3035 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp17_ = backing_photo_id_is_valid (&editable_id);
#line 3035 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			if (_tmp17_) {
#line 22540 "Photo.c"
				BackingPhotoTable* _tmp18_ = NULL;
				BackingPhotoTable* _tmp19_;
				BackingPhotoID _tmp20_;
#line 3036 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp18_ = backing_photo_table_get_instance ();
#line 3036 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp19_ = _tmp18_;
#line 3036 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp20_ = editable_id;
#line 3036 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				backing_photo_table_remove (_tmp19_, &_tmp20_, &_inner_error_);
#line 3036 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_database_table_unref0 (_tmp19_);
#line 3036 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				if (_inner_error_ != NULL) {
#line 3036 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					if (_inner_error_->domain == DATABASE_ERROR) {
#line 22558 "Photo.c"
						goto __catch220_database_error;
					}
#line 3036 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_g_object_unref0 (editable_file);
#line 3036 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 3036 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					g_clear_error (&_inner_error_);
#line 3036 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					return;
#line 22569 "Photo.c"
				}
			}
		}
		goto __finally220;
		__catch220_database_error:
		{
			GError* err = NULL;
			GError* _tmp21_;
			const gchar* _tmp22_;
#line 3034 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			err = _inner_error_;
#line 3034 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_inner_error_ = NULL;
#line 3038 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp21_ = err;
#line 3038 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp22_ = _tmp21_->message;
#line 3038 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_warning ("Photo.vala:3038: Unable to remove editable from BackingPhotoTable: %s", _tmp22_);
#line 3034 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_g_error_free0 (err);
#line 22591 "Photo.c"
		}
		__finally220:
#line 3034 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 3034 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_g_object_unref0 (editable_file);
#line 3034 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 3034 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 3034 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			return;
#line 22604 "Photo.c"
		}
	}
#line 3042 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp23_ = remove_transformations;
#line 3042 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp23_) {
#line 3043 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		photo_internal_remove_all_transformations (self, FALSE);
#line 22613 "Photo.c"
	}
#line 3045 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp24_ = has_editable;
#line 3045 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp24_) {
#line 22619 "Photo.c"
		GFile* _tmp25_;
#line 3046 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		photo_notify_baseline_replaced (self);
#line 3047 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp25_ = editable_file;
#line 3047 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		photo_notify_editable_replaced (self, _tmp25_, NULL);
#line 22627 "Photo.c"
	}
#line 3050 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp27_ = delete_editable;
#line 3050 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp27_) {
#line 22633 "Photo.c"
		GFile* _tmp28_;
#line 3050 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp28_ = editable_file;
#line 3050 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp26_ = _tmp28_ != NULL;
#line 22639 "Photo.c"
	} else {
#line 3050 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp26_ = FALSE;
#line 22643 "Photo.c"
	}
#line 3050 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp29_ = _tmp26_;
#line 3050 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp29_) {
#line 22649 "Photo.c"
		{
			GFile* _tmp30_;
#line 3052 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp30_ = editable_file;
#line 3052 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_file_trash (_tmp30_, NULL, &_inner_error_);
#line 3052 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			if (_inner_error_ != NULL) {
#line 22658 "Photo.c"
				goto __catch221_g_error;
			}
		}
		goto __finally221;
		__catch221_g_error:
		{
			GError* err = NULL;
			GFile* _tmp31_;
			gchar* _tmp32_ = NULL;
			gchar* _tmp33_;
			gchar* _tmp34_ = NULL;
			gchar* _tmp35_;
			GError* _tmp36_;
			const gchar* _tmp37_;
#line 3051 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			err = _inner_error_;
#line 3051 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_inner_error_ = NULL;
#line 3054 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp31_ = editable_file;
#line 3054 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp32_ = g_file_get_path (_tmp31_);
#line 3054 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp33_ = _tmp32_;
#line 3054 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp34_ = data_object_to_string (DATA_OBJECT (self));
#line 3054 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp35_ = _tmp34_;
#line 3054 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp36_ = err;
#line 3054 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp37_ = _tmp36_->message;
#line 3054 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_warning ("Photo.vala:3054: Unable to trash editable %s for %s: %s", _tmp33_, _tmp35_, _tmp37_);
#line 3054 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_g_free0 (_tmp35_);
#line 3054 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_g_free0 (_tmp33_);
#line 3051 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_g_error_free0 (err);
#line 22699 "Photo.c"
		}
		__finally221:
#line 3051 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 3051 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_g_object_unref0 (editable_file);
#line 3051 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 3051 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 3051 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			return;
#line 22712 "Photo.c"
		}
	}
#line 3059 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp39_ = has_editable;
#line 3059 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp39_) {
#line 3059 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp38_ = TRUE;
#line 22721 "Photo.c"
	} else {
		gboolean _tmp40_;
#line 3059 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp40_ = remove_transformations;
#line 3059 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp38_ = _tmp40_;
#line 22728 "Photo.c"
	}
#line 3059 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp41_ = _tmp38_;
#line 3059 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp41_) {
#line 22734 "Photo.c"
		Alteration* _tmp42_;
		Alteration* _tmp43_;
#line 3060 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp42_ = alteration_new ("image", "revert");
#line 3060 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp43_ = _tmp42_;
#line 3060 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		data_object_notify_altered (DATA_OBJECT (self), _tmp43_);
#line 3060 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_alteration_unref0 (_tmp43_);
#line 22745 "Photo.c"
	}
#line 3008 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_g_object_unref0 (editable_file);
#line 22749 "Photo.c"
}


static void _photo_on_reimport_editable_one_shot_callback (gpointer self) {
#line 3075 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	photo_on_reimport_editable (self);
#line 22756 "Photo.c"
}


static void _photo_on_update_editable_attributes_one_shot_callback (gpointer self) {
#line 3084 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	photo_on_update_editable_attributes (self);
#line 22763 "Photo.c"
}


static void _photo_on_remove_editable_one_shot_callback (gpointer self) {
#line 3093 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	photo_on_remove_editable (self);
#line 22770 "Photo.c"
}


static void photo_on_editable_file_changed (Photo* self, GFile* file, GFile* other_file, GFileMonitorEvent event) {
	GFileMonitorEvent _tmp12_;
	GEnumValue* _tmp13_;
	GFile* _tmp14_;
	gchar* _tmp15_ = NULL;
	gchar* _tmp16_;
	GFileMonitorEvent _tmp17_;
	GError * _inner_error_ = NULL;
#line 3063 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 3063 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail (G_IS_FILE (file));
#line 3063 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail ((other_file == NULL) || G_IS_FILE (other_file));
#line 22788 "Photo.c"
	{
		PhotoBackingReaders _tmp0_;
#line 3065 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp0_ = self->priv->readers;
#line 3065 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_readers);
#line 22795 "Photo.c"
		{
			gboolean _tmp1_ = FALSE;
			PhotoBackingReaders _tmp2_;
			PhotoFileReader* _tmp3_;
			gboolean _tmp10_;
#line 3066 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp2_ = self->priv->readers;
#line 3066 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp3_ = _tmp2_.editable;
#line 3066 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			if (_tmp3_ != NULL) {
#line 22807 "Photo.c"
				GFile* _tmp4_;
				PhotoBackingReaders _tmp5_;
				PhotoFileReader* _tmp6_;
				GFile* _tmp7_ = NULL;
				GFile* _tmp8_;
				gboolean _tmp9_ = FALSE;
#line 3066 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp4_ = file;
#line 3066 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp5_ = self->priv->readers;
#line 3066 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp6_ = _tmp5_.editable;
#line 3066 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp7_ = photo_file_adapter_get_file (PHOTO_FILE_ADAPTER (_tmp6_));
#line 3066 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp8_ = _tmp7_;
#line 3066 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp9_ = g_file_equal (_tmp4_, _tmp8_);
#line 3066 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp1_ = _tmp9_;
#line 3066 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_g_object_unref0 (_tmp8_);
#line 22830 "Photo.c"
			} else {
#line 3066 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp1_ = FALSE;
#line 22834 "Photo.c"
			}
#line 3066 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp10_ = _tmp1_;
#line 3066 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_assert (_tmp10_);
#line 22840 "Photo.c"
		}
		__finally222:
		{
			PhotoBackingReaders _tmp11_;
#line 3065 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp11_ = self->priv->readers;
#line 3065 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_readers);
#line 22849 "Photo.c"
		}
#line 3065 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 3065 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 3065 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 3065 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			return;
#line 22859 "Photo.c"
		}
	}
#line 3069 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp12_ = event;
#line 3069 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp13_ = g_enum_get_value (g_type_class_ref (G_TYPE_FILE_MONITOR_EVENT), _tmp12_);
#line 3069 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp14_ = file;
#line 3069 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp15_ = g_file_get_path (_tmp14_);
#line 3069 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp16_ = _tmp15_;
#line 3069 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_debug ("Photo.vala:3069: EDITABLE %s: %s", (_tmp13_ != NULL) ? _tmp13_->value_name : NULL, _tmp16_);
#line 3069 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_g_free0 (_tmp16_);
#line 3071 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp17_ = event;
#line 3071 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	switch (_tmp17_) {
#line 3071 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		case G_FILE_MONITOR_EVENT_CHANGED:
#line 3071 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		case G_FILE_MONITOR_EVENT_CREATED:
#line 22884 "Photo.c"
		{
			OneShotScheduler* _tmp18_;
			OneShotScheduler* _tmp20_;
#line 3074 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp18_ = self->priv->reimport_editable_scheduler;
#line 3074 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			if (_tmp18_ == NULL) {
#line 22892 "Photo.c"
				OneShotScheduler* _tmp19_;
#line 3075 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp19_ = one_shot_scheduler_new ("Photo.reimport_editable", _photo_on_reimport_editable_one_shot_callback, self);
#line 3075 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_one_shot_scheduler_unref0 (self->priv->reimport_editable_scheduler);
#line 3075 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				self->priv->reimport_editable_scheduler = _tmp19_;
#line 22900 "Photo.c"
			}
#line 3079 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp20_ = self->priv->reimport_editable_scheduler;
#line 3079 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			one_shot_scheduler_after_timeout (_tmp20_, (guint) 1000, TRUE);
#line 3080 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			break;
#line 22908 "Photo.c"
		}
#line 3071 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		case G_FILE_MONITOR_EVENT_ATTRIBUTE_CHANGED:
#line 22912 "Photo.c"
		{
			OneShotScheduler* _tmp21_;
			OneShotScheduler* _tmp23_;
#line 3083 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp21_ = self->priv->update_editable_attributes_scheduler;
#line 3083 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			if (_tmp21_ == NULL) {
#line 22920 "Photo.c"
				OneShotScheduler* _tmp22_;
#line 3084 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp22_ = one_shot_scheduler_new ("Photo.update_editable_attributes", _photo_on_update_editable_attributes_one_shot_callback, self);
#line 3084 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_one_shot_scheduler_unref0 (self->priv->update_editable_attributes_scheduler);
#line 3084 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				self->priv->update_editable_attributes_scheduler = _tmp22_;
#line 22928 "Photo.c"
			}
#line 3088 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp23_ = self->priv->update_editable_attributes_scheduler;
#line 3088 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			one_shot_scheduler_after_timeout (_tmp23_, (guint) 1000, TRUE);
#line 3089 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			break;
#line 22936 "Photo.c"
		}
#line 3071 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		case G_FILE_MONITOR_EVENT_DELETED:
#line 22940 "Photo.c"
		{
			OneShotScheduler* _tmp24_;
			OneShotScheduler* _tmp26_;
#line 3092 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp24_ = self->priv->remove_editable_scheduler;
#line 3092 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			if (_tmp24_ == NULL) {
#line 22948 "Photo.c"
				OneShotScheduler* _tmp25_;
#line 3093 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp25_ = one_shot_scheduler_new ("Photo.remove_editable", _photo_on_remove_editable_one_shot_callback, self);
#line 3093 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_one_shot_scheduler_unref0 (self->priv->remove_editable_scheduler);
#line 3093 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				self->priv->remove_editable_scheduler = _tmp25_;
#line 22956 "Photo.c"
			}
#line 3097 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp26_ = self->priv->remove_editable_scheduler;
#line 3097 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			one_shot_scheduler_after_timeout (_tmp26_, (guint) 3000, TRUE);
#line 3098 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			break;
#line 22964 "Photo.c"
		}
		default:
#line 3071 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		case G_FILE_MONITOR_EVENT_CHANGES_DONE_HINT:
#line 22969 "Photo.c"
		{
#line 3103 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			break;
#line 22973 "Photo.c"
		}
	}
}


static void photo_on_reimport_editable (Photo* self) {
	gchar* _tmp0_ = NULL;
	gchar* _tmp1_;
	GError * _inner_error_ = NULL;
#line 3107 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 3108 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp0_ = data_object_to_string (DATA_OBJECT (self));
#line 3108 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 3108 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_debug ("Photo.vala:3108: Reimporting editable for %s", _tmp1_);
#line 3108 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_g_free0 (_tmp1_);
#line 22993 "Photo.c"
	{
#line 3110 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		photo_reimport_editable (self, &_inner_error_);
#line 3110 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 22999 "Photo.c"
			goto __catch223_g_error;
		}
	}
	goto __finally223;
	__catch223_g_error:
	{
		GError* err = NULL;
		gchar* _tmp2_ = NULL;
		gchar* _tmp3_;
		GError* _tmp4_;
		const gchar* _tmp5_;
#line 3109 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		err = _inner_error_;
#line 3109 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_inner_error_ = NULL;
#line 3112 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp2_ = data_object_to_string (DATA_OBJECT (self));
#line 3112 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp3_ = _tmp2_;
#line 3112 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp4_ = err;
#line 3112 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp5_ = _tmp4_->message;
#line 3112 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_warning ("Photo.vala:3112: Unable to reimport photo %s changed by external edito" \
"r: %s", _tmp3_, _tmp5_);
#line 3112 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_free0 (_tmp3_);
#line 3109 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_error_free0 (err);
#line 23029 "Photo.c"
	}
	__finally223:
#line 3109 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 3109 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 3109 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 3109 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return;
#line 23040 "Photo.c"
	}
}


static void photo_on_update_editable_attributes (Photo* self) {
	gchar* _tmp0_ = NULL;
	gchar* _tmp1_;
	GError * _inner_error_ = NULL;
#line 3117 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 3118 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp0_ = data_object_to_string (DATA_OBJECT (self));
#line 3118 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 3118 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_debug ("Photo.vala:3118: Updating editable attributes for %s", _tmp1_);
#line 3118 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_g_free0 (_tmp1_);
#line 23059 "Photo.c"
	{
#line 3120 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		photo_update_editable_attributes (self, &_inner_error_);
#line 3120 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 23065 "Photo.c"
			goto __catch224_g_error;
		}
	}
	goto __finally224;
	__catch224_g_error:
	{
		GError* err = NULL;
		GError* _tmp2_;
		const gchar* _tmp3_;
#line 3119 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		err = _inner_error_;
#line 3119 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_inner_error_ = NULL;
#line 3122 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp2_ = err;
#line 3122 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp3_ = _tmp2_->message;
#line 3122 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_warning ("Photo.vala:3122: Unable to update editable attributes: %s", _tmp3_);
#line 3119 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_error_free0 (err);
#line 23087 "Photo.c"
	}
	__finally224:
#line 3119 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 3119 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 3119 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 3119 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return;
#line 23098 "Photo.c"
	}
}


static void photo_on_remove_editable (Photo* self) {
	PhotoFileReader* _tmp0_ = NULL;
	PhotoFileReader* reader;
	PhotoFileReader* _tmp1_;
	PhotoFileReader* _tmp2_;
	GFile* _tmp3_ = NULL;
	GFile* file;
	GFile* _tmp4_;
	gboolean _tmp5_ = FALSE;
	gchar* _tmp8_ = NULL;
	gchar* _tmp9_;
#line 3126 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 3127 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp0_ = photo_get_editable_reader (self);
#line 3127 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	reader = _tmp0_;
#line 3128 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp1_ = reader;
#line 3128 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp1_ == NULL) {
#line 3129 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_photo_file_adapter_unref0 (reader);
#line 3129 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return;
#line 23128 "Photo.c"
	}
#line 3131 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp2_ = reader;
#line 3131 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp3_ = photo_file_adapter_get_file (PHOTO_FILE_ADAPTER (_tmp2_));
#line 3131 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	file = _tmp3_;
#line 3132 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp4_ = file;
#line 3132 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp5_ = g_file_query_exists (_tmp4_, NULL);
#line 3132 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp5_) {
#line 23142 "Photo.c"
		gchar* _tmp6_ = NULL;
		gchar* _tmp7_;
#line 3133 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp6_ = data_object_to_string (DATA_OBJECT (self));
#line 3133 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp7_ = _tmp6_;
#line 3133 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_debug ("Photo.vala:3133: Not removing editable for %s: file exists", _tmp7_);
#line 3133 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_free0 (_tmp7_);
#line 3135 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_object_unref0 (file);
#line 3135 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_photo_file_adapter_unref0 (reader);
#line 3135 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return;
#line 23159 "Photo.c"
	}
#line 3138 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp8_ = data_object_to_string (DATA_OBJECT (self));
#line 3138 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp9_ = _tmp8_;
#line 3138 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_debug ("Photo.vala:3138: Removing editable for %s: file no longer exists", _tmp9_);
#line 3138 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_g_free0 (_tmp9_);
#line 3139 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	photo_detach_editable (self, FALSE, TRUE);
#line 3126 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_g_object_unref0 (file);
#line 3126 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_photo_file_adapter_unref0 (reader);
#line 23175 "Photo.c"
}


void photo_get_original_dimensions (Photo* self, Dimensions* result) {
	Dimensions _tmp0_ = {0};
	Dimensions dim;
	Orientation _tmp1_ = 0;
	Orientation orientation;
	Dimensions _tmp2_;
	Dimensions _tmp3_ = {0};
#line 3147 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 3148 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	photo_get_raw_dimensions (self, &_tmp0_);
#line 3148 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	dim = _tmp0_;
#line 3149 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp1_ = photo_get_orientation (self);
#line 3149 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	orientation = _tmp1_;
#line 3151 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp2_ = dim;
#line 3151 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	orientation_rotate_dimensions (orientation, &_tmp2_, &_tmp3_);
#line 3151 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	*result = _tmp3_;
#line 3151 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return;
#line 23204 "Photo.c"
}


void photo_get_master_dimensions (Photo* self, Dimensions* result) {
	Orientation _tmp0_ = 0;
	Dimensions _tmp1_ = {0};
	Dimensions _tmp2_ = {0};
#line 3155 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 3156 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp0_ = photo_get_original_orientation (self);
#line 3156 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	photo_get_raw_dimensions (self, &_tmp1_);
#line 3156 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	orientation_rotate_dimensions (_tmp0_, &_tmp1_, &_tmp2_);
#line 3156 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	*result = _tmp2_;
#line 3156 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return;
#line 23224 "Photo.c"
}


gboolean photo_get_crop (Photo* self, Box* crop) {
	Box _vala_crop = {0};
	gboolean result = FALSE;
	Box raw = {0};
	Box _tmp0_ = {0};
	gboolean _tmp1_ = FALSE;
	Dimensions _tmp2_ = {0};
	Dimensions dim;
	Orientation _tmp3_ = 0;
	Orientation orientation;
	Orientation _tmp4_;
	Dimensions _tmp5_;
	Box _tmp6_;
	Box _tmp7_ = {0};
#line 3160 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 3162 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp1_ = photo_get_raw_crop (self, &_tmp0_);
#line 3162 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	raw = _tmp0_;
#line 3162 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (!_tmp1_) {
#line 3163 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		result = FALSE;
#line 3163 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		if (crop) {
#line 3163 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			*crop = _vala_crop;
#line 23256 "Photo.c"
		}
#line 3163 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return result;
#line 23260 "Photo.c"
	}
#line 3165 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	photo_get_raw_dimensions (self, &_tmp2_);
#line 3165 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	dim = _tmp2_;
#line 3166 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp3_ = photo_get_orientation (self);
#line 3166 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	orientation = _tmp3_;
#line 3168 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp4_ = orientation;
#line 3168 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp5_ = dim;
#line 3168 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp6_ = raw;
#line 3168 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	orientation_rotate_box (_tmp4_, &_tmp5_, &_tmp6_, &_tmp7_);
#line 3168 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_vala_crop = _tmp7_;
#line 3170 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	result = TRUE;
#line 3170 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (crop) {
#line 3170 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		*crop = _vala_crop;
#line 23286 "Photo.c"
	}
#line 3170 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return result;
#line 23290 "Photo.c"
}


void photo_set_crop (Photo* self, Box* crop) {
	Dimensions _tmp0_ = {0};
	Dimensions dim;
	Orientation _tmp1_ = 0;
	Orientation orientation;
	Dimensions _tmp2_;
	Box _tmp3_;
	Box _tmp4_ = {0};
	Box derotated;
	gint _tmp5_ = 0;
	Dimensions _tmp6_;
	gint _tmp7_;
	gint _tmp8_ = 0;
	Dimensions _tmp9_;
	gint _tmp10_;
	Box _tmp11_;
#line 3174 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 3174 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail (crop != NULL);
#line 3175 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	photo_get_raw_dimensions (self, &_tmp0_);
#line 3175 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	dim = _tmp0_;
#line 3176 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp1_ = photo_get_orientation (self);
#line 3176 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	orientation = _tmp1_;
#line 3178 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp2_ = dim;
#line 3178 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp3_ = *crop;
#line 3178 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	orientation_derotate_box (orientation, &_tmp2_, &_tmp3_, &_tmp4_);
#line 3178 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	derotated = _tmp4_;
#line 3180 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp5_ = box_get_width (&derotated);
#line 3180 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp6_ = dim;
#line 3180 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp7_ = _tmp6_.width;
#line 3180 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_assert (_tmp5_ <= _tmp7_);
#line 3181 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp8_ = box_get_height (&derotated);
#line 3181 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp9_ = dim;
#line 3181 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp10_ = _tmp9_.height;
#line 3181 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_assert (_tmp8_ <= _tmp10_);
#line 3183 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp11_ = derotated;
#line 3183 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	photo_set_raw_crop (self, &_tmp11_);
#line 23350 "Photo.c"
}


void photo_add_redeye_instance (Photo* self, RedeyeInstance* inst_unscaled) {
	RedeyeInstance _tmp0_;
	GdkRectangle _tmp1_ = {0};
	GdkRectangle bounds_rect_unscaled;
	GdkRectangle _tmp2_;
	GdkRectangle _tmp3_ = {0};
	GdkRectangle bounds_rect_raw;
	GdkRectangle _tmp4_;
	RedeyeInstance _tmp5_ = {0};
	RedeyeInstance inst;
	RedeyeInstance _tmp6_;
#line 3186 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 3186 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail (inst_unscaled != NULL);
#line 3187 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp0_ = *inst_unscaled;
#line 3187 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	redeye_instance_to_bounds_rect (&_tmp0_, &_tmp1_);
#line 3187 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	bounds_rect_unscaled = _tmp1_;
#line 3188 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp2_ = bounds_rect_unscaled;
#line 3188 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	photo_unscaled_to_raw_rect (self, &_tmp2_, &_tmp3_);
#line 3188 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	bounds_rect_raw = _tmp3_;
#line 3189 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp4_ = bounds_rect_raw;
#line 3189 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	redeye_instance_from_bounds_rect (&_tmp4_, &_tmp5_);
#line 3189 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	inst = _tmp5_;
#line 3191 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp6_ = inst;
#line 3191 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	photo_add_raw_redeye_instance (self, &_tmp6_);
#line 23391 "Photo.c"
}


static GdkPixbuf* photo_do_redeye (Photo* self, GdkPixbuf* pixbuf, RedeyeInstance* inst) {
	GdkPixbuf* result = NULL;
	RedeyeInstance _tmp0_;
	gint _tmp1_;
	gdouble r;
	RedeyeInstance _tmp2_;
	gint _tmp3_;
	gint* _tmp4_ = NULL;
	gint* x_insets_first_quadrant;
	gint x_insets_first_quadrant_length1;
	gint _x_insets_first_quadrant_size_;
	gint i;
	RedeyeInstance _tmp23_;
	GdkPoint _tmp24_;
	gint _tmp25_;
	RedeyeInstance _tmp26_;
	gint _tmp27_;
	gint x_bounds_min;
	RedeyeInstance _tmp28_;
	GdkPoint _tmp29_;
	gint _tmp30_;
	RedeyeInstance _tmp31_;
	gint _tmp32_;
	gint x_bounds_max;
	RedeyeInstance _tmp33_;
	GdkPoint _tmp34_;
	gint _tmp35_;
	RedeyeInstance _tmp36_;
	gint _tmp37_;
	gint ymin;
	gint _tmp38_ = 0;
	gint _tmp39_;
	gint _tmp41_;
	RedeyeInstance _tmp42_;
	GdkPoint _tmp43_;
	gint _tmp44_;
	gint ymax;
	gint _tmp45_ = 0;
	gint _tmp46_;
	GdkPixbuf* _tmp47_;
	gint _tmp48_;
	gint _tmp49_;
	gint _tmp54_;
	gint inset_index;
	RedeyeInstance _tmp95_;
	GdkPoint _tmp96_;
	gint _tmp97_;
	RedeyeInstance _tmp98_;
	GdkPoint _tmp99_;
	gint _tmp100_;
	RedeyeInstance _tmp101_;
	gint _tmp102_;
	gint* _tmp103_;
	gint _tmp103__length1;
	GdkPixbuf* _tmp144_;
	GdkPixbuf* _tmp145_;
#line 3194 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 3194 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail (GDK_IS_PIXBUF (pixbuf), NULL);
#line 3194 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail (inst != NULL, NULL);
#line 3204 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp0_ = *inst;
#line 3204 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp1_ = _tmp0_.radius;
#line 3204 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	r = (gdouble) _tmp1_;
#line 3205 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp2_ = *inst;
#line 3205 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp3_ = _tmp2_.radius;
#line 3205 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp4_ = g_new0 (gint, _tmp3_ + 1);
#line 3205 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	x_insets_first_quadrant = _tmp4_;
#line 3205 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	x_insets_first_quadrant_length1 = _tmp3_ + 1;
#line 3205 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_x_insets_first_quadrant_size_ = x_insets_first_quadrant_length1;
#line 3207 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	i = 0;
#line 23477 "Photo.c"
	{
		gdouble _tmp5_;
		gdouble y;
#line 3208 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp5_ = r;
#line 3208 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		y = _tmp5_;
#line 23485 "Photo.c"
		{
			gboolean _tmp6_;
#line 3208 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp6_ = TRUE;
#line 3208 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			while (TRUE) {
#line 23492 "Photo.c"
				gboolean _tmp7_;
				gdouble _tmp9_;
				gdouble _tmp10_;
				gdouble _tmp11_;
				gdouble _tmp12_ = 0.0;
				gdouble theta;
				gdouble _tmp13_;
				gdouble _tmp14_;
				gdouble _tmp15_ = 0.0;
				gint x;
				gint* _tmp16_;
				gint _tmp16__length1;
				gint _tmp17_;
				RedeyeInstance _tmp18_;
				gint _tmp19_;
				gint _tmp20_;
				gint _tmp21_;
				gint _tmp22_;
#line 3208 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp7_ = _tmp6_;
#line 3208 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				if (!_tmp7_) {
#line 23515 "Photo.c"
					gdouble _tmp8_;
#line 3208 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_tmp8_ = y;
#line 3208 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					y = _tmp8_ - 1.0;
#line 23521 "Photo.c"
				}
#line 3208 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp6_ = FALSE;
#line 3208 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp9_ = y;
#line 3208 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				if (!(_tmp9_ >= 0.0)) {
#line 3208 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					break;
#line 23531 "Photo.c"
				}
#line 3209 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp10_ = y;
#line 3209 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp11_ = r;
#line 3209 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp12_ = asin (_tmp10_ / _tmp11_);
#line 3209 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				theta = _tmp12_;
#line 3210 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp13_ = r;
#line 3210 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp14_ = theta;
#line 3210 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp15_ = cos (_tmp14_);
#line 3210 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				x = (gint) ((_tmp13_ * _tmp15_) + 0.5);
#line 3211 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp16_ = x_insets_first_quadrant;
#line 3211 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp16__length1 = x_insets_first_quadrant_length1;
#line 3211 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp17_ = i;
#line 3211 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp18_ = *inst;
#line 3211 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp19_ = _tmp18_.radius;
#line 3211 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp20_ = x;
#line 3211 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp16_[_tmp17_] = _tmp19_ - _tmp20_;
#line 3211 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp21_ = _tmp16_[_tmp17_];
#line 3213 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp22_ = i;
#line 3213 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				i = _tmp22_ + 1;
#line 23569 "Photo.c"
			}
		}
	}
#line 3216 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp23_ = *inst;
#line 3216 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp24_ = _tmp23_.center;
#line 3216 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp25_ = _tmp24_.x;
#line 3216 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp26_ = *inst;
#line 3216 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp27_ = _tmp26_.radius;
#line 3216 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	x_bounds_min = _tmp25_ - _tmp27_;
#line 3217 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp28_ = *inst;
#line 3217 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp29_ = _tmp28_.center;
#line 3217 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp30_ = _tmp29_.x;
#line 3217 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp31_ = *inst;
#line 3217 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp32_ = _tmp31_.radius;
#line 3217 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	x_bounds_max = _tmp30_ + _tmp32_;
#line 3218 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp33_ = *inst;
#line 3218 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp34_ = _tmp33_.center;
#line 3218 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp35_ = _tmp34_.y;
#line 3218 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp36_ = *inst;
#line 3218 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp37_ = _tmp36_.radius;
#line 3218 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	ymin = _tmp35_ - _tmp37_;
#line 3219 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp39_ = ymin;
#line 3219 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp39_ < 0) {
#line 3219 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp38_ = 0;
#line 23615 "Photo.c"
	} else {
		gint _tmp40_;
#line 3219 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp40_ = ymin;
#line 3219 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp38_ = _tmp40_;
#line 23622 "Photo.c"
	}
#line 3219 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp41_ = _tmp38_;
#line 3219 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	ymin = _tmp41_;
#line 3220 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp42_ = *inst;
#line 3220 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp43_ = _tmp42_.center;
#line 3220 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp44_ = _tmp43_.y;
#line 3220 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	ymax = _tmp44_;
#line 3221 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp46_ = ymax;
#line 3221 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp47_ = pixbuf;
#line 3221 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp48_ = gdk_pixbuf_get_height (_tmp47_);
#line 3221 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp49_ = _tmp48_;
#line 3221 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp46_ > (_tmp49_ - 1)) {
#line 23646 "Photo.c"
		GdkPixbuf* _tmp50_;
		gint _tmp51_;
		gint _tmp52_;
#line 3221 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp50_ = pixbuf;
#line 3221 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp51_ = gdk_pixbuf_get_height (_tmp50_);
#line 3221 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp52_ = _tmp51_;
#line 3221 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp45_ = _tmp52_ - 1;
#line 23658 "Photo.c"
	} else {
		gint _tmp53_;
#line 3221 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp53_ = ymax;
#line 3221 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp45_ = _tmp53_;
#line 23665 "Photo.c"
	}
#line 3221 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp54_ = _tmp45_;
#line 3221 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	ymax = _tmp54_;
#line 3225 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	inset_index = 0;
#line 23673 "Photo.c"
	{
		gint _tmp55_;
		gint y_it;
#line 3226 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp55_ = ymin;
#line 3226 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		y_it = _tmp55_;
#line 23681 "Photo.c"
		{
			gboolean _tmp56_;
#line 3226 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp56_ = TRUE;
#line 3226 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			while (TRUE) {
#line 23688 "Photo.c"
				gboolean _tmp57_;
				gint _tmp59_;
				gint _tmp60_;
				gint _tmp61_;
				gint* _tmp62_;
				gint _tmp62__length1;
				gint _tmp63_;
				gint _tmp64_;
				gint xmin;
				gint _tmp65_ = 0;
				gint _tmp66_;
				gint _tmp68_;
				gint _tmp69_;
				gint* _tmp70_;
				gint _tmp70__length1;
				gint _tmp71_;
				gint _tmp72_;
				gint xmax;
				gint _tmp73_ = 0;
				gint _tmp74_;
				GdkPixbuf* _tmp75_;
				gint _tmp76_;
				gint _tmp77_;
				gint _tmp82_;
				gint _tmp94_;
#line 3226 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp57_ = _tmp56_;
#line 3226 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				if (!_tmp57_) {
#line 23718 "Photo.c"
					gint _tmp58_;
#line 3226 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_tmp58_ = y_it;
#line 3226 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					y_it = _tmp58_ + 1;
#line 23724 "Photo.c"
				}
#line 3226 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp56_ = FALSE;
#line 3226 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp59_ = y_it;
#line 3226 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp60_ = ymax;
#line 3226 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				if (!(_tmp59_ <= _tmp60_)) {
#line 3226 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					break;
#line 23736 "Photo.c"
				}
#line 3227 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp61_ = x_bounds_min;
#line 3227 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp62_ = x_insets_first_quadrant;
#line 3227 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp62__length1 = x_insets_first_quadrant_length1;
#line 3227 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp63_ = inset_index;
#line 3227 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp64_ = _tmp62_[_tmp63_];
#line 3227 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				xmin = _tmp61_ + _tmp64_;
#line 3228 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp66_ = xmin;
#line 3228 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				if (_tmp66_ < 0) {
#line 3228 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_tmp65_ = 0;
#line 23756 "Photo.c"
				} else {
					gint _tmp67_;
#line 3228 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_tmp67_ = xmin;
#line 3228 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_tmp65_ = _tmp67_;
#line 23763 "Photo.c"
				}
#line 3228 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp68_ = _tmp65_;
#line 3228 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				xmin = _tmp68_;
#line 3229 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp69_ = x_bounds_max;
#line 3229 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp70_ = x_insets_first_quadrant;
#line 3229 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp70__length1 = x_insets_first_quadrant_length1;
#line 3229 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp71_ = inset_index;
#line 3229 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp72_ = _tmp70_[_tmp71_];
#line 3229 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				xmax = _tmp69_ - _tmp72_;
#line 3230 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp74_ = xmax;
#line 3230 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp75_ = pixbuf;
#line 3230 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp76_ = gdk_pixbuf_get_width (_tmp75_);
#line 3230 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp77_ = _tmp76_;
#line 3230 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				if (_tmp74_ > (_tmp77_ - 1)) {
#line 23791 "Photo.c"
					GdkPixbuf* _tmp78_;
					gint _tmp79_;
					gint _tmp80_;
#line 3230 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_tmp78_ = pixbuf;
#line 3230 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_tmp79_ = gdk_pixbuf_get_width (_tmp78_);
#line 3230 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_tmp80_ = _tmp79_;
#line 3230 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_tmp73_ = _tmp80_ - 1;
#line 23803 "Photo.c"
				} else {
					gint _tmp81_;
#line 3230 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_tmp81_ = xmax;
#line 3230 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_tmp73_ = _tmp81_;
#line 23810 "Photo.c"
				}
#line 3230 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp82_ = _tmp73_;
#line 3230 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				xmax = _tmp82_;
#line 23816 "Photo.c"
				{
					gint _tmp83_;
					gint x_it;
#line 3232 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_tmp83_ = xmin;
#line 3232 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					x_it = _tmp83_;
#line 23824 "Photo.c"
					{
						gboolean _tmp84_;
#line 3232 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						_tmp84_ = TRUE;
#line 3232 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						while (TRUE) {
#line 23831 "Photo.c"
							gboolean _tmp85_;
							gint _tmp87_;
							gint _tmp88_;
							GdkPixbuf* _tmp89_;
							gint _tmp90_;
							gint _tmp91_;
							GdkPixbuf* _tmp92_ = NULL;
							GdkPixbuf* _tmp93_;
#line 3232 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
							_tmp85_ = _tmp84_;
#line 3232 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
							if (!_tmp85_) {
#line 23844 "Photo.c"
								gint _tmp86_;
#line 3232 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
								_tmp86_ = x_it;
#line 3232 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
								x_it = _tmp86_ + 1;
#line 23850 "Photo.c"
							}
#line 3232 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
							_tmp84_ = FALSE;
#line 3232 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
							_tmp87_ = x_it;
#line 3232 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
							_tmp88_ = xmax;
#line 3232 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
							if (!(_tmp87_ <= _tmp88_)) {
#line 3232 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
								break;
#line 23862 "Photo.c"
							}
#line 3233 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
							_tmp89_ = pixbuf;
#line 3233 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
							_tmp90_ = x_it;
#line 3233 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
							_tmp91_ = y_it;
#line 3233 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
							_tmp92_ = photo_red_reduce_pixel (self, _tmp89_, _tmp90_, _tmp91_);
#line 3233 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
							_tmp93_ = _tmp92_;
#line 3233 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
							_g_object_unref0 (_tmp93_);
#line 23876 "Photo.c"
						}
					}
				}
#line 3235 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp94_ = inset_index;
#line 3235 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				inset_index = _tmp94_ + 1;
#line 23884 "Photo.c"
			}
		}
	}
#line 3240 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp95_ = *inst;
#line 3240 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp96_ = _tmp95_.center;
#line 3240 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp97_ = _tmp96_.y;
#line 3240 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	ymin = _tmp97_;
#line 3241 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp98_ = *inst;
#line 3241 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp99_ = _tmp98_.center;
#line 3241 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp100_ = _tmp99_.y;
#line 3241 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp101_ = *inst;
#line 3241 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp102_ = _tmp101_.radius;
#line 3241 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	ymax = _tmp100_ + _tmp102_;
#line 3242 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp103_ = x_insets_first_quadrant;
#line 3242 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp103__length1 = x_insets_first_quadrant_length1;
#line 3242 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	inset_index = _tmp103__length1 - 1;
#line 23914 "Photo.c"
	{
		gint _tmp104_;
		gint y_it;
#line 3243 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp104_ = ymin;
#line 3243 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		y_it = _tmp104_;
#line 23922 "Photo.c"
		{
			gboolean _tmp105_;
#line 3243 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp105_ = TRUE;
#line 3243 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			while (TRUE) {
#line 23929 "Photo.c"
				gboolean _tmp106_;
				gint _tmp108_;
				gint _tmp109_;
				gint _tmp110_;
				gint* _tmp111_;
				gint _tmp111__length1;
				gint _tmp112_;
				gint _tmp113_;
				gint xmin;
				gint _tmp114_ = 0;
				gint _tmp115_;
				gint _tmp117_;
				gint _tmp118_;
				gint* _tmp119_;
				gint _tmp119__length1;
				gint _tmp120_;
				gint _tmp121_;
				gint xmax;
				gint _tmp122_ = 0;
				gint _tmp123_;
				GdkPixbuf* _tmp124_;
				gint _tmp125_;
				gint _tmp126_;
				gint _tmp131_;
				gint _tmp143_;
#line 3243 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp106_ = _tmp105_;
#line 3243 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				if (!_tmp106_) {
#line 23959 "Photo.c"
					gint _tmp107_;
#line 3243 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_tmp107_ = y_it;
#line 3243 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					y_it = _tmp107_ + 1;
#line 23965 "Photo.c"
				}
#line 3243 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp105_ = FALSE;
#line 3243 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp108_ = y_it;
#line 3243 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp109_ = ymax;
#line 3243 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				if (!(_tmp108_ <= _tmp109_)) {
#line 3243 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					break;
#line 23977 "Photo.c"
				}
#line 3244 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp110_ = x_bounds_min;
#line 3244 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp111_ = x_insets_first_quadrant;
#line 3244 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp111__length1 = x_insets_first_quadrant_length1;
#line 3244 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp112_ = inset_index;
#line 3244 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp113_ = _tmp111_[_tmp112_];
#line 3244 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				xmin = _tmp110_ + _tmp113_;
#line 3245 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp115_ = xmin;
#line 3245 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				if (_tmp115_ < 0) {
#line 3245 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_tmp114_ = 0;
#line 23997 "Photo.c"
				} else {
					gint _tmp116_;
#line 3245 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_tmp116_ = xmin;
#line 3245 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_tmp114_ = _tmp116_;
#line 24004 "Photo.c"
				}
#line 3245 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp117_ = _tmp114_;
#line 3245 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				xmin = _tmp117_;
#line 3246 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp118_ = x_bounds_max;
#line 3246 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp119_ = x_insets_first_quadrant;
#line 3246 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp119__length1 = x_insets_first_quadrant_length1;
#line 3246 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp120_ = inset_index;
#line 3246 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp121_ = _tmp119_[_tmp120_];
#line 3246 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				xmax = _tmp118_ - _tmp121_;
#line 3247 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp123_ = xmax;
#line 3247 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp124_ = pixbuf;
#line 3247 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp125_ = gdk_pixbuf_get_width (_tmp124_);
#line 3247 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp126_ = _tmp125_;
#line 3247 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				if (_tmp123_ > (_tmp126_ - 1)) {
#line 24032 "Photo.c"
					GdkPixbuf* _tmp127_;
					gint _tmp128_;
					gint _tmp129_;
#line 3247 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_tmp127_ = pixbuf;
#line 3247 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_tmp128_ = gdk_pixbuf_get_width (_tmp127_);
#line 3247 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_tmp129_ = _tmp128_;
#line 3247 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_tmp122_ = _tmp129_ - 1;
#line 24044 "Photo.c"
				} else {
					gint _tmp130_;
#line 3247 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_tmp130_ = xmax;
#line 3247 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_tmp122_ = _tmp130_;
#line 24051 "Photo.c"
				}
#line 3247 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp131_ = _tmp122_;
#line 3247 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				xmax = _tmp131_;
#line 24057 "Photo.c"
				{
					gint _tmp132_;
					gint x_it;
#line 3249 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_tmp132_ = xmin;
#line 3249 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					x_it = _tmp132_;
#line 24065 "Photo.c"
					{
						gboolean _tmp133_;
#line 3249 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						_tmp133_ = TRUE;
#line 3249 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						while (TRUE) {
#line 24072 "Photo.c"
							gboolean _tmp134_;
							gint _tmp136_;
							gint _tmp137_;
							GdkPixbuf* _tmp138_;
							gint _tmp139_;
							gint _tmp140_;
							GdkPixbuf* _tmp141_ = NULL;
							GdkPixbuf* _tmp142_;
#line 3249 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
							_tmp134_ = _tmp133_;
#line 3249 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
							if (!_tmp134_) {
#line 24085 "Photo.c"
								gint _tmp135_;
#line 3249 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
								_tmp135_ = x_it;
#line 3249 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
								x_it = _tmp135_ + 1;
#line 24091 "Photo.c"
							}
#line 3249 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
							_tmp133_ = FALSE;
#line 3249 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
							_tmp136_ = x_it;
#line 3249 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
							_tmp137_ = xmax;
#line 3249 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
							if (!(_tmp136_ <= _tmp137_)) {
#line 3249 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
								break;
#line 24103 "Photo.c"
							}
#line 3250 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
							_tmp138_ = pixbuf;
#line 3250 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
							_tmp139_ = x_it;
#line 3250 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
							_tmp140_ = y_it;
#line 3250 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
							_tmp141_ = photo_red_reduce_pixel (self, _tmp138_, _tmp139_, _tmp140_);
#line 3250 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
							_tmp142_ = _tmp141_;
#line 3250 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
							_g_object_unref0 (_tmp142_);
#line 24117 "Photo.c"
						}
					}
				}
#line 3252 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp143_ = inset_index;
#line 3252 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				inset_index = _tmp143_ - 1;
#line 24125 "Photo.c"
			}
		}
	}
#line 3255 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp144_ = pixbuf;
#line 3255 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp145_ = _g_object_ref0 (_tmp144_);
#line 3255 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	result = _tmp145_;
#line 3255 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	x_insets_first_quadrant = (g_free (x_insets_first_quadrant), NULL);
#line 3255 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return result;
#line 24139 "Photo.c"
}


static GdkPixbuf* photo_red_reduce_pixel (Photo* self, GdkPixbuf* pixbuf, gint x, gint y) {
	GdkPixbuf* result = NULL;
	gint _tmp0_;
	GdkPixbuf* _tmp1_;
	gint _tmp2_ = 0;
	gint _tmp3_;
	GdkPixbuf* _tmp4_;
	gint _tmp5_ = 0;
	gint px_start_byte_offset;
	GdkPixbuf* _tmp6_;
	guint8* _tmp7_ = NULL;
	guchar* pixel_data;
	gint pixel_data_length1;
	gint _pixel_data_size_;
	guchar _tmp8_;
	guchar g;
	guchar _tmp9_;
	guchar b;
	guchar r;
	guchar _tmp10_;
	GdkPixbuf* _tmp11_;
	GdkPixbuf* _tmp12_;
#line 3258 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 3258 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail (GDK_IS_PIXBUF (pixbuf), NULL);
#line 3259 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp0_ = y;
#line 3259 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp1_ = pixbuf;
#line 3259 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp2_ = gdk_pixbuf_get_rowstride (_tmp1_);
#line 3259 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp3_ = x;
#line 3259 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp4_ = pixbuf;
#line 3259 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp5_ = gdk_pixbuf_get_n_channels (_tmp4_);
#line 3259 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	px_start_byte_offset = (_tmp0_ * _tmp2_) + (_tmp3_ * _tmp5_);
#line 3262 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp6_ = pixbuf;
#line 3262 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp7_ = gdk_pixbuf_get_pixels (_tmp6_);
#line 3262 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	pixel_data = _tmp7_;
#line 3262 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	pixel_data_length1 = -1;
#line 3262 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_pixel_data_size_ = pixel_data_length1;
#line 3272 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp8_ = pixel_data[px_start_byte_offset + 1];
#line 3272 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g = _tmp8_;
#line 3273 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp9_ = pixel_data[px_start_byte_offset + 2];
#line 3273 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	b = _tmp9_;
#line 3275 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	r = (guchar) ((g + b) / 2);
#line 3277 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	pixel_data[px_start_byte_offset] = r;
#line 3277 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp10_ = pixel_data[px_start_byte_offset];
#line 3279 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp11_ = pixbuf;
#line 3279 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp12_ = _g_object_ref0 (_tmp11_);
#line 3279 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	result = _tmp12_;
#line 3279 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return result;
#line 24215 "Photo.c"
}


void photo_unscaled_to_raw_point (Photo* self, GdkPoint* unscaled_point, GdkPoint* result) {
	Orientation _tmp0_ = 0;
	Orientation unscaled_orientation;
	Orientation _tmp1_;
	Dimensions _tmp2_ = {0};
	Dimensions _tmp3_ = {0};
	Dimensions unscaled_dims;
	gint unscaled_x_offset_raw;
	gint unscaled_y_offset_raw;
	Box crop_box = {0};
	Box _tmp4_ = {0};
	gboolean _tmp5_ = FALSE;
	Orientation _tmp10_;
	Dimensions _tmp11_;
	GdkPoint _tmp12_;
	GdkPoint _tmp13_ = {0};
	GdkPoint derotated_point;
	gint _tmp14_;
	gint _tmp15_;
	gint _tmp16_;
	gint _tmp17_;
#line 3282 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 3282 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail (unscaled_point != NULL);
#line 3283 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp0_ = photo_get_orientation (self);
#line 3283 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	unscaled_orientation = _tmp0_;
#line 3285 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp1_ = unscaled_orientation;
#line 3285 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	media_source_get_dimensions (MEDIA_SOURCE (self), &_tmp2_);
#line 3285 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	orientation_rotate_dimensions (_tmp1_, &_tmp2_, &_tmp3_);
#line 3285 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	unscaled_dims = _tmp3_;
#line 3288 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	unscaled_x_offset_raw = 0;
#line 3289 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	unscaled_y_offset_raw = 0;
#line 3292 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp5_ = photo_get_raw_crop (self, &_tmp4_);
#line 3292 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	crop_box = _tmp4_;
#line 3292 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp5_) {
#line 24266 "Photo.c"
		Box _tmp6_;
		gint _tmp7_;
		Box _tmp8_;
		gint _tmp9_;
#line 3293 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp6_ = crop_box;
#line 3293 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp7_ = _tmp6_.left;
#line 3293 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		unscaled_x_offset_raw = _tmp7_;
#line 3294 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp8_ = crop_box;
#line 3294 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp9_ = _tmp8_.top;
#line 3294 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		unscaled_y_offset_raw = _tmp9_;
#line 24283 "Photo.c"
	}
#line 3297 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp10_ = unscaled_orientation;
#line 3297 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp11_ = unscaled_dims;
#line 3297 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp12_ = *unscaled_point;
#line 3297 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	orientation_derotate_point (_tmp10_, &_tmp11_, &_tmp12_, &_tmp13_);
#line 3297 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	derotated_point = _tmp13_;
#line 3301 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp14_ = derotated_point.x;
#line 3301 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp15_ = unscaled_x_offset_raw;
#line 3301 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	derotated_point.x = _tmp14_ + _tmp15_;
#line 3302 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp16_ = derotated_point.y;
#line 3302 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp17_ = unscaled_y_offset_raw;
#line 3302 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	derotated_point.y = _tmp16_ + _tmp17_;
#line 3304 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	*result = derotated_point;
#line 3304 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return;
#line 24311 "Photo.c"
}


void photo_unscaled_to_raw_rect (Photo* self, GdkRectangle* unscaled_rect, GdkRectangle* result) {
	GdkPoint _tmp0_ = {0};
	GdkPoint upper_left;
	GdkPoint _tmp1_ = {0};
	GdkPoint lower_right;
	GdkRectangle _tmp2_;
	gint _tmp3_;
	GdkRectangle _tmp4_;
	gint _tmp5_;
	GdkPoint _tmp6_;
	gint _tmp7_;
	GdkRectangle _tmp8_;
	gint _tmp9_;
	GdkPoint _tmp10_;
	gint _tmp11_;
	GdkRectangle _tmp12_;
	gint _tmp13_;
	GdkPoint _tmp14_;
	GdkPoint _tmp15_ = {0};
	GdkPoint _tmp16_;
	GdkPoint _tmp17_ = {0};
	GdkPoint _tmp18_;
	gint _tmp19_;
	GdkPoint _tmp20_;
	gint _tmp21_;
	GdkPoint _tmp27_;
	gint _tmp28_;
	GdkPoint _tmp29_;
	gint _tmp30_;
	GdkRectangle _tmp36_ = {0};
	GdkRectangle raw_rect;
	GdkPoint _tmp37_;
	gint _tmp38_;
	GdkPoint _tmp39_;
	gint _tmp40_;
	GdkPoint _tmp41_;
	gint _tmp42_;
	GdkPoint _tmp43_;
	gint _tmp44_;
	GdkPoint _tmp45_;
	gint _tmp46_;
	GdkPoint _tmp47_;
	gint _tmp48_;
#line 3307 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (self));
#line 3307 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail (unscaled_rect != NULL);
#line 3308 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp0_.x = 0;
#line 3308 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	upper_left = _tmp0_;
#line 3309 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp1_.x = 0;
#line 3309 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	lower_right = _tmp1_;
#line 3310 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp2_ = *unscaled_rect;
#line 3310 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp3_ = _tmp2_.x;
#line 3310 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	upper_left.x = _tmp3_;
#line 3311 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp4_ = *unscaled_rect;
#line 3311 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp5_ = _tmp4_.y;
#line 3311 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	upper_left.y = _tmp5_;
#line 3312 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp6_ = upper_left;
#line 3312 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp7_ = _tmp6_.x;
#line 3312 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp8_ = *unscaled_rect;
#line 3312 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp9_ = _tmp8_.width;
#line 3312 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	lower_right.x = _tmp7_ + _tmp9_;
#line 3313 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp10_ = upper_left;
#line 3313 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp11_ = _tmp10_.y;
#line 3313 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp12_ = *unscaled_rect;
#line 3313 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp13_ = _tmp12_.height;
#line 3313 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	lower_right.y = _tmp11_ + _tmp13_;
#line 3315 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp14_ = upper_left;
#line 3315 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	photo_unscaled_to_raw_point (self, &_tmp14_, &_tmp15_);
#line 3315 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	upper_left = _tmp15_;
#line 3316 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp16_ = lower_right;
#line 3316 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	photo_unscaled_to_raw_point (self, &_tmp16_, &_tmp17_);
#line 3316 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	lower_right = _tmp17_;
#line 3318 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp18_ = upper_left;
#line 3318 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp19_ = _tmp18_.x;
#line 3318 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp20_ = lower_right;
#line 3318 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp21_ = _tmp20_.x;
#line 3318 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp19_ > _tmp21_) {
#line 24424 "Photo.c"
		GdkPoint _tmp22_;
		gint _tmp23_;
		gint temp;
		GdkPoint _tmp24_;
		gint _tmp25_;
		gint _tmp26_;
#line 3319 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp22_ = upper_left;
#line 3319 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp23_ = _tmp22_.x;
#line 3319 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		temp = _tmp23_;
#line 3320 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp24_ = lower_right;
#line 3320 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp25_ = _tmp24_.x;
#line 3320 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		upper_left.x = _tmp25_;
#line 3321 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp26_ = temp;
#line 3321 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		lower_right.x = _tmp26_;
#line 24447 "Photo.c"
	}
#line 3323 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp27_ = upper_left;
#line 3323 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp28_ = _tmp27_.y;
#line 3323 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp29_ = lower_right;
#line 3323 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp30_ = _tmp29_.y;
#line 3323 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp28_ > _tmp30_) {
#line 24459 "Photo.c"
		GdkPoint _tmp31_;
		gint _tmp32_;
		gint temp;
		GdkPoint _tmp33_;
		gint _tmp34_;
		gint _tmp35_;
#line 3324 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp31_ = upper_left;
#line 3324 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp32_ = _tmp31_.y;
#line 3324 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		temp = _tmp32_;
#line 3325 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp33_ = lower_right;
#line 3325 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp34_ = _tmp33_.y;
#line 3325 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		upper_left.y = _tmp34_;
#line 3326 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp35_ = temp;
#line 3326 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		lower_right.y = _tmp35_;
#line 24482 "Photo.c"
	}
#line 3329 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp36_.x = 0;
#line 3329 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	raw_rect = _tmp36_;
#line 3330 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp37_ = upper_left;
#line 3330 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp38_ = _tmp37_.x;
#line 3330 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	raw_rect.x = _tmp38_;
#line 3331 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp39_ = upper_left;
#line 3331 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp40_ = _tmp39_.y;
#line 3331 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	raw_rect.y = _tmp40_;
#line 3332 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp41_ = lower_right;
#line 3332 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp42_ = _tmp41_.x;
#line 3332 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp43_ = upper_left;
#line 3332 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp44_ = _tmp43_.x;
#line 3332 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	raw_rect.width = _tmp42_ - _tmp44_;
#line 3333 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp45_ = lower_right;
#line 3333 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp46_ = _tmp45_.y;
#line 3333 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp47_ = upper_left;
#line 3333 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp48_ = _tmp47_.y;
#line 3333 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	raw_rect.height = _tmp46_ - _tmp48_;
#line 3335 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	*result = raw_rect;
#line 3335 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return;
#line 24524 "Photo.c"
}


PixelTransformationBundle* photo_get_enhance_transformations (Photo* self) {
	PixelTransformationBundle* result = NULL;
	GdkPixbuf* pixbuf;
	GdkPixbuf* _tmp3_;
	PixelTransformationBundle* _tmp4_ = NULL;
	PixelTransformationBundle* transformations;
	GError * _inner_error_ = NULL;
#line 3338 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), NULL);
#line 3339 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	pixbuf = NULL;
#line 24539 "Photo.c"
	{
		Scaling _tmp0_ = {0};
		GdkPixbuf* _tmp1_ = NULL;
		GdkPixbuf* _tmp2_;
#line 3346 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		scaling_for_best_fit (360, FALSE, &_tmp0_);
#line 3346 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp1_ = photo_get_pixbuf_with_options (self, &_tmp0_, PHOTO_EXCEPTION_ALL, BACKING_FETCH_MODE_BASELINE, &_inner_error_);
#line 3346 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp2_ = _tmp1_;
#line 3346 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 24552 "Photo.c"
			goto __catch225_g_error;
		}
#line 3346 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_object_unref0 (pixbuf);
#line 3346 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		pixbuf = _tmp2_;
#line 24559 "Photo.c"
	}
	goto __finally225;
	__catch225_g_error:
	{
		GError* e = NULL;
#line 3345 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		e = _inner_error_;
#line 3345 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_inner_error_ = NULL;
#line 3353 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_warning ("Photo.vala:3353: %s", "Photo: get_enhance_transformations: couldn't obtain pixbuf to build " "transform histogram");
#line 3355 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		result = NULL;
#line 3355 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_error_free0 (e);
#line 3355 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_object_unref0 (pixbuf);
#line 3355 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return result;
#line 24579 "Photo.c"
	}
	__finally225:
#line 3345 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 3345 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_object_unref0 (pixbuf);
#line 3345 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 3345 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 3345 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return NULL;
#line 24592 "Photo.c"
	}
#line 3362 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp3_ = pixbuf;
#line 3362 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp4_ = auto_enhance_create_auto_enhance_adjustments (_tmp3_);
#line 3362 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	transformations = _tmp4_;
#line 3370 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	result = transformations;
#line 3370 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_g_object_unref0 (pixbuf);
#line 3370 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return result;
#line 24606 "Photo.c"
}


gboolean photo_enhance (Photo* self) {
	gboolean result = FALSE;
	PixelTransformationBundle* _tmp0_ = NULL;
	PixelTransformationBundle* transformations;
	PixelTransformationBundle* _tmp1_;
	GError * _inner_error_ = NULL;
#line 3373 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (self), FALSE);
#line 3374 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp0_ = photo_get_enhance_transformations (self);
#line 3374 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	transformations = _tmp0_;
#line 3376 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp1_ = transformations;
#line 3376 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp1_ == NULL) {
#line 3377 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		result = FALSE;
#line 3377 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_pixel_transformation_bundle_unref0 (transformations);
#line 3377 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return result;
#line 24632 "Photo.c"
	}
	{
		PhotoRow _tmp2_;
#line 3382 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp2_ = self->priv->row;
#line 3382 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_static_rec_mutex_lock (&self->priv->__lock_row);
#line 24640 "Photo.c"
		{
			PixelTransformationBundle* _tmp3_;
#line 3383 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp3_ = transformations;
#line 3383 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			photo_set_color_adjustments (self, _tmp3_);
#line 24647 "Photo.c"
		}
		__finally226:
		{
			PhotoRow _tmp4_;
#line 3382 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp4_ = self->priv->row;
#line 3382 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_static_rec_mutex_unlock (&self->priv->__lock_row);
#line 24656 "Photo.c"
		}
#line 3382 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 3382 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_pixel_transformation_bundle_unref0 (transformations);
#line 3382 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 3382 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 3382 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			return FALSE;
#line 24668 "Photo.c"
		}
	}
#line 3390 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	result = TRUE;
#line 3390 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_pixel_transformation_bundle_unref0 (transformations);
#line 3390 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return result;
#line 24677 "Photo.c"
}


static void photo_real_editable_replaced (Photo* self, GFile* old_file, GFile* new_file) {
#line 298 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail ((old_file == NULL) || G_IS_FILE (old_file));
#line 298 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail ((new_file == NULL) || G_IS_FILE (new_file));
#line 24686 "Photo.c"
}


static void g_cclosure_user_marshal_VOID__OBJECT_OBJECT (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__OBJECT_OBJECT) (gpointer data1, gpointer arg_1, gpointer arg_2, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_OBJECT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 157 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail (n_param_values == 3);
#line 157 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 157 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		data1 = closure->data;
#line 157 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		data2 = param_values->data[0].v_pointer;
#line 24705 "Photo.c"
	} else {
#line 157 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		data1 = param_values->data[0].v_pointer;
#line 157 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		data2 = closure->data;
#line 24711 "Photo.c"
	}
#line 157 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	callback = (GMarshalFunc_VOID__OBJECT_OBJECT) (marshal_data ? marshal_data : cc->callback);
#line 157 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	callback (data1, g_value_get_object (param_values + 1), g_value_get_object (param_values + 2), data2);
#line 24717 "Photo.c"
}


static void photo_real_baseline_replaced (Photo* self) {
}


static void photo_real_master_reimported (Photo* self, PhotoMetadata* metadata) {
#line 311 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
#line 24728 "Photo.c"
}


static void g_cclosure_user_marshal_VOID__MEDIA_METADATA (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__MEDIA_METADATA) (gpointer data1, gpointer arg_1, gpointer data2);
	register GMarshalFunc_VOID__MEDIA_METADATA callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 157 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail (n_param_values == 2);
#line 157 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 157 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		data1 = closure->data;
#line 157 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		data2 = param_values->data[0].v_pointer;
#line 24747 "Photo.c"
	} else {
#line 157 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		data1 = param_values->data[0].v_pointer;
#line 157 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		data2 = closure->data;
#line 24753 "Photo.c"
	}
#line 157 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	callback = (GMarshalFunc_VOID__MEDIA_METADATA) (marshal_data ? marshal_data : cc->callback);
#line 157 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	callback (data1, value_get_media_metadata (param_values + 1), data2);
#line 24759 "Photo.c"
}


static void photo_real_editable_reimported (Photo* self, PhotoMetadata* metadata) {
#line 315 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
#line 24766 "Photo.c"
}


static void photo_real_baseline_reimported (Photo* self, PhotoMetadata* metadata) {
#line 322 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
#line 24773 "Photo.c"
}


static void photo_real_source_reimported (Photo* self, PhotoMetadata* metadata) {
#line 329 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
#line 24780 "Photo.c"
}


static void _photo_photo_transformation_state_impl_on_photo_baseline_replaced_photo_baseline_replaced (Photo* _sender, gpointer self) {
#line 234 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	photo_photo_transformation_state_impl_on_photo_baseline_replaced (self);
#line 24787 "Photo.c"
}


static PhotoPhotoTransformationStateImpl* photo_photo_transformation_state_impl_construct (GType object_type, Photo* photo, Orientation orientation, GeeHashMap* transformations, PixelTransformer* transformer, PixelTransformationBundle* adjustments) {
	PhotoPhotoTransformationStateImpl * self = NULL;
	Photo* _tmp0_;
	Photo* _tmp1_;
	Orientation _tmp2_;
	GeeHashMap* _tmp3_;
	GeeHashMap* _tmp4_ = NULL;
	PixelTransformer* _tmp5_;
	PixelTransformer* _tmp6_;
	PixelTransformationBundle* _tmp7_;
	PixelTransformationBundle* _tmp8_;
	Photo* _tmp9_;
#line 221 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO (photo), NULL);
#line 221 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail ((transformations == NULL) || GEE_IS_HASH_MAP (transformations), NULL);
#line 221 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail ((transformer == NULL) || IS_PIXEL_TRANSFORMER (transformer), NULL);
#line 221 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail ((adjustments == NULL) || IS_PIXEL_TRANSFORMATION_BUNDLE (adjustments), NULL);
#line 221 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	self = (PhotoPhotoTransformationStateImpl*) photo_transformation_state_construct (object_type);
#line 224 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp0_ = photo;
#line 224 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 224 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_g_object_unref0 (self->priv->photo);
#line 224 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	self->priv->photo = _tmp1_;
#line 225 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp2_ = orientation;
#line 225 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	self->priv->orientation = _tmp2_;
#line 226 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp3_ = transformations;
#line 226 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp4_ = photo_photo_transformation_state_impl_copy_transformations (_tmp3_);
#line 226 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_g_object_unref0 (self->priv->transformations);
#line 226 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	self->priv->transformations = _tmp4_;
#line 227 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp5_ = transformer;
#line 227 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp6_ = _pixel_transformer_ref0 (_tmp5_);
#line 227 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_pixel_transformer_unref0 (self->priv->transformer);
#line 227 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	self->priv->transformer = _tmp6_;
#line 228 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp7_ = adjustments;
#line 228 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp8_ = _pixel_transformation_bundle_ref0 (_tmp7_);
#line 228 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_pixel_transformation_bundle_unref0 (self->priv->adjustments);
#line 228 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	self->priv->adjustments = _tmp8_;
#line 230 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp9_ = photo;
#line 230 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_signal_connect_object (_tmp9_, "baseline-replaced", (GCallback) _photo_photo_transformation_state_impl_on_photo_baseline_replaced_photo_baseline_replaced, self, 0);
#line 221 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return self;
#line 24855 "Photo.c"
}


static PhotoPhotoTransformationStateImpl* photo_photo_transformation_state_impl_new (Photo* photo, Orientation orientation, GeeHashMap* transformations, PixelTransformer* transformer, PixelTransformationBundle* adjustments) {
#line 221 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return photo_photo_transformation_state_impl_construct (PHOTO_TYPE_PHOTO_TRANSFORMATION_STATE_IMPL, photo, orientation, transformations, transformer, adjustments);
#line 24862 "Photo.c"
}


static Orientation photo_photo_transformation_state_impl_get_orientation (PhotoPhotoTransformationStateImpl* self) {
	Orientation result = 0;
	Orientation _tmp0_;
#line 237 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail (PHOTO_IS_PHOTO_TRANSFORMATION_STATE_IMPL (self), 0);
#line 238 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp0_ = self->priv->orientation;
#line 238 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	result = _tmp0_;
#line 238 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return result;
#line 24877 "Photo.c"
}


static GeeHashMap* photo_photo_transformation_state_impl_get_transformations (PhotoPhotoTransformationStateImpl* self) {
	GeeHashMap* result = NULL;
	GeeHashMap* _tmp0_;
	GeeHashMap* _tmp1_ = NULL;
#line 241 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail (PHOTO_IS_PHOTO_TRANSFORMATION_STATE_IMPL (self), NULL);
#line 242 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp0_ = self->priv->transformations;
#line 242 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp1_ = photo_photo_transformation_state_impl_copy_transformations (_tmp0_);
#line 242 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	result = _tmp1_;
#line 242 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return result;
#line 24895 "Photo.c"
}


static PixelTransformer* photo_photo_transformation_state_impl_get_transformer (PhotoPhotoTransformationStateImpl* self) {
	PixelTransformer* result = NULL;
	PixelTransformer* _tmp0_ = NULL;
	PixelTransformer* _tmp1_;
#line 245 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail (PHOTO_IS_PHOTO_TRANSFORMATION_STATE_IMPL (self), NULL);
#line 246 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp1_ = self->priv->transformer;
#line 246 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp1_ != NULL) {
#line 24909 "Photo.c"
		PixelTransformer* _tmp2_;
		PixelTransformer* _tmp3_ = NULL;
#line 246 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp2_ = self->priv->transformer;
#line 246 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp3_ = pixel_transformer_copy (_tmp2_);
#line 246 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_pixel_transformer_unref0 (_tmp0_);
#line 246 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp0_ = _tmp3_;
#line 24920 "Photo.c"
	} else {
#line 246 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_pixel_transformer_unref0 (_tmp0_);
#line 246 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp0_ = NULL;
#line 24926 "Photo.c"
	}
#line 246 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	result = _tmp0_;
#line 246 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return result;
#line 24932 "Photo.c"
}


static PixelTransformationBundle* photo_photo_transformation_state_impl_get_color_adjustments (PhotoPhotoTransformationStateImpl* self) {
	PixelTransformationBundle* result = NULL;
	PixelTransformationBundle* _tmp0_ = NULL;
	PixelTransformationBundle* _tmp1_;
#line 249 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail (PHOTO_IS_PHOTO_TRANSFORMATION_STATE_IMPL (self), NULL);
#line 250 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp1_ = self->priv->adjustments;
#line 250 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp1_ != NULL) {
#line 24946 "Photo.c"
		PixelTransformationBundle* _tmp2_;
		PixelTransformationBundle* _tmp3_ = NULL;
#line 250 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp2_ = self->priv->adjustments;
#line 250 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp3_ = pixel_transformation_bundle_copy (_tmp2_);
#line 250 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_pixel_transformation_bundle_unref0 (_tmp0_);
#line 250 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp0_ = _tmp3_;
#line 24957 "Photo.c"
	} else {
#line 250 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_pixel_transformation_bundle_unref0 (_tmp0_);
#line 250 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp0_ = NULL;
#line 24963 "Photo.c"
	}
#line 250 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	result = _tmp0_;
#line 250 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return result;
#line 24969 "Photo.c"
}


static GeeHashMap* photo_photo_transformation_state_impl_copy_transformations (GeeHashMap* original) {
	GeeHashMap* result = NULL;
	GeeHashMap* _tmp0_;
	GeeHashMap* _tmp1_;
	GeeHashMap* clone;
#line 253 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail ((original == NULL) || GEE_IS_HASH_MAP (original), NULL);
#line 255 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp0_ = original;
#line 255 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp0_ == NULL) {
#line 256 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		result = NULL;
#line 256 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return result;
#line 24988 "Photo.c"
	}
#line 258 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp1_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, TYPE_KEY_VALUE_MAP, (GBoxedCopyFunc) key_value_map_ref, key_value_map_unref, NULL, NULL, NULL);
#line 258 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	clone = _tmp1_;
#line 24994 "Photo.c"
	{
		GeeHashMap* _tmp2_;
		GeeSet* _tmp3_;
		GeeSet* _tmp4_;
		GeeSet* _tmp5_;
		GeeIterator* _tmp6_ = NULL;
		GeeIterator* _tmp7_;
		GeeIterator* _object_it;
#line 259 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp2_ = original;
#line 259 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp3_ = gee_abstract_map_get_keys (GEE_MAP (_tmp2_));
#line 259 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp4_ = _tmp3_;
#line 259 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp5_ = _tmp4_;
#line 259 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp6_ = gee_iterable_iterator (GEE_ITERABLE (_tmp5_));
#line 259 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp7_ = _tmp6_;
#line 259 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_object_unref0 (_tmp5_);
#line 259 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_object_it = _tmp7_;
#line 259 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		while (TRUE) {
#line 25021 "Photo.c"
			GeeIterator* _tmp8_;
			gboolean _tmp9_ = FALSE;
			GeeIterator* _tmp10_;
			gpointer _tmp11_ = NULL;
			gchar* object;
			GeeHashMap* _tmp12_;
			const gchar* _tmp13_;
			GeeHashMap* _tmp14_;
			const gchar* _tmp15_;
			gpointer _tmp16_ = NULL;
			KeyValueMap* _tmp17_;
			KeyValueMap* _tmp18_ = NULL;
			KeyValueMap* _tmp19_;
#line 259 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp8_ = _object_it;
#line 259 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp9_ = gee_iterator_next (_tmp8_);
#line 259 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			if (!_tmp9_) {
#line 259 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				break;
#line 25043 "Photo.c"
			}
#line 259 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp10_ = _object_it;
#line 259 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp11_ = gee_iterator_get (_tmp10_);
#line 259 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			object = (gchar*) _tmp11_;
#line 260 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp12_ = clone;
#line 260 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp13_ = object;
#line 260 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp14_ = original;
#line 260 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp15_ = object;
#line 260 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp16_ = gee_abstract_map_get (GEE_ABSTRACT_MAP (_tmp14_), _tmp15_);
#line 260 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp17_ = (KeyValueMap*) _tmp16_;
#line 260 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp18_ = key_value_map_copy (_tmp17_);
#line 260 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp19_ = _tmp18_;
#line 260 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			gee_abstract_map_set (GEE_ABSTRACT_MAP (_tmp12_), _tmp13_, _tmp19_);
#line 260 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_key_value_map_unref0 (_tmp19_);
#line 260 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_key_value_map_unref0 (_tmp17_);
#line 259 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_g_free0 (object);
#line 25075 "Photo.c"
		}
#line 259 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_object_unref0 (_object_it);
#line 25079 "Photo.c"
	}
#line 262 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	result = clone;
#line 262 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return result;
#line 25085 "Photo.c"
}


static void photo_photo_transformation_state_impl_on_photo_baseline_replaced (PhotoPhotoTransformationStateImpl* self) {
	gboolean _tmp0_ = FALSE;
#line 265 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail (PHOTO_IS_PHOTO_TRANSFORMATION_STATE_IMPL (self));
#line 266 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp0_ = photo_transformation_state_is_broken (PHOTO_TRANSFORMATION_STATE (self));
#line 266 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (!_tmp0_) {
#line 267 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_signal_emit_by_name (PHOTO_TRANSFORMATION_STATE (self), "broken");
#line 25099 "Photo.c"
	}
}


static void photo_photo_transformation_state_impl_class_init (PhotoPhotoTransformationStateImplClass * klass) {
#line 214 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	photo_photo_transformation_state_impl_parent_class = g_type_class_peek_parent (klass);
#line 214 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_type_class_add_private (klass, sizeof (PhotoPhotoTransformationStateImplPrivate));
#line 214 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	G_OBJECT_CLASS (klass)->finalize = photo_photo_transformation_state_impl_finalize;
#line 25111 "Photo.c"
}


static void photo_photo_transformation_state_impl_instance_init (PhotoPhotoTransformationStateImpl * self) {
#line 214 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	self->priv = PHOTO_PHOTO_TRANSFORMATION_STATE_IMPL_GET_PRIVATE (self);
#line 25118 "Photo.c"
}


static void photo_photo_transformation_state_impl_finalize (GObject* obj) {
	PhotoPhotoTransformationStateImpl * self;
	Photo* _tmp0_;
	guint _tmp1_ = 0U;
#line 214 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	self = PHOTO_PHOTO_TRANSFORMATION_STATE_IMPL (obj);
#line 234 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp0_ = self->priv->photo;
#line 234 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_signal_parse_name ("baseline-replaced", TYPE_PHOTO, &_tmp1_, NULL, FALSE);
#line 234 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_signal_handlers_disconnect_matched (_tmp0_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _photo_photo_transformation_state_impl_on_photo_baseline_replaced_photo_baseline_replaced, self);
#line 215 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_g_object_unref0 (self->priv->photo);
#line 217 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_g_object_unref0 (self->priv->transformations);
#line 218 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_pixel_transformer_unref0 (self->priv->transformer);
#line 219 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_pixel_transformation_bundle_unref0 (self->priv->adjustments);
#line 214 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	G_OBJECT_CLASS (photo_photo_transformation_state_impl_parent_class)->finalize (obj);
#line 25144 "Photo.c"
}


static GType photo_photo_transformation_state_impl_get_type (void) {
	static volatile gsize photo_photo_transformation_state_impl_type_id__volatile = 0;
	if (g_once_init_enter (&photo_photo_transformation_state_impl_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PhotoPhotoTransformationStateImplClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_photo_transformation_state_impl_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoPhotoTransformationStateImpl), 0, (GInstanceInitFunc) photo_photo_transformation_state_impl_instance_init, NULL };
		GType photo_photo_transformation_state_impl_type_id;
		photo_photo_transformation_state_impl_type_id = g_type_register_static (TYPE_PHOTO_TRANSFORMATION_STATE, "PhotoPhotoTransformationStateImpl", &g_define_type_info, 0);
		g_once_init_leave (&photo_photo_transformation_state_impl_type_id__volatile, photo_photo_transformation_state_impl_type_id);
	}
	return photo_photo_transformation_state_impl_type_id__volatile;
}


PhotoReimportMasterState* photo_reimport_master_state_construct (GType object_type) {
	PhotoReimportMasterState* self = NULL;
#line 829 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	self = (PhotoReimportMasterState*) g_type_create_instance (object_type);
#line 829 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return self;
#line 25166 "Photo.c"
}


static void photo_value_reimport_master_state_init (GValue* value) {
#line 829 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	value->data[0].v_pointer = NULL;
#line 25173 "Photo.c"
}


static void photo_value_reimport_master_state_free_value (GValue* value) {
#line 829 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (value->data[0].v_pointer) {
#line 829 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		photo_reimport_master_state_unref (value->data[0].v_pointer);
#line 25182 "Photo.c"
	}
}


static void photo_value_reimport_master_state_copy_value (const GValue* src_value, GValue* dest_value) {
#line 829 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (src_value->data[0].v_pointer) {
#line 829 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		dest_value->data[0].v_pointer = photo_reimport_master_state_ref (src_value->data[0].v_pointer);
#line 25192 "Photo.c"
	} else {
#line 829 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		dest_value->data[0].v_pointer = NULL;
#line 25196 "Photo.c"
	}
}


static gpointer photo_value_reimport_master_state_peek_pointer (const GValue* value) {
#line 829 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return value->data[0].v_pointer;
#line 25204 "Photo.c"
}


static gchar* photo_value_reimport_master_state_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
#line 829 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (collect_values[0].v_pointer) {
#line 25211 "Photo.c"
		PhotoReimportMasterState* object;
		object = collect_values[0].v_pointer;
#line 829 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		if (object->parent_instance.g_class == NULL) {
#line 829 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 25218 "Photo.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 829 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 25222 "Photo.c"
		}
#line 829 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		value->data[0].v_pointer = photo_reimport_master_state_ref (object);
#line 25226 "Photo.c"
	} else {
#line 829 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 25230 "Photo.c"
	}
#line 829 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return NULL;
#line 25234 "Photo.c"
}


static gchar* photo_value_reimport_master_state_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	PhotoReimportMasterState** object_p;
	object_p = collect_values[0].v_pointer;
#line 829 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (!object_p) {
#line 829 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 25245 "Photo.c"
	}
#line 829 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (!value->data[0].v_pointer) {
#line 829 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		*object_p = NULL;
#line 25251 "Photo.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 829 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		*object_p = value->data[0].v_pointer;
#line 25255 "Photo.c"
	} else {
#line 829 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		*object_p = photo_reimport_master_state_ref (value->data[0].v_pointer);
#line 25259 "Photo.c"
	}
#line 829 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return NULL;
#line 25263 "Photo.c"
}


GParamSpec* photo_param_spec_reimport_master_state (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	PhotoParamSpecReimportMasterState* spec;
#line 829 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail (g_type_is_a (object_type, PHOTO_TYPE_REIMPORT_MASTER_STATE), NULL);
#line 829 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 829 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 829 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return G_PARAM_SPEC (spec);
#line 25277 "Photo.c"
}


gpointer photo_value_get_reimport_master_state (const GValue* value) {
#line 829 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_TYPE_REIMPORT_MASTER_STATE), NULL);
#line 829 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return value->data[0].v_pointer;
#line 25286 "Photo.c"
}


void photo_value_set_reimport_master_state (GValue* value, gpointer v_object) {
	PhotoReimportMasterState* old;
#line 829 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_TYPE_REIMPORT_MASTER_STATE));
#line 829 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	old = value->data[0].v_pointer;
#line 829 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (v_object) {
#line 829 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PHOTO_TYPE_REIMPORT_MASTER_STATE));
#line 829 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 829 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		value->data[0].v_pointer = v_object;
#line 829 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		photo_reimport_master_state_ref (value->data[0].v_pointer);
#line 25306 "Photo.c"
	} else {
#line 829 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 25310 "Photo.c"
	}
#line 829 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (old) {
#line 829 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		photo_reimport_master_state_unref (old);
#line 25316 "Photo.c"
	}
}


void photo_value_take_reimport_master_state (GValue* value, gpointer v_object) {
	PhotoReimportMasterState* old;
#line 829 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_TYPE_REIMPORT_MASTER_STATE));
#line 829 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	old = value->data[0].v_pointer;
#line 829 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (v_object) {
#line 829 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PHOTO_TYPE_REIMPORT_MASTER_STATE));
#line 829 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 829 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		value->data[0].v_pointer = v_object;
#line 25335 "Photo.c"
	} else {
#line 829 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 25339 "Photo.c"
	}
#line 829 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (old) {
#line 829 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		photo_reimport_master_state_unref (old);
#line 25345 "Photo.c"
	}
}


static void photo_reimport_master_state_class_init (PhotoReimportMasterStateClass * klass) {
#line 829 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	photo_reimport_master_state_parent_class = g_type_class_peek_parent (klass);
#line 829 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	PHOTO_REIMPORT_MASTER_STATE_CLASS (klass)->finalize = photo_reimport_master_state_finalize;
#line 25355 "Photo.c"
}


static void photo_reimport_master_state_instance_init (PhotoReimportMasterState * self) {
#line 829 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	self->ref_count = 1;
#line 25362 "Photo.c"
}


static void photo_reimport_master_state_finalize (PhotoReimportMasterState* obj) {
	PhotoReimportMasterState * self;
#line 829 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	self = PHOTO_REIMPORT_MASTER_STATE (obj);
#line 25370 "Photo.c"
}


GType photo_reimport_master_state_get_type (void) {
	static volatile gsize photo_reimport_master_state_type_id__volatile = 0;
	if (g_once_init_enter (&photo_reimport_master_state_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { photo_value_reimport_master_state_init, photo_value_reimport_master_state_free_value, photo_value_reimport_master_state_copy_value, photo_value_reimport_master_state_peek_pointer, "p", photo_value_reimport_master_state_collect_value, "p", photo_value_reimport_master_state_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (PhotoReimportMasterStateClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_reimport_master_state_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoReimportMasterState), 0, (GInstanceInitFunc) photo_reimport_master_state_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType photo_reimport_master_state_type_id;
		photo_reimport_master_state_type_id = g_type_register_fundamental (g_type_fundamental_next (), "PhotoReimportMasterState", &g_define_type_info, &g_define_type_fundamental_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&photo_reimport_master_state_type_id__volatile, photo_reimport_master_state_type_id);
	}
	return photo_reimport_master_state_type_id__volatile;
}


gpointer photo_reimport_master_state_ref (gpointer instance) {
	PhotoReimportMasterState* self;
	self = instance;
#line 829 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_atomic_int_inc (&self->ref_count);
#line 829 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return instance;
#line 25395 "Photo.c"
}


void photo_reimport_master_state_unref (gpointer instance) {
	PhotoReimportMasterState* self;
	self = instance;
#line 829 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 829 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		PHOTO_REIMPORT_MASTER_STATE_GET_CLASS (self)->finalize (self);
#line 829 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 25408 "Photo.c"
	}
}


static gchar** _vala_array_dup29 (gchar** self, int length) {
	gchar** result;
	int i;
#line 841 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	result = g_new0 (gchar*, length + 1);
#line 841 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	for (i = 0; i < length; i++) {
#line 25420 "Photo.c"
		gchar* _tmp0_;
#line 841 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp0_ = g_strdup (self[i]);
#line 841 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		result[i] = _tmp0_;
#line 25426 "Photo.c"
	}
#line 841 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return result;
#line 25430 "Photo.c"
}


static PhotoReimportMasterStateImpl* photo_reimport_master_state_impl_construct (GType object_type, PhotoRow* row, PhotoMetadata* metadata, gchar** alterations, int alterations_length1) {
	PhotoReimportMasterStateImpl* self = NULL;
	PhotoRow _tmp0_;
	PhotoRow _tmp1_ = {0};
	PhotoMetadata* _tmp2_;
	PhotoMetadata* _tmp3_;
	gchar** _tmp4_;
	gint _tmp4__length1;
	gchar** _tmp5_;
	gint _tmp5__length1;
#line 838 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail (row != NULL, NULL);
#line 838 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata), NULL);
#line 838 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	self = (PhotoReimportMasterStateImpl*) photo_reimport_master_state_construct (object_type);
#line 839 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp0_ = *row;
#line 839 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	photo_row_copy (&_tmp0_, &_tmp1_);
#line 839 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	photo_row_destroy (&self->row);
#line 839 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	self->row = _tmp1_;
#line 840 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp2_ = metadata;
#line 840 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp3_ = _media_metadata_ref0 (_tmp2_);
#line 840 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_media_metadata_unref0 (self->metadata);
#line 840 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	self->metadata = _tmp3_;
#line 841 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp4_ = alterations;
#line 841 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp4__length1 = alterations_length1;
#line 841 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp5_ = (_tmp4_ != NULL) ? _vala_array_dup29 (_tmp4_, _tmp4__length1) : ((gpointer) _tmp4_);
#line 841 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp5__length1 = _tmp4__length1;
#line 841 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	self->alterations = (_vala_array_free (self->alterations, self->alterations_length1, (GDestroyNotify) g_free), NULL);
#line 841 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	self->alterations = _tmp5_;
#line 841 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	self->alterations_length1 = _tmp5__length1;
#line 841 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	self->_alterations_size_ = self->alterations_length1;
#line 838 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return self;
#line 25484 "Photo.c"
}


static PhotoReimportMasterStateImpl* photo_reimport_master_state_impl_new (PhotoRow* row, PhotoMetadata* metadata, gchar** alterations, int alterations_length1) {
#line 838 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return photo_reimport_master_state_impl_construct (PHOTO_TYPE_REIMPORT_MASTER_STATE_IMPL, row, metadata, alterations, alterations_length1);
#line 25491 "Photo.c"
}


static void photo_reimport_master_state_impl_class_init (PhotoReimportMasterStateImplClass * klass) {
#line 832 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	photo_reimport_master_state_impl_parent_class = g_type_class_peek_parent (klass);
#line 832 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	PHOTO_REIMPORT_MASTER_STATE_CLASS (klass)->finalize = photo_reimport_master_state_impl_finalize;
#line 25500 "Photo.c"
}


static void photo_reimport_master_state_impl_instance_init (PhotoReimportMasterStateImpl * self) {
	PhotoRow _tmp0_ = {0};
#line 833 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	photo_row_init (&_tmp0_);
#line 833 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	self->row = _tmp0_;
#line 836 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	self->metadata_only = FALSE;
#line 25512 "Photo.c"
}


static void photo_reimport_master_state_impl_finalize (PhotoReimportMasterState* obj) {
	PhotoReimportMasterStateImpl * self;
#line 832 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	self = PHOTO_REIMPORT_MASTER_STATE_IMPL (obj);
#line 833 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	photo_row_destroy (&self->row);
#line 834 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_media_metadata_unref0 (self->metadata);
#line 835 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	self->alterations = (_vala_array_free (self->alterations, self->alterations_length1, (GDestroyNotify) g_free), NULL);
#line 832 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	PHOTO_REIMPORT_MASTER_STATE_CLASS (photo_reimport_master_state_impl_parent_class)->finalize (obj);
#line 25528 "Photo.c"
}


static GType photo_reimport_master_state_impl_get_type (void) {
	static volatile gsize photo_reimport_master_state_impl_type_id__volatile = 0;
	if (g_once_init_enter (&photo_reimport_master_state_impl_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PhotoReimportMasterStateImplClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_reimport_master_state_impl_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoReimportMasterStateImpl), 0, (GInstanceInitFunc) photo_reimport_master_state_impl_instance_init, NULL };
		GType photo_reimport_master_state_impl_type_id;
		photo_reimport_master_state_impl_type_id = g_type_register_static (PHOTO_TYPE_REIMPORT_MASTER_STATE, "PhotoReimportMasterStateImpl", &g_define_type_info, 0);
		g_once_init_leave (&photo_reimport_master_state_impl_type_id__volatile, photo_reimport_master_state_impl_type_id);
	}
	return photo_reimport_master_state_impl_type_id__volatile;
}


PhotoReimportEditableState* photo_reimport_editable_state_construct (GType object_type) {
	PhotoReimportEditableState* self = NULL;
#line 845 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	self = (PhotoReimportEditableState*) g_type_create_instance (object_type);
#line 845 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return self;
#line 25550 "Photo.c"
}


static void photo_value_reimport_editable_state_init (GValue* value) {
#line 845 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	value->data[0].v_pointer = NULL;
#line 25557 "Photo.c"
}


static void photo_value_reimport_editable_state_free_value (GValue* value) {
#line 845 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (value->data[0].v_pointer) {
#line 845 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		photo_reimport_editable_state_unref (value->data[0].v_pointer);
#line 25566 "Photo.c"
	}
}


static void photo_value_reimport_editable_state_copy_value (const GValue* src_value, GValue* dest_value) {
#line 845 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (src_value->data[0].v_pointer) {
#line 845 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		dest_value->data[0].v_pointer = photo_reimport_editable_state_ref (src_value->data[0].v_pointer);
#line 25576 "Photo.c"
	} else {
#line 845 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		dest_value->data[0].v_pointer = NULL;
#line 25580 "Photo.c"
	}
}


static gpointer photo_value_reimport_editable_state_peek_pointer (const GValue* value) {
#line 845 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return value->data[0].v_pointer;
#line 25588 "Photo.c"
}


static gchar* photo_value_reimport_editable_state_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
#line 845 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (collect_values[0].v_pointer) {
#line 25595 "Photo.c"
		PhotoReimportEditableState* object;
		object = collect_values[0].v_pointer;
#line 845 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		if (object->parent_instance.g_class == NULL) {
#line 845 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 25602 "Photo.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 845 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 25606 "Photo.c"
		}
#line 845 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		value->data[0].v_pointer = photo_reimport_editable_state_ref (object);
#line 25610 "Photo.c"
	} else {
#line 845 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 25614 "Photo.c"
	}
#line 845 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return NULL;
#line 25618 "Photo.c"
}


static gchar* photo_value_reimport_editable_state_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	PhotoReimportEditableState** object_p;
	object_p = collect_values[0].v_pointer;
#line 845 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (!object_p) {
#line 845 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 25629 "Photo.c"
	}
#line 845 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (!value->data[0].v_pointer) {
#line 845 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		*object_p = NULL;
#line 25635 "Photo.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 845 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		*object_p = value->data[0].v_pointer;
#line 25639 "Photo.c"
	} else {
#line 845 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		*object_p = photo_reimport_editable_state_ref (value->data[0].v_pointer);
#line 25643 "Photo.c"
	}
#line 845 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return NULL;
#line 25647 "Photo.c"
}


GParamSpec* photo_param_spec_reimport_editable_state (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	PhotoParamSpecReimportEditableState* spec;
#line 845 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail (g_type_is_a (object_type, PHOTO_TYPE_REIMPORT_EDITABLE_STATE), NULL);
#line 845 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 845 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 845 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return G_PARAM_SPEC (spec);
#line 25661 "Photo.c"
}


gpointer photo_value_get_reimport_editable_state (const GValue* value) {
#line 845 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_TYPE_REIMPORT_EDITABLE_STATE), NULL);
#line 845 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return value->data[0].v_pointer;
#line 25670 "Photo.c"
}


void photo_value_set_reimport_editable_state (GValue* value, gpointer v_object) {
	PhotoReimportEditableState* old;
#line 845 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_TYPE_REIMPORT_EDITABLE_STATE));
#line 845 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	old = value->data[0].v_pointer;
#line 845 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (v_object) {
#line 845 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PHOTO_TYPE_REIMPORT_EDITABLE_STATE));
#line 845 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 845 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		value->data[0].v_pointer = v_object;
#line 845 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		photo_reimport_editable_state_ref (value->data[0].v_pointer);
#line 25690 "Photo.c"
	} else {
#line 845 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 25694 "Photo.c"
	}
#line 845 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (old) {
#line 845 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		photo_reimport_editable_state_unref (old);
#line 25700 "Photo.c"
	}
}


void photo_value_take_reimport_editable_state (GValue* value, gpointer v_object) {
	PhotoReimportEditableState* old;
#line 845 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PHOTO_TYPE_REIMPORT_EDITABLE_STATE));
#line 845 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	old = value->data[0].v_pointer;
#line 845 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (v_object) {
#line 845 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PHOTO_TYPE_REIMPORT_EDITABLE_STATE));
#line 845 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 845 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		value->data[0].v_pointer = v_object;
#line 25719 "Photo.c"
	} else {
#line 845 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		value->data[0].v_pointer = NULL;
#line 25723 "Photo.c"
	}
#line 845 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (old) {
#line 845 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		photo_reimport_editable_state_unref (old);
#line 25729 "Photo.c"
	}
}


static void photo_reimport_editable_state_class_init (PhotoReimportEditableStateClass * klass) {
#line 845 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	photo_reimport_editable_state_parent_class = g_type_class_peek_parent (klass);
#line 845 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	PHOTO_REIMPORT_EDITABLE_STATE_CLASS (klass)->finalize = photo_reimport_editable_state_finalize;
#line 25739 "Photo.c"
}


static void photo_reimport_editable_state_instance_init (PhotoReimportEditableState * self) {
#line 845 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	self->ref_count = 1;
#line 25746 "Photo.c"
}


static void photo_reimport_editable_state_finalize (PhotoReimportEditableState* obj) {
	PhotoReimportEditableState * self;
#line 845 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	self = PHOTO_REIMPORT_EDITABLE_STATE (obj);
#line 25754 "Photo.c"
}


GType photo_reimport_editable_state_get_type (void) {
	static volatile gsize photo_reimport_editable_state_type_id__volatile = 0;
	if (g_once_init_enter (&photo_reimport_editable_state_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { photo_value_reimport_editable_state_init, photo_value_reimport_editable_state_free_value, photo_value_reimport_editable_state_copy_value, photo_value_reimport_editable_state_peek_pointer, "p", photo_value_reimport_editable_state_collect_value, "p", photo_value_reimport_editable_state_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (PhotoReimportEditableStateClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_reimport_editable_state_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoReimportEditableState), 0, (GInstanceInitFunc) photo_reimport_editable_state_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType photo_reimport_editable_state_type_id;
		photo_reimport_editable_state_type_id = g_type_register_fundamental (g_type_fundamental_next (), "PhotoReimportEditableState", &g_define_type_info, &g_define_type_fundamental_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&photo_reimport_editable_state_type_id__volatile, photo_reimport_editable_state_type_id);
	}
	return photo_reimport_editable_state_type_id__volatile;
}


gpointer photo_reimport_editable_state_ref (gpointer instance) {
	PhotoReimportEditableState* self;
	self = instance;
#line 845 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_atomic_int_inc (&self->ref_count);
#line 845 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return instance;
#line 25779 "Photo.c"
}


void photo_reimport_editable_state_unref (gpointer instance) {
	PhotoReimportEditableState* self;
	self = instance;
#line 845 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 845 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		PHOTO_REIMPORT_EDITABLE_STATE_GET_CLASS (self)->finalize (self);
#line 845 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 25792 "Photo.c"
	}
}


static PhotoReimportEditableStateImpl* photo_reimport_editable_state_impl_construct (GType object_type, BackingPhotoState* backing_state, PhotoMetadata* metadata) {
	PhotoReimportEditableStateImpl* self = NULL;
	BackingPhotoState _tmp0_;
	BackingPhotoState _tmp1_ = {0};
	PhotoMetadata* _tmp2_;
	PhotoMetadata* _tmp3_;
#line 853 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail (backing_state != NULL, NULL);
#line 853 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata), NULL);
#line 853 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	self = (PhotoReimportEditableStateImpl*) photo_reimport_editable_state_construct (object_type);
#line 854 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp0_ = *backing_state;
#line 854 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	backing_photo_state_copy (&_tmp0_, &_tmp1_);
#line 854 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	backing_photo_state_destroy (&self->backing_state);
#line 854 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	self->backing_state = _tmp1_;
#line 855 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp2_ = metadata;
#line 855 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp3_ = _media_metadata_ref0 (_tmp2_);
#line 855 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_media_metadata_unref0 (self->metadata);
#line 855 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	self->metadata = _tmp3_;
#line 853 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return self;
#line 25827 "Photo.c"
}


static PhotoReimportEditableStateImpl* photo_reimport_editable_state_impl_new (BackingPhotoState* backing_state, PhotoMetadata* metadata) {
#line 853 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return photo_reimport_editable_state_impl_construct (PHOTO_TYPE_REIMPORT_EDITABLE_STATE_IMPL, backing_state, metadata);
#line 25834 "Photo.c"
}


static void photo_reimport_editable_state_impl_class_init (PhotoReimportEditableStateImplClass * klass) {
#line 848 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	photo_reimport_editable_state_impl_parent_class = g_type_class_peek_parent (klass);
#line 848 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	PHOTO_REIMPORT_EDITABLE_STATE_CLASS (klass)->finalize = photo_reimport_editable_state_impl_finalize;
#line 25843 "Photo.c"
}


static void photo_reimport_editable_state_impl_instance_init (PhotoReimportEditableStateImpl * self) {
	BackingPhotoState _tmp0_ = {0};
#line 849 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	memset (&_tmp0_, 0, sizeof (BackingPhotoState));
#line 849 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	self->backing_state = _tmp0_;
#line 851 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	self->metadata_only = FALSE;
#line 25855 "Photo.c"
}


static void photo_reimport_editable_state_impl_finalize (PhotoReimportEditableState* obj) {
	PhotoReimportEditableStateImpl * self;
#line 848 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	self = PHOTO_REIMPORT_EDITABLE_STATE_IMPL (obj);
#line 849 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	backing_photo_state_destroy (&self->backing_state);
#line 850 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_media_metadata_unref0 (self->metadata);
#line 848 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	PHOTO_REIMPORT_EDITABLE_STATE_CLASS (photo_reimport_editable_state_impl_parent_class)->finalize (obj);
#line 25869 "Photo.c"
}


static GType photo_reimport_editable_state_impl_get_type (void) {
	static volatile gsize photo_reimport_editable_state_impl_type_id__volatile = 0;
	if (g_once_init_enter (&photo_reimport_editable_state_impl_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PhotoReimportEditableStateImplClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_reimport_editable_state_impl_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoReimportEditableStateImpl), 0, (GInstanceInitFunc) photo_reimport_editable_state_impl_instance_init, NULL };
		GType photo_reimport_editable_state_impl_type_id;
		photo_reimport_editable_state_impl_type_id = g_type_register_static (PHOTO_TYPE_REIMPORT_EDITABLE_STATE, "PhotoReimportEditableStateImpl", &g_define_type_info, 0);
		g_once_init_leave (&photo_reimport_editable_state_impl_type_id__volatile, photo_reimport_editable_state_impl_type_id);
	}
	return photo_reimport_editable_state_impl_type_id__volatile;
}


static void photo_backing_readers_copy (const PhotoBackingReaders* self, PhotoBackingReaders* dest) {
	PhotoFileReader* _tmp0_;
	PhotoFileReader* _tmp1_;
	PhotoFileReader* _tmp2_;
	PhotoFileReader* _tmp3_;
	PhotoFileReader* _tmp4_;
	PhotoFileReader* _tmp5_;
#line 271 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp0_ = (*self).master;
#line 271 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp1_ = _photo_file_adapter_ref0 (_tmp0_);
#line 271 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_photo_file_adapter_unref0 ((*dest).master);
#line 271 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	(*dest).master = _tmp1_;
#line 271 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp2_ = (*self).mimic;
#line 271 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp3_ = _photo_file_adapter_ref0 (_tmp2_);
#line 271 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_photo_file_adapter_unref0 ((*dest).mimic);
#line 271 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	(*dest).mimic = _tmp3_;
#line 271 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp4_ = (*self).editable;
#line 271 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp5_ = _photo_file_adapter_ref0 (_tmp4_);
#line 271 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_photo_file_adapter_unref0 ((*dest).editable);
#line 271 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	(*dest).editable = _tmp5_;
#line 25916 "Photo.c"
}


static void photo_backing_readers_destroy (PhotoBackingReaders* self) {
#line 272 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_photo_file_adapter_unref0 ((*self).master);
#line 273 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_photo_file_adapter_unref0 ((*self).mimic);
#line 274 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_photo_file_adapter_unref0 ((*self).editable);
#line 25927 "Photo.c"
}


static PhotoBackingReaders* photo_backing_readers_dup (const PhotoBackingReaders* self) {
	PhotoBackingReaders* dup;
#line 271 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	dup = g_new0 (PhotoBackingReaders, 1);
#line 271 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	photo_backing_readers_copy (self, dup);
#line 271 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return dup;
#line 25939 "Photo.c"
}


static void photo_backing_readers_free (PhotoBackingReaders* self) {
#line 271 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	photo_backing_readers_destroy (self);
#line 271 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_free (self);
#line 25948 "Photo.c"
}


static GType photo_backing_readers_get_type (void) {
	static volatile gsize photo_backing_readers_type_id__volatile = 0;
	if (g_once_init_enter (&photo_backing_readers_type_id__volatile)) {
		GType photo_backing_readers_type_id;
		photo_backing_readers_type_id = g_boxed_type_register_static ("PhotoBackingReaders", (GBoxedCopyFunc) photo_backing_readers_dup, (GBoxedFreeFunc) photo_backing_readers_free);
		g_once_init_leave (&photo_backing_readers_type_id__volatile, photo_backing_readers_type_id);
	}
	return photo_backing_readers_type_id__volatile;
}


static void photo_class_init (PhotoClass * klass) {
#line 157 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	photo_parent_class = g_type_class_peek_parent (klass);
#line 157 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_type_class_add_private (klass, sizeof (PhotoPrivate));
#line 157 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	PHOTO_CLASS (klass)->notify_editable_replaced = photo_real_notify_editable_replaced;
#line 157 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	PHOTO_CLASS (klass)->notify_baseline_replaced = photo_real_notify_baseline_replaced;
#line 157 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	PHOTO_CLASS (klass)->notify_master_reimported = photo_real_notify_master_reimported;
#line 157 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	PHOTO_CLASS (klass)->notify_editable_reimported = photo_real_notify_editable_reimported;
#line 157 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	PHOTO_CLASS (klass)->notify_source_reimported = photo_real_notify_source_reimported;
#line 157 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	PHOTO_CLASS (klass)->notify_baseline_reimported = photo_real_notify_baseline_reimported;
#line 157 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	DATA_SOURCE_CLASS (klass)->internal_delete_backing = photo_real_internal_delete_backing;
#line 157 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	MEDIA_SOURCE_CLASS (klass)->get_backing_files_state = photo_real_get_backing_files_state;
#line 157 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	PHOTO_CLASS (klass)->apply_user_metadata_for_reimport = photo_real_apply_user_metadata_for_reimport;
#line 157 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	DATA_SOURCE_CLASS (klass)->get_typename = photo_real_get_typename;
#line 157 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	DATA_SOURCE_CLASS (klass)->get_instance_id = photo_real_get_instance_id;
#line 157 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	DATA_SOURCE_CLASS (klass)->get_source_id = photo_real_get_source_id;
#line 157 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	THUMBNAIL_SOURCE_CLASS (klass)->get_preferred_thumbnail_format = photo_real_get_preferred_thumbnail_format;
#line 157 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	THUMBNAIL_SOURCE_CLASS (klass)->create_thumbnail = photo_real_create_thumbnail;
#line 157 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	MEDIA_SOURCE_CLASS (klass)->get_file = photo_real_get_file;
#line 157 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	MEDIA_SOURCE_CLASS (klass)->get_master_file = photo_real_get_master_file;
#line 157 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	MEDIA_SOURCE_CLASS (klass)->get_timestamp = photo_real_get_timestamp;
#line 157 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	MEDIA_SOURCE_CLASS (klass)->get_event_id = photo_real_get_event_id;
#line 157 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	MEDIA_SOURCE_CLASS (klass)->get_import_id = photo_real_get_import_id;
#line 157 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	MEDIA_SOURCE_CLASS (klass)->get_master_md5 = photo_real_get_master_md5;
#line 157 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	MEDIA_SOURCE_CLASS (klass)->get_rating = photo_real_get_rating;
#line 157 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	MEDIA_SOURCE_CLASS (klass)->set_rating = photo_real_set_rating;
#line 157 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	MEDIA_SOURCE_CLASS (klass)->increase_rating = photo_real_increase_rating;
#line 157 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	MEDIA_SOURCE_CLASS (klass)->decrease_rating = photo_real_decrease_rating;
#line 157 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	DATA_SOURCE_CLASS (klass)->commit_backlinks = photo_real_commit_backlinks;
#line 157 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	MEDIA_SOURCE_CLASS (klass)->set_event_id = photo_real_set_event_id;
#line 157 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	DATA_OBJECT_CLASS (klass)->to_string = photo_real_to_string;
#line 157 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	DATA_SOURCE_CLASS (klass)->equals = photo_real_equals;
#line 157 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	MEDIA_SOURCE_CLASS (klass)->get_filesize = photo_real_get_filesize;
#line 157 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	MEDIA_SOURCE_CLASS (klass)->get_master_filesize = photo_real_get_master_filesize;
#line 157 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	MEDIA_SOURCE_CLASS (klass)->get_exposure_time = photo_real_get_exposure_time;
#line 157 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	MEDIA_SOURCE_CLASS (klass)->get_basename = photo_real_get_basename;
#line 157 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	MEDIA_SOURCE_CLASS (klass)->get_title = photo_real_get_title;
#line 157 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	MEDIA_SOURCE_CLASS (klass)->set_title = photo_real_set_title;
#line 157 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	MEDIA_SOURCE_CLASS (klass)->get_dimensions = photo_real_get_dimensions;
#line 157 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	PHOTO_SOURCE_CLASS (klass)->get_metadata = photo_real_get_metadata;
#line 157 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	PHOTO_CLASS (klass)->rotate = photo_real_rotate;
#line 157 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	PHOTO_SOURCE_CLASS (klass)->get_pixbuf = photo_real_get_pixbuf;
#line 157 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	PHOTO_CLASS (klass)->has_user_generated_metadata = photo_real_has_user_generated_metadata;
#line 157 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	PHOTO_CLASS (klass)->set_user_metadata_for_export = photo_real_set_user_metadata_for_export;
#line 157 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	PHOTO_CLASS (klass)->editable_replaced = photo_real_editable_replaced;
#line 157 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	PHOTO_CLASS (klass)->baseline_replaced = photo_real_baseline_replaced;
#line 157 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	PHOTO_CLASS (klass)->master_reimported = photo_real_master_reimported;
#line 157 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	PHOTO_CLASS (klass)->editable_reimported = photo_real_editable_reimported;
#line 157 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	PHOTO_CLASS (klass)->baseline_reimported = photo_real_baseline_reimported;
#line 157 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	PHOTO_CLASS (klass)->source_reimported = photo_real_source_reimported;
#line 157 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	G_OBJECT_CLASS (klass)->finalize = photo_finalize;
#line 157 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_signal_new ("editable_replaced", TYPE_PHOTO, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (PhotoClass, editable_replaced), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT, G_TYPE_NONE, 2, G_TYPE_FILE, G_TYPE_FILE);
#line 157 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_signal_new ("baseline_replaced", TYPE_PHOTO, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (PhotoClass, baseline_replaced), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 157 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_signal_new ("master_reimported", TYPE_PHOTO, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (PhotoClass, master_reimported), NULL, NULL, g_cclosure_user_marshal_VOID__MEDIA_METADATA, G_TYPE_NONE, 1, TYPE_PHOTO_METADATA);
#line 157 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_signal_new ("editable_reimported", TYPE_PHOTO, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (PhotoClass, editable_reimported), NULL, NULL, g_cclosure_user_marshal_VOID__MEDIA_METADATA, G_TYPE_NONE, 1, TYPE_PHOTO_METADATA);
#line 157 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_signal_new ("baseline_reimported", TYPE_PHOTO, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (PhotoClass, baseline_reimported), NULL, NULL, g_cclosure_user_marshal_VOID__MEDIA_METADATA, G_TYPE_NONE, 1, TYPE_PHOTO_METADATA);
#line 157 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_signal_new ("source_reimported", TYPE_PHOTO, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (PhotoClass, source_reimported), NULL, NULL, g_cclosure_user_marshal_VOID__MEDIA_METADATA, G_TYPE_NONE, 1, TYPE_PHOTO_METADATA);
#line 26074 "Photo.c"
}


static void photo_dateable_interface_init (DateableIface * iface) {
#line 157 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	photo_dateable_parent_iface = g_type_interface_peek_parent (iface);
#line 157 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	iface->get_exposure_time = (time_t (*)(Dateable*)) photo_real_get_exposure_time;
#line 157 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	iface->set_exposure_time = (void (*)(Dateable*, time_t)) photo_real_set_exposure_time;
#line 26085 "Photo.c"
}


static void photo_instance_init (Photo * self) {
	BackingPhotoState _tmp0_ = {0};
	PhotoBackingReaders _tmp1_ = {0};
#line 157 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	self->priv = PHOTO_GET_PRIVATE (self);
#line 279 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_static_rec_mutex_init (&self->priv->__lock_row);
#line 280 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	memset (&_tmp0_, 0, sizeof (BackingPhotoState));
#line 280 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	self->priv->editable = _tmp0_;
#line 281 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_static_rec_mutex_init (&self->priv->__lock_readers);
#line 281 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	memset (&_tmp1_, 0, sizeof (PhotoBackingReaders));
#line 281 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	self->priv->readers = _tmp1_;
#line 282 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	self->priv->transformer = NULL;
#line 283 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	self->priv->adjustments = NULL;
#line 285 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	self->priv->file_title = NULL;
#line 286 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	self->priv->editable_monitor = NULL;
#line 287 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	self->priv->reimport_editable_scheduler = NULL;
#line 288 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	self->priv->update_editable_attributes_scheduler = NULL;
#line 289 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	self->priv->remove_editable_scheduler = NULL;
#line 293 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	self->priv->backing_photo_state = NULL;
#line 26122 "Photo.c"
}


static void photo_finalize (GObject* obj) {
	Photo * self;
#line 157 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	self = PHOTO (obj);
#line 279 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_static_rec_mutex_free (&self->priv->__lock_row);
#line 279 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	photo_row_destroy (&self->priv->row);
#line 280 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	backing_photo_state_destroy (&self->priv->editable);
#line 281 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_static_rec_mutex_free (&self->priv->__lock_readers);
#line 281 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	photo_backing_readers_destroy (&self->priv->readers);
#line 282 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_pixel_transformer_unref0 (self->priv->transformer);
#line 283 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_pixel_transformation_bundle_unref0 (self->priv->adjustments);
#line 285 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_g_free0 (self->priv->file_title);
#line 286 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_g_object_unref0 (self->priv->editable_monitor);
#line 287 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_one_shot_scheduler_unref0 (self->priv->reimport_editable_scheduler);
#line 288 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_one_shot_scheduler_unref0 (self->priv->update_editable_attributes_scheduler);
#line 289 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_one_shot_scheduler_unref0 (self->priv->remove_editable_scheduler);
#line 157 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	G_OBJECT_CLASS (photo_parent_class)->finalize (obj);
#line 26156 "Photo.c"
}


GType photo_get_type (void) {
	static volatile gsize photo_type_id__volatile = 0;
	if (g_once_init_enter (&photo_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PhotoClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Photo), 0, (GInstanceInitFunc) photo_instance_init, NULL };
		static const GInterfaceInfo dateable_info = { (GInterfaceInitFunc) photo_dateable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		GType photo_type_id;
		photo_type_id = g_type_register_static (TYPE_PHOTO_SOURCE, "Photo", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
		g_type_add_interface_static (photo_type_id, TYPE_DATEABLE, &dateable_info);
		g_once_init_leave (&photo_type_id__volatile, photo_type_id);
	}
	return photo_type_id__volatile;
}


GType library_photo_source_collection_state_get_type (void) {
	static volatile gsize library_photo_source_collection_state_type_id__volatile = 0;
	if (g_once_init_enter (&library_photo_source_collection_state_type_id__volatile)) {
		static const GEnumValue values[] = {{LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_ONLINE, "LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_ONLINE", "online"}, {LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_OFFLINE, "LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_OFFLINE", "offline"}, {LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_TRASH, "LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_TRASH", "trash"}, {LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_EDITABLE, "LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_EDITABLE", "editable"}, {0, NULL, NULL}};
		GType library_photo_source_collection_state_type_id;
		library_photo_source_collection_state_type_id = g_enum_register_static ("LibraryPhotoSourceCollectionState", values);
		g_once_init_leave (&library_photo_source_collection_state_type_id__volatile, library_photo_source_collection_state_type_id);
	}
	return library_photo_source_collection_state_type_id__volatile;
}


static gint _int64_compare_gcompare_func (gconstpointer a, gconstpointer b) {
	gint result;
	result = int64_compare (a, b);
#line 3414 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return result;
#line 26191 "Photo.c"
}


static gint64* _int64_dup (gint64* self) {
	gint64* dup;
#line 3414 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	dup = g_new0 (gint64, 1);
#line 3414 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	memcpy (dup, self, sizeof (gint64));
#line 3414 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return dup;
#line 26203 "Photo.c"
}


static gboolean _int64_equal_gequal_func (gconstpointer a, gconstpointer b) {
	gboolean result;
	result = int64_equal (a, b);
#line 3416 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return result;
#line 26212 "Photo.c"
}


static gint64 _photo_get_photo_key_get_source_database_key (DataSource* source, gpointer self) {
	gint64 result;
	result = photo_get_photo_key (source);
#line 3434 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return result;
#line 26221 "Photo.c"
}


static void _library_photo_source_collection_on_trashcan_contents_altered_source_holding_tank_contents_altered (SourceHoldingTank* _sender, GeeCollection* added, GeeCollection* removed, gpointer self) {
#line 3436 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	library_photo_source_collection_on_trashcan_contents_altered (self, added, removed);
#line 26228 "Photo.c"
}


static void _library_photo_source_collection_on_offline_contents_altered_source_holding_tank_contents_altered (SourceHoldingTank* _sender, GeeCollection* added, GeeCollection* removed, gpointer self) {
#line 3437 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	library_photo_source_collection_on_offline_contents_altered (self, added, removed);
#line 26235 "Photo.c"
}


LibraryPhotoSourceCollection* library_photo_source_collection_construct (GType object_type) {
	LibraryPhotoSourceCollection* self = NULL;
	MediaSourceHoldingTank* _tmp0_ = NULL;
	MediaSourceHoldingTank* _tmp1_;
	MediaSourceHoldingTank* _tmp2_ = NULL;
	MediaSourceHoldingTank* _tmp3_;
#line 3434 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	self = (LibraryPhotoSourceCollection*) media_source_collection_construct (object_type, "LibraryPhotoSourceCollection", _photo_get_photo_key_get_source_database_key, NULL);
#line 3436 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp0_ = media_source_collection_get_trashcan (MEDIA_SOURCE_COLLECTION (self));
#line 3436 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 3436 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_signal_connect (SOURCE_HOLDING_TANK (_tmp1_), "contents-altered", (GCallback) _library_photo_source_collection_on_trashcan_contents_altered_source_holding_tank_contents_altered, self);
#line 3436 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_source_holding_tank_unref0 (_tmp1_);
#line 3437 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp2_ = media_source_collection_get_offline_bin (MEDIA_SOURCE_COLLECTION (self));
#line 3437 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp3_ = _tmp2_;
#line 3437 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_signal_connect (SOURCE_HOLDING_TANK (_tmp3_), "contents-altered", (GCallback) _library_photo_source_collection_on_offline_contents_altered_source_holding_tank_contents_altered, self);
#line 3437 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_source_holding_tank_unref0 (_tmp3_);
#line 3433 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return self;
#line 26265 "Photo.c"
}


LibraryPhotoSourceCollection* library_photo_source_collection_new (void) {
#line 3433 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return library_photo_source_collection_construct (TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION);
#line 26272 "Photo.c"
}


static gboolean _library_photo_source_collection_check_if_trashed_photo_source_holding_tank_check_to_keep (DataSource* source, Alteration* alteration, gpointer self) {
	gboolean result;
	result = library_photo_source_collection_check_if_trashed_photo (self, source, alteration);
#line 3441 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return result;
#line 26281 "Photo.c"
}


static MediaSourceHoldingTank* library_photo_source_collection_real_create_trashcan (MediaSourceCollection* base) {
	LibraryPhotoSourceCollection * self;
	MediaSourceHoldingTank* result = NULL;
	MediaSourceHoldingTank* _tmp0_;
#line 3440 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	self = LIBRARY_PHOTO_SOURCE_COLLECTION (base);
#line 3441 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp0_ = media_source_holding_tank_new (MEDIA_SOURCE_COLLECTION (self), _library_photo_source_collection_check_if_trashed_photo_source_holding_tank_check_to_keep, self, _photo_get_photo_key_get_source_database_key, NULL);
#line 3441 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	result = _tmp0_;
#line 3441 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return result;
#line 26297 "Photo.c"
}


static gboolean _library_photo_source_collection_check_if_offline_photo_source_holding_tank_check_to_keep (DataSource* source, Alteration* alteration, gpointer self) {
	gboolean result;
	result = library_photo_source_collection_check_if_offline_photo (self, source, alteration);
#line 3445 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return result;
#line 26306 "Photo.c"
}


static MediaSourceHoldingTank* library_photo_source_collection_real_create_offline_bin (MediaSourceCollection* base) {
	LibraryPhotoSourceCollection * self;
	MediaSourceHoldingTank* result = NULL;
	MediaSourceHoldingTank* _tmp0_;
#line 3444 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	self = LIBRARY_PHOTO_SOURCE_COLLECTION (base);
#line 3445 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp0_ = media_source_holding_tank_new (MEDIA_SOURCE_COLLECTION (self), _library_photo_source_collection_check_if_offline_photo_source_holding_tank_check_to_keep, self, _photo_get_photo_key_get_source_database_key, NULL);
#line 3445 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	result = _tmp0_;
#line 3445 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return result;
#line 26322 "Photo.c"
}


static MediaMonitor* library_photo_source_collection_real_create_media_monitor (MediaSourceCollection* base, Workers* workers, GCancellable* cancellable) {
	LibraryPhotoSourceCollection * self;
	MediaMonitor* result = NULL;
	Workers* _tmp0_;
	GCancellable* _tmp1_;
	PhotoMonitor* _tmp2_;
#line 3448 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	self = LIBRARY_PHOTO_SOURCE_COLLECTION (base);
#line 3448 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail (IS_WORKERS (workers), NULL);
#line 3448 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail (G_IS_CANCELLABLE (cancellable), NULL);
#line 3449 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp0_ = workers;
#line 3449 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp1_ = cancellable;
#line 3449 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp2_ = photo_monitor_new (_tmp0_, _tmp1_);
#line 3449 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	result = MEDIA_MONITOR (_tmp2_);
#line 3449 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return result;
#line 26348 "Photo.c"
}


static gboolean library_photo_source_collection_real_holds_type_of_source (SourceCollection* base, DataSource* source) {
	LibraryPhotoSourceCollection * self;
	gboolean result = FALSE;
	DataSource* _tmp0_;
#line 3452 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	self = LIBRARY_PHOTO_SOURCE_COLLECTION (base);
#line 3452 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail (IS_DATA_SOURCE (source), FALSE);
#line 3453 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp0_ = source;
#line 3453 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	result = IS_LIBRARY_PHOTO (_tmp0_);
#line 3453 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return result;
#line 26366 "Photo.c"
}


static gchar* library_photo_source_collection_real_get_typename (MediaSourceCollection* base) {
	LibraryPhotoSourceCollection * self;
	gchar* result = NULL;
	gchar* _tmp0_;
#line 3456 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	self = LIBRARY_PHOTO_SOURCE_COLLECTION (base);
#line 3457 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp0_ = g_strdup (PHOTO_TYPENAME);
#line 3457 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	result = _tmp0_;
#line 3457 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return result;
#line 26382 "Photo.c"
}


static gboolean library_photo_source_collection_real_is_file_recognized (MediaSourceCollection* base, GFile* file) {
	LibraryPhotoSourceCollection * self;
	gboolean result = FALSE;
	GFile* _tmp0_;
	gboolean _tmp1_ = FALSE;
#line 3460 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	self = LIBRARY_PHOTO_SOURCE_COLLECTION (base);
#line 3460 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail (G_IS_FILE (file), FALSE);
#line 3461 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp0_ = file;
#line 3461 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp1_ = photo_file_format_is_file_supported (_tmp0_);
#line 3461 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	result = _tmp1_;
#line 3461 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return result;
#line 26403 "Photo.c"
}


static void _library_photo_source_collection_on_editable_replaced_photo_editable_replaced (Photo* _sender, GFile* old_file, GFile* new_file, gpointer self) {
#line 3473 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	library_photo_source_collection_on_editable_replaced (self, _sender, old_file, new_file);
#line 26410 "Photo.c"
}


static void library_photo_source_collection_real_notify_contents_altered (DataCollection* base, GeeIterable* added, GeeIterable* removed) {
	LibraryPhotoSourceCollection * self;
	GeeIterable* _tmp0_;
	GeeIterable* _tmp44_;
	GeeIterable* _tmp91_;
	GeeIterable* _tmp92_;
#line 3464 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	self = LIBRARY_PHOTO_SOURCE_COLLECTION (base);
#line 3464 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail ((added == NULL) || GEE_IS_ITERABLE (added));
#line 3464 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail ((removed == NULL) || GEE_IS_ITERABLE (removed));
#line 3466 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp0_ = added;
#line 3466 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp0_ != NULL) {
#line 26430 "Photo.c"
		{
			GeeIterable* _tmp1_;
			GeeIterator* _tmp2_ = NULL;
			GeeIterator* _object_it;
#line 3467 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp1_ = added;
#line 3467 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp2_ = gee_iterable_iterator (_tmp1_);
#line 3467 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_object_it = _tmp2_;
#line 3467 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			while (TRUE) {
#line 26443 "Photo.c"
				GeeIterator* _tmp3_;
				gboolean _tmp4_ = FALSE;
				GeeIterator* _tmp5_;
				gpointer _tmp6_ = NULL;
				DataObject* object;
				DataObject* _tmp7_;
				LibraryPhoto* _tmp8_;
				LibraryPhoto* photo;
				LibraryPhoto* _tmp9_;
				GFile* _tmp10_ = NULL;
				GFile* editable;
				GFile* _tmp11_;
				LibraryPhoto* _tmp15_;
				LibraryPhoto* _tmp16_;
				BackingPhotoState _tmp17_ = {0};
				BackingPhotoState _tmp18_;
				gint64 _tmp19_;
				gint64 _tmp20_;
				gint64 master_filesize;
				gint64 _tmp21_ = 0LL;
				LibraryPhoto* _tmp22_;
				BackingPhotoState* _tmp23_ = NULL;
				BackingPhotoState* _tmp24_;
				gboolean _tmp25_;
				gint64 _tmp30_;
				gint64 editable_filesize;
				GeeMultiMap* _tmp31_;
				gint64 _tmp32_;
				LibraryPhoto* _tmp33_;
				GeeHashMap* _tmp34_;
				LibraryPhoto* _tmp35_;
				gint64 _tmp36_;
				gint64 _tmp37_;
#line 3467 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp3_ = _object_it;
#line 3467 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp4_ = gee_iterator_next (_tmp3_);
#line 3467 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				if (!_tmp4_) {
#line 3467 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					break;
#line 26485 "Photo.c"
				}
#line 3467 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp5_ = _object_it;
#line 3467 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp6_ = gee_iterator_get (_tmp5_);
#line 3467 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				object = (DataObject*) _tmp6_;
#line 3468 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp7_ = object;
#line 3468 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp8_ = _g_object_ref0 (LIBRARY_PHOTO (_tmp7_));
#line 3468 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				photo = _tmp8_;
#line 3470 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp9_ = photo;
#line 3470 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp10_ = photo_get_editable_file (PHOTO (_tmp9_));
#line 3470 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				editable = _tmp10_;
#line 3471 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp11_ = editable;
#line 3471 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				if (_tmp11_ != NULL) {
#line 26509 "Photo.c"
					GeeHashMap* _tmp12_;
					GFile* _tmp13_;
					LibraryPhoto* _tmp14_;
#line 3472 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_tmp12_ = self->priv->by_editable_file;
#line 3472 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_tmp13_ = editable;
#line 3472 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_tmp14_ = photo;
#line 3472 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					gee_abstract_map_set (GEE_ABSTRACT_MAP (_tmp12_), _tmp13_, _tmp14_);
#line 26521 "Photo.c"
				}
#line 3473 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp15_ = photo;
#line 3473 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				g_signal_connect (PHOTO (_tmp15_), "editable-replaced", (GCallback) _library_photo_source_collection_on_editable_replaced_photo_editable_replaced, self);
#line 3475 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp16_ = photo;
#line 3475 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				photo_get_master_photo_state (PHOTO (_tmp16_), &_tmp17_);
#line 3475 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp18_ = _tmp17_;
#line 3475 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp19_ = _tmp18_.filesize;
#line 3475 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp20_ = _tmp19_;
#line 3475 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				backing_photo_state_destroy (&_tmp18_);
#line 3475 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				master_filesize = _tmp20_;
#line 3476 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp22_ = photo;
#line 3476 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp23_ = photo_get_editable_photo_state (PHOTO (_tmp22_));
#line 3476 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp24_ = _tmp23_;
#line 3476 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp25_ = _tmp24_ != NULL;
#line 3476 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_backing_photo_state_free0 (_tmp24_);
#line 3476 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				if (_tmp25_) {
#line 26553 "Photo.c"
					LibraryPhoto* _tmp26_;
					BackingPhotoState* _tmp27_ = NULL;
					BackingPhotoState* _tmp28_;
					gint64 _tmp29_;
#line 3477 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_tmp26_ = photo;
#line 3477 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_tmp27_ = photo_get_editable_photo_state (PHOTO (_tmp26_));
#line 3477 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_tmp28_ = _tmp27_;
#line 3477 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_tmp29_ = (*_tmp28_).filesize;
#line 3477 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_tmp21_ = _tmp29_;
#line 3477 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_backing_photo_state_free0 (_tmp28_);
#line 26570 "Photo.c"
				} else {
#line 3478 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_tmp21_ = (gint64) (-1);
#line 26574 "Photo.c"
				}
#line 3476 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp30_ = _tmp21_;
#line 3476 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				editable_filesize = _tmp30_;
#line 3479 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp31_ = self->priv->filesize_to_photo;
#line 3479 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp32_ = master_filesize;
#line 3479 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp33_ = photo;
#line 3479 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				gee_multi_map_set (_tmp31_, &_tmp32_, _tmp33_);
#line 3480 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp34_ = self->priv->photo_to_master_filesize;
#line 3480 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp35_ = photo;
#line 3480 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp36_ = master_filesize;
#line 3480 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				gee_abstract_map_set (GEE_ABSTRACT_MAP (_tmp34_), _tmp35_, &_tmp36_);
#line 3481 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp37_ = editable_filesize;
#line 3481 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				if (_tmp37_ >= ((gint64) 0)) {
#line 26600 "Photo.c"
					GeeMultiMap* _tmp38_;
					gint64 _tmp39_;
					LibraryPhoto* _tmp40_;
					GeeHashMap* _tmp41_;
					LibraryPhoto* _tmp42_;
					gint64 _tmp43_;
#line 3482 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_tmp38_ = self->priv->filesize_to_photo;
#line 3482 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_tmp39_ = editable_filesize;
#line 3482 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_tmp40_ = photo;
#line 3482 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					gee_multi_map_set (_tmp38_, &_tmp39_, _tmp40_);
#line 3483 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_tmp41_ = self->priv->photo_to_editable_filesize;
#line 3483 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_tmp42_ = photo;
#line 3483 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_tmp43_ = editable_filesize;
#line 3483 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					gee_abstract_map_set (GEE_ABSTRACT_MAP (_tmp41_), _tmp42_, &_tmp43_);
#line 26623 "Photo.c"
				}
#line 3467 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_g_object_unref0 (editable);
#line 3467 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_g_object_unref0 (photo);
#line 3467 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_g_object_unref0 (object);
#line 26631 "Photo.c"
			}
#line 3467 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_g_object_unref0 (_object_it);
#line 26635 "Photo.c"
		}
	}
#line 3488 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp44_ = removed;
#line 3488 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp44_ != NULL) {
#line 26642 "Photo.c"
		{
			GeeIterable* _tmp45_;
			GeeIterator* _tmp46_ = NULL;
			GeeIterator* _object_it;
#line 3489 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp45_ = removed;
#line 3489 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp46_ = gee_iterable_iterator (_tmp45_);
#line 3489 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_object_it = _tmp46_;
#line 3489 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			while (TRUE) {
#line 26655 "Photo.c"
				GeeIterator* _tmp47_;
				gboolean _tmp48_ = FALSE;
				GeeIterator* _tmp49_;
				gpointer _tmp50_ = NULL;
				DataObject* object;
				DataObject* _tmp51_;
				LibraryPhoto* _tmp52_;
				LibraryPhoto* photo;
				LibraryPhoto* _tmp53_;
				GFile* _tmp54_ = NULL;
				GFile* editable;
				GFile* _tmp55_;
				LibraryPhoto* _tmp63_;
				guint _tmp64_ = 0U;
				LibraryPhoto* _tmp65_;
				BackingPhotoState _tmp66_ = {0};
				BackingPhotoState _tmp67_;
				gint64 _tmp68_;
				gint64 _tmp69_;
				gint64 master_filesize;
				gint64 _tmp70_ = 0LL;
				LibraryPhoto* _tmp71_;
				BackingPhotoState* _tmp72_ = NULL;
				BackingPhotoState* _tmp73_;
				gboolean _tmp74_;
				gint64 _tmp79_;
				gint64 editable_filesize;
				GeeMultiMap* _tmp80_;
				gint64 _tmp81_;
				LibraryPhoto* _tmp82_;
				GeeHashMap* _tmp83_;
				LibraryPhoto* _tmp84_;
				gint64 _tmp85_;
#line 3489 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp47_ = _object_it;
#line 3489 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp48_ = gee_iterator_next (_tmp47_);
#line 3489 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				if (!_tmp48_) {
#line 3489 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					break;
#line 26697 "Photo.c"
				}
#line 3489 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp49_ = _object_it;
#line 3489 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp50_ = gee_iterator_get (_tmp49_);
#line 3489 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				object = (DataObject*) _tmp50_;
#line 3490 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp51_ = object;
#line 3490 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp52_ = _g_object_ref0 (LIBRARY_PHOTO (_tmp51_));
#line 3490 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				photo = _tmp52_;
#line 3492 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp53_ = photo;
#line 3492 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp54_ = photo_get_editable_file (PHOTO (_tmp53_));
#line 3492 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				editable = _tmp54_;
#line 3493 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp55_ = editable;
#line 3493 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				if (_tmp55_ != NULL) {
#line 26721 "Photo.c"
					GeeHashMap* _tmp56_;
					LibraryPhoto* _tmp57_;
					GFile* _tmp58_ = NULL;
					GFile* _tmp59_;
					gboolean _tmp60_ = FALSE;
					gboolean _tmp61_;
					gboolean is_removed;
					gboolean _tmp62_;
#line 3494 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_tmp56_ = self->priv->by_editable_file;
#line 3494 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_tmp57_ = photo;
#line 3494 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_tmp58_ = photo_get_editable_file (PHOTO (_tmp57_));
#line 3494 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_tmp59_ = _tmp58_;
#line 3494 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_tmp60_ = gee_abstract_map_unset (GEE_ABSTRACT_MAP (_tmp56_), _tmp59_, NULL);
#line 3494 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_tmp61_ = _tmp60_;
#line 3494 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_g_object_unref0 (_tmp59_);
#line 3494 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					is_removed = _tmp61_;
#line 3495 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_tmp62_ = is_removed;
#line 3495 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					g_assert (_tmp62_);
#line 26750 "Photo.c"
				}
#line 3497 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp63_ = photo;
#line 3497 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				g_signal_parse_name ("editable-replaced", TYPE_PHOTO, &_tmp64_, NULL, FALSE);
#line 3497 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				g_signal_handlers_disconnect_matched (PHOTO (_tmp63_), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp64_, 0, NULL, (GCallback) _library_photo_source_collection_on_editable_replaced_photo_editable_replaced, self);
#line 3499 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp65_ = photo;
#line 3499 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				photo_get_master_photo_state (PHOTO (_tmp65_), &_tmp66_);
#line 3499 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp67_ = _tmp66_;
#line 3499 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp68_ = _tmp67_.filesize;
#line 3499 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp69_ = _tmp68_;
#line 3499 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				backing_photo_state_destroy (&_tmp67_);
#line 3499 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				master_filesize = _tmp69_;
#line 3500 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp71_ = photo;
#line 3500 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp72_ = photo_get_editable_photo_state (PHOTO (_tmp71_));
#line 3500 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp73_ = _tmp72_;
#line 3500 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp74_ = _tmp73_ != NULL;
#line 3500 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_backing_photo_state_free0 (_tmp73_);
#line 3500 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				if (_tmp74_) {
#line 26784 "Photo.c"
					LibraryPhoto* _tmp75_;
					BackingPhotoState* _tmp76_ = NULL;
					BackingPhotoState* _tmp77_;
					gint64 _tmp78_;
#line 3501 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_tmp75_ = photo;
#line 3501 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_tmp76_ = photo_get_editable_photo_state (PHOTO (_tmp75_));
#line 3501 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_tmp77_ = _tmp76_;
#line 3501 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_tmp78_ = (*_tmp77_).filesize;
#line 3501 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_tmp70_ = _tmp78_;
#line 3501 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_backing_photo_state_free0 (_tmp77_);
#line 26801 "Photo.c"
				} else {
#line 3502 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_tmp70_ = (gint64) (-1);
#line 26805 "Photo.c"
				}
#line 3500 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp79_ = _tmp70_;
#line 3500 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				editable_filesize = _tmp79_;
#line 3503 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp80_ = self->priv->filesize_to_photo;
#line 3503 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp81_ = master_filesize;
#line 3503 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp82_ = photo;
#line 3503 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				gee_multi_map_remove (_tmp80_, &_tmp81_, _tmp82_);
#line 3504 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp83_ = self->priv->photo_to_master_filesize;
#line 3504 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp84_ = photo;
#line 3504 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				gee_abstract_map_unset (GEE_ABSTRACT_MAP (_tmp83_), _tmp84_, NULL);
#line 3505 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp85_ = editable_filesize;
#line 3505 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				if (_tmp85_ >= ((gint64) 0)) {
#line 26829 "Photo.c"
					GeeMultiMap* _tmp86_;
					gint64 _tmp87_;
					LibraryPhoto* _tmp88_;
					GeeHashMap* _tmp89_;
					LibraryPhoto* _tmp90_;
#line 3506 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_tmp86_ = self->priv->filesize_to_photo;
#line 3506 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_tmp87_ = editable_filesize;
#line 3506 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_tmp88_ = photo;
#line 3506 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					gee_multi_map_remove (_tmp86_, &_tmp87_, _tmp88_);
#line 3507 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_tmp89_ = self->priv->photo_to_editable_filesize;
#line 3507 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_tmp90_ = photo;
#line 3507 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					gee_abstract_map_unset (GEE_ABSTRACT_MAP (_tmp89_), _tmp90_, NULL);
#line 26849 "Photo.c"
				}
#line 3489 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_g_object_unref0 (editable);
#line 3489 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_g_object_unref0 (photo);
#line 3489 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_g_object_unref0 (object);
#line 26857 "Photo.c"
			}
#line 3489 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_g_object_unref0 (_object_it);
#line 26861 "Photo.c"
		}
	}
#line 3512 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp91_ = added;
#line 3512 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp92_ = removed;
#line 3512 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	DATA_COLLECTION_CLASS (library_photo_source_collection_parent_class)->notify_contents_altered (DATA_COLLECTION (MEDIA_SOURCE_COLLECTION (self)), _tmp91_, _tmp92_);
#line 26870 "Photo.c"
}


static void library_photo_source_collection_on_editable_replaced (LibraryPhotoSourceCollection* self, Photo* photo, GFile* old_file, GFile* new_file) {
	GFile* _tmp0_;
	GFile* _tmp5_;
#line 3515 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self));
#line 3515 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO (photo));
#line 3515 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail ((old_file == NULL) || G_IS_FILE (old_file));
#line 3515 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail ((new_file == NULL) || G_IS_FILE (new_file));
#line 3516 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp0_ = old_file;
#line 3516 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp0_ != NULL) {
#line 26889 "Photo.c"
		GeeHashMap* _tmp1_;
		GFile* _tmp2_;
		gboolean _tmp3_ = FALSE;
		gboolean is_removed;
		gboolean _tmp4_;
#line 3517 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp1_ = self->priv->by_editable_file;
#line 3517 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp2_ = old_file;
#line 3517 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp3_ = gee_abstract_map_unset (GEE_ABSTRACT_MAP (_tmp1_), _tmp2_, NULL);
#line 3517 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		is_removed = _tmp3_;
#line 3518 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp4_ = is_removed;
#line 3518 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_assert (_tmp4_);
#line 26907 "Photo.c"
	}
#line 3521 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp5_ = new_file;
#line 3521 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp5_ != NULL) {
#line 26913 "Photo.c"
		GeeHashMap* _tmp6_;
		GFile* _tmp7_;
		Photo* _tmp8_;
#line 3522 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp6_ = self->priv->by_editable_file;
#line 3522 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp7_ = new_file;
#line 3522 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp8_ = photo;
#line 3522 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		gee_abstract_map_set (GEE_ABSTRACT_MAP (_tmp6_), _tmp7_, LIBRARY_PHOTO (_tmp8_));
#line 26925 "Photo.c"
	}
}


static gpointer __int64_dup0 (gpointer self) {
#line 3535 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return self ? _int64_dup (self) : NULL;
#line 26933 "Photo.c"
}


static void library_photo_source_collection_real_items_altered (DataCollection* base, GeeMap* items) {
	LibraryPhotoSourceCollection * self;
	GeeMap* _tmp75_;
#line 3525 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	self = LIBRARY_PHOTO_SOURCE_COLLECTION (base);
#line 3525 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail (GEE_IS_MAP (items));
#line 26944 "Photo.c"
	{
		GeeMap* _tmp0_;
		GeeSet* _tmp1_;
		GeeSet* _tmp2_;
		GeeSet* _tmp3_;
		GeeIterator* _tmp4_ = NULL;
		GeeIterator* _tmp5_;
		GeeIterator* _object_it;
#line 3526 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp0_ = items;
#line 3526 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp1_ = gee_map_get_keys (_tmp0_);
#line 3526 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp2_ = _tmp1_;
#line 3526 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp3_ = _tmp2_;
#line 3526 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp4_ = gee_iterable_iterator (GEE_ITERABLE (_tmp3_));
#line 3526 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp5_ = _tmp4_;
#line 3526 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_object_unref0 (_tmp3_);
#line 3526 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_object_it = _tmp5_;
#line 3526 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		while (TRUE) {
#line 26971 "Photo.c"
			GeeIterator* _tmp6_;
			gboolean _tmp7_ = FALSE;
			GeeIterator* _tmp8_;
			gpointer _tmp9_ = NULL;
			DataObject* object;
			GeeMap* _tmp10_;
			DataObject* _tmp11_;
			gpointer _tmp12_ = NULL;
			Alteration* alteration;
			DataObject* _tmp13_;
			LibraryPhoto* _tmp14_;
			LibraryPhoto* photo;
			gboolean _tmp15_ = FALSE;
			Alteration* _tmp16_;
			gboolean _tmp17_ = FALSE;
			gboolean _tmp20_;
#line 3526 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp6_ = _object_it;
#line 3526 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp7_ = gee_iterator_next (_tmp6_);
#line 3526 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			if (!_tmp7_) {
#line 3526 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				break;
#line 26996 "Photo.c"
			}
#line 3526 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp8_ = _object_it;
#line 3526 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp9_ = gee_iterator_get (_tmp8_);
#line 3526 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			object = (DataObject*) _tmp9_;
#line 3527 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp10_ = items;
#line 3527 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp11_ = object;
#line 3527 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp12_ = gee_map_get (_tmp10_, _tmp11_);
#line 3527 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			alteration = (Alteration*) _tmp12_;
#line 3529 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp13_ = object;
#line 3529 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp14_ = _g_object_ref0 (LIBRARY_PHOTO (_tmp13_));
#line 3529 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			photo = _tmp14_;
#line 3531 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp16_ = alteration;
#line 3531 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp17_ = alteration_has_detail (_tmp16_, "image", "master");
#line 3531 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			if (_tmp17_) {
#line 3531 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp15_ = TRUE;
#line 27026 "Photo.c"
			} else {
				Alteration* _tmp18_;
				gboolean _tmp19_ = FALSE;
#line 3531 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp18_ = alteration;
#line 3531 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp19_ = alteration_has_detail (_tmp18_, "image", "editable");
#line 3531 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp15_ = _tmp19_;
#line 27036 "Photo.c"
			}
#line 3531 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp20_ = _tmp15_;
#line 3531 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			if (_tmp20_) {
#line 27042 "Photo.c"
				GeeHashMap* _tmp21_;
				LibraryPhoto* _tmp22_;
				gpointer _tmp23_ = NULL;
				gint64* _tmp24_;
				gint64 _tmp25_;
				gint64 old_master_filesize;
				gint64* _tmp26_ = NULL;
				GeeHashMap* _tmp27_;
				LibraryPhoto* _tmp28_;
				gboolean _tmp29_ = FALSE;
				gint64* _tmp35_;
				gint64 old_editable_filesize;
				GeeHashMap* _tmp36_;
				LibraryPhoto* _tmp37_;
				GeeMultiMap* _tmp38_;
				gint64 _tmp39_;
				LibraryPhoto* _tmp40_;
				gint64 _tmp41_;
				LibraryPhoto* _tmp47_;
				BackingPhotoState _tmp48_ = {0};
				BackingPhotoState _tmp49_;
				gint64 _tmp50_;
				gint64 _tmp51_;
				gint64 master_filesize;
				gint64 _tmp52_ = 0LL;
				LibraryPhoto* _tmp53_;
				BackingPhotoState* _tmp54_ = NULL;
				BackingPhotoState* _tmp55_;
				gboolean _tmp56_;
				gint64 _tmp61_;
				gint64 editable_filesize;
				GeeHashMap* _tmp62_;
				LibraryPhoto* _tmp63_;
				gint64 _tmp64_;
				GeeMultiMap* _tmp65_;
				gint64 _tmp66_;
				LibraryPhoto* _tmp67_;
				gint64 _tmp68_;
#line 3532 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp21_ = self->priv->photo_to_master_filesize;
#line 3532 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp22_ = photo;
#line 3532 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp23_ = gee_abstract_map_get (GEE_ABSTRACT_MAP (_tmp21_), _tmp22_);
#line 3532 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp24_ = (gint64*) _tmp23_;
#line 3532 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp25_ = *_tmp24_;
#line 3532 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_g_free0 (_tmp24_);
#line 3532 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				old_master_filesize = _tmp25_;
#line 3533 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp27_ = self->priv->photo_to_editable_filesize;
#line 3533 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp28_ = photo;
#line 3533 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp29_ = gee_abstract_map_has_key (GEE_ABSTRACT_MAP (_tmp27_), _tmp28_);
#line 3533 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				if (_tmp29_) {
#line 27103 "Photo.c"
					GeeHashMap* _tmp30_;
					LibraryPhoto* _tmp31_;
					gpointer _tmp32_ = NULL;
#line 3534 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_tmp30_ = self->priv->photo_to_editable_filesize;
#line 3534 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_tmp31_ = photo;
#line 3534 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_tmp32_ = gee_abstract_map_get (GEE_ABSTRACT_MAP (_tmp30_), _tmp31_);
#line 3534 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_g_free0 (_tmp26_);
#line 3534 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_tmp26_ = (gint64*) _tmp32_;
#line 27117 "Photo.c"
				} else {
					gint64 _tmp33_;
					gint64* _tmp34_;
#line 3535 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_tmp33_ = (gint64) (-1);
#line 3535 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_tmp34_ = __int64_dup0 (&_tmp33_);
#line 3535 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_g_free0 (_tmp26_);
#line 3535 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_tmp26_ = _tmp34_;
#line 27129 "Photo.c"
				}
#line 3533 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp35_ = _tmp26_;
#line 3533 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				old_editable_filesize = *_tmp35_;
#line 3537 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp36_ = self->priv->photo_to_master_filesize;
#line 3537 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp37_ = photo;
#line 3537 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				gee_abstract_map_unset (GEE_ABSTRACT_MAP (_tmp36_), _tmp37_, NULL);
#line 3538 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp38_ = self->priv->filesize_to_photo;
#line 3538 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp39_ = old_master_filesize;
#line 3538 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp40_ = photo;
#line 3538 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				gee_multi_map_remove (_tmp38_, &_tmp39_, _tmp40_);
#line 3539 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp41_ = old_editable_filesize;
#line 3539 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				if (_tmp41_ >= ((gint64) 0)) {
#line 27153 "Photo.c"
					GeeHashMap* _tmp42_;
					LibraryPhoto* _tmp43_;
					GeeMultiMap* _tmp44_;
					gint64 _tmp45_;
					LibraryPhoto* _tmp46_;
#line 3540 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_tmp42_ = self->priv->photo_to_editable_filesize;
#line 3540 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_tmp43_ = photo;
#line 3540 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					gee_abstract_map_unset (GEE_ABSTRACT_MAP (_tmp42_), _tmp43_, NULL);
#line 3541 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_tmp44_ = self->priv->filesize_to_photo;
#line 3541 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_tmp45_ = old_editable_filesize;
#line 3541 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_tmp46_ = photo;
#line 3541 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					gee_multi_map_remove (_tmp44_, &_tmp45_, _tmp46_);
#line 27173 "Photo.c"
				}
#line 3544 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp47_ = photo;
#line 3544 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				photo_get_master_photo_state (PHOTO (_tmp47_), &_tmp48_);
#line 3544 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp49_ = _tmp48_;
#line 3544 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp50_ = _tmp49_.filesize;
#line 3544 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp51_ = _tmp50_;
#line 3544 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				backing_photo_state_destroy (&_tmp49_);
#line 3544 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				master_filesize = _tmp51_;
#line 3545 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp53_ = photo;
#line 3545 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp54_ = photo_get_editable_photo_state (PHOTO (_tmp53_));
#line 3545 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp55_ = _tmp54_;
#line 3545 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp56_ = _tmp55_ != NULL;
#line 3545 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_backing_photo_state_free0 (_tmp55_);
#line 3545 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				if (_tmp56_) {
#line 27201 "Photo.c"
					LibraryPhoto* _tmp57_;
					BackingPhotoState* _tmp58_ = NULL;
					BackingPhotoState* _tmp59_;
					gint64 _tmp60_;
#line 3546 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_tmp57_ = photo;
#line 3546 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_tmp58_ = photo_get_editable_photo_state (PHOTO (_tmp57_));
#line 3546 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_tmp59_ = _tmp58_;
#line 3546 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_tmp60_ = (*_tmp59_).filesize;
#line 3546 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_tmp52_ = _tmp60_;
#line 3546 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_backing_photo_state_free0 (_tmp59_);
#line 27218 "Photo.c"
				} else {
#line 3547 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_tmp52_ = (gint64) (-1);
#line 27222 "Photo.c"
				}
#line 3545 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp61_ = _tmp52_;
#line 3545 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				editable_filesize = _tmp61_;
#line 3548 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp62_ = self->priv->photo_to_master_filesize;
#line 3548 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp63_ = photo;
#line 3548 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp64_ = master_filesize;
#line 3548 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				gee_abstract_map_set (GEE_ABSTRACT_MAP (_tmp62_), _tmp63_, &_tmp64_);
#line 3549 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp65_ = self->priv->filesize_to_photo;
#line 3549 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp66_ = master_filesize;
#line 3549 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp67_ = photo;
#line 3549 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				gee_multi_map_set (_tmp65_, &_tmp66_, _tmp67_);
#line 3550 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp68_ = editable_filesize;
#line 3550 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				if (_tmp68_ >= ((gint64) 0)) {
#line 27248 "Photo.c"
					GeeHashMap* _tmp69_;
					LibraryPhoto* _tmp70_;
					gint64 _tmp71_;
					GeeMultiMap* _tmp72_;
					gint64 _tmp73_;
					LibraryPhoto* _tmp74_;
#line 3551 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_tmp69_ = self->priv->photo_to_editable_filesize;
#line 3551 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_tmp70_ = photo;
#line 3551 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_tmp71_ = editable_filesize;
#line 3551 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					gee_abstract_map_set (GEE_ABSTRACT_MAP (_tmp69_), _tmp70_, &_tmp71_);
#line 3552 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_tmp72_ = self->priv->filesize_to_photo;
#line 3552 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_tmp73_ = editable_filesize;
#line 3552 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_tmp74_ = photo;
#line 3552 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					gee_multi_map_set (_tmp72_, &_tmp73_, _tmp74_);
#line 27271 "Photo.c"
				}
#line 3531 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_g_free0 (_tmp26_);
#line 27275 "Photo.c"
			}
#line 3526 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_g_object_unref0 (photo);
#line 3526 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_alteration_unref0 (alteration);
#line 3526 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_g_object_unref0 (object);
#line 27283 "Photo.c"
		}
#line 3526 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_object_unref0 (_object_it);
#line 27287 "Photo.c"
	}
#line 3557 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp75_ = items;
#line 3557 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	DATA_COLLECTION_CLASS (library_photo_source_collection_parent_class)->items_altered (DATA_COLLECTION (MEDIA_SOURCE_COLLECTION (self)), _tmp75_);
#line 27293 "Photo.c"
}


static void library_photo_source_collection_real_postprocess_imported_media (MediaSourceCollection* base, GeeCollection* media_sources) {
	LibraryPhotoSourceCollection * self;
	GeeHashMultiMap* _tmp0_;
	GeeHashMultiMap* map;
	GeeCollection* _tmp45_;
#line 3561 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	self = LIBRARY_PHOTO_SOURCE_COLLECTION (base);
#line 3561 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail (GEE_IS_COLLECTION (media_sources));
#line 3562 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp0_ = gee_hash_multi_map_new (TYPE_TAG, (GBoxedCopyFunc) g_object_ref, g_object_unref, TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL, NULL, NULL, NULL);
#line 3562 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	map = _tmp0_;
#line 27310 "Photo.c"
	{
		GeeCollection* _tmp1_;
		GeeIterator* _tmp2_ = NULL;
		GeeIterator* _media_it;
#line 3563 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp1_ = media_sources;
#line 3563 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp2_ = gee_iterable_iterator (GEE_ITERABLE (_tmp1_));
#line 3563 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_media_it = _tmp2_;
#line 3563 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		while (TRUE) {
#line 27323 "Photo.c"
			GeeIterator* _tmp3_;
			gboolean _tmp4_ = FALSE;
			GeeIterator* _tmp5_;
			gpointer _tmp6_ = NULL;
			MediaSource* media;
			MediaSource* _tmp7_;
			LibraryPhoto* _tmp8_;
			LibraryPhoto* photo;
			LibraryPhoto* _tmp9_;
			GeeCollection* _tmp10_ = NULL;
			GeeCollection* _tmp11_;
			gboolean _tmp12_;
#line 3563 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp3_ = _media_it;
#line 3563 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp4_ = gee_iterator_next (_tmp3_);
#line 3563 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			if (!_tmp4_) {
#line 3563 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				break;
#line 27344 "Photo.c"
			}
#line 3563 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp5_ = _media_it;
#line 3563 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp6_ = gee_iterator_get (_tmp5_);
#line 3563 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			media = (MediaSource*) _tmp6_;
#line 3564 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp7_ = media;
#line 3564 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp8_ = _g_object_ref0 (LIBRARY_PHOTO (_tmp7_));
#line 3564 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			photo = _tmp8_;
#line 3565 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp9_ = photo;
#line 3565 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp10_ = library_photo_get_import_keywords (_tmp9_);
#line 3565 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp11_ = _tmp10_;
#line 3565 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp12_ = _tmp11_ != NULL;
#line 3565 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_g_object_unref0 (_tmp11_);
#line 3565 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			if (_tmp12_) {
#line 27370 "Photo.c"
				LibraryPhoto* _tmp30_;
				{
					LibraryPhoto* _tmp13_;
					GeeCollection* _tmp14_ = NULL;
					GeeCollection* _tmp15_;
					GeeIterator* _tmp16_ = NULL;
					GeeIterator* _tmp17_;
					GeeIterator* _keyword_it;
#line 3566 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_tmp13_ = photo;
#line 3566 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_tmp14_ = library_photo_get_import_keywords (_tmp13_);
#line 3566 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_tmp15_ = _tmp14_;
#line 3566 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_tmp16_ = gee_iterable_iterator (GEE_ITERABLE (_tmp15_));
#line 3566 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_tmp17_ = _tmp16_;
#line 3566 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_g_object_unref0 (_tmp15_);
#line 3566 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_keyword_it = _tmp17_;
#line 3566 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					while (TRUE) {
#line 27395 "Photo.c"
						GeeIterator* _tmp18_;
						gboolean _tmp19_ = FALSE;
						GeeIterator* _tmp20_;
						gpointer _tmp21_ = NULL;
						gchar* keyword;
						const gchar* _tmp22_;
						gchar* _tmp23_ = NULL;
						gchar* name;
						const gchar* _tmp24_;
#line 3566 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						_tmp18_ = _keyword_it;
#line 3566 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						_tmp19_ = gee_iterator_next (_tmp18_);
#line 3566 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						if (!_tmp19_) {
#line 3566 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
							break;
#line 27413 "Photo.c"
						}
#line 3566 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						_tmp20_ = _keyword_it;
#line 3566 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						_tmp21_ = gee_iterator_get (_tmp20_);
#line 3566 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						keyword = (gchar*) _tmp21_;
#line 3567 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						_tmp22_ = keyword;
#line 3567 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						_tmp23_ = tag_prep_tag_name (_tmp22_);
#line 3567 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						name = _tmp23_;
#line 3568 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						_tmp24_ = name;
#line 3568 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						if (_tmp24_ != NULL) {
#line 27431 "Photo.c"
							GeeHashMultiMap* _tmp25_;
							const gchar* _tmp26_;
							Tag* _tmp27_ = NULL;
							Tag* _tmp28_;
							LibraryPhoto* _tmp29_;
#line 3569 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
							_tmp25_ = map;
#line 3569 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
							_tmp26_ = name;
#line 3569 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
							_tmp27_ = tag_for_name (_tmp26_);
#line 3569 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
							_tmp28_ = _tmp27_;
#line 3569 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
							_tmp29_ = photo;
#line 3569 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
							gee_multi_map_set (GEE_MULTI_MAP (_tmp25_), _tmp28_, _tmp29_);
#line 3569 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
							_g_object_unref0 (_tmp28_);
#line 27451 "Photo.c"
						}
#line 3566 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						_g_free0 (name);
#line 3566 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						_g_free0 (keyword);
#line 27457 "Photo.c"
					}
#line 3566 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_g_object_unref0 (_keyword_it);
#line 27461 "Photo.c"
				}
#line 3572 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp30_ = photo;
#line 3572 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				library_photo_clear_import_keywords (_tmp30_);
#line 27467 "Photo.c"
			}
#line 3563 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_g_object_unref0 (photo);
#line 3563 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_g_object_unref0 (media);
#line 27473 "Photo.c"
		}
#line 3563 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_object_unref0 (_media_it);
#line 27477 "Photo.c"
	}
	{
		GeeHashMultiMap* _tmp31_;
		GeeSet* _tmp32_ = NULL;
		GeeSet* _tmp33_;
		GeeIterator* _tmp34_ = NULL;
		GeeIterator* _tmp35_;
		GeeIterator* _tag_it;
#line 3576 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp31_ = map;
#line 3576 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp32_ = gee_multi_map_get_keys (GEE_MULTI_MAP (_tmp31_));
#line 3576 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp33_ = _tmp32_;
#line 3576 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp34_ = gee_iterable_iterator (GEE_ITERABLE (_tmp33_));
#line 3576 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp35_ = _tmp34_;
#line 3576 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_object_unref0 (_tmp33_);
#line 3576 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tag_it = _tmp35_;
#line 3576 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		while (TRUE) {
#line 27502 "Photo.c"
			GeeIterator* _tmp36_;
			gboolean _tmp37_ = FALSE;
			GeeIterator* _tmp38_;
			gpointer _tmp39_ = NULL;
			Tag* tag;
			Tag* _tmp40_;
			GeeHashMultiMap* _tmp41_;
			Tag* _tmp42_;
			GeeCollection* _tmp43_ = NULL;
			GeeCollection* _tmp44_;
#line 3576 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp36_ = _tag_it;
#line 3576 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp37_ = gee_iterator_next (_tmp36_);
#line 3576 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			if (!_tmp37_) {
#line 3576 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				break;
#line 27521 "Photo.c"
			}
#line 3576 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp38_ = _tag_it;
#line 3576 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp39_ = gee_iterator_get (_tmp38_);
#line 3576 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			tag = (Tag*) _tmp39_;
#line 3577 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp40_ = tag;
#line 3577 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp41_ = map;
#line 3577 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp42_ = tag;
#line 3577 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp43_ = gee_multi_map_get (GEE_MULTI_MAP (_tmp41_), _tmp42_);
#line 3577 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp44_ = _tmp43_;
#line 3577 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			tag_attach_many (_tmp40_, _tmp44_);
#line 3577 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_g_object_unref0 (_tmp44_);
#line 3576 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_g_object_unref0 (tag);
#line 27545 "Photo.c"
		}
#line 3576 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_object_unref0 (_tag_it);
#line 27549 "Photo.c"
	}
#line 3579 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp45_ = media_sources;
#line 3579 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	MEDIA_SOURCE_COLLECTION_CLASS (library_photo_source_collection_parent_class)->postprocess_imported_media (MEDIA_SOURCE_COLLECTION (self), _tmp45_);
#line 3561 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_g_object_unref0 (map);
#line 27557 "Photo.c"
}


static void library_photo_source_collection_real_notify_master_reimported (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata) {
	LibraryPhoto* _tmp0_;
	PhotoMetadata* _tmp1_;
#line 3583 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO (photo));
#line 3583 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
#line 3584 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp0_ = photo;
#line 3584 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp1_ = metadata;
#line 3584 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_signal_emit_by_name (self, "master-reimported", _tmp0_, _tmp1_);
#line 27574 "Photo.c"
}


void library_photo_source_collection_notify_master_reimported (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata) {
#line 3583 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self));
#line 3583 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	LIBRARY_PHOTO_SOURCE_COLLECTION_GET_CLASS (self)->notify_master_reimported (self, photo, metadata);
#line 27583 "Photo.c"
}


static void library_photo_source_collection_real_notify_editable_reimported (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata) {
	LibraryPhoto* _tmp0_;
	PhotoMetadata* _tmp1_;
#line 3588 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO (photo));
#line 3588 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
#line 3589 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp0_ = photo;
#line 3589 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp1_ = metadata;
#line 3589 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_signal_emit_by_name (self, "editable-reimported", _tmp0_, _tmp1_);
#line 27600 "Photo.c"
}


void library_photo_source_collection_notify_editable_reimported (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata) {
#line 3588 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self));
#line 3588 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	LIBRARY_PHOTO_SOURCE_COLLECTION_GET_CLASS (self)->notify_editable_reimported (self, photo, metadata);
#line 27609 "Photo.c"
}


static void library_photo_source_collection_real_notify_source_reimported (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata) {
	LibraryPhoto* _tmp0_;
	PhotoMetadata* _tmp1_;
#line 3593 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO (photo));
#line 3593 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
#line 3594 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp0_ = photo;
#line 3594 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp1_ = metadata;
#line 3594 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_signal_emit_by_name (self, "source-reimported", _tmp0_, _tmp1_);
#line 27626 "Photo.c"
}


void library_photo_source_collection_notify_source_reimported (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata) {
#line 3593 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self));
#line 3593 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	LIBRARY_PHOTO_SOURCE_COLLECTION_GET_CLASS (self)->notify_source_reimported (self, photo, metadata);
#line 27635 "Photo.c"
}


static void library_photo_source_collection_real_notify_baseline_reimported (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata) {
	LibraryPhoto* _tmp0_;
	PhotoMetadata* _tmp1_;
#line 3598 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO (photo));
#line 3598 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
#line 3599 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp0_ = photo;
#line 3599 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp1_ = metadata;
#line 3599 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_signal_emit_by_name (self, "baseline-reimported", _tmp0_, _tmp1_);
#line 27652 "Photo.c"
}


void library_photo_source_collection_notify_baseline_reimported (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata) {
#line 3598 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self));
#line 3598 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	LIBRARY_PHOTO_SOURCE_COLLECTION_GET_CLASS (self)->notify_baseline_reimported (self, photo, metadata);
#line 27661 "Photo.c"
}


static MediaSource* library_photo_source_collection_real_fetch_by_numeric_id (MediaSourceCollection* base, gint64 numeric_id) {
	LibraryPhotoSourceCollection * self;
	MediaSource* result = NULL;
	gint64 _tmp0_;
	PhotoID _tmp1_ = {0};
	LibraryPhoto* _tmp2_ = NULL;
#line 3602 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	self = LIBRARY_PHOTO_SOURCE_COLLECTION (base);
#line 3603 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp0_ = numeric_id;
#line 3603 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	photo_id_init (&_tmp1_, _tmp0_);
#line 3603 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp2_ = library_photo_source_collection_fetch (self, &_tmp1_);
#line 3603 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	result = MEDIA_SOURCE (_tmp2_);
#line 3603 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return result;
#line 27683 "Photo.c"
}


static void library_photo_source_collection_on_trashcan_contents_altered (LibraryPhotoSourceCollection* self, GeeCollection* added, GeeCollection* removed) {
	GeeCollection* _tmp0_;
	GeeCollection* _tmp1_;
#line 3606 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self));
#line 3606 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail ((added == NULL) || GEE_IS_COLLECTION (added));
#line 3606 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail ((removed == NULL) || GEE_IS_COLLECTION (removed));
#line 3608 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp0_ = added;
#line 3608 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp1_ = removed;
#line 3608 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_signal_emit_by_name (MEDIA_SOURCE_COLLECTION (self), "trashcan-contents-altered", GEE_COLLECTION (_tmp0_), GEE_COLLECTION (_tmp1_));
#line 27702 "Photo.c"
}


static gboolean library_photo_source_collection_check_if_trashed_photo (LibraryPhotoSourceCollection* self, DataSource* source, Alteration* alteration) {
	gboolean result = FALSE;
	DataSource* _tmp0_;
	gboolean _tmp1_ = FALSE;
#line 3612 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self), FALSE);
#line 3612 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail (IS_DATA_SOURCE (source), FALSE);
#line 3612 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail (IS_ALTERATION (alteration), FALSE);
#line 3613 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp0_ = source;
#line 3613 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp1_ = media_source_is_trashed (MEDIA_SOURCE (LIBRARY_PHOTO (_tmp0_)));
#line 3613 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	result = _tmp1_;
#line 3613 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return result;
#line 27724 "Photo.c"
}


static void library_photo_source_collection_on_offline_contents_altered (LibraryPhotoSourceCollection* self, GeeCollection* added, GeeCollection* removed) {
	GeeCollection* _tmp0_;
	GeeCollection* _tmp1_;
#line 3616 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self));
#line 3616 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail ((added == NULL) || GEE_IS_COLLECTION (added));
#line 3616 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail ((removed == NULL) || GEE_IS_COLLECTION (removed));
#line 3618 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp0_ = added;
#line 3618 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp1_ = removed;
#line 3618 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_signal_emit_by_name (MEDIA_SOURCE_COLLECTION (self), "offline-contents-altered", GEE_COLLECTION (_tmp0_), GEE_COLLECTION (_tmp1_));
#line 27743 "Photo.c"
}


static gboolean library_photo_source_collection_check_if_offline_photo (LibraryPhotoSourceCollection* self, DataSource* source, Alteration* alteration) {
	gboolean result = FALSE;
	DataSource* _tmp0_;
	gboolean _tmp1_ = FALSE;
#line 3622 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self), FALSE);
#line 3622 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail (IS_DATA_SOURCE (source), FALSE);
#line 3622 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail (IS_ALTERATION (alteration), FALSE);
#line 3623 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp0_ = source;
#line 3623 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp1_ = media_source_is_offline (MEDIA_SOURCE (LIBRARY_PHOTO (_tmp0_)));
#line 3623 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	result = _tmp1_;
#line 3623 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return result;
#line 27765 "Photo.c"
}


static glong string_strnlen (gchar* str, glong maxlen) {
	glong result = 0L;
	gchar* _tmp0_;
	glong _tmp1_;
	gchar* _tmp2_ = NULL;
	gchar* end;
	gchar* _tmp3_;
#line 1301 "/usr/share/vala-0.14/vapi/glib-2.0.vapi"
	_tmp0_ = str;
#line 1301 "/usr/share/vala-0.14/vapi/glib-2.0.vapi"
	_tmp1_ = maxlen;
#line 1301 "/usr/share/vala-0.14/vapi/glib-2.0.vapi"
	_tmp2_ = memchr (_tmp0_, 0, (gsize) _tmp1_);
#line 1301 "/usr/share/vala-0.14/vapi/glib-2.0.vapi"
	end = _tmp2_;
#line 1302 "/usr/share/vala-0.14/vapi/glib-2.0.vapi"
	_tmp3_ = end;
#line 1302 "/usr/share/vala-0.14/vapi/glib-2.0.vapi"
	if (_tmp3_ == NULL) {
#line 27788 "Photo.c"
		glong _tmp4_;
#line 1303 "/usr/share/vala-0.14/vapi/glib-2.0.vapi"
		_tmp4_ = maxlen;
#line 1303 "/usr/share/vala-0.14/vapi/glib-2.0.vapi"
		result = _tmp4_;
#line 1303 "/usr/share/vala-0.14/vapi/glib-2.0.vapi"
		return result;
#line 27796 "Photo.c"
	} else {
		gchar* _tmp5_;
		gchar* _tmp6_;
#line 1305 "/usr/share/vala-0.14/vapi/glib-2.0.vapi"
		_tmp5_ = end;
#line 1305 "/usr/share/vala-0.14/vapi/glib-2.0.vapi"
		_tmp6_ = str;
#line 1305 "/usr/share/vala-0.14/vapi/glib-2.0.vapi"
		result = (glong) (_tmp5_ - _tmp6_);
#line 1305 "/usr/share/vala-0.14/vapi/glib-2.0.vapi"
		return result;
#line 27808 "Photo.c"
	}
}


static gchar* string_substring (const gchar* self, glong offset, glong len) {
	gchar* result = NULL;
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	glong _tmp1_;
	gboolean _tmp3_;
	glong _tmp9_;
	glong _tmp15_;
	glong _tmp18_;
	glong _tmp19_;
	glong _tmp20_;
	glong _tmp21_;
	glong _tmp22_;
	gchar* _tmp23_ = NULL;
#line 1312 "/usr/share/vala-0.14/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1314 "/usr/share/vala-0.14/vapi/glib-2.0.vapi"
	_tmp1_ = offset;
#line 1314 "/usr/share/vala-0.14/vapi/glib-2.0.vapi"
	if (_tmp1_ >= ((glong) 0)) {
#line 27833 "Photo.c"
		glong _tmp2_;
#line 1314 "/usr/share/vala-0.14/vapi/glib-2.0.vapi"
		_tmp2_ = len;
#line 1314 "/usr/share/vala-0.14/vapi/glib-2.0.vapi"
		_tmp0_ = _tmp2_ >= ((glong) 0);
#line 27839 "Photo.c"
	} else {
#line 1314 "/usr/share/vala-0.14/vapi/glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 27843 "Photo.c"
	}
#line 1314 "/usr/share/vala-0.14/vapi/glib-2.0.vapi"
	_tmp3_ = _tmp0_;
#line 1314 "/usr/share/vala-0.14/vapi/glib-2.0.vapi"
	if (_tmp3_) {
#line 27849 "Photo.c"
		glong _tmp4_;
		glong _tmp5_;
		glong _tmp6_ = 0L;
#line 1316 "/usr/share/vala-0.14/vapi/glib-2.0.vapi"
		_tmp4_ = offset;
#line 1316 "/usr/share/vala-0.14/vapi/glib-2.0.vapi"
		_tmp5_ = len;
#line 1316 "/usr/share/vala-0.14/vapi/glib-2.0.vapi"
		_tmp6_ = string_strnlen ((gchar*) self, _tmp4_ + _tmp5_);
#line 1316 "/usr/share/vala-0.14/vapi/glib-2.0.vapi"
		string_length = _tmp6_;
#line 27861 "Photo.c"
	} else {
		gint _tmp7_;
		gint _tmp8_;
#line 1318 "/usr/share/vala-0.14/vapi/glib-2.0.vapi"
		_tmp7_ = strlen (self);
#line 1318 "/usr/share/vala-0.14/vapi/glib-2.0.vapi"
		_tmp8_ = _tmp7_;
#line 1318 "/usr/share/vala-0.14/vapi/glib-2.0.vapi"
		string_length = (glong) _tmp8_;
#line 27871 "Photo.c"
	}
#line 1321 "/usr/share/vala-0.14/vapi/glib-2.0.vapi"
	_tmp9_ = offset;
#line 1321 "/usr/share/vala-0.14/vapi/glib-2.0.vapi"
	if (_tmp9_ < ((glong) 0)) {
#line 27877 "Photo.c"
		glong _tmp10_;
		glong _tmp11_;
		glong _tmp12_;
#line 1322 "/usr/share/vala-0.14/vapi/glib-2.0.vapi"
		_tmp10_ = string_length;
#line 1322 "/usr/share/vala-0.14/vapi/glib-2.0.vapi"
		_tmp11_ = offset;
#line 1322 "/usr/share/vala-0.14/vapi/glib-2.0.vapi"
		offset = _tmp10_ + _tmp11_;
#line 1323 "/usr/share/vala-0.14/vapi/glib-2.0.vapi"
		_tmp12_ = offset;
#line 1323 "/usr/share/vala-0.14/vapi/glib-2.0.vapi"
		g_return_val_if_fail (_tmp12_ >= ((glong) 0), NULL);
#line 27891 "Photo.c"
	} else {
		glong _tmp13_;
		glong _tmp14_;
#line 1325 "/usr/share/vala-0.14/vapi/glib-2.0.vapi"
		_tmp13_ = offset;
#line 1325 "/usr/share/vala-0.14/vapi/glib-2.0.vapi"
		_tmp14_ = string_length;
#line 1325 "/usr/share/vala-0.14/vapi/glib-2.0.vapi"
		g_return_val_if_fail (_tmp13_ <= _tmp14_, NULL);
#line 27901 "Photo.c"
	}
#line 1327 "/usr/share/vala-0.14/vapi/glib-2.0.vapi"
	_tmp15_ = len;
#line 1327 "/usr/share/vala-0.14/vapi/glib-2.0.vapi"
	if (_tmp15_ < ((glong) 0)) {
#line 27907 "Photo.c"
		glong _tmp16_;
		glong _tmp17_;
#line 1328 "/usr/share/vala-0.14/vapi/glib-2.0.vapi"
		_tmp16_ = string_length;
#line 1328 "/usr/share/vala-0.14/vapi/glib-2.0.vapi"
		_tmp17_ = offset;
#line 1328 "/usr/share/vala-0.14/vapi/glib-2.0.vapi"
		len = _tmp16_ - _tmp17_;
#line 27916 "Photo.c"
	}
#line 1330 "/usr/share/vala-0.14/vapi/glib-2.0.vapi"
	_tmp18_ = offset;
#line 1330 "/usr/share/vala-0.14/vapi/glib-2.0.vapi"
	_tmp19_ = len;
#line 1330 "/usr/share/vala-0.14/vapi/glib-2.0.vapi"
	_tmp20_ = string_length;
#line 1330 "/usr/share/vala-0.14/vapi/glib-2.0.vapi"
	g_return_val_if_fail ((_tmp18_ + _tmp19_) <= _tmp20_, NULL);
#line 1331 "/usr/share/vala-0.14/vapi/glib-2.0.vapi"
	_tmp21_ = offset;
#line 1331 "/usr/share/vala-0.14/vapi/glib-2.0.vapi"
	_tmp22_ = len;
#line 1331 "/usr/share/vala-0.14/vapi/glib-2.0.vapi"
	_tmp23_ = g_strndup (((gchar*) self) + _tmp21_, (gsize) _tmp22_);
#line 1331 "/usr/share/vala-0.14/vapi/glib-2.0.vapi"
	result = _tmp23_;
#line 1331 "/usr/share/vala-0.14/vapi/glib-2.0.vapi"
	return result;
#line 27936 "Photo.c"
}


static MediaSource* library_photo_source_collection_real_fetch_by_source_id (MediaSourceCollection* base, const gchar* source_id) {
	LibraryPhotoSourceCollection * self;
	MediaSource* result = NULL;
	const gchar* _tmp0_;
	gboolean _tmp1_ = FALSE;
	const gchar* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	gchar* _tmp5_ = NULL;
	gchar* numeric_only;
	gint64 _tmp6_ = 0LL;
	MediaSource* _tmp7_ = NULL;
#line 3626 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	self = LIBRARY_PHOTO_SOURCE_COLLECTION (base);
#line 3626 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail (source_id != NULL, NULL);
#line 3627 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp0_ = source_id;
#line 3627 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp1_ = g_str_has_prefix (_tmp0_, PHOTO_TYPENAME);
#line 3627 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_assert (_tmp1_);
#line 3628 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp2_ = source_id;
#line 3628 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp3_ = strlen (PHOTO_TYPENAME);
#line 3628 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp4_ = _tmp3_;
#line 3628 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp5_ = string_substring (_tmp2_, (glong) _tmp4_, (glong) (-1));
#line 3628 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	numeric_only = _tmp5_;
#line 3630 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp6_ = parse_int64 (numeric_only, 16);
#line 3630 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp7_ = media_source_collection_fetch_by_numeric_id (MEDIA_SOURCE_COLLECTION (self), _tmp6_);
#line 3630 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	result = _tmp7_;
#line 3630 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_g_free0 (numeric_only);
#line 3630 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return result;
#line 27982 "Photo.c"
}


static GeeCollection* library_photo_source_collection_real_get_event_source_ids (MediaSourceCollection* base, EventID* event_id) {
	LibraryPhotoSourceCollection * self;
	GeeCollection* result = NULL;
	PhotoTable* _tmp0_ = NULL;
	PhotoTable* _tmp1_;
	EventID _tmp2_;
	GeeArrayList* _tmp3_ = NULL;
	GeeCollection* _tmp4_;
#line 3633 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	self = LIBRARY_PHOTO_SOURCE_COLLECTION (base);
#line 3633 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail (event_id != NULL, NULL);
#line 3634 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp0_ = photo_table_get_instance ();
#line 3634 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 3634 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp2_ = *event_id;
#line 3634 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp3_ = photo_table_get_event_source_ids (_tmp1_, &_tmp2_);
#line 3634 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp4_ = GEE_COLLECTION (_tmp3_);
#line 3634 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_database_table_unref0 (_tmp1_);
#line 3634 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	result = _tmp4_;
#line 3634 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return result;
#line 28014 "Photo.c"
}


LibraryPhoto* library_photo_source_collection_fetch (LibraryPhotoSourceCollection* self, PhotoID* photo_id) {
	LibraryPhoto* result = NULL;
	PhotoID _tmp0_;
	gint64 _tmp1_;
	DataSource* _tmp2_ = NULL;
#line 3637 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self), NULL);
#line 3637 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail (photo_id != NULL, NULL);
#line 3638 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp0_ = *photo_id;
#line 3638 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp1_ = _tmp0_.id;
#line 3638 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp2_ = database_source_collection_fetch_by_key (DATABASE_SOURCE_COLLECTION (self), _tmp1_);
#line 3638 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	result = LIBRARY_PHOTO (_tmp2_);
#line 3638 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return result;
#line 28037 "Photo.c"
}


LibraryPhoto* library_photo_source_collection_fetch_by_editable_file (LibraryPhotoSourceCollection* self, GFile* file) {
	LibraryPhoto* result = NULL;
	GeeHashMap* _tmp0_;
	GFile* _tmp1_;
	gpointer _tmp2_ = NULL;
#line 3641 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self), NULL);
#line 3641 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail (G_IS_FILE (file), NULL);
#line 3642 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp0_ = self->priv->by_editable_file;
#line 3642 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp1_ = file;
#line 3642 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp2_ = gee_abstract_map_get (GEE_ABSTRACT_MAP (_tmp0_), _tmp1_);
#line 3642 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	result = (LibraryPhoto*) _tmp2_;
#line 3642 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return result;
#line 28060 "Photo.c"
}


static void library_photo_source_collection_compare_backing (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, GFileInfo* info, GeeCollection* matches_master, GeeCollection* matches_editable) {
	LibraryPhoto* _tmp0_;
	BackingPhotoState _tmp1_ = {0};
	BackingPhotoState _tmp2_;
	GFileInfo* _tmp3_;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp5_;
	LibraryPhoto* _tmp8_;
	BackingPhotoState* _tmp9_ = NULL;
	BackingPhotoState* editable;
	gboolean _tmp10_ = FALSE;
	BackingPhotoState* _tmp11_;
	gboolean _tmp15_;
#line 3645 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self));
#line 3645 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO (photo));
#line 3645 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail (G_IS_FILE_INFO (info));
#line 3645 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail (GEE_IS_COLLECTION (matches_master));
#line 3645 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail (GEE_IS_COLLECTION (matches_editable));
#line 3647 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp0_ = photo;
#line 3647 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	photo_get_master_photo_state (PHOTO (_tmp0_), &_tmp1_);
#line 3647 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp2_ = _tmp1_;
#line 3647 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp3_ = info;
#line 3647 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp4_ = backing_photo_state_matches_file_info (&_tmp2_, _tmp3_);
#line 3647 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp5_ = _tmp4_;
#line 3647 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	backing_photo_state_destroy (&_tmp2_);
#line 3647 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp5_) {
#line 28103 "Photo.c"
		GeeCollection* _tmp6_;
		LibraryPhoto* _tmp7_;
#line 3648 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp6_ = matches_master;
#line 3648 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp7_ = photo;
#line 3648 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		gee_collection_add (_tmp6_, _tmp7_);
#line 28112 "Photo.c"
	}
#line 3650 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp8_ = photo;
#line 3650 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp9_ = photo_get_editable_photo_state (PHOTO (_tmp8_));
#line 3650 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	editable = _tmp9_;
#line 3651 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp11_ = editable;
#line 3651 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp11_ != NULL) {
#line 28124 "Photo.c"
		BackingPhotoState* _tmp12_;
		GFileInfo* _tmp13_;
		gboolean _tmp14_ = FALSE;
#line 3651 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp12_ = editable;
#line 3651 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp13_ = info;
#line 3651 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp14_ = backing_photo_state_matches_file_info (_tmp12_, _tmp13_);
#line 3651 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp10_ = _tmp14_;
#line 28136 "Photo.c"
	} else {
#line 3651 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp10_ = FALSE;
#line 28140 "Photo.c"
	}
#line 3651 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp15_ = _tmp10_;
#line 3651 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp15_) {
#line 28146 "Photo.c"
		GeeCollection* _tmp16_;
		LibraryPhoto* _tmp17_;
#line 3652 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp16_ = matches_editable;
#line 3652 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp17_ = photo;
#line 3652 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		gee_collection_add (_tmp16_, _tmp17_);
#line 28155 "Photo.c"
	}
#line 3645 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_backing_photo_state_free0 (editable);
#line 28159 "Photo.c"
}


void library_photo_source_collection_fetch_by_matching_backing (LibraryPhotoSourceCollection* self, GFileInfo* info, GeeCollection* matches_master, GeeCollection* matches_editable) {
#line 3657 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self));
#line 3657 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail (G_IS_FILE_INFO (info));
#line 3657 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail (GEE_IS_COLLECTION (matches_master));
#line 3657 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail (GEE_IS_COLLECTION (matches_editable));
#line 28172 "Photo.c"
	{
		GeeMultiMap* _tmp0_;
		GFileInfo* _tmp1_;
		gint64 _tmp2_ = 0LL;
		GeeCollection* _tmp3_ = NULL;
		GeeCollection* _tmp4_;
		GeeIterator* _tmp5_ = NULL;
		GeeIterator* _tmp6_;
		GeeIterator* _photo_it;
#line 3659 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp0_ = self->priv->filesize_to_photo;
#line 3659 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp1_ = info;
#line 3659 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp2_ = g_file_info_get_size (_tmp1_);
#line 3659 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp3_ = gee_multi_map_get (_tmp0_, &_tmp2_);
#line 3659 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp4_ = _tmp3_;
#line 3659 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp5_ = gee_iterable_iterator (GEE_ITERABLE (_tmp4_));
#line 3659 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp6_ = _tmp5_;
#line 3659 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_object_unref0 (_tmp4_);
#line 3659 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_photo_it = _tmp6_;
#line 3659 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		while (TRUE) {
#line 28202 "Photo.c"
			GeeIterator* _tmp7_;
			gboolean _tmp8_ = FALSE;
			GeeIterator* _tmp9_;
			gpointer _tmp10_ = NULL;
			LibraryPhoto* photo;
			LibraryPhoto* _tmp11_;
			GFileInfo* _tmp12_;
			GeeCollection* _tmp13_;
			GeeCollection* _tmp14_;
#line 3659 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp7_ = _photo_it;
#line 3659 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp8_ = gee_iterator_next (_tmp7_);
#line 3659 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			if (!_tmp8_) {
#line 3659 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				break;
#line 28220 "Photo.c"
			}
#line 3659 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp9_ = _photo_it;
#line 3659 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp10_ = gee_iterator_get (_tmp9_);
#line 3659 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			photo = (LibraryPhoto*) _tmp10_;
#line 3660 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp11_ = photo;
#line 3660 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp12_ = info;
#line 3660 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp13_ = matches_master;
#line 3660 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp14_ = matches_editable;
#line 3660 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			library_photo_source_collection_compare_backing (self, _tmp11_, _tmp12_, _tmp13_, _tmp14_);
#line 3659 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_g_object_unref0 (photo);
#line 28240 "Photo.c"
		}
#line 3659 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_object_unref0 (_photo_it);
#line 28244 "Photo.c"
	}
	{
		GeeCollection* _tmp15_ = NULL;
		GeeCollection* _tmp16_;
		GeeIterator* _tmp17_ = NULL;
		GeeIterator* _tmp18_;
		GeeIterator* _media_it;
#line 3662 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp15_ = media_source_collection_get_offline_bin_contents (MEDIA_SOURCE_COLLECTION (self));
#line 3662 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp16_ = _tmp15_;
#line 3662 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp17_ = gee_iterable_iterator (GEE_ITERABLE (_tmp16_));
#line 3662 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp18_ = _tmp17_;
#line 3662 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_object_unref0 (_tmp16_);
#line 3662 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_media_it = _tmp18_;
#line 3662 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		while (TRUE) {
#line 28266 "Photo.c"
			GeeIterator* _tmp19_;
			gboolean _tmp20_ = FALSE;
			GeeIterator* _tmp21_;
			gpointer _tmp22_ = NULL;
			MediaSource* media;
			MediaSource* _tmp23_;
			GFileInfo* _tmp24_;
			GeeCollection* _tmp25_;
			GeeCollection* _tmp26_;
#line 3662 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp19_ = _media_it;
#line 3662 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp20_ = gee_iterator_next (_tmp19_);
#line 3662 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			if (!_tmp20_) {
#line 3662 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				break;
#line 28284 "Photo.c"
			}
#line 3662 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp21_ = _media_it;
#line 3662 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp22_ = gee_iterator_get (_tmp21_);
#line 3662 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			media = (MediaSource*) _tmp22_;
#line 3663 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp23_ = media;
#line 3663 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp24_ = info;
#line 3663 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp25_ = matches_master;
#line 3663 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp26_ = matches_editable;
#line 3663 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			library_photo_source_collection_compare_backing (self, LIBRARY_PHOTO (_tmp23_), _tmp24_, _tmp25_, _tmp26_);
#line 3662 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_g_object_unref0 (media);
#line 28304 "Photo.c"
		}
#line 3662 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_object_unref0 (_media_it);
#line 28308 "Photo.c"
	}
}


gboolean library_photo_source_collection_has_basename_filesize_duplicate (LibraryPhotoSourceCollection* self, const gchar* basename, gint64 filesize) {
	gboolean result = FALSE;
#line 3666 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self), FALSE);
#line 3666 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail (basename != NULL, FALSE);
#line 28319 "Photo.c"
	{
		GeeMultiMap* _tmp0_;
		gint64 _tmp1_;
		GeeCollection* _tmp2_ = NULL;
		GeeCollection* _tmp3_;
		GeeIterator* _tmp4_ = NULL;
		GeeIterator* _tmp5_;
		GeeIterator* _photo_it;
#line 3667 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp0_ = self->priv->filesize_to_photo;
#line 3667 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp1_ = filesize;
#line 3667 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp2_ = gee_multi_map_get (_tmp0_, &_tmp1_);
#line 3667 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp3_ = _tmp2_;
#line 3667 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp4_ = gee_iterable_iterator (GEE_ITERABLE (_tmp3_));
#line 3667 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp5_ = _tmp4_;
#line 3667 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_object_unref0 (_tmp3_);
#line 3667 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_photo_it = _tmp5_;
#line 3667 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		while (TRUE) {
#line 28346 "Photo.c"
			GeeIterator* _tmp6_;
			gboolean _tmp7_ = FALSE;
			GeeIterator* _tmp8_;
			gpointer _tmp9_ = NULL;
			LibraryPhoto* photo;
			LibraryPhoto* _tmp10_;
			GFile* _tmp11_ = NULL;
			GFile* _tmp12_;
			gchar* _tmp13_ = NULL;
			gchar* _tmp14_;
			const gchar* _tmp15_;
			gint _tmp16_ = 0;
			gboolean _tmp17_;
#line 3667 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp6_ = _photo_it;
#line 3667 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp7_ = gee_iterator_next (_tmp6_);
#line 3667 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			if (!_tmp7_) {
#line 3667 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				break;
#line 28368 "Photo.c"
			}
#line 3667 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp8_ = _photo_it;
#line 3667 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp9_ = gee_iterator_get (_tmp8_);
#line 3667 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			photo = (LibraryPhoto*) _tmp9_;
#line 3668 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp10_ = photo;
#line 3668 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp11_ = media_source_get_master_file (MEDIA_SOURCE (_tmp10_));
#line 3668 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp12_ = _tmp11_;
#line 3668 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp13_ = g_file_get_basename (_tmp12_);
#line 3668 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp14_ = _tmp13_;
#line 3668 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp15_ = basename;
#line 3668 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp16_ = utf8_ci_compare (_tmp14_, _tmp15_);
#line 3668 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp17_ = _tmp16_ == 0;
#line 3668 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_g_free0 (_tmp14_);
#line 3668 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_g_object_unref0 (_tmp12_);
#line 3668 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			if (_tmp17_) {
#line 3669 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				result = TRUE;
#line 3669 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_g_object_unref0 (photo);
#line 3669 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_g_object_unref0 (_photo_it);
#line 3669 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				return result;
#line 28406 "Photo.c"
			}
#line 3667 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_g_object_unref0 (photo);
#line 28410 "Photo.c"
		}
#line 3667 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_object_unref0 (_photo_it);
#line 28414 "Photo.c"
	}
#line 3672 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	result = FALSE;
#line 3672 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return result;
#line 28420 "Photo.c"
}


LibraryPhoto* library_photo_source_collection_get_trashed_by_file (LibraryPhotoSourceCollection* self, GFile* file) {
	LibraryPhoto* result = NULL;
	MediaSourceHoldingTank* _tmp0_ = NULL;
	MediaSourceHoldingTank* _tmp1_;
	GFile* _tmp2_;
	MediaSource* _tmp3_ = NULL;
	LibraryPhoto* _tmp4_;
#line 3675 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self), NULL);
#line 3675 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail (G_IS_FILE (file), NULL);
#line 3676 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp0_ = media_source_collection_get_trashcan (MEDIA_SOURCE_COLLECTION (self));
#line 3676 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 3676 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp2_ = file;
#line 3676 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp3_ = media_source_holding_tank_fetch_by_master_file (_tmp1_, _tmp2_);
#line 3676 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp4_ = LIBRARY_PHOTO (_tmp3_);
#line 3676 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_source_holding_tank_unref0 (_tmp1_);
#line 3676 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	result = _tmp4_;
#line 3676 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return result;
#line 28451 "Photo.c"
}


LibraryPhoto* library_photo_source_collection_get_trashed_by_md5 (LibraryPhotoSourceCollection* self, const gchar* md5) {
	LibraryPhoto* result = NULL;
	MediaSourceHoldingTank* _tmp0_ = NULL;
	MediaSourceHoldingTank* _tmp1_;
	const gchar* _tmp2_;
	MediaSource* _tmp3_ = NULL;
	LibraryPhoto* _tmp4_;
#line 3679 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self), NULL);
#line 3679 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail (md5 != NULL, NULL);
#line 3680 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp0_ = media_source_collection_get_trashcan (MEDIA_SOURCE_COLLECTION (self));
#line 3680 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 3680 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp2_ = md5;
#line 3680 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp3_ = media_source_holding_tank_fetch_by_md5 (_tmp1_, _tmp2_);
#line 3680 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp4_ = LIBRARY_PHOTO (_tmp3_);
#line 3680 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_source_holding_tank_unref0 (_tmp1_);
#line 3680 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	result = _tmp4_;
#line 3680 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return result;
#line 28482 "Photo.c"
}


LibraryPhoto* library_photo_source_collection_get_offline_by_file (LibraryPhotoSourceCollection* self, GFile* file) {
	LibraryPhoto* result = NULL;
	MediaSourceHoldingTank* _tmp0_ = NULL;
	MediaSourceHoldingTank* _tmp1_;
	GFile* _tmp2_;
	MediaSource* _tmp3_ = NULL;
	LibraryPhoto* _tmp4_;
#line 3683 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self), NULL);
#line 3683 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail (G_IS_FILE (file), NULL);
#line 3684 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp0_ = media_source_collection_get_offline_bin (MEDIA_SOURCE_COLLECTION (self));
#line 3684 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 3684 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp2_ = file;
#line 3684 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp3_ = media_source_holding_tank_fetch_by_master_file (_tmp1_, _tmp2_);
#line 3684 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp4_ = LIBRARY_PHOTO (_tmp3_);
#line 3684 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_source_holding_tank_unref0 (_tmp1_);
#line 3684 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	result = _tmp4_;
#line 3684 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return result;
#line 28513 "Photo.c"
}


LibraryPhoto* library_photo_source_collection_get_offline_by_md5 (LibraryPhotoSourceCollection* self, const gchar* md5) {
	LibraryPhoto* result = NULL;
	MediaSourceHoldingTank* _tmp0_ = NULL;
	MediaSourceHoldingTank* _tmp1_;
	const gchar* _tmp2_;
	MediaSource* _tmp3_ = NULL;
	LibraryPhoto* _tmp4_;
#line 3687 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self), NULL);
#line 3687 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail (md5 != NULL, NULL);
#line 3688 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp0_ = media_source_collection_get_offline_bin (MEDIA_SOURCE_COLLECTION (self));
#line 3688 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 3688 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp2_ = md5;
#line 3688 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp3_ = media_source_holding_tank_fetch_by_md5 (_tmp1_, _tmp2_);
#line 3688 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp4_ = LIBRARY_PHOTO (_tmp3_);
#line 3688 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_source_holding_tank_unref0 (_tmp1_);
#line 3688 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	result = _tmp4_;
#line 3688 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return result;
#line 28544 "Photo.c"
}


gint library_photo_source_collection_get_offline_count (LibraryPhotoSourceCollection* self) {
	gint result = 0;
	MediaSourceHoldingTank* _tmp0_ = NULL;
	MediaSourceHoldingTank* _tmp1_;
	gint _tmp2_ = 0;
	gint _tmp3_;
#line 3691 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self), 0);
#line 3692 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp0_ = media_source_collection_get_offline_bin (MEDIA_SOURCE_COLLECTION (self));
#line 3692 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 3692 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp2_ = source_holding_tank_get_count (SOURCE_HOLDING_TANK (_tmp1_));
#line 3692 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp3_ = _tmp2_;
#line 3692 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_source_holding_tank_unref0 (_tmp1_);
#line 3692 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	result = _tmp3_;
#line 3692 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return result;
#line 28570 "Photo.c"
}


LibraryPhoto* library_photo_source_collection_get_state_by_file (LibraryPhotoSourceCollection* self, GFile* file, LibraryPhotoSourceCollectionState* state) {
	LibraryPhotoSourceCollectionState _vala_state = 0;
	LibraryPhoto* result = NULL;
	GFile* _tmp0_;
	MediaSource* _tmp1_ = NULL;
	LibraryPhoto* photo;
	LibraryPhoto* _tmp2_;
	GFile* _tmp3_;
	LibraryPhoto* _tmp4_ = NULL;
	LibraryPhoto* _tmp5_;
	MediaSourceHoldingTank* _tmp6_ = NULL;
	MediaSourceHoldingTank* _tmp7_;
	GFile* _tmp8_;
	MediaSource* _tmp9_ = NULL;
	LibraryPhoto* _tmp10_;
	MediaSourceHoldingTank* _tmp11_ = NULL;
	MediaSourceHoldingTank* _tmp12_;
	GFile* _tmp13_;
	MediaSource* _tmp14_ = NULL;
	LibraryPhoto* _tmp15_;
#line 3695 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail (IS_LIBRARY_PHOTO_SOURCE_COLLECTION (self), NULL);
#line 3695 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail (G_IS_FILE (file), NULL);
#line 3696 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp0_ = file;
#line 3696 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp1_ = media_source_collection_fetch_by_master_file (MEDIA_SOURCE_COLLECTION (self), _tmp0_);
#line 3696 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	photo = LIBRARY_PHOTO (_tmp1_);
#line 3697 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp2_ = photo;
#line 3697 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp2_ != NULL) {
#line 3698 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_vala_state = LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_ONLINE;
#line 3700 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		result = photo;
#line 3700 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		if (state) {
#line 3700 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			*state = _vala_state;
#line 28616 "Photo.c"
		}
#line 3700 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return result;
#line 28620 "Photo.c"
	}
#line 3703 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp3_ = file;
#line 3703 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp4_ = library_photo_source_collection_fetch_by_editable_file (self, _tmp3_);
#line 3703 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_g_object_unref0 (photo);
#line 3703 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	photo = _tmp4_;
#line 3704 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp5_ = photo;
#line 3704 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp5_ != NULL) {
#line 3705 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_vala_state = LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_EDITABLE;
#line 3707 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		result = photo;
#line 3707 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		if (state) {
#line 3707 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			*state = _vala_state;
#line 28642 "Photo.c"
		}
#line 3707 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return result;
#line 28646 "Photo.c"
	}
#line 3710 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp6_ = media_source_collection_get_trashcan (MEDIA_SOURCE_COLLECTION (self));
#line 3710 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp7_ = _tmp6_;
#line 3710 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp8_ = file;
#line 3710 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp9_ = media_source_holding_tank_fetch_by_master_file (_tmp7_, _tmp8_);
#line 3710 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_g_object_unref0 (photo);
#line 3710 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	photo = IS_LIBRARY_PHOTO (_tmp9_) ? ((LibraryPhoto*) _tmp9_) : NULL;
#line 3710 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_source_holding_tank_unref0 (_tmp7_);
#line 3711 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp10_ = photo;
#line 3711 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp10_ != NULL) {
#line 3712 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_vala_state = LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_TRASH;
#line 3714 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		result = photo;
#line 3714 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		if (state) {
#line 3714 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			*state = _vala_state;
#line 28674 "Photo.c"
		}
#line 3714 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return result;
#line 28678 "Photo.c"
	}
#line 3717 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp11_ = media_source_collection_get_offline_bin (MEDIA_SOURCE_COLLECTION (self));
#line 3717 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp12_ = _tmp11_;
#line 3717 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp13_ = file;
#line 3717 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp14_ = media_source_holding_tank_fetch_by_master_file (_tmp12_, _tmp13_);
#line 3717 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_g_object_unref0 (photo);
#line 3717 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	photo = IS_LIBRARY_PHOTO (_tmp14_) ? ((LibraryPhoto*) _tmp14_) : NULL;
#line 3717 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_source_holding_tank_unref0 (_tmp12_);
#line 3718 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp15_ = photo;
#line 3718 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp15_ != NULL) {
#line 3719 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_vala_state = LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_OFFLINE;
#line 3721 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		result = photo;
#line 3721 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		if (state) {
#line 3721 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			*state = _vala_state;
#line 28706 "Photo.c"
		}
#line 3721 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return result;
#line 28710 "Photo.c"
	}
#line 3724 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	result = NULL;
#line 3724 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_g_object_unref0 (photo);
#line 3724 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (state) {
#line 3724 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		*state = _vala_state;
#line 28720 "Photo.c"
	}
#line 3724 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return result;
#line 28724 "Photo.c"
}


static gboolean library_photo_source_collection_real_has_backlink (SourceCollection* base, SourceBacklink* backlink) {
	LibraryPhotoSourceCollection * self;
	gboolean result = FALSE;
	SourceBacklink* _tmp0_;
	gboolean _tmp1_ = FALSE;
	MediaSourceHoldingTank* _tmp2_ = NULL;
	MediaSourceHoldingTank* _tmp3_;
	SourceBacklink* _tmp4_;
	gboolean _tmp5_ = FALSE;
	gboolean _tmp6_;
	MediaSourceHoldingTank* _tmp7_ = NULL;
	MediaSourceHoldingTank* _tmp8_;
	SourceBacklink* _tmp9_;
	gboolean _tmp10_ = FALSE;
	gboolean _tmp11_;
#line 3727 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	self = LIBRARY_PHOTO_SOURCE_COLLECTION (base);
#line 3727 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail (IS_SOURCE_BACKLINK (backlink), FALSE);
#line 3728 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp0_ = backlink;
#line 3728 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp1_ = SOURCE_COLLECTION_CLASS (library_photo_source_collection_parent_class)->has_backlink (SOURCE_COLLECTION (MEDIA_SOURCE_COLLECTION (self)), _tmp0_);
#line 3728 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp1_) {
#line 3729 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		result = TRUE;
#line 3729 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return result;
#line 28757 "Photo.c"
	}
#line 3731 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp2_ = media_source_collection_get_trashcan (MEDIA_SOURCE_COLLECTION (self));
#line 3731 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp3_ = _tmp2_;
#line 3731 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp4_ = backlink;
#line 3731 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp5_ = source_holding_tank_has_backlink (SOURCE_HOLDING_TANK (_tmp3_), _tmp4_);
#line 3731 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp6_ = _tmp5_;
#line 3731 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_source_holding_tank_unref0 (_tmp3_);
#line 3731 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp6_) {
#line 3732 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		result = TRUE;
#line 3732 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return result;
#line 28777 "Photo.c"
	}
#line 3734 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp7_ = media_source_collection_get_offline_bin (MEDIA_SOURCE_COLLECTION (self));
#line 3734 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp8_ = _tmp7_;
#line 3734 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp9_ = backlink;
#line 3734 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp10_ = source_holding_tank_has_backlink (SOURCE_HOLDING_TANK (_tmp8_), _tmp9_);
#line 3734 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp11_ = _tmp10_;
#line 3734 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_source_holding_tank_unref0 (_tmp8_);
#line 3734 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp11_) {
#line 3735 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		result = TRUE;
#line 3735 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return result;
#line 28797 "Photo.c"
	}
#line 3737 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	result = FALSE;
#line 3737 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return result;
#line 28803 "Photo.c"
}


static void library_photo_source_collection_real_remove_backlink (SourceCollection* base, SourceBacklink* backlink) {
	LibraryPhotoSourceCollection * self;
	MediaSourceHoldingTank* _tmp0_ = NULL;
	MediaSourceHoldingTank* _tmp1_;
	SourceBacklink* _tmp2_;
	MediaSourceHoldingTank* _tmp3_ = NULL;
	MediaSourceHoldingTank* _tmp4_;
	SourceBacklink* _tmp5_;
	SourceBacklink* _tmp6_;
#line 3740 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	self = LIBRARY_PHOTO_SOURCE_COLLECTION (base);
#line 3740 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail (IS_SOURCE_BACKLINK (backlink));
#line 3741 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp0_ = media_source_collection_get_trashcan (MEDIA_SOURCE_COLLECTION (self));
#line 3741 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 3741 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp2_ = backlink;
#line 3741 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	source_holding_tank_remove_backlink (SOURCE_HOLDING_TANK (_tmp1_), _tmp2_);
#line 3741 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_source_holding_tank_unref0 (_tmp1_);
#line 3742 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp3_ = media_source_collection_get_offline_bin (MEDIA_SOURCE_COLLECTION (self));
#line 3742 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp4_ = _tmp3_;
#line 3742 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp5_ = backlink;
#line 3742 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	source_holding_tank_remove_backlink (SOURCE_HOLDING_TANK (_tmp4_), _tmp5_);
#line 3742 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_source_holding_tank_unref0 (_tmp4_);
#line 3744 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp6_ = backlink;
#line 3744 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	SOURCE_COLLECTION_CLASS (library_photo_source_collection_parent_class)->remove_backlink (SOURCE_COLLECTION (MEDIA_SOURCE_COLLECTION (self)), _tmp6_);
#line 28844 "Photo.c"
}


static TransactionController* library_photo_source_collection_real_get_transaction_controller (MediaSourceCollection* base) {
	TransactionController* result;
	LibraryPhotoSourceCollection* self;
	TransactionController* _tmp0_;
	TransactionController* _tmp2_;
#line 3403 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	self = LIBRARY_PHOTO_SOURCE_COLLECTION (base);
#line 3404 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp0_ = self->priv->_transaction_controller;
#line 3404 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp0_ == NULL) {
#line 28859 "Photo.c"
		MediaSourceTransactionController* _tmp1_;
#line 3405 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp1_ = media_source_transaction_controller_new (MEDIA_SOURCE_COLLECTION (self));
#line 3405 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_transaction_controller_unref0 (self->priv->_transaction_controller);
#line 3405 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		self->priv->_transaction_controller = TRANSACTION_CONTROLLER (_tmp1_);
#line 28867 "Photo.c"
	}
#line 3407 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp2_ = self->priv->_transaction_controller;
#line 3407 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	result = _tmp2_;
#line 3407 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return result;
#line 28875 "Photo.c"
}


static void library_photo_source_collection_real_master_reimported (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata) {
#line 3421 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO (photo));
#line 3421 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
#line 28884 "Photo.c"
}


static void g_cclosure_user_marshal_VOID__OBJECT_MEDIA_METADATA (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__OBJECT_MEDIA_METADATA) (gpointer data1, gpointer arg_1, gpointer arg_2, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_MEDIA_METADATA callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 3394 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail (n_param_values == 3);
#line 3394 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 3394 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		data1 = closure->data;
#line 3394 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		data2 = param_values->data[0].v_pointer;
#line 28903 "Photo.c"
	} else {
#line 3394 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		data1 = param_values->data[0].v_pointer;
#line 3394 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		data2 = closure->data;
#line 28909 "Photo.c"
	}
#line 3394 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	callback = (GMarshalFunc_VOID__OBJECT_MEDIA_METADATA) (marshal_data ? marshal_data : cc->callback);
#line 3394 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	callback (data1, g_value_get_object (param_values + 1), value_get_media_metadata (param_values + 2), data2);
#line 28915 "Photo.c"
}


static void library_photo_source_collection_real_editable_reimported (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata) {
#line 3424 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO (photo));
#line 3424 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
#line 28924 "Photo.c"
}


static void library_photo_source_collection_real_baseline_reimported (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata) {
#line 3427 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO (photo));
#line 3427 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
#line 28933 "Photo.c"
}


static void library_photo_source_collection_real_source_reimported (LibraryPhotoSourceCollection* self, LibraryPhoto* photo, PhotoMetadata* metadata) {
#line 3430 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO (photo));
#line 3430 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
#line 28942 "Photo.c"
}


static void library_photo_source_collection_class_init (LibraryPhotoSourceCollectionClass * klass) {
#line 3394 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	library_photo_source_collection_parent_class = g_type_class_peek_parent (klass);
#line 3394 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	DATA_COLLECTION_CLASS (klass)->finalize = library_photo_source_collection_finalize;
#line 3394 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_type_class_add_private (klass, sizeof (LibraryPhotoSourceCollectionPrivate));
#line 3394 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	MEDIA_SOURCE_COLLECTION_CLASS (klass)->create_trashcan = library_photo_source_collection_real_create_trashcan;
#line 3394 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	MEDIA_SOURCE_COLLECTION_CLASS (klass)->create_offline_bin = library_photo_source_collection_real_create_offline_bin;
#line 3394 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	MEDIA_SOURCE_COLLECTION_CLASS (klass)->create_media_monitor = library_photo_source_collection_real_create_media_monitor;
#line 3394 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	SOURCE_COLLECTION_CLASS (klass)->holds_type_of_source = library_photo_source_collection_real_holds_type_of_source;
#line 3394 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	MEDIA_SOURCE_COLLECTION_CLASS (klass)->get_typename = library_photo_source_collection_real_get_typename;
#line 3394 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	MEDIA_SOURCE_COLLECTION_CLASS (klass)->is_file_recognized = library_photo_source_collection_real_is_file_recognized;
#line 3394 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	DATA_COLLECTION_CLASS (klass)->notify_contents_altered = library_photo_source_collection_real_notify_contents_altered;
#line 3394 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	DATA_COLLECTION_CLASS (klass)->items_altered = library_photo_source_collection_real_items_altered;
#line 3394 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	MEDIA_SOURCE_COLLECTION_CLASS (klass)->postprocess_imported_media = library_photo_source_collection_real_postprocess_imported_media;
#line 3394 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	LIBRARY_PHOTO_SOURCE_COLLECTION_CLASS (klass)->notify_master_reimported = library_photo_source_collection_real_notify_master_reimported;
#line 3394 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	LIBRARY_PHOTO_SOURCE_COLLECTION_CLASS (klass)->notify_editable_reimported = library_photo_source_collection_real_notify_editable_reimported;
#line 3394 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	LIBRARY_PHOTO_SOURCE_COLLECTION_CLASS (klass)->notify_source_reimported = library_photo_source_collection_real_notify_source_reimported;
#line 3394 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	LIBRARY_PHOTO_SOURCE_COLLECTION_CLASS (klass)->notify_baseline_reimported = library_photo_source_collection_real_notify_baseline_reimported;
#line 3394 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	MEDIA_SOURCE_COLLECTION_CLASS (klass)->fetch_by_numeric_id = library_photo_source_collection_real_fetch_by_numeric_id;
#line 3394 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	MEDIA_SOURCE_COLLECTION_CLASS (klass)->fetch_by_source_id = library_photo_source_collection_real_fetch_by_source_id;
#line 3394 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	MEDIA_SOURCE_COLLECTION_CLASS (klass)->get_event_source_ids = library_photo_source_collection_real_get_event_source_ids;
#line 3394 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	SOURCE_COLLECTION_CLASS (klass)->has_backlink = library_photo_source_collection_real_has_backlink;
#line 3394 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	SOURCE_COLLECTION_CLASS (klass)->remove_backlink = library_photo_source_collection_real_remove_backlink;
#line 3394 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	LIBRARY_PHOTO_SOURCE_COLLECTION_CLASS (klass)->master_reimported = library_photo_source_collection_real_master_reimported;
#line 3394 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	LIBRARY_PHOTO_SOURCE_COLLECTION_CLASS (klass)->editable_reimported = library_photo_source_collection_real_editable_reimported;
#line 3394 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	LIBRARY_PHOTO_SOURCE_COLLECTION_CLASS (klass)->baseline_reimported = library_photo_source_collection_real_baseline_reimported;
#line 3394 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	LIBRARY_PHOTO_SOURCE_COLLECTION_CLASS (klass)->source_reimported = library_photo_source_collection_real_source_reimported;
#line 3394 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	MEDIA_SOURCE_COLLECTION_CLASS (klass)->get_transaction_controller = library_photo_source_collection_real_get_transaction_controller;
#line 3394 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_signal_new ("master_reimported", TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (LibraryPhotoSourceCollectionClass, master_reimported), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_MEDIA_METADATA, G_TYPE_NONE, 2, TYPE_LIBRARY_PHOTO, TYPE_PHOTO_METADATA);
#line 3394 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_signal_new ("editable_reimported", TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (LibraryPhotoSourceCollectionClass, editable_reimported), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_MEDIA_METADATA, G_TYPE_NONE, 2, TYPE_LIBRARY_PHOTO, TYPE_PHOTO_METADATA);
#line 3394 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_signal_new ("baseline_reimported", TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (LibraryPhotoSourceCollectionClass, baseline_reimported), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_MEDIA_METADATA, G_TYPE_NONE, 2, TYPE_LIBRARY_PHOTO, TYPE_PHOTO_METADATA);
#line 3394 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_signal_new ("source_reimported", TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (LibraryPhotoSourceCollectionClass, source_reimported), NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_MEDIA_METADATA, G_TYPE_NONE, 2, TYPE_LIBRARY_PHOTO, TYPE_PHOTO_METADATA);
#line 29007 "Photo.c"
}


static void library_photo_source_collection_instance_init (LibraryPhotoSourceCollection * self) {
	GHashFunc _tmp0_;
	GEqualFunc _tmp1_;
	GeeHashMap* _tmp2_;
	GeeTreeMultiMap* _tmp3_;
	GHashFunc _tmp4_;
	GEqualFunc _tmp5_;
	GeeHashMap* _tmp6_;
	GHashFunc _tmp7_;
	GEqualFunc _tmp8_;
	GeeHashMap* _tmp9_;
#line 3394 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	self->priv = LIBRARY_PHOTO_SOURCE_COLLECTION_GET_PRIVATE (self);
#line 3411 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	self->priv->_transaction_controller = NULL;
#line 3412 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp0_ = g_file_hash;
#line 3412 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp1_ = g_file_equal;
#line 3412 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp2_ = gee_hash_map_new (G_TYPE_FILE, (GBoxedCopyFunc) g_object_ref, g_object_unref, TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, g_object_unref, _tmp0_, _tmp1_, NULL);
#line 3412 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	self->priv->by_editable_file = _tmp2_;
#line 3414 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp3_ = gee_tree_multi_map_new (G_TYPE_INT64, (GBoxedCopyFunc) _int64_dup, g_free, TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, g_object_unref, _int64_compare_gcompare_func, NULL);
#line 3414 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	self->priv->filesize_to_photo = GEE_MULTI_MAP (_tmp3_);
#line 3416 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp4_ = g_direct_hash;
#line 3416 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp5_ = g_direct_equal;
#line 3416 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp6_ = gee_hash_map_new (TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, g_object_unref, G_TYPE_INT64, (GBoxedCopyFunc) _int64_dup, g_free, _tmp4_, _tmp5_, _int64_equal_gequal_func);
#line 3416 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	self->priv->photo_to_master_filesize = _tmp6_;
#line 3418 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp7_ = g_direct_hash;
#line 3418 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp8_ = g_direct_equal;
#line 3418 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp9_ = gee_hash_map_new (TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, g_object_unref, G_TYPE_INT64, (GBoxedCopyFunc) _int64_dup, g_free, _tmp7_, _tmp8_, _int64_equal_gequal_func);
#line 3418 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	self->priv->photo_to_editable_filesize = _tmp9_;
#line 29054 "Photo.c"
}


static void library_photo_source_collection_finalize (DataCollection* obj) {
	LibraryPhotoSourceCollection * self;
#line 3394 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	self = LIBRARY_PHOTO_SOURCE_COLLECTION (obj);
#line 3411 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_transaction_controller_unref0 (self->priv->_transaction_controller);
#line 3412 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_g_object_unref0 (self->priv->by_editable_file);
#line 3414 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_g_object_unref0 (self->priv->filesize_to_photo);
#line 3416 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_g_object_unref0 (self->priv->photo_to_master_filesize);
#line 3418 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_g_object_unref0 (self->priv->photo_to_editable_filesize);
#line 3394 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	DATA_COLLECTION_CLASS (library_photo_source_collection_parent_class)->finalize (obj);
#line 29074 "Photo.c"
}


GType library_photo_source_collection_get_type (void) {
	static volatile gsize library_photo_source_collection_type_id__volatile = 0;
	if (g_once_init_enter (&library_photo_source_collection_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (LibraryPhotoSourceCollectionClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) library_photo_source_collection_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (LibraryPhotoSourceCollection), 0, (GInstanceInitFunc) library_photo_source_collection_instance_init, NULL };
		GType library_photo_source_collection_type_id;
		library_photo_source_collection_type_id = g_type_register_static (TYPE_MEDIA_SOURCE_COLLECTION, "LibraryPhotoSourceCollection", &g_define_type_info, 0);
		g_once_init_leave (&library_photo_source_collection_type_id__volatile, library_photo_source_collection_type_id);
	}
	return library_photo_source_collection_type_id__volatile;
}


static void _library_photo_generate_thumbnails_one_shot_callback (gpointer self) {
#line 3773 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	library_photo_generate_thumbnails (self);
#line 29093 "Photo.c"
}


static LibraryPhoto* library_photo_construct (GType object_type, PhotoRow* row, GeeCollection* import_keywords) {
	LibraryPhoto * self = NULL;
	PhotoRow _tmp0_;
	GeeCollection* _tmp1_;
	GeeCollection* _tmp2_;
	OneShotScheduler* _tmp3_;
	PhotoRow _tmp4_;
	guint64 _tmp5_;
	PhotoRow _tmp9_;
	guint64 _tmp10_;
#line 3768 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail (row != NULL, NULL);
#line 3768 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail ((import_keywords == NULL) || GEE_IS_COLLECTION (import_keywords), NULL);
#line 3769 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp0_ = *row;
#line 3769 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	self = (LibraryPhoto*) photo_construct (object_type, &_tmp0_);
#line 3771 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp1_ = import_keywords;
#line 3771 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 3771 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_g_object_unref0 (self->priv->import_keywords);
#line 3771 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	self->priv->import_keywords = _tmp2_;
#line 3773 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp3_ = one_shot_scheduler_new ("LibraryPhoto", _library_photo_generate_thumbnails_one_shot_callback, self);
#line 3773 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_one_shot_scheduler_unref0 (self->priv->thumbnail_scheduler);
#line 3773 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	self->priv->thumbnail_scheduler = _tmp3_;
#line 3776 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp4_ = *row;
#line 3776 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp5_ = _tmp4_.flags;
#line 3776 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if ((_tmp5_ & (LIBRARY_PHOTO_FLAG_TRASH | LIBRARY_PHOTO_FLAG_OFFLINE)) != ((guint64) 0)) {
#line 29135 "Photo.c"
		LibraryPhotoSourceCollection* _tmp6_;
		PhotoRow _tmp7_;
		const gchar* _tmp8_;
#line 3777 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp6_ = library_photo_global;
#line 3777 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp7_ = *row;
#line 3777 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp8_ = _tmp7_.backlinks;
#line 3777 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		data_source_rehydrate_backlinks (DATA_SOURCE (self), SOURCE_COLLECTION (_tmp6_), _tmp8_);
#line 29147 "Photo.c"
	}
#line 3779 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp9_ = *row;
#line 3779 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp10_ = _tmp9_.flags;
#line 3779 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if ((_tmp10_ & (LIBRARY_PHOTO_FLAG_HIDDEN | LIBRARY_PHOTO_FLAG_FAVORITE)) != ((guint64) 0)) {
#line 29155 "Photo.c"
		PhotoRow _tmp11_;
		guint64 _tmp12_;
#line 3780 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp11_ = *row;
#line 3780 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp12_ = _tmp11_.flags;
#line 3780 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		library_photo_upgrade_rating_flags (self, _tmp12_);
#line 29164 "Photo.c"
	}
#line 3768 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return self;
#line 29168 "Photo.c"
}


static LibraryPhoto* library_photo_new (PhotoRow* row, GeeCollection* import_keywords) {
#line 3768 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return library_photo_construct (TYPE_LIBRARY_PHOTO, row, import_keywords);
#line 29175 "Photo.c"
}


void library_photo_init (ProgressMonitor monitor, void* monitor_target) {
	LibraryPhotoSourceCollection* _tmp0_;
	LibraryPhotoSourceCollection* _tmp1_;
	GFile* _tmp2_ = NULL;
	GFile* _tmp3_;
	MimicManager* _tmp4_;
	PhotoTable* _tmp5_ = NULL;
	PhotoTable* _tmp6_;
	GeeArrayList* _tmp7_ = NULL;
	GeeArrayList* _tmp8_;
	GeeArrayList* all;
	GeeArrayList* _tmp9_;
	GeeArrayList* all_photos;
	GeeArrayList* _tmp10_;
	GeeArrayList* trashed_photos;
	GeeArrayList* _tmp11_;
	GeeArrayList* offline_photos;
	GeeArrayList* _tmp12_;
	gint _tmp13_;
	gint _tmp14_;
	gint count;
	LibraryPhotoSourceCollection* _tmp42_;
	GeeArrayList* _tmp43_;
	GeeCollection* _tmp44_ = NULL;
	GeeCollection* _tmp45_;
	LibraryPhotoSourceCollection* _tmp46_;
	GeeArrayList* _tmp47_;
	LibraryPhotoSourceCollection* _tmp48_;
	GeeArrayList* _tmp49_;
#line 3784 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp0_ = library_photo_source_collection_new ();
#line 3784 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_data_collection_unref0 (library_photo_global);
#line 3784 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	library_photo_global = _tmp0_;
#line 3785 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp1_ = library_photo_global;
#line 3785 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp2_ = app_dirs_get_data_subdir ("mimics", NULL);
#line 3785 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp3_ = _tmp2_;
#line 3785 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp4_ = mimic_manager_new (SOURCE_COLLECTION (_tmp1_), _tmp3_);
#line 3785 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_g_object_unref0 (library_photo_mimic_manager);
#line 3785 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	library_photo_mimic_manager = _tmp4_;
#line 3785 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_g_object_unref0 (_tmp3_);
#line 3789 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp5_ = photo_table_get_instance ();
#line 3789 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp6_ = _tmp5_;
#line 3789 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp7_ = photo_table_get_all (_tmp6_);
#line 3789 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp8_ = _tmp7_;
#line 3789 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_database_table_unref0 (_tmp6_);
#line 3789 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	all = _tmp8_;
#line 3790 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp9_ = gee_array_list_new (TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
#line 3790 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	all_photos = _tmp9_;
#line 3791 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp10_ = gee_array_list_new (TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
#line 3791 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	trashed_photos = _tmp10_;
#line 3792 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp11_ = gee_array_list_new (TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
#line 3792 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	offline_photos = _tmp11_;
#line 3793 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp12_ = all;
#line 3793 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp13_ = gee_abstract_collection_get_size (GEE_COLLECTION (_tmp12_));
#line 3793 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp14_ = _tmp13_;
#line 3793 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	count = _tmp14_;
#line 29260 "Photo.c"
	{
		gint ctr;
#line 3794 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		ctr = 0;
#line 29265 "Photo.c"
		{
			gboolean _tmp15_;
#line 3794 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp15_ = TRUE;
#line 3794 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			while (TRUE) {
#line 29272 "Photo.c"
				gboolean _tmp16_;
				gint _tmp18_;
				gint _tmp19_;
				GeeArrayList* _tmp20_;
				gint _tmp21_;
				gpointer _tmp22_ = NULL;
				PhotoRow* _tmp23_;
				PhotoRow _tmp24_ = {0};
				PhotoRow _tmp25_;
				PhotoRow row;
				PhotoRow _tmp26_;
				LibraryPhoto* _tmp27_;
				LibraryPhoto* photo;
				PhotoRow _tmp28_;
				guint64 _tmp29_;
				guint64 flags;
				guint64 _tmp30_;
				ProgressMonitor _tmp38_;
				void* _tmp38__target;
#line 3794 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp16_ = _tmp15_;
#line 3794 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				if (!_tmp16_) {
#line 29296 "Photo.c"
					gint _tmp17_;
#line 3794 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_tmp17_ = ctr;
#line 3794 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					ctr = _tmp17_ + 1;
#line 29302 "Photo.c"
				}
#line 3794 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp15_ = FALSE;
#line 3794 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp18_ = ctr;
#line 3794 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp19_ = count;
#line 3794 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				if (!(_tmp18_ < _tmp19_)) {
#line 3794 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					break;
#line 29314 "Photo.c"
				}
#line 3795 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp20_ = all;
#line 3795 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp21_ = ctr;
#line 3795 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp22_ = gee_abstract_list_get (GEE_ABSTRACT_LIST (_tmp20_), _tmp21_);
#line 3795 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp23_ = (PhotoRow*) _tmp22_;
#line 3795 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				photo_row_copy (_tmp23_, &_tmp24_);
#line 3795 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp25_ = _tmp24_;
#line 3795 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_photo_row_free0 (_tmp23_);
#line 3795 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				row = _tmp25_;
#line 3796 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp26_ = row;
#line 3796 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp27_ = library_photo_new (&_tmp26_, NULL);
#line 3796 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				photo = _tmp27_;
#line 3797 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp28_ = row;
#line 3797 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp29_ = _tmp28_.flags;
#line 3797 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				flags = _tmp29_;
#line 3799 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp30_ = flags;
#line 3799 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				if ((_tmp30_ & LIBRARY_PHOTO_FLAG_TRASH) != ((guint64) 0)) {
#line 29348 "Photo.c"
					GeeArrayList* _tmp31_;
					LibraryPhoto* _tmp32_;
#line 3800 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_tmp31_ = trashed_photos;
#line 3800 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_tmp32_ = photo;
#line 3800 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (_tmp31_), _tmp32_);
#line 29357 "Photo.c"
				} else {
					guint64 _tmp33_;
#line 3801 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_tmp33_ = flags;
#line 3801 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					if ((_tmp33_ & LIBRARY_PHOTO_FLAG_OFFLINE) != ((guint64) 0)) {
#line 29364 "Photo.c"
						GeeArrayList* _tmp34_;
						LibraryPhoto* _tmp35_;
#line 3802 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						_tmp34_ = offline_photos;
#line 3802 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						_tmp35_ = photo;
#line 3802 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (_tmp34_), _tmp35_);
#line 29373 "Photo.c"
					} else {
						GeeArrayList* _tmp36_;
						LibraryPhoto* _tmp37_;
#line 3804 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						_tmp36_ = all_photos;
#line 3804 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						_tmp37_ = photo;
#line 3804 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
						gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (_tmp36_), _tmp37_);
#line 29383 "Photo.c"
					}
				}
#line 3806 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp38_ = monitor;
#line 3806 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp38__target = monitor_target;
#line 3806 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				if (_tmp38_ != NULL) {
#line 29392 "Photo.c"
					ProgressMonitor _tmp39_;
					void* _tmp39__target;
					gint _tmp40_;
					gint _tmp41_;
#line 3807 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_tmp39_ = monitor;
#line 3807 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_tmp39__target = monitor_target;
#line 3807 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_tmp40_ = ctr;
#line 3807 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_tmp41_ = count;
#line 3807 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_tmp39_ ((guint64) _tmp40_, (guint64) _tmp41_, _tmp39__target);
#line 29407 "Photo.c"
				}
#line 3794 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_g_object_unref0 (photo);
#line 3794 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				photo_row_destroy (&row);
#line 29413 "Photo.c"
			}
		}
	}
#line 3810 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp42_ = library_photo_global;
#line 3810 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp43_ = all_photos;
#line 3810 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp44_ = data_collection_add_many (DATA_COLLECTION (_tmp42_), GEE_COLLECTION (_tmp43_), NULL, NULL);
#line 3810 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp45_ = _tmp44_;
#line 3810 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_g_object_unref0 (_tmp45_);
#line 3811 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp46_ = library_photo_global;
#line 3811 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp47_ = trashed_photos;
#line 3811 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	media_source_collection_add_many_to_trash (MEDIA_SOURCE_COLLECTION (_tmp46_), GEE_COLLECTION (_tmp47_));
#line 3812 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp48_ = library_photo_global;
#line 3812 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp49_ = offline_photos;
#line 3812 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	media_source_collection_add_many_to_offline (MEDIA_SOURCE_COLLECTION (_tmp48_), GEE_COLLECTION (_tmp49_));
#line 3783 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_g_object_unref0 (offline_photos);
#line 3783 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_g_object_unref0 (trashed_photos);
#line 3783 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_g_object_unref0 (all_photos);
#line 3783 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_g_object_unref0 (all);
#line 29447 "Photo.c"
}


void library_photo_terminate (void) {
}


ImportResult library_photo_import_create (PhotoImportParams* params, LibraryPhoto** photo) {
	LibraryPhoto* _vala_photo = NULL;
	ImportResult result = 0;
	PhotoTable* _tmp0_ = NULL;
	PhotoTable* _tmp1_;
	PhotoImportParams* _tmp2_;
	PhotoID _tmp3_ = {0};
	PhotoID _tmp4_;
	PhotoID photo_id;
	gboolean _tmp5_ = FALSE;
	PhotoImportParams* _tmp6_;
	PhotoRow _tmp7_;
	PhotoImportParams* _tmp8_;
	GeeCollection* _tmp9_;
	LibraryPhoto* _tmp10_;
#line 3822 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail (IS_PHOTO_IMPORT_PARAMS (params), 0);
#line 3824 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp0_ = photo_table_get_instance ();
#line 3824 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 3824 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp2_ = params;
#line 3824 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	photo_table_add (_tmp1_, &_tmp2_->row, &_tmp3_);
#line 3824 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp4_ = _tmp3_;
#line 3824 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_database_table_unref0 (_tmp1_);
#line 3824 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	photo_id = _tmp4_;
#line 3825 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp5_ = photo_id_is_invalid (&photo_id);
#line 3825 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp5_) {
#line 3826 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		result = IMPORT_RESULT_DATABASE_ERROR;
#line 3826 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		if (photo) {
#line 3826 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			*photo = _vala_photo;
#line 29496 "Photo.c"
		} else {
#line 3826 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_g_object_unref0 (_vala_photo);
#line 29500 "Photo.c"
		}
#line 3826 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return result;
#line 29504 "Photo.c"
	}
#line 3829 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp6_ = params;
#line 3829 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp7_ = _tmp6_->row;
#line 3829 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp8_ = params;
#line 3829 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp9_ = _tmp8_->keywords;
#line 3829 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp10_ = library_photo_new (&_tmp7_, _tmp9_);
#line 3829 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_g_object_unref0 (_vala_photo);
#line 3829 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_vala_photo = _tmp10_;
#line 3831 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	result = IMPORT_RESULT_SUCCESS;
#line 3831 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (photo) {
#line 3831 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		*photo = _vala_photo;
#line 29526 "Photo.c"
	} else {
#line 3831 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_object_unref0 (_vala_photo);
#line 29530 "Photo.c"
	}
#line 3831 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return result;
#line 29534 "Photo.c"
}


void library_photo_import_failed (LibraryPhoto* photo) {
	GError * _inner_error_ = NULL;
#line 3834 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO (photo));
#line 29542 "Photo.c"
	{
		PhotoTable* _tmp0_ = NULL;
		PhotoTable* _tmp1_;
		LibraryPhoto* _tmp2_;
		PhotoID _tmp3_ = {0};
#line 3836 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp0_ = photo_table_get_instance ();
#line 3836 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp1_ = _tmp0_;
#line 3836 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp2_ = photo;
#line 3836 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		photo_get_photo_id (PHOTO (_tmp2_), &_tmp3_);
#line 3836 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		photo_table_remove (_tmp1_, &_tmp3_, &_inner_error_);
#line 3836 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_database_table_unref0 (_tmp1_);
#line 3836 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 3836 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			if (_inner_error_->domain == DATABASE_ERROR) {
#line 29564 "Photo.c"
				goto __catch227_database_error;
			}
#line 3836 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 3836 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 3836 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			return;
#line 29573 "Photo.c"
		}
	}
	goto __finally227;
	__catch227_database_error:
	{
		GError* err = NULL;
		GError* _tmp4_;
#line 3835 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		err = _inner_error_;
#line 3835 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_inner_error_ = NULL;
#line 3838 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp4_ = err;
#line 3838 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		app_window_database_error (_tmp4_);
#line 3835 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_error_free0 (err);
#line 29591 "Photo.c"
	}
	__finally227:
#line 3835 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 3835 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 3835 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 3835 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return;
#line 29602 "Photo.c"
	}
}


static void library_photo_real_notify_master_reimported (Photo* base, PhotoMetadata* metadata) {
	LibraryPhoto * self;
	PhotoMetadata* _tmp0_;
	LibraryPhotoSourceCollection* _tmp1_;
	PhotoMetadata* _tmp2_;
#line 3842 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	self = LIBRARY_PHOTO (base);
#line 3842 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
#line 3843 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp0_ = metadata;
#line 3843 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	PHOTO_CLASS (library_photo_parent_class)->notify_master_reimported (PHOTO (self), _tmp0_);
#line 3845 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp1_ = library_photo_global;
#line 3845 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp2_ = metadata;
#line 3845 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	library_photo_source_collection_notify_master_reimported (_tmp1_, self, _tmp2_);
#line 29626 "Photo.c"
}


static void library_photo_real_notify_editable_reimported (Photo* base, PhotoMetadata* metadata) {
	LibraryPhoto * self;
	PhotoMetadata* _tmp0_;
	LibraryPhotoSourceCollection* _tmp1_;
	PhotoMetadata* _tmp2_;
#line 3848 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	self = LIBRARY_PHOTO (base);
#line 3848 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
#line 3849 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp0_ = metadata;
#line 3849 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	PHOTO_CLASS (library_photo_parent_class)->notify_editable_reimported (PHOTO (self), _tmp0_);
#line 3851 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp1_ = library_photo_global;
#line 3851 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp2_ = metadata;
#line 3851 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	library_photo_source_collection_notify_editable_reimported (_tmp1_, self, _tmp2_);
#line 29649 "Photo.c"
}


static void library_photo_real_notify_source_reimported (Photo* base, PhotoMetadata* metadata) {
	LibraryPhoto * self;
	PhotoMetadata* _tmp0_;
	LibraryPhotoSourceCollection* _tmp1_;
	PhotoMetadata* _tmp2_;
#line 3854 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	self = LIBRARY_PHOTO (base);
#line 3854 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
#line 3855 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp0_ = metadata;
#line 3855 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	PHOTO_CLASS (library_photo_parent_class)->notify_source_reimported (PHOTO (self), _tmp0_);
#line 3857 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp1_ = library_photo_global;
#line 3857 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp2_ = metadata;
#line 3857 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	library_photo_source_collection_notify_source_reimported (_tmp1_, self, _tmp2_);
#line 29672 "Photo.c"
}


static void library_photo_real_notify_baseline_reimported (Photo* base, PhotoMetadata* metadata) {
	LibraryPhoto * self;
	PhotoMetadata* _tmp0_;
	LibraryPhotoSourceCollection* _tmp1_;
	PhotoMetadata* _tmp2_;
#line 3860 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	self = LIBRARY_PHOTO (base);
#line 3860 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail ((metadata == NULL) || IS_PHOTO_METADATA (metadata));
#line 3861 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp0_ = metadata;
#line 3861 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	PHOTO_CLASS (library_photo_parent_class)->notify_baseline_reimported (PHOTO (self), _tmp0_);
#line 3863 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp1_ = library_photo_global;
#line 3863 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp2_ = metadata;
#line 3863 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	library_photo_source_collection_notify_baseline_reimported (_tmp1_, self, _tmp2_);
#line 29695 "Photo.c"
}


static void library_photo_generate_thumbnails (LibraryPhoto* self) {
	GError * _inner_error_ = NULL;
#line 3866 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO (self));
#line 29703 "Photo.c"
	{
#line 3868 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		thumbnail_cache_import_from_source (THUMBNAIL_SOURCE (self), TRUE, &_inner_error_);
#line 3868 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 29709 "Photo.c"
			goto __catch228_g_error;
		}
	}
	goto __finally228;
	__catch228_g_error:
	{
		GError* err = NULL;
		gchar* _tmp0_ = NULL;
		gchar* _tmp1_;
		GError* _tmp2_;
		const gchar* _tmp3_;
#line 3867 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		err = _inner_error_;
#line 3867 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_inner_error_ = NULL;
#line 3870 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp0_ = data_object_to_string (DATA_OBJECT (self));
#line 3870 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp1_ = _tmp0_;
#line 3870 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp2_ = err;
#line 3870 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp3_ = _tmp2_->message;
#line 3870 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_warning ("Photo.vala:3870: Unable to generate thumbnails for %s: %s", _tmp1_, _tmp3_);
#line 3870 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_free0 (_tmp1_);
#line 3867 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_error_free0 (err);
#line 29739 "Photo.c"
	}
	__finally228:
#line 3867 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 3867 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 3867 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 3867 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return;
#line 29750 "Photo.c"
	}
#line 3874 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	thumbnail_source_notify_thumbnail_altered (THUMBNAIL_SOURCE (self));
#line 29754 "Photo.c"
}


GeeCollection* library_photo_get_import_keywords (LibraryPhoto* self) {
	GeeCollection* result = NULL;
	GeeCollection* _tmp0_;
	GeeCollection* _tmp1_;
#line 3878 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail (IS_LIBRARY_PHOTO (self), NULL);
#line 3879 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp0_ = self->priv->import_keywords;
#line 3879 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 3879 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	result = _tmp1_;
#line 3879 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return result;
#line 29772 "Photo.c"
}


void library_photo_clear_import_keywords (LibraryPhoto* self) {
#line 3882 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO (self));
#line 3883 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_g_object_unref0 (self->priv->import_keywords);
#line 3883 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	self->priv->import_keywords = NULL;
#line 29783 "Photo.c"
}


static void library_photo_real_notify_altered (DataObject* base, Alteration* alteration) {
	LibraryPhoto * self;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
	gboolean _tmp4_;
	Alteration* _tmp6_;
#line 3886 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	self = LIBRARY_PHOTO (base);
#line 3886 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail (IS_ALTERATION (alteration));
#line 3888 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp1_ = self->priv->block_thumbnail_generation;
#line 3888 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (!_tmp1_) {
#line 29801 "Photo.c"
		Alteration* _tmp2_;
		gboolean _tmp3_ = FALSE;
#line 3888 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp2_ = alteration;
#line 3888 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp3_ = alteration_has_subject (_tmp2_, "image");
#line 3888 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp0_ = _tmp3_;
#line 29810 "Photo.c"
	} else {
#line 3888 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp0_ = FALSE;
#line 29814 "Photo.c"
	}
#line 3888 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp4_ = _tmp0_;
#line 3888 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp4_) {
#line 29820 "Photo.c"
		OneShotScheduler* _tmp5_;
#line 3889 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp5_ = self->priv->thumbnail_scheduler;
#line 3889 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		one_shot_scheduler_at_priority_idle (_tmp5_, G_PRIORITY_LOW);
#line 29826 "Photo.c"
	}
#line 3891 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp6_ = alteration;
#line 3891 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	DATA_OBJECT_CLASS (library_photo_parent_class)->notify_altered (DATA_OBJECT (PHOTO (self)), _tmp6_);
#line 29832 "Photo.c"
}


static GdkPixbuf* library_photo_real_get_preview_pixbuf (MediaSource* base, Scaling* scaling, GError** error) {
	LibraryPhoto * self;
	GdkPixbuf* result = NULL;
	GdkPixbuf* _tmp0_ = NULL;
	GdkPixbuf* pixbuf;
	GdkPixbuf* _tmp1_ = NULL;
	GError * _inner_error_ = NULL;
#line 3894 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	self = LIBRARY_PHOTO (base);
#line 3894 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail (scaling != NULL, NULL);
#line 3895 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp0_ = thumbnail_source_get_thumbnail (THUMBNAIL_SOURCE (self), (gint) THUMBNAIL_CACHE_SIZE_BIG, &_inner_error_);
#line 3895 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	pixbuf = _tmp0_;
#line 3895 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 3895 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 3895 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return NULL;
#line 29857 "Photo.c"
	}
#line 3897 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp1_ = scaling_perform_on_pixbuf (scaling, pixbuf, GDK_INTERP_BILINEAR, TRUE);
#line 3897 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	result = _tmp1_;
#line 3897 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_g_object_unref0 (pixbuf);
#line 3897 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return result;
#line 29867 "Photo.c"
}


static void library_photo_real_rotate (Photo* base, Rotation rotation) {
	LibraryPhoto * self;
	Rotation _tmp0_;
	GError * _inner_error_ = NULL;
#line 3900 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	self = LIBRARY_PHOTO (base);
#line 3902 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	self->priv->block_thumbnail_generation = TRUE;
#line 3903 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp0_ = rotation;
#line 3903 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	PHOTO_CLASS (library_photo_parent_class)->rotate (PHOTO (self), _tmp0_);
#line 3904 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	self->priv->block_thumbnail_generation = FALSE;
#line 29885 "Photo.c"
	{
		Rotation _tmp1_;
#line 3912 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp1_ = rotation;
#line 3912 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		thumbnail_cache_rotate (THUMBNAIL_SOURCE (self), _tmp1_, &_inner_error_);
#line 3912 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 29894 "Photo.c"
			goto __catch229_g_error;
		}
	}
	goto __finally229;
	__catch229_g_error:
	{
		GError* err = NULL;
		gchar* _tmp2_ = NULL;
		gchar* _tmp3_;
		GError* _tmp4_;
		const gchar* _tmp5_;
#line 3911 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		err = _inner_error_;
#line 3911 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_inner_error_ = NULL;
#line 3915 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp2_ = data_object_to_string (DATA_OBJECT (self));
#line 3915 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp3_ = _tmp2_;
#line 3915 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp4_ = err;
#line 3915 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp5_ = _tmp4_->message;
#line 3915 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_warning ("Photo.vala:3915: Unable to update thumbnails for %s: %s", _tmp3_, _tmp5_);
#line 3915 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_free0 (_tmp3_);
#line 3911 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_error_free0 (err);
#line 29924 "Photo.c"
	}
	__finally229:
#line 3911 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 3911 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 3911 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 3911 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return;
#line 29935 "Photo.c"
	}
#line 3918 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	thumbnail_source_notify_thumbnail_altered (THUMBNAIL_SOURCE (self));
#line 29939 "Photo.c"
}


static GdkPixbuf* library_photo_real_get_thumbnail (ThumbnailSource* base, gint scale, GError** error) {
	LibraryPhoto * self;
	GdkPixbuf* result = NULL;
	gint _tmp0_;
	GdkPixbuf* _tmp1_ = NULL;
	GdkPixbuf* _tmp2_;
	GError * _inner_error_ = NULL;
#line 3922 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	self = LIBRARY_PHOTO (base);
#line 3923 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp0_ = scale;
#line 3923 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp1_ = thumbnail_cache_fetch (THUMBNAIL_SOURCE (self), _tmp0_, &_inner_error_);
#line 3923 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp2_ = _tmp1_;
#line 3923 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 3923 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 3923 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return NULL;
#line 29964 "Photo.c"
	}
#line 3923 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	result = _tmp2_;
#line 3923 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return result;
#line 29970 "Photo.c"
}


static void _library_photo_on_duplicate_progress_gfile_progress_callback (gint64 current_num_bytes, gint64 total_num_bytes, gpointer self) {
#line 3928 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	library_photo_on_duplicate_progress (self, current_num_bytes, total_num_bytes);
#line 29977 "Photo.c"
}


LibraryPhoto* library_photo_duplicate (LibraryPhoto* self, GError** error) {
	LibraryPhoto* result = NULL;
	GFile* _tmp0_ = NULL;
	GFile* _tmp1_;
	GFile* _tmp2_ = NULL;
	GFile* _tmp3_;
	GFile* dupe_file;
	BackingPhotoID dupe_editable_id = {0};
	PhotoFileReader* _tmp4_ = NULL;
	PhotoFileReader* editable_reader;
	GFile* _tmp5_ = NULL;
	PhotoFileReader* _tmp6_;
	GFile* _tmp9_;
	GFile* _tmp10_;
	GFile* editable_file;
	GFile* _tmp11_;
	PhotoTable* _tmp26_ = NULL;
	PhotoTable* _tmp27_;
	PhotoID _tmp28_ = {0};
	GFile* _tmp29_;
	gchar* _tmp30_ = NULL;
	gchar* _tmp31_;
	BackingPhotoID _tmp32_;
	PhotoID _tmp33_ = {0};
	PhotoID _tmp34_;
	PhotoID dupe_id;
	PhotoTable* _tmp35_ = NULL;
	PhotoTable* _tmp36_;
	PhotoID _tmp37_;
	PhotoRow* _tmp38_ = NULL;
	PhotoRow* _tmp39_;
	PhotoRow _tmp40_ = {0};
	PhotoRow _tmp41_;
	PhotoRow dupe_row;
	PhotoRow _tmp42_;
	LibraryPhoto* _tmp43_;
	LibraryPhoto* dupe;
	LibraryPhoto* _tmp44_;
	LibraryPhotoSourceCollection* _tmp45_;
	LibraryPhoto* _tmp46_;
	LibraryPhoto* _tmp47_;
	Event* _tmp48_ = NULL;
	Event* _tmp49_;
	LibraryPhoto* _tmp50_;
	TagSourceCollection* _tmp51_;
	GeeList* _tmp52_ = NULL;
	GeeCollection* tags;
	GeeCollection* _tmp53_;
	GError * _inner_error_ = NULL;
#line 3926 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail (IS_LIBRARY_PHOTO (self), NULL);
#line 3928 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp0_ = media_source_get_master_file (MEDIA_SOURCE (self));
#line 3928 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 3928 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp2_ = library_files_duplicate (_tmp1_, _library_photo_on_duplicate_progress_gfile_progress_callback, self, TRUE, &_inner_error_);
#line 3928 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp3_ = _tmp2_;
#line 3928 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_g_object_unref0 (_tmp1_);
#line 3928 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	dupe_file = _tmp3_;
#line 3928 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 3928 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 3928 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return NULL;
#line 30050 "Photo.c"
	}
#line 3931 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	backing_photo_id_init (&dupe_editable_id, BACKING_PHOTO_ID_INVALID);
#line 3932 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp4_ = photo_get_editable_reader (PHOTO (self));
#line 3932 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	editable_reader = _tmp4_;
#line 3933 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp6_ = editable_reader;
#line 3933 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp6_ != NULL) {
#line 30062 "Photo.c"
		PhotoFileReader* _tmp7_;
		GFile* _tmp8_ = NULL;
#line 3933 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp7_ = editable_reader;
#line 3933 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp8_ = photo_file_adapter_get_file (PHOTO_FILE_ADAPTER (_tmp7_));
#line 3933 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_object_unref0 (_tmp5_);
#line 3933 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp5_ = _tmp8_;
#line 30073 "Photo.c"
	} else {
#line 3933 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_object_unref0 (_tmp5_);
#line 3933 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp5_ = NULL;
#line 30079 "Photo.c"
	}
#line 3933 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp9_ = _tmp5_;
#line 3933 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp10_ = _g_object_ref0 (_tmp9_);
#line 3933 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	editable_file = _tmp10_;
#line 3934 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp11_ = editable_file;
#line 3934 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp11_ != NULL) {
#line 30091 "Photo.c"
		GFile* _tmp12_;
		GFile* _tmp13_ = NULL;
		GFile* dupe_editable;
		BackingPhotoState state = {0};
		DetectedPhotoInformation* detected = NULL;
		GFile* _tmp14_;
		BackingPhotoState _tmp15_ = {0};
		DetectedPhotoInformation* _tmp16_ = NULL;
		gboolean _tmp17_ = FALSE;
		gboolean _tmp18_;
#line 3935 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp12_ = editable_file;
#line 3935 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp13_ = library_files_duplicate (_tmp12_, _library_photo_on_duplicate_progress_gfile_progress_callback, self, TRUE, &_inner_error_);
#line 3935 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		dupe_editable = _tmp13_;
#line 3935 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 3935 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 3935 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_g_object_unref0 (editable_file);
#line 3935 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_g_object_unref0 (_tmp5_);
#line 3935 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_photo_file_adapter_unref0 (editable_reader);
#line 3935 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_g_object_unref0 (dupe_file);
#line 3935 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			return NULL;
#line 30122 "Photo.c"
		}
#line 3937 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		memset (&state, 0, sizeof (BackingPhotoState));
#line 3939 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp14_ = dupe_editable;
#line 3939 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp17_ = photo_query_backing_photo_state (PHOTO (self), _tmp14_, PHOTO_FILE_SNIFFER_OPTIONS_NO_MD5, &_tmp15_, &_tmp16_, &_inner_error_);
#line 3939 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		backing_photo_state_destroy (&state);
#line 3939 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		state = _tmp15_;
#line 3939 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 3939 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		detected = _tmp16_;
#line 3939 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp18_ = _tmp17_;
#line 3939 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 3939 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_propagate_error (error, _inner_error_);
#line 3939 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_detected_photo_information_unref0 (detected);
#line 3939 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			backing_photo_state_destroy (&state);
#line 3939 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_g_object_unref0 (dupe_editable);
#line 3939 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_g_object_unref0 (editable_file);
#line 3939 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_g_object_unref0 (_tmp5_);
#line 3939 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_photo_file_adapter_unref0 (editable_reader);
#line 3939 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_g_object_unref0 (dupe_file);
#line 3939 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			return NULL;
#line 30160 "Photo.c"
		}
#line 3939 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		if (_tmp18_) {
#line 30164 "Photo.c"
			BackingPhotoTable* _tmp19_ = NULL;
			BackingPhotoTable* _tmp20_;
			BackingPhotoState _tmp21_;
			BackingPhotoRow _tmp22_ = {0};
			BackingPhotoRow _tmp23_;
			BackingPhotoRow editable_row;
			BackingPhotoRow _tmp24_;
			BackingPhotoID _tmp25_;
#line 3941 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp19_ = backing_photo_table_get_instance ();
#line 3941 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp20_ = _tmp19_;
#line 3941 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp21_ = state;
#line 3941 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			backing_photo_table_add (_tmp20_, &_tmp21_, &_tmp22_, &_inner_error_);
#line 3941 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp23_ = _tmp22_;
#line 3941 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_database_table_unref0 (_tmp20_);
#line 3941 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			editable_row = _tmp23_;
#line 3941 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			if (_inner_error_ != NULL) {
#line 3941 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				g_propagate_error (error, _inner_error_);
#line 3941 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_detected_photo_information_unref0 (detected);
#line 3941 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				backing_photo_state_destroy (&state);
#line 3941 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_g_object_unref0 (dupe_editable);
#line 3941 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_g_object_unref0 (editable_file);
#line 3941 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_g_object_unref0 (_tmp5_);
#line 3941 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_photo_file_adapter_unref0 (editable_reader);
#line 3941 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_g_object_unref0 (dupe_file);
#line 3941 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				return NULL;
#line 30207 "Photo.c"
			}
#line 3942 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp24_ = editable_row;
#line 3942 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp25_ = _tmp24_.id;
#line 3942 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			dupe_editable_id = _tmp25_;
#line 3939 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			backing_photo_row_destroy (&editable_row);
#line 30217 "Photo.c"
		}
#line 3934 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_detected_photo_information_unref0 (detected);
#line 3934 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		backing_photo_state_destroy (&state);
#line 3934 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_object_unref0 (dupe_editable);
#line 30225 "Photo.c"
	}
#line 3947 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp26_ = photo_table_get_instance ();
#line 3947 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp27_ = _tmp26_;
#line 3947 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	photo_get_photo_id (PHOTO (self), &_tmp28_);
#line 3947 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp29_ = dupe_file;
#line 3947 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp30_ = g_file_get_path (_tmp29_);
#line 3947 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp31_ = _tmp30_;
#line 3947 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp32_ = dupe_editable_id;
#line 3947 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	photo_table_duplicate (_tmp27_, &_tmp28_, _tmp31_, &_tmp32_, &_tmp33_);
#line 3947 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp34_ = _tmp33_;
#line 3947 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_g_free0 (_tmp31_);
#line 3947 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_database_table_unref0 (_tmp27_);
#line 3947 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	dupe_id = _tmp34_;
#line 3949 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp35_ = photo_table_get_instance ();
#line 3949 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp36_ = _tmp35_;
#line 3949 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp37_ = dupe_id;
#line 3949 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp38_ = photo_table_get_row (_tmp36_, &_tmp37_);
#line 3949 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp39_ = _tmp38_;
#line 3949 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	photo_row_copy (_tmp39_, &_tmp40_);
#line 3949 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp41_ = _tmp40_;
#line 3949 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_photo_row_free0 (_tmp39_);
#line 3949 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_database_table_unref0 (_tmp36_);
#line 3949 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	dupe_row = _tmp41_;
#line 3952 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp42_ = dupe_row;
#line 3952 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp43_ = library_photo_new (&_tmp42_, NULL);
#line 3952 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	dupe = _tmp43_;
#line 3955 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp44_ = dupe;
#line 3955 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	thumbnail_cache_duplicate (THUMBNAIL_SOURCE (self), THUMBNAIL_SOURCE (_tmp44_));
#line 3958 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp45_ = library_photo_global;
#line 3958 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp46_ = dupe;
#line 3958 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	data_collection_add (DATA_COLLECTION (_tmp45_), DATA_OBJECT (_tmp46_));
#line 3961 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp47_ = dupe;
#line 3961 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp48_ = media_source_get_event (MEDIA_SOURCE (_tmp47_));
#line 3961 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp49_ = _tmp48_;
#line 3961 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp50_ = dupe;
#line 3961 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	event_attach (_tmp49_, MEDIA_SOURCE (_tmp50_));
#line 3961 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_g_object_unref0 (_tmp49_);
#line 3962 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp51_ = tag_global;
#line 3962 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp52_ = tag_source_collection_fetch_for_source (_tmp51_, MEDIA_SOURCE (self));
#line 3962 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	tags = GEE_COLLECTION (_tmp52_);
#line 3963 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp53_ = tags;
#line 3963 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp53_ != NULL) {
#line 30309 "Photo.c"
		{
			GeeCollection* _tmp54_;
			GeeIterator* _tmp55_ = NULL;
			GeeIterator* _tag_it;
#line 3964 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp54_ = tags;
#line 3964 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp55_ = gee_iterable_iterator (GEE_ITERABLE (_tmp54_));
#line 3964 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tag_it = _tmp55_;
#line 3964 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			while (TRUE) {
#line 30322 "Photo.c"
				GeeIterator* _tmp56_;
				gboolean _tmp57_ = FALSE;
				GeeIterator* _tmp58_;
				gpointer _tmp59_ = NULL;
				Tag* tag;
				Tag* _tmp60_;
				LibraryPhoto* _tmp61_;
#line 3964 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp56_ = _tag_it;
#line 3964 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp57_ = gee_iterator_next (_tmp56_);
#line 3964 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				if (!_tmp57_) {
#line 3964 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					break;
#line 30338 "Photo.c"
				}
#line 3964 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp58_ = _tag_it;
#line 3964 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp59_ = gee_iterator_get (_tmp58_);
#line 3964 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				tag = (Tag*) _tmp59_;
#line 3965 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp60_ = tag;
#line 3965 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp61_ = dupe;
#line 3965 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				tag_attach (_tmp60_, MEDIA_SOURCE (_tmp61_));
#line 3964 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_g_object_unref0 (tag);
#line 30354 "Photo.c"
			}
#line 3964 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_g_object_unref0 (_tag_it);
#line 30358 "Photo.c"
		}
	}
#line 3969 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	result = dupe;
#line 3969 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_g_object_unref0 (tags);
#line 3969 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	photo_row_destroy (&dupe_row);
#line 3969 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_g_object_unref0 (editable_file);
#line 3969 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_g_object_unref0 (_tmp5_);
#line 3969 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_photo_file_adapter_unref0 (editable_reader);
#line 3969 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_g_object_unref0 (dupe_file);
#line 3969 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return result;
#line 30377 "Photo.c"
}


static void library_photo_on_duplicate_progress (LibraryPhoto* self, gint64 current, gint64 total) {
#line 3972 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO (self));
#line 3973 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	spin_event_loop (-1);
#line 30386 "Photo.c"
}


static void library_photo_upgrade_rating_flags (LibraryPhoto* self, guint64 flags) {
	guint64 _tmp0_;
	guint64 _tmp1_;
#line 3976 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail (IS_LIBRARY_PHOTO (self));
#line 3977 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp0_ = flags;
#line 3977 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if ((_tmp0_ & LIBRARY_PHOTO_FLAG_HIDDEN) != ((guint64) 0)) {
#line 3978 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		media_source_set_rating (MEDIA_SOURCE (self), RATING_REJECTED);
#line 3979 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		photo_remove_flags (PHOTO (self), LIBRARY_PHOTO_FLAG_HIDDEN, NULL);
#line 30403 "Photo.c"
	}
#line 3982 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp1_ = flags;
#line 3982 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if ((_tmp1_ & LIBRARY_PHOTO_FLAG_FAVORITE) != ((guint64) 0)) {
#line 3983 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		media_source_set_rating (MEDIA_SOURCE (self), RATING_FIVE);
#line 3984 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		photo_remove_flags (PHOTO (self), LIBRARY_PHOTO_FLAG_FAVORITE, NULL);
#line 30413 "Photo.c"
	}
}


static gboolean library_photo_real_is_trashed (MediaSource* base) {
	LibraryPhoto * self;
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
#line 3989 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	self = LIBRARY_PHOTO (base);
#line 3990 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp0_ = photo_is_flag_set (PHOTO (self), LIBRARY_PHOTO_FLAG_TRASH);
#line 3990 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	result = _tmp0_;
#line 3990 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return result;
#line 30430 "Photo.c"
}


static void library_photo_real_trash (MediaSource* base) {
	LibraryPhoto * self;
#line 3993 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	self = LIBRARY_PHOTO (base);
#line 3994 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	photo_add_flags (PHOTO (self), LIBRARY_PHOTO_FLAG_TRASH, NULL);
#line 30440 "Photo.c"
}


static void library_photo_real_untrash (MediaSource* base) {
	LibraryPhoto * self;
#line 3997 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	self = LIBRARY_PHOTO (base);
#line 3998 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	photo_remove_flags (PHOTO (self), LIBRARY_PHOTO_FLAG_TRASH, NULL);
#line 30450 "Photo.c"
}


static gboolean library_photo_real_is_offline (Monitorable* base) {
	LibraryPhoto * self;
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
#line 4001 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	self = LIBRARY_PHOTO (base);
#line 4002 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp0_ = photo_is_flag_set (PHOTO (self), LIBRARY_PHOTO_FLAG_OFFLINE);
#line 4002 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	result = _tmp0_;
#line 4002 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return result;
#line 30466 "Photo.c"
}


static void library_photo_real_mark_offline (Monitorable* base) {
	LibraryPhoto * self;
#line 4005 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	self = LIBRARY_PHOTO (base);
#line 4006 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	photo_add_flags (PHOTO (self), LIBRARY_PHOTO_FLAG_OFFLINE, NULL);
#line 30476 "Photo.c"
}


static void library_photo_real_mark_online (Monitorable* base) {
	LibraryPhoto * self;
#line 4009 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	self = LIBRARY_PHOTO (base);
#line 4010 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	photo_remove_flags (PHOTO (self), LIBRARY_PHOTO_FLAG_OFFLINE, NULL);
#line 30486 "Photo.c"
}


static gboolean library_photo_real_is_flagged (Flaggable* base) {
	LibraryPhoto * self;
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
#line 4013 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	self = LIBRARY_PHOTO (base);
#line 4014 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp0_ = photo_is_flag_set (PHOTO (self), LIBRARY_PHOTO_FLAG_FLAGGED);
#line 4014 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	result = _tmp0_;
#line 4014 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return result;
#line 30502 "Photo.c"
}


static void library_photo_real_mark_flagged (Flaggable* base) {
	LibraryPhoto * self;
	Alteration* _tmp0_;
	Alteration* _tmp1_;
#line 4017 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	self = LIBRARY_PHOTO (base);
#line 4018 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp0_ = alteration_new ("metadata", "flagged");
#line 4018 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 4018 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	photo_add_flags (PHOTO (self), LIBRARY_PHOTO_FLAG_FLAGGED, _tmp1_);
#line 4018 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_alteration_unref0 (_tmp1_);
#line 30520 "Photo.c"
}


static void library_photo_real_mark_unflagged (Flaggable* base) {
	LibraryPhoto * self;
	Alteration* _tmp0_;
	Alteration* _tmp1_;
#line 4021 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	self = LIBRARY_PHOTO (base);
#line 4022 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp0_ = alteration_new ("metadata", "flagged");
#line 4022 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 4022 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	photo_remove_flags (PHOTO (self), LIBRARY_PHOTO_FLAG_FLAGGED, _tmp1_);
#line 4022 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_alteration_unref0 (_tmp1_);
#line 30538 "Photo.c"
}


static gboolean library_photo_real_internal_delete_backing (DataSource* base, GError** error) {
	LibraryPhoto * self;
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
	gboolean _tmp2_ = FALSE;
	GError * _inner_error_ = NULL;
#line 4025 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	self = LIBRARY_PHOTO (base);
#line 4028 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp0_ = DATA_SOURCE_CLASS (library_photo_parent_class)->internal_delete_backing (DATA_SOURCE (PHOTO (self)), &_inner_error_);
#line 4028 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp1_ = _tmp0_;
#line 4028 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 4028 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_propagate_error (error, _inner_error_);
#line 4028 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return FALSE;
#line 30561 "Photo.c"
	}
#line 4028 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (!_tmp1_) {
#line 4029 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		result = FALSE;
#line 4029 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return result;
#line 30569 "Photo.c"
	}
#line 4031 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp2_ = media_source_delete_original_file (MEDIA_SOURCE (self));
#line 4031 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	result = _tmp2_;
#line 4031 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return result;
#line 30577 "Photo.c"
}


static void library_photo_real_destroy (DataSource* base) {
	LibraryPhoto * self;
	PhotoID _tmp0_ = {0};
	PhotoID photo_id;
	GError * _inner_error_ = NULL;
#line 4034 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	self = LIBRARY_PHOTO (base);
#line 4035 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	photo_get_photo_id (PHOTO (self), &_tmp0_);
#line 4035 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	photo_id = _tmp0_;
#line 4038 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	thumbnail_cache_remove (THUMBNAIL_SOURCE (self));
#line 30594 "Photo.c"
	{
		PhotoTable* _tmp1_ = NULL;
		PhotoTable* _tmp2_;
		PhotoID _tmp3_;
#line 4044 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp1_ = photo_table_get_instance ();
#line 4044 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp2_ = _tmp1_;
#line 4044 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp3_ = photo_id;
#line 4044 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		photo_table_remove (_tmp2_, &_tmp3_, &_inner_error_);
#line 4044 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_database_table_unref0 (_tmp2_);
#line 4044 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		if (_inner_error_ != NULL) {
#line 4044 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			if (_inner_error_->domain == DATABASE_ERROR) {
#line 30613 "Photo.c"
				goto __catch230_database_error;
			}
#line 4044 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 4044 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			g_clear_error (&_inner_error_);
#line 4044 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			return;
#line 30622 "Photo.c"
		}
	}
	goto __finally230;
	__catch230_database_error:
	{
		GError* err = NULL;
		GError* _tmp4_;
#line 4043 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		err = _inner_error_;
#line 4043 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_inner_error_ = NULL;
#line 4046 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp4_ = err;
#line 4046 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		app_window_database_error (_tmp4_);
#line 4043 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_error_free0 (err);
#line 30640 "Photo.c"
	}
	__finally230:
#line 4043 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_inner_error_ != NULL) {
#line 4043 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 4043 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		g_clear_error (&_inner_error_);
#line 4043 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return;
#line 30651 "Photo.c"
	}
#line 4049 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	DATA_SOURCE_CLASS (library_photo_parent_class)->destroy (DATA_SOURCE (PHOTO (self)));
#line 30655 "Photo.c"
}


gboolean library_photo_has_nontrash_duplicate (GFile* file, const gchar* thumbnail_md5, const gchar* full_md5, PhotoFileFormat file_format) {
	gboolean result = FALSE;
	GFile* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	PhotoFileFormat _tmp3_;
	gint _tmp4_ = 0;
	PhotoID* _tmp5_ = NULL;
	PhotoID* ids;
	gint ids_length1;
	gint _ids_size_;
	gboolean _tmp6_ = FALSE;
	PhotoID* _tmp7_;
	gint _tmp7__length1;
	gboolean _tmp9_;
	PhotoID* _tmp10_;
	gint _tmp10__length1;
#line 4052 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_val_if_fail ((file == NULL) || G_IS_FILE (file), FALSE);
#line 4054 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp0_ = file;
#line 4054 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp1_ = thumbnail_md5;
#line 4054 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp2_ = full_md5;
#line 4054 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp3_ = file_format;
#line 4054 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp5_ = photo_get_duplicate_ids (_tmp0_, _tmp1_, _tmp2_, _tmp3_, &_tmp4_);
#line 4054 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	ids = _tmp5_;
#line 4054 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	ids_length1 = _tmp4_;
#line 4054 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_ids_size_ = ids_length1;
#line 4056 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp7_ = ids;
#line 4056 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp7__length1 = ids_length1;
#line 4056 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp7_ == NULL) {
#line 4056 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp6_ = TRUE;
#line 30702 "Photo.c"
	} else {
		PhotoID* _tmp8_;
		gint _tmp8__length1;
#line 4056 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp8_ = ids;
#line 4056 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp8__length1 = ids_length1;
#line 4056 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp6_ = _tmp8__length1 == 0;
#line 30712 "Photo.c"
	}
#line 4056 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp9_ = _tmp6_;
#line 4056 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp9_) {
#line 4057 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		result = FALSE;
#line 4057 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		ids = (g_free (ids), NULL);
#line 4057 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return result;
#line 30724 "Photo.c"
	}
#line 4059 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp10_ = ids;
#line 4059 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp10__length1 = ids_length1;
#line 30730 "Photo.c"
	{
		PhotoID* id_collection = NULL;
		gint id_collection_length1 = 0;
		gint _id_collection_size_ = 0;
		gint id_it = 0;
#line 4059 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		id_collection = _tmp10_;
#line 4059 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		id_collection_length1 = _tmp10__length1;
#line 4059 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		for (id_it = 0; id_it < _tmp10__length1; id_it = id_it + 1) {
#line 30742 "Photo.c"
			PhotoID id = {0};
#line 4059 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			id = id_collection[id_it];
#line 30746 "Photo.c"
			{
				LibraryPhotoSourceCollection* _tmp11_;
				PhotoID _tmp12_;
				LibraryPhoto* _tmp13_ = NULL;
				LibraryPhoto* photo;
				gboolean _tmp14_ = FALSE;
				LibraryPhoto* _tmp15_;
				gboolean _tmp18_;
#line 4060 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp11_ = library_photo_global;
#line 4060 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp12_ = id;
#line 4060 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp13_ = library_photo_source_collection_fetch (_tmp11_, &_tmp12_);
#line 4060 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				photo = _tmp13_;
#line 4061 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp15_ = photo;
#line 4061 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				if (_tmp15_ != NULL) {
#line 30767 "Photo.c"
					LibraryPhoto* _tmp16_;
					gboolean _tmp17_ = FALSE;
#line 4061 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_tmp16_ = photo;
#line 4061 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_tmp17_ = media_source_is_trashed (MEDIA_SOURCE (_tmp16_));
#line 4061 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_tmp14_ = !_tmp17_;
#line 30776 "Photo.c"
				} else {
#line 4061 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_tmp14_ = FALSE;
#line 30780 "Photo.c"
				}
#line 4061 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp18_ = _tmp14_;
#line 4061 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				if (_tmp18_) {
#line 4062 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					result = TRUE;
#line 4062 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_g_object_unref0 (photo);
#line 4062 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					ids = (g_free (ids), NULL);
#line 4062 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					return result;
#line 30794 "Photo.c"
				}
#line 4059 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_g_object_unref0 (photo);
#line 30798 "Photo.c"
			}
		}
	}
#line 4065 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	result = FALSE;
#line 4065 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	ids = (g_free (ids), NULL);
#line 4065 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return result;
#line 30808 "Photo.c"
}


static gboolean library_photo_real_has_user_generated_metadata (Photo* base) {
	LibraryPhoto * self;
	gboolean result = FALSE;
	TagSourceCollection* _tmp0_;
	GeeList* _tmp1_ = NULL;
	GeeList* tags;
	PhotoMetadata* _tmp2_ = NULL;
	PhotoMetadata* metadata;
	PhotoMetadata* _tmp3_;
	Rating _tmp13_ = 0;
	PhotoMetadata* _tmp14_;
	Rating _tmp15_ = 0;
	PhotoMetadata* _tmp16_;
	GeeSet* _tmp17_ = NULL;
	GeeSet* keywords;
	gint _tmp18_ = 0;
	GeeList* _tmp19_;
	gint _tmp23_;
	gint tags_count;
	gint _tmp24_ = 0;
	GeeSet* _tmp25_;
	gint _tmp29_;
	gint keywords_count;
	gint _tmp30_;
	gint _tmp31_;
	gboolean _tmp32_ = FALSE;
	GeeList* _tmp33_;
	gboolean _tmp35_;
#line 4068 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	self = LIBRARY_PHOTO (base);
#line 4069 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp0_ = tag_global;
#line 4069 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp1_ = tag_source_collection_fetch_for_source (_tmp0_, MEDIA_SOURCE (self));
#line 4069 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	tags = _tmp1_;
#line 4071 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp2_ = photo_source_get_metadata (PHOTO_SOURCE (self));
#line 4071 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	metadata = _tmp2_;
#line 4072 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp3_ = metadata;
#line 4072 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp3_ == NULL) {
#line 30856 "Photo.c"
		gboolean _tmp4_ = FALSE;
		gboolean _tmp5_ = FALSE;
		GeeList* _tmp6_;
		gboolean _tmp10_;
		gboolean _tmp12_;
#line 4073 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp6_ = tags;
#line 4073 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		if (_tmp6_ != NULL) {
#line 4073 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp5_ = TRUE;
#line 30868 "Photo.c"
		} else {
			GeeList* _tmp7_;
			gint _tmp8_;
			gint _tmp9_;
#line 4073 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp7_ = tags;
#line 4073 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp8_ = gee_collection_get_size (GEE_COLLECTION (_tmp7_));
#line 4073 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp9_ = _tmp8_;
#line 4073 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp5_ = _tmp9_ > 0;
#line 30881 "Photo.c"
		}
#line 4073 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp10_ = _tmp5_;
#line 4073 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		if (_tmp10_) {
#line 4073 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp4_ = TRUE;
#line 30889 "Photo.c"
		} else {
			Rating _tmp11_ = 0;
#line 4073 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp11_ = media_source_get_rating (MEDIA_SOURCE (self));
#line 4073 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp4_ = _tmp11_ != RATING_UNRATED;
#line 30896 "Photo.c"
		}
#line 4073 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp12_ = _tmp4_;
#line 4073 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		result = _tmp12_;
#line 4073 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 4073 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_object_unref0 (tags);
#line 4073 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return result;
#line 30908 "Photo.c"
	}
#line 4075 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp13_ = media_source_get_rating (MEDIA_SOURCE (self));
#line 4075 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp14_ = metadata;
#line 4075 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp15_ = photo_metadata_get_rating (_tmp14_);
#line 4075 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp13_ != _tmp15_) {
#line 4076 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		result = TRUE;
#line 4076 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 4076 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_object_unref0 (tags);
#line 4076 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return result;
#line 30926 "Photo.c"
	}
#line 4078 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp16_ = metadata;
#line 4078 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp17_ = photo_metadata_get_keywords (_tmp16_, NULL);
#line 4078 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	keywords = _tmp17_;
#line 4079 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp19_ = tags;
#line 4079 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp19_ != NULL) {
#line 30938 "Photo.c"
		GeeList* _tmp20_;
		gint _tmp21_;
		gint _tmp22_;
#line 4079 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp20_ = tags;
#line 4079 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp21_ = gee_collection_get_size (GEE_COLLECTION (_tmp20_));
#line 4079 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp22_ = _tmp21_;
#line 4079 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp18_ = _tmp22_;
#line 30950 "Photo.c"
	} else {
#line 4079 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp18_ = 0;
#line 30954 "Photo.c"
	}
#line 4079 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp23_ = _tmp18_;
#line 4079 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	tags_count = _tmp23_;
#line 4080 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp25_ = keywords;
#line 4080 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp25_ != NULL) {
#line 30964 "Photo.c"
		GeeSet* _tmp26_;
		gint _tmp27_;
		gint _tmp28_;
#line 4080 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp26_ = keywords;
#line 4080 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp27_ = gee_collection_get_size (GEE_COLLECTION (_tmp26_));
#line 4080 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp28_ = _tmp27_;
#line 4080 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp24_ = _tmp28_;
#line 30976 "Photo.c"
	} else {
#line 4080 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp24_ = 0;
#line 30980 "Photo.c"
	}
#line 4080 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp29_ = _tmp24_;
#line 4080 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	keywords_count = _tmp29_;
#line 4082 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp30_ = tags_count;
#line 4082 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp31_ = keywords_count;
#line 4082 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp30_ != _tmp31_) {
#line 4083 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		result = TRUE;
#line 4083 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_object_unref0 (keywords);
#line 4083 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_media_metadata_unref0 (metadata);
#line 4083 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_object_unref0 (tags);
#line 4083 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		return result;
#line 31002 "Photo.c"
	}
#line 4085 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp33_ = tags;
#line 4085 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp33_ != NULL) {
#line 31008 "Photo.c"
		GeeSet* _tmp34_;
#line 4085 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp34_ = keywords;
#line 4085 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp32_ = _tmp34_ != NULL;
#line 31014 "Photo.c"
	} else {
#line 4085 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp32_ = FALSE;
#line 31018 "Photo.c"
	}
#line 4085 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp35_ = _tmp32_;
#line 4085 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp35_) {
#line 31024 "Photo.c"
		{
			GeeList* _tmp36_;
			GeeList* _tmp37_;
			GeeList* _tag_list;
			GeeList* _tmp38_;
			gint _tmp39_;
			gint _tmp40_;
			gint _tag_size;
			gint _tag_index;
#line 4086 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp36_ = tags;
#line 4086 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp37_ = _g_object_ref0 (_tmp36_);
#line 4086 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tag_list = _tmp37_;
#line 4086 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp38_ = _tag_list;
#line 4086 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp39_ = gee_collection_get_size (GEE_COLLECTION (_tmp38_));
#line 4086 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp40_ = _tmp39_;
#line 4086 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tag_size = _tmp40_;
#line 4086 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tag_index = -1;
#line 4086 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			while (TRUE) {
#line 31052 "Photo.c"
				gint _tmp41_;
				gint _tmp42_;
				gint _tmp43_;
				GeeList* _tmp44_;
				gint _tmp45_;
				gpointer _tmp46_ = NULL;
				Tag* tag;
				GeeSet* _tmp47_;
				Tag* _tmp48_;
				gchar* _tmp49_ = NULL;
				gchar* _tmp50_;
				gchar* _tmp51_ = NULL;
				gchar* _tmp52_;
				gboolean _tmp53_ = FALSE;
				gboolean _tmp54_;
#line 4086 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp41_ = _tag_index;
#line 4086 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tag_index = _tmp41_ + 1;
#line 4086 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp42_ = _tag_index;
#line 4086 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp43_ = _tag_size;
#line 4086 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				if (!(_tmp42_ < _tmp43_)) {
#line 4086 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					break;
#line 31080 "Photo.c"
				}
#line 4086 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp44_ = _tag_list;
#line 4086 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp45_ = _tag_index;
#line 4086 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp46_ = gee_list_get (_tmp44_, _tmp45_);
#line 4086 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				tag = (Tag*) _tmp46_;
#line 4087 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp47_ = keywords;
#line 4087 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp48_ = tag;
#line 4087 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp49_ = data_object_get_name (DATA_OBJECT (_tmp48_));
#line 4087 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp50_ = _tmp49_;
#line 4087 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp51_ = g_utf8_normalize (_tmp50_, (gssize) (-1), G_NORMALIZE_DEFAULT);
#line 4087 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp52_ = _tmp51_;
#line 4087 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp53_ = gee_collection_contains (GEE_COLLECTION (_tmp47_), _tmp52_);
#line 4087 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp54_ = !_tmp53_;
#line 4087 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_g_free0 (_tmp52_);
#line 4087 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_g_free0 (_tmp50_);
#line 4087 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				if (_tmp54_) {
#line 4088 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					result = TRUE;
#line 4088 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_g_object_unref0 (tag);
#line 4088 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_g_object_unref0 (_tag_list);
#line 4088 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_g_object_unref0 (keywords);
#line 4088 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_media_metadata_unref0 (metadata);
#line 4088 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					_g_object_unref0 (tags);
#line 4088 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					return result;
#line 31126 "Photo.c"
				}
#line 4086 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_g_object_unref0 (tag);
#line 31130 "Photo.c"
			}
#line 4086 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_g_object_unref0 (_tag_list);
#line 31134 "Photo.c"
		}
	}
#line 4092 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	result = FALSE;
#line 4092 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_g_object_unref0 (keywords);
#line 4092 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_media_metadata_unref0 (metadata);
#line 4092 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_g_object_unref0 (tags);
#line 4092 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	return result;
#line 31147 "Photo.c"
}


static void library_photo_real_set_user_metadata_for_export (Photo* base, PhotoMetadata* metadata) {
	LibraryPhoto * self;
	TagSourceCollection* _tmp0_;
	GeeList* _tmp1_ = NULL;
	GeeList* photo_tags;
	GeeList* _tmp2_;
	PhotoMetadata* _tmp22_;
	Rating _tmp23_ = 0;
#line 4095 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	self = LIBRARY_PHOTO (base);
#line 4095 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO_METADATA (metadata));
#line 4096 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp0_ = tag_global;
#line 4096 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp1_ = tag_source_collection_fetch_for_source (_tmp0_, MEDIA_SOURCE (self));
#line 4096 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	photo_tags = _tmp1_;
#line 4097 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp2_ = photo_tags;
#line 4097 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp2_ != NULL) {
#line 31173 "Photo.c"
		GeeArrayList* _tmp3_;
		GeeCollection* string_tags;
		PhotoMetadata* _tmp19_;
		GeeCollection* _tmp20_;
#line 4098 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp3_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, NULL);
#line 4098 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		string_tags = GEE_COLLECTION (_tmp3_);
#line 31182 "Photo.c"
		{
			GeeList* _tmp4_;
			GeeList* _tmp5_;
			GeeList* _tag_list;
			GeeList* _tmp6_;
			gint _tmp7_;
			gint _tmp8_;
			gint _tag_size;
			gint _tag_index;
#line 4099 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp4_ = photo_tags;
#line 4099 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp5_ = _g_object_ref0 (_tmp4_);
#line 4099 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tag_list = _tmp5_;
#line 4099 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp6_ = _tag_list;
#line 4099 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp7_ = gee_collection_get_size (GEE_COLLECTION (_tmp6_));
#line 4099 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp8_ = _tmp7_;
#line 4099 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tag_size = _tmp8_;
#line 4099 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tag_index = -1;
#line 4099 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			while (TRUE) {
#line 31210 "Photo.c"
				gint _tmp9_;
				gint _tmp10_;
				gint _tmp11_;
				GeeList* _tmp12_;
				gint _tmp13_;
				gpointer _tmp14_ = NULL;
				Tag* tag;
				GeeCollection* _tmp15_;
				Tag* _tmp16_;
				gchar* _tmp17_ = NULL;
				gchar* _tmp18_;
#line 4099 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp9_ = _tag_index;
#line 4099 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tag_index = _tmp9_ + 1;
#line 4099 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp10_ = _tag_index;
#line 4099 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp11_ = _tag_size;
#line 4099 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				if (!(_tmp10_ < _tmp11_)) {
#line 4099 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					break;
#line 31234 "Photo.c"
				}
#line 4099 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp12_ = _tag_list;
#line 4099 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp13_ = _tag_index;
#line 4099 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp14_ = gee_list_get (_tmp12_, _tmp13_);
#line 4099 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				tag = (Tag*) _tmp14_;
#line 4100 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp15_ = string_tags;
#line 4100 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp16_ = tag;
#line 4100 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp17_ = data_object_get_name (DATA_OBJECT (_tmp16_));
#line 4100 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp18_ = _tmp17_;
#line 4100 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				gee_collection_add (_tmp15_, _tmp18_);
#line 4100 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_g_free0 (_tmp18_);
#line 4099 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_g_object_unref0 (tag);
#line 31258 "Photo.c"
			}
#line 4099 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_g_object_unref0 (_tag_list);
#line 31262 "Photo.c"
		}
#line 4102 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp19_ = metadata;
#line 4102 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp20_ = string_tags;
#line 4102 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		photo_metadata_set_keywords (_tmp19_, _tmp20_, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 4097 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_g_object_unref0 (string_tags);
#line 31272 "Photo.c"
	} else {
		PhotoMetadata* _tmp21_;
#line 4104 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		_tmp21_ = metadata;
#line 4104 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
		photo_metadata_set_keywords (_tmp21_, NULL, PHOTO_METADATA_SET_OPTION_ALL_DOMAINS);
#line 31279 "Photo.c"
	}
#line 4106 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp22_ = metadata;
#line 4106 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp23_ = media_source_get_rating (MEDIA_SOURCE (self));
#line 4106 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	photo_metadata_set_rating (_tmp22_, _tmp23_);
#line 4095 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_g_object_unref0 (photo_tags);
#line 31289 "Photo.c"
}


static void library_photo_real_apply_user_metadata_for_reimport (Photo* base, PhotoMetadata* metadata) {
	LibraryPhoto * self;
	PhotoMetadata* _tmp0_;
	GeeSet* _tmp1_ = NULL;
	GeeCollection* keywords;
	GeeCollection* _tmp2_;
#line 4109 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	self = LIBRARY_PHOTO (base);
#line 4109 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_return_if_fail (IS_PHOTO_METADATA (metadata));
#line 4110 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp0_ = metadata;
#line 4110 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp1_ = photo_metadata_get_keywords (_tmp0_, NULL);
#line 4110 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	keywords = GEE_COLLECTION (_tmp1_);
#line 4111 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_tmp2_ = keywords;
#line 4111 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	if (_tmp2_ != NULL) {
#line 31313 "Photo.c"
		{
			GeeCollection* _tmp3_;
			GeeIterator* _tmp4_ = NULL;
			GeeIterator* _keyword_it;
#line 4112 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp3_ = keywords;
#line 4112 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_tmp4_ = gee_iterable_iterator (GEE_ITERABLE (_tmp3_));
#line 4112 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_keyword_it = _tmp4_;
#line 4112 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			while (TRUE) {
#line 31326 "Photo.c"
				GeeIterator* _tmp5_;
				gboolean _tmp6_ = FALSE;
				GeeIterator* _tmp7_;
				gpointer _tmp8_ = NULL;
				gchar* keyword;
				const gchar* _tmp9_;
				Tag* _tmp10_ = NULL;
				Tag* _tmp11_;
#line 4112 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp5_ = _keyword_it;
#line 4112 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp6_ = gee_iterator_next (_tmp5_);
#line 4112 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				if (!_tmp6_) {
#line 4112 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
					break;
#line 31343 "Photo.c"
				}
#line 4112 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp7_ = _keyword_it;
#line 4112 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp8_ = gee_iterator_get (_tmp7_);
#line 4112 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				keyword = (gchar*) _tmp8_;
#line 4113 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp9_ = keyword;
#line 4113 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp10_ = tag_for_name (_tmp9_);
#line 4113 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_tmp11_ = _tmp10_;
#line 4113 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				tag_attach (_tmp11_, MEDIA_SOURCE (self));
#line 4113 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_g_object_unref0 (_tmp11_);
#line 4112 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
				_g_free0 (keyword);
#line 31363 "Photo.c"
			}
#line 4112 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
			_g_object_unref0 (_keyword_it);
#line 31367 "Photo.c"
		}
	}
#line 4109 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_g_object_unref0 (keywords);
#line 31372 "Photo.c"
}


static void library_photo_class_init (LibraryPhotoClass * klass) {
#line 3752 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	library_photo_parent_class = g_type_class_peek_parent (klass);
#line 3752 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	g_type_class_add_private (klass, sizeof (LibraryPhotoPrivate));
#line 3752 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	PHOTO_CLASS (klass)->notify_master_reimported = library_photo_real_notify_master_reimported;
#line 3752 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	PHOTO_CLASS (klass)->notify_editable_reimported = library_photo_real_notify_editable_reimported;
#line 3752 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	PHOTO_CLASS (klass)->notify_source_reimported = library_photo_real_notify_source_reimported;
#line 3752 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	PHOTO_CLASS (klass)->notify_baseline_reimported = library_photo_real_notify_baseline_reimported;
#line 3752 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	DATA_OBJECT_CLASS (klass)->notify_altered = library_photo_real_notify_altered;
#line 3752 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	MEDIA_SOURCE_CLASS (klass)->get_preview_pixbuf = library_photo_real_get_preview_pixbuf;
#line 3752 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	PHOTO_CLASS (klass)->rotate = library_photo_real_rotate;
#line 3752 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	THUMBNAIL_SOURCE_CLASS (klass)->get_thumbnail = library_photo_real_get_thumbnail;
#line 3752 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	MEDIA_SOURCE_CLASS (klass)->is_trashed = library_photo_real_is_trashed;
#line 3752 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	MEDIA_SOURCE_CLASS (klass)->trash = library_photo_real_trash;
#line 3752 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	MEDIA_SOURCE_CLASS (klass)->untrash = library_photo_real_untrash;
#line 3752 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	MEDIA_SOURCE_CLASS (klass)->is_offline = library_photo_real_is_offline;
#line 3752 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	MEDIA_SOURCE_CLASS (klass)->mark_offline = library_photo_real_mark_offline;
#line 3752 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	MEDIA_SOURCE_CLASS (klass)->mark_online = library_photo_real_mark_online;
#line 3752 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	DATA_SOURCE_CLASS (klass)->internal_delete_backing = library_photo_real_internal_delete_backing;
#line 3752 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	DATA_SOURCE_CLASS (klass)->destroy = library_photo_real_destroy;
#line 3752 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	PHOTO_CLASS (klass)->has_user_generated_metadata = library_photo_real_has_user_generated_metadata;
#line 3752 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	PHOTO_CLASS (klass)->set_user_metadata_for_export = library_photo_real_set_user_metadata_for_export;
#line 3752 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	PHOTO_CLASS (klass)->apply_user_metadata_for_reimport = library_photo_real_apply_user_metadata_for_reimport;
#line 3752 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	G_OBJECT_CLASS (klass)->finalize = library_photo_finalize;
#line 31421 "Photo.c"
}


static void library_photo_flaggable_interface_init (FlaggableIface * iface) {
#line 3752 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	library_photo_flaggable_parent_iface = g_type_interface_peek_parent (iface);
#line 3752 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	iface->is_flagged = (gboolean (*)(Flaggable*)) library_photo_real_is_flagged;
#line 3752 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	iface->mark_flagged = (void (*)(Flaggable*)) library_photo_real_mark_flagged;
#line 3752 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	iface->mark_unflagged = (void (*)(Flaggable*)) library_photo_real_mark_unflagged;
#line 31434 "Photo.c"
}


static void library_photo_monitorable_interface_init (MonitorableIface * iface) {
#line 3752 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	library_photo_monitorable_parent_iface = g_type_interface_peek_parent (iface);
#line 3752 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	iface->is_offline = (gboolean (*)(Monitorable*)) library_photo_real_is_offline;
#line 3752 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	iface->mark_offline = (void (*)(Monitorable*)) library_photo_real_mark_offline;
#line 3752 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	iface->mark_online = (void (*)(Monitorable*)) library_photo_real_mark_online;
#line 3752 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	iface->set_master_file = (void (*)(Monitorable*, GFile*)) photo_set_master_file;
#line 3752 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	iface->set_master_timestamp = (void (*)(Monitorable*, GFileInfo*)) photo_set_master_timestamp;
#line 31451 "Photo.c"
}


static void library_photo_instance_init (LibraryPhoto * self) {
#line 3752 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	self->priv = LIBRARY_PHOTO_GET_PRIVATE (self);
#line 3764 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	self->priv->block_thumbnail_generation = FALSE;
#line 3765 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	self->priv->thumbnail_scheduler = NULL;
#line 31462 "Photo.c"
}


static void library_photo_finalize (GObject* obj) {
	LibraryPhoto * self;
#line 3752 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	self = LIBRARY_PHOTO (obj);
#line 3765 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_one_shot_scheduler_unref0 (self->priv->thumbnail_scheduler);
#line 3766 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	_g_object_unref0 (self->priv->import_keywords);
#line 3752 "/builddir/build/BUILD/shotwell-0.10.1/src/Photo.vala"
	G_OBJECT_CLASS (library_photo_parent_class)->finalize (obj);
#line 31476 "Photo.c"
}


GType library_photo_get_type (void) {
	static volatile gsize library_photo_type_id__volatile = 0;
	if (g_once_init_enter (&library_photo_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (LibraryPhotoClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) library_photo_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (LibraryPhoto), 0, (GInstanceInitFunc) library_photo_instance_init, NULL };
		static const GInterfaceInfo flaggable_info = { (GInterfaceInitFunc) library_photo_flaggable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		static const GInterfaceInfo monitorable_info = { (GInterfaceInitFunc) library_photo_monitorable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		GType library_photo_type_id;
		library_photo_type_id = g_type_register_static (TYPE_PHOTO, "LibraryPhoto", &g_define_type_info, 0);
		g_type_add_interface_static (library_photo_type_id, TYPE_FLAGGABLE, &flaggable_info);
		g_type_add_interface_static (library_photo_type_id, TYPE_MONITORABLE, &monitorable_info);
		g_once_init_leave (&library_photo_type_id__volatile, library_photo_type_id);
	}
	return library_photo_type_id__volatile;
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}



