/* PhotoMetadata.c generated by valac 0.14.2, the Vala compiler
 * generated from PhotoMetadata.vala, do not modify */

/* Copyright 2010-2011 Yorba Foundation
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution. 
 */
/**/
/* PhotoMetadata*/
/**/
/* PhotoMetadata is a wrapper class around gexiv2.  The reasoning for this is (a) to facilitiate*/
/* interface changes to meet Shotwell's requirements without needing modifications of the library*/
/* itself, and (b) some requirements for this class (i.e. obtaining raw metadata) is not available*/
/* in gexiv2, and so must be done by hand.*/
/**/
/* Although it's perceived that Exiv2 will remain Shotwell's metadata library of choice, this*/
/* may change in the future, and so this wrapper helps with that as well.*/
/**/
/* There is no expectation of thread-safety in this class (yet).*/
/**/
/* Tags come from Exiv2's naming scheme:*/
/* http://www.exiv2.org/metadata.html*/
/**/

#include <glib.h>
#include <glib-object.h>
#include <gdk-pixbuf/gdk-pixdata.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <gexiv2/gexiv2.h>
#include <libexif/exif-data.h>
#include <gee.h>
#include <libexif/exif-mem.h>
#include <float.h>
#include <math.h>
#include <gobject/gvaluecollector.h>


#define TYPE_METADATA_DOMAIN (metadata_domain_get_type ())

#define TYPE_PHOTO_PREVIEW (photo_preview_get_type ())
#define PHOTO_PREVIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_PREVIEW, PhotoPreview))
#define PHOTO_PREVIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_PREVIEW, PhotoPreviewClass))
#define IS_PHOTO_PREVIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_PREVIEW))
#define IS_PHOTO_PREVIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_PREVIEW))
#define PHOTO_PREVIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_PREVIEW, PhotoPreviewClass))

typedef struct _PhotoPreview PhotoPreview;
typedef struct _PhotoPreviewClass PhotoPreviewClass;
typedef struct _PhotoPreviewPrivate PhotoPreviewPrivate;

#define TYPE_DIMENSIONS (dimensions_get_type ())
typedef struct _Dimensions Dimensions;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _ParamSpecPhotoPreview ParamSpecPhotoPreview;

#define TYPE_MEDIA_METADATA (media_metadata_get_type ())
#define MEDIA_METADATA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_METADATA, MediaMetadata))
#define MEDIA_METADATA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_METADATA, MediaMetadataClass))
#define IS_MEDIA_METADATA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_METADATA))
#define IS_MEDIA_METADATA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_METADATA))
#define MEDIA_METADATA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_METADATA, MediaMetadataClass))

typedef struct _MediaMetadata MediaMetadata;
typedef struct _MediaMetadataClass MediaMetadataClass;
typedef struct _MediaMetadataPrivate MediaMetadataPrivate;

#define TYPE_METADATA_DATE_TIME (metadata_date_time_get_type ())
#define METADATA_DATE_TIME(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_METADATA_DATE_TIME, MetadataDateTime))
#define METADATA_DATE_TIME_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_METADATA_DATE_TIME, MetadataDateTimeClass))
#define IS_METADATA_DATE_TIME(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_METADATA_DATE_TIME))
#define IS_METADATA_DATE_TIME_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_METADATA_DATE_TIME))
#define METADATA_DATE_TIME_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_METADATA_DATE_TIME, MetadataDateTimeClass))

typedef struct _MetadataDateTime MetadataDateTime;
typedef struct _MetadataDateTimeClass MetadataDateTimeClass;

#define TYPE_PHOTO_METADATA (photo_metadata_get_type ())
#define PHOTO_METADATA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_METADATA, PhotoMetadata))
#define PHOTO_METADATA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_METADATA, PhotoMetadataClass))
#define IS_PHOTO_METADATA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_METADATA))
#define IS_PHOTO_METADATA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_METADATA))
#define PHOTO_METADATA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_METADATA, PhotoMetadataClass))

typedef struct _PhotoMetadata PhotoMetadata;
typedef struct _PhotoMetadataClass PhotoMetadataClass;
typedef struct _PhotoMetadataPrivate PhotoMetadataPrivate;

#define PHOTO_METADATA_TYPE_SET_OPTION (photo_metadata_set_option_get_type ())
#define _gexiv2_metadata_free0(var) ((var == NULL) ? NULL : (var = (gexiv2_metadata_free (var), NULL)))
#define _exif_data_unref0(var) ((var == NULL) ? NULL : (var = (exif_data_unref (var), NULL)))

#define TYPE_PREPARE_INPUT_TEXT_OPTIONS (prepare_input_text_options_get_type ())
typedef struct _Block1Data Block1Data;
#define _media_metadata_unref0(var) ((var == NULL) ? NULL : (var = (media_metadata_unref (var), NULL)))
typedef struct _Block2Data Block2Data;
typedef struct _Block3Data Block3Data;

#define TYPE_METADATA_RATIONAL (metadata_rational_get_type ())
typedef struct _MetadataRational MetadataRational;
typedef struct _Block4Data Block4Data;
#define _metadata_date_time_unref0(var) ((var == NULL) ? NULL : (var = (metadata_date_time_unref (var), NULL)))
typedef struct _Block5Data Block5Data;
#define _exif_mem_unref0(var) ((var == NULL) ? NULL : (var = (exif_mem_unref (var), NULL)))

#define PHOTO_METADATA_TYPE_INTERNAL_PHOTO_PREVIEW (photo_metadata_internal_photo_preview_get_type ())
#define PHOTO_METADATA_INTERNAL_PHOTO_PREVIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PHOTO_METADATA_TYPE_INTERNAL_PHOTO_PREVIEW, PhotoMetadataInternalPhotoPreview))
#define PHOTO_METADATA_INTERNAL_PHOTO_PREVIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PHOTO_METADATA_TYPE_INTERNAL_PHOTO_PREVIEW, PhotoMetadataInternalPhotoPreviewClass))
#define PHOTO_METADATA_IS_INTERNAL_PHOTO_PREVIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PHOTO_METADATA_TYPE_INTERNAL_PHOTO_PREVIEW))
#define PHOTO_METADATA_IS_INTERNAL_PHOTO_PREVIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PHOTO_METADATA_TYPE_INTERNAL_PHOTO_PREVIEW))
#define PHOTO_METADATA_INTERNAL_PHOTO_PREVIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PHOTO_METADATA_TYPE_INTERNAL_PHOTO_PREVIEW, PhotoMetadataInternalPhotoPreviewClass))

typedef struct _PhotoMetadataInternalPhotoPreview PhotoMetadataInternalPhotoPreview;
typedef struct _PhotoMetadataInternalPhotoPreviewClass PhotoMetadataInternalPhotoPreviewClass;

#define TYPE_ORIENTATION (orientation_get_type ())

#define TYPE_RATING (rating_get_type ())
typedef struct _PhotoMetadataInternalPhotoPreviewPrivate PhotoMetadataInternalPhotoPreviewPrivate;
#define _gexiv2_preview_image_free0(var) ((var == NULL) ? NULL : (var = (gexiv2_preview_image_free (var), NULL)))

typedef enum  {
	METADATA_DOMAIN_UNKNOWN,
	METADATA_DOMAIN_EXIF,
	METADATA_DOMAIN_XMP,
	METADATA_DOMAIN_IPTC
} MetadataDomain;

struct _PhotoPreview {
	GTypeInstance parent_instance;
	volatile int ref_count;
	PhotoPreviewPrivate * priv;
};

struct _PhotoPreviewClass {
	GTypeClass parent_class;
	void (*finalize) (PhotoPreview *self);
	guint8* (*flatten) (PhotoPreview* self, int* result_length1, GError** error);
	GdkPixbuf* (*get_pixbuf) (PhotoPreview* self, GError** error);
};

struct _Dimensions {
	gint width;
	gint height;
};

struct _PhotoPreviewPrivate {
	gchar* name;
	Dimensions dimensions;
	guint32 size;
	gchar* mime_type;
	gchar* extension;
};

struct _ParamSpecPhotoPreview {
	GParamSpec parent_instance;
};

struct _MediaMetadata {
	GTypeInstance parent_instance;
	volatile int ref_count;
	MediaMetadataPrivate * priv;
};

struct _MediaMetadataClass {
	GTypeClass parent_class;
	void (*finalize) (MediaMetadata *self);
	void (*read_from_file) (MediaMetadata* self, GFile* file, GError** error);
	MetadataDateTime* (*get_creation_date_time) (MediaMetadata* self);
	gchar* (*get_title) (MediaMetadata* self);
};

struct _PhotoMetadata {
	MediaMetadata parent_instance;
	PhotoMetadataPrivate * priv;
};

struct _PhotoMetadataClass {
	MediaMetadataClass parent_class;
};

struct _PhotoMetadataPrivate {
	GExiv2Metadata* exiv2;
	ExifData* exif;
	gchar* source_name;
};

typedef enum  {
	PHOTO_METADATA_SET_OPTION_ALL_DOMAINS,
	PHOTO_METADATA_SET_OPTION_ONLY_IF_DOMAIN_PRESENT,
	PHOTO_METADATA_SET_OPTION_AT_LEAST_DEFAULT_DOMAIN
} PhotoMetadataSetOption;

typedef enum  {
	PREPARE_INPUT_TEXT_OPTIONS_EMPTY_IS_NULL = 1 << 0,
	PREPARE_INPUT_TEXT_OPTIONS_VALIDATE = 1 << 1,
	PREPARE_INPUT_TEXT_OPTIONS_INVALID_IS_NULL = 1 << 2,
	PREPARE_INPUT_TEXT_OPTIONS_STRIP = 1 << 3,
	PREPARE_INPUT_TEXT_OPTIONS_STRIP_CRLF = 1 << 4,
	PREPARE_INPUT_TEXT_OPTIONS_NORMALIZE = 1 << 5,
	PREPARE_INPUT_TEXT_OPTIONS_DEFAULT = ((((PREPARE_INPUT_TEXT_OPTIONS_EMPTY_IS_NULL | PREPARE_INPUT_TEXT_OPTIONS_VALIDATE) | PREPARE_INPUT_TEXT_OPTIONS_INVALID_IS_NULL) | PREPARE_INPUT_TEXT_OPTIONS_STRIP_CRLF) | PREPARE_INPUT_TEXT_OPTIONS_STRIP) | PREPARE_INPUT_TEXT_OPTIONS_NORMALIZE
} PrepareInputTextOptions;

typedef void (*PhotoMetadataSetGenericValue) (const gchar* tag, void* user_data);
struct _Block1Data {
	int _ref_count_;
	PhotoMetadata * self;
	gchar* value;
};

struct _Block2Data {
	int _ref_count_;
	PhotoMetadata * self;
	GeeCollection* values;
};

struct _Block3Data {
	int _ref_count_;
	PhotoMetadata * self;
	glong value;
};

struct _MetadataRational {
	gint numerator;
	gint denominator;
};

struct _Block4Data {
	int _ref_count_;
	PhotoMetadata * self;
	MetadataRational rational;
};

typedef enum  {
	METADATA_DATE_TIME_ERROR_INVALID_FORMAT,
	METADATA_DATE_TIME_ERROR_UNSUPPORTED_FORMAT
} MetadataDateTimeError;
#define METADATA_DATE_TIME_ERROR metadata_date_time_error_quark ()
struct _Block5Data {
	int _ref_count_;
	PhotoMetadata * self;
	MetadataDateTime* date_time;
};

typedef enum  {
	ORIENTATION_MIN = 1,
	ORIENTATION_TOP_LEFT = 1,
	ORIENTATION_TOP_RIGHT = 2,
	ORIENTATION_BOTTOM_RIGHT = 3,
	ORIENTATION_BOTTOM_LEFT = 4,
	ORIENTATION_LEFT_TOP = 5,
	ORIENTATION_RIGHT_TOP = 6,
	ORIENTATION_RIGHT_BOTTOM = 7,
	ORIENTATION_LEFT_BOTTOM = 8,
	ORIENTATION_MAX = 8
} Orientation;

typedef enum  {
	RATING_REJECTED = -1,
	RATING_UNRATED = 0,
	RATING_ONE = 1,
	RATING_TWO = 2,
	RATING_THREE = 3,
	RATING_FOUR = 4,
	RATING_FIVE = 5
} Rating;

struct _PhotoMetadataInternalPhotoPreview {
	PhotoPreview parent_instance;
	PhotoMetadataInternalPhotoPreviewPrivate * priv;
	PhotoMetadata* owner;
	guint number;
};

struct _PhotoMetadataInternalPhotoPreviewClass {
	PhotoPreviewClass parent_class;
};


static gpointer photo_preview_parent_class = NULL;
static gpointer photo_metadata_parent_class = NULL;
static gchar** photo_metadata_DATE_TIME_TAGS;
static gint photo_metadata_DATE_TIME_TAGS_length1;
static gchar** photo_metadata_DATE_TIME_TAGS = NULL;
static gint photo_metadata_DATE_TIME_TAGS_length1 = 0;
static gint _photo_metadata_DATE_TIME_TAGS_size_ = 0;
static gchar** photo_metadata_EXPOSURE_DATE_TIME_TAGS;
static gint photo_metadata_EXPOSURE_DATE_TIME_TAGS_length1;
static gchar** photo_metadata_EXPOSURE_DATE_TIME_TAGS = NULL;
static gint photo_metadata_EXPOSURE_DATE_TIME_TAGS_length1 = 0;
static gint _photo_metadata_EXPOSURE_DATE_TIME_TAGS_size_ = 0;
static gchar** photo_metadata_DIGITIZED_DATE_TIME_TAGS;
static gint photo_metadata_DIGITIZED_DATE_TIME_TAGS_length1;
static gchar** photo_metadata_DIGITIZED_DATE_TIME_TAGS = NULL;
static gint photo_metadata_DIGITIZED_DATE_TIME_TAGS_length1 = 0;
static gint _photo_metadata_DIGITIZED_DATE_TIME_TAGS_size_ = 0;
static gchar** photo_metadata_WIDTH_TAGS;
static gint photo_metadata_WIDTH_TAGS_length1;
static gchar** photo_metadata_WIDTH_TAGS = NULL;
static gint photo_metadata_WIDTH_TAGS_length1 = 0;
static gint _photo_metadata_WIDTH_TAGS_size_ = 0;
extern gchar** photo_metadata_HEIGHT_TAGS;
extern gint photo_metadata_HEIGHT_TAGS_length1;
gchar** photo_metadata_HEIGHT_TAGS = NULL;
gint photo_metadata_HEIGHT_TAGS_length1 = 0;
static gchar** photo_metadata_STANDARD_TITLE_TAGS;
static gint photo_metadata_STANDARD_TITLE_TAGS_length1;
static gchar** photo_metadata_STANDARD_TITLE_TAGS = NULL;
static gint photo_metadata_STANDARD_TITLE_TAGS_length1 = 0;
static gint _photo_metadata_STANDARD_TITLE_TAGS_size_ = 0;
static gchar** photo_metadata_KEYWORD_TAGS;
static gint photo_metadata_KEYWORD_TAGS_length1;
static gchar** photo_metadata_KEYWORD_TAGS = NULL;
static gint photo_metadata_KEYWORD_TAGS_length1 = 0;
static gint _photo_metadata_KEYWORD_TAGS_size_ = 0;
static gchar** photo_metadata_ARTIST_TAGS;
static gint photo_metadata_ARTIST_TAGS_length1;
static gchar** photo_metadata_ARTIST_TAGS = NULL;
static gint photo_metadata_ARTIST_TAGS_length1 = 0;
static gint _photo_metadata_ARTIST_TAGS_size_ = 0;
static gchar** photo_metadata_RATING_TAGS;
static gint photo_metadata_RATING_TAGS_length1;
static gchar** photo_metadata_RATING_TAGS = NULL;
static gint photo_metadata_RATING_TAGS_length1 = 0;
static gint _photo_metadata_RATING_TAGS_size_ = 0;
static gpointer photo_metadata_internal_photo_preview_parent_class = NULL;

GType metadata_domain_get_type (void) G_GNUC_CONST;
gpointer photo_preview_ref (gpointer instance);
void photo_preview_unref (gpointer instance);
GParamSpec* param_spec_photo_preview (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_photo_preview (GValue* value, gpointer v_object);
void value_take_photo_preview (GValue* value, gpointer v_object);
gpointer value_get_photo_preview (const GValue* value);
GType photo_preview_get_type (void) G_GNUC_CONST;
GType dimensions_get_type (void) G_GNUC_CONST;
Dimensions* dimensions_dup (const Dimensions* self);
void dimensions_free (Dimensions* self);
#define PHOTO_PREVIEW_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_PHOTO_PREVIEW, PhotoPreviewPrivate))
enum  {
	PHOTO_PREVIEW_DUMMY_PROPERTY
};
PhotoPreview* photo_preview_construct (GType object_type, const gchar* name, Dimensions* dimensions, guint32 size, const gchar* mime_type, const gchar* extension);
gchar* photo_preview_get_name (PhotoPreview* self);
void photo_preview_get_pixel_dimensions (PhotoPreview* self, Dimensions* result);
guint32 photo_preview_get_size (PhotoPreview* self);
gchar* photo_preview_get_mime_type (PhotoPreview* self);
gchar* photo_preview_get_extension (PhotoPreview* self);
guint8* photo_preview_flatten (PhotoPreview* self, int* result_length1, GError** error);
static guint8* photo_preview_real_flatten (PhotoPreview* self, int* result_length1, GError** error);
GdkPixbuf* photo_preview_get_pixbuf (PhotoPreview* self, GError** error);
static GdkPixbuf* photo_preview_real_get_pixbuf (PhotoPreview* self, GError** error);
static guint8* _vala_array_dup7 (guint8* self, int length);
static void photo_preview_finalize (PhotoPreview* obj);
gpointer media_metadata_ref (gpointer instance);
void media_metadata_unref (gpointer instance);
GParamSpec* param_spec_media_metadata (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_media_metadata (GValue* value, gpointer v_object);
void value_take_media_metadata (GValue* value, gpointer v_object);
gpointer value_get_media_metadata (const GValue* value);
GType media_metadata_get_type (void) G_GNUC_CONST;
gpointer metadata_date_time_ref (gpointer instance);
void metadata_date_time_unref (gpointer instance);
GParamSpec* param_spec_metadata_date_time (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_metadata_date_time (GValue* value, gpointer v_object);
void value_take_metadata_date_time (GValue* value, gpointer v_object);
gpointer value_get_metadata_date_time (const GValue* value);
GType metadata_date_time_get_type (void) G_GNUC_CONST;
GType photo_metadata_get_type (void) G_GNUC_CONST;
#define PHOTO_METADATA_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_PHOTO_METADATA, PhotoMetadataPrivate))
enum  {
	PHOTO_METADATA_DUMMY_PROPERTY
};
GType photo_metadata_set_option_get_type (void) G_GNUC_CONST;
GType prepare_input_text_options_get_type (void) G_GNUC_CONST;
#define PHOTO_METADATA_PREPARE_STRING_OPTIONS (((((PREPARE_INPUT_TEXT_OPTIONS_INVALID_IS_NULL | PREPARE_INPUT_TEXT_OPTIONS_EMPTY_IS_NULL) | PREPARE_INPUT_TEXT_OPTIONS_STRIP) | PREPARE_INPUT_TEXT_OPTIONS_STRIP_CRLF) | PREPARE_INPUT_TEXT_OPTIONS_NORMALIZE) | PREPARE_INPUT_TEXT_OPTIONS_VALIDATE)
#define PHOTO_METADATA_IPHOTO_TITLE_TAG "Iptc.Application2.ObjectName"
PhotoMetadata* photo_metadata_new (void);
PhotoMetadata* photo_metadata_construct (GType object_type);
MediaMetadata* media_metadata_construct (GType object_type);
static void photo_metadata_real_read_from_file (MediaMetadata* base, GFile* file, GError** error);
void photo_metadata_write_to_file (PhotoMetadata* self, GFile* file, GError** error);
void photo_metadata_read_from_buffer (PhotoMetadata* self, guint8* buffer, int buffer_length1, gint length, GError** error);
void photo_metadata_read_from_app1_segment (PhotoMetadata* self, guint8* buffer, int buffer_length1, gint length, GError** error);
MetadataDomain photo_metadata_get_tag_domain (const gchar* tag);
gboolean photo_metadata_has_domain (PhotoMetadata* self, MetadataDomain domain);
gboolean photo_metadata_has_exif (PhotoMetadata* self);
gboolean photo_metadata_has_xmp (PhotoMetadata* self);
gboolean photo_metadata_has_iptc (PhotoMetadata* self);
gboolean photo_metadata_can_write_to_domain (PhotoMetadata* self, MetadataDomain domain);
gboolean photo_metadata_can_write_exif (PhotoMetadata* self);
gboolean photo_metadata_can_write_xmp (PhotoMetadata* self);
gboolean photo_metadata_can_write_iptc (PhotoMetadata* self);
gboolean photo_metadata_has_tag (PhotoMetadata* self, const gchar* tag);
static GeeSet* photo_metadata_create_string_set (PhotoMetadata* self, GCompareFunc compare_func);
GeeCollection* photo_metadata_get_tags (PhotoMetadata* self, MetadataDomain domain, GCompareFunc compare_func);
GeeCollection* photo_metadata_get_all_tags (PhotoMetadata* self, GCompareFunc compare_func);
gchar* photo_metadata_get_tag_label (PhotoMetadata* self, const gchar* tag);
gchar* photo_metadata_get_tag_description (PhotoMetadata* self, const gchar* tag);
gchar* photo_metadata_get_string (PhotoMetadata* self, const gchar* tag);
gchar* prepare_input_text (const gchar* text, PrepareInputTextOptions options, gint dest_length);
#define DEFAULT_USER_TEXT_INPUT_LENGTH 1024
gchar* photo_metadata_get_string_interpreted (PhotoMetadata* self, const gchar* tag);
gchar* photo_metadata_get_first_string (PhotoMetadata* self, gchar** tags, int tags_length1);
gchar* photo_metadata_get_first_string_interpreted (PhotoMetadata* self, gchar** tags, int tags_length1);
GeeList* photo_metadata_get_string_multiple (PhotoMetadata* self, const gchar* tag);
GeeList* photo_metadata_get_first_string_multiple (PhotoMetadata* self, gchar** tags, int tags_length1);
void photo_metadata_set_string (PhotoMetadata* self, const gchar* tag, const gchar* value);
static void photo_metadata_set_all_generic (PhotoMetadata* self, gchar** tags, int tags_length1, PhotoMetadataSetOption option, PhotoMetadataSetGenericValue setter, void* setter_target);
void photo_metadata_set_all_string (PhotoMetadata* self, gchar** tags, int tags_length1, const gchar* value, PhotoMetadataSetOption option);
static Block1Data* block1_data_ref (Block1Data* _data1_);
static void block1_data_unref (Block1Data* _data1_);
static void __lambda1_ (Block1Data* _data1_, const gchar* tag);
static void ___lambda1__photo_metadata_set_generic_value (const gchar* tag, gpointer self);
void photo_metadata_set_string_multiple (PhotoMetadata* self, const gchar* tag, GeeCollection* collection);
static void _vala_array_add13 (gchar*** array, int* length, int* size, gchar* value);
static void _vala_array_add14 (gchar*** array, int* length, int* size, gchar* value);
void photo_metadata_set_all_string_multiple (PhotoMetadata* self, gchar** tags, int tags_length1, GeeCollection* values, PhotoMetadataSetOption option);
static Block2Data* block2_data_ref (Block2Data* _data2_);
static void block2_data_unref (Block2Data* _data2_);
static void __lambda2_ (Block2Data* _data2_, const gchar* tag);
static void ___lambda2__photo_metadata_set_generic_value (const gchar* tag, gpointer self);
gboolean photo_metadata_get_long (PhotoMetadata* self, const gchar* tag, glong* value);
gboolean photo_metadata_get_first_long (PhotoMetadata* self, gchar** tags, int tags_length1, glong* value);
void photo_metadata_set_long (PhotoMetadata* self, const gchar* tag, glong value);
void photo_metadata_set_all_long (PhotoMetadata* self, gchar** tags, int tags_length1, glong value, PhotoMetadataSetOption option);
static Block3Data* block3_data_ref (Block3Data* _data3_);
static void block3_data_unref (Block3Data* _data3_);
static void __lambda3_ (Block3Data* _data3_, const gchar* tag);
static void ___lambda3__photo_metadata_set_generic_value (const gchar* tag, gpointer self);
GType metadata_rational_get_type (void) G_GNUC_CONST;
MetadataRational* metadata_rational_dup (const MetadataRational* self);
void metadata_rational_free (MetadataRational* self);
gboolean photo_metadata_get_rational (PhotoMetadata* self, const gchar* tag, MetadataRational* rational);
gboolean photo_metadata_get_first_rational (PhotoMetadata* self, gchar** tags, int tags_length1, MetadataRational* rational);
void photo_metadata_set_rational (PhotoMetadata* self, const gchar* tag, MetadataRational* rational);
gchar* metadata_rational_to_string (MetadataRational *self);
void photo_metadata_set_all_rational (PhotoMetadata* self, gchar** tags, int tags_length1, MetadataRational* rational, PhotoMetadataSetOption option);
static Block4Data* block4_data_ref (Block4Data* _data4_);
static void block4_data_unref (Block4Data* _data4_);
static void __lambda4_ (Block4Data* _data4_, const gchar* tag);
static void ___lambda4__photo_metadata_set_generic_value (const gchar* tag, gpointer self);
MetadataDateTime* photo_metadata_get_date_time (PhotoMetadata* self, const gchar* tag);
GQuark metadata_date_time_error_quark (void);
MetadataDateTime* metadata_date_time_new_from_xmp (const gchar* label, GError** error);
MetadataDateTime* metadata_date_time_construct_from_xmp (GType object_type, const gchar* label, GError** error);
MetadataDateTime* metadata_date_time_new_from_exif (const gchar* label, GError** error);
MetadataDateTime* metadata_date_time_construct_from_exif (GType object_type, const gchar* label, GError** error);
MetadataDateTime* photo_metadata_get_first_date_time (PhotoMetadata* self, gchar** tags, int tags_length1);
void photo_metadata_set_date_time (PhotoMetadata* self, const gchar* tag, MetadataDateTime* date_time);
gchar* metadata_date_time_get_exif_label (MetadataDateTime* self);
gchar* metadata_date_time_get_xmp_label (MetadataDateTime* self);
const gchar* metadata_domain_to_string (MetadataDomain self);
void photo_metadata_set_all_date_time (PhotoMetadata* self, gchar** tags, int tags_length1, MetadataDateTime* date_time, PhotoMetadataSetOption option);
static Block5Data* block5_data_ref (Block5Data* _data5_);
static void block5_data_unref (Block5Data* _data5_);
static void __lambda5_ (Block5Data* _data5_, const gchar* tag);
static void ___lambda5__photo_metadata_set_generic_value (const gchar* tag, gpointer self);
guint8* photo_metadata_flatten_exif (PhotoMetadata* self, gboolean include_preview, int* result_length1);
guint8* photo_metadata_flatten_exif_preview (PhotoMetadata* self, int* result_length1);
static guint8* _vala_array_dup8 (guint8* self, int length);
guint photo_metadata_get_preview_count (PhotoMetadata* self);
PhotoPreview* photo_metadata_get_preview (PhotoMetadata* self, guint number);
static PhotoMetadataInternalPhotoPreview* photo_metadata_internal_photo_preview_new (PhotoMetadata* owner, const gchar* name, guint number, GExiv2PreviewProperties* props);
static PhotoMetadataInternalPhotoPreview* photo_metadata_internal_photo_preview_construct (GType object_type, PhotoMetadata* owner, const gchar* name, guint number, GExiv2PreviewProperties* props);
static GType photo_metadata_internal_photo_preview_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
void photo_metadata_remove_exif_thumbnail (PhotoMetadata* self);
void photo_metadata_remove_tag (PhotoMetadata* self, const gchar* tag);
void photo_metadata_remove_tags (PhotoMetadata* self, gchar** tags, int tags_length1);
void photo_metadata_clear_domain (PhotoMetadata* self, MetadataDomain domain);
void photo_metadata_clear (PhotoMetadata* self);
MetadataDateTime* photo_metadata_get_modification_date_time (PhotoMetadata* self);
void photo_metadata_set_modification_date_time (PhotoMetadata* self, MetadataDateTime* date_time, PhotoMetadataSetOption option);
MetadataDateTime* photo_metadata_get_exposure_date_time (PhotoMetadata* self);
void photo_metadata_set_exposure_date_time (PhotoMetadata* self, MetadataDateTime* date_time, PhotoMetadataSetOption option);
MetadataDateTime* photo_metadata_get_digitized_date_time (PhotoMetadata* self);
void photo_metadata_set_digitized_date_time (PhotoMetadata* self, MetadataDateTime* date_time, PhotoMetadataSetOption option);
static MetadataDateTime* photo_metadata_real_get_creation_date_time (MediaMetadata* base);
Dimensions* photo_metadata_get_pixel_dimensions (PhotoMetadata* self);
void dimensions_init (Dimensions *self, gint width, gint height);
void photo_metadata_set_pixel_dimensions (PhotoMetadata* self, Dimensions* dim, PhotoMetadataSetOption option);
static gchar* photo_metadata_real_get_title (MediaMetadata* base);
gboolean is_string_empty (const gchar* s);
void photo_metadata_set_title (PhotoMetadata* self, const gchar* title, PhotoMetadataSetOption option);
GeeSet* photo_metadata_get_keywords (PhotoMetadata* self, GCompareFunc compare_func);
void photo_metadata_set_keywords (PhotoMetadata* self, GeeCollection* keywords, PhotoMetadataSetOption option);
gboolean photo_metadata_has_orientation (PhotoMetadata* self);
GType orientation_get_type (void) G_GNUC_CONST;
Orientation photo_metadata_get_orientation (PhotoMetadata* self);
void photo_metadata_set_orientation (PhotoMetadata* self, Orientation orientation);
gboolean photo_metadata_get_gps (PhotoMetadata* self, gdouble* longitude, gchar** long_ref, gdouble* latitude, gchar** lat_ref, gdouble* altitude);
gboolean photo_metadata_get_exposure (PhotoMetadata* self, MetadataRational* exposure);
gchar* photo_metadata_get_exposure_string (PhotoMetadata* self);
gboolean metadata_rational_is_valid (MetadataRational *self);
gboolean photo_metadata_get_iso (PhotoMetadata* self, glong* iso);
gchar* photo_metadata_get_iso_string (PhotoMetadata* self);
gboolean photo_metadata_get_aperture (PhotoMetadata* self, MetadataRational* aperture);
gchar* photo_metadata_get_aperture_string (PhotoMetadata* self, gboolean pango_formatted);
gchar* photo_metadata_get_camera_make (PhotoMetadata* self);
gchar* photo_metadata_get_camera_model (PhotoMetadata* self);
gboolean photo_metadata_get_flash (PhotoMetadata* self, glong* flash);
gchar* photo_metadata_get_flash_string (PhotoMetadata* self);
gboolean photo_metadata_get_focal_length (PhotoMetadata* self, MetadataRational* focal_length);
gchar* photo_metadata_get_focal_length_string (PhotoMetadata* self);
gchar* photo_metadata_get_artist (PhotoMetadata* self);
gchar* photo_metadata_get_copyright (PhotoMetadata* self);
gchar* photo_metadata_get_software (PhotoMetadata* self);
void photo_metadata_set_software (PhotoMetadata* self, const gchar* software, const gchar* version);
void photo_metadata_remove_software (PhotoMetadata* self);
gchar* photo_metadata_get_exposure_bias (PhotoMetadata* self);
GType rating_get_type (void) G_GNUC_CONST;
Rating photo_metadata_get_rating (PhotoMetadata* self);
Rating rating_unserialize (gint value);
void photo_metadata_set_rating (PhotoMetadata* self, Rating rating);
gint rating_serialize (Rating self);
enum  {
	PHOTO_METADATA_INTERNAL_PHOTO_PREVIEW_DUMMY_PROPERTY
};
static guint8* photo_metadata_internal_photo_preview_real_flatten (PhotoPreview* base, int* result_length1, GError** error);
static guint8* _vala_array_dup9 (guint8* self, int length);
static void photo_metadata_internal_photo_preview_finalize (PhotoPreview* obj);
static void photo_metadata_finalize (MediaMetadata* obj);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);


GType metadata_domain_get_type (void) {
	static volatile gsize metadata_domain_type_id__volatile = 0;
	if (g_once_init_enter (&metadata_domain_type_id__volatile)) {
		static const GEnumValue values[] = {{METADATA_DOMAIN_UNKNOWN, "METADATA_DOMAIN_UNKNOWN", "unknown"}, {METADATA_DOMAIN_EXIF, "METADATA_DOMAIN_EXIF", "exif"}, {METADATA_DOMAIN_XMP, "METADATA_DOMAIN_XMP", "xmp"}, {METADATA_DOMAIN_IPTC, "METADATA_DOMAIN_IPTC", "iptc"}, {0, NULL, NULL}};
		GType metadata_domain_type_id;
		metadata_domain_type_id = g_enum_register_static ("MetadataDomain", values);
		g_once_init_leave (&metadata_domain_type_id__volatile, metadata_domain_type_id);
	}
	return metadata_domain_type_id__volatile;
}


PhotoPreview* photo_preview_construct (GType object_type, const gchar* name, Dimensions* dimensions, guint32 size, const gchar* mime_type, const gchar* extension) {
	PhotoPreview* self = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	Dimensions _tmp2_;
	guint32 _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	const gchar* _tmp6_;
	gchar* _tmp7_;
#line 38 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 38 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (dimensions != NULL, NULL);
#line 38 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (mime_type != NULL, NULL);
#line 38 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (extension != NULL, NULL);
#line 38 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	self = (PhotoPreview*) g_type_create_instance (object_type);
#line 39 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = name;
#line 39 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 39 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_g_free0 (self->priv->name);
#line 39 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	self->priv->name = _tmp1_;
#line 40 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp2_ = *dimensions;
#line 40 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	self->priv->dimensions = _tmp2_;
#line 41 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp3_ = size;
#line 41 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	self->priv->size = _tmp3_;
#line 42 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp4_ = mime_type;
#line 42 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp5_ = g_strdup (_tmp4_);
#line 42 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_g_free0 (self->priv->mime_type);
#line 42 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	self->priv->mime_type = _tmp5_;
#line 43 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp6_ = extension;
#line 43 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp7_ = g_strdup (_tmp6_);
#line 43 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_g_free0 (self->priv->extension);
#line 43 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	self->priv->extension = _tmp7_;
#line 38 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	return self;
#line 599 "PhotoMetadata.c"
}


gchar* photo_preview_get_name (PhotoPreview* self) {
	gchar* result = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
#line 46 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_PREVIEW (self), NULL);
#line 47 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = self->priv->name;
#line 47 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 47 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	result = _tmp1_;
#line 47 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	return result;
#line 617 "PhotoMetadata.c"
}


void photo_preview_get_pixel_dimensions (PhotoPreview* self, Dimensions* result) {
	Dimensions _tmp0_;
#line 50 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_PREVIEW (self));
#line 51 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = self->priv->dimensions;
#line 51 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	*result = _tmp0_;
#line 51 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	return;
#line 631 "PhotoMetadata.c"
}


guint32 photo_preview_get_size (PhotoPreview* self) {
	guint32 result = 0U;
	guint32 _tmp0_;
#line 54 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_PREVIEW (self), 0U);
#line 55 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = self->priv->size;
#line 55 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	result = _tmp0_;
#line 55 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	return result;
#line 646 "PhotoMetadata.c"
}


gchar* photo_preview_get_mime_type (PhotoPreview* self) {
	gchar* result = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
#line 58 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_PREVIEW (self), NULL);
#line 59 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = self->priv->mime_type;
#line 59 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 59 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	result = _tmp1_;
#line 59 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	return result;
#line 664 "PhotoMetadata.c"
}


gchar* photo_preview_get_extension (PhotoPreview* self) {
	gchar* result = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
#line 62 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_PREVIEW (self), NULL);
#line 63 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = self->priv->extension;
#line 63 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 63 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	result = _tmp1_;
#line 63 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	return result;
#line 682 "PhotoMetadata.c"
}


static guint8* photo_preview_real_flatten (PhotoPreview* self, int* result_length1, GError** error) {
#line 66 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	g_critical ("Type `%s' does not implement abstract method `photo_preview_flatten'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 66 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	return NULL;
#line 691 "PhotoMetadata.c"
}


guint8* photo_preview_flatten (PhotoPreview* self, int* result_length1, GError** error) {
#line 66 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_PREVIEW (self), NULL);
#line 66 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	return PHOTO_PREVIEW_GET_CLASS (self)->flatten (self, result_length1, error);
#line 700 "PhotoMetadata.c"
}


static guint8* _vala_array_dup7 (guint8* self, int length) {
#line 74 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	return g_memdup (self, length * sizeof (guint8));
#line 707 "PhotoMetadata.c"
}


static GdkPixbuf* photo_preview_real_get_pixbuf (PhotoPreview* self, GError** error) {
	GdkPixbuf* result = NULL;
	gint _tmp0_ = 0;
	guint8* _tmp1_ = NULL;
	guint8* flattened;
	gint flattened_length1;
	gint _flattened_size_;
	GError * _inner_error_ = NULL;
#line 69 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp1_ = photo_preview_flatten (self, &_tmp0_, &_inner_error_);
#line 69 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	flattened = _tmp1_;
#line 69 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	flattened_length1 = _tmp0_;
#line 69 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_flattened_size_ = flattened_length1;
#line 69 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	if (_inner_error_ != NULL) {
#line 69 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		g_propagate_error (error, _inner_error_);
#line 69 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		return NULL;
#line 733 "PhotoMetadata.c"
	}
	{
		guint8* _tmp2_;
		gint _tmp2__length1;
		GMemoryInputStream* _tmp3_;
		GMemoryInputStream* _tmp4_;
		GdkPixbuf* _tmp5_;
		GdkPixbuf* _tmp6_;
		GdkPixbuf* _tmp7_;
#line 74 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp2_ = (flattened != NULL) ? _vala_array_dup7 (flattened, flattened_length1) : ((gpointer) flattened);
#line 74 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp2__length1 = flattened_length1;
#line 74 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp3_ = (GMemoryInputStream*) g_memory_input_stream_new_from_data (_tmp2_, _tmp2__length1, NULL);
#line 74 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp4_ = _tmp3_;
#line 74 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp5_ = gdk_pixbuf_new_from_stream (G_INPUT_STREAM (_tmp4_), NULL, &_inner_error_);
#line 74 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp6_ = _tmp5_;
#line 74 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_g_object_unref0 (_tmp4_);
#line 74 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp7_ = _tmp6_;
#line 74 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		if (_inner_error_ != NULL) {
#line 761 "PhotoMetadata.c"
			goto __catch23_g_error;
		}
#line 74 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		result = _tmp7_;
#line 74 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		flattened = (g_free (flattened), NULL);
#line 74 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		return result;
#line 770 "PhotoMetadata.c"
	}
	goto __finally23;
	__catch23_g_error:
	{
		GError* err = NULL;
		const gchar* _tmp8_;
		GError* _tmp9_;
		const gchar* _tmp10_;
#line 73 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		err = _inner_error_;
#line 73 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_inner_error_ = NULL;
#line 77 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp8_ = self->priv->name;
#line 77 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp9_ = err;
#line 77 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp10_ = _tmp9_->message;
#line 77 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		g_warning ("PhotoMetadata.vala:77: Unable to decode thumbnail for %s: %s", _tmp8_, _tmp10_);
#line 79 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		result = NULL;
#line 79 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_g_error_free0 (err);
#line 79 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		flattened = (g_free (flattened), NULL);
#line 79 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		return result;
#line 799 "PhotoMetadata.c"
	}
	__finally23:
#line 73 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	g_propagate_error (error, _inner_error_);
#line 73 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	flattened = (g_free (flattened), NULL);
#line 73 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	return NULL;
#line 808 "PhotoMetadata.c"
}


GdkPixbuf* photo_preview_get_pixbuf (PhotoPreview* self, GError** error) {
#line 68 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_PREVIEW (self), NULL);
#line 68 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	return PHOTO_PREVIEW_GET_CLASS (self)->get_pixbuf (self, error);
#line 817 "PhotoMetadata.c"
}


static void value_photo_preview_init (GValue* value) {
#line 31 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	value->data[0].v_pointer = NULL;
#line 824 "PhotoMetadata.c"
}


static void value_photo_preview_free_value (GValue* value) {
#line 31 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	if (value->data[0].v_pointer) {
#line 31 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		photo_preview_unref (value->data[0].v_pointer);
#line 833 "PhotoMetadata.c"
	}
}


static void value_photo_preview_copy_value (const GValue* src_value, GValue* dest_value) {
#line 31 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	if (src_value->data[0].v_pointer) {
#line 31 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		dest_value->data[0].v_pointer = photo_preview_ref (src_value->data[0].v_pointer);
#line 843 "PhotoMetadata.c"
	} else {
#line 31 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		dest_value->data[0].v_pointer = NULL;
#line 847 "PhotoMetadata.c"
	}
}


static gpointer value_photo_preview_peek_pointer (const GValue* value) {
#line 31 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	return value->data[0].v_pointer;
#line 855 "PhotoMetadata.c"
}


static gchar* value_photo_preview_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
#line 31 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	if (collect_values[0].v_pointer) {
#line 862 "PhotoMetadata.c"
		PhotoPreview* object;
		object = collect_values[0].v_pointer;
#line 31 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		if (object->parent_instance.g_class == NULL) {
#line 31 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 869 "PhotoMetadata.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 31 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 873 "PhotoMetadata.c"
		}
#line 31 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		value->data[0].v_pointer = photo_preview_ref (object);
#line 877 "PhotoMetadata.c"
	} else {
#line 31 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		value->data[0].v_pointer = NULL;
#line 881 "PhotoMetadata.c"
	}
#line 31 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	return NULL;
#line 885 "PhotoMetadata.c"
}


static gchar* value_photo_preview_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	PhotoPreview** object_p;
	object_p = collect_values[0].v_pointer;
#line 31 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	if (!object_p) {
#line 31 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 896 "PhotoMetadata.c"
	}
#line 31 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	if (!value->data[0].v_pointer) {
#line 31 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		*object_p = NULL;
#line 902 "PhotoMetadata.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 31 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		*object_p = value->data[0].v_pointer;
#line 906 "PhotoMetadata.c"
	} else {
#line 31 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		*object_p = photo_preview_ref (value->data[0].v_pointer);
#line 910 "PhotoMetadata.c"
	}
#line 31 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	return NULL;
#line 914 "PhotoMetadata.c"
}


GParamSpec* param_spec_photo_preview (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	ParamSpecPhotoPreview* spec;
#line 31 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_PHOTO_PREVIEW), NULL);
#line 31 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 31 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 31 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	return G_PARAM_SPEC (spec);
#line 928 "PhotoMetadata.c"
}


gpointer value_get_photo_preview (const GValue* value) {
#line 31 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_PHOTO_PREVIEW), NULL);
#line 31 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	return value->data[0].v_pointer;
#line 937 "PhotoMetadata.c"
}


void value_set_photo_preview (GValue* value, gpointer v_object) {
	PhotoPreview* old;
#line 31 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_PHOTO_PREVIEW));
#line 31 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	old = value->data[0].v_pointer;
#line 31 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	if (v_object) {
#line 31 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_PHOTO_PREVIEW));
#line 31 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 31 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		value->data[0].v_pointer = v_object;
#line 31 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		photo_preview_ref (value->data[0].v_pointer);
#line 957 "PhotoMetadata.c"
	} else {
#line 31 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		value->data[0].v_pointer = NULL;
#line 961 "PhotoMetadata.c"
	}
#line 31 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	if (old) {
#line 31 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		photo_preview_unref (old);
#line 967 "PhotoMetadata.c"
	}
}


void value_take_photo_preview (GValue* value, gpointer v_object) {
	PhotoPreview* old;
#line 31 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_PHOTO_PREVIEW));
#line 31 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	old = value->data[0].v_pointer;
#line 31 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	if (v_object) {
#line 31 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_PHOTO_PREVIEW));
#line 31 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 31 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		value->data[0].v_pointer = v_object;
#line 986 "PhotoMetadata.c"
	} else {
#line 31 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		value->data[0].v_pointer = NULL;
#line 990 "PhotoMetadata.c"
	}
#line 31 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	if (old) {
#line 31 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		photo_preview_unref (old);
#line 996 "PhotoMetadata.c"
	}
}


static void photo_preview_class_init (PhotoPreviewClass * klass) {
#line 31 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	photo_preview_parent_class = g_type_class_peek_parent (klass);
#line 31 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	PHOTO_PREVIEW_CLASS (klass)->finalize = photo_preview_finalize;
#line 31 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	g_type_class_add_private (klass, sizeof (PhotoPreviewPrivate));
#line 31 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	PHOTO_PREVIEW_CLASS (klass)->flatten = photo_preview_real_flatten;
#line 31 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	PHOTO_PREVIEW_CLASS (klass)->get_pixbuf = photo_preview_real_get_pixbuf;
#line 1012 "PhotoMetadata.c"
}


static void photo_preview_instance_init (PhotoPreview * self) {
#line 31 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	self->priv = PHOTO_PREVIEW_GET_PRIVATE (self);
#line 31 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	self->ref_count = 1;
#line 1021 "PhotoMetadata.c"
}


static void photo_preview_finalize (PhotoPreview* obj) {
	PhotoPreview * self;
#line 31 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	self = PHOTO_PREVIEW (obj);
#line 32 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_g_free0 (self->priv->name);
#line 35 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_g_free0 (self->priv->mime_type);
#line 36 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_g_free0 (self->priv->extension);
#line 1035 "PhotoMetadata.c"
}


GType photo_preview_get_type (void) {
	static volatile gsize photo_preview_type_id__volatile = 0;
	if (g_once_init_enter (&photo_preview_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_photo_preview_init, value_photo_preview_free_value, value_photo_preview_copy_value, value_photo_preview_peek_pointer, "p", value_photo_preview_collect_value, "p", value_photo_preview_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (PhotoPreviewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_preview_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoPreview), 0, (GInstanceInitFunc) photo_preview_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType photo_preview_type_id;
		photo_preview_type_id = g_type_register_fundamental (g_type_fundamental_next (), "PhotoPreview", &g_define_type_info, &g_define_type_fundamental_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&photo_preview_type_id__volatile, photo_preview_type_id);
	}
	return photo_preview_type_id__volatile;
}


gpointer photo_preview_ref (gpointer instance) {
	PhotoPreview* self;
	self = instance;
#line 31 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	g_atomic_int_inc (&self->ref_count);
#line 31 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	return instance;
#line 1060 "PhotoMetadata.c"
}


void photo_preview_unref (gpointer instance) {
	PhotoPreview* self;
	self = instance;
#line 31 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 31 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		PHOTO_PREVIEW_GET_CLASS (self)->finalize (self);
#line 31 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 1073 "PhotoMetadata.c"
	}
}


GType photo_metadata_set_option_get_type (void) {
	static volatile gsize photo_metadata_set_option_type_id__volatile = 0;
	if (g_once_init_enter (&photo_metadata_set_option_type_id__volatile)) {
		static const GEnumValue values[] = {{PHOTO_METADATA_SET_OPTION_ALL_DOMAINS, "PHOTO_METADATA_SET_OPTION_ALL_DOMAINS", "all-domains"}, {PHOTO_METADATA_SET_OPTION_ONLY_IF_DOMAIN_PRESENT, "PHOTO_METADATA_SET_OPTION_ONLY_IF_DOMAIN_PRESENT", "only-if-domain-present"}, {PHOTO_METADATA_SET_OPTION_AT_LEAST_DEFAULT_DOMAIN, "PHOTO_METADATA_SET_OPTION_AT_LEAST_DEFAULT_DOMAIN", "at-least-default-domain"}, {0, NULL, NULL}};
		GType photo_metadata_set_option_type_id;
		photo_metadata_set_option_type_id = g_enum_register_static ("PhotoMetadataSetOption", values);
		g_once_init_leave (&photo_metadata_set_option_type_id__volatile, photo_metadata_set_option_type_id);
	}
	return photo_metadata_set_option_type_id__volatile;
}


PhotoMetadata* photo_metadata_construct (GType object_type) {
	PhotoMetadata* self = NULL;
#line 124 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	self = (PhotoMetadata*) media_metadata_construct (object_type);
#line 124 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	return self;
#line 1096 "PhotoMetadata.c"
}


PhotoMetadata* photo_metadata_new (void) {
#line 124 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	return photo_metadata_construct (TYPE_PHOTO_METADATA);
#line 1103 "PhotoMetadata.c"
}


static void photo_metadata_real_read_from_file (MediaMetadata* base, GFile* file, GError** error) {
	PhotoMetadata * self;
	GExiv2Metadata* _tmp0_;
	GExiv2Metadata* _tmp1_;
	GFile* _tmp2_;
	gchar* _tmp3_ = NULL;
	gchar* _tmp4_;
	GFile* _tmp5_;
	gchar* _tmp6_ = NULL;
	gchar* _tmp7_;
	ExifData* _tmp8_ = NULL;
	GFile* _tmp9_;
	gchar* _tmp10_ = NULL;
	GError * _inner_error_ = NULL;
#line 127 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	self = PHOTO_METADATA (base);
#line 127 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	g_return_if_fail (G_IS_FILE (file));
#line 128 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = gexiv2_metadata_new ();
#line 128 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_gexiv2_metadata_free0 (self->priv->exiv2);
#line 128 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	self->priv->exiv2 = _tmp0_;
#line 129 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_exif_data_unref0 (self->priv->exif);
#line 129 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	self->priv->exif = NULL;
#line 131 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp1_ = self->priv->exiv2;
#line 131 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp2_ = file;
#line 131 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp3_ = g_file_get_path (_tmp2_);
#line 131 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp4_ = _tmp3_;
#line 131 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	gexiv2_metadata_open_path (_tmp1_, _tmp4_, &_inner_error_);
#line 131 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_g_free0 (_tmp4_);
#line 131 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	if (_inner_error_ != NULL) {
#line 131 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		g_propagate_error (error, _inner_error_);
#line 131 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		return;
#line 1153 "PhotoMetadata.c"
	}
#line 132 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp5_ = file;
#line 132 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp6_ = g_file_get_path (_tmp5_);
#line 132 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp7_ = _tmp6_;
#line 132 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp8_ = exif_data_new_from_file (_tmp7_);
#line 132 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_exif_data_unref0 (self->priv->exif);
#line 132 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	self->priv->exif = _tmp8_;
#line 132 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_g_free0 (_tmp7_);
#line 133 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp9_ = file;
#line 133 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp10_ = g_file_get_basename (_tmp9_);
#line 133 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_g_free0 (self->priv->source_name);
#line 133 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	self->priv->source_name = _tmp10_;
#line 1177 "PhotoMetadata.c"
}


void photo_metadata_write_to_file (PhotoMetadata* self, GFile* file, GError** error) {
	GExiv2Metadata* _tmp0_;
	GFile* _tmp1_;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_;
	GError * _inner_error_ = NULL;
#line 136 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 136 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	g_return_if_fail (G_IS_FILE (file));
#line 137 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = self->priv->exiv2;
#line 137 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp1_ = file;
#line 137 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp2_ = g_file_get_path (_tmp1_);
#line 137 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp3_ = _tmp2_;
#line 137 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	gexiv2_metadata_save_file (_tmp0_, _tmp3_, &_inner_error_);
#line 137 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_g_free0 (_tmp3_);
#line 137 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	if (_inner_error_ != NULL) {
#line 137 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		g_propagate_error (error, _inner_error_);
#line 137 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		return;
#line 1209 "PhotoMetadata.c"
	}
}


void photo_metadata_read_from_buffer (PhotoMetadata* self, guint8* buffer, int buffer_length1, gint length, GError** error) {
	gint _tmp0_;
	guint8* _tmp2_;
	gint _tmp2__length1;
	gint _tmp3_;
	GExiv2Metadata* _tmp4_;
	GExiv2Metadata* _tmp5_;
	guint8* _tmp6_;
	gint _tmp6__length1;
	gint _tmp7_;
	guint8* _tmp8_;
	gint _tmp8__length1;
	gint _tmp9_;
	ExifData* _tmp10_ = NULL;
	gint _tmp11_;
	gchar* _tmp12_ = NULL;
	GError * _inner_error_ = NULL;
#line 140 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 141 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = length;
#line 141 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	if (_tmp0_ <= 0) {
#line 1237 "PhotoMetadata.c"
		guint8* _tmp1_;
		gint _tmp1__length1;
#line 142 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp1_ = buffer;
#line 142 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp1__length1 = buffer_length1;
#line 142 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		length = _tmp1__length1;
#line 1246 "PhotoMetadata.c"
	}
#line 144 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp2_ = buffer;
#line 144 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp2__length1 = buffer_length1;
#line 144 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp3_ = length;
#line 144 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	g_assert (_tmp2__length1 >= _tmp3_);
#line 146 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp4_ = gexiv2_metadata_new ();
#line 146 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_gexiv2_metadata_free0 (self->priv->exiv2);
#line 146 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	self->priv->exiv2 = _tmp4_;
#line 147 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_exif_data_unref0 (self->priv->exif);
#line 147 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	self->priv->exif = NULL;
#line 149 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp5_ = self->priv->exiv2;
#line 149 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp6_ = buffer;
#line 149 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp6__length1 = buffer_length1;
#line 149 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp7_ = length;
#line 149 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	gexiv2_metadata_open_buf (_tmp5_, _tmp6_, (glong) _tmp7_, &_inner_error_);
#line 149 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	if (_inner_error_ != NULL) {
#line 149 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		g_propagate_error (error, _inner_error_);
#line 149 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		return;
#line 1282 "PhotoMetadata.c"
	}
#line 150 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp8_ = buffer;
#line 150 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp8__length1 = buffer_length1;
#line 150 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp9_ = length;
#line 150 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp10_ = exif_data_new_from_data (_tmp8_, (gsize) _tmp9_);
#line 150 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_exif_data_unref0 (self->priv->exif);
#line 150 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	self->priv->exif = _tmp10_;
#line 151 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp11_ = length;
#line 151 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp12_ = g_strdup_printf ("<memory buffer %d bytes>", _tmp11_);
#line 151 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_g_free0 (self->priv->source_name);
#line 151 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	self->priv->source_name = _tmp12_;
#line 1304 "PhotoMetadata.c"
}


void photo_metadata_read_from_app1_segment (PhotoMetadata* self, guint8* buffer, int buffer_length1, gint length, GError** error) {
	gint _tmp0_;
	guint8* _tmp2_;
	gint _tmp2__length1;
	gint _tmp3_;
	GExiv2Metadata* _tmp4_;
	GExiv2Metadata* _tmp5_;
	guint8* _tmp6_;
	gint _tmp6__length1;
	gint _tmp7_;
	guint8* _tmp8_;
	gint _tmp8__length1;
	gint _tmp9_;
	ExifData* _tmp10_ = NULL;
	gint _tmp11_;
	gchar* _tmp12_ = NULL;
	GError * _inner_error_ = NULL;
#line 154 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 155 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = length;
#line 155 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	if (_tmp0_ <= 0) {
#line 1331 "PhotoMetadata.c"
		guint8* _tmp1_;
		gint _tmp1__length1;
#line 156 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp1_ = buffer;
#line 156 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp1__length1 = buffer_length1;
#line 156 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		length = _tmp1__length1;
#line 1340 "PhotoMetadata.c"
	}
#line 158 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp2_ = buffer;
#line 158 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp2__length1 = buffer_length1;
#line 158 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp3_ = length;
#line 158 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	g_assert (_tmp2__length1 >= _tmp3_);
#line 160 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp4_ = gexiv2_metadata_new ();
#line 160 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_gexiv2_metadata_free0 (self->priv->exiv2);
#line 160 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	self->priv->exiv2 = _tmp4_;
#line 161 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_exif_data_unref0 (self->priv->exif);
#line 161 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	self->priv->exif = NULL;
#line 163 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp5_ = self->priv->exiv2;
#line 163 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp6_ = buffer;
#line 163 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp6__length1 = buffer_length1;
#line 163 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp7_ = length;
#line 163 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	gexiv2_metadata_from_app1_segment (_tmp5_, _tmp6_, (glong) _tmp7_, &_inner_error_);
#line 163 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	if (_inner_error_ != NULL) {
#line 163 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		g_propagate_error (error, _inner_error_);
#line 163 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		return;
#line 1376 "PhotoMetadata.c"
	}
#line 164 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp8_ = buffer;
#line 164 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp8__length1 = buffer_length1;
#line 164 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp9_ = length;
#line 164 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp10_ = exif_data_new_from_data (_tmp8_, (gsize) _tmp9_);
#line 164 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_exif_data_unref0 (self->priv->exif);
#line 164 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	self->priv->exif = _tmp10_;
#line 165 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp11_ = length;
#line 165 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp12_ = g_strdup_printf ("<app1 segment %d bytes>", _tmp11_);
#line 165 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_g_free0 (self->priv->source_name);
#line 165 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	self->priv->source_name = _tmp12_;
#line 1398 "PhotoMetadata.c"
}


MetadataDomain photo_metadata_get_tag_domain (const gchar* tag) {
	MetadataDomain result = 0;
	const gchar* _tmp0_;
	gboolean _tmp1_ = FALSE;
	const gchar* _tmp2_;
	gboolean _tmp3_ = FALSE;
	const gchar* _tmp4_;
	gboolean _tmp5_ = FALSE;
#line 168 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (tag != NULL, 0);
#line 169 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = tag;
#line 169 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp1_ = gexiv2_metadata_is_exif_tag (_tmp0_);
#line 169 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	if (_tmp1_) {
#line 170 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		result = METADATA_DOMAIN_EXIF;
#line 170 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		return result;
#line 1422 "PhotoMetadata.c"
	}
#line 172 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp2_ = tag;
#line 172 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp3_ = gexiv2_metadata_is_xmp_tag (_tmp2_);
#line 172 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	if (_tmp3_) {
#line 173 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		result = METADATA_DOMAIN_XMP;
#line 173 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		return result;
#line 1434 "PhotoMetadata.c"
	}
#line 175 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp4_ = tag;
#line 175 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp5_ = gexiv2_metadata_is_iptc_tag (_tmp4_);
#line 175 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	if (_tmp5_) {
#line 176 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		result = METADATA_DOMAIN_IPTC;
#line 176 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		return result;
#line 1446 "PhotoMetadata.c"
	}
#line 178 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	result = METADATA_DOMAIN_UNKNOWN;
#line 178 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	return result;
#line 1452 "PhotoMetadata.c"
}


gboolean photo_metadata_has_domain (PhotoMetadata* self, MetadataDomain domain) {
	gboolean result = FALSE;
	MetadataDomain _tmp0_;
#line 181 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), FALSE);
#line 182 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = domain;
#line 182 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	switch (_tmp0_) {
#line 182 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		case METADATA_DOMAIN_EXIF:
#line 1467 "PhotoMetadata.c"
		{
			GExiv2Metadata* _tmp1_;
			gboolean _tmp2_ = FALSE;
#line 184 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
			_tmp1_ = self->priv->exiv2;
#line 184 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
			_tmp2_ = gexiv2_metadata_has_exif (_tmp1_);
#line 184 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
			result = _tmp2_;
#line 184 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
			return result;
#line 1479 "PhotoMetadata.c"
		}
#line 182 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		case METADATA_DOMAIN_XMP:
#line 1483 "PhotoMetadata.c"
		{
			GExiv2Metadata* _tmp3_;
			gboolean _tmp4_ = FALSE;
#line 187 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
			_tmp3_ = self->priv->exiv2;
#line 187 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
			_tmp4_ = gexiv2_metadata_has_xmp (_tmp3_);
#line 187 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
			result = _tmp4_;
#line 187 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
			return result;
#line 1495 "PhotoMetadata.c"
		}
#line 182 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		case METADATA_DOMAIN_IPTC:
#line 1499 "PhotoMetadata.c"
		{
			GExiv2Metadata* _tmp5_;
			gboolean _tmp6_ = FALSE;
#line 190 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
			_tmp5_ = self->priv->exiv2;
#line 190 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
			_tmp6_ = gexiv2_metadata_has_iptc (_tmp5_);
#line 190 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
			result = _tmp6_;
#line 190 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
			return result;
#line 1511 "PhotoMetadata.c"
		}
		default:
#line 182 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		case METADATA_DOMAIN_UNKNOWN:
#line 1516 "PhotoMetadata.c"
		{
#line 194 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
			result = FALSE;
#line 194 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
			return result;
#line 1522 "PhotoMetadata.c"
		}
	}
}


gboolean photo_metadata_has_exif (PhotoMetadata* self) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
#line 198 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), FALSE);
#line 199 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = photo_metadata_has_domain (self, METADATA_DOMAIN_EXIF);
#line 199 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	result = _tmp0_;
#line 199 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	return result;
#line 1539 "PhotoMetadata.c"
}


gboolean photo_metadata_has_xmp (PhotoMetadata* self) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
#line 202 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), FALSE);
#line 203 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = photo_metadata_has_domain (self, METADATA_DOMAIN_XMP);
#line 203 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	result = _tmp0_;
#line 203 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	return result;
#line 1554 "PhotoMetadata.c"
}


gboolean photo_metadata_has_iptc (PhotoMetadata* self) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
#line 206 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), FALSE);
#line 207 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = photo_metadata_has_domain (self, METADATA_DOMAIN_IPTC);
#line 207 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	result = _tmp0_;
#line 207 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	return result;
#line 1569 "PhotoMetadata.c"
}


gboolean photo_metadata_can_write_to_domain (PhotoMetadata* self, MetadataDomain domain) {
	gboolean result = FALSE;
	MetadataDomain _tmp0_;
#line 210 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), FALSE);
#line 211 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = domain;
#line 211 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	switch (_tmp0_) {
#line 211 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		case METADATA_DOMAIN_EXIF:
#line 1584 "PhotoMetadata.c"
		{
			GExiv2Metadata* _tmp1_;
			gboolean _tmp2_ = FALSE;
#line 213 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
			_tmp1_ = self->priv->exiv2;
#line 213 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
			_tmp2_ = gexiv2_metadata_get_supports_exif (_tmp1_);
#line 213 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
			result = _tmp2_;
#line 213 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
			return result;
#line 1596 "PhotoMetadata.c"
		}
#line 211 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		case METADATA_DOMAIN_XMP:
#line 1600 "PhotoMetadata.c"
		{
			GExiv2Metadata* _tmp3_;
			gboolean _tmp4_ = FALSE;
#line 216 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
			_tmp3_ = self->priv->exiv2;
#line 216 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
			_tmp4_ = gexiv2_metadata_get_supports_xmp (_tmp3_);
#line 216 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
			result = _tmp4_;
#line 216 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
			return result;
#line 1612 "PhotoMetadata.c"
		}
#line 211 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		case METADATA_DOMAIN_IPTC:
#line 1616 "PhotoMetadata.c"
		{
			GExiv2Metadata* _tmp5_;
			gboolean _tmp6_ = FALSE;
#line 219 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
			_tmp5_ = self->priv->exiv2;
#line 219 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
			_tmp6_ = gexiv2_metadata_get_supports_iptc (_tmp5_);
#line 219 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
			result = _tmp6_;
#line 219 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
			return result;
#line 1628 "PhotoMetadata.c"
		}
		default:
#line 211 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		case METADATA_DOMAIN_UNKNOWN:
#line 1633 "PhotoMetadata.c"
		{
#line 223 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
			result = FALSE;
#line 223 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
			return result;
#line 1639 "PhotoMetadata.c"
		}
	}
}


gboolean photo_metadata_can_write_exif (PhotoMetadata* self) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
#line 227 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), FALSE);
#line 228 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = photo_metadata_can_write_to_domain (self, METADATA_DOMAIN_EXIF);
#line 228 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	result = _tmp0_;
#line 228 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	return result;
#line 1656 "PhotoMetadata.c"
}


gboolean photo_metadata_can_write_xmp (PhotoMetadata* self) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
#line 231 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), FALSE);
#line 232 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = photo_metadata_can_write_to_domain (self, METADATA_DOMAIN_XMP);
#line 232 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	result = _tmp0_;
#line 232 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	return result;
#line 1671 "PhotoMetadata.c"
}


gboolean photo_metadata_can_write_iptc (PhotoMetadata* self) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
#line 235 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), FALSE);
#line 236 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = photo_metadata_can_write_to_domain (self, METADATA_DOMAIN_IPTC);
#line 236 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	result = _tmp0_;
#line 236 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	return result;
#line 1686 "PhotoMetadata.c"
}


gboolean photo_metadata_has_tag (PhotoMetadata* self, const gchar* tag) {
	gboolean result = FALSE;
	GExiv2Metadata* _tmp0_;
	const gchar* _tmp1_;
	gboolean _tmp2_ = FALSE;
#line 239 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), FALSE);
#line 239 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (tag != NULL, FALSE);
#line 240 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = self->priv->exiv2;
#line 240 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp1_ = tag;
#line 240 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp2_ = gexiv2_metadata_has_tag (_tmp0_, _tmp1_);
#line 240 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	result = _tmp2_;
#line 240 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	return result;
#line 1709 "PhotoMetadata.c"
}


static GeeSet* photo_metadata_create_string_set (PhotoMetadata* self, GCompareFunc compare_func) {
	GeeSet* result = NULL;
	GCompareFunc _tmp0_;
#line 243 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 245 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = compare_func;
#line 245 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	if (_tmp0_ == NULL) {
#line 1722 "PhotoMetadata.c"
		GeeHashSet* _tmp1_;
#line 246 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp1_ = gee_hash_set_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, NULL, NULL);
#line 246 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		result = GEE_SET (_tmp1_);
#line 246 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		return result;
#line 1730 "PhotoMetadata.c"
	} else {
		GCompareFunc _tmp2_;
		GeeTreeSet* _tmp3_;
#line 248 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp2_ = compare_func;
#line 248 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp3_ = gee_tree_set_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, _tmp2_);
#line 248 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		result = GEE_SET (_tmp3_);
#line 248 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		return result;
#line 1742 "PhotoMetadata.c"
	}
}


GeeCollection* photo_metadata_get_tags (PhotoMetadata* self, MetadataDomain domain, GCompareFunc compare_func) {
	GeeCollection* result = NULL;
	gchar** tags;
	gint tags_length1;
	gint _tags_size_;
	MetadataDomain _tmp0_;
	gboolean _tmp10_ = FALSE;
	gchar** _tmp11_;
	gint _tmp11__length1;
	gboolean _tmp13_;
	GCompareFunc _tmp14_;
	GeeSet* _tmp15_ = NULL;
	GeeCollection* collection;
	gchar** _tmp16_;
	gint _tmp16__length1;
#line 251 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 252 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	tags = NULL;
#line 252 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	tags_length1 = 0;
#line 252 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tags_size_ = tags_length1;
#line 253 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = domain;
#line 253 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	switch (_tmp0_) {
#line 253 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		case METADATA_DOMAIN_EXIF:
#line 1776 "PhotoMetadata.c"
		{
			GExiv2Metadata* _tmp1_;
			gchar** _tmp2_;
			gchar** _tmp3_ = NULL;
#line 255 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
			_tmp1_ = self->priv->exiv2;
#line 255 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
			_tmp3_ = _tmp2_ = gexiv2_metadata_get_exif_tags (_tmp1_);
#line 255 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
			tags = (_vala_array_free (tags, tags_length1, (GDestroyNotify) g_free), NULL);
#line 255 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
			tags = _tmp3_;
#line 255 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
			tags_length1 = _vala_array_length (_tmp2_);
#line 255 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
			_tags_size_ = tags_length1;
#line 256 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
			break;
#line 1795 "PhotoMetadata.c"
		}
#line 253 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		case METADATA_DOMAIN_XMP:
#line 1799 "PhotoMetadata.c"
		{
			GExiv2Metadata* _tmp4_;
			gchar** _tmp5_;
			gchar** _tmp6_ = NULL;
#line 259 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
			_tmp4_ = self->priv->exiv2;
#line 259 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
			_tmp6_ = _tmp5_ = gexiv2_metadata_get_xmp_tags (_tmp4_);
#line 259 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
			tags = (_vala_array_free (tags, tags_length1, (GDestroyNotify) g_free), NULL);
#line 259 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
			tags = _tmp6_;
#line 259 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
			tags_length1 = _vala_array_length (_tmp5_);
#line 259 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
			_tags_size_ = tags_length1;
#line 260 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
			break;
#line 1818 "PhotoMetadata.c"
		}
#line 253 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		case METADATA_DOMAIN_IPTC:
#line 1822 "PhotoMetadata.c"
		{
			GExiv2Metadata* _tmp7_;
			gchar** _tmp8_;
			gchar** _tmp9_ = NULL;
#line 263 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
			_tmp7_ = self->priv->exiv2;
#line 263 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
			_tmp9_ = _tmp8_ = gexiv2_metadata_get_iptc_tags (_tmp7_);
#line 263 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
			tags = (_vala_array_free (tags, tags_length1, (GDestroyNotify) g_free), NULL);
#line 263 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
			tags = _tmp9_;
#line 263 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
			tags_length1 = _vala_array_length (_tmp8_);
#line 263 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
			_tags_size_ = tags_length1;
#line 264 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
			break;
#line 1841 "PhotoMetadata.c"
		}
		default:
#line 253 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		break;
#line 1846 "PhotoMetadata.c"
	}
#line 267 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp11_ = tags;
#line 267 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp11__length1 = tags_length1;
#line 267 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	if (_tmp11_ == NULL) {
#line 267 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp10_ = TRUE;
#line 1856 "PhotoMetadata.c"
	} else {
		gchar** _tmp12_;
		gint _tmp12__length1;
#line 267 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp12_ = tags;
#line 267 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp12__length1 = tags_length1;
#line 267 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp10_ = _tmp12__length1 == 0;
#line 1866 "PhotoMetadata.c"
	}
#line 267 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp13_ = _tmp10_;
#line 267 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	if (_tmp13_) {
#line 268 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		result = NULL;
#line 268 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		tags = (_vala_array_free (tags, tags_length1, (GDestroyNotify) g_free), NULL);
#line 268 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		return result;
#line 1878 "PhotoMetadata.c"
	}
#line 270 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp14_ = compare_func;
#line 270 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp15_ = photo_metadata_create_string_set (self, _tmp14_);
#line 270 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	collection = GEE_COLLECTION (_tmp15_);
#line 271 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp16_ = tags;
#line 271 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp16__length1 = tags_length1;
#line 1890 "PhotoMetadata.c"
	{
		gchar** tag_collection = NULL;
		gint tag_collection_length1 = 0;
		gint _tag_collection_size_ = 0;
		gint tag_it = 0;
#line 271 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		tag_collection = _tmp16_;
#line 271 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		tag_collection_length1 = _tmp16__length1;
#line 271 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		for (tag_it = 0; tag_it < _tmp16__length1; tag_it = tag_it + 1) {
#line 1902 "PhotoMetadata.c"
			gchar* _tmp17_;
			gchar* tag = NULL;
#line 271 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
			_tmp17_ = g_strdup (tag_collection[tag_it]);
#line 271 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
			tag = _tmp17_;
#line 1909 "PhotoMetadata.c"
			{
				GeeCollection* _tmp18_;
				const gchar* _tmp19_;
#line 272 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
				_tmp18_ = collection;
#line 272 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
				_tmp19_ = tag;
#line 272 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
				gee_collection_add (_tmp18_, _tmp19_);
#line 271 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
				_g_free0 (tag);
#line 1921 "PhotoMetadata.c"
			}
		}
	}
#line 274 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	result = collection;
#line 274 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	tags = (_vala_array_free (tags, tags_length1, (GDestroyNotify) g_free), NULL);
#line 274 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	return result;
#line 1931 "PhotoMetadata.c"
}


static gpointer _g_object_ref0 (gpointer self) {
#line 292 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	return self ? g_object_ref (self) : NULL;
#line 1938 "PhotoMetadata.c"
}


GeeCollection* photo_metadata_get_all_tags (PhotoMetadata* self, GCompareFunc compare_func) {
	GeeCollection* result = NULL;
	GCompareFunc _tmp0_;
	GeeSet* _tmp1_ = NULL;
	GeeCollection* all_tags;
	GeeCollection* _tmp2_ = NULL;
	GeeCollection* exif_tags;
	gboolean _tmp3_ = FALSE;
	GeeCollection* _tmp4_;
	gboolean _tmp8_;
	GeeCollection* _tmp11_ = NULL;
	GeeCollection* xmp_tags;
	gboolean _tmp12_ = FALSE;
	GeeCollection* _tmp13_;
	gboolean _tmp17_;
	GeeCollection* _tmp20_ = NULL;
	GeeCollection* iptc_tags;
	gboolean _tmp21_ = FALSE;
	GeeCollection* _tmp22_;
	gboolean _tmp26_;
	GeeCollection* _tmp29_ = NULL;
	GeeCollection* _tmp30_;
	gint _tmp31_;
	gint _tmp32_;
	GeeCollection* _tmp34_;
	GeeCollection* _tmp35_;
#line 277 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 278 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = compare_func;
#line 278 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp1_ = photo_metadata_create_string_set (self, _tmp0_);
#line 278 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	all_tags = GEE_COLLECTION (_tmp1_);
#line 280 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp2_ = photo_metadata_get_tags (self, METADATA_DOMAIN_EXIF, NULL);
#line 280 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	exif_tags = _tmp2_;
#line 281 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp4_ = exif_tags;
#line 281 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	if (_tmp4_ != NULL) {
#line 1984 "PhotoMetadata.c"
		GeeCollection* _tmp5_;
		gint _tmp6_;
		gint _tmp7_;
#line 281 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp5_ = exif_tags;
#line 281 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp6_ = gee_collection_get_size (_tmp5_);
#line 281 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp7_ = _tmp6_;
#line 281 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp3_ = _tmp7_ > 0;
#line 1996 "PhotoMetadata.c"
	} else {
#line 281 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp3_ = FALSE;
#line 2000 "PhotoMetadata.c"
	}
#line 281 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp8_ = _tmp3_;
#line 281 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	if (_tmp8_) {
#line 2006 "PhotoMetadata.c"
		GeeCollection* _tmp9_;
		GeeCollection* _tmp10_;
#line 282 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp9_ = all_tags;
#line 282 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp10_ = exif_tags;
#line 282 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		gee_collection_add_all (_tmp9_, _tmp10_);
#line 2015 "PhotoMetadata.c"
	}
#line 284 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp11_ = photo_metadata_get_tags (self, METADATA_DOMAIN_XMP, NULL);
#line 284 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	xmp_tags = _tmp11_;
#line 285 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp13_ = xmp_tags;
#line 285 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	if (_tmp13_ != NULL) {
#line 2025 "PhotoMetadata.c"
		GeeCollection* _tmp14_;
		gint _tmp15_;
		gint _tmp16_;
#line 285 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp14_ = xmp_tags;
#line 285 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp15_ = gee_collection_get_size (_tmp14_);
#line 285 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp16_ = _tmp15_;
#line 285 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp12_ = _tmp16_ > 0;
#line 2037 "PhotoMetadata.c"
	} else {
#line 285 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp12_ = FALSE;
#line 2041 "PhotoMetadata.c"
	}
#line 285 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp17_ = _tmp12_;
#line 285 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	if (_tmp17_) {
#line 2047 "PhotoMetadata.c"
		GeeCollection* _tmp18_;
		GeeCollection* _tmp19_;
#line 286 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp18_ = all_tags;
#line 286 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp19_ = xmp_tags;
#line 286 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		gee_collection_add_all (_tmp18_, _tmp19_);
#line 2056 "PhotoMetadata.c"
	}
#line 288 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp20_ = photo_metadata_get_tags (self, METADATA_DOMAIN_IPTC, NULL);
#line 288 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	iptc_tags = _tmp20_;
#line 289 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp22_ = iptc_tags;
#line 289 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	if (_tmp22_ != NULL) {
#line 2066 "PhotoMetadata.c"
		GeeCollection* _tmp23_;
		gint _tmp24_;
		gint _tmp25_;
#line 289 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp23_ = iptc_tags;
#line 289 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp24_ = gee_collection_get_size (_tmp23_);
#line 289 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp25_ = _tmp24_;
#line 289 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp21_ = _tmp25_ > 0;
#line 2078 "PhotoMetadata.c"
	} else {
#line 289 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp21_ = FALSE;
#line 2082 "PhotoMetadata.c"
	}
#line 289 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp26_ = _tmp21_;
#line 289 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	if (_tmp26_) {
#line 2088 "PhotoMetadata.c"
		GeeCollection* _tmp27_;
		GeeCollection* _tmp28_;
#line 290 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp27_ = all_tags;
#line 290 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp28_ = iptc_tags;
#line 290 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		gee_collection_add_all (_tmp27_, _tmp28_);
#line 2097 "PhotoMetadata.c"
	}
#line 292 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp30_ = all_tags;
#line 292 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp31_ = gee_collection_get_size (_tmp30_);
#line 292 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp32_ = _tmp31_;
#line 292 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	if (_tmp32_ > 0) {
#line 2107 "PhotoMetadata.c"
		GeeCollection* _tmp33_;
#line 292 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp33_ = all_tags;
#line 292 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp29_ = _tmp33_;
#line 2113 "PhotoMetadata.c"
	} else {
#line 292 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp29_ = NULL;
#line 2117 "PhotoMetadata.c"
	}
#line 292 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp34_ = _tmp29_;
#line 292 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp35_ = _g_object_ref0 (_tmp34_);
#line 292 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	result = _tmp35_;
#line 292 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_g_object_unref0 (iptc_tags);
#line 292 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_g_object_unref0 (xmp_tags);
#line 292 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_g_object_unref0 (exif_tags);
#line 292 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_g_object_unref0 (all_tags);
#line 292 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	return result;
#line 2135 "PhotoMetadata.c"
}


gchar* photo_metadata_get_tag_label (PhotoMetadata* self, const gchar* tag) {
	gchar* result = NULL;
	const gchar* _tmp0_;
	const gchar* _tmp1_ = NULL;
	gchar* _tmp2_;
#line 295 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 295 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (tag != NULL, NULL);
#line 296 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = tag;
#line 296 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp1_ = gexiv2_metadata_get_tag_label (_tmp0_);
#line 296 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp2_ = g_strdup (_tmp1_);
#line 296 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	result = _tmp2_;
#line 296 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	return result;
#line 2158 "PhotoMetadata.c"
}


gchar* photo_metadata_get_tag_description (PhotoMetadata* self, const gchar* tag) {
	gchar* result = NULL;
	const gchar* _tmp0_;
	const gchar* _tmp1_ = NULL;
	gchar* _tmp2_;
#line 299 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 299 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (tag != NULL, NULL);
#line 300 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = tag;
#line 300 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp1_ = gexiv2_metadata_get_tag_description (_tmp0_);
#line 300 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp2_ = g_strdup (_tmp1_);
#line 300 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	result = _tmp2_;
#line 300 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	return result;
#line 2181 "PhotoMetadata.c"
}


gchar* photo_metadata_get_string (PhotoMetadata* self, const gchar* tag) {
	gchar* result = NULL;
	GExiv2Metadata* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_;
	gchar* _tmp4_ = NULL;
	gchar* _tmp5_;
#line 303 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 303 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (tag != NULL, NULL);
#line 304 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = self->priv->exiv2;
#line 304 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp1_ = tag;
#line 304 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp2_ = gexiv2_metadata_get_tag_string (_tmp0_, _tmp1_);
#line 304 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp3_ = _tmp2_;
#line 304 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp4_ = prepare_input_text (_tmp3_, PHOTO_METADATA_PREPARE_STRING_OPTIONS, DEFAULT_USER_TEXT_INPUT_LENGTH);
#line 304 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp5_ = _tmp4_;
#line 304 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_g_free0 (_tmp3_);
#line 304 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	result = _tmp5_;
#line 304 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	return result;
#line 2215 "PhotoMetadata.c"
}


gchar* photo_metadata_get_string_interpreted (PhotoMetadata* self, const gchar* tag) {
	gchar* result = NULL;
	GExiv2Metadata* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_;
	gchar* _tmp4_ = NULL;
	gchar* _tmp5_;
#line 307 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 307 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (tag != NULL, NULL);
#line 308 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = self->priv->exiv2;
#line 308 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp1_ = tag;
#line 308 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp2_ = gexiv2_metadata_get_tag_interpreted_string (_tmp0_, _tmp1_);
#line 308 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp3_ = _tmp2_;
#line 308 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp4_ = prepare_input_text (_tmp3_, PHOTO_METADATA_PREPARE_STRING_OPTIONS, DEFAULT_USER_TEXT_INPUT_LENGTH);
#line 308 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp5_ = _tmp4_;
#line 308 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_g_free0 (_tmp3_);
#line 308 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	result = _tmp5_;
#line 308 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	return result;
#line 2249 "PhotoMetadata.c"
}


gchar* photo_metadata_get_first_string (PhotoMetadata* self, gchar** tags, int tags_length1) {
	gchar* result = NULL;
	gchar** _tmp0_;
	gint _tmp0__length1;
#line 311 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 312 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = tags;
#line 312 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp0__length1 = tags_length1;
#line 2263 "PhotoMetadata.c"
	{
		gchar** tag_collection = NULL;
		gint tag_collection_length1 = 0;
		gint _tag_collection_size_ = 0;
		gint tag_it = 0;
#line 312 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		tag_collection = _tmp0_;
#line 312 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		tag_collection_length1 = _tmp0__length1;
#line 312 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		for (tag_it = 0; tag_it < _tmp0__length1; tag_it = tag_it + 1) {
#line 2275 "PhotoMetadata.c"
			gchar* _tmp1_;
			gchar* tag = NULL;
#line 312 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
			_tmp1_ = g_strdup (tag_collection[tag_it]);
#line 312 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
			tag = _tmp1_;
#line 2282 "PhotoMetadata.c"
			{
				const gchar* _tmp2_;
				gchar* _tmp3_ = NULL;
				gchar* value;
				const gchar* _tmp4_;
#line 313 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
				_tmp2_ = tag;
#line 313 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
				_tmp3_ = photo_metadata_get_string (self, _tmp2_);
#line 313 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
				value = _tmp3_;
#line 314 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
				_tmp4_ = value;
#line 314 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
				if (_tmp4_ != NULL) {
#line 315 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
					result = value;
#line 315 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
					_g_free0 (tag);
#line 315 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
					return result;
#line 2304 "PhotoMetadata.c"
				}
#line 312 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
				_g_free0 (value);
#line 312 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
				_g_free0 (tag);
#line 2310 "PhotoMetadata.c"
			}
		}
	}
#line 318 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	result = NULL;
#line 318 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	return result;
#line 2318 "PhotoMetadata.c"
}


gchar* photo_metadata_get_first_string_interpreted (PhotoMetadata* self, gchar** tags, int tags_length1) {
	gchar* result = NULL;
	gchar** _tmp0_;
	gint _tmp0__length1;
#line 321 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 322 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = tags;
#line 322 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp0__length1 = tags_length1;
#line 2332 "PhotoMetadata.c"
	{
		gchar** tag_collection = NULL;
		gint tag_collection_length1 = 0;
		gint _tag_collection_size_ = 0;
		gint tag_it = 0;
#line 322 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		tag_collection = _tmp0_;
#line 322 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		tag_collection_length1 = _tmp0__length1;
#line 322 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		for (tag_it = 0; tag_it < _tmp0__length1; tag_it = tag_it + 1) {
#line 2344 "PhotoMetadata.c"
			gchar* _tmp1_;
			gchar* tag = NULL;
#line 322 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
			_tmp1_ = g_strdup (tag_collection[tag_it]);
#line 322 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
			tag = _tmp1_;
#line 2351 "PhotoMetadata.c"
			{
				const gchar* _tmp2_;
				gchar* _tmp3_ = NULL;
				gchar* value;
				const gchar* _tmp4_;
#line 323 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
				_tmp2_ = tag;
#line 323 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
				_tmp3_ = photo_metadata_get_string_interpreted (self, _tmp2_);
#line 323 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
				value = _tmp3_;
#line 324 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
				_tmp4_ = value;
#line 324 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
				if (_tmp4_ != NULL) {
#line 325 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
					result = value;
#line 325 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
					_g_free0 (tag);
#line 325 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
					return result;
#line 2373 "PhotoMetadata.c"
				}
#line 322 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
				_g_free0 (value);
#line 322 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
				_g_free0 (tag);
#line 2379 "PhotoMetadata.c"
			}
		}
	}
#line 328 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	result = NULL;
#line 328 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	return result;
#line 2387 "PhotoMetadata.c"
}


GeeList* photo_metadata_get_string_multiple (PhotoMetadata* self, const gchar* tag) {
	GeeList* result = NULL;
	GExiv2Metadata* _tmp0_;
	const gchar* _tmp1_;
	gchar** _tmp2_;
	gchar** _tmp3_ = NULL;
	gchar** values;
	gint values_length1;
	gint _values_size_;
	gboolean _tmp4_ = FALSE;
	gchar** _tmp5_;
	gint _tmp5__length1;
	gboolean _tmp7_;
	GeeArrayList* _tmp8_;
	GeeList* list;
	GeeHashSet* _tmp9_;
	GeeHashSet* collection;
	gchar** _tmp10_;
	gint _tmp10__length1;
	GeeList* _tmp24_ = NULL;
	GeeList* _tmp25_;
	gint _tmp26_;
	gint _tmp27_;
	GeeList* _tmp29_;
	GeeList* _tmp30_;
#line 337 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 337 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (tag != NULL, NULL);
#line 338 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = self->priv->exiv2;
#line 338 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp1_ = tag;
#line 338 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp3_ = _tmp2_ = gexiv2_metadata_get_tag_multiple (_tmp0_, _tmp1_);
#line 338 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	values = _tmp3_;
#line 338 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	values_length1 = _vala_array_length (_tmp2_);
#line 338 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_values_size_ = values_length1;
#line 339 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp5_ = values;
#line 339 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp5__length1 = values_length1;
#line 339 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	if (_tmp5_ == NULL) {
#line 339 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp4_ = TRUE;
#line 2440 "PhotoMetadata.c"
	} else {
		gchar** _tmp6_;
		gint _tmp6__length1;
#line 339 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp6_ = values;
#line 339 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp6__length1 = values_length1;
#line 339 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp4_ = _tmp6__length1 == 0;
#line 2450 "PhotoMetadata.c"
	}
#line 339 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp7_ = _tmp4_;
#line 339 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	if (_tmp7_) {
#line 340 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		result = NULL;
#line 340 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		values = (_vala_array_free (values, values_length1, (GDestroyNotify) g_free), NULL);
#line 340 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		return result;
#line 2462 "PhotoMetadata.c"
	}
#line 342 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp8_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, NULL);
#line 342 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	list = GEE_LIST (_tmp8_);
#line 344 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp9_ = gee_hash_set_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, NULL, NULL);
#line 344 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	collection = _tmp9_;
#line 345 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp10_ = values;
#line 345 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp10__length1 = values_length1;
#line 2476 "PhotoMetadata.c"
	{
		gchar** value_collection = NULL;
		gint value_collection_length1 = 0;
		gint _value_collection_size_ = 0;
		gint value_it = 0;
#line 345 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		value_collection = _tmp10_;
#line 345 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		value_collection_length1 = _tmp10__length1;
#line 345 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		for (value_it = 0; value_it < _tmp10__length1; value_it = value_it + 1) {
#line 2488 "PhotoMetadata.c"
			gchar* _tmp11_;
			gchar* value = NULL;
#line 345 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
			_tmp11_ = g_strdup (value_collection[value_it]);
#line 345 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
			value = _tmp11_;
#line 2495 "PhotoMetadata.c"
			{
				const gchar* _tmp12_;
				gchar* _tmp13_ = NULL;
				gchar* prepped;
				gboolean _tmp14_ = FALSE;
				const gchar* _tmp15_;
				gboolean _tmp19_;
#line 346 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
				_tmp12_ = value;
#line 346 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
				_tmp13_ = prepare_input_text (_tmp12_, PHOTO_METADATA_PREPARE_STRING_OPTIONS, DEFAULT_USER_TEXT_INPUT_LENGTH);
#line 346 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
				prepped = _tmp13_;
#line 349 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
				_tmp15_ = prepped;
#line 349 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
				if (_tmp15_ != NULL) {
#line 2513 "PhotoMetadata.c"
					GeeHashSet* _tmp16_;
					const gchar* _tmp17_;
					gboolean _tmp18_ = FALSE;
#line 349 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
					_tmp16_ = collection;
#line 349 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
					_tmp17_ = prepped;
#line 349 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
					_tmp18_ = gee_abstract_collection_contains (GEE_ABSTRACT_COLLECTION (_tmp16_), _tmp17_);
#line 349 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
					_tmp14_ = !_tmp18_;
#line 2525 "PhotoMetadata.c"
				} else {
#line 349 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
					_tmp14_ = FALSE;
#line 2529 "PhotoMetadata.c"
				}
#line 349 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
				_tmp19_ = _tmp14_;
#line 349 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
				if (_tmp19_) {
#line 2535 "PhotoMetadata.c"
					GeeList* _tmp20_;
					const gchar* _tmp21_;
					GeeHashSet* _tmp22_;
					const gchar* _tmp23_;
#line 350 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
					_tmp20_ = list;
#line 350 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
					_tmp21_ = prepped;
#line 350 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
					gee_collection_add (GEE_COLLECTION (_tmp20_), _tmp21_);
#line 351 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
					_tmp22_ = collection;
#line 351 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
					_tmp23_ = prepped;
#line 351 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
					gee_abstract_collection_add (GEE_ABSTRACT_COLLECTION (_tmp22_), _tmp23_);
#line 2552 "PhotoMetadata.c"
				}
#line 345 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
				_g_free0 (prepped);
#line 345 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
				_g_free0 (value);
#line 2558 "PhotoMetadata.c"
			}
		}
	}
#line 355 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp25_ = list;
#line 355 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp26_ = gee_collection_get_size (GEE_COLLECTION (_tmp25_));
#line 355 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp27_ = _tmp26_;
#line 355 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	if (_tmp27_ > 0) {
#line 2570 "PhotoMetadata.c"
		GeeList* _tmp28_;
#line 355 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp28_ = list;
#line 355 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp24_ = _tmp28_;
#line 2576 "PhotoMetadata.c"
	} else {
#line 355 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp24_ = NULL;
#line 2580 "PhotoMetadata.c"
	}
#line 355 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp29_ = _tmp24_;
#line 355 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp30_ = _g_object_ref0 (_tmp29_);
#line 355 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	result = _tmp30_;
#line 355 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_g_object_unref0 (collection);
#line 355 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_g_object_unref0 (list);
#line 355 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	values = (_vala_array_free (values, values_length1, (GDestroyNotify) g_free), NULL);
#line 355 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	return result;
#line 2596 "PhotoMetadata.c"
}


GeeList* photo_metadata_get_first_string_multiple (PhotoMetadata* self, gchar** tags, int tags_length1) {
	GeeList* result = NULL;
	gchar** _tmp0_;
	gint _tmp0__length1;
#line 364 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 365 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = tags;
#line 365 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp0__length1 = tags_length1;
#line 2610 "PhotoMetadata.c"
	{
		gchar** tag_collection = NULL;
		gint tag_collection_length1 = 0;
		gint _tag_collection_size_ = 0;
		gint tag_it = 0;
#line 365 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		tag_collection = _tmp0_;
#line 365 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		tag_collection_length1 = _tmp0__length1;
#line 365 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		for (tag_it = 0; tag_it < _tmp0__length1; tag_it = tag_it + 1) {
#line 2622 "PhotoMetadata.c"
			gchar* _tmp1_;
			gchar* tag = NULL;
#line 365 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
			_tmp1_ = g_strdup (tag_collection[tag_it]);
#line 365 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
			tag = _tmp1_;
#line 2629 "PhotoMetadata.c"
			{
				const gchar* _tmp2_;
				GeeList* _tmp3_ = NULL;
				GeeList* values;
				gboolean _tmp4_ = FALSE;
				GeeList* _tmp5_;
				gboolean _tmp9_;
#line 366 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
				_tmp2_ = tag;
#line 366 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
				_tmp3_ = photo_metadata_get_string_multiple (self, _tmp2_);
#line 366 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
				values = _tmp3_;
#line 367 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
				_tmp5_ = values;
#line 367 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
				if (_tmp5_ != NULL) {
#line 2647 "PhotoMetadata.c"
					GeeList* _tmp6_;
					gint _tmp7_;
					gint _tmp8_;
#line 367 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
					_tmp6_ = values;
#line 367 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
					_tmp7_ = gee_collection_get_size (GEE_COLLECTION (_tmp6_));
#line 367 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
					_tmp8_ = _tmp7_;
#line 367 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
					_tmp4_ = _tmp8_ > 0;
#line 2659 "PhotoMetadata.c"
				} else {
#line 367 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
					_tmp4_ = FALSE;
#line 2663 "PhotoMetadata.c"
				}
#line 367 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
				_tmp9_ = _tmp4_;
#line 367 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
				if (_tmp9_) {
#line 368 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
					result = values;
#line 368 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
					_g_free0 (tag);
#line 368 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
					return result;
#line 2675 "PhotoMetadata.c"
				}
#line 365 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
				_g_object_unref0 (values);
#line 365 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
				_g_free0 (tag);
#line 2681 "PhotoMetadata.c"
			}
		}
	}
#line 371 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	result = NULL;
#line 371 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	return result;
#line 2689 "PhotoMetadata.c"
}


void photo_metadata_set_string (PhotoMetadata* self, const gchar* tag, const gchar* value) {
	const gchar* _tmp0_;
	gchar* _tmp1_ = NULL;
	gchar* prepped;
	const gchar* _tmp2_;
	GExiv2Metadata* _tmp5_;
	const gchar* _tmp6_;
	const gchar* _tmp7_;
	gboolean _tmp8_ = FALSE;
#line 374 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 374 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	g_return_if_fail (tag != NULL);
#line 374 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	g_return_if_fail (value != NULL);
#line 375 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = value;
#line 375 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp1_ = prepare_input_text (_tmp0_, PHOTO_METADATA_PREPARE_STRING_OPTIONS, DEFAULT_USER_TEXT_INPUT_LENGTH);
#line 375 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	prepped = _tmp1_;
#line 376 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp2_ = prepped;
#line 376 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	if (_tmp2_ == NULL) {
#line 2718 "PhotoMetadata.c"
		const gchar* _tmp3_;
		const gchar* _tmp4_;
#line 377 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp3_ = tag;
#line 377 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp4_ = value;
#line 377 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		g_warning ("PhotoMetadata.vala:377: Not setting tag %s to string %s: invalid UTF-8", _tmp3_, _tmp4_);
#line 379 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_g_free0 (prepped);
#line 379 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		return;
#line 2731 "PhotoMetadata.c"
	}
#line 382 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp5_ = self->priv->exiv2;
#line 382 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp6_ = tag;
#line 382 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp7_ = prepped;
#line 382 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp8_ = gexiv2_metadata_set_tag_string (_tmp5_, _tmp6_, _tmp7_);
#line 382 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	if (!_tmp8_) {
#line 2743 "PhotoMetadata.c"
		const gchar* _tmp9_;
		const gchar* _tmp10_;
		const gchar* _tmp11_;
#line 383 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp9_ = tag;
#line 383 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp10_ = value;
#line 383 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp11_ = self->priv->source_name;
#line 383 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		g_warning ("PhotoMetadata.vala:383: Unable to set tag %s to string %s from source " \
"%s", _tmp9_, _tmp10_, _tmp11_);
#line 2755 "PhotoMetadata.c"
	}
#line 374 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_g_free0 (prepped);
#line 2759 "PhotoMetadata.c"
}


static void photo_metadata_set_all_generic (PhotoMetadata* self, gchar** tags, int tags_length1, PhotoMetadataSetOption option, PhotoMetadataSetGenericValue setter, void* setter_target) {
	gboolean written;
	gchar** _tmp0_;
	gint _tmp0__length1;
	gboolean _tmp10_ = FALSE;
	gboolean _tmp11_ = FALSE;
	PhotoMetadataSetOption _tmp12_;
	gboolean _tmp14_;
	gboolean _tmp16_;
#line 388 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 389 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	written = FALSE;
#line 390 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = tags;
#line 390 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp0__length1 = tags_length1;
#line 2780 "PhotoMetadata.c"
	{
		gchar** tag_collection = NULL;
		gint tag_collection_length1 = 0;
		gint _tag_collection_size_ = 0;
		gint tag_it = 0;
#line 390 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		tag_collection = _tmp0_;
#line 390 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		tag_collection_length1 = _tmp0__length1;
#line 390 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		for (tag_it = 0; tag_it < _tmp0__length1; tag_it = tag_it + 1) {
#line 2792 "PhotoMetadata.c"
			gchar* _tmp1_;
			gchar* tag = NULL;
#line 390 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
			_tmp1_ = g_strdup (tag_collection[tag_it]);
#line 390 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
			tag = _tmp1_;
#line 2799 "PhotoMetadata.c"
			{
				gboolean _tmp2_ = FALSE;
				PhotoMetadataSetOption _tmp3_;
				gboolean _tmp7_;
#line 391 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
				_tmp3_ = option;
#line 391 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
				if (_tmp3_ == PHOTO_METADATA_SET_OPTION_ALL_DOMAINS) {
#line 391 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
					_tmp2_ = TRUE;
#line 2810 "PhotoMetadata.c"
				} else {
					const gchar* _tmp4_;
					MetadataDomain _tmp5_ = 0;
					gboolean _tmp6_ = FALSE;
#line 391 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
					_tmp4_ = tag;
#line 391 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
					_tmp5_ = photo_metadata_get_tag_domain (_tmp4_);
#line 391 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
					_tmp6_ = photo_metadata_has_domain (self, _tmp5_);
#line 391 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
					_tmp2_ = _tmp6_;
#line 2823 "PhotoMetadata.c"
				}
#line 391 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
				_tmp7_ = _tmp2_;
#line 391 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
				if (_tmp7_) {
#line 2829 "PhotoMetadata.c"
					PhotoMetadataSetGenericValue _tmp8_;
					void* _tmp8__target;
					const gchar* _tmp9_;
#line 392 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
					_tmp8_ = setter;
#line 392 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
					_tmp8__target = setter_target;
#line 392 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
					_tmp9_ = tag;
#line 392 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
					_tmp8_ (_tmp9_, _tmp8__target);
#line 393 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
					written = TRUE;
#line 2843 "PhotoMetadata.c"
				}
#line 390 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
				_g_free0 (tag);
#line 2847 "PhotoMetadata.c"
			}
		}
	}
#line 397 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp12_ = option;
#line 397 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	if (_tmp12_ == PHOTO_METADATA_SET_OPTION_AT_LEAST_DEFAULT_DOMAIN) {
#line 2855 "PhotoMetadata.c"
		gboolean _tmp13_;
#line 397 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp13_ = written;
#line 397 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp11_ = !_tmp13_;
#line 2861 "PhotoMetadata.c"
	} else {
#line 397 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp11_ = FALSE;
#line 2865 "PhotoMetadata.c"
	}
#line 397 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp14_ = _tmp11_;
#line 397 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	if (_tmp14_) {
#line 2871 "PhotoMetadata.c"
		gchar** _tmp15_;
		gint _tmp15__length1;
#line 397 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp15_ = tags;
#line 397 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp15__length1 = tags_length1;
#line 397 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp10_ = _tmp15__length1 > 0;
#line 2880 "PhotoMetadata.c"
	} else {
#line 397 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp10_ = FALSE;
#line 2884 "PhotoMetadata.c"
	}
#line 397 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp16_ = _tmp10_;
#line 397 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	if (_tmp16_) {
#line 2890 "PhotoMetadata.c"
		gchar** _tmp17_;
		gint _tmp17__length1;
		const gchar* _tmp18_;
		MetadataDomain _tmp19_ = 0;
		MetadataDomain default_domain;
		PhotoMetadataSetGenericValue _tmp20_;
		void* _tmp20__target;
		gchar** _tmp21_;
		gint _tmp21__length1;
		const gchar* _tmp22_;
#line 398 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp17_ = tags;
#line 398 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp17__length1 = tags_length1;
#line 398 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp18_ = _tmp17_[0];
#line 398 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp19_ = photo_metadata_get_tag_domain (_tmp18_);
#line 398 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		default_domain = _tmp19_;
#line 401 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp20_ = setter;
#line 401 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp20__target = setter_target;
#line 401 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp21_ = tags;
#line 401 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp21__length1 = tags_length1;
#line 401 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp22_ = _tmp21_[0];
#line 401 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp20_ (_tmp22_, _tmp20__target);
#line 2923 "PhotoMetadata.c"
		{
			gint ctr;
#line 404 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
			ctr = 1;
#line 2928 "PhotoMetadata.c"
			{
				gboolean _tmp23_;
#line 404 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
				_tmp23_ = TRUE;
#line 404 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
				while (TRUE) {
#line 2935 "PhotoMetadata.c"
					gboolean _tmp24_;
					gint _tmp26_;
					gchar** _tmp27_;
					gint _tmp27__length1;
					gchar** _tmp28_;
					gint _tmp28__length1;
					gint _tmp29_;
					const gchar* _tmp30_;
					MetadataDomain _tmp31_ = 0;
					MetadataDomain _tmp32_;
#line 404 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
					_tmp24_ = _tmp23_;
#line 404 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
					if (!_tmp24_) {
#line 2950 "PhotoMetadata.c"
						gint _tmp25_;
#line 404 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
						_tmp25_ = ctr;
#line 404 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
						ctr = _tmp25_ + 1;
#line 2956 "PhotoMetadata.c"
					}
#line 404 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
					_tmp23_ = FALSE;
#line 404 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
					_tmp26_ = ctr;
#line 404 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
					_tmp27_ = tags;
#line 404 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
					_tmp27__length1 = tags_length1;
#line 404 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
					if (!(_tmp26_ < _tmp27__length1)) {
#line 404 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
						break;
#line 2970 "PhotoMetadata.c"
					}
#line 405 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
					_tmp28_ = tags;
#line 405 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
					_tmp28__length1 = tags_length1;
#line 405 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
					_tmp29_ = ctr;
#line 405 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
					_tmp30_ = _tmp28_[_tmp29_];
#line 405 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
					_tmp31_ = photo_metadata_get_tag_domain (_tmp30_);
#line 405 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
					_tmp32_ = default_domain;
#line 405 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
					if (_tmp31_ == _tmp32_) {
#line 2986 "PhotoMetadata.c"
						PhotoMetadataSetGenericValue _tmp33_;
						void* _tmp33__target;
						gchar** _tmp34_;
						gint _tmp34__length1;
						gint _tmp35_;
						const gchar* _tmp36_;
#line 406 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
						_tmp33_ = setter;
#line 406 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
						_tmp33__target = setter_target;
#line 406 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
						_tmp34_ = tags;
#line 406 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
						_tmp34__length1 = tags_length1;
#line 406 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
						_tmp35_ = ctr;
#line 406 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
						_tmp36_ = _tmp34_[_tmp35_];
#line 406 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
						_tmp33_ (_tmp36_, _tmp33__target);
#line 3007 "PhotoMetadata.c"
					}
				}
			}
		}
	}
}


static Block1Data* block1_data_ref (Block1Data* _data1_) {
#line 411 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	g_atomic_int_inc (&_data1_->_ref_count_);
#line 411 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	return _data1_;
#line 3021 "PhotoMetadata.c"
}


static void block1_data_unref (Block1Data* _data1_) {
#line 411 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	if (g_atomic_int_dec_and_test (&_data1_->_ref_count_)) {
#line 411 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_media_metadata_unref0 (_data1_->self);
#line 411 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_g_free0 (_data1_->value);
#line 411 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		g_slice_free (Block1Data, _data1_);
#line 3034 "PhotoMetadata.c"
	}
}


static void __lambda1_ (Block1Data* _data1_, const gchar* tag) {
	PhotoMetadata * self;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
#line 412 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	self = _data1_->self;
#line 412 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	g_return_if_fail (tag != NULL);
#line 412 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = tag;
#line 412 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp1_ = _data1_->value;
#line 412 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	photo_metadata_set_string (self, _tmp0_, _tmp1_);
#line 3053 "PhotoMetadata.c"
}


static void ___lambda1__photo_metadata_set_generic_value (const gchar* tag, gpointer self) {
#line 412 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	__lambda1_ (self, tag);
#line 3060 "PhotoMetadata.c"
}


void photo_metadata_set_all_string (PhotoMetadata* self, gchar** tags, int tags_length1, const gchar* value, PhotoMetadataSetOption option) {
	Block1Data* _data1_;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar** _tmp2_;
	gint _tmp2__length1;
	PhotoMetadataSetOption _tmp3_;
#line 411 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 411 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	g_return_if_fail (value != NULL);
#line 411 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_data1_ = g_slice_new0 (Block1Data);
#line 411 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_data1_->_ref_count_ = 1;
#line 411 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_data1_->self = media_metadata_ref (self);
#line 411 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = value;
#line 411 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 411 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_data1_->value = _tmp1_;
#line 412 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp2_ = tags;
#line 412 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp2__length1 = tags_length1;
#line 412 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp3_ = option;
#line 412 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	photo_metadata_set_all_generic (self, _tmp2_, _tmp2__length1, _tmp3_, ___lambda1__photo_metadata_set_generic_value, _data1_);
#line 411 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	block1_data_unref (_data1_);
#line 411 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_data1_ = NULL;
#line 3099 "PhotoMetadata.c"
}


static void _vala_array_add13 (gchar*** array, int* length, int* size, gchar* value) {
#line 420 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	if ((*length) == (*size)) {
#line 420 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 420 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 3110 "PhotoMetadata.c"
	}
#line 420 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	(*array)[(*length)++] = value;
#line 420 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	(*array)[*length] = NULL;
#line 3116 "PhotoMetadata.c"
}


static void _vala_array_add14 (gchar*** array, int* length, int* size, gchar* value) {
#line 432 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	if ((*length) == (*size)) {
#line 432 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 432 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 3127 "PhotoMetadata.c"
	}
#line 432 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	(*array)[(*length)++] = value;
#line 432 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	(*array)[*length] = NULL;
#line 3133 "PhotoMetadata.c"
}


void photo_metadata_set_string_multiple (PhotoMetadata* self, const gchar* tag, GeeCollection* collection) {
	gchar** _tmp0_ = NULL;
	gchar** values;
	gint values_length1;
	gint _values_size_;
	gchar** _tmp15_;
	gint _tmp15__length1;
	gchar** _tmp16_;
	gint _tmp16__length1;
	GExiv2Metadata* _tmp17_;
	const gchar* _tmp18_;
	gchar** _tmp19_;
	gint _tmp19__length1;
	gboolean _tmp20_ = FALSE;
#line 415 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 415 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	g_return_if_fail (tag != NULL);
#line 415 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	g_return_if_fail (GEE_IS_COLLECTION (collection));
#line 416 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = g_new0 (gchar*, 0 + 1);
#line 416 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	values = _tmp0_;
#line 416 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	values_length1 = 0;
#line 416 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_values_size_ = values_length1;
#line 3165 "PhotoMetadata.c"
	{
		GeeCollection* _tmp1_;
		GeeIterator* _tmp2_ = NULL;
		GeeIterator* _value_it;
#line 417 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp1_ = collection;
#line 417 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp2_ = gee_iterable_iterator (GEE_ITERABLE (_tmp1_));
#line 417 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_value_it = _tmp2_;
#line 417 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		while (TRUE) {
#line 3178 "PhotoMetadata.c"
			GeeIterator* _tmp3_;
			gboolean _tmp4_ = FALSE;
			GeeIterator* _tmp5_;
			gpointer _tmp6_ = NULL;
			gchar* value;
			const gchar* _tmp7_;
			gchar* _tmp8_ = NULL;
			gchar* prepped;
			const gchar* _tmp9_;
#line 417 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
			_tmp3_ = _value_it;
#line 417 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
			_tmp4_ = gee_iterator_next (_tmp3_);
#line 417 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
			if (!_tmp4_) {
#line 417 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
				break;
#line 3196 "PhotoMetadata.c"
			}
#line 417 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
			_tmp5_ = _value_it;
#line 417 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
			_tmp6_ = gee_iterator_get (_tmp5_);
#line 417 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
			value = (gchar*) _tmp6_;
#line 418 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
			_tmp7_ = value;
#line 418 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
			_tmp8_ = prepare_input_text (_tmp7_, PHOTO_METADATA_PREPARE_STRING_OPTIONS, -1);
#line 418 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
			prepped = _tmp8_;
#line 419 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
			_tmp9_ = prepped;
#line 419 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
			if (_tmp9_ != NULL) {
#line 3214 "PhotoMetadata.c"
				gchar** _tmp10_;
				gint _tmp10__length1;
				const gchar* _tmp11_;
				gchar* _tmp12_;
#line 420 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
				_tmp10_ = values;
#line 420 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
				_tmp10__length1 = values_length1;
#line 420 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
				_tmp11_ = prepped;
#line 420 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
				_tmp12_ = g_strdup (_tmp11_);
#line 420 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
				_vala_array_add13 (&values, &values_length1, &_values_size_, _tmp12_);
#line 3229 "PhotoMetadata.c"
			} else {
				const gchar* _tmp13_;
				const gchar* _tmp14_;
#line 422 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
				_tmp13_ = value;
#line 422 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
				_tmp14_ = tag;
#line 422 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
				g_warning ("PhotoMetadata.vala:422: Unable to set string %s to %s: invalid UTF-8", _tmp13_, _tmp14_);
#line 3239 "PhotoMetadata.c"
			}
#line 417 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
			_g_free0 (prepped);
#line 417 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
			_g_free0 (value);
#line 3245 "PhotoMetadata.c"
		}
#line 417 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_g_object_unref0 (_value_it);
#line 3249 "PhotoMetadata.c"
	}
#line 425 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp15_ = values;
#line 425 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp15__length1 = values_length1;
#line 425 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	if (_tmp15__length1 == 0) {
#line 426 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		values = (_vala_array_free (values, values_length1, (GDestroyNotify) g_free), NULL);
#line 426 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		return;
#line 3261 "PhotoMetadata.c"
	}
#line 432 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp16_ = values;
#line 432 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp16__length1 = values_length1;
#line 432 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_vala_array_add14 (&values, &values_length1, &_values_size_, NULL);
#line 434 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp17_ = self->priv->exiv2;
#line 434 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp18_ = tag;
#line 434 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp19_ = values;
#line 434 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp19__length1 = values_length1;
#line 434 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp20_ = gexiv2_metadata_set_tag_multiple (_tmp17_, _tmp18_, _tmp19_);
#line 434 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	if (!_tmp20_) {
#line 3281 "PhotoMetadata.c"
		gchar** _tmp21_;
		gint _tmp21__length1;
		const gchar* _tmp22_;
		const gchar* _tmp23_;
#line 435 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp21_ = values;
#line 435 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp21__length1 = values_length1;
#line 435 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp22_ = tag;
#line 435 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp23_ = self->priv->source_name;
#line 435 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		g_warning ("PhotoMetadata.vala:435: Unable to set %d strings to tag %s from source" \
" %s", _tmp21__length1, _tmp22_, _tmp23_);
#line 3296 "PhotoMetadata.c"
	}
#line 415 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	values = (_vala_array_free (values, values_length1, (GDestroyNotify) g_free), NULL);
#line 3300 "PhotoMetadata.c"
}


static Block2Data* block2_data_ref (Block2Data* _data2_) {
#line 438 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	g_atomic_int_inc (&_data2_->_ref_count_);
#line 438 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	return _data2_;
#line 3309 "PhotoMetadata.c"
}


static void block2_data_unref (Block2Data* _data2_) {
#line 438 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	if (g_atomic_int_dec_and_test (&_data2_->_ref_count_)) {
#line 438 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_media_metadata_unref0 (_data2_->self);
#line 438 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_g_object_unref0 (_data2_->values);
#line 438 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		g_slice_free (Block2Data, _data2_);
#line 3322 "PhotoMetadata.c"
	}
}


static void __lambda2_ (Block2Data* _data2_, const gchar* tag) {
	PhotoMetadata * self;
	const gchar* _tmp0_;
	GeeCollection* _tmp1_;
#line 439 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	self = _data2_->self;
#line 439 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	g_return_if_fail (tag != NULL);
#line 439 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = tag;
#line 439 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp1_ = _data2_->values;
#line 439 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	photo_metadata_set_string_multiple (self, _tmp0_, _tmp1_);
#line 3341 "PhotoMetadata.c"
}


static void ___lambda2__photo_metadata_set_generic_value (const gchar* tag, gpointer self) {
#line 439 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	__lambda2_ (self, tag);
#line 3348 "PhotoMetadata.c"
}


void photo_metadata_set_all_string_multiple (PhotoMetadata* self, gchar** tags, int tags_length1, GeeCollection* values, PhotoMetadataSetOption option) {
	Block2Data* _data2_;
	GeeCollection* _tmp0_;
	GeeCollection* _tmp1_;
	gchar** _tmp2_;
	gint _tmp2__length1;
	PhotoMetadataSetOption _tmp3_;
#line 438 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 438 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	g_return_if_fail (GEE_IS_COLLECTION (values));
#line 438 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_data2_ = g_slice_new0 (Block2Data);
#line 438 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_data2_->_ref_count_ = 1;
#line 438 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_data2_->self = media_metadata_ref (self);
#line 438 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = values;
#line 438 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 438 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_data2_->values = _tmp1_;
#line 439 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp2_ = tags;
#line 439 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp2__length1 = tags_length1;
#line 439 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp3_ = option;
#line 439 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	photo_metadata_set_all_generic (self, _tmp2_, _tmp2__length1, _tmp3_, ___lambda2__photo_metadata_set_generic_value, _data2_);
#line 438 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	block2_data_unref (_data2_);
#line 438 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_data2_ = NULL;
#line 3387 "PhotoMetadata.c"
}


gboolean photo_metadata_get_long (PhotoMetadata* self, const gchar* tag, glong* value) {
	glong _vala_value = 0L;
	gboolean result = FALSE;
	const gchar* _tmp0_;
	gboolean _tmp1_ = FALSE;
	GExiv2Metadata* _tmp2_;
	const gchar* _tmp3_;
	glong _tmp4_ = 0L;
#line 442 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), FALSE);
#line 442 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (tag != NULL, FALSE);
#line 443 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = tag;
#line 443 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp1_ = photo_metadata_has_tag (self, _tmp0_);
#line 443 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	if (!_tmp1_) {
#line 444 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		result = FALSE;
#line 444 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		if (value) {
#line 444 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
			*value = _vala_value;
#line 3415 "PhotoMetadata.c"
		}
#line 444 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		return result;
#line 3419 "PhotoMetadata.c"
	}
#line 446 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp2_ = self->priv->exiv2;
#line 446 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp3_ = tag;
#line 446 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp4_ = gexiv2_metadata_get_tag_long (_tmp2_, _tmp3_);
#line 446 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_vala_value = _tmp4_;
#line 448 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	result = TRUE;
#line 448 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	if (value) {
#line 448 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		*value = _vala_value;
#line 3435 "PhotoMetadata.c"
	}
#line 448 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	return result;
#line 3439 "PhotoMetadata.c"
}


gboolean photo_metadata_get_first_long (PhotoMetadata* self, gchar** tags, int tags_length1, glong* value) {
	glong _vala_value = 0L;
	gboolean result = FALSE;
	gchar** _tmp0_;
	gint _tmp0__length1;
#line 451 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), FALSE);
#line 452 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = tags;
#line 452 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp0__length1 = tags_length1;
#line 3454 "PhotoMetadata.c"
	{
		gchar** tag_collection = NULL;
		gint tag_collection_length1 = 0;
		gint _tag_collection_size_ = 0;
		gint tag_it = 0;
#line 452 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		tag_collection = _tmp0_;
#line 452 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		tag_collection_length1 = _tmp0__length1;
#line 452 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		for (tag_it = 0; tag_it < _tmp0__length1; tag_it = tag_it + 1) {
#line 3466 "PhotoMetadata.c"
			gchar* _tmp1_;
			gchar* tag = NULL;
#line 452 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
			_tmp1_ = g_strdup (tag_collection[tag_it]);
#line 452 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
			tag = _tmp1_;
#line 3473 "PhotoMetadata.c"
			{
				const gchar* _tmp2_;
				glong _tmp3_ = 0L;
				gboolean _tmp4_ = FALSE;
#line 453 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
				_tmp2_ = tag;
#line 453 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
				_tmp4_ = photo_metadata_get_long (self, _tmp2_, &_tmp3_);
#line 453 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
				_vala_value = _tmp3_;
#line 453 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
				if (_tmp4_) {
#line 454 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
					result = TRUE;
#line 454 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
					_g_free0 (tag);
#line 454 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
					if (value) {
#line 454 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
						*value = _vala_value;
#line 3494 "PhotoMetadata.c"
					}
#line 454 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
					return result;
#line 3498 "PhotoMetadata.c"
				}
#line 452 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
				_g_free0 (tag);
#line 3502 "PhotoMetadata.c"
			}
		}
	}
#line 457 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	result = FALSE;
#line 457 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	if (value) {
#line 457 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		*value = _vala_value;
#line 3512 "PhotoMetadata.c"
	}
#line 457 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	return result;
#line 3516 "PhotoMetadata.c"
}


void photo_metadata_set_long (PhotoMetadata* self, const gchar* tag, glong value) {
	GExiv2Metadata* _tmp0_;
	const gchar* _tmp1_;
	glong _tmp2_;
	gboolean _tmp3_ = FALSE;
#line 460 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 460 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	g_return_if_fail (tag != NULL);
#line 461 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = self->priv->exiv2;
#line 461 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp1_ = tag;
#line 461 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp2_ = value;
#line 461 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp3_ = gexiv2_metadata_set_tag_long (_tmp0_, _tmp1_, _tmp2_);
#line 461 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	if (!_tmp3_) {
#line 3539 "PhotoMetadata.c"
		const gchar* _tmp4_;
		glong _tmp5_;
		const gchar* _tmp6_;
#line 462 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp4_ = tag;
#line 462 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp5_ = value;
#line 462 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp6_ = self->priv->source_name;
#line 462 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		g_warning ("PhotoMetadata.vala:462: Unable to set tag %s to long %ld from source %" \
"s", _tmp4_, _tmp5_, _tmp6_);
#line 3551 "PhotoMetadata.c"
	}
}


static Block3Data* block3_data_ref (Block3Data* _data3_) {
#line 465 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	g_atomic_int_inc (&_data3_->_ref_count_);
#line 465 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	return _data3_;
#line 3561 "PhotoMetadata.c"
}


static void block3_data_unref (Block3Data* _data3_) {
#line 465 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	if (g_atomic_int_dec_and_test (&_data3_->_ref_count_)) {
#line 465 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_media_metadata_unref0 (_data3_->self);
#line 465 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		g_slice_free (Block3Data, _data3_);
#line 3572 "PhotoMetadata.c"
	}
}


static void __lambda3_ (Block3Data* _data3_, const gchar* tag) {
	PhotoMetadata * self;
	const gchar* _tmp0_;
	glong _tmp1_;
#line 466 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	self = _data3_->self;
#line 466 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	g_return_if_fail (tag != NULL);
#line 466 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = tag;
#line 466 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp1_ = _data3_->value;
#line 466 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	photo_metadata_set_long (self, _tmp0_, _tmp1_);
#line 3591 "PhotoMetadata.c"
}


static void ___lambda3__photo_metadata_set_generic_value (const gchar* tag, gpointer self) {
#line 466 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	__lambda3_ (self, tag);
#line 3598 "PhotoMetadata.c"
}


void photo_metadata_set_all_long (PhotoMetadata* self, gchar** tags, int tags_length1, glong value, PhotoMetadataSetOption option) {
	Block3Data* _data3_;
	glong _tmp0_;
	gchar** _tmp1_;
	gint _tmp1__length1;
	PhotoMetadataSetOption _tmp2_;
#line 465 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 465 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_data3_ = g_slice_new0 (Block3Data);
#line 465 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_data3_->_ref_count_ = 1;
#line 465 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_data3_->self = media_metadata_ref (self);
#line 465 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = value;
#line 465 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_data3_->value = _tmp0_;
#line 466 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp1_ = tags;
#line 466 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp1__length1 = tags_length1;
#line 466 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp2_ = option;
#line 466 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	photo_metadata_set_all_generic (self, _tmp1_, _tmp1__length1, _tmp2_, ___lambda3__photo_metadata_set_generic_value, _data3_);
#line 465 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	block3_data_unref (_data3_);
#line 465 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_data3_ = NULL;
#line 3632 "PhotoMetadata.c"
}


gboolean photo_metadata_get_rational (PhotoMetadata* self, const gchar* tag, MetadataRational* rational) {
	MetadataRational _vala_rational = {0};
	gboolean result = FALSE;
	GExiv2Metadata* _tmp0_;
	const gchar* _tmp1_;
	gint _tmp2_ = 0;
	gint _tmp3_ = 0;
	gboolean _tmp4_ = FALSE;
#line 469 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), FALSE);
#line 469 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (tag != NULL, FALSE);
#line 470 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = self->priv->exiv2;
#line 470 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp1_ = tag;
#line 470 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp4_ = gexiv2_metadata_get_exif_tag_rational (_tmp0_, _tmp1_, &_tmp2_, &_tmp3_);
#line 470 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_vala_rational.numerator = _tmp2_;
#line 470 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_vala_rational.denominator = _tmp3_;
#line 470 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	result = _tmp4_;
#line 470 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	if (rational) {
#line 470 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		*rational = _vala_rational;
#line 3664 "PhotoMetadata.c"
	}
#line 470 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	return result;
#line 3668 "PhotoMetadata.c"
}


gboolean photo_metadata_get_first_rational (PhotoMetadata* self, gchar** tags, int tags_length1, MetadataRational* rational) {
	MetadataRational _vala_rational = {0};
	gboolean result = FALSE;
	gchar** _tmp0_;
	gint _tmp0__length1;
#line 473 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), FALSE);
#line 474 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = tags;
#line 474 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp0__length1 = tags_length1;
#line 3683 "PhotoMetadata.c"
	{
		gchar** tag_collection = NULL;
		gint tag_collection_length1 = 0;
		gint _tag_collection_size_ = 0;
		gint tag_it = 0;
#line 474 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		tag_collection = _tmp0_;
#line 474 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		tag_collection_length1 = _tmp0__length1;
#line 474 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		for (tag_it = 0; tag_it < _tmp0__length1; tag_it = tag_it + 1) {
#line 3695 "PhotoMetadata.c"
			gchar* _tmp1_;
			gchar* tag = NULL;
#line 474 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
			_tmp1_ = g_strdup (tag_collection[tag_it]);
#line 474 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
			tag = _tmp1_;
#line 3702 "PhotoMetadata.c"
			{
				const gchar* _tmp2_;
				MetadataRational _tmp3_ = {0};
				gboolean _tmp4_ = FALSE;
#line 475 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
				_tmp2_ = tag;
#line 475 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
				_tmp4_ = photo_metadata_get_rational (self, _tmp2_, &_tmp3_);
#line 475 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
				_vala_rational = _tmp3_;
#line 475 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
				if (_tmp4_) {
#line 476 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
					result = TRUE;
#line 476 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
					_g_free0 (tag);
#line 476 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
					if (rational) {
#line 476 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
						*rational = _vala_rational;
#line 3723 "PhotoMetadata.c"
					}
#line 476 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
					return result;
#line 3727 "PhotoMetadata.c"
				}
#line 474 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
				_g_free0 (tag);
#line 3731 "PhotoMetadata.c"
			}
		}
	}
#line 479 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	result = FALSE;
#line 479 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	if (rational) {
#line 479 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		*rational = _vala_rational;
#line 3741 "PhotoMetadata.c"
	}
#line 479 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	return result;
#line 3745 "PhotoMetadata.c"
}


void photo_metadata_set_rational (PhotoMetadata* self, const gchar* tag, MetadataRational* rational) {
	GExiv2Metadata* _tmp0_;
	const gchar* _tmp1_;
	MetadataRational _tmp2_;
	gint _tmp3_;
	MetadataRational _tmp4_;
	gint _tmp5_;
	gboolean _tmp6_ = FALSE;
#line 482 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 482 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	g_return_if_fail (tag != NULL);
#line 482 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	g_return_if_fail (rational != NULL);
#line 483 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = self->priv->exiv2;
#line 483 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp1_ = tag;
#line 483 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp2_ = *rational;
#line 483 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp3_ = _tmp2_.numerator;
#line 483 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp4_ = *rational;
#line 483 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp5_ = _tmp4_.denominator;
#line 483 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp6_ = gexiv2_metadata_set_exif_tag_rational (_tmp0_, _tmp1_, _tmp3_, _tmp5_);
#line 483 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	if (!_tmp6_) {
#line 3779 "PhotoMetadata.c"
		const gchar* _tmp7_;
		gchar* _tmp8_ = NULL;
		gchar* _tmp9_;
		const gchar* _tmp10_;
#line 484 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp7_ = tag;
#line 484 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp8_ = metadata_rational_to_string (rational);
#line 484 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp9_ = _tmp8_;
#line 484 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp10_ = self->priv->source_name;
#line 484 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		g_warning ("PhotoMetadata.vala:484: Unable to set tag %s to rational %s from sourc" \
"e %s", _tmp7_, _tmp9_, _tmp10_);
#line 484 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_g_free0 (_tmp9_);
#line 3796 "PhotoMetadata.c"
	}
}


static Block4Data* block4_data_ref (Block4Data* _data4_) {
#line 489 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	g_atomic_int_inc (&_data4_->_ref_count_);
#line 489 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	return _data4_;
#line 3806 "PhotoMetadata.c"
}


static void block4_data_unref (Block4Data* _data4_) {
#line 489 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	if (g_atomic_int_dec_and_test (&_data4_->_ref_count_)) {
#line 489 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_media_metadata_unref0 (_data4_->self);
#line 489 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		g_slice_free (Block4Data, _data4_);
#line 3817 "PhotoMetadata.c"
	}
}


static void __lambda4_ (Block4Data* _data4_, const gchar* tag) {
	PhotoMetadata * self;
	const gchar* _tmp0_;
	MetadataRational _tmp1_;
#line 490 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	self = _data4_->self;
#line 490 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	g_return_if_fail (tag != NULL);
#line 490 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = tag;
#line 490 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp1_ = _data4_->rational;
#line 490 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	photo_metadata_set_rational (self, _tmp0_, &_tmp1_);
#line 3836 "PhotoMetadata.c"
}


static void ___lambda4__photo_metadata_set_generic_value (const gchar* tag, gpointer self) {
#line 490 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	__lambda4_ (self, tag);
#line 3843 "PhotoMetadata.c"
}


void photo_metadata_set_all_rational (PhotoMetadata* self, gchar** tags, int tags_length1, MetadataRational* rational, PhotoMetadataSetOption option) {
	Block4Data* _data4_;
	MetadataRational _tmp0_;
	gchar** _tmp1_;
	gint _tmp1__length1;
	PhotoMetadataSetOption _tmp2_;
#line 489 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 489 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	g_return_if_fail (rational != NULL);
#line 489 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_data4_ = g_slice_new0 (Block4Data);
#line 489 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_data4_->_ref_count_ = 1;
#line 489 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_data4_->self = media_metadata_ref (self);
#line 489 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = *rational;
#line 489 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_data4_->rational = _tmp0_;
#line 490 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp1_ = tags;
#line 490 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp1__length1 = tags_length1;
#line 490 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp2_ = option;
#line 490 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	photo_metadata_set_all_generic (self, _tmp1_, _tmp1__length1, _tmp2_, ___lambda4__photo_metadata_set_generic_value, _data4_);
#line 489 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	block4_data_unref (_data4_);
#line 489 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_data4_ = NULL;
#line 3879 "PhotoMetadata.c"
}


MetadataDateTime* photo_metadata_get_date_time (PhotoMetadata* self, const gchar* tag) {
	MetadataDateTime* result = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_ = NULL;
	gchar* value;
	const gchar* _tmp2_;
	GError * _inner_error_ = NULL;
#line 493 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 493 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (tag != NULL, NULL);
#line 494 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = tag;
#line 494 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp1_ = photo_metadata_get_string (self, _tmp0_);
#line 494 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	value = _tmp1_;
#line 495 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp2_ = value;
#line 495 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	if (_tmp2_ == NULL) {
#line 496 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		result = NULL;
#line 496 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_g_free0 (value);
#line 496 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		return result;
#line 3910 "PhotoMetadata.c"
	}
	{
		const gchar* _tmp3_;
		MetadataDomain _tmp4_ = 0;
#line 499 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp3_ = tag;
#line 499 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp4_ = photo_metadata_get_tag_domain (_tmp3_);
#line 499 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		switch (_tmp4_) {
#line 499 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
			case METADATA_DOMAIN_XMP:
#line 3923 "PhotoMetadata.c"
			{
				const gchar* _tmp5_;
				MetadataDateTime* _tmp6_;
				MetadataDateTime* _tmp7_;
#line 501 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
				_tmp5_ = value;
#line 501 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
				_tmp6_ = metadata_date_time_new_from_xmp (_tmp5_, &_inner_error_);
#line 501 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
				_tmp7_ = _tmp6_;
#line 501 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
				if (_inner_error_ != NULL) {
#line 3936 "PhotoMetadata.c"
					goto __catch24_g_error;
				}
#line 501 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
				result = _tmp7_;
#line 501 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
				_g_free0 (value);
#line 501 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
				return result;
#line 3945 "PhotoMetadata.c"
			}
#line 499 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
			case METADATA_DOMAIN_IPTC:
#line 3949 "PhotoMetadata.c"
			{
#line 506 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
				result = NULL;
#line 506 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
				_g_free0 (value);
#line 506 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
				return result;
#line 3957 "PhotoMetadata.c"
			}
			default:
#line 499 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
			case METADATA_DOMAIN_EXIF:
#line 3962 "PhotoMetadata.c"
			{
				const gchar* _tmp8_;
				MetadataDateTime* _tmp9_;
				MetadataDateTime* _tmp10_;
#line 510 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
				_tmp8_ = value;
#line 510 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
				_tmp9_ = metadata_date_time_new_from_exif (_tmp8_, &_inner_error_);
#line 510 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
				_tmp10_ = _tmp9_;
#line 510 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
				if (_inner_error_ != NULL) {
#line 3975 "PhotoMetadata.c"
					goto __catch24_g_error;
				}
#line 510 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
				result = _tmp10_;
#line 510 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
				_g_free0 (value);
#line 510 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
				return result;
#line 3984 "PhotoMetadata.c"
			}
		}
	}
	goto __finally24;
	__catch24_g_error:
	{
		GError* err = NULL;
		const gchar* _tmp11_;
		const gchar* _tmp12_;
		GError* _tmp13_;
		const gchar* _tmp14_;
#line 498 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		err = _inner_error_;
#line 498 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_inner_error_ = NULL;
#line 513 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp11_ = tag;
#line 513 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp12_ = self->priv->source_name;
#line 513 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp13_ = err;
#line 513 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp14_ = _tmp13_->message;
#line 513 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		g_warning ("PhotoMetadata.vala:513: Unable to read date/time %s from source %s: %s", _tmp11_, _tmp12_, _tmp14_);
#line 515 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		result = NULL;
#line 515 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_g_error_free0 (err);
#line 515 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_g_free0 (value);
#line 515 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		return result;
#line 4018 "PhotoMetadata.c"
	}
	__finally24:
#line 498 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_g_free0 (value);
#line 498 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 498 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	g_clear_error (&_inner_error_);
#line 498 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	return NULL;
#line 4029 "PhotoMetadata.c"
}


MetadataDateTime* photo_metadata_get_first_date_time (PhotoMetadata* self, gchar** tags, int tags_length1) {
	MetadataDateTime* result = NULL;
	gchar** _tmp0_;
	gint _tmp0__length1;
#line 519 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 520 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = tags;
#line 520 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp0__length1 = tags_length1;
#line 4043 "PhotoMetadata.c"
	{
		gchar** tag_collection = NULL;
		gint tag_collection_length1 = 0;
		gint _tag_collection_size_ = 0;
		gint tag_it = 0;
#line 520 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		tag_collection = _tmp0_;
#line 520 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		tag_collection_length1 = _tmp0__length1;
#line 520 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		for (tag_it = 0; tag_it < _tmp0__length1; tag_it = tag_it + 1) {
#line 4055 "PhotoMetadata.c"
			gchar* _tmp1_;
			gchar* tag = NULL;
#line 520 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
			_tmp1_ = g_strdup (tag_collection[tag_it]);
#line 520 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
			tag = _tmp1_;
#line 4062 "PhotoMetadata.c"
			{
				const gchar* _tmp2_;
				MetadataDateTime* _tmp3_ = NULL;
				MetadataDateTime* date_time;
				MetadataDateTime* _tmp4_;
#line 521 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
				_tmp2_ = tag;
#line 521 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
				_tmp3_ = photo_metadata_get_date_time (self, _tmp2_);
#line 521 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
				date_time = _tmp3_;
#line 522 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
				_tmp4_ = date_time;
#line 522 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
				if (_tmp4_ != NULL) {
#line 523 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
					result = date_time;
#line 523 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
					_g_free0 (tag);
#line 523 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
					return result;
#line 4084 "PhotoMetadata.c"
				}
#line 520 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
				_metadata_date_time_unref0 (date_time);
#line 520 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
				_g_free0 (tag);
#line 4090 "PhotoMetadata.c"
			}
		}
	}
#line 526 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	result = NULL;
#line 526 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	return result;
#line 4098 "PhotoMetadata.c"
}


void photo_metadata_set_date_time (PhotoMetadata* self, const gchar* tag, MetadataDateTime* date_time) {
	const gchar* _tmp0_;
	MetadataDomain _tmp1_ = 0;
#line 529 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 529 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	g_return_if_fail (tag != NULL);
#line 529 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	g_return_if_fail (IS_METADATA_DATE_TIME (date_time));
#line 530 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = tag;
#line 530 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp1_ = photo_metadata_get_tag_domain (_tmp0_);
#line 530 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	switch (_tmp1_) {
#line 530 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		case METADATA_DOMAIN_EXIF:
#line 4119 "PhotoMetadata.c"
		{
			const gchar* _tmp2_;
			MetadataDateTime* _tmp3_;
			gchar* _tmp4_ = NULL;
			gchar* _tmp5_;
#line 532 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
			_tmp2_ = tag;
#line 532 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
			_tmp3_ = date_time;
#line 532 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
			_tmp4_ = metadata_date_time_get_exif_label (_tmp3_);
#line 532 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
			_tmp5_ = _tmp4_;
#line 532 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
			photo_metadata_set_string (self, _tmp2_, _tmp5_);
#line 532 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
			_g_free0 (_tmp5_);
#line 533 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
			break;
#line 4139 "PhotoMetadata.c"
		}
#line 530 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		case METADATA_DOMAIN_XMP:
#line 4143 "PhotoMetadata.c"
		{
			const gchar* _tmp6_;
			MetadataDateTime* _tmp7_;
			gchar* _tmp8_ = NULL;
			gchar* _tmp9_;
#line 536 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
			_tmp6_ = tag;
#line 536 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
			_tmp7_ = date_time;
#line 536 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
			_tmp8_ = metadata_date_time_get_xmp_label (_tmp7_);
#line 536 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
			_tmp9_ = _tmp8_;
#line 536 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
			photo_metadata_set_string (self, _tmp6_, _tmp9_);
#line 536 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
			_g_free0 (_tmp9_);
#line 537 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
			break;
#line 4163 "PhotoMetadata.c"
		}
		default:
#line 530 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		case METADATA_DOMAIN_IPTC:
#line 4168 "PhotoMetadata.c"
		{
			const gchar* _tmp10_;
			const gchar* _tmp11_;
			const gchar* _tmp12_;
			MetadataDomain _tmp13_ = 0;
			GEnumValue* _tmp14_;
#line 542 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
			_tmp10_ = tag;
#line 542 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
			_tmp11_ = self->priv->source_name;
#line 542 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
			_tmp12_ = tag;
#line 542 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
			_tmp13_ = photo_metadata_get_tag_domain (_tmp12_);
#line 543 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
			_tmp14_ = g_enum_get_value (g_type_class_ref (TYPE_METADATA_DOMAIN), _tmp13_);
#line 542 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
			g_warning ("PhotoMetadata.vala:542: Cannot set date/time for %s from source %s: un" \
"supported metadata domain %s", _tmp10_, _tmp11_, (_tmp14_ != NULL) ? _tmp14_->value_name : NULL);
#line 544 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
			break;
#line 4189 "PhotoMetadata.c"
		}
	}
}


static gpointer _metadata_date_time_ref0 (gpointer self) {
#line 548 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	return self ? metadata_date_time_ref (self) : NULL;
#line 4198 "PhotoMetadata.c"
}


static Block5Data* block5_data_ref (Block5Data* _data5_) {
#line 548 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	g_atomic_int_inc (&_data5_->_ref_count_);
#line 548 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	return _data5_;
#line 4207 "PhotoMetadata.c"
}


static void block5_data_unref (Block5Data* _data5_) {
#line 548 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	if (g_atomic_int_dec_and_test (&_data5_->_ref_count_)) {
#line 548 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_media_metadata_unref0 (_data5_->self);
#line 548 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_metadata_date_time_unref0 (_data5_->date_time);
#line 548 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		g_slice_free (Block5Data, _data5_);
#line 4220 "PhotoMetadata.c"
	}
}


static void __lambda5_ (Block5Data* _data5_, const gchar* tag) {
	PhotoMetadata * self;
	const gchar* _tmp0_;
	MetadataDateTime* _tmp1_;
#line 549 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	self = _data5_->self;
#line 549 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	g_return_if_fail (tag != NULL);
#line 549 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = tag;
#line 549 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp1_ = _data5_->date_time;
#line 549 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	photo_metadata_set_date_time (self, _tmp0_, _tmp1_);
#line 4239 "PhotoMetadata.c"
}


static void ___lambda5__photo_metadata_set_generic_value (const gchar* tag, gpointer self) {
#line 549 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	__lambda5_ (self, tag);
#line 4246 "PhotoMetadata.c"
}


void photo_metadata_set_all_date_time (PhotoMetadata* self, gchar** tags, int tags_length1, MetadataDateTime* date_time, PhotoMetadataSetOption option) {
	Block5Data* _data5_;
	MetadataDateTime* _tmp0_;
	MetadataDateTime* _tmp1_;
	gchar** _tmp2_;
	gint _tmp2__length1;
	PhotoMetadataSetOption _tmp3_;
#line 548 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 548 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	g_return_if_fail (IS_METADATA_DATE_TIME (date_time));
#line 548 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_data5_ = g_slice_new0 (Block5Data);
#line 548 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_data5_->_ref_count_ = 1;
#line 548 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_data5_->self = media_metadata_ref (self);
#line 548 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = date_time;
#line 548 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp1_ = _metadata_date_time_ref0 (_tmp0_);
#line 548 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_data5_->date_time = _tmp1_;
#line 549 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp2_ = tags;
#line 549 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp2__length1 = tags_length1;
#line 549 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp3_ = option;
#line 549 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	photo_metadata_set_all_generic (self, _tmp2_, _tmp2__length1, _tmp3_, ___lambda5__photo_metadata_set_generic_value, _data5_);
#line 548 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	block5_data_unref (_data5_);
#line 548 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_data5_ = NULL;
#line 4285 "PhotoMetadata.c"
}


guint8* photo_metadata_flatten_exif (PhotoMetadata* self, gboolean include_preview, int* result_length1) {
	guint8* result = NULL;
	ExifData* _tmp0_;
	ExifData* _tmp2_;
	guchar* _tmp3_;
	guchar* thumbnail;
	ExifData* _tmp4_;
	guint _tmp5_;
	guint thumbnail_size;
	gboolean _tmp6_;
	guint8* flattened;
	gint flattened_length1;
	gint _flattened_size_;
	guchar* saved_data;
	guint saved_size;
	ExifData* _tmp9_;
	gboolean _tmp10_ = FALSE;
	guint _tmp11_;
	gboolean _tmp13_;
	ExifData* _tmp22_;
	guchar* _tmp23_;
	ExifData* _tmp24_;
	guint _tmp25_;
	guint8* _tmp26_;
	gint _tmp26__length1;
#line 553 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 554 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = self->priv->exif;
#line 554 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	if (_tmp0_ == NULL) {
#line 4320 "PhotoMetadata.c"
		guint8* _tmp1_;
		gint _tmp1__length1;
#line 555 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp1_ = NULL;
#line 555 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp1__length1 = 0;
#line 555 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		if (result_length1) {
#line 555 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
			*result_length1 = _tmp1__length1;
#line 4331 "PhotoMetadata.c"
		}
#line 555 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		result = _tmp1_;
#line 555 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		return result;
#line 4337 "PhotoMetadata.c"
	}
#line 559 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp2_ = self->priv->exif;
#line 559 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp3_ = _tmp2_->data;
#line 559 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	thumbnail = _tmp3_;
#line 560 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp4_ = self->priv->exif;
#line 560 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp5_ = _tmp4_->size;
#line 560 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	thumbnail_size = _tmp5_;
#line 561 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp6_ = include_preview;
#line 561 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	if (!_tmp6_) {
#line 4355 "PhotoMetadata.c"
		ExifData* _tmp7_;
		ExifData* _tmp8_;
#line 562 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp7_ = self->priv->exif;
#line 562 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp7_->data = NULL;
#line 563 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp8_ = self->priv->exif;
#line 563 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp8_->size = (guint) 0;
#line 4366 "PhotoMetadata.c"
	}
#line 566 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	flattened = NULL;
#line 566 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	flattened_length1 = 0;
#line 566 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_flattened_size_ = flattened_length1;
#line 569 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	saved_data = NULL;
#line 570 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	saved_size = (guint) 0;
#line 571 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp9_ = self->priv->exif;
#line 571 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	exif_data_save_data (_tmp9_, &saved_data, &saved_size);
#line 572 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp11_ = saved_size;
#line 572 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	if (_tmp11_ > ((guint) 0)) {
#line 4386 "PhotoMetadata.c"
		guchar* _tmp12_;
#line 572 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp12_ = saved_data;
#line 572 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp10_ = _tmp12_ != NULL;
#line 4392 "PhotoMetadata.c"
	} else {
#line 572 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp10_ = FALSE;
#line 4396 "PhotoMetadata.c"
	}
#line 572 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp13_ = _tmp10_;
#line 572 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	if (_tmp13_) {
#line 4402 "PhotoMetadata.c"
		guint _tmp14_;
		guint8* _tmp15_ = NULL;
		guint8* _tmp16_;
		gint _tmp16__length1;
		guchar* _tmp17_;
		guint _tmp18_;
		ExifMem* _tmp19_ = NULL;
		ExifMem* _tmp20_;
		guchar* _tmp21_;
#line 573 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp14_ = saved_size;
#line 573 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp15_ = g_new0 (guint8, _tmp14_);
#line 573 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		flattened = (g_free (flattened), NULL);
#line 573 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		flattened = _tmp15_;
#line 573 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		flattened_length1 = _tmp14_;
#line 573 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_flattened_size_ = flattened_length1;
#line 574 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp16_ = flattened;
#line 574 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp16__length1 = flattened_length1;
#line 574 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp17_ = saved_data;
#line 574 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp18_ = saved_size;
#line 574 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		memcpy (_tmp16_, _tmp17_, (gsize) _tmp18_);
#line 576 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp19_ = exif_mem_new_default ();
#line 576 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp20_ = _tmp19_;
#line 576 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp21_ = saved_data;
#line 576 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		exif_mem_free (_tmp20_, _tmp21_);
#line 576 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_exif_mem_unref0 (_tmp20_);
#line 4444 "PhotoMetadata.c"
	}
#line 580 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp22_ = self->priv->exif;
#line 580 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp23_ = thumbnail;
#line 580 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp22_->data = _tmp23_;
#line 581 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp24_ = self->priv->exif;
#line 581 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp25_ = thumbnail_size;
#line 581 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp24_->size = _tmp25_;
#line 583 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp26_ = flattened;
#line 583 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp26__length1 = flattened_length1;
#line 583 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	if (result_length1) {
#line 583 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		*result_length1 = _tmp26__length1;
#line 4466 "PhotoMetadata.c"
	}
#line 583 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	result = _tmp26_;
#line 583 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	return result;
#line 4472 "PhotoMetadata.c"
}


static guint8* _vala_array_dup8 (guint8* self, int length) {
#line 589 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	return g_memdup (self, length * sizeof (guint8));
#line 4479 "PhotoMetadata.c"
}


guint8* photo_metadata_flatten_exif_preview (PhotoMetadata* self, int* result_length1) {
	guint8* result = NULL;
	guchar* buffer = NULL;
	gint buffer_length1 = 0;
	gint _buffer_size_ = 0;
	guchar* _tmp0_ = NULL;
	gint _tmp0__length1 = 0;
	gint __tmp0__size_ = 0;
	GExiv2Metadata* _tmp1_;
	guchar* _tmp2_ = NULL;
	gint _tmp3_ = 0;
	gboolean _tmp4_ = FALSE;
	guchar* _tmp6_;
	gint _tmp6__length1;
	guint8* _tmp7_;
	gint _tmp7__length1;
	guint8* _tmp8_;
	gint _tmp8__length1;
#line 587 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 589 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp1_ = self->priv->exiv2;
#line 589 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp4_ = gexiv2_metadata_get_exif_thumbnail (_tmp1_, &_tmp2_, &_tmp3_);
#line 589 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	buffer = (g_free (buffer), NULL);
#line 589 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	buffer = _tmp2_;
#line 589 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	buffer_length1 = _tmp3_;
#line 589 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_buffer_size_ = buffer_length1;
#line 589 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	if (_tmp4_) {
#line 4517 "PhotoMetadata.c"
		guchar* _tmp5_;
		gint _tmp5__length1;
#line 589 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp5_ = buffer;
#line 589 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp5__length1 = buffer_length1;
#line 589 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp0_ = _tmp5_;
#line 589 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp0__length1 = _tmp5__length1;
#line 589 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		__tmp0__size_ = _tmp0__length1;
#line 4530 "PhotoMetadata.c"
	} else {
#line 589 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp0_ = NULL;
#line 589 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp0__length1 = 0;
#line 589 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		__tmp0__size_ = _tmp0__length1;
#line 4538 "PhotoMetadata.c"
	}
#line 589 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp6_ = _tmp0_;
#line 589 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp6__length1 = _tmp0__length1;
#line 589 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp7_ = (_tmp6_ != NULL) ? _vala_array_dup8 (_tmp6_, _tmp6__length1) : ((gpointer) _tmp6_);
#line 589 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp7__length1 = _tmp6__length1;
#line 589 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp8_ = _tmp7_;
#line 589 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp8__length1 = _tmp7__length1;
#line 589 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	if (result_length1) {
#line 589 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		*result_length1 = _tmp8__length1;
#line 4556 "PhotoMetadata.c"
	}
#line 589 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	result = _tmp8_;
#line 589 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	buffer = (g_free (buffer), NULL);
#line 589 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	return result;
#line 4564 "PhotoMetadata.c"
}


guint photo_metadata_get_preview_count (PhotoMetadata* self) {
	guint result = 0U;
	GExiv2Metadata* _tmp0_;
	GExiv2PreviewProperties** _tmp1_;
	GExiv2PreviewProperties** _tmp2_ = NULL;
	GExiv2PreviewProperties** props;
	gint props_length1;
	gint _props_size_;
	gint _tmp3_ = 0;
	GExiv2PreviewProperties** _tmp4_;
	gint _tmp4__length1;
	gint _tmp6_;
#line 592 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), 0U);
#line 593 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = self->priv->exiv2;
#line 593 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp2_ = _tmp1_ = gexiv2_metadata_get_preview_properties (_tmp0_);
#line 593 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	props = _tmp2_;
#line 593 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	props_length1 = _vala_array_length (_tmp1_);
#line 593 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_props_size_ = props_length1;
#line 595 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp4_ = props;
#line 595 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp4__length1 = props_length1;
#line 595 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	if (_tmp4_ != NULL) {
#line 4598 "PhotoMetadata.c"
		GExiv2PreviewProperties** _tmp5_;
		gint _tmp5__length1;
#line 595 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp5_ = props;
#line 595 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp5__length1 = props_length1;
#line 595 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp3_ = _tmp5__length1;
#line 4607 "PhotoMetadata.c"
	} else {
#line 595 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp3_ = 0;
#line 4611 "PhotoMetadata.c"
	}
#line 595 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp6_ = _tmp3_;
#line 595 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	result = (guint) _tmp6_;
#line 595 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	return result;
#line 4619 "PhotoMetadata.c"
}


PhotoPreview* photo_metadata_get_preview (PhotoMetadata* self, guint number) {
	PhotoPreview* result = NULL;
	GExiv2Metadata* _tmp0_;
	GExiv2PreviewProperties** _tmp1_;
	GExiv2PreviewProperties** _tmp2_ = NULL;
	GExiv2PreviewProperties** props;
	gint props_length1;
	gint _props_size_;
	gboolean _tmp3_ = FALSE;
	GExiv2PreviewProperties** _tmp4_;
	gint _tmp4__length1;
	gboolean _tmp7_;
	const gchar* _tmp8_;
	guint _tmp9_;
	GExiv2PreviewProperties** _tmp10_;
	gint _tmp10__length1;
	guint _tmp11_;
	GExiv2PreviewProperties* _tmp12_;
	PhotoMetadataInternalPhotoPreview* _tmp13_;
#line 599 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 600 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = self->priv->exiv2;
#line 600 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp2_ = _tmp1_ = gexiv2_metadata_get_preview_properties (_tmp0_);
#line 600 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	props = _tmp2_;
#line 600 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	props_length1 = _vala_array_length (_tmp1_);
#line 600 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_props_size_ = props_length1;
#line 601 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp4_ = props;
#line 601 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp4__length1 = props_length1;
#line 601 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	if (_tmp4_ == NULL) {
#line 601 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp3_ = TRUE;
#line 4662 "PhotoMetadata.c"
	} else {
		GExiv2PreviewProperties** _tmp5_;
		gint _tmp5__length1;
		guint _tmp6_;
#line 601 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp5_ = props;
#line 601 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp5__length1 = props_length1;
#line 601 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp6_ = number;
#line 601 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp3_ = ((guint) _tmp5__length1) <= _tmp6_;
#line 4675 "PhotoMetadata.c"
	}
#line 601 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp7_ = _tmp3_;
#line 601 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	if (_tmp7_) {
#line 602 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		result = NULL;
#line 602 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		return result;
#line 4685 "PhotoMetadata.c"
	}
#line 604 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp8_ = self->priv->source_name;
#line 604 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp9_ = number;
#line 604 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp10_ = props;
#line 604 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp10__length1 = props_length1;
#line 604 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp11_ = number;
#line 604 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp12_ = _tmp10_[_tmp11_];
#line 604 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp13_ = photo_metadata_internal_photo_preview_new (self, _tmp8_, _tmp9_, _tmp12_);
#line 604 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	result = PHOTO_PREVIEW (_tmp13_);
#line 604 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	return result;
#line 4705 "PhotoMetadata.c"
}


void photo_metadata_remove_exif_thumbnail (PhotoMetadata* self) {
	GExiv2Metadata* _tmp0_;
	ExifData* _tmp1_;
#line 607 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 608 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = self->priv->exiv2;
#line 608 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	gexiv2_metadata_erase_exif_thumbnail (_tmp0_);
#line 609 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp1_ = self->priv->exif;
#line 609 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	if (_tmp1_ != NULL) {
#line 4722 "PhotoMetadata.c"
		ExifMem* _tmp2_ = NULL;
		ExifMem* _tmp3_;
		ExifData* _tmp4_;
		guchar* _tmp5_;
		ExifData* _tmp6_;
		ExifData* _tmp7_;
#line 610 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp2_ = exif_mem_new_default ();
#line 610 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp3_ = _tmp2_;
#line 610 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp4_ = self->priv->exif;
#line 610 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp5_ = _tmp4_->data;
#line 610 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		exif_mem_free (_tmp3_, _tmp5_);
#line 610 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_exif_mem_unref0 (_tmp3_);
#line 611 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp6_ = self->priv->exif;
#line 611 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp6_->data = NULL;
#line 612 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp7_ = self->priv->exif;
#line 612 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp7_->size = (guint) 0;
#line 4749 "PhotoMetadata.c"
	}
}


void photo_metadata_remove_tag (PhotoMetadata* self, const gchar* tag) {
	GExiv2Metadata* _tmp0_;
	const gchar* _tmp1_;
#line 616 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 616 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	g_return_if_fail (tag != NULL);
#line 617 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = self->priv->exiv2;
#line 617 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp1_ = tag;
#line 617 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	gexiv2_metadata_clear_tag (_tmp0_, _tmp1_);
#line 4767 "PhotoMetadata.c"
}


void photo_metadata_remove_tags (PhotoMetadata* self, gchar** tags, int tags_length1) {
	gchar** _tmp0_;
	gint _tmp0__length1;
#line 620 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 621 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = tags;
#line 621 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp0__length1 = tags_length1;
#line 4780 "PhotoMetadata.c"
	{
		gchar** tag_collection = NULL;
		gint tag_collection_length1 = 0;
		gint _tag_collection_size_ = 0;
		gint tag_it = 0;
#line 621 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		tag_collection = _tmp0_;
#line 621 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		tag_collection_length1 = _tmp0__length1;
#line 621 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		for (tag_it = 0; tag_it < _tmp0__length1; tag_it = tag_it + 1) {
#line 4792 "PhotoMetadata.c"
			gchar* _tmp1_;
			gchar* tag = NULL;
#line 621 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
			_tmp1_ = g_strdup (tag_collection[tag_it]);
#line 621 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
			tag = _tmp1_;
#line 4799 "PhotoMetadata.c"
			{
				const gchar* _tmp2_;
#line 622 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
				_tmp2_ = tag;
#line 622 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
				photo_metadata_remove_tag (self, _tmp2_);
#line 621 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
				_g_free0 (tag);
#line 4808 "PhotoMetadata.c"
			}
		}
	}
}


void photo_metadata_clear_domain (PhotoMetadata* self, MetadataDomain domain) {
	MetadataDomain _tmp0_;
#line 625 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 626 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = domain;
#line 626 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	switch (_tmp0_) {
#line 626 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		case METADATA_DOMAIN_EXIF:
#line 4825 "PhotoMetadata.c"
		{
			GExiv2Metadata* _tmp1_;
#line 628 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
			_tmp1_ = self->priv->exiv2;
#line 628 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
			gexiv2_metadata_clear_exif (_tmp1_);
#line 629 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
			break;
#line 4834 "PhotoMetadata.c"
		}
#line 626 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		case METADATA_DOMAIN_XMP:
#line 4838 "PhotoMetadata.c"
		{
			GExiv2Metadata* _tmp2_;
#line 632 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
			_tmp2_ = self->priv->exiv2;
#line 632 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
			gexiv2_metadata_clear_xmp (_tmp2_);
#line 633 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
			break;
#line 4847 "PhotoMetadata.c"
		}
#line 626 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		case METADATA_DOMAIN_IPTC:
#line 4851 "PhotoMetadata.c"
		{
			GExiv2Metadata* _tmp3_;
#line 636 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
			_tmp3_ = self->priv->exiv2;
#line 636 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
			gexiv2_metadata_clear_iptc (_tmp3_);
#line 637 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
			break;
#line 4860 "PhotoMetadata.c"
		}
		default:
#line 626 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		break;
#line 4865 "PhotoMetadata.c"
	}
}


void photo_metadata_clear (PhotoMetadata* self) {
	GExiv2Metadata* _tmp0_;
#line 641 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 642 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = self->priv->exiv2;
#line 642 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	gexiv2_metadata_clear (_tmp0_);
#line 4878 "PhotoMetadata.c"
}


MetadataDateTime* photo_metadata_get_modification_date_time (PhotoMetadata* self) {
	MetadataDateTime* result = NULL;
	gchar** _tmp0_;
	gint _tmp0__length1;
	MetadataDateTime* _tmp1_ = NULL;
#line 651 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 652 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = photo_metadata_DATE_TIME_TAGS;
#line 652 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp0__length1 = photo_metadata_DATE_TIME_TAGS_length1;
#line 652 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp1_ = photo_metadata_get_first_date_time (self, _tmp0_, _tmp0__length1);
#line 652 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	result = _tmp1_;
#line 652 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	return result;
#line 4899 "PhotoMetadata.c"
}


void photo_metadata_set_modification_date_time (PhotoMetadata* self, MetadataDateTime* date_time, PhotoMetadataSetOption option) {
	MetadataDateTime* _tmp0_;
#line 655 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 655 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	g_return_if_fail ((date_time == NULL) || IS_METADATA_DATE_TIME (date_time));
#line 657 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = date_time;
#line 657 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	if (_tmp0_ != NULL) {
#line 4913 "PhotoMetadata.c"
		gchar** _tmp1_;
		gint _tmp1__length1;
		MetadataDateTime* _tmp2_;
		PhotoMetadataSetOption _tmp3_;
#line 658 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp1_ = photo_metadata_DATE_TIME_TAGS;
#line 658 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp1__length1 = photo_metadata_DATE_TIME_TAGS_length1;
#line 658 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp2_ = date_time;
#line 658 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp3_ = option;
#line 658 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		photo_metadata_set_all_date_time (self, _tmp1_, _tmp1__length1, _tmp2_, _tmp3_);
#line 4928 "PhotoMetadata.c"
	} else {
		gchar** _tmp4_;
		gint _tmp4__length1;
#line 660 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp4_ = photo_metadata_DATE_TIME_TAGS;
#line 660 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp4__length1 = photo_metadata_DATE_TIME_TAGS_length1;
#line 660 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		photo_metadata_remove_tags (self, _tmp4_, _tmp4__length1);
#line 4938 "PhotoMetadata.c"
	}
}


MetadataDateTime* photo_metadata_get_exposure_date_time (PhotoMetadata* self) {
	MetadataDateTime* result = NULL;
	gchar** _tmp0_;
	gint _tmp0__length1;
	MetadataDateTime* _tmp1_ = NULL;
#line 672 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 673 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = photo_metadata_EXPOSURE_DATE_TIME_TAGS;
#line 673 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp0__length1 = photo_metadata_EXPOSURE_DATE_TIME_TAGS_length1;
#line 673 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp1_ = photo_metadata_get_first_date_time (self, _tmp0_, _tmp0__length1);
#line 673 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	result = _tmp1_;
#line 673 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	return result;
#line 4960 "PhotoMetadata.c"
}


void photo_metadata_set_exposure_date_time (PhotoMetadata* self, MetadataDateTime* date_time, PhotoMetadataSetOption option) {
	MetadataDateTime* _tmp0_;
#line 676 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 676 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	g_return_if_fail ((date_time == NULL) || IS_METADATA_DATE_TIME (date_time));
#line 678 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = date_time;
#line 678 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	if (_tmp0_ != NULL) {
#line 4974 "PhotoMetadata.c"
		gchar** _tmp1_;
		gint _tmp1__length1;
		MetadataDateTime* _tmp2_;
		PhotoMetadataSetOption _tmp3_;
#line 679 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp1_ = photo_metadata_EXPOSURE_DATE_TIME_TAGS;
#line 679 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp1__length1 = photo_metadata_EXPOSURE_DATE_TIME_TAGS_length1;
#line 679 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp2_ = date_time;
#line 679 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp3_ = option;
#line 679 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		photo_metadata_set_all_date_time (self, _tmp1_, _tmp1__length1, _tmp2_, _tmp3_);
#line 4989 "PhotoMetadata.c"
	} else {
		gchar** _tmp4_;
		gint _tmp4__length1;
#line 681 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp4_ = photo_metadata_EXPOSURE_DATE_TIME_TAGS;
#line 681 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp4__length1 = photo_metadata_EXPOSURE_DATE_TIME_TAGS_length1;
#line 681 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		photo_metadata_remove_tags (self, _tmp4_, _tmp4__length1);
#line 4999 "PhotoMetadata.c"
	}
}


MetadataDateTime* photo_metadata_get_digitized_date_time (PhotoMetadata* self) {
	MetadataDateTime* result = NULL;
	gchar** _tmp0_;
	gint _tmp0__length1;
	MetadataDateTime* _tmp1_ = NULL;
#line 689 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 690 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = photo_metadata_DIGITIZED_DATE_TIME_TAGS;
#line 690 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp0__length1 = photo_metadata_DIGITIZED_DATE_TIME_TAGS_length1;
#line 690 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp1_ = photo_metadata_get_first_date_time (self, _tmp0_, _tmp0__length1);
#line 690 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	result = _tmp1_;
#line 690 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	return result;
#line 5021 "PhotoMetadata.c"
}


void photo_metadata_set_digitized_date_time (PhotoMetadata* self, MetadataDateTime* date_time, PhotoMetadataSetOption option) {
	MetadataDateTime* _tmp0_;
#line 693 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 693 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	g_return_if_fail ((date_time == NULL) || IS_METADATA_DATE_TIME (date_time));
#line 695 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = date_time;
#line 695 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	if (_tmp0_ != NULL) {
#line 5035 "PhotoMetadata.c"
		gchar** _tmp1_;
		gint _tmp1__length1;
		MetadataDateTime* _tmp2_;
		PhotoMetadataSetOption _tmp3_;
#line 696 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp1_ = photo_metadata_DIGITIZED_DATE_TIME_TAGS;
#line 696 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp1__length1 = photo_metadata_DIGITIZED_DATE_TIME_TAGS_length1;
#line 696 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp2_ = date_time;
#line 696 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp3_ = option;
#line 696 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		photo_metadata_set_all_date_time (self, _tmp1_, _tmp1__length1, _tmp2_, _tmp3_);
#line 5050 "PhotoMetadata.c"
	} else {
		gchar** _tmp4_;
		gint _tmp4__length1;
#line 698 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp4_ = photo_metadata_DIGITIZED_DATE_TIME_TAGS;
#line 698 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp4__length1 = photo_metadata_DIGITIZED_DATE_TIME_TAGS_length1;
#line 698 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		photo_metadata_remove_tags (self, _tmp4_, _tmp4__length1);
#line 5060 "PhotoMetadata.c"
	}
}


static MetadataDateTime* photo_metadata_real_get_creation_date_time (MediaMetadata* base) {
	PhotoMetadata * self;
	MetadataDateTime* result = NULL;
	MetadataDateTime* _tmp0_ = NULL;
	MetadataDateTime* creation;
	MetadataDateTime* _tmp1_;
#line 701 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	self = PHOTO_METADATA (base);
#line 702 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = photo_metadata_get_exposure_date_time (self);
#line 702 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	creation = _tmp0_;
#line 703 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp1_ = creation;
#line 703 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	if (_tmp1_ == NULL) {
#line 5081 "PhotoMetadata.c"
		MetadataDateTime* _tmp2_ = NULL;
#line 704 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp2_ = photo_metadata_get_digitized_date_time (self);
#line 704 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_metadata_date_time_unref0 (creation);
#line 704 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		creation = _tmp2_;
#line 5089 "PhotoMetadata.c"
	}
#line 706 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	result = creation;
#line 706 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	return result;
#line 5095 "PhotoMetadata.c"
}


static gpointer _dimensions_dup0 (gpointer self) {
#line 737 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	return self ? dimensions_dup (self) : NULL;
#line 5102 "PhotoMetadata.c"
}


Dimensions* photo_metadata_get_pixel_dimensions (PhotoMetadata* self) {
	Dimensions* result = NULL;
	gchar** _tmp0_;
	gint _tmp0__length1;
	gchar** _tmp1_;
	gint _tmp1__length1;
#line 723 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 725 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = photo_metadata_WIDTH_TAGS;
#line 725 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp0__length1 = photo_metadata_WIDTH_TAGS_length1;
#line 725 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp1_ = photo_metadata_HEIGHT_TAGS;
#line 725 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp1__length1 = photo_metadata_HEIGHT_TAGS_length1;
#line 725 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	g_assert (_tmp0__length1 == _tmp1__length1);
#line 5124 "PhotoMetadata.c"
	{
		gint ctr;
#line 726 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		ctr = 0;
#line 5129 "PhotoMetadata.c"
		{
			gboolean _tmp2_;
#line 726 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
			_tmp2_ = TRUE;
#line 726 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
			while (TRUE) {
#line 5136 "PhotoMetadata.c"
				gboolean _tmp3_;
				gint _tmp5_;
				gchar** _tmp6_;
				gint _tmp6__length1;
				glong width = 0L;
				gchar** _tmp7_;
				gint _tmp7__length1;
				gint _tmp8_;
				const gchar* _tmp9_;
				glong _tmp10_ = 0L;
				gboolean _tmp11_ = FALSE;
				glong height = 0L;
				gchar** _tmp12_;
				gint _tmp12__length1;
				gint _tmp13_;
				const gchar* _tmp14_;
				glong _tmp15_ = 0L;
				gboolean _tmp16_ = FALSE;
				glong _tmp17_;
				glong _tmp18_;
				Dimensions _tmp19_ = {0};
				Dimensions* _tmp20_;
#line 726 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
				_tmp3_ = _tmp2_;
#line 726 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
				if (!_tmp3_) {
#line 5163 "PhotoMetadata.c"
					gint _tmp4_;
#line 726 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
					_tmp4_ = ctr;
#line 726 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
					ctr = _tmp4_ + 1;
#line 5169 "PhotoMetadata.c"
				}
#line 726 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
				_tmp2_ = FALSE;
#line 726 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
				_tmp5_ = ctr;
#line 726 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
				_tmp6_ = photo_metadata_WIDTH_TAGS;
#line 726 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
				_tmp6__length1 = photo_metadata_WIDTH_TAGS_length1;
#line 726 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
				if (!(_tmp5_ < _tmp6__length1)) {
#line 726 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
					break;
#line 5183 "PhotoMetadata.c"
				}
#line 730 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
				_tmp7_ = photo_metadata_WIDTH_TAGS;
#line 730 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
				_tmp7__length1 = photo_metadata_WIDTH_TAGS_length1;
#line 730 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
				_tmp8_ = ctr;
#line 730 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
				_tmp9_ = _tmp7_[_tmp8_];
#line 730 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
				_tmp11_ = photo_metadata_get_long (self, _tmp9_, &_tmp10_);
#line 730 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
				width = _tmp10_;
#line 730 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
				if (!_tmp11_) {
#line 731 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
					continue;
#line 5201 "PhotoMetadata.c"
				}
#line 734 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
				_tmp12_ = photo_metadata_HEIGHT_TAGS;
#line 734 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
				_tmp12__length1 = photo_metadata_HEIGHT_TAGS_length1;
#line 734 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
				_tmp13_ = ctr;
#line 734 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
				_tmp14_ = _tmp12_[_tmp13_];
#line 734 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
				_tmp16_ = photo_metadata_get_long (self, _tmp14_, &_tmp15_);
#line 734 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
				height = _tmp15_;
#line 734 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
				if (!_tmp16_) {
#line 735 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
					continue;
#line 5219 "PhotoMetadata.c"
				}
#line 737 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
				_tmp17_ = width;
#line 737 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
				_tmp18_ = height;
#line 737 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
				dimensions_init (&_tmp19_, (gint) _tmp17_, (gint) _tmp18_);
#line 737 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
				_tmp20_ = _dimensions_dup0 (&_tmp19_);
#line 737 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
				result = _tmp20_;
#line 737 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
				return result;
#line 5233 "PhotoMetadata.c"
			}
		}
	}
#line 740 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	result = NULL;
#line 740 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	return result;
#line 5241 "PhotoMetadata.c"
}


void photo_metadata_set_pixel_dimensions (PhotoMetadata* self, Dimensions* dim, PhotoMetadataSetOption option) {
	Dimensions* _tmp0_;
#line 743 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 744 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = dim;
#line 744 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	if (_tmp0_ != NULL) {
#line 5253 "PhotoMetadata.c"
		gchar** _tmp1_;
		gint _tmp1__length1;
		Dimensions* _tmp2_;
		gint _tmp3_;
		PhotoMetadataSetOption _tmp4_;
		gchar** _tmp5_;
		gint _tmp5__length1;
		Dimensions* _tmp6_;
		gint _tmp7_;
		PhotoMetadataSetOption _tmp8_;
#line 745 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp1_ = photo_metadata_WIDTH_TAGS;
#line 745 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp1__length1 = photo_metadata_WIDTH_TAGS_length1;
#line 745 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp2_ = dim;
#line 745 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp3_ = (*_tmp2_).width;
#line 745 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp4_ = option;
#line 745 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		photo_metadata_set_all_long (self, _tmp1_, _tmp1__length1, (glong) _tmp3_, _tmp4_);
#line 746 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp5_ = photo_metadata_HEIGHT_TAGS;
#line 746 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp5__length1 = photo_metadata_HEIGHT_TAGS_length1;
#line 746 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp6_ = dim;
#line 746 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp7_ = (*_tmp6_).height;
#line 746 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp8_ = option;
#line 746 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		photo_metadata_set_all_long (self, _tmp5_, _tmp5__length1, (glong) _tmp7_, _tmp8_);
#line 5288 "PhotoMetadata.c"
	} else {
		gchar** _tmp9_;
		gint _tmp9__length1;
		gchar** _tmp10_;
		gint _tmp10__length1;
#line 748 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp9_ = photo_metadata_WIDTH_TAGS;
#line 748 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp9__length1 = photo_metadata_WIDTH_TAGS_length1;
#line 748 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		photo_metadata_remove_tags (self, _tmp9_, _tmp9__length1);
#line 749 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp10_ = photo_metadata_HEIGHT_TAGS;
#line 749 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp10__length1 = photo_metadata_HEIGHT_TAGS_length1;
#line 749 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		photo_metadata_remove_tags (self, _tmp10_, _tmp10__length1);
#line 5306 "PhotoMetadata.c"
	}
}


static gchar* string_strip (const gchar* self) {
	gchar* result = NULL;
	gchar* _tmp0_ = NULL;
	gchar* _result_;
	const gchar* _tmp1_;
#line 1229 "/usr/share/vala-0.14/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1230 "/usr/share/vala-0.14/vapi/glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1230 "/usr/share/vala-0.14/vapi/glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1231 "/usr/share/vala-0.14/vapi/glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1231 "/usr/share/vala-0.14/vapi/glib-2.0.vapi"
	g_strstrip (_tmp1_);
#line 1232 "/usr/share/vala-0.14/vapi/glib-2.0.vapi"
	result = _result_;
#line 1232 "/usr/share/vala-0.14/vapi/glib-2.0.vapi"
	return result;
#line 5330 "PhotoMetadata.c"
}


static gboolean string_contains (const gchar* self, const gchar* needle) {
	gboolean result = FALSE;
	const gchar* _tmp0_;
	gchar* _tmp1_ = NULL;
#line 1382 "/usr/share/vala-0.14/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1382 "/usr/share/vala-0.14/vapi/glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1383 "/usr/share/vala-0.14/vapi/glib-2.0.vapi"
	_tmp0_ = needle;
#line 1383 "/usr/share/vala-0.14/vapi/glib-2.0.vapi"
	_tmp1_ = strstr ((gchar*) self, (gchar*) _tmp0_);
#line 1383 "/usr/share/vala-0.14/vapi/glib-2.0.vapi"
	result = _tmp1_ != NULL;
#line 1383 "/usr/share/vala-0.14/vapi/glib-2.0.vapi"
	return result;
#line 5350 "PhotoMetadata.c"
}


static gchar* photo_metadata_real_get_title (MediaMetadata* base) {
	PhotoMetadata * self;
	gchar* result = NULL;
	GeeList* _tmp0_ = NULL;
	gboolean _tmp1_ = FALSE;
	GeeList* _tmp5_;
	GeeList* _tmp6_;
	GeeList* titles;
	gchar* _tmp7_ = NULL;
	gboolean _tmp8_ = FALSE;
	GeeList* _tmp9_;
	gboolean _tmp13_;
	const gchar* _tmp16_;
	gchar* _tmp17_;
	gchar* title;
	const gchar* _tmp18_;
	const gchar* _tmp21_ = NULL;
	gboolean _tmp22_ = FALSE;
	gboolean _tmp23_ = FALSE;
	const gchar* _tmp24_;
	gboolean _tmp25_ = FALSE;
	gboolean _tmp28_;
	gboolean _tmp31_;
	const gchar* _tmp33_;
	gchar* _tmp34_;
#line 782 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	self = PHOTO_METADATA (base);
#line 790 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp1_ = photo_metadata_has_tag (self, PHOTO_METADATA_IPHOTO_TITLE_TAG);
#line 790 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	if (_tmp1_) {
#line 5385 "PhotoMetadata.c"
		GeeList* _tmp2_ = NULL;
#line 791 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp2_ = photo_metadata_get_string_multiple (self, PHOTO_METADATA_IPHOTO_TITLE_TAG);
#line 791 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_g_object_unref0 (_tmp0_);
#line 791 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp0_ = _tmp2_;
#line 5393 "PhotoMetadata.c"
	} else {
		gchar** _tmp3_;
		gint _tmp3__length1;
		GeeList* _tmp4_ = NULL;
#line 792 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp3_ = photo_metadata_STANDARD_TITLE_TAGS;
#line 792 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp3__length1 = photo_metadata_STANDARD_TITLE_TAGS_length1;
#line 792 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp4_ = photo_metadata_get_first_string_multiple (self, _tmp3_, _tmp3__length1);
#line 792 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_g_object_unref0 (_tmp0_);
#line 792 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp0_ = _tmp4_;
#line 5408 "PhotoMetadata.c"
	}
#line 790 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp5_ = _tmp0_;
#line 790 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp6_ = _g_object_ref0 (_tmp5_);
#line 790 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	titles = _tmp6_;
#line 797 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp9_ = titles;
#line 797 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	if (_tmp9_ != NULL) {
#line 5420 "PhotoMetadata.c"
		GeeList* _tmp10_;
		gint _tmp11_;
		gint _tmp12_;
#line 797 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp10_ = titles;
#line 797 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp11_ = gee_collection_get_size (GEE_COLLECTION (_tmp10_));
#line 797 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp12_ = _tmp11_;
#line 797 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp8_ = _tmp12_ > 0;
#line 5432 "PhotoMetadata.c"
	} else {
#line 797 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp8_ = FALSE;
#line 5436 "PhotoMetadata.c"
	}
#line 797 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp13_ = _tmp8_;
#line 797 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	if (_tmp13_) {
#line 5442 "PhotoMetadata.c"
		GeeList* _tmp14_;
		gpointer _tmp15_ = NULL;
#line 797 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp14_ = titles;
#line 797 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp15_ = gee_list_get (_tmp14_, 0);
#line 797 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_g_free0 (_tmp7_);
#line 797 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp7_ = (gchar*) _tmp15_;
#line 5453 "PhotoMetadata.c"
	} else {
#line 797 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_g_free0 (_tmp7_);
#line 797 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp7_ = NULL;
#line 5459 "PhotoMetadata.c"
	}
#line 797 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp16_ = _tmp7_;
#line 797 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp17_ = g_strdup (_tmp16_);
#line 797 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	title = _tmp17_;
#line 800 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp18_ = title;
#line 800 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	if (_tmp18_ != NULL) {
#line 5471 "PhotoMetadata.c"
		const gchar* _tmp19_;
		gchar* _tmp20_ = NULL;
#line 801 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp19_ = title;
#line 801 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp20_ = string_strip (_tmp19_);
#line 801 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_g_free0 (title);
#line 801 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		title = _tmp20_;
#line 5482 "PhotoMetadata.c"
	}
#line 804 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp24_ = title;
#line 804 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp25_ = is_string_empty (_tmp24_);
#line 804 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	if (!_tmp25_) {
#line 5490 "PhotoMetadata.c"
		const gchar* _tmp26_;
		gboolean _tmp27_ = FALSE;
#line 804 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp26_ = title;
#line 804 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp27_ = string_contains (_tmp26_, "\n");
#line 804 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp23_ = !_tmp27_;
#line 5499 "PhotoMetadata.c"
	} else {
#line 804 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp23_ = FALSE;
#line 5503 "PhotoMetadata.c"
	}
#line 804 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp28_ = _tmp23_;
#line 804 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	if (_tmp28_) {
#line 5509 "PhotoMetadata.c"
		const gchar* _tmp29_;
		gboolean _tmp30_ = FALSE;
#line 804 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp29_ = title;
#line 804 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp30_ = string_contains (_tmp29_, "\r");
#line 804 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp22_ = !_tmp30_;
#line 5518 "PhotoMetadata.c"
	} else {
#line 804 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp22_ = FALSE;
#line 5522 "PhotoMetadata.c"
	}
#line 804 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp31_ = _tmp22_;
#line 804 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	if (_tmp31_) {
#line 5528 "PhotoMetadata.c"
		const gchar* _tmp32_;
#line 805 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp32_ = title;
#line 805 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp21_ = _tmp32_;
#line 5534 "PhotoMetadata.c"
	} else {
#line 805 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp21_ = NULL;
#line 5538 "PhotoMetadata.c"
	}
#line 804 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp33_ = _tmp21_;
#line 804 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp34_ = g_strdup (_tmp33_);
#line 804 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	result = _tmp34_;
#line 804 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_g_free0 (title);
#line 804 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_g_free0 (_tmp7_);
#line 804 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_g_object_unref0 (titles);
#line 804 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_g_object_unref0 (_tmp0_);
#line 804 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	return result;
#line 5556 "PhotoMetadata.c"
}


void photo_metadata_set_title (PhotoMetadata* self, const gchar* title, PhotoMetadataSetOption option) {
	const gchar* _tmp0_;
	gboolean _tmp1_ = FALSE;
#line 808 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 809 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = title;
#line 809 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp1_ = is_string_empty (_tmp0_);
#line 809 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	if (!_tmp1_) {
#line 5571 "PhotoMetadata.c"
		gboolean _tmp2_ = FALSE;
#line 810 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp2_ = photo_metadata_has_tag (self, PHOTO_METADATA_IPHOTO_TITLE_TAG);
#line 810 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		if (_tmp2_) {
#line 5577 "PhotoMetadata.c"
			const gchar* _tmp3_;
#line 811 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
			_tmp3_ = title;
#line 811 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
			photo_metadata_set_string (self, PHOTO_METADATA_IPHOTO_TITLE_TAG, _tmp3_);
#line 5583 "PhotoMetadata.c"
		} else {
			gchar** _tmp4_;
			gint _tmp4__length1;
			const gchar* _tmp5_;
			PhotoMetadataSetOption _tmp6_;
#line 813 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
			_tmp4_ = photo_metadata_STANDARD_TITLE_TAGS;
#line 813 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
			_tmp4__length1 = photo_metadata_STANDARD_TITLE_TAGS_length1;
#line 813 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
			_tmp5_ = title;
#line 813 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
			_tmp6_ = option;
#line 813 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
			photo_metadata_set_all_string (self, _tmp4_, _tmp4__length1, _tmp5_, _tmp6_);
#line 5599 "PhotoMetadata.c"
		}
	} else {
		gchar** _tmp7_;
		gint _tmp7__length1;
#line 815 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp7_ = photo_metadata_STANDARD_TITLE_TAGS;
#line 815 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp7__length1 = photo_metadata_STANDARD_TITLE_TAGS_length1;
#line 815 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		photo_metadata_remove_tags (self, _tmp7_, _tmp7__length1);
#line 5610 "PhotoMetadata.c"
	}
}


GeeSet* photo_metadata_get_keywords (PhotoMetadata* self, GCompareFunc compare_func) {
	GeeSet* result = NULL;
	GeeSet* keywords;
	gchar** _tmp0_;
	gint _tmp0__length1;
	GeeSet* _tmp15_ = NULL;
	gboolean _tmp16_ = FALSE;
	GeeSet* _tmp17_;
	gboolean _tmp21_;
	GeeSet* _tmp23_;
	GeeSet* _tmp24_;
#line 824 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 825 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	keywords = NULL;
#line 826 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = photo_metadata_KEYWORD_TAGS;
#line 826 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp0__length1 = photo_metadata_KEYWORD_TAGS_length1;
#line 5634 "PhotoMetadata.c"
	{
		gchar** tag_collection = NULL;
		gint tag_collection_length1 = 0;
		gint _tag_collection_size_ = 0;
		gint tag_it = 0;
#line 826 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		tag_collection = _tmp0_;
#line 826 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		tag_collection_length1 = _tmp0__length1;
#line 826 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		for (tag_it = 0; tag_it < _tmp0__length1; tag_it = tag_it + 1) {
#line 5646 "PhotoMetadata.c"
			gchar* _tmp1_;
			gchar* tag = NULL;
#line 826 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
			_tmp1_ = g_strdup (tag_collection[tag_it]);
#line 826 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
			tag = _tmp1_;
#line 5653 "PhotoMetadata.c"
			{
				const gchar* _tmp2_;
				GeeList* _tmp3_ = NULL;
				GeeCollection* values;
				gboolean _tmp4_ = FALSE;
				GeeCollection* _tmp5_;
				gboolean _tmp9_;
#line 827 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
				_tmp2_ = tag;
#line 827 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
				_tmp3_ = photo_metadata_get_string_multiple (self, _tmp2_);
#line 827 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
				values = GEE_COLLECTION (_tmp3_);
#line 828 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
				_tmp5_ = values;
#line 828 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
				if (_tmp5_ != NULL) {
#line 5671 "PhotoMetadata.c"
					GeeCollection* _tmp6_;
					gint _tmp7_;
					gint _tmp8_;
#line 828 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
					_tmp6_ = values;
#line 828 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
					_tmp7_ = gee_collection_get_size (_tmp6_);
#line 828 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
					_tmp8_ = _tmp7_;
#line 828 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
					_tmp4_ = _tmp8_ > 0;
#line 5683 "PhotoMetadata.c"
				} else {
#line 828 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
					_tmp4_ = FALSE;
#line 5687 "PhotoMetadata.c"
				}
#line 828 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
				_tmp9_ = _tmp4_;
#line 828 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
				if (_tmp9_) {
#line 5693 "PhotoMetadata.c"
					GeeSet* _tmp10_;
					GeeSet* _tmp13_;
					GeeCollection* _tmp14_;
#line 829 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
					_tmp10_ = keywords;
#line 829 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
					if (_tmp10_ == NULL) {
#line 5701 "PhotoMetadata.c"
						GCompareFunc _tmp11_;
						GeeSet* _tmp12_ = NULL;
#line 830 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
						_tmp11_ = compare_func;
#line 830 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
						_tmp12_ = photo_metadata_create_string_set (self, _tmp11_);
#line 830 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
						_g_object_unref0 (keywords);
#line 830 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
						keywords = _tmp12_;
#line 5712 "PhotoMetadata.c"
					}
#line 832 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
					_tmp13_ = keywords;
#line 832 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
					_tmp14_ = values;
#line 832 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
					gee_collection_add_all (GEE_COLLECTION (_tmp13_), _tmp14_);
#line 5720 "PhotoMetadata.c"
				}
#line 826 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
				_g_object_unref0 (values);
#line 826 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
				_g_free0 (tag);
#line 5726 "PhotoMetadata.c"
			}
		}
	}
#line 836 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp17_ = keywords;
#line 836 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	if (_tmp17_ != NULL) {
#line 5734 "PhotoMetadata.c"
		GeeSet* _tmp18_;
		gint _tmp19_;
		gint _tmp20_;
#line 836 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp18_ = keywords;
#line 836 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp19_ = gee_collection_get_size (GEE_COLLECTION (_tmp18_));
#line 836 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp20_ = _tmp19_;
#line 836 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp16_ = _tmp20_ > 0;
#line 5746 "PhotoMetadata.c"
	} else {
#line 836 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp16_ = FALSE;
#line 5750 "PhotoMetadata.c"
	}
#line 836 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp21_ = _tmp16_;
#line 836 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	if (_tmp21_) {
#line 5756 "PhotoMetadata.c"
		GeeSet* _tmp22_;
#line 836 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp22_ = keywords;
#line 836 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp15_ = _tmp22_;
#line 5762 "PhotoMetadata.c"
	} else {
#line 836 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp15_ = NULL;
#line 5766 "PhotoMetadata.c"
	}
#line 836 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp23_ = _tmp15_;
#line 836 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp24_ = _g_object_ref0 (_tmp23_);
#line 836 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	result = _tmp24_;
#line 836 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_g_object_unref0 (keywords);
#line 836 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	return result;
#line 5778 "PhotoMetadata.c"
}


void photo_metadata_set_keywords (PhotoMetadata* self, GeeCollection* keywords, PhotoMetadataSetOption option) {
	GeeCollection* _tmp0_;
#line 839 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 839 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	g_return_if_fail ((keywords == NULL) || GEE_IS_COLLECTION (keywords));
#line 840 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = keywords;
#line 840 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	if (_tmp0_ != NULL) {
#line 5792 "PhotoMetadata.c"
		gchar** _tmp1_;
		gint _tmp1__length1;
		GeeCollection* _tmp2_;
		PhotoMetadataSetOption _tmp3_;
#line 841 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp1_ = photo_metadata_KEYWORD_TAGS;
#line 841 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp1__length1 = photo_metadata_KEYWORD_TAGS_length1;
#line 841 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp2_ = keywords;
#line 841 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp3_ = option;
#line 841 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		photo_metadata_set_all_string_multiple (self, _tmp1_, _tmp1__length1, _tmp2_, _tmp3_);
#line 5807 "PhotoMetadata.c"
	} else {
		gchar** _tmp4_;
		gint _tmp4__length1;
#line 843 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp4_ = photo_metadata_KEYWORD_TAGS;
#line 843 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp4__length1 = photo_metadata_KEYWORD_TAGS_length1;
#line 843 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		photo_metadata_remove_tags (self, _tmp4_, _tmp4__length1);
#line 5817 "PhotoMetadata.c"
	}
}


gboolean photo_metadata_has_orientation (PhotoMetadata* self) {
	gboolean result = FALSE;
	GExiv2Metadata* _tmp0_;
	GExiv2Orientation _tmp1_ = 0;
#line 846 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), FALSE);
#line 847 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = self->priv->exiv2;
#line 847 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp1_ = gexiv2_metadata_get_orientation (_tmp0_);
#line 847 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	result = _tmp1_ == GEXIV2_ORIENTATION_UNSPECIFIED;
#line 847 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	return result;
#line 5836 "PhotoMetadata.c"
}


Orientation photo_metadata_get_orientation (PhotoMetadata* self) {
	Orientation result = 0;
	GExiv2Metadata* _tmp0_;
	GExiv2Orientation _tmp1_ = 0;
	GExiv2Orientation orientation;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	GExiv2Orientation _tmp4_;
	gboolean _tmp6_;
	gboolean _tmp8_;
#line 851 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), 0);
#line 854 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = self->priv->exiv2;
#line 854 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp1_ = gexiv2_metadata_get_orientation (_tmp0_);
#line 854 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	orientation = _tmp1_;
#line 855 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp4_ = orientation;
#line 855 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	if (_tmp4_ == GEXIV2_ORIENTATION_UNSPECIFIED) {
#line 855 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp3_ = TRUE;
#line 5864 "PhotoMetadata.c"
	} else {
		GExiv2Orientation _tmp5_;
#line 855 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp5_ = orientation;
#line 855 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp3_ = _tmp5_ < ORIENTATION_MIN;
#line 5871 "PhotoMetadata.c"
	}
#line 855 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp6_ = _tmp3_;
#line 855 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	if (_tmp6_) {
#line 855 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp2_ = TRUE;
#line 5879 "PhotoMetadata.c"
	} else {
		GExiv2Orientation _tmp7_;
#line 856 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp7_ = orientation;
#line 856 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp2_ = _tmp7_ > ORIENTATION_MAX;
#line 5886 "PhotoMetadata.c"
	}
#line 855 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp8_ = _tmp2_;
#line 855 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	if (_tmp8_) {
#line 857 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		result = ORIENTATION_TOP_LEFT;
#line 857 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		return result;
#line 5896 "PhotoMetadata.c"
	} else {
		GExiv2Orientation _tmp9_;
#line 859 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp9_ = orientation;
#line 859 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		result = (Orientation) _tmp9_;
#line 859 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		return result;
#line 5905 "PhotoMetadata.c"
	}
}


void photo_metadata_set_orientation (PhotoMetadata* self, Orientation orientation) {
	GExiv2Metadata* _tmp0_;
	Orientation _tmp1_;
#line 862 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 864 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = self->priv->exiv2;
#line 864 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp1_ = orientation;
#line 864 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	gexiv2_metadata_set_orientation (_tmp0_, (GExiv2Orientation) _tmp1_);
#line 5921 "PhotoMetadata.c"
}


gboolean photo_metadata_get_gps (PhotoMetadata* self, gdouble* longitude, gchar** long_ref, gdouble* latitude, gchar** lat_ref, gdouble* altitude) {
	gdouble _vala_longitude = 0.0;
	gchar* _vala_long_ref = NULL;
	gdouble _vala_latitude = 0.0;
	gchar* _vala_lat_ref = NULL;
	gdouble _vala_altitude = 0.0;
	gboolean result = FALSE;
	GExiv2Metadata* _tmp0_;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_ = 0.0;
	gboolean _tmp4_ = FALSE;
	gchar* _tmp5_ = NULL;
	gchar* _tmp6_ = NULL;
#line 867 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), FALSE);
#line 869 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = self->priv->exiv2;
#line 869 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp4_ = gexiv2_metadata_get_gps_info (_tmp0_, &_tmp1_, &_tmp2_, &_tmp3_);
#line 869 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_vala_longitude = _tmp1_;
#line 869 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_vala_latitude = _tmp2_;
#line 869 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_vala_altitude = _tmp3_;
#line 869 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	if (!_tmp4_) {
#line 870 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		result = FALSE;
#line 870 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		if (longitude) {
#line 870 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
			*longitude = _vala_longitude;
#line 5959 "PhotoMetadata.c"
		}
#line 870 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		if (long_ref) {
#line 870 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
			*long_ref = _vala_long_ref;
#line 5965 "PhotoMetadata.c"
		} else {
#line 870 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
			_g_free0 (_vala_long_ref);
#line 5969 "PhotoMetadata.c"
		}
#line 870 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		if (latitude) {
#line 870 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
			*latitude = _vala_latitude;
#line 5975 "PhotoMetadata.c"
		}
#line 870 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		if (lat_ref) {
#line 870 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
			*lat_ref = _vala_lat_ref;
#line 5981 "PhotoMetadata.c"
		} else {
#line 870 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
			_g_free0 (_vala_lat_ref);
#line 5985 "PhotoMetadata.c"
		}
#line 870 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		if (altitude) {
#line 870 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
			*altitude = _vala_altitude;
#line 5991 "PhotoMetadata.c"
		}
#line 870 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		return result;
#line 5995 "PhotoMetadata.c"
	}
#line 872 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp5_ = photo_metadata_get_string (self, "Exif.GPSInfo.GPSLongitudeRef");
#line 872 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_g_free0 (_vala_long_ref);
#line 872 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_vala_long_ref = _tmp5_;
#line 873 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp6_ = photo_metadata_get_string (self, "Exif.GPSInfo.GPSLatitudeRef");
#line 873 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_g_free0 (_vala_lat_ref);
#line 873 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_vala_lat_ref = _tmp6_;
#line 875 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	result = TRUE;
#line 875 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	if (longitude) {
#line 875 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		*longitude = _vala_longitude;
#line 6015 "PhotoMetadata.c"
	}
#line 875 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	if (long_ref) {
#line 875 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		*long_ref = _vala_long_ref;
#line 6021 "PhotoMetadata.c"
	} else {
#line 875 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_g_free0 (_vala_long_ref);
#line 6025 "PhotoMetadata.c"
	}
#line 875 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	if (latitude) {
#line 875 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		*latitude = _vala_latitude;
#line 6031 "PhotoMetadata.c"
	}
#line 875 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	if (lat_ref) {
#line 875 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		*lat_ref = _vala_lat_ref;
#line 6037 "PhotoMetadata.c"
	} else {
#line 875 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_g_free0 (_vala_lat_ref);
#line 6041 "PhotoMetadata.c"
	}
#line 875 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	if (altitude) {
#line 875 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		*altitude = _vala_altitude;
#line 6047 "PhotoMetadata.c"
	}
#line 875 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	return result;
#line 6051 "PhotoMetadata.c"
}


gboolean photo_metadata_get_exposure (PhotoMetadata* self, MetadataRational* exposure) {
	MetadataRational _vala_exposure = {0};
	gboolean result = FALSE;
	MetadataRational _tmp0_ = {0};
	gboolean _tmp1_ = FALSE;
#line 878 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), FALSE);
#line 879 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp1_ = photo_metadata_get_rational (self, "Exif.Photo.ExposureTime", &_tmp0_);
#line 879 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_vala_exposure = _tmp0_;
#line 879 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	result = _tmp1_;
#line 879 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	if (exposure) {
#line 879 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		*exposure = _vala_exposure;
#line 6072 "PhotoMetadata.c"
	}
#line 879 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	return result;
#line 6076 "PhotoMetadata.c"
}


gchar* photo_metadata_get_exposure_string (PhotoMetadata* self) {
	gchar* result = NULL;
	MetadataRational exposure_time = {0};
	MetadataRational _tmp0_ = {0};
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gchar* _tmp3_ = NULL;
#line 882 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 884 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp1_ = photo_metadata_get_rational (self, "Exif.Photo.ExposureTime", &_tmp0_);
#line 884 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	exposure_time = _tmp0_;
#line 884 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	if (!_tmp1_) {
#line 885 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		result = NULL;
#line 885 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		return result;
#line 6099 "PhotoMetadata.c"
	}
#line 887 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp2_ = metadata_rational_is_valid (&exposure_time);
#line 887 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	if (!_tmp2_) {
#line 888 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		result = NULL;
#line 888 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		return result;
#line 6109 "PhotoMetadata.c"
	}
#line 890 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp3_ = photo_metadata_get_string_interpreted (self, "Exif.Photo.ExposureTime");
#line 890 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	result = _tmp3_;
#line 890 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	return result;
#line 6117 "PhotoMetadata.c"
}


gboolean photo_metadata_get_iso (PhotoMetadata* self, glong* iso) {
	glong _vala_iso = 0L;
	gboolean result = FALSE;
	glong _tmp0_ = 0L;
	gboolean _tmp1_ = FALSE;
	gboolean fetched_ok;
	gboolean _tmp2_;
	gboolean _tmp3_ = FALSE;
	glong _tmp4_;
	gboolean _tmp6_;
#line 893 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), FALSE);
#line 894 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp1_ = photo_metadata_get_long (self, "Exif.Photo.ISOSpeedRatings", &_tmp0_);
#line 894 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_vala_iso = _tmp0_;
#line 894 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	fetched_ok = _tmp1_;
#line 896 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp2_ = fetched_ok;
#line 896 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	if (_tmp2_ == FALSE) {
#line 897 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		result = FALSE;
#line 897 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		if (iso) {
#line 897 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
			*iso = _vala_iso;
#line 6149 "PhotoMetadata.c"
		}
#line 897 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		return result;
#line 6153 "PhotoMetadata.c"
	}
#line 901 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp4_ = _vala_iso;
#line 901 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	if (_tmp4_ < ((glong) 6)) {
#line 901 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp3_ = TRUE;
#line 6161 "PhotoMetadata.c"
	} else {
		glong _tmp5_;
#line 901 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp5_ = _vala_iso;
#line 901 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp3_ = _tmp5_ > ((glong) 409600);
#line 6168 "PhotoMetadata.c"
	}
#line 901 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp6_ = _tmp3_;
#line 901 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	if (_tmp6_) {
#line 902 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		result = FALSE;
#line 902 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		if (iso) {
#line 902 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
			*iso = _vala_iso;
#line 6180 "PhotoMetadata.c"
		}
#line 902 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		return result;
#line 6184 "PhotoMetadata.c"
	}
#line 904 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	result = TRUE;
#line 904 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	if (iso) {
#line 904 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		*iso = _vala_iso;
#line 6192 "PhotoMetadata.c"
	}
#line 904 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	return result;
#line 6196 "PhotoMetadata.c"
}


gchar* photo_metadata_get_iso_string (PhotoMetadata* self) {
	gchar* result = NULL;
	glong iso = 0L;
	glong _tmp0_ = 0L;
	gboolean _tmp1_ = FALSE;
	gchar* _tmp2_ = NULL;
#line 907 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 909 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp1_ = photo_metadata_get_iso (self, &_tmp0_);
#line 909 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	iso = _tmp0_;
#line 909 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	if (!_tmp1_) {
#line 910 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		result = NULL;
#line 910 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		return result;
#line 6218 "PhotoMetadata.c"
	}
#line 912 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp2_ = photo_metadata_get_string_interpreted (self, "Exif.Photo.ISOSpeedRatings");
#line 912 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	result = _tmp2_;
#line 912 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	return result;
#line 6226 "PhotoMetadata.c"
}


gboolean photo_metadata_get_aperture (PhotoMetadata* self, MetadataRational* aperture) {
	MetadataRational _vala_aperture = {0};
	gboolean result = FALSE;
	MetadataRational _tmp0_ = {0};
	gboolean _tmp1_ = FALSE;
#line 915 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), FALSE);
#line 916 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp1_ = photo_metadata_get_rational (self, "Exif.Photo.FNumber", &_tmp0_);
#line 916 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_vala_aperture = _tmp0_;
#line 916 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	result = _tmp1_;
#line 916 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	if (aperture) {
#line 916 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		*aperture = _vala_aperture;
#line 6247 "PhotoMetadata.c"
	}
#line 916 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	return result;
#line 6251 "PhotoMetadata.c"
}


gchar* photo_metadata_get_aperture_string (PhotoMetadata* self, gboolean pango_formatted) {
	gchar* result = NULL;
	MetadataRational aperture = {0};
	MetadataRational _tmp0_ = {0};
	gboolean _tmp1_ = FALSE;
	MetadataRational _tmp2_;
	gint _tmp3_;
	MetadataRational _tmp4_;
	gint _tmp5_;
	gdouble aperture_value;
	gdouble _tmp6_;
	const gchar* _tmp7_ = NULL;
	gboolean _tmp8_;
	const gchar* _tmp9_ = NULL;
	gdouble _tmp10_;
	const gchar* _tmp11_;
	const gchar* _tmp12_;
	gdouble _tmp13_;
	gchar* _tmp14_ = NULL;
	gchar* _tmp15_;
	gchar* _tmp16_;
	gchar* _tmp17_;
#line 919 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 921 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp1_ = photo_metadata_get_aperture (self, &_tmp0_);
#line 921 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	aperture = _tmp0_;
#line 921 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	if (!_tmp1_) {
#line 922 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		result = NULL;
#line 922 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		return result;
#line 6289 "PhotoMetadata.c"
	}
#line 924 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp2_ = aperture;
#line 924 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp3_ = _tmp2_.numerator;
#line 924 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp4_ = aperture;
#line 924 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp5_ = _tmp4_.denominator;
#line 924 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	aperture_value = ((gdouble) _tmp3_) / ((gdouble) _tmp5_);
#line 925 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp6_ = aperture_value;
#line 925 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	aperture_value = ((gint) (_tmp6_ * 10.0)) / 10.0;
#line 927 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp8_ = pango_formatted;
#line 927 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	if (_tmp8_) {
#line 927 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp7_ = "<i>f</i>/";
#line 6311 "PhotoMetadata.c"
	} else {
#line 927 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp7_ = "f/";
#line 6315 "PhotoMetadata.c"
	}
#line 928 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp10_ = aperture_value;
#line 928 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	if (fmod (_tmp10_, 1) == ((gdouble) 0)) {
#line 928 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp9_ = "%.0f";
#line 6323 "PhotoMetadata.c"
	} else {
#line 928 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp9_ = "%.1f";
#line 6327 "PhotoMetadata.c"
	}
#line 927 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp11_ = _tmp7_;
#line 927 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp12_ = _tmp9_;
#line 927 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp13_ = aperture_value;
#line 927 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp14_ = g_strdup_printf (_tmp12_, _tmp13_);
#line 927 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp15_ = _tmp14_;
#line 927 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp16_ = g_strconcat (_tmp11_, _tmp15_, NULL);
#line 927 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp17_ = _tmp16_;
#line 927 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_g_free0 (_tmp15_);
#line 927 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	result = _tmp17_;
#line 927 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	return result;
#line 6349 "PhotoMetadata.c"
}


gchar* photo_metadata_get_camera_make (PhotoMetadata* self) {
	gchar* result = NULL;
	gchar* _tmp0_ = NULL;
#line 931 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 932 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = photo_metadata_get_string_interpreted (self, "Exif.Image.Make");
#line 932 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	result = _tmp0_;
#line 932 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	return result;
#line 6364 "PhotoMetadata.c"
}


gchar* photo_metadata_get_camera_model (PhotoMetadata* self) {
	gchar* result = NULL;
	gchar* _tmp0_ = NULL;
#line 935 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 936 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = photo_metadata_get_string_interpreted (self, "Exif.Image.Model");
#line 936 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	result = _tmp0_;
#line 936 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	return result;
#line 6379 "PhotoMetadata.c"
}


gboolean photo_metadata_get_flash (PhotoMetadata* self, glong* flash) {
	glong _vala_flash = 0L;
	gboolean result = FALSE;
	glong _tmp0_ = 0L;
	gboolean _tmp1_ = FALSE;
#line 939 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), FALSE);
#line 941 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp1_ = photo_metadata_get_long (self, "Exif.Photo.Flash", &_tmp0_);
#line 941 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_vala_flash = _tmp0_;
#line 941 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	result = _tmp1_;
#line 941 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	if (flash) {
#line 941 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		*flash = _vala_flash;
#line 6400 "PhotoMetadata.c"
	}
#line 941 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	return result;
#line 6404 "PhotoMetadata.c"
}


gchar* photo_metadata_get_flash_string (PhotoMetadata* self) {
	gchar* result = NULL;
	gchar* _tmp0_ = NULL;
#line 944 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 946 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = photo_metadata_get_string_interpreted (self, "Exif.Photo.Flash");
#line 946 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	result = _tmp0_;
#line 946 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	return result;
#line 6419 "PhotoMetadata.c"
}


gboolean photo_metadata_get_focal_length (PhotoMetadata* self, MetadataRational* focal_length) {
	MetadataRational _vala_focal_length = {0};
	gboolean result = FALSE;
	MetadataRational _tmp0_ = {0};
	gboolean _tmp1_ = FALSE;
#line 949 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), FALSE);
#line 950 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp1_ = photo_metadata_get_rational (self, "Exif.Photo.FocalLength", &_tmp0_);
#line 950 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_vala_focal_length = _tmp0_;
#line 950 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	result = _tmp1_;
#line 950 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	if (focal_length) {
#line 950 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		*focal_length = _vala_focal_length;
#line 6440 "PhotoMetadata.c"
	}
#line 950 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	return result;
#line 6444 "PhotoMetadata.c"
}


gchar* photo_metadata_get_focal_length_string (PhotoMetadata* self) {
	gchar* result = NULL;
	gchar* _tmp0_ = NULL;
#line 953 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 954 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = photo_metadata_get_string_interpreted (self, "Exif.Photo.FocalLength");
#line 954 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	result = _tmp0_;
#line 954 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	return result;
#line 6459 "PhotoMetadata.c"
}


gchar* photo_metadata_get_artist (PhotoMetadata* self) {
	gchar* result = NULL;
	gchar** _tmp0_;
	gint _tmp0__length1;
	gchar* _tmp1_ = NULL;
#line 962 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 963 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = photo_metadata_ARTIST_TAGS;
#line 963 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp0__length1 = photo_metadata_ARTIST_TAGS_length1;
#line 963 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp1_ = photo_metadata_get_first_string_interpreted (self, _tmp0_, _tmp0__length1);
#line 963 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	result = _tmp1_;
#line 963 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	return result;
#line 6480 "PhotoMetadata.c"
}


gchar* photo_metadata_get_copyright (PhotoMetadata* self) {
	gchar* result = NULL;
	gchar* _tmp0_ = NULL;
#line 966 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 967 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = photo_metadata_get_string_interpreted (self, "Exif.Image.Copyright");
#line 967 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	result = _tmp0_;
#line 967 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	return result;
#line 6495 "PhotoMetadata.c"
}


gchar* photo_metadata_get_software (PhotoMetadata* self) {
	gchar* result = NULL;
	gchar* _tmp0_ = NULL;
#line 970 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 971 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = photo_metadata_get_string_interpreted (self, "Exif.Image.Software");
#line 971 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	result = _tmp0_;
#line 971 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	return result;
#line 6510 "PhotoMetadata.c"
}


void photo_metadata_set_software (PhotoMetadata* self, const gchar* software, const gchar* version) {
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_;
	gboolean _tmp4_ = FALSE;
#line 974 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 974 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	g_return_if_fail (software != NULL);
#line 974 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	g_return_if_fail (version != NULL);
#line 976 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = software;
#line 976 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp1_ = version;
#line 976 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp2_ = g_strdup_printf ("%s %s", _tmp0_, _tmp1_);
#line 976 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp3_ = _tmp2_;
#line 976 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	photo_metadata_set_string (self, "Exif.Image.Software", _tmp3_);
#line 976 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_g_free0 (_tmp3_);
#line 978 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp4_ = photo_metadata_has_iptc (self);
#line 978 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	if (_tmp4_) {
#line 6542 "PhotoMetadata.c"
		const gchar* _tmp5_;
		const gchar* _tmp6_;
#line 979 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp5_ = software;
#line 979 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		photo_metadata_set_string (self, "Iptc.Application2.Program", _tmp5_);
#line 980 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp6_ = version;
#line 980 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		photo_metadata_set_string (self, "Iptc.Application2.ProgramVersion", _tmp6_);
#line 6553 "PhotoMetadata.c"
	}
}


void photo_metadata_remove_software (PhotoMetadata* self) {
#line 984 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 985 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	photo_metadata_remove_tag (self, "Exif.Image.Software");
#line 986 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	photo_metadata_remove_tag (self, "Iptc.Application2.Program");
#line 987 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	photo_metadata_remove_tag (self, "Iptc.Application2.ProgramVersion");
#line 6567 "PhotoMetadata.c"
}


gchar* photo_metadata_get_exposure_bias (PhotoMetadata* self) {
	gchar* result = NULL;
	gchar* _tmp0_ = NULL;
#line 990 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), NULL);
#line 991 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = photo_metadata_get_string_interpreted (self, "Exif.Photo.ExposureBiasValue");
#line 991 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	result = _tmp0_;
#line 991 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	return result;
#line 6582 "PhotoMetadata.c"
}


Rating photo_metadata_get_rating (PhotoMetadata* self) {
	Rating result = 0;
	gchar** _tmp0_;
	gint _tmp0__length1;
	gchar* _tmp1_ = NULL;
	gchar* rating_string;
	Rating _tmp2_ = 0;
	const gchar* _tmp3_;
#line 1000 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (self), 0);
#line 1001 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = photo_metadata_RATING_TAGS;
#line 1001 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp0__length1 = photo_metadata_RATING_TAGS_length1;
#line 1001 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp1_ = photo_metadata_get_first_string (self, _tmp0_, _tmp0__length1);
#line 1001 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	rating_string = _tmp1_;
#line 1002 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp3_ = rating_string;
#line 1002 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	if (_tmp3_ == NULL) {
#line 1002 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp2_ = RATING_UNRATED;
#line 6610 "PhotoMetadata.c"
	} else {
		const gchar* _tmp4_;
		gint _tmp5_ = 0;
		Rating _tmp6_ = 0;
#line 1002 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp4_ = rating_string;
#line 1002 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp5_ = atoi (_tmp4_);
#line 1002 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp6_ = rating_unserialize (_tmp5_);
#line 1002 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp2_ = _tmp6_;
#line 6623 "PhotoMetadata.c"
	}
#line 1002 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	result = _tmp2_;
#line 1002 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_g_free0 (rating_string);
#line 1002 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	return result;
#line 6631 "PhotoMetadata.c"
}


void photo_metadata_set_rating (PhotoMetadata* self, Rating rating) {
	Rating _tmp0_;
	gint _tmp1_ = 0;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_;
#line 1010 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	g_return_if_fail (IS_PHOTO_METADATA (self));
#line 1011 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = rating;
#line 1011 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp1_ = rating_serialize (_tmp0_);
#line 1011 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp2_ = g_strdup_printf ("%i", _tmp1_);
#line 1011 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp3_ = _tmp2_;
#line 1011 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	photo_metadata_set_string (self, "Xmp.xmp.Rating", _tmp3_);
#line 1011 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_g_free0 (_tmp3_);
#line 6654 "PhotoMetadata.c"
}


static gpointer _media_metadata_ref0 (gpointer self) {
#line 108 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	return self ? media_metadata_ref (self) : NULL;
#line 6661 "PhotoMetadata.c"
}


static PhotoMetadataInternalPhotoPreview* photo_metadata_internal_photo_preview_construct (GType object_type, PhotoMetadata* owner, const gchar* name, guint number, GExiv2PreviewProperties* props) {
	PhotoMetadataInternalPhotoPreview* self = NULL;
	const gchar* _tmp0_;
	GExiv2PreviewProperties* _tmp1_;
	guint32 _tmp2_ = 0U;
	GExiv2PreviewProperties* _tmp3_;
	guint32 _tmp4_ = 0U;
	Dimensions _tmp5_ = {0};
	GExiv2PreviewProperties* _tmp6_;
	guint32 _tmp7_ = 0U;
	GExiv2PreviewProperties* _tmp8_;
	const gchar* _tmp9_ = NULL;
	GExiv2PreviewProperties* _tmp10_;
	const gchar* _tmp11_ = NULL;
	PhotoMetadata* _tmp12_;
	PhotoMetadata* _tmp13_;
	guint _tmp14_;
#line 103 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (IS_PHOTO_METADATA (owner), NULL);
#line 103 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 103 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	g_return_val_if_fail (props != NULL, NULL);
#line 105 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = name;
#line 105 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp1_ = props;
#line 105 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp2_ = gexiv2_preview_properties_get_width (_tmp1_);
#line 105 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp3_ = props;
#line 105 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp4_ = gexiv2_preview_properties_get_height (_tmp3_);
#line 105 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	dimensions_init (&_tmp5_, (gint) _tmp2_, (gint) _tmp4_);
#line 105 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp6_ = props;
#line 105 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp7_ = gexiv2_preview_properties_get_size (_tmp6_);
#line 105 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp8_ = props;
#line 105 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp9_ = gexiv2_preview_properties_get_mime_type (_tmp8_);
#line 105 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp10_ = props;
#line 105 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp11_ = gexiv2_preview_properties_get_extension (_tmp10_);
#line 105 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	self = (PhotoMetadataInternalPhotoPreview*) photo_preview_construct (object_type, _tmp0_, &_tmp5_, _tmp7_, _tmp9_, _tmp11_);
#line 108 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp12_ = owner;
#line 108 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp13_ = _media_metadata_ref0 (_tmp12_);
#line 108 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_media_metadata_unref0 (self->owner);
#line 108 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	self->owner = _tmp13_;
#line 109 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp14_ = number;
#line 109 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	self->number = _tmp14_;
#line 103 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	return self;
#line 6728 "PhotoMetadata.c"
}


static PhotoMetadataInternalPhotoPreview* photo_metadata_internal_photo_preview_new (PhotoMetadata* owner, const gchar* name, guint number, GExiv2PreviewProperties* props) {
#line 103 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	return photo_metadata_internal_photo_preview_construct (PHOTO_METADATA_TYPE_INTERNAL_PHOTO_PREVIEW, owner, name, number, props);
#line 6735 "PhotoMetadata.c"
}


static guint8* _vala_array_dup9 (guint8* self, int length) {
#line 116 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	return g_memdup (self, length * sizeof (guint8));
#line 6742 "PhotoMetadata.c"
}


static guint8* photo_metadata_internal_photo_preview_real_flatten (PhotoPreview* base, int* result_length1, GError** error) {
	PhotoMetadataInternalPhotoPreview * self;
	guint8* result = NULL;
	PhotoMetadata* _tmp0_;
	GExiv2Metadata* _tmp1_;
	GExiv2PreviewProperties** _tmp2_;
	GExiv2PreviewProperties** _tmp3_ = NULL;
	GExiv2PreviewProperties** props;
	gint props_length1;
	gint _props_size_;
	gboolean _tmp4_ = FALSE;
	GExiv2PreviewProperties** _tmp5_;
	gint _tmp5__length1;
	gboolean _tmp8_;
	PhotoMetadata* _tmp9_;
	GExiv2Metadata* _tmp10_;
	GExiv2PreviewProperties** _tmp11_;
	gint _tmp11__length1;
	guint _tmp12_;
	GExiv2PreviewProperties* _tmp13_;
	GExiv2PreviewImage* _tmp14_ = NULL;
	GExiv2PreviewImage* _tmp15_;
	gint _tmp16_ = 0;
	guchar** _tmp17_ = NULL;
	guint8* _tmp18_;
	gint _tmp18__length1;
	guint8* _tmp19_;
	gint _tmp19__length1;
	guint8* _tmp20_;
	gint _tmp20__length1;
#line 112 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	self = PHOTO_METADATA_INTERNAL_PHOTO_PREVIEW (base);
#line 113 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = self->owner;
#line 113 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp1_ = _tmp0_->priv->exiv2;
#line 113 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp3_ = _tmp2_ = gexiv2_metadata_get_preview_properties (_tmp1_);
#line 113 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	props = _tmp3_;
#line 113 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	props_length1 = _vala_array_length (_tmp2_);
#line 113 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_props_size_ = props_length1;
#line 114 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp5_ = props;
#line 114 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp5__length1 = props_length1;
#line 114 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	if (_tmp5_ != NULL) {
#line 6796 "PhotoMetadata.c"
		GExiv2PreviewProperties** _tmp6_;
		gint _tmp6__length1;
		guint _tmp7_;
#line 114 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp6_ = props;
#line 114 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp6__length1 = props_length1;
#line 114 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp7_ = self->number;
#line 114 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp4_ = ((guint) _tmp6__length1) > _tmp7_;
#line 6808 "PhotoMetadata.c"
	} else {
#line 114 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		_tmp4_ = FALSE;
#line 6812 "PhotoMetadata.c"
	}
#line 114 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp8_ = _tmp4_;
#line 114 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	g_assert (_tmp8_);
#line 116 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp9_ = self->owner;
#line 116 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp10_ = _tmp9_->priv->exiv2;
#line 116 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp11_ = props;
#line 116 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp11__length1 = props_length1;
#line 116 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp12_ = self->number;
#line 116 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp13_ = _tmp11_[_tmp12_];
#line 116 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp14_ = gexiv2_metadata_get_preview_image (_tmp10_, _tmp13_);
#line 116 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp15_ = _tmp14_;
#line 116 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp17_ = gexiv2_preview_image_get_data (_tmp15_, &_tmp16_);
#line 116 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp18_ = (_tmp17_ != NULL) ? _vala_array_dup9 (_tmp17_, _tmp16_) : ((gpointer) _tmp17_);
#line 116 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp18__length1 = _tmp16_;
#line 116 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp19_ = _tmp18_;
#line 116 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp19__length1 = _tmp18__length1;
#line 116 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_gexiv2_preview_image_free0 (_tmp15_);
#line 116 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp20_ = _tmp19_;
#line 116 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp20__length1 = _tmp19__length1;
#line 116 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	if (result_length1) {
#line 116 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
		*result_length1 = _tmp20__length1;
#line 6854 "PhotoMetadata.c"
	}
#line 116 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	result = _tmp20_;
#line 116 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	return result;
#line 6860 "PhotoMetadata.c"
}


static void photo_metadata_internal_photo_preview_class_init (PhotoMetadataInternalPhotoPreviewClass * klass) {
#line 99 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	photo_metadata_internal_photo_preview_parent_class = g_type_class_peek_parent (klass);
#line 99 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	PHOTO_PREVIEW_CLASS (klass)->finalize = photo_metadata_internal_photo_preview_finalize;
#line 99 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	PHOTO_PREVIEW_CLASS (klass)->flatten = photo_metadata_internal_photo_preview_real_flatten;
#line 6871 "PhotoMetadata.c"
}


static void photo_metadata_internal_photo_preview_instance_init (PhotoMetadataInternalPhotoPreview * self) {
}


static void photo_metadata_internal_photo_preview_finalize (PhotoPreview* obj) {
	PhotoMetadataInternalPhotoPreview * self;
#line 99 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	self = PHOTO_METADATA_INTERNAL_PHOTO_PREVIEW (obj);
#line 100 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_media_metadata_unref0 (self->owner);
#line 99 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	PHOTO_PREVIEW_CLASS (photo_metadata_internal_photo_preview_parent_class)->finalize (obj);
#line 6887 "PhotoMetadata.c"
}


static GType photo_metadata_internal_photo_preview_get_type (void) {
	static volatile gsize photo_metadata_internal_photo_preview_type_id__volatile = 0;
	if (g_once_init_enter (&photo_metadata_internal_photo_preview_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PhotoMetadataInternalPhotoPreviewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_metadata_internal_photo_preview_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoMetadataInternalPhotoPreview), 0, (GInstanceInitFunc) photo_metadata_internal_photo_preview_instance_init, NULL };
		GType photo_metadata_internal_photo_preview_type_id;
		photo_metadata_internal_photo_preview_type_id = g_type_register_static (TYPE_PHOTO_PREVIEW, "PhotoMetadataInternalPhotoPreview", &g_define_type_info, 0);
		g_once_init_leave (&photo_metadata_internal_photo_preview_type_id__volatile, photo_metadata_internal_photo_preview_type_id);
	}
	return photo_metadata_internal_photo_preview_type_id__volatile;
}


static void photo_metadata_class_init (PhotoMetadataClass * klass) {
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar** _tmp3_ = NULL;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar** _tmp10_ = NULL;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gchar** _tmp13_ = NULL;
	gchar* _tmp14_;
	gchar* _tmp15_;
	gchar* _tmp16_;
	gchar* _tmp17_;
	gchar** _tmp18_ = NULL;
	gchar* _tmp19_;
	gchar* _tmp20_;
	gchar* _tmp21_;
	gchar* _tmp22_;
	gchar** _tmp23_ = NULL;
	gchar* _tmp24_;
	gchar* _tmp25_;
	gchar* _tmp26_;
	gchar* _tmp27_;
	gchar** _tmp28_ = NULL;
	gchar* _tmp29_;
	gchar* _tmp30_;
	gchar** _tmp31_ = NULL;
	gchar* _tmp32_;
	gchar* _tmp33_;
	gchar** _tmp34_ = NULL;
	gchar* _tmp35_;
	gchar* _tmp36_;
	gchar* _tmp37_;
	gchar** _tmp38_ = NULL;
#line 84 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	photo_metadata_parent_class = g_type_class_peek_parent (klass);
#line 84 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	MEDIA_METADATA_CLASS (klass)->finalize = photo_metadata_finalize;
#line 84 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	g_type_class_add_private (klass, sizeof (PhotoMetadataPrivate));
#line 84 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	MEDIA_METADATA_CLASS (klass)->read_from_file = photo_metadata_real_read_from_file;
#line 84 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	MEDIA_METADATA_CLASS (klass)->get_creation_date_time = photo_metadata_real_get_creation_date_time;
#line 84 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	MEDIA_METADATA_CLASS (klass)->get_title = photo_metadata_real_get_title;
#line 645 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = g_strdup ("Exif.Image.DateTime");
#line 645 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp1_ = g_strdup ("Xmp.tiff.DateTime");
#line 645 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp2_ = g_strdup ("Xmp.xmp.ModifyDate");
#line 645 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp3_ = g_new0 (gchar*, 3 + 1);
#line 645 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp3_[0] = _tmp0_;
#line 645 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp3_[1] = _tmp1_;
#line 645 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp3_[2] = _tmp2_;
#line 645 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	photo_metadata_DATE_TIME_TAGS = _tmp3_;
#line 645 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	photo_metadata_DATE_TIME_TAGS_length1 = 3;
#line 663 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp4_ = g_strdup ("Exif.Photo.DateTimeOriginal");
#line 663 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp5_ = g_strdup ("Xmp.exif.DateTimeOriginal");
#line 663 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp6_ = g_strdup ("Xmp.xmp.CreateDate");
#line 663 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp7_ = g_strdup ("Exif.Photo.DateTimeDigitized");
#line 663 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp8_ = g_strdup ("Xmp.exif.DateTimeDigitized");
#line 663 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp9_ = g_strdup ("Exif.Image.DateTime");
#line 663 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp10_ = g_new0 (gchar*, 6 + 1);
#line 663 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp10_[0] = _tmp4_;
#line 663 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp10_[1] = _tmp5_;
#line 663 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp10_[2] = _tmp6_;
#line 663 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp10_[3] = _tmp7_;
#line 663 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp10_[4] = _tmp8_;
#line 663 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp10_[5] = _tmp9_;
#line 663 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	photo_metadata_EXPOSURE_DATE_TIME_TAGS = _tmp10_;
#line 663 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	photo_metadata_EXPOSURE_DATE_TIME_TAGS_length1 = 6;
#line 684 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp11_ = g_strdup ("Exif.Photo.DateTimeDigitized");
#line 684 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp12_ = g_strdup ("Xmp.exif.DateTimeDigitized");
#line 684 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp13_ = g_new0 (gchar*, 2 + 1);
#line 684 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp13_[0] = _tmp11_;
#line 684 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp13_[1] = _tmp12_;
#line 684 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	photo_metadata_DIGITIZED_DATE_TIME_TAGS = _tmp13_;
#line 684 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	photo_metadata_DIGITIZED_DATE_TIME_TAGS_length1 = 2;
#line 709 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp14_ = g_strdup ("Exif.Photo.PixelXDimension");
#line 709 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp15_ = g_strdup ("Xmp.exif.PixelXDimension");
#line 709 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp16_ = g_strdup ("Xmp.tiff.ImageWidth");
#line 709 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp17_ = g_strdup ("Xmp.exif.PixelXDimension");
#line 709 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp18_ = g_new0 (gchar*, 4 + 1);
#line 709 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp18_[0] = _tmp14_;
#line 709 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp18_[1] = _tmp15_;
#line 709 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp18_[2] = _tmp16_;
#line 709 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp18_[3] = _tmp17_;
#line 709 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	photo_metadata_WIDTH_TAGS = _tmp18_;
#line 709 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	photo_metadata_WIDTH_TAGS_length1 = 4;
#line 716 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp19_ = g_strdup ("Exif.Photo.PixelYDimension");
#line 716 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp20_ = g_strdup ("Xmp.exif.PixelYDimension");
#line 716 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp21_ = g_strdup ("Xmp.tiff.ImageHeight");
#line 716 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp22_ = g_strdup ("Xmp.exif.PixelYDimension");
#line 716 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp23_ = g_new0 (gchar*, 4 + 1);
#line 716 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp23_[0] = _tmp19_;
#line 716 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp23_[1] = _tmp20_;
#line 716 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp23_[2] = _tmp21_;
#line 716 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp23_[3] = _tmp22_;
#line 716 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	photo_metadata_HEIGHT_TAGS = _tmp23_;
#line 716 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	photo_metadata_HEIGHT_TAGS_length1 = 4;
#line 775 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp24_ = g_strdup ("Iptc.Application2.Caption");
#line 775 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp25_ = g_strdup ("Xmp.dc.title");
#line 775 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp26_ = g_strdup ("Iptc.Application2.Headline");
#line 775 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp27_ = g_strdup ("Xmp.photoshop.Headline");
#line 775 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp28_ = g_new0 (gchar*, 4 + 1);
#line 775 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp28_[0] = _tmp24_;
#line 775 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp28_[1] = _tmp25_;
#line 775 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp28_[2] = _tmp26_;
#line 775 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp28_[3] = _tmp27_;
#line 775 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	photo_metadata_STANDARD_TITLE_TAGS = _tmp28_;
#line 775 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	photo_metadata_STANDARD_TITLE_TAGS_length1 = 4;
#line 819 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp29_ = g_strdup ("Xmp.dc.subject");
#line 819 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp30_ = g_strdup ("Iptc.Application2.Keywords");
#line 819 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp31_ = g_new0 (gchar*, 2 + 1);
#line 819 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp31_[0] = _tmp29_;
#line 819 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp31_[1] = _tmp30_;
#line 819 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	photo_metadata_KEYWORD_TAGS = _tmp31_;
#line 819 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	photo_metadata_KEYWORD_TAGS_length1 = 2;
#line 957 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp32_ = g_strdup ("Exif.Image.Artist");
#line 957 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp33_ = g_strdup ("Exif.Canon.OwnerName");
#line 957 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp34_ = g_new0 (gchar*, 2 + 1);
#line 957 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp34_[0] = _tmp32_;
#line 957 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp34_[1] = _tmp33_;
#line 957 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	photo_metadata_ARTIST_TAGS = _tmp34_;
#line 957 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	photo_metadata_ARTIST_TAGS_length1 = 2;
#line 994 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp35_ = g_strdup ("Xmp.xmp.Rating");
#line 994 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp36_ = g_strdup ("Iptc.Application2.Urgency");
#line 994 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp37_ = g_strdup ("Xmp.photoshop.Urgency");
#line 994 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp38_ = g_new0 (gchar*, 3 + 1);
#line 994 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp38_[0] = _tmp35_;
#line 994 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp38_[1] = _tmp36_;
#line 994 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp38_[2] = _tmp37_;
#line 994 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	photo_metadata_RATING_TAGS = _tmp38_;
#line 994 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	photo_metadata_RATING_TAGS_length1 = 3;
#line 7129 "PhotoMetadata.c"
}


static void photo_metadata_instance_init (PhotoMetadata * self) {
	GExiv2Metadata* _tmp0_;
	gchar* _tmp1_;
#line 84 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	self->priv = PHOTO_METADATA_GET_PRIVATE (self);
#line 120 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp0_ = gexiv2_metadata_new ();
#line 120 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	self->priv->exiv2 = _tmp0_;
#line 121 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	self->priv->exif = NULL;
#line 122 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_tmp1_ = g_strdup ("<uninitialized>");
#line 122 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	self->priv->source_name = _tmp1_;
#line 7148 "PhotoMetadata.c"
}


static void photo_metadata_finalize (MediaMetadata* obj) {
	PhotoMetadata * self;
#line 84 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	self = PHOTO_METADATA (obj);
#line 120 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_gexiv2_metadata_free0 (self->priv->exiv2);
#line 121 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_exif_data_unref0 (self->priv->exif);
#line 122 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	_g_free0 (self->priv->source_name);
#line 84 "/builddir/build/BUILD/shotwell-0.10.1/src/photos/PhotoMetadata.vala"
	MEDIA_METADATA_CLASS (photo_metadata_parent_class)->finalize (obj);
#line 7164 "PhotoMetadata.c"
}


GType photo_metadata_get_type (void) {
	static volatile gsize photo_metadata_type_id__volatile = 0;
	if (g_once_init_enter (&photo_metadata_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PhotoMetadataClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) photo_metadata_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PhotoMetadata), 0, (GInstanceInitFunc) photo_metadata_instance_init, NULL };
		GType photo_metadata_type_id;
		photo_metadata_type_id = g_type_register_static (TYPE_MEDIA_METADATA, "PhotoMetadata", &g_define_type_info, 0);
		g_once_init_leave (&photo_metadata_type_id__volatile, photo_metadata_type_id);
	}
	return photo_metadata_type_id__volatile;
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint _vala_array_length (gpointer array) {
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}



